/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var e1=["require","exports","vs/base/common/errors","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/event","vs/base/common/strings","vs/base/common/types","vs/base/common/worker/simpleWorker"],t1=function(Y){for(var e=[],m=0,b=Y.length;m<b;m++)e[m]=e1[Y[m]];return e};define(e1[2],t1([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(h=>{h(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=m,e.errorHandler=new m;function b(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=b;function M(i){P(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=M;function d(i){P(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=d;function A(i){if(i instanceof Error){let{name:o,message:h}=i;const l=i.stacktrace||i.stack;return{$isError:!0,name:o,message:h,stack:l}}return i}e.transformErrorForSerialization=A;const F="Canceled";function P(i){return i instanceof Error&&i.name===F&&i.message===F}e.isPromiseCanceledError=P;class I extends Error{constructor(){super(F);this.name=this.message}}e.CancellationError=I;function z(){const i=new Error(F);return i.name=i.message,i}e.canceled=z;function k(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=k;function U(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=U;function W(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=W;function S(i){const o=new Error(`${i} has been disposed`);return o.name="DISPOSED",o}e.disposed=S;function G(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=G;class Z extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=Z;class q extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=q;class T extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=T;function Q(i){const o=i;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=Q;function L(i,o=Object.create(null)){const h=new Error(i);return o.actions&&(h.actions=o.actions),h}e.createErrorWithActions=L}),define(e1[3],t1([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(b){const M=this;let d=!1,A;return function(){return d||(d=!0,A=b.apply(M,arguments)),A}}e.once=m}),define(e1[6],t1([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(b){function M(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}b.is=M;const d=Object.freeze([]);function A(){return d}b.empty=A;function*F(i){yield i}b.single=F;function P(i){return i||d}b.from=P;function I(i){return!i||i[Symbol.iterator]().next().done===!0}b.isEmpty=I;function z(i){return i[Symbol.iterator]().next().value}b.first=z;function k(i,o){for(const h of i)if(o(h))return!0;return!1}b.some=k;function U(i,o){for(const h of i)if(o(h))return h}b.find=U;function*W(i,o){for(const h of i)o(h)&&(yield h)}b.filter=W;function*S(i,o){let h=0;for(const l of i)yield o(l,h++)}b.map=S;function*G(...i){for(const o of i)for(const h of o)yield h}b.concat=G;function*Z(i){for(const o of i)for(const h of o)yield h}b.concatNested=Z;function q(i,o,h){let l=h;for(const n of i)l=o(l,n);return l}b.reduce=q;function*T(i,o,h=i.length){for(o<0&&(o+=i.length),h<0?h+=i.length:h>i.length&&(h=i.length);o<h;o++)yield i[o]}b.slice=T;function Q(i,o=Number.POSITIVE_INFINITY){const h=[];if(o===0)return[h,i];const l=i[Symbol.iterator]();for(let n=0;n<o;n++){const r=l.next();if(r.done)return[h,b.empty()];h.push(r.value)}return[h,{[Symbol.iterator](){return l}}]}b.consume=Q;function L(i,o,h=(l,n)=>l===n){const l=i[Symbol.iterator](),n=o[Symbol.iterator]();for(;;){const r=l.next(),a=n.next();if(r.done!==a.done)return!1;if(r.done)return!0;if(!h(r.value,a.value))return!1}}b.equals=L})(m=e.Iterable||(e.Iterable={}))}),define(e1[4],t1([0,1,3,6]),function(Y,e,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const M=!1;let d=null;function A(n){d=n}if(e.setDisposableTracker=A,M){const n="__is_disposable_tracked__";A(new class{trackDisposable(r){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[n]||console.log(a)},3e3)}setParent(r,a){if(r&&r!==T.None)try{r[n]=!0}catch{}}markAsDisposed(r){if(r&&r!==T.None)try{r[n]=!0}catch{}}markAsSingleton(r){}})}function F(n){return d?.trackDisposable(n),n}function P(n){d?.markAsDisposed(n)}function I(n,r){d?.setParent(n,r)}function z(n,r){if(!!d)for(const a of n)d.setParent(a,r)}function k(n){return d?.markAsSingleton(n),n}e.markAsSingleton=k;class U extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=U;function W(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=W;function S(n){if(b.Iterable.is(n)){let r=[];for(const a of n)if(a)try{a.dispose()}catch(f){r.push(f)}if(r.length===1)throw r[0];if(r.length>1)throw new U(r);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=S;function G(...n){const r=Z(()=>S(n));return z(n,r),r}e.combinedDisposable=G;function Z(n){const r=F({dispose:(0,m.once)(()=>{P(r),n()})});return r}e.toDisposable=Z;class q{constructor(){this._toDispose=new Set,this._isDisposed=!1,F(this)}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{S(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return I(r,this),this._isDisposed?q.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=q,q.DISABLE_DISPOSED_WARNING=!1;class T{constructor(){this._store=new q,F(this),I(this._store,this)}dispose(){P(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=T,T.None=Object.freeze({dispose(){}});class Q{constructor(){this._isDisposed=!1,F(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&I(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&I(r,null),r}}e.MutableDisposable=Q;class L{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=L;class i{constructor(){this.references=new Map}acquire(r,...a){let f=this.references.get(r);f||(f={counter:0,object:this.createReferencedObject(r,...a)},this.references.set(r,f));const{object:c}=f,_=(0,m.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(r,f.object),this.references.delete(r))});return f.counter++,{object:c,dispose:_}}}e.ReferenceCollection=i;class o{constructor(r){this.referenceCollection=r}async acquire(r,...a){const f=this.referenceCollection.acquire(r,...a);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(c){throw f.dispose(),c}}}e.AsyncReferenceCollection=o;class h{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=h;function l(n){const r=new q;try{n(r)}finally{r.dispose()}}e.disposeOnReturn=l}),define(e1[7],t1([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(d){this.element=d,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class b{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let d=this._first;for(;d!==m.Undefined;){const A=d.next;d.prev=m.Undefined,d.next=m.Undefined,d=A}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(d){return this._insert(d,!1)}push(d){return this._insert(d,!0)}_insert(d,A){const F=new m(d);if(this._first===m.Undefined)this._first=F,this._last=F;else if(A){const I=this._last;this._last=F,F.prev=I,I.next=F}else{const I=this._first;this._first=F,F.next=I,I.prev=F}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(F))}}shift(){if(this._first!==m.Undefined){const d=this._first.element;return this._remove(this._first),d}}pop(){if(this._last!==m.Undefined){const d=this._last.element;return this._remove(this._last),d}}_remove(d){if(d.prev!==m.Undefined&&d.next!==m.Undefined){const A=d.prev;A.next=d.next,d.next.prev=A}else d.prev===m.Undefined&&d.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):d.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):d.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let d=this._first;for(;d!==m.Undefined;)yield d.element,d=d.next}}e.LinkedList=b}),define(e1[5],t1([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let b=!1,M=!1,d=!1,A=!1,F=!1,P=!1,I=!1,z,k=m,U,W;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let S;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?S=e.globals.vscode.process:typeof process!="undefined"&&(S=process);const G=typeof S?.versions?.electron=="string"&&S.type==="renderer";if(e.isElectronSandboxed=G&&S?.sandboxed,typeof navigator=="object"&&!G)W=navigator.userAgent,b=W.indexOf("Windows")>=0,M=W.indexOf("Macintosh")>=0,I=(W.indexOf("Macintosh")>=0||W.indexOf("iPad")>=0||W.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,d=W.indexOf("Linux")>=0,P=!0,z=navigator.language,k=z;else if(typeof S=="object"){b=S.platform==="win32",M=S.platform==="darwin",d=S.platform==="linux",A=d&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,z=m,k=m;const l=S.env.VSCODE_NLS_CONFIG;if(l)try{const n=JSON.parse(l),r=n.availableLanguages["*"];z=n.locale,k=r||m,U=n._translationsConfigFile}catch(n){}F=!0}else console.error("Unable to resolve platform.");var Z;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(Z=e.Platform||(e.Platform={}));function q(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=q;let T=0;M?T=1:b?T=3:d&&(T=2),e.isWindows=b,e.isMacintosh=M,e.isLinux=d,e.isLinuxSnap=A,e.isNative=F,e.isWeb=P,e.isIOS=I,e.platform=T,e.userAgent=W,e.language=k;var Q;(function(l){function n(){return e.language}l.value=n;function r(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=r;function a(){return e.language==="en"}l.isDefault=a})(Q=e.Language||(e.Language={})),e.locale=z,e.translationsConfigFile=U,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeSetImmediateId)for(let c=0,_=r.length;c<_;c++){const D=r[c];if(D.id===f.data.vscodeSetImmediateId){r.splice(c,1),D.callback();return}}});let a=0;return f=>{const c=++a;r.push({id:c,callback:f}),e.globals.postMessage({vscodeSetImmediateId:c},"*")}}if(typeof S?.nextTick=="function")return S.nextTick.bind(S);const n=Promise.resolve();return r=>n.then(r)}();var L;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(L=e.OperatingSystem||(e.OperatingSystem={})),e.OS=M||I?2:b?1:3;let i=!0,o=!1;function h(){if(!o){o=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,i=new Uint16Array(l.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=h}),define(e1[8],t1([0,1,5]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const b=m.globals.performance&&typeof m.globals.performance.now=="function";class M{constructor(A){this._highResolution=b&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new M(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=M}),define(e1[9],t1([0,1,2,3,4,7,8]),function(Y,e,m,b,M,d,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var F;(function(L){L.None=()=>M.Disposable.None;function i(y){return(v,C=null,w)=>{let O=!1,N;return N=y($=>{if(!O)return N?N.dispose():O=!0,v.call(C,$)},null,w),O&&N.dispose(),N}}L.once=i;function o(y,v){return f((C,w=null,O)=>y(N=>C.call(w,v(N)),null,O))}L.map=o;function h(y,v){return f((C,w=null,O)=>y(N=>{v(N),C.call(w,N)},null,O))}L.forEach=h;function l(y,v){return f((C,w=null,O)=>y(N=>v(N)&&C.call(w,N),null,O))}L.filter=l;function n(y){return y}L.signal=n;function r(...y){return(v,C=null,w)=>(0,M.combinedDisposable)(...y.map(O=>O(N=>v.call(C,N),null,w)))}L.any=r;function a(y,v,C){let w=C;return o(y,O=>(w=v(w,O),w))}L.reduce=a;function f(y){let v;const C=new U({onFirstListenerAdd(){v=y(C.fire,C)},onLastListenerRemove(){v.dispose()}});return C.event}function c(y,v,C=100,w=!1,O){let N,$,V,o1=0;const u1=new U({leakWarningThreshold:O,onFirstListenerAdd(){N=y(a1=>{o1++,$=v($,a1),w&&!V&&(u1.fire($),$=void 0),clearTimeout(V),V=setTimeout(()=>{const f1=$;$=void 0,V=void 0,(!w||o1>1)&&u1.fire(f1),o1=0},C)})},onLastListenerRemove(){N.dispose()}});return u1.event}L.debounce=c;function _(y,v=(C,w)=>C===w){let C=!0,w;return l(y,O=>{const N=C||!v(O,w);return C=!1,w=O,N})}L.latch=_;function D(y,v){return[L.filter(y,v),L.filter(y,C=>!v(C))]}L.split=D;function j(y,v=!1,C=[]){let w=C.slice(),O=y(V=>{w?w.push(V):$.fire(V)});const N=()=>{w&&w.forEach(V=>$.fire(V)),w=null},$=new U({onFirstListenerAdd(){O||(O=y(V=>$.fire(V)))},onFirstListenerDidAdd(){w&&(v?setTimeout(N):N())},onLastListenerRemove(){O&&O.dispose(),O=null}});return $.event}L.buffer=j;class p{constructor(v){this.event=v}map(v){return new p(o(this.event,v))}forEach(v){return new p(h(this.event,v))}filter(v){return new p(l(this.event,v))}reduce(v,C){return new p(a(this.event,v,C))}latch(){return new p(_(this.event))}debounce(v,C=100,w=!1,O){return new p(c(this.event,v,C,w,O))}on(v,C,w){return this.event(v,C,w)}once(v,C,w){return i(this.event)(v,C,w)}}function H(y){return new p(y)}L.chain=H;function B(y,v,C=w=>w){const w=(...V)=>$.fire(C(...V)),O=()=>y.on(v,w),N=()=>y.removeListener(v,w),$=new U({onFirstListenerAdd:O,onLastListenerRemove:N});return $.event}L.fromNodeEventEmitter=B;function s1(y,v,C=w=>w){const w=(...V)=>$.fire(C(...V)),O=()=>y.addEventListener(v,w),N=()=>y.removeEventListener(v,w),$=new U({onFirstListenerAdd:O,onLastListenerRemove:N});return $.event}L.fromDOMEventEmitter=s1;function r1(y){return new Promise(v=>i(y)(v))}L.toPromise=r1})(F=e.Event||(e.Event={}));class P{constructor(i){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${i}_${P._idPool++}`}start(i){this._stopWatch=new A.StopWatch(!0),this._listenerCount=i}stop(){if(this._stopWatch){const i=this._stopWatch.elapsed();this._elapsedOverall+=i,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${i.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}P._idPool=0;let I=-1;function z(L){const i=I;return I=L,{dispose(){I=i}}}e.setGlobalLeakWarningThreshold=z;class k{constructor(i,o=Math.random().toString(18).slice(2,5)){this.customThreshold=i,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(i){let o=I;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||i<o)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),l=this._stacks.get(h)||0;if(this._stacks.set(h,l+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let n,r=0;for(const[a,f]of this._stacks)(!n||r<f)&&(n=a,r=f);console.warn(`[${this.name}] potential listener LEAK detected, having ${i} listeners already. MOST frequent listener (${r}):`),console.warn(n)}return()=>{const n=this._stacks.get(h)||0;this._stacks.set(h,n-1)}}}class U{constructor(i){this._disposed=!1,this._options=i,this._leakageMon=I>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new P(this._options._profName):void 0}get event(){return this._event||(this._event=(i,o,h)=>{this._listeners||(this._listeners=new d.LinkedList);const l=this._listeners.isEmpty();l&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(o?[i,o]:i);l&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,i,o);const r=this._leakageMon?.check(this._listeners.size),a=(0,M.toDisposable)(()=>{r&&r(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof M.DisposableStore?h.add(a):Array.isArray(h)&&h.push(a),a}),this._event}fire(i){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new d.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,i]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,h]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,h):o[0].call(o[1],h)}catch(l){(0,m.onUnexpectedError)(l)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=U;class W extends U{async fireAsync(i,o,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new d.LinkedList);for(const l of this._listeners)this._asyncDeliveryQueue.push([l,i]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[l,n]=this._asyncDeliveryQueue.shift(),r=[],a={...n,waitUntil:f=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");h&&(f=h(f,typeof l=="function"?l:l[0])),r.push(f)}};try{typeof l=="function"?l.call(void 0,a):l[0].call(l[1],a)}catch(f){(0,m.onUnexpectedError)(f);continue}Object.freeze(r),await Promise.allSettled(r).then(f=>{for(const c of f)c.status==="rejected"&&(0,m.onUnexpectedError)(c.reason)})}}}}e.AsyncEmitter=W;class S extends U{constructor(i){super(i);this._isPaused=0,this._eventQueue=new d.LinkedList,this._mergeFn=i?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const i=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(i))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):super.fire(i))}}e.PauseableEmitter=S;class G extends S{constructor(i){super(i);this._delay=i.delay??100}fire(i){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(i)}}e.DebounceEmitter=G;class Z extends U{constructor(i){super(i);this._queuedEvents=[],this._mergeFn=i?.merge}fire(i){this._queuedEvents.push(i),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=Z;class q{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new U({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(i){const o={event:i,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const h=()=>{this.hasListeners&&this.unhook(o);const l=this.events.indexOf(o);this.events.splice(l,1)};return(0,M.toDisposable)((0,b.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(i=>this.hook(i))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(i=>this.unhook(i))}hook(i){i.listener=i.event(o=>this.emitter.fire(o))}unhook(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=q;class T{constructor(){this.buffers=[]}wrapEvent(i){return(o,h,l)=>i(n=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>o.call(h,n)):o.call(h,n)},void 0,l)}bufferEvents(i){const o=[];this.buffers.push(o);const h=i();return this.buffers.pop(),o.forEach(l=>l()),h}}e.EventBufferer=T;class Q{constructor(){this.listening=!1,this.inputEvent=F.None,this.inputEventListener=M.Disposable.None,this.emitter=new U({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(i){this.inputEvent=i,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=i(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=Q}),define(e1[10],t1([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(t){return!t||typeof t!="string"?!0:t.trim().length===0}e.isFalsyOrWhitespace=m;const b=/{(\d+)}/g;function M(t,...s){return s.length===0?t:t.replace(b,function(u,g){const E=parseInt(g,10);return isNaN(E)||E<0||E>=s.length?u:s[E]})}e.format=M;const d=/{([^}]+)}/g;function A(t,s){return t.replace(d,(u,g)=>s[g]??u)}e.format2=A;function F(t){return t.replace(/[<>&]/g,function(s){switch(s){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return s}})}e.escape=F;function P(t){return t.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function I(t,s){let u=0;const g=s.charCodeAt(0);for(let E=t.length-1;E>=0;E--)t.charCodeAt(E)===g&&u++;return u}e.count=I;function z(t,s,u="\u2026"){return t.length<=s?t:`${t.substr(0,s)}${u}`}e.truncate=z;function k(t,s=" "){const u=U(t,s);return W(u,s)}e.trim=k;function U(t,s){if(!t||!s)return t;const u=s.length;if(u===0||t.length===0)return t;let g=0;for(;t.indexOf(s,g)===g;)g=g+u;return t.substring(g)}e.ltrim=U;function W(t,s){if(!t||!s)return t;const u=s.length,g=t.length;if(u===0||g===0)return t;let E=g,R=-1;for(;R=t.lastIndexOf(s,E-1),!(R===-1||R+u!==E);){if(R===0)return"";E=R}return t.substring(0,E)}e.rtrim=W;function S(t){return t.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=S;function G(t){return t.replace(/\*/g,"")}e.stripWildcards=G;function Z(t,s,u={}){if(!t)throw new Error("Cannot create regex from empty string");s||(t=P(t)),u.wholeWord&&(/\B/.test(t.charAt(0))||(t="\\b"+t),/\B/.test(t.charAt(t.length-1))||(t=t+"\\b"));let g="";return u.global&&(g+="g"),u.matchCase||(g+="i"),u.multiline&&(g+="m"),u.unicode&&(g+="u"),new RegExp(t,g)}e.createRegExp=Z;function q(t){return t.source==="^"||t.source==="^$"||t.source==="$"||t.source==="^\\s*$"?!1:!!(t.exec("")&&t.lastIndex===0)}e.regExpLeadsToEndlessLoop=q;function T(t){return!!t.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=T;function Q(t){return(t.global?"g":"")+(t.ignoreCase?"i":"")+(t.multiline?"m":"")+(t.unicode?"u":"")}e.regExpFlags=Q;function L(t){return t.split(/\r\n|\r|\n/)}e.splitLines=L;function i(t){for(let s=0,u=t.length;s<u;s++){const g=t.charCodeAt(s);if(g!==32&&g!==9)return s}return-1}e.firstNonWhitespaceIndex=i;function o(t,s=0,u=t.length){for(let g=s;g<u;g++){const E=t.charCodeAt(g);if(E!==32&&E!==9)return t.substring(s,g)}return t.substring(s,u)}e.getLeadingWhitespace=o;function h(t,s=t.length-1){for(let u=s;u>=0;u--){const g=t.charCodeAt(u);if(g!==32&&g!==9)return u}return-1}e.lastNonWhitespaceIndex=h;function l(t,s){return t<s?-1:t>s?1:0}e.compare=l;function n(t,s,u=0,g=t.length,E=0,R=s.length){for(;u<g&&E<R;u++,E++){let x=t.charCodeAt(u),X=s.charCodeAt(E);if(x<X)return-1;if(x>X)return 1}const J=g-u,K=R-E;return J<K?-1:J>K?1:0}e.compareSubstring=n;function r(t,s){return a(t,s,0,t.length,0,s.length)}e.compareIgnoreCase=r;function a(t,s,u=0,g=t.length,E=0,R=s.length){for(;u<g&&E<R;u++,E++){let x=t.charCodeAt(u),X=s.charCodeAt(E);if(x===X)continue;if(x>=128||X>=128)return n(t.toLowerCase(),s.toLowerCase(),u,g,E,R);f(x)&&(x-=32),f(X)&&(X-=32);const i1=x-X;if(i1!==0)return i1}const J=g-u,K=R-E;return J<K?-1:J>K?1:0}e.compareSubstringIgnoreCase=a;function f(t){return t>=97&&t<=122}e.isLowerAsciiLetter=f;function c(t){return t>=65&&t<=90}e.isUpperAsciiLetter=c;function _(t,s){return t.length===s.length&&a(t,s)===0}e.equalsIgnoreCase=_;function D(t,s){const u=s.length;return s.length>t.length?!1:a(t,s,0,u)===0}e.startsWithIgnoreCase=D;function j(t,s){let u,g=Math.min(t.length,s.length);for(u=0;u<g;u++)if(t.charCodeAt(u)!==s.charCodeAt(u))return u;return g}e.commonPrefixLength=j;function p(t,s){let u,g=Math.min(t.length,s.length);const E=t.length-1,R=s.length-1;for(u=0;u<g;u++)if(t.charCodeAt(E-u)!==s.charCodeAt(R-u))return u;return g}e.commonSuffixLength=p;function H(t){return 55296<=t&&t<=56319}e.isHighSurrogate=H;function B(t){return 56320<=t&&t<=57343}e.isLowSurrogate=B;function s1(t,s){return(t-55296<<10)+(s-56320)+65536}e.computeCodePoint=s1;function r1(t,s,u){const g=t.charCodeAt(u);if(H(g)&&u+1<s){const E=t.charCodeAt(u+1);if(B(E))return s1(g,E)}return g}e.getNextCodePoint=r1;function y(t,s){const u=t.charCodeAt(s-1);if(B(u)&&s>1){const g=t.charCodeAt(s-2);if(H(g))return s1(g,u)}return u}function v(t,s){const u=n1.getInstance(),g=s,E=t.length,R=r1(t,E,s);s+=R>=65536?2:1;let J=u.getGraphemeBreakType(R);for(;s<E;){const K=r1(t,E,s),x=u.getGraphemeBreakType(K);if(l1(J,x))break;s+=K>=65536?2:1,J=x}return s-g}e.nextCharLength=v;function C(t,s){const u=n1.getInstance(),g=s,E=y(t,s);s-=E>=65536?2:1;let R=u.getGraphemeBreakType(E);for(;s>0;){const J=y(t,s),K=u.getGraphemeBreakType(J);if(l1(K,R))break;s-=J>=65536?2:1,R=K}return g-s}e.prevCharLength=C;function w(t,s){const u=n1.getInstance(),g=t.length,E=s,R=r1(t,g,s),J=u.getGraphemeBreakType(R);s+=R>=65536?2:1;let K=J;for(;s<g;){const X=r1(t,g,s),i1=u.getGraphemeBreakType(X);if(l1(K,i1))break;s+=X>=65536?2:1,K=i1}const x=s;for(s=E,K=J;s>0;){const X=y(t,s),i1=u.getGraphemeBreakType(X);if(l1(i1,K))break;s-=X>=65536?2:1,K=i1}return[s,x]}function O(t,s){return s>0&&B(t.charCodeAt(s))?w(t,s-1):w(t,s)}e.getCharContainingOffset=O;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function $(t){return N.test(t)}e.containsRTL=$;const V=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function o1(t){return V.test(t)}e.containsEmoji=o1;const u1=/^[\t\n\r\x20-\x7E]*$/;function a1(t){return u1.test(t)}e.isBasicASCII=a1,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function f1(t){return e.UNUSUAL_LINE_TERMINATORS.test(t)}e.containsUnusualLineTerminators=f1;function _1(t){for(let s=0,u=t.length;s<u;s++)if(d1(t.charCodeAt(s)))return!0;return!1}e.containsFullWidthCharacter=_1;function d1(t){return t>=11904&&t<=55215||t>=63744&&t<=64255||t>=65281&&t<=65374}e.isFullWidthCharacter=d1;function h1(t){return t>=127462&&t<=127487||t===8986||t===8987||t===9200||t===9203||t>=9728&&t<=10175||t===11088||t===11093||t>=127744&&t<=128591||t>=128640&&t<=128764||t>=128992&&t<=129003||t>=129280&&t<=129535||t>=129648&&t<=129750}e.isEmojiImprecise=h1;function E1(t,s){if(t.length<s)return t;const u=/\b/g;let g=0;for(;u.test(t)&&!(t.length-u.lastIndex<s);)g=u.lastIndex,u.lastIndex+=1;return t.substring(g).replace(/^\s/,"")}e.lcut=E1;const v1=/\x1B\x5B[12]?K/g,w1=/\x1b\[\d+m/g,L1=/\x1b\[0?m/g;function p1(t){return t&&(t=t.replace(v1,""),t=t.replace(w1,""),t=t.replace(L1,"")),t}e.removeAnsiEscapeCodes=p1,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function g1(t){return!!(t&&t.length>0&&t.charCodeAt(0)===65279)}e.startsWithUTF8BOM=g1;function b1(t){return g1(t)?t.substr(1):t}e.stripUTF8BOM=b1;function y1(t,s){if(!t||!s||t.length<s.length)return!1;const u=s.length,g=t.toLowerCase();let E=0,R=-1;for(;E<u;){const J=g.indexOf(s[E],R+1);if(J<0)return!1;R=J,E++}return!0}e.fuzzyContains=y1;function C1(t,s=!1){return t?(s&&(t=t.replace(/\\./g,"")),t.toLowerCase()!==t):!1}e.containsUppercaseCharacter=C1;function D1(t){return t.charAt(0).toUpperCase()+t.slice(1)}e.uppercaseFirstLetter=D1;function A1(t,s=1){if(s===0)return"";let u=-1;do u=t.indexOf(`
`,u+1),s--;while(s>0&&u>=0);return u===-1?t:(t[u-1]==="\r"&&u--,t.substr(0,u))}e.getNLines=A1;function F1(t){const s=90-65+1;return t=t%(2*s),t<s?String.fromCharCode(97+t):String.fromCharCode(65+t-s)}e.singleLetterHash=F1;function I1(t){return n1.getInstance().getGraphemeBreakType(t)}e.getGraphemeBreakType=I1;function l1(t,s){return t===0?s!==5&&s!==7:t===2&&s===3?!1:t===4||t===2||t===3||s===4||s===2||s===3?!0:!(t===8&&(s===8||s===9||s===11||s===12)||(t===11||t===9)&&(s===9||s===10)||(t===12||t===10)&&s===10||s===5||s===13||s===7||t===1||t===13&&s===14||t===6&&s===6)}e.breakBetweenGraphemeBreakType=l1;var S1;(function(t){t[t.Other=0]="Other",t[t.Prepend=1]="Prepend",t[t.CR=2]="CR",t[t.LF=3]="LF",t[t.Control=4]="Control",t[t.Extend=5]="Extend",t[t.Regional_Indicator=6]="Regional_Indicator",t[t.SpacingMark=7]="SpacingMark",t[t.L=8]="L",t[t.V=9]="V",t[t.T=10]="T",t[t.LV=11]="LV",t[t.LVT=12]="LVT",t[t.ZWJ=13]="ZWJ",t[t.Extended_Pictographic=14]="Extended_Pictographic"})(S1=e.GraphemeBreakType||(e.GraphemeBreakType={}));class n1{constructor(){this._data=O1()}static getInstance(){return n1._INSTANCE||(n1._INSTANCE=new n1),n1._INSTANCE}getGraphemeBreakType(s){if(s<32)return s===10?3:s===13?2:4;if(s<127)return 0;const u=this._data,g=u.length/3;let E=1;for(;E<=g;)if(s<u[3*E])E=2*E;else if(s>u[3*E+1])E=2*E+1;else return u[3*E+2];return 0}}n1._INSTANCE=null;function O1(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function M1(t,s){if(t===0)return 0;const u=P1(t,s);if(u!==void 0)return u;const g=y(s,t);return t-=c1(g),t}e.getLeftDeleteOffset=M1;function P1(t,s){let u=y(s,t);for(t-=c1(u);N1(u)||u===65039||u===8419;){if(t===0)return;u=y(s,t),t-=c1(u)}if(!!h1(u)){if(t>=0){const g=y(s,t);g===8205&&(t-=c1(g))}return t}}function c1(t){return t>=65536?2:1}function N1(t){return 127995<=t&&t<=127999}var m1;(function(t){t[t.zwj=8205]="zwj",t[t.emojiVariantSelector=65039]="emojiVariantSelector",t[t.enclosingKeyCap=8419]="enclosingKeyCap"})(m1||(m1={})),e.noBreakWhitespace="\xA0"}),define(e1[11],t1([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(c){return Array.isArray(c)}e.isArray=m;function b(c){return typeof c=="string"}e.isString=b;function M(c){return Array.isArray(c)&&c.every(_=>b(_))}e.isStringArray=M;function d(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=d;function A(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=A;function F(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=F;function P(c){return c===!0||c===!1}e.isBoolean=P;function I(c){return typeof c=="undefined"}e.isUndefined=I;function z(c){return!k(c)}e.isDefined=z;function k(c){return I(c)||c===null}e.isUndefinedOrNull=k;function U(c,_){if(!c)throw new Error(_?`Unexpected type, expected '${_}'`:"Unexpected type")}e.assertType=U;function W(c){if(k(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=W;function S(...c){const _=[];for(let D=0;D<c.length;D++){const j=c[D];if(k(j))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);_.push(j)}return _}e.assertAllDefined=S;const G=Object.prototype.hasOwnProperty;function Z(c){if(!d(c))return!1;for(let _ in c)if(G.call(c,_))return!1;return!0}e.isEmptyObject=Z;function q(c){return typeof c=="function"}e.isFunction=q;function T(...c){return c.length>0&&c.every(q)}e.areFunctions=T;function Q(c,_){const D=Math.min(c.length,_.length);for(let j=0;j<D;j++)L(c[j],_[j])}e.validateConstraints=Q;function L(c,_){if(b(_)){if(typeof c!==_)throw new Error(`argument does not match constraint: typeof ${_}`)}else if(q(_)){try{if(c instanceof _)return}catch{}if(!k(c)&&c.constructor===_||_.length===1&&_.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=L;function i(c){let _=[],D=Object.getPrototypeOf(c);for(;Object.prototype!==D;)_=_.concat(Object.getOwnPropertyNames(D)),D=Object.getPrototypeOf(D);return _}e.getAllPropertyNames=i;function o(c){const _=[];for(const D of i(c))typeof c[D]=="function"&&_.push(D);return _}e.getAllMethodNames=o;function h(c,_){const D=p=>function(){const H=Array.prototype.slice.call(arguments,0);return _(p,H)};let j={};for(const p of c)j[p]=D(p);return j}e.createProxyObject=h;function l(c){return c===null?void 0:c}e.withNullAsUndefined=l;function n(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=n;function r(c){return class{constructor(){return new Proxy({},{get(_,D){if(_[D])return _[D];throw new Error(`Not Implemented: ${c}->${String(D)}`)}})}}}e.NotImplementedProxy=r;function a(c,_="Unreachable"){throw new Error(_)}e.assertNever=a;function f(c){return!!c&&typeof c.then=="function"&&typeof c.catch=="function"}e.isPromise=f}),define(e1[12],t1([0,1,2,9,4,5,11,10]),function(Y,e,m,b,M,d,A,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const P="$initialize";let I=!1;function z(l){!d.isWeb||(I||(I=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(l.message))}e.logOnceWebWorkerWarning=z;var k;(function(l){l[l.Request=0]="Request",l[l.Reply=1]="Reply",l[l.SubscribeEvent=2]="SubscribeEvent",l[l.Event=3]="Event",l[l.UnsubscribeEvent=4]="UnsubscribeEvent"})(k||(k={}));class U{constructor(n,r,a,f){this.vsWorker=n,this.req=r,this.method=a,this.args=f,this.type=0}}class W{constructor(n,r,a,f){this.vsWorker=n,this.seq=r,this.res=a,this.err=f,this.type=1}}class S{constructor(n,r,a,f){this.vsWorker=n,this.req=r,this.eventName=a,this.arg=f,this.type=2}}class G{constructor(n,r,a){this.vsWorker=n,this.req=r,this.event=a,this.type=3}}class Z{constructor(n,r){this.vsWorker=n,this.req=r,this.type=4}}class q{constructor(n){this._workerId=-1,this._handler=n,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(n){this._workerId=n}sendMessage(n,r){const a=String(++this._lastSentReq);return new Promise((f,c)=>{this._pendingReplies[a]={resolve:f,reject:c},this._send(new U(this._workerId,a,n,r))})}listen(n,r){let a=null;const f=new b.Emitter({onFirstListenerAdd:()=>{a=String(++this._lastSentReq),this._pendingEmitters.set(a,f),this._send(new S(this._workerId,a,n,r))},onLastListenerRemove:()=>{this._pendingEmitters.delete(a),this._send(new Z(this._workerId,a)),a=null}});return f.event}handleMessage(n){!n||!n.vsWorker||this._workerId!==-1&&n.vsWorker!==this._workerId||this._handleMessage(n)}_handleMessage(n){switch(n.type){case 1:return this._handleReplyMessage(n);case 0:return this._handleRequestMessage(n);case 2:return this._handleSubscribeEventMessage(n);case 3:return this._handleEventMessage(n);case 4:return this._handleUnsubscribeEventMessage(n)}}_handleReplyMessage(n){if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let r=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let a=n.err;n.err.$isError&&(a=new Error,a.name=n.err.name,a.message=n.err.message,a.stack=n.err.stack),r.reject(a);return}r.resolve(n.res)}_handleRequestMessage(n){let r=n.req;this._handler.handleMessage(n.method,n.args).then(f=>{this._send(new W(this._workerId,r,f,void 0))},f=>{f.detail instanceof Error&&(f.detail=(0,m.transformErrorForSerialization)(f.detail)),this._send(new W(this._workerId,r,void 0,(0,m.transformErrorForSerialization)(f)))})}_handleSubscribeEventMessage(n){const r=n.req,a=this._handler.handleEvent(n.eventName,n.arg)(f=>{this._send(new G(this._workerId,r,f))});this._pendingEvents.set(r,a)}_handleEventMessage(n){if(!this._pendingEmitters.has(n.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(n.req).fire(n.event)}_handleUnsubscribeEventMessage(n){if(!this._pendingEvents.has(n.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(n.req).dispose(),this._pendingEvents.delete(n.req)}_send(n){let r=[];if(n.type===0)for(let a=0;a<n.args.length;a++)n.args[a]instanceof ArrayBuffer&&r.push(n.args[a]);else n.type===1&&n.res instanceof ArrayBuffer&&r.push(n.res);this._handler.sendMessage(n,r)}}class T extends M.Disposable{constructor(n,r,a){super();let f=null;this._worker=this._register(n.create("vs/base/common/worker/simpleWorker",p=>{this._protocol.handleMessage(p)},p=>{f&&f(p)})),this._protocol=new q({sendMessage:(p,H)=>{this._worker.postMessage(p,H)},handleMessage:(p,H)=>{if(typeof a[p]!="function")return Promise.reject(new Error("Missing method "+p+" on main thread host."));try{return Promise.resolve(a[p].apply(a,H))}catch(B){return Promise.reject(B)}},handleEvent:(p,H)=>{if(L(p)){const B=a[p].call(a,H);if(typeof B!="function")throw new Error(`Missing dynamic event ${p} on main thread host.`);return B}if(Q(p)){const B=a[p];if(typeof B!="function")throw new Error(`Missing event ${p} on main thread host.`);return B}throw new Error(`Malformed event name ${p}`)}}),this._protocol.setWorkerId(this._worker.getId());let c=null;typeof d.globals.require!="undefined"&&typeof d.globals.require.getConfig=="function"?c=d.globals.require.getConfig():typeof d.globals.requirejs!="undefined"&&(c=d.globals.requirejs.s.contexts._.config);const _=A.getAllMethodNames(a);this._onModuleLoaded=this._protocol.sendMessage(P,[this._worker.getId(),JSON.parse(JSON.stringify(c)),r,_]);const D=(p,H)=>this._request(p,H),j=(p,H)=>this._protocol.listen(p,H);this._lazyProxy=new Promise((p,H)=>{f=H,this._onModuleLoaded.then(B=>{p(i(B,D,j))},B=>{H(B),this._onError("Worker failed to load "+r,B)})})}getProxyObject(){return this._lazyProxy}_request(n,r){return new Promise((a,f)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(n,r).then(a,f)},f)})}_onError(n,r){console.error(n),console.info(r)}}e.SimpleWorkerClient=T;function Q(l){return l[0]==="o"&&l[1]==="n"&&F.isUpperAsciiLetter(l.charCodeAt(2))}function L(l){return/^onDynamic/.test(l)&&F.isUpperAsciiLetter(l.charCodeAt(9))}function i(l,n,r){const a=_=>function(){const D=Array.prototype.slice.call(arguments,0);return n(_,D)},f=_=>function(D){return r(_,D)};let c={};for(const _ of l){if(L(_)){c[_]=f(_);continue}if(Q(_)){c[_]=r(_,void 0);continue}c[_]=a(_)}return c}class o{constructor(n,r){this._requestHandlerFactory=r,this._requestHandler=null,this._protocol=new q({sendMessage:(a,f)=>{n(a,f)},handleMessage:(a,f)=>this._handleMessage(a,f),handleEvent:(a,f)=>this._handleEvent(a,f)})}onmessage(n){this._protocol.handleMessage(n)}_handleMessage(n,r){if(n===P)return this.initialize(r[0],r[1],r[2],r[3]);if(!this._requestHandler||typeof this._requestHandler[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this._requestHandler[n].apply(this._requestHandler,r))}catch(a){return Promise.reject(a)}}_handleEvent(n,r){if(!this._requestHandler)throw new Error("Missing requestHandler");if(L(n)){const a=this._requestHandler[n].call(this._requestHandler,r);if(typeof a!="function")throw new Error(`Missing dynamic event ${n} on request handler.`);return a}if(Q(n)){const a=this._requestHandler[n];if(typeof a!="function")throw new Error(`Missing event ${n} on request handler.`);return a}throw new Error(`Malformed event name ${n}`)}initialize(n,r,a,f){this._protocol.setWorkerId(n);const D=i(f,(j,p)=>this._protocol.sendMessage(j,p),(j,p)=>this._protocol.listen(j,p));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(D),Promise.resolve(A.getAllMethodNames(this._requestHandler))):(r&&(typeof r.baseUrl!="undefined"&&delete r.baseUrl,typeof r.paths!="undefined"&&typeof r.paths.vs!="undefined"&&delete r.paths.vs,typeof r.trustedTypesPolicy!==void 0&&delete r.trustedTypesPolicy,r.catchError=!0,d.globals.require.config(r)),new Promise((j,p)=>{(d.globals.require||Y)([a],B=>{if(this._requestHandler=B.create(D),!this._requestHandler){p(new Error("No RequestHandler!"));return}j(A.getAllMethodNames(this._requestHandler))},p)}))}}e.SimpleWorkerServer=o;function h(l){return new o(l,null)}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d450b04c783dfa6f83dc439017767acccd4e9fac/core/vs/base/common/worker/simpleWorker.js.map
