/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/platform","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/errors","vs/base/common/event","vs/editor/common/core/range","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/base/common/uri","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/editor/common/core/characterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],te=function(U){for(var n=[],R=0,y=U.length;R<y;R++)n[R]=ee[U[R]];return n},Ae=this,Me=typeof global=="object"?global:{},le;(function(U){U.global=Ae;var n=function(){function R(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(R.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(R.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),R.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=R._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof U.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},R._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},R}();U.Environment=n})(le||(le={}));var le;(function(U){var n=function(){function D(l,A,d){this.type=l,this.detail=A,this.timestamp=d}return D}();U.LoaderEvent=n;var R=function(){function D(l){this._events=[new n(1,"",l)]}return D.prototype.record=function(l,A){this._events.push(new n(l,A,U.Utilities.getHighPerformanceTimestamp()))},D.prototype.getEvents=function(){return this._events},D}();U.LoaderEventRecorder=R;var y=function(){function D(){}return D.prototype.record=function(l,A){},D.prototype.getEvents=function(){return[]},D.INSTANCE=new D,D}();U.NullLoaderEventRecorder=y})(le||(le={}));var le;(function(U){var n=function(){function R(){}return R.fileUriToFilePath=function(y,D){if(D=decodeURI(D).replace(/%23/g,"#"),y){if(/^file:\/\/\//.test(D))return D.substr(8);if(/^file:\/\//.test(D))return D.substr(5)}else if(/^file:\/\//.test(D))return D.substr(7);return D},R.startsWith=function(y,D){return y.length>=D.length&&y.substr(0,D.length)===D},R.endsWith=function(y,D){return y.length>=D.length&&y.substr(y.length-D.length)===D},R.containsQueryString=function(y){return/^[^\#]*\?/gi.test(y)},R.isAbsolutePath=function(y){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(y)},R.forEachProperty=function(y,D){if(y){var l=void 0;for(l in y)y.hasOwnProperty(l)&&D(l,y[l])}},R.isEmpty=function(y){var D=!0;return R.forEachProperty(y,function(){D=!1}),D},R.recursiveClone=function(y){if(!y||typeof y!="object"||y instanceof RegExp||!Array.isArray(y)&&Object.getPrototypeOf(y)!==Object.prototype)return y;var D=Array.isArray(y)?[]:{};return R.forEachProperty(y,function(l,A){A&&typeof A=="object"?D[l]=R.recursiveClone(A):D[l]=A}),D},R.generateAnonymousModule=function(){return"===anonymous"+R.NEXT_ANONYMOUS_ID+++"==="},R.isAnonymousModule=function(y){return R.startsWith(y,"===anonymous")},R.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=U.global.performance&&typeof U.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?U.global.performance.now():Date.now()},R.NEXT_ANONYMOUS_ID=1,R.PERFORMANCE_NOW_PROBED=!1,R.HAS_PERFORMANCE_NOW=!1,R}();U.Utilities=n})(le||(le={}));var le;(function(U){function n(D){if(D instanceof Error)return D;var l=new Error(D.message||String(D)||"Unknown Error");return D.stack&&(l.stack=D.stack),l}U.ensureError=n;var R=function(){function D(){}return D.validateConfigurationOptions=function(l){function A(r){if(r.phase==="loading"){console.error('Loading "'+r.moduleId+'" failed'),console.error(r),console.error("Here are the modules that depend on it:"),console.error(r.neededBy);return}if(r.phase==="factory"){console.error('The factory method of "'+r.moduleId+'" has thrown an exception'),console.error(r);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError=="undefined"&&(l.catchError=!1),typeof l.recordStats=="undefined"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=A),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(U.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags=="undefined"&&(l.preferScriptTags=!1),Array.isArray(l.nodeModules)||(l.nodeModules=[]),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){var d=n(new Error("INVALID cached data configuration, 'path' MUST be set"));d.phase="configuration",l.onError(d),l.nodeCachedData=void 0}return l},D.mergeConfigurationOptions=function(l,A){l===void 0&&(l=null),A===void 0&&(A=null);var d=U.Utilities.recursiveClone(A||{});return U.Utilities.forEachProperty(l,function(r,o){r==="ignoreDuplicateModules"&&typeof d.ignoreDuplicateModules!="undefined"?d.ignoreDuplicateModules=d.ignoreDuplicateModules.concat(o):r==="paths"&&typeof d.paths!="undefined"?U.Utilities.forEachProperty(o,function(_,p){return d.paths[_]=p}):r==="config"&&typeof d.config!="undefined"?U.Utilities.forEachProperty(o,function(_,p){return d.config[_]=p}):d[r]=U.Utilities.recursiveClone(o)}),D.validateConfigurationOptions(d)},D}();U.ConfigurationOptionsUtil=R;var y=function(){function D(l,A){if(this._env=l,this.options=R.mergeConfigurationOptions(A),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var d=this.options.nodeRequire.main.filename,r=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,r+1)}if(this.options.nodeMain&&this._env.isNode){var d=this.options.nodeMain,r=Math.max(d.lastIndexOf("/"),d.lastIndexOf("\\"));this.options.baseUrl=d.substring(0,r+1)}}}return D.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0},D.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var l=0,A=this.options.nodeModules;l<A.length;l++){var d=A[l];this.nodeModulesMap[d]=!0}},D.prototype._createSortedPathsRules=function(){var l=this;this.sortedPathsRules=[],U.Utilities.forEachProperty(this.options.paths,function(A,d){Array.isArray(d)?l.sortedPathsRules.push({from:A,to:d}):l.sortedPathsRules.push({from:A,to:[d]})}),this.sortedPathsRules.sort(function(A,d){return d.from.length-A.from.length})},D.prototype.cloneAndMerge=function(l){return new D(this._env,R.mergeConfigurationOptions(l,this.options))},D.prototype.getOptionsLiteral=function(){return this.options},D.prototype._applyPaths=function(l){for(var A,d=0,r=this.sortedPathsRules.length;d<r;d++)if(A=this.sortedPathsRules[d],U.Utilities.startsWith(l,A.from)){for(var o=[],_=0,p=A.to.length;_<p;_++)o.push(A.to[_]+l.substr(A.from.length));return o}return[l]},D.prototype._addUrlArgsToUrl=function(l){return U.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs},D.prototype._addUrlArgsIfNecessaryToUrl=function(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l},D.prototype._addUrlArgsIfNecessaryToUrls=function(l){if(this.options.urlArgs)for(var A=0,d=l.length;A<d;A++)l[A]=this._addUrlArgsToUrl(l[A]);return l},D.prototype.moduleIdToPaths=function(l){if(this._env.isNode){var A=this.nodeModulesMap[l]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l);if(A)return this.isBuild()?["empty:"]:["node|"+l]}var d=l,r;if(!U.Utilities.endsWith(d,".js")&&!U.Utilities.isAbsolutePath(d)){r=this._applyPaths(d);for(var o=0,_=r.length;o<_;o++)this.isBuild()&&r[o]==="empty:"||(U.Utilities.isAbsolutePath(r[o])||(r[o]=this.options.baseUrl+r[o]),!U.Utilities.endsWith(r[o],".js")&&!U.Utilities.containsQueryString(r[o])&&(r[o]=r[o]+".js"))}else!U.Utilities.endsWith(d,".js")&&!U.Utilities.containsQueryString(d)&&(d=d+".js"),r=[d];return this._addUrlArgsIfNecessaryToUrls(r)},D.prototype.requireToUrl=function(l){var A=l;return U.Utilities.isAbsolutePath(A)||(A=this._applyPaths(A)[0],U.Utilities.isAbsolutePath(A)||(A=this.options.baseUrl+A)),this._addUrlArgsIfNecessaryToUrl(A)},D.prototype.isBuild=function(){return this.options.isBuild},D.prototype.isDuplicateMessageIgnoredFor=function(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)},D.prototype.getConfigForModule=function(l){if(this.options.config)return this.options.config[l]},D.prototype.shouldCatchError=function(){return this.options.catchError},D.prototype.shouldRecordStats=function(){return this.options.recordStats},D.prototype.onError=function(l){this.options.onError(l)},D}();U.Configuration=y})(le||(le={}));var le;(function(U){var n=function(){function r(o){this._env=o,this._scriptLoader=null,this._callbackMap={}}return r.prototype.load=function(o,_,p,m){var h=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new D;else if(this._env.isElectronRenderer){var e=o.getConfig().getOptionsLiteral().preferScriptTags;e?this._scriptLoader=new R:this._scriptLoader=new l(this._env)}else this._env.isNode?this._scriptLoader=new l(this._env):this._scriptLoader=new R;var w={callback:p,errorback:m};if(this._callbackMap.hasOwnProperty(_)){this._callbackMap[_].push(w);return}this._callbackMap[_]=[w],this._scriptLoader.load(o,_,function(){return h.triggerCallback(_)},function(E){return h.triggerErrorback(_,E)})},r.prototype.triggerCallback=function(o){var _=this._callbackMap[o];delete this._callbackMap[o];for(var p=0;p<_.length;p++)_[p].callback()},r.prototype.triggerErrorback=function(o,_){var p=this._callbackMap[o];delete this._callbackMap[o];for(var m=0;m<p.length;m++)p[m].errorback(_)},r}(),R=function(){function r(){}return r.prototype.attachListeners=function(o,_,p){var m=function(){o.removeEventListener("load",h),o.removeEventListener("error",e)},h=function(w){m(),_()},e=function(w){m(),p(w)};o.addEventListener("load",h),o.addEventListener("error",e)},r.prototype.load=function(o,_,p,m){if(/^node\|/.test(_)){var h=o.getConfig().getOptionsLiteral(),e=A(o.getRecorder(),h.nodeRequire||U.global.nodeRequire),w=_.split("|"),E=null;try{E=e(w[1])}catch(s){m(s);return}o.enqueueDefineAnonymousModule([],function(){return E}),p()}else{var L=document.createElement("script");L.setAttribute("async","async"),L.setAttribute("type","text/javascript"),this.attachListeners(L,p,m);var M=o.getConfig().getOptionsLiteral().trustedTypesPolicy;M&&(_=M.createScriptURL(_)),L.setAttribute("src",_);var i=o.getConfig().getOptionsLiteral().cspNonce;i&&L.setAttribute("nonce",i),document.getElementsByTagName("head")[0].appendChild(L)}},r}();function y(r){var o=r.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var _=o?self.eval(o.createScript("","true")):new Function("true");return _.call(self),!0}catch(p){return!1}}var D=function(){function r(){this._cachedCanUseEval=null}return r.prototype._canUseEval=function(o){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=y(o)),this._cachedCanUseEval},r.prototype.load=function(o,_,p,m){if(/^node\|/.test(_)){var h=o.getConfig().getOptionsLiteral(),e=A(o.getRecorder(),h.nodeRequire||U.global.nodeRequire),w=_.split("|"),E=null;try{E=e(w[1])}catch(i){m(i);return}o.enqueueDefineAnonymousModule([],function(){return E}),p()}else{var L=o.getConfig().getOptionsLiteral().trustedTypesPolicy,M=/^((http:)|(https:)|(file:))/.test(_)&&_.substring(0,self.origin.length)!==self.origin;if(!M&&this._canUseEval(o)){fetch(_).then(function(i){if(i.status!==200)throw new Error(i.statusText);return i.text()}).then(function(i){i=i+`
//# sourceURL=`+_;var s=L?self.eval(L.createScript("",i)):new Function(i);s.call(self),p()}).then(void 0,m);return}try{L&&(_=L.createScriptURL(_)),importScripts(_),p()}catch(i){m(i)}}},r}(),l=function(){function r(o){this._env=o,this._didInitialize=!1,this._didPatchNodeRequire=!1}return r.prototype._init=function(o){this._didInitialize||(this._didInitialize=!0,this._fs=o("fs"),this._vm=o("vm"),this._path=o("path"),this._crypto=o("crypto"))},r.prototype._initNodeRequire=function(o,_){var p=_.getConfig().getOptionsLiteral().nodeCachedData;if(!p||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var m=this,h=o("module");function e(w){var E=w.constructor,L=function(i){try{return w.require(i)}finally{}};return L.resolve=function(i,s){return E._resolveFilename(i,w,!1,s)},L.resolve.paths=function(i){return E._resolveLookupPaths(i,w)},L.main=process.mainModule,L.extensions=E._extensions,L.cache=E._cache,L}h.prototype._compile=function(w,E){var L=h.wrap(w.replace(/^#!.*/,"")),M=_.getRecorder(),i=m._getCachedDataPath(p,E),s={filename:E},u;try{var g=m._fs.readFileSync(i);u=g.slice(0,16),s.cachedData=g.slice(16),M.record(60,i)}catch(F){M.record(61,i)}var v=new m._vm.Script(L,s),c=v.runInThisContext(s),a=m._path.dirname(E),f=e(this),b=[this.exports,f,this,E,a,process,Me,Buffer],P=c.apply(this.exports,b);return m._handleCachedData(v,L,i,!s.cachedData,_),m._verifyCachedData(v,L,i,u,_),P}},r.prototype.load=function(o,_,p,m){var h=this,e=o.getConfig().getOptionsLiteral(),w=A(o.getRecorder(),e.nodeRequire||U.global.nodeRequire),E=e.nodeInstrumenter||function(c){return c};this._init(w),this._initNodeRequire(w,o);var L=o.getRecorder();if(/^node\|/.test(_)){var M=_.split("|"),i=null;try{i=w(M[1])}catch(c){m(c);return}o.enqueueDefineAnonymousModule([],function(){return i}),p()}else{_=U.Utilities.fileUriToFilePath(this._env.isWindows,_);var s=this._path.normalize(_),u=this._getElectronRendererScriptPathOrUri(s),g=Boolean(e.nodeCachedData),v=g?this._getCachedDataPath(e.nodeCachedData,_):void 0;this._readSourceAndCachedData(s,v,L,function(c,a,f,b){if(c){m(c);return}var P;a.charCodeAt(0)===r._BOM?P=r._PREFIX+a.substring(1)+r._SUFFIX:P=r._PREFIX+a+r._SUFFIX,P=E(P,s);var F={filename:u,cachedData:f},I=h._createAndEvalScript(o,P,F,p,m);h._handleCachedData(I,P,v,g&&!f,o),h._verifyCachedData(I,P,v,b,o)})}},r.prototype._createAndEvalScript=function(o,_,p,m,h){var e=o.getRecorder();e.record(31,p.filename);var w=new this._vm.Script(_,p),E=w.runInThisContext(p),L=o.getGlobalAMDDefineFunc(),M=!1,i=function(){return M=!0,L.apply(null,arguments)};return i.amd=L.amd,E.call(U.global,o.getGlobalAMDRequireFunc(),i,p.filename,this._path.dirname(p.filename)),e.record(32,p.filename),M?m():h(new Error("Didn't receive define call in "+p.filename+"!")),w},r.prototype._getElectronRendererScriptPathOrUri=function(o){if(!this._env.isElectronRenderer)return o;var _=o.match(/^([a-z])\:(.*)/i);return _?"file:///"+(_[1].toUpperCase()+":"+_[2]).replace(/\\/g,"/"):"file://"+o},r.prototype._getCachedDataPath=function(o,_){var p=this._crypto.createHash("md5").update(_,"utf8").update(o.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(_).replace(/\.js$/,"");return this._path.join(o.path,m+"-"+p+".code")},r.prototype._handleCachedData=function(o,_,p,m,h){var e=this;o.cachedDataRejected?this._fs.unlink(p,function(w){h.getRecorder().record(62,p),e._createAndWriteCachedData(o,_,p,h),w&&h.getConfig().onError(w)}):m&&this._createAndWriteCachedData(o,_,p,h)},r.prototype._createAndWriteCachedData=function(o,_,p,m){var h=this,e=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),w=-1,E=0,L=void 0,M=function(){setTimeout(function(){L||(L=h._crypto.createHash("md5").update(_,"utf8").digest());var i=o.createCachedData();if(!(i.length===0||i.length===w||E>=5)){if(i.length<w){M();return}w=i.length,h._fs.writeFile(p,Buffer.concat([L,i]),function(s){s&&m.getConfig().onError(s),m.getRecorder().record(63,p),M()})}},e*Math.pow(4,E++))};M()},r.prototype._readSourceAndCachedData=function(o,_,p,m){if(!_)this._fs.readFile(o,{encoding:"utf8"},m);else{var h=void 0,e=void 0,w=void 0,E=2,L=function(M){M?m(M):--E==0&&m(void 0,h,e,w)};this._fs.readFile(o,{encoding:"utf8"},function(M,i){h=i,L(M)}),this._fs.readFile(_,function(M,i){!M&&i&&i.length>0?(w=i.slice(0,16),e=i.slice(16),p.record(60,_)):p.record(61,_),L()})}},r.prototype._verifyCachedData=function(o,_,p,m,h){var e=this;!m||o.cachedDataRejected||setTimeout(function(){var w=e._crypto.createHash("md5").update(_,"utf8").digest();m.equals(w)||(h.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+p+"' now, but a RESTART IS REQUIRED")),e._fs.unlink(p,function(E){E&&h.getConfig().onError(E)}))},Math.ceil(5e3*(1+Math.random())))},r._BOM=65279,r._PREFIX="(function (require, define, __filename, __dirname) { ",r._SUFFIX=`
});`,r}();function A(r,o){if(o.__$__isRecorded)return o;var _=function(m){r.record(33,m);try{return o(m)}finally{r.record(34,m)}};return _.__$__isRecorded=!0,_}U.ensureRecordedNodeRequire=A;function d(r){return new n(r)}U.createScriptLoader=d})(le||(le={}));var le;(function(U){var n=function(){function d(r){var o=r.lastIndexOf("/");o!==-1?this.fromModulePath=r.substr(0,o+1):this.fromModulePath=""}return d._normalizeModuleId=function(r){var o=r,_;for(_=/\/\.\//;_.test(o);)o=o.replace(_,"/");for(o=o.replace(/^\.\//g,""),_=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;_.test(o);)o=o.replace(_,"/");return o=o.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),o},d.prototype.resolveModule=function(r){var o=r;return U.Utilities.isAbsolutePath(o)||(U.Utilities.startsWith(o,"./")||U.Utilities.startsWith(o,"../"))&&(o=d._normalizeModuleId(this.fromModulePath+o)),o},d.ROOT=new d(""),d}();U.ModuleIdResolver=n;var R=function(){function d(r,o,_,p,m,h){this.id=r,this.strId=o,this.dependencies=_,this._callback=p,this._errorback=m,this.moduleIdResolver=h,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return d._safeInvokeFunction=function(r,o){try{return{returnedValue:r.apply(U.global,o),producedError:null}}catch(_){return{returnedValue:null,producedError:_}}},d._invokeFactory=function(r,o,_,p){return r.isBuild()&&!U.Utilities.isAnonymousModule(o)?{returnedValue:null,producedError:null}:r.shouldCatchError()?this._safeInvokeFunction(_,p):{returnedValue:_.apply(U.global,p),producedError:null}},d.prototype.complete=function(r,o,_){this._isComplete=!0;var p=null;if(this._callback)if(typeof this._callback=="function"){r.record(21,this.strId);var m=d._invokeFactory(o,this.strId,this._callback,_);p=m.producedError,r.record(22,this.strId),!p&&typeof m.returnedValue!="undefined"&&(!this.exportsPassedIn||U.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(p){var h=U.ensureError(p);h.phase="factory",h.moduleId=this.strId,this.error=h,o.onError(h)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},d.prototype.onDependencyError=function(r){return this._isComplete=!0,this.error=r,this._errorback?(this._errorback(r),!0):!1},d.prototype.isComplete=function(){return this._isComplete},d}();U.Module=R;var y=function(){function d(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return d.prototype.getMaxModuleId=function(){return this._nextId},d.prototype.getModuleId=function(r){var o=this._strModuleIdToIntModuleId.get(r);return typeof o=="undefined"&&(o=this._nextId++,this._strModuleIdToIntModuleId.set(r,o),this._intModuleIdToStrModuleId[o]=r),o},d.prototype.getStrModuleId=function(r){return this._intModuleIdToStrModuleId[r]},d}(),D=function(){function d(r){this.id=r}return d.EXPORTS=new d(0),d.MODULE=new d(1),d.REQUIRE=new d(2),d}();U.RegularDependency=D;var l=function(){function d(r,o,_){this.id=r,this.pluginId=o,this.pluginParam=_}return d}();U.PluginDependency=l;var A=function(){function d(r,o,_,p,m){m===void 0&&(m=0),this._env=r,this._scriptLoader=o,this._loaderAvailableTimestamp=m,this._defineFunc=_,this._requireFunc=p,this._moduleIdProvider=new y,this._config=new U.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return d.prototype.reset=function(){return new d(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},d.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},d.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},d._findRelevantLocationInStack=function(r,o){for(var _=function(s){return s.replace(/\\/g,"/")},p=_(r),m=o.split(/\n/),h=0;h<m.length;h++){var e=m[h].match(/(.*):(\d+):(\d+)\)?$/);if(e){var w=e[1],E=e[2],L=e[3],M=Math.max(w.lastIndexOf(" ")+1,w.lastIndexOf("(")+1);if(w=w.substr(M),w=_(w),w===p){var i={line:parseInt(E,10),col:parseInt(L,10)};return i.line===1&&(i.col-="(function (require, define, __filename, __dirname) { ".length),i}}}throw new Error("Could not correlate define call site for needle "+r)},d.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var r=[],o=0,_=0,p=this._modules2.length;_<p;_++){var m=this._modules2[_];if(!!m){var h=this._buildInfoPath[m.id]||null,e=this._buildInfoDefineStack[m.id]||null,w=this._buildInfoDependencies[m.id];r[o++]={id:m.strId,path:h,defineLocation:h&&e?d._findRelevantLocationInStack(h,e):null,dependencies:w,shim:null,exports:m.exports}}}return r},d.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new U.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=U.NullLoaderEventRecorder.INSTANCE),this._recorder},d.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},d.prototype.enqueueDefineAnonymousModule=function(r,o){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var _=null;this._config.isBuild()&&(_=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:_,dependencies:r,callback:o}},d.prototype.defineModule=function(r,o,_,p,m,h){var e=this;h===void 0&&(h=new n(r));var w=this._moduleIdProvider.getModuleId(r);if(this._modules2[w]){this._config.isDuplicateMessageIgnoredFor(r)||console.warn("Duplicate definition of module '"+r+"'");return}var E=new R(w,r,this._normalizeDependencies(o,h),_,p,h);this._modules2[w]=E,this._config.isBuild()&&(this._buildInfoDefineStack[w]=m,this._buildInfoDependencies[w]=(E.dependencies||[]).map(function(L){return e._moduleIdProvider.getStrModuleId(L.id)})),this._resolve(E)},d.prototype._normalizeDependency=function(r,o){if(r==="exports")return D.EXPORTS;if(r==="module")return D.MODULE;if(r==="require")return D.REQUIRE;var _=r.indexOf("!");if(_>=0){var p=o.resolveModule(r.substr(0,_)),m=o.resolveModule(r.substr(_+1)),h=this._moduleIdProvider.getModuleId(p+"!"+m),e=this._moduleIdProvider.getModuleId(p);return new l(h,e,m)}return new D(this._moduleIdProvider.getModuleId(o.resolveModule(r)))},d.prototype._normalizeDependencies=function(r,o){for(var _=[],p=0,m=0,h=r.length;m<h;m++)_[p++]=this._normalizeDependency(r[m],o);return _},d.prototype._relativeRequire=function(r,o,_,p){if(typeof o=="string")return this.synchronousRequire(o,r);this.defineModule(U.Utilities.generateAnonymousModule(),o,_,p,null,r)},d.prototype.synchronousRequire=function(r,o){o===void 0&&(o=new n(r));var _=this._normalizeDependency(r,o),p=this._modules2[_.id];if(!p)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+r+"'. This is the first mention of this module!");if(!p.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+r+"'. This module has not been resolved completely yet.");if(p.error)throw p.error;return p.exports},d.prototype.configure=function(r,o){var _=this._config.shouldRecordStats();o?this._config=new U.Configuration(this._env,r):this._config=this._config.cloneAndMerge(r),this._config.shouldRecordStats()&&!_&&(this._recorder=null)},d.prototype.getConfig=function(){return this._config},d.prototype._onLoad=function(r){if(this._currentAnonymousDefineCall!==null){var o=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(r),o.dependencies,o.callback,null,o.stack)}},d.prototype._createLoadError=function(r,o){var _=this,p=this._moduleIdProvider.getStrModuleId(r),m=(this._inverseDependencies2[r]||[]).map(function(e){return _._moduleIdProvider.getStrModuleId(e)}),h=U.ensureError(o);return h.phase="loading",h.moduleId=p,h.neededBy=m,h},d.prototype._onLoadError=function(r,o){var _=this._createLoadError(r,o);this._modules2[r]||(this._modules2[r]=new R(r,this._moduleIdProvider.getStrModuleId(r),[],function(){},null,null));for(var p=[],m=0,h=this._moduleIdProvider.getMaxModuleId();m<h;m++)p[m]=!1;var e=!1,w=[];for(w.push(r),p[r]=!0;w.length>0;){var E=w.shift(),L=this._modules2[E];L&&(e=L.onDependencyError(_)||e);var M=this._inverseDependencies2[E];if(M)for(var m=0,h=M.length;m<h;m++){var i=M[m];p[i]||(w.push(i),p[i]=!0)}}e||this._config.onError(_)},d.prototype._hasDependencyPath=function(r,o){var _=this._modules2[r];if(!_)return!1;for(var p=[],m=0,h=this._moduleIdProvider.getMaxModuleId();m<h;m++)p[m]=!1;var e=[];for(e.push(_),p[r]=!0;e.length>0;){var w=e.shift(),E=w.dependencies;if(E)for(var m=0,h=E.length;m<h;m++){var L=E[m];if(L.id===o)return!0;var M=this._modules2[L.id];M&&!p[L.id]&&(p[L.id]=!0,e.push(M))}}return!1},d.prototype._findCyclePath=function(r,o,_){if(r===o||_===50)return[r];var p=this._modules2[r];if(!p)return null;var m=p.dependencies;if(m)for(var h=0,e=m.length;h<e;h++){var w=this._findCyclePath(m[h].id,o,_+1);if(w!==null)return w.push(r),w}return null},d.prototype._createRequire=function(r){var o=this,_=function(p,m,h){return o._relativeRequire(r,p,m,h)};return _.toUrl=function(p){return o._config.requireToUrl(r.resolveModule(p))},_.getStats=function(){return o.getLoaderEvents()},_.hasDependencyCycle=function(){return o._hasDependencyCycle},_.config=function(p,m){m===void 0&&(m=!1),o.configure(p,m)},_.__$__nodeRequire=U.global.nodeRequire,_},d.prototype._loadModule=function(r){var o=this;if(!(this._modules2[r]||this._knownModules2[r])){this._knownModules2[r]=!0;var _=this._moduleIdProvider.getStrModuleId(r),p=this._config.moduleIdToPaths(_),m=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(_.indexOf("/")===-1||m.test(_))&&p.push("node|"+_);var h=-1,e=function(w){if(h++,h>=p.length)o._onLoadError(r,w);else{var E=p[h],L=o.getRecorder();if(o._config.isBuild()&&E==="empty:"){o._buildInfoPath[r]=E,o.defineModule(o._moduleIdProvider.getStrModuleId(r),[],null,null,null),o._onLoad(r);return}L.record(10,E),o._scriptLoader.load(o,E,function(){o._config.isBuild()&&(o._buildInfoPath[r]=E),L.record(11,E),o._onLoad(r)},function(M){L.record(12,E),e(M)})}};e(null)}},d.prototype._loadPluginDependency=function(r,o){var _=this;if(!(this._modules2[o.id]||this._knownModules2[o.id])){this._knownModules2[o.id]=!0;var p=function(m){_.defineModule(_._moduleIdProvider.getStrModuleId(o.id),[],m,null,null)};p.error=function(m){_._config.onError(_._createLoadError(o.id,m))},r.load(o.pluginParam,this._createRequire(n.ROOT),p,this._config.getOptionsLiteral())}},d.prototype._resolve=function(r){var o=this,_=r.dependencies;if(_)for(var p=0,m=_.length;p<m;p++){var h=_[p];if(h===D.EXPORTS){r.exportsPassedIn=!0,r.unresolvedDependenciesCount--;continue}if(h===D.MODULE){r.unresolvedDependenciesCount--;continue}if(h===D.REQUIRE){r.unresolvedDependenciesCount--;continue}var e=this._modules2[h.id];if(e&&e.isComplete()){if(e.error){r.onDependencyError(e.error);return}r.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,r.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(r.id)+"'. The cyclic path follows:");var w=this._findCyclePath(h.id,r.id,0)||[];w.reverse(),w.push(h.id),console.warn(w.map(function(M){return o._moduleIdProvider.getStrModuleId(M)}).join(` => 
`)),r.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(r.id),h instanceof l){var E=this._modules2[h.pluginId];if(E&&E.isComplete()){this._loadPluginDependency(E.exports,h);continue}var L=this._inversePluginDependencies2.get(h.pluginId);L||(L=[],this._inversePluginDependencies2.set(h.pluginId,L)),L.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}r.unresolvedDependenciesCount===0&&this._onModuleComplete(r)},d.prototype._onModuleComplete=function(r){var o=this,_=this.getRecorder();if(!r.isComplete()){var p=r.dependencies,m=[];if(p)for(var h=0,e=p.length;h<e;h++){var w=p[h];if(w===D.EXPORTS){m[h]=r.exports;continue}if(w===D.MODULE){m[h]={id:r.strId,config:function(){return o._config.getConfigForModule(r.strId)}};continue}if(w===D.REQUIRE){m[h]=this._createRequire(r.moduleIdResolver);continue}var E=this._modules2[w.id];if(E){m[h]=E.exports;continue}m[h]=null}r.complete(_,this._config,m);var L=this._inverseDependencies2[r.id];if(this._inverseDependencies2[r.id]=null,L)for(var h=0,e=L.length;h<e;h++){var M=L[h],i=this._modules2[M];i.unresolvedDependenciesCount--,i.unresolvedDependenciesCount===0&&this._onModuleComplete(i)}var s=this._inversePluginDependencies2.get(r.id);if(s){this._inversePluginDependencies2.delete(r.id);for(var h=0,e=s.length;h<e;h++)this._loadPluginDependency(r.exports,s[h])}}},d}();U.ModuleManager=A})(le||(le={}));var x,le;(function(U){var n=new U.Environment,R=null,y=function(d,r,o){typeof d!="string"&&(o=r,r=d,d=null),(typeof r!="object"||!Array.isArray(r))&&(o=r,r=null),r||(r=["require","exports","module"]),d?R.defineModule(d,r,o,null,null):R.enqueueDefineAnonymousModule(r,o)};y.amd={jQuery:!0};var D=function(d,r){r===void 0&&(r=!1),R.configure(d,r)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){D(arguments[0]);return}if(typeof arguments[0]=="string")return R.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){R.defineModule(U.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=D,l.getConfig=function(){return R.getConfig().getOptionsLiteral()},l.reset=function(){R=R.reset()},l.getBuildInfo=function(){return R.getBuildInfo()},l.getStats=function(){return R.getLoaderEvents()},l.define=y;function A(){if(typeof U.global.require!="undefined"||typeof require!="undefined"){var d=U.global.require||require;if(typeof d=="function"&&typeof d.resolve=="function"){var r=U.ensureRecordedNodeRequire(R.getRecorder(),d);U.global.nodeRequire=r,l.nodeRequire=r,l.__$__nodeRequire=r}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=l,require=l):(n.isElectronRenderer||(U.global.define=y),U.global.require=l)}U.init=A,(typeof U.global.define!="function"||!U.global.define.amd)&&(R=new U.ModuleManager(n,U.createScriptLoader(n),y,l,U.Utilities.getHighPerformanceTimestamp()),typeof U.global.require!="undefined"&&typeof U.global.require!="function"&&l.config(U.global.require),x=function(){return y.apply(null,arguments)},x.amd=y.amd,typeof doNotInitLoader=="undefined"&&A())})(le||(le={}));var De=this,be;(function(U){var n=De||{},R=n.Plugin&&n.Plugin.Resources?n.Plugin.Resources:void 0,y=n&&n.document&&n.document.location&&n.document.location.hash.indexOf("pseudo=true")>=0;function D(o,_){var p;return _.length===0?p=o:p=o.replace(/\{(\d+)\}/g,function(m,h){var e=h[0];return typeof _[e]!="undefined"?_[e]:m}),y&&(p="\uFF3B"+p.replace(/[aouei]/g,"$&$&")+"\uFF3D"),p}function l(o,_){var p=o[_];return p||(p=o["*"],p)?p:null}function A(o,_){for(var p=[],m=0;m<arguments.length-2;m++)p[m]=arguments[m+2];return D(_,p)}function d(o){return function(_,p){var m=Array.prototype.slice.call(arguments,2);return D(o[_],m)}}var r=function(){function o(){this.localize=A}return o.prototype.setPseudoTranslation=function(_){y=_},o.prototype.create=function(_,p){return{localize:d(p[_])}},o.prototype.load=function(_,p,m,h){if(h=h||{},!_||_.length===0)m({localize:A});else{var e=void 0;if(R&&R.getString)e=".nls.keys",p([_+e],function(L){m({localize:function(M,i){if(!L[M])return"NLS error: unknown key "+M;var s=L[M].keys;if(i>=s.length)return"NLS error unknown index "+i;var u=s[i],g=[];g[0]=M+"_"+u;for(var v=0;v<arguments.length-2;v++)g[v+1]=arguments[v+2];return R.getString.apply(R,g)}})});else if(h.isBuild)p([_+".nls",_+".nls.keys"],function(L,M){o.BUILD_MAP[_]=L,o.BUILD_MAP_KEYS[_]=M,m(L)});else{var w=h["vs/nls"]||{},E=w.availableLanguages?l(w.availableLanguages,_):null;e=".nls",E!==null&&E!==o.DEFAULT_TAG&&(e=e+"."+E),p([_+e],function(L){Array.isArray(L)?L.localize=d(L):L.localize=d(L[_]),m(L)})}}},o.prototype._getEntryPointsMap=function(){return n.nlsPluginEntryPoints=n.nlsPluginEntryPoints||{},n.nlsPluginEntryPoints},o.prototype.write=function(_,p,m){var h=m.getEntryPoint(),e=this._getEntryPointsMap();e[h]=e[h]||[],e[h].push(p),p!==h&&m.asModule(_+"!"+p,"define(['vs/nls', 'vs/nls!"+h+`'], function(nls, data) { return nls.create("`+p+'", data); });')},o.prototype.writeFile=function(_,p,m,h,e){var w=this._getEntryPointsMap();if(w.hasOwnProperty(p)){for(var E=m.toUrl(p+".nls.js"),L=["/*---------------------------------------------------------"," * Copyright (c) Microsoft Corporation. All rights reserved."," *--------------------------------------------------------*/"],M=w[p],i={},s=0;s<M.length;s++)i[M[s]]=o.BUILD_MAP[M[s]];L.push('define("'+p+'.nls", '+JSON.stringify(i,null,"	")+");"),h(E,L.join(`\r
`))}},o.prototype.finishBuild=function(_){_("nls.metadata.json",JSON.stringify({keys:o.BUILD_MAP_KEYS,messages:o.BUILD_MAP,bundles:this._getEntryPointsMap()},null,"	"))},o.DEFAULT_TAG="i-default",o.BUILD_MAP={},o.BUILD_MAP_KEYS={},o}();U.NLSPlugin=r,function(){x("vs/nls",new r)}()})(be||(be={})),x(ee[15],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class R{constructor(D,l,A,d){this.originalStart=D,this.originalLength=l,this.modifiedStart=A,this.modifiedLength=d}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=R}),x(ee[5],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createErrorWithActions=n.isErrorWithActions=n.ExpectedError=n.NotSupportedError=n.NotImplementedError=n.getErrorMessage=n.disposed=n.readonly=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isPromiseCanceledError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.setUnexpectedErrorHandler=n.errorHandler=n.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(g){setTimeout(()=>{throw g.stack?new Error(g.message+`

`+g.stack):g},0)}}addListener(g){return this.listeners.push(g),()=>{this._removeListener(g)}}emit(g){this.listeners.forEach(v=>{v(g)})}_removeListener(g){this.listeners.splice(this.listeners.indexOf(g),1)}setUnexpectedErrorHandler(g){this.unexpectedErrorHandler=g}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(g){this.unexpectedErrorHandler(g),this.emit(g)}onUnexpectedExternalError(g){this.unexpectedErrorHandler(g)}}n.ErrorHandler=R,n.errorHandler=new R;function y(u){n.errorHandler.setUnexpectedErrorHandler(u)}n.setUnexpectedErrorHandler=y;function D(u){r(u)||n.errorHandler.onUnexpectedError(u)}n.onUnexpectedError=D;function l(u){r(u)||n.errorHandler.onUnexpectedExternalError(u)}n.onUnexpectedExternalError=l;function A(u){if(u instanceof Error){let{name:g,message:v}=u;const c=u.stacktrace||u.stack;return{$isError:!0,name:g,message:v,stack:c}}return u}n.transformErrorForSerialization=A;const d="Canceled";function r(u){return u instanceof Error&&u.name===d&&u.message===d}n.isPromiseCanceledError=r;class o extends Error{constructor(){super(d);this.name=this.message}}n.CancellationError=o;function _(){const u=new Error(d);return u.name=u.message,u}n.canceled=_;function p(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}n.illegalArgument=p;function m(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}n.illegalState=m;function h(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}n.readonly=h;function e(u){const g=new Error(`${u} has been disposed`);return g.name="DISPOSED",g}n.disposed=e;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}n.getErrorMessage=w;class E extends Error{constructor(g){super("NotImplemented");g&&(this.message=g)}}n.NotImplementedError=E;class L extends Error{constructor(g){super("NotSupported");g&&(this.message=g)}}n.NotSupportedError=L;class M extends Error{constructor(){super(...arguments);this.isExpected=!0}}n.ExpectedError=M;function i(u){const g=u;return g instanceof Error&&Array.isArray(g.actions)}n.isErrorWithActions=i;function s(u,g=Object.create(null)){const v=new Error(u);return g.actions&&(v.actions=g.actions),v}n.createErrorWithActions=s}),x(ee[16],te([0,1,5]),function(U,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ArrayQueue=n.maxIndex=n.minIndex=n.splice=n.insertInto=n.mapFind=n.getRandomElement=n.asArray=n.mapArrayOrNot=n.pushToEnd=n.pushToStart=n.shuffle=n.arrayInsert=n.remove=n.insert=n.index=n.range=n.flatten=n.commonPrefixLength=n.firstOrDefault=n.lastIndex=n.findLast=n.uniqueFilter=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.move=n.coalesceInPlace=n.coalesce=n.topAsync=n.top=n.delta=n.sortedDiff=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch=n.equals=n.tail2=n.tail=void 0;function y(T,B=0){return T[T.length-(1+B)]}n.tail=y;function D(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}n.tail2=D;function l(T,B,k=(q,j)=>q===j){if(T===B)return!0;if(!T||!B||T.length!==B.length)return!1;for(let q=0,j=T.length;q<j;q++)if(!k(T[q],B[q]))return!1;return!0}n.equals=l;function A(T,B,k){let q=0,j=T.length-1;for(;q<=j;){const K=(q+j)/2|0,J=k(T[K],B);if(J<0)q=K+1;else if(J>0)j=K-1;else return K}return-(q+1)}n.binarySearch=A;function d(T,B){let k=0,q=T.length;if(q===0)return 0;for(;k<q;){const j=Math.floor((k+q)/2);B(T[j])?q=j:k=j+1}return k}n.findFirstInSorted=d;function r(T,B,k){if(T=T|0,T>=B.length)throw new TypeError("invalid index");let q=B[Math.floor(B.length*Math.random())],j=[],K=[],J=[];for(let ae of B){const fe=k(ae,q);fe<0?j.push(ae):fe>0?K.push(ae):J.push(ae)}return T<j.length?r(T,j,k):T<j.length+J.length?J[0]:r(T-(j.length+J.length),K,k)}n.quickSelect=r;function o(T,B){const k=[];let q;for(const j of T.slice(0).sort(B))!q||B(q[0],j)!==0?(q=[j],k.push(q)):q.push(j);return k}n.groupBy=o;function _(T,B,k){const q=[];function j(ae,fe,he){if(fe===0&&he.length===0)return;const ge=q[q.length-1];ge&&ge.start+ge.deleteCount===ae?(ge.deleteCount+=fe,ge.toInsert.push(...he)):q.push({start:ae,deleteCount:fe,toInsert:he})}let K=0,J=0;for(;;){if(K===T.length){j(K,0,B.slice(J));break}if(J===B.length){j(K,T.length-K,[]);break}const ae=T[K],fe=B[J],he=k(ae,fe);he===0?(K+=1,J+=1):he<0?(j(K,1,[]),K+=1):he>0&&(j(K,0,[fe]),J+=1)}return q}n.sortedDiff=_;function p(T,B,k){const q=_(T,B,k),j=[],K=[];for(const J of q)j.push(...T.slice(J.start,J.start+J.deleteCount)),K.push(...J.toInsert);return{removed:j,added:K}}n.delta=p;function m(T,B,k){if(k===0)return[];const q=T.slice(0,k).sort(B);return e(T,B,q,k,T.length),q}n.top=m;function h(T,B,k,q,j){return k===0?Promise.resolve([]):new Promise((K,J)=>{(async()=>{const ae=T.length,fe=T.slice(0,k).sort(B);for(let he=k,ge=Math.min(k+q,ae);he<ae;he=ge,ge=Math.min(ge+q,ae)){if(he>k&&await new Promise(Ee=>setTimeout(Ee)),j&&j.isCancellationRequested)throw(0,R.canceled)();e(T,B,fe,he,ge)}return fe})().then(K,J)})}n.topAsync=h;function e(T,B,k,q,j){for(const K=k.length;q<j;q++){const J=T[q];if(B(J,k[K-1])<0){k.pop();const ae=d(k,fe=>B(J,fe)<0);k.splice(ae,0,J)}}}function w(T){return T.filter(B=>!!B)}n.coalesce=w;function E(T){let B=0;for(let k=0;k<T.length;k++)T[k]&&(T[B]=T[k],B+=1);T.length=B}n.coalesceInPlace=E;function L(T,B,k){T.splice(k,0,T.splice(B,1)[0])}n.move=L;function M(T){return!Array.isArray(T)||T.length===0}n.isFalsyOrEmpty=M;function i(T){return Array.isArray(T)&&T.length>0}n.isNonEmptyArray=i;function s(T,B=k=>k){const k=new Set;return T.filter(q=>{const j=B(q);return k.has(j)?!1:(k.add(j),!0)})}n.distinct=s;function u(T){const B=Object.create(null);return k=>{const q=T(k);return B[q]?!1:(B[q]=!0,!0)}}n.uniqueFilter=u;function g(T,B){const k=v(T,B);if(k!==-1)return T[k]}n.findLast=g;function v(T,B){for(let k=T.length-1;k>=0;k--){const q=T[k];if(B(q))return k}return-1}n.lastIndex=v;function c(T,B){return T.length>0?T[0]:B}n.firstOrDefault=c;function a(T,B,k=(q,j)=>q===j){let q=0;for(let j=0,K=Math.min(T.length,B.length);j<K&&k(T[j],B[j]);j++)q++;return q}n.commonPrefixLength=a;function f(T){return[].concat(...T)}n.flatten=f;function b(T,B){let k=typeof B=="number"?T:0;typeof B=="number"?k=T:(k=0,B=T);const q=[];if(k<=B)for(let j=k;j<B;j++)q.push(j);else for(let j=k;j>B;j--)q.push(j);return q}n.range=b;function P(T,B,k){return T.reduce((q,j)=>(q[B(j)]=k?k(j):j,q),Object.create(null))}n.index=P;function F(T,B){return T.push(B),()=>I(T,B)}n.insert=F;function I(T,B){const k=T.indexOf(B);if(k>-1)return T.splice(k,1),B}n.remove=I;function V(T,B,k){const q=T.slice(0,B),j=T.slice(B);return q.concat(k,j)}n.arrayInsert=V;function C(T,B){let k;if(typeof B=="number"){let q=B;k=()=>{const j=Math.sin(q++)*179426549;return j-Math.floor(j)}}else k=Math.random;for(let q=T.length-1;q>0;q-=1){const j=Math.floor(k()*(q+1)),K=T[q];T[q]=T[j],T[j]=K}}n.shuffle=C;function H(T,B){const k=T.indexOf(B);k>-1&&(T.splice(k,1),T.unshift(B))}n.pushToStart=H;function Z(T,B){const k=T.indexOf(B);k>-1&&(T.splice(k,1),T.push(B))}n.pushToEnd=Z;function G(T,B){return Array.isArray(T)?T.map(B):B(T)}n.mapArrayOrNot=G;function se(T){return Array.isArray(T)?T:[T]}n.asArray=se;function t(T){return T[Math.floor(Math.random()*T.length)]}n.getRandomElement=t;function $(T,B){for(const k of T){const q=B(k);if(q!==void 0)return q}}n.mapFind=$;function W(T,B,k){const q=Q(T,B),j=T.length,K=k.length;T.length=j+K;for(let J=j-1;J>=q;J--)T[J+K]=T[J];for(let J=0;J<K;J++)T[J+q]=k[J]}n.insertInto=W;function X(T,B,k,q){const j=Q(T,B),K=T.splice(j,k);return W(T,j,q),K}n.splice=X;function Q(T,B){return B<0?Math.max(B+T.length,0):Math.min(B,T.length)}function ne(T,B){let k=Number.MAX_SAFE_INTEGER,q=0;return T.forEach((j,K)=>{const J=B(j);J<k&&(k=J,q=K)}),q}n.minIndex=ne;function ie(T,B){let k=Number.MIN_SAFE_INTEGER,q=0;return T.forEach((j,K)=>{const J=B(j);J>k&&(k=J,q=K)}),q}n.maxIndex=ie;class ue{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let k=this.firstIdx;for(;k<this.items.length&&B(this.items[k]);)k++;const q=k===this.firstIdx?null:this.items.slice(this.firstIdx,k);return this.firstIdx=k,q}takeFromEndWhile(B){let k=this.lastIdx;for(;k>=0&&B(this.items[k]);)k--;const q=k===this.lastIdx?null:this.items.slice(k+1,this.lastIdx+1);return this.lastIdx=k,q}peek(){return this.items[this.firstIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}takeCount(B){const k=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,k}}n.ArrayQueue=ue}),x(ee[8],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function R(y){const D=this;let l=!1,A;return function(){return l||(l=!0,A=y.apply(D,arguments)),A}}n.once=R}),x(ee[17],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var R;(function(y){function D(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}y.is=D;const l=Object.freeze([]);function A(){return l}y.empty=A;function*d(u){yield u}y.single=d;function r(u){return u||l}y.from=r;function o(u){return!u||u[Symbol.iterator]().next().done===!0}y.isEmpty=o;function _(u){return u[Symbol.iterator]().next().value}y.first=_;function p(u,g){for(const v of u)if(g(v))return!0;return!1}y.some=p;function m(u,g){for(const v of u)if(g(v))return v}y.find=m;function*h(u,g){for(const v of u)g(v)&&(yield v)}y.filter=h;function*e(u,g){let v=0;for(const c of u)yield g(c,v++)}y.map=e;function*w(...u){for(const g of u)for(const v of g)yield v}y.concat=w;function*E(u){for(const g of u)for(const v of g)yield v}y.concatNested=E;function L(u,g,v){let c=v;for(const a of u)c=g(c,a);return c}y.reduce=L;function*M(u,g,v=u.length){for(g<0&&(g+=u.length),v<0?v+=u.length:v>u.length&&(v=u.length);g<v;g++)yield u[g]}y.slice=M;function i(u,g=Number.POSITIVE_INFINITY){const v=[];if(g===0)return[v,u];const c=u[Symbol.iterator]();for(let a=0;a<g;a++){const f=c.next();if(f.done)return[v,y.empty()];v.push(f.value)}return[v,{[Symbol.iterator](){return c}}]}y.consume=i;function s(u,g,v=(c,a)=>c===a){const c=u[Symbol.iterator](),a=g[Symbol.iterator]();for(;;){const f=c.next(),b=a.next();if(f.done!==b.done)return!1;if(f.done)return!0;if(!v(f.value,b.value))return!1}}y.equals=s})(R=n.Iterable||(n.Iterable={}))}),x(ee[18],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyMod=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.ScanCodeUtils=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=n.ScanCode=n.KeyCode=void 0;var R;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.MAX_VALUE=126]="MAX_VALUE"})(R=n.KeyCode||(n.KeyCode={}));var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(y=n.ScanCode||(n.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(w,E){this._keyCodeToStr[w]=E,this._strToKeyCode[E.toLowerCase()]=w}keyCodeToStr(w){return this._keyCodeToStr[w]}strToKeyCode(w){return this._strToKeyCode[w.toLowerCase()]||0}}const l=new D,A=new D,d=new D;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const r=[],o=Object.create(null),_=Object.create(null);n.ScanCodeUtils={lowerCaseToEnum:e=>_[e]||0,toEnum:e=>o[e]||0,toString:e=>r[e]||"None"},n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=126;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",w=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",0,e,0,e,e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_CLEAR",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let E=[],L=[];for(const M of w){const[i,s,u,g,v,c,a,f,b,P]=M;if(L[u]||(L[u]=!0,r[u]=g,o[g]=u,_[g.toLowerCase()]=u,s&&(n.IMMUTABLE_CODE_TO_KEY_CODE[u]=v,v!==0&&v!==3&&v!==5&&v!==4&&v!==6&&v!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[v]=u))),!E[v]){if(E[v]=!0,!c)throw new Error(`String representation missing for key code ${v} around scan code ${g}`);l.define(v,c),A.define(v,b||c),d.define(v,P||b||c)}a&&(n.EVENT_KEY_CODE_MAP[a]=v),f&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[f]=v)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var p;(function(e){function w(u){return l.keyCodeToStr(u)}e.toString=w;function E(u){return l.strToKeyCode(u)}e.fromString=E;function L(u){return A.keyCodeToStr(u)}e.toUserSettingsUS=L;function M(u){return d.keyCodeToStr(u)}e.toUserSettingsGeneral=M;function i(u){return A.strToKeyCode(u)||d.strToKeyCode(u)}e.fromUserSettings=i;function s(u){if(u>=93&&u<=108)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return l.keyCodeToStr(u)}e.toElectronAccelerator=s})(p=n.KeyCodeUtils||(n.KeyCodeUtils={}));var m;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(m=n.KeyMod||(n.KeyMod={}));function h(e,w){const E=(w&65535)<<16>>>0;return(e|E)>>>0}n.KeyChord=h}),x(ee[9],te([0,1,8,17]),function(U,n,R,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.disposeOnReturn=n.ImmortalReference=n.AsyncReferenceCollection=n.ReferenceCollection=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const D=!1;let l=null;function A(a){l=a}if(n.setDisposableTracker=A,D){const a="__is_disposable_tracked__";A(new class{trackDisposable(f){const b=new Error("Potentially leaked disposable").stack;setTimeout(()=>{f[a]||console.log(b)},3e3)}setParent(f,b){if(f&&f!==M.None)try{f[a]=!0}catch{}}markAsDisposed(f){if(f&&f!==M.None)try{f[a]=!0}catch{}}markAsSingleton(f){}})}function d(a){return l?.trackDisposable(a),a}function r(a){l?.markAsDisposed(a)}function o(a,f){l?.setParent(a,f)}function _(a,f){if(!!l)for(const b of a)l.setParent(b,f)}function p(a){return l?.markAsSingleton(a),a}n.markAsSingleton=p;class m extends Error{constructor(f){super(`Encountered errors while disposing of store. Errors: [${f.join(", ")}]`);this.errors=f}}n.MultiDisposeError=m;function h(a){return typeof a.dispose=="function"&&a.dispose.length===0}n.isDisposable=h;function e(a){if(y.Iterable.is(a)){let f=[];for(const b of a)if(b)try{b.dispose()}catch(P){f.push(P)}if(f.length===1)throw f[0];if(f.length>1)throw new m(f);return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}n.dispose=e;function w(...a){const f=E(()=>e(a));return _(a,f),f}n.combinedDisposable=w;function E(a){const f=d({dispose:(0,R.once)(()=>{r(f),a()})});return f}n.toDisposable=E;class L{constructor(){this._toDispose=new Set,this._isDisposed=!1,d(this)}dispose(){this._isDisposed||(r(this),this._isDisposed=!0,this.clear())}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(f){if(!f)return f;if(f===this)throw new Error("Cannot register a disposable on itself!");return o(f,this),this._isDisposed?L.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(f),f}}n.DisposableStore=L,L.DISABLE_DISPOSED_WARNING=!1;class M{constructor(){this._store=new L,d(this),o(this._store,this)}dispose(){r(this),this._store.dispose()}_register(f){if(f===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(f)}}n.Disposable=M,M.None=Object.freeze({dispose(){}});class i{constructor(){this._isDisposed=!1,d(this)}get value(){return this._isDisposed?void 0:this._value}set value(f){this._isDisposed||f===this._value||(this._value?.dispose(),f&&o(f,this),this._value=f)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,r(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const f=this._value;return this._value=void 0,f&&o(f,null),f}}n.MutableDisposable=i;class s{constructor(f){this._disposable=f,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}n.RefCountedDisposable=s;class u{constructor(){this.references=new Map}acquire(f,...b){let P=this.references.get(f);P||(P={counter:0,object:this.createReferencedObject(f,...b)},this.references.set(f,P));const{object:F}=P,I=(0,R.once)(()=>{--P.counter==0&&(this.destroyReferencedObject(f,P.object),this.references.delete(f))});return P.counter++,{object:F,dispose:I}}}n.ReferenceCollection=u;class g{constructor(f){this.referenceCollection=f}async acquire(f,...b){const P=this.referenceCollection.acquire(f,...b);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(F){throw P.dispose(),F}}}n.AsyncReferenceCollection=g;class v{constructor(f){this.object=f}dispose(){}}n.ImmortalReference=v;function c(a){const f=new L;try{a(f)}finally{f.dispose()}}n.disposeOnReturn=c}),x(ee[19],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class R{constructor(l){this.element=l,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class y{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let l=this._first;for(;l!==R.Undefined;){const A=l.next;l.prev=R.Undefined,l.next=R.Undefined,l=A}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(l){return this._insert(l,!1)}push(l){return this._insert(l,!0)}_insert(l,A){const d=new R(l);if(this._first===R.Undefined)this._first=d,this._last=d;else if(A){const o=this._last;this._last=d,d.prev=o,o.next=d}else{const o=this._first;this._first=d,d.next=o,o.prev=d}this._size+=1;let r=!1;return()=>{r||(r=!0,this._remove(d))}}shift(){if(this._first!==R.Undefined){const l=this._first.element;return this._remove(this._first),l}}pop(){if(this._last!==R.Undefined){const l=this._last.element;return this._remove(this._last),l}}_remove(l){if(l.prev!==R.Undefined&&l.next!==R.Undefined){const A=l.prev;A.next=l.next,l.next.prev=A}else l.prev===R.Undefined&&l.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):l.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):l.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let l=this._first;for(;l!==R.Undefined;)yield l.element,l=l.next}}n.LinkedList=y}),x(ee[2],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isLittleEndian=n.OS=n.OperatingSystem=n.setImmediate=n.translationsConfigFile=n.locale=n.Language=n.language=n.userAgent=n.platform=n.isIOS=n.isWeb=n.isNative=n.isLinuxSnap=n.isLinux=n.isMacintosh=n.isWindows=n.PlatformToString=n.Platform=n.isElectronSandboxed=n.globals=void 0;const R="en";let y=!1,D=!1,l=!1,A=!1,d=!1,r=!1,o=!1,_,p=R,m,h;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let e;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?e=n.globals.vscode.process:typeof process!="undefined"&&(e=process);const w=typeof e?.versions?.electron=="string"&&e.type==="renderer";if(n.isElectronSandboxed=w&&e?.sandboxed,typeof navigator=="object"&&!w)h=navigator.userAgent,y=h.indexOf("Windows")>=0,D=h.indexOf("Macintosh")>=0,o=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,l=h.indexOf("Linux")>=0,r=!0,_=navigator.language,p=_;else if(typeof e=="object"){y=e.platform==="win32",D=e.platform==="darwin",l=e.platform==="linux",A=l&&!!e.env.SNAP&&!!e.env.SNAP_REVISION,_=R,p=R;const c=e.env.VSCODE_NLS_CONFIG;if(c)try{const a=JSON.parse(c),f=a.availableLanguages["*"];_=a.locale,p=f||R,m=a._translationsConfigFile}catch(a){}d=!0}else console.error("Unable to resolve platform.");var E;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(E=n.Platform||(n.Platform={}));function L(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}n.PlatformToString=L;let M=0;D?M=1:y?M=3:l&&(M=2),n.isWindows=y,n.isMacintosh=D,n.isLinux=l,n.isLinuxSnap=A,n.isNative=d,n.isWeb=r,n.isIOS=o,n.platform=M,n.userAgent=h,n.language=p;var i;(function(c){function a(){return n.language}c.value=a;function f(){return n.language.length===2?n.language==="en":n.language.length>=3?n.language[0]==="e"&&n.language[1]==="n"&&n.language[2]==="-":!1}c.isDefaultVariant=f;function b(){return n.language==="en"}c.isDefault=b})(i=n.Language||(n.Language={})),n.locale=_,n.translationsConfigFile=m,n.setImmediate=function(){if(n.globals.setImmediate)return n.globals.setImmediate.bind(n.globals);if(typeof n.globals.postMessage=="function"&&!n.globals.importScripts){let f=[];n.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let F=0,I=f.length;F<I;F++){const V=f[F];if(V.id===P.data.vscodeSetImmediateId){f.splice(F,1),V.callback();return}}});let b=0;return P=>{const F=++b;f.push({id:F,callback:P}),n.globals.postMessage({vscodeSetImmediateId:F},"*")}}if(typeof e?.nextTick=="function")return e.nextTick.bind(e);const a=Promise.resolve();return f=>a.then(f)}();var s;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(s=n.OperatingSystem||(n.OperatingSystem={})),n.OS=D||o?2:y?1:3;let u=!0,g=!1;function v(){if(!g){g=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,u=new Uint16Array(c.buffer)[0]===(2<<8)+1}return u}n.isLittleEndian=v}),x(ee[20],te([0,1,2]),function(U,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.arch=n.nextTick=n.platform=n.env=n.cwd=void 0;let y;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const D=R.globals.vscode.process;y={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(l){return(0,R.setImmediate)(l)}}}else typeof process!="undefined"?y={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:y={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,R.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};n.cwd=y.cwd,n.env=y.env,n.platform=y.platform,n.nextTick=y.nextTick,n.arch=y.arch}),x(ee[21],te([0,1,20]),function(U,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.delimiter=n.sep=n.toNamespacedPath=n.parse=n.format=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.join=n.isAbsolute=n.normalize=n.posix=n.win32=void 0;const y=65,D=97,l=90,A=122,d=46,r=47,o=92,_=58,p=63;class m extends Error{constructor(s,u,g){let v;typeof u=="string"&&u.indexOf("not ")===0?(v="must not be",u=u.replace(/^not /,"")):v="must be";const c=s.indexOf(".")!==-1?"property":"argument";let a=`The "${s}" ${c} ${v} of type ${u}`;a+=`. Received type ${typeof g}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(i,s){if(typeof i!="string")throw new m(s,"string",i)}function e(i){return i===r||i===o}function w(i){return i===r}function E(i){return i>=y&&i<=l||i>=D&&i<=A}function L(i,s,u,g){let v="",c=0,a=-1,f=0,b=0;for(let P=0;P<=i.length;++P){if(P<i.length)b=i.charCodeAt(P);else{if(g(b))break;b=r}if(g(b)){if(!(a===P-1||f===1))if(f===2){if(v.length<2||c!==2||v.charCodeAt(v.length-1)!==d||v.charCodeAt(v.length-2)!==d){if(v.length>2){const F=v.lastIndexOf(u);F===-1?(v="",c=0):(v=v.slice(0,F),c=v.length-1-v.lastIndexOf(u)),a=P,f=0;continue}else if(v.length!==0){v="",c=0,a=P,f=0;continue}}s&&(v+=v.length>0?`${u}..`:"..",c=2)}else v.length>0?v+=`${u}${i.slice(a+1,P)}`:v=i.slice(a+1,P),c=P-a-1;a=P,f=0}else b===d&&f!==-1?++f:f=-1}return v}function M(i,s){if(s===null||typeof s!="object")throw new m("pathObject","Object",s);const u=s.dir||s.root,g=s.base||`${s.name||""}${s.ext||""}`;return u?u===s.root?`${u}${g}`:`${u}${i}${g}`:g}n.win32={resolve(...i){let s="",u="",g=!1;for(let v=i.length-1;v>=-1;v--){let c;if(v>=0){if(c=i[v],h(c,"path"),c.length===0)continue}else s.length===0?c=R.cwd():(c=R.env[`=${s}`]||R.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==s.toLowerCase()&&c.charCodeAt(2)===o)&&(c=`${s}\\`));const a=c.length;let f=0,b="",P=!1;const F=c.charCodeAt(0);if(a===1)e(F)&&(f=1,P=!0);else if(e(F))if(P=!0,e(c.charCodeAt(1))){let I=2,V=I;for(;I<a&&!e(c.charCodeAt(I));)I++;if(I<a&&I!==V){const C=c.slice(V,I);for(V=I;I<a&&e(c.charCodeAt(I));)I++;if(I<a&&I!==V){for(V=I;I<a&&!e(c.charCodeAt(I));)I++;(I===a||I!==V)&&(b=`\\\\${C}\\${c.slice(V,I)}`,f=I)}}}else f=1;else E(F)&&c.charCodeAt(1)===_&&(b=c.slice(0,2),f=2,a>2&&e(c.charCodeAt(2))&&(P=!0,f=3));if(b.length>0)if(s.length>0){if(b.toLowerCase()!==s.toLowerCase())continue}else s=b;if(g){if(s.length>0)break}else if(u=`${c.slice(f)}\\${u}`,g=P,P&&s.length>0)break}return u=L(u,!g,"\\",e),g?`${s}\\${u}`:`${s}${u}`||"."},normalize(i){h(i,"path");const s=i.length;if(s===0)return".";let u=0,g,v=!1;const c=i.charCodeAt(0);if(s===1)return w(c)?"\\":i;if(e(c))if(v=!0,e(i.charCodeAt(1))){let f=2,b=f;for(;f<s&&!e(i.charCodeAt(f));)f++;if(f<s&&f!==b){const P=i.slice(b,f);for(b=f;f<s&&e(i.charCodeAt(f));)f++;if(f<s&&f!==b){for(b=f;f<s&&!e(i.charCodeAt(f));)f++;if(f===s)return`\\\\${P}\\${i.slice(b)}\\`;f!==b&&(g=`\\\\${P}\\${i.slice(b,f)}`,u=f)}}}else u=1;else E(c)&&i.charCodeAt(1)===_&&(g=i.slice(0,2),u=2,s>2&&e(i.charCodeAt(2))&&(v=!0,u=3));let a=u<s?L(i.slice(u),!v,"\\",e):"";return a.length===0&&!v&&(a="."),a.length>0&&e(i.charCodeAt(s-1))&&(a+="\\"),g===void 0?v?`\\${a}`:a:v?`${g}\\${a}`:`${g}${a}`},isAbsolute(i){h(i,"path");const s=i.length;if(s===0)return!1;const u=i.charCodeAt(0);return e(u)||s>2&&E(u)&&i.charCodeAt(1)===_&&e(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,u;for(let c=0;c<i.length;++c){const a=i[c];h(a,"path"),a.length>0&&(s===void 0?s=u=a:s+=`\\${a}`)}if(s===void 0)return".";let g=!0,v=0;if(typeof u=="string"&&e(u.charCodeAt(0))){++v;const c=u.length;c>1&&e(u.charCodeAt(1))&&(++v,c>2&&(e(u.charCodeAt(2))?++v:g=!1))}if(g){for(;v<s.length&&e(s.charCodeAt(v));)v++;v>=2&&(s=`\\${s.slice(v)}`)}return n.win32.normalize(s)},relative(i,s){if(h(i,"from"),h(s,"to"),i===s)return"";const u=n.win32.resolve(i),g=n.win32.resolve(s);if(u===g||(i=u.toLowerCase(),s=g.toLowerCase(),i===s))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===o;)v++;let c=i.length;for(;c-1>v&&i.charCodeAt(c-1)===o;)c--;const a=c-v;let f=0;for(;f<s.length&&s.charCodeAt(f)===o;)f++;let b=s.length;for(;b-1>f&&s.charCodeAt(b-1)===o;)b--;const P=b-f,F=a<P?a:P;let I=-1,V=0;for(;V<F;V++){const H=i.charCodeAt(v+V);if(H!==s.charCodeAt(f+V))break;H===o&&(I=V)}if(V!==F){if(I===-1)return g}else{if(P>F){if(s.charCodeAt(f+V)===o)return g.slice(f+V+1);if(V===2)return g.slice(f+V)}a>F&&(i.charCodeAt(v+V)===o?I=V:V===2&&(I=3)),I===-1&&(I=0)}let C="";for(V=v+I+1;V<=c;++V)(V===c||i.charCodeAt(V)===o)&&(C+=C.length===0?"..":"\\..");return f+=I,C.length>0?`${C}${g.slice(f,b)}`:(g.charCodeAt(f)===o&&++f,g.slice(f,b))},toNamespacedPath(i){if(typeof i!="string")return i;if(i.length===0)return"";const s=n.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===o){if(s.charCodeAt(1)===o){const u=s.charCodeAt(2);if(u!==p&&u!==d)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(E(s.charCodeAt(0))&&s.charCodeAt(1)===_&&s.charCodeAt(2)===o)return`\\\\?\\${s}`;return i},dirname(i){h(i,"path");const s=i.length;if(s===0)return".";let u=-1,g=0;const v=i.charCodeAt(0);if(s===1)return e(v)?i:".";if(e(v)){if(u=g=1,e(i.charCodeAt(1))){let f=2,b=f;for(;f<s&&!e(i.charCodeAt(f));)f++;if(f<s&&f!==b){for(b=f;f<s&&e(i.charCodeAt(f));)f++;if(f<s&&f!==b){for(b=f;f<s&&!e(i.charCodeAt(f));)f++;if(f===s)return i;f!==b&&(u=g=f+1)}}}}else E(v)&&i.charCodeAt(1)===_&&(u=s>2&&e(i.charCodeAt(2))?3:2,g=u);let c=-1,a=!0;for(let f=s-1;f>=g;--f)if(e(i.charCodeAt(f))){if(!a){c=f;break}}else a=!1;if(c===-1){if(u===-1)return".";c=u}return i.slice(0,c)},basename(i,s){s!==void 0&&h(s,"ext"),h(i,"path");let u=0,g=-1,v=!0,c;if(i.length>=2&&E(i.charCodeAt(0))&&i.charCodeAt(1)===_&&(u=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let a=s.length-1,f=-1;for(c=i.length-1;c>=u;--c){const b=i.charCodeAt(c);if(e(b)){if(!v){u=c+1;break}}else f===-1&&(v=!1,f=c+1),a>=0&&(b===s.charCodeAt(a)?--a==-1&&(g=c):(a=-1,g=f))}return u===g?g=f:g===-1&&(g=i.length),i.slice(u,g)}for(c=i.length-1;c>=u;--c)if(e(i.charCodeAt(c))){if(!v){u=c+1;break}}else g===-1&&(v=!1,g=c+1);return g===-1?"":i.slice(u,g)},extname(i){h(i,"path");let s=0,u=-1,g=0,v=-1,c=!0,a=0;i.length>=2&&i.charCodeAt(1)===_&&E(i.charCodeAt(0))&&(s=g=2);for(let f=i.length-1;f>=s;--f){const b=i.charCodeAt(f);if(e(b)){if(!c){g=f+1;break}continue}v===-1&&(c=!1,v=f+1),b===d?u===-1?u=f:a!==1&&(a=1):u!==-1&&(a=-1)}return u===-1||v===-1||a===0||a===1&&u===v-1&&u===g+1?"":i.slice(u,v)},format:M.bind(null,"\\"),parse(i){h(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const u=i.length;let g=0,v=i.charCodeAt(0);if(u===1)return e(v)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(e(v)){if(g=1,e(i.charCodeAt(1))){let I=2,V=I;for(;I<u&&!e(i.charCodeAt(I));)I++;if(I<u&&I!==V){for(V=I;I<u&&e(i.charCodeAt(I));)I++;if(I<u&&I!==V){for(V=I;I<u&&!e(i.charCodeAt(I));)I++;I===u?g=I:I!==V&&(g=I+1)}}}}else if(E(v)&&i.charCodeAt(1)===_){if(u<=2)return s.root=s.dir=i,s;if(g=2,e(i.charCodeAt(2))){if(u===3)return s.root=s.dir=i,s;g=3}}g>0&&(s.root=i.slice(0,g));let c=-1,a=g,f=-1,b=!0,P=i.length-1,F=0;for(;P>=g;--P){if(v=i.charCodeAt(P),e(v)){if(!b){a=P+1;break}continue}f===-1&&(b=!1,f=P+1),v===d?c===-1?c=P:F!==1&&(F=1):c!==-1&&(F=-1)}return f!==-1&&(c===-1||F===0||F===1&&c===f-1&&c===a+1?s.base=s.name=i.slice(a,f):(s.name=i.slice(a,c),s.base=i.slice(a,f),s.ext=i.slice(c,f))),a>0&&a!==g?s.dir=i.slice(0,a-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...i){let s="",u=!1;for(let g=i.length-1;g>=-1&&!u;g--){const v=g>=0?i[g]:R.cwd();h(v,"path"),v.length!==0&&(s=`${v}/${s}`,u=v.charCodeAt(0)===r)}return s=L(s,!u,"/",w),u?`/${s}`:s.length>0?s:"."},normalize(i){if(h(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===r,u=i.charCodeAt(i.length-1)===r;return i=L(i,!s,"/",w),i.length===0?s?"/":u?"./":".":(u&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return h(i,"path"),i.length>0&&i.charCodeAt(0)===r},join(...i){if(i.length===0)return".";let s;for(let u=0;u<i.length;++u){const g=i[u];h(g,"path"),g.length>0&&(s===void 0?s=g:s+=`/${g}`)}return s===void 0?".":n.posix.normalize(s)},relative(i,s){if(h(i,"from"),h(s,"to"),i===s||(i=n.posix.resolve(i),s=n.posix.resolve(s),i===s))return"";const u=1,g=i.length,v=g-u,c=1,a=s.length-c,f=v<a?v:a;let b=-1,P=0;for(;P<f;P++){const I=i.charCodeAt(u+P);if(I!==s.charCodeAt(c+P))break;I===r&&(b=P)}if(P===f)if(a>f){if(s.charCodeAt(c+P)===r)return s.slice(c+P+1);if(P===0)return s.slice(c+P)}else v>f&&(i.charCodeAt(u+P)===r?b=P:P===0&&(b=0));let F="";for(P=u+b+1;P<=g;++P)(P===g||i.charCodeAt(P)===r)&&(F+=F.length===0?"..":"/..");return`${F}${s.slice(c+b)}`},toNamespacedPath(i){return i},dirname(i){if(h(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===r;let u=-1,g=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===r){if(!g){u=v;break}}else g=!1;return u===-1?s?"/":".":s&&u===1?"//":i.slice(0,u)},basename(i,s){s!==void 0&&h(s,"ext"),h(i,"path");let u=0,g=-1,v=!0,c;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let a=s.length-1,f=-1;for(c=i.length-1;c>=0;--c){const b=i.charCodeAt(c);if(b===r){if(!v){u=c+1;break}}else f===-1&&(v=!1,f=c+1),a>=0&&(b===s.charCodeAt(a)?--a==-1&&(g=c):(a=-1,g=f))}return u===g?g=f:g===-1&&(g=i.length),i.slice(u,g)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===r){if(!v){u=c+1;break}}else g===-1&&(v=!1,g=c+1);return g===-1?"":i.slice(u,g)},extname(i){h(i,"path");let s=-1,u=0,g=-1,v=!0,c=0;for(let a=i.length-1;a>=0;--a){const f=i.charCodeAt(a);if(f===r){if(!v){u=a+1;break}continue}g===-1&&(v=!1,g=a+1),f===d?s===-1?s=a:c!==1&&(c=1):s!==-1&&(c=-1)}return s===-1||g===-1||c===0||c===1&&s===g-1&&s===u+1?"":i.slice(s,g)},format:M.bind(null,"/"),parse(i){h(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const u=i.charCodeAt(0)===r;let g;u?(s.root="/",g=1):g=0;let v=-1,c=0,a=-1,f=!0,b=i.length-1,P=0;for(;b>=g;--b){const F=i.charCodeAt(b);if(F===r){if(!f){c=b+1;break}continue}a===-1&&(f=!1,a=b+1),F===d?v===-1?v=b:P!==1&&(P=1):v!==-1&&(P=-1)}if(a!==-1){const F=c===0&&u?1:c;v===-1||P===0||P===1&&v===a-1&&v===c+1?s.base=s.name=i.slice(F,a):(s.name=i.slice(F,v),s.base=i.slice(F,a),s.ext=i.slice(v,a))}return c>0?s.dir=i.slice(0,c-1):u&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=R.platform==="win32"?n.win32.normalize:n.posix.normalize,n.isAbsolute=R.platform==="win32"?n.win32.isAbsolute:n.posix.isAbsolute,n.join=R.platform==="win32"?n.win32.join:n.posix.join,n.resolve=R.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=R.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=R.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=R.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=R.platform==="win32"?n.win32.extname:n.posix.extname,n.format=R.platform==="win32"?n.win32.format:n.posix.format,n.parse=R.platform==="win32"?n.win32.parse:n.posix.parse,n.toNamespacedPath=R.platform==="win32"?n.win32.toNamespacedPath:n.posix.toNamespacedPath,n.sep=R.platform==="win32"?n.win32.sep:n.posix.sep,n.delimiter=R.platform==="win32"?n.win32.delimiter:n.posix.delimiter}),x(ee[10],te([0,1,2]),function(U,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const y=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(A){this._highResolution=y&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new D(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}n.StopWatch=D}),x(ee[6],te([0,1,5,8,9,19,10]),function(U,n,R,y,D,l,A){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.AsyncEmitter=n.Emitter=n.setGlobalLeakWarningThreshold=n.Event=void 0;var d;(function(s){s.None=()=>D.Disposable.None;function u($){return(W,X=null,Q)=>{let ne=!1,ie;return ie=$(ue=>{if(!ne)return ie?ie.dispose():ne=!0,W.call(X,ue)},null,Q),ne&&ie.dispose(),ie}}s.once=u;function g($,W){return P((X,Q=null,ne)=>$(ie=>X.call(Q,W(ie)),null,ne))}s.map=g;function v($,W){return P((X,Q=null,ne)=>$(ie=>{W(ie),X.call(Q,ie)},null,ne))}s.forEach=v;function c($,W){return P((X,Q=null,ne)=>$(ie=>W(ie)&&X.call(Q,ie),null,ne))}s.filter=c;function a($){return $}s.signal=a;function f(...$){return(W,X=null,Q)=>(0,D.combinedDisposable)(...$.map(ne=>ne(ie=>W.call(X,ie),null,Q)))}s.any=f;function b($,W,X){let Q=X;return g($,ne=>(Q=W(Q,ne),Q))}s.reduce=b;function P($){let W;const X=new m({onFirstListenerAdd(){W=$(X.fire,X)},onLastListenerRemove(){W.dispose()}});return X.event}function F($,W,X=100,Q=!1,ne){let ie,ue,T,B=0;const k=new m({leakWarningThreshold:ne,onFirstListenerAdd(){ie=$(q=>{B++,ue=W(ue,q),Q&&!T&&(k.fire(ue),ue=void 0),clearTimeout(T),T=setTimeout(()=>{const j=ue;ue=void 0,T=void 0,(!Q||B>1)&&k.fire(j),B=0},X)})},onLastListenerRemove(){ie.dispose()}});return k.event}s.debounce=F;function I($,W=(X,Q)=>X===Q){let X=!0,Q;return c($,ne=>{const ie=X||!W(ne,Q);return X=!1,Q=ne,ie})}s.latch=I;function V($,W){return[s.filter($,W),s.filter($,X=>!W(X))]}s.split=V;function C($,W=!1,X=[]){let Q=X.slice(),ne=$(T=>{Q?Q.push(T):ue.fire(T)});const ie=()=>{Q&&Q.forEach(T=>ue.fire(T)),Q=null},ue=new m({onFirstListenerAdd(){ne||(ne=$(T=>ue.fire(T)))},onFirstListenerDidAdd(){Q&&(W?setTimeout(ie):ie())},onLastListenerRemove(){ne&&ne.dispose(),ne=null}});return ue.event}s.buffer=C;class H{constructor(W){this.event=W}map(W){return new H(g(this.event,W))}forEach(W){return new H(v(this.event,W))}filter(W){return new H(c(this.event,W))}reduce(W,X){return new H(b(this.event,W,X))}latch(){return new H(I(this.event))}debounce(W,X=100,Q=!1,ne){return new H(F(this.event,W,X,Q,ne))}on(W,X,Q){return this.event(W,X,Q)}once(W,X,Q){return u(this.event)(W,X,Q)}}function Z($){return new H($)}s.chain=Z;function G($,W,X=Q=>Q){const Q=(...T)=>ue.fire(X(...T)),ne=()=>$.on(W,Q),ie=()=>$.removeListener(W,Q),ue=new m({onFirstListenerAdd:ne,onLastListenerRemove:ie});return ue.event}s.fromNodeEventEmitter=G;function se($,W,X=Q=>Q){const Q=(...T)=>ue.fire(X(...T)),ne=()=>$.addEventListener(W,Q),ie=()=>$.removeEventListener(W,Q),ue=new m({onFirstListenerAdd:ne,onLastListenerRemove:ie});return ue.event}s.fromDOMEventEmitter=se;function t($){return new Promise(W=>u($)(W))}s.toPromise=t})(d=n.Event||(n.Event={}));class r{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${r._idPool++}`}start(u){this._stopWatch=new A.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}r._idPool=0;let o=-1;function _(s){const u=o;return o=s,{dispose(){o=u}}}n.setGlobalLeakWarningThreshold=_;class p{constructor(u,g=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let g=o;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),g<=0||u<g)return;this._stacks||(this._stacks=new Map);const v=new Error().stack.split(`
`).slice(3).join(`
`),c=this._stacks.get(v)||0;if(this._stacks.set(v,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let a,f=0;for(const[b,P]of this._stacks)(!a||f<P)&&(a=b,f=P);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${f}):`),console.warn(a)}return()=>{const a=this._stacks.get(v)||0;this._stacks.set(v,a-1)}}}class m{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=o>0?new p(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new r(this._options._profName):void 0}get event(){return this._event||(this._event=(u,g,v)=>{this._listeners||(this._listeners=new l.LinkedList);const c=this._listeners.isEmpty();c&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const a=this._listeners.push(g?[u,g]:u);c&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,g);const f=this._leakageMon?.check(this._listeners.size),b=(0,D.toDisposable)(()=>{f&&f(),this._disposed||(a(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return v instanceof D.DisposableStore?v.add(b):Array.isArray(v)&&v.push(b),b}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new l.LinkedList);for(let g of this._listeners)this._deliveryQueue.push([g,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[g,v]=this._deliveryQueue.shift();try{typeof g=="function"?g.call(void 0,v):g[0].call(g[1],v)}catch(c){(0,R.onUnexpectedError)(c)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}n.Emitter=m;class h extends m{async fireAsync(u,g,v){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new l.LinkedList);for(const c of this._listeners)this._asyncDeliveryQueue.push([c,u]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[c,a]=this._asyncDeliveryQueue.shift(),f=[],b={...a,waitUntil:P=>{if(Object.isFrozen(f))throw new Error("waitUntil can NOT be called asynchronous");v&&(P=v(P,typeof c=="function"?c:c[0])),f.push(P)}};try{typeof c=="function"?c.call(void 0,b):c[0].call(c[1],b)}catch(P){(0,R.onUnexpectedError)(P);continue}Object.freeze(f),await Promise.allSettled(f).then(P=>{for(const F of P)F.status==="rejected"&&(0,R.onUnexpectedError)(F.reason)})}}}}n.AsyncEmitter=h;class e extends m{constructor(u){super(u);this._isPaused=0,this._eventQueue=new l.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}n.PauseableEmitter=e;class w extends e{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}n.DebounceEmitter=w;class E extends m{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]})}}n.MicrotaskEmitter=E;class L{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const g={event:u,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const v=()=>{this.hasListeners&&this.unhook(g);const c=this.events.indexOf(g);this.events.splice(c,1)};return(0,D.toDisposable)((0,y.once)(v))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(g=>this.emitter.fire(g))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=L;class M{constructor(){this.buffers=[]}wrapEvent(u){return(g,v,c)=>u(a=>{const f=this.buffers[this.buffers.length-1];f?f.push(()=>g.call(v,a)):g.call(v,a)},void 0,c)}bufferEvents(u){const g=[];this.buffers.push(g);const v=u();return this.buffers.pop(),g.forEach(c=>c()),v}}n.EventBufferer=M;class i{constructor(){this.listening=!1,this.inputEvent=d.None,this.inputEventListener=D.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=i}),x(ee[22],te([0,1,6]),function(U,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const y=Object.freeze(function(d,r){const o=setTimeout(d.bind(r),0);return{dispose(){clearTimeout(o)}}});var D;(function(d){function r(o){return o===d.None||o===d.Cancelled||o instanceof l?!0:!o||typeof o!="object"?!1:typeof o.isCancellationRequested=="boolean"&&typeof o.onCancellationRequested=="function"}d.isCancellationToken=r,d.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),d.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:y})})(D=n.CancellationToken||(n.CancellationToken={}));class l{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?y:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(r){this._token=void 0,this._parentListener=void 0,this._parentListener=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new l),this._token}cancel(){this._token?this._token instanceof l&&this._token.cancel():this._token=D.Cancelled}dispose(r=!1){r&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof l&&this._token.dispose():this._token=D.None}}n.CancellationTokenSource=A}),x(ee[4],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.noBreakWhitespace=n.getLeftDeleteOffset=n.GraphemeBreakType=n.breakBetweenGraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.getNLines=n.uppercaseFirstLetter=n.containsUppercaseCharacter=n.fuzzyContains=n.stripUTF8BOM=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.removeAnsiEscapeCodes=n.lcut=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsEmoji=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpContainsBackreference=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.truncate=n.count=n.escapeRegExpCharacters=n.escape=n.format2=n.format=n.isFalsyOrWhitespace=void 0;function R(N){return!N||typeof N!="string"?!0:N.trim().length===0}n.isFalsyOrWhitespace=R;const y=/{(\d+)}/g;function D(N,...S){return S.length===0?N:N.replace(y,function(O,z){const Y=parseInt(z,10);return isNaN(Y)||Y<0||Y>=S.length?O:S[Y]})}n.format=D;const l=/{([^}]+)}/g;function A(N,S){return N.replace(l,(O,z)=>S[z]??O)}n.format2=A;function d(N){return N.replace(/[<>&]/g,function(S){switch(S){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return S}})}n.escape=d;function r(N){return N.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=r;function o(N,S){let O=0;const z=S.charCodeAt(0);for(let Y=N.length-1;Y>=0;Y--)N.charCodeAt(Y)===z&&O++;return O}n.count=o;function _(N,S,O="\u2026"){return N.length<=S?N:`${N.substr(0,S)}${O}`}n.truncate=_;function p(N,S=" "){const O=m(N,S);return h(O,S)}n.trim=p;function m(N,S){if(!N||!S)return N;const O=S.length;if(O===0||N.length===0)return N;let z=0;for(;N.indexOf(S,z)===z;)z=z+O;return N.substring(z)}n.ltrim=m;function h(N,S){if(!N||!S)return N;const O=S.length,z=N.length;if(O===0||z===0)return N;let Y=z,re=-1;for(;re=N.lastIndexOf(S,Y-1),!(re===-1||re+O!==Y);){if(re===0)return"";Y=re}return N.substring(0,Y)}n.rtrim=h;function e(N){return N.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=e;function w(N){return N.replace(/\*/g,"")}n.stripWildcards=w;function E(N,S,O={}){if(!N)throw new Error("Cannot create regex from empty string");S||(N=r(N)),O.wholeWord&&(/\B/.test(N.charAt(0))||(N="\\b"+N),/\B/.test(N.charAt(N.length-1))||(N=N+"\\b"));let z="";return O.global&&(z+="g"),O.matchCase||(z+="i"),O.multiline&&(z+="m"),O.unicode&&(z+="u"),new RegExp(N,z)}n.createRegExp=E;function L(N){return N.source==="^"||N.source==="^$"||N.source==="$"||N.source==="^\\s*$"?!1:!!(N.exec("")&&N.lastIndex===0)}n.regExpLeadsToEndlessLoop=L;function M(N){return!!N.match(/([^\\]|^)(\\\\)*\\\d+/)}n.regExpContainsBackreference=M;function i(N){return(N.global?"g":"")+(N.ignoreCase?"i":"")+(N.multiline?"m":"")+(N.unicode?"u":"")}n.regExpFlags=i;function s(N){return N.split(/\r\n|\r|\n/)}n.splitLines=s;function u(N){for(let S=0,O=N.length;S<O;S++){const z=N.charCodeAt(S);if(z!==32&&z!==9)return S}return-1}n.firstNonWhitespaceIndex=u;function g(N,S=0,O=N.length){for(let z=S;z<O;z++){const Y=N.charCodeAt(z);if(Y!==32&&Y!==9)return N.substring(S,z)}return N.substring(S,O)}n.getLeadingWhitespace=g;function v(N,S=N.length-1){for(let O=S;O>=0;O--){const z=N.charCodeAt(O);if(z!==32&&z!==9)return O}return-1}n.lastNonWhitespaceIndex=v;function c(N,S){return N<S?-1:N>S?1:0}n.compare=c;function a(N,S,O=0,z=N.length,Y=0,re=S.length){for(;O<z&&Y<re;O++,Y++){let me=N.charCodeAt(O),de=S.charCodeAt(Y);if(me<de)return-1;if(me>de)return 1}const oe=z-O,ce=re-Y;return oe<ce?-1:oe>ce?1:0}n.compareSubstring=a;function f(N,S){return b(N,S,0,N.length,0,S.length)}n.compareIgnoreCase=f;function b(N,S,O=0,z=N.length,Y=0,re=S.length){for(;O<z&&Y<re;O++,Y++){let me=N.charCodeAt(O),de=S.charCodeAt(Y);if(me===de)continue;if(me>=128||de>=128)return a(N.toLowerCase(),S.toLowerCase(),O,z,Y,re);P(me)&&(me-=32),P(de)&&(de-=32);const ve=me-de;if(ve!==0)return ve}const oe=z-O,ce=re-Y;return oe<ce?-1:oe>ce?1:0}n.compareSubstringIgnoreCase=b;function P(N){return N>=97&&N<=122}n.isLowerAsciiLetter=P;function F(N){return N>=65&&N<=90}n.isUpperAsciiLetter=F;function I(N,S){return N.length===S.length&&b(N,S)===0}n.equalsIgnoreCase=I;function V(N,S){const O=S.length;return S.length>N.length?!1:b(N,S,0,O)===0}n.startsWithIgnoreCase=V;function C(N,S){let O,z=Math.min(N.length,S.length);for(O=0;O<z;O++)if(N.charCodeAt(O)!==S.charCodeAt(O))return O;return z}n.commonPrefixLength=C;function H(N,S){let O,z=Math.min(N.length,S.length);const Y=N.length-1,re=S.length-1;for(O=0;O<z;O++)if(N.charCodeAt(Y-O)!==S.charCodeAt(re-O))return O;return z}n.commonSuffixLength=H;function Z(N){return 55296<=N&&N<=56319}n.isHighSurrogate=Z;function G(N){return 56320<=N&&N<=57343}n.isLowSurrogate=G;function se(N,S){return(N-55296<<10)+(S-56320)+65536}n.computeCodePoint=se;function t(N,S,O){const z=N.charCodeAt(O);if(Z(z)&&O+1<S){const Y=N.charCodeAt(O+1);if(G(Y))return se(z,Y)}return z}n.getNextCodePoint=t;function $(N,S){const O=N.charCodeAt(S-1);if(G(O)&&S>1){const z=N.charCodeAt(S-2);if(Z(z))return se(z,O)}return O}function W(N,S){const O=_e.getInstance(),z=S,Y=N.length,re=t(N,Y,S);S+=re>=65536?2:1;let oe=O.getGraphemeBreakType(re);for(;S<Y;){const ce=t(N,Y,S),me=O.getGraphemeBreakType(ce);if(Le(oe,me))break;S+=ce>=65536?2:1,oe=me}return S-z}n.nextCharLength=W;function X(N,S){const O=_e.getInstance(),z=S,Y=$(N,S);S-=Y>=65536?2:1;let re=O.getGraphemeBreakType(Y);for(;S>0;){const oe=$(N,S),ce=O.getGraphemeBreakType(oe);if(Le(ce,re))break;S-=oe>=65536?2:1,re=ce}return z-S}n.prevCharLength=X;function Q(N,S){const O=_e.getInstance(),z=N.length,Y=S,re=t(N,z,S),oe=O.getGraphemeBreakType(re);S+=re>=65536?2:1;let ce=oe;for(;S<z;){const de=t(N,z,S),ve=O.getGraphemeBreakType(de);if(Le(ce,ve))break;S+=de>=65536?2:1,ce=ve}const me=S;for(S=Y,ce=oe;S>0;){const de=$(N,S),ve=O.getGraphemeBreakType(de);if(Le(ve,ce))break;S-=de>=65536?2:1,ce=ve}return[S,me]}function ne(N,S){return S>0&&G(N.charCodeAt(S))?Q(N,S-1):Q(N,S)}n.getCharContainingOffset=ne;const ie=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ue(N){return ie.test(N)}n.containsRTL=ue;const T=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function B(N){return T.test(N)}n.containsEmoji=B;const k=/^[\t\n\r\x20-\x7E]*$/;function q(N){return k.test(N)}n.isBasicASCII=q,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(N){return n.UNUSUAL_LINE_TERMINATORS.test(N)}n.containsUnusualLineTerminators=j;function K(N){for(let S=0,O=N.length;S<O;S++)if(J(N.charCodeAt(S)))return!0;return!1}n.containsFullWidthCharacter=K;function J(N){return N>=11904&&N<=55215||N>=63744&&N<=64255||N>=65281&&N<=65374}n.isFullWidthCharacter=J;function ae(N){return N>=127462&&N<=127487||N===8986||N===8987||N===9200||N===9203||N>=9728&&N<=10175||N===11088||N===11093||N>=127744&&N<=128591||N>=128640&&N<=128764||N>=128992&&N<=129003||N>=129280&&N<=129535||N>=129648&&N<=129750}n.isEmojiImprecise=ae;function fe(N,S){if(N.length<S)return N;const O=/\b/g;let z=0;for(;O.test(N)&&!(N.length-O.lastIndex<S);)z=O.lastIndex,O.lastIndex+=1;return N.substring(z).replace(/^\s/,"")}n.lcut=fe;const he=/\x1B\x5B[12]?K/g,ge=/\x1b\[\d+m/g,Ee=/\x1b\[0?m/g;function Pe(N){return N&&(N=N.replace(he,""),N=N.replace(ge,""),N=N.replace(Ee,"")),N}n.removeAnsiEscapeCodes=Pe,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(N){return!!(N&&N.length>0&&N.charCodeAt(0)===65279)}n.startsWithUTF8BOM=we;function Re(N){return we(N)?N.substr(1):N}n.stripUTF8BOM=Re;function Fe(N,S){if(!N||!S||N.length<S.length)return!1;const O=S.length,z=N.toLowerCase();let Y=0,re=-1;for(;Y<O;){const oe=z.indexOf(S[Y],re+1);if(oe<0)return!1;re=oe,Y++}return!0}n.fuzzyContains=Fe;function Ie(N,S=!1){return N?(S&&(N=N.replace(/\\./g,"")),N.toLowerCase()!==N):!1}n.containsUppercaseCharacter=Ie;function ye(N){return N.charAt(0).toUpperCase()+N.slice(1)}n.uppercaseFirstLetter=ye;function Se(N,S=1){if(S===0)return"";let O=-1;do O=N.indexOf(`
`,O+1),S--;while(S>0&&O>=0);return O===-1?N:(N[O-1]==="\r"&&O--,N.substr(0,O))}n.getNLines=Se;function Te(N){const S=90-65+1;return N=N%(2*S),N<S?String.fromCharCode(97+N):String.fromCharCode(65+N-S)}n.singleLetterHash=Te;function Ue(N){return _e.getInstance().getGraphemeBreakType(N)}n.getGraphemeBreakType=Ue;function Le(N,S){return N===0?S!==5&&S!==7:N===2&&S===3?!1:N===4||N===2||N===3||S===4||S===2||S===3?!0:!(N===8&&(S===8||S===9||S===11||S===12)||(N===11||N===9)&&(S===9||S===10)||(N===12||N===10)&&S===10||S===5||S===13||S===7||N===1||N===13&&S===14||N===6&&S===6)}n.breakBetweenGraphemeBreakType=Le;var ke;(function(N){N[N.Other=0]="Other",N[N.Prepend=1]="Prepend",N[N.CR=2]="CR",N[N.LF=3]="LF",N[N.Control=4]="Control",N[N.Extend=5]="Extend",N[N.Regional_Indicator=6]="Regional_Indicator",N[N.SpacingMark=7]="SpacingMark",N[N.L=8]="L",N[N.V=9]="V",N[N.T=10]="T",N[N.LV=11]="LV",N[N.LVT=12]="LVT",N[N.ZWJ=13]="ZWJ",N[N.Extended_Pictographic=14]="Extended_Pictographic"})(ke=n.GraphemeBreakType||(n.GraphemeBreakType={}));class _e{constructor(){this._data=Be()}static getInstance(){return _e._INSTANCE||(_e._INSTANCE=new _e),_e._INSTANCE}getGraphemeBreakType(S){if(S<32)return S===10?3:S===13?2:4;if(S<127)return 0;const O=this._data,z=O.length/3;let Y=1;for(;Y<=z;)if(S<O[3*Y])Y=2*Y;else if(S>O[3*Y+1])Y=2*Y+1;else return O[3*Y+2];return 0}}_e._INSTANCE=null;function Be(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Oe(N,S){if(N===0)return 0;const O=Ve(N,S);if(O!==void 0)return O;const z=$(S,N);return N-=Ne(z),N}n.getLeftDeleteOffset=Oe;function Ve(N,S){let O=$(S,N);for(N-=Ne(O);We(O)||O===65039||O===8419;){if(N===0)return;O=$(S,N),N-=Ne(O)}if(!!ae(O)){if(N>=0){const z=$(S,N);z===8205&&(N-=Ne(z))}return N}}function Ne(N){return N>=65536?2:1}function We(N){return 127995<=N&&N<=127999}var pe;(function(N){N[N.zwj=8205]="zwj",N[N.emojiVariantSelector=65039]="emojiVariantSelector",N[N.enclosingKeyCap=8419]="enclosingKeyCap"})(pe||(pe={})),n.noBreakWhitespace="\xA0"}),x(ee[23],te([0,1,4]),function(U,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.Hasher=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function y(L){return D(L,0)}n.hash=y;function D(L,M){switch(typeof L){case"object":return L===null?l(349,M):Array.isArray(L)?r(L,M):o(L,M);case"string":return d(L,M);case"boolean":return A(L,M);case"number":return l(L,M);case"undefined":return l(937,M);default:return l(617,M)}}n.doHash=D;function l(L,M){return(M<<5)-M+L|0}n.numberHash=l;function A(L,M){return l(L?433:863,M)}function d(L,M){M=l(149417,M);for(let i=0,s=L.length;i<s;i++)M=l(L.charCodeAt(i),M);return M}n.stringHash=d;function r(L,M){return M=l(104579,M),L.reduce((i,s)=>D(s,i),M)}function o(L,M){return M=l(181387,M),Object.keys(L).sort().reduce((i,s)=>(i=d(s,i),D(L[s],i)),M)}class _{constructor(){this._value=0}get value(){return this._value}hash(M){return this._value=D(M,this._value),this._value}}n.Hasher=_;var p;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function m(L,M,i=32){const s=i-M,u=~((1<<s)-1);return(L<<M|(u&L)>>>s)>>>0}function h(L,M=0,i=L.byteLength,s=0){for(let u=0;u<i;u++)L[M+u]=s}function e(L,M,i="0"){for(;L.length<M;)L=i+L;return L}function w(L,M=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(i=>i.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),M/4)}n.toHexString=w;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(M){const i=M.length;if(i===0)return;const s=this._buff;let u=this._buffLen,g=this._leftoverHighSurrogate,v,c;for(g!==0?(v=g,c=-1,g=0):(v=M.charCodeAt(0),c=0);;){let a=v;if(R.isHighSurrogate(v))if(c+1<i){const f=M.charCodeAt(c+1);R.isLowSurrogate(f)?(c++,a=R.computeCodePoint(v,f)):a=65533}else{g=v;break}else R.isLowSurrogate(v)&&(a=65533);if(u=this._push(s,u,a),c++,c<i)v=M.charCodeAt(c);else break}this._buffLen=u,this._leftoverHighSurrogate=g}_push(M,i,s){return s<128?M[i++]=s:s<2048?(M[i++]=192|(s&1984)>>>6,M[i++]=128|(s&63)>>>0):s<65536?(M[i++]=224|(s&61440)>>>12,M[i++]=128|(s&4032)>>>6,M[i++]=128|(s&63)>>>0):(M[i++]=240|(s&1835008)>>>18,M[i++]=128|(s&258048)>>>12,M[i++]=128|(s&4032)>>>6,M[i++]=128|(s&63)>>>0),i>=64&&(this._step(),i-=64,this._totalLen+=64,M[0]=M[64+0],M[1]=M[64+1],M[2]=M[64+2]),i}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const M=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(M/4294967296),!1),this._buffDV.setUint32(60,M%4294967296,!1),this._step()}_step(){const M=E._bigBlock32,i=this._buffDV;for(let P=0;P<64;P+=4)M.setUint32(P,i.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)M.setUint32(P,m(M.getUint32(P-12,!1)^M.getUint32(P-32,!1)^M.getUint32(P-56,!1)^M.getUint32(P-64,!1),1),!1);let s=this._h0,u=this._h1,g=this._h2,v=this._h3,c=this._h4,a,f,b;for(let P=0;P<80;P++)P<20?(a=u&g|~u&v,f=1518500249):P<40?(a=u^g^v,f=1859775393):P<60?(a=u&g|u&v|g&v,f=2400959708):(a=u^g^v,f=3395469782),b=m(s,5)+a+c+f+M.getUint32(P*4,!1)&4294967295,c=v,v=g,g=m(u,30),u=s,s=b;this._h0=this._h0+s&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+g&4294967295,this._h3=this._h3+v&4294967295,this._h4=this._h4+c&4294967295}}n.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),x(ee[11],te([0,1,15,23]),function(U,n,R,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class D{constructor(m){this.source=m}getElements(){const m=this.source,h=new Int32Array(m.length);for(let e=0,w=m.length;e<w;e++)h[e]=m.charCodeAt(e);return h}}n.StringDiffSequence=D;function l(p,m,h){return new _(new D(p),new D(m)).ComputeDiff(h).changes}n.stringDiff=l;class A{static Assert(m,h){if(!m)throw new Error(h)}}n.Debug=A;class d{static Copy(m,h,e,w,E){for(let L=0;L<E;L++)e[w+L]=m[h+L]}static Copy2(m,h,e,w,E){for(let L=0;L<E;L++)e[w+L]=m[h+L]}}n.MyArray=d;var r;(function(p){p[p.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(r||(r={}));class o{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new R.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(m,h){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,h),this.m_originalCount++}AddModifiedElement(m,h){this.m_originalStart=Math.min(this.m_originalStart,m),this.m_modifiedStart=Math.min(this.m_modifiedStart,h),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class _{constructor(m,h,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=m,this._modifiedSequence=h;const[w,E,L]=_._getElements(m),[M,i,s]=_._getElements(h);this._hasStrings=L&&s,this._originalStringElements=w,this._originalElementsOrHash=E,this._modifiedStringElements=M,this._modifiedElementsOrHash=i,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(m){return m.length>0&&typeof m[0]=="string"}static _getElements(m){const h=m.getElements();if(_._isStringArray(h)){const e=new Int32Array(h.length);for(let w=0,E=h.length;w<E;w++)e[w]=(0,y.stringHash)(h[w],0);return[h,e,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}ElementsAreEqual(m,h){return this._originalElementsOrHash[m]!==this._modifiedElementsOrHash[h]?!1:this._hasStrings?this._originalStringElements[m]===this._modifiedStringElements[h]:!0}ElementsAreStrictEqual(m,h){if(!this.ElementsAreEqual(m,h))return!1;const e=_._getStrictElement(this._originalSequence,m),w=_._getStrictElement(this._modifiedSequence,h);return e===w}static _getStrictElement(m,h){return typeof m.getStrictElement=="function"?m.getStrictElement(h):null}OriginalElementsAreEqual(m,h){return this._originalElementsOrHash[m]!==this._originalElementsOrHash[h]?!1:this._hasStrings?this._originalStringElements[m]===this._originalStringElements[h]:!0}ModifiedElementsAreEqual(m,h){return this._modifiedElementsOrHash[m]!==this._modifiedElementsOrHash[h]?!1:this._hasStrings?this._modifiedStringElements[m]===this._modifiedStringElements[h]:!0}ComputeDiff(m){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,m)}_ComputeDiff(m,h,e,w,E){const L=[!1];let M=this.ComputeDiffRecursive(m,h,e,w,L);return E&&(M=this.PrettifyChanges(M)),{quitEarly:L[0],changes:M}}ComputeDiffRecursive(m,h,e,w,E){for(E[0]=!1;m<=h&&e<=w&&this.ElementsAreEqual(m,e);)m++,e++;for(;h>=m&&w>=e&&this.ElementsAreEqual(h,w);)h--,w--;if(m>h||e>w){let g;return e<=w?(A.Assert(m===h+1,"originalStart should only be one more than originalEnd"),g=[new R.DiffChange(m,0,e,w-e+1)]):m<=h?(A.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),g=[new R.DiffChange(m,h-m+1,e,0)]):(A.Assert(m===h+1,"originalStart should only be one more than originalEnd"),A.Assert(e===w+1,"modifiedStart should only be one more than modifiedEnd"),g=[]),g}const L=[0],M=[0],i=this.ComputeRecursionPoint(m,h,e,w,L,M,E),s=L[0],u=M[0];if(i!==null)return i;if(!E[0]){const g=this.ComputeDiffRecursive(m,s,e,u,E);let v=[];return E[0]?v=[new R.DiffChange(s+1,h-(s+1)+1,u+1,w-(u+1)+1)]:v=this.ComputeDiffRecursive(s+1,h,u+1,w,E),this.ConcatenateChanges(g,v)}return[new R.DiffChange(m,h-m+1,e,w-e+1)]}WALKTRACE(m,h,e,w,E,L,M,i,s,u,g,v,c,a,f,b,P,F){let I=null,V=null,C=new o,H=h,Z=e,G=c[0]-b[0]-w,se=-1073741824,t=this.m_forwardHistory.length-1;do{const $=G+m;$===H||$<Z&&s[$-1]<s[$+1]?(g=s[$+1],a=g-G-w,g<se&&C.MarkNextChange(),se=g,C.AddModifiedElement(g+1,a),G=$+1-m):(g=s[$-1]+1,a=g-G-w,g<se&&C.MarkNextChange(),se=g-1,C.AddOriginalElement(g,a+1),G=$-1-m),t>=0&&(s=this.m_forwardHistory[t],m=s[0],H=1,Z=s.length-1)}while(--t>=-1);if(I=C.getReverseChanges(),F[0]){let $=c[0]+1,W=b[0]+1;if(I!==null&&I.length>0){const X=I[I.length-1];$=Math.max($,X.getOriginalEnd()),W=Math.max(W,X.getModifiedEnd())}V=[new R.DiffChange($,v-$+1,W,f-W+1)]}else{C=new o,H=L,Z=M,G=c[0]-b[0]-i,se=1073741824,t=P?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const $=G+E;$===H||$<Z&&u[$-1]>=u[$+1]?(g=u[$+1]-1,a=g-G-i,g>se&&C.MarkNextChange(),se=g+1,C.AddOriginalElement(g+1,a+1),G=$+1-E):(g=u[$-1],a=g-G-i,g>se&&C.MarkNextChange(),se=g,C.AddModifiedElement(g+1,a+1),G=$-1-E),t>=0&&(u=this.m_reverseHistory[t],E=u[0],H=1,Z=u.length-1)}while(--t>=-1);V=C.getChanges()}return this.ConcatenateChanges(I,V)}ComputeRecursionPoint(m,h,e,w,E,L,M){let i=0,s=0,u=0,g=0,v=0,c=0;m--,e--,E[0]=0,L[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const a=h-m+(w-e),f=a+1,b=new Int32Array(f),P=new Int32Array(f),F=w-e,I=h-m,V=m-e,C=h-w,Z=(I-F)%2==0;b[F]=m,P[I]=h,M[0]=!1;for(let G=1;G<=a/2+1;G++){let se=0,t=0;u=this.ClipDiagonalBound(F-G,G,F,f),g=this.ClipDiagonalBound(F+G,G,F,f);for(let W=u;W<=g;W+=2){W===u||W<g&&b[W-1]<b[W+1]?i=b[W+1]:i=b[W-1]+1,s=i-(W-F)-V;const X=i;for(;i<h&&s<w&&this.ElementsAreEqual(i+1,s+1);)i++,s++;if(b[W]=i,i+s>se+t&&(se=i,t=s),!Z&&Math.abs(W-I)<=G-1&&i>=P[W])return E[0]=i,L[0]=s,X<=P[W]&&1447>0&&G<=1447+1?this.WALKTRACE(F,u,g,V,I,v,c,C,b,P,i,h,E,s,w,L,Z,M):null}const $=(se-m+(t-e)-G)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(se,$))return M[0]=!0,E[0]=se,L[0]=t,$>0&&1447>0&&G<=1447+1?this.WALKTRACE(F,u,g,V,I,v,c,C,b,P,i,h,E,s,w,L,Z,M):(m++,e++,[new R.DiffChange(m,h-m+1,e,w-e+1)]);v=this.ClipDiagonalBound(I-G,G,I,f),c=this.ClipDiagonalBound(I+G,G,I,f);for(let W=v;W<=c;W+=2){W===v||W<c&&P[W-1]>=P[W+1]?i=P[W+1]-1:i=P[W-1],s=i-(W-I)-C;const X=i;for(;i>m&&s>e&&this.ElementsAreEqual(i,s);)i--,s--;if(P[W]=i,Z&&Math.abs(W-F)<=G&&i<=b[W])return E[0]=i,L[0]=s,X>=b[W]&&1447>0&&G<=1447+1?this.WALKTRACE(F,u,g,V,I,v,c,C,b,P,i,h,E,s,w,L,Z,M):null}if(G<=1447){let W=new Int32Array(g-u+2);W[0]=F-u+1,d.Copy2(b,u,W,1,g-u+1),this.m_forwardHistory.push(W),W=new Int32Array(c-v+2),W[0]=I-v+1,d.Copy2(P,v,W,1,c-v+1),this.m_reverseHistory.push(W)}}return this.WALKTRACE(F,u,g,V,I,v,c,C,b,P,i,h,E,s,w,L,Z,M)}PrettifyChanges(m){for(let h=0;h<m.length;h++){const e=m[h],w=h<m.length-1?m[h+1].originalStart:this._originalElementsOrHash.length,E=h<m.length-1?m[h+1].modifiedStart:this._modifiedElementsOrHash.length,L=e.originalLength>0,M=e.modifiedLength>0;for(;e.originalStart+e.originalLength<w&&e.modifiedStart+e.modifiedLength<E&&(!L||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!M||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const s=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!s)break;e.originalStart++,e.modifiedStart++}let i=[null];if(h<m.length-1&&this.ChangesOverlap(m[h],m[h+1],i)){m[h]=i[0],m.splice(h+1,1),h--;continue}}for(let h=m.length-1;h>=0;h--){const e=m[h];let w=0,E=0;if(h>0){const g=m[h-1];w=g.originalStart+g.originalLength,E=g.modifiedStart+g.modifiedLength}const L=e.originalLength>0,M=e.modifiedLength>0;let i=0,s=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let g=1;;g++){const v=e.originalStart-g,c=e.modifiedStart-g;if(v<w||c<E||L&&!this.OriginalElementsAreEqual(v,v+e.originalLength)||M&&!this.ModifiedElementsAreEqual(c,c+e.modifiedLength))break;const f=(v===w&&c===E?5:0)+this._boundaryScore(v,e.originalLength,c,e.modifiedLength);f>s&&(s=f,i=g)}e.originalStart-=i,e.modifiedStart-=i;const u=[null];if(h>0&&this.ChangesOverlap(m[h-1],m[h],u)){m[h-1]=u[0],m.splice(h,1),h++;continue}}if(this._hasStrings)for(let h=1,e=m.length;h<e;h++){const w=m[h-1],E=m[h],L=E.originalStart-w.originalStart-w.originalLength,M=w.originalStart,i=E.originalStart+E.originalLength,s=i-M,u=w.modifiedStart,g=E.modifiedStart+E.modifiedLength,v=g-u;if(L<5&&s<20&&v<20){const c=this._findBetterContiguousSequence(M,s,u,v,L);if(c){const[a,f]=c;(a!==w.originalStart+w.originalLength||f!==w.modifiedStart+w.modifiedLength)&&(w.originalLength=a-w.originalStart,w.modifiedLength=f-w.modifiedStart,E.originalStart=a+L,E.modifiedStart=f+L,E.originalLength=i-E.originalStart,E.modifiedLength=g-E.modifiedStart)}}}return m}_findBetterContiguousSequence(m,h,e,w,E){if(h<E||w<E)return null;const L=m+h-E+1,M=e+w-E+1;let i=0,s=0,u=0;for(let g=m;g<L;g++)for(let v=e;v<M;v++){const c=this._contiguousSequenceScore(g,v,E);c>0&&c>i&&(i=c,s=g,u=v)}return i>0?[s,u]:null}_contiguousSequenceScore(m,h,e){let w=0;for(let E=0;E<e;E++){if(!this.ElementsAreEqual(m+E,h+E))return 0;w+=this._originalStringElements[m+E].length}return w}_OriginalIsBoundary(m){return m<=0||m>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[m])}_OriginalRegionIsBoundary(m,h){if(this._OriginalIsBoundary(m)||this._OriginalIsBoundary(m-1))return!0;if(h>0){const e=m+h;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(m){return m<=0||m>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[m])}_ModifiedRegionIsBoundary(m,h){if(this._ModifiedIsBoundary(m)||this._ModifiedIsBoundary(m-1))return!0;if(h>0){const e=m+h;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(m,h,e,w){const E=this._OriginalRegionIsBoundary(m,h)?1:0,L=this._ModifiedRegionIsBoundary(e,w)?1:0;return E+L}ConcatenateChanges(m,h){let e=[];if(m.length===0||h.length===0)return h.length>0?h:m;if(this.ChangesOverlap(m[m.length-1],h[0],e)){const w=new Array(m.length+h.length-1);return d.Copy(m,0,w,0,m.length-1),w[m.length-1]=e[0],d.Copy(h,1,w,m.length,h.length-1),w}else{const w=new Array(m.length+h.length);return d.Copy(m,0,w,0,m.length),d.Copy(h,0,w,m.length,h.length),w}}ChangesOverlap(m,h,e){if(A.Assert(m.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),A.Assert(m.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=h.originalStart||m.modifiedStart+m.modifiedLength>=h.modifiedStart){const w=m.originalStart;let E=m.originalLength;const L=m.modifiedStart;let M=m.modifiedLength;return m.originalStart+m.originalLength>=h.originalStart&&(E=h.originalStart+h.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=h.modifiedStart&&(M=h.modifiedStart+h.modifiedLength-m.modifiedStart),e[0]=new R.DiffChange(w,E,L,M),!0}else return e[0]=null,!1}ClipDiagonalBound(m,h,e,w){if(m>=0&&m<w)return m;const E=e,L=w-e-1,M=h%2==0;if(m<0){const i=E%2==0;return M===i?0:1}else{const i=L%2==0;return M===i?w-1:w-2}}}n.LcsDiff=_}),x(ee[12],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.isPromise=n.assertNever=n.NotImplementedProxy=n.withUndefinedAsNull=n.withNullAsUndefined=n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.validateConstraint=n.validateConstraints=n.areFunctions=n.isFunction=n.isEmptyObject=n.assertAllDefined=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isObject=n.isStringArray=n.isString=n.isArray=void 0;function R(F){return Array.isArray(F)}n.isArray=R;function y(F){return typeof F=="string"}n.isString=y;function D(F){return Array.isArray(F)&&F.every(I=>y(I))}n.isStringArray=D;function l(F){return typeof F=="object"&&F!==null&&!Array.isArray(F)&&!(F instanceof RegExp)&&!(F instanceof Date)}n.isObject=l;function A(F){return typeof F=="number"&&!isNaN(F)}n.isNumber=A;function d(F){return!!F&&typeof F[Symbol.iterator]=="function"}n.isIterable=d;function r(F){return F===!0||F===!1}n.isBoolean=r;function o(F){return typeof F=="undefined"}n.isUndefined=o;function _(F){return!p(F)}n.isDefined=_;function p(F){return o(F)||F===null}n.isUndefinedOrNull=p;function m(F,I){if(!F)throw new Error(I?`Unexpected type, expected '${I}'`:"Unexpected type")}n.assertType=m;function h(F){if(p(F))throw new Error("Assertion Failed: argument is undefined or null");return F}n.assertIsDefined=h;function e(...F){const I=[];for(let V=0;V<F.length;V++){const C=F[V];if(p(C))throw new Error(`Assertion Failed: argument at index ${V} is undefined or null`);I.push(C)}return I}n.assertAllDefined=e;const w=Object.prototype.hasOwnProperty;function E(F){if(!l(F))return!1;for(let I in F)if(w.call(F,I))return!1;return!0}n.isEmptyObject=E;function L(F){return typeof F=="function"}n.isFunction=L;function M(...F){return F.length>0&&F.every(L)}n.areFunctions=M;function i(F,I){const V=Math.min(F.length,I.length);for(let C=0;C<V;C++)s(F[C],I[C])}n.validateConstraints=i;function s(F,I){if(y(I)){if(typeof F!==I)throw new Error(`argument does not match constraint: typeof ${I}`)}else if(L(I)){try{if(F instanceof I)return}catch{}if(!p(F)&&F.constructor===I||I.length===1&&I.call(void 0,F)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=s;function u(F){let I=[],V=Object.getPrototypeOf(F);for(;Object.prototype!==V;)I=I.concat(Object.getOwnPropertyNames(V)),V=Object.getPrototypeOf(V);return I}n.getAllPropertyNames=u;function g(F){const I=[];for(const V of u(F))typeof F[V]=="function"&&I.push(V);return I}n.getAllMethodNames=g;function v(F,I){const V=H=>function(){const Z=Array.prototype.slice.call(arguments,0);return I(H,Z)};let C={};for(const H of F)C[H]=V(H);return C}n.createProxyObject=v;function c(F){return F===null?void 0:F}n.withNullAsUndefined=c;function a(F){return typeof F=="undefined"?null:F}n.withUndefinedAsNull=a;function f(F){return class{constructor(){return new Proxy({},{get(I,V){if(I[V])return I[V];throw new Error(`Not Implemented: ${F}->${String(V)}`)}})}}}n.NotImplementedProxy=f;function b(F,I="Unreachable"){throw new Error(I)}n.assertNever=b;function P(F){return!!F&&typeof F.then=="function"&&typeof F.catch=="function"}n.isPromise=P}),x(ee[13],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=n.Constants=void 0;var R;(function(l){l[l.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",l[l.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",l[l.MAX_UINT_8=255]="MAX_UINT_8",l[l.MAX_UINT_16=65535]="MAX_UINT_16",l[l.MAX_UINT_32=4294967295]="MAX_UINT_32",l[l.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(R=n.Constants||(n.Constants={}));function y(l){return l<0?0:l>255?255:l|0}n.toUint8=y;function D(l){return l<0?0:l>4294967295?4294967295:l|0}n.toUint32=D}),x(ee[14],te([0,1,21,2]),function(U,n,R,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const D=/^\w[\w\d+.-]*$/,l=/^\//,A=/^\/\//;function d(c,a){if(!c.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!D.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!l.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function r(c,a){return!c&&!a?"file":c}function o(c,a){switch(c){case"https":case"http":case"file":a?a[0]!==p&&(a=p+a):a=p;break}return a}const _="",p="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(a,f,b,P,F,I=!1){typeof a=="object"?(this.scheme=a.scheme||_,this.authority=a.authority||_,this.path=a.path||_,this.query=a.query||_,this.fragment=a.fragment||_):(this.scheme=r(a,I),this.authority=f||_,this.path=o(this.scheme,b||_),this.query=P||_,this.fragment=F||_,d(this,I))}static isUri(a){return a instanceof h?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return i(this,!1)}with(a){if(!a)return this;let{scheme:f,authority:b,path:P,query:F,fragment:I}=a;return f===void 0?f=this.scheme:f===null&&(f=_),b===void 0?b=this.authority:b===null&&(b=_),P===void 0?P=this.path:P===null&&(P=_),F===void 0?F=this.query:F===null&&(F=_),I===void 0?I=this.fragment:I===null&&(I=_),f===this.scheme&&b===this.authority&&P===this.path&&F===this.query&&I===this.fragment?this:new w(f,b,P,F,I)}static parse(a,f=!1){const b=m.exec(a);return b?new w(b[2]||_,v(b[4]||_),v(b[5]||_),v(b[7]||_),v(b[9]||_),f):new w(_,_,_,_,_)}static file(a){let f=_;if(y.isWindows&&(a=a.replace(/\\/g,p)),a[0]===p&&a[1]===p){const b=a.indexOf(p,2);b===-1?(f=a.substring(2),a=p):(f=a.substring(2,b),a=a.substring(b)||p)}return new w("file",f,a,_,_)}static from(a){const f=new w(a.scheme,a.authority,a.path,a.query,a.fragment);return d(f,!0),f}static joinPath(a,...f){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return y.isWindows&&a.scheme==="file"?b=h.file(R.win32.join(i(a,!0),...f)).path:b=R.posix.join(a.path,...f),a.with({path:b})}toString(a=!1){return s(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof h)return a;{const f=new w(a);return f._formatted=a.external,f._fsPath=a._sep===e?a.fsPath:null,f}}else return a}}n.URI=h;const e=y.isWindows?1:void 0;class w extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=i(this,!1)),this._fsPath}toString(a=!1){return a?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=e),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function L(c,a){let f,b=-1;for(let P=0;P<c.length;P++){const F=c.charCodeAt(P);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||a&&F===47)b!==-1&&(f+=encodeURIComponent(c.substring(b,P)),b=-1),f!==void 0&&(f+=c.charAt(P));else{f===void 0&&(f=c.substr(0,P));const I=E[F];I!==void 0?(b!==-1&&(f+=encodeURIComponent(c.substring(b,P)),b=-1),f+=I):b===-1&&(b=P)}}return b!==-1&&(f+=encodeURIComponent(c.substring(b))),f!==void 0?f:c}function M(c){let a;for(let f=0;f<c.length;f++){const b=c.charCodeAt(f);b===35||b===63?(a===void 0&&(a=c.substr(0,f)),a+=E[b]):a!==void 0&&(a+=c[f])}return a!==void 0?a:c}function i(c,a){let f;return c.authority&&c.path.length>1&&c.scheme==="file"?f=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?a?f=c.path.substr(1):f=c.path[1].toLowerCase()+c.path.substr(2):f=c.path,y.isWindows&&(f=f.replace(/\//g,"\\")),f}n.uriToFsPath=i;function s(c,a){const f=a?M:L;let b="",{scheme:P,authority:F,path:I,query:V,fragment:C}=c;if(P&&(b+=P,b+=":"),(F||P==="file")&&(b+=p,b+=p),F){let H=F.indexOf("@");if(H!==-1){const Z=F.substr(0,H);F=F.substr(H+1),H=Z.indexOf(":"),H===-1?b+=f(Z,!1):(b+=f(Z.substr(0,H),!1),b+=":",b+=f(Z.substr(H+1),!1)),b+="@"}F=F.toLowerCase(),H=F.indexOf(":"),H===-1?b+=f(F,!1):(b+=f(F.substr(0,H),!1),b+=F.substr(H))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const H=I.charCodeAt(1);H>=65&&H<=90&&(I=`/${String.fromCharCode(H+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const H=I.charCodeAt(0);H>=65&&H<=90&&(I=`${String.fromCharCode(H+32)}:${I.substr(2)}`)}b+=f(I,!0)}return V&&(b+="?",b+=f(V,!1)),C&&(b+="#",b+=a?C:L(C,!1)),b}function u(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+u(c.substr(3)):c}}const g=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(c){return c.match(g)?c.replace(g,a=>u(a)):c}}),x(ee[35],te([0,1,5,6,9,2,12,4]),function(U,n,R,y,D,l,A,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const r="$initialize";let o=!1;function _(c){!l.isWeb||(o||(o=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(c.message))}n.logOnceWebWorkerWarning=_;var p;(function(c){c[c.Request=0]="Request",c[c.Reply=1]="Reply",c[c.SubscribeEvent=2]="SubscribeEvent",c[c.Event=3]="Event",c[c.UnsubscribeEvent=4]="UnsubscribeEvent"})(p||(p={}));class m{constructor(a,f,b,P){this.vsWorker=a,this.req=f,this.method=b,this.args=P,this.type=0}}class h{constructor(a,f,b,P){this.vsWorker=a,this.seq=f,this.res=b,this.err=P,this.type=1}}class e{constructor(a,f,b,P){this.vsWorker=a,this.req=f,this.eventName=b,this.arg=P,this.type=2}}class w{constructor(a,f,b){this.vsWorker=a,this.req=f,this.event=b,this.type=3}}class E{constructor(a,f){this.vsWorker=a,this.req=f,this.type=4}}class L{constructor(a){this._workerId=-1,this._handler=a,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(a){this._workerId=a}sendMessage(a,f){const b=String(++this._lastSentReq);return new Promise((P,F)=>{this._pendingReplies[b]={resolve:P,reject:F},this._send(new m(this._workerId,b,a,f))})}listen(a,f){let b=null;const P=new y.Emitter({onFirstListenerAdd:()=>{b=String(++this._lastSentReq),this._pendingEmitters.set(b,P),this._send(new e(this._workerId,b,a,f))},onLastListenerRemove:()=>{this._pendingEmitters.delete(b),this._send(new E(this._workerId,b)),b=null}});return P.event}handleMessage(a){!a||!a.vsWorker||this._workerId!==-1&&a.vsWorker!==this._workerId||this._handleMessage(a)}_handleMessage(a){switch(a.type){case 1:return this._handleReplyMessage(a);case 0:return this._handleRequestMessage(a);case 2:return this._handleSubscribeEventMessage(a);case 3:return this._handleEventMessage(a);case 4:return this._handleUnsubscribeEventMessage(a)}}_handleReplyMessage(a){if(!this._pendingReplies[a.seq]){console.warn("Got reply to unknown seq");return}let f=this._pendingReplies[a.seq];if(delete this._pendingReplies[a.seq],a.err){let b=a.err;a.err.$isError&&(b=new Error,b.name=a.err.name,b.message=a.err.message,b.stack=a.err.stack),f.reject(b);return}f.resolve(a.res)}_handleRequestMessage(a){let f=a.req;this._handler.handleMessage(a.method,a.args).then(P=>{this._send(new h(this._workerId,f,P,void 0))},P=>{P.detail instanceof Error&&(P.detail=(0,R.transformErrorForSerialization)(P.detail)),this._send(new h(this._workerId,f,void 0,(0,R.transformErrorForSerialization)(P)))})}_handleSubscribeEventMessage(a){const f=a.req,b=this._handler.handleEvent(a.eventName,a.arg)(P=>{this._send(new w(this._workerId,f,P))});this._pendingEvents.set(f,b)}_handleEventMessage(a){if(!this._pendingEmitters.has(a.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(a.req).fire(a.event)}_handleUnsubscribeEventMessage(a){if(!this._pendingEvents.has(a.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(a.req).dispose(),this._pendingEvents.delete(a.req)}_send(a){let f=[];if(a.type===0)for(let b=0;b<a.args.length;b++)a.args[b]instanceof ArrayBuffer&&f.push(a.args[b]);else a.type===1&&a.res instanceof ArrayBuffer&&f.push(a.res);this._handler.sendMessage(a,f)}}class M extends D.Disposable{constructor(a,f,b){super();let P=null;this._worker=this._register(a.create("vs/base/common/worker/simpleWorker",H=>{this._protocol.handleMessage(H)},H=>{P&&P(H)})),this._protocol=new L({sendMessage:(H,Z)=>{this._worker.postMessage(H,Z)},handleMessage:(H,Z)=>{if(typeof b[H]!="function")return Promise.reject(new Error("Missing method "+H+" on main thread host."));try{return Promise.resolve(b[H].apply(b,Z))}catch(G){return Promise.reject(G)}},handleEvent:(H,Z)=>{if(s(H)){const G=b[H].call(b,Z);if(typeof G!="function")throw new Error(`Missing dynamic event ${H} on main thread host.`);return G}if(i(H)){const G=b[H];if(typeof G!="function")throw new Error(`Missing event ${H} on main thread host.`);return G}throw new Error(`Malformed event name ${H}`)}}),this._protocol.setWorkerId(this._worker.getId());let F=null;typeof l.globals.require!="undefined"&&typeof l.globals.require.getConfig=="function"?F=l.globals.require.getConfig():typeof l.globals.requirejs!="undefined"&&(F=l.globals.requirejs.s.contexts._.config);const I=A.getAllMethodNames(b);this._onModuleLoaded=this._protocol.sendMessage(r,[this._worker.getId(),JSON.parse(JSON.stringify(F)),f,I]);const V=(H,Z)=>this._request(H,Z),C=(H,Z)=>this._protocol.listen(H,Z);this._lazyProxy=new Promise((H,Z)=>{P=Z,this._onModuleLoaded.then(G=>{H(u(G,V,C))},G=>{Z(G),this._onError("Worker failed to load "+f,G)})})}getProxyObject(){return this._lazyProxy}_request(a,f){return new Promise((b,P)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(a,f).then(b,P)},P)})}_onError(a,f){console.error(a),console.info(f)}}n.SimpleWorkerClient=M;function i(c){return c[0]==="o"&&c[1]==="n"&&d.isUpperAsciiLetter(c.charCodeAt(2))}function s(c){return/^onDynamic/.test(c)&&d.isUpperAsciiLetter(c.charCodeAt(9))}function u(c,a,f){const b=I=>function(){const V=Array.prototype.slice.call(arguments,0);return a(I,V)},P=I=>function(V){return f(I,V)};let F={};for(const I of c){if(s(I)){F[I]=P(I);continue}if(i(I)){F[I]=f(I,void 0);continue}F[I]=b(I)}return F}class g{constructor(a,f){this._requestHandlerFactory=f,this._requestHandler=null,this._protocol=new L({sendMessage:(b,P)=>{a(b,P)},handleMessage:(b,P)=>this._handleMessage(b,P),handleEvent:(b,P)=>this._handleEvent(b,P)})}onmessage(a){this._protocol.handleMessage(a)}_handleMessage(a,f){if(a===r)return this.initialize(f[0],f[1],f[2],f[3]);if(!this._requestHandler||typeof this._requestHandler[a]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+a));try{return Promise.resolve(this._requestHandler[a].apply(this._requestHandler,f))}catch(b){return Promise.reject(b)}}_handleEvent(a,f){if(!this._requestHandler)throw new Error("Missing requestHandler");if(s(a)){const b=this._requestHandler[a].call(this._requestHandler,f);if(typeof b!="function")throw new Error(`Missing dynamic event ${a} on request handler.`);return b}if(i(a)){const b=this._requestHandler[a];if(typeof b!="function")throw new Error(`Missing event ${a} on request handler.`);return b}throw new Error(`Malformed event name ${a}`)}initialize(a,f,b,P){this._protocol.setWorkerId(a);const V=u(P,(C,H)=>this._protocol.sendMessage(C,H),(C,H)=>this._protocol.listen(C,H));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(V),Promise.resolve(A.getAllMethodNames(this._requestHandler))):(f&&(typeof f.baseUrl!="undefined"&&delete f.baseUrl,typeof f.paths!="undefined"&&typeof f.paths.vs!="undefined"&&delete f.paths.vs,typeof f.trustedTypesPolicy!==void 0&&delete f.trustedTypesPolicy,f.catchError=!0,l.globals.require.config(f)),new Promise((C,H)=>{(l.globals.require||U)([b],G=>{if(this._requestHandler=G.create(V),!this._requestHandler){H(new Error("No RequestHandler!"));return}C(A.getAllMethodNames(this._requestHandler))},H)}))}}n.SimpleWorkerServer=g;function v(c){return new g(c,null)}n.create=v}),x(ee[24],te([0,1,13]),function(U,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class y{constructor(d){let r=(0,R.toUint8)(d);this._defaultValue=r,this._asciiMap=y._createAsciiMap(r),this._map=new Map}static _createAsciiMap(d){let r=new Uint8Array(256);for(let o=0;o<256;o++)r[o]=d;return r}set(d,r){let o=(0,R.toUint8)(r);d>=0&&d<256?this._asciiMap[d]=o:this._map.set(d,o)}get(d){return d>=0&&d<256?this._asciiMap[d]:this._map.get(d)||this._defaultValue}}n.CharacterClassifier=y;var D;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(D||(D={}));class l{constructor(){this._actual=new y(0)}add(d){this._actual.set(d,1)}has(d){return this._actual.get(d)===1}}n.CharacterSet=l}),x(ee[3],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class R{constructor(D,l){this.lineNumber=D,this.column=l}with(D=this.lineNumber,l=this.column){return D===this.lineNumber&&l===this.column?this:new R(D,l)}delta(D=0,l=0){return this.with(this.lineNumber+D,this.column+l)}equals(D){return R.equals(this,D)}static equals(D,l){return!D&&!l?!0:!!D&&!!l&&D.lineNumber===l.lineNumber&&D.column===l.column}isBefore(D){return R.isBefore(this,D)}static isBefore(D,l){return D.lineNumber<l.lineNumber?!0:l.lineNumber<D.lineNumber?!1:D.column<l.column}isBeforeOrEqual(D){return R.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,l){return D.lineNumber<l.lineNumber?!0:l.lineNumber<D.lineNumber?!1:D.column<=l.column}static compare(D,l){let A=D.lineNumber|0,d=l.lineNumber|0;if(A===d){let r=D.column|0,o=l.column|0;return r-o}return A-d}clone(){return new R(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new R(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}n.Position=R}),x(ee[7],te([0,1,3]),function(U,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class y{constructor(l,A,d,r){l>d||l===d&&A>r?(this.startLineNumber=d,this.startColumn=r,this.endLineNumber=l,this.endColumn=A):(this.startLineNumber=l,this.startColumn=A,this.endLineNumber=d,this.endColumn=r)}isEmpty(){return y.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return y.containsPosition(this,l)}static containsPosition(l,A){return!(A.lineNumber<l.startLineNumber||A.lineNumber>l.endLineNumber||A.lineNumber===l.startLineNumber&&A.column<l.startColumn||A.lineNumber===l.endLineNumber&&A.column>l.endColumn)}containsRange(l){return y.containsRange(this,l)}static containsRange(l,A){return!(A.startLineNumber<l.startLineNumber||A.endLineNumber<l.startLineNumber||A.startLineNumber>l.endLineNumber||A.endLineNumber>l.endLineNumber||A.startLineNumber===l.startLineNumber&&A.startColumn<l.startColumn||A.endLineNumber===l.endLineNumber&&A.endColumn>l.endColumn)}strictContainsRange(l){return y.strictContainsRange(this,l)}static strictContainsRange(l,A){return!(A.startLineNumber<l.startLineNumber||A.endLineNumber<l.startLineNumber||A.startLineNumber>l.endLineNumber||A.endLineNumber>l.endLineNumber||A.startLineNumber===l.startLineNumber&&A.startColumn<=l.startColumn||A.endLineNumber===l.endLineNumber&&A.endColumn>=l.endColumn)}plusRange(l){return y.plusRange(this,l)}static plusRange(l,A){let d,r,o,_;return A.startLineNumber<l.startLineNumber?(d=A.startLineNumber,r=A.startColumn):A.startLineNumber===l.startLineNumber?(d=A.startLineNumber,r=Math.min(A.startColumn,l.startColumn)):(d=l.startLineNumber,r=l.startColumn),A.endLineNumber>l.endLineNumber?(o=A.endLineNumber,_=A.endColumn):A.endLineNumber===l.endLineNumber?(o=A.endLineNumber,_=Math.max(A.endColumn,l.endColumn)):(o=l.endLineNumber,_=l.endColumn),new y(d,r,o,_)}intersectRanges(l){return y.intersectRanges(this,l)}static intersectRanges(l,A){let d=l.startLineNumber,r=l.startColumn,o=l.endLineNumber,_=l.endColumn,p=A.startLineNumber,m=A.startColumn,h=A.endLineNumber,e=A.endColumn;return d<p?(d=p,r=m):d===p&&(r=Math.max(r,m)),o>h?(o=h,_=e):o===h&&(_=Math.min(_,e)),d>o||d===o&&r>_?null:new y(d,r,o,_)}equalsRange(l){return y.equalsRange(this,l)}static equalsRange(l,A){return!!l&&!!A&&l.startLineNumber===A.startLineNumber&&l.startColumn===A.startColumn&&l.endLineNumber===A.endLineNumber&&l.endColumn===A.endColumn}getEndPosition(){return y.getEndPosition(this)}static getEndPosition(l){return new R.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return y.getStartPosition(this)}static getStartPosition(l){return new R.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,A){return new y(this.startLineNumber,this.startColumn,l,A)}setStartPosition(l,A){return new y(l,A,this.endLineNumber,this.endColumn)}collapseToStart(){return y.collapseToStart(this)}static collapseToStart(l){return new y(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}static fromPositions(l,A=l){return new y(l.lineNumber,l.column,A.lineNumber,A.column)}static lift(l){return l?new y(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,A){return!(l.endLineNumber<A.startLineNumber||l.endLineNumber===A.startLineNumber&&l.endColumn<A.startColumn||A.endLineNumber<l.startLineNumber||A.endLineNumber===l.startLineNumber&&A.endColumn<l.startColumn)}static areIntersecting(l,A){return!(l.endLineNumber<A.startLineNumber||l.endLineNumber===A.startLineNumber&&l.endColumn<=A.startColumn||A.endLineNumber<l.startLineNumber||A.endLineNumber===l.startLineNumber&&A.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,A){if(l&&A){const o=l.startLineNumber|0,_=A.startLineNumber|0;if(o===_){const p=l.startColumn|0,m=A.startColumn|0;if(p===m){const h=l.endLineNumber|0,e=A.endLineNumber|0;if(h===e){const w=l.endColumn|0,E=A.endColumn|0;return w-E}return h-e}return p-m}return o-_}return(l?1:0)-(A?1:0)}static compareRangesUsingEnds(l,A){return l.endLineNumber===A.endLineNumber?l.endColumn===A.endColumn?l.startLineNumber===A.startLineNumber?l.startColumn-A.startColumn:l.startLineNumber-A.startLineNumber:l.endColumn-A.endColumn:l.endLineNumber-A.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}}n.Range=y}),x(ee[25],te([0,1,3,7]),function(U,n,R,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=n.SelectionDirection=void 0;var D;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(D=n.SelectionDirection||(n.SelectionDirection={}));class l extends y.Range{constructor(d,r,o,_){super(d,r,o,_);this.selectionStartLineNumber=d,this.selectionStartColumn=r,this.positionLineNumber=o,this.positionColumn=_}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return l.selectionsEqual(this,d)}static selectionsEqual(d,r){return d.selectionStartLineNumber===r.selectionStartLineNumber&&d.selectionStartColumn===r.selectionStartColumn&&d.positionLineNumber===r.positionLineNumber&&d.positionColumn===r.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,r){return this.getDirection()===0?new l(this.startLineNumber,this.startColumn,d,r):new l(d,r,this.startLineNumber,this.startColumn)}getPosition(){return new R.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new R.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,r){return this.getDirection()===0?new l(d,r,this.endLineNumber,this.endColumn):new l(this.endLineNumber,this.endColumn,d,r)}static fromPositions(d,r=d){return new l(d.lineNumber,d.column,r.lineNumber,r.column)}static fromRange(d,r){return r===0?new l(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new l(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new l(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,r){if(d&&!r||!d&&r)return!1;if(!d&&!r)return!0;if(d.length!==r.length)return!1;for(let o=0,_=d.length;o<_;o++)if(!this.selectionsEqual(d[o],r[o]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,r,o,_,p){return p===0?new l(d,r,o,_):new l(o,_,d,r)}}n.Selection=l}),x(ee[26],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationResult2=n.TokenizationResult=n.Token=void 0;class R{constructor(A,d,r){this._tokenBrand=void 0,this.offset=A|0,this.type=d,this.language=r}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=R;class y{constructor(A,d){this._tokenizationResultBrand=void 0,this.tokens=A,this.endState=d}}n.TokenizationResult=y;class D{constructor(A,d){this._tokenizationResult2Brand=void 0,this.tokens=A,this.endState=d}}n.TokenizationResult2=D}),x(ee[27],te([0,1,11,4]),function(U,n,R,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=void 0;const D=3;function l(w,E,L,M){return new R.LcsDiff(w,E,L).ComputeDiff(M)}class A{constructor(E){const L=[],M=[];for(let i=0,s=E.length;i<s;i++)L[i]=m(E[i],1),M[i]=h(E[i],1);this.lines=E,this._startColumns=L,this._endColumns=M}getElements(){const E=[];for(let L=0,M=this.lines.length;L<M;L++)E[L]=this.lines[L].substring(this._startColumns[L]-1,this._endColumns[L]-1);return E}getStrictElement(E){return this.lines[E]}getStartLineNumber(E){return E+1}getEndLineNumber(E){return E+1}createCharSequence(E,L,M){const i=[],s=[],u=[];let g=0;for(let v=L;v<=M;v++){const c=this.lines[v],a=E?this._startColumns[v]:1,f=E?this._endColumns[v]:c.length+1;for(let b=a;b<f;b++)i[g]=c.charCodeAt(b-1),s[g]=v+1,u[g]=b,g++}return new d(i,s,u)}}class d{constructor(E,L,M){this._charCodes=E,this._lineNumbers=L,this._columns=M}getElements(){return this._charCodes}getStartLineNumber(E){return this._lineNumbers[E]}getStartColumn(E){return this._columns[E]}getEndLineNumber(E){return this._lineNumbers[E]}getEndColumn(E){return this._columns[E]+1}}class r{constructor(E,L,M,i,s,u,g,v){this.originalStartLineNumber=E,this.originalStartColumn=L,this.originalEndLineNumber=M,this.originalEndColumn=i,this.modifiedStartLineNumber=s,this.modifiedStartColumn=u,this.modifiedEndLineNumber=g,this.modifiedEndColumn=v}static createFromDiffChange(E,L,M){let i,s,u,g,v,c,a,f;return E.originalLength===0?(i=0,s=0,u=0,g=0):(i=L.getStartLineNumber(E.originalStart),s=L.getStartColumn(E.originalStart),u=L.getEndLineNumber(E.originalStart+E.originalLength-1),g=L.getEndColumn(E.originalStart+E.originalLength-1)),E.modifiedLength===0?(v=0,c=0,a=0,f=0):(v=M.getStartLineNumber(E.modifiedStart),c=M.getStartColumn(E.modifiedStart),a=M.getEndLineNumber(E.modifiedStart+E.modifiedLength-1),f=M.getEndColumn(E.modifiedStart+E.modifiedLength-1)),new r(i,s,u,g,v,c,a,f)}}function o(w){if(w.length<=1)return w;const E=[w[0]];let L=E[0];for(let M=1,i=w.length;M<i;M++){const s=w[M],u=s.originalStart-(L.originalStart+L.originalLength),g=s.modifiedStart-(L.modifiedStart+L.modifiedLength);Math.min(u,g)<D?(L.originalLength=s.originalStart+s.originalLength-L.originalStart,L.modifiedLength=s.modifiedStart+s.modifiedLength-L.modifiedStart):(E.push(s),L=s)}return E}class _{constructor(E,L,M,i,s){this.originalStartLineNumber=E,this.originalEndLineNumber=L,this.modifiedStartLineNumber=M,this.modifiedEndLineNumber=i,this.charChanges=s}static createFromDiffResult(E,L,M,i,s,u,g){let v,c,a,f,b;if(L.originalLength===0?(v=M.getStartLineNumber(L.originalStart)-1,c=0):(v=M.getStartLineNumber(L.originalStart),c=M.getEndLineNumber(L.originalStart+L.originalLength-1)),L.modifiedLength===0?(a=i.getStartLineNumber(L.modifiedStart)-1,f=0):(a=i.getStartLineNumber(L.modifiedStart),f=i.getEndLineNumber(L.modifiedStart+L.modifiedLength-1)),u&&L.originalLength>0&&L.originalLength<20&&L.modifiedLength>0&&L.modifiedLength<20&&s()){const P=M.createCharSequence(E,L.originalStart,L.originalStart+L.originalLength-1),F=i.createCharSequence(E,L.modifiedStart,L.modifiedStart+L.modifiedLength-1);let I=l(P,F,s,!0).changes;g&&(I=o(I)),b=[];for(let V=0,C=I.length;V<C;V++)b.push(r.createFromDiffChange(I[V],P,F))}return new _(v,c,a,f,b)}}class p{constructor(E,L,M){this.shouldComputeCharChanges=M.shouldComputeCharChanges,this.shouldPostProcessCharChanges=M.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=M.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=M.shouldMakePrettyDiff,this.originalLines=E,this.modifiedLines=L,this.original=new A(E),this.modified=new A(L),this.continueLineDiff=e(M.maxComputationTime),this.continueCharDiff=e(M.maxComputationTime===0?0:Math.min(M.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const E=l(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),L=E.changes,M=E.quitEarly;if(this.shouldIgnoreTrimWhitespace){const g=[];for(let v=0,c=L.length;v<c;v++)g.push(_.createFromDiffResult(this.shouldIgnoreTrimWhitespace,L[v],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:M,changes:g}}const i=[];let s=0,u=0;for(let g=-1,v=L.length;g<v;g++){const c=g+1<v?L[g+1]:null,a=c?c.originalStart:this.originalLines.length,f=c?c.modifiedStart:this.modifiedLines.length;for(;s<a&&u<f;){const b=this.originalLines[s],P=this.modifiedLines[u];if(b!==P){{let F=m(b,1),I=m(P,1);for(;F>1&&I>1;){const V=b.charCodeAt(F-2),C=P.charCodeAt(I-2);if(V!==C)break;F--,I--}(F>1||I>1)&&this._pushTrimWhitespaceCharChange(i,s+1,1,F,u+1,1,I)}{let F=h(b,1),I=h(P,1);const V=b.length+1,C=P.length+1;for(;F<V&&I<C;){const H=b.charCodeAt(F-1),Z=b.charCodeAt(I-1);if(H!==Z)break;F++,I++}(F<V||I<C)&&this._pushTrimWhitespaceCharChange(i,s+1,F,V,u+1,I,C)}}s++,u++}c&&(i.push(_.createFromDiffResult(this.shouldIgnoreTrimWhitespace,c,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),s+=c.originalLength,u+=c.modifiedLength)}return{quitEarly:M,changes:i}}_pushTrimWhitespaceCharChange(E,L,M,i,s,u,g){if(this._mergeTrimWhitespaceCharChange(E,L,M,i,s,u,g))return;let v;this.shouldComputeCharChanges&&(v=[new r(L,M,L,i,s,u,s,g)]),E.push(new _(L,L,s,s,v))}_mergeTrimWhitespaceCharChange(E,L,M,i,s,u,g){const v=E.length;if(v===0)return!1;const c=E[v-1];return c.originalEndLineNumber===0||c.modifiedEndLineNumber===0?!1:c.originalEndLineNumber+1===L&&c.modifiedEndLineNumber+1===s?(c.originalEndLineNumber=L,c.modifiedEndLineNumber=s,this.shouldComputeCharChanges&&c.charChanges&&c.charChanges.push(new r(L,M,L,i,s,u,s,g)),!0):!1}}n.DiffComputer=p;function m(w,E){const L=y.firstNonWhitespaceIndex(w);return L===-1?E:L+1}function h(w,E){const L=y.lastNonWhitespaceIndex(w);return L===-1?E:L+2}function e(w){if(w===0)return()=>!0;const E=Date.now();return()=>Date.now()-E<w}}),x(ee[28],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(d=""){let r="(-?\\d*\\.\\d\\w*)|([^";for(const o of n.USUAL_WORD_SEPARATORS)d.indexOf(o)>=0||(r+="\\"+o);return r+="\\s]+)",new RegExp(r,"g")}n.DEFAULT_WORD_REGEXP=R();function y(d){let r=n.DEFAULT_WORD_REGEXP;if(d&&d instanceof RegExp)if(d.global)r=d;else{let o="g";d.ignoreCase&&(o+="i"),d.multiline&&(o+="m"),d.unicode&&(o+="u"),r=new RegExp(d.source,o)}return r.lastIndex=0,r}n.ensureValidWordDefinition=y;const D={maxLen:1e3,windowSize:15,timeBudget:150};function l(d,r,o,_,p=D){if(o.length>p.maxLen){let E=d-p.maxLen/2;return E<0?E=0:_+=E,o=o.substring(E,d+p.maxLen/2),l(d,r,o,_,p)}const m=Date.now(),h=d-1-_;let e=-1,w=null;for(let E=1;!(Date.now()-m>=p.timeBudget);E++){const L=h-p.windowSize*E;r.lastIndex=Math.max(0,L);const M=A(r,o,h,e);if(!M&&w||(w=M,L<=0))break;e=L}if(w){let E={word:w[0],startColumn:_+1+w.index,endColumn:_+1+w.index+w[0].length};return r.lastIndex=0,E}return null}n.getWordAtText=l;function A(d,r,o,_){let p;for(;p=d.exec(r);){const m=p.index||0;if(m<=o&&d.lastIndex>=o)return p;if(_>0&&m>_)return null}return null}}),x(ee[29],te([0,1,24]),function(U,n,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=n.State=void 0;var y;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(y=n.State||(n.State={}));class D{constructor(e,w,E){const L=new Uint8Array(e*w);for(let M=0,i=e*w;M<i;M++)L[M]=E;this._data=L,this.rows=e,this.cols=w}get(e,w){return this._data[e*this.cols+w]}set(e,w,E){this._data[e*this.cols+w]=E}}n.Uint8Matrix=D;class l{constructor(e){let w=0,E=0;for(let M=0,i=e.length;M<i;M++){let[s,u,g]=e[M];u>w&&(w=u),s>E&&(E=s),g>E&&(E=g)}w++,E++;let L=new D(E,w,0);for(let M=0,i=e.length;M<i;M++){let[s,u,g]=e[M];L.set(s,u,g)}this._states=L,this._maxCharCode=w}nextState(e,w){return w<0||w>=this._maxCharCode?0:this._states.get(e,w)}}n.StateMachine=l;let A=null;function d(){return A===null&&(A=new l([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var r;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(r||(r={}));let o=null;function _(){if(o===null){o=new R.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<h.length;w++)o.set(h.charCodeAt(w),1);const e=".,;";for(let w=0;w<e.length;w++)o.set(e.charCodeAt(w),2)}return o}class p{static _createLink(e,w,E,L,M){let i=M-1;do{const s=w.charCodeAt(i);if(e.get(s)!==2)break;i--}while(i>L);if(L>0){const s=w.charCodeAt(L-1),u=w.charCodeAt(i);(s===40&&u===41||s===91&&u===93||s===123&&u===125)&&i--}return{range:{startLineNumber:E,startColumn:L+1,endLineNumber:E,endColumn:i+2},url:w.substring(L,i+1)}}static computeLinks(e,w=d()){const E=_();let L=[];for(let M=1,i=e.getLineCount();M<=i;M++){const s=e.getLineContent(M),u=s.length;let g=0,v=0,c=0,a=1,f=!1,b=!1,P=!1,F=!1;for(;g<u;){let I=!1;const V=s.charCodeAt(g);if(a===13){let C;switch(V){case 40:f=!0,C=0;break;case 41:C=f?0:1;break;case 91:P=!0,b=!0,C=0;break;case 93:P=!1,C=b?0:1;break;case 123:F=!0,C=0;break;case 125:C=F?0:1;break;case 39:C=c===34||c===96?0:1;break;case 34:C=c===39||c===96?0:1;break;case 96:C=c===39||c===34?0:1;break;case 42:C=c===42?1:0;break;case 124:C=c===124?1:0;break;case 32:C=P?0:1;break;default:C=E.get(V)}C===1&&(L.push(p._createLink(E,s,M,v,g)),I=!0)}else if(a===12){let C;V===91?(b=!0,C=0):C=E.get(V),C===1?I=!0:a=13}else a=w.nextState(a,V),a===0&&(I=!0);I&&(a=1,f=!1,b=!1,F=!1,v=g+1,c=V),g++}a===13&&L.push(p._createLink(E,s,M,v,u))}return L}}n.LinkComputer=p;function m(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:p.computeLinks(h)}n.computeLinks=m}),x(ee[30],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class R{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(D,l,A,d,r){if(D&&l){let o=this.doNavigateValueSet(l,r);if(o)return{range:D,value:o}}if(A&&d){let o=this.doNavigateValueSet(d,r);if(o)return{range:A,value:o}}return null}doNavigateValueSet(D,l){let A=this.numberReplace(D,l);return A!==null?A:this.textReplace(D,l)}numberReplace(D,l){let A=Math.pow(10,D.length-(D.lastIndexOf(".")+1)),d=Number(D),r=parseFloat(D);return!isNaN(d)&&!isNaN(r)&&d===r?d===0&&!l?null:(d=Math.floor(d*A),d+=l?A:-A,String(d/A)):null}textReplace(D,l){return this.valueSetsReplace(this._defaultValueSet,D,l)}valueSetsReplace(D,l,A){let d=null;for(let r=0,o=D.length;d===null&&r<o;r++)d=this.valueSetReplace(D[r],l,A);return d}valueSetReplace(D,l,A){let d=D.indexOf(l);return d>=0?(d+=A?1:-1,d<0?d=D.length-1:d%=D.length,D[d]):null}}n.BasicInplaceReplace=R,R.INSTANCE=new R}),x(ee[31],te([0,1]),function(U,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.AccessibilitySupport=void 0;var R;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(R=n.AccessibilitySupport||(n.AccessibilitySupport={}));var y;(function(t){t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(y=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var D;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(D=n.CompletionItemKind||(n.CompletionItemKind={}));var l;(function(t){t[t.Deprecated=1]="Deprecated"})(l=n.CompletionItemTag||(n.CompletionItemTag={}));var A;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(A=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var d;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(d=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var r;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(r=n.CursorChangeReason||(n.CursorChangeReason={}));var o;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(o=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var _;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(_=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var p;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(p=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var m;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.autoClosingDelete=6]="autoClosingDelete",t[t.autoClosingOvertype=7]="autoClosingOvertype",t[t.autoClosingQuotes=8]="autoClosingQuotes",t[t.autoIndent=9]="autoIndent",t[t.automaticLayout=10]="automaticLayout",t[t.autoSurround=11]="autoSurround",t[t.bracketPairColorization=12]="bracketPairColorization",t[t.guides=13]="guides",t[t.codeLens=14]="codeLens",t[t.codeLensFontFamily=15]="codeLensFontFamily",t[t.codeLensFontSize=16]="codeLensFontSize",t[t.colorDecorators=17]="colorDecorators",t[t.columnSelection=18]="columnSelection",t[t.comments=19]="comments",t[t.contextmenu=20]="contextmenu",t[t.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",t[t.cursorBlinking=22]="cursorBlinking",t[t.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",t[t.cursorStyle=24]="cursorStyle",t[t.cursorSurroundingLines=25]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",t[t.cursorWidth=27]="cursorWidth",t[t.disableLayerHinting=28]="disableLayerHinting",t[t.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",t[t.domReadOnly=30]="domReadOnly",t[t.dragAndDrop=31]="dragAndDrop",t[t.emptySelectionClipboard=32]="emptySelectionClipboard",t[t.extraEditorClassName=33]="extraEditorClassName",t[t.fastScrollSensitivity=34]="fastScrollSensitivity",t[t.find=35]="find",t[t.fixedOverflowWidgets=36]="fixedOverflowWidgets",t[t.folding=37]="folding",t[t.foldingStrategy=38]="foldingStrategy",t[t.foldingHighlight=39]="foldingHighlight",t[t.foldingImportsByDefault=40]="foldingImportsByDefault",t[t.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=42]="fontFamily",t[t.fontInfo=43]="fontInfo",t[t.fontLigatures=44]="fontLigatures",t[t.fontSize=45]="fontSize",t[t.fontWeight=46]="fontWeight",t[t.formatOnPaste=47]="formatOnPaste",t[t.formatOnType=48]="formatOnType",t[t.glyphMargin=49]="glyphMargin",t[t.gotoLocation=50]="gotoLocation",t[t.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",t[t.hover=52]="hover",t[t.inDiffEditor=53]="inDiffEditor",t[t.inlineSuggest=54]="inlineSuggest",t[t.letterSpacing=55]="letterSpacing",t[t.lightbulb=56]="lightbulb",t[t.lineDecorationsWidth=57]="lineDecorationsWidth",t[t.lineHeight=58]="lineHeight",t[t.lineNumbers=59]="lineNumbers",t[t.lineNumbersMinChars=60]="lineNumbersMinChars",t[t.linkedEditing=61]="linkedEditing",t[t.links=62]="links",t[t.matchBrackets=63]="matchBrackets",t[t.minimap=64]="minimap",t[t.mouseStyle=65]="mouseStyle",t[t.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=67]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",t[t.multiCursorModifier=69]="multiCursorModifier",t[t.multiCursorPaste=70]="multiCursorPaste",t[t.occurrencesHighlight=71]="occurrencesHighlight",t[t.overviewRulerBorder=72]="overviewRulerBorder",t[t.overviewRulerLanes=73]="overviewRulerLanes",t[t.padding=74]="padding",t[t.parameterHints=75]="parameterHints",t[t.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",t[t.quickSuggestions=78]="quickSuggestions",t[t.quickSuggestionsDelay=79]="quickSuggestionsDelay",t[t.readOnly=80]="readOnly",t[t.renameOnType=81]="renameOnType",t[t.renderControlCharacters=82]="renderControlCharacters",t[t.renderFinalNewline=83]="renderFinalNewline",t[t.renderLineHighlight=84]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=86]="renderValidationDecorations",t[t.renderWhitespace=87]="renderWhitespace",t[t.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",t[t.roundedSelection=89]="roundedSelection",t[t.rulers=90]="rulers",t[t.scrollbar=91]="scrollbar",t[t.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=93]="scrollBeyondLastLine",t[t.scrollPredominantAxis=94]="scrollPredominantAxis",t[t.selectionClipboard=95]="selectionClipboard",t[t.selectionHighlight=96]="selectionHighlight",t[t.selectOnLineNumbers=97]="selectOnLineNumbers",t[t.showFoldingControls=98]="showFoldingControls",t[t.showUnused=99]="showUnused",t[t.snippetSuggestions=100]="snippetSuggestions",t[t.smartSelect=101]="smartSelect",t[t.smoothScrolling=102]="smoothScrolling",t[t.stickyTabStops=103]="stickyTabStops",t[t.stopRenderingLineAfter=104]="stopRenderingLineAfter",t[t.suggest=105]="suggest",t[t.suggestFontSize=106]="suggestFontSize",t[t.suggestLineHeight=107]="suggestLineHeight",t[t.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",t[t.suggestSelection=109]="suggestSelection",t[t.tabCompletion=110]="tabCompletion",t[t.tabIndex=111]="tabIndex",t[t.unusualLineTerminators=112]="unusualLineTerminators",t[t.useShadowDOM=113]="useShadowDOM",t[t.useTabStops=114]="useTabStops",t[t.wordSeparators=115]="wordSeparators",t[t.wordWrap=116]="wordWrap",t[t.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=119]="wordWrapColumn",t[t.wordWrapOverride1=120]="wordWrapOverride1",t[t.wordWrapOverride2=121]="wordWrapOverride2",t[t.wrappingIndent=122]="wrappingIndent",t[t.wrappingStrategy=123]="wrappingStrategy",t[t.showDeprecated=124]="showDeprecated",t[t.inlayHints=125]="inlayHints",t[t.editorClassName=126]="editorClassName",t[t.pixelRatio=127]="pixelRatio",t[t.tabFocusMode=128]="tabFocusMode",t[t.layoutInfo=129]="layoutInfo",t[t.wrappingInfo=130]="wrappingInfo"})(m=n.EditorOption||(n.EditorOption={}));var h;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(h=n.EndOfLinePreference||(n.EndOfLinePreference={}));var e;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(e=n.EndOfLineSequence||(n.EndOfLineSequence={}));var w;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(w=n.IndentAction||(n.IndentAction={}));var E;(function(t){t[t.Other=0]="Other",t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(E=n.InlayHintKind||(n.InlayHintKind={}));var L;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(L=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var M;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(M=n.KeyCode||(n.KeyCode={}));var i;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(i=n.MarkerSeverity||(n.MarkerSeverity={}));var s;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(s=n.MarkerTag||(n.MarkerTag={}));var u;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(u=n.MinimapPosition||(n.MinimapPosition={}));var g;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(g=n.MouseTargetType||(n.MouseTargetType={}));var v;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(v=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var c;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(c=n.OverviewRulerLane||(n.OverviewRulerLane={}));var a;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(a=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var f;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(f=n.RenderMinimap||(n.RenderMinimap={}));var b;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(b=n.ScrollType||(n.ScrollType={}));var P;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(P=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var F;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(F=n.SelectionDirection||(n.SelectionDirection={}));var I;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(I=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var V;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(V=n.SymbolKind||(n.SymbolKind={}));var C;(function(t){t[t.Deprecated=1]="Deprecated"})(C=n.SymbolTag||(n.SymbolTag={}));var H;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(H=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var Z;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(Z=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var G;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(G=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var se;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(se=n.WrappingIndent||(n.WrappingIndent={}))}),x(ee[32],te([0,1,22,6,18,14,3,7,25,26,31]),function(U,n,R,y,D,l,A,d,r,o,_){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class p{static chord(e,w){return(0,D.KeyChord)(e,w)}}n.KeyMod=p,p.CtrlCmd=2048,p.Shift=1024,p.Alt=512,p.WinCtrl=256;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:R.CancellationTokenSource,Emitter:y.Emitter,KeyCode:_.KeyCode,KeyMod:p,Position:A.Position,Range:d.Range,Selection:r.Selection,SelectionDirection:_.SelectionDirection,MarkerSeverity:_.MarkerSeverity,MarkerTag:_.MarkerTag,Uri:l.URI,Token:o.Token}}n.createMonacoBaseAPI=m}),x(ee[33],te([0,1,16,13]),function(U,n,R,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class D{constructor(r){this.values=r,this.prefixSum=new Uint32Array(r.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(r,o){r=(0,y.toUint32)(r);const _=this.values,p=this.prefixSum,m=o.length;return m===0?!1:(this.values=new Uint32Array(_.length+m),this.values.set(_.subarray(0,r),0),this.values.set(_.subarray(r),r+m),this.values.set(o,r),r-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=r-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(p.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(r,o){return r=(0,y.toUint32)(r),o=(0,y.toUint32)(o),this.values[r]===o?!1:(this.values[r]=o,r-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=r-1),!0)}removeValues(r,o){r=(0,y.toUint32)(r),o=(0,y.toUint32)(o);const _=this.values,p=this.prefixSum;if(r>=_.length)return!1;let m=_.length-r;return o>=m&&(o=m),o===0?!1:(this.values=new Uint32Array(_.length-o),this.values.set(_.subarray(0,r),0),this.values.set(_.subarray(r+o),r),this.prefixSum=new Uint32Array(this.values.length),r-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=r-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(p.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(r){return r<0?0:(r=(0,y.toUint32)(r),this._getPrefixSum(r))}_getPrefixSum(r){if(r<=this.prefixSumValidIndex[0])return this.prefixSum[r];let o=this.prefixSumValidIndex[0]+1;o===0&&(this.prefixSum[0]=this.values[0],o++),r>=this.values.length&&(r=this.values.length-1);for(let _=o;_<=r;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],r),this.prefixSum[r]}getIndexOf(r){r=Math.floor(r),this.getTotalSum();let o=0,_=this.values.length-1,p=0,m=0,h=0;for(;o<=_;)if(p=o+(_-o)/2|0,m=this.prefixSum[p],h=m-this.values[p],r<h)_=p-1;else if(r>=m)o=p+1;else break;return new A(p,r-h)}}n.PrefixSumComputer=D;class l{constructor(r){this._values=r,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(r){return this._ensureValid(),r===0?0:this._prefixSum[r-1]}getIndexOf(r){this._ensureValid();const o=this._indexBySum[r],_=o>0?this._prefixSum[o-1]:0;return new A(o,r-_)}removeValues(r,o){this._values.splice(r,o),this._invalidate(r)}insertValues(r,o){this._values=(0,R.arrayInsert)(this._values,r,o),this._invalidate(r)}_invalidate(r){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,r-1)}_ensureValid(){if(!this._isValid){for(let r=this._validEndIndex+1,o=this._values.length;r<o;r++){const _=this._values[r],p=r>0?this._prefixSum[r-1]:0;this._prefixSum[r]=p+_;for(let m=0;m<_;m++)this._indexBySum[p+m]=r}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(r,o){this._values[r]!==o&&(this._values[r]=o,this._invalidate(r))}}n.ConstantTimePrefixSumComputer=l;class A{constructor(r,o){this.index=r,this.remainder=o,this._prefixSumIndexOfResultBrand=void 0,this.index=r,this.remainder=o}}n.PrefixSumIndexOfResult=A}),x(ee[34],te([0,1,4,3,33]),function(U,n,R,y,D){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class l{constructor(d,r,o,_){this._uri=d,this._lines=r,this._eol=o,this._versionId=_,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(d){d.eol&&d.eol!==this._eol&&(this._eol=d.eol,this._lineStarts=null);const r=d.changes;for(const o of r)this._acceptDeleteRange(o.range),this._acceptInsertText(new y.Position(o.range.startLineNumber,o.range.startColumn),o.text);this._versionId=d.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const d=this._eol.length,r=this._lines.length,o=new Uint32Array(r);for(let _=0;_<r;_++)o[_]=this._lines[_].length+d;this._lineStarts=new D.PrefixSumComputer(o)}}_setLineText(d,r){this._lines[d]=r,this._lineStarts&&this._lineStarts.setValue(d,this._lines[d].length+this._eol.length)}_acceptDeleteRange(d){if(d.startLineNumber===d.endLineNumber){if(d.startColumn===d.endColumn)return;this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.startLineNumber-1].substring(d.endColumn-1));return}this._setLineText(d.startLineNumber-1,this._lines[d.startLineNumber-1].substring(0,d.startColumn-1)+this._lines[d.endLineNumber-1].substring(d.endColumn-1)),this._lines.splice(d.startLineNumber,d.endLineNumber-d.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(d.startLineNumber,d.endLineNumber-d.startLineNumber)}_acceptInsertText(d,r){if(r.length===0)return;let o=(0,R.splitLines)(r);if(o.length===1){this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+o[0]+this._lines[d.lineNumber-1].substring(d.column-1));return}o[o.length-1]+=this._lines[d.lineNumber-1].substring(d.column-1),this._setLineText(d.lineNumber-1,this._lines[d.lineNumber-1].substring(0,d.column-1)+o[0]);let _=new Uint32Array(o.length-1);for(let p=1;p<o.length;p++)this._lines.splice(d.lineNumber+p-1,0,o[p]),_[p-1]=o[p].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(d.lineNumber,_)}}n.MirrorTextModel=l}),x(ee[36],te([0,1,11,2,14,3,7,27,34,28,29,30,32,12,10]),function(U,n,R,y,D,l,A,d,r,o,_,p,m,h,e){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class w extends r.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,s){let u=(0,o.getWordAtText)(i.column,(0,o.ensureValidWordDefinition)(s),this._lines[i.lineNumber-1],0);return u?new A.Range(i.lineNumber,u.startColumn,i.lineNumber,u.endColumn):null}getWordUntilPosition(i,s){const u=this.getWordAtPosition(i,s);return u?{word:this._lines[i.lineNumber-1].substring(u.startColumn-1,i.column-1),startColumn:u.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const s=this._lines,u=this._wordenize.bind(this);let g=0,v="",c=0,a=[];return{*[Symbol.iterator](){for(;;)if(c<a.length){const f=v.substring(a[c].start,a[c].end);c+=1,yield f}else if(g<s.length)v=s[g],a=u(v,i),c=0,g+=1;else break}}}getLineWords(i,s){let u=this._lines[i-1],g=this._wordenize(u,s),v=[];for(const c of g)v.push({word:u.substring(c.start,c.end),startColumn:c.start+1,endColumn:c.end+1});return v}_wordenize(i,s){const u=[];let g;for(s.lastIndex=0;(g=s.exec(i))&&g[0].length!==0;)u.push({start:g.index,end:g.index+g[0].length});return u}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let s=this._eol,u=i.startLineNumber-1,g=i.endLineNumber-1,v=[];v.push(this._lines[u].substring(i.startColumn-1));for(let c=u+1;c<g;c++)v.push(this._lines[c]);return v.push(this._lines[g].substring(0,i.endColumn-1)),v.join(s)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let s=this._lineStarts.getIndexOf(i),u=this._lines[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,u)}}_validateRange(i){const s=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),u=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return s.lineNumber!==i.startLineNumber||s.column!==i.startColumn||u.lineNumber!==i.endLineNumber||u.column!==i.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:u.lineNumber,endColumn:u.column}:i}_validatePosition(i){if(!l.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:s,column:u}=i,g=!1;if(s<1)s=1,u=1,g=!0;else if(s>this._lines.length)s=this._lines.length,u=this._lines[s-1].length+1,g=!0;else{let v=this._lines[s-1].length+1;u<1?(u=1,g=!0):u>v&&(u=v,g=!0)}return g?{lineNumber:s,column:u}:i}}n.MirrorModel=w;class E{constructor(i,s){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=s,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(s=>i.push(this._models[s])),i}acceptNewModel(i){this._models[i.url]=new w(D.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,s){if(!this._models[i])return;this._models[i].onEvents(s)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}async computeDiff(i,s,u,g){const v=this._getModel(i),c=this._getModel(s);if(!v||!c)return null;const a=v.getLinesContent(),f=c.getLinesContent(),P=new d.DiffComputer(a,f,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:u,shouldMakePrettyDiff:!0,maxComputationTime:g}).computeDiff(),F=P.changes.length>0?!1:this._modelsAreIdentical(v,c);return{quitEarly:P.quitEarly,identical:F,changes:P.changes}}_modelsAreIdentical(i,s){const u=i.getLineCount(),g=s.getLineCount();if(u!==g)return!1;for(let v=1;v<=u;v++){const c=i.getLineContent(v),a=s.getLineContent(v);if(c!==a)return!1}return!0}async computeDirtyDiff(i,s,u){let g=this._getModel(i),v=this._getModel(s);if(!g||!v)return null;let c=g.getLinesContent(),a=v.getLinesContent();return new d.DiffComputer(c,a,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:u,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,s){const u=this._getModel(i);if(!u)return s;const g=[];let v;s=s.slice(0).sort((c,a)=>{if(c.range&&a.range)return A.Range.compareRangesUsingStarts(c.range,a.range);let f=c.range?0:1,b=a.range?0:1;return f-b});for(let{range:c,text:a,eol:f}of s){if(typeof f=="number"&&(v=f),A.Range.isEmpty(c)&&!a)continue;const b=u.getValueInRange(c);if(a=a.replace(/\r\n|\n|\r/g,u.eol),b===a)continue;if(Math.max(a.length,b.length)>E._diffLimit){g.push({range:c,text:a});continue}const P=(0,R.stringDiff)(b,a,!1),F=u.offsetAt(A.Range.lift(c).getStartPosition());for(const I of P){const V=u.positionAt(F+I.originalStart),C=u.positionAt(F+I.originalStart+I.originalLength),H={text:a.substr(I.modifiedStart,I.modifiedLength),range:{startLineNumber:V.lineNumber,startColumn:V.column,endLineNumber:C.lineNumber,endColumn:C.column}};u.getValueInRange(H.range)!==H.text&&g.push(H)}}return typeof v=="number"&&g.push({eol:v,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),g}async computeLinks(i){let s=this._getModel(i);return s?(0,_.computeLinks)(s):null}async textualSuggest(i,s,u,g){const v=new e.StopWatch(!0),c=new RegExp(u,g),a=new Set;e:for(let f of i){const b=this._getModel(f);if(!!b){for(let P of b.words(c))if(!(P===s||!isNaN(Number(P)))&&(a.add(P),a.size>E._suggestionsLimit))break e}}return{words:Array.from(a),duration:v.elapsed()}}async computeWordRanges(i,s,u,g){let v=this._getModel(i);if(!v)return Object.create(null);const c=new RegExp(u,g),a=Object.create(null);for(let f=s.startLineNumber;f<s.endLineNumber;f++){let b=v.getLineWords(f,c);for(const P of b){if(!isNaN(Number(P.word)))continue;let F=a[P.word];F||(F=[],a[P.word]=F),F.push({startLineNumber:f,startColumn:P.startColumn,endLineNumber:f,endColumn:P.endColumn})}}return a}async navigateValueSet(i,s,u,g,v){let c=this._getModel(i);if(!c)return null;let a=new RegExp(g,v);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});let f=c.getValueInRange(s),b=c.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},a);if(!b)return null;let P=c.getValueInRange(b);return p.BasicInplaceReplace.INSTANCE.navigateValueSet(s,f,b,P,u)}loadForeignModule(i,s,u){const g=(a,f)=>this._host.fhr(a,f);let c={host:h.createProxyObject(u,g),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(c,s),Promise.resolve(h.getAllMethodNames(this._foreignModule))):new Promise((a,f)=>{U([i],b=>{this._foreignModule=b.create(c,s),a(h.getAllMethodNames(this._foreignModule))},f)})}fmr(i,s){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,s))}catch(u){return Promise.reject(u)}}}n.EditorSimpleWorker=E,E._diffLimit=1e5,E._suggestionsLimit=1e4;function L(M){return new E(M,null)}n.create=L,typeof importScripts=="function"&&(y.globals.monaco=(0,m.createMonacoBaseAPI)())}),function(){const U=self.MonacoEnvironment,n=U&&U.baseUrl?U.baseUrl:"../../../",R=typeof self.trustedTypes?.createPolicy=="function"?self.trustedTypes?.createPolicy("amdLoader",{createScriptURL:r=>r,createScript:(r,...o)=>{const _=o.slice(0,-1).join(","),p=o.pop().toString();return`(function anonymous(${_}) {
${p}
})`}}):void 0;function y(){try{return(R?self.eval(R.createScript("","true")):new Function("true")).call(self),!0}catch(r){return!1}}function D(){return new Promise((r,o)=>{if(typeof self.define=="function"&&self.define.amd)return r();const _=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(_)&&_.substring(0,self.origin.length)!==self.origin)&&y()){fetch(_).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${_}`,(R?self.eval(R.createScript("",m)):new Function(m)).call(self),r()}).then(void 0,o);return}R?importScripts(R.createScriptURL(_)):importScripts(_),r()})}const l=function(r){D().then(()=>{require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:R,amdModulesPattern:/^vs\//}),require([r],function(o){setTimeout(function(){let _=o.create((p,m)=>{self.postMessage(p,m)},null);for(self.onmessage=p=>_.onmessage(p.data,p.ports);d.length>0;)self.onmessage(d.shift())},0)})})};let A=!0,d=[];self.onmessage=r=>{if(!A){d.push(r);return}A=!1,l(r.data)}}()}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d450b04c783dfa6f83dc439017767acccd4e9fac/core/vs/base/worker/workerMain.js.map
