/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/uri","vs/base/common/path","vs/platform/environment/common/environment","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/network","vs/base/common/arrays","vs/base/common/types","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/process","vs/base/common/json","os","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/jsonEdit","vs/base/common/map","vs/base/common/extpath","child_process","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/instantiation/common/extensions","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensions/node/extensionHostStarter","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(X){for(var e=[],R=0,L=X.length;R<L;R++)e[R]=te[X[R]];return e};define(te[102],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function R(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=R}),define(te[67],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const R=Object.prototype.hasOwnProperty;function L(I){const E=[];for(let d in I)R.call(I,d)&&E.push(I[d]);return E}e.values=L;function D(I,E){for(let d in I)if(R.call(I,d)&&E({key:d,value:I[d]},function(){delete I[d]})===!1)return}e.forEach=D;function k(I,E){const d=Object.create(null);for(const p of I){const h=E(p);let b=d[h];b||(b=d[h]=[]),b.push(p)}return d}e.groupBy=k;function i(I){const E=Object.create(null);return I&&I.forEach((d,p)=>{E[p]=d}),E}e.fromMap=i;function P(I,E){const d=[],p=[];for(let h of I)E.has(h)||d.push(h);for(let h of E)I.has(h)||p.push(h);return{removed:d,added:p}}e.diffSets=P;function w(I,E){const d=[],p=[];for(let[h,b]of I)E.has(h)||d.push(b);for(let[h,b]of E)I.has(h)||p.push(b);return{removed:d,added:p}}e.diffMaps=w;class C{constructor(){this.map=new Map}add(E,d){let p=this.map.get(E);p||(p=new Set,this.map.set(E,p)),p.add(d)}delete(E,d){const p=this.map.get(E);!p||(p.delete(d),p.size===0&&this.map.delete(E))}forEach(E,d){const p=this.map.get(E);!p||p.forEach(d)}}e.SetMap=C}),define(te[68],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(i){return(P,w,C)=>{let I=null,E=null;if(typeof C.value=="function"?(I="value",E=C.value):typeof C.get=="function"&&(I="get",E=C.get),!E)throw new Error("not supported");C[I]=i(E,w)}}e.createDecorator=R;function L(i,P,w){let C=null,I=null;if(typeof w.value=="function"?(C="value",I=w.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(C="get",I=w.get),!I)throw new Error("not supported");const E=`$memoize$${P}`;w[C]=function(...d){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[E]}}e.memoize=L;function D(i,P,w){return R((C,I)=>{const E=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...p){this[d]||(this[d]=w?w():void 0),clearTimeout(this[E]),P&&(this[d]=P(this[d],...p),p=[this[d]]),this[E]=setTimeout(()=>{C.apply(this,p),this[d]=w?w():void 0},i)}})}e.debounce=D;function k(i,P,w){return R((C,I)=>{const E=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,p=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...b){if(this[d]||(this[d]=w?w():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...b)),this[h])return;const y=this[p]+i;y<=Date.now()?(this[p]=Date.now(),C.apply(this,[this[d]]),this[d]=w?w():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),C.apply(this,[this[d]]),this[d]=w?w():void 0},y-Date.now()))}})}e.throttle=k}),define(te[8],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(o=>{o(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=R,e.errorHandler=new R;function L(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=L;function D(u){w(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=D;function k(u){w(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=k;function i(u){if(u instanceof Error){let{name:r,message:o}=u;const n=u.stacktrace||u.stack;return{$isError:!0,name:r,message:o,stack:n}}return u}e.transformErrorForSerialization=i;const P="Canceled";function w(u){return u instanceof Error&&u.name===P&&u.message===P}e.isPromiseCanceledError=w;class C extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=C;function I(){const u=new Error(P);return u.name=u.message,u}e.canceled=I;function E(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=E;function d(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=d;function p(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(u){const r=new Error(`${u} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function b(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=b;class y extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=y;class m extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=m;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function f(u){const r=u;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=f;function a(u,r=Object.create(null)){const o=new Error(u);return r.actions&&(o.actions=r.actions),o}e.createErrorWithActions=a}),define(te[16],ne([0,1,8]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(F,B=0){return F[F.length-(1+B)]}e.tail=L;function D(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=D;function k(F,B,V=(Q,Z)=>Q===Z){if(F===B)return!0;if(!F||!B||F.length!==B.length)return!1;for(let Q=0,Z=F.length;Q<Z;Q++)if(!V(F[Q],B[Q]))return!1;return!0}e.equals=k;function i(F,B,V){let Q=0,Z=F.length-1;for(;Q<=Z;){const G=(Q+Z)/2|0,H=V(F[G],B);if(H<0)Q=G+1;else if(H>0)Z=G-1;else return G}return-(Q+1)}e.binarySearch=i;function P(F,B){let V=0,Q=F.length;if(Q===0)return 0;for(;V<Q;){const Z=Math.floor((V+Q)/2);B(F[Z])?Q=Z:V=Z+1}return V}e.findFirstInSorted=P;function w(F,B,V){if(F=F|0,F>=B.length)throw new TypeError("invalid index");let Q=B[Math.floor(B.length*Math.random())],Z=[],G=[],H=[];for(let re of B){const ie=V(re,Q);ie<0?Z.push(re):ie>0?G.push(re):H.push(re)}return F<Z.length?w(F,Z,V):F<Z.length+H.length?H[0]:w(F-(Z.length+H.length),G,V)}e.quickSelect=w;function C(F,B){const V=[];let Q;for(const Z of F.slice(0).sort(B))!Q||B(Q[0],Z)!==0?(Q=[Z],V.push(Q)):Q.push(Z);return V}e.groupBy=C;function I(F,B,V){const Q=[];function Z(re,ie,ce){if(ie===0&&ce.length===0)return;const le=Q[Q.length-1];le&&le.start+le.deleteCount===re?(le.deleteCount+=ie,le.toInsert.push(...ce)):Q.push({start:re,deleteCount:ie,toInsert:ce})}let G=0,H=0;for(;;){if(G===F.length){Z(G,0,B.slice(H));break}if(H===B.length){Z(G,F.length-G,[]);break}const re=F[G],ie=B[H],ce=V(re,ie);ce===0?(G+=1,H+=1):ce<0?(Z(G,1,[]),G+=1):ce>0&&(Z(G,0,[ie]),H+=1)}return Q}e.sortedDiff=I;function E(F,B,V){const Q=I(F,B,V),Z=[],G=[];for(const H of Q)Z.push(...F.slice(H.start,H.start+H.deleteCount)),G.push(...H.toInsert);return{removed:Z,added:G}}e.delta=E;function d(F,B,V){if(V===0)return[];const Q=F.slice(0,V).sort(B);return h(F,B,Q,V,F.length),Q}e.top=d;function p(F,B,V,Q,Z){return V===0?Promise.resolve([]):new Promise((G,H)=>{(async()=>{const re=F.length,ie=F.slice(0,V).sort(B);for(let ce=V,le=Math.min(V+Q,re);ce<re;ce=le,le=Math.min(le+Q,re)){if(ce>V&&await new Promise(fe=>setTimeout(fe)),Z&&Z.isCancellationRequested)throw(0,R.canceled)();h(F,B,ie,ce,le)}return ie})().then(G,H)})}e.topAsync=p;function h(F,B,V,Q,Z){for(const G=V.length;Q<Z;Q++){const H=F[Q];if(B(H,V[G-1])<0){V.pop();const re=P(V,ie=>B(H,ie)<0);V.splice(re,0,H)}}}function b(F){return F.filter(B=>!!B)}e.coalesce=b;function y(F){let B=0;for(let V=0;V<F.length;V++)F[V]&&(F[B]=F[V],B+=1);F.length=B}e.coalesceInPlace=y;function m(F,B,V){F.splice(V,0,F.splice(B,1)[0])}e.move=m;function S(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=S;function f(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=f;function a(F,B=V=>V){const V=new Set;return F.filter(Q=>{const Z=B(Q);return V.has(Z)?!1:(V.add(Z),!0)})}e.distinct=a;function u(F){const B=Object.create(null);return V=>{const Q=F(V);return B[Q]?!1:(B[Q]=!0,!0)}}e.uniqueFilter=u;function r(F,B){const V=o(F,B);if(V!==-1)return F[V]}e.findLast=r;function o(F,B){for(let V=F.length-1;V>=0;V--){const Q=F[V];if(B(Q))return V}return-1}e.lastIndex=o;function n(F,B){return F.length>0?F[0]:B}e.firstOrDefault=n;function t(F,B,V=(Q,Z)=>Q===Z){let Q=0;for(let Z=0,G=Math.min(F.length,B.length);Z<G&&V(F[Z],B[Z]);Z++)Q++;return Q}e.commonPrefixLength=t;function s(F){return[].concat(...F)}e.flatten=s;function c(F,B){let V=typeof B=="number"?F:0;typeof B=="number"?V=F:(V=0,B=F);const Q=[];if(V<=B)for(let Z=V;Z<B;Z++)Q.push(Z);else for(let Z=V;Z>B;Z--)Q.push(Z);return Q}e.range=c;function l(F,B,V){return F.reduce((Q,Z)=>(Q[B(Z)]=V?V(Z):Z,Q),Object.create(null))}e.index=l;function g(F,B){return F.push(B),()=>v(F,B)}e.insert=g;function v(F,B){const V=F.indexOf(B);if(V>-1)return F.splice(V,1),B}e.remove=v;function T(F,B,V){const Q=F.slice(0,B),Z=F.slice(B);return Q.concat(V,Z)}e.arrayInsert=T;function O(F,B){let V;if(typeof B=="number"){let Q=B;V=()=>{const Z=Math.sin(Q++)*179426549;return Z-Math.floor(Z)}}else V=Math.random;for(let Q=F.length-1;Q>0;Q-=1){const Z=Math.floor(V()*(Q+1)),G=F[Q];F[Q]=F[Z],F[Z]=G}}e.shuffle=O;function U(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.unshift(B))}e.pushToStart=U;function x(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.push(B))}e.pushToEnd=x;function N(F,B){return Array.isArray(F)?F.map(B):B(F)}e.mapArrayOrNot=N;function _(F){return Array.isArray(F)?F:[F]}e.asArray=_;function z(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=z;function A(F,B){for(const V of F){const Q=B(V);if(Q!==void 0)return Q}}e.mapFind=A;function M(F,B,V){const Q=j(F,B),Z=F.length,G=V.length;F.length=Z+G;for(let H=Z-1;H>=Q;H--)F[H+G]=F[H];for(let H=0;H<G;H++)F[H+Q]=V[H]}e.insertInto=M;function q(F,B,V,Q){const Z=j(F,B),G=F.splice(Z,V);return M(F,Z,Q),G}e.splice=q;function j(F,B){return B<0?Math.max(B+F.length,0):Math.min(B,F.length)}function W(F,B){let V=Number.MAX_SAFE_INTEGER,Q=0;return F.forEach((Z,G)=>{const H=B(Z);H<V&&(V=H,Q=G)}),Q}e.minIndex=W;function $(F,B){let V=Number.MIN_SAFE_INTEGER,Q=0;return F.forEach((Z,G)=>{const H=B(Z);H>V&&(V=H,Q=G)}),Q}e.maxIndex=$;class K{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let V=this.firstIdx;for(;V<this.items.length&&B(this.items[V]);)V++;const Q=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,Q}takeFromEndWhile(B){let V=this.lastIdx;for(;V>=0&&B(this.items[V]);)V--;const Q=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,Q}peek(){return this.items[this.firstIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}takeCount(B){const V=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,V}}e.ArrayQueue=K}),define(te[69],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(L){const D=this;let k=!1,i;return function(){return k||(k=!0,i=L.apply(D,arguments)),i}}e.once=R}),define(te[56],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(L){function D(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=D;const k=Object.freeze([]);function i(){return k}L.empty=i;function*P(u){yield u}L.single=P;function w(u){return u||k}L.from=w;function C(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=C;function I(u){return u[Symbol.iterator]().next().value}L.first=I;function E(u,r){for(const o of u)if(r(o))return!0;return!1}L.some=E;function d(u,r){for(const o of u)if(r(o))return o}L.find=d;function*p(u,r){for(const o of u)r(o)&&(yield o)}L.filter=p;function*h(u,r){let o=0;for(const n of u)yield r(n,o++)}L.map=h;function*b(...u){for(const r of u)for(const o of r)yield o}L.concat=b;function*y(u){for(const r of u)for(const o of r)yield o}L.concatNested=y;function m(u,r,o){let n=o;for(const t of u)n=r(n,t);return n}L.reduce=m;function*S(u,r,o=u.length){for(r<0&&(r+=u.length),o<0?o+=u.length:o>u.length&&(o=u.length);r<o;r++)yield u[r]}L.slice=S;function f(u,r=Number.POSITIVE_INFINITY){const o=[];if(r===0)return[o,u];const n=u[Symbol.iterator]();for(let t=0;t<r;t++){const s=n.next();if(s.done)return[o,L.empty()];o.push(s.value)}return[o,{[Symbol.iterator](){return n}}]}L.consume=f;function a(u,r,o=(n,t)=>n===t){const n=u[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=n.next(),c=t.next();if(s.done!==c.done)return!1;if(s.done)return!0;if(!o(s.value,c.value))return!1}}L.equals=a})(R=e.Iterable||(e.Iterable={}))}),define(te[32],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var L;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(r){r.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function i(r,o=!1){let n=0,t=r.length,s="",c=0,l=16,g=0;function v(z){let A=0,M=0;for(;A<z;){const q=r.charCodeAt(n);if(q>=48&&q<=57)M=M*16+q-48;else if(q>=65&&q<=70)M=M*16+q-65+10;else if(q>=97&&q<=102)M=M*16+q-97+10;else break;n++,A++}return A<z&&(M=-1),M}function T(z){n=z,s="",c=0,l=16,g=0}function O(){const z=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&C(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&C(r.charCodeAt(n)))for(n++;n<r.length&&C(r.charCodeAt(n));)n++;else return g=3,r.substring(z,n);let A=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&C(r.charCodeAt(n))){for(n++;n<r.length&&C(r.charCodeAt(n));)n++;A=n}else g=3;return r.substring(z,A)}function U(){let z="",A=n;for(;;){if(n>=t){z+=r.substring(A,n),g=2;break}const M=r.charCodeAt(n);if(M===34){z+=r.substring(A,n),n++;break}if(M===92){if(z+=r.substring(A,n),n++,n>=t){g=2;break}switch(r.charCodeAt(n++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const j=v(4);j>=0?z+=String.fromCharCode(j):g=4;break;default:g=5}A=n;continue}if(M>=0&&M<=31)if(w(M)){z+=r.substring(A,n),g=2;break}else g=6;n++}return z}function x(){if(s="",g=0,c=n,n>=t)return c=t,l=17;let z=r.charCodeAt(n);if(P(z)){do n++,s+=String.fromCharCode(z),z=r.charCodeAt(n);while(P(z));return l=15}if(w(z))return n++,s+=String.fromCharCode(z),z===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),l=14;switch(z){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,s=U(),l=10;case 47:const A=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<t&&!w(r.charCodeAt(n));)n++;return s=r.substring(A,n),l=12}if(r.charCodeAt(n+1)===42){n+=2;const M=t-1;let q=!1;for(;n<M;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,q=!0;break}n++}return q||(n++,g=1),s=r.substring(A,n),l=13}return s+=String.fromCharCode(z),n++,l=16;case 45:if(s+=String.fromCharCode(z),n++,n===t||!C(r.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),l=11;default:for(;n<t&&N(z);)n++,z=r.charCodeAt(n);if(c!==n){switch(s=r.substring(c,n),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(z),n++,l=16}}function N(z){if(P(z)||w(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function _(){let z;do z=x();while(z>=12&&z<=15);return z}return{setPosition:T,getPosition:()=>n,scan:o?_:x,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>g}}e.createScanner=i;function P(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function w(r){return r===10||r===13||r===8232||r===8233}function C(r){return r>=48&&r<=57}var I;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(I||(I={}));function E(r,o){const n=[],t=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function g(v,T,O,U){c.value=v,c.offset=T,c.length=O,c.type=U,c.colonOffset=void 0,s=c}try{f(r,{onObjectBegin:(v,T)=>{if(o<=v)throw t;s=void 0,l=o>v,n.push("")},onObjectProperty:(v,T,O)=>{if(o<T||(g(v,T,O,"property"),n[n.length-1]=v,o<=T+O))throw t},onObjectEnd:(v,T)=>{if(o<=v)throw t;s=void 0,n.pop()},onArrayBegin:(v,T)=>{if(o<=v)throw t;s=void 0,n.push(0)},onArrayEnd:(v,T)=>{if(o<=v)throw t;s=void 0,n.pop()},onLiteralValue:(v,T,O)=>{if(o<T||(g(v,T,O,u(v)),o<=T+O))throw t},onSeparator:(v,T,O)=>{if(o<=T)throw t;if(v===":"&&s&&s.type==="property")s.colonOffset=T,l=!1,s=void 0;else if(v===","){const U=n[n.length-1];typeof U=="number"?n[n.length-1]=U+1:(l=!0,n[n.length-1]=""),s=void 0}}})}catch(v){if(v!==t)throw v}return{path:n,previousNode:s,isAtPropertyKey:l,matches:v=>{let T=0;for(let O=0;T<v.length&&O<n.length;O++)if(v[T]===n[O]||v[T]==="*")T++;else if(v[T]!=="**")return!1;return T===v.length}}}e.getLocation=E;function d(r,o=[],n=k.DEFAULT){let t=null,s=[];const c=[];function l(v){Array.isArray(s)?s.push(v):t!==null&&(s[t]=v)}return f(r,{onObjectBegin:()=>{const v={};l(v),c.push(s),s=v,t=null},onObjectProperty:v=>{t=v},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const v=[];l(v),c.push(s),s=v,t=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:l,onError:(v,T,O)=>{o.push({error:v,offset:T,length:O})}},n),s[0]}e.parse=d;function p(r,o=[],n=k.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){t.type==="property"&&(t.length=v-t.offset,t=t.parent)}function c(v){return t.children.push(v),v}f(r,{onObjectBegin:v=>{t=c({type:"object",offset:v,length:-1,parent:t,children:[]})},onObjectProperty:(v,T,O)=>{t=c({type:"property",offset:T,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:v,offset:T,length:O,parent:t})},onObjectEnd:(v,T)=>{t.length=v+T-t.offset,t=t.parent,s(v+T)},onArrayBegin:(v,T)=>{t=c({type:"array",offset:v,length:-1,parent:t,children:[]})},onArrayEnd:(v,T)=>{t.length=v+T-t.offset,t=t.parent,s(v+T)},onLiteralValue:(v,T,O)=>{c({type:u(v),offset:T,length:O,parent:t,value:v}),s(T+O)},onSeparator:(v,T,O)=>{t.type==="property"&&(v===":"?t.colonOffset=T:v===","&&s(T))},onError:(v,T,O)=>{o.push({error:v,offset:T,length:O})}},n);const g=t.children[0];return g&&delete g.parent,g}e.parseTree=p;function h(r,o){if(!r)return;let n=r;for(let t of o)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===t){n=c.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function b(r){if(!r.parent||!r.parent.children)return[];const o=b(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;o.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&o.push(n)}return o}e.getNodePath=b;function y(r){switch(r.type){case"array":return r.children.map(y);case"object":const o=Object.create(null);for(let n of r.children){const t=n.children[1];t&&(o[n.children[0].value]=y(t))}return o;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=y;function m(r,o,n=!1){return o>=r.offset&&o<r.offset+r.length||n&&o===r.offset+r.length}e.contains=m;function S(r,o,n=!1){if(m(r,o,n)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=o;s++){const c=S(t[s],o,n);if(c)return c}return r}}e.findNodeAtOffset=S;function f(r,o,n=k.DEFAULT){const t=i(r,!1);function s(V){return V?()=>V(t.getTokenOffset(),t.getTokenLength()):()=>!0}function c(V){return V?Q=>V(Q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const l=s(o.onObjectBegin),g=c(o.onObjectProperty),v=s(o.onObjectEnd),T=s(o.onArrayBegin),O=s(o.onArrayEnd),U=c(o.onLiteralValue),x=c(o.onSeparator),N=s(o.onComment),_=c(o.onError),z=n&&n.disallowComments,A=n&&n.allowTrailingComma;function M(){for(;;){const V=t.scan();switch(t.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:z||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(V){case 12:case 13:z?q(10):N();break;case 16:q(1);break;case 15:case 14:break;default:return V}}}function q(V,Q=[],Z=[]){if(_(V),Q.length+Z.length>0){let G=t.getToken();for(;G!==17;){if(Q.indexOf(G)!==-1){M();break}else if(Z.indexOf(G)!==-1)break;G=M()}}}function j(V){const Q=t.getTokenValue();return V?U(Q):g(Q),M(),!0}function W(){switch(t.getToken()){case 11:let V=0;try{V=JSON.parse(t.getTokenValue()),typeof V!="number"&&(q(2),V=0)}catch(Q){q(2)}U(V);break;case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return M(),!0}function $(){return t.getToken()!==10?(q(3,[],[2,5]),!1):(j(!1),t.getToken()===6?(x(":"),M(),B()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function K(){l(),M();let V=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(V||q(4,[],[]),x(","),M(),t.getToken()===2&&A)break}else V&&q(6,[],[]);$()||q(4,[],[2,5]),V=!0}return v(),t.getToken()!==2?q(7,[2],[]):M(),!0}function F(){T(),M();let V=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(V||q(4,[],[]),x(","),M(),t.getToken()===4&&A)break}else V&&q(6,[],[]);B()||q(4,[],[4,5]),V=!0}return O(),t.getToken()!==4?q(8,[4],[]):M(),!0}function B(){switch(t.getToken()){case 3:return F();case 1:return K();case 10:return j(!0);default:return W()}}return M(),t.getToken()===17?n.allowEmptyContent?!0:(q(4,[],[]),!1):B()?(t.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=f;function a(r,o){let n=i(r),t=[],s,c=0,l;do switch(l=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:c!==l&&t.push(r.substring(c,l)),o!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,o)),c=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=a;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(te[48],ne([0,1,32]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(w,C,I){let E,d,p,h,b;if(C){for(h=C.offset,b=h+C.length,p=h;p>0&&!P(w,p-1);)p--;let c=b;for(;c<w.length&&!P(w,c);)c++;d=w.substring(p,c),E=k(d,I)}else d=w,E=0,p=0,h=0,b=w.length;const y=i(I,w);let m=!1,S=0,f;I.insertSpaces?f=D(" ",I.tabSize||4):f="	";const a=(0,R.createScanner)(d,!1);let u=!1;function r(){return y+D(f,E+S)}function o(){let c=a.scan();for(m=!1;c===15||c===14;)m=m||c===14,c=a.scan();return u=c===16||a.getTokenError()!==0,c}const n=[];function t(c,l,g){!u&&l<b&&g>h&&w.substring(l,g)!==c&&n.push({offset:l,length:g-l,content:c})}let s=o();if(s!==17){const c=a.getTokenOffset()+p,l=D(f,E);t(l,p,c)}for(;s!==17;){let c=a.getTokenOffset()+a.getTokenLength()+p,l=o(),g="";for(;!m&&(l===12||l===13);){const T=a.getTokenOffset()+p;t(" ",c,T),c=a.getTokenOffset()+a.getTokenLength()+p,g=l===12?r():"",l=o()}if(l===2)s!==1&&(S--,g=r());else if(l===4)s!==3&&(S--,g=r());else{switch(s){case 3:case 1:S++,g=r();break;case 5:case 12:g=r();break;case 13:m?g=r():g=" ";break;case 6:g=" ";break;case 10:if(l===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?g=" ":l!==5&&l!==17&&(u=!0);break;case 16:u=!0;break}m&&(l===12||l===13)&&(g=r())}const v=a.getTokenOffset()+p;t(g,c,v),s=l}return n}e.format=L;function D(w,C){let I="";for(let E=0;E<C;E++)I+=w;return I}function k(w,C){let I=0,E=0;const d=C.tabSize||4;for(;I<w.length;){const p=w.charAt(I);if(p===" ")E++;else if(p==="	")E+=d;else break;I++}return Math.floor(E/d)}function i(w,C){for(let I=0;I<C.length;I++){const E=C.charAt(I);if(E==="\r")return I+1<C.length&&C.charAt(I+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=i;function P(w,C){return`\r
`.indexOf(w.charAt(C))!==-1}e.isEOL=P}),define(te[40],ne([0,1,32,48]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(C,I,E){return k(C,I,void 0,E)}e.removeProperty=D;function k(C,I,E,d,p){const h=I.slice(),b=[],y=(0,R.parseTree)(C,b);let m,S;for(;h.length>0&&(S=h.pop(),m=(0,R.findNodeAtLocation)(y,h),m===void 0&&E!==void 0);)typeof S=="string"?E={[S]:E}:E=[E];if(m)if(m.type==="object"&&typeof S=="string"&&Array.isArray(m.children)){const f=(0,R.findNodeAtLocation)(m,[S]);if(f!==void 0)if(E===void 0){if(!f.parent)throw new Error("Malformed AST");const a=m.children.indexOf(f.parent);let u,r=f.parent.offset+f.parent.length;if(a>0){const o=m.children[a-1];u=o.offset+o.length}else u=m.offset+1,m.children.length>1&&(r=m.children[1].offset);return i(C,{offset:u,length:r-u,content:""},d)}else return i(C,{offset:f.offset,length:f.length,content:JSON.stringify(E)},d);else{if(E===void 0)return[];const a=`${JSON.stringify(S)}: ${JSON.stringify(E)}`,u=p?p(m.children.map(o=>o.children[0].value)):m.children.length;let r;if(u>0){const o=m.children[u-1];r={offset:o.offset+o.length,length:0,content:","+a}}else m.children.length===0?r={offset:m.offset+1,length:0,content:a}:r={offset:m.offset+1,length:0,content:a+","};return i(C,r,d)}}else if(m.type==="array"&&typeof S=="number"&&Array.isArray(m.children))if(E!==void 0){const f=`${JSON.stringify(E)}`;let a;if(m.children.length===0||S===0)a={offset:m.offset+1,length:0,content:m.children.length===0?f:f+","};else{const u=S===-1||S>m.children.length?m.children.length:S,r=m.children[u-1];a={offset:r.offset+r.length,length:0,content:","+f}}return i(C,a,d)}else{const f=S,a=m.children[f];let u;if(m.children.length===1)u={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===f){const r=m.children[f-1],o=r.offset+r.length,n=m.offset+m.length;u={offset:o,length:n-2-o,content:""}}else u={offset:a.offset,length:m.children[f+1].offset-a.offset,content:""};return i(C,u,d)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${m.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return i(C,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(E)},d)}}e.setProperty=k;function i(C,I,E){let d=P(C,I),p=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;p>0&&!(0,L.isEOL)(d,p-1);)p--;for(;h<d.length&&!(0,L.isEOL)(d,h);)h++}const b=(0,L.format)(d,{offset:p,length:h-p},E);for(let m=b.length-1;m>=0;m--){const S=b[m];d=P(d,S),p=Math.min(p,S.offset),h=Math.max(h,S.offset+S.length),h+=S.content.length-S.length}const y=C.length-(d.length-h)-p;return[{offset:p,length:y,content:d.substring(p,h)}]}e.withFormatting=i;function P(C,I){return C.substring(0,I.offset)+I.content+C.substring(I.offset+I.length)}e.applyEdit=P;function w(C,I){let E=I.slice(0).sort((p,h)=>{const b=p.offset-h.offset;return b===0?p.length-h.length:b}),d=C.length;for(let p=E.length-1;p>=0;p--){let h=E[p];if(h.offset+h.length<=d)C=P(C,h);else throw new Error("Overlapping edit");d=h.offset}return C}e.applyEdits=w}),define(te[2],ne([0,1,69,56]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let k=null;function i(t){k=t}if(e.setDisposableTracker=i,D){const t="__is_disposable_tracked__";i(new class{trackDisposable(s){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(c)},3e3)}setParent(s,c){if(s&&s!==S.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==S.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function P(t){return k?.trackDisposable(t),t}function w(t){k?.markAsDisposed(t)}function C(t,s){k?.setParent(t,s)}function I(t,s){if(!!k)for(const c of t)k.setParent(c,s)}function E(t){return k?.markAsSingleton(t),t}e.markAsSingleton=E;class d extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=d;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function h(t){if(L.Iterable.is(t)){let s=[];for(const c of t)if(c)try{c.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new d(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function b(...t){const s=y(()=>h(t));return I(t,s),s}e.combinedDisposable=b;function y(t){const s=P({dispose:(0,R.once)(()=>{w(s),t()})});return s}e.toDisposable=y;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return C(s,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new m,P(this),C(this._store,this)}dispose(){w(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&C(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&C(s,null),s}}e.MutableDisposable=f;class a{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class u{constructor(){this.references=new Map}acquire(s,...c){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...c)},this.references.set(s,l));const{object:g}=l,v=(0,R.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:g,dispose:v}}}e.ReferenceCollection=u;class r{constructor(s){this.referenceCollection=s}async acquire(s,...c){const l=this.referenceCollection.acquire(s,...c);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(g){throw l.dispose(),g}}}e.AsyncReferenceCollection=r;class o{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=o;function n(t){const s=new m;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(te[103],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(k){this.element=k,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class L{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let k=this._first;for(;k!==R.Undefined;){const i=k.next;k.prev=R.Undefined,k.next=R.Undefined,k=i}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,i){const P=new R(k);if(this._first===R.Undefined)this._first=P,this._last=P;else if(i){const C=this._last;this._last=P,P.prev=C,C.next=P}else{const C=this._first;this._first=P,P.next=C,C.prev=P}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(P))}}shift(){if(this._first!==R.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==R.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==R.Undefined&&k.next!==R.Undefined){const i=k.prev;i.next=k.next,k.next.prev=i}else k.prev===R.Undefined&&k.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):k.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):k.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==R.Undefined;)yield k.element,k=k.next}}e.LinkedList=L}),function(){function X(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function i(w){k.push(w,Date.now())}function P(){const w=[];for(let C=0;C<k.length;C+=2)w.push({name:k[C],startTime:k[C+1]});return w}return{mark:i,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const i of performance.getEntriesByType("mark"))k.push({name:i.name,startTime:Math.round(D+i.startTime)});return k}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=R(L))}(),define(te[4],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const R="en";let L=!1,D=!1,k=!1,i=!1,P=!1,w=!1,C=!1,I,E=R,d,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const b=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=b&&h?.sandboxed,typeof navigator=="object"&&!b)p=navigator.userAgent,L=p.indexOf("Windows")>=0,D=p.indexOf("Macintosh")>=0,C=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=p.indexOf("Linux")>=0,w=!0,I=navigator.language,E=I;else if(typeof h=="object"){L=h.platform==="win32",D=h.platform==="darwin",k=h.platform==="linux",i=k&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,I=R,E=R;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const t=JSON.parse(n),s=t.availableLanguages["*"];I=t.locale,E=s||R,d=t._translationsConfigFile}catch(t){}P=!0}else console.error("Unable to resolve platform.");var y;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(y=e.Platform||(e.Platform={}));function m(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let S=0;D?S=1:L?S=3:k&&(S=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=k,e.isLinuxSnap=i,e.isNative=P,e.isWeb=w,e.isIOS=C,e.platform=S,e.userAgent=p,e.language=E;var f;(function(n){function t(){return e.language}n.value=t;function s(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=s;function c(){return e.language==="en"}n.isDefault=c})(f=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeSetImmediateId)for(let g=0,v=s.length;g<v;g++){const T=s[g];if(T.id===l.data.vscodeSetImmediateId){s.splice(g,1),T.callback();return}}});let c=0;return l=>{const g=++c;s.push({id:g,callback:l}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const t=Promise.resolve();return s=>t.then(s)}();var a;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:L?1:3;let u=!0,r=!1;function o(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,u=new Uint16Array(n.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=o}),define(te[31],ne([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const D=R.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(k){return(0,R.setImmediate)(k)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,R.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(te[10],ne([0,1,31]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,k=90,i=122,P=46,w=47,C=92,I=58,E=63;class d extends Error{constructor(a,u,r){let o;typeof u=="string"&&u.indexOf("not ")===0?(o="must not be",u=u.replace(/^not /,"")):o="must be";const n=a.indexOf(".")!==-1?"property":"argument";let t=`The "${a}" ${n} ${o} of type ${u}`;t+=`. Received type ${typeof r}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function p(f,a){if(typeof f!="string")throw new d(a,"string",f)}function h(f){return f===w||f===C}function b(f){return f===w}function y(f){return f>=L&&f<=k||f>=D&&f<=i}function m(f,a,u,r){let o="",n=0,t=-1,s=0,c=0;for(let l=0;l<=f.length;++l){if(l<f.length)c=f.charCodeAt(l);else{if(r(c))break;c=w}if(r(c)){if(!(t===l-1||s===1))if(s===2){if(o.length<2||n!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const g=o.lastIndexOf(u);g===-1?(o="",n=0):(o=o.slice(0,g),n=o.length-1-o.lastIndexOf(u)),t=l,s=0;continue}else if(o.length!==0){o="",n=0,t=l,s=0;continue}}a&&(o+=o.length>0?`${u}..`:"..",n=2)}else o.length>0?o+=`${u}${f.slice(t+1,l)}`:o=f.slice(t+1,l),n=l-t-1;t=l,s=0}else c===P&&s!==-1?++s:s=-1}return o}function S(f,a){if(a===null||typeof a!="object")throw new d("pathObject","Object",a);const u=a.dir||a.root,r=a.base||`${a.name||""}${a.ext||""}`;return u?u===a.root?`${u}${r}`:`${u}${f}${r}`:r}e.win32={resolve(...f){let a="",u="",r=!1;for(let o=f.length-1;o>=-1;o--){let n;if(o>=0){if(n=f[o],p(n,"path"),n.length===0)continue}else a.length===0?n=R.cwd():(n=R.env[`=${a}`]||R.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==a.toLowerCase()&&n.charCodeAt(2)===C)&&(n=`${a}\\`));const t=n.length;let s=0,c="",l=!1;const g=n.charCodeAt(0);if(t===1)h(g)&&(s=1,l=!0);else if(h(g))if(l=!0,h(n.charCodeAt(1))){let v=2,T=v;for(;v<t&&!h(n.charCodeAt(v));)v++;if(v<t&&v!==T){const O=n.slice(T,v);for(T=v;v<t&&h(n.charCodeAt(v));)v++;if(v<t&&v!==T){for(T=v;v<t&&!h(n.charCodeAt(v));)v++;(v===t||v!==T)&&(c=`\\\\${O}\\${n.slice(T,v)}`,s=v)}}}else s=1;else y(g)&&n.charCodeAt(1)===I&&(c=n.slice(0,2),s=2,t>2&&h(n.charCodeAt(2))&&(l=!0,s=3));if(c.length>0)if(a.length>0){if(c.toLowerCase()!==a.toLowerCase())continue}else a=c;if(r){if(a.length>0)break}else if(u=`${n.slice(s)}\\${u}`,r=l,l&&a.length>0)break}return u=m(u,!r,"\\",h),r?`${a}\\${u}`:`${a}${u}`||"."},normalize(f){p(f,"path");const a=f.length;if(a===0)return".";let u=0,r,o=!1;const n=f.charCodeAt(0);if(a===1)return b(n)?"\\":f;if(h(n))if(o=!0,h(f.charCodeAt(1))){let s=2,c=s;for(;s<a&&!h(f.charCodeAt(s));)s++;if(s<a&&s!==c){const l=f.slice(c,s);for(c=s;s<a&&h(f.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&!h(f.charCodeAt(s));)s++;if(s===a)return`\\\\${l}\\${f.slice(c)}\\`;s!==c&&(r=`\\\\${l}\\${f.slice(c,s)}`,u=s)}}}else u=1;else y(n)&&f.charCodeAt(1)===I&&(r=f.slice(0,2),u=2,a>2&&h(f.charCodeAt(2))&&(o=!0,u=3));let t=u<a?m(f.slice(u),!o,"\\",h):"";return t.length===0&&!o&&(t="."),t.length>0&&h(f.charCodeAt(a-1))&&(t+="\\"),r===void 0?o?`\\${t}`:t:o?`${r}\\${t}`:`${r}${t}`},isAbsolute(f){p(f,"path");const a=f.length;if(a===0)return!1;const u=f.charCodeAt(0);return h(u)||a>2&&y(u)&&f.charCodeAt(1)===I&&h(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let a,u;for(let n=0;n<f.length;++n){const t=f[n];p(t,"path"),t.length>0&&(a===void 0?a=u=t:a+=`\\${t}`)}if(a===void 0)return".";let r=!0,o=0;if(typeof u=="string"&&h(u.charCodeAt(0))){++o;const n=u.length;n>1&&h(u.charCodeAt(1))&&(++o,n>2&&(h(u.charCodeAt(2))?++o:r=!1))}if(r){for(;o<a.length&&h(a.charCodeAt(o));)o++;o>=2&&(a=`\\${a.slice(o)}`)}return e.win32.normalize(a)},relative(f,a){if(p(f,"from"),p(a,"to"),f===a)return"";const u=e.win32.resolve(f),r=e.win32.resolve(a);if(u===r||(f=u.toLowerCase(),a=r.toLowerCase(),f===a))return"";let o=0;for(;o<f.length&&f.charCodeAt(o)===C;)o++;let n=f.length;for(;n-1>o&&f.charCodeAt(n-1)===C;)n--;const t=n-o;let s=0;for(;s<a.length&&a.charCodeAt(s)===C;)s++;let c=a.length;for(;c-1>s&&a.charCodeAt(c-1)===C;)c--;const l=c-s,g=t<l?t:l;let v=-1,T=0;for(;T<g;T++){const U=f.charCodeAt(o+T);if(U!==a.charCodeAt(s+T))break;U===C&&(v=T)}if(T!==g){if(v===-1)return r}else{if(l>g){if(a.charCodeAt(s+T)===C)return r.slice(s+T+1);if(T===2)return r.slice(s+T)}t>g&&(f.charCodeAt(o+T)===C?v=T:T===2&&(v=3)),v===-1&&(v=0)}let O="";for(T=o+v+1;T<=n;++T)(T===n||f.charCodeAt(T)===C)&&(O+=O.length===0?"..":"\\..");return s+=v,O.length>0?`${O}${r.slice(s,c)}`:(r.charCodeAt(s)===C&&++s,r.slice(s,c))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const a=e.win32.resolve(f);if(a.length<=2)return f;if(a.charCodeAt(0)===C){if(a.charCodeAt(1)===C){const u=a.charCodeAt(2);if(u!==E&&u!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(y(a.charCodeAt(0))&&a.charCodeAt(1)===I&&a.charCodeAt(2)===C)return`\\\\?\\${a}`;return f},dirname(f){p(f,"path");const a=f.length;if(a===0)return".";let u=-1,r=0;const o=f.charCodeAt(0);if(a===1)return h(o)?f:".";if(h(o)){if(u=r=1,h(f.charCodeAt(1))){let s=2,c=s;for(;s<a&&!h(f.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&h(f.charCodeAt(s));)s++;if(s<a&&s!==c){for(c=s;s<a&&!h(f.charCodeAt(s));)s++;if(s===a)return f;s!==c&&(u=r=s+1)}}}}else y(o)&&f.charCodeAt(1)===I&&(u=a>2&&h(f.charCodeAt(2))?3:2,r=u);let n=-1,t=!0;for(let s=a-1;s>=r;--s)if(h(f.charCodeAt(s))){if(!t){n=s;break}}else t=!1;if(n===-1){if(u===-1)return".";n=u}return f.slice(0,n)},basename(f,a){a!==void 0&&p(a,"ext"),p(f,"path");let u=0,r=-1,o=!0,n;if(f.length>=2&&y(f.charCodeAt(0))&&f.charCodeAt(1)===I&&(u=2),a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let t=a.length-1,s=-1;for(n=f.length-1;n>=u;--n){const c=f.charCodeAt(n);if(h(c)){if(!o){u=n+1;break}}else s===-1&&(o=!1,s=n+1),t>=0&&(c===a.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=f.length),f.slice(u,r)}for(n=f.length-1;n>=u;--n)if(h(f.charCodeAt(n))){if(!o){u=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":f.slice(u,r)},extname(f){p(f,"path");let a=0,u=-1,r=0,o=-1,n=!0,t=0;f.length>=2&&f.charCodeAt(1)===I&&y(f.charCodeAt(0))&&(a=r=2);for(let s=f.length-1;s>=a;--s){const c=f.charCodeAt(s);if(h(c)){if(!n){r=s+1;break}continue}o===-1&&(n=!1,o=s+1),c===P?u===-1?u=s:t!==1&&(t=1):u!==-1&&(t=-1)}return u===-1||o===-1||t===0||t===1&&u===o-1&&u===r+1?"":f.slice(u,o)},format:S.bind(null,"\\"),parse(f){p(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const u=f.length;let r=0,o=f.charCodeAt(0);if(u===1)return h(o)?(a.root=a.dir=f,a):(a.base=a.name=f,a);if(h(o)){if(r=1,h(f.charCodeAt(1))){let v=2,T=v;for(;v<u&&!h(f.charCodeAt(v));)v++;if(v<u&&v!==T){for(T=v;v<u&&h(f.charCodeAt(v));)v++;if(v<u&&v!==T){for(T=v;v<u&&!h(f.charCodeAt(v));)v++;v===u?r=v:v!==T&&(r=v+1)}}}}else if(y(o)&&f.charCodeAt(1)===I){if(u<=2)return a.root=a.dir=f,a;if(r=2,h(f.charCodeAt(2))){if(u===3)return a.root=a.dir=f,a;r=3}}r>0&&(a.root=f.slice(0,r));let n=-1,t=r,s=-1,c=!0,l=f.length-1,g=0;for(;l>=r;--l){if(o=f.charCodeAt(l),h(o)){if(!c){t=l+1;break}continue}s===-1&&(c=!1,s=l+1),o===P?n===-1?n=l:g!==1&&(g=1):n!==-1&&(g=-1)}return s!==-1&&(n===-1||g===0||g===1&&n===s-1&&n===t+1?a.base=a.name=f.slice(t,s):(a.name=f.slice(t,n),a.base=f.slice(t,s),a.ext=f.slice(n,s))),t>0&&t!==r?a.dir=f.slice(0,t-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let a="",u=!1;for(let r=f.length-1;r>=-1&&!u;r--){const o=r>=0?f[r]:R.cwd();p(o,"path"),o.length!==0&&(a=`${o}/${a}`,u=o.charCodeAt(0)===w)}return a=m(a,!u,"/",b),u?`/${a}`:a.length>0?a:"."},normalize(f){if(p(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===w,u=f.charCodeAt(f.length-1)===w;return f=m(f,!a,"/",b),f.length===0?a?"/":u?"./":".":(u&&(f+="/"),a?`/${f}`:f)},isAbsolute(f){return p(f,"path"),f.length>0&&f.charCodeAt(0)===w},join(...f){if(f.length===0)return".";let a;for(let u=0;u<f.length;++u){const r=f[u];p(r,"path"),r.length>0&&(a===void 0?a=r:a+=`/${r}`)}return a===void 0?".":e.posix.normalize(a)},relative(f,a){if(p(f,"from"),p(a,"to"),f===a||(f=e.posix.resolve(f),a=e.posix.resolve(a),f===a))return"";const u=1,r=f.length,o=r-u,n=1,t=a.length-n,s=o<t?o:t;let c=-1,l=0;for(;l<s;l++){const v=f.charCodeAt(u+l);if(v!==a.charCodeAt(n+l))break;v===w&&(c=l)}if(l===s)if(t>s){if(a.charCodeAt(n+l)===w)return a.slice(n+l+1);if(l===0)return a.slice(n+l)}else o>s&&(f.charCodeAt(u+l)===w?c=l:l===0&&(c=0));let g="";for(l=u+c+1;l<=r;++l)(l===r||f.charCodeAt(l)===w)&&(g+=g.length===0?"..":"/..");return`${g}${a.slice(n+c)}`},toNamespacedPath(f){return f},dirname(f){if(p(f,"path"),f.length===0)return".";const a=f.charCodeAt(0)===w;let u=-1,r=!0;for(let o=f.length-1;o>=1;--o)if(f.charCodeAt(o)===w){if(!r){u=o;break}}else r=!1;return u===-1?a?"/":".":a&&u===1?"//":f.slice(0,u)},basename(f,a){a!==void 0&&p(a,"ext"),p(f,"path");let u=0,r=-1,o=!0,n;if(a!==void 0&&a.length>0&&a.length<=f.length){if(a===f)return"";let t=a.length-1,s=-1;for(n=f.length-1;n>=0;--n){const c=f.charCodeAt(n);if(c===w){if(!o){u=n+1;break}}else s===-1&&(o=!1,s=n+1),t>=0&&(c===a.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=f.length),f.slice(u,r)}for(n=f.length-1;n>=0;--n)if(f.charCodeAt(n)===w){if(!o){u=n+1;break}}else r===-1&&(o=!1,r=n+1);return r===-1?"":f.slice(u,r)},extname(f){p(f,"path");let a=-1,u=0,r=-1,o=!0,n=0;for(let t=f.length-1;t>=0;--t){const s=f.charCodeAt(t);if(s===w){if(!o){u=t+1;break}continue}r===-1&&(o=!1,r=t+1),s===P?a===-1?a=t:n!==1&&(n=1):a!==-1&&(n=-1)}return a===-1||r===-1||n===0||n===1&&a===r-1&&a===u+1?"":f.slice(a,r)},format:S.bind(null,"/"),parse(f){p(f,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return a;const u=f.charCodeAt(0)===w;let r;u?(a.root="/",r=1):r=0;let o=-1,n=0,t=-1,s=!0,c=f.length-1,l=0;for(;c>=r;--c){const g=f.charCodeAt(c);if(g===w){if(!s){n=c+1;break}continue}t===-1&&(s=!1,t=c+1),g===P?o===-1?o=c:l!==1&&(l=1):o!==-1&&(l=-1)}if(t!==-1){const g=n===0&&u?1:n;o===-1||l===0||l===1&&o===t-1&&o===n+1?a.base=a.name=f.slice(g,t):(a.name=f.slice(g,o),a.base=f.slice(g,t),a.ext=f.slice(o,t))}return n>0?a.dir=f.slice(0,n-1):u&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[104],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var L;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(k,...i){const P=i.reduce((I,E)=>(I[E]=!0,I),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(I=>!P[I]).forEach(I=>{for(let E=0;E<w.length;E++)if(I.search(w[E])!==-1){delete k[I];break}})}e.sanitizeProcessEnvironment=D}),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var L in R)(typeof exports=="object"?exports:X)[L]=R[L]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function R(L){if(e[L])return e[L].exports;var D=e[L]={i:L,l:!1,exports:{}};return X[L].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=X,R.c=e,R.d=function(L,D,k){R.o(L,D)||Object.defineProperty(L,D,{enumerable:!0,get:k})},R.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},R.t=function(L,D){if(1&D&&(L=R(L)),8&D||4&D&&typeof L=="object"&&L&&L.__esModule)return L;var k=Object.create(null);if(R.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:L}),2&D&&typeof L!="string")for(var i in L)R.d(k,i,function(P){return L[P]}.bind(null,i));return k},R.n=function(L){var D=L&&L.__esModule?function(){return L.default}:function(){return L};return R.d(D,"a",D),D},R.o=function(L,D){return Object.prototype.hasOwnProperty.call(L,D)},R.p="",R(R.s=0)}([function(X,e,R){(function(L){var D;e=X.exports=Z,D=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,i=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],C=0,I=C++;w[I]="0|[1-9]\\d*";var E=C++;w[E]="[0-9]+";var d=C++;w[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=C++;w[p]="("+w[I]+")\\.("+w[I]+")\\.("+w[I]+")";var h=C++;w[h]="("+w[E]+")\\.("+w[E]+")\\.("+w[E]+")";var b=C++;w[b]="(?:"+w[I]+"|"+w[d]+")";var y=C++;w[y]="(?:"+w[E]+"|"+w[d]+")";var m=C++;w[m]="(?:-("+w[b]+"(?:\\."+w[b]+")*))";var S=C++;w[S]="(?:-?("+w[y]+"(?:\\."+w[y]+")*))";var f=C++;w[f]="[0-9A-Za-z-]+";var a=C++;w[a]="(?:\\+("+w[f]+"(?:\\."+w[f]+")*))";var u=C++,r="v?"+w[p]+w[m]+"?"+w[a]+"?";w[u]="^"+r+"$";var o="[v=\\s]*"+w[h]+w[S]+"?"+w[a]+"?",n=C++;w[n]="^"+o+"$";var t=C++;w[t]="((?:<|>)?=?)";var s=C++;w[s]=w[E]+"|x|X|\\*";var c=C++;w[c]=w[I]+"|x|X|\\*";var l=C++;w[l]="[v=\\s]*("+w[c]+")(?:\\.("+w[c]+")(?:\\.("+w[c]+")(?:"+w[m]+")?"+w[a]+"?)?)?";var g=C++;w[g]="[v=\\s]*("+w[s]+")(?:\\.("+w[s]+")(?:\\.("+w[s]+")(?:"+w[S]+")?"+w[a]+"?)?)?";var v=C++;w[v]="^"+w[t]+"\\s*"+w[l]+"$";var T=C++;w[T]="^"+w[t]+"\\s*"+w[g]+"$";var O=C++;w[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=C++;w[U]="(?:~>?)";var x=C++;w[x]="(\\s*)"+w[U]+"\\s+",P[x]=new RegExp(w[x],"g");var N=C++;w[N]="^"+w[U]+w[l]+"$";var _=C++;w[_]="^"+w[U]+w[g]+"$";var z=C++;w[z]="(?:\\^)";var A=C++;w[A]="(\\s*)"+w[z]+"\\s+",P[A]=new RegExp(w[A],"g");var M=C++;w[M]="^"+w[z]+w[l]+"$";var q=C++;w[q]="^"+w[z]+w[g]+"$";var j=C++;w[j]="^"+w[t]+"\\s*("+o+")$|^$";var W=C++;w[W]="^"+w[t]+"\\s*("+r+")$|^$";var $=C++;w[$]="(\\s*)"+w[t]+"\\s*("+o+"|"+w[l]+")",P[$]=new RegExp(w[$],"g");var K=C++;w[K]="^\\s*("+w[l]+")\\s+-\\s+("+w[l]+")\\s*$";var F=C++;w[F]="^\\s*("+w[g]+")\\s+-\\s+("+w[g]+")\\s*$";var B=C++;w[B]="(<|>)?=?\\s*\\*";for(var V=0;V<35;V++)D(V,w[V]),P[V]||(P[V]=new RegExp(w[V]));function Q(ee,oe){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>k||!(oe?P[n]:P[u]).test(ee))return null;try{return new Z(ee,oe)}catch(ae){return null}}function Z(ee,oe){if(ee instanceof Z){if(ee.loose===oe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof Z))return new Z(ee,oe);D("SemVer",ee,oe),this.loose=oe;var ae=ee.trim().match(oe?P[n]:P[u]);if(!ae)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var ye=+pe;if(ye>=0&&ye<i)return ye}return pe}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ee,oe){var ae=Q(ee,oe);return ae?ae.version:null},e.clean=function(ee,oe){var ae=Q(ee.trim().replace(/^[=v]+/,""),oe);return ae?ae.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return D("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),H(this.major,ee.major)||H(this.minor,ee.minor)||H(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var oe=0;do{var ae=this.prerelease[oe],pe=ee.prerelease[oe];if(D("prerelease compare",oe,ae,pe),ae===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(ae===void 0)return-1;if(ae!==pe)return H(ae,pe)}while(++oe)},Z.prototype.inc=function(ee,oe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,oe,ae,pe){typeof ae=="string"&&(pe=ae,ae=void 0);try{return new Z(ee,ae).inc(oe,pe).version}catch(ye){return null}},e.diff=function(ee,oe){if(le(ee,oe))return null;var ae=Q(ee),pe=Q(oe);if(ae.prerelease.length||pe.prerelease.length){for(var ye in ae)if((ye==="major"||ye==="minor"||ye==="patch")&&ae[ye]!==pe[ye])return"pre"+ye;return"prerelease"}for(var ye in ae)if((ye==="major"||ye==="minor"||ye==="patch")&&ae[ye]!==pe[ye])return ye},e.compareIdentifiers=H;var G=/^[0-9]+$/;function H(ee,oe){var ae=G.test(ee),pe=G.test(oe);return ae&&pe&&(ee=+ee,oe=+oe),ae&&!pe?-1:pe&&!ae?1:ee<oe?-1:ee>oe?1:0}function re(ee,oe,ae){return new Z(ee,ae).compare(new Z(oe,ae))}function ie(ee,oe,ae){return re(ee,oe,ae)>0}function ce(ee,oe,ae){return re(ee,oe,ae)<0}function le(ee,oe,ae){return re(ee,oe,ae)===0}function fe(ee,oe,ae){return re(ee,oe,ae)!==0}function de(ee,oe,ae){return re(ee,oe,ae)>=0}function be(ee,oe,ae){return re(ee,oe,ae)<=0}function Ie(ee,oe,ae,pe){var ye;switch(oe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ae=="object"&&(ae=ae.version),ye=ee===ae;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ae=="object"&&(ae=ae.version),ye=ee!==ae;break;case"":case"=":case"==":ye=le(ee,ae,pe);break;case"!=":ye=fe(ee,ae,pe);break;case">":ye=ie(ee,ae,pe);break;case">=":ye=de(ee,ae,pe);break;case"<":ye=ce(ee,ae,pe);break;case"<=":ye=be(ee,ae,pe);break;default:throw new TypeError("Invalid operator: "+oe)}return ye}function Ee(ee,oe){if(ee instanceof Ee){if(ee.loose===oe)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,oe);D("comparator",ee,oe),this.loose=oe,this.parse(ee),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ee,oe){return H(oe,ee)},e.major=function(ee,oe){return new Z(ee,oe).major},e.minor=function(ee,oe){return new Z(ee,oe).minor},e.patch=function(ee,oe){return new Z(ee,oe).patch},e.compare=re,e.compareLoose=function(ee,oe){return re(ee,oe,!0)},e.rcompare=function(ee,oe,ae){return re(oe,ee,ae)},e.sort=function(ee,oe){return ee.sort(function(ae,pe){return e.compare(ae,pe,oe)})},e.rsort=function(ee,oe){return ee.sort(function(ae,pe){return e.rcompare(ae,pe,oe)})},e.gt=ie,e.lt=ce,e.eq=le,e.neq=fe,e.gte=de,e.lte=be,e.cmp=Ie,e.Comparator=Ee;var _e={};function Pe(ee,oe){if(ee instanceof Pe)return ee.loose===oe?ee:new Pe(ee.raw,oe);if(ee instanceof Ee)return new Pe(ee.value,oe);if(!(this instanceof Pe))return new Pe(ee,oe);if(this.loose=oe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Le(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,oe,ae,pe,ye,Ae,Re,Y,se,ue,ge,me,Ce){return((oe=Le(ae)?"":Le(pe)?">="+ae+".0.0":Le(ye)?">="+ae+"."+pe+".0":">="+oe)+" "+(Y=Le(se)?"":Le(ue)?"<"+(+se+1)+".0.0":Le(ge)?"<"+se+"."+(+ue+1)+".0":me?"<="+se+"."+ue+"."+ge+"-"+me:"<="+Y)).trim()}function Ne(ee,oe){for(var ae=0;ae<ee.length;ae++)if(!ee[ae].test(oe))return!1;if(oe.prerelease.length){for(ae=0;ae<ee.length;ae++)if(D(ee[ae].semver),ee[ae].semver!==_e&&ee[ae].semver.prerelease.length>0){var pe=ee[ae].semver;if(pe.major===oe.major&&pe.minor===oe.minor&&pe.patch===oe.patch)return!0}return!1}return!0}function $e(ee,oe,ae){try{oe=new Pe(oe,ae)}catch(pe){return!1}return oe.test(ee)}function xe(ee,oe,ae,pe){var ye,Ae,Re,Y,se;switch(ee=new Z(ee,pe),oe=new Pe(oe,pe),ae){case">":ye=ie,Ae=be,Re=ce,Y=">",se=">=";break;case"<":ye=ce,Ae=de,Re=ie,Y="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(ee,oe,pe))return!1;for(var ue=0;ue<oe.set.length;++ue){var ge=oe.set[ue],me=null,Ce=null;if(ge.forEach(function(ke){ke.semver===_e&&(ke=new Ee(">=0.0.0")),me=me||ke,Ce=Ce||ke,ye(ke.semver,me.semver,pe)?me=ke:Re(ke.semver,Ce.semver,pe)&&(Ce=ke)}),me.operator===Y||me.operator===se||(!Ce.operator||Ce.operator===Y)&&Ae(ee,Ce.semver)||Ce.operator===se&&Re(ee,Ce.semver))return!1}return!0}Ee.prototype.parse=function(ee){var oe=this.loose?P[j]:P[W],ae=ee.match(oe);if(!ae)throw new TypeError("Invalid comparator: "+ee);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new Z(ae[2],this.loose):this.semver=_e},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return D("Comparator.test",ee,this.loose),this.semver===_e||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Ie(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,oe){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new Pe(ee.value,oe),$e(this.value,ae,oe);if(ee.operator==="")return ae=new Pe(this.value,oe),$e(ee.semver,ae,oe);var pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Ae=this.semver.version===ee.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Y=Ie(this.semver,"<",ee.semver,oe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),se=Ie(this.semver,">",ee.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return pe||ye||Ae&&Re||Y||se},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ee){var oe=this.loose;ee=ee.trim(),D("range",ee,oe);var ae=oe?P[F]:P[K];ee=ee.replace(ae,Fe),D("hyphen replace",ee),ee=ee.replace(P[$],"$1$2$3"),D("comparator trim",ee,P[$]),ee=(ee=(ee=ee.replace(P[x],"$1~")).replace(P[A],"$1^")).split(/\s+/).join(" ");var pe=oe?P[j]:P[W],ye=ee.split(" ").map(function(Ae){return function(Re,Y){return D("comp",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ce){D("caret",me,Ce);var ke=Ce?P[q]:P[M];return me.replace(ke,function(Te,Se,we,De,Oe){var Me;return D("caret",me,Te,Se,we,De,Oe),Le(Se)?Me="":Le(we)?Me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Le(De)?Me=Se==="0"?">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+".0 <"+(+Se+1)+".0.0":Oe?(D("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=Se==="0"?we==="0"?">="+Se+"."+we+"."+De+Oe+" <"+Se+"."+we+"."+(+De+1):">="+Se+"."+we+"."+De+Oe+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+De+Oe+" <"+(+Se+1)+".0.0"):(D("no pr"),Me=Se==="0"?we==="0"?">="+Se+"."+we+"."+De+" <"+Se+"."+we+"."+(+De+1):">="+Se+"."+we+"."+De+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+De+" <"+(+Se+1)+".0.0"),D("caret return",Me),Me})}(ge,ue)}).join(" ")}(Re,Y),D("caret",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ce){var ke=Ce?P[_]:P[N];return me.replace(ke,function(Te,Se,we,De,Oe){var Me;return D("tilde",me,Te,Se,we,De,Oe),Le(Se)?Me="":Le(we)?Me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Le(De)?Me=">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":Oe?(D("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=">="+Se+"."+we+"."+De+Oe+" <"+Se+"."+(+we+1)+".0"):Me=">="+Se+"."+we+"."+De+" <"+Se+"."+(+we+1)+".0",D("tilde return",Me),Me})}(ge,ue)}).join(" ")}(Re,Y),D("tildes",Re),Re=function(se,ue){return D("replaceXRanges",se,ue),se.split(/\s+/).map(function(ge){return function(me,Ce){me=me.trim();var ke=Ce?P[T]:P[v];return me.replace(ke,function(Te,Se,we,De,Oe,Me){D("xRange",me,Te,Se,we,De,Oe,Me);var Qe=Le(we),Ye=Qe||Le(De),We=Ye||Le(Oe);return Se==="="&&We&&(Se=""),Qe?Te=Se===">"||Se==="<"?"<0.0.0":"*":Se&&We?(Ye&&(De=0),We&&(Oe=0),Se===">"?(Se=">=",Ye?(we=+we+1,De=0,Oe=0):We&&(De=+De+1,Oe=0)):Se==="<="&&(Se="<",Ye?we=+we+1:De=+De+1),Te=Se+we+"."+De+"."+Oe):Ye?Te=">="+we+".0.0 <"+(+we+1)+".0.0":We&&(Te=">="+we+"."+De+".0 <"+we+"."+(+De+1)+".0"),D("xRange return",Te),Te})}(ge,ue)}).join(" ")}(Re,Y),D("xrange",Re),Re=function(se,ue){return D("replaceStars",se,ue),se.trim().replace(P[B],"")}(Re,Y),D("stars",Re),Re}(Ae,oe)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(Ae){return!!Ae.match(pe)})),ye=ye.map(function(Ae){return new Ee(Ae,oe)})},Pe.prototype.intersects=function(ee,oe){if(!(ee instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(pe){return ee.set.some(function(ye){return ye.every(function(Ae){return pe.intersects(Ae,oe)})})})})},e.toComparators=function(ee,oe){return new Pe(ee,oe).set.map(function(ae){return ae.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var oe=0;oe<this.set.length;oe++)if(Ne(this.set[oe],ee))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(ee,oe,ae){var pe=null,ye=null;try{var Ae=new Pe(oe,ae)}catch(Re){return null}return ee.forEach(function(Re){Ae.test(Re)&&(pe&&ye.compare(Re)!==-1||(ye=new Z(pe=Re,ae)))}),pe},e.minSatisfying=function(ee,oe,ae){var pe=null,ye=null;try{var Ae=new Pe(oe,ae)}catch(Re){return null}return ee.forEach(function(Re){Ae.test(Re)&&(pe&&ye.compare(Re)!==1||(ye=new Z(pe=Re,ae)))}),pe},e.validRange=function(ee,oe){try{return new Pe(ee,oe).range||"*"}catch(ae){return null}},e.ltr=function(ee,oe,ae){return xe(ee,oe,"<",ae)},e.gtr=function(ee,oe,ae){return xe(ee,oe,">",ae)},e.outside=xe,e.prerelease=function(ee,oe){var ae=Q(ee,oe);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(ee,oe,ae){return ee=new Pe(ee,ae),oe=new Pe(oe,ae),ee.intersects(oe)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var oe=ee.match(P[O]);return oe==null?null:Q((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,R(1))},function(X,e){var R,L,D=X.exports={};function k(){throw new Error("setTimeout has not been defined")}function i(){throw new Error("clearTimeout has not been defined")}function P(y){if(R===setTimeout)return setTimeout(y,0);if((R===k||!R)&&setTimeout)return R=setTimeout,setTimeout(y,0);try{return R(y,0)}catch(m){try{return R.call(null,y,0)}catch(S){return R.call(this,y,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:k}catch(y){R=k}try{L=typeof clearTimeout=="function"?clearTimeout:i}catch(y){L=i}})();var w,C=[],I=!1,E=-1;function d(){I&&w&&(I=!1,w.length?C=w.concat(C):E=-1,C.length&&p())}function p(){if(!I){var y=P(d);I=!0;for(var m=C.length;m;){for(w=C,C=[];++E<m;)w&&w[E].run();E=-1,m=C.length}w=null,I=!1,function(S){if(L===clearTimeout)return clearTimeout(S);if((L===i||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(S);try{L(S)}catch(f){try{return L.call(null,S)}catch(a){return L.call(this,S)}}}(y)}}function h(y,m){this.fun=y,this.array=m}function b(){}D.nextTick=function(y){var m=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)m[S-1]=arguments[S];C.push(new h(y,m)),C.length!==1||I||P(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=b,D.addListener=b,D.once=b,D.off=b,D.removeListener=b,D.removeAllListeners=b,D.emit=b,D.prependListener=b,D.prependOnceListener=b,D.listeners=function(y){return[]},D.binding=function(y){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(y){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[105],ne([0,1]),function(X,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class L{constructor(P,w,C){this.level=P,this.key=w,this.value=C,this.forward=[]}}const D=void 0;class k{constructor(P,w=2**16){this.comparator=P,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(w)|0),this._header=new L(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new L(this._maxLevel,D,D)}has(P){return Boolean(k._search(this,P,this.comparator))}get(P){return k._search(this,P,this.comparator)?.value}set(P,w){return k._insert(this,P,w,this.comparator)&&(this._size+=1),this}delete(P){const w=k._delete(this,P,this.comparator);return w&&(this._size-=1),w}forEach(P,w){let C=this._header.forward[0];for(;C;)P.call(w,C.value,C.key,this),C=C.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",w=this._header.forward[0];for(;w;)P+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return P}static _search(P,w,C){let I=P._header;for(let E=P._level-1;E>=0;E--)for(;I.forward[E]&&C(I.forward[E].key,w)<0;)I=I.forward[E];if(I=I.forward[0],I&&C(I.key,w)===0)return I}static _insert(P,w,C,I){let E=[],d=P._header;for(let p=P._level-1;p>=0;p--){for(;d.forward[p]&&I(d.forward[p].key,w)<0;)d=d.forward[p];E[p]=d}if(d=d.forward[0],d&&I(d.key,w)===0)return d.value=C,!1;{let p=k._randomLevel(P);if(p>P._level){for(let h=P._level;h<p;h++)E[h]=P._header;P._level=p}d=new L(p,w,C);for(let h=0;h<p;h++)d.forward[h]=E[h].forward[h],E[h].forward[h]=d;return!0}}static _randomLevel(P,w=.5){let C=1;for(;Math.random()<w&&C<P._maxLevel;)C+=1;return C}static _delete(P,w,C){let I=[],E=P._header;for(let d=P._level-1;d>=0;d--){for(;E.forward[d]&&C(E.forward[d].key,w)<0;)E=E.forward[d];I[d]=E}if(E=E.forward[0],!E||C(E.key,w)!==0)return!1;for(let d=0;d<P._level&&I[d].forward[d]===E;d++)I[d].forward[d]=E.forward[d];for(;P._level>0&&P._header.forward[P._level-1]===D;)P._level-=1;return!0}}e.SkipList=k}),define(te[70],ne([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(i){this._highResolution=L&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new D(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[3],ne([0,1,8,69,2,103,70]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(a){a.None=()=>D.Disposable.None;function u(A){return(M,q=null,j)=>{let W=!1,$;return $=A(K=>{if(!W)return $?$.dispose():W=!0,M.call(q,K)},null,j),W&&$.dispose(),$}}a.once=u;function r(A,M){return l((q,j=null,W)=>A($=>q.call(j,M($)),null,W))}a.map=r;function o(A,M){return l((q,j=null,W)=>A($=>{M($),q.call(j,$)},null,W))}a.forEach=o;function n(A,M){return l((q,j=null,W)=>A($=>M($)&&q.call(j,$),null,W))}a.filter=n;function t(A){return A}a.signal=t;function s(...A){return(M,q=null,j)=>(0,D.combinedDisposable)(...A.map(W=>W($=>M.call(q,$),null,j)))}a.any=s;function c(A,M,q){let j=q;return r(A,W=>(j=M(j,W),j))}a.reduce=c;function l(A){let M;const q=new d({onFirstListenerAdd(){M=A(q.fire,q)},onLastListenerRemove(){M.dispose()}});return q.event}function g(A,M,q=100,j=!1,W){let $,K,F,B=0;const V=new d({leakWarningThreshold:W,onFirstListenerAdd(){$=A(Q=>{B++,K=M(K,Q),j&&!F&&(V.fire(K),K=void 0),clearTimeout(F),F=setTimeout(()=>{const Z=K;K=void 0,F=void 0,(!j||B>1)&&V.fire(Z),B=0},q)})},onLastListenerRemove(){$.dispose()}});return V.event}a.debounce=g;function v(A,M=(q,j)=>q===j){let q=!0,j;return n(A,W=>{const $=q||!M(W,j);return q=!1,j=W,$})}a.latch=v;function T(A,M){return[a.filter(A,M),a.filter(A,q=>!M(q))]}a.split=T;function O(A,M=!1,q=[]){let j=q.slice(),W=A(F=>{j?j.push(F):K.fire(F)});const $=()=>{j&&j.forEach(F=>K.fire(F)),j=null},K=new d({onFirstListenerAdd(){W||(W=A(F=>K.fire(F)))},onFirstListenerDidAdd(){j&&(M?setTimeout($):$())},onLastListenerRemove(){W&&W.dispose(),W=null}});return K.event}a.buffer=O;class U{constructor(M){this.event=M}map(M){return new U(r(this.event,M))}forEach(M){return new U(o(this.event,M))}filter(M){return new U(n(this.event,M))}reduce(M,q){return new U(c(this.event,M,q))}latch(){return new U(v(this.event))}debounce(M,q=100,j=!1,W){return new U(g(this.event,M,q,j,W))}on(M,q,j){return this.event(M,q,j)}once(M,q,j){return u(this.event)(M,q,j)}}function x(A){return new U(A)}a.chain=x;function N(A,M,q=j=>j){const j=(...F)=>K.fire(q(...F)),W=()=>A.on(M,j),$=()=>A.removeListener(M,j),K=new d({onFirstListenerAdd:W,onLastListenerRemove:$});return K.event}a.fromNodeEventEmitter=N;function _(A,M,q=j=>j){const j=(...F)=>K.fire(q(...F)),W=()=>A.addEventListener(M,j),$=()=>A.removeEventListener(M,j),K=new d({onFirstListenerAdd:W,onLastListenerRemove:$});return K.event}a.fromDOMEventEmitter=_;function z(A){return new Promise(M=>u(A)(M))}a.toPromise=z})(P=e.Event||(e.Event={}));class w{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${w._idPool++}`}start(u){this._stopWatch=new i.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let C=-1;function I(a){const u=C;return C=a,{dispose(){C=u}}}e.setGlobalLeakWarningThreshold=I;class E{constructor(u,r=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let r=C;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||u<r)return;this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(o)||0;if(this._stacks.set(o,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[c,l]of this._stacks)(!t||s<l)&&(t=c,s=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}class d{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=C>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(u,r,o)=>{this._listeners||(this._listeners=new k.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[u,r]:u);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,r);const s=this._leakageMon?.check(this._listeners.size),c=(0,D.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return o instanceof D.DisposableStore?o.add(c):Array.isArray(o)&&o.push(c),c}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,o]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(n){(0,R.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class p extends d{async fireAsync(u,r,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,u]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),s=[],c={...t,waitUntil:l=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");o&&(l=o(l,typeof n=="function"?n:n[0])),s.push(l)}};try{typeof n=="function"?n.call(void 0,c):n[0].call(n[1],c)}catch(l){(0,R.onUnexpectedError)(l);continue}Object.freeze(s),await Promise.allSettled(s).then(l=>{for(const g of l)g.status==="rejected"&&(0,R.onUnexpectedError)(g.reason)})}}}}e.AsyncEmitter=p;class h extends d{constructor(u){super(u);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=h;class b extends h{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=b;class y extends d{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const r={event:u,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const o=()=>{this.hasListeners&&this.unhook(r);const n=this.events.indexOf(r);this.events.splice(n,1)};return(0,D.toDisposable)((0,L.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(r=>this.emitter.fire(r))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class S{constructor(){this.buffers=[]}wrapEvent(u){return(r,o,n)=>u(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(o,t)):r.call(o,t)},void 0,n)}bufferEvents(u){const r=[];this.buffers.push(r);const o=u();return this.buffers.pop(),r.forEach(n=>n()),o}}e.EventBufferer=S;class f{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=D.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=f}),define(te[27],ne([0,1,3]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(P,w){const C=setTimeout(P.bind(w),0);return{dispose(){clearTimeout(C)}}});var D;(function(P){function w(C){return C===P.None||C===P.Cancelled||C instanceof k?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}P.isCancellationToken=w,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=D.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=i}),define(te[49],ne([0,1,3]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new R.Emitter}add(I){const E=this._icons.get(I.id);E?I.description?E.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function k(C){return C?C.replace(/\$\((.*?)\)/g,(I,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=k;class i{constructor(I,E,d){this.id=I,this.definition=E,this.description=d,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function P(C,I){const E=["codicon","codicon-"+C];return I&&E.push("codicon-modifier-"+I),E}e.getClassNamesArray=P;var w;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function E(h){if(h instanceof i)return["codicon","codicon-"+h.id];const b=I.exec(h.id);if(!b)return E(i.error);let[,y,m]=b;const S=["codicon","codicon-"+y];return m&&S.push("codicon-modifier-"+m.substr(1)),S}C.asClassNameArray=E;function d(h){return E(h).join(" ")}C.asClassName=d;function p(h){return"."+E(h).join(".")}C.asCSSSelector=p})(w=e.CSSIcon||(e.CSSIcon={}))}),define(te[50],ne([0,1,8,2]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(f){const a=f;return a?[a.on,a.pause,a.resume,a.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=D;function k(f){const a=f;return a?D(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=k;function i(f,a){return new P(f,a)}e.newWriteableStream=i;class P{constructor(a,u){this.reducer=a,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(u=>u(a))}emitError(a){this.listeners.error.length===0?(0,R.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(u=>u(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,u){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(a,u){if(this.state.destroyed)return;let r;switch(a){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const o=r.indexOf(u);o>=0&&r.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(f,a){const u=[];let r;for(;(r=f.read())!==null;)u.push(r);return a(u)}e.consumeReadable=w;function C(f,a,u){const r=[];let o;for(;(o=f.read())!==null&&r.length<u;)r.push(o);return o===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof o!="undefined"){const n=o;return o=void 0,n}return f.read()}}}e.peekReadable=C;function I(f,a){return new Promise((u,r)=>{const o=[];E(f,{onData:n=>{a&&o.push(n)},onError:n=>{a?r(n):u(void 0)},onEnd:()=>{u(a?a(o):void 0)}})})}e.consumeStream=I;function E(f,a){f.on("error",u=>a.onError(u)),f.on("end",()=>a.onEnd()),f.on("data",u=>a.onData(u))}e.listenStream=E;function d(f,a){return new Promise((u,r)=>{const o=new L.DisposableStore,n=[],t=l=>{if(n.push(l),n.length>a)return o.dispose(),f.pause(),u({stream:f,buffer:n,ended:!1})},s=l=>r(l),c=()=>u({stream:f,buffer:n,ended:!0});o.add((0,L.toDisposable)(()=>f.removeListener("error",s))),f.on("error",s),o.add((0,L.toDisposable)(()=>f.removeListener("end",c))),f.on("end",c),o.add((0,L.toDisposable)(()=>f.removeListener("data",t))),f.on("data",t)})}e.peekStream=d;function p(f,a){const u=i(a);return u.end(f),u}e.toStream=p;function h(){const f=i(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=h;function b(f){let a=!1;return{read:()=>a?null:(a=!0,f)}}e.toReadable=b;function y(f,a,u){const r=i(u);return E(f,{onData:o=>r.write(a.data(o)),onError:o=>r.error(a.error?a.error(o):o),onEnd:()=>r.end()}),r}e.transform=y;function m(f,a,u){let r=!1;return{read:()=>{const o=a.read();return r?o:(r=!0,o!==null?u([f,o]):f)}}}e.prefixedReadable=m;function S(f,a,u){let r=!1;const o=i(u);return E(a,{onData:n=>r?o.write(n):(r=!0,o.write(u([f,n]))),onError:n=>o.error(n),onEnd:()=>{r||(r=!0,o.write(f)),o.end()}}),o}e.prefixedStream=S}),define(te[19],ne([0,1,50]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,k;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&L?new i(Buffer.from(t)):(D||(D=new TextEncoder),new i(D.encode(t)))}static concat(t,s){if(typeof s=="undefined"){s=0;for(let g=0,v=t.length;g<v;g++)s+=t[g].byteLength}const c=i.alloc(s);let l=0;for(let g=0,v=t.length;g<v;g++){const T=t[g];c.set(T,l),l+=T.byteLength}return c}toString(){return L?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(t,s){return new i(this.buffer.subarray(t,s))}set(t,s){t instanceof i?this.buffer.set(t.buffer,s):this.buffer.set(t,s)}readUInt32BE(t){return C(this.buffer,t)}writeUInt32BE(t,s){I(this.buffer,t,s)}readUInt32LE(t){return E(this.buffer,t)}writeUInt32LE(t,s){d(this.buffer,t,s)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,s){h(this.buffer,t,s)}}e.VSBuffer=i;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=P;function w(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255}e.writeUInt16LE=w;function C(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=C;function I(n,t,s){n[s+3]=t,t=t>>>8,n[s+2]=t,t=t>>>8,n[s+1]=t,t=t>>>8,n[s]=t}e.writeUInt32BE=I;function E(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=E;function d(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255,t=t>>>8,n[s+2]=t&255,t=t>>>8,n[s+3]=t&255}e.writeUInt32LE=d;function p(n,t){return n[t]}e.readUInt8=p;function h(n,t,s){n[s]=t}e.writeUInt8=h;function b(n){return R.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=b;function y(n){return R.toReadable(n)}e.bufferToReadable=y;function m(n){return R.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=m;async function S(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=S;function f(n){return R.toStream(n,t=>i.concat(t))}e.bufferToStream=f;function a(n){return R.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=a;function u(n){return R.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=u;function r(n,t){return R.prefixedReadable(n,t,s=>i.concat(s))}e.prefixedBufferReadable=r;function o(n,t){return R.prefixedStream(n,t,s=>i.concat(s))}e.prefixedBufferStream=o}),define(te[25],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=R;const L=/{(\d+)}/g;function D(Y,...se){return se.length===0?Y:Y.replace(L,function(ue,ge){const me=parseInt(ge,10);return isNaN(me)||me<0||me>=se.length?ue:se[me]})}e.format=D;const k=/{([^}]+)}/g;function i(Y,se){return Y.replace(k,(ue,ge)=>se[ge]??ue)}e.format2=i;function P(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function w(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function C(Y,se){let ue=0;const ge=se.charCodeAt(0);for(let me=Y.length-1;me>=0;me--)Y.charCodeAt(me)===ge&&ue++;return ue}e.count=C;function I(Y,se,ue="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${ue}`}e.truncate=I;function E(Y,se=" "){const ue=d(Y,se);return p(ue,se)}e.trim=E;function d(Y,se){if(!Y||!se)return Y;const ue=se.length;if(ue===0||Y.length===0)return Y;let ge=0;for(;Y.indexOf(se,ge)===ge;)ge=ge+ue;return Y.substring(ge)}e.ltrim=d;function p(Y,se){if(!Y||!se)return Y;const ue=se.length,ge=Y.length;if(ue===0||ge===0)return Y;let me=ge,Ce=-1;for(;Ce=Y.lastIndexOf(se,me-1),!(Ce===-1||Ce+ue!==me);){if(Ce===0)return"";me=Ce}return Y.substring(0,me)}e.rtrim=p;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function b(Y){return Y.replace(/\*/g,"")}e.stripWildcards=b;function y(Y,se,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=w(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ge="";return ue.global&&(ge+="g"),ue.matchCase||(ge+="i"),ue.multiline&&(ge+="m"),ue.unicode&&(ge+="u"),new RegExp(Y,ge)}e.createRegExp=y;function m(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function S(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function f(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=f;function a(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=a;function u(Y){for(let se=0,ue=Y.length;se<ue;se++){const ge=Y.charCodeAt(se);if(ge!==32&&ge!==9)return se}return-1}e.firstNonWhitespaceIndex=u;function r(Y,se=0,ue=Y.length){for(let ge=se;ge<ue;ge++){const me=Y.charCodeAt(ge);if(me!==32&&me!==9)return Y.substring(se,ge)}return Y.substring(se,ue)}e.getLeadingWhitespace=r;function o(Y,se=Y.length-1){for(let ue=se;ue>=0;ue--){const ge=Y.charCodeAt(ue);if(ge!==32&&ge!==9)return ue}return-1}e.lastNonWhitespaceIndex=o;function n(Y,se){return Y<se?-1:Y>se?1:0}e.compare=n;function t(Y,se,ue=0,ge=Y.length,me=0,Ce=se.length){for(;ue<ge&&me<Ce;ue++,me++){let Se=Y.charCodeAt(ue),we=se.charCodeAt(me);if(Se<we)return-1;if(Se>we)return 1}const ke=ge-ue,Te=Ce-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstring=t;function s(Y,se){return c(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=s;function c(Y,se,ue=0,ge=Y.length,me=0,Ce=se.length){for(;ue<ge&&me<Ce;ue++,me++){let Se=Y.charCodeAt(ue),we=se.charCodeAt(me);if(Se===we)continue;if(Se>=128||we>=128)return t(Y.toLowerCase(),se.toLowerCase(),ue,ge,me,Ce);l(Se)&&(Se-=32),l(we)&&(we-=32);const De=Se-we;if(De!==0)return De}const ke=ge-ue,Te=Ce-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstringIgnoreCase=c;function l(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=l;function g(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=g;function v(Y,se){return Y.length===se.length&&c(Y,se)===0}e.equalsIgnoreCase=v;function T(Y,se){const ue=se.length;return se.length>Y.length?!1:c(Y,se,0,ue)===0}e.startsWithIgnoreCase=T;function O(Y,se){let ue,ge=Math.min(Y.length,se.length);for(ue=0;ue<ge;ue++)if(Y.charCodeAt(ue)!==se.charCodeAt(ue))return ue;return ge}e.commonPrefixLength=O;function U(Y,se){let ue,ge=Math.min(Y.length,se.length);const me=Y.length-1,Ce=se.length-1;for(ue=0;ue<ge;ue++)if(Y.charCodeAt(me-ue)!==se.charCodeAt(Ce-ue))return ue;return ge}e.commonSuffixLength=U;function x(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=x;function N(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=N;function _(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=_;function z(Y,se,ue){const ge=Y.charCodeAt(ue);if(x(ge)&&ue+1<se){const me=Y.charCodeAt(ue+1);if(N(me))return _(ge,me)}return ge}e.getNextCodePoint=z;function A(Y,se){const ue=Y.charCodeAt(se-1);if(N(ue)&&se>1){const ge=Y.charCodeAt(se-2);if(x(ge))return _(ge,ue)}return ue}function M(Y,se){const ue=ee.getInstance(),ge=se,me=Y.length,Ce=z(Y,me,se);se+=Ce>=65536?2:1;let ke=ue.getGraphemeBreakType(Ce);for(;se<me;){const Te=z(Y,me,se),Se=ue.getGraphemeBreakType(Te);if($e(ke,Se))break;se+=Te>=65536?2:1,ke=Se}return se-ge}e.nextCharLength=M;function q(Y,se){const ue=ee.getInstance(),ge=se,me=A(Y,se);se-=me>=65536?2:1;let Ce=ue.getGraphemeBreakType(me);for(;se>0;){const ke=A(Y,se),Te=ue.getGraphemeBreakType(ke);if($e(Te,Ce))break;se-=ke>=65536?2:1,Ce=Te}return ge-se}e.prevCharLength=q;function j(Y,se){const ue=ee.getInstance(),ge=Y.length,me=se,Ce=z(Y,ge,se),ke=ue.getGraphemeBreakType(Ce);se+=Ce>=65536?2:1;let Te=ke;for(;se<ge;){const we=z(Y,ge,se),De=ue.getGraphemeBreakType(we);if($e(Te,De))break;se+=we>=65536?2:1,Te=De}const Se=se;for(se=me,Te=ke;se>0;){const we=A(Y,se),De=ue.getGraphemeBreakType(we);if($e(De,Te))break;se-=we>=65536?2:1,Te=De}return[se,Se]}function W(Y,se){return se>0&&N(Y.charCodeAt(se))?j(Y,se-1):j(Y,se)}e.getCharContainingOffset=W;const $=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(Y){return $.test(Y)}e.containsRTL=K;const F=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function B(Y){return F.test(Y)}e.containsEmoji=B;const V=/^[\t\n\r\x20-\x7E]*$/;function Q(Y){return V.test(Y)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=Z;function G(Y){for(let se=0,ue=Y.length;se<ue;se++)if(H(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=G;function H(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=H;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=re;function ie(Y,se){if(Y.length<se)return Y;const ue=/\b/g;let ge=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<se);)ge=ue.lastIndex,ue.lastIndex+=1;return Y.substring(ge).replace(/^\s/,"")}e.lcut=ie;const ce=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function de(Y){return Y&&(Y=Y.replace(ce,""),Y=Y.replace(le,""),Y=Y.replace(fe,"")),Y}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ie(Y){return be(Y)?Y.substr(1):Y}e.stripUTF8BOM=Ie;function Ee(Y,se){if(!Y||!se||Y.length<se.length)return!1;const ue=se.length,ge=Y.toLowerCase();let me=0,Ce=-1;for(;me<ue;){const ke=ge.indexOf(se[me],Ce+1);if(ke<0)return!1;Ce=ke,me++}return!0}e.fuzzyContains=Ee;function _e(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=_e;function Pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Pe;function Le(Y,se=1){if(se===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),se--;while(se>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Le;function Fe(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Fe;function Ne(Y){return ee.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ne;function $e(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=$e;var xe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ee{constructor(){this._data=oe()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ue=this._data,ge=ue.length/3;let me=1;for(;me<=ge;)if(se<ue[3*me])me=2*me;else if(se>ue[3*me+1])me=2*me+1;else return ue[3*me+2];return 0}}ee._INSTANCE=null;function oe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ae(Y,se){if(Y===0)return 0;const ue=pe(Y,se);if(ue!==void 0)return ue;const ge=A(se,Y);return Y-=ye(ge),Y}e.getLeftDeleteOffset=ae;function pe(Y,se){let ue=A(se,Y);for(Y-=ye(ue);Ae(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=A(se,Y),Y-=ye(ue)}if(!!re(ue)){if(Y>=0){const ge=A(se,Y);ge===8205&&(Y-=ye(ge))}return Y}}function ye(Y){return Y>=65536?2:1}function Ae(Y){return 127995<=Y&&Y<=127999}var Re;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={})),e.noBreakWhitespace="\xA0"}),define(te[106],ne([0,1,25]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(m){return D(m,0)}e.hash=L;function D(m,S){switch(typeof m){case"object":return m===null?k(349,S):Array.isArray(m)?w(m,S):C(m,S);case"string":return P(m,S);case"boolean":return i(m,S);case"number":return k(m,S);case"undefined":return k(937,S);default:return k(617,S)}}e.doHash=D;function k(m,S){return(S<<5)-S+m|0}e.numberHash=k;function i(m,S){return k(m?433:863,S)}function P(m,S){S=k(149417,S);for(let f=0,a=m.length;f<a;f++)S=k(m.charCodeAt(f),S);return S}e.stringHash=P;function w(m,S){return S=k(104579,S),m.reduce((f,a)=>D(a,f),S)}function C(m,S){return S=k(181387,S),Object.keys(m).sort().reduce((f,a)=>(f=P(a,f),D(m[a],f)),S)}class I{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=D(S,this._value),this._value}}e.Hasher=I;var E;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(m,S,f=32){const a=f-S,u=~((1<<a)-1);return(m<<S|(u&m)>>>a)>>>0}function p(m,S=0,f=m.byteLength,a=0){for(let u=0;u<f;u++)m[S+u]=a}function h(m,S,f="0"){for(;m.length<S;)m=f+m;return m}function b(m,S=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),S/4)}e.toHexString=b;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const f=S.length;if(f===0)return;const a=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,o,n;for(r!==0?(o=r,n=-1,r=0):(o=S.charCodeAt(0),n=0);;){let t=o;if(R.isHighSurrogate(o))if(n+1<f){const s=S.charCodeAt(n+1);R.isLowSurrogate(s)?(n++,t=R.computeCodePoint(o,s)):t=65533}else{r=o;break}else R.isLowSurrogate(o)&&(t=65533);if(u=this._push(a,u,t),n++,n<f)o=S.charCodeAt(n);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(S,f,a){return a<128?S[f++]=a:a<2048?(S[f++]=192|(a&1984)>>>6,S[f++]=128|(a&63)>>>0):a<65536?(S[f++]=224|(a&61440)>>>12,S[f++]=128|(a&4032)>>>6,S[f++]=128|(a&63)>>>0):(S[f++]=240|(a&1835008)>>>18,S[f++]=128|(a&258048)>>>12,S[f++]=128|(a&4032)>>>6,S[f++]=128|(a&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),b(this._h0)+b(this._h1)+b(this._h2)+b(this._h3)+b(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=y._bigBlock32,f=this._buffDV;for(let l=0;l<64;l+=4)S.setUint32(l,f.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)S.setUint32(l,d(S.getUint32(l-12,!1)^S.getUint32(l-32,!1)^S.getUint32(l-56,!1)^S.getUint32(l-64,!1),1),!1);let a=this._h0,u=this._h1,r=this._h2,o=this._h3,n=this._h4,t,s,c;for(let l=0;l<80;l++)l<20?(t=u&r|~u&o,s=1518500249):l<40?(t=u^r^o,s=1859775393):l<60?(t=u&r|u&o|r&o,s=2400959708):(t=u^r^o,s=3395469782),c=d(a,5)+t+n+s+S.getUint32(l*4,!1)&4294967295,n=o,o=r,r=d(u,30),u=a,a=c;this._h0=this._h0+a&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(X,e,R,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(X,R):D?D.value=R:e.set(X,R),R},Ve=this&&this.__classPrivateFieldGet||function(X,e,R,L){if(R==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!L:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return R==="m"?L:R==="a"?L.call(X):L?L.value:e.get(X)};define(te[41],ne([0,1,16,25]),function(X,e,R,L){"use strict";var D,k,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(n,t,s){let c=n.get(t);return c===void 0&&(c=s,n.set(t,c)),c}e.getOrSet=P;function w(n){const t=[];return n.forEach((s,c)=>{t.push(`${c} => ${s}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=w;function C(n){const t=[];return n.forEach(s=>{t.push(s)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=C;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=I;class E{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class d{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var p;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(y||(y={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new h(t))}static forPaths(){return new m(new d)}static forStrings(){return new m(new I)}static forConfigKeys(){return new m(new E)}clear(){this._root=void 0}fill(t,s){if(s){const c=s.slice(0);(0,R.shuffle)(c);for(let l of c)this.set(l,t)}else{const c=t.slice(0);(0,R.shuffle)(c);for(let l of c)this.set(l[0],l[1])}}set(t,s){const c=this._iter.reset(t);let l;this._root||(this._root=new b,this._root.segment=c.value());const g=[];for(l=this._root;;){const T=c.cmp(l.segment);if(T>0)l.left||(l.left=new b,l.left.segment=c.value()),g.push([-1,l]),l=l.left;else if(T<0)l.right||(l.right=new b,l.right.segment=c.value()),g.push([1,l]),l=l.right;else if(c.hasNext())c.next(),l.mid||(l.mid=new b,l.mid.segment=c.value()),g.push([0,l]),l=l.mid;else break}const v=l.value;l.value=s,l.key=t;for(let T=g.length-1;T>=0;T--){const O=g[T][1];O.updateHeight();const U=O.balanceFactor();if(U<-1||U>1){const x=g[T][0],N=g[T+1][0];if(x===1&&N===1)g[T][1]=O.rotateLeft();else if(x===-1&&N===-1)g[T][1]=O.rotateRight();else if(x===1&&N===-1)O.right=g[T+1][1]=g[T+1][1].rotateRight(),g[T][1]=O.rotateLeft();else if(x===-1&&N===1)O.left=g[T+1][1]=g[T+1][1].rotateLeft(),g[T][1]=O.rotateRight();else throw new Error;if(T>0)switch(g[T-1][0]){case-1:g[T-1][1].left=g[T][1];break;case 1:g[T-1][1].right=g[T][1];break;case 0:g[T-1][1].mid=g[T][1];break}else this._root=g[0][1]}}return v}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let c=this._root;for(;c;){const l=s.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const c=this._iter.reset(t),l=[];let g=this._root;for(;g;){const v=c.cmp(g.segment);if(v>0)l.push([-1,g]),g=g.left;else if(v<0)l.push([1,g]),g=g.right;else if(c.hasNext())c.next(),l.push([0,g]),g=g.mid;else break}if(!!g){if(s?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const v=this._min(g.right),{key:T,value:O,segment:U}=v;this._delete(v.key,!1),g.key=T,g.value=O,g.segment=U}else{const v=g.left??g.right;if(l.length>0){const[T,O]=l[l.length-1];switch(T){case-1:O.left=v;break;case 0:O.mid=v;break;case 1:O.right=v;break}}else this._root=v}for(let v=l.length-1;v>=0;v--){const T=l[v][1];T.updateHeight();const O=T.balanceFactor();if(O>1?(T.right.balanceFactor()>=0||(T.right=l[v+1][1]=l[v+1][1].rotateRight()),l[v][1]=T.rotateLeft()):O<-1&&(T.left.balanceFactor()<=0||(T.left=l[v+1][1]=l[v+1][1].rotateLeft()),l[v][1]=T.rotateRight()),v>0)switch(l[v-1][0]){case-1:l[v-1][1].left=l[v][1];break;case 1:l[v-1][1].right=l[v][1];break;case 0:l[v-1][1].mid=l[v][1];break}else this._root=l[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let c=this._root,l;for(;c;){const g=s.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(s.hasNext())s.next(),l=c.value||l,c=c.mid;else break}return c&&c.value||l}findSuperstr(t){const s=this._iter.reset(t);let c=this._root;for(;c;){const l=s.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(t){for(const[s,c]of this)t(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const c=s.balanceFactor();return c<-1||c>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=m;class S{constructor(t,s){this.uri=t,this.value=s}}class f{constructor(t,s){this[D]="ResourceMap",t instanceof f?(this.map=new Map(t.map),this.toKey=s??f.defaultToKey):(this.map=new Map,this.toKey=t??f.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new S(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[c,l]of this.map)t(l.value,l.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=f,f.defaultToKey=n=>n.toString();var a;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class u{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const c=this._map.get(t);if(!!c)return s!==0&&this.touch(c,s),c.value}set(t,s,c=0){let l=this._map.get(t);if(l)l.value=s,c!==0&&this.touch(l,c);else{switch(l={key:t,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(t,l),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const c=this._state;let l=this._head;for(;l;){if(s?t.bind(s)(l.value,l.key,this):t(l.value,l.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const t=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const g={value:c.key,done:!1};return c=c.next,g}else return{value:void 0,done:!0}}};return l}values(){const t=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const g={value:c.value,done:!1};return c=c.next,g}else return{value:void 0,done:!0}}};return l}entries(){const t=this,s=this._state;let c=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const g={value:[c.key,c.value],done:!1};return c=c.next,g}else return{value:void 0,done:!0}}};return l}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>t;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,c=t.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const c=t.next,l=t.previous;t===this._tail?(l.next=void 0,this._tail=l):(c.previous=l,l.next=c),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const c=t.next,l=t.previous;t===this._head?(c.previous=void 0,this._head=c):(c.previous=l,l.next=c),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,c)=>{t.push([c,s])}),t}fromJSON(t){this.clear();for(const[s,c]of t)this.set(s,c)}}e.LinkedMap=u;class r extends u{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class o{constructor(t){i.set(this,void 0),It(this,i,t,"f")}get size(){return Ve(this,i,"f").size}forEach(t,s){Ve(this,i,"f").forEach(t,s)}get(t){return Ve(this,i,"f").get(t)}has(t){return Ve(this,i,"f").has(t)}entries(){return Ve(this,i,"f").entries()}keys(){return Ve(this,i,"f").keys()}values(){return Ve(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Ve(this,i,"f").entries()}}e.ReadonlyMapView=o}),define(te[71],ne([0,1,41]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new R.LRUCache(1e4);function D(C){return w(C,"NFC",L)}e.normalizeNFC=D;const k=new R.LRUCache(1e4);function i(C){return w(C,"NFD",k)}e.normalizeNFD=i;const P=/[^\u0000-\u0080]/;function w(C,I,E){if(!C)return C;const d=E.get(C);if(d)return d;let p;return P.test(C)?p=C.normalize(I):p=C,E.set(C,p),p}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(I){return i(I).replace(C,"")}}()}),define(te[17],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function R(g){return Array.isArray(g)}e.isArray=R;function L(g){return typeof g=="string"}e.isString=L;function D(g){return Array.isArray(g)&&g.every(v=>L(v))}e.isStringArray=D;function k(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=k;function i(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=i;function P(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=P;function w(g){return g===!0||g===!1}e.isBoolean=w;function C(g){return typeof g=="undefined"}e.isUndefined=C;function I(g){return!E(g)}e.isDefined=I;function E(g){return C(g)||g===null}e.isUndefinedOrNull=E;function d(g,v){if(!g)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=d;function p(g){if(E(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=p;function h(...g){const v=[];for(let T=0;T<g.length;T++){const O=g[T];if(E(O))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);v.push(O)}return v}e.assertAllDefined=h;const b=Object.prototype.hasOwnProperty;function y(g){if(!k(g))return!1;for(let v in g)if(b.call(g,v))return!1;return!0}e.isEmptyObject=y;function m(g){return typeof g=="function"}e.isFunction=m;function S(...g){return g.length>0&&g.every(m)}e.areFunctions=S;function f(g,v){const T=Math.min(g.length,v.length);for(let O=0;O<T;O++)a(g[O],v[O])}e.validateConstraints=f;function a(g,v){if(L(v)){if(typeof g!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(m(v)){try{if(g instanceof v)return}catch{}if(!E(g)&&g.constructor===v||v.length===1&&v.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function u(g){let v=[],T=Object.getPrototypeOf(g);for(;Object.prototype!==T;)v=v.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return v}e.getAllPropertyNames=u;function r(g){const v=[];for(const T of u(g))typeof g[T]=="function"&&v.push(T);return v}e.getAllMethodNames=r;function o(g,v){const T=U=>function(){const x=Array.prototype.slice.call(arguments,0);return v(U,x)};let O={};for(const U of g)O[U]=T(U);return O}e.createProxyObject=o;function n(g){return g===null?void 0:g}e.withNullAsUndefined=n;function t(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=t;function s(g){return class{constructor(){return new Proxy({},{get(v,T){if(v[T])return v[T];throw new Error(`Not Implemented: ${g}->${String(T)}`)}})}}}e.NotImplementedProxy=s;function c(g,v="Unreachable"){throw new Error(v)}e.assertNever=c;function l(g){return!!g&&typeof g.then=="function"&&typeof g.catch=="function"}e.isPromise=l}),define(te[42],ne([0,1,10,4,25,17]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function P(n){return n.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=P;function w(n){return n.indexOf("/")===-1&&(n=P(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=w;function C(n,t=R.posix.sep){if(!n)return"";const s=n.length,c=n.charCodeAt(0);if(i(c)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let g=3;const v=g;for(;g<s&&!i(n.charCodeAt(g));g++);if(v!==g&&!i(n.charCodeAt(g+1))){for(g+=1;g<s;g++)if(i(n.charCodeAt(g)))return n.slice(0,g+1).replace(/[\\/]/g,t)}}return t}else if(m(c)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let l=n.indexOf("://");if(l!==-1){for(l+=3;l<s;l++)if(i(n.charCodeAt(l)))return n.slice(0,l+1)}return""}e.getRoot=C;function I(n){if(!L.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let s=2;const c=s;for(;s<n.length&&(t=n.charCodeAt(s),t!==92);s++);return!(c===s||(t=n.charCodeAt(s+1),isNaN(t)||t===92))}e.isUNC=I;const E=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,t=L.isWindows){const s=t?E:d;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||t&&p.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function b(n,t,s){const c=n===t;return!s||c?c:!n||!t?!1:(0,D.equalsIgnoreCase)(n,t)}e.isEqual=b;function y(n,t,s,c=R.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(s){if(!(0,D.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let g=t.length;return t.charAt(t.length-1)===c&&g--,n.charAt(g)===c}return t.charAt(t.length-1)!==c&&(t+=c),n.indexOf(t)===0}e.isEqualOrParent=y;function m(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=m;function S(n,t){return L.isWindows&&n.endsWith(":")&&(n+=R.sep),(0,R.isAbsolute)(n)||(n=(0,R.join)(t,n)),n=(0,R.normalize)(n),L.isWindows?(n=(0,D.rtrim)(n,R.sep),n.endsWith(":")&&(n+=R.sep)):(n=(0,D.rtrim)(n,R.sep),n||(n=R.sep)),n}e.sanitizeFilePath=S;function f(n){const t=(0,R.normalize)(n);return L.isWindows?n.length>3?!1:a(t)&&(n.length===2||t.charCodeAt(2)===92):t===R.posix.sep}e.isRootOrDriveLetter=f;function a(n,t){return(t!==void 0?t:L.isWindows)?m(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function u(n){return a(n)?n[0]:void 0}e.getDriveLetter=u;function r(n,t,s){return t.length>n.length?-1:n===t?0:(s&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=r;function o(n){const t=n.split(":");let s,c,l;if(t.forEach(g=>{const v=Number(g);(0,k.isNumber)(v)?c===void 0?c=v:l===void 0&&(l=v):s=s?[s,g].join(":"):g}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:c!==void 0?c:void 0,column:l!==void 0?l:c!==void 0?1:void 0}}e.parseLineAndColumnAware=o}),define(te[28],ne([0,1,17]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(b){if(!b||typeof b!="object"||b instanceof RegExp)return b;const y=Array.isArray(b)?[]:{};return Object.keys(b).forEach(m=>{b[m]&&typeof b[m]=="object"?y[m]=L(b[m]):y[m]=b[m]}),y}e.deepClone=L;function D(b){if(!b||typeof b!="object")return b;const y=[b];for(;y.length>0;){const m=y.shift();Object.freeze(m);for(const S in m)if(k.call(m,S)){const f=m[S];typeof f=="object"&&!Object.isFrozen(f)&&y.push(f)}}return b}e.deepFreeze=D;const k=Object.prototype.hasOwnProperty;function i(b,y){return P(b,y,new Set)}e.cloneAndChange=i;function P(b,y,m){if((0,R.isUndefinedOrNull)(b))return b;const S=y(b);if(typeof S!="undefined")return S;if((0,R.isArray)(b)){const f=[];for(const a of b)f.push(P(a,y,m));return f}if((0,R.isObject)(b)){if(m.has(b))throw new Error("Cannot clone recursive data-structure");m.add(b);const f={};for(let a in b)k.call(b,a)&&(f[a]=P(b[a],y,m));return m.delete(b),f}return b}function w(b,y,m=!0){return(0,R.isObject)(b)?((0,R.isObject)(y)&&Object.keys(y).forEach(S=>{S in b?m&&((0,R.isObject)(b[S])&&(0,R.isObject)(y[S])?w(b[S],y[S],m):b[S]=y[S]):b[S]=y[S]}),b):y}e.mixin=w;function C(b,y){if(b===y)return!0;if(b==null||y===null||y===void 0||typeof b!=typeof y||typeof b!="object"||Array.isArray(b)!==Array.isArray(y))return!1;let m,S;if(Array.isArray(b)){if(b.length!==y.length)return!1;for(m=0;m<b.length;m++)if(!C(b[m],y[m]))return!1}else{const f=[];for(S in b)f.push(S);f.sort();const a=[];for(S in y)a.push(S);if(a.sort(),!C(f,a))return!1;for(m=0;m<f.length;m++)if(!C(b[f[m]],y[f[m]]))return!1}return!0}e.equals=C;function I(b){const y=new Set;return JSON.stringify(b,(m,S)=>{if((0,R.isObject)(S)||Array.isArray(S)){if(y.has(S))return"[Circular]";y.add(S)}return S})}e.safeStringify=I;function E(b,y,m){const S=y(b);return typeof S=="undefined"?m:S}e.getOrDefault=E;function d(b,y){const m=Object.create(null);return!b||!y||Object.keys(y).forEach(f=>{const a=b[f],u=y[f];C(a,u)||(m[f]=u)}),m}e.distinct=d;function p(b,y){const m=y.toLowerCase(),S=Object.keys(b).find(f=>f.toLowerCase()===m);return S?b[S]:b[y]}e.getCaseInsensitive=p;function h(b,y){const m=Object.create(null);for(const[S,f]of Object.entries(b))y(S,f)&&(m[S]=f);return m}e.filter=h}),define(te[9],ne([0,1,10,4]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,k=/^\//,i=/^\/\//;function P(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!k.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(n,t){return!n&&!t?"file":n}function C(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const I="",E="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,s,c,l,g,v=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=w(t,v),this.authority=s||I,this.path=C(this.scheme,c||I),this.query=l||I,this.fragment=g||I,P(this,v))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return f(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:c,path:l,query:g,fragment:v}=t;return s===void 0?s=this.scheme:s===null&&(s=I),c===void 0?c=this.authority:c===null&&(c=I),l===void 0?l=this.path:l===null&&(l=I),g===void 0?g=this.query:g===null&&(g=I),v===void 0?v=this.fragment:v===null&&(v=I),s===this.scheme&&c===this.authority&&l===this.path&&g===this.query&&v===this.fragment?this:new b(s,c,l,g,v)}static parse(t,s=!1){const c=d.exec(t);return c?new b(c[2]||I,o(c[4]||I),o(c[5]||I),o(c[7]||I),o(c[9]||I),s):new b(I,I,I,I,I)}static file(t){let s=I;if(L.isWindows&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const c=t.indexOf(E,2);c===-1?(s=t.substring(2),t=E):(s=t.substring(2,c),t=t.substring(c)||E)}return new b("file",s,t,I,I)}static from(t){const s=new b(t.scheme,t.authority,t.path,t.query,t.fragment);return P(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return L.isWindows&&t.scheme==="file"?c=p.file(R.win32.join(f(t,!0),...s)).path:c=R.posix.join(t.path,...s),t.with({path:c})}toString(t=!1){return a(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const s=new b(t);return s._formatted=t.external,s._fsPath=t._sep===h?t.fsPath:null,s}}else return t}}e.URI=p;const h=L.isWindows?1:void 0;class b extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(t=!1){return t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,t){let s,c=-1;for(let l=0;l<n.length;l++){const g=n.charCodeAt(l);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||t&&g===47)c!==-1&&(s+=encodeURIComponent(n.substring(c,l)),c=-1),s!==void 0&&(s+=n.charAt(l));else{s===void 0&&(s=n.substr(0,l));const v=y[g];v!==void 0?(c!==-1&&(s+=encodeURIComponent(n.substring(c,l)),c=-1),s+=v):c===-1&&(c=l)}}return c!==-1&&(s+=encodeURIComponent(n.substring(c))),s!==void 0?s:n}function S(n){let t;for(let s=0;s<n.length;s++){const c=n.charCodeAt(s);c===35||c===63?(t===void 0&&(t=n.substr(0,s)),t+=y[c]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function f(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,L.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function a(n,t){const s=t?S:m;let c="",{scheme:l,authority:g,path:v,query:T,fragment:O}=n;if(l&&(c+=l,c+=":"),(g||l==="file")&&(c+=E,c+=E),g){let U=g.indexOf("@");if(U!==-1){const x=g.substr(0,U);g=g.substr(U+1),U=x.indexOf(":"),U===-1?c+=s(x,!1):(c+=s(x.substr(0,U),!1),c+=":",c+=s(x.substr(U+1),!1)),c+="@"}g=g.toLowerCase(),U=g.indexOf(":"),U===-1?c+=s(g,!1):(c+=s(g.substr(0,U),!1),c+=g.substr(U))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const U=v.charCodeAt(1);U>=65&&U<=90&&(v=`/${String.fromCharCode(U+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const U=v.charCodeAt(0);U>=65&&U<=90&&(v=`${String.fromCharCode(U+32)}:${v.substr(2)}`)}c+=s(v,!0)}return T&&(c+="?",c+=s(T,!1)),O&&(c+="#",c+=t?O:m(O,!1)),c}function u(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+u(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(n){return n.match(r)?n.replace(r,t=>u(t)):n}}),define(te[107],ne([0,1,9]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(C){const I=C;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=L;function D(C){const I=[];let E;try{const d=JSON.parse(C.arguments),p=d[d.length-1];p&&p.__$stack&&(d.pop(),E=p.__$stack),I.push(...d)}catch(d){I.push("Unable to log remote console arguments",C.arguments)}return{args:I,stack:E}}e.parse=D;function k(C){if(typeof C!="string")return k(D(C).stack);const I=C;if(I){const E=i(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(d&&d.length===4)return{uri:R.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=k;function i(C){if(!C)return C;const I=C.indexOf(`
`);return I===-1?C:C.substring(0,I)}function P(C,I){const{args:E,stack:d}=D(C),p=typeof E[0]=="string"&&E.length===1;let h=i(d);h&&(h=`(${h.trim()})`);let b=[];if(typeof E[0]=="string"?h&&p?b=[`%c[${I}] %c${E[0]} %c${h}`,w("blue"),w(""),w("grey")]:b=[`%c[${I}] %c${E[0]}`,w("blue"),w(""),...E.slice(1)]:b=[`%c[${I}]%`,w("blue"),...E],h&&!p&&b.push(h),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,b)}e.log=P;function w(C){return`color: ${C}`}}),define(te[108],ne([0,1,19,25,9]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(I){return JSON.stringify(I,w)}e.stringify=k;function i(I){let E=JSON.parse(I);return E=C(E),E}e.parse=i;var P;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function w(I,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,L.regExpFlags)(E)}:E}function C(I,E=0){if(!I||E>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof R.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let d=0;d<I.length;++d)I[d]=C(I[d],E+1);else for(const d in I)Object.hasOwnProperty.call(I,d)&&(I[d]=C(I[d],E+1))}return I}e.revive=C}),define(te[15],ne([0,1,4,9]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,C,I){this._hosts[w]=C,this._ports[w]=I}setConnectionToken(w,C){this._connectionTokens[w]=C}rewrite(w){if(this._delegate)return this._delegate(w);const C=w.authority;let I=this._hosts[C];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const E=this._ports[C],d=this._connectionTokens[C];let p=`path=${encodeURIComponent(w.path)}`;return typeof d=="string"&&(p+=`&tkn=${encodeURIComponent(d)}`),L.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${I}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new k;class i{asBrowserUri(w,C){const I=this.toUri(w,C);return I.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===D.file&&(R.isNative||typeof R.globals.importScripts=="function"&&R.globals.origin===`${D.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?I.with({scheme:D.vscodeFileResource,authority:I.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(w,C){const I=this.toUri(w,C);return I.scheme===D.vscodeFileResource?I.with({scheme:D.file,authority:I.authority!==i.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(w,C){return L.URI.isUri(w)?w:L.URI.parse(C.toUrl(w))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(te[18],ne([0,1,42,15,10,4,25,9]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=w;class C{constructor(h){this._ignorePathCasing=h}compare(h,b,y=!1){return h===b?0:(0,i.compare)(this.getComparisonKey(h,y),this.getComparisonKey(b,y))}isEqual(h,b,y=!1){return h===b?!0:!h||!b?!1:this.getComparisonKey(h,y)===this.getComparisonKey(b,y)}getComparisonKey(h,b=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,b,y=!1){if(h.scheme===b.scheme){if(h.scheme===L.Schemas.file)return R.isEqualOrParent(w(h),w(b),this._ignorePathCasing(h))&&h.query===b.query&&(y||h.fragment===b.fragment);if((0,e.isEqualAuthority)(h.authority,b.authority))return R.isEqualOrParent(h.path,b.path,this._ignorePathCasing(h),"/")&&h.query===b.query&&(y||h.fragment===b.fragment)}return!1}joinPath(h,...b){return P.URI.joinPath(h,...b)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let b;return h.scheme===L.Schemas.file?b=P.URI.file(D.dirname(w(h))).path:(b=D.posix.dirname(h.path),h.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),b="/")),h.with({path:b})}normalizePath(h){if(!h.path.length)return h;let b;return h.scheme===L.Schemas.file?b=P.URI.file(D.normalize(w(h))).path:b=D.posix.normalize(h.path),h.with({path:b})}relativePath(h,b){if(h.scheme!==b.scheme||!(0,e.isEqualAuthority)(h.authority,b.authority))return;if(h.scheme===L.Schemas.file){const S=D.relative(w(h),w(b));return k.isWindows?R.toSlashes(S):S}let y=h.path||"/",m=b.path||"/";if(this._ignorePathCasing(h)){let S=0;for(const f=Math.min(y.length,m.length);S<f&&!(y.charCodeAt(S)!==m.charCodeAt(S)&&y.charAt(S).toLowerCase()!==m.charAt(S).toLowerCase());S++);y=m.substr(0,S)+y.substr(S)}return D.posix.relative(y,m)}resolvePath(h,b){if(h.scheme===L.Schemas.file){const y=P.URI.file(D.resolve(w(h),b));return h.with({authority:y.authority,path:y.path})}return b=R.toPosixPath(b),h.with({path:D.posix.resolve(h.path,b)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,b){return h===b||h!==void 0&&b!==void 0&&(0,i.equalsIgnoreCase)(h,b)}hasTrailingPathSeparator(h,b=D.sep){if(h.scheme===L.Schemas.file){const y=w(h);return y.length>R.getRoot(y).length&&y[y.length-1]===b}else{const y=h.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,b=D.sep){return(0,e.hasTrailingPathSeparator)(h,b)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,b=D.sep){let y=!1;if(h.scheme===L.Schemas.file){const m=w(h);y=m!==void 0&&m.length===R.getRoot(m).length&&m[m.length-1]===b}else{b="/";const m=h.path;y=m.length===1&&m.charCodeAt(m.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(h,b)?h.with({path:h.path+"/"}):h}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(p=>p.scheme===L.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new C(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(p,h){const b=[];for(let y=0;y<p.length;y++){const m=h(p[y]);p.some((S,f)=>f===y?!1:(0,e.isEqualOrParent)(m,h(S)))||b.push(p[y])}return b}e.distinctParents=I;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(b){const y=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(f=>{const[a,u]=f.split(":");a&&u&&y.set(a,u)});const S=b.path.substring(0,b.path.indexOf(";"));return S&&y.set(p.META_DATA_MIME,S),y}p.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function d(p,h,b){if(h){let y=p.path;return y&&y[0]!==D.posix.sep&&(y=D.posix.sep+y),p.with({scheme:b,authority:h,path:y})}return p.with({scheme:b})}e.toLocalResource=d}),define(te[5],ne([0,1,27,8,3,2,18]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(q){return!!q&&typeof q.then=="function"}e.isThenable=P;function w(q){const j=new R.CancellationTokenSource,W=q(j.token),$=new Promise((K,F)=>{const B=j.token.onCancellationRequested(()=>{B.dispose(),j.dispose(),F((0,L.canceled)())});Promise.resolve(W).then(V=>{B.dispose(),j.dispose(),K(V)},V=>{B.dispose(),j.dispose(),F(V)})});return new class{cancel(){j.cancel()}then(K,F){return $.then(K,F)}catch(K){return this.then(void 0,K)}finally(K){return $.finally(K)}}}e.createCancelablePromise=w;function C(q,j,W){return Promise.race([q,new Promise($=>j.onCancellationRequested(()=>$(W)))])}e.raceCancellation=C;async function I(q){let j=-1;const W=q.map((K,F)=>K.then(B=>(j=F,B))),$=await Promise.race(W);return q.forEach((K,F)=>{F!==j&&K.cancel()}),$}e.raceCancellablePromises=I;function E(q,j,W){let $;const K=setTimeout(()=>{$?.(void 0),W?.()},j);return Promise.race([q.finally(()=>clearTimeout(K)),new Promise(F=>$=F)])}e.raceTimeout=E;function d(q){return new Promise((j,W)=>{const $=q();P($)?$.then(j,W):j($)})}e.asPromise=d;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const $=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,$};this.queuedPromise=new Promise($=>{this.activePromise.then(W,W).then($)})}return new Promise((W,$)=>{this.queuedPromise.then(W,$)})}return this.activePromise=j(),new Promise((W,$)=>{this.activePromise.then(K=>{this.activePromise=null,W(K)},K=>{this.activePromise=null,$(K)})})}}e.Throttler=p;class h{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=h;class b{constructor(){this.promiseMap=new Map}queue(j,W){const K=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(j)===K&&this.promiseMap.delete(j)});return this.promiseMap.set(j,K),K}}e.SequencerByKey=b;class y{constructor(j){this.defaultDelay=j,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,W=this.defaultDelay){return this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise(($,K)=>{this.doResolve=$,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const $=this.task;return this.task=null,$()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=y;class m{constructor(j){this.delayer=new y(j),this.throttler=new p}trigger(j,W){return this.delayer.trigger(()=>this.throttler.queue(j),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class S{constructor(){this._isOpen=!1,this._promise=new Promise((j,W)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=S;class f extends S{constructor(j){super();this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function a(q,j){return j?new Promise((W,$)=>{const K=setTimeout(()=>{F.dispose(),W()},q),F=j.onCancellationRequested(()=>{clearTimeout(K),F.dispose(),$((0,L.canceled)())})}):w(W=>a(q,W))}e.timeout=a;function u(q,j=0){const W=setTimeout(q,j);return(0,k.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=u;function r(q){const j=[];let W=0;const $=q.length;function K(){return W<$?q[W++]():null}function F(B){B!=null&&j.push(B);const V=K();return V?V.then(F):Promise.resolve(j)}return Promise.resolve(null).then(F)}e.sequence=r;function o(q,j=$=>!!$,W=null){let $=0;const K=q.length,F=()=>{if($>=K)return Promise.resolve(W);const B=q[$++];return Promise.resolve(B()).then(Q=>j(Q)?Promise.resolve(Q):F())};return F()}e.first=o;function n(q,j=$=>!!$,W=null){if(q.length===0)return Promise.resolve(W);let $=q.length;const K=()=>{$=-1;for(const F of q)F.cancel?.()};return new Promise((F,B)=>{for(const V of q)V.then(Q=>{--$>=0&&j(Q)?(K(),F(Q)):$===0&&F(W)}).catch(Q=>{--$>=0&&(K(),B(Q))})})}e.firstParallel=n;class t{constructor(j){this._size=0,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(j){return this._size++,new Promise((W,$)=>{this.outstandingPromises.push({factory:j,c:W,e:$}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const W=j.factory();W.then(j.c,j.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class s extends t{constructor(){super(1)}}e.Queue=s;class c{constructor(){this.queues=new Map}queueFor(j,W=i.extUri){const $=W.getComparisonKey(j);let K=this.queues.get($);return K||(K=new s,D.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete($)}),this.queues.set($,K)),K}dispose(){this.queues.forEach(j=>j.dispose()),this.queues.clear()}}e.ResourceQueue=c;class l{constructor(j,W){this._token=-1,typeof j=="function"&&typeof W=="number"&&this.setIfNotSet(j,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},W)}setIfNotSet(j,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},W))}}e.TimeoutTimer=l;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(j,W){this.cancel(),this._token=setInterval(()=>{j()},W)}}e.IntervalTimer=g;class v{constructor(j,W){this.timeoutToken=-1,this.runner=j,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=v;class T{constructor(j,W){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=j,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(j=this.timeout){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(j/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class O extends v{constructor(j,W){super(j,W);this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner&&this.runner(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class U extends k.Disposable{constructor(j,W,$,K){super();this.maxWorkChunkSize=j,this.maxPendingWork=W,this.throttleDelay=$,this.handler=K,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.maxPendingWork)return!1}else if(this.pending+j.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...j),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new v(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{const j=setTimeout(()=>{const $=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0,clearTimeout(j))}}}:e.runWhenIdle=(q,j)=>{const W=requestIdleCallback(q,typeof j=="number"?{timeout:j}:void 0);let $=!1;return{dispose(){$||($=!0,cancelIdleCallback(W))}}}}();class x{constructor(j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function N(q,j,W){let $;for(let K=0;K<W;K++)try{return await q()}catch(F){$=F,await a(j)}throw $}e.retry=N;class _{hasPending(j){return this._pending?typeof j=="number"?this._pending.taskId===j:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(j,W,$){return this._pending={taskId:j,cancel:()=>$?.(),promise:W},W.then(()=>this.donePending(j),()=>this.donePending(j)),W}donePending(j){this._pending&&j===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const j=this._next;this._next=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this._next)this._next.run=j;else{let W,$;const K=new Promise((F,B)=>{W=F,$=B});this._next={run:j,promise:K,promiseResolve:W,promiseReject:$}}return this._next.promise}}e.TaskSequentializer=_;class z{constructor(j){this.interval=j,this.lastIncrementTime=0,this.value=0}increment(){const j=Date.now();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class A{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((j,W)=>{this.completeCallback=j,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(j){return new Promise(W=>{this.completeCallback(j),this.resolved=!0,W()})}error(j){return new Promise(W=>{this.errorCallback(j),this.rejected=!0,W()})}cancel(){new Promise(j=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,j()})}}e.DeferredPromise=A;var M;(function(q){async function j($){let K;const F=await Promise.all($.map(B=>B.then(V=>V,V=>{K||(K=V)})));if(typeof K!="undefined")throw K;return F}q.settled=j;function W($){return new Promise(async(K,F)=>{try{await $(K,F)}catch(B){F(B)}})}q.withAsyncBody=W})(M=e.Promises||(e.Promises={}))}),define(te[109],ne([0,1,5,42,41,10,25]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const w="**",C="/",I="[/\\\\]",E="[^/\\\\]",d=/\//g;function p($){switch($){case 0:return"";case 1:return`${E}*?`;default:return`(?:${I}|${E}+${I}|${I}${E}+)*?`}}function h($,K){if(!$)return[];const F=[];let B=!1,V=!1,Q="";for(const Z of $){switch(Z){case K:if(!B&&!V){F.push(Q),Q="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":V=!0;break;case"]":V=!1;break}Q+=Z}return Q&&F.push(Q),F}e.splitGlobAware=h;function b($){if(!$)return"";let K="";const F=h($,C);if(F.every(B=>B===w))K=".*";else{let B=!1;F.forEach((V,Q)=>{if(V===w){B||(K+=p(2),B=!0);return}let Z=!1,G="",H=!1,re="";for(const ie of V){if(ie!=="}"&&Z){G+=ie;continue}if(H&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===C?ce="":ce=i.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":K+=`(?:${h(G,",").map(fe=>b(fe)).join("|")})`,Z=!1,G="";break;case"]":K+="["+re+"]",H=!1,re="";break;case"?":K+=E;continue;case"*":K+=p(1);continue;default:K+=i.escapeRegExpCharacters(ie)}}Q<F.length-1&&(F[Q+1]!==w||Q+2<F.length)&&(K+=I),B=!1})}return K}const y=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,S=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new D.LRUCache(1e4),o=function(){return!1},n=function(){return null};function t($,K){if(!$)return n;let F;typeof $!="string"?F=$.pattern:F=$,F=F.trim();const B=`${F}_${!!K.trimForExclusions}`;let V=r.get(B);if(V)return s(V,$);let Q;if(y.test(F)){const Z=F.substr(4);V=function(G,H){return typeof G=="string"&&G.endsWith(Z)?F:null}}else(Q=m.exec(c(F,K)))?V=l(Q[1],F):(K.trimForExclusions?f:S).test(F)?V=g(F,K):(Q=a.exec(c(F,K)))?V=v(Q[1].substr(1),F,!0):(Q=u.exec(c(F,K)))?V=v(Q[1],F,!1):V=T(F);return r.set(B,V),s(V,$)}function s($,K){return typeof K=="string"?$:function(F,B){return L.isEqualOrParent(F,K.base)?$(k.relative(K.base,F),B):null}}function c($,K){return K.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function l($,K){const F=`/${$}`,B=`\\${$}`,V=function(Z,G){return typeof Z!="string"?null:G?G===$?K:null:Z===$||Z.endsWith(F)||Z.endsWith(B)?K:null},Q=[$];return V.basenames=Q,V.patterns=[K],V.allBasenames=Q,V}function g($,K){const F=W($.slice(1,-1).split(",").map(G=>t(G,K)).filter(G=>G!==n),$),B=F.length;if(!B)return n;if(B===1)return F[0];const V=function(G,H){for(let re=0,ie=F.length;re<ie;re++)if(F[re](G,H))return $;return null},Q=F.find(G=>!!G.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=F.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(V.allPaths=Z),V}function v($,K,F){const B=k.sep===k.posix.sep,V=B?$:$.replace(d,k.sep),Q=k.sep+V,Z=k.posix.sep+$,G=F?function(H,re){return typeof H=="string"&&(H===V||H.endsWith(Q)||!B&&(H===$||H.endsWith(Z)))?K:null}:function(H,re){return typeof H=="string"&&(H===V||!B&&H===$)?K:null};return G.allPaths=[(F?"*/":"./")+$],G}function T($){try{const K=new RegExp(`^${b($)}$`);return function(F){return K.lastIndex=0,typeof F=="string"&&K.test(F)?$:null}}catch(K){return n}}function O($,K,F){return!$||typeof K!="string"?!1:U($)(K,void 0,F)}e.match=O;function U($,K={}){if(!$)return o;if(typeof $=="string"||z($)){const F=t($,K);if(F===n)return o;const B=function(V,Q){return!!F(V,Q)};return F.allBasenames&&(B.allBasenames=F.allBasenames),F.allPaths&&(B.allPaths=F.allPaths),B}return q($,K)}e.parse=U;function x($){if(!$)return;let K;return F=>(K||(K=($()||Promise.resolve([])).then(B=>B?_(B):{})),K.then(B=>!!B[F]))}e.hasSiblingPromiseFn=x;function N($){if(!$)return;let K;return F=>{if(!K){const B=$();K=B?_(B):{}}return!!K[F]}}e.hasSiblingFn=N;function _($){const K={};for(const F of $)K[F]=!0;return K}function z($){const K=$;return K&&typeof K.base=="string"&&typeof K.pattern=="string"}e.isRelativePattern=z;function A($){return $.allBasenames||[]}e.getBasenameTerms=A;function M($){return $.allPaths||[]}e.getPathTerms=M;function q($,K){const F=W(Object.getOwnPropertyNames($).map(G=>j(G,$[G],K)).filter(G=>G!==n)),B=F.length;if(!B)return n;if(!F.some(G=>!!G.requiresSiblings)){if(B===1)return F[0];const G=function(ie,ce){for(let le=0,fe=F.length;le<fe;le++){const de=F[le](ie,ce);if(de)return de}return null},H=F.find(ie=>!!ie.allBasenames);H&&(G.allBasenames=H.allBasenames);const re=F.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(G.allPaths=re),G}const V=function(G,H,re){let ie;for(let ce=0,le=F.length;ce<le;ce++){const fe=F[ce];fe.requiresSiblings&&re&&(H||(H=k.basename(G)),ie||(ie=H.substr(0,H.length-k.extname(G).length)));const de=fe(G,H,ie,re);if(de)return de}return null},Q=F.find(G=>!!G.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=F.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(V.allPaths=Z),V}function j($,K,F){if(K===!1)return n;const B=t($,F);if(B===n)return n;if(typeof K=="boolean")return B;if(K){const V=K.when;if(typeof V=="string"){const Q=(Z,G,H,re)=>{if(!re||!B(Z,G))return null;const ie=V.replace("$(basename)",H),ce=re(ie);return(0,R.isThenable)(ce)?ce.then(le=>le?$:null):ce?$:null};return Q.requiresSiblings=!0,Q}}return B}function W($,K){const F=$.filter(G=>!!G.basenames);if(F.length<2)return $;const B=F.reduce((G,H)=>{const re=H.basenames;return re?G.concat(re):G},[]);let V;if(K){V=[];for(let G=0,H=B.length;G<H;G++)V.push(K)}else V=F.reduce((G,H)=>{const re=H.patterns;return re?G.concat(re):G},[]);const Q=function(G,H){if(typeof G!="string")return null;if(!H){let ie;for(ie=G.length;ie>0;ie--){const ce=G.charCodeAt(ie-1);if(ce===47||ce===92)break}H=G.substr(ie)}const re=B.indexOf(H);return re!==-1?V[re]:null};Q.basenames=B,Q.patterns=V,Q.allBasenames=B;const Z=$.filter(G=>!G.basenames);return Z.push(Q),Z}}),define(te[110],ne([0,1,109,15,10,18,25]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let w=[],C=[],I=[];function E(t,s=!1){const c=d(t);w.push(c),c.userConfigured?I.push(c):C.push(c),s&&!c.userConfigured&&w.forEach(l=>{l.mime===c.mime||l.userConfigured||(c.extension&&l.extension===c.extension&&console.warn(`Overwriting extension <<${c.extension}>> to now point to mime <<${c.mime}>>`),c.filename&&l.filename===c.filename&&console.warn(`Overwriting filename <<${c.filename}>> to now point to mime <<${c.mime}>>`),c.filepattern&&l.filepattern===c.filepattern&&console.warn(`Overwriting filepattern <<${c.filepattern}>> to now point to mime <<${c.mime}>>`),c.firstline&&l.firstline===c.firstline&&console.warn(`Overwriting firstline <<${c.firstline}>> to now point to mime <<${c.mime}>>`))})}e.registerTextMime=E;function d(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,R.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function p(t){t?(w=w.filter(s=>!s.userConfigured),I=[]):(w=[],C=[],I=[])}e.clearTextMimes=p;function h(t,s){let c;if(t)switch(t.scheme){case L.Schemas.file:c=t.fsPath;break;case L.Schemas.data:c=k.DataUri.parseMetaData(t).get(k.DataUri.META_DATA_LABEL);break;default:c=t.path}if(!c)return[P.unknown];c=c.toLowerCase();const l=(0,D.basename)(c),g=b(c,l,I);if(g)return[g,P.text];const v=b(c,l,C);if(v)return[v,P.text];if(s){const T=y(s);if(T)return[T,P.text]}return[P.unknown]}e.guessMimeTypes=h;function b(t,s,c){let l=null,g=null,v=null;for(let T=c.length-1;T>=0;T--){const O=c[T];if(s===O.filenameLowercase){l=O;break}if(O.filepattern&&(!g||O.filepattern.length>g.filepattern.length)){const U=O.filepatternOnPath?t:s;O.filepatternLowercase?.(U)&&(g=O)}O.extension&&(!v||O.extension.length>v.extension.length)&&s.endsWith(O.extensionLowercase)&&(v=O)}return l?l.mime:g?g.mime:v?v.mime:null}function y(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let s=w.length-1;s>=0;s--){const c=w[s];if(!c.firstline)continue;const l=t.match(c.firstline);if(l&&l.length>0)return c.mime}return null}function m(t){return t?typeof t=="string"?t===P.binary||t===P.text||t===P.unknown:t.length===1&&m(t[0]):!0}e.isUnspecific=m;const S={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(t){const s=(0,D.extname)(t),c=S[s.toLowerCase()];return c!==void 0?c:u(t)}e.getMediaOrTextMime=a;function u(t){const s=(0,D.extname)(t);return f[s.toLowerCase()]}e.getMediaMime=u;function r(t){for(const s in f)if(f[s]===t)return s}e.getExtensionForMimeType=r;const o=/^(.+)\/(.+?)(;.+)?$/;function n(t,s){const c=o.exec(t);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:s?void 0:t}e.normalizeMimeType=n}),define(te[111],ne([0,1,9]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(I){return I.toJSON()}class D{constructor(E){this._uriTransformer=E}transformIncoming(E){const d=this._uriTransformer.transformIncoming(E);return d===E?E:L(R.URI.from(d))}transformOutgoing(E){const d=this._uriTransformer.transformOutgoing(E);return d===E?E:L(R.URI.from(d))}transformOutgoingURI(E){const d=this._uriTransformer.transformOutgoing(E);return d===E?E:R.URI.from(d)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function k(I,E,d){if(!I||d>200)return null;if(typeof I=="object"){if(I instanceof R.URI)return E.transformOutgoing(I);for(let p in I)if(Object.hasOwnProperty.call(I,p)){const h=k(I[p],E,d+1);h!==null&&(I[p]=h)}}return null}function i(I,E){const d=k(I,E,0);return d===null?I:d}e.transformOutgoingURIs=i;function P(I,E,d,p){if(!I||p>200)return null;if(typeof I=="object"){if(I.$mid===1)return d?R.URI.revive(E.transformIncoming(I)):E.transformIncoming(I);for(let h in I)if(Object.hasOwnProperty.call(I,h)){const b=P(I[h],E,d,p+1);b!==null&&(I[h]=b)}}return null}function w(I,E){const d=P(I,E,!1,0);return d===null?I:d}e.transformIncomingURIs=w;function C(I,E){const d=P(I,E,!0,0);return d===null?I:d}e.transformAndReviveIncomingURIs=C}),define(te[29],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(w){return R.test(w)}e.isUUID=L;const D=new Uint8Array(16),k=[];for(let w=0;w<256;w++)k.push(w.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(w){for(let C=0;C<w.length;C++)w[C]=Math.floor(Math.random()*256);return w};function P(){i(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let w=0,C="";return C+=k[D[w++]],C+=k[D[w++]],C+=k[D[w++]],C+=k[D[w++]],C+="-",C+=k[D[w++]],C+=k[D[w++]],C+="-",C+=k[D[w++]],C+=k[D[w++]],C+="-",C+=k[D[w++]],C+=k[D[w++]],C+="-",C+=k[D[w++]],C+=k[D[w++]],C+=k[D[w++]],C+=k[D[w++]],C+=k[D[w++]],C+=k[D[w++]],C}e.generateUuid=P}),define(te[112],ne([0,1,113]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(k="utf8"){this.stringDecoder=new R.StringDecoder(k),this.remaining=null}write(k){const i=[],P=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(P.length<1)return i;let w=0,C,I=w;for(;I<P.length;)if(C=P.charCodeAt(I),C===13||C===10){if(i.push(P.substring(w,I)),I++,I<P.length){const E=C;C=P.charCodeAt(I),(E===13&&C===10||E===10&&C===13)&&I++}w=I}else I++;return this.remaining=w<P.length?P.substr(w):null,i}end(){return this.remaining}}e.LineDecoder=L}),define(te[114],ne([0,1,33]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(i){const P=i.replace(/\-/g,":").toLowerCase();return!L.has(P)}function k(){const i=(0,R.networkInterfaces)();for(let P in i){const w=i[P];if(w){for(const{mac:C}of w)if(D(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(te[115],ne([0,1,33,8,41,29,114]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,E=0;const d=(0,R.networkInterfaces)();for(let p in d){const h=d[p];if(h)for(const{mac:b,internal:y}of h)y||(E+=1,this._isVirtualMachineMacAddress(b.toUpperCase())&&(I+=1))}this._value=E>0?I/E:0}return this._value}};let P;async function w(){return P||(P=(async()=>await C()||k.generateUuid())()),P}e.getMachineId=w;async function C(){try{const I=await new Promise((d,p)=>{X(["crypto"],d,p)}),E=(0,i.getMac)();return I.createHash("sha256").update(E,"utf8").digest("hex")}catch(I){L.onUnexpectedError(I);return}}}),define(te[20],ne([0,1,51,33,246,5,42,71,10,4,18,9,29]),function(X,e,R,L,D,k,i,P,w,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(A){A[A.UNLINK=0]="UNLINK",A[A.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function h(A,M=p.UNLINK){if((0,i.isRootOrDriveLetter)(A))throw new Error("rimraf - will refuse to recursively delete root");return M===p.UNLINK?y(A):b(A)}async function b(A){try{const M=(0,w.join)((0,L.tmpdir)(),(0,d.generateUuid)());try{await e.Promises.rename(A,M)}catch(q){return y(A)}y(M).catch(q=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function y(A){return e.Promises.rmdir(A,{recursive:!0,maxRetries:3})}function m(A){if((0,i.isRootOrDriveLetter)(A))throw new Error("rimraf - will refuse to recursively delete root");R.rmdirSync(A,{recursive:!0})}e.rimrafSync=m;async function S(A,M){return u(await(M?f(A):(0,D.promisify)(R.readdir)(A)))}async function f(A){try{return await(0,D.promisify)(R.readdir)(A,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const M=[],q=await S(A);for(const j of q){let W=!1,$=!1,K=!1;try{const F=await e.Promises.lstat((0,w.join)(A,j));W=F.isFile(),$=F.isDirectory(),K=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}M.push({name:j,isFile:()=>W,isDirectory:()=>$,isSymbolicLink:()=>K})}return M}function a(A){return u(R.readdirSync(A))}e.readdirSync=a;function u(A){return A.map(M=>typeof M=="string"?C.isMacintosh?(0,P.normalizeNFC)(M):M:(M.name=C.isMacintosh?(0,P.normalizeNFC)(M.name):M.name,M))}async function r(A){const M=await S(A),q=[];for(const j of M)await n.existsDirectory((0,w.join)(A,j))&&q.push(j);return q}function o(A,M=1e3){return new Promise(q=>{let j=!1;const W=setInterval(()=>{j||(j=!0,R.access(A,$=>{j=!1,$&&(clearInterval(W),q(void 0))}))},M)})}e.whenDeleted=o;var n;(function(A){async function M(W){let $;try{if($=await e.Promises.lstat(W),!$.isSymbolicLink())return{stat:$}}catch(K){}try{return{stat:await e.Promises.stat(W),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(C.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw F}throw K}}A.stat=M;async function q(W){try{const{stat:$,symbolicLink:K}=await A.stat(W);return $.isFile()&&K?.dangling!==!0}catch($){}return!1}A.existsFile=q;async function j(W){try{const{stat:$,symbolicLink:K}=await A.stat(W);return $.isDirectory()&&K?.dangling!==!0}catch($){}return!1}A.existsDirectory=j})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new k.ResourceQueue;function s(A,M,q){return t.queueFor(E.URI.file(A),I.extUriBiasedIgnorePathCase).queue(()=>{const j=v(q);return new Promise((W,$)=>l(A,M,j,K=>K?$(K):W()))})}let c=!0;function l(A,M,q,j){if(!c)return R.writeFile(A,M,{mode:q.mode,flag:q.flag},j);R.open(A,q.flag,q.mode,(W,$)=>{if(W)return j(W);R.writeFile($,M,K=>{if(K)return R.close($,()=>j(K));R.fdatasync($,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),c=!1),R.close($,B=>j(B))))})})}function g(A,M,q){const j=v(q);if(!c)return R.writeFileSync(A,M,{mode:j.mode,flag:j.flag});const W=R.openSync(A,j.flag,j.mode);try{R.writeFileSync(W,M);try{R.fdatasyncSync(W)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),c=!1}}finally{R.closeSync(W)}}e.writeFileSync=g;function v(A){return A?{mode:typeof A.mode=="number"?A.mode:438,flag:typeof A.flag=="string"?A.flag:"w"}:{mode:438,flag:"w"}}async function T(A,M){if(A===M)return;async function q(j){try{const W=await e.Promises.lstat(j);if(W.isDirectory()||W.isSymbolicLink())return;await e.Promises.utimes(j,W.atime,new Date)}catch(W){}}try{await e.Promises.rename(A,M),await q(M)}catch(j){if(A.toLowerCase()!==M.toLowerCase()&&j.code==="EXDEV"||A.endsWith("."))await O(A,M,{preserveSymlinks:!1}),await h(A,p.MOVE),await q(M);else throw j}}async function O(A,M,q){return x(A,M,{root:{source:A,target:M},options:q,handledSourcePaths:new Set})}const U=511;async function x(A,M,q){if(q.handledSourcePaths.has(A))return;q.handledSourcePaths.add(A);const{stat:j,symbolicLink:W}=await n.stat(A);if(W){if(q.options.preserveSymlinks)try{return await z(A,M,q)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(W.dangling)return}return j.isDirectory()?N(A,M,j.mode&U,q):_(A,M,j.mode&U)}async function N(A,M,q,j){await e.Promises.mkdir(M,{recursive:!0,mode:q});const W=await S(A);for(const $ of W)await x((0,w.join)(A,$),(0,w.join)(M,$),j)}async function _(A,M,q){await e.Promises.copyFile(A,M),await e.Promises.chmod(M,q)}async function z(A,M,q){let j=await e.Promises.readlink(A);(0,i.isEqualOrParent)(j,q.root.source,!C.isLinux)&&(j=(0,w.join)(q.root.target,j.substr(q.root.source.length+1))),await e.Promises.symlink(j,M)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(0,D.promisify)(R.read)}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(0,D.promisify)(R.write)}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(A){try{return await e.Promises.access(A),!0}catch{return!1}}get readdir(){return S}get readDirsInDir(){return r}get writeFile(){return s}get rm(){return h}get move(){return T}get copy(){return O}}}),define(te[116],ne([0,1,51,10,25,20]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(I){const E=(0,L.dirname)(I);if(I===E)return I;const d=((0,L.basename)(I)||I).toLowerCase();try{const h=(0,k.readdirSync)(E).filter(b=>b.toLowerCase()===d);if(h.length===1){const b=i(E);if(b)return(0,L.join)(b,h[0])}else if(h.length>1){const b=h.indexOf(d);if(b>=0){const y=i(E);if(y)return(0,L.join)(y,h[b])}}}catch(p){}return null}e.realcaseSync=i;async function P(I){try{return await k.Promises.realpath(I)}catch(E){const d=C(I);return await k.Promises.access(d,R.constants.R_OK),d}}e.realpath=P;function w(I){try{return R.realpathSync(I)}catch(E){const d=C(I);return R.accessSync(d,R.constants.R_OK),d}}e.realpathSync=w;function C(I){return(0,D.rtrim)((0,L.normalize)(I),L.sep)}}),define(te[117],ne([0,1,57]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function L(P,w,C,I=1){let E=!1;return new Promise(d=>{const p=setTimeout(()=>{if(!E)return E=!0,d(0)},C);D(P,w,I,h=>{if(!E)return E=!0,clearTimeout(p),d(h)})})}e.findFreePort=L;function D(P,w,C,I){if(w===0)return I(0);const E=new R.Socket;E.once("connect",()=>(i(E),D(P+C,w-1,C,I))),E.once("data",()=>{}),E.once("error",d=>(i(E),d.code!=="ECONNREFUSED"?D(P+C,w-1,C,I):I(P))),E.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(P,w,C){let I=!1,E,d=1;const p=R.createServer({pauseOnConnect:!0});function h(b,y){I||(I=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),y(b))}return new Promise(b=>{E=setTimeout(()=>{h(0,b)},C),p.on("listening",()=>{h(P,b)}),p.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&d<w?(P++,d++,p.listen(P,"127.0.0.1")):h(0,b)}),p.on("close",()=>{h(0,b)}),p.listen(P,"127.0.0.1")})}e.findFreePortFaster=k;function i(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(w){console.error(w)}}}),define(te[72],ne([0,1,33,10,20]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,i=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var w;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(w||(w={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class E{constructor(u,r,o){this.exePath=u,this.displayName=r,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:a=!1}={}){return a?C===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:a=!1,findPreview:u=!1}={}){const r=d({useAlternateBitness:a});if(!r)return null;const o=L.join(r,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let n=-1,t=null;for(const l of await D.Promises.readdir(o)){let g=-1;if(u){const T=l.indexOf("-");if(T<0)continue;const O=l.substring(0,T);if(!k.test(O)||l.substring(T+1)!=="preview")continue;g=parseInt(O,10)}else{if(!k.test(l))continue;g=parseInt(l,10)}if(g<=n)continue;const v=L.join(o,l,"pwsh.exe");!await D.SymlinkSupport.existsFile(v)||(t=v,n=g)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",c=u?" Preview":"";return new E(t,`PowerShell${c}${s}`,!0)}async function h({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:r,pwshMsixName:o}=a?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:i,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(u))if(r.test(n)){const t=L.join(u,n,"pwsh.exe");return new E(t,o)}return null}function b(){const a=L.join(R.homedir(),".dotnet","tools","pwsh.exe");return new E(a,".NET Core PowerShell Global Tool")}function y(){const a=L.join(process.env.windir,C===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(a,"Windows PowerShell",!0)}async function*m(){let a=await p();a&&(yield a),a=await p({useAlternateBitness:!0}),a&&(yield a),a=await h(),a&&(yield a),a=b(),a&&(yield a),a=await p({findPreview:!0}),a&&(yield a),a=await h({findPreview:!0}),a&&(yield a),a=await p({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=y(),a&&(yield a)}async function*S(){for await(const a of m())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=S;async function f(){for await(const a of S())return a;return null}e.getFirstAvailablePowerShellInstallation=f}),define(te[118],ne([0,1,43,15]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(i){return new Promise((P,w)=>{let C;const I=new Map;function E(p,h,b,y,m){const S=I.get(h);if(p===i||S){const f={name:d(b),cmd:b,pid:p,ppid:h,load:y,mem:m};I.set(p,f),p===i&&(C=f),S&&(S.children||(S.children=[]),S.children.push(f),S.children.length>1&&(S.children=S.children.sort((a,u)=>a.pid-u.pid)))}}function d(p){const h=/--disable-blink-features=Auxclick/,b=/\\watcher\\win32\\CodeHelper\.exe/,y=/--crashes-directory/,m=/\\pipe\\winpty-control/,S=/conhost\.exe/,f=/--type=([a-zA-Z-]+)/;if(b.exec(p))return"watcherService ";if(y.exec(p))return"electron-crash-reporter";if(m.exec(p))return"winpty-process";if(S.exec(p))return"console-window-host (Windows internal process)";let a=f.exec(p);if(a&&a.length===2)return a[1]==="renderer"?h.exec(p)?"shared-process":"window":a[1];const u=/[a-zA-Z-]+\.js/g;let r="";do a=u.exec(p),a&&(r+=a+" ");while(a);return r&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${r}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,b)=>{X(["windows-process-tree"],h,b)}).then(h=>{h.getProcessList(i,b=>{h.getProcessCpuUsage(b,y=>{const m=new Map;y.forEach(S=>{const f=p(S.commandLine||"");m.set(S.pid,{name:d(f),cmd:f,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),C=m.get(i),C?(m.forEach(S=>{const f=m.get(S.ppid);f&&(f.children||(f.children=[]),f.children.push(S))}),m.forEach(S=>{S.children&&(S.children=S.children.sort((f,a)=>f.pid-a.pid))}),P(C)):w(new Error(`Root process ${i} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[C];const b=[];for(;h.length;){const m=h.shift();m&&(b.push(m.pid),m.children&&(h=h.concat(m.children)))}let y=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);y+=" "+b.join(" "),(0,R.exec)(y,{},(m,S,f)=>{if(m||f)w(m||new Error(f.toString()));else{const a=S.toString().split(`
`);for(let u=0;u<b.length;u++){const r=I.get(b[u]);r.load=parseFloat(a[u])}if(!C){w(new Error(`Root process ${i} not found`));return}P(C)}})};(0,R.exec)("which ps",{},(h,b,y)=>{if(h||y)if(process.platform!=="linux")w(h||new Error(y.toString()));else{const m=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);(0,R.exec)(m,{},(S,f,a)=>{S||a?w(S||new Error(a.toString())):(k(f,E),p())})}else{const m=b.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${m} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,a,u)=>{f||u&&!u.includes("screen size is bogus")?w(f||new Error(u.toString())):(k(a,E),process.platform==="linux"?p():C?P(C):w(new Error(`Root process ${i} not found`)))})}})}})}e.listProcesses=D;function k(i,P){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=i.toString().split(`
`);for(const I of C){const E=w.exec(I.trim());E&&E.length===6&&P(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(te[119],ne([0,1,51,27,42,2,71,10,4,20]),function(X,e,R,L,D,k,i,P,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function I(h,b,y){return d({path:h,isDirectory:!1},b,y)}e.watchFile=I;function E(h,b,y){return d({path:h,isDirectory:!0},b,y)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function d(h,b,y){if(w.isMacintosh&&(0,D.isEqualOrParent)(h.path,"/Volumes/"))return y(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const m=(0,P.basename)(h.path),S=new Map;let f=!1,a=[(0,k.toDisposable)(()=>{S.forEach(u=>(0,k.dispose)(u)),S.clear()})];try{const u=(0,R.watch)(h.path);a.push((0,k.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const r=new Set;h.isDirectory&&C.Promises.readdir(h.path).then(o=>o.forEach(n=>r.add(n))),u.on("error",(o,n)=>{f||y(`Failed to watch ${h.path} for changes using fs.watch() (${o}, ${n})`)}),u.on("change",(o,n)=>{if(f)return;let t="";if(n&&(t=n.toString(),w.isMacintosh&&(t=(0,i.normalizeNFC)(t))),!t||o!=="change"&&o!=="rename")return;const s=h.isDirectory?(0,P.join)(h.path,t):h.path;if(h.isDirectory)if(o==="rename"){const c=S.get(s);c&&(0,k.dispose)(c);const l=setTimeout(async()=>{S.delete(s);const g=await C.Promises.exists(s);if(f)return;let v;g?r.has(t)?v="changed":(v="added",r.add(t)):(r.delete(t),v="deleted"),b(v,s)},e.CHANGE_BUFFER_DELAY);S.set(s,(0,k.toDisposable)(()=>clearTimeout(l)))}else{let c;r.has(t)?c="changed":(c="added",r.add(t)),b(c,s)}else if(o==="rename"||t!==m){const c=setTimeout(async()=>{const l=await C.Promises.exists(s);f||(l?(b("changed",s),a=[d(h,b,y)]):b("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(a),a=[(0,k.toDisposable)(()=>clearTimeout(c))]}else b("changed",s)})}catch(u){C.Promises.exists(h.path).then(r=>{r&&!f&&y(`Failed to watch ${h.path} for changes using fs.watch() (${u.toString()})`)})}return(0,k.toDisposable)(()=>{f=!0,a=(0,k.dispose)(a)})}async function p(h,b,y,m=512){const S=await C.Promises.open(h,"r"),f=Buffer.allocUnsafe(m),a=new L.CancellationTokenSource(y);let u,r=!1;const o=I(h,async n=>{if(n==="changed"){if(r)return;r=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:t}=await C.Promises.read(S,f,0,m,null);if(!t||a.token.isCancellationRequested)break;b(f.slice(0,t))}}catch(t){u=new Error(t),a.dispose(!0)}finally{r=!1}}},n=>{u=new Error(n),a.dispose(!0)});return new Promise((n,t)=>{a.token.onCancellationRequested(async()=>{o.dispose(),await C.Promises.close(S),u?t(u):n()})})}e.watchFileContents=p});var he=this&&this.__decorate||function(X,e,R,L){var D=arguments.length,k=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,R):L,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(X,e,R,L);else for(var P=X.length-1;P>=0;P--)(i=X[P])&&(k=(D<3?i(k):D>3?i(e,R,k):i(e,R))||k);return D>3&&k&&Object.defineProperty(e,R,k),k};define(te[34],ne([0,1,16,5,19,27,68,8,3,2,108,25,17]),function(X,e,R,L,D,k,i,P,w,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(b=e.ResponseType||(e.ResponseType={}));function y(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(m||(m={}));class S{constructor($){this.buffer=$,this.pos=0}read($){const K=this.buffer.slice(this.pos,this.pos+$);return this.pos+=K.byteLength,K}}class f{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var a;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(a||(a={}));function u(W){const $=D.VSBuffer.alloc(4);return $.writeUInt32BE(W,0),$}function r(W){return W.read(4).readUInt32BE(0)}function o(W){const $=D.VSBuffer.alloc(1);return $.writeUInt8(W,0),$}const n={Undefined:o(a.Undefined),String:o(a.String),Buffer:o(a.Buffer),VSBuffer:o(a.VSBuffer),Array:o(a.Array),Object:o(a.Object)},t=typeof Buffer!="undefined";function s(W,$){if(typeof $=="undefined")W.write(n.Undefined);else if(typeof $=="string"){const K=D.VSBuffer.fromString($);W.write(n.String),W.write(u(K.byteLength)),W.write(K)}else if(t&&Buffer.isBuffer($)){const K=D.VSBuffer.wrap($);W.write(n.Buffer),W.write(u(K.byteLength)),W.write(K)}else if($ instanceof D.VSBuffer)W.write(n.VSBuffer),W.write(u($.byteLength)),W.write($);else if(Array.isArray($)){W.write(n.Array),W.write(u($.length));for(const K of $)s(W,K)}else{const K=D.VSBuffer.fromString(JSON.stringify($));W.write(n.Object),W.write(u(K.byteLength)),W.write(K)}}function c(W){switch(W.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return W.read(r(W)).toString();case a.Buffer:return W.read(r(W)).buffer;case a.VSBuffer:return W.read(r(W));case a.Array:{const K=r(W),F=[];for(let B=0;B<K;B++)F.push(c(W));return F}case a.Object:return JSON.parse(W.read(r(W)).toString())}}class l{constructor($,K,F=null,B=1e3){this.protocol=$,this.ctx=K,this.logger=F,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel($,K){this.channels.set($,K),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const K=this.send([$.type]);this.logger&&this.logger.logOutgoing(K,0,1,y($.type));return}case 201:case 202:case 204:case 203:{const K=this.send([$.type,$.id],$.data);this.logger&&this.logger.logOutgoing(K,$.id,1,y($.type),$.data);return}}}send($,K=void 0){const F=new f;return s(F,$),s(F,K),this.sendBuffer(F.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(K){return 0}}onRawMessage($){const K=new S($),F=c(K),B=c(K),V=F[0];switch(V){case 100:return this.logger&&this.logger.logIncoming($.byteLength,F[1],1,`${h(V)}: ${F[2]}.${F[3]}`,B),this.onPromise({type:V,id:F[1],channelName:F[2],name:F[3],arg:B});case 102:return this.logger&&this.logger.logIncoming($.byteLength,F[1],1,`${h(V)}: ${F[2]}.${F[3]}`,B),this.onEventListen({type:V,id:F[1],channelName:F[2],name:F[3],arg:B});case 101:return this.logger&&this.logger.logIncoming($.byteLength,F[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:F[1]});case 103:return this.logger&&this.logger.logIncoming($.byteLength,F[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:F[1]})}}onPromise($){const K=this.channels.get($.channelName);if(!K){this.collectPendingRequest($);return}const F=new k.CancellationTokenSource;let B;try{B=K.call(this.ctx,$.name,$.arg,F.token)}catch(Z){B=Promise.reject(Z)}const V=$.id;B.then(Z=>{this.sendResponse({id:V,data:Z,type:201}),this.activeRequests.delete($.id)},Z=>{Z instanceof Error?this.sendResponse({id:V,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:V,data:Z,type:203}),this.activeRequests.delete($.id)});const Q=(0,C.toDisposable)(()=>F.cancel());this.activeRequests.set($.id,Q)}onEventListen($){const K=this.channels.get($.channelName);if(!K){this.collectPendingRequest($);return}const F=$.id,V=K.listen(this.ctx,$.name,$.arg)(Q=>this.sendResponse({id:F,data:Q,type:204}));this.activeRequests.set($.id,V)}disposeActiveRequest($){const K=this.activeRequests.get($.id);K&&(K.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let K=this.pendingRequests.get($.channelName);K||(K=[],this.pendingRequests.set($.channelName,K));const F=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:$,timeoutTimer:F})}flushPendingRequests($){const K=this.pendingRequests.get($);if(K){for(const F of K)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var g;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor($,K=null){this.protocol=$,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=K}getChannel($){const K=this;return{call(F,B,V){return K.isDisposed?Promise.reject(P.canceled()):K.requestPromise($,F,B,V)},listen(F,B){return K.isDisposed?Promise.reject(P.canceled()):K.requestEvent($,F,B)}}}requestPromise($,K,F,B=k.CancellationToken.None){const V=this.lastRequestId++,Z={id:V,type:100,channelName:$,name:K,arg:F};if(B.isCancellationRequested)return Promise.reject(P.canceled());let G;return new Promise((re,ie)=>{if(B.isCancellationRequested)return ie(P.canceled());const ce=()=>{const be=Ie=>{switch(Ie.type){case 201:this.handlers.delete(V),re(Ie.data);break;case 202:this.handlers.delete(V);const Ee=new Error(Ie.data.message);Ee.stack=Ie.data.stack,Ee.name=Ie.data.name,ie(Ee);break;case 203:this.handlers.delete(V),ie(Ie.data);break}};this.handlers.set(V,be),this.sendRequest(Z)};let le=null;this.state===m.Idle?ce():(le=(0,L.createCancelablePromise)(be=>this.whenInitialized()),le.then(()=>{le=null,ce()}));const fe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:V,type:101}),ie(P.canceled())},de=B.onCancellationRequested(fe);G=(0,C.combinedDisposable)((0,C.toDisposable)(fe),de),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent($,K,F){const B=this.lastRequestId++,Q={id:B,type:102,channelName:$,name:K,arg:F};let Z=null;const G=new w.Emitter({onFirstListenerAdd:()=>{Z=(0,L.createCancelablePromise)(re=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(G),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(G),this.sendRequest({id:B,type:103}))}}),H=re=>G.fire(re.data);return this.handlers.set(B,H),G.event}sendRequest($){switch($.type){case 100:case 102:{const K=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger&&this.logger.logOutgoing(K,$.id,0,`${h($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const K=this.send([$.type,$.id]);this.logger&&this.logger.logOutgoing(K,$.id,0,h($.type));return}}}send($,K=void 0){const F=new f;return s(F,$),s(F,K),this.sendBuffer(F.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch(K){return 0}}onBuffer($){const K=new S($),F=c(K),B=c(K),V=F[0];switch(V){case 200:return this.logger&&this.logger.logIncoming($.byteLength,0,0,y(V)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming($.byteLength,F[1],0,y(V),B),this.onResponse({type:F[0],id:F[1],data:B})}}onResponse($){if($.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get($.id);K&&K($)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}he([i.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class T{constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:K,onDidClientDisconnect:F})=>{w.Event.once(K.onMessage)(V=>{const Q=new S(V),Z=c(Q),G=new l(K,Z),H=new v(K);this.channels.forEach((ie,ce)=>G.registerChannel(ce,ie));const re={channelServer:G,channelClient:H,ctx:Z};this._connections.add(re),this._onDidAddConnection.fire(re),F(()=>{G.dispose(),H.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const $=[];return this._connections.forEach(K=>$.push(K)),$}getChannel($,K){const F=this;return{call(B,V,Q){let Z;if((0,d.isFunction)(K)){let H=(0,R.getRandomElement)(F.connections.filter(K));Z=H?Promise.resolve(H):w.Event.toPromise(w.Event.filter(F.onDidAddConnection,K))}else Z=K.routeCall(F,B,V);const G=Z.then(H=>H.channelClient.getChannel($));return U(G).call(B,V,Q)},listen(B,V){if((0,d.isFunction)(K))return F.getMulticastEvent($,K,B,V);const Q=K.routeEvent(F,B,V).then(Z=>Z.channelClient.getChannel($));return U(Q).listen(B,V)}}}getMulticastEvent($,K,F,B){const V=this;let Q=new C.DisposableStore;const Z=new w.Emitter({onFirstListenerAdd:()=>{Q=new C.DisposableStore;const G=new w.EventMultiplexer,H=new Map,re=ce=>{const fe=ce.channelClient.getChannel($).listen(F,B),de=G.add(fe);H.set(ce,de)},ie=ce=>{const le=H.get(ce);!le||(le.dispose(),H.delete(ce))};V.connections.filter(K).forEach(re),w.Event.filter(V.onDidAddConnection,K)(re,void 0,Q),V.onDidRemoveConnection(ie,void 0,Q),G.event(Z.fire,Z,Q),Q.add(G)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel($,K){this.channels.set($,K),this._connections.forEach(F=>{F.channelServer.registerChannel($,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class O{constructor($,K,F=null){const B=new f;s(B,K),$.send(B.buffer),this.channelClient=new v($,F),this.channelServer=new l($,K,F)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,K){this.channelServer.registerChannel($,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function U(W){return{call($,K,F){return W.then(B=>B.call($,K,F))},listen($,K){const F=new w.Relay;return W.then(B=>F.input=B.listen($,K)),F.event}}}e.getDelayedChannel=U;function x(W){let $=!1;return{call(K,F,B){return $?W.call(K,F,B):(0,L.timeout)(0).then(()=>$=!0).then(()=>W.call(K,F,B))},listen(K,F){if($)return W.listen(K,F);const B=new w.Relay;return(0,L.timeout)(0).then(()=>$=!0).then(()=>B.input=W.listen(K,F)),B.event}}}e.getNextTickChannel=x;class N{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const K of $.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await w.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=N;var _;(function(W){function $(V,Q){const Z=V,G=Q&&Q.disableMarshalling,H=new Map;for(const re in Z)F(re)&&H.set(re,w.Event.buffer(Z[re],!0));return new class{listen(re,ie,ce){const le=H.get(ie);if(le)return le;if(B(ie)){const fe=Z[ie];if(typeof fe=="function")return fe.call(Z,ce)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ce){const le=Z[ie];if(typeof le=="function"){if(!G&&Array.isArray(ce))for(let fe=0;fe<ce.length;fe++)ce[fe]=(0,I.revive)(ce[fe]);return le.apply(Z,ce)}throw new Error(`Method not found: ${ie}`)}}}W.fromService=$;function K(V,Q){const Z=Q&&Q.disableMarshalling;return new Proxy({},{get(G,H){if(typeof H=="string")return Q?.properties?.has(H)?Q.properties.get(H):B(H)?function(re){return V.listen(H,re)}:F(H)?V.listen(H):async function(...re){let ie;Q&&!(0,d.isUndefinedOrNull)(Q.context)?ie=[Q.context,...re]:ie=re;const ce=await V.call(H,ie);return Z?ce:(0,I.revive)(ce)};throw new Error(`Property not found: ${String(H)}`)}})}W.toService=K;function F(V){return V[0]==="o"&&V[1]==="n"&&E.isUpperAsciiLetter(V.charCodeAt(2))}function B(V){return/^onDynamic/.test(V)&&E.isUpperAsciiLetter(V.charCodeAt(9))}})(_=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function A(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){let $=W.toString();if($!=="[object Object]")return $}return W}function M(W){return Array.isArray(W)?W.map(A):A(W)}function q(W,$,K,F,B,V,Q){Q=M(Q);const Z=z[B],G=Z[F%Z.length];let H=[`%c[${W}]%c[${String($).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(V)?(H=H.concat(Q),H.push(")")):H.push(Q),console.log.apply(console,H)}e.logWithColors=q;class j{constructor($,K){this._outgoingPrefix=$,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,K,F,B,V){this._totalOutgoing+=$,q(this._outgoingPrefix,this._totalOutgoing,$,K,F,B,V)}logIncoming($,K,F,B,V){this._totalIncoming+=$,q(this._incomingPrefix,this._totalIncoming,$,K,F,B,V)}}e.IPCLogger=j}),define(te[120],ne([0,1,19,3,34]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(w){this.port=w,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",C=>R.VSBuffer.wrap(C.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class i extends D.IPCClient{constructor(w,C){const I=new k(w);super(I,C);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=i}),define(te[73],ne([0,1,19,3,2,4,31,34]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var w;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function I(){return C||(C=R.VSBuffer.alloc(0)),C}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,s){if(t===0)return I();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const v=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=t),v}if(this._chunks[0].byteLength>t){const v=this._chunks[0].slice(0,t);return s&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),v}let c=R.VSBuffer.alloc(t),l=0,g=0;for(;t>0;){const v=this._chunks[g];if(v.byteLength>t){const T=v.slice(0,t);c.set(T,l),l+=t,s&&(this._chunks[g]=v.slice(t),this._totalLength-=t),t-=t}else c.set(v,l),l+=v.byteLength,s?(this._chunks.shift(),this._totalLength-=v.byteLength):g++,t-=v.byteLength}return c}}e.ChunkStream=E;var d;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(d||(d={}));var p;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(t,s,c,l){this.type=t,this.id=s,this.ack=c,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends D.Disposable{constructor(t){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5);else{const c=this._state.messageType,l=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(c,l,g,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=R.VSBuffer.alloc(13);s.writeUInt8(t.type,0),s.writeUInt32BE(t.id,1),s.writeUInt32BE(t.ack,5),s.writeUInt32BE(t.data.byteLength,9),this._writeSoon(s,t.data)}_bufferAdd(t,s){const c=this._totalLength===0;return this._data.push(t,s),this._totalLength+=t.byteLength+s.byteLength,c}_bufferTake(){const t=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,s){this._bufferAdd(t,s)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class m extends D.Disposable{constructor(t){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new b(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new h(1,0,0,t))}}e.Protocol=m;class S extends P.IPCClient{constructor(t,s,c=null){super(t,s,c);this.protocol=t}static fromSocket(t,s){return new S(new m(t),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=S;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,i.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class a{constructor(t){this.data=t,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],s=0,c=this._first;for(;c;)t[s++]=c.data,c=c.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const s=new a(t);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class r{constructor(){this.lastRuns=[];const t=Date.now();for(let s=0;s<r._HISTORY_LENGTH;s++)this.lastRuns[s]=t-1e3*s;setInterval(()=>{for(let s=r._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const t=Date.now(),s=(1+r._HISTORY_LENGTH)*1e3;let c=0;for(let l=0;l<r._HISTORY_LENGTH;l++)t-this.lastRuns[l]<=s&&c++;return 1-c/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class o{constructor(t,s=null,c=r.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),s&&this._socketReader.acceptChunk(s),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new h(5,0,0,I());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const s=new h(4,0,0,I());this._socketWriter.write(s),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,s){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new b(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let s=0,c=t.length;s<c;s++)this._socketWriter.write(t[s]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new h(6,0,0,I())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const s=this._outgoingUnackMsg.toArray();for(let c=0,l=s.length;c<l;c++)this._socketWriter.write(s[c]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new h(1,s,this._incomingAckId,t);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(t){const s=new h(2,0,0,t);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),s=Date.now()-t.writtenTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-s,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new h(3,0,this._incomingAckId,I());this._socketWriter.write(t)}}e.PersistentProtocol=o}),define(te[121],ne([0,1,74,3,34,120]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class i extends D.IPCServer{static getOnDidClientConnect(){const w=L.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(C,I)=>I);return L.Event.map(w,C=>{const{port1:I,port2:E}=new MessageChannel,p={protocol:new k.Protocol(I),onDidClientDisconnect:L.Event.fromDOMEventEmitter(I,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",C,[E]),p})}constructor(){super(i.getOnDidClientConnect())}}e.Server=i}),define(te[122],ne([0,1,19,8]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(P,w){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((I,E)=>{C.open(P.type||"GET",P.url||"",!0,P.user,P.password),k(C,P),C.responseType="arraybuffer",C.onerror=d=>E(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=d=>{I({res:{statusCode:C.status,headers:i(C)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=d=>E(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(C.timeout=P.timeout),C.send(P.data),w.onCancellationRequested(()=>{C.abort(),E((0,L.canceled)())})})}e.request=D;function k(P,w){if(w.headers){e:for(let C in w.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(C,w.headers[C])}}}function i(P){const w=Object.create(null);for(const C of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const I=C.indexOf(":");w[C.substr(0,I).trim().toLowerCase()]=C.substr(I+1).trim()}return w}}),define(te[75],ne([0,1,5,3,2,17]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var i;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(i=e.StorageHint||(e.StorageHint={}));function P(E){const d=E;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var w;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(w||(w={}));class C extends D.Disposable{constructor(d,p=Object.create(null)){super();this.database=d,this.options=p,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((p,h)=>this.accept(h,p)),d.deleted?.forEach(p=>this.accept(p,void 0))}accept(d,p){if(this.state===w.Closed)return;let h=!1;(0,k.isUndefinedOrNull)(p)?h=this.cache.delete(d):this.cache.get(d)!==p&&(this.cache.set(d,p),h=!0),h&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==i.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,p){const h=this.cache.get(d);return(0,k.isUndefinedOrNull)(h)?p:h}getBoolean(d,p){const h=this.get(d);return(0,k.isUndefinedOrNull)(h)?p:h==="true"}getNumber(d,p){const h=this.get(d);return(0,k.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(d,p){if(this.state===w.Closed)return;if((0,k.isUndefinedOrNull)(p))return this.delete(d);const h=String(p);if(this.cache.get(d)!==h)return this.cache.set(d,h),this.pendingInserts.set(d,h),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===w.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.doFlush(0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((p,h)=>this.items.set(h,p)),d.delete&&d.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=I}),define(te[123],ne([12,13]),function(X,e){return X.create("vs/base/common/date",e)}),define(te[58],ne([0,1,123]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,k=D*24,i=k*7,P=k*30,w=k*365;function C(E,d){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,R.localize)(0,null,C(new Date().getTime()+p*1e3,!1));if(p<30)return(0,R.localize)(1,null);let h;return p<L?(h=p,d?h===1?(0,R.localize)(2,null,h):(0,R.localize)(3,null,h):h===1?(0,R.localize)(4,null,h):(0,R.localize)(5,null,h)):p<D?(h=Math.floor(p/L),d?h===1?(0,R.localize)(6,null,h):(0,R.localize)(7,null,h):h===1?(0,R.localize)(8,null,h):(0,R.localize)(9,null,h)):p<k?(h=Math.floor(p/D),d?h===1?(0,R.localize)(10,null,h):(0,R.localize)(11,null,h):h===1?(0,R.localize)(12,null,h):(0,R.localize)(13,null,h)):p<i?(h=Math.floor(p/k),d?h===1?(0,R.localize)(14,null,h):(0,R.localize)(15,null,h):h===1?(0,R.localize)(16,null,h):(0,R.localize)(17,null,h)):p<P?(h=Math.floor(p/i),d?h===1?(0,R.localize)(18,null,h):(0,R.localize)(19,null,h):h===1?(0,R.localize)(20,null,h):(0,R.localize)(21,null,h)):p<w?(h=Math.floor(p/P),d?h===1?(0,R.localize)(22,null,h):(0,R.localize)(23,null,h):h===1?(0,R.localize)(24,null,h):(0,R.localize)(25,null,h)):(h=Math.floor(p/w),d?h===1?(0,R.localize)(26,null,h):(0,R.localize)(27,null,h):h===1?(0,R.localize)(28,null,h):(0,R.localize)(29,null,h))}e.fromNow=C;function I(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(te[124],ne([12,13]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,16,17,124]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(C,I){return I&&(C.stack||C.stacktrace)?D.localize(0,null,P(C),i(C.stack)||i(C.stacktrace)):P(C)}function i(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?D.localize(1,null,C.message):C.message||D.localize(2,null)}function w(C=null,I=!1){if(!C)return D.localize(3,null);if(Array.isArray(C)){const E=R.coalesce(C),d=w(E[0],I);return E.length>1?D.localize(4,null,d,E.length):d}if(L.isString(C))return C;if(C.detail){const E=C.detail;if(E.error)return k(E.error,I);if(E.exception)return k(E.exception,I)}return C.stack?k(C,I):C.message?C.message:D.localize(5,null)}e.toErrorMessage=w}),define(te[125],ne([12,13]),function(X,e){return X.create("vs/base/node/processes",e)}),define(te[76],ne([0,1,43,42,15,28,10,4,31,104,17,112,20,125]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function b(r,o){if(P.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};o&&(n.cwd=o);const t=R.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],n);return new Promise(s=>{t.once("error",c=>{s({success:!1,error:c})}),t.once("exit",(c,l)=>{s(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(P.isLinux||P.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(t=>{R.execFile(n,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,c,l)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function y(r){!r||(delete r.DEBUG,P.isMacintosh&&delete r.DYLD_LIBRARY_PATH,P.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=y;function m(r=w.env){return r.comspec||"cmd.exe"}e.getWindowsShell=m;class S{constructor(o,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=o,this.args=n,this.shell=t,this.options=s;else{const c=o;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(w.env).forEach(l=>{c[l]=w.env[l]}),Object.keys(this.options.env).forEach(l=>{c[l]=this.options.env[l]}),this.options.env=c}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const n=o.lastIndexOf(i.sep);return n!==-1&&(o=o.substring(n+1)),S.WellKnowCommands[o]?o:"other"}start(o){return P.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(w.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(n=>{let t,s;const c=new Promise((l,g)=>{t=l,s=g});if(n){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=R.exec(l,this.options,(g,v,T)=>{this.childProcess=null;const O=g;O&&O.killed?s({killed:this.terminateRequested,stdout:v.toString(),stderr:T.toString()}):this.handleExec(t,o,g,v,T)})}else{let l=null;const g=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,t,o,s);const T={terminated:this.terminateRequested};I.isNumber(v)&&(T.cmdCode=v),t(T)};if(this.shell&&P.isWindows){const v=k.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let T=!1,O=!1;const U=[];let x=this.ensureQuotes(this.cmd);U.push(x.value),T=x.quoted,this.args&&this.args.forEach(_=>{x=this.ensureQuotes(_),U.push(x.value),O=O&&x.quoted});const N=["/s","/c"];T?O?N.push('"'+U.join(" ")+'"'):U.length>1?N.push('"'+U[0]+'" '+U.slice(1).join(" ")):N.push('"'+U[0]+'"'):N.push(U.join(" ")),l=R.spawn(m(),N,v)}else this.cmd&&(l=R.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(I.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",v=>{this.childProcess=null,s({terminated:this.terminateRequested,error:v})}),l.pid&&(this.childProcess.on("close",g),this.handleSpawn(l,t,o,s,!0)))}return c})}handleClose(o,n,t,s){}ensureQuotes(o){return S.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,b(o,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!P.isWindows)return o(!1);const n=R.spawn(m(),["/s","/c"]);n.on("error",t=>o(!0)),n.on("exit",t=>o(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class f extends S{constructor(o,n,t,s){super(o,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,n,t,s,c){[s,c].forEach((l,g)=>{const v=new E.LineDecoder;v.write(l).forEach(U=>{n({line:U,source:g===0?0:1})});const O=v.end();O&&n({line:O,source:g===0?0:1})}),o({terminated:this.terminateRequested,error:t})}handleSpawn(o,n,t,s,c){const l=new E.LineDecoder,g=new E.LineDecoder;o.stdout.on("data",v=>{l.write(v).forEach(O=>t({line:O,source:0}))}),o.stderr.on("data",v=>{g.write(v).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=g}handleClose(o,n,t,s){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&t({line:c,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&t({line:l,source:1})}}e.LineProcess=f;function a(r){let o=[],n=!1;const t=function(s){if(n){o.push(s);return}(!r.send(s,l=>{if(l&&console.error(l),n=!1,o.length>0){const g=o.slice(0);o=[],g.forEach(v=>t(v))}})||P.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=a;var u;(function(r){async function o(n,t,s){if(i.isAbsolute(n))return n;if(t===void 0&&(t=w.cwd()),i.dirname(n)!=="."||(s===void 0&&I.isString(w.env.PATH)&&(s=w.env.PATH.split(i.delimiter)),s===void 0||s.length===0))return i.join(t,n);async function l(g){if(await d.Promises.exists(g)){let v;try{v=await d.Promises.stat(g)}catch(T){T.message.startsWith("EACCES")&&(v=await d.Promises.lstat(g))}return v?!v.isDirectory():!1}return!1}for(let g of s){let v;if(i.isAbsolute(g)?v=i.join(g,n):v=i.join(t,g,n),await l(v))return v;let T=v+".com";if(await l(T)||(T=v+".exe",await l(T)))return T}return i.join(t,n)}r.findExecutable=o})(u=e.win32||(e.win32={}))}),define(te[126],ne([0,1,33,4,72,76]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function i(p,h){return p===1?L.isWindows?E():k.getWindowsShell(h):C(p,h)}e.getSystemShell=i;function P(p,h){return p===1?L.isWindows?d(h):k.getWindowsShell(h):C(p,h)}e.getSystemShellSync=P;let w=null;function C(p,h){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!w){let b;if(L.isWindows)b="/bin/bash";else{if(b=h.SHELL,!b)try{b=(0,R.userInfo)().shell}catch(y){}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}w=b}return w}let I=null;async function E(){return I||(I=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),I}function d(p){if(I)return I;const h=L.isWindows&&parseFloat((0,R.release)())>=10,b=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${p.windir}\\${b?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?y:k.getWindowsShell(p)}}),define(te[52],ne([0,1,43,5,19,27,107,8,3,2,28,76,34]),function(X,e,R,L,D,k,i,P,w,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends d.ChannelServer{constructor(y){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(S){}},onMessage:w.Event.fromNodeEventEmitter(process,"message",m=>D.VSBuffer.wrap(Buffer.from(m,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=p;class h{constructor(y,m){this.modulePath=y,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new L.Delayer(S),this.child=null,this._client=null}getChannel(y){const m=this;return{call(S,f,a){return m.requestPromise(y,S,f,a)},listen(S,f){return m.requestEvent(y,S,f)}}}requestPromise(y,m,S,f=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(y),u=(0,L.createCancelablePromise)(n=>a.call(m,S,n)),r=f.onCancellationRequested(()=>u.cancel()),o=(0,C.toDisposable)(()=>u.cancel());return this.activeRequests.add(o),u.finally(()=>{r.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(y,m,S){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let f;const a=new w.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(y).listen(m,S)(a.fire,a),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,E.removeDangerousEnvVariables)(m.env),this.child=(0,R.fork)(this.modulePath,y,m);const S=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,i.isRemoteConsoleLog)(t)){(0,i.log)(t,`IPC Library: ${this.options.serverName}`);return}S.fire(D.VSBuffer.wrap(Buffer.from(t,"base64")))});const a=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,u=t=>this.child&&this.child.connected&&a.send(t.buffer.toString("base64")),r=S.event,o={send:u,onMessage:r};this._client=new d.ChannelClient(o);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",n),this.activeRequests.forEach(c=>(0,C.dispose)(c)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(y){let m=this.channels.get(y);return m||(m=this.client.getChannel(y),this.channels.set(y,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[127],ne([12,13]),function(X,e){return X.create("vs/base/node/zip",e)}),define(te[128],ne([12,13]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[129],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(te[130],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(te[131],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/shellEnv",e)}),define(te[132],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[133],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[134],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[135],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[136],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[137],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[138],ne([12,13]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[139],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(te[140],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(te[141],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(te[142],ne([12,13]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[143],ne([12,13]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(te[144],ne([12,13]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[145],ne([12,13]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[146],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[147],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[148],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[149],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[150],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[151],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[152],ne([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var L;(function(i){i.Team="team",i.Internal="internal",i.Insiders="insider",i.Public="public"})(L=e.TargetPopulation||(e.TargetPopulation={}));var D;(function(i){i.Market="X-MSEdge-Market",i.CorpNet="X-FD-Corpnet",i.ApplicationVersion="X-VSCode-AppVersion",i.Build="X-VSCode-Build",i.ClientId="X-MSEdge-ClientId",i.ExtensionName="X-VSCode-ExtensionName",i.Language="X-VSCode-Language",i.TargetPopulation="X-VSCode-TargetPopulation"})(D=e.Filters||(e.Filters={}));class k{constructor(P,w,C,I){this.version=P,this.appName=w,this.machineId=C,this.targetPopulation=I}getFilterValue(P){switch(P){case D.ApplicationVersion:return this.version;case D.Build:return this.appName;case D.ClientId:return this.machineId;case D.Language:return R.language;case D.ExtensionName:return"vscode-core";case D.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let P=new Map,w=Object.values(D);for(let C of w)P.set(C,this.getFilterValue(C));return P}}e.AssignmentFilterProvider=k}),define(te[77],ne([0,1,58,68,15,10,31,18,9]),function(X,e,R,L,D,k,i,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class C{constructor(b,y,m){this._args=b,this.paths=y,this.productService=m}get appRoot(){return(0,k.dirname)(D.FileAccess.asFileUri("",X).fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const b=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",b)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(w.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return w.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return w.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const b=i.env.VSCODE_PORTABLE;return b?w.URI.file((0,k.join)(b,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const b=this.args["builtin-extensions-dir"];return b?(0,k.resolve)(b):(0,k.normalize)((0,k.join)(D.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const b=this.args["extensions-download-dir"];return b?(0,k.resolve)(b):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const b=this.args["extensions-dir"];if(b)return(0,k.resolve)(b);const y=i.env.VSCODE_EXTENSIONS;if(y)return y;const m=i.env.VSCODE_PORTABLE;return m?(0,k.join)(m,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const b=this.args.extensionDevelopmentPath;if(Array.isArray(b))return b.map(y=>/^[^:/?#]+?:\/\//.test(y)?w.URI.parse(y):w.URI.file((0,k.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(b=>b==="ui"||b==="workspace"||b==="web"?b:"workspace")}get extensionTestsLocationURI(){const b=this.args.extensionTestsPath;if(b)return/^[^:/?#]+?:\/\//.test(b)?w.URI.parse(b):w.URI.file((0,k.normalize)(b))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const b=this.args["disable-extension"];if(b){if(typeof b=="string")return[b];if(Array.isArray(b)&&b.length>0)return b}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!i.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return w.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],C.prototype,"appRoot",null),he([L.memoize],C.prototype,"userHome",null),he([L.memoize],C.prototype,"userDataPath",null),he([L.memoize],C.prototype,"appSettingsHome",null),he([L.memoize],C.prototype,"tmpDir",null),he([L.memoize],C.prototype,"userRoamingDataHome",null),he([L.memoize],C.prototype,"settingsResource",null),he([L.memoize],C.prototype,"userDataSyncHome",null),he([L.memoize],C.prototype,"userDataSyncLogResource",null),he([L.memoize],C.prototype,"sync",null),he([L.memoize],C.prototype,"machineSettingsResource",null),he([L.memoize],C.prototype,"globalStorageHome",null),he([L.memoize],C.prototype,"workspaceStorageHome",null),he([L.memoize],C.prototype,"keybindingsResource",null),he([L.memoize],C.prototype,"keyboardLayoutResource",null),he([L.memoize],C.prototype,"argvResource",null),he([L.memoize],C.prototype,"snippetsHome",null),he([L.memoize],C.prototype,"isExtensionDevelopment",null),he([L.memoize],C.prototype,"untitledWorkspacesHome",null),he([L.memoize],C.prototype,"installSourcePath",null),he([L.memoize],C.prototype,"builtinExtensionsPath",null),he([L.memoize],C.prototype,"extensionsPath",null),he([L.memoize],C.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],C.prototype,"extensionDevelopmentKind",null),he([L.memoize],C.prototype,"extensionTestsLocationURI",null),he([L.memoize],C.prototype,"debugExtensionHost",null),he([L.memoize],C.prototype,"serviceMachineIdResource",null),he([L.memoize],C.prototype,"telemetryLogResource",null),he([L.memoize],C.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=C;function I(h,b){return p(h["inspect-extensions"],h["inspect-brk-extensions"],5870,b,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function E(h,b){return p(h["inspect-search"],h["inspect-brk-search"],5876,b,h.extensionEnvironment)}e.parseSearchPort=E;function d(h,b){return p(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,b,h.extensionEnvironment)}e.parsePtyHostPort=d;function p(h,b,y,m,S,f){const u=Number(b||h)||(m?null:y),r=u?Boolean(!!b):!1;let o;if(f)try{o=JSON.parse(f)}catch{}return{port:u,break:r,debugId:S,env:o}}}),define(te[153],ne([0,1,247,4,129]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const i={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(h,b,y=i){const m={},S=[],f=[];for(let o in b){const n=b[o];n.alias&&(m[o]=n.alias),n.type==="string"||n.type==="string[]"?(S.push(o),n.deprecates&&S.push(n.deprecates)):n.type==="boolean"&&(f.push(o),n.deprecates&&f.push(n.deprecates))}const a=R(h,{string:S,boolean:f,alias:m}),u={},r=a;u._=a._.map(o=>String(o)).filter(o=>o.length>0),delete r._;for(let o in b){const n=b[o];n.alias&&delete r[n.alias];let t=r[o];n.deprecates&&r.hasOwnProperty(n.deprecates)&&(t||(t=r[n.deprecates]),delete r[n.deprecates]),typeof t!="undefined"&&(n.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):n.type==="string"&&Array.isArray(t)&&(t=t.pop(),y.onMultipleValues(o,t)),u[o]=t),delete r[o]}for(let o in r)y.onUnknownOption(o);return u}e.parseArgs=P;function w(h,b){let y="";return b.args&&(Array.isArray(b.args)?y=` <${b.args.join("> <")}>`:y=` <${b.args}>`),b.alias?`-${b.alias} --${h}${y}`:`--${h}${y}`}function C(h,b){let y=0,m=[];for(const u in h){const r=h[u],o=w(u,r);y=Math.max(y,o.length),m.push([o,r.description])}let S=y+2+1;if(b-S<25)return m.reduce((u,r)=>u.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let f=b-S-1,a=[];for(const u of m){let r=u[0],o=E(u[1],f),n=I(S-r.length-2);a.push("  "+r+n+o[0]);for(let t=1;t<o.length;t++)a.push(I(S)+o[t])}return a}e.formatOptions=C;function I(h){return" ".repeat(h)}function E(h,b){let y=[];for(;h.length;){let m=h.length<b?h.length:h.lastIndexOf(" ",b),S=h.slice(0,m).trim();h=h.slice(m),y.push(S)}return y}function d(h,b,y,m,S=!0){const f=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${h} ${y}`];a.push(""),a.push(`${(0,D.localize)(32,null)}: ${b} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),a.push(""),S&&(L.isWindows?a.push((0,D.localize)(35,null,b)):a.push((0,D.localize)(36,null,b)),a.push(""));const u={};for(const r in m){const o=m[r];if(o.description&&o.cat){let n=u[o.cat];n||(u[o.cat]=n={}),n[r]=o}}for(let r in u){const o=r;let n=u[o];n&&(a.push(k[o]),a.push(...C(n,f)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=d;function p(h,b){return`${h||(0,D.localize)(37,null)}
${b||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function X(e,R,L,D){function k(P){const w=i(P),C=[w];return e.isAbsolute(w)||C.unshift(D),e.resolve(...C)}function i(P){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,L);const I=P["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(E,"AppData","Roaming")}break;case"darwin":C=e.join(R.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,L)}return{getUserDataPath:k}}if(typeof define=="function")define(te[154],ne([0,155,33,15,18,31]),function(e,R,L,D,k,i){const P=k.dirname(D.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(k.joinPath(P,"package.json").fsPath);return X(R,L,w.name,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),L=require("os");module.exports=X(R,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[156],ne([0,1,33,77,154]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends L.AbstractNativeEnvironmentService{constructor(P,w){super(P,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P)},w)}}e.NativeEnvironmentService=k}),define(te[157],ne([0,1,9]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,i=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,w=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function C(y){const m=y.match(i);return m?m[1]:null}function I(y){if(y.indexOf("://")===-1){const m=y.match(L);return m?C(m[2]):null}try{const m=R.URI.parse(y);if(m.authority)return C(m.authority)}catch(m){}return null}function E(y,m){const S=new Set;let f;for(;f=P.exec(y);){const u=I(f[1]);u&&S.add(u)}const a=new Set(m);return Array.from(S).map(u=>a.has(u)?u:u.replace(w,"a"))}e.getDomainsOfRemotes=E;function d(y){const m=y.match(k);return m?m[2]:null}function p(y,m,S){return y&&m?(S&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${y}${m}`:`${y}/${m}`):null}function h(y,m){if(y.indexOf("://")===-1){const S=y.match(D);if(S)return p(S[2],S[3],m)}try{const S=R.URI.parse(y);if(S.authority)return p(d(S.authority),S.path,m)}catch(S){}return null}function b(y,m=!1){const S=[];let f;for(;f=P.exec(y);){const a=h(f[1],m);a&&S.push(a)}return S}e.getRemotes=b}),define(te[158],ne([0,1,28]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function D(k,i){const P=w=>{if(typeof w!="string")return;const C=L.exec(w);if(!C)return;const I=i[C[1]]??w;return typeof I=="string"?I:typeof I.message=="string"?I.message:w};return(0,R.cloneAndChange)(k,P)}e.localizeManifest=D}),define(te[159],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(k){this.channel=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,i,P,w){return this.channel.call("promptImportantExtensionsInstallNotification",[k,i,P,w])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class L{constructor(k){this.service=k}listen(k,i){throw new Error(`Event not found: ${i}`)}call(k,i,P){switch(i){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${i}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[78],ne([0,1,138]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function k(d){return d=d.trim(),d==="*"||L.test(d)}e.isValidVersionStr=k;function i(d){if(!k(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=d.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=i;function P(d){if(!d)return null;let p=d.majorBase,h=d.majorMustEqual,b=d.minorBase,y=d.minorMustEqual,m=d.patchBase,S=d.patchMustEqual;d.hasCaret&&(p===0||(y=!1),S=!1);let f=0;if(d.preRelease){const a=D.exec(d.preRelease);if(a){const[,u,r,o]=a;f=Date.UTC(Number(u),Number(r)-1,Number(o))}}return{majorBase:p,majorMustEqual:h,minorBase:b,minorMustEqual:y,patchBase:m,patchMustEqual:S,isMinimum:d.hasGreaterEquals,notBefore:f}}e.normalizeVersion=P;function w(d,p,h){let b;typeof d=="string"?b=P(i(d)):b=d;let y;p instanceof Date?y=p.getTime():typeof p=="string"&&(y=new Date(p).getTime());let m;if(typeof h=="string"?m=P(i(h)):m=h,!b||!m)return!1;let S=b.majorBase,f=b.minorBase,a=b.patchBase,u=m.majorBase,r=m.minorBase,o=m.patchBase,n=m.notBefore,t=m.majorMustEqual,s=m.minorMustEqual,c=m.patchMustEqual;return m.isMinimum?S>u?!0:S<u?!1:f>r?!0:f<r||y&&y<n?!1:a>=o:(S===1&&u===0&&(!t||!s||!c)&&(u=1,r=0,o=0,t=!0,s=!1,c=!1),S<u?!1:S>u?!t:f<r?!1:f>r?!s:a<o?!1:a>o?!c:!(y&&y<n))}e.isValidVersion=w;function C(d,p,h,b){return h.isBuiltin||typeof h.main=="undefined"?!0:E(d,p,h.engines.vscode,b)}e.isValidExtensionVersion=C;function I(d,p,h){return d==="*"||E(p,h,d)}e.isEngineValid=I;function E(d,p,h,b=[]){let y=P(i(h));if(!y)return b.push(R.localize(0,null,h)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return b.push(R.localize(1,null,h)),!1}else if(!y.majorMustEqual)return b.push(R.localize(2,null,h)),!1;return w(d,p,y)?!0:(b.push(R.localize(3,null,d,h)),!1)}}),define(te[53],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,k=[],i=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=R}),define(te[59],ne([0,1,53]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(i,P,w){P instanceof R.SyncDescriptor||(P=new R.SyncDescriptor(P,[],w)),L.push([i,P])}e.registerSingleton=D;function k(){return L}e.getSingletonServiceDescriptors=k}),define(te[160],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=R;class L{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let i of this._nodes.values())i.outgoing.size===0&&k.push(i);return k}insertEdge(k,i){const P=this.lookupOrInsertNode(k),w=this.lookupOrInsertNode(i);P.outgoing.set(this._hashFn(i),w),w.incoming.set(this._hashFn(k),P)}removeNode(k){const i=this._hashFn(k);this._nodes.delete(i);for(let P of this._nodes.values())P.outgoing.delete(i),P.incoming.delete(i)}lookupOrInsertNode(k){const i=this._hashFn(k);let P=this._nodes.get(i);return P||(P=new R(k),this._nodes.set(i,P)),P}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[i,P]of this._nodes)k.push(`${i}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,i]of this._nodes){const P=new Set([k]),w=this._findCycle(i,P);if(w)return w}}_findCycle(k,i){for(let[P,w]of k.outgoing){if(i.has(P))return[...i,P].join(" -> ");i.add(P);const C=this._findCycle(w,i);if(C)return C;i.delete(P)}}}e.Graph=L}),define(te[6],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function P(w){return w[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=P})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(i,P,w,C){P[R.DI_TARGET]===P?P[R.DI_DEPENDENCIES].push({id:i,index:w,optional:C}):(P[R.DI_DEPENDENCIES]=[{id:i,index:w,optional:C}],P[R.DI_TARGET]=P)}function D(i){if(R.serviceIds.has(i))return R.serviceIds.get(i);const P=function(w,C,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(P,w,I,!1)};return P.toString=()=>i,R.serviceIds.set(i,P),P}e.createDecorator=D;function k(i){return i}e.refineServiceDecorator=k}),define(te[161],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(te[162],ne([0,1,4,25,6]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let k=R.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",R.isMacintosh),i.set("isLinux",R.isLinux),i.set("isWindows",R.isWindows),i.set("isWeb",R.isWeb),i.set("isMacNative",R.isMacintosh&&!R.isWeb),i.set("isEdge",k.indexOf("Edg/")>=0),i.set("isFirefox",k.indexOf("Firefox")>=0),i.set("isChrome",k.indexOf("Chrome")>=0),i.set("isSafari",k.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var w;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return d.INSTANCE}static true(){return p.INSTANCE}static has(_){return h.create(_)}static equals(_,z){return b.create(_,z)}static notEquals(_,z){return S.create(_,z)}static regex(_,z){return t.create(_,z)}static in(_,z){return y.create(_,z)}static not(_){return f.create(_)}static and(..._){return l.create(_,null)}static or(..._){return g.create(_,null,!0)}static greater(_,z){return u.create(_,z)}static greaterEquals(_,z){return r.create(_,z)}static smaller(_,z){return o.create(_,z)}static smallerEquals(_,z){return n.create(_,z)}static deserialize(_,z=!1){if(!!_)return this._deserializeOrExpression(_,z)}static _deserializeOrExpression(_,z){let A=_.split("||");return g.create(A.map(M=>this._deserializeAndExpression(M,z)),null,!0)}static _deserializeAndExpression(_,z){let A=_.split("&&");return l.create(A.map(M=>this._deserializeOne(M,z)),null)}static _deserializeOne(_,z){if(_=_.trim(),_.indexOf("!=")>=0){let A=_.split("!=");return S.create(A[0].trim(),this._deserializeValue(A[1],z))}if(_.indexOf("==")>=0){let A=_.split("==");return b.create(A[0].trim(),this._deserializeValue(A[1],z))}if(_.indexOf("=~")>=0){let A=_.split("=~");return t.create(A[0].trim(),this._deserializeRegexValue(A[1],z))}if(_.indexOf(" in ")>=0){let A=_.split(" in ");return y.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const A=_.split(">=");return r.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const A=_.split(">");return u.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const A=_.split("<=");return n.create(A[0].trim(),A[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const A=_.split("<");return o.create(A[0].trim(),A[1].trim())}return/^\!\s*/.test(_)?f.create(_.substr(1).trim()):h.create(_)}static _deserializeValue(_,z){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let A=/^'([^']*)'$/.exec(_);return A?A[1].trim():_}static _deserializeRegexValue(_,z){if((0,L.isFalsyOrWhitespace)(_)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let A=_.indexOf("/"),M=_.lastIndexOf("/");if(A===M||A<0){if(z)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let q=_.slice(A+1,M),j=_[M+1]==="i"?"i":"";try{return new RegExp(q,j)}catch(W){if(z)throw new Error(`bad regexp-value '${_}', parse error: ${W}`);return console.warn(`bad regexp-value '${_}', parse error: ${W}`),null}}}e.ContextKeyExpr=C;function I(N,_){const z=N?N.substituteConstants():void 0,A=_?_.substituteConstants():void 0;return!z&&!A?!0:!z||!A?!1:z.equals(A)}e.expressionsAreEqualWithConstantSubstitution=I;function E(N,_){return N.cmp(_)}class d{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class p{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}substituteConstants(){return this}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(_,z){this.key=_,this.negated=z,this.type=2}static create(_,z=null){const A=i.get(_);return typeof A=="boolean"?A?p.INSTANCE:d.INSTANCE:new h(_,z)}cmp(_){return _.type!==this.type?this.type-_.type:T(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=i.get(this.key);return typeof _=="boolean"?_?p.INSTANCE:d.INSTANCE:this}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class b{constructor(_,z,A){this.key=_,this.value=z,this.negated=A,this.type=4}static create(_,z,A=null){if(typeof z=="boolean")return z?h.create(_,A):f.create(_,A);const M=i.get(_);return typeof M=="boolean"?z===(M?"true":"false")?p.INSTANCE:d.INSTANCE:new b(_,z,A)}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=i.get(this.key);if(typeof _=="boolean"){const z=_?"true":"false";return this.value===z?p.INSTANCE:d.INSTANCE}return this}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=b;class y{constructor(_,z){this.key=_,this.valueKey=z,this.type=10,this.negated=null}static create(_,z){return new y(_,z)}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}substituteConstants(){return this}evaluate(_){const z=_.getValue(this.valueKey),A=_.getValue(this.key);return Array.isArray(z)?z.indexOf(A)>=0:typeof A=="string"&&typeof z=="object"&&z!==null?P.call(z,A):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=y;class m{constructor(_){this._actual=_,this.type=11}static create(_){return new m(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new m(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class S{constructor(_,z,A){this.key=_,this.value=z,this.negated=A,this.type=5}static create(_,z,A=null){if(typeof z=="boolean")return z?f.create(_,A):h.create(_,A);const M=i.get(_);return typeof M=="boolean"?z===(M?"true":"false")?d.INSTANCE:p.INSTANCE:new S(_,z,A)}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){const _=i.get(this.key);if(typeof _=="boolean"){const z=_?"true":"false";return this.value===z?d.INSTANCE:p.INSTANCE}return this}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class f{constructor(_,z){this.key=_,this.negated=z,this.type=3}static create(_,z=null){const A=i.get(_);return typeof A=="boolean"?A?d.INSTANCE:p.INSTANCE:new f(_,z)}cmp(_){return _.type!==this.type?this.type-_.type:T(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}substituteConstants(){const _=i.get(this.key);return typeof _=="boolean"?_?d.INSTANCE:p.INSTANCE:this}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=f;function a(N,_){if(typeof N=="string"){const z=parseFloat(N);isNaN(z)||(N=z)}return typeof N=="string"||typeof N=="number"?_(N):d.INSTANCE}class u{constructor(_,z,A){this.key=_,this.value=z,this.negated=A,this.type=12}static create(_,z,A=null){return a(z,M=>new u(_,M,A))}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class r{constructor(_,z,A){this.key=_,this.value=z,this.negated=A,this.type=13}static create(_,z,A=null){return a(z,M=>new r(_,M,A))}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class o{constructor(_,z,A){this.key=_,this.value=z,this.negated=A,this.type=14}static create(_,z,A=null){return a(z,M=>new o(_,M,A))}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=o;class n{constructor(_,z,A){this.key=_,this.value=z,this.negated=A,this.type=15}static create(_,z,A=null){return a(z,M=>new n(_,M,A))}cmp(_){return _.type!==this.type?this.type-_.type:O(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}substituteConstants(){return this}evaluate(_){return typeof this.value=="string"?!1:parseFloat(_.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(_,z){this.key=_,this.regexp=z,this.type=7,this.negated=null}static create(_,z){return new t(_,z)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const z=this.regexp?this.regexp.source:"",A=_.regexp?_.regexp.source:"";return z<A?-1:z>A?1:0}equals(_){if(_.type===this.type){const z=this.regexp?this.regexp.source:"",A=_.regexp?_.regexp.source:"";return this.key===_.key&&z===A}return!1}substituteConstants(){return this}evaluate(_){let z=_.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(_){this._actual=_,this.type=8}static create(_){return new s(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}substituteConstants(){return this}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new s(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function c(N){let _=null;for(let z=0,A=N.length;z<A;z++){const M=N[z].substituteConstants();if(N[z]!==M&&_===null){_=[];for(let q=0;q<z;q++)_[q]=N[q]}_!==null&&(_[z]=M)}return _===null?N:_}class l{constructor(_,z){this.expr=_,this.negated=z,this.type=6}static create(_,z){return l._normalizeArr(_,z)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let z=0,A=this.expr.length;z<A;z++){const M=E(this.expr[z],_.expr[z]);if(M!==0)return M}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let z=0,A=this.expr.length;z<A;z++)if(!this.expr[z].equals(_.expr[z]))return!1;return!0}return!1}substituteConstants(){const _=c(this.expr);return _===this.expr?this:l.create(_,this.negated)}evaluate(_){for(let z=0,A=this.expr.length;z<A;z++)if(!this.expr[z].evaluate(_))return!1;return!0}static _normalizeArr(_,z){const A=[];let M=!1;for(const q of _)if(!!q){if(q.type===1){M=!0;continue}if(q.type===0)return d.INSTANCE;if(q.type===6){A.push(...q.expr);continue}A.push(q)}if(A.length===0&&M)return p.INSTANCE;if(A.length!==0){if(A.length===1)return A[0];A.sort(E);for(let q=1;q<A.length;q++)A[q-1].equals(A[q])&&(A.splice(q,1),q--);if(A.length===1)return A[0];for(;A.length>1;){const q=A[A.length-1];if(q.type!==9)break;A.pop();const j=A.pop(),W=A.length===0,$=g.create(q.expr.map(K=>l.create([K,j],null)),null,W);$&&(A.push($),A.sort(E))}return A.length===1?A[0]:new l(A,z)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let z of this.expr)_.push(...z.keys());return _}map(_){return new l(this.expr.map(z=>z.map(_)),null)}negate(){if(!this.negated){const _=[];for(let z of this.expr)_.push(z.negate());this.negated=g.create(_,this,!0)}return this.negated}}class g{constructor(_,z){this.expr=_,this.negated=z,this.type=9}static create(_,z,A){return g._normalizeArr(_,z,A)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let z=0,A=this.expr.length;z<A;z++){const M=E(this.expr[z],_.expr[z]);if(M!==0)return M}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let z=0,A=this.expr.length;z<A;z++)if(!this.expr[z].equals(_.expr[z]))return!1;return!0}return!1}substituteConstants(){const _=c(this.expr);return _===this.expr?this:g.create(_,this.negated,!1)}evaluate(_){for(let z=0,A=this.expr.length;z<A;z++)if(this.expr[z].evaluate(_))return!0;return!1}static _normalizeArr(_,z,A){let M=[],q=!1;if(_){for(let j=0,W=_.length;j<W;j++){const $=_[j];if(!!$){if($.type===0){q=!0;continue}if($.type===1)return p.INSTANCE;if($.type===9){M=M.concat($.expr);continue}M.push($)}}if(M.length===0&&q)return d.INSTANCE;M.sort(E)}if(M.length!==0){if(M.length===1)return M[0];for(let j=1;j<M.length;j++)M[j-1].equals(M[j])&&(M.splice(j,1),j--);if(M.length===1)return M[0];if(A){for(let j=0;j<M.length;j++)for(let W=j+1;W<M.length;W++)U(M[j],M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0]}return new g(M,z)}}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let z of this.expr)_.push(...z.keys());return _}map(_){return new g(this.expr.map(z=>z.map(_)),null)}negate(){if(!this.negated){let _=[];for(let z of this.expr)_.push(z.negate());for(;_.length>1;){const z=_.shift(),A=_.shift(),M=[];for(const j of x(z))for(const W of x(A))M.push(l.create([j,W],null));const q=_.length===0;_.unshift(g.create(M,null,q))}this.negated=_[0]}return this.negated}}class v extends h{constructor(_,z,A){super(_,null);this._defaultValue=z,typeof A=="object"?v._info.push({...A,key:_}):A!==!0&&v._info.push({key:_,description:A,type:z!=null?typeof z:void 0})}static all(){return v._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(_){return b.create(this.key,_)}notEqualsTo(_){return S.create(this.key,_)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function T(N,_){return N<_?-1:N>_?1:0}function O(N,_,z,A){return N<z?-1:N>z?1:_<A?-1:_>A?1:0}function U(N,_){if(_.type===6&&N.type!==9&&N.type!==6){for(const M of _.expr)if(N.equals(M))return!0}const z=N.negate(),A=x(z).concat(x(_));A.sort(E);for(let M=0;M<A.length;M++){const j=A[M].negate();for(let W=M+1;W<A.length;W++){const $=A[W];if(j.equals($))return!0}}return!1}e.implies=U;function x(N){return N.type===9?N.expr:[N]}}),define(te[79],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L}),define(te[80],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(te[11],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,15,133,6]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var k;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function i(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function P(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function w(f,a){switch(f){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=w;function C(f,a){return a==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function I(f,a,u){return C(a,u)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===u?!0:E(u).includes(f)}e.isTargetPlatformCompatible=I;function E(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function d(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=d;var p;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var b;(function(f){f.Install="install",f.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var y;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.Malicious="Malicious",f.Incompatible="Incompatible",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class S extends Error{constructor(a,u){super(a);this.code=u,this.name=u}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=R.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var J=this&&this.__param||function(X,e){return function(R,L){e(R,L,X)}};define(te[163],ne([0,1,2,30]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let D=class extends R.Disposable{constructor(i){super();this.extensionManagementService=i,this._register(i),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};D=he([J(0,L.IExtensionManagementService)],D),e.DeprecatedExtensionsCleaner=D}),define(te[164],ne([0,1,3,2,28,9,111,30]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function w(b,y){return k.URI.revive(y?y.transformIncoming(b):b)}function C(b,y){return y?y.transformOutgoingURI(b):b}function I(b,y){y=y||i.DefaultURITransformer;const m=b.manifest;return{...(0,i.transformAndReviveIncomingURIs)({...b,manifest:void 0},y),manifest:m}}function E(b,y){return y?(0,D.cloneAndChange)(b,m=>m instanceof k.URI?y.transformOutgoingURI(m):void 0):b}class d{constructor(y,m){this.service=y,this.getUriTransformer=m,this.onInstallExtension=R.Event.buffer(y.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(y.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(y.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(y.onDidUninstallExtension,!0)}listen(y,m){const S=this.getUriTransformer(y);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,f=>f.map(a=>({...a,local:a.local?E(a.local,S):a.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(y,m,S){const f=this.getUriTransformer(y);switch(m){case"zip":return this.service.zip(I(S[0],f)).then(a=>C(a,f));case"unzip":return this.service.unzip(w(S[0],f));case"install":return this.service.install(w(S[0],f),S[1]);case"getManifest":return this.service.getManifest(w(S[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(S[0]);case"installFromGallery":return this.service.installFromGallery(S[0],S[1]);case"uninstall":return this.service.uninstall(I(S[0],f),S[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(I(S[0],f));case"getInstalled":return this.service.getInstalled(S[0]).then(a=>a.map(u=>E(u,f)));case"updateMetadata":return this.service.updateMetadata(I(S[0],f),S[1]).then(a=>E(a,f));case"updateExtensionScope":return this.service.updateExtensionScope(I(S[0],f),S[1]).then(a=>E(a,f));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class p extends L.Disposable{constructor(y){super();this.channel=y,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?k.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(S=>({...S,local:S.local?I(S.local,null):S.local,source:this.isUriComponents(S.source)?k.URI.revive(S.source):S.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(y){const m=await this.getTargetPlatform();return y.allTargetPlatforms.some(S=>(0,P.isTargetPlatformCompatible)(S,y.allTargetPlatforms,m))}zip(y){return Promise.resolve(this.channel.call("zip",[y]).then(m=>k.URI.revive(m)))}unzip(y){return Promise.resolve(this.channel.call("unzip",[y]))}install(y,m){return Promise.resolve(this.channel.call("install",[y,m])).then(S=>I(S,null))}getManifest(y){return Promise.resolve(this.channel.call("getManifest",[y]))}installFromGallery(y,m){return Promise.resolve(this.channel.call("installFromGallery",[y,m])).then(S=>I(S,null))}uninstall(y,m){return Promise.resolve(this.channel.call("uninstall",[y,m]))}reinstallFromGallery(y){return Promise.resolve(this.channel.call("reinstallFromGallery",[y]))}getInstalled(y=null){return Promise.resolve(this.channel.call("getInstalled",[y])).then(m=>m.map(S=>I(S,null)))}updateMetadata(y,m){return Promise.resolve(this.channel.call("updateMetadata",[y,m])).then(S=>I(S,null))}updateExtensionScope(y,m){return Promise.resolve(this.channel.call("updateExtensionScope",[y,m])).then(S=>I(S,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class h{constructor(y){this.service=y}listen(y,m){throw new Error("Invalid listen")}call(y,m,S){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(S[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[81],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(i){i[i.FILE=1]="FILE",i[i.WORKSPACE=2]="WORKSPACE",i[i.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function D(i){switch(i){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var k;(function(i){i.Ignored="ignored",i.Cancelled="cancelled",i.TooMany="toomany",i.IncompatibleWindow="incompatibleWindow",i.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[82],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,R.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[14],ne([0,1,41,10,25,17,9,140,6]),function(X,e,R,L,D,k,i,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function C(A){return A.create===!0}e.isFileOpenForWriteOptions=C;var I;(function(A){A[A.Unknown=0]="Unknown",A[A.File=1]="File",A[A.Directory=2]="Directory",A[A.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var E;(function(A){A[A.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var d;(function(A){A[A.FileReadWrite=2]="FileReadWrite",A[A.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",A[A.FileReadStream=16]="FileReadStream",A[A.FileFolderCopy=8]="FileFolderCopy",A[A.PathCaseSensitive=1024]="PathCaseSensitive",A[A.Readonly=2048]="Readonly",A[A.Trash=4096]="Trash",A[A.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(A){return!!(A.capabilities&2)}e.hasReadWriteCapability=p;function h(A){return!!(A.capabilities&8)}e.hasFileFolderCopyCapability=h;function b(A){return!!(A.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function y(A){return!!(A.capabilities&16)}e.hasFileReadStreamCapability=y;var m;(function(A){A.FileExists="EntryExists",A.FileNotFound="EntryNotFound",A.FileNotADirectory="EntryNotADirectory",A.FileIsADirectory="EntryIsADirectory",A.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",A.FileTooLarge="EntryTooLarge",A.FileWriteLocked="EntryWriteLocked",A.NoPermissions="NoPermissions",A.Unavailable="Unavailable",A.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class S extends Error{constructor(M,q){super(M);this.code=q}}e.FileSystemProviderError=S;function f(A,M){const q=new S(A.toString(),M);return u(q,M),q}e.createFileSystemProviderError=f;function a(A){return A||f((0,P.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=a;function u(A,M){return A.name=M?`${M} (FileSystemError)`:"FileSystemError",A}e.markAsFileSystemProviderError=u;function r(A){if(!A)return m.Unknown;if(A instanceof S)return A.code;const M=/^(.+) \(FileSystemError\)$/.exec(A.name);if(!M)return m.Unknown;switch(M[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=r;function o(A){if(A instanceof g)return A.fileOperationResult;switch(r(A)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var n;(function(A){A[A.CREATE=0]="CREATE",A[A.DELETE=1]="DELETE",A[A.MOVE=2]="MOVE",A[A.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(M,q,j){this.resource=M,this.operation=q,this.target=j}isOperation(M){return this.operation===M}}e.FileOperationEvent=t;var s;(function(A){A[A.UPDATED=0]="UPDATED",A[A.ADDED=1]="ADDED",A[A.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class c{constructor(M,q){this.added=void 0,this.updated=void 0,this.deleted=void 0;const j=new Map;for(const W of M){const $=j.get(W.type);$?$.push([W.resource,W]):j.set(W.type,[[W.resource,W]])}for(const[W,$]of j)switch(W){case 1:this.added=R.TernarySearchTree.forUris(()=>q),this.added.fill($);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>q),this.updated.fill($);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>q),this.deleted.fill($);break}}contains(M,...q){return this.doContains(M,{includeChildren:!1},...q)}affects(M,...q){return this.doContains(M,{includeChildren:!0},...q)}doContains(M,q,...j){if(!M)return!1;const W=j.length>0;return!!((!W||j.includes(1))&&(this.added?.get(M)||q.includeChildren&&this.added?.findSuperstr(M))||(!W||j.includes(0))&&(this.updated?.get(M)||q.includeChildren&&this.updated?.findSuperstr(M))||(!W||j.includes(2))&&(this.deleted?.findSubstr(M)||q.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function l(A,M,q){return!A||!M||A===M||M.length>A.length?!1:(M.charAt(M.length-1)!==L.sep&&(M+=L.sep),q?(0,D.startsWithIgnoreCase)(A,M):A.indexOf(M)===0)}e.isParent=l;class g extends Error{constructor(M,q,j){super(M);this.fileOperationResult=q,this.options=j}}e.FileOperationError=g;class v extends g{constructor(M,q,j){super(M,2,j);this.stat=q}}e.NotModifiedSinceFileOperationError=v;var T;(function(A){A[A.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",A[A.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",A[A.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",A[A.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",A[A.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",A[A.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",A[A.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",A[A.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",A[A.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",A[A.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",A[A.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",A[A.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(A){A[A.FILE=0]="FILE",A[A.FOLDER=1]="FOLDER",A[A.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(A){if(!(typeof A.size!="number"||typeof A.mtime!="number"))return A.mtime.toString(29)+A.size.toString(31)}e.etag=U;async function x(A,M){if(!M.hasProvider(i.URI.from({scheme:A.scheme})))return new Promise(q=>{const j=M.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===A.scheme&&W.added&&(j.dispose(),q())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(M){return(0,k.isNumber)(M)||(M=0),M<N.KB?(0,P.localize)(1,null,M.toFixed(0)):M<N.MB?(0,P.localize)(2,null,(M/N.KB).toFixed(2)):M<N.GB?(0,P.localize)(3,null,(M/N.MB).toFixed(2)):M<N.TB?(0,P.localize)(4,null,(M/N.GB).toFixed(2)):(0,P.localize)(5,null,(M/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var _;(function(A){A[A.IA32=0]="IA32",A[A.OTHER=1]="OTHER"})(_=e.Arch||(e.Arch={}));function z(A){return{maxFileSize:A===0?300*N.MB:16*N.GB,maxHeapSize:A===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=z}),define(te[165],ne([0,1,83,50,14]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(P){this.fileService=P}async checksum(P){const w=(await this.fileService.readFileStream(P)).value;return new Promise((C,I)=>{const E=(0,R.createHash)("md5");(0,L.listenStream)(w,{onData:d=>E.update(d.buffer),onError:d=>I(d),onEnd:()=>C(E.digest("base64").replace(/=+$/,""))})})}};k=he([J(0,D.IFileService)],k),e.ChecksumService=k}),define(te[166],ne([0,1,248,130,153,14]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function i(d,p){const h={onUnknownOption:y=>{console.warn((0,L.localize)(0,null,y))},onMultipleValues:(y,m)=>{console.warn((0,L.localize)(1,null,y,m))}},b=(0,D.parseArgs)(d,D.OPTIONS,p?h:void 0);return b.goto&&b._.forEach(y=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,L.localize)(2,null))),b["max-memory"]&&R(parseInt(b["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),b}function P(d){const p=d.findIndex(h=>!/^-/.test(h));if(p>-1)return[...d.slice(0,p),...d.slice(p+1)]}function w(d){let[,...p]=d;process.env.VSCODE_DEV&&(p=P(p)||[]);const h=!E(process.env);return i(p,h)}e.parseMainProcessArgv=w;function C(d){const[,,...p]=d;return i(p,!0)}e.parseCLIProcessArgv=C;function I(d,...p){const h=d.indexOf("--");return h===-1?d.push(...p):d.splice(h,0,...p),d}e.addArg=I;function E(d){return d.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(te[167],ne([0,1,43,10,131,27,38,8,4,29,126,166,5]),function(X,e,R,L,D,k,i,P,w,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const p=1e4;let h;async function b(m,S,f){return S["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(f)&&!S["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(f)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=d.Promises.withAsyncBody(async(a,u)=>{const r=new k.CancellationTokenSource,o=setTimeout(()=>{r.dispose(!0),u(new Error((0,D.localize)(0,null)))},p);try{a(await y(m,r.token))}catch(n){!(0,P.isPromiseCanceledError)(n)&&!r.token.isCancellationRequested?u(new Error((0,D.localize)(1,null,(0,i.toErrorMessage)(n)))):a({})}finally{clearTimeout(o),r.dispose()}})),h)}e.resolveShellEnv=b;async function y(m,S){const f=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",f);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",a);const u=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(u+"(.*)"+u),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",o);const n=await(0,I.getSystemShell)(w.OS,o);return m.trace("getUnixShellEnvironment#shell",n),new Promise((t,s)=>{if(S.isCancellationRequested)return s((0,P.canceled)());const c=(0,L.basename)(n);let l,g;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(l=`& '${process.execPath}' ${v} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,g=["-Login","-Command"]):(l=`'${process.execPath}' ${v} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,c==="tcsh"?g=["-ic"]:g=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),l);const T=(0,R.spawn)(n,[...g,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});S.onCancellationRequested(()=>(T.kill(),s((0,P.canceled)()))),T.on("error",x=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,i.toErrorMessage)(x)),s(x)});const O=[];T.stdout.on("data",x=>O.push(x));const U=[];T.stderr.on("data",x=>U.push(x)),T.on("close",(x,N)=>{const _=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",_);const z=Buffer.concat(U).toString("utf8");if(z.trim()&&m.trace("getUnixShellEnvironment#stderr",z),x||N)return s(new Error((0,D.localize)(2,null,x,N)));const A=r.exec(_),M=A?A[1]:"{}";try{const q=JSON.parse(M);f?q.ELECTRON_RUN_AS_NODE=f:delete q.ELECTRON_RUN_AS_NODE,a?q.ELECTRON_NO_ATTACH_CONSOLE=a:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",q),t(q)}catch(q){m.error("getUnixShellEnvironment#errorCaught",(0,i.toErrorMessage)(q)),s(q)}})})}}),define(te[84],ne([0,1,19,8,141,14]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function i(I,E,d,p,h,b){let y;try{await P(I,E,d,p,h,b)}catch(m){y=m}finally{y&&h.errorTransformer&&(y=h.errorTransformer(y)),typeof y!="undefined"&&d.error(y),d.end()}}e.readFileIntoStream=i;async function P(I,E,d,p,h,b){w(b);const y=await I.open(E,{create:!1});try{w(b);let m=0,S=0,f=h&&typeof h.length=="number"?h.length:void 0,a=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),u=h&&typeof h.position=="number"?h.position:0,r=0;do S=await I.read(y,u,a.buffer,r,a.byteLength-r),u+=S,r+=S,m+=S,typeof f=="number"&&(f-=S),r===a.byteLength&&(await d.write(p(a)),a=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),r=0);while(S>0&&(typeof f!="number"||f>0)&&w(b)&&C(m,h));if(r>0){let o=r;typeof f=="number"&&(o=Math.min(r,f)),d.write(p(a.slice(0,o)))}}catch(m){throw(0,k.ensureFileSystemProviderError)(m)}finally{await I.close(y)}}function w(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function C(I,E){if(E?.limits){if(typeof E.limits.memory=="number"&&I>E.limits.memory)throw(0,k.createFileSystemProviderError)((0,D.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&I>E.limits.size)throw(0,k.createFileSystemProviderError)((0,D.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[54],ne([0,1,2,4,9,14]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class i extends R.Disposable{constructor(d,p,h){super();this.onFileChanges=d,this.onLogMessage=p,this.verboseLogging=h,this.serviceDisposables=this._register(new R.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new R.DisposableStore;this.serviceDisposables.value=d,this.service=this.createService(d),this.service.setVerboseLogging(this.verboseLogging),d.add(this.service.onDidChangeFile(p=>this.onFileChanges(p))),d.add(this.service.onDidLogMessage(p=>this.onLogMessage(p))),d.add(this.service.onDidError(p=>this.onError(p)))}onError(d){this.restartCounter<i.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.service?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${d}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=i,i.MAX_RESTARTS=5;class P extends R.Disposable{}e.WatcherService=P;function w(E){return E.map(d=>({type:d.type,resource:D.URI.file(d.path)}))}e.toFileChanges=w;function C(E){const d=new I;for(const p of E)d.processEvent(p);return d.coalesce()}e.coalesceEvents=C;class I{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(d){return L.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const p=this.mapPathToChange.get(this.toKey(d));let h=!1;if(p){const b=p.type,y=d.type;p.path!==d.path&&d.type===2?h=!0:b===1&&y===2?(this.mapPathToChange.delete(this.toKey(d)),this.coalesced.delete(p)):b===2&&y===1?p.type=0:b===1&&y===0||(p.type=y)}else h=!0;h&&(this.coalesced.add(d),this.mapPathToChange.set(this.toKey(d),d))}coalesce(){const d=[],p=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(d.push(h),!1):!0).sort((h,b)=>h.path.length-b.path.length).filter(h=>p.some(b=>(0,k.isParent)(h.path,b,!L.isLinux))?!1:(p.push(h.path),!0)).concat(d)}}}),define(te[168],ne([0,1,5,2,10,116,20,119,54]),function(X,e,R,L,D,k,i,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class C extends L.Disposable{constructor(E,d,p,h){super();this.path=E,this.onDidFilesChange=d,this.onLogMessage=p,this.verboseLogging=h,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:d}=await i.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(d)try{p=await(0,k.realpath)(p)}catch(h){if(this.onError(h),d.dangling)return}E.isDirectory()?this._register((0,P.watchFolder)(p,(h,b)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(b))})},h=>this.onError(h))):this._register((0,P.watchFile)(p,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,w.coalesceEvents)(d);if(this.verboseLogging)for(const h of p)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=C}),define(te[169],ne([0,1,15,34,52,54]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends k.WatcherService{constructor(w,C,I){super();this.onDidFilesChange=w,this.onLogMessage=C,this.verboseLogging=I,this.isDisposed=!1,this.startWatching()}startWatching(){const w=this._register(new D.Client(R.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(C=>!this.isDisposed&&this.onDidFilesChange(C))),this._register(this.service.onDidLogMessage(C=>this.onLogMessage(C)))}async setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||await this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}async watch(w){this.isDisposed||await this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(te[170],ne([0,1,15,34,52,54]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends k.AbstractWatcherService{constructor(w,C,I){super(w,C,I);this.init()}createService(w){const C=w.add(new D.Client(R.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(C.onDidProcessExit(({code:I,signal:E})=>this.onError(`terminated by itself with code ${I}, signal: ${E}`))),L.ProxyChannel.toService((0,L.getNextTickChannel)(C.getChannel("watcher")))}}e.FileWatcher=i}),define(te[85],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this._entries=new Map;for(let[k,i]of D)this.set(k,i)}set(D,k){const i=this._entries.get(D);return this._entries.set(D,k),i}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=R}),define(te[171],ne([0,1,5,8,53,160,6,85]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class C extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new P.ServiceCollection,b=!1,y){this._activeInstantiations=new Set,this._services=h,this._strict=b,this._parent=y,this._services.set(i.IInstantiationService,this)}createChild(h){return new I(h,this._strict,this)}invokeFunction(h,...b){let y=d.traceInvocation(h),m=!1;try{return h({get:f=>{if(m)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(f,y);if(!a)throw new Error(`[invokeFunction] unknown service '${f}'`);return a}},...b)}finally{m=!0,y.stop()}}createInstance(h,...b){let y,m;return h instanceof D.SyncDescriptor?(y=d.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(b),y)):(y=d.traceCreation(h),m=this._createInstance(h,b,y)),y.stop(),m}_createInstance(h,b=[],y){let m=i._util.getServiceDependencies(h).sort((a,u)=>a.index-u.index),S=[];for(const a of m){let u=this._getOrCreateServiceInstance(a.id,y);if(!u&&this._strict&&!a.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${a.id}.`);S.push(u)}let f=m.length>0?m[0].index:b.length;if(b.length!==f){console.warn(`[createInstance] First service dependency of ${h.name} at position ${f+1} conflicts with ${b.length} static arguments`);let a=f-b.length;a>0?b=b.concat(new Array(a)):b=b.slice(0,f)}return new h(...[...b,...S])}_setServiceInstance(h,b){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,b);else if(this._parent)this._parent._setServiceInstance(h,b);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let b=this._services.get(h);return!b&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):b}_getOrCreateServiceInstance(h,b){let y=this._getServiceInstanceOrDescriptor(h);return y instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,y,b.branch(h,!0)):(b.branch(h,!1),y)}_safeCreateAndCacheServiceInstance(h,b,y){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,b,y)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,b,y){const m=new k.Graph(a=>a.id.toString());let S=0;const f=[{id:h,desc:b,_trace:y}];for(;f.length;){const a=f.pop();if(m.lookupOrInsertNode(a),S++>1e3)throw new C(m);for(let u of i._util.getServiceDependencies(a.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(u.id);if(!r&&!u.optional&&console.warn(`[createInstance] ${h} depends on ${u.id} which is NOT registered.`),r instanceof D.SyncDescriptor){const o={id:u.id,desc:r,_trace:a._trace.branch(u.id,!0)};m.insertEdge(a,o),f.push(o)}}}for(;;){const a=m.roots();if(a.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:u}of a){if(this._getServiceInstanceOrDescriptor(u.id)instanceof D.SyncDescriptor){const o=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,o)}m.removeNode(u)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,b,y=[],m,S){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(b,y,m,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,b,y,m,S);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}_createServiceInstance(h,b=[],y,m){if(y){const S=new R.IdleValue(()=>this._createInstance(h,b,m));return new Proxy(Object.create(null),{get(f,a){if(a in f)return f[a];let u=S.value,r=u[a];return typeof r!="function"||(r=r.bind(u),f[a]=r),r},set(f,a,u){return S.value[a]=u,!0}})}else return this._createInstance(h,b,m)}}e.InstantiationService=I;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class d{constructor(h,b){this.type=h,this.name=b,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return w?new d(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(h){return w?new d(0,h.name):d._None}branch(h,b){let y=new d(2,h.toString());return this._dep.push([h,b,y]),y}stop(){let h=Date.now()-this._start;d._totals+=h;let b=!1;function y(S,f){let a=[],u=new Array(S+1).join("	");for(const[r,o,n]of f._dep)if(o&&n){b=!0,a.push(`${u}CREATES -> ${r}`);let t=y(S+1,n);t&&a.push(t)}else a.push(`${u}uses -> ${r}`);return a.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||b)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(te[172],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,k){this.server=D,this.router=k}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,k){this.server.registerChannel(D,k)}}e.MessagePortMainProcessService=R}),define(te[173],ne([0,1,34,53,59,6]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class i{constructor(p,h,b){const y=b.getChannel(p);return P(h)?new h.channelClientCtor(y):R.ProxyChannel.toService(y,h?.proxyOptions)}}function P(d){return!!d?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let w=class extends i{constructor(p,h,b){super(p,h,b)}};w=he([J(2,e.IMainProcessService)],w);function C(d,p,h){(0,D.registerSingleton)(d,new L.SyncDescriptor(w,[p,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=C,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let I=class extends i{constructor(p,h,b){super(p,h,b)}};I=he([J(2,e.ISharedProcessService)],I);function E(d,p,h){(0,D.registerSingleton)(d,new L.SyncDescriptor(I,[p,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(te[60],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,R.createDecorator)("localizationsService");function L(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const k of D.translations)if(typeof k.id!="string"||typeof k.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[174],ne([0,1,2,60]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(i){super();this.localizationsService=i,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=he([J(0,L.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(te[7],ne([0,1,38,3,2,4,6]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function P(){return new Date().toISOString()}var w;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function C(o,n,t){switch(n){case w.Trace:o.trace(t);break;case w.Debug:o.debug(t);break;case w.Info:o.info(t);break;case w.Warning:o.warn(t);break;case w.Error:o.error(t);break;case w.Critical:o.critical(t);break;default:throw new Error("Invalid log level")}}e.log=C;function I(o){let n="";for(let t=0;t<o.length;t++){let s=o[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch(c){}n+=(t>0?" ":"")+s}return n}e.format=I;class E extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class d extends E{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(w.Trace)&&this.log(w.Trace,I([n,...t]))}debug(n,...t){this.checkLogLevel(w.Debug)&&this.log(w.Debug,I([n,...t]))}info(n,...t){this.checkLogLevel(w.Info)&&this.log(w.Info,I([n,...t]))}warn(n,...t){this.checkLogLevel(w.Warning)&&this.log(w.Warning,I([n,...t]))}error(n,...t){if(this.checkLogLevel(w.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(w.Error,I(s))}else this.log(w.Error,I([n,...t]))}critical(n,...t){this.checkLogLevel(w.Critical)&&this.log(w.Critical,I([n,...t]))}flush(){}}e.AbstractMessageLogger=d;class p extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!k.isWindows}trace(n,...t){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}debug(n,...t){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}info(n,...t){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...t):console.log(`[main ${P()}]`,n,...t))}warn(n,...t){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,n,...t):console.warn(`[main ${P()}]`,n,...t))}error(n,...t){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,n,...t):console.error(`[main ${P()}]`,n,...t))}critical(n,...t){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,n,...t):console.error(`[main ${P()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class h extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class b extends E{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,R.toErrorMessage)(n,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class y extends E{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const s of this.logServices)s.trace(n,...t)}debug(n,...t){for(const s of this.logServices)s.debug(n,...t)}info(n,...t){for(const s of this.logServices)s.info(n,...t)}warn(n,...t){for(const s of this.logServices)s.warn(n,...t)}error(n,...t){for(const s of this.logServices)s.error(n,...t)}critical(n,...t){for(const s of this.logServices)s.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=y;class m extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=m;class S extends D.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,t?.always?w.Trace:this.logLevel,t),this.loggers.set(n.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class f{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return w.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=f;function a(o){if(o.verbose)return w.Trace;if(typeof o.logLevel=="string"){const n=u(o.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function u(o){switch(o){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=u;function r(o){switch(o){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=r}),define(te[175],ne([0,1,5,8,2,10,20,11,7]),function(X,e,R,L,D,k,i,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends D.Disposable{constructor(E,d){super();this.environmentService=E,this.logService=d,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,k.basename)(this.environmentService.logsPath),d=(0,k.dirname)(this.environmentService.logsPath),b=(await i.Promises.readdir(d)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==E),y=b.slice(0,Math.max(0,b.length-9));y.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${y.join(", ")}'`),await Promise.all(y.map(m=>i.Promises.rm((0,k.join)(d,m)))))}catch(E){(0,L.onUnexpectedError)(E)}}};C=he([J(0,P.IEnvironmentService),J(1,w.ILogService)],C),e.LogsDataCleaner=C}),define(te[176],ne([0,1,5,8,2,10,20,11,7]),function(X,e,R,L,D,k,i,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let C=class gt extends D.Disposable{constructor(E,d,p){super();this.backupWorkspacesPath=E,this.environmentService=d,this.logService=p,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await i.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(E).emptyWorkspaceInfos.map(b=>b.backupFolder),h=await i.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async b=>{b.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||b===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||p.indexOf(b)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${b}.`),await i.Promises.rm((0,k.join)(this.environmentService.workspaceStorageHome.fsPath,b)))}))}catch(E){(0,L.onUnexpectedError)(E)}}};C.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,C.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",C=he([J(1,P.INativeEnvironmentService),J(2,w.ILogService)],C),e.StorageDataCleaner=C}),define(te[86],ne([0,1,5,19,32,40,11,14,6,7]),function(X,e,R,L,D,k,i,P,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var I;(function(d){d.ERROR_INVALID_FILE="ERROR_INVALID_FILE",d.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(I=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,w.createDecorator)(e.UserConfigurationFileServiceId);let E=class{constructor(p,h,b){this.environmentService=p,this.fileService=h,this.logService=b,this.queue=new R.Queue}async updateSettings(p,h){return this.queue.queue(()=>this.doWrite(p,h))}async doWrite(p,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),p);const{value:b,mtime:y,etag:m}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let S=b.toString();const f=[];if((0,D.parse)(S,f,{allowTrailingComma:!0,allowEmptyContent:!0}),f.length)throw new Error("ERROR_INVALID_FILE");const a=this.getEdits(p,S,h)[0];if(a){S=S.substring(0,a.offset)+a.content+S.substring(a.offset+a.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(S),{etag:m,mtime:y})}catch(u){if(u.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(p,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,p,h)})}getEdits({value:p,path:h},b,y){return h.length?(0,k.setProperty)(b,h,p,y):[{content:JSON.stringify(p,null,y.insertSpaces&&y.tabSize?" ".repeat(y.tabSize):"	"),length:b.length,offset:0}]}};E=he([J(0,i.IEnvironmentService),J(1,P.IFileService),J(2,C.ILogService)],E),e.UserConfigurationFileService=E}),define(te[177],ne([0,1,43,5,38,3,2,15,10,20,11,7]),function(X,e,R,L,D,k,i,P,w,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends i.Disposable{constructor(h,b){super();this.environmentService=h,this.logService=b,this.processesLimiter=new L.Limiter(5)}async postUninstall(h){const b=this.parseScript(h,"uninstall");return b&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(b.script,"uninstall",b.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${y}`)))),C.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(h,b){const y=`vscode:${b}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[y]=="string"){const m=h.manifest.scripts[y].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${y} should be a node script`),null):{script:(0,w.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,b,y,m,S){return new Promise((f,a)=>{const u=this.start(h,b,y,S);let r;const o=n=>{r&&(clearTimeout(r),r=null),n?a(n):f(void 0)};u.on("error",n=>{o((0,D.toErrorMessage)(n)||"Unknown")}),u.on("exit",(n,t)=>{o(n?`post-${b} process exited with code ${n}`:void 0)}),m&&(r=setTimeout(()=>{r=null,u.kill(),a("timed out")},5e3))})}start(h,b,y,m){const S={silent:!0,execArgv:void 0},f=(0,R.fork)(h,[`--type=extension-post-${b}`,...y],S);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const a=k.Event.fromNodeEventEmitter(f.stdout,"data"),u=k.Event.fromNodeEventEmitter(f.stderr,"data");a(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${b}`,n)),u(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${b}`,n));const r=k.Event.any(k.Event.map(a,n=>({data:`%c${n}`,format:[""]})),k.Event.map(u,n=>({data:`%c${n}`,format:["color: red"]})));return k.Event.debounce(r,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(h){return(0,w.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};d=he([J(0,I.IEnvironmentService),J(1,E.ILogService)],d),e.ExtensionsLifecycle=d}),define(te[178],ne([0,1,8,2,82,3,43,15,113,4,7,59,28,31,70,5]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let y=class extends L.Disposable{constructor(f,a){super();this.id=f,this._logService=a,this._onStdout=this._register(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onExit=this._register(new k.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(f){const a=h.StopWatch.create(!1);this._process=(0,i.fork)(P.FileAccess.asFileUri("bootstrap-fork",X).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,d.mixin)({cwd:(0,p.cwd)()},f));const u=a.elapsed(),r=this._process.pid;this._logService.info(`Starting extension host with pid ${r} (fork() took ${u} ms).`);const o=new w.StringDecoder("utf-8");this._process.stdout?.on("data",t=>{const s=typeof t=="string"?t:o.write(t);this._onStdout.fire(s)});const n=new w.StringDecoder("utf-8");return this._process.stderr?.on("data",t=>{const s=typeof t=="string"?t:n.write(t);this._onStderr.fire(s)}),this._process.on("message",t=>{this._onMessage.fire(t)}),this._process.on("error",t=>{this._onError.fire({error:(0,R.transformErrorForSerialization)(t)})}),this._process.on("exit",(t,s)=>{this._hasExited=!0,this._onExit.fire({pid:r,code:t,signal:s})}),{pid:r}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):C.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(f){if(!this._process)return;const a=this._process.pid;this._logService.info(`Waiting for extension host with pid ${a} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,b.timeout)(f)]),this._hasExited||(this._logService.info(`Extension host with pid ${a} did not exit within ${f}ms.`),this._process.kill())}};y=he([J(1,I.ILogService)],y);let m=class bt{constructor(f){this._logService=f,this._extHosts=new Map}dispose(){}_getExtHost(f){const a=this._extHosts.get(f);if(!a)throw new Error("Unknown extension host!");return a}onDynamicStdout(f){return this._getExtHost(f).onStdout}onDynamicStderr(f){return this._getExtHost(f).onStderr}onDynamicMessage(f){return this._getExtHost(f).onMessage}onDynamicError(f){return this._getExtHost(f).onError}onDynamicExit(f){return this._getExtHost(f).onExit}async createExtensionHost(){const f=String(++bt._lastId),a=new y(f,this._logService);return this._extHosts.set(f,a),a.onExit(({pid:u,code:r,signal:o})=>{this._logService.info(`Extension host with pid ${u} exited with code: ${r}, signal: ${o}.`),setTimeout(()=>{a.dispose(),this._extHosts.delete(f)})}),{id:f}}async start(f,a){return this._getExtHost(f).start(a)}async enableInspectPort(f){const a=this._extHosts.get(f);return a?a.enableInspectPort():!1}async kill(f){const a=this._extHosts.get(f);!a||a.kill()}async killAllNow(){for(const[,f]of this._extHosts)f.kill()}async waitForAllExit(f){const a=[];for(const[,u]of this._extHosts)a.push(u.waitForExit(f));return b.Promises.settled(a).then(()=>{})}};m._lastId=0,m=he([J(0,I.ILogService)],m),e.ExtensionHostStarter=m,(0,E.registerSingleton)(D.IExtensionHostStarter,m,!0)}),define(te[179],ne([0,1,16,5,8,3,2,10,54,7]),function(X,e,R,L,D,k,i,P,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends i.Disposable{constructor(d){super();this.logService=d,this._onDidErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}watch(d,p){return p.recursive?this.watchRecursive(d,p):this.watchNonRecursive(d)}watchRecursive(d,p){const h={path:this.toFilePath(d),excludes:p.excludes},b=(0,R.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,i.toDisposable)(()=>{b(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(d=>(0,D.onUnexpectedError)(d))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(d=>this._onDidChangeFile.fire((0,w.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(d,p){return d.watch(p)}watchNonRecursive(d){const p=this.createNonRecursiveWatcher(this.toFilePath(d),b=>this._onDidChangeFile.fire((0,w.toFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===C.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)});return(0,i.combinedDisposable)(p,h)}onWatcherLogMessage(d){d.type==="error"&&this._onDidErrorOccur.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,P.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(te[180],ne([0,1,16,5,19,27,3,56,2,41,15,181,18,50,139,14,84,7]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class Ke extends w.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new i.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new i.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new i.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new i.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new i.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new i.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new b.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new b.FileChangesEvent(u,!0)))),this.watchedResources=C.TernarySearchTree.forUris(u=>{const r=this.getProvider(u.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(a,u){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:u});const r=new w.DisposableStore;return r.add(u.onDidChangeFile(o=>this.onDidChangeFile(o,this.isPathCaseSensitive(u)))),r.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:a}))),typeof u.onDidErrorOccur=="function"&&r.add(u.onDidErrorOccur(o=>this._onError.fire(new Error(o)))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:u}),this.provider.delete(a),(0,w.dispose)(r)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(r){u.push(r)}}),!this.provider.has(a)&&await L.Promises.settled(u)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,u){const r=this.provider.get(a.scheme);return!!(r&&r.capabilities&u)}listCapabilities(){return P.Iterable.map(this.provider,([a,u])=>({scheme:a,capabilities:u.capabilities}))}async withProvider(a){if(!(0,d.isAbsolutePath)(a))throw new b.FileOperationError((0,h.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const u=this.provider.get(a.scheme);if(!u){const r=new Error;throw r.name="ENOPRO",r.message=(0,h.localize)(1,null,a.toString()),r}return u}async withReadProvider(a){const u=await this.withProvider(a);if((0,b.hasOpenReadWriteCloseCapability)(u)||(0,b.hasReadWriteCapability)(u)||(0,b.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const u=await this.withProvider(a);if((0,b.hasOpenReadWriteCloseCapability)(u)||(0,b.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,u){try{return await this.doResolveFile(a,u)}catch(r){throw(0,b.toFileSystemProviderErrorCode)(r)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,h.localize)(2,null,this.resourceForError(a)),1):(0,b.ensureFileSystemProviderError)(r)}}async doResolveFile(a,u){const r=await this.withProvider(a),o=this.isPathCaseSensitive(r),n=u?.resolveTo,t=u?.resolveSingleChildDescendants,s=u?.resolveMetadata,c=await r.stat(a);let l;return this.toFileStat(r,a,c,void 0,!!s,(g,v)=>(l||(l=C.TernarySearchTree.forUris(()=>!o),l.set(a,!0),n&&l.fill(!0,n)),l.get(g.resource)||l.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&t?v===1:!1))}async toFileStat(a,u,r,o,n,t){const{providerExtUri:s}=this.getExtUri(a),c={resource:u,name:s.basename(u),isFile:(r.type&b.FileType.File)!=0,isDirectory:(r.type&b.FileType.Directory)!=0,isSymbolicLink:(r.type&b.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&b.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,b.etag)({mtime:r.mtime,size:r.size})};if(c.isDirectory&&t(c,o)){try{const l=await a.readdir(u),g=await L.Promises.settled(l.map(async([v,T])=>{try{const O=s.joinPath(u,v),U=n?await a.stat(O):{type:T};return await this.toFileStat(a,O,U,l.length,n,t)}catch(O){return this.logService.trace(O),null}}));c.children=(0,R.coalesce)(g)}catch(l){this.logService.trace(l),c.children=[]}return c}return c}async resolveAll(a){return L.Promises.settled(a.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(a){const u=await this.withProvider(a);try{return!!await u.stat(a)}catch(r){return!1}}async canCreateFile(a,u){try{await this.doValidateCreateFile(a,u)}catch(r){return r}return!0}async doValidateCreateFile(a,u){if(!u?.overwrite&&await this.exists(a))throw new b.FileOperationError((0,h.localize)(3,null,this.resourceForError(a)),3,u)}async createFile(a,u=D.VSBuffer.fromString(""),r){await this.doValidateCreateFile(a,r);const o=await this.writeFile(a,u);return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,o)),o}async writeFile(a,u,r){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:n}=this.getExtUri(o);try{await this.validateWriteFile(o,a,r)||await this.mkdirp(o,n.dirname(a));let s;if((0,b.hasReadWriteCapability)(o)&&!(u instanceof D.VSBuffer))if((0,p.isReadableStream)(u)){const c=await(0,p.peekStream)(u,3);c.ended?s=D.VSBuffer.concat(c.buffer):s=c}else s=(0,p.peekReadable)(u,c=>D.VSBuffer.concat(c),3);else s=u;!(0,b.hasOpenReadWriteCloseCapability)(o)||(0,b.hasReadWriteCapability)(o)&&s instanceof D.VSBuffer?await this.doWriteUnbuffered(o,a,r,s):await this.doWriteBuffered(o,a,r,s instanceof D.VSBuffer?(0,D.bufferToReadable)(s):s)}catch(t){throw new b.FileOperationError((0,h.localize)(4,null,this.resourceForError(a),(0,b.ensureFileSystemProviderError)(t).toString()),(0,b.toFileOperationResult)(t),r)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,u,r){if(!!r?.unlock&&!(a.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(u)));let n;try{n=await a.stat(u)}catch(t){return}if((n.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,h.localize)(6,null,this.resourceForError(u)),0,r);if(this.throwIfFileIsReadonly(u,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==b.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,b.etag)({mtime:r.mtime,size:n.size}))throw new b.FileOperationError((0,h.localize)(7,null),3,r);return n}async readFile(a,u){const r=await this.withReadProvider(a);return u?.atomic?this.doReadFileAtomic(r,a,u):this.doReadFile(r,a,u)}async doReadFileAtomic(a,u,r){return new Promise((o,n)=>{this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(a,u,r);o(t)}catch(t){n(t)}})})}async doReadFile(a,u,r){const o=await this.doReadFileStream(a,u,{...r,preferUnbuffered:!0});return{...o,value:await(0,D.streamToBuffer)(o.value)}}async readFileStream(a,u){const r=await this.withReadProvider(a);return this.doReadFileStream(r,a,u)}async doReadFileStream(a,u,r){const o=new k.CancellationTokenSource,n=this.validateReadFile(u,r).then(s=>s,s=>{throw o.cancel(),s});let t;try{return typeof r?.etag=="string"&&r.etag!==b.ETAG_DISABLED&&await n,!((0,b.hasOpenReadWriteCloseCapability)(a)||(0,b.hasFileReadStreamCapability)(a))||(0,b.hasReadWriteCapability)(a)&&r?.preferUnbuffered?t=this.readFileUnbuffered(a,u,r):(0,b.hasFileReadStreamCapability)(a)?t=this.readFileStreamed(a,u,o.token,r):t=this.readFileBuffered(a,u,o.token,r),{...await n,value:t}}catch(s){t&&await(0,p.consumeStream)(t);const c=(0,h.localize)(8,null,this.resourceForError(u),(0,b.ensureFileSystemProviderError)(s).toString());throw s instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(c,s.stat,r):new b.FileOperationError(c,(0,b.toFileOperationResult)(s),r)}}readFileStreamed(a,u,r,o=Object.create(null)){const n=a.readFileStream(u,o,r);return(0,p.transform)(n,{data:t=>t instanceof D.VSBuffer?t:D.VSBuffer.wrap(t),error:t=>new b.FileOperationError((0,h.localize)(9,null,this.resourceForError(u),(0,b.ensureFileSystemProviderError)(t).toString()),(0,b.toFileOperationResult)(t),o)},t=>D.VSBuffer.concat(t))}readFileBuffered(a,u,r,o=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,y.readFileIntoStream)(a,u,n,t=>t,{...o,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new b.FileOperationError((0,h.localize)(10,null,this.resourceForError(u),(0,b.ensureFileSystemProviderError)(t).toString()),(0,b.toFileOperationResult)(t),o)},r),n}readFileUnbuffered(a,u,r){const o=(0,p.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n=await a.readFile(u);typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(u,n.byteLength,r),o.end(D.VSBuffer.wrap(n))}catch(n){o.error(n),o.end()}})(),o}async validateReadFile(a,u){const r=await this.resolve(a,{resolveMetadata:!0});if(r.isDirectory)throw new b.FileOperationError((0,h.localize)(11,null,this.resourceForError(a)),0,u);if(typeof u?.etag=="string"&&u.etag!==b.ETAG_DISABLED&&u.etag===r.etag)throw new b.NotModifiedSinceFileOperationError((0,h.localize)(12,null),r,u);return this.validateReadFileLimits(a,r.size,u),r}validateReadFileLimits(a,u,r){if(r?.limits){let o;if(typeof r.limits.memory=="number"&&u>r.limits.memory&&(o=9),typeof r.limits.size=="number"&&u>r.limits.size&&(o=7),typeof o=="number")throw new b.FileOperationError((0,h.localize)(13,null,this.resourceForError(a)),o)}}async canMove(a,u,r){return this.doCanMoveCopy(a,u,"move",r)}async canCopy(a,u,r){return this.doCanMoveCopy(a,u,"copy",r)}async doCanMoveCopy(a,u,r,o){if(a.toString()!==u.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(n,a,t,u,r,o)}catch(n){return n}return!0}async move(a,u,r){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),t=await this.doMoveCopy(o,a,n,u,"move",!!r),s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,t==="move"?2:3,s)),s}async copy(a,u,r){const o=await this.withReadProvider(a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),t=await this.doMoveCopy(o,a,n,u,"copy",!!r),s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,t==="copy"?3:2,s)),s}async doMoveCopy(a,u,r,o,n,t){if(u.toString()===o.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(a,u,r,o,n,t);if(s&&!c&&t&&await this.del(o,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(o)),n==="copy"){if(a===r&&(0,b.hasFileFolderCopyCapability)(a))await a.copy(u,o,{overwrite:t});else{const l=await this.resolve(u);l.isDirectory?await this.doCopyFolder(a,l,r,o):await this.doCopyFile(a,u,r,o)}return n}else return a===r?(await a.rename(u,o,{overwrite:t}),n):(await this.doMoveCopy(a,u,r,o,"copy",t),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(a,u,r,o){if((0,b.hasOpenReadWriteCloseCapability)(a)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(a,u,r,o);if((0,b.hasOpenReadWriteCloseCapability)(a)&&(0,b.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(a,u,r,o);if((0,b.hasReadWriteCapability)(a)&&(0,b.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(a,u,r,o);if((0,b.hasReadWriteCapability)(a)&&(0,b.hasReadWriteCapability)(r))return this.doPipeUnbuffered(a,u,r,o)}async doCopyFolder(a,u,r,o){await r.mkdir(o),Array.isArray(u.children)&&await L.Promises.settled(u.children.map(async n=>{const t=this.getExtUri(r).providerExtUri.joinPath(o,n.name);return n.isDirectory?this.doCopyFolder(a,await this.resolve(n.resource),r,t):this.doCopyFile(a,n.resource,r,t)}))}async doValidateMoveCopy(a,u,r,o,n,t){let s=!1;if(a===r){const{providerExtUri:l,isPathCaseSensitive:g}=this.getExtUri(a);if(g||(s=l.isEqual(u,o)),s&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(u),this.resourceForError(o)));if(!s&&l.isEqualOrParent(o,u))throw new Error((0,h.localize)(15,null,this.resourceForError(u),this.resourceForError(o)))}const c=await this.exists(o);if(c&&!s){if(!t)throw new b.FileOperationError((0,h.localize)(16,null,this.resourceForError(u),this.resourceForError(o)),4);if(a===r){const{providerExtUri:l}=this.getExtUri(a);if(l.isEqualOrParent(u,o))throw new Error((0,h.localize)(17,null,this.resourceForError(u),this.resourceForError(o)))}}return{exists:c,isSameResourceWithDifferentPathCase:s}}getExtUri(a){const u=this.isPathCaseSensitive(a);return{providerExtUri:u?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(u,a);const r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,r)),r}async mkdirp(a,u){const r=[],{providerExtUri:o}=this.getExtUri(a);for(;!o.isEqual(u,o.dirname(u));)try{if(((await a.stat(u)).type&b.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(u)));break}catch(n){if((0,b.toFileSystemProviderErrorCode)(n)!==b.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(o.basename(u)),u=o.dirname(u)}for(let n=r.length-1;n>=0;n--){u=o.joinPath(u,r[n]);try{await a.mkdir(u)}catch(t){if((0,b.toFileSystemProviderErrorCode)(t)!==b.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(a,u){try{await this.doValidateDelete(a,u)}catch(r){return r}return!0}async doValidateDelete(a,u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!u?.useTrash&&!(r.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(a)));let n;try{n=await r.stat(a)}catch(s){}if(n)this.throwIfFileIsReadonly(a,n);else throw new b.FileOperationError((0,h.localize)(20,null,this.resourceForError(a)),1);if(!!!u?.recursive){const s=await this.resolve(a);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(a)))}return r}async del(a,u){const r=await this.doValidateDelete(a,u),o=!!u?.useTrash,n=!!u?.recursive;await r.delete(a,{recursive:n,useTrash:o}),this._onDidRunOperation.fire(new b.FileOperationEvent(a,1))}onDidChangeFile(a,u){this._onDidChangeFilesRaw.fire({changes:a});let r,o;{for(const n of a)this.watchedResources.has(n.resource)?(r||(r=[]),r.push(n)):(o||(o=[]),o.push(n));r&&this._onDidFilesChange.fire(new b.FileChangesEvent(r,!u))}if(o){const n=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(o)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,u={recursive:!1,excludes:[]}){const r=new w.DisposableStore;let o=!1,n=()=>{o=!0};return r.add((0,w.toDisposable)(()=>n())),this.doWatch(a,u).then(t=>{o?(0,w.dispose)(t):n=()=>(0,w.dispose)(t)},t=>this.logService.error(t)),u.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),r.add((0,w.toDisposable)(()=>{const t=this.watchedResources.get(a);typeof t=="number"&&(t<=1?this.watchedResources.delete(a):this.watchedResources.set(a,t-1))}))),r}async doWatch(a,u){const r=await this.withProvider(a),o=this.toWatchKey(r,a,u);let n=this.activeWatchers.get(o);return n||(n={count:0,disposable:r.watch(a,u)},this.activeWatchers.set(o,n)),n.count+=1,(0,w.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,w.dispose)(n.disposable),this.activeWatchers.delete(o)))})}toWatchKey(a,u,r){const{providerExtUri:o}=this.getExtUri(a);return[o.getComparisonKey(u),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,w.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,u,r,o){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{const n=await a.open(u,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(o)||(0,p.isReadableBufferedStream)(o)?await this.doWriteStreamBufferedQueued(a,n,o):await this.doWriteReadableBufferedQueued(a,n,o)}catch(t){throw(0,b.ensureFileSystemProviderError)(t)}finally{await a.close(n)}})}async doWriteStreamBufferedQueued(a,u,r){let o=0,n;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const t=D.VSBuffer.concat(r.buffer);await this.doWriteBuffer(a,u,t,t.byteLength,o,0),o+=t.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((t,s)=>{(0,p.listenStream)(n,{onData:async c=>{n.pause();try{await this.doWriteBuffer(a,u,c,c.byteLength,o,0)}catch(l){return s(l)}o+=c.byteLength,setTimeout(()=>n.resume())},onError:c=>s(c),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(a,u,r){let o=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(a,u,n,n.byteLength,o,0),o+=n.byteLength}async doWriteBuffer(a,u,r,o,n,t){let s=0;for(;s<o;)s+=await a.write(u,n+s,r.buffer,t+s,o-s)}async doWriteUnbuffered(a,u,r,o){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,u,r,o))}async doWriteUnbufferedQueued(a,u,r,o){let n;o instanceof D.VSBuffer?n=o:(0,p.isReadableStream)(o)?n=await(0,D.streamToBuffer)(o):(0,p.isReadableBufferedStream)(o)?n=await(0,D.bufferedStreamToBuffer)(o):n=(0,D.readableToBuffer)(o),await a.writeFile(u,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(a,u,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,u,r,o))}async doPipeBufferedQueued(a,u,r,o){let n,t;try{n=await a.open(u,{create:!1}),t=await r.open(o,{create:!0,unlock:!1});const s=D.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,l=0,g=0;do g=await a.read(n,c,s.buffer,l,s.byteLength-l),await this.doWriteBuffer(r,t,s,g,c,l),c+=g,l+=g,l===s.byteLength&&(l=0);while(g>0)}catch(s){throw(0,b.ensureFileSystemProviderError)(s)}finally{await L.Promises.settled([typeof n=="number"?a.close(n):Promise.resolve(),typeof t=="number"?r.close(t):Promise.resolve()])}}async doPipeUnbuffered(a,u,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,u,r,o))}async doPipeUnbufferedQueued(a,u,r,o){return r.writeFile(o,await a.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,u,r,o){return this.writeQueue.queueFor(o,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,u,r,o))}async doPipeUnbufferedToBufferedQueued(a,u,r,o){const n=await r.open(o,{create:!0,unlock:!1});try{const t=await a.readFile(u);await this.doWriteBuffer(r,n,D.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,b.ensureFileSystemProviderError)(t)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(a,u,r,o){const n=await(0,D.streamToBuffer)(this.readFileBuffered(a,u,k.CancellationToken.None));await this.doWriteUnbuffered(r,o,void 0,n)}throwIfFileSystemIsReadonly(a,u){if(a.capabilities&2048)throw new b.FileOperationError((0,h.localize)(22,null,this.resourceForError(u)),6);return a}throwIfFileIsReadonly(a,u){if((u.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,h.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===I.Schemas.file?a.fsPath:a.toString(!0)}};S.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},S=he([J(0,m.ILogService)],S),e.FileService=S}),define(te[182],ne([0,1,51,249,5,19,3,42,10,4,18,50,20,142,14,84,168,169,170,179,38]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,L.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(r)}`)}})();class u extends f.AbstractDiskFileSystemProvider{constructor(o,n){super(o);this.options=n,this.onDidChangeCapabilities=i.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(o){try{const{stat:n,symbolicLink:t}=await d.SymlinkSupport.stat(this.toFilePath(o));return{type:this.toType(n,t),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(o){try{const n=await d.Promises.readdir(this.toFilePath(o),{withFileTypes:!0}),t=[];return await Promise.all(n.map(async s=>{try{let c;s.isSymbolicLink()?c=(await this.stat((0,I.joinPath)(o,s.name))).type:c=this.toType(s),t.push([s.name,c])}catch(c){this.logService.trace(c)}})),t}catch(n){throw this.toFileSystemProviderError(n)}}toType(o,n){let t;return n?.dangling?t=h.FileType.Unknown:o.isFile()?t=h.FileType.File:o.isDirectory()?t=h.FileType.Directory:t=h.FileType.Unknown,n&&(t|=h.FileType.SymbolicLink),t}async readFile(o){try{const n=this.toFilePath(o);return await d.Promises.readFile(n)}catch(n){throw this.toFileSystemProviderError(n)}}readFileStream(o,n,t){const s=(0,E.newWriteableStream)(c=>k.VSBuffer.concat(c.map(l=>k.VSBuffer.wrap(l))).buffer);return(0,b.readFileIntoStream)(this,o,s,c=>c.buffer,{...n,bufferSize:256*1024},t),s}async writeFile(o,n,t){let s;try{const c=this.toFilePath(o);if(!t.create||!t.overwrite){if(await d.Promises.exists(c)){if(!t.overwrite)throw(0,h.createFileSystemProviderError)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,h.createFileSystemProviderError)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(o,{create:!0,unlock:t.unlock}),await this.write(s,0,n,0,n.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(o,c)}finally{typeof s=="number"&&await this.close(s)}}async open(o,n){try{const t=this.toFilePath(o);if((0,h.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:l}=await d.SymlinkSupport.stat(t);l.mode&128||await d.Promises.chmod(t,l.mode|128)}catch(l){this.logService.trace(l)}let s;if((0,h.isFileOpenForWriteOptions)(n)){if(C.isWindows)try{await d.Promises.truncate(t,0),s="r+"}catch(l){l.code!=="ENOENT"&&this.logService.trace(l)}s||(s="w")}else s="r";const c=await d.Promises.open(t,s);return this.mapHandleToPos.set(c,0),(0,h.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(c,o),c}catch(t){throw(0,h.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(o,t):this.toFileSystemProviderError(t)}}async close(o){try{if(this.mapHandleToPos.delete(o),this.writeHandles.delete(o)&&this.canFlush)try{await d.Promises.fdatasync(o)}catch(n){this.canFlush=!1,this.logService.error(n)}return await d.Promises.close(o)}catch(n){throw this.toFileSystemProviderError(n)}}async read(o,n,t,s,c){const l=this.normalizePos(o,n);let g=null;try{const v=await d.Promises.read(o,t,s,c,l);return typeof v=="number"?g=v:g=v.bytesRead,g}catch(v){throw this.toFileSystemProviderError(v)}finally{this.updatePos(o,l,g)}}normalizePos(o,n){return n===this.mapHandleToPos.get(o)?null:n}updatePos(o,n,t){const s=this.mapHandleToPos.get(o);typeof s=="number"&&(typeof n=="number"||(typeof t=="number"?this.mapHandleToPos.set(o,s+t):this.mapHandleToPos.delete(o)))}async write(o,n,t,s,c){return(0,D.retry)(()=>this.doWrite(o,n,t,s,c),100,3)}async doWrite(o,n,t,s,c){const l=this.normalizePos(o,n);let g=null;try{const v=await d.Promises.write(o,t,s,c,l);return typeof v=="number"?g=v:g=v.bytesWritten,g}catch(v){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(o),v)}finally{this.updatePos(o,l,g)}}async mkdir(o){try{await d.Promises.mkdir(this.toFilePath(o))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(o,n){try{const t=this.toFilePath(o);await this.doDelete(t,n)}catch(t){throw this.toFileSystemProviderError(t)}}async doDelete(o,n){n.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}async rename(o,n,t){const s=this.toFilePath(o),c=this.toFilePath(n);if(s!==c)try{await this.validateTargetDeleted(o,n,"move",t.overwrite),await d.Promises.move(s,c)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,p.localize)(2,null,(0,w.basename)(s),(0,w.basename)((0,w.dirname)(c)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(o,n,t){const s=this.toFilePath(o),c=this.toFilePath(n);if(s!==c)try{await this.validateTargetDeleted(o,n,"copy",t.overwrite),await d.Promises.copy(s,c,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,p.localize)(3,null,(0,w.basename)(s),(0,w.basename)((0,w.dirname)(c)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(o,n,t,s){const c=this.toFilePath(o),l=this.toFilePath(n);let g=!1;if(!!(this.capabilities&1024)||(g=(0,P.isEqual)(c,l,!0)),g&&t==="copy")throw(0,h.createFileSystemProviderError)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!g&&await d.Promises.exists(l)){if(!s)throw(0,h.createFileSystemProviderError)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(o,n,t){let s,c=!1;return this.options?.watcher?.usePolling?c=!1:c=this.options?.legacyWatcher==="on",c?s=m.FileWatcher:s=S.FileWatcher,new s(l=>o(l),l=>n(l),t,this.options?.watcher)}doWatch(o,n){const t=this.options?.watcher?.usePolling;if(t===!0)for(const s of n)s.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(t))for(const s of n)t.includes(s.path)&&(s.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(o,n)}createNonRecursiveWatcher(o,n,t,s){return new y.FileWatcher(o,c=>n(c),c=>t(c),s)}toFileSystemProviderError(o){if(o instanceof h.FileSystemProviderError)return o;let n;switch(o.code){case"ENOENT":n=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=h.FileSystemProviderErrorCode.NoPermissions;break;default:n=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(o,n)}async toFileSystemProviderWriteError(o,n){let t=this.toFileSystemProviderError(n);if(o&&t.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await d.SymlinkSupport.stat(this.toFilePath(o));s.mode&128||(t=(0,h.createFileSystemProviderError)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return t}}e.DiskFileSystemProvider=u}),define(te[87],ne([0,1,3,9,7]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(d){this.service=d,this.onDidChangeLogLevel=R.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=k;class i{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){i.setLevel(this.channel,d)}static setLevel(d,p){return d.call("setLevel",p)}}e.LogLevelChannelClient=i;class P{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,p){throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(d,p){this.loggers.set(d.toString(),this.loggerService.createLogger(d,p))}consoleLog(d,p){let h=console.log;switch(d){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(d,p){const h=this.loggers.get(d.toString());if(!h)throw new Error("Create the logger before logging");for(const[b,y]of p)(0,D.log)(h,b,y)}}e.LoggerChannel=P;class w extends D.AbstractLoggerService{constructor(d,p,h){super(d,p);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(d,p)=>{this.channel.call("consoleLog",[d,p])}})}doCreateLogger(d,p,h){return new C(this.channel,d,p,h)}}e.LoggerChannelClient=w;class C extends D.AbstractMessageLogger{constructor(d,p,h,b){super(b?.always);this.channel=d,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[p,b]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,p){const h=[[d,p]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(d){this.channel.call("log",[this.file,d])}}class I extends D.LogService{constructor(d,p){super(p);this.parent=d,this._register(d.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=I}),define(te[61],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(te[88],ne([0,1,15,4,31,18]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const P=L.globals.vscode.context.configuration();if(P)i=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const P=(0,k.dirname)(R.FileAccess.asFileUri("",X));i=X.__$__nodeRequire((0,k.joinPath)(P,"product.json").fsPath);const w=X.__$__nodeRequire((0,k.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:w.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i}),define(te[26],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService")}),define(te[183],ne([0,1,5,8,2,10,20,7,26]),function(X,e,R,L,D,k,i,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let C=class extends D.Disposable{constructor(E,d,p){super();this.productService=d,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),p=(0,k.dirname)(E),h=(0,k.basename)(E),b=await i.Promises.readdir(p);await Promise.all(b.map(async y=>{if(y===h)return;const m=(0,k.join)(p,y),S=await i.Promises.stat(m);if(S.isDirectory()&&d-S.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),i.Promises.rm(m)}))}catch(d){(0,L.onUnexpectedError)(d)}}};C=he([J(1,w.IProductService),J(2,P.ILogService)],C),e.CodeCacheCleaner=C}),define(te[184],ne([0,1,5,8,2,10,20,11,7,26]),function(X,e,R,L,D,k,i,P,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends D.Disposable{constructor(d,p,h){super();this.environmentService=d,this.logService=p,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),p=JSON.parse(await i.Promises.readFile((0,k.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let S of Object.keys(p)){const f=p[S];d[`${f.hash}.${S}`]=!0}const h=(0,k.join)(this.environmentService.userDataPath,"clp");if(!await i.Promises.exists(h))return;const y=await i.Promises.readdir(h);for(const S of y){if(d[S]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${S}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${S}`),await i.Promises.rm((0,k.join)(h,S))}const m=Date.now();for(const S of Object.keys(d)){const f=(0,k.join)(h,S),a=await i.Promises.readdir(f);for(const u of a){if(u==="tcf.json")continue;const r=(0,k.join)(f,u),o=await i.Promises.stat(r);o.isDirectory()&&m-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(S,u)}`),await i.Promises.rm(r))}}}catch(d){(0,L.onUnexpectedError)(d)}}};I=he([J(0,P.INativeEnvironmentService),J(1,w.ILogService),J(2,C.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(te[35],ne([0,1,102,17]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(i,P){R.ok(L.isString(i)),R.ok(L.isObject(P)),R.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,P)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new D}),define(te[89],ne([0,1,3,35]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class k{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,C){this.schemasById[D(w)]=C,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new k;L.Registry.add(e.Extensions.JSONContribution,i)}),define(te[39],ne([0,1,16,3,17,128,89,35]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const I=P.Registry.as(i.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,r=!0){this.registerConfigurations([u],r)}registerConfigurations(u,r=!0){const o=this.doRegisterConfigurations(u,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(u){const r=this.doDeregisterConfigurations(u);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}updateConfigurations({add:u,remove:r}){const o=[];o.push(...this.doDeregisterConfigurations(r)),o.push(...this.doRegisterConfigurations(u,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,R.distinct)(o))}registerDefaultConfigurations(u){const r=[],o=[];for(const n of u)for(const t in n)if(r.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...n[t]};const s={type:"object",default:this.defaultValues[t],description:k.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};o.push(...h(t)),this.configurationProperties[t]=s,this.defaultLanguageConfigurationOverridesNode.properties[t]=s}else{this.defaultValues[t]=n[t];const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterDefaultConfigurations(u){const r=[];for(const o of u)for(const n in o)if(r.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const t=this.configurationProperties[n];t&&(this.updatePropertyDefaultValue(n,t),this.updateSchema(n,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const r of u)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,r){const o=[];return u.forEach(n=>{o.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),o}doDeregisterConfigurations(u){const r=[],o=n=>{if(n.properties)for(const t in n.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>o(t))};for(const n of u){o(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(u,r=!0,o,n=3){n=D.isUndefinedOrNull(u.scope)?n:u.scope;let t=[],s=u.properties;if(s)for(let l in s){if(r&&S(l)){delete s[l];continue}const g=s[l];if(this.updatePropertyDefaultValue(l,g),e.OVERRIDE_PROPERTY_REGEX.test(l)?g.scope=void 0:(g.scope=D.isUndefinedOrNull(g.scope)?n:g.scope,g.restricted=D.isUndefinedOrNull(g.restricted)?!!o?.restrictedConfigurations?.includes(l):g.restricted),s[l].hasOwnProperty("included")&&!s[l].included){this.excludedConfigurationProperties[l]=s[l],delete s[l];continue}else this.configurationProperties[l]=s[l];!s[l].deprecationMessage&&s[l].markdownDeprecationMessage&&(s[l].deprecationMessage=s[l].markdownDeprecationMessage),t.push(l)}let c=u.allOf;if(c)for(let l of c)t.push(...this.validateAndRegisterProperties(l,r,o,n));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(u){const r=o=>{let n=o.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let t=o.allOf;t&&t.forEach(r)};r(u)}updateSchema(u,r){switch(e.allSettings.properties[u]=r,r.scope){case 1:e.applicationSettings.properties[u]=r;break;case 2:e.machineSettings.properties[u]=r;break;case 6:e.machineOverridableSettings.properties[u]=r;break;case 3:e.windowSettings.properties[u]=r;break;case 4:e.resourceSettings.properties[u]=r;break;case 5:e.resourceSettings.properties[u]=r,this.resourceLanguageSettingsSchema.properties[u]=r;break}}removeFromSchema(u,r){switch(delete e.allSettings.properties[u],r.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const r=`[${u}]`,o={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,o),e.allSettings.properties[r]=o,e.applicationSettings.properties[r]=o,e.machineSettings.properties[r]=o,e.machineOverridableSettings.properties[r]=o,e.windowSettings.properties[r]=o,e.resourceSettings.properties[r]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,r){let o=this.defaultValues[u];D.isUndefined(o)&&(o=r.default),D.isUndefined(o)&&(o=y(r.type)),r.default=o}}const d="\\[([^\\]]+)\\]",p=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(a){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let r=p.exec(a);for(;r?.length;){const o=r[1].trim();o&&u.push(o),r=p.exec(a)}}return(0,R.distinct)(u)}e.overrideIdentifiersFromKey=h;function b(a){return a.reduce((u,r)=>`${u}[${r}]`,"")}e.keyFromOverrideIdentifiers=b;function y(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const m=new E;P.Registry.add(e.Extensions.Configuration,m);function S(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?k.localize(7,null,a):m.getConfigurationProperties()[a]!==void 0?k.localize(8,null,a):null:k.localize(6,null)}e.validateProperty=S;function f(){const a=[],u=m.getConfigurationProperties();for(const r of Object.keys(u))a.push([r,u[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=f}),define(te[21],ne([0,1,17,9,39,6,35]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function P(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof L.URI)}e.isConfigurationOverrides=P;function w(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||R.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=w;var C;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=I;function E(a,u){const r=Object.create(null);for(let o in a)d(r,o,a[o],u);return r}e.toValuesTree=E;function d(a,u,r,o){const n=u.split("."),t=n.pop();let s=a;for(let c=0;c<n.length;c++){let l=n[c],g=s[l];switch(typeof g){case"undefined":g=s[l]=Object.create(null);break;case"object":break;default:o(`Ignoring ${u} as ${n.slice(0,c+1).join(".")} is ${JSON.stringify(g)}`);return}s=g}if(typeof s=="object"&&s!==null)try{s[t]=r}catch(c){o(`Ignoring ${u} as ${n.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${u} as ${n.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=d;function p(a,u){const r=u.split(".");h(a,r)}e.removeFromValueTree=p;function h(a,u){const r=u.shift();if(u.length===0){delete a[r];return}if(Object.keys(a).indexOf(r)!==-1){const o=a[r];typeof o=="object"&&!Array.isArray(o)&&(h(o,u),Object.keys(o).length===0&&delete a[r])}}function b(a,u,r){function o(s,c){let l=s;for(const g of c){if(typeof l!="object"||l===null)return;l=l[g]}return l}const n=u.split("."),t=o(a,n);return typeof t=="undefined"?r:t}e.getConfigurationValue=b;function y(a,u,r){Object.keys(u).forEach(o=>{o!=="__proto__"&&(o in a?R.isObject(a[o])&&R.isObject(u[o])?y(a[o],u[o],r):r&&(a[o]=u[o]):a[o]=u[o])})}e.merge=y;function m(){const a=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=m;function S(){const a=Object.create(null),u=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let r in u){let o=u[r].default;d(a,r,o,n=>console.error(`Conflict in default settings: ${n}`))}return a}e.getDefaultValues=S;function f(a,u,r){const o=a.inspect(u),n=a.inspect(r);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:o.defaultValue}e.getMigratedSettingValue=f}),define(te[90],ne([0,1,16,3,32,2,41,28,17,9,21,39,35]),function(X,e,R,L,D,k,i,P,w,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,I.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return R.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return R.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=P.deepClone(this.contents),s=P.deepClone(this.overrides),c=[...this.keys];for(const l of n){this.mergeContents(t,l.contents);for(const g of l.overrides){const[v]=s.filter(T=>R.equals(T.identifiers,g.identifiers));v?(this.mergeContents(v.contents,g.contents),v.keys.push(...g.keys),v.keys=R.distinct(v.keys)):s.push(P.deepClone(g))}for(const g of l.keys)c.indexOf(g)===-1&&c.push(g)}return new p(t,c,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const c of R.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[c],g=t[c];g&&(typeof l=="object"&&typeof g=="object"?(l=P.deepClone(l),this.mergeContents(l,g)):l=g),s[c]=l}return new p(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&w.isObject(n[s])&&w.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=P.deepClone(t[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?P.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const c=l=>{l&&(s?this.mergeContents(s,l):s=P.deepClone(l))};for(const l of this.overrides)R.equals(l.identifiers,[n])?t=l.contents:l.identifiers.includes(n)&&c(l.contents);return c(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,I.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(){const n=(0,I.getDefaultValues)(),t=(0,I.getConfigurationKeys)(),s=[];for(const c of Object.keys(n))E.OVERRIDE_PROPERTY_REGEX.test(c)&&s.push({identifiers:(0,E.overrideIdentifiersFromKey)(c),keys:Object.keys(n[c]),contents:(0,I.toValuesTree)(n[c],l=>console.error(`Conflict in default settings file: ${l}`))});super(n,t,s)}}e.DefaultConfigurationModel=h;class b{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!w.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:c,overrides:l,restricted:g}=this.doParseRaw(n,t);this._configurationModel=new p(s,c,l),this._restrictedConfigurations=g||[]}doParseContent(n){let t={},s=null,c=[],l=[],g=[];function v(O){Array.isArray(c)?c.push(O):s!==null&&(c[s]=O)}let T={onObjectBegin:()=>{let O={};v(O),l.push(c),c=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{let O=[];v(O),l.push(c),c=O,s=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:v,onError:(O,U,x)=>{g.push({error:O,offset:U,length:x})}};if(n)try{D.visit(n,T),t=c[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return t}doParseRaw(n,t){const s=d.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),c=this.filter(n,s,!0,t);n=c.raw;const l=(0,I.toValuesTree)(n,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),g=Object.keys(n),v=this.toOverrides(n,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:l,keys:g,overrides:v,restricted:c.restricted}}filter(n,t,s,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:n,restricted:[]};const l={},g=[];for(let v in n)if(E.OVERRIDE_PROPERTY_REGEX.test(v)&&s){const T=this.filter(n[v],t,!1,c);l[v]=T.raw,g.push(...T.restricted)}else{const T=t[v],O=T?typeof T.scope!="undefined"?T.scope:3:void 0;T?.restricted&&g.push(v),(O===void 0||c.scopes===void 0||c.scopes.includes(O))&&(c.skipRestricted&&T?.restricted||(l[v]=n[v]))}return{raw:l,restricted:g}}toOverrides(n,t){const s=[];for(const c of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(c)){const l={};for(const g in n[c])l[g]=n[c][g];s.push({identifiers:(0,E.overrideIdentifiersFromKey)(c),keys:Object.keys(l),contents:(0,I.toValuesTree)(l,t)})}return s}}e.ConfigurationModelParser=b;class y extends k.Disposable{constructor(n,t,s,c){super();this.userSettingsResource=n,this.scopes=t,this.fileService=c,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new b(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class m{constructor(n,t,s=new p,c=new p,l=new i.ResourceMap,g=new p,v=new i.ResourceMap,T=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=l,this._memoryConfiguration=g,this._memoryConfigurationByResource=v,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(n)}updateValue(n,t,s={}){let c;s.resource?(c=this._memoryConfigurationByResource.get(s.resource),c||(c=new p,this._memoryConfigurationByResource.set(s.resource,c))):c=this._memoryConfiguration,t===void 0?c.removeValue(n):c.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const c=this.getConsolidateConfigurationModel(t,s),l=this.getFolderConfigurationModelForResource(t.resource,s),g=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,v=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),T=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),O=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),U=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),x=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,N=l?t.overrideIdentifier?l.freeze().override(t.overrideIdentifier).getValue(n):l.freeze().getValue(n):void 0,_=t.overrideIdentifier?g.override(t.overrideIdentifier).getValue(n):g.getValue(n),z=c.getValue(n),A=R.distinct(R.flatten(c.overrides.map(M=>M.identifiers))).filter(M=>c.getOverrideValue(n,M)!==void 0);return{defaultValue:v,userValue:T,userLocalValue:O,userRemoteValue:U,workspaceValue:x,workspaceFolderValue:N,memoryValue:_,value:z,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:l?.freeze().getValue(n),override:t.overrideIdentifier?l?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:_!==void 0?{value:g.getValue(n),override:t.overrideIdentifier?g.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:A.length?A:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const s=[];for(const c of t)for(const l of(0,E.overrideIdentifiersFromKey)(c)){const g=this._defaultConfiguration.getKeysForOverrideIdentifier(l),v=n.getKeysForOverrideIdentifier(l),T=[...v.filter(O=>g.indexOf(O)===-1),...g.filter(O=>v.indexOf(O)===-1),...g.filter(O=>!P.equals(this._defaultConfiguration.override(l).getValue(O),n.override(l).getValue(O)))];s.push([l,T])}return this.updateDefaultConfiguration(n),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:c,overrides:l}=u(this.localUserConfiguration,n),g=[...t,...s,...c];return g.length&&this.updateLocalUserConfiguration(n),{keys:g,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:c,overrides:l}=u(this.remoteUserConfiguration,n);let g=[...t,...s,...c];return g.length&&this.updateRemoteUserConfiguration(n),{keys:g,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:c,overrides:l}=u(this.workspaceConfiguration,n);let g=[...t,...s,...c];return g.length&&this.updateWorkspaceConfiguration(n),{keys:g,overrides:l}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:c,updated:l,removed:g,overrides:v}=u(s,t);let T=[...c,...l,...g];return(T.length||!s)&&this.updateFolderConfiguration(n,t),{keys:T,overrides:v}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:c,removed:l,overrides:g}=u(t,void 0);return{keys:[...s,...c,...l],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let s=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const c=t.getFolder(n);c&&(s=this.getFolderConsolidatedConfiguration(c.uri)||s);const l=this._memoryConfigurationByResource.get(n);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(n);c?(t=s.merge(c),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:c,keys:l}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:c,keys:l}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(c=>t.add(c))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),c=this.parseConfigurationModel(n.workspace),l=n.folders.reduce((g,v)=>(g.set(C.URI.revive(v[0]),this.parseConfigurationModel(v[1])),g),new i.ResourceMap);return new m(t,s,new p,c,l,new p,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=m;function S(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,t=new Map;for(const c of o)c.keys.forEach(l=>n.add(l)),c.overrides.forEach(([l,g])=>{const v=(0,i.getOrSet)(t,l,new Set);g.forEach(T=>v.add(T))});const s=[];return t.forEach((c,l)=>s.push([l,[...c.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=S;class f{constructor(n,t,s,c){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=c,this._previousConfiguration=void 0;const l=new Set;n.keys.forEach(v=>l.add(v)),n.overrides.forEach(([,v])=>v.forEach(T=>l.add(T))),this.affectedKeys=[...l.values()];const g=new p;this.affectedKeys.forEach(v=>g.setValue(v,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!P.equals(s,c)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,I.toValuesTree)({[t]:!0},()=>{}),c;for(;typeof s=="object"&&(c=Object.keys(s)[0]);){if(n=n[c],!n)return!1;s=s[c]}return!0}}e.ConfigurationChangeEvent=f;class a extends f{constructor(n,t,s,c){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=a;function u(o,n){const{added:t,removed:s,updated:c}=r(n,o),l=[],g=o?.getAllOverrideIdentifiers()||[],v=n?.getAllOverrideIdentifiers()||[];if(n){const T=v.filter(O=>!g.includes(O));for(const O of T)l.push([O,n.getKeysForOverrideIdentifier(O)])}if(o){const T=g.filter(O=>!v.includes(O));for(const O of T)l.push([O,o.getKeysForOverrideIdentifier(O)])}if(n&&o){for(const T of g)if(v.includes(T)){const O=r({contents:o.getOverrideValue(void 0,T)||{},keys:o.getKeysForOverrideIdentifier(T)},{contents:n.getOverrideValue(void 0,T)||{},keys:n.getKeysForOverrideIdentifier(T)});l.push([T,[...O.added,...O.removed,...O.updated]])}}return{added:t,removed:s,updated:c,overrides:l}}function r(o,n){const t=o?n?o.keys.filter(l=>n.keys.indexOf(l)===-1):[...o.keys]:[],s=n?o?n.keys.filter(l=>o.keys.indexOf(l)===-1):[...n.keys]:[],c=[];if(o&&n){for(const l of n.keys)if(o.keys.indexOf(l)!==-1){const g=(0,I.getConfigurationValue)(n.contents,l),v=(0,I.getConfigurationValue)(o.contents,l);P.equals(g,v)||c.push(l)}}return{added:t,removed:s,updated:c}}}),define(te[185],ne([0,1,5,3,2,18,21,90,39,35]),function(X,e,R,L,D,k,i,P,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends D.Disposable{constructor(d,p){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,p)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(C.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,p){const h=typeof d=="string"?d:void 0,b=(0,i.isConfigurationOverrides)(d)?d:(0,i.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,b,void 0)}updateValue(d,p,h,b){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(h,p,1)}onDidDefaultConfigurationChange(d){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,d);this.trigger(h,p,6)}trigger(d,p,h){const b=new P.ConfigurationChangeEvent(d,{data:p},this.configuration);b.source=h,b.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(b)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(te[186],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var L;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(i,P=L.Unknown,w){super(i);this._message=i,this._code=P,this._detail=w,this.isHandled=P===L.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(i){return i instanceof D&&i._code===L.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof D&&i._code===L.NoResolverFound}static isHandled(i){return i instanceof D&&i.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[187],ne([0,1,5,19,27,8,3,2,29,73,186]),function(X,e,R,L,D,k,i,P,w,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var d;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function p(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(F){const B=new D.CancellationTokenSource;return setTimeout(()=>B.cancel(),F),B.token}function b(F,B){if(F.isCancellationRequested||B.isCancellationRequested)return D.CancellationToken.Cancelled;const V=new D.CancellationTokenSource;return F.onCancellationRequested(()=>V.cancel()),B.onCancellationRequested(()=>V.cancel()),V.token}class y{constructor(B){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((V,Q)=>{this._resolvePromise=V,this._rejectPromise=Q}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function m(F,B){const V=new y(B);return V.registerDisposable(F.onControlMessage(Q=>{const Z=JSON.parse(Q.toString()),G=q(Z);G?V.reject(G):V.resolve(Z)})),V.promise}function S(F,B,V,Q,Z,G){const H=new y(G);return B.connect(V,Q,Z,(re,ie)=>{H.didTimeout?(re&&F.error(re),ie?.dispose()):re||!ie?H.reject(re):H.resolve(ie)}),H.promise}function f(F,B){const V=new y(B);return F.then(Q=>{V.didTimeout||V.resolve(Q)},Q=>{V.didTimeout||V.reject(Q)}),V.promise}async function a(F,B,V,Q){const Z=$(F,B);F.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let G;try{G=await S(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,Q)}catch(le){throw F.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),F.logService.error(le),le}F.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let H,re;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(G,null),H=F.reconnectionProtocol,re=!1):(H=new C.PersistentProtocol(G,null),re=!0),F.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const ie=await f(F.signService.createNewMessage((0,w.generateUuid)()),Q),ce={type:"auth",auth:F.connectionToken||"00000000000000000000",data:ie.data};H.sendControl(L.VSBuffer.fromString(JSON.stringify(ce)));try{const le=await m(H,b(Q,h(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(F.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await f(F.signService.validate(ie,le.signedData),Q)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const de=await f(F.signService.sign(le.data),Q),be={type:"connectionType",commit:F.commit,signedData:de,desiredConnectionType:B};return V&&(be.args=V),F.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(L.VSBuffer.fromString(JSON.stringify(be))),{protocol:H,ownsProtocol:re}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(F.logService.error(`${Z} the handshake timed out. Error:`),F.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${Z} received error control message when negotiating connection. Error:`),F.logService.error(le)),re&&M(H),le}}async function u(F,B,V,Q){const Z=Date.now(),G=$(F,B),{protocol:H,ownsProtocol:re}=await a(F,B,V,Q),ie=new y(Q);return ie.registerDisposable(H.onControlMessage(ce=>{const le=JSON.parse(ce.toString()),fe=q(le);fe?(F.logService.error(`${G} received error control message when negotiating connection. Error:`),F.logService.error(fe),re&&M(H),ie.reject(fe)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${K(Z)}!`),ie.resolve({protocol:H,firstMessage:le}))})),ie.promise}async function r(F,B){const{protocol:V}=await u(F,1,void 0,B);return{protocol:V}}async function o(F,B,V){const{protocol:Q,firstMessage:Z}=await u(F,2,B,V),G=Z&&Z.debugPort;return{protocol:Q,debugPort:G}}async function n(F,B,V){const Q=Date.now(),Z=$(F,3),{protocol:G}=await a(F,3,B,V);return F.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${K(Q)}!`),G}async function t(F,B,V){const{host:Q,port:Z,connectionToken:G}=await F.addressProvider.getAddress();return{commit:F.commit,host:Q,port:Z,connectionToken:G,reconnectionToken:B,reconnectionProtocol:V,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function s(F,B,V){try{const Q=(0,w.generateUuid)(),Z=await t(F,Q,null),{protocol:G}=await r(Z,D.CancellationToken.None);return new z(F,B,V,Q,G)}catch(Q){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(Q),_.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentManagement=s;async function c(F,B){try{const V=(0,w.generateUuid)(),Q=await t(F,V,null),{protocol:Z,debugPort:G}=await o(Q,B,D.CancellationToken.None);return new A(F,B,V,Z,G)}catch(V){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(V),_.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentExtensionHost=c;async function l(F,B,V){const Q=await t(F,(0,w.generateUuid)(),null);return await n(Q,{host:B,port:V},D.CancellationToken.None)}e.connectRemoteAgentTunnel=l;function g(F){return(0,R.createCancelablePromise)(B=>new Promise((V,Q)=>{const Z=setTimeout(V,F*1e3);B.onCancellationRequested(()=>{clearTimeout(Z),V()})}))}var v;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(v=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class T{constructor(B,V){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.type=0}}e.ConnectionLostEvent=T;class O{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.durationSeconds=Q,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class U{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=U;class x{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=x;class N{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=N;class _ extends P.Disposable{constructor(B,V,Q,Z){super();this._connectionType=B,this._onDidStateChange=this._register(new i.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=V,this.reconnectionToken=Q,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(G=>{const H=W(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const G=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${G} received socket timeout event.`),this._beginReconnecting()})),_._instances.push(this),_._permanentFailure&&this._gotoPermanentFailure(_._permanentFailureMillisSinceLastIncomingData,_._permanentFailureAttempt,_._permanentFailureHandled)}static triggerPermanentFailure(B,V,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=V,this._permanentFailureHandled=Q,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(_._permanentFailure)return;const B=W(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const Z=Q<V.length?V[Q]:V[V.length-1];try{if(Z>0){const H=g(Z);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,H)),this._options.logService.info(`${B} waiting for ${Z} seconds before reconnecting...`);try{await H}catch{}}if(_._permanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${B} resolving connection...`);const G=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${G.host}:${G.port}...`),await this._reconnect(G,h(E)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),_.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),_.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,k.isPromiseCanceledError)(G)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),_.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,I.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),_.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!_._permanentFailure)}_gotoPermanentFailure(B,V,Q){this._onDidStateChange.fire(new N(this.reconnectionToken,B,V,Q)),M(this.protocol)}}_._permanentFailure=!1,_._permanentFailureMillisSinceLastIncomingData=0,_._permanentFailureAttempt=0,_._permanentFailureHandled=!1,_._instances=[];class z extends _{constructor(B,V,Q,Z,G){super(1,B,Z,G);this.client=this._register(new C.Client(G,{remoteAuthority:V,clientId:Q},B.ipcLogger))}async _reconnect(B,V){await r(B,V)}}e.ManagementPersistentConnection=z;class A extends _{constructor(B,V,Q,Z,G){super(2,B,Q,Z);this._startArguments=V,this.debugPort=G}async _reconnect(B,V){await o(B,this._startArguments,V)}}e.ExtensionHostPersistentConnection=A;function M(F){try{F.acceptDisconnect();const B=F.getSocket();F.dispose(),B.dispose()}catch(B){(0,k.onUnexpectedError)(B)}}function q(F){if(F&&F.type==="error"){const B=new Error(`Connection error: ${F.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function j(F,B){for(;F.length<B;)F+=" ";return F}function W(F,B,V){return`[remote-connection][${j(p(F),13)}][${B.substr(0,5)}\u2026][${V?"reconnect":"initial"}]`}function $(F,B){return`${W(B,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function K(F){return`${Date.now()-F} ms`}}),define(te[188],ne([0,1,15]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(C){return C.scheme===R.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=L;function D(C){if(!C)return;const I=C.indexOf("+");return I<0?C:C.substr(0,I)}e.getRemoteName=D;function k(C){return C.scheme!==R.Schemas.file&&C.scheme!==R.Schemas.vscodeRemote}e.isVirtualResource=k;function i(C){if(C.folders.length)return C.folders.every(I=>k(I.uri))?C.folders[0].uri:void 0;if(C.configuration&&k(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=i;function P(C){return i(C)?.scheme}e.getVirtualWorkspaceScheme=P;function w(C){return i(C)!==void 0}e.isVirtualWorkspace=w}),define(te[91],ne([0,1,25,6,188]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=k;function i(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class w{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let b=typeof p=="string"?p:p.value,y=typeof h=="string"?h:h.value;return R.equalsIgnoreCase(b,y)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=w;function C(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function I(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function E(d,p){if(p){const h=`onResolveRemoteAuthority:${(0,D.getRemoteName)(p)}`;return d.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[36],ne([0,1,25,91]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,b){return h.uuid&&b.uuid?h.uuid===b.uuid:h.id===b.id?!0:(0,R.compareIgnoreCase)(h.id,b.id)===0}e.areSameExtensions=D;class k{constructor(b,y){this.version=y,this.id=b.id,this.uuid=b.uuid}key(){return`${this.id}-${this.version}`}equals(b){return b instanceof k?D(this,b)&&this.version===b.version:!1}}e.ExtensionIdentifierWithVersion=k;function i(h,b){return`${h}.${b}`}e.getExtensionId=i;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function w(h,b){return P(i(h,b))}e.getGalleryExtensionId=w;function C(h,b){const y=[],m=S=>{for(const f of y)if(f.some(a=>D(b(a),b(S))))return f;return null};for(const S of h){const f=m(S);f?f.push(S):y.push([S])}return y}e.groupByExtension=C;function I(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function E(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function d(h){const b=new Set;for(const y of h)y.malicious&&b.add(y.id.id);return b}e.getMaliciousExtensionsSet=d;function p(h,b){const y=[],m=b.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const S=m.shift();if(S&&y.every(f=>!D(f.identifier,{id:S}))){const f=h.filter(a=>D(a.identifier,{id:S}));f.length===1&&(y.push(f[0]),m.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.getExtensionDependencies=p}),define(te[189],ne([0,1,5,8,2,4,18,62,9,29,20,11,30,36,14,7]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends D.Disposable{constructor(f,a,u,r){super();this.fileService=a,this.extensionGalleryService=u,this.logService=r,this.extensionsDownloadDir=w.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,a){await this.cleanUpPromise;const u=this.getName(f),r=(0,i.joinPath)(this.extensionsDownloadDir,u);if(!await this.fileService.exists(r)){const o=(0,i.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(f,o,a);try{await this.rename(o,r,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(o)}catch(t){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,o.path),n}}return r}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,a,u){try{await I.Promises.rename(f.fsPath,a.fsPath)}catch(r){if(k.isWindows&&r&&r.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${f} to ${a} with 'EPERM' error. Trying again...`),this.rename(f,a,u);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const a=[],u=[];for(const n of f.children){const t=this.parse(n.name);t&&u.push([t,n])}const r=(0,p.groupByExtension)(u,([n])=>n),o=[];for(const n of r)n.sort((t,s)=>P.rcompare(t[0].version,s[0].version)),a.push(...n.slice(1).map(t=>t[1].resource)),o.push(n[0][1]);o.sort((n,t)=>n.mtime-t.mtime),a.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(n=>n.resource)),await R.Promises.settled(a.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new p.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,C.generateUuid)()}parse(f){const a=y.exec(f);return a&&a[1]&&a[2]?new p.ExtensionIdentifierWithVersion({id:a[1]},a[2]):null}};m=he([J(0,E.INativeEnvironmentService),J(1,h.IFileService),J(2,d.IExtensionGalleryService),J(3,b.ILogService)],m),e.ExtensionsDownloader=m}),define(te[190],ne([0,1,2,10,20,91]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class i extends R.Disposable{constructor(w,C){super();this.environmentService=w,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(C.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(w){w.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(w){w.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=i}),define(te[191],ne([0,1,83,16,5,2,15,10,20,11,30,36,60,7]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends k.Disposable{constructor(m,S,f){super();this.extensionManagementService=m,this.logService=f,this.cache=this._register(new b(S,f)),this.extensionManagementService.registerParticipant({postInstall:async a=>this.postInstallExtension(a),postUninstall:async a=>this.postUninstallExtension(a)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),S=["en",...Object.keys(m)];return(0,L.distinct)(S)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const S=await this.cache.getLanguagePacks();Object.keys(S).some(f=>S[f]&&S[f].extensions.some(a=>(0,E.areSameExtensions)(a.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,S]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(S);return!(0,L.equals)(Object.keys(m),Object.keys(f))}};h=he([J(0,I.IExtensionManagementService),J(1,C.INativeEnvironmentService),J(2,p.ILogService)],h),e.LocalizationsService=h;let b=class extends k.Disposable{constructor(m,S){super();this.logService=S,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(S=>{Object.keys(S).forEach(f=>delete S[f]),this.createLanguagePacksFromExtensions(S,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...S){for(const f of S)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,f);Object.keys(m).forEach(f=>this.updateHash(m[f]))}createLanguagePacksFromExtension(m,S){const f=S.identifier,a=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const u of a)if(S.location.scheme===i.Schemas.file&&(0,d.isValidLocalization)(u)){let r=m[u.languageId];r||(r={hash:"",extensions:[],translations:{}},m[u.languageId]=r);let o=r.extensions.filter(n=>(0,E.areSameExtensions)(n.extensionIdentifier,f))[0];o?o.version=S.manifest.version:r.extensions.push({extensionIdentifier:f,version:S.manifest.version});for(const n of u.translations)r.translations[n.id]=(0,P.join)(S.location.fsPath,n.path)}}updateHash(m){if(m){const S=(0,R.createHash)("md5");for(const f of m.extensions)S.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);m.hash=S.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let S=null;return w.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(a){return{}}}).then(f=>(S=m(f),f)).then(f=>{for(const u of Object.keys(f))f[u]||delete f[u];this.languagePacks=f,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),w.Promises.writeFile(this.languagePacksFilePath,a)}).then(()=>S,f=>this.logService.error(f))})}};b=he([J(0,C.INativeEnvironmentService),J(1,p.ILogService)],b)}),define(te[192],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[63],ne([0,1,3,4,6,7]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var i;(function(h){h.Http="http",h.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=E;function d(h,b){return b?b!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=d;let p=class{constructor(b){this.logService=b,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(b,y){return this._tunnelProvider=b,b?(this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const b=[],y=Array.from(this._tunnels.values());for(let m of y){const S=Array.from(m.values());for(let f of S){const a=await f.value;a&&b.push(a)}}return b}async dispose(){for(const b of this._tunnels.values()){for(const{value:y}of b.values())await y.then(m=>m?.dispose());b.clear()}this._tunnels.clear()}openTunnel(b,y,m,S,f=!1,a=P.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${m} on local port ${S}.`),!b)return;y||(y="localhost");const r=this.retainOrCreateTunnel(b,y,m,S,f,a,u);return r?r.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(y,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(o);return(o.tunnelRemoteHost!==y||o.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const y=this._tunnels.get(b.tunnelRemoteHost);if(y){const m=y.get(b.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,m))}}}}async tryDisposeTunnel(b,y,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${y}.`);const S=m.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(y),S}}async closeTunnel(b,y){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${y} `);const m=this._tunnels.get(b);if(m&&m.has(y)){const S=m.get(y);S.refcount=0,await this.tryDisposeTunnel(b,y,S)}}addTunnelToMap(b,y,m){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(y,{refcount:1,value:m})}async removeEmptyTunnelFromMap(b,y){const m=this._tunnels.get(b);m&&(await m.get(y)||m.delete(y),m.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,y){let m=[b];I(b)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(b)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const S=m.map(f=>this._tunnels.get(f));for(const f of S){const a=f?.get(y);if(a)return a}}canTunnel(b){return!!C(b)}createWithProvider(b,y,m,S,f,a,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${m} on local port ${S}.`);const o={elevationRequired:f?d(S===void 0?m:S):!1},n={remoteAddress:{host:y,port:m},localAddressPort:S,privacy:a,public:a!==P.Private,protocol:u},t=b.forwardPort(n,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(y,m,t),t}};p=he([J(0,k.ILogService)],p),e.AbstractTunnelService=p}),define(te[193],ne([0,1,7,63,2,8,5]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends D.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new i.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let w=class Ct extends D.Disposable{constructor(I,E){super();this._tunnelService=I,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(I,E,d,p,h,b){const y=new P,m=await Promise.resolve(this._tunnelService.openTunnel(I,y,d,p,h,b));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${p} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),y.dispose(),await m.dispose(),(0,k.canceled)();return y.setTunnel(m),this._tunnels.set(E,y),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${m.localAddress} (local) to ${d}:${p} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(I,E){const d=this._tunnels.get(I);!d||d.setAddress(E)}async destroyTunnel(I){const E=this._tunnels.get(I);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await E.dispose();return}this._disposedTunnels.add(I)}};w._lastId=0,w=he([J(0,L.ISharedTunnelsService),J(1,R.ILogService)],w),e.SharedProcessTunnelService=w}),define(te[194],ne([0,1,122,21,7]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(P,w){this.configurationService=P,this.logService=w}request(P,w){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,R.request)(P,w)}async resolveProxy(P){}};k=he([J(0,L.IConfigurationService),J(1,D.ILogService)],k),e.RequestService=k}),define(te[44],ne([0,1,19,143,39,6,35]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function w(h){return h.res.statusCode===204}async function C(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return w(h)?null:(await(0,R.streamToBuffer)(h.stream)).toString()}e.asText=C;async function I(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(w(h))return null;const y=(await(0,R.streamToBuffer)(h.stream)).toString();try{return JSON.parse(y)}catch(m){throw m.message+=`:
`+y,m}}e.asJson=I;function E(h){p(h)}e.updateProxyConfigurationsScope=E;let d;function p(h){const b=i.Registry.as(D.Extensions.Configuration),y=d;d={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[d],remove:y?[y]:[]})}p(2)}),define(te[195],ne([0,1,27,15,14,44]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let i=class{constructor(w,C){this.requestService=w,this.fileService=C}async download(w,C,I=R.CancellationToken.None){if(w.scheme===L.Schemas.file||w.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(w,C);return}const E={type:"GET",url:w.toString()},d=await this.requestService.request(E,I);if(d.res.statusCode===200)await this.fileService.writeFile(C,d.stream);else{const p=await(0,k.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${p}`)}}};i=he([J(0,k.IRequestService),J(1,D.IFileService)],i),e.DownloadService=i}),define(te[196],ne([0,1,16,27,67,2,18,157,14,7,26,44]),function(X,e,R,L,D,k,i,P,w,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends k.Disposable{constructor(h,b,y,m){super();this.fileService=h,this.productService=b,this.requestService=y,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:S})=>this.allConfigBasedTips.set(S.configPath,S))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const b=[];for(const[y,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const S=await this.fileService.readFile((0,i.joinPath)(h,y)),f=new Map;(0,D.forEach)(m.recommendations,({key:u,value:r})=>{if((0,R.isNonEmptyArray)(r.remotes))for(const o of r.remotes)f.set(o,{extensionId:u,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else b.push({extensionId:u,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const a=(0,P.getDomainsOfRemotes)(S.value.toString(),[...f.keys()]);for(const u of a){const r=f.get(u);r&&b.push(r)}}catch(S){}return b}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(h.res.statusCode!==200)return[];const b=await(0,E.asJson)(h);return b?b.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};d=he([J(0,w.IFileService),J(1,I.IProductService),J(2,E.IRequestService),J(3,C.ILogService)],d),e.ExtensionTipsService=d}),define(te[46],ne([0,1,19,29]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(k,i,P){let w=P&&P.get("storage.serviceMachineId",0)||null;if(w)return w;try{const I=(await i.readFile(k.serviceMachineIdResource)).value.toString();w=(0,L.isUUID)(I)?I:null}catch(C){w=null}if(!w){w=(0,L.generateUuid)();try{await i.writeFile(k.serviceMachineIdResource,R.VSBuffer.fromString(w))}catch(C){}}return P&&P.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=D}),define(te[92],ne([0,1,106,6]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(k){return(0,R.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,L.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[197],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(L){L.Spawn="vscode:shared-process->shared-process-worker=spawn",L.Terminate="vscode:shared-process->shared-process-worker=terminate",L.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",L.Ready="vscode:shared-process-worker->shared-process=ready",L.Ack="vscode:shared-process-worker->shared-process=ack",L.Trace="vscode:shared-process-worker->shared-process=trace",L.Info="vscode:shared-process-worker->shared-process=info",L.Warn="vscode:shared-process-worker->shared-process=warn",L.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[198],ne([0,1,74,155,27,3,2,15,4,29,11,7,26,92,197]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let b=class{constructor(S,f,a){this.logService=S,this.productService=f,this.environmentService=a,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const f=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${f})`);const a=(0,p.hash)(S);this.processeDisposables.has(a)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${f})`),this.doDisposeWorker(S));const u=new D.CancellationTokenSource;let r,o,n;this.processeDisposables.set(a,l=>{u.dispose(!0),r?.terminate(S,D.CancellationToken.None),o?.close(),n?.close(),this.processeDisposables.delete(a);const g=this.processResolvers.get(a);g&&(this.processResolvers.delete(a),g({reason:l}))}),r=await this.getOrCreateWebWorker(S);const t=new Promise(l=>{this.processResolvers.set(a,l)});if(u.token.isCancellationRequested)return t;const{port1:s,port2:c}=new MessageChannel;return o=s,n=c,await r.spawn(S,n,u.token),u.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${f})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[o])),t}getOrCreateWebWorker(S){let f=this.workers.get(S.process.moduleId);if(!f){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const a=new y(S.process.type,this.logService,this.productService,this.environmentService);f=a.init(),a.onDidProcessSelfTerminate(({configuration:u,reason:r})=>{this.doDisposeWorker(u,r)}),this.workers.set(S.process.moduleId,f)}return f}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,f){const a=this.processeDisposables.get((0,p.hash)(S));a&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),a(f))}};b=he([J(0,E.ILogService),J(1,d.IProductService),J(2,I.INativeEnvironmentService)],b),e.SharedProcessWorkerService=b;class y extends i.Disposable{constructor(S,f,a,u){super();this.type=S,this.logService=f,this.productService=a,this.environmentService=u,this._onDidProcessSelfTerminate=this._register(new k.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){let S;const f=new Promise(u=>S=u),a=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return a.onerror=u=>{this.logService.error(`SharedProcess: worker error (${this.type})`,u.message)},a.onmessageerror=u=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,u)},a.onmessage=u=>{const{id:r,message:o,configuration:n,nonce:t}=u.data;switch(r){case h.SharedProcessWorkerMessages.Ready:S(a);break;case h.SharedProcessWorkerMessages.Ack:if(t){const s=this.mapMessageNonceToPendingMessageResolve.get(t);s&&(this.mapMessageNonceToPendingMessageResolve.delete(t),s())}break;case h.SharedProcessWorkerMessages.SelfTerminated:n&&o&&this._onDidProcessSelfTerminate.fire({configuration:n,reason:JSON.parse(o)});break;case h.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,o);break;case h.SharedProcessWorkerMessages.Info:o&&this.logService.info(o);break;case h.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,o);break;case h.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,o);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,u)}},a.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),f}async send(S,f,a){const u=await this.workerReady;if(!f.isCancellationRequested)return new Promise(r=>{const o=(0,C.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(o,r);const n={...S,nonce:o};a?u.postMessage(n,[a]):u.postMessage(n),f.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(o)&&r()})})}spawn(S,f,a){const u={id:h.SharedProcessWorkerMessages.Spawn,configuration:S,environment:this.getSharedProcessWorkerEnvironment()};return this.send(u,a,f)}getSharedProcessWorkerEnvironment(){const S={bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",X).fsPath,env:Object.create(null)};if(w.isLinux){const f={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},a=this.environmentService.args["crash-reporter-id"],u=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&u&&a&&(0,C.isUUID)(a)){const n=u["linux-x64"];f.submitURL=n.concat("&uid=",a,"&iid=",a,"&sid=",a),f.uploadToServer=!0}const o=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;S.env.BREAKPAD_DUMP_LOCATION=(0,L.join)(o,this.type),S.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(f)}return S}terminate(S,f){const a={id:h.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(a,f)}}}),define(te[93],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[199],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((D,k)=>X(["vsda"],D,k))}async createNewMessage(D){try{const k=await this.vsda(),i=new k.validator;if(i){const P=String(R._nextId++);return this.validators.set(P,i),{id:P,data:i.createNewMessage(D)}}}catch(k){}return{id:"",data:D}}async validate(D,k){if(!D.id)return!0;const i=this.validators.get(D.id);if(!i)return!1;this.validators.delete(D.id);try{return i.validate(k)==="ok"}catch(P){return!1}}async sign(D){try{const k=await this.vsda(),i=new k.signer;if(i)return i.sign(D)}catch(k){}return D}}e.SignService=R,R._nextId=1}),define(te[23],ne([0,1,5,3,2,181,17,75,6]),function(X,e,R,L,D,k,i,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,w.createDecorator)("storageService");var I;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var d;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class p extends D.Disposable{constructor(m={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,S){S===C?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:S,target:this.getKeyTargets(m)[S]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,S,f){return this.getStorage(S)?.get(m,f)}getBoolean(m,S,f){return this.getStorage(S)?.getBoolean(m,f)}getNumber(m,S,f){return this.getStorage(S)?.getNumber(m,f)}store(m,S,f,a){if((0,i.isUndefinedOrNull)(S)){this.remove(m,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,f,a),this.getStorage(f)?.set(m,S)})}remove(m,S){this.withPausedEmitters(()=>{this.updateKeyTarget(m,S,void 0),this.getStorage(S)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,S){const f=[],a=this.getKeyTargets(m);for(const u of Object.keys(a))a[u]===S&&f.push(u);return f}updateKeyTarget(m,S,f){const a=this.getKeyTargets(S);typeof f=="number"?a[m]!==f&&(a[m]=f,this.getStorage(S)?.set(C,JSON.stringify(a))):typeof a[m]=="number"&&(delete a[m],this.getStorage(S)?.set(C,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const S=this.get(C,m);if(S)try{return JSON.parse(S)}catch(f){}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=I.NONE){this._onWillSaveState.fire({reason:m});const S=this.getStorage(0),f=this.getStorage(1);switch(m){case I.NONE:await R.Promises.settled([S?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await R.Promises.settled([S?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return b(m,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends p{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function b(y,m,S,f){const a=c=>{try{return JSON.parse(c)}catch(l){return c}},u=new Map,r=new Map;y.forEach((c,l)=>{u.set(l,c),r.set(l,a(c))});const o=new Map,n=new Map;m.forEach((c,l)=>{o.set(l,c),n.set(l,a(c))}),console.group(`Storage: Global (path: ${S})`);let t=[];u.forEach((c,l)=>{t.push({key:l,value:c})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${f})`);let s=[];o.forEach((c,l)=>{s.push({key:l,value:c})}),console.table(s),console.groupEnd(),console.log(n)}e.logStorage=b}),define(te[200],ne([0,1,3,2,17,30,36,23]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let w=class extends L.Disposable{constructor(E){super();this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new C(E)),this._register(this.storageManger.onDidChange(d=>this._onDidChangeEnablement.fire({extensions:d,source:"storage"})))}async enableExtension(E,d){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:d}),!0):!1}async disableExtension(E,d){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let d=this.getDisabledExtensions();return d.every(p=>!(0,i.areSameExtensions)(p,E))?(d.push(E),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(E){let d=this.getDisabledExtensions();for(let p=0;p<d.length;p++){const h=d[p];if((0,i.areSameExtensions)(h,E))return d.splice(p,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(E){this._setExtensions(k.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,d){this.storageManger.set(E,d,0)}};w=he([J(0,P.IStorageService)],w),e.GlobalExtensionEnablementService=w;class C extends L.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(E,d){let p;return d===0?((0,D.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,d)),p=this.storage[E]):p=this._get(E,d),JSON.parse(p)}set(E,d,p){let h=JSON.stringify(d.map(({id:y,uuid:m})=>({id:y,uuid:m})));this._get(E,p)!==h&&(p===0&&(d.length?this.storage[E]=h:delete this.storage[E]),this._set(E,d.length?h:void 0,p))}onDidStorageChange(E){if(E.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const p=this.get(E.key,E.scope);delete this.storage[E.key];const h=this.get(E.key,E.scope),b=p.filter(m=>!h.some(S=>(0,i.areSameExtensions)(m,S))),y=h.filter(m=>!p.some(S=>(0,i.areSameExtensions)(S,m)));(b.length||y.length)&&this._onDidChange.fire([...b,...y])}}_get(E,d){return this.storageService.get(E,d,"[]")}_set(E,d,p){d?this.storageService.store(E,d,p,1):this.storageService.remove(E,p)}}e.StorageManager=C}),define(te[201],ne([0,1,3,2]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends L.Disposable{constructor(C,I){super();this.channel=C,this.workspace=I}async getItems(){const C={workspace:this.workspace},I=await this.channel.call("getItems",C);return new Map(I)}updateItems(C){const I={workspace:this.workspace};return C.insert&&(I.insert=Array.from(C.insert.entries())),C.delete&&(I.delete=Array.from(C.delete.values())),this.channel.call("updateItems",I)}}class k extends D{constructor(C){super(C,void 0);this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(C=>this.onDidChangeGlobalStorage(C)))}onDidChangeGlobalStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}async close(){this.dispose()}}class i extends D{constructor(C,I){super(C,I);this.onDidChangeItemsExternal=R.Event.None}async close(){const C={workspace:this.workspace};return this.channel.call("close",C)}}class P extends L.Disposable{constructor(C,I){super();this.channel=C,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new k(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new i(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[202],ne([0,1,5,2,18,75,23,201]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends i.AbstractStorageService{constructor(I,E,d){super();this.mainProcessService=E,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new k.Storage(I.globalStorage);return this._register(E.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),E}createWorkspaceStorage(I){const E=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(E.workspaceStorage){const d=new k.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=I?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await R.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,D.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(i.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const E=this.workspaceStorage,d=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[p,h]of d)this.workspaceStorage.set(p,h)}}e.NativeStorageService=w}),define(te[203],ne([0,1,4,31,9,29]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function i(C){if(R.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function P(C,I,E,d,p,h,b,y,m,S){const f=Object.create(null);f["common.machineId"]=b,f.sessionID=(0,k.generateUuid)()+Date.now(),f.commitHash=p,f.version=h,f["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,R.PlatformToString)(R.platform),f["common.nodePlatform"]=L.platform,f["common.nodeArch"]=d,f["common.product"]=S||"desktop";const a=w(y||[]);a&&(f["common.msftInternal"]=a);let u=0;const r=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),R.isLinuxSnap&&(f["common.snap"]="true");const o=i(E);o&&(f["common.platformDetail"]=o);try{const n=await C.readFile(D.URI.file(m));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}e.resolveCommonProperties=P;function w(C){const I=L.env.USERDNSDOMAIN;if(!I)return!1;const E=I.toLowerCase();return C.some(d=>E===d)}e.verifyMicrosoftInternalDomain=w}),define(te[22],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[204],ne([0,1,33,56,5,32,15,10,4,9,115,20,118,79,14,26,22]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(r,o){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],t=new Map,s=new Map,c=2e4;function l(T,O,U,x){const N=O.substring(T.length+1);return D.Promises.withAsyncBody(async _=>{let z;try{z=await E.Promises.readdir(O,{withFileTypes:!0})}catch(q){_();return}if(x.count>=c){x.count+=z.length,x.maxReached=!0,_();return}let A=z.length;if(A===0){_();return}let M=z;x.count+z.length>c&&(x.maxReached=!0,A=c-x.count,M=z.slice(0,A)),x.count+=z.length;for(const q of M)if(q.isDirectory()){if(U.includes(q.name)||await l(T,(0,P.join)(O,q.name),U,x),--A==0){_();return}}else{const j=q.name.lastIndexOf(".");if(j>=0){const W=q.name.substring(j+1);W&&t.set(W,(t.get(W)??0)+1)}for(const W of n)W.relativePathPattern?.test(N)!==!1&&W.filePattern.test(q.name)&&s.set(W.tag,(s.get(W.tag)??0)+1);if(--A==0){_();return}}})}const g={count:0,maxReached:!1};await l(r,r,o,g);const v=await a(r);return{configFiles:S(s),fileTypes:S(t),fileCount:g.count,maxFilesReached:g.maxReached,launchConfigFiles:v}}e.collectWorkspaceStats=m;function S(r){return[...L.Iterable.map(r.entries(),([o,n])=>({name:o,count:n}))].sort((o,n)=>n.count-o.count)}function f(){const r={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},o=R.cpus();return o&&o.length>0&&(r.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),r}e.getMachineInfo=f;async function a(r){try{const o=new Map,n=(0,P.join)(r,".vscode","launch.json"),t=await E.Promises.readFile(n),s=[],c=(0,k.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,k.getNodeType)(c)==="object"&&c.configurations)for(const l of c.configurations){const g=l.type;g&&(o.has(g)?o.set(g,o.get(g)+1):o.set(g,1))}return S(o)}catch(o){return[]}}e.collectLaunchConfigs=a;let u=class{constructor(o,n){this.telemetryService=o,this.productService=n}formatMachineInfo(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}formatEnvironment(o){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const t=R.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||n.push(`Load (avg):       ${R.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,d.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async t=>{let[s,c]=t,l=this.formatProcessList(o,s);return n.forEach(g=>{if((0,p.isRemoteDiagnosticError)(g))l+=`
${g.errorMessage}`,c+=`
${g.errorMessage}`;else if(l+=`

Remote: ${g.hostName}`,g.processes&&(l+=`
${this.formatProcessList(o,g.processes)}`),g.workspaceMetadata){c+=`
|  Remote: ${g.hostName}`;for(const v of Object.keys(g.workspaceMetadata)){const T=g.workspaceMetadata[v];let O=`${T.fileCount} files`;T.maxFilesReached&&(O=`more than ${O}`),c+=`|    Folder (${v}): ${O}`,c+=this.formatWorkspaceStats(T)}}}),{processInfo:l,workspaceInfo:c}})}async getSystemInfo(o,n){const{memory:t,vmHint:s,os:c,cpus:l}=f(),g={os:c,memory:t,cpus:l,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return w.isWindows||(g.load=`${R.loadavg().map(v=>Math.round(v)).join(", ")}`),w.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(o,n){const t=[];return(0,d.listProcesses)(o.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(o)),t.push(""),t.push(this.formatProcessList(o,s)),o.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(o))),n.forEach(c=>{if((0,p.isRemoteDiagnosticError)(c))t.push(`
${c.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${c.hostName}`),t.push(this.formatMachineInfo(c.machineInfo)),c.processes&&t.push(this.formatProcessList(o,c.processes)),c.workspaceMetadata)for(const l of Object.keys(c.workspaceMetadata)){const g=c.workspaceMetadata[l];let v=`${g.fileCount} files`;g.maxFilesReached&&(v=`more than ${v}`),t.push(`Folder (${l}): ${v}`),t.push(this.formatWorkspaceStats(g))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(o){const n=[],t=60;let s=0;const c=(T,O)=>{const U=` ${T}(${O})`;s+U.length>t?(n.push(l),l="|                 ",s=l.length):s+=U.length,l+=U};let l="|      File types:";const g=10;let v=o.fileTypes.length>g?g:o.fileTypes.length;for(let T=0;T<v;T++){const O=o.fileTypes[T];c(O.name,O.count)}if(n.push(l),o.configFiles.length>=0&&(l="|      Conf files:",s=0,o.configFiles.forEach(T=>{c(T.name,T.count)}),n.push(l)),o.launchConfigFiles.length>0){let T="|      Launch Configs:";o.launchConfigFiles.forEach(O=>{T+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(T)}return n.join(`
`)}expandGPUFeatures(o){const n=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${o[t]}`).join(`
                  `)}formatWorkspaceMetadata(o){const n=[],t=[];return o.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const l=C.URI.revive(c);if(l.scheme===i.Schemas.file){const g=l.fsPath;t.push(m(g,["node_modules",".git"]).then(v=>{let T=`${v.fileCount} files`;v.maxFilesReached&&(T=`more than ${T}`),n.push(`|    Folder (${(0,P.basename)(g)}): ${T}`),n.push(this.formatWorkspaceStats(v))}).catch(v=>{n.push(`|      Error: Unable to collect workspace stats for folder ${g} (${v.toString()})`)}))}else n.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(o,n){const t=new Map;o.windows.forEach(c=>t.set(c.pid,c.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(o.mainPID,t,s,n,0),s.join(`
`)}formatProcessItem(o,n,t,s,c){const l=c===0;let g;l?g=s.pid===o?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(c)} ${s.name}`,s.name==="window"&&(g=`${g} (${n.get(s.pid)})`));const v=process.platform==="win32"?s.mem:R.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(v/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(s.children)&&s.children.forEach(T=>this.formatProcessItem(o,n,t,T,c+1))}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const t=C.URI.revive(n);if(t.scheme!==i.Schemas.file)continue;const s=t.fsPath;try{const c=await m(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),c.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:l.name,count:l.count})}),c.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:l.name,count:l.count})}),c.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};u=he([J(0,y.ITelemetryService),J(1,b.IProductService)],u),e.DiagnosticsService=u}),define(te[205],ne([0,1,16,5,27,8,3,2,4,9,132,30,36,7,26,22]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let y=class extends P.Disposable{constructor(r,o,n,t){super();this.galleryService=r,this.telemetryService=o,this.logService=n,this.productService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new i.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new i.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new i.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new i.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const o=await this.getTargetPlatform();return r.allTargetPlatforms.some(n=>(0,E.isTargetPlatformCompatible)(n,r.allTargetPlatforms,o))}async installFromGallery(r,o={}){try{return await this.doInstallFromGallery(r,o)}catch(n){throw this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(n),S(n)}}async uninstall(r,o={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,o)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(0,null));const o=await this.findGalleryExtension(r);if(!o)throw new Error(I.localize(1,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsReport(){const r=new Date().getTime();return(!this.reportedExtensions||r-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=r),this.reportedExtensions}registerParticipant(r){this.participants.push(r)}async doInstallFromGallery(r,o={}){if(!this.galleryService.isEnabled())throw new E.ExtensionManagementError(I.localize(2,null),E.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(r)){const t=await this.getTargetPlatform(),s=new E.ExtensionManagementError(I.localize(3,null,r.identifier.id,this.productService.nameLong,(0,E.TargetPlatformToString)(t)),E.ExtensionManagementErrorCode.Incompatible);throw f(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(r),void 0,s),s}try{r=await this.checkAndGetCompatibleVersion(r,!o.installGivenVersion)}catch(t){throw f(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(r),void 0,t),t}const n=await this.galleryService.getManifest(r,D.CancellationToken.None);if(n===null){const t=new E.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);throw f(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(r),void 0,t),t}if(n.version!==r.version){const t=new E.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);throw f(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(r),void 0,t),t}return this.installExtension(n,r,o)}async installExtension(r,o,n){if(!C.URI.isUri(o)){let g=this.installingExtensions.get(new d.ExtensionIdentifierWithVersion(o.identifier,o.version).key());if(g)return this.logService.info("Extensions is already requested to install",o.identifier.id),g.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],s=[],c=this.createInstallExtensionTask(r,o,n);C.URI.isUri(o)||this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(c.identifier,r.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:o}),this.logService.info("Installing extension:",c.identifier.id),t.push({task:c,manifest:r});let l=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const v=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,r,!!n.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:T,manifest:O}of v)if(l=l||!!O.extensionDependencies?.some(U=>(0,d.areSameExtensions)({id:U},c.identifier)),this.installingExtensions.has(new d.ExtensionIdentifierWithVersion(T.identifier,T.version).key()))this.logService.info("Extension is already requested to install",T.identifier.id);else{const U=this.createInstallExtensionTask(O,T,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(U.identifier,O.version).key(),U),this._onInstallExtension.fire({identifier:U.identifier,source:T}),this.logService.info("Installing extension:",U.identifier.id),t.push({task:U,manifest:O})}}catch(v){if(C.URI.isUri(c.source))(0,R.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,v.message),(0,R.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,v.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),v}const g=t.reduce((v,{task:T,manifest:O})=>(v.set(T.identifier.id.toLowerCase(),{task:T,manifest:O}),v),new Map);for(;g.size;){let v;const T=[...g.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(U=>g.has(U.toLowerCase())));T.length?v=g.size===1?T:T.filter(({task:O})=>!(O===c&&!l)):(this.logService.info("Found extensions with circular dependencies",T.map(({task:O})=>O.identifier.id)),v=[...g.values()]),await this.joinAllSettled(v.map(async({task:O})=>{const U=new Date().getTime();try{const x=await O.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(x,O.source,n,D.CancellationToken.None))),!C.URI.isUri(O.source)&&(f(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,void 0),w.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch(N){}s.push({local:x,identifier:O.identifier,operation:O.operation,source:O.source})}catch(x){throw C.URI.isUri(O.source)||f(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,x),this.logService.error("Error while installing the extension:",O.identifier.id),x}finally{g.delete(O.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:v})=>this.logService.info("Extension installed successfully:",v.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:v})=>(0,d.areSameExtensions)(v,c.identifier))[0].local}catch(g){if(t.forEach(({task:v})=>v.cancel()),s.length)try{const v=await Promise.allSettled(s.map(({local:T})=>this.createUninstallExtensionTask(T,{versionOnly:!0}).run()));for(let T=0;T<v.length;T++){const O=v[T],{identifier:U}=s[T];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,k.getErrorMessage)(O.reason))}}catch(v){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(v),s.map(({identifier:T})=>T.id))}throw this._onDidInstallExtensions.fire(t.map(({task:v})=>({identifier:v.identifier,operation:1,source:v.source}))),g}finally{for(const{task:g,manifest:v}of t)if(!C.URI.isUri(g.source)){const T=new d.ExtensionIdentifierWithVersion(g.identifier,v.version).key();this.installingExtensions.delete(T)||this.logService.warn("Installation task is not found in the cache",T)}}}async joinAllSettled(r){const o=[],n=[],t=await Promise.allSettled(r);for(const s of t)s.status==="fulfilled"?o.push(s.value):n.push(s.reason);if(n.length)throw m(n);return o}async getAllDepsAndPackExtensionsToInstall(r,o,n){if(!this.galleryService.isEnabled())return[];let t=await this.getInstalled();const s=[r,...t.map(g=>g.identifier)],c=[],l=async(g,v)=>{const T=v.extensionDependencies||[],O=[...T];if(v.extensionPack){const U=n?t.find(x=>(0,d.areSameExtensions)(x.identifier,g)):void 0;for(const x of v.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(N=>(0,d.areSameExtensions)({id:N},{id:x}))||O.every(N=>!(0,d.areSameExtensions)({id:N},{id:x}))&&O.push(x)}if(O.length){const U=[...s,...c.map(N=>N.gallery.identifier)],x=O.filter(N=>U.every(_=>!(0,d.areSameExtensions)(_,{id:N})));if(x.length){const N=await this.galleryService.query({names:x,pageSize:O.length},D.CancellationToken.None);for(const _ of N.firstPage){if(U.find(q=>(0,d.areSameExtensions)(q,_.identifier)))continue;if(!T.some(q=>(0,d.areSameExtensions)({id:q},_.identifier))&&!await this.canInstall(_)){this.logService.info("Skipping the packed extension as it cannot be installed",_.identifier.id);continue}const A=await this.checkAndGetCompatibleVersion(_,!0),M=await this.galleryService.getManifest(A,D.CancellationToken.None);if(M===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${A.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);c.push({gallery:A,manifest:M}),await l(A.identifier,M)}}}};return await l(r,o),t=await this.getInstalled(),c.filter(g=>!t.some(v=>(0,d.areSameExtensions)(v.identifier,g.gallery.identifier)))}async checkAndGetCompatibleVersion(r,o){if(await this.isMalicious(r))throw new E.ExtensionManagementError(I.localize(4,null,r.identifier.id),E.ExtensionManagementErrorCode.Malicious);const n=await this.getCompatibleVersion(r,o);if(!n)throw new E.ExtensionManagementError(I.localize(5,null,r.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.Incompatible);return n}async getCompatibleVersion(r,o){const n=await this.getTargetPlatform();let t=null;return await this.galleryService.isExtensionCompatible(r,n)&&(t=r),!t&&o&&(t=await this.galleryService.getCompatibleExtension(r,n)),t}async isMalicious(r){const o=await this.getExtensionsReport();return(0,d.getMaliciousExtensionsSet)(o).has(r.identifier.id)}async unininstallExtension(r,o){const n=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),n.waitUntilTaskIsFinished();const t=(g,v)=>{const T=this.createUninstallExtensionTask(g,v);return this.uninstallingExtensions.set(T.extension.identifier.id.toLowerCase(),T),this.logService.info("Uninstalling extension:",g.identifier.id),this._onUninstallExtension.fire(g.identifier),T},s=(g,v)=>{v?this.logService.error("Failed to uninstall extension:",g.identifier.id,v.message):this.logService.info("Successfully uninstalled extension:",g.identifier.id),f(this.telemetryService,"extensionGallery:uninstall",(0,d.getLocalExtensionTelemetryData)(g),void 0,v),this._onDidUninstallExtension.fire({identifier:g.identifier,error:v?.code})},c=[],l=[];try{c.push(t(r,{}));const g=await this.getInstalled(1);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const v=this.getAllPackExtensionsToUninstall(r,g);for(const T of v)this.uninstallingExtensions.has(T.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",T.identifier.id):c.push(t(T,{}))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(c.map(v=>v.extension),g,r),await this.joinAllSettled(c.map(async v=>{try{if(await v.run(),await this.joinAllSettled(this.participants.map(T=>T.postUninstall(v.extension,o,D.CancellationToken.None))),v.extension.identifier.uuid)try{await this.galleryService.reportStatistic(v.extension.manifest.publisher,v.extension.manifest.name,v.extension.manifest.version,"uninstall")}catch(T){}s(v.extension)}catch(T){const O=T instanceof E.ExtensionManagementError?T:new E.ExtensionManagementError((0,k.getErrorMessage)(T),E.ExtensionManagementErrorCode.Internal);throw s(v.extension,O),O}finally{l.push(v)}}))}catch(g){const v=g instanceof E.ExtensionManagementError?g:new E.ExtensionManagementError((0,k.getErrorMessage)(g),E.ExtensionManagementErrorCode.Internal);for(const T of c){try{T.cancel()}catch(O){}l.includes(T)||s(T.extension,v)}throw v}finally{for(const g of c)this.uninstallingExtensions.delete(g.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",g.extension.identifier.id)}}checkForDependents(r,o,n){for(const t of r){const s=this.getDependents(t,o);if(s.length){const c=s.filter(l=>!r.some(g=>(0,d.areSameExtensions)(g.identifier,l.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(t,c,n))}}}getDependentsErrorMessage(r,o,n){return n===r?o.length===1?I.localize(6,null,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?I.localize(7,null,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):I.localize(8,null,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?I.localize(9,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?I.localize(10,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):I.localize(11,null,n.manifest.displayName||n.manifest.name,r.manifest.displayName||r.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(r,o,n=[]){if(n.indexOf(r)!==-1)return[];n.push(r);const t=r.manifest.extensionPack?r.manifest.extensionPack:[];if(t.length){const s=o.filter(l=>!l.isBuiltin&&t.some(g=>(0,d.areSameExtensions)({id:g},l.identifier))),c=[];for(const l of s)c.push(...this.getAllPackExtensionsToUninstall(l,o,n));return[...s,...c]}return[]}getDependents(r,o){return o.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(t=>(0,d.areSameExtensions)({id:t},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const o=await this.findGalleryExtensionById(r.identifier.uuid);return o||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${r.length} reported extensions from service`),r}catch(r){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};y=he([J(0,E.IExtensionGalleryService),J(1,b.ITelemetryService),J(2,p.ILogService),J(3,h.IProductService)],y),e.AbstractExtensionManagementService=y;function m(u){const r=Array.isArray(u)?u:[u];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((o,n)=>new Error(`${o.message}${o.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}e.joinErrors=m;function S(u){if(u instanceof E.ExtensionManagementError)return u;const r=new E.ExtensionManagementError(u.message,E.ExtensionManagementErrorCode.Internal);return r.stack=u.stack,r}function f(u,r,o,n,t){const s=t?t instanceof E.ExtensionManagementError?t.code:E.ExtensionManagementErrorCode.Internal:void 0;u.publicLogError(r,{...o,success:!t,duration:n,errorcode:s})}e.reportTelemetry=f;class a{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(r=>new Promise((o,n)=>{const t=r.onCancellationRequested(()=>{t.dispose(),n((0,k.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=a}),define(te[206],ne([0,1,16,5,67,3,10,4,31,9,134,11,30,196,81,14,7,61,26,44,23,22]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S,f,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",o="extensionTips/lastPromptedMediumImpExeTime";let n=class extends p.ExtensionTipsService{constructor(s,c,l,g,v,T,O,U,x,N){super(O,U,x,N);this.environmentService=s,this.telemetryService=c,this.extensionManagementService=l,this.storageService=g,this.nativeHostService=v,this.extensionRecommendationNotificationService=T,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,U.exeBasedExtensionTips&&(0,D.forEach)(U.exeBasedExtensionTips,({key:_,value:z})=>{const A=[],M=[],q=[];(0,D.forEach)(z.recommendations,({key:j,value:W})=>{W.important?z.important?A.push({extensionId:j,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):M.push({extensionId:j,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):q.push({extensionId:j,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),A.length&&this.highImportanceExecutableTips.set(_,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:A}),M.length&&this.mediumImportanceExecutableTips.set(_,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:M}),q.length&&this.allOtherExecutableTips.set(_,{exeFriendlyName:z.friendlyName,windowsPath:z.windowsPath,recommendations:q})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,l)}groupImportantTipsByExe(s,c){const l=new Map;s.forEach(U=>l.set(U.extensionId.toLowerCase(),U));const{installed:g,uninstalled:v}=this.groupByInstalled([...l.keys()],c);for(const U of g){const x=l.get(U);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:U,exeName:x.exeName})}for(const U of v){const x=l.get(U);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:U,exeName:x.exeName})}const T=this.getPromptedExecutableTips(),O=new Map;for(const U of v){const x=l.get(U);if(x&&(!T[x.exeName]||!T[x.exeName].includes(x.extensionId))){let N=O.get(x.exeName);N||(N=[],O.set(x.exeName,N)),N.push(x)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":const g=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const v=this._register((0,L.disposableTimeout)(()=>{v.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),c=Date.now()-s,l=7*24*60*60*1e3;if(c<l){const T=this._register((0,L.disposableTimeout)(()=>{T.dispose(),this.promptMediumImportanceExeBasedTip()},l-c));return}const[g,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(T=>{switch(T){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(v[0].exeName,v);const O=this._register((0,L.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const U=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(U(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const x=this._register((0,L.disposableTimeout)(()=>{x.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(s){const c=s.map(({extensionId:g})=>g.toLowerCase()),l=(0,I.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,l,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(o,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(o,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,c){const l=this.getPromptedExecutableTips();l[s]=c.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(r,JSON.stringify(l),0,0)}groupByInstalled(s,c){const l=[],g=[],v=c.reduce((T,O)=>(T.add(O.identifier.id.toLowerCase()),T),new Set);return s.forEach(T=>{v.has(T.toLowerCase())?l.push(T):g.push(T)}),{installed:l,uninstalled:g}}async getValidExecutableBasedExtensionTips(s){const c=[],l=new Map;for(const g of s.keys()){const v=s.get(g);if(!v||!(0,R.isNonEmptyArray)(v.recommendations))continue;const T=[];P.isWindows?v.windowsPath&&T.push(v.windowsPath.replace("%USERPROFILE%",w.env.USERPROFILE).replace("%ProgramFiles(x86)%",w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",w.env.ProgramFiles).replace("%APPDATA%",w.env.APPDATA).replace("%WINDIR%",w.env.WINDIR)):(T.push((0,i.join)("/usr/local/bin",g)),T.push((0,i.join)("/usr/bin",g)),T.push((0,i.join)(this.environmentService.userHome.fsPath,g)));for(const O of T){let U=l.get(O);if(U===void 0&&(U=await this.fileService.exists(C.URI.file(O)),l.set(O,U)),U)for(const{extensionId:x,extensionName:N,isExtensionPack:_}of v.recommendations)c.push({extensionId:x,extensionName:N,isExtensionPack:_,exeName:g,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath})}}return c}};n=he([J(0,E.INativeEnvironmentService),J(1,u.ITelemetryService),J(2,d.IExtensionManagementService),J(3,a.IStorageService),J(4,m.INativeHostService),J(5,h.IExtensionRecommendationNotificationService),J(6,b.IFileService),J(7,S.IProductService),J(8,f.IRequestService),J(9,y.ILogService)],n),e.ExtensionTipsService=n}),define(te[94],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(k){this.appenders=k}listen(k,i){throw new Error(`Event not found: ${i}`)}call(k,i,{eventName:P,data:w}){return this.appenders.forEach(C=>C.log(P,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class L{constructor(k){this.channel=k}log(k,i){return this.channel.call("log",{eventName:k,data:i}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[45],ne([0,1,28,17,21,22]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class i{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,S){return Promise.resolve(void 0)}publicLog2(m,S){return this.publicLog(m,S)}publicLogError(m,S){return Promise.resolve(void 0)}publicLogError2(m,S){return this.publicLogError(m,S)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=i,e.NullTelemetryService=new i;class P{async publicLog(m,S,f){}async publicLogError(m,S,f){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(y,m){return m.onDidChangeConfiguration(S=>{S.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(S.source),configurationKeys:h(S.sourceConfig)})})}e.configurationTelemetry=w;function C(y,m){return!(m.disableTelemetry||!y.enableTelemetry)}e.supportsTelemetry=C;function I(y){const m=y.getValue(k.TELEMETRY_SETTING_ID),S=y.getValue("telemetry.enableCrashReporter");if(y.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||S===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function E(y){const m=Object.create(null),S=Object.create(null),f=Object.create(null);p(y,f);for(let a in f){a=a.length>150?a.substr(a.length-149):a;const u=f[a];typeof u=="number"?S[a]=u:typeof u=="boolean"?S[a]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${u.length}`),m[a]=u.substring(0,8191)):typeof u!="undefined"&&u!==null&&(m[a]=u)}return{properties:m,measurements:S}}e.validateTelemetryData=E;function d(y){if(!y)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{y.indexOf(`${f}+`)===0&&(m=f)}),m}e.cleanRemoteAuthority=d;function p(y,m,S=0,f){if(!!y)for(let a of Object.getOwnPropertyNames(y)){const u=y[a],r=f?f+a:a;Array.isArray(u)?m[r]=(0,R.safeStringify)(u):u instanceof Date?m[r]=u.toISOString():(0,L.isObject)(u)?S<2?p(u,m,S+1,r+"."):m[r]=(0,R.safeStringify)(u):m[r]=u}}function h(y){if(!y)return[];const m=[];return b(m,"",y),m}function b(y,m,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(f=>b(y,m?`${m}.${f}`:f,S[f])):y.push(m)}}),define(te[207],ne([0,1,45,152]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class D{constructor(){}setSharedProperty(w,C){}postEvent(w,C){}}class k{constructor(w,C,I,E,d){this.getMachineId=w,this.configurationService=C,this.productService=I,this.telemetry=E,this.keyValueStorage=d,this.networkInitialized=!1,I.tasConfig&&this.experimentsEnabled&&(0,R.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),h=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(b=>setTimeout(b,h))}get experimentsEnabled(){return!0}async getTreatment(w){await this.overrideInitDelay;const C=this.configurationService.getValue("experiments.override."+w);if(C!==void 0)return C;if(!this.tasClient||!this.experimentsEnabled)return;let I;const E=await this.tasClient;return this.networkInitialized?I=E.getTreatmentVariable("vscode",w):I=await E.getTreatmentVariableAsync("vscode",w,!0),I=E.getTreatmentVariable("vscode",w),I}async setupTASClient(){const w=this.productService.quality==="stable"?L.TargetPopulation.Public:L.TargetPopulation.Insiders,C=await this.getMachineId(),I=new L.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,C,w),E=this.productService.tasConfig,d=new(await new Promise((p,h)=>{X(["tas-client-umd"],p,h)})).ExperimentationService({filterProviders:[I],telemetry:this.telemetry,storageKey:L.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:E.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:E.assignmentContextTelemetryPropertyName,telemetryEventName:E.telemetryEventName,endpoint:E.endpoint,refetchInterval:L.ASSIGNMENT_REFETCH_INTERVAL});return await d.initializePromise,d.initialFetch.then(()=>this.networkInitialized=!0),d}}e.BaseAssignmentService=k;class i extends k{constructor(w,C,I){super(()=>Promise.resolve(w),C,I,new D)}}e.AssignmentService=i}),define(te[208],ne([0,1,16,27,8,28,4,31,9,21,11,30,36,78,14,7,26,44,46,23,22,45]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S,f,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const r=i.isWeb?"web":(0,E.getTargetPlatform)(i.platform,P.arch);var o;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished"})(o||(o={}));function n(...G){return String(G.reduce((H,re)=>H|re,0))}var t;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},g={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class v{constructor(H=g){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,re=this.state.pageSize){return new v({...this.state,pageNumber:H,pageSize:re})}withFilter(H,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:H,value:ce})):[{filterType:H}]];return new v({...this.state,criteria:ie})}withSortBy(H){return new v({...this.state,sortBy:H})}withSortOrder(H){return new v({...this.state,sortOrder:H})}withFlags(...H){return new v({...this.state,flags:H.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...H){return new v({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le,flags:fe,assetTypes:de}=this.state;return{filters:[{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le}],assetTypes:de,flags:fe}}get searchText(){const H=this.state.criteria.filter(re=>re.filterType===t.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(G,H){const re=(G||[]).filter(ie=>ie.statisticName===H)[0];return re?re.value:0}function O(G){const H="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(ie=>ie.assetType.indexOf(H)===0).reduce((ie,ce)=>{const le=_(G,ce.assetType);return le&&ie.push([ce.assetType.substring(H.length),le]),ie},[])}function U(G){if(G.properties){const H=G.properties.filter(ce=>ce.key===s.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=H.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return _(G,s.Repository)}function x(G){return{uri:`${G.fallbackAssetUri}/${s.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${s.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function N(G){const H=_(G,s.Icon);if(H)return H;const re=E.DefaultIconPath;return{uri:re,fallbackUri:re}}function _(G,H){return G.files.filter(ie=>ie.assetType===H)[0]?{uri:`${G.assetUri}/${H}`,fallbackUri:`${G.fallbackAssetUri}/${H}`}:null}function z(G,H){const re=G.properties?G.properties.filter(ce=>ce.key===H):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,d.adoptToGalleryExtensionId)(ce)):[]}function A(G){const H=G.properties?G.properties.filter(re=>re.key===c.Engine):[];return H.length>0&&H[0].value||""}function M(G){const H=G.properties?G.properties.filter(ie=>ie.key===c.LocalizedLanguages):[],re=H.length>0&&H[0].value||"";return re?re.split(","):[]}function q(G){return G.indexOf("preview")!==-1}function j(G){return G.targetPlatform?(0,E.toTargetPlatform)(G.targetPlatform):"undefined"}function W(G){const H=(0,R.distinct)(G.versions.map(j)),re=!!G.tags?.includes(E.WEB_EXTENSION_TAG),ie=H.indexOf("web");return re?ie===-1&&H.push("web"):ie!==-1&&H.splice(ie,1),H}function $(G,H){const re=(0,E.getFallbackTargetPlarforms)(H);for(let ie=0;ie<G.length;ie++){const ce=G[ie];if(ce.version===G[ie-1]?.version){let le=ie;const fe=j(ce);if(fe===H)for(;le>0&&G[le-1].version===ce.version;)le--;else if(re.includes(fe))for(;le>0&&G[le-1].version===ce.version&&j(G[le-1])!==H;)le--;le!==ie&&(G.splice(ie,1),G.splice(le,0,ce))}}return G}e.sortExtensionVersions=$;function K(G,H,re,ie,ce){const le=W(G);let fe=G.versions[0];return fe=G.versions.find(de=>de.version===fe.version&&(0,E.isTargetPlatformCompatible)(j(de),le,ce))||fe,F(G,fe,le,H,re,ie)}function F(G,H,re,ie,ce,le){const fe={manifest:_(H,s.Manifest),readme:_(H,s.Details),changelog:_(H,s.Changelog),license:_(H,s.License),repository:U(H),download:x(H),icon:N(H),coreTranslations:O(H)};return{identifier:{id:(0,d.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:H.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,description:G.shortDescription||"",installCount:T(G.statistics,"install"),rating:T(G.statistics,"averagerating"),ratingCount:T(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:re,assets:fe,properties:{dependencies:z(H,c.Dependency),extensionPack:z(H,c.ExtensionPack),engine:A(H),localizedLanguages:M(H),targetPlatform:j(H)},preview:q(G.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:le}}}let B=class{constructor(H,re,ie,ce,le,fe,de,be){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=le,this.fileService=fe,this.productService=de,this.configurationService=be;const Ie=de.extensionsGallery;this.extensionsGalleryUrl=Ie&&Ie.serviceUrl,this.extensionsControlUrl=Ie&&Ie.controlUrl,this.commonHeadersPromise=Z(de.version,de,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,re){const ie=[];let ce=new v().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,H.length).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExtensionName,...H.map(({id:fe})=>fe.toLowerCase()));H.every(fe=>!fe.version)&&(ce=ce.withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties,o.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,r,L.CancellationToken.None);for(let fe=0;fe<le.length;fe++){const de=le[fe];if(!de.versions.length)continue;const be=(0,d.getGalleryExtensionId)(de.publisher.publisherName,de.extensionName),Ie=H.find(Ee=>(0,d.areSameExtensions)(Ee,{id:be}))?.version;if(Ie){const Ee=de.versions.find(_e=>_e.version===Ie);Ee&&ie.push(F(de,Ee,W(de),fe,ce))}else ie.push(K(de,fe,ce,void 0,r))}return ie}async getCompatibleExtension(H,re){const ie=(0,E.isIExtensionIdentifier)(H)?null:H;if(ie){if((0,E.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:le}=ie?ie.identifier:H;let fe=new v().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");le?fe=fe.withFilter(t.ExtensionId,le):fe=fe.withFilter(t.ExtensionName,ce);const{galleryExtensions:de}=await this.queryGallery(fe,re,L.CancellationToken.None),[be]=de;if(!be||!be.versions.length)return null;const Ie=W(be);if((0,E.isNotWebExtensionInWebTargetPlatform)(Ie,re))return null;for(let Ee of be.versions){if(!A(Ee)){const _e=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:c.Engine,value:_e}]}}if(await this.isRawExtensionVersionCompatible(Ee,Ie,re))return F(be,Ee,Ie,0,fe)}return null}async isExtensionCompatible(H,re){if(!(0,E.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,re))return!1;let ie=H.properties.engine;if(!ie){const ce=await this.getManifest(H,L.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,p.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,re,ie){if(!(0,E.isTargetPlatformCompatible)(j(H),re,ie))return!1;const ce=await this.getEngine(H);return(0,p.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(H,re){const ie=L.CancellationToken.isCancellationToken(H)?{}:H,ce=L.CancellationToken.isCancellationToken(H)?H:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=ie.text||"";const fe=(0,k.getOrDefault)(ie,Pe=>Pe.pageSize,50);let de=new v().withFlags(o.IncludeLatestVersionOnly,o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,fe).withFilter(t.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(de=de.withFilter(t.Category,Fe||Le),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(de=de.withFilter(t.Tag,Fe||Le),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(de=de.withFilter(t.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),de=de.withFilter(t.SearchText,le)),de=de.withSortBy(0)):ie.ids?de=de.withFilter(t.ExtensionId,...ie.ids):ie.names?de=de.withFilter(t.ExtensionName,...ie.names):de=de.withSortBy(4),typeof ie.sortBy=="number"&&(de=de.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(de=de.withSortOrder(ie.sortOrder));const{galleryExtensions:be,total:Ie}=await this.queryGallery(de,r,ce),Ee=be.map((Pe,Le)=>K(Pe,Le,de,ie.source,r)),_e=async(Pe,Le)=>{if(Le.isCancellationRequested)throw(0,D.canceled)();const Fe=de.withPage(Pe+1),{galleryExtensions:Ne}=await this.queryGallery(Fe,r,Le);return Ne.map(($e,xe)=>K($e,xe,Fe,ie.source,r))};return{firstPage:Ee,total:Ie,pageSize:de.pageSize,getPage:_e}}async queryGallery(H,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,o.ExcludeNonValidated).withFilter(t.ExcludeWithFlags,n(o.Unpublished));const ce=await this.commonHeadersPromise,le=JSON.stringify(H.raw),fe={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},de=new Date().getTime();let be,Ie,Ee=0;try{if(be=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:fe},ie),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:Ee};const _e=await(0,m.asJson)(be);if(_e){const Pe=_e.results[0],Le=Pe.extensions;Le.forEach(Ne=>$(Ne.versions,re));const Fe=Pe.resultMetadata&&Pe.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Le,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(_e){throw Ie=_e,_e}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-de,success:!!be&&(0,m.isSuccess)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Ie?(0,D.isPromiseCanceledError)(Ie)?"canceled":(0,D.getErrorMessage)(Ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(H,re,ie,ce){if(!this.isEnabled())return;const le=i.isWeb?this.api(`/itemName/${H}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${re}/${ie}/stats?statType=${ce}`),fe=i.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",be={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:le,headers:be},L.CancellationToken.None)}catch(Ie){}}async download(H,re,ie){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const ce=(0,d.getGalleryExtensionTelemetryData)(H),le=new Date().getTime(),fe=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ee}),de=ie===1?"install":ie===2?"update":"",be=de?{uri:`${H.assets.download.uri}${w.URI.parse(H.assets.download.uri).query?"&":"?"}${de}=true`,fallbackUri:`${H.assets.download.fallbackUri}${w.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${de}=true`}:H.assets.download,Ie=await this.getAsset(be);await this.fileService.writeFile(re,Ie.stream),fe(new Date().getTime()-le)}async getReadme(H,re){if(H.assets.readme){const ie=await this.getAsset(H.assets.readme,{},re);return await(0,m.asText)(ie)||""}return""}async getManifest(H,re){if(H.assets.manifest){const ie=await this.getAsset(H.assets.manifest,{},re),ce=await(0,m.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(H,re){const ie=_(H,s.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},le=await this.getAsset(ie,{headers:ce});return await(0,m.asJson)(le)}async getCoreTranslation(H,re){const ie=H.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),le=await(0,m.asText)(ce);return le?JSON.parse(le):null}return null}async getChangelog(H,re){if(H.assets.changelog){const ie=await this.getAsset(H.assets.changelog,{},re);return await(0,m.asText)(ie)||""}return""}async getAllCompatibleVersions(H,re){let ie=new v().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?ie=ie.withFilter(t.ExtensionId,H.identifier.uuid):ie=ie.withFilter(t.ExtensionName,H.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,L.CancellationToken.None);if(!ce.length)return[];const le=W(ce[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(le,re))return[];const fe=[];for(const de of ce[0].versions)try{fe[fe.length-1]?.version!==de.version&&await this.isRawExtensionVersionCompatible(de,le,re)&&fe.push({version:de.version,date:de.lastUpdated})}catch(be){}return fe}async getAsset(H,re={},ie=L.CancellationToken.None){const ce=await this.commonHeadersPromise,le={type:"GET"},fe={...ce,...re.headers||{}};re={...re,...le,headers:fe};const de=H.uri,be=H.fallbackUri,Ie={...re,url:de};try{const Ee=await this.requestService.request(Ie,ie);if(Ee.res.statusCode===200)return Ee;const _e=await(0,m.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${_e}`)}catch(Ee){if((0,D.isPromiseCanceledError)(Ee))throw Ee;const _e=(0,D.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:de,message:_e});const Pe={...re,url:be};return this.requestService.request(Pe,ie)}}async getEngine(H){let re=A(H);if(!re){const ie=await this.getManifestFromRawExtensionVersion(H,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,m.asJson)(H),ie=new Map;if(re)for(const ce of re.malicious){const le=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};le.malicious=!0,ie.set(ce,le)}return[...ie.values()]}};B=he([J(1,m.IRequestService),J(2,b.ILogService),J(3,I.IEnvironmentService),J(4,a.ITelemetryService),J(5,h.IFileService),J(6,y.IProductService),J(7,C.IConfigurationService)],B);let V=class extends B{constructor(H,re,ie,ce,le,fe,de,be){super(H,re,ie,ce,le,fe,de,be)}};V=he([J(0,f.IStorageService),J(1,m.IRequestService),J(2,b.ILogService),J(3,I.IEnvironmentService),J(4,a.ITelemetryService),J(5,h.IFileService),J(6,y.IProductService),J(7,C.IConfigurationService)],V),e.ExtensionGalleryService=V;let Q=class extends B{constructor(H,re,ie,ce,le,fe,de){super(void 0,H,re,ie,ce,le,fe,de)}};Q=he([J(0,m.IRequestService),J(1,b.ILogService),J(2,I.IEnvironmentService),J(3,a.ITelemetryService),J(4,h.IFileService),J(5,y.IProductService),J(6,C.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q;async function Z(G,H,re,ie,ce,le){const fe={"X-Market-Client-Id":`VSCode ${G}`,"User-Agent":`VSCode ${G}`},de=await(0,S.getServiceMachineId)(re,ce,le);return(0,u.supportsTelemetry)(H,re)&&(0,u.getTelemetryLevel)(ie)===3&&(fe["X-Market-User-Id"]=de),fe}e.resolveMarketplaceHeaders=Z}),define(te[95],ne([0,1,2,11,7,45]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let i=class extends R.Disposable{constructor(w,C,I=""){super();this.prefix=I;const E=w.getLogger(C.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(w.createLogger(C.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(w,C){this.logger.trace(`${this.prefix}telemetry/${w}`,(0,k.validateTelemetryData)(C))}};i=he([J(0,D.ILoggerService),J(1,L.IEnvironmentService)],i),e.TelemetryLogAppender=i}),define(te[96],ne([0,1,2,28,4,25,144,21,39,88,35,22,45]),function(X,e,R,L,D,k,i,P,w,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(y,m){this._configurationService=m,this._experimentProperties={},this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(S),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(S=>{const f=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(y,m){this._experimentProperties[y]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const y=await this._commonProperties;let m=y.sessionID,S=y["common.machineId"],f=y["common.firstSessionDate"],a=y["common.msftInternal"];return{sessionId:m,machineId:S,firstSessionDate:f,msftInternal:a}}dispose(){this._disposables.dispose()}_log(y,m,S,f){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(a=>{S=(0,L.mixin)(S,a),S=(0,L.mixin)(S,this._experimentProperties),S=(0,L.cloneAndChange)(S,u=>{if(typeof u=="string")return this._cleanupInfo(u,f)}),this._appenders.forEach(u=>u.log(y,S))},a=>{console.error(a)})}publicLog(y,m,S){return this._log(y,3,m,S)}publicLog2(y,m,S){return this.publicLog(y,m,S)}publicLogError(y,m){return this.sendErrorTelemetry?this._log(y,2,m,!0):Promise.resolve(void 0)}publicLogError2(y,m){return this.publicLogError(y,m)}_anonymizeFilePaths(y){let m=y;const S=[];for(let r of this._cleanupPatterns)for(;;){const o=r.exec(y);if(!o)break;S.push([o.index,r.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(m="";;){const r=a.exec(y);if(!r)break;!f.test(r[0])&&S.every(([o,n])=>r.index<o||r.index>=n)&&(m+=y.substring(u,r.index)+"<REDACTED: user-file-path>",u=a.lastIndex)}return u<y.length&&(m+=y.substr(u)),m}_removePropertiesWithPossibleUserInfo(y){if(!y)return y;const m=y.toLowerCase(),S=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":S.test(m)?"<REDACTED: email>":y}_cleanupInfo(y,m){let S=y;m&&(S=this._anonymizeFilePaths(S));for(let f of this._cleanupPatterns)S=S.replace(f,"");return S=this._removePropertiesWithPossibleUserInfo(S),S}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=he([J(1,P.IConfigurationService)],p),e.TelemetryService=p;function h(){const b=(0,i.localize)(0,null,C.default.nameLong),y=C.default.privacyStatementUrl?(0,i.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,i.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=D.isWeb?"":(0,i.localize)(3,null),S=(0,i.localize)(4,null),f=(0,i.localize)(5,null),a=(0,i.localize)(6,null),u=(0,i.localize)(7,null),r=`
|       | ${S} | ${f} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,i.localize)(8,null);return`
${b} ${y} ${m}

&nbsp;

${u}
${r}

&nbsp;

${o}
`}I.Registry.as(w.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,i.localize)(10,null),(0,i.localize)(11,null),(0,i.localize)(12,null),(0,i.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(w.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,i.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,i.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,i.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[209],ne([0,1,8,28,45]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function k(P,w){const C=await new Promise((E,d)=>{X(["applicationinsights"],E,d)});let I;return C.defaultClient?(I=new C.TelemetryClient(P),I.channel.setUseDiskRetryCaching(!0)):(C.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=C.defaultClient),P.indexOf("AIF-")===0&&(I.config.endpointUrl=w?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class i{constructor(w,C,I,E,d){this._eventPrefix=w,this._defaultData=C,this.testCollector=E,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(w){if(!!this._aiClient){if(typeof this._aiClient!="string"){w(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=k(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(C=>{w(C)},C=>{(0,R.onUnexpectedError)(C),console.error(C)})}}log(w,C){!this._aiClient||(C=(0,L.mixin)(C,this._defaultData),C=(0,D.validateTelemetryData)(C),this.testCollector&&(C.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+w,properties:C.properties,measurements:C.measurements})))}flush(){return this._aiClient?new Promise(w=>{this._withAIClient(C=>{C.flush({callback:()=>{this._aiClient=void 0,w(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=i}),define(te[210],ne([0,1,15,52,21,11,7,22,94,95,96]),function(X,e,R,L,D,k,i,P,w,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(p,h,b,y){this.configurationService=p,this.telemetryService=h,this.loggerService=b,this.environmentService=y,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:h,sessionId:b}=await this.telemetryService.getTelemetryInfo(),y=Object.create(null);y["common.vscodemachineid"]=h,y["common.vscodesessionid"]=b;const m=[p.id,JSON.stringify(y),p.aiKey],f=new L.Client(R.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),a=[new w.TelemetryAppenderClient(f),new C.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new I.TelemetryService({appenders:a,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,h,b){await(await this.getCustomTelemetryService(p)).publicLog(h,b)}async publicLogError(p,h,b){await(await this.getCustomTelemetryService(p)).publicLogError(h,b)}};E=he([J(0,D.IConfigurationService),J(1,P.ITelemetryService),J(2,i.ILoggerService),J(3,k.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(te[211],ne([0,1,5,27,3,2,7]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends k.Disposable{constructor(C,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((I,E)=>{const d=++this._lastRequestId;this._pendingRequests.set(d,I),this._onCreateRequest.fire({requestId:d,...C});const p=new L.CancellationTokenSource;(0,R.timeout)(this._timeout,p.token).then(()=>E(`Request ${d} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(d,[(0,k.toDisposable)(()=>p.cancel())])})}acceptReply(C,I){const E=this._pendingRequests.get(C);E?(this._pendingRequests.delete(C),(0,k.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),E(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};P=he([J(1,i.ILogService)],P),e.RequestStore=P}),define(te[97],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(y){y.Shell="terminal.integrated.shell.",y.ShellArgs="terminal.integrated.shellArgs.",y.DefaultProfile="terminal.integrated.defaultProfile.",y.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(y){y.ShellLinux="terminal.integrated.shell.linux",y.ShellMacOs="terminal.integrated.shell.osx",y.ShellWindows="terminal.integrated.shell.windows",y.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",y.AutomationShellLinux="terminal.integrated.automationShell.linux",y.AutomationShellMacOs="terminal.integrated.automationShell.osx",y.AutomationShellWindows="terminal.integrated.automationShell.windows",y.AutomationProfileLinux="terminal.integrated.automationProfile.linux",y.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",y.AutomationProfileWindows="terminal.integrated.automationProfile.windows",y.ShellArgsLinux="terminal.integrated.shellArgs.linux",y.ShellArgsMacOs="terminal.integrated.shellArgs.osx",y.ShellArgsWindows="terminal.integrated.shellArgs.windows",y.ProfilesWindows="terminal.integrated.profiles.windows",y.ProfilesMacOs="terminal.integrated.profiles.osx",y.ProfilesLinux="terminal.integrated.profiles.linux",y.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",y.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",y.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",y.UseWslProfiles="terminal.integrated.useWslProfiles",y.TabsEnabled="terminal.integrated.tabs.enabled",y.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",y.TabsHideCondition="terminal.integrated.tabs.hideCondition",y.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",y.TabsShowActions="terminal.integrated.tabs.showActions",y.TabsLocation="terminal.integrated.tabs.location",y.TabsFocusMode="terminal.integrated.tabs.focusMode",y.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",y.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",y.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",y.CopyOnSelection="terminal.integrated.copyOnSelection",y.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",y.FontFamily="terminal.integrated.fontFamily",y.FontSize="terminal.integrated.fontSize",y.LetterSpacing="terminal.integrated.letterSpacing",y.LineHeight="terminal.integrated.lineHeight",y.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",y.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",y.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",y.BellDuration="terminal.integrated.bellDuration",y.FontWeight="terminal.integrated.fontWeight",y.FontWeightBold="terminal.integrated.fontWeightBold",y.CursorBlinking="terminal.integrated.cursorBlinking",y.CursorStyle="terminal.integrated.cursorStyle",y.CursorWidth="terminal.integrated.cursorWidth",y.Scrollback="terminal.integrated.scrollback",y.DetectLocale="terminal.integrated.detectLocale",y.DefaultLocation="terminal.integrated.defaultLocation",y.GpuAcceleration="terminal.integrated.gpuAcceleration",y.TerminalTitleSeparator="terminal.integrated.tabs.separator",y.TerminalTitle="terminal.integrated.tabs.title",y.TerminalDescription="terminal.integrated.tabs.description",y.RightClickBehavior="terminal.integrated.rightClickBehavior",y.Cwd="terminal.integrated.cwd",y.ConfirmOnExit="terminal.integrated.confirmOnExit",y.ConfirmOnKill="terminal.integrated.confirmOnKill",y.EnableBell="terminal.integrated.enableBell",y.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",y.AllowChords="terminal.integrated.allowChords",y.AllowMnemonics="terminal.integrated.allowMnemonics",y.EnvMacOs="terminal.integrated.env.osx",y.EnvLinux="terminal.integrated.env.linux",y.EnvWindows="terminal.integrated.env.windows",y.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",y.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",y.ShowExitAlert="terminal.integrated.showExitAlert",y.SplitCwd="terminal.integrated.splitCwd",y.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",y.WordSeparators="terminal.integrated.wordSeparators",y.EnableFileLinks="terminal.integrated.enableFileLinks",y.UnicodeVersion="terminal.integrated.unicodeVersion",y.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",y.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",y.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",y.LocalEchoStyle="terminal.integrated.localEchoStyle",y.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",y.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",y.CustomGlyphs="terminal.integrated.customGlyphs",y.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",y.InheritEnv="terminal.integrated.inheritEnv",y.ShowLinkHover="terminal.integrated.showLinkHover",y.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(y){y.CommandPrompt="cmd",y.PowerShell="pwsh",y.Wsl="wsl",y.GitBash="gitbash"})(k=e.WindowsShellType||(e.WindowsShellType={}));var i;(function(y){y[y.Api=0]="Api",y[y.Process=1]="Process",y[y.Sequence=2]="Sequence",y[y.Config=3]="Config"})(i=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(y){y.LocalPty="localPty",y.PtyHost="ptyHost",y.Log="log",y.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var w;(function(y){y.Cwd="cwd",y.InitialCwd="initialCwd",y.FixedDimensions="fixedDimensions",y.Title="title",y.ShellType="shellType",y.HasChildProcesses="hasChildProcesses",y.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",y.OverrideDimensions="overrideDimensions"})(w=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(y){y[y.BeatInterval=5e3]="BeatInterval",y[y.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",y[y.SecondWaitMultiplier=1]="SecondWaitMultiplier",y[y.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(y){y[y.Panel=1]="Panel",y[y.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(y){y.TerminalView="view",y.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(y){y.CwdDetection="cwdDetection"})(d=e.ProcessCapability||(e.ProcessCapability={}));var p;(function(y){y[y.GraceTime=6e4]="GraceTime",y[y.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(y){y[y.HighWatermarkChars=1e5]="HighWatermarkChars",y[y.LowWatermarkChars=5e3]="LowWatermarkChars",y[y.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var b;(function(y){y.GitBash="Git Bash",y.Pwsh="PowerShell"})(b=e.ProfileSource||(e.ProfileSource={}))}),define(te[212],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(te[213],ne([0,1,33,28,10,4,31,17,20]),function(X,e,R,L,D,k,i,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let d=0;return E&&E.length===4&&(d=parseInt(E[3])),d}e.getWindowsBuildNumber=C;async function I(E,d,p,h=i.env,b=w.Promises.exists){if(D.isAbsolute(E))return await b(E)?E:void 0;if(d===void 0&&(d=i.cwd()),D.dirname(E)!=="."){const f=D.join(d,E);return await b(f)?f:void 0}const m=(0,L.getCaseInsensitive)(h,"PATH");if(p===void 0&&(0,P.isString)(m)&&(p=m.split(D.delimiter)),p===void 0||p.length===0){const f=D.join(d,E);return await b(f)?f:void 0}for(let f of p){let a;if(D.isAbsolute(f)?a=D.join(f,E):a=D.join(d,f,E),await b(a))return a;if(k.isWindows){let u=a+".com";if(await b(u)||(u=a+".exe",await b(u)))return u}}const S=D.join(d,E);return await b(S)?S:void 0}e.findExecutable=I}),define(te[214],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var R;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(R=e.ColorScheme||(e.ColorScheme={}))}),define(te[98],ne([0,1,49,3,2,6,35,214]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var w;(function(y){function m(S){return S&&typeof S=="object"&&typeof S.id=="string"}y.isThemeColor=m})(w=e.ThemeColor||(e.ThemeColor={}));function C(y){return{id:y}}e.themeColorFromId=C;var I;(function(y){function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||w.isThemeColor(n.color))}y.isThemeIcon=m;const S=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function f(n){const t=S.exec(n);if(!t)return;let[,s]=t;return{id:s}}y.fromString=f;function a(n,t){let s=n.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),t&&(s=`${s}~${t}`),{id:s}}y.modify=a;function u(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}y.getModifier=u;function r(n,t){return n.id===t.id&&n.color?.id===t.color?.id}y.isEqual=r;function o(n,t){return{id:n.id,color:t?C(t):void 0}}y.asThemeIcon=o,y.asClassNameArray=R.CSSIcon.asClassNameArray,y.asClassName=R.CSSIcon.asClassName,y.asCSSSelector=R.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function E(y){switch(y){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,D.toDisposable)(()=>{const S=this.themingParticipants.indexOf(m);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new d;i.Registry.add(e.Extensions.ThemingContribution,p);function h(y){return p.onColorThemeChange(y)}e.registerThemingParticipant=h;class b extends D.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,S){let f=this.theme.getColor(m);return f&&S&&(f=S(f,this.theme)),f?f.toString():null}}e.Themable=b}),define(te[215],ne([0,1,49,9,98]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function k(E,d){const p=E.map(h=>({name:h.profileName,description:i(h)}));return d&&p.push(...d.map(h=>({name:h.title,description:P(h)}))),{values:p.map(h=>h.name),markdownDescriptions:p.map(h=>h.description)}}e.createProfileSchemaEnums=k;function i(E){let d=`$(${D.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:R.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?d+=`
- args: "${E.args}"`:d+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(d+=`
- overrideName: ${E.overrideName}`),E.color&&(d+=`
- color: ${E.color}`),E.env&&(d+=`
- env: ${JSON.stringify(E.env)}`),d}function P(E){return`$(${D.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:R.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function w(E,d){if(!E&&!d)return!0;if(typeof E=="string"&&typeof d=="string")return E===d;if(Array.isArray(E)&&Array.isArray(d)){if(E.length!==d.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==d[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=w;function C(E,d){if(!E&&!d)return!0;if(!E||!d)return!1;if(D.ThemeIcon.isThemeIcon(E)&&D.ThemeIcon.isThemeIcon(d))return E.id===d.id&&E.color===d.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof d=="object"&&d&&"light"in d&&"dark"in d){const p=E,h=d;if((L.URI.isUri(p.light)||I(p.light))&&(L.URI.isUri(p.dark)||I(p.dark))&&(L.URI.isUri(h.light)||I(h.light))&&(L.URI.isUri(h.dark)||I(h.dark)))return p.light.path===h.light.path&&p.dark.path===h.dark.path}if(L.URI.isUri(E)&&L.URI.isUri(d)||I(E)||I(d)){const p=E,h=d;return p.path===h.path&&p.scheme===h.scheme}return!1}e.terminalIconsEqual=C;function I(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=I}),define(te[216],ne([0,1,49,145,39,35,215]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(R.iconRegistry.all,f=>f.id),markdownEnumDescriptions:Array.from(R.iconRegistry.all,f=>`$(${f.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},C=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),I=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),E=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,L.localize)(9,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,L.localize)(10,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,L.localize)(11,null,"`#terminal.integrated.automationProfile.windows#`"),b={id:"terminal",order:100,title:(0,L.localize)(12,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},w]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,L.localize)(17,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},w]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,L.localize)(18,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},w]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(19,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(22,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(23,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(24,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(25,null)}},{type:"string",markdownDescription:(0,L.localize)(26,null)}],default:[],markdownDeprecationMessage:E},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(27,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(28,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(29,null),type:"string"},id:{description:(0,L.localize)(30,null),type:"string"},title:{description:(0,L.localize)(31,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(32,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(33,null),type:"string"},id:{description:(0,L.localize)(34,null),type:"string"},title:{description:(0,L.localize)(35,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(36,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(37,null),type:"string"},id:{description:(0,L.localize)(38,null),type:"string"},title:{description:(0,L.localize)(39,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(42,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(43,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,L.localize)(44,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function y(){k.Registry.as(D.Extensions.Configuration).registerConfiguration(b),S()}e.registerTerminalPlatformConfiguration=y;let m;function S(f,a){const u=k.Registry.as(D.Extensions.Configuration);let r;f&&(r=(0,i.createProfileSchemaEnums)(f?.profiles,a));const o=m;m={id:"terminal",order:100,title:(0,L.localize)(45,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(46,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?r?.values:void 0,markdownEnumDescriptions:f?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(47,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?r?.values:void 0,markdownEnumDescriptions:f?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(48,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?r?.values:void 0,markdownEnumDescriptions:f?.os===1?r?.markdownDescriptions:void 0}}},u.updateConfigurations({add:[m],remove:o?[o]:[]})}e.registerTerminalDefaultProfileConfiguration=S}),define(te[217],ne([0,1,43,49,10,4,20,72,213,98]),function(X,e,R,L,D,k,i,P,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,E=!0;function d(o,n,t,s,c=process.env,l,g,v,T){return l=l||{existsFile:i.SymlinkSupport.existsFile,readFile:i.Promises.readFile},k.isWindows?p(t,l,c,g,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),T,v):a(l,g,t,o&&typeof o=="object"?{...o}:s.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,v,c)}e.detectAvailableProfiles=d;async function p(o,n,t,s,c,l,g,v,T){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let x=!1;(0,w.getWindowsBuildNumber)()>=16299&&(x=!0),await y(v);const N=new Map;o&&(N.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),N.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),u(l,N);const _=await h(N.entries(),g,n,t,s,T);if(o||!o&&c)try{const z=await S(`${U}\\${x?"wsl":"bash"}.exe`,g);for(const A of z)(!l||!(A.profileName in l))&&_.push(A)}catch(z){E&&(s?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return _}async function h(o,n,t,s=process.env,c,l){const g=[];for(const[v,T]of o){if(T===null)continue;let O,U,x;if("source"in T){const z=I?.get(T.source);if(!z)continue;O=z.paths,U=T.args||z.args,T.icon?x=b(T.icon):z.icon&&(x=z.icon)}else O=Array.isArray(T.path)?T.path:[T.path],U=k.isWindows||Array.isArray(T.args)?T.args:void 0,x=b(T.icon)||void 0;const N=await l?.(O)||O.slice(),_=await r(v,n,N,t,s,U,T.env,T.overrideName,T.isAutoDetected,c);_?(_.isAutoDetected=T.isAutoDetected,_.icon=x,_.color=T.color,g.push(_)):c?.trace("profile not validated",v,O)}return g}function b(o){return typeof o=="string"?{id:o}:o}async function y(o){I&&!o||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:o||await m(),icon:C.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function m(){const o=[];for await(const n of(0,P.enumeratePowerShellInstallations)())o.push(n.exePath);return o}async function S(o,n){const t=[],s=await new Promise((g,v)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,O)=>{if(T)return v("Problem occurred when getting wsl distros");g(O)})});if(!s)return[];const c=new RegExp(/[\r?\n]/),l=s.split(c).filter(g=>g.trim().length>0&&g!=="");for(const g of l){if(g===""||g.startsWith("docker-desktop"))continue;const v=`${g} (WSL)`,T={profileName:v,path:o,args:["-d",`${g}`],isDefault:v===n,icon:f(g)};t.push(T)}return t}function f(o){return o.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):o.includes("Debian")?C.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function a(o,n,t,s,c,l,g,v){const T=new Map;if(t){const O=(await o.readFile("/etc/shells")).toString(),U=l||O.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),x=new Map;for(const N of U){let _=(0,D.basename)(N),z=x.get(_)||0;z++,z>1&&(_=`${_} (${z})`),x.set(_,z),T.set(_,{path:N,isAutoDetected:!0})}}return u(s,T),await h(T.entries(),c,o,v,n,g)}function u(o,n){if(!!o)for(const[t,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?n.delete(t):n.set(t,s)}async function r(o,n,t,s,c,l,g,v,T,O){if(t.length===0)return Promise.resolve(void 0);const U=t.shift();if(U==="")return r(o,n,t,s,c,l,g,v,T);const x={profileName:o,path:U,args:l,env:g,overrideName:v,isAutoDetected:T,isDefault:o===n};if((0,D.basename)(U)===U){const _=c.PATH?c.PATH.split(D.delimiter):void 0;return await(0,w.findExecutable)(U,void 0,_,void 0,s.existsFile)?x:r(o,n,t,s,c,l)}return await s.existsFile((0,D.normalize)(U))?x:r(o,n,t,s,c,l,g,v,T)}}),define(te[218],ne([0,1,3,2,15,4,34,52,21,11,77,167,7,87,22,211,97,216,217]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let a=0,u=class extends L.Disposable{constructor(o,n,t,s,c){super();this._reconnectConstants=o,this._configurationService=n,this._environmentService=t,this._logService=s,this._telemetryService=c,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new b.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(k.isWindows)return process.env;try{return await(0,E.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(o){return this._logService.error("ptyHost was unable to resolve shell environment",o),{}}}_startPtyHost(){const o={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:a,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?o.debugBrk=n.port:!n.break&&n.port&&(o.debug=n.port));const t=new P.Client(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,o);this._onPtyHostStart.fire(),i.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(g=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(g.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}, giving up`))}));const c=t.getChannel(y.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(c,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(c,this._logService.getLevel())}));const l=i.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.PtyHost));return this._register(l.onProcessData(g=>this._onProcessData.fire(g))),this._register(l.onProcessReady(g=>this._onProcessReady.fire(g))),this._register(l.onProcessExit(g=>this._onProcessExit.fire(g))),this._register(l.onDidChangeProperty(g=>this._onDidChangeProperty.fire(g))),this._register(l.onProcessReplay(g=>this._onProcessReplay.fire(g))),this._register(l.onProcessOrphanQuestion(g=>this._onProcessOrphanQuestion.fire(g))),this._register(l.onDidRequestDetach(g=>this._onDidRequestDetach.fire(g))),[t,l]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(o,n,t,s,c,l,g,v,T,O,U){const x=setTimeout(()=>this._handleUnresponsiveCreateProcess(),y.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(o,n,t,s,c,l,g,v,T,O,U);return clearTimeout(x),a=Math.max(a,N),N}updateTitle(o,n,t){return this._proxy.updateTitle(o,n,t)}updateIcon(o,n,t){return this._proxy.updateIcon(o,n,t)}attachToProcess(o){return this._proxy.attachToProcess(o)}detachFromProcess(o){return this._proxy.detachFromProcess(o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(o){return this._proxy.start(o)}shutdown(o,n){return this._proxy.shutdown(o,n)}input(o,n){return this._proxy.input(o,n)}processBinary(o,n){return this._proxy.processBinary(o,n)}resize(o,n,t){return this._proxy.resize(o,n,t)}acknowledgeDataEvent(o,n){return this._proxy.acknowledgeDataEvent(o,n)}setUnicodeVersion(o,n){return this._proxy.setUnicodeVersion(o,n)}getInitialCwd(o){return this._proxy.getInitialCwd(o)}getCwd(o){return this._proxy.getCwd(o)}getLatency(o){return this._proxy.getLatency(o)}orphanQuestionReply(o){return this._proxy.orphanQuestionReply(o)}getDefaultSystemShell(o){return this._proxy.getDefaultSystemShell(o)}async getProfiles(o,n,t,s=!1){const c=await this._shellEnv;return(0,S.detectAvailableProfiles)(n,t,s,this._configurationService,c,void 0,this._logService,this._resolveVariables.bind(this,o))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(o){return this._proxy.getWslPath(o)}setTerminalLayoutInfo(o){return this._proxy.setTerminalLayoutInfo(o)}async getTerminalLayoutInfo(o){return await this._proxy.getTerminalLayoutInfo(o)}async requestDetachInstance(o,n){return this._proxy.requestDetachInstance(o,n)}async acceptDetachInstanceReply(o,n){return this._proxy.acceptDetachInstanceReply(o,n)}async serializeTerminalState(o){return this._proxy.serializeTerminalState(o)}async reviveTerminalProcesses(o){return this._proxy.reviveTerminalProcesses(o)}async refreshProperty(o,n){return this._proxy.refreshProperty(o,n)}async updateProperty(o,n,t){return this._proxy.updateProperty(o,n,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(o,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:o,originalText:n})}async acceptPtyHostResolvedVariables(o,n){this._resolveVariablesRequestStore.acceptReply(o,n)}};u=he([J(1,w.IConfigurationService),J(2,C.IEnvironmentService),J(3,d.ILogService),J(4,h.ITelemetryService)],u),e.PtyHostService=u}),define(te[37],ne([0,1,6]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(te[219],ne([0,1,3,2,9,11,36,14,7,37]),function(X,e,R,L,D,k,i,P,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends L.Disposable{constructor(d,p,h,b,y){super();this.extensionsManagementService=d,this.logService=b,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(S=>{this.installedExtensions=S.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(S=>this.onInstallExtension(S))),this._register(d.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(d.onDidUninstallExtension(S=>this.onDidUninstallExtension(S)));const m=D.URI.file(h.extensionsPath);this._register(p.watch(m)),this._register(R.Event.filter(p.onDidChangeFilesRaw,S=>S.changes.some(f=>this.doesChangeAffects(f,m)))(()=>this.onDidChange()))}doesChangeAffects(d,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),p)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const p of d)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(p=>!(0,i.areSameExtensions)(p,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,i.areSameExtensions)(p,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),p=d.filter(b=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,i.areSameExtensions)(y,b.identifier))?!1:b.installedTimestamp&&b.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",b.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",b.identifier.id),!1)),h=this.installedExtensions.filter(b=>this.installingExtensions.some(y=>(0,i.areSameExtensions)(y,b))?!1:d.every(y=>!(0,i.areSameExtensions)(y.identifier,b))?(this.logService.info("Detected extension removed from another source",b.id),!0):!1);this.installedExtensions=d.map(b=>b.identifier),(p.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:h})}}};I=he([J(1,P.IFileService),J(2,k.INativeEnvironmentService),J(3,w.ILogService),J(4,C.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(te[220],ne([0,1,37,59,14,18,105,3,2]),function(X,e,R,L,D,k,i,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(d){this.uri=d,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let I=class{constructor(d){this._fileService=d,this._dispooables=new w.DisposableStore,this._limit=2**16;const p=new Map,h=b=>{let y=p.get(b.scheme);return y===void 0&&(y=d.hasProvider(b)&&!this._fileService.hasCapability(b,1024),p.set(b.scheme,y)),y};this._dispooables.add(P.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(b=>{p.delete(b.scheme)})),this.extUri=new k.ExtUri(h),this._canonicalUris=new i.SkipList((b,y)=>this.extUri.compare(b,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,k.normalizePath)(d));let p=this._canonicalUris.get(d);return p?p.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new C(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((h,b)=>h[1].touch<b[1].touch?1:h[1].touch>b[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let h=0;h<p;h++)this._canonicalUris.set(d[h][0],d[h][1].touch())}};I=he([J(0,D.IFileService)],I),e.UriIdentityService=I,(0,L.registerSingleton)(R.IUriIdentityService,I,!0)}),define(te[55],ne([0,1,40]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(i,P,w,C){const I=(0,R.setProperty)(i,P,w,C)[0];return I&&(i=i.substring(0,I.offset)+I.content+i.substring(I.offset+I.length)),i}e.edit=L;function D(i,P,w){let C=w;for(;C>=0;){if(i.charAt(C)===P.charAt(P.length-1)&&P.length===1)return C+1;if(C--,P.length===2&&C>=0&&i.charAt(C)===P.charAt(0))return C+2}return 0}e.getLineStartOffset=D;function k(i,P,w){let C=w;for(;C>=0;)if(i.charAt(C)===P.charAt(P.length-1)&&P.length===1||(C++,P.length===2&&C>=0&&i.charAt(C)===P.charAt(1)))return C;return i.length-1}e.getLineEndOffset=k}),define(te[221],ne([0,1,28,62]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(E,d,p,h,b){const y=[],m=[],S=[];if(!d){const O=E.filter(({identifier:U})=>b.every(x=>x.toLowerCase()!==U.id.toLowerCase()));return{local:{added:y,removed:m,updated:S},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}E=E.map(C),d=d.map(C),p=p?p.map(C):null;const f=new Map,a=O=>{O.uuid&&f.set(O.id.toLowerCase(),O.uuid)};E.forEach(({identifier:O})=>a(O)),d.forEach(({identifier:O})=>a(O)),p&&p.forEach(({identifier:O})=>a(O));const u=O=>{const U=O.identifier.uuid||f.get(O.identifier.id.toLowerCase());return U?`uuid:${U}`:`id:${O.identifier.id.toLowerCase()}`},r=(O,U)=>(O.set(u(U),U),O),o=E.reduce(r,new Map),n=d.reduce(r,new Map),t=d.reduce((O,U)=>{const x=u(U);U=(0,R.deepClone)(U);const N=o.get(x);return N&&(N.installed&&(U.installed=!0),U.version||(U.version=N.version)),r(O,U)},new Map),s=p?p.reduce(r,new Map):null,c=h.reduce(r,new Map),l=b.reduce((O,U)=>{const x=f.get(U.toLowerCase());return O.add(x?`uuid:${x}`:`id:${U.toLowerCase()}`)},new Set),g=k(o,n,l);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const O=k(s,o,l),U=k(s,n,l),x=(N,_)=>{const z=o.get(N);if(z){const A=n.get(N);return{..._?A:z,version:(A.version&&L.gt(A.version,z.version),z.version),state:i(z,A,s?.get(N))}}};for(const N of U.removed.values()){const _=o.get(N);_&&m.push(_.identifier)}for(const N of U.added.values())if(O.added.has(N)){if(g.updated.has(N)){const _=x(N,!0);_&&(S.push(I(_,N)),t.set(N,_))}}else{const _=n.get(N);_.installed&&y.push(I(_,N))}for(const N of U.updated.values()){const _=x(N,!0);_&&(S.push(I(_,N)),t.set(N,_))}for(const N of O.added.values())U.added.has(N)||t.set(N,o.get(N));for(const N of O.updated.values())if(!U.removed.has(N)&&!U.updated.has(N)){const _=x(N,!1);_&&(t.get(N)?.installed&&(_.installed=!0),t.set(N,_))}for(const N of O.removed.values())!c.has(N)&&!U.updated.has(N)&&s?.get(N)?.installed&&t.delete(N)}const v=[],T=k(n,t,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(T.added.size>0||T.updated.size>0||T.removed.size>0)&&t.forEach((O,U)=>v.push(I(O,U))),{local:{added:y,removed:m,updated:S},remote:v.length?{added:[...T.added].map(O=>t.get(O)),updated:[...T.updated].map(O=>t.get(O)),removed:[...T.removed].map(O=>n.get(O)),all:v}:null}}e.merge=D;function k(E,d,p,{checkInstalledProperty:h,checkVersionProperty:b}={checkInstalledProperty:!1,checkVersionProperty:!1}){const y=E?[...E.keys()].filter(u=>!p.has(u)):[],m=[...d.keys()].filter(u=>!p.has(u)),S=m.filter(u=>y.indexOf(u)===-1).reduce((u,r)=>(u.add(r),u),new Set),f=y.filter(u=>m.indexOf(u)===-1).reduce((u,r)=>(u.add(r),u),new Set),a=new Set;for(const u of y){if(f.has(u))continue;const r=E.get(u),o=d.get(u);(!o||r.disabled!==o.disabled||!w(r.state,o.state)||b&&r.version!==o.version||h&&r.installed!==o.installed)&&a.add(u)}return{added:S,removed:f,updated:a}}function i(E,d,p){const h=E.state,b=d.state,y=p?.state;if(!d.version||h&&L.gt(E.version,d.version))return h;if(b&&L.gt(d.version,E.version)||!h)return b;if(!b)return h;const m=(0,R.deepClone)(h),S=y?P(y,b):{added:Object.keys(b).reduce((a,u)=>(a.add(u),a),new Set),removed:new Set,updated:new Set},f=y?P(y,h):{added:Object.keys(h).reduce((a,u)=>(a.add(u),a),new Set),removed:new Set,updated:new Set};for(const a of[...S.added.values(),...S.updated.values()])m[a]=b[a];for(const a of S.removed.values())f.updated.has(a)||delete m[a];return m}function P(E,d){const p=Object.keys(E),h=Object.keys(d),b=h.filter(S=>p.indexOf(S)===-1).reduce((S,f)=>(S.add(f),S),new Set),y=p.filter(S=>h.indexOf(S)===-1).reduce((S,f)=>(S.add(f),S),new Set),m=new Set;for(const S of p){if(y.has(S))continue;const f=E[S],a=d[S];(0,R.equals)(f,a)||m.add(S)}return{added:b,removed:y,updated:m}}function w(E={},d={}){const{added:p,removed:h,updated:b}=P(E,d);return p.size===0&&h.size===0&&b.size===0}function C(E){return{...E,disabled:!!E.disabled,installed:!!E.installed}}function I(E,d){const p={identifier:{id:E.identifier.id,uuid:d.startsWith("uuid:")?d.substring("uuid:".length):void 0}};return E.version&&(p.version=E.version),E.disabled&&(p.disabled=!0),E.installed&&(p.installed=!0),E.state&&(p.state=E.state),p}}),define(te[99],ne([0,1,16,3,2,36,6,26,23]),function(X,e,R,L,D,k,i,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,i.createDecorator)("IExtensionsStorageSyncService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let I=class it extends D.Disposable{constructor(d,p){super();this.storageService=d,this.productService=p,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const p=C.exec(d);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const d=this.storageService.keys(0,1);for(const p of d){const h=it.fromKey(p);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const p=it.fromKey(d.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(d,p){this.storageService.store(it.toKey(d),JSON.stringify(p),0,1)}getKeysForSync(d){const p=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.storageService.get(it.toKey(d),0),b=h?JSON.parse(h):void 0;return b&&p?(0,R.distinct)([...b,...p]):b||p}};I=he([J(0,w.IStorageService),J(1,P.IProductService)],I),e.ExtensionsStorageSyncService=I}),define(te[100],ne([0,1,16,21,6]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,w){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return C=C.filter(I=>I!==P&&I!==`-${P}`),w&&C.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}updateSynchronizedExtensions(P,w){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return C=C.filter(I=>I!==P&&I!==`-${P}`),w&&C.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}getIgnoredExtensions(P){const w=P.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),C=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),I=[],E=[];if(Array.isArray(C))for(const d of C)d.startsWith("-")?E.push(d.substring(1)):I.push(d);return(0,R.distinct)([...w,...I].filter(d=>E.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(w=>w.toLowerCase())}};k=he([J(0,L.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(te[222],ne([0,1,16,32,28,162,55]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(a){return(0,L.parse)(a)||[]}e.parseKeybindings=P;async function w(a,u,r,o,n){const t=P(a),s=P(u),c=r?P(r):null,l=[...t,...s,...c||[]].map(M=>M.key),g=await n.resolveUserBindings(l);let v=I(t,s,c,g);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:a,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};const T=d(t),O=d(s),U=c?d(c):null,x=h(T,O,g),N=U?h(U,T,g):{added:[...T.keys()].reduce((M,q)=>(M.add(q),M),new Set),removed:new Set,updated:new Set},_=U?h(U,O,g):{added:[...O.keys()].reduce((M,q)=>(M.add(q),M),new Set),removed:new Set,updated:new Set},z=C(x,N,_);let A=a;for(const M of z.removed.values())z.conflicts.has(M)||(A=S(A,M,o));for(const M of z.added.values()){if(z.conflicts.has(M))continue;const q=O.get(M);if(q.some(j=>j.command!==`-${M}`&&v.conflicts.has(g[j.key]))){z.conflicts.add(M);continue}A=m(A,q,o)}for(const M of z.updated.values()){if(z.conflicts.has(M))continue;const q=O.get(M);if(q.some(j=>j.command!==`-${M}`&&v.conflicts.has(g[j.key]))){z.conflicts.add(M);continue}A=f(A,M,q,o)}return{mergeContent:A,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.merge=w;function C(a,u,r){const o=new Set,n=new Set,t=new Set,s=new Set;for(const c of u.removed.values())r.updated.has(c)&&s.add(c);for(const c of r.removed.values())s.has(c)||(u.updated.has(c)?s.add(c):n.add(c));for(const c of u.added.values())s.has(c)||r.added.has(c)&&a.updated.has(c)&&s.add(c);for(const c of r.added.values())s.has(c)||(u.added.has(c)?a.updated.has(c)&&s.add(c):o.add(c));for(const c of u.updated.values())s.has(c)||r.updated.has(c)&&a.updated.has(c)&&s.add(c);for(const c of r.updated.values())s.has(c)||(u.updated.has(c)?a.updated.has(c)&&s.add(c):t.add(c));return{added:o,removed:n,updated:t,conflicts:s}}function I(a,u,r,o){const n=new Set,t=E(a,o),s=E(u,o),c=r?E(r,o):null,l=p(t,s);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const g=c?p(c,t):{added:[...t.keys()].reduce((N,_)=>(N.add(_),N),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const v=c?p(c,s):{added:[...s.keys()].reduce((N,_)=>(N.add(_),N),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:T,removed:O,updated:U,conflicts:x}=C(l,g,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:T,removed:O,updated:U,conflicts:x}}function E(a,u){const r=new Map;for(const o of a){const n=u[o.key];let t=r.get(n);t||(t=[],r.set(n,t)),t.push(o)}return r}function d(a){const u=new Map;for(const r of a){const o=r.command[0]==="-"?r.command.substring(1):r.command;let n=u.get(o);n||(n=[],u.set(o,n)),n.push(r)}return u}function p(a,u){const r=[...a.keys()],o=[...u.keys()],n=o.filter(c=>r.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),t=r.filter(c=>o.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),s=new Set;for(const c of r){if(t.has(c))continue;const l=a.get(c).map(v=>({...v,key:c})),g=u.get(c).map(v=>({...v,key:c}));(0,R.equals)(l,g,(v,T)=>y(v,T))||s.add(c)}return{added:n,removed:t,updated:s}}function h(a,u,r){const o=[...a.keys()],n=[...u.keys()],t=n.filter(l=>o.indexOf(l)===-1).reduce((l,g)=>(l.add(g),l),new Set),s=o.filter(l=>n.indexOf(l)===-1).reduce((l,g)=>(l.add(g),l),new Set),c=new Set;for(const l of o){if(s.has(l))continue;const g=a.get(l).map(T=>({...T,key:r[T.key]})),v=u.get(l).map(T=>({...T,key:r[T.key]}));b(g,v)||c.add(l)}return{added:t,removed:s,updated:c}}function b(a,u){return!(!(0,R.equals)(a.filter(({command:r})=>r[0]!=="-"),u.filter(({command:r})=>r[0]!=="-"),(r,o)=>y(r,o))||!(0,R.equals)(a.filter(({command:r})=>r[0]==="-"),u.filter(({command:r})=>r[0]==="-"),(r,o)=>y(r,o)))}function y(a,u){if(a.command!==u.command||a.key!==u.key)return!1;const r=k.ContextKeyExpr.deserialize(a.when),o=k.ContextKeyExpr.deserialize(u.when);return!(r&&!o||!r&&o||r&&o&&!r.equals(o)||!D.equals(a.args,u.args))}function m(a,u,r){for(const o of u)a=i.edit(a,[-1],o,r);return a}function S(a,u,r){const o=P(a);for(let n=o.length-1;n>=0;n--)(o[n].command===u||o[n].command===`-${u}`)&&(a=i.edit(a,[n],void 0,r));return a}function f(a,u,r,o){const n=P(a),t=n.findIndex(s=>s.command===u||s.command===`-${u}`);for(let s=n.length-1;s>=0;s--)(n[s].command===u||n[s].command===`-${u}`)&&(a=i.edit(a,[s],void 0,o));for(let s=r.length-1;s>=0;s--)a=i.edit(a,[t],r[s],o);return a}}),define(te[223],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(k,i,P){const w={},C={},I=new Set;if(!i)return{local:{added:w,updated:C,removed:[...I.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const E=L(k,i);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:w,updated:C,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=L(P,k),p=L(P,i),h={},b={},y=new Set,m=new Set;for(const S of d.removed.values())p.updated.has(S)?w[S]=i[S]:y.add(S);for(const S of p.removed.values())m.has(S)||(d.updated.has(S)?m.add(S):I.add(S));for(const S of d.updated.values())m.has(S)||(p.updated.has(S)?E.updated.has(S)&&m.add(S):b[S]=k[S]);for(const S of p.updated.values())m.has(S)||(d.updated.has(S)?E.updated.has(S)&&m.add(S):k[S]!==void 0&&(C[S]=i[S]));for(const S of d.added.values())m.has(S)||(p.added.has(S)?E.updated.has(S)&&m.add(S):h[S]=k[S]);for(const S of p.added.values())m.has(S)||(d.added.has(S)?E.updated.has(S)&&m.add(S):w[S]=i[S]);return{local:{added:w,removed:[...I.values()],updated:C},remote:{added:h,removed:[...y.values()],updated:b},conflicts:[...m.values()]}}e.merge=R;function L(k,i){const P=k?Object.keys(k):[],w=i?Object.keys(i):[],C=w.filter(d=>P.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),I=P.filter(d=>w.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),E=new Set;for(const d of P){if(I.has(d))continue;const p=k[d],h=i[d];p!==h&&E.add(d)}return{added:C,removed:I,updated:E}}function D(k,i){const{added:P,removed:w,updated:C}=L(k,i);return P.size===0&&w.size===0&&C.size===0}e.areSame=D}),define(te[24],ne([0,1,16,18,17,150,39,30,6,89,35]),function(X,e,R,L,D,k,i,P,w,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const c=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(l=>!!c[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function d(){const c=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(c).filter(T=>!!c[T].ignoreSync),g=Object.keys(c).filter(T=>c[T].scope===2||c[T].scope===6),v=E();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...g,...v])}e.getDefaultIgnoredSettings=d,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const c="vscode://schemas/ignoredSettings",l=I.Registry.as(i.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,k.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,k.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,k.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,k.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,k.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=I.Registry.as(C.Extensions.JSONContribution),v=()=>{const T=E(),O=d().filter(_=>_!==e.CONFIGURATION_SYNC_STORE_KEY),U=Object.keys(i.allSettings.properties).filter(_=>O.indexOf(_)===-1),x=O.filter(_=>T.indexOf(_)===-1),N={items:{type:"string",enum:[...U,...x.map(_=>`-${_}`)]}};g.registerSchema(c,N)};return l.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=p;function h(c){return c&&(0,D.isObject)(c)&&(0,D.isString)(c.id)&&(0,D.isArray)(c.scopes)}e.isAuthenticationProvider=h;var b;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(b=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function y(c,l,g){return g.joinPath(l.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,w.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,w.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,w.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(c){const l={};return l[e.HEADER_EXECUTION_ID]=c,l}e.createSyncHeaders=m;var S;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(S=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class f extends Error{constructor(l,g,v,T){super(l);this.code=g,this.resource=v,this.operationId=T,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class a extends f{constructor(l,g,v,T,O){super(l,v,void 0,O);this.url=g,this.serverCode=T}}e.UserDataSyncStoreError=a;class u extends f{constructor(l,g){super(l,g)}}e.UserDataAutoSyncError=u,function(c){function l(g){if(g instanceof c)return g;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(v&&v[1]){const T=v[2]==="unknown"?void 0:v[2],O=v[3]==="unknown"?void 0:v[3];return new c(g.message,v[1],T,O)}return new c(g.message,"Unknown")}c.toUserDataSyncError=l}(f=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var o;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var n;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(c){return`sync.enable.${c}`}e.getEnablementKey=t,e.IUserDataSyncResourceEnablementService=(0,w.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,w.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,w.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,w.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,w.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,w.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(c,l){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,L.isEqualOrParent)(c,(0,L.joinPath)(l.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(te[47],ne([0,1,16,5,19,27,3,32,2,25,17,9,146,21,11,14,7,46,23,22,37,24]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S,f,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(c){return!!(c&&c.version!==void 0&&typeof c.version=="number"&&c.content!==void 0&&typeof c.content=="string"&&(Object.keys(c).length===2||Object.keys(c).length===3&&c.machineId!==void 0&&typeof c.machineId=="string"))}e.isSyncData=r;let o=class extends w.Disposable{constructor(l,g,v,T,O,U,x,N,_,z,A){super();this.resource=l,this.fileService=g,this.environmentService=v,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=U,this.userDataSyncResourceEnablementService=x,this.telemetryService=N,this.logService=_,this.configurationService=z,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new i.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=A.extUri,this.syncFolder=this.extUri.joinPath(v.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(l,v,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(v,g,T)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const g=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(g)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?(await this.doGenerateSyncResourcePreview(l,l,!0,this.getUserDataSyncConfiguration(),k.CancellationToken.None)).resourcePreviews.some(({remoteChange:v})=>v!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const g=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),g==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,g={}){await this._sync(l,!0,this.getUserDataSyncConfiguration(),g)}async preview(l,g,v={}){return this._sync(l,!1,g,v)}async apply(l,g={}){try{this.syncHeaders={...g};const v=await this.doApply(l);return this.setStatus(v),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,g,v,T){try{if(this.syncHeaders={...T},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const U=await this.getLastSyncUserData(),x=await this.getLatestRemoteUserData(l,U);return O=await this.performSync(x,U,g,v),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(l){const g=await this.resolveContent(l);if(!g)return!1;const v=this.parseSyncData(g);if(!v)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const T=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,T),U=await this.isRemoteDataFromCurrentMachine(O),x=await this.generateSyncPreview({ref:O.ref,syncData:v},T,U,this.getUserDataSyncConfiguration(),k.CancellationToken.None),N=[];for(const _ of x){const z=await this.getAcceptResult(_,_.remoteResource,void 0,k.CancellationToken.None),{remoteChange:A}=await this.getAcceptResult(_,_.previewResource,_.remoteContent,k.CancellationToken.None);N.push([_,{...z,remoteChange:A!==0?A:2}])}await this.applyResult(O,T,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const g=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===g}async getLatestRemoteUserData(l,g){if(g){const v=l&&l.latest?l.latest[this.resource]:void 0;if(g.ref===v||v===void 0&&g.syncData===null)return g}return this.getRemoteUserData(g)}async performSync(l,g,v,T){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,g,v,T)}catch(O){if(O instanceof u.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,g,v,T);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),g=await this.getLastSyncUserData(),this.performSync(l,g,v,T)}throw O}}async doSync(l,g,v,T){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(U=>this.doGenerateSyncResourcePreview(l,g,v,T,U)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":v?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(l){return await this.updateSyncResourcePreview(l,async g=>{const v=await this.getMergeResult(g,k.CancellationToken.None);await this.fileService.writeFile(g.previewResource,D.VSBuffer.fromString(v?.content||""));const T=v&&!v.hasConflicts?await this.getAcceptResult(g,g.previewResource,void 0,k.CancellationToken.None):void 0;return g.acceptResult=T,g.mergeState=v.hasConflicts?"conflict":T?"accepted":"preview",g.localChange=T?T.localChange:v.localChange,g.remoteChange=T?T.remoteChange:v.remoteChange,g}),this.syncPreviewPromise}async accept(l,g){return await this.updateSyncResourcePreview(l,async v=>{const T=await this.getAcceptResult(v,l,g,k.CancellationToken.None);return v.acceptResult=T,v.mergeState="accepted",v.localChange=T.localChange,v.remoteChange=T.remoteChange,v}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async g=>{const v=await this.getMergeResult(g,k.CancellationToken.None);return await this.fileService.writeFile(g.previewResource,D.VSBuffer.fromString(v.content||"")),g.acceptResult=void 0,g.mergeState="preview",g.localChange=v.localChange,g.remoteChange=v.remoteChange,g}),this.syncPreviewPromise}async updateSyncResourcePreview(l,g){if(!this.syncPreviewPromise)return;let v=await this.syncPreviewPromise;const T=v.resourcePreviews.findIndex(({localResource:O,remoteResource:U,previewResource:x})=>this.extUri.isEqual(O,l)||this.extUri.isEqual(U,l)||this.extUri.isEqual(x,l));T!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async O=>{const U=[...v.resourcePreviews];return U[T]=await g(U[T]),{...v,resourcePreviews:U}}),v=await this.syncPreviewPromise,this.updateConflicts(v.resourcePreviews),v.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const g=await this.syncPreviewPromise;return g.resourcePreviews.some(({mergeState:v})=>v==="conflict")?"hasConflicts":g.resourcePreviews.some(({mergeState:v})=>v!=="accepted")?"syncing":(await this.applyResult(g.remoteUserData,g.lastSyncUserData,g.resourcePreviews.map(v=>[v,v.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(l){}}updateConflicts(l){const g=l.filter(({mergeState:v})=>v==="conflict");(0,R.equals)(this._conflicts,g,(v,T)=>this.extUri.isEqual(v.previewResource,T.previewResource))||(this._conflicts=g,this._onDidChangeConflicts.fire(g))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:g,ref:v})=>({created:g,uri:this.toRemoteBackupResource(v)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:g,ref:v})=>({created:g,uri:this.toLocalBackupResource(v)}))}toRemoteBackupResource(l){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const g=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(g))){const{content:v}=await this.getUserData(g);if(v)return this.parseSyncData(v)?.machineId}}async resolveContent(l){const g=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(g))){const{content:v}=await this.getUserData(g);return v}return this.extUri.isEqual(l,this.toLocalBackupResource(g))?this.userDataSyncBackupStoreService.resolveContent(this.resource,g):null}async resolvePreviewContent(l){const g=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(g)for(const v of g.resourcePreviews){if(this.extUri.isEqual(v.acceptedResource,l))return v.acceptResult?v.acceptResult.content:null;if(this.extUri.isEqual(v.remoteResource,l))return v.remoteContent;if(this.extUri.isEqual(v.localResource,l))return v.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(l){}}async doGenerateSyncResourcePreview(l,g,v,T,O){const U=await this.isRemoteDataFromCurrentMachine(l),x=await this.generateSyncPreview(l,g,U,T,O),N=[];for(const _ of x){const z=_.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(_.localChange===0&&_.remoteChange===0)N.push({..._,acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const A=v?await this.getMergeResult(_,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(_.previewResource,D.VSBuffer.fromString(A?.content||""));const M=A&&!A.hasConflicts?await this.getAcceptResult(_,_.previewResource,void 0,O):void 0;N.push({..._,acceptResult:M,mergeState:A?.hasConflicts?"conflict":M?"accepted":"preview",localChange:M?M.localChange:A?A.localChange:_.localChange,remoteChange:M?M.remoteChange:A?A.remoteChange:_.remoteChange})}}return{remoteUserData:l,lastSyncUserData:g,resourcePreviews:N,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),g=JSON.parse(l.value.toString()),v=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=g.version&&v&&g.version!==v,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${g.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;const T=g;if(T.content===null)return{ref:g.ref,syncData:null};const O=JSON.parse(T.content);if(r(O))return{...g,syncData:O,content:void 0}}catch(l){l instanceof b.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,g={}){if(g.ref||g.content||g.version)throw new Error("Cannot have core properties as additional");const v=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),T={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:v,...g};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(T)))}async getRemoteUserData(l){const{ref:g,content:v}=await this.getUserData(l);let T=null;return v!==null&&(T=this.parseSyncData(v)),{ref:g,syncData:T}}parseSyncData(l){try{const g=JSON.parse(l);if(r(g))return g}catch(g){this.logService.error(g)}throw new u.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,I.isString)(l)){const g=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:g}}else{const g=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,g,this.syncHeaders)}}async updateRemoteUserData(l,g){const v=await this.currentMachineIdPromise,T={version:this.version,machineId:v,content:l};return g=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(T),g,this.syncHeaders),{ref:g,syncData:T}}async backupLocal(l){const g={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(g))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};o=he([J(1,b.IFileService),J(2,h.IEnvironmentService),J(3,S.IStorageService),J(4,u.IUserDataSyncStoreService),J(5,u.IUserDataSyncBackupStoreService),J(6,u.IUserDataSyncResourceEnablementService),J(7,f.ITelemetryService),J(8,u.IUserDataSyncLogService),J(9,p.IConfigurationService),J(10,a.IUriIdentityService)],o),e.AbstractSynchroniser=o;let n=class extends o{constructor(l,g,v,T,O,U,x,N,_,z,A,M){super(g,v,T,O,U,x,N,_,z,A,M);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(q=>this.onFileChanges(q)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(l){return null}}async updateLocalFileContent(l,g,v){try{g?await this.writeFileContent(l,g,v):await this.fileService.createFile(this.file,D.VSBuffer.fromString(l),{overwrite:v})}catch(T){throw T instanceof b.FileOperationError&&T.fileOperationResult===1||T instanceof b.FileOperationError&&T.fileOperationResult===3?new u.UserDataSyncError(T.message,"LocalPreconditionFailed"):T}}async writeFileContent(l,g,v){await this.fileService.writeFile(this.file,D.VSBuffer.fromString(l),v?void 0:g)}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};n=he([J(2,b.IFileService),J(3,h.IEnvironmentService),J(4,S.IStorageService),J(5,u.IUserDataSyncStoreService),J(6,u.IUserDataSyncBackupStoreService),J(7,u.IUserDataSyncResourceEnablementService),J(8,f.ITelemetryService),J(9,u.IUserDataSyncLogService),J(10,p.IConfigurationService),J(11,a.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let t=class extends n{constructor(l,g,v,T,O,U,x,N,_,z,A,M,q){super(l,g,v,T,O,U,x,N,_,z,M,q);this.userDataSyncUtilService=A,this._formattingOptions=void 0}hasErrors(l){const g=[];return(0,P.parse)(l,g,{allowEmptyContent:!0,allowTrailingComma:!0}),g.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=he([J(2,b.IFileService),J(3,h.IEnvironmentService),J(4,S.IStorageService),J(5,u.IUserDataSyncStoreService),J(6,u.IUserDataSyncBackupStoreService),J(7,u.IUserDataSyncResourceEnablementService),J(8,f.ITelemetryService),J(9,u.IUserDataSyncLogService),J(10,u.IUserDataSyncUtilService),J(11,p.IConfigurationService),J(12,a.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(l,g,v,T,O){this.resource=l,this.environmentService=g,this.logService=v,this.fileService=T,this.extUri=O.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,g,this.extUri)}async initialize({ref:l,content:g}){if(!g){this.logService.info("Remote content does not exist.",this.resource);return}const v=this.parseSyncData(g);if(!!v)try{await this.doInitialize({ref:l,syncData:v})}catch(T){this.logService.error(T)}}parseSyncData(l){try{const g=JSON.parse(l);if(r(g))return g}catch(g){this.logService.error(g)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,g={}){const v={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...g};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(v)))}};s=he([J(1,h.IEnvironmentService),J(2,y.ILogService),J(3,b.IFileService),J(4,a.IUriIdentityService)],s),e.AbstractInitializer=s}),define(te[224],ne([0,1,5,27,8,3,40,48,25,9,21,11,30,36,14,7,23,22,37,47,221,99,100,24]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S,f,a,u,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function n(g,v){const T=JSON.parse(g.content);if(g.version===1||g.version===2){const O=(await v.getInstalled(0)).filter(U=>U.isBuiltin);for(const U of T)g.version===1&&(U.enabled===!1&&(U.disabled=!0),delete U.enabled),g.version===2&&O.every(x=>!(0,p.areSameExtensions)(x.identifier,U.identifier))&&(U.installed=!0)}return T}function t(g,v,T){const O=T.get((0,p.getExtensionId)(g,v),0)||"{}";return JSON.parse(O)}e.getExtensionStorageState=t;function s(g,v,T,O){O.store((0,p.getExtensionId)(g,v),JSON.stringify(T),0,1)}e.storeExtensionStorageState=s;let c=class mt extends f.AbstractSynchroniser{constructor(v,T,O,U,x,N,_,z,A,M,q,j,W,$,K){super("extensions",T,v,O,U,x,j,W,A,q,K);this.storageService=O,this.extensionManagementService=N,this.extensionEnablementService=_,this.ignoredExtensionsManagementService=z,this.extensionGalleryService=M,this.extensionsStorageSyncService=$,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtensions,F=>F.some(({local:B})=>!!B)),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,F=>!F.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(v,T){const O=v.syncData?await n(v.syncData,this.extensionManagementService):null,U=T?.skippedExtensions||[],x=T?.syncData?await n(T.syncData,this.extensionManagementService):null,N=await this.extensionManagementService.getInstalled(void 0,!0),_=this.getLocalExtensions(N),z=this.ignoredExtensionsManagementService.getIgnoredExtensions(N);O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:A,remote:M}=(0,a.merge)(_,O,x,U,z),q={local:A,remote:M,content:this.getPreviewContent(_,A.added,A.updated,A.removed),localChange:A.added.length>0||A.removed.length>0||A.updated.length>0?2:0,remoteChange:M!==null?2:0};return[{skippedExtensions:U,localResource:this.localResource,localContent:this.format(_),localExtensions:_,remoteResource:this.remoteResource,remoteContent:O?this.format(O):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(v,T,O,U){const x=[...T,...O],N=new Set,_=z=>{N.add(z.id.toLowerCase()),z.uuid&&N.add(z.uuid)};x.forEach(({identifier:z})=>_(z)),U.forEach(_);for(const z of v)N.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&N.has(z.identifier.uuid)||x.push(z);return this.format(x)}async getMergeResult(v,T){return{...v.previewResult,hasConflicts:!1}}async getAcceptResult(v,T,O,U){if(this.extUri.isEqual(T,this.localResource))return this.acceptLocal(v);if(this.extUri.isEqual(T,this.remoteResource))return this.acceptRemote(v);if(this.extUri.isEqual(T,this.previewResource))return v.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async acceptLocal(v){const T=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(T),U=(0,a.merge)(v.localExtensions,null,null,v.skippedExtensions,O),{local:x,remote:N}=U;return{content:v.localContent,local:x,remote:N,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:N!==null?2:0}}async acceptRemote(v){const T=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(T),U=v.remoteContent?JSON.parse(v.remoteContent):null;if(U!==null){const x=(0,a.merge)(v.localExtensions,U,v.localExtensions,[],O),{local:N,remote:_}=x;return{content:v.remoteContent,local:N,remote:_,localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:_!==null?2:0}}else return{content:v.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(v,T,O,U){let{skippedExtensions:x,localExtensions:N}=O[0][0],{local:_,remote:z,localChange:A,remoteChange:M}=O[0][1];if(A===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),A!==0&&(await this.backupLocal(JSON.stringify(N)),x=await this.updateLocalExtensions(_.added,_.removed,_.updated,x)),z){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const q=JSON.stringify(z.all);v=await this.updateRemoteUserData(q,U?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(j=>j.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(j=>j.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(j=>j.identifier.id))}.`:""}`)}T?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(v,{skippedExtensions:x}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(q=>q.identifier.id))}.`:""}`))}async getAssociatedResources({uri:v}){return[{resource:this.extUri.joinPath(v,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(v){if(this.extUri.isEqual(v,mt.EXTENSIONS_DATA_URI)){const O=await this.extensionManagementService.getInstalled(),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(O),x=this.getLocalExtensions(O).filter(N=>!U.some(_=>(0,p.areSameExtensions)({id:_},N.identifier)));return this.format(x)}if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v))return this.resolvePreviewContent(v);let T=await super.resolveContent(v);if(T)return T;if(T=await super.resolveContent(this.extUri.dirname(v)),T){const O=this.parseSyncData(T);if(O)switch(this.extUri.basename(v)){case"extensions.json":return this.format(this.parseExtensions(O))}}return null}format(v){v.sort((U,x)=>!U.identifier.uuid&&x.identifier.uuid?-1:U.identifier.uuid&&!x.identifier.uuid?1:(0,w.compare)(U.identifier.id,x.identifier.id));const T=JSON.stringify(v),O=(0,P.format)(T,void 0,{});return(0,i.applyEdits)(T,O)}async hasLocalData(){try{const v=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(v).some(O=>O.installed||O.disabled))return!0}catch(v){}return!1}async updateLocalExtensions(v,T,O,U){const x=[],N=[],_=await this.extensionManagementService.getInstalled();if(T.length){const A=_.filter(({identifier:M,isBuiltin:q})=>!q&&T.some(j=>(0,p.areSameExtensions)(M,j)));await R.Promises.settled(A.map(async M=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,M.identifier.id),await this.extensionManagementService.uninstall(M,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,M.identifier.id),x.push(M.identifier)}))}(v.length||O.length)&&await R.Promises.settled([...v,...O].map(async A=>{const M=_.find(j=>(0,p.areSameExtensions)(j.identifier,A.identifier));if(M&&M.isBuiltin){A.state&&M.manifest.version===A.version&&this.updateExtensionState(A.state,M.manifest.publisher,M.manifest.name,M.manifest.version),A.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,A.identifier.id),await this.extensionEnablementService.disableExtension(A.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,A.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,A.identifier.id),await this.extensionEnablementService.enableExtension(A.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,A.identifier.id)),x.push(A.identifier);return}const q=(await this.extensionGalleryService.getExtensions([A.identifier],L.CancellationToken.None))[0];if(A.state&&(M?M.manifest.version===A.version:!!q)){const j=M?M.manifest.publisher:q.publisher,W=M?M.manifest.name:q.name;this.updateExtensionState(A.state,j,W,M?.manifest.version)}if(q)try{A.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,A.identifier.id,q.version),await this.extensionEnablementService.disableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,A.identifier.id,q.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,A.identifier.id,q.version),await this.extensionEnablementService.enableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,A.identifier.id,q.version)),M||(await this.extensionManagementService.canInstall(q)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,A.identifier.id,q.version),await this.extensionManagementService.installFromGallery(q,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,A.identifier.id,q.version),x.push(q.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),N.push(A)))}catch(j){N.push(A),j instanceof d.ExtensionManagementError&&j.code===d.ExtensionManagementErrorCode.Incompatible?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,q.displayName||q.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,q.displayName||q.identifier.id))}else N.push(A),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,A.identifier.id)}));const z=[];for(const A of U)x.some(M=>(0,p.areSameExtensions)(M,A.identifier))||z.push(A);for(const A of N)z.some(M=>(0,p.areSameExtensions)(M.identifier,A.identifier))||z.push(A);return z}updateExtensionState(v,T,O,U){const x=t(T,O,this.storageService),N=U?this.extensionsStorageSyncService.getKeysForSync({id:(0,p.getGalleryExtensionId)(T,O),version:U}):void 0;N?N.forEach(_=>{x[_]=v[_]}):Object.keys(v).forEach(_=>x[_]=v[_]),s(T,O,x,this.storageService)}parseExtensions(v){return JSON.parse(v.content)}getLocalExtensions(v){const T=this.extensionEnablementService.getDisabledExtensions();return v.map(({identifier:O,isBuiltin:U,manifest:x})=>{const N={identifier:O,version:x.version};T.some(_=>(0,p.areSameExtensions)(_,O))&&(N.disabled=!0),U||(N.installed=!0);try{const _=this.extensionsStorageSyncService.getKeysForSync({id:O.id,version:x.version});if(_){const z=t(x.publisher,x.name,this.storageService);N.state=Object.keys(z).reduce((A,M)=>(_.includes(M)&&(A[M]=z[M]),A),{})}}catch(_){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(_))}return N})}};c.EXTENSIONS_DATA_URI=C.URI.from({scheme:o.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),c=he([J(0,E.IEnvironmentService),J(1,h.IFileService),J(2,y.IStorageService),J(3,o.IUserDataSyncStoreService),J(4,o.IUserDataSyncBackupStoreService),J(5,d.IExtensionManagementService),J(6,d.IGlobalExtensionEnablementService),J(7,r.IIgnoredExtensionsManagementService),J(8,o.IUserDataSyncLogService),J(9,d.IExtensionGalleryService),J(10,I.IConfigurationService),J(11,o.IUserDataSyncResourceEnablementService),J(12,m.ITelemetryService),J(13,u.IExtensionsStorageSyncService),J(14,S.IUriIdentityService)],c),e.ExtensionsSynchroniser=c;let l=class extends f.AbstractInitializer{constructor(v,T,O,U,x,N){super("extensions",U,x,O,N);this.extensionManagementService=v,this.ignoredExtensionsManagementService=T}async parseExtensions(v){return v.syncData?await n(v.syncData,this.extensionManagementService):null}generatePreview(v,T){const O=[],U=[],x=[];for(const N of v){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(N.identifier.id))continue;const _=T.find(z=>(0,p.areSameExtensions)(z.identifier,N.identifier));_?(O.push(_),N.disabled&&x.push(N.identifier)):N.installed&&(U.push(N.identifier),N.disabled&&x.push(N.identifier))}return{installedExtensions:O,newExtensions:U,disabledExtensions:x,remoteExtensions:v}}};l=he([J(0,d.IExtensionManagementService),J(1,r.IIgnoredExtensionsManagementService),J(2,h.IFileService),J(3,E.IEnvironmentService),J(4,b.ILogService),J(5,S.IUriIdentityService)],l),e.AbstractExtensionsInitializer=l}),define(te[225],ne([0,1,28,24]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(P,w,C,I,E){if(!w)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const d=k(P,w);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=C?k(C,w):{added:Object.keys(w).reduce((S,f)=>(S.add(f),S),new Set),removed:new Set,updated:new Set},h=C?k(C,P):{added:Object.keys(P).reduce((S,f)=>(S.add(f),S),new Set),removed:new Set,updated:new Set},b={added:{},removed:[],updated:{}},y=R.deepClone(w),m=!C;for(const S of h.added.values())S!==L.SYNC_SERVICE_URL_TYPE&&m&&p.added.has(S)||(y[S]=P[S]);for(const S of h.updated.values())y[S]=P[S];for(const S of h.removed.values())I.unregistered.includes(S)||delete y[S];for(const S of p.added.values()){const f=w[S];if(I.machine.includes(S)){E.info(`GlobalState: Skipped adding ${S} in local storage because it is declared as machine scoped.`);continue}if(C&&h.added.has(S))continue;const a=P[S];a&&a.value===f.value||S===L.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(S)||(a?b.updated[S]=f:b.added[S]=f)}for(const S of p.updated.values()){const f=w[S];if(I.machine.includes(S)){E.info(`GlobalState: Skipped updating ${S} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(S)||h.removed.has(S))continue;const a=P[S];a&&a.value===f.value||(b.updated[S]=f)}for(const S of p.removed.values()){if(I.machine.includes(S)){E.trace(`GlobalState: Skipped removing ${S} in local storage because it is declared as machine scoped.`);continue}h.updated.has(S)||h.removed.has(S)||b.removed.push(S)}return{local:b,remote:i(y,w)?null:y}}e.merge=D;function k(P,w){const C=Object.keys(P),I=Object.keys(w),E=I.filter(h=>C.indexOf(h)===-1).reduce((h,b)=>(h.add(b),h),new Set),d=C.filter(h=>I.indexOf(h)===-1).reduce((h,b)=>(h.add(b),h),new Set),p=new Set;for(const h of C){if(d.has(h))continue;const b=P[h],y=w[h];R.equals(b,y)||p.add(h)}return{added:E,removed:d,updated:p}}function i(P,w){const{added:C,removed:I,updated:E}=k(P,w);return C.size===0&&I.size===0&&E.size===0}}),define(te[226],ne([0,1,19,8,3,32,40,48,4,9,29,21,11,14,7,46,23,22,37,47,55,225,24]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S,f,a,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const o="globalState.argv.",n=["locale"];function t(v){const T=v.storage?Object.keys(v.storage).sort():[],O={};T.forEach(N=>O[N]=v.storage[N]),v.storage=O;const U=JSON.stringify(v),x=(0,P.format)(U,void 0,{});return(0,i.applyEdits)(U,x)}const s=1;let c=class vt extends f.AbstractSynchroniser{constructor(T,O,U,x,N,_,z,A,M,q){super("globalState",T,N,M,O,U,_,z,x,A,q);this.storageService=M,this.version=s,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(T.onDidFilesChange,j=>j.contains(this.environmentService.argvResource)),D.Event.filter(M.onDidChangeValue,j=>j.scope===0&&j.target!==void 0?j.target===0:M.keys(0,0).includes(j.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(T,O,U){const x=T.syncData?JSON.parse(T.syncData.content):null;O=O===null&&U?T:O;const N=O&&O.syncData?JSON.parse(O.syncData.content):null,_=await this.getLocalGlobalState();x?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const z=this.getStorageKeys(N),{local:A,remote:M}=(0,u.merge)(_.storage,x?x.storage:null,N?N.storage:null,z,this.logService),q={content:null,local:A,remote:M,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:t(_),localUserData:_,remoteResource:this.remoteResource,remoteContent:x?t(x):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource,storageKeys:z}]}async getMergeResult(T,O){return{...T.previewResult,hasConflicts:!1}}async getAcceptResult(T,O,U,x){if(this.extUri.isEqual(O,this.localResource))return this.acceptLocal(T);if(this.extUri.isEqual(O,this.remoteResource))return this.acceptRemote(T);if(this.extUri.isEqual(O,this.previewResource))return T.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async acceptLocal(T){return{content:T.localContent,local:{added:{},removed:[],updated:{}},remote:T.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(T){if(T.remoteContent!==null){const O=JSON.parse(T.remoteContent),{local:U,remote:x}=(0,u.merge)(T.localUserData.storage,O.storage,null,T.storageKeys,this.logService);return{content:T.remoteContent,local:U,remote:x,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:x!==null?2:0}}else return{content:T.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(T,O,U,x){let{localUserData:N}=U[0][0],{local:_,remote:z,localChange:A,remoteChange:M}=U[0][1];if(A===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),A!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(_),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),M!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const q=JSON.stringify({storage:z});T=await this.updateRemoteUserData(q,x?null:T.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}O?.ref!==T.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(T),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:T}){return[{resource:this.extUri.joinPath(T,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(T){if(this.extUri.isEqual(T,vt.GLOBAL_STATE_DATA_URI)){const U=await this.getLocalGlobalState();return t(U)}if(this.extUri.isEqual(this.remoteResource,T)||this.extUri.isEqual(this.localResource,T)||this.extUri.isEqual(this.acceptedResource,T))return this.resolvePreviewContent(T);let O=await super.resolveContent(T);if(O)return O;if(O=await super.resolveContent(this.extUri.dirname(T)),O){const U=this.parseSyncData(O);if(U)switch(this.extUri.basename(T)){case"globalState.json":return t(JSON.parse(U.content))}}return null}async hasLocalData(){try{const{storage:T}=await this.getLocalGlobalState();if(Object.keys(T).length>1||T[`${o}.locale`]?.value!=="en")return!0}catch(T){}return!1}async getLocalGlobalState(){const T={},O=await this.getLocalArgvContent(),U=(0,k.parse)(O);for(const x of n)U[x]!==void 0&&(T[`${o}${x}`]={version:1,value:U[x]});for(const x of this.storageService.keys(0,0)){const N=this.storageService.get(x,0);N&&(T[x]={version:1,value:N})}return{storage:T}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const T=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),T.value.toString()}catch(T){this.logService.debug((0,L.getErrorMessage)(T))}return"{}"}async writeLocalGlobalState({added:T,removed:O,updated:U}){const x={},N={},_=(A,M)=>{for(const q of A){if(q.startsWith(o)){x[q.substring(o.length)]=M?M[q].value:void 0;continue}if(M){const j=M[q];j.value!==String(this.storageService.get(q,0))&&(N[q]=j.value)}else this.storageService.get(q,0)!==void 0&&(N[q]=void 0)}};if(_(Object.keys(T),T),_(Object.keys(U),U),_(O),Object.keys(x).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(x),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const A of Object.keys(N))this.storageService.store(A,N[A],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(T){const O=await this.getLocalArgvContent();let U=O;for(const x of Object.keys(T))U=(0,a.edit)(U,[x],T[x],{});O!==U&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(U)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(T){const O=this.storageService.keys(0,0),U=this.storageService.keys(0,1),x=[...O,...U],N=T?.storage?Object.keys(T.storage).filter(_=>!_.startsWith(o)&&!x.includes(_)&&this.storageService.get(_,0)!==void 0):[];if(!w.isWeb){const _=[...r.ALL_SYNC_RESOURCES.map(z=>(0,r.getEnablementKey)(z)),r.SYNC_SERVICE_URL_TYPE];N.push(..._),U.push(..._)}return{user:O,machine:U,unregistered:N}}};c.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),c=he([J(0,p.IFileService),J(1,r.IUserDataSyncStoreService),J(2,r.IUserDataSyncBackupStoreService),J(3,r.IUserDataSyncLogService),J(4,d.IEnvironmentService),J(5,r.IUserDataSyncResourceEnablementService),J(6,m.ITelemetryService),J(7,E.IConfigurationService),J(8,y.IStorageService),J(9,S.IUriIdentityService)],c),e.GlobalStateSynchroniser=c;let l=class extends f.AbstractInitializer{constructor(T,O,U,x,N){super("globalState",U,x,O,N);this.storageService=T}async doInitialize(T){const O=T.syncData?JSON.parse(T.syncData.content):null;if(!O){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const U={},x={};for(const N of Object.keys(O.storage))N.startsWith(o)?U[N.substring(o.length)]=O.storage[N].value:this.storageService.get(N,0)===void 0&&(x[N]=O.storage[N].value);if(Object.keys(U).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(_){}for(const _ of Object.keys(U))N=(0,a.edit)(N,[_],U[_],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(N))}if(Object.keys(x).length)for(const N of Object.keys(x))this.storageService.store(N,x[N],0,0)}};l=he([J(0,y.IStorageService),J(1,p.IFileService),J(2,d.IEnvironmentService),J(3,r.IUserDataSyncLogService),J(4,S.IUriIdentityService)],l),e.GlobalStateInitializer=l;let g=class{constructor(T,O,U,x,N){this.userDataSyncStoreClient=T,this.storageService=O,this.environmentService=U,this.fileService=x,this.logService=N}getSyncStoreType(T){return this.parseGlobalState(T)?.storage[r.SYNC_SERVICE_URL_TYPE]?.value}async sync(T){const O=(0,r.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(T,O)}catch(U){if(U instanceof r.UserDataSyncError)switch(U.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(T,O)}throw U}}async doSync(T,O){const U=await this.userDataSyncStoreClient.read("globalState",null,O),x=this.parseGlobalState(U)||{storage:{}};x.storage[r.SYNC_SERVICE_URL_TYPE]={value:T,version:s};const N=await(0,b.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),_={version:s,machineId:N,content:t(x)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(_),U.ref,O)}parseGlobalState({content:T}){if(!T)return null;const O=JSON.parse(T);if((0,f.isSyncData)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};g=he([J(1,y.IStorageService),J(2,d.IEnvironmentService),J(3,p.IFileService),J(4,h.ILogService)],g),e.UserDataSyncStoreTypeSynchronizer=g}),define(te[227],ne([0,1,16,19,3,32,4,17,147,21,11,14,23,22,37,47,222,24]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function S(u,r,o){try{const n=JSON.parse(u);if(!r)return(0,P.isUndefined)(n.all)?null:n.all;switch(i.OS){case 2:return(0,P.isUndefined)(n.mac)?null:n.mac;case 3:return(0,P.isUndefined)(n.linux)?null:n.linux;case 1:return(0,P.isUndefined)(n.windows)?null:n.windows}}catch(n){return o.error(n),null}}e.getKeybindingsContentFromSyncContent=S;let f=class extends b.AbstractJsonFileSynchroniser{constructor(r,o,n,t,s,c,l,g,v,T,O){super(l.keybindingsResource,"keybindings",c,l,g,r,o,s,T,n,v,t,O);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(t.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,o,n,t){const s=r.syncData?S(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;o=o===null&&n?r:o;const c=o?this.getKeybindingsContentFromLastSyncUserData(o):null,l=await this.getLocalFileContent(),g=await this.getFormattingOptions();let v=null,T=!1,O=!1,U=!1;if(s){let N=l?l.value.toString():"[]";if(N=N||"[]",this.hasErrors(N))throw new m.UserDataSyncError((0,w.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==N||c!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const _=await(0,y.merge)(N,s,c,g,this.userDataSyncUtilService);_.hasChanges&&(v=_.mergeContent,U=_.hasConflicts,T=U||_.mergeContent!==N,O=U||_.mergeContent!==s)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=l.value.toString(),O=!0);const x={content:v,localChange:T?l?2:1:0,remoteChange:O?2:0,hasConflicts:U};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:x.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:x.remoteChange,previewResource:this.previewResource,previewResult:x,acceptedResource:this.acceptedResource}]}async getMergeResult(r,o){return r.previewResult}async getAcceptResult(r,o,n,t){if(this.extUri.isEqual(o,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(r,o,n,t){const{fileContent:s}=n[0][0];let{content:c,localChange:l,remoteChange:g}=n[0][1];if(l===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.hasErrors(c)))throw new m.UserDataSyncError((0,w.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(c||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),g!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const v=this.toSyncContent(c||"[]",r.syncData?.content);r=await this.updateRemoteUserData(v,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(v){}o?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const o=(0,k.parse)(r.value.toString());if((0,R.isNonEmptyArray)(o))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const o=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:o}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let o=await super.resolveContent(r);if(o)return o;if(o=await super.resolveContent(this.extUri.dirname(r)),o){const n=this.parseSyncData(o);if(n)switch(this.extUri.basename(r)){case"keybindings.json":return S(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:S(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,o){let n={};try{n=JSON.parse(o||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=r,i.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=he([J(0,m.IUserDataSyncStoreService),J(1,m.IUserDataSyncBackupStoreService),J(2,m.IUserDataSyncLogService),J(3,C.IConfigurationService),J(4,m.IUserDataSyncResourceEnablementService),J(5,E.IFileService),J(6,I.IEnvironmentService),J(7,d.IStorageService),J(8,m.IUserDataSyncUtilService),J(9,p.ITelemetryService),J(10,h.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let a=class extends b.AbstractInitializer{constructor(r,o,n,t){super("keybindings",o,n,r,t)}async doInitialize(r){const o=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!o){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(o)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),o=(0,k.parse)(r.value.toString());return!(0,R.isNonEmptyArray)(o)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return S(r,!0,this.logService)}catch(o){return this.logService.error(o),null}}};a=he([J(0,E.IFileService),J(1,I.IEnvironmentService),J(2,m.IUserDataSyncLogService),J(3,h.IUriIdentityService)],a),e.KeybindingsInitializer=a}),define(te[228],ne([0,1,16,32,40,48,28,55,24]),function(X,e,R,L,D,k,i,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function C(c,l,g){let v=[];g?v=E(g):v=I(l);const T=[],O=[...(0,w.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const U of v)U.startsWith("-")?O.push(U.substring(1)):T.push(U);return(0,R.distinct)([...c,...T].filter(U=>O.indexOf(U)===-1))}e.getIgnoredSettings=C;function I(c){let l=c.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=c.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:c.getValue("settingsSync.ignoredSettings")||[]}function E(c){const l=(0,L.parse)(c);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function d(c,l,g,v){if(g.length){const T=s(l),O=(0,L.parse)(l),U=(0,L.parse)(c),x=[];for(const N of g){const _=O[N],z=U[N];_===void 0?c=P.edit(c,[N],void 0,v):z!==void 0?c=P.edit(c,[N],_,v):x.push(u(N,T))}x.sort((N,_)=>N.startOffset-_.startOffset),x.forEach(N=>c=m(N.setting.key,l,c,v))}return c}e.updateIgnoredSettings=d;function p(c,l,g,v,T,O){const U=d(c,l,v,O),x=g!==U,N=g!==l;if(!x&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(x&&!N)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(N&&!x)return{conflictsSettings:[],localContent:d(l,c,v,O),remoteContent:null,hasConflicts:!1};if(g===null&&b(c)){const H=h(c,l,v)?null:d(l,c,v,O);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let _=c,z=l;const A=(0,L.parse)(c),M=(0,L.parse)(l),q=g?(0,L.parse)(g):null,j=v.reduce((H,re)=>(H.add(re),H),new Set),W=y(A,M,j),$=y(q,A,j),K=y(q,M,j),F=new Map,B=new Set,V=H=>{B.add(H);const re=T.filter(({key:ie})=>ie===H)[0];re?(_=P.edit(_,[H],re.value,O),z=P.edit(z,[H],re.value,O)):F.set(H,{key:H,localValue:A[H],remoteValue:M[H]})};for(const H of $.removed.values())K.updated.has(H)?V(H):z=P.edit(z,[H],void 0,O);for(const H of K.removed.values())B.has(H)||($.updated.has(H)?V(H):_=P.edit(_,[H],void 0,O));for(const H of $.updated.values())B.has(H)||(K.updated.has(H)?W.updated.has(H)&&V(H):z=P.edit(z,[H],A[H],O));for(const H of K.updated.values())B.has(H)||($.updated.has(H)?W.updated.has(H)&&V(H):_=P.edit(_,[H],M[H],O));for(const H of $.added.values())B.has(H)||(K.added.has(H)?W.updated.has(H)&&V(H):z=m(H,_,z,O));for(const H of K.added.values())B.has(H)||($.added.has(H)?W.updated.has(H)&&V(H):_=m(H,z,_,O));const Q=F.size>0||!h(_,z,v),Z=Q||!h(_,c,[]),G=Q||!h(z,l,[]);return{localContent:Z?_:null,remoteContent:G?z:null,conflictsSettings:[...F.values()],hasConflicts:Q}}e.merge=p;function h(c,l,g){if(c===l)return!0;const v=(0,L.parse)(c),T=(0,L.parse)(l),O=g.reduce((N,_)=>(N.add(_),N),new Set),U=s(c).filter(N=>!(N.setting&&O.has(N.setting.key))),x=s(l).filter(N=>!(N.setting&&O.has(N.setting.key)));if(U.length!==x.length)return!1;for(let N=0;N<U.length;N++){const _=U[N],z=x[N];if(_.setting&&z.setting){if(_.setting.key!==z.setting.key||!i.equals(v[_.setting.key],T[_.setting.key]))return!1}else if(!_.setting&&!z.setting){if(_.value!==z.value)return!1}else return!1}return!0}e.areSame=h;function b(c){return c?s(c).length===0:!0}e.isEmpty=b;function y(c,l,g){const v=c?Object.keys(c).filter(N=>!g.has(N)):[],T=Object.keys(l).filter(N=>!g.has(N)),O=T.filter(N=>v.indexOf(N)===-1).reduce((N,_)=>(N.add(_),N),new Set),U=v.filter(N=>T.indexOf(N)===-1).reduce((N,_)=>(N.add(_),N),new Set),x=new Set;if(c)for(const N of v){if(U.has(N))continue;const _=c[N],z=l[N];i.equals(_,z)||x.add(N)}return{added:O,removed:U,updated:x}}function m(c,l,g,v){const T=(0,L.parse)(l),O=s(l),U=s(g),x=S(c,O,U);return f(g,c,T[c],x,U,v)}e.addSetting=m;function S(c,l,g){const v=l.findIndex(O=>O.setting?.key===c),T=l[v-1];if(T){if(T.setting){const U=u(T.setting.key,g);if(U)return{index:g.indexOf(U),insertAfter:!0}}else{const U=r(v,l);if(U){const x=u(U.setting.key,g);if(x){const N=o(g.indexOf(x),g),_=n(l,U,l[v]);if(N){const z=n(g,x,N),A=t(_,z);return A?{index:g.indexOf(A),insertAfter:!0}:{index:g.indexOf(N),insertAfter:!1}}else{const z=n(g,x,g[g.length-1]),A=t(_,z);return A?{index:g.indexOf(A),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const O=l[v+1];if(O)if(O.setting){const U=u(O.setting.key,g);if(U)return{index:g.indexOf(U),insertAfter:!1}}else{const U=o(v,l);if(U){const x=u(U.setting.key,g);if(x){const N=r(g.indexOf(x),g),_=n(l,l[v],U);if(N){const z=n(g,N,x),A=t(_.reverse(),z.reverse());return A?{index:g.indexOf(A),insertAfter:!1}:{index:g.indexOf(N),insertAfter:!0}}else{const z=n(g,g[0],x),A=t(_.reverse(),z.reverse());return A?{index:g.indexOf(A),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function f(c,l,g,v,T,O){let U;return v.index===-1?U=(0,D.setProperty)(c,[l],g,O):U=a(c,l,g,v,T,O).map(x=>(0,D.withFormatting)(c,x,O)[0]),(0,D.applyEdits)(c,U)}function a(c,l,g,v,T,O){const U=`${JSON.stringify(l)}: ${JSON.stringify(g)}`,x=(0,k.getEOL)(O,c),N=T[v.index];if(v.insertAfter){const _=[];if(N.setting)_.push({offset:N.endOffset,length:0,content:","+U});else{const z=o(v.index,T),A=r(v.index,T),M=A?.setting?.commaOffset;A&&M===void 0&&_.push({offset:A.endOffset,length:0,content:","});const q=M!==void 0&&M>N.endOffset;_.push({offset:q?M+1:N.endOffset,length:0,content:z?x+U+",":x+U})}return _}else{if(N.setting)return[{offset:N.startOffset,length:0,content:U+","}];const _=(T[v.index-1]&&!T[v.index-1].setting?x:"")+U+(o(v.index,T)?",":"")+x;return[{offset:N.startOffset,length:0,content:_}]}}function u(c,l){return l.filter(g=>g.setting?.key===c)[0]}function r(c,l){for(let g=c-1;g>=0;g--)if(l[g].setting)return l[g]}function o(c,l){for(let g=c+1;g<l.length;g++)if(l[g].setting)return l[g]}function n(c,l,g){const v=c.indexOf(l),T=c.indexOf(g);return c.filter((O,U)=>v<U&&U<T)}function t(c,l){if(c.length&&l.length){let g=0;for(;g<l.length&&g<c.length;g++)if(c[g].value!==l[g].value)return l[g-1];return l[g-1]}}function s(c){const l=[];let g=-1,v,T;const O={onObjectBegin:U=>{g++},onObjectProperty:(U,x,N)=>{g===0&&(v=x,T=U)},onObjectEnd:(U,x)=>{g--,g===0&&l.push({startOffset:v,endOffset:U+x,value:c.substring(v,U+x),setting:{key:T,commaOffset:void 0}})},onArrayBegin:(U,x)=>{g++},onArrayEnd:(U,x)=>{g--,g===0&&l.push({startOffset:v,endOffset:U+x,value:c.substring(v,U+x),setting:{key:T,commaOffset:void 0}})},onLiteralValue:(U,x,N)=>{g===0&&l.push({startOffset:v,endOffset:x+N,value:c.substring(v,x+N),setting:{key:T,commaOffset:void 0}})},onSeparator:(U,x,N)=>{if(g===0&&U===","){let _=l.length-1;for(;_>=0&&!l[_].setting;_--);const z=l[_];z&&l.splice(_,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:x}})}},onComment:(U,x)=>{g===0&&l.push({startOffset:U,endOffset:U+x,value:c.substring(U,U+x)})}};return(0,L.visit)(c,O),l}}),define(te[229],ne([0,1,19,3,40,148,21,90,86,11,30,14,23,22,37,47,55,228,24]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function a(n){const t=JSON.parse(n);return f(t)?t:{settings:n}}e.parseSettingsSyncContent=a;let u=class extends b.AbstractJsonFileSynchroniser{constructor(t,s,c,l,g,v,T,O,U,x,N,_,z){super(s.settingsResource,"settings",t,s,c,l,g,U,x,v,T,O,z);this.extensionManagementService=N,this.userConfigurationFileService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const s=await this.getLastSyncUserData(),c=await this.getLatestRemoteUserData(t,s),l=this.getSettingsSyncContent(c),g=new P.ConfigurationModelParser(S.USER_DATA_SYNC_CONFIGURATION_SCOPE);return l?.settings&&g.parse(l.settings),g.configurationModel.getValue(S.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,s,c){const l=await this.getLocalFileContent(),g=await this.getFormattingOptions(),v=this.getSettingsSyncContent(t);s=s===null&&c?t:s;const T=s?this.getSettingsSyncContent(s):null,O=await this.getIgnoredSettings();let U=null,x=!1,N=!1,_=!1;if(v){let A=l?l.value.toString().trim():"{}";A=A||"{}",this.validateContent(A),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,m.merge)(A,v.settings,T?T.settings:null,O,[],g);U=M.localContent||M.remoteContent,x=M.localContent!==null,N=M.remoteContent!==null,_=M.hasConflicts}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),U=l.value.toString(),N=!0);const z={content:U,localChange:x?2:0,remoteChange:N?2:0,hasConflicts:_};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:z.localChange,remoteResource:this.remoteResource,remoteContent:v?v.settings:null,remoteChange:z.remoteChange,previewResource:this.previewResource,previewResult:z,acceptedResource:this.acceptedResource}]}async getMergeResult(t,s){const c=await this.getFormattingOptions(),l=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,m.updateIgnoredSettings)(t.previewResult.content,"{}",l,c):null}}async getAcceptResult(t,s,c,l){const g=await this.getFormattingOptions(),v=await this.getIgnoredSettings();if(this.extUri.isEqual(s,this.localResource))return{content:t.fileContent?(0,m.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",v,g):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,m.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",v,g):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return c===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:c!==null?(0,m.updateIgnoredSettings)(c,t.fileContent?t.fileContent.value.toString():"{}",v,g):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(t,s,c,l){const{fileContent:g}=c[0][0];let{content:v,localChange:T,remoteChange:O}=c[0][1];if(T===0&&O===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),v=v?v.trim():"{}",v=v||"{}",this.validateContent(v),T!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),g&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(g.value.toString()))),await this.updateLocalFileContent(v,g,l),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),O!==0){const U=await this.getFormattingOptions(),x=this.getSettingsSyncContent(t),N=await this.getIgnoredSettings(v);v=(0,m.updateIgnoredSettings)(v,x?x.settings:"{}",N,U),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(v)),l?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(U){}s?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const s=await this.getFormattingOptions(),c=(0,y.edit)(t.value.toString(),[S.CONFIGURATION_SYNC_STORE_KEY],void 0,s);return!(0,m.isEmpty)(c)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:s}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let s=await super.resolveContent(t);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(t)),s){const c=this.parseSyncData(s);if(c){const l=this.parseSettingsSyncContent(c.content);if(l)switch(this.extUri.basename(t)){case"settings.json":return l.settings}}}return null}async resolvePreviewContent(t){let s=await super.resolvePreviewContent(t);if(s){const c=await this.getFormattingOptions(),l=await this.getIgnoredSettings();s=(0,m.updateIgnoredSettings)(s,"{}",l,c)}return s}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return a(t)}catch(s){this.logService.error(s)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const c=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,l=>l.some(({local:g})=>!!g)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,l=>!l.error))(()=>{c.dispose(),this._defaultIgnoredSettings=void 0})}const s=await this._defaultIgnoredSettings;return(0,m.getIgnoredSettings)(s,this.configurationService,t)}async writeFileContent(t,s,c){await this.userConfigurationFileService.write(R.VSBuffer.fromString(t),c?void 0:{etag:s.etag,mtime:s.mtime})}validateContent(t){if(this.hasErrors(t))throw new S.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const s=JSON.parse(t.value.toString());if(!o(s))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const c=this.parseSettingsSyncContent(s.content);if(!c||!c.settings)return;let l=c.settings;const g=await this.getFormattingOptions();for(const v in s)if(["version","content","machineId"].indexOf(v)===-1&&s[v]!==void 0){const T=(0,D.setProperty)(l,[v],s[v],g);T.length&&(l=(0,D.applyEdits)(l,T))}await this.fileService.writeFile(this.file,R.VSBuffer.fromString(l))}catch(t){}}};u=he([J(0,E.IFileService),J(1,C.IEnvironmentService),J(2,d.IStorageService),J(3,S.IUserDataSyncStoreService),J(4,S.IUserDataSyncBackupStoreService),J(5,S.IUserDataSyncLogService),J(6,S.IUserDataSyncUtilService),J(7,i.IConfigurationService),J(8,S.IUserDataSyncResourceEnablementService),J(9,p.ITelemetryService),J(10,I.IExtensionManagementService),J(11,w.IUserConfigurationFileService),J(12,h.IUriIdentityService)],u),e.SettingsSynchroniser=u;let r=class extends b.AbstractInitializer{constructor(t,s,c,l){super("settings",s,c,t,l)}async doInitialize(t){const s=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!s){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,R.VSBuffer.fromString(s.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,m.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return a(t)}catch(s){this.logService.error(s)}return null}};r=he([J(0,E.IFileService),J(1,C.IEnvironmentService),J(2,S.IUserDataSyncLogService),J(3,h.IUriIdentityService)],r),e.SettingsInitializer=r;function o(n){return!!(n&&n.version!==void 0&&typeof n.version=="number"&&n.content!==void 0&&typeof n.content=="string"&&n.machineId!==void 0&&typeof n.machineId=="string")}}),define(te[230],ne([0,1,19,3,28,21,11,14,23,22,37,47,223,24]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends E.AbstractSynchroniser{constructor(m,S,f,a,u,r,o,n,t,s){super("snippets",S,m,f,a,u,n,t,r,o,s);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,c=>c.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,S,f){const a=await this.getSnippetsFileContents(),u=this.toSnippetsContents(a),r=m.syncData?this.parseSnippets(m.syncData):null;S=S===null&&f?m:S;const o=S&&S.syncData?this.parseSnippets(S.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,d.merge)(u,r,o);return this.getResourcePreviews(n,a,r||{})}async getMergeResult(m,S){return m.previewResult}async getAcceptResult(m,S,f,a){if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder))return f===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:f,localChange:f===null?m.fileContent!==null?3:0:2,remoteChange:f===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${S.toString()}`)}async applyResult(m,S,f,a){const u=f.map(([r,o])=>({...r,acceptResult:o}));u.every(({localChange:r,remoteChange:o})=>r===0&&o===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),u.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(u),await this.updateLocalSnippets(u,a)),u.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(u,m,a)),S?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of u)try{await this.fileService.del(r)}catch(o){}}getResourcePreviews(m,S,f){const a=new Map;for(const u of Object.keys(m.local.added)){const r={content:m.local.added[u],hasConflicts:!1,localChange:1,remoteChange:0};a.set(u,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(m.local.updated)){const r={content:m.local.updated[u],hasConflicts:!1,localChange:2,remoteChange:0};a.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of m.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};a.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(m.remote.added)){const r={content:m.remote.added[u],hasConflicts:!1,localChange:0,remoteChange:1};a.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(m.remote.updated)){const r={content:m.remote.updated[u],hasConflicts:!1,localChange:0,remoteChange:2};a.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of m.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};a.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of m.conflicts){const r={content:S[u]?S[u].value.toString():null,hasConflicts:!0,localChange:S[u]?2:1,remoteChange:f[u]?2:1};a.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u]||null,localContent:S[u]?S[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(S))if(!a.has(u)){const r={content:S[u]?S[u].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};a.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u]||null,localContent:S[u]?S[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...a.values()]}async getAssociatedResources({uri:m}){let S=await super.resolveContent(m);if(S){const f=this.parseSyncData(S);if(f){const a=this.parseSnippets(f),u=[];for(const r of Object.keys(a)){const o=this.extUri.joinPath(m,r),n=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(n);u.push({resource:o,comparableResource:t?n:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return u}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let S=await super.resolveContent(m);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(m)),S){const f=this.parseSyncData(S);if(f)return this.parseSnippets(f)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch(m){}return!1}async updateLocalBackup(m){const S={};for(const f of m)f.fileContent&&(S[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(S)))}async updateLocalSnippets(m,S){for(const{fileContent:f,acceptResult:a,localResource:u,remoteResource:r,localChange:o}of m)if(o!==0){const n=r?this.extUri.basename(r):this.extUri.basename(u),t=this.extUri.joinPath(this.snippetsFolder,n);o===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):o===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,R.VSBuffer.fromString(a.content),{overwrite:S}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,R.VSBuffer.fromString(a.content),S?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,S,f){const a=S.syncData?this.parseSnippets(S.syncData):{},u=(0,D.deepClone)(a);for(const{acceptResult:r,localResource:o,remoteResource:n,remoteChange:t}of m)if(t!==0){const s=o?this.extUri.basename(o):this.extUri.basename(n);t===3?delete u[s]:u[s]=r.content}return(0,d.areSame)(a,u)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),S=await this.updateRemoteUserData(JSON.stringify(u),f?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),S}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const S={};for(const f of Object.keys(m))S[f]=m[f].value.toString();return S}async getSnippetsFileContents(){const m={};let S;try{S=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof P.FileOperationError&&f.fileOperationResult===1)return m;throw f}for(const f of S.children||[]){const a=f.resource,u=this.extUri.extname(a);if(u===".json"||u===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,a),o=await this.fileService.readFile(a);m[r]=o}}return m}};h=he([J(0,i.IEnvironmentService),J(1,P.IFileService),J(2,w.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncBackupStoreService),J(5,p.IUserDataSyncLogService),J(6,k.IConfigurationService),J(7,p.IUserDataSyncResourceEnablementService),J(8,C.ITelemetryService),J(9,I.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let b=class extends E.AbstractInitializer{constructor(m,S,f,a){super("snippets",S,f,m,a)}async doInitialize(m){const S=m.syncData?JSON.parse(m.syncData.content):null;if(!S){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const a of Object.keys(S)){const u=S[a];if(u){const r=this.extUri.joinPath(this.environmentService.snippetsHome,a);await this.fileService.createFile(r,R.VSBuffer.fromString(u)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};b=he([J(0,P.IFileService),J(1,i.IEnvironmentService),J(2,p.IUserDataSyncLogService),J(3,I.IUriIdentityService)],b),e.SnippetsInitializer=b}),define(te[64],ne([0,1,3,2,6,24]),function(X,e,R,L,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let i=class extends L.Disposable{constructor(w,C){super();this.userDataSyncStoreService=w,this.logService=C,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(w.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(w.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(w){(w&&this._account?w.token!==this._account.token||w.authenticationProviderId!==this._account.authenticationProviderId:w!==this._account)&&(this._account=w,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(w))}};i=he([J(0,k.IUserDataSyncStoreService),J(1,k.IUserDataSyncLogService)],i),e.UserDataSyncAccountService=i}),define(te[231],ne([0,1,5,19,58,2,18,21,11,14,24]),function(X,e,R,L,D,k,i,P,w,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends k.Disposable{constructor(p,h,b,y){super();this.environmentService=p,this.fileService=h,this.configurationService=b,this.logService=y,I.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(p){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,p),b=await this.fileService.resolve(h);return b.children?b.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(p,h){if(!h){const b=await this.getAllRefs(p);b.length&&(h=b[b.length-1].ref)}if(h){const b=(0,i.joinPath)(this.environmentService.userDataSyncHome,p,h);return(await this.fileService.readFile(b)).value.toString()}return null}async backup(p,h){const b=(0,i.joinPath)(this.environmentService.userDataSyncHome,p),y=(0,i.joinPath)(b,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(y,L.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(p)}catch(m){}}async cleanUpBackup(p){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(h))return}catch(y){return}const b=await this.fileService.resolve(h);if(b.children){const y=b.children.filter(a=>a.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(a.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let S=y.filter(a=>Date.now()-this.getCreationTime(a)>m);const f=y.length-S.length;f<10&&(S=S.slice(10-f)),await R.Promises.settled(S.map(async a=>{this.logService.info("Deleting from backup",a.resource.path),await this.fileService.del(a.resource)}))}}catch(b){this.logService.error(b)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};E=he([J(0,w.IEnvironmentService),J(1,C.IFileService),J(2,P.IConfigurationService),J(3,I.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(te[232],ne([0,1,2,9]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(d){this.service=d}listen(d,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class k{constructor(d){this.service=d}listen(d,p){throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class i{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=i;class P{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class w{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=w;class C{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=C;class I extends R.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:L.URI.revive(d.url),type:d.type,defaultUrl:L.URI.revive(d.defaultUrl),insidersUrl:L.URI.revive(d.insidersUrl),stableUrl:L.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(te[233],ne([0,1,11,7]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends L.AbstractLogger{constructor(i,P){super();this.logger=this._register(i.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(i,...P){this.logger.trace(i,...P)}debug(i,...P){this.logger.debug(i,...P)}info(i,...P){this.logger.info(i,...P)}warn(i,...P){this.logger.warn(i,...P)}error(i,...P){this.logger.error(i,...P)}critical(i,...P){this.logger.critical(i,...P)}flush(){this.logger.flush()}};D=he([J(0,L.ILoggerService),J(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(te[65],ne([0,1,3,2,4,25,151,11,14,6,26,46,23,24]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,C.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let b=class tt extends L.Disposable{constructor(m,S,f,a,u,r){super();this.storageService=f,this.userDataSyncStoreService=a,this.logService=u,this.productService=r,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(m,S,f)}async getMachines(m){const S=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(a=>({...a,isCurrent:a.id===S}))}async addCurrentMachine(m){const S=await this.currentMachineIdPromise,f=await this.readMachinesData(m);f.machines.some(({id:a})=>a===S)||(f.machines.push({id:S,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(m){const S=await this.currentMachineIdPromise,f=await this.readMachinesData(m),a=f.machines.filter(({id:u})=>u!==S);a.length!==f.machines.length&&(f.machines=a,await this.writeMachinesData(f))}async renameMachine(m,S,f){const a=await this.currentMachineIdPromise,u=await this.readMachinesData(f),r=u.machines.find(({id:o})=>o===m);r&&(r.name=S,await this.writeMachinesData(u),u.machines.some(({id:o})=>o===a)&&this.storageService.store(h,S,0,1))}async setEnablement(m,S){const f=await this.readMachinesData(),a=f.machines.find(({id:u})=>u===m);a&&(a.disabled=S?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(m){const S=this.storageService.get(h,0);if(S)return S;const f=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,a=new RegExp(`${(0,k.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let u=0;for(const r of m){const o=a.exec(r.name),n=o?parseInt(o[1]):0;u=n>u?n:u}return`${f} #${u+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const S=this.parse(this.userData);if(S.version!==tt.VERSION)throw new Error((0,i.localize)(0,null,this.productService.nameLong));return S}async writeMachinesData(m){const S=JSON.stringify(m),f=await this.userDataSyncStoreService.write(tt.RESOURCE,S,this.userData?.ref||null);this.userData={ref:f,content:S},this._onDidChange.fire()}async readUserData(m){if(this.userData){const S=m&&m.latest?m.latest[tt.RESOURCE]:void 0;if(this.userData.ref===S)return this.userData;if(S===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(tt.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(S){this.logService.error(S)}return{version:tt.VERSION,machines:[]}}};b.VERSION=1,b.RESOURCE="machines",b=he([J(0,P.IEnvironmentService),J(1,w.IFileService),J(2,d.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncLogService),J(5,I.IProductService)],b),e.UserDataSyncMachinesService=b}),define(te[101],ne([0,1,5,58,38,8,3,2,4,18,9,149,11,26,23,22,24,64,65]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const f="sync.enable",a="sync.disableMachineEventually",u="sync.sessionId",r="sync.storeUrl",o="sync.productQuality";let n=class extends P.Disposable{constructor(l,g,v){super();this.storageService=l,this.environmentService=g,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new i.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(T=>this.onDidStorageChange(T)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(f,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(f,l,0,1)}onDidStorageChange(l){if(l.scope===0&&f===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};n=he([J(0,h.IStorageService),J(1,d.IEnvironmentService),J(2,y.IUserDataSyncStoreManagementService)],n),e.UserDataAutoSyncEnablementService=n;let t=class extends P.Disposable{constructor(l,g,v,T,O,U,x,N,_,z,A){super();this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=v,this.userDataSyncResourceEnablementService=T,this.userDataSyncService=O,this.logService=U,this.userDataSyncAccountService=x,this.telemetryService=N,this.userDataSyncMachinesService=_,this.storageService=z,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=A,this.syncTriggerDelayer=this._register(new R.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(g.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,g.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(x.onDidChangeAccount(()=>this.updateAutoSync())),this._register(v.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(i.Event.debounce(O.onDidChangeLocal,(M,q)=>M?[...M,q]:[q],1e3)(M=>this.triggerSync(M,!1,!1))),this._register(i.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(r,0);return l?I.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(r,l.toString(),0,1):this.storageService.remove(r,0)}get productQuality(){return this.storageService.get(o,0)}set productQuality(l){l?this.storageService.store(o,l,0,1):this.storageService.remove(o,0)}updateAutoSync(){const{enabled:l,message:g}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(v=>this.onDidFinishSync(v))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(g&&this.logService.info(g),this.autoSync.clear()):g&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(g))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,g,v){try{this.userDataSyncAccountService.account&&!v&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(u,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(T){if(g)this.logService.error(T),this.updateEnablement(!1);else throw T}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(f,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const g=y.UserDataSyncError.toUserDataSyncError(l);g instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:g.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),g.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):g.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):g.code==="LocalTooManyRequests"||g.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):g.code==="UpgradeRequired"||g.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):g.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with newer version than of client. Requires client upgrade.`)):g.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with older version than of client. Requires server reset.`)):g.code==="ServiceChanged"||g.code==="DefaultServiceChanged"?w.isWeb&&g.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(g),this.successiveFailures++),this._onError.fire(g)}async disableMachineEventually(){this.storageService.store(a,!0,0,1),await(0,R.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(a,0,!1)}stopDisableMachineEventually(){this.storageService.remove(a,0)}async triggerSync(l,g,v){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(g&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",v)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};t=he([J(0,p.IProductService),J(1,y.IUserDataSyncStoreManagementService),J(2,y.IUserDataSyncStoreService),J(3,y.IUserDataSyncResourceEnablementService),J(4,y.IUserDataSyncService),J(5,y.IUserDataSyncLogService),J(6,m.IUserDataSyncAccountService),J(7,b.ITelemetryService),J(8,S.IUserDataSyncMachinesService),J(9,h.IStorageService),J(10,y.IUserDataAutoSyncEnablementService)],t),e.UserDataAutoSyncService=t;class s extends P.Disposable{constructor(l,g,v,T,O,U,x,N){super();this.lastSyncUrl=l,this.interval=g,this.userDataSyncStoreManagementService=v,this.userDataSyncStoreService=T,this.userDataSyncService=O,this.userDataSyncMachinesService=U,this.logService=x,this.storageService=N,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new i.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new i.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(l,g){const v=(0,R.createCancelablePromise)(async T=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,k.isPromiseCanceledError)(O))return}return this.doSync(l,g,T)});return this.syncPromise=v,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),g=this.userDataSyncStoreManagementService.userDataSyncStore;return!!g&&!!l&&(!(0,C.isEqual)(g.defaultUrl,l.defaultUrl)||!(0,C.isEqual)(g.insidersUrl,l.insidersUrl)||!(0,C.isEqual)(g.stableUrl,l.stableUrl))}async doSync(l,g,v){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let T;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,g),v.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const O=this.storageService.get(u,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const U=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(v.isCancellationRequested)return;const x=U.find(N=>N.isCurrent);if(x?.disabled)throw new y.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(N){throw new y.UserDataAutoSyncError((0,D.toErrorMessage)(N),N instanceof y.UserDataSyncError?N.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(u,this.manifest.session,0,1),v.isCancellationRequested)return;x||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),T=O}this._onDidFinishSync.fire(T)}register(l){return super._register(l)}}s.INTERVAL_SYNCING="Interval"}),define(te[234],ne([0,1,3,2,4,23,22,24]),function(X,e,R,L,D,k,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let w=class extends L.Disposable{constructor(I,E){super();this.storageService=I,this.telemetryService=E,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(I.onDidChangeValue(d=>this.onDidStorageChange(d)))}isResourceEnabled(I){return this.storageService.getBoolean((0,P.getEnablementKey)(I),0,!0)}setResourceEnablement(I,E){if(this.isResourceEnabled(I)!==E){const d=(0,P.getEnablementKey)(I);this.telemetryService.publicLog2(d,{enabled:E}),this.storeResourceEnablement(d,E)}}getResourceSyncStateVersion(I){}storeResourceEnablement(I,E){this.storageService.store(I,E,0,D.isWeb?0:1)}onDidStorageChange(I){if(I.scope===0){const E=P.ALL_SYNC_RESOURCES.filter(d=>(0,P.getEnablementKey)(d)===I.key)[0];if(E){this._onDidChangeResourceEnablement.fire([E,this.isResourceEnabled(E)]);return}}}};w=he([J(0,k.IStorageService),J(1,i.ITelemetryService)],w),e.UserDataSyncResourceEnablementService=w}),define(te[235],ne([0,1,16,5,38,8,3,2,18,29,21,6,23,22,224,226,227,229,230,24]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const a="sync.lastSyncTime";let u=class extends P.Disposable{constructor(t,s,c,l,g,v,T){super();this.userDataSyncStoreService=t,this.userDataSyncStoreManagementService=s,this.instantiationService=c,this.configurationService=l,this.logService=g,this.telemetryService=v,this.storageService=T,this._status="uninitialized",this._onDidChangeStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new i.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new i.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new i.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new i.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(m.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(y.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(S.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(b.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(a,0,void 0),this.onDidChangeLocal=i.Event.any(...this.synchronisers.map(O=>i.Event.map(O.onDidChangeLocal,()=>O.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(t,s){await this.checkEnablement();const c=(0,C.generateUuid)();try{const T=(0,f.createSyncHeaders)(c);s&&(T["Cache-Control"]="no-cache"),t=await this.userDataSyncStoreService.manifest(t,T)}catch(T){const O=f.UserDataSyncError.toUserDataSyncError(T);throw this.reportUserDataSyncError(O,c),O}let l=!1;const g=this;let v;return{manifest:t,run(){if(l)throw new Error("Can run a task only once");return v=(0,L.createCancelablePromise)(T=>g.sync(t,c,T)),v.finally(()=>v=void 0)},async stop(){if(v&&v.cancel(),g.status!=="idle")return g.stop()}}}async createManualSyncTask(){await this.checkEnablement();const t=(0,C.generateUuid)(),s=(0,f.createSyncHeaders)(t);let c;try{c=await this.userDataSyncStoreService.manifest(null,s)}catch(l){const g=f.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(g,t),g}return new r(t,c,s,this.synchronisers,this.configurationService,this.logService)}async sync(t,s,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),c.isCancellationRequested)return;const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const g=(0,f.createSyncHeaders)(s);for(const v of this.synchronisers){if(c.isCancellationRequested)return;try{await v.sync(t,g)}catch(T){let O=!1;if(T instanceof f.UserDataSyncError)switch(T.code){case"TooLarge":T=new f.UserDataSyncError(T.message,T.code,v.resource),O=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":O=!0;break}const U=f.UserDataSyncError.toUserDataSyncError(T);if(this.reportUserDataSyncError(U,s),O)throw U;this.logService.error(T),this.logService.error(`${v.resource}: ${(0,D.toErrorMessage)(T)}`),this._syncErrors.push([v.resource,U])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(g){const v=f.UserDataSyncError.toUserDataSyncError(g);throw this.reportUserDataSyncError(v,s),v}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const t of this.synchronisers)try{t.status!=="idle"&&await t.stop()}catch(s){this.logService.error(s)}}async replace(t){await this.checkEnablement();for(const s of this.synchronisers)if(await s.replace(t))return}async accept(t,s,c,l){await this.checkEnablement();const g=this.getSynchroniser(t);await g.accept(s,c),l&&await g.apply(!1,(0,f.createSyncHeaders)((0,C.generateUuid)()))}async resolveContent(t){for(const s of this.synchronisers){const c=await s.resolveContent(t);if(c)return c}return null}getRemoteSyncResourceHandles(t){return this.getSynchroniser(t).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(t){return this.getSynchroniser(t).getLocalSyncResourceHandles()}getAssociatedResources(t,s){return this.getSynchroniser(t).getAssociatedResources(s)}getMachineId(t,s){return this.getSynchroniser(t).getMachineId(s)}async hasLocalData(){const t=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const s of t)if(await s.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(t){this.logService.error(t)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(a,0);for(const t of this.synchronisers)try{await t.resetLocal()}catch(s){this.logService.error(`${t.resource}: ${(0,D.toErrorMessage)(s)}`),this.logService.error(s)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const t of this.synchronisers)if(await t.hasPreviouslySynced())return!0;return!1}setStatus(t){const s=this._status;this._status!==t&&(this._status=t,this._onDidChangeStatus.fire(t),s==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const t=this.computeStatus();this.setStatus(t)}updateConflicts(){const t=this.computeConflicts();(0,R.equals)(this._conflicts,t,([s,c],[l,g])=>s===s&&(0,R.equals)(c,g,(v,T)=>(0,w.isEqual)(v.previewResource,T.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(t))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(a,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(t,s){this.telemetryService.publicLog2("sync/error",{code:t.code,serverCode:t instanceof f.UserDataSyncStoreError?String(t.serverCode):void 0,url:t instanceof f.UserDataSyncStoreError?t.url:void 0,resource:t.resource,executionId:s,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(t=>t.status==="hasConflicts").map(t=>[t.resource,t.conflicts.map(o)])}getSynchroniser(t){return this.synchronisers.find(s=>s.resource===t)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};u=he([J(0,f.IUserDataSyncStoreService),J(1,f.IUserDataSyncStoreManagementService),J(2,E.IInstantiationService),J(3,I.IConfigurationService),J(4,f.IUserDataSyncLogService),J(5,p.ITelemetryService),J(6,d.IStorageService)],u),e.UserDataSyncService=u;class r extends P.Disposable{constructor(t,s,c,l,g,v){super();this.id=t,this.manifest=s,this.syncHeaders=c,this.synchronisers=l,this.configurationService=g,this.logService=v,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new i.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(t=>this.getPreviews(t))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(t){throw this.logService.error(t),t}}async accept(t,s){try{return await this.performAction(t,c=>c.accept(t,s))}catch(c){throw this.logService.error(c),c}}async merge(t){try{return t?await this.performAction(t,s=>s.merge(t)):await this.mergeAll()}catch(s){throw this.logService.error(s),s}}async discard(t){try{return await this.performAction(t,s=>s.discard(t))}catch(s){throw this.logService.error(s),s}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const t=[];for(const[,s]of this.previews)for(const c of s.resourcePreviews)c.mergeState==="conflict"&&t.push(c.previewResource);for(const s of t)await this.discard(s);return this.previews}catch(t){throw this.logService.error(t),t}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const t=[];for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(v=>v.resource===s);for(const v of c.resourcePreviews)(v.localChange!==0||v.remoteChange!==0)&&v.mergeState==="preview"&&await l.merge(v.previewResource);const g=await l.apply(!1,this.syncHeaders);g&&t.push(this.toSyncResourcePreview(l.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}catch(t){throw this.logService.error(t),t}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,s]of this.previews){this.synchronizingResources.push([t,s.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===t);for(const l of s.resourcePreviews)await c.accept(l.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,s]of this.previews){this.synchronizingResources.push([t,s.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===t);for(const l of s.resourcePreviews)await c.accept(l.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async stop(){for(const t of this.synchronisers)try{await t.stop()}catch(s){(0,k.isPromiseCanceledError)(s)||this.logService.error(s)}this.reset()}async performAction(t,s){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,N])=>N.resourcePreviews.some(({localResource:_,previewResource:z,remoteResource:A})=>(0,w.isEqual)(t,_)||(0,w.isEqual)(t,z)||(0,w.isEqual)(t,A)));if(c===-1)return this.previews;const[l,g]=this.previews[c],v=g.resourcePreviews.find(({localResource:N,remoteResource:_,previewResource:z})=>(0,w.isEqual)(N,t)||(0,w.isEqual)(_,t)||(0,w.isEqual)(z,t));if(!v)return this.previews;let T=this.synchronizingResources.find(N=>N[0]===l);T||(T=[l,[]],this.synchronizingResources.push(T)),T[1].some(N=>(0,w.isEqual)(N,v.localResource))||(T[1].push(v.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const O=this.synchronisers.find(N=>N.resource===this.previews[c][0]),U=await s(O);U?this.previews.splice(c,1,this.toSyncResourcePreview(O.resource,U)):this.previews.splice(c,1);const x=this.synchronizingResources.findIndex(N=>N[0]===l);return this.synchronizingResources[x][1].splice(T[1].findIndex(N=>(0,w.isEqual)(N,v.localResource)),1),T[1].length||(this.synchronizingResources.splice(x,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const t=[];for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(v=>v.resource===s);let g=c;for(const v of c.resourcePreviews)(v.localChange!==0||v.remoteChange!==0)&&v.mergeState==="preview"&&(g=await l.merge(v.previewResource));g&&t.push(this.toSyncResourcePreview(l.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}async getPreviews(t){const s=[],c=await this.getUserDataSyncConfiguration();for(const l of this.synchronisers){if(t.isCancellationRequested)return[];const g=await l.preview(this.manifest,c,this.syncHeaders);g&&s.push(this.toSyncResourcePreview(l.resource,g))}return s}async getUserDataSyncConfiguration(){const t=this.configurationService.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE),s=await this.synchronisers.find(c=>c instanceof m.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...t,...s}}toSyncResourcePreview(t,s){return[t,{isLastSyncFromCurrentMachine:s.isLastSyncFromCurrentMachine,resourcePreviews:s.resourcePreviews.map(o)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function o(n){return{localResource:n.localResource,previewResource:n.previewResource,remoteResource:n.remoteResource,acceptedResource:n.acceptedResource,localChange:n.localChange,remoteChange:n.remoteChange,mergeState:n.mergeState}}}),define(te[236],ne([0,1,3,2,17,9,24]),function(X,e,R,L,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(E,d){this.service=E,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(E,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(E,d,p){try{return await this._call(E,d,p)}catch(h){throw this.logService.error(h),h}}async _call(E,d,p){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],k.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:k.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:k.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring("manualSync/".length),b=p[0],y=this.getManualSyncTask(b);switch(p=p.slice(1),h){case"preview":return y.preview();case"accept":return y.accept(k.URI.revive(p[0]),p[1]);case"merge":return y.merge(k.URI.revive(p[0]));case"discard":return y.discard(k.URI.revive(p[0]));case"discardConflicts":return y.discardConflicts();case"apply":return y.apply();case"pull":return y.pull();case"push":return y.push();case"stop":return y.stop();case"_getStatus":return y.status;case"dispose":return this.disposeManualSyncTask(y)}}throw new Error("Invalid call")}getManualSyncTask(E){const d=this.manualSyncTasks.get(this.createKey(E));if(!d)throw new Error(`Manual sync taks not found: ${E}`);return d.manualSyncTask}async createManualSyncTask(){const E=new L.DisposableStore,d=E.add(await this.service.createManualSyncTask());return E.add(d.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:p}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:E}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(E){E.dispose();const d=this.createKey(E.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=P;class w extends L.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,p,h){return E.call(d,p,h).then(null,b=>{throw i.UserDataSyncError.toUserDataSyncError(b)})},listen(d,p){return E.listen(d,p)}},this.channel.call("_getInitialData").then(([d,p,h])=>{this.updateStatus(d),this.updateConflicts(p),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(b=>this.updateStatus(b))),this._register(this.channel.listen("onDidChangeLastSyncTime")(b=>this.updateLastSyncTime(b)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([p,h])=>[p,i.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:d,status:p}=await this.channel.call("createManualSyncTask"),h=this,b=new C(E,d,p,{async call(y,m,S){return h.channel.call(`manualSync/${y}`,[E,...(0,D.isArray)(m)?m:[m]],S)},listen(y,m){return R.Event.map(R.Event.filter(h.channel.listen(`manualSync/${y}`,m),S=>!b.isDiposed()&&S.manualSyncTaskId===E),S=>S.data)}});return b}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,d,p,h){return this.channel.call("accept",[E,d,p,h])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:k.URI.revive(h)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:k.URI.revive(h)}))}async getAssociatedResources(E,d){return(await this.channel.call("getAssociatedResources",[E,d])).map(({resource:h,comparableResource:b})=>({resource:k.URI.revive(h),comparableResource:k.URI.revive(b)}))}async getMachineId(E,d){return this.channel.call("getMachineId",[E,d])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([d,p])=>[d,p.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=w;class C extends L.Disposable{constructor(E,d,p,h){super();this.id=E,this.manifest=d,this._disposed=!1,this._status=p;const b=this;this.channel={async call(y,m,S){try{const f=await h.call(y,m,S);return b.isDiposed()||(b._status=await h.call("_getStatus")),f}catch(f){throw i.UserDataSyncError.toUserDataSyncError(f)}},listen(y,m){return h.listen(y,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,d){const p=await this.channel.call("accept",[E,d]);return this.deserializePreviews(p)}async merge(E){const d=await this.channel.call("merge",[E]);return this.deserializePreviews(d)}async discard(E){const d=await this.channel.call("discard",[E]);return this.deserializePreviews(d)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([d,p])=>[d,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(h=>({...h,localResource:k.URI.revive(h.localResource),remoteResource:k.URI.revive(h.remoteResource),previewResource:k.URI.revive(h.previewResource),acceptedResource:k.URI.revive(h.acceptedResource)}))}])}}}),define(te[237],ne([0,1,5,27,8,3,2,110,4,18,17,9,29,21,11,14,26,44,46,23,24]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",r="sync.donot-make-requests-until",o="sync.user-session-id",n="sync.machine-session-id",t=100,s=1e3*60*5;let c=class extends i.Disposable{constructor(U,x,N){super();this.productService=U,this.configurationService=x,this.storageService=N,this._onDidChangeUserDataSyncStore=this._register(new k.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(k.Event.filter(N.onDidChangeValue,_=>_.key===a.SYNC_SERVICE_URL_TYPE&&_.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(a.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(U){this.storageService.store(a.SYNC_SERVICE_URL_TYPE,U,0,w.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[a.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(a.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(U,x){U=w.isWeb&&U?.web?{...U,...U.web}:U;const N={...U||{},...x||{}};if(N&&(0,I.isString)(N.url)&&(0,I.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(_=>(0,I.isArray)(N.authenticationProviders[_].scopes))){const _=N,z=!!_.canSwitch&&!x?.url,A=_.url===_.insidersUrl?"insiders":"stable",M=(z?this.userDataSyncStoreType:void 0)||A,q=x?.url||(M==="insiders"?_.insidersUrl:M==="stable"?_.stableUrl:_.url);return{url:E.URI.parse(q),type:M,defaultType:A,defaultUrl:E.URI.parse(_.url),stableUrl:E.URI.parse(_.stableUrl),insidersUrl:E.URI.parse(_.insidersUrl),canSwitch:z,authenticationProviders:Object.keys(_.authenticationProviders).reduce((j,W)=>(j.push({id:W,scopes:_.authenticationProviders[W].scopes}),j),[])}}}};c=he([J(0,y.IProductService),J(1,p.IConfigurationService),J(2,f.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let l=class extends c{constructor(U,x,N){super(U,x,N);const _=this.storageService.get(u,0);_&&(this.previousConfigurationSyncStore=JSON.parse(_));const z=this.productService[a.CONFIGURATION_SYNC_STORE_KEY];z?this.storageService.store(u,JSON.stringify(z),0,1):this.storageService.remove(u,0)}async switch(U){U!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=U,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=he([J(0,y.IProductService),J(1,p.IConfigurationService),J(2,f.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let g=class extends i.Disposable{constructor(U,x,N,_,z,A,M){super();this.requestService=N,this.logService=_,this.storageService=M,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new k.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(U),this.commonHeadersPromise=(0,S.getServiceMachineId)(z,A,M).then(q=>{const j={"X-Client-Name":`${x.applicationName}${w.isWeb?"-web":""}`,"X-Client-Version":x.version};return x.commit&&(j["X-Client-Commit"]=x.commit),j}),this.session=new T(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,i.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(U,x){this.authToken={token:U,type:x}}updateUserDataSyncStoreUrl(U){this.userDataSyncStoreUrl=U?(0,C.joinPath)(U,"v1"):void 0}initDonotMakeRequestsUntil(){const U=this.storageService.getNumber(r,0);U&&Date.now()<U&&this.setDonotMakeRequestsUntil(new Date(U))}setDonotMakeRequestsUntil(U){this._donotMakeRequestsUntil?.getTime()!==U?.getTime()&&(this._donotMakeRequestsUntil=U,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(x=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),x).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,x=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U),N={},_=await this.request(x.toString(),{type:"GET",headers:N},[],L.CancellationToken.None);return(await(0,m.asJson)(_)||[]).map(({url:A,created:M})=>({ref:(0,C.relativePath)(x,x.with({path:A})),created:M*1e3}))}async resolveContent(U,x){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U,x).toString(),_={};_["Cache-Control"]="no-cache";const z=await this.request(N,{type:"GET",headers:_},[],L.CancellationToken.None);return await(0,m.asText)(z)}async delete(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString(),N={};await this.request(x,{type:"DELETE",headers:N},[],L.CancellationToken.None)}async read(U,x,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U,"latest").toString();N={...N},N["Cache-Control"]="no-cache",x&&(N["If-None-Match"]=x.ref);const z=await this.request(_,{type:"GET",headers:N},[304],L.CancellationToken.None);let A=null;if(z.res.statusCode===304&&(A=x),A===null){const M=z.res.headers.etag;if(!M)throw new a.UserDataSyncStoreError("Server did not return the ref",_,"NoRef",z.res.statusCode,z.res.headers[a.HEADER_OPERATION_ID]);const q=await(0,m.asText)(z);if(!q&&z.res.statusCode===304)throw new a.UserDataSyncStoreError("Empty response",_,"EmptyResponse",z.res.statusCode,z.res.headers[a.HEADER_OPERATION_ID]);A={ref:M,content:q}}return A}async write(U,x,N,_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString();_={..._},_["Content-Type"]=P.Mimes.text,N&&(_["If-Match"]=N);const A=await this.request(z,{type:"POST",data:x,headers:_},[],L.CancellationToken.None),M=A.res.headers.etag;if(!M)throw new a.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",A.res.statusCode,A.res.headers[a.HEADER_OPERATION_ID]);return M}async manifest(U,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();x={...x},x["Content-Type"]="application/json",U&&(x["If-None-Match"]=U.ref);const _=await this.request(N,{type:"GET",headers:x},[304],L.CancellationToken.None);let z=null;if(_.res.statusCode===304&&(z=U),!z){const M=_.res.headers.etag;if(!M)throw new a.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",_.res.statusCode,_.res.headers[a.HEADER_OPERATION_ID]);const q=await(0,m.asText)(_);if(!q&&_.res.statusCode===304)throw new a.UserDataSyncStoreError("Empty response",N,"EmptyResponse",_.res.statusCode,_.res.headers[a.HEADER_OPERATION_ID]);q&&(z={...JSON.parse(q),ref:M})}const A=this.storageService.get(o,0);return A&&z&&A!==z.session&&this.clearSession(),z===null&&A&&this.clearSession(),z&&this.storageService.store(o,z.session,0,1),z}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),x={"Content-Type":P.Mimes.text};await this.request(U,{type:"DELETE",headers:x},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(o,0),this.storageService.remove(n,0)}async request(U,x,N,_){if(!this.authToken)throw new a.UserDataSyncStoreError("No Auth Token Available",U,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new a.UserDataSyncStoreError(`${x.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const z=await this.commonHeadersPromise;x.headers={...x.headers||{},...z,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(x.headers),this.logService.trace("Sending request to server",{url:U,type:x.type,headers:{...x.headers,authorization:void 0}});let A;try{A=await this.session.request(U,x,_)}catch(W){if(!(W instanceof a.UserDataSyncStoreError)){let $="RequestFailed";const K=(0,D.getErrorMessage)(W).toLowerCase();K.includes("xhr timeout")?$="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?$="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?$="RequestPathNotEscaped":K.includes("headers must be an object")?$="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(W)&&($="RequestCanceled"),W=new a.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,$,void 0,void 0)}throw this.logService.info("Request failed",U),W}const M=A.res.headers[a.HEADER_OPERATION_ID],q={url:U,status:A.res.statusCode,"execution-id":x.headers[a.HEADER_EXECUTION_ID],"operation-id":M},j=(0,m.isSuccess)(A)||A.res.statusCode&&N.indexOf(A.res.statusCode)!==-1;if(j?this.logService.trace("Request succeeded",q):this.logService.info("Request failed",q),A.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new a.UserDataSyncStoreError(`Request '${U}' failed because of Unauthorized (401).`,U,"Unauthorized",A.res.statusCode,M);if(this._onTokenSucceed.fire(),A.res.statusCode===409)throw new a.UserDataSyncStoreError(`${x.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,"Conflict",A.res.statusCode,M);if(A.res.statusCode===410)throw new a.UserDataSyncStoreError(`${x.type} request '${U}' failed because the requested resource is not longer available (410).`,U,"Gone",A.res.statusCode,M);if(A.res.statusCode===412)throw new a.UserDataSyncStoreError(`${x.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,"PreconditionFailed",A.res.statusCode,M);if(A.res.statusCode===413)throw new a.UserDataSyncStoreError(`${x.type} request '${U}' failed because of too large payload (413).`,U,"TooLarge",A.res.statusCode,M);if(A.res.statusCode===426)throw new a.UserDataSyncStoreError(`${x.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,"UpgradeRequired",A.res.statusCode,M);if(A.res.statusCode===429){const W=A.res.headers["retry-after"];throw W?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(W)*1e3)),new a.UserDataSyncStoreError(`${x.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",A.res.statusCode,M)):new a.UserDataSyncStoreError(`${x.type} request '${U}' failed because of too many requests (429).`,U,"RemoteTooManyRequests",A.res.statusCode,M)}if(!j)throw new a.UserDataSyncStoreError("Server returned "+A.res.statusCode,U,"Unknown",A.res.statusCode,M);return A}addSessionHeaders(U){let x=this.storageService.get(n,0);x===void 0&&(x=(0,d.generateUuid)(),this.storageService.store(n,x,0,1)),U["X-Machine-Session-Id"]=x;const N=this.storageService.get(o,0);N!==void 0&&(U["X-User-Session-Id"]=N)}};g=he([J(1,y.IProductService),J(2,m.IRequestService),J(3,a.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,b.IFileService),J(6,f.IStorageService)],g),e.UserDataSyncStoreClient=g;let v=class extends g{constructor(U,x,N,_,z,A,M){super(U.userDataSyncStore?.url,x,N,_,z,A,M);this._register(U.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(U.userDataSyncStore?.url)))}};v=he([J(0,a.IUserDataSyncStoreManagementService),J(1,y.IProductService),J(2,m.IRequestService),J(3,a.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,b.IFileService),J(6,f.IStorageService)],v),e.UserDataSyncStoreService=v;class T{constructor(U,x,N,_){this.limit=U,this.interval=x,this.requestService=N,this.logService=_,this.requests=[],this.startTime=void 0}request(U,x,N){if(this.isExpired()&&this.reset(),x.url=U,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new a.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,U,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(U),this.requestService.request(x,N)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=T}),define(te[238],ne([0,1,3,61,26,23,22,101,24,64,65]),function(X,e,R,L,D,k,i,P,w,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends P.UserDataAutoSyncService{constructor(p,h,b,y,m,S,f,a,u,r,o,n){super(p,h,b,y,m,f,a,u,r,o,n);this._register(R.Event.debounce(R.Event.any(R.Event.map(S.onDidFocusWindow,()=>"windowFocus"),R.Event.map(S.onDidOpenWindow,()=>"windowOpen")),(t,s)=>t?[...t,s]:[s],1e3)(t=>this.triggerSync(t,!0,!1)))}};E=he([J(0,D.IProductService),J(1,w.IUserDataSyncStoreManagementService),J(2,w.IUserDataSyncStoreService),J(3,w.IUserDataSyncResourceEnablementService),J(4,w.IUserDataSyncService),J(5,L.INativeHostService),J(6,w.IUserDataSyncLogService),J(7,C.IUserDataSyncAccountService),J(8,i.ITelemetryService),J(9,I.IUserDataSyncMachinesService),J(10,k.IStorageService),J(11,w.IUserDataAutoSyncEnablementService)],E),e.UserDataAutoSyncService=E}),define(te[239],ne([0,1,5,3,2]),function(X,e,R,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:w,getActiveWindowId:C}){super();this.disposables=this._register(new D.DisposableStore),L.Event.latch(L.Event.any(P,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>C()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(te[66],ne([0,1,51,5,10,17,20,127,250,251]),function(X,e,R,L,D,k,i,P,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(r,o){let n=o.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=r,this.cause=o}}e.ExtractError=I;function E(u){const r=u.externalFileAttributes>>16||33188;return[448,56,7].map(o=>r&o).reduce((o,n)=>o+n,r&61440)}function d(u){if(u instanceof I)return u;let r;return/end of central directory record signature not found/.test(u.message)&&(r="CorruptZip"),new I(r,u)}function p(u,r,o,n,t,s){const c=D.dirname(r),l=D.join(n,c);if(!l.startsWith(n))return Promise.reject(new Error(P.localize(0,null,r)));const g=D.join(n,r);let v;return s.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(i.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((T,O)=>{if(!s.isCancellationRequested)try{v=(0,R.createWriteStream)(g,{mode:o}),v.once("close",()=>T()),v.once("error",O),u.once("error",O),u.pipe(v)}catch(U){O(U)}}))}function h(u,r,o,n){let t=(0,L.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{t.cancel(),u.close()}),new Promise((c,l)=>{const g=new L.Sequencer,v=T=>{T.isCancellationRequested||(s++,u.readEntry())};u.once("error",l),u.once("close",()=>t.then(()=>{n.isCancellationRequested||u.entryCount===s?c():l(new I("Incomplete",new Error(P.localize(1,null,s,u.entryCount))))},l)),u.readEntry(),u.on("entry",T=>{if(n.isCancellationRequested)return;if(!o.sourcePathRegex.test(T.fileName)){v(n);return}const O=T.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(O)){const N=D.join(r,O);t=(0,L.createCancelablePromise)(_=>i.Promises.mkdir(N,{recursive:!0}).then(()=>v(_)).then(void 0,l));return}const U=y(u,T),x=E(T);t=(0,L.createCancelablePromise)(N=>g.queue(()=>U.then(_=>p(_,O,x,r,o,N).then(()=>v(N)))).then(null,l))})})}function b(u,r=!1){return new Promise((o,n)=>{(0,w.open)(u,r?{lazyEntries:!0}:void 0,(t,s)=>{t?n(d(t)):o((0,k.assertIsDefined)(s))})})}function y(u,r){return new Promise((o,n)=>{u.openReadStream(r,(t,s)=>{t?n(d(t)):o((0,k.assertIsDefined)(s))})})}function m(u,r){return new Promise((o,n)=>{const t=new C.ZipFile;r.forEach(c=>{c.contents?t.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&t.addFile(c.localPath,c.path)}),t.end();const s=(0,R.createWriteStream)(u);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>o(u))})}e.zip=m;function S(u,r,o={},n){const t=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=b(u,!0);return o.overwrite&&(s=s.then(c=>i.Promises.rm(r).then(()=>c))),s.then(c=>h(c,r,{sourcePathRegex:t},n))}e.extract=S;function f(u,r){return b(u).then(o=>new Promise((n,t)=>{o.on("entry",s=>{s.fileName===r&&y(o,s).then(c=>n(c),c=>t(c))}),o.once("close",()=>t(new Error(P.localize(2,null,r))))}))}function a(u,r){return f(u,r).then(o=>new Promise((n,t)=>{const s=[];o.once("error",t),o.on("data",c=>s.push(c)),o.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=a}),define(te[240],ne([0,1,66,136]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(k){return(0,R.buffer)(k,"extension/package.json").then(i=>{try{return JSON.parse(i.toString("utf8"))}catch(P){throw new Error((0,L.localize)(0,null))}})}e.getManifest=D}),define(te[241],ne([0,1,16,5,8,2,15,10,4,18,62,9,29,20,66,137,11,30,36,158,14,7,26]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S,f,a,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let o=class extends k.Disposable{constructor(t,s,c,l,g){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=c,this.environmentService=l,this.productService=g,this._devSystemExtensionsPath=null,this.systemExtensionsPath=l.builtinExtensionsPath,this.extensionsPath=l.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,c=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(c).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,c=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(c).message,m.ExtensionManagementErrorCode.Internal))));try{const c=await Promise.all(s);return(0,R.flatten)(c)}catch(c){throw this.joinErrors(c)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,c]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return c=c.filter(l=>!s[new S.ExtensionIdentifierWithVersion(l.identifier,l.manifest.version).key()]),t&&(c=(0,S.groupByExtension)(c,g=>g.identifier).map(g=>g.sort((v,T)=>I.rcompare(v.manifest.version,T.manifest.version))[0])),this.logService.trace("Scanned user extensions:",c.length),c}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,c,l){const g=t.key(),v=P.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),T=P.join(this.extensionsPath,g);try{await p.Promises.rm(T)}catch(U){try{await p.Promises.rm(T)}catch(x){}throw new m.ExtensionManagementError((0,b.localize)(0,null,T,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,v,l);let O=await this.scanExtension(E.URI.file(v),1);if(!O)throw new Error((0,b.localize)(1,null,v));await this.storeMetadata(O,{...c,installedTimestamp:Date.now()});try{await this.rename(t,v,T,Date.now()+2*60*1e3),this.logService.info("Renamed to",T)}catch(U){try{await p.Promises.rm(v)}catch(x){}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(U)}. Deleted from extracted location`,v),U}try{O=await this.scanExtension(E.URI.file(T),1)}catch(U){}if(O)return O;throw new Error((0,b.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const c=P.join(t.location.fsPath,"package.json"),l=await p.Promises.readFile(c,"utf8"),{manifest:g}=await this.parseManifest(l);return g.__metadata=s,await p.Promises.writeFile(c,JSON.stringify(g,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(c=>new S.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version));await this.withUninstalledExtensions(c=>{s.forEach(l=>c[l.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(l=>delete l[t.key()]);const c=(await this.scanExtensions(1)).find(l=>new S.ExtensionIdentifierWithVersion(l.identifier,l.manifest.version).equals(t))||null;return c?(await this.storeMetadata(c,{installedTimestamp:Date.now()}),this.scanExtension(c.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(l){if(l.code!=="ENOENT")throw l}let c={};if(s)try{c=JSON.parse(s)}catch(l){}return t&&(t(c),Object.keys(c).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(c)):await p.Promises.rm(this.uninstalledPath)),c})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await p.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new S.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,c,l){this.logService.trace(`Started extracting the extension from ${s} to ${c}`);try{await p.Promises.rm(c)}catch(g){throw new m.ExtensionManagementError(this.joinErrors(g).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(s,c,{sourcePath:"extension",overwrite:!0},l),this.logService.info(`Extracted extension to ${c}:`,t.id)}catch(g){try{await p.Promises.rm(c)}catch(T){}let v=m.ExtensionManagementErrorCode.Extract;throw g instanceof h.ExtractError&&(g.type==="CorruptZip"?v=m.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(v=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(g.message,v)}}async rename(t,s,c,l){try{await p.Promises.rename(s,c)}catch(g){if(w.isWindows&&g&&g.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${s} to ${c} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,c,l);throw new m.ExtensionManagementError(g.message||(0,b.localize)(3,null,s,c),g.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[c,l]=await Promise.all([t,s]);return[...c,...l]}async scanExtensionsInDir(t,s){const c=new L.Limiter(10),l=await this.fileService.resolve(E.URI.file(t));return l.children?(await Promise.all(l.children.filter(v=>v.isDirectory).map(v=>c.queue(async()=>s===1&&(0,C.basename)(v.resource).indexOf(".")===0?null:this.scanExtension(v.resource,s))))).filter(v=>v&&v.identifier):[]}async scanExtension(t,s){try{const c=await this.fileService.resolve(t);if(c.children){const{manifest:l,metadata:g}=await this.readManifest(t.fsPath),v=c.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,T=c.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource,O={id:(0,S.getGalleryExtensionId)(l.publisher,l.name)},U={type:s,identifier:O,manifest:l,location:t,readmeUrl:v,changelogUrl:T,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return g&&(this.setMetadata(U,g),U.installedTimestamp=g.installedTimestamp),U}}catch(c){s!==0&&this.logService.trace(c)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(c=>t.some(l=>(0,S.areSameExtensions)(c.identifier,{id:l})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s.publisherDisplayName||null,t.publisherId=s.publisherId||null,t.identifier.uuid=s.id,t.isMachineScoped=!!s.isMachineScoped,t.isBuiltin=t.type===0||!!s.isBuiltin}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),c=new Set;for(const v of s)t[new S.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]||c.add(v.identifier.id.toLowerCase());const l=(0,S.groupByExtension)(s,v=>v.identifier);await L.Promises.settled(l.map(async v=>{const T=v.sort((O,U)=>I.rcompare(O.manifest.version,U.manifest.version))[0];c.has(T.identifier.id.toLowerCase())||await this.beforeRemovingExtension(T)}));const g=s.filter(v=>t[new S.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]);await L.Promises.settled(g.map(v=>this.removeUninstalledExtension(v)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],c=(0,S.groupByExtension)(t,l=>l.identifier);s.push(...(0,R.flatten)(c.map(l=>l.sort((g,v)=>I.rcompare(g.manifest.version,v.manifest.version)).slice(1)))),await L.Promises.settled(s.map(l=>this.removeExtension(l,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((c,l)=>new Error(`${c.message}${c.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(i.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[p.Promises.readFile(P.join(t,"package.json"),"utf8").then(v=>this.parseManifest(v)),p.Promises.readFile(P.join(t,"package.nls.json"),"utf8").then(void 0,v=>v.code!=="ENOENT"?Promise.reject(v):"{}").then(v=>JSON.parse(v))],[{manifest:c,metadata:l},g]=await Promise.all(s);return{manifest:(0,f.localizeManifest)(c,g),metadata:l}}parseManifest(t){return new Promise((s,c)=>{try{const l=JSON.parse(t),g=l.__metadata||null;s({manifest:l,metadata:g})}catch(l){c(new Error((0,b.localize)(4,null)))}})}};o=he([J(1,a.IFileService),J(2,u.ILogService),J(3,y.INativeEnvironmentService),J(4,r.IProductService)],o),e.ExtensionsScanner=o}),define(te[242],ne([0,1,38,8,15,10,4,31,18,62,9,29,20,66,135,80,11,205,30,36,189,177,240,190,241,219,78,14,6,7,26,22,37]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S,f,a,u,r,o,n,t,s,c,l,g,v,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let U=class extends m.AbstractExtensionManagementService{constructor(M,q,j,W,$,K,F,B,V){super(M,q,j,B);this.environmentService=W,this.downloadService=$,this.fileService=F;const Q=this._register(K.createInstance(u.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(n.ExtensionsScanner,G=>Q.postUninstall(G))),this.manifestCache=this._register(new o.ExtensionsManifestCache(W,this)),this.extensionsDownloader=this._register(K.createInstance(a.ExtensionsDownloader));const Z=this._register(new t.ExtensionsWatcher(this,F,W,j,V));this._register(Z.onDidChangeExtensionsByAnotherSource(({added:G,removed:H})=>{G.length&&this._onDidInstallExtensions.fire(G.map(re=>({identifier:re.identifier,operation:0,local:re}))),H.forEach(re=>this._onDidUninstallExtension.fire({identifier:re}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const M=await this.isAlpineLinux(),q=(0,S.getTargetPlatform)(M?"alpine":i.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",q),q})()),this._targetPlatformPromise}async isAlpineLinux(){if(!i.isLinux)return!1;let M;try{M=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch(q){try{M=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(j){this.logService.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(j))}}return!!M&&(M.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const q=await this.collectFiles(M),j=await(0,p.zip)((0,w.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,q);return I.URI.file(j)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const q=await this.downloadVsix(M),j=k.resolve(q.fsPath);return(0,r.getManifest)(j)}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}async install(M,q={}){this.logService.trace("ExtensionManagementService#install",M.toString());const j=await this.downloadVsix(M),W=await(0,r.getManifest)(k.resolve(j.fsPath));if(W.engines&&W.engines.vscode&&!(0,s.isEngineValid)(W.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,f.getGalleryExtensionId)(W.publisher,W.name),this.productService.version));return this.installExtension(W,j,q)}async updateMetadata(M,q){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},...q}),this.manifestCache.invalidate(),M}async updateExtensionScope(M,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},isMachineScoped:q}),this.manifestCache.invalidate(),M}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(M){if(M.scheme===D.Schemas.file)return M;const q=(0,w.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(M,q),q}createInstallExtensionTask(M,q,j){return I.URI.isUri(q)?new _(M,q,j,this.galleryService,this.extensionsScanner,this.logService):new N(q,j,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(M,q){return new z(M,q,this.extensionsScanner)}async collectFiles(M){const q=async W=>{let $=await d.Promises.readdir(W);$=$.map(B=>k.join(W,B));const K=await Promise.all($.map(B=>d.Promises.stat(B)));let F=Promise.resolve([]);return K.forEach((B,V)=>{const Q=$[V];B.isFile()&&(F=F.then(Z=>[...Z,Q])),B.isDirectory()&&(F=F.then(Z=>q(Q).then(G=>[...Z,...G])))}),F};return(await q(M.location.fsPath)).map(W=>({path:`extension/${k.relative(M.location.fsPath,W)}`,localPath:W}))}};U=he([J(0,S.IExtensionGalleryService),J(1,T.ITelemetryService),J(2,g.ILogService),J(3,y.INativeEnvironmentService),J(4,b.IDownloadService),J(5,l.IInstantiationService),J(6,c.IFileService),J(7,v.IProductService),J(8,O.IUriIdentityService)],U),e.ExtensionManagementService=U;class x extends m.AbstractExtensionTask{constructor(M,q,j,W){super();this.identifier=M,this.source=q,this.extensionsScanner=j,this.logService=W,this._operation=1}get operation(){return this._operation}async installExtension(M,q){try{const j=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(j)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(j,M.metadata):j}catch(j){throw i.isMacintosh?new S.ExtensionManagementError(h.localize(1,null),S.ExtensionManagementErrorCode.Internal):new S.ExtensionManagementError(h.localize(2,null),S.ExtensionManagementErrorCode.Internal)}return this.extract(M,q)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const j=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),j}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.key()]}async extract({zipPath:M,identifierWithVersion:q,metadata:j},W){let $=await this.extensionsScanner.extractUserExtension(q,M,j,W);return this.logService.info("Extracting completed.",q.id),$}}class N extends x{constructor(M,q,j,W,$){super(M.identifier,M,W,$);this.gallery=M,this.options=q,this.extensionsDownloader=j}async doRun(M){const j=(await this.extensionsScanner.scanExtensions(null)).find($=>(0,f.areSameExtensions)($.identifier,this.gallery.identifier));j&&(this._operation=2);const W=await this.downloadInstallableExtension(this.gallery,this._operation);W.metadata.isMachineScoped=this.options.isMachineScoped||j?.isMachineScoped,W.metadata.isBuiltin=this.options.isBuiltin||j?.isBuiltin;try{const $=await this.installExtension(W,M);return j&&C.neq(j.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(j),$}catch($){throw await this.deleteDownloadedVSIX(W.zipPath),$}}async deleteDownloadedVSIX(M){try{await this.extensionsDownloader.delete(I.URI.file(M))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",M.toString(),(0,L.getErrorMessage)(q))}}async downloadInstallableExtension(M,q){const j={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let W;try{this.logService.trace("Started downloading extension:",M.identifier.id),W=(await this.extensionsDownloader.downloadExtension(M,q)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,W)}catch($){throw new S.ExtensionManagementError((0,m.joinErrors)($).message,S.ExtensionManagementErrorCode.Download)}try{const $=await(0,r.getManifest)(W);return{zipPath:W,identifierWithVersion:new f.ExtensionIdentifierWithVersion(M.identifier,$.version),metadata:j}}catch($){throw await this.deleteDownloadedVSIX(W),new S.ExtensionManagementError((0,m.joinErrors)($).message,S.ExtensionManagementErrorCode.Invalid)}}}class _ extends x{constructor(M,q,j,W,$,K){super({id:(0,f.getGalleryExtensionId)(M.publisher,M.name)},q,$,K);this.manifest=M,this.location=q,this.options=j,this.galleryService=W}async doRun(M){const q=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),W=(await this.extensionsScanner.scanExtensions(1)).find(K=>(0,f.areSameExtensions)(this.identifier,K.identifier)),$=await this.getMetadata(this.identifier.id,M);if($.isMachineScoped=this.options.isMachineScoped||W?.isMachineScoped,$.isBuiltin=this.options.isBuiltin||W?.isBuiltin,W)if(this._operation=2,q.equals(new f.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version)))try{await this.extensionsScanner.removeExtension(W,"existing")}catch(K){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else C.gt(W.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(W);else{const K=await this.unsetUninstalledAndGetLocal(q);if(K)try{await this.extensionsScanner.removeExtension(K,"existing")}catch(F){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:k.resolve(this.location.fsPath),identifierWithVersion:q,metadata:$},M)}async getMetadata(M,q){try{const j=(await this.galleryService.query({names:[M],pageSize:1},q)).firstPage[0];if(j)return{id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId}}catch(j){}return{}}}class z extends m.AbstractExtensionTask{constructor(M,q,j){super();this.extension=M,this.options=q,this.extensionsScanner=j}async doRun(M){const q=[],j=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const W=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);q.push(...j.filter($=>W.equals(new f.ExtensionIdentifierWithVersion($.identifier,$.manifest.version))))}else q.push(...j.filter(W=>(0,f.areSameExtensions)(W.identifier,this.extension.identifier)));if(!q.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const W of q)try{M.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(W)}catch($){throw new Error(h.localize(6,null,(0,R.toErrorMessage)($)))}}}}),define(te[243],ne([0,1,83,57,33,19,8,3,2,10,4,29,34,73,252]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class b{constructor(l){this.socket=l,this._errorListener=g=>{if(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const g=v=>l(k.VSBuffer.wrap(v));return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(l){const g=v=>{l({type:0,hadError:v,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(l){return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(l){if(!this.socket.destroyed)try{this.socket.write(l.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}}end(){this.socket.end()}drain(){return new Promise((l,g)=>{if(this.socket.bufferSize===0){l();return}const v=()=>{this.socket.off("close",v),this.socket.off("end",v),this.socket.off("error",v),this.socket.off("timeout",v),this.socket.off("drain",v),l()};this.socket.on("close",v),this.socket.on("end",v),this.socket.on("error",v),this.socket.on("timeout",v),this.socket.on("drain",v)})}}e.NodeSocket=b;var y;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var m;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(m||(m={}));class S extends w.Disposable{constructor(l,g,v,T){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=g,this._recordInflateBytes=T,g?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),(0,i.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),v&&(this._zlibInflate.write(v.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),(0,i.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._totalOutgoingDataBytes+=l.byteLength,this._zlibDeflate?(this._zlibDeflate.write(l.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let g=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,g=g.slice(0,g.length-4),this._isEnded||this._write(k.VSBuffer.wrap(g),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(l,!1)}_write(l,g){let v=2;l.byteLength<126?v+=0:l.byteLength<2**16?v+=2:v+=8;const T=k.VSBuffer.alloc(v);if(g?T.writeUInt8(194,0):T.writeUInt8(130,0),l.byteLength<126)T.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){T.writeUInt8(126,1);let O=1;T.writeUInt8(l.byteLength>>>8&255,++O),T.writeUInt8(l.byteLength>>>0&255,++O)}else{T.writeUInt8(127,1);let O=1;T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(l.byteLength>>>24&255,++O),T.writeUInt8(l.byteLength>>>16&255,++O),T.writeUInt8(l.byteLength>>>8&255,++O),T.writeUInt8(l.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=T.byteLength+l.byteLength,this.socket.write(k.VSBuffer.concat([T,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._totalIncomingWireBytes+=l.byteLength,this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const g=this._incomingData.peek(this._state.readLen),v=g.readUInt8(0),T=(v&128)>>>7,O=(v&64)>>>6,U=g.readUInt8(1),x=(U&128)>>>7,N=U&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0}else if(this._state.state===2){const g=this._incomingData.read(this._state.readLen),v=g.readUInt8(1),T=(v&128)>>>7;let O=v&127,U=1;O===126?O=g.readUInt8(++U)*2**8+g.readUInt8(++U):O===127&&(O=g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*2**24+g.readUInt8(++U)*2**16+g.readUInt8(++U)*2**8+g.readUInt8(++U));let x=0;T&&(x=g.readUInt8(++U)*2**24+g.readUInt8(++U)*2**16+g.readUInt8(++U)*2**8+g.readUInt8(++U)),this._state.state=3,this._state.readLen=O,this._state.mask=x}else if(this._state.state===3){const g=this._incomingData.read(this._state.readLen);f(g,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(g.buffer)),this._zlibInflate.write(g.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const v=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=v.length,this._onData.fire(k.VSBuffer.wrap(v))})):(this._totalIncomingDataBytes+=g.byteLength,this._onData.fire(g))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=S;function f(c,l){if(l===0)return;let g=c.byteLength>>>2;for(let N=0;N<g;N++){const _=c.readUInt32BE(N*4);c.writeUInt32BE(_^l,N*4)}let v=g*4,T=c.byteLength-v;const O=l>>>24&255,U=l>>>16&255,x=l>>>8&255;T>=1&&c.writeUInt8(c.readUInt8(v)^O,v),T>=2&&c.writeUInt8(c.readUInt8(v+1)^U,v+1),T>=3&&c.writeUInt8(c.readUInt8(v+2)^x,v+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function u(){const c=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):l=(0,C.join)((0,D.tmpdir)(),`vscode-ipc-${c}.sock`),o(l),l}e.createRandomIPCHandle=u;function r(c,l,g){const v=(0,R.createHash)("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${v}-${g}-${l}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${v.substr(0,8)}-${g}-${l}.sock`):T=(0,C.join)(c,`${g}-${l}.sock`),o(T),T}e.createStaticIPCHandle=r;function o(c){const l=a[I.platform];typeof l=="number"&&c.length>=l&&console.warn(`WARNING: IPC handle "${c}" is longer than ${l} chars, try a shorter --user-data-dir`)}class n extends d.IPCServer{constructor(l){super(n.toClientConnectionEvent(l));this.server=l}static toClientConnectionEvent(l){const g=P.Event.fromNodeEventEmitter(l,"connection");return P.Event.map(g,v=>({protocol:new p.Protocol(new b(v)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(v,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function t(c){return new Promise((l,g)=>{const v=(0,L.createServer)();v.on("error",g),v.listen(c,()=>{v.removeListener("error",g),l(new n(v))})})}e.serve=t;function s(c,l){return new Promise((g,v)=>{const T=(0,L.createConnection)(c,()=>{T.removeListener("error",v),g(p.Client.fromSocket(new b(T),l))});T.once("error",v)})}e.connect=s}),define(te[244],ne([0,1,57,243]),function(X,e,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,k,i,P){const w=I=>P(I,void 0),C=R.createConnection({host:D,port:k},()=>{C.removeListener("error",w);const I=Buffer.alloc(16);for(let h=0;h<16;h++)I[h]=Math.round(Math.random()*256);const E=I.toString("base64");let d=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${k}/?${i}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];C.write(d.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",p),P(void 0,new L.NodeSocket(C)))};C.on("data",p)});C.once("error",w)}}}),define(te[245],ne([0,1,57,117,244,5,2,21,7,26,187,63,93]),function(X,e,R,L,D,k,i,P,w,C,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(S,f,a,u,r){let o;for(let n=3;n&&(o&&o.dispose(),o=await new h(S,f,a,u,r).waitForReady(),!(r&&L.BROWSER_RESTRICTED_PORTS[r]||!L.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));n--);return o}class h extends i.Disposable{constructor(f,a,u,r,o){super();this.defaultTunnelHost=a,this.suggestedLocalPort=o,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=R.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let f=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(f){f.pause();const a=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,I.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),r=u.getSocket().socket,o=u.readEntireBuffer();u.dispose(),o.byteLength>0&&f.write(o.buffer),f.on("end",()=>{this._socketsDispose.delete(f.localAddress),r.end()}),f.on("close",()=>r.end()),f.on("error",()=>{this._socketsDispose.delete(f.localAddress),r.destroy()}),r.on("end",()=>f.end()),r.on("close",()=>f.end()),r.on("error",()=>{f.destroy()}),f.pipe(r),r.pipe(f),this._socketsDispose.set(f.localAddress,()=>{f.end(),r.end()})}}let b=class extends E.AbstractTunnelService{constructor(f,a,u,r,o){super(a);this.socketFactory=f,this.signService=u,this.productService=r,this.configurationService=o}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,a,u,r,o,n,t){const s=this.getTunnelFromMap(a,u);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,u,r,o,n,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${u} on local port ${r}.`);const c={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},l=p(c,this.defaultTunnelHost,a,u,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,u,l),l}}};b=he([J(1,w.ILogService),J(2,d.ISignService),J(3,C.IProductService),J(4,P.IConfigurationService)],b),e.BaseTunnelService=b;let y=class extends b{constructor(f,a,u,r){super(D.nodeSocketFactory,f,a,u,r)}};y=he([J(0,w.ILogService),J(1,d.ISignService),J(2,C.IProductService),J(3,P.IConfigurationService)],y),e.TunnelService=y;let m=class extends i.Disposable{constructor(f,a,u,r){super();this.logService=f,this.productService=a,this.signService=u,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(f,a,u,r,o,n,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${r} on local port ${o}.`),!this._tunnelServices.has(f)){const c=new y(this.logService,this.signService,this.productService,this.configurationService);this._register(c),this._tunnelServices.set(f,c),c.onTunnelClosed(async()=>{(await c.tunnels).length===0&&(c.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(a,u,r,o,n,t,s)}};m=he([J(0,w.ILogService),J(1,C.IProductService),J(2,d.ISignService),J(3,P.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[253],ne([0,1,74,33,38,8,2,15,18,9,34,121,183,163,184,174,175,176,161,165,21,185,79,204,80,195,11,156,200,208,30,164,206,242,81,159,14,180,182,53,6,171,85,172,173,60,191,7,87,61,88,26,194,44,23,202,203,22,94,95,96,45,209,210,97,212,218,99,100,101,24,64,231,232,233,65,234,235,236,237,238,239,82,178,93,199,63,245,192,193,92,198,86,207,37,220]),function(X,e,R,L,D,k,i,P,w,C,I,E,d,p,h,b,y,m,S,f,a,u,r,o,n,t,s,c,l,g,v,T,O,U,x,N,_,z,A,M,q,j,W,$,K,F,B,V,Q,Z,G,H,re,ie,ce,le,fe,de,be,Ie,Ee,_e,Pe,Le,Fe,Ne,$e,xe,ee,oe,ae,pe,ye,Ae,Re,Y,se,ue,ge,me,Ce,ke,Te,Se,we,De,Oe,Me,Qe,Ye,We,Pt,pt,Dt,Rt,kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends i.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",qe=(He,ze)=>this.onDisposeWorker(ze);R.ipcRenderer.on(Ue,qe),this._register((0,i.toDisposable)(()=>R.ipcRenderer.removeListener(Ue,qe)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,ae.registerConfiguration)(),ve.invokeFunction(Ue=>{const qe=Ue.get(V.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(qe)}),this._register((0,i.combinedDisposable)(ve.createInstance(d.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(h.LanguagePackCachedDataCleaner),ve.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(y.LogsDataCleaner),ve.createInstance(b.LocalizationsUpdater),ve.createInstance(p.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new W.ServiceCollection,Ue={_serviceBrand:void 0,...G.default};ve.set(H.IProductService,Ue);const qe=new I.StaticRouter(Be=>Be==="main"),He=new $.MessagePortMainProcessService(this.server,qe);ve.set(K.IMainProcessService,He);const ze=new c.NativeEnvironmentService(this.configuration.args,Ue);ve.set(s.INativeEnvironmentService,ze);const rt=new Q.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Ze=new Q.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,He.getChannel("logger"));ve.set(V.ILoggerService,Ze);const at=this._register(new V.MultiplexLogService([this._register(new V.ConsoleLogger(this.configuration.logLevel)),this._register(Ze.createLogger((0,w.joinPath)(C.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new Q.FollowerLogService(rt,at));ve.set(V.ILogService,Ge),this.sharedProcessWorkerService=new Pt.SharedProcessWorkerService(Ge,Ue,ze),ve.set(We.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new z.FileService(Ge));ve.set(_.IFileService,Je);const ct=this._register(new A.DiskFileSystemProvider(Ge));Je.registerProvider(P.Schemas.file,ct);const je=this._register(new u.ConfigurationService(ze.settingsResource,Je));ve.set(a.IConfigurationService,je);const nt=new le.NativeStorageService(void 0,He,ze);ve.set(ce.IStorageService,nt),this._register((0,i.toDisposable)(()=>nt.flush())),await Promise.all([je.initialize(),nt.initialize()]),ve.set(pt.IUserConfigurationFileService,I.ProxyChannel.toService(He.getChannel(pt.UserConfigurationFileServiceId))),ve.set(Rt.IUriIdentityService,new kt.UriIdentityService(Je)),ve.set(ie.IRequestService,new M.SyncDescriptor(re.RequestService)),ve.set(S.IChecksumService,new M.SyncDescriptor(f.ChecksumService));const st=I.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(Z.INativeHostService,st),ve.set(n.IDownloadService,new M.SyncDescriptor(t.DownloadService));const lt=this._register(new ke.ActiveWindowManager(st)),ut=new I.StaticRouter(Be=>lt.getActiveClientId().then(dt=>Be===dt));ve.set(x.IExtensionRecommendationNotificationService,new N.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new Dt.AssignmentService(this.configuration.machineId,je,Ue);let Xe;const et=[];if((0,_e.supportsTelemetry)(Ue,ze)){const Be=new Ie.TelemetryLogAppender(Ze,ze);et.push(Be);const{appRoot:dt,extensionsPath:At,installSourcePath:Ot}=ze;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const ot=await ht.getTreatment("telemetryMigration")??!1,ft=Ue.quality!=="stable";if(ft&&ot){const Et=new Pe.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ot,!0);this._register((0,i.toDisposable)(()=>Et.flush())),et.push(Et)}const wt=new Pe.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ft?!1:ot,ot&&ft);this._register((0,i.toDisposable)(()=>wt.flush())),et.push(wt)}Xe=new Ee.TelemetryService({appenders:et,commonProperties:(0,fe.resolveCommonProperties)(Je,(0,L.release)(),(0,L.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[dt,At]},je)}else{Xe=_e.NullTelemetryService;const Be=_e.NullAppender;et.push(Be)}this.server.registerChannel("telemetryAppender",new be.TelemetryAppenderChannel(et)),ve.set(de.ITelemetryService,Xe);const _t=new Le.CustomEndpointTelemetryService(je,Xe,Ze,ze);ve.set(de.ICustomEndpointTelemetryService,_t),ve.set(v.IExtensionManagementService,new M.SyncDescriptor(U.ExtensionManagementService)),ve.set(v.IExtensionGalleryService,new M.SyncDescriptor(g.ExtensionGalleryService)),ve.set(v.IExtensionTipsService,new M.SyncDescriptor(O.ExtensionTipsService)),ve.set(F.ILocalizationsService,new M.SyncDescriptor(B.LocalizationsService)),ve.set(r.IDiagnosticsService,new M.SyncDescriptor(o.DiagnosticsService)),ve.set(pe.IUserDataSyncAccountService,new M.SyncDescriptor(pe.UserDataSyncAccountService)),ve.set(ae.IUserDataSyncLogService,new M.SyncDescriptor(Re.UserDataSyncLogService)),ve.set(ae.IUserDataSyncUtilService,new Ae.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),ve.set(v.IGlobalExtensionEnablementService,new M.SyncDescriptor(l.GlobalExtensionEnablementService)),ve.set(ee.IIgnoredExtensionsManagementService,new M.SyncDescriptor(ee.IgnoredExtensionsManagementService)),ve.set(xe.IExtensionsStorageSyncService,new M.SyncDescriptor(xe.ExtensionsStorageSyncService)),ve.set(ae.IUserDataSyncStoreManagementService,new M.SyncDescriptor(me.UserDataSyncStoreManagementService)),ve.set(ae.IUserDataSyncStoreService,new M.SyncDescriptor(me.UserDataSyncStoreService)),ve.set(Y.IUserDataSyncMachinesService,new M.SyncDescriptor(Y.UserDataSyncMachinesService)),ve.set(ae.IUserDataSyncBackupStoreService,new M.SyncDescriptor(ye.UserDataSyncBackupStoreService)),ve.set(ae.IUserDataAutoSyncEnablementService,new M.SyncDescriptor(oe.UserDataAutoSyncEnablementService)),ve.set(ae.IUserDataSyncResourceEnablementService,new M.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ve.set(ae.IUserDataSyncService,new M.SyncDescriptor(ue.UserDataSyncService));const yt=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:je.getValue("terminal.integrated.persistentSessionScrollback")??100},je,ze,Ge,Xe);return await yt.initialize(),ve.set(Ne.ILocalPtyService,this._register(yt)),ve.set(Te.IExtensionHostStarter,this._register(new Se.ExtensionHostStarter(Ge))),ve.set(we.ISignService,new M.SyncDescriptor(De.SignService)),ve.set(Oe.ISharedTunnelsService,new M.SyncDescriptor(Me.SharedTunnelsService)),ve.set(Qe.ISharedProcessTunnelService,new M.SyncDescriptor(Ye.SharedProcessTunnelService)),new j.InstantiationService(ve)}initChannels(ve){const Ue=new T.ExtensionManagementChannel(ve.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const qe=I.ProxyChannel.fromService(ve.get(F.ILocalizationsService));this.server.registerChannel("localizations",qe);const He=I.ProxyChannel.fromService(ve.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const ze=new T.ExtensionTipsChannel(ve.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const rt=I.ProxyChannel.fromService(ve.get(S.IChecksumService));this.server.registerChannel("checksum",rt);const Ze=new Ae.UserDataSyncMachinesServiceChannel(ve.get(Y.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ze);const at=I.ProxyChannel.fromService(ve.get(de.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Ge=new Ae.UserDataSyncAccountServiceChannel(ve.get(pe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Je=new Ae.UserDataSyncStoreManagementServiceChannel(ve.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ct=new ge.UserDataSyncChannel(ve.get(ae.IUserDataSyncService),ve.get(V.ILogService));this.server.registerChannel("userDataSync",ct);const je=this._register(ve.get(q.IInstantiationService).createInstance(Ce.UserDataAutoSyncService)),nt=new Ae.UserDataAutoSyncChannel(je);this.server.registerChannel("userDataAutoSync",nt);const st=ve.get(Ne.ILocalPtyService),lt=I.ProxyChannel.fromService(st);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,lt);const ut=I.ProxyChannel.fromService(ve.get(Te.IExtensionHostStarter));this.server.registerChannel(Te.ipcExtensionHostStarterChannelName,ut);const ht=I.ProxyChannel.fromService(ve.get(Qe.ISharedProcessTunnelService));this.server.registerChannel(Qe.ipcSharedProcessTunnelChannelName,ht);const Xe=I.ProxyChannel.fromService(ve.get(We.ISharedProcessWorkerService));this.server.registerChannel(We.ipcSharedProcessWorkerChannelName,Xe)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Ue=>{(0,k.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,k.setUnexpectedErrorHandler)(Ue=>{const qe=(0,D.toErrorMessage)(Ue,!0);!qe||ve.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function Lt(St){const ve=new Tt(St);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Lt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d450b04c783dfa6f83dc439017767acccd4e9fac/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
