/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/path","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","os","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","vs/base/parts/ipc/common/ipc","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/map","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],J=function(z){for(var i=[],T=0,I=z.length;T<I;T++)i[T]=Y[z[T]];return i};define(Y[56],J([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function T(I,b){if(!I)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}i.ok=T}),define(Y[46],J([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function T(R){return(w,l,g)=>{let y=null,D=null;if(typeof g.value=="function"?(y="value",D=g.value):typeof g.get=="function"&&(y="get",D=g.get),!D)throw new Error("not supported");g[y]=R(D,l)}}i.createDecorator=T;function I(R,w,l){let g=null,y=null;if(typeof l.value=="function"?(g="value",y=l.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(g="get",y=l.get),!y)throw new Error("not supported");const D=`$memoize$${w}`;l[g]=function(...c){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,c)}),this[D]}}i.memoize=I;function b(R,w,l){return T((g,y)=>{const D=`$debounce$${y}`,c=`$debounce$result$${y}`;return function(...E){this[c]||(this[c]=l?l():void 0),clearTimeout(this[D]),w&&(this[c]=w(this[c],...E),E=[this[c]]),this[D]=setTimeout(()=>{g.apply(this,E),this[c]=l?l():void 0},R)}})}i.debounce=b;function C(R,w,l){return T((g,y)=>{const D=`$throttle$timer$${y}`,c=`$throttle$result$${y}`,E=`$throttle$lastRun$${y}`,u=`$throttle$pending$${y}`;return function(...d){if(this[c]||(this[c]=l?l():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),w&&(this[c]=w(this[c],...d)),this[u])return;const p=this[E]+R;p<=Date.now()?(this[E]=Date.now(),g.apply(this,[this[c]]),this[c]=l?l():void 0):(this[u]=!0,this[D]=setTimeout(()=>{this[u]=!1,this[E]=Date.now(),g.apply(this,[this[c]]),this[c]=l?l():void 0},p-Date.now()))}})}i.throttle=C}),define(Y[57],J([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T=i.ScanError||(i.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=i.SyntaxKind||(i.SyntaxKind={}));var b;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(b=i.ParseErrorCode||(i.ParseErrorCode={}));var C;(function(t){t.DEFAULT={allowTrailingComma:!0}})(C=i.ParseOptions||(i.ParseOptions={}));function R(t,r=!1){let e=0,n=t.length,o="",h=0,v=16,L=0;function S(se){let ce=0,W=0;for(;ce<se;){const q=t.charCodeAt(e);if(q>=48&&q<=57)W=W*16+q-48;else if(q>=65&&q<=70)W=W*16+q-65+10;else if(q>=97&&q<=102)W=W*16+q-97+10;else break;e++,ce++}return ce<se&&(W=-1),W}function O(se){e=se,o="",h=0,v=16,L=0}function N(){const se=e;if(t.charCodeAt(e)===48)e++;else for(e++;e<t.length&&g(t.charCodeAt(e));)e++;if(e<t.length&&t.charCodeAt(e)===46)if(e++,e<t.length&&g(t.charCodeAt(e)))for(e++;e<t.length&&g(t.charCodeAt(e));)e++;else return L=3,t.substring(se,e);let ce=e;if(e<t.length&&(t.charCodeAt(e)===69||t.charCodeAt(e)===101))if(e++,(e<t.length&&t.charCodeAt(e)===43||t.charCodeAt(e)===45)&&e++,e<t.length&&g(t.charCodeAt(e))){for(e++;e<t.length&&g(t.charCodeAt(e));)e++;ce=e}else L=3;return t.substring(se,ce)}function X(){let se="",ce=e;for(;;){if(e>=n){se+=t.substring(ce,e),L=2;break}const W=t.charCodeAt(e);if(W===34){se+=t.substring(ce,e),e++;break}if(W===92){if(se+=t.substring(ce,e),e++,e>=n){L=2;break}switch(t.charCodeAt(e++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:const ne=S(4);ne>=0?se+=String.fromCharCode(ne):L=4;break;default:L=5}ce=e;continue}if(W>=0&&W<=31)if(l(W)){se+=t.substring(ce,e),L=2;break}else L=6;e++}return se}function ee(){if(o="",L=0,h=e,e>=n)return h=n,v=17;let se=t.charCodeAt(e);if(w(se)){do e++,o+=String.fromCharCode(se),se=t.charCodeAt(e);while(w(se));return v=15}if(l(se))return e++,o+=String.fromCharCode(se),se===13&&t.charCodeAt(e)===10&&(e++,o+=`
`),v=14;switch(se){case 123:return e++,v=1;case 125:return e++,v=2;case 91:return e++,v=3;case 93:return e++,v=4;case 58:return e++,v=6;case 44:return e++,v=5;case 34:return e++,o=X(),v=10;case 47:const ce=e-1;if(t.charCodeAt(e+1)===47){for(e+=2;e<n&&!l(t.charCodeAt(e));)e++;return o=t.substring(ce,e),v=12}if(t.charCodeAt(e+1)===42){e+=2;const W=n-1;let q=!1;for(;e<W;){if(t.charCodeAt(e)===42&&t.charCodeAt(e+1)===47){e+=2,q=!0;break}e++}return q||(e++,L=1),o=t.substring(ce,e),v=13}return o+=String.fromCharCode(se),e++,v=16;case 45:if(o+=String.fromCharCode(se),e++,e===n||!g(t.charCodeAt(e)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=N(),v=11;default:for(;e<n&&ue(se);)e++,se=t.charCodeAt(e);if(h!==e){switch(o=t.substring(h,e),o){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return o+=String.fromCharCode(se),e++,v=16}}function ue(se){if(w(se)||l(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let se;do se=ee();while(se>=12&&se<=15);return se}return{setPosition:O,getPosition:()=>e,scan:r?le:ee,getToken:()=>v,getTokenValue:()=>o,getTokenOffset:()=>h,getTokenLength:()=>e-h,getTokenError:()=>L}}i.createScanner=R;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function l(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function D(t,r){const e=[],n=new Object;let o;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function L(S,O,N,X){h.value=S,h.offset=O,h.length=N,h.type=X,h.colonOffset=void 0,o=h}try{f(t,{onObjectBegin:(S,O)=>{if(r<=S)throw n;o=void 0,v=r>S,e.push("")},onObjectProperty:(S,O,N)=>{if(r<O||(L(S,O,N,"property"),e[e.length-1]=S,r<=O+N))throw n},onObjectEnd:(S,O)=>{if(r<=S)throw n;o=void 0,e.pop()},onArrayBegin:(S,O)=>{if(r<=S)throw n;o=void 0,e.push(0)},onArrayEnd:(S,O)=>{if(r<=S)throw n;o=void 0,e.pop()},onLiteralValue:(S,O,N)=>{if(r<O||(L(S,O,N,a(S)),r<=O+N))throw n},onSeparator:(S,O,N)=>{if(r<=O)throw n;if(S===":"&&o&&o.type==="property")o.colonOffset=O,v=!1,o=void 0;else if(S===","){const X=e[e.length-1];typeof X=="number"?e[e.length-1]=X+1:(v=!0,e[e.length-1]=""),o=void 0}}})}catch(S){if(S!==n)throw S}return{path:e,previousNode:o,isAtPropertyKey:v,matches:S=>{let O=0;for(let N=0;O<S.length&&N<e.length;N++)if(S[O]===e[N]||S[O]==="*")O++;else if(S[O]!=="**")return!1;return O===S.length}}}i.getLocation=D;function c(t,r=[],e=C.DEFAULT){let n=null,o=[];const h=[];function v(S){Array.isArray(o)?o.push(S):n!==null&&(o[n]=S)}return f(t,{onObjectBegin:()=>{const S={};v(S),h.push(o),o=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const S=[];v(S),h.push(o),o=S,n=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:v,onError:(S,O,N)=>{r.push({error:S,offset:O,length:N})}},e),o[0]}i.parse=c;function E(t,r=[],e=C.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function h(S){return n.children.push(S),S}f(t,{onObjectBegin:S=>{n=h({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,O,N)=>{n=h({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:O,length:N,parent:n})},onObjectEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,o(S+O)},onArrayBegin:(S,O)=>{n=h({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,o(S+O)},onLiteralValue:(S,O,N)=>{h({type:a(S),offset:O,length:N,parent:n,value:S}),o(O+N)},onSeparator:(S,O,N)=>{n.type==="property"&&(S===":"?n.colonOffset=O:S===","&&o(O))},onError:(S,O,N)=>{r.push({error:S,offset:O,length:N})}},e);const L=n.children[0];return L&&delete L.parent,L}i.parseTree=E;function u(t,r){if(!t)return;let e=t;for(let n of r)if(typeof n=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let o=!1;for(const h of e.children)if(Array.isArray(h.children)&&h.children[0].value===n){e=h.children[1],o=!0;break}if(!o)return}else{const o=n;if(e.type!=="array"||o<0||!Array.isArray(e.children)||o>=e.children.length)return;e=e.children[o]}return e}i.findNodeAtLocation=u;function d(t){if(!t.parent||!t.parent.children)return[];const r=d(t.parent);if(t.parent.type==="property"){const e=t.parent.children[0].value;r.push(e)}else if(t.parent.type==="array"){const e=t.parent.children.indexOf(t);e!==-1&&r.push(e)}return r}i.getNodePath=d;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const r=Object.create(null);for(let e of t.children){const n=e.children[1];n&&(r[e.children[0].value]=p(n))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}i.getNodeValue=p;function m(t,r,e=!1){return r>=t.offset&&r<t.offset+t.length||e&&r===t.offset+t.length}i.contains=m;function P(t,r,e=!1){if(m(t,r,e)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const h=P(n[o],r,e);if(h)return h}return t}}i.findNodeAtOffset=P;function f(t,r,e=C.DEFAULT){const n=R(t,!1);function o(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function h(K){return K?Z=>K(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const v=o(r.onObjectBegin),L=h(r.onObjectProperty),S=o(r.onObjectEnd),O=o(r.onArrayBegin),N=o(r.onArrayEnd),X=h(r.onLiteralValue),ee=h(r.onSeparator),ue=o(r.onComment),le=h(r.onError),se=e&&e.disallowComments,ce=e&&e.allowTrailingComma;function W(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:se||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(K){case 12:case 13:se?q(10):ue();break;case 16:q(1);break;case 15:case 14:break;default:return K}}}function q(K,Z=[],_=[]){if(le(K),Z.length+_.length>0){let M=n.getToken();for(;M!==17;){if(Z.indexOf(M)!==-1){W();break}else if(_.indexOf(M)!==-1)break;M=W()}}}function ne(K){const Z=n.getTokenValue();return K?X(Z):L(Z),W(),!0}function U(){switch(n.getToken()){case 11:let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(q(2),K=0)}catch(Z){q(2)}X(K);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return W(),!0}function k(){return n.getToken()!==10?(q(3,[],[2,5]),!1):(ne(!1),n.getToken()===6?(ee(":"),W(),te()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function j(){v(),W();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||q(4,[],[]),ee(","),W(),n.getToken()===2&&ce)break}else K&&q(6,[],[]);k()||q(4,[],[2,5]),K=!0}return S(),n.getToken()!==2?q(7,[2],[]):W(),!0}function G(){O(),W();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||q(4,[],[]),ee(","),W(),n.getToken()===4&&ce)break}else K&&q(6,[],[]);te()||q(4,[],[4,5]),K=!0}return N(),n.getToken()!==4?q(8,[4],[]):W(),!0}function te(){switch(n.getToken()){case 3:return G();case 1:return j();case 10:return ne(!0);default:return U()}}return W(),n.getToken()===17?e.allowEmptyContent?!0:(q(4,[],[]),!1):te()?(n.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}i.visit=f;function s(t,r){let e=R(t),n=[],o,h=0,v;do switch(v=e.getPosition(),o=e.scan(),o){case 12:case 13:case 17:h!==v&&n.push(t.substring(h,v)),r!==void 0&&n.push(e.getTokenValue().replace(/[^\r\n]/g,r)),h=e.getPosition();break}while(o!==17);return n.join("")}i.stripComments=s;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=a}),function(){function z(b){const C=[];typeof b=="number"&&C.push("code/timeOrigin",b);function R(l){C.push(l,Date.now())}function w(){const l=[];for(let g=0;g<C.length;g+=2)l.push({name:C[g],startTime:C[g+1]});return l}return{mark:R,getMarks:w}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const R of performance.getEntriesByType("mark"))C.push({name:R.name,startTime:Math.round(b+R.startTime)});return C}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function T(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=i()),b.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=T(I))}(),define(Y[58],J([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var T;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(T=i.Source||(i.Source={}));var I;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(I=i.TerminateResponseCode||(i.TerminateResponseCode={}));function b(C,...R){const w=R.reduce((y,D)=>(y[D]=!0,y),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(y=>!w[y]).forEach(y=>{for(let D=0;D<l.length;D++)if(y.search(l[D])!==-1){delete C[y];break}})}i.sanitizeProcessEnvironment=b}),function(z,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var T=i();for(var I in T)(typeof exports=="object"?exports:z)[I]=T[I]}}(typeof self!="undefined"?self:this,function(){return function(z){var i={};function T(I){if(i[I])return i[I].exports;var b=i[I]={i:I,l:!1,exports:{}};return z[I].call(b.exports,b,b.exports,T),b.l=!0,b.exports}return T.m=z,T.c=i,T.d=function(I,b,C){T.o(I,b)||Object.defineProperty(I,b,{enumerable:!0,get:C})},T.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},T.t=function(I,b){if(1&b&&(I=T(I)),8&b||4&b&&typeof I=="object"&&I&&I.__esModule)return I;var C=Object.create(null);if(T.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:I}),2&b&&typeof I!="string")for(var R in I)T.d(C,R,function(w){return I[w]}.bind(null,R));return C},T.n=function(I){var b=I&&I.__esModule?function(){return I.default}:function(){return I};return T.d(b,"a",b),b},T.o=function(I,b){return Object.prototype.hasOwnProperty.call(I,b)},T.p="",T(T.s=0)}([function(z,i,T){(function(I){var b;i=z.exports=_,b=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var C=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,w=i.re=[],l=i.src=[],g=0,y=g++;l[y]="0|[1-9]\\d*";var D=g++;l[D]="[0-9]+";var c=g++;l[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=g++;l[E]="("+l[y]+")\\.("+l[y]+")\\.("+l[y]+")";var u=g++;l[u]="("+l[D]+")\\.("+l[D]+")\\.("+l[D]+")";var d=g++;l[d]="(?:"+l[y]+"|"+l[c]+")";var p=g++;l[p]="(?:"+l[D]+"|"+l[c]+")";var m=g++;l[m]="(?:-("+l[d]+"(?:\\."+l[d]+")*))";var P=g++;l[P]="(?:-?("+l[p]+"(?:\\."+l[p]+")*))";var f=g++;l[f]="[0-9A-Za-z-]+";var s=g++;l[s]="(?:\\+("+l[f]+"(?:\\."+l[f]+")*))";var a=g++,t="v?"+l[E]+l[m]+"?"+l[s]+"?";l[a]="^"+t+"$";var r="[v=\\s]*"+l[u]+l[P]+"?"+l[s]+"?",e=g++;l[e]="^"+r+"$";var n=g++;l[n]="((?:<|>)?=?)";var o=g++;l[o]=l[D]+"|x|X|\\*";var h=g++;l[h]=l[y]+"|x|X|\\*";var v=g++;l[v]="[v=\\s]*("+l[h]+")(?:\\.("+l[h]+")(?:\\.("+l[h]+")(?:"+l[m]+")?"+l[s]+"?)?)?";var L=g++;l[L]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[P]+")?"+l[s]+"?)?)?";var S=g++;l[S]="^"+l[n]+"\\s*"+l[v]+"$";var O=g++;l[O]="^"+l[n]+"\\s*"+l[L]+"$";var N=g++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=g++;l[X]="(?:~>?)";var ee=g++;l[ee]="(\\s*)"+l[X]+"\\s+",w[ee]=new RegExp(l[ee],"g");var ue=g++;l[ue]="^"+l[X]+l[v]+"$";var le=g++;l[le]="^"+l[X]+l[L]+"$";var se=g++;l[se]="(?:\\^)";var ce=g++;l[ce]="(\\s*)"+l[se]+"\\s+",w[ce]=new RegExp(l[ce],"g");var W=g++;l[W]="^"+l[se]+l[v]+"$";var q=g++;l[q]="^"+l[se]+l[L]+"$";var ne=g++;l[ne]="^"+l[n]+"\\s*("+r+")$|^$";var U=g++;l[U]="^"+l[n]+"\\s*("+t+")$|^$";var k=g++;l[k]="(\\s*)"+l[n]+"\\s*("+r+"|"+l[v]+")",w[k]=new RegExp(l[k],"g");var j=g++;l[j]="^\\s*("+l[v]+")\\s+-\\s+("+l[v]+")\\s*$";var G=g++;l[G]="^\\s*("+l[L]+")\\s+-\\s+("+l[L]+")\\s*$";var te=g++;l[te]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)b(K,l[K]),w[K]||(w[K]=new RegExp(l[K]));function Z(F,V){if(F instanceof _)return F;if(typeof F!="string"||F.length>C||!(V?w[e]:w[a]).test(F))return null;try{return new _(F,V)}catch($){return null}}function _(F,V){if(F instanceof _){if(F.loose===V)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof _))return new _(F,V);b("SemVer",F,V),this.loose=V;var $=F.trim().match(V?w[e]:w[a]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var he=+ae;if(he>=0&&he<R)return he}return ae}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}i.parse=Z,i.valid=function(F,V){var $=Z(F,V);return $?$.version:null},i.clean=function(F,V){var $=Z(F.trim().replace(/^[=v]+/,""),V);return $?$.version:null},i.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof _||(F=new _(F,this.loose)),this.compareMain(F)||this.comparePre(F)},_.prototype.compareMain=function(F){return F instanceof _||(F=new _(F,this.loose)),A(this.major,F.major)||A(this.minor,F.minor)||A(this.patch,F.patch)},_.prototype.comparePre=function(F){if(F instanceof _||(F=new _(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var V=0;do{var $=this.prerelease[V],ae=F.prerelease[V];if(b("prerelease compare",V,$,ae),$===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if($===void 0)return-1;if($!==ae)return A($,ae)}while(++V)},_.prototype.inc=function(F,V){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",V);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",V);break;case"prepatch":this.prerelease.length=0,this.inc("patch",V),this.inc("pre",V);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",V),this.inc("pre",V);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}V&&(this.prerelease[0]===V?isNaN(this.prerelease[1])&&(this.prerelease=[V,0]):this.prerelease=[V,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,V,$,ae){typeof $=="string"&&(ae=$,$=void 0);try{return new _(F,$).inc(V,ae).version}catch(he){return null}},i.diff=function(F,V){if(Q(F,V))return null;var $=Z(F),ae=Z(V);if($.prerelease.length||ae.prerelease.length){for(var he in $)if((he==="major"||he==="minor"||he==="patch")&&$[he]!==ae[he])return"pre"+he;return"prerelease"}for(var he in $)if((he==="major"||he==="minor"||he==="patch")&&$[he]!==ae[he])return he},i.compareIdentifiers=A;var M=/^[0-9]+$/;function A(F,V){var $=M.test(F),ae=M.test(V);return $&&ae&&(F=+F,V=+V),$&&!ae?-1:ae&&!$?1:F<V?-1:F>V?1:0}function B(F,V,$){return new _(F,$).compare(new _(V,$))}function x(F,V,$){return B(F,V,$)>0}function H(F,V,$){return B(F,V,$)<0}function Q(F,V,$){return B(F,V,$)===0}function re(F,V,$){return B(F,V,$)!==0}function ie(F,V,$){return B(F,V,$)>=0}function me(F,V,$){return B(F,V,$)<=0}function ye(F,V,$,ae){var he;switch(V){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),he=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),he=F!==$;break;case"":case"=":case"==":he=Q(F,$,ae);break;case"!=":he=re(F,$,ae);break;case">":he=x(F,$,ae);break;case">=":he=ie(F,$,ae);break;case"<":he=H(F,$,ae);break;case"<=":he=me(F,$,ae);break;default:throw new TypeError("Invalid operator: "+V)}return he}function fe(F,V){if(F instanceof fe){if(F.loose===V)return F;F=F.value}if(!(this instanceof fe))return new fe(F,V);b("comparator",F,V),this.loose=V,this.parse(F),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}i.rcompareIdentifiers=function(F,V){return A(V,F)},i.major=function(F,V){return new _(F,V).major},i.minor=function(F,V){return new _(F,V).minor},i.patch=function(F,V){return new _(F,V).patch},i.compare=B,i.compareLoose=function(F,V){return B(F,V,!0)},i.rcompare=function(F,V,$){return B(V,F,$)},i.sort=function(F,V){return F.sort(function($,ae){return i.compare($,ae,V)})},i.rsort=function(F,V){return F.sort(function($,ae){return i.rcompare($,ae,V)})},i.gt=x,i.lt=H,i.eq=Q,i.neq=re,i.gte=ie,i.lte=me,i.cmp=ye,i.Comparator=fe;var Ie={};function ve(F,V){if(F instanceof ve)return F.loose===V?F:new ve(F.raw,V);if(F instanceof fe)return new ve(F.value,V);if(!(this instanceof ve))return new ve(F,V);if(this.loose=V,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Fe(F,V,$,ae,he,Ce,we,Oe,Pe,Le,Ne,De,Re){return((V=Ee($)?"":Ee(ae)?">="+$+".0.0":Ee(he)?">="+$+"."+ae+".0":">="+V)+" "+(Oe=Ee(Pe)?"":Ee(Le)?"<"+(+Pe+1)+".0.0":Ee(Ne)?"<"+Pe+"."+(+Le+1)+".0":De?"<="+Pe+"."+Le+"."+Ne+"-"+De:"<="+Oe)).trim()}function Me(F,V){for(var $=0;$<F.length;$++)if(!F[$].test(V))return!1;if(V.prerelease.length){for($=0;$<F.length;$++)if(b(F[$].semver),F[$].semver!==Ie&&F[$].semver.prerelease.length>0){var ae=F[$].semver;if(ae.major===V.major&&ae.minor===V.minor&&ae.patch===V.patch)return!0}return!1}return!0}function ze(F,V,$){try{V=new ve(V,$)}catch(ae){return!1}return V.test(F)}function xe(F,V,$,ae){var he,Ce,we,Oe,Pe;switch(F=new _(F,ae),V=new ve(V,ae),$){case">":he=x,Ce=me,we=H,Oe=">",Pe=">=";break;case"<":he=H,Ce=ie,we=x,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(F,V,ae))return!1;for(var Le=0;Le<V.set.length;++Le){var Ne=V.set[Le],De=null,Re=null;if(Ne.forEach(function(ke){ke.semver===Ie&&(ke=new fe(">=0.0.0")),De=De||ke,Re=Re||ke,he(ke.semver,De.semver,ae)?De=ke:we(ke.semver,Re.semver,ae)&&(Re=ke)}),De.operator===Oe||De.operator===Pe||(!Re.operator||Re.operator===Oe)&&Ce(F,Re.semver)||Re.operator===Pe&&we(F,Re.semver))return!1}return!0}fe.prototype.parse=function(F){var V=this.loose?w[ne]:w[U],$=F.match(V);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new _($[2],this.loose):this.semver=Ie},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===Ie||(typeof F=="string"&&(F=new _(F,this.loose)),ye(F,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(F,V){if(!(F instanceof fe))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new ve(F.value,V),ze(this.value,$,V);if(F.operator==="")return $=new ve(this.value,V),ze(F.semver,$,V);var ae=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Oe=ye(this.semver,"<",F.semver,V)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Pe=ye(this.semver,">",F.semver,V)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ae||he||Ce&&we||Oe||Pe},i.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(F){var V=this.loose;F=F.trim(),b("range",F,V);var $=V?w[G]:w[j];F=F.replace($,Fe),b("hyphen replace",F),F=F.replace(w[k],"$1$2$3"),b("comparator trim",F,w[k]),F=(F=(F=F.replace(w[ee],"$1~")).replace(w[ce],"$1^")).split(/\s+/).join(" ");var ae=V?w[ne]:w[U],he=F.split(" ").map(function(Ce){return function(we,Oe){return b("comp",we),we=function(Pe,Le){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Re){b("caret",De,Re);var ke=Re?w[q]:w[W];return De.replace(ke,function(Ae,ge,pe,Se,be){var Te;return b("caret",De,Ae,ge,pe,Se,be),Ee(ge)?Te="":Ee(pe)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Te=ge==="0"?">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+".0 <"+(+ge+1)+".0.0":be?(b("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),Te=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+be+" <"+(+ge+1)+".0.0"):(b("no pr"),Te=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+" <"+(+ge+1)+".0.0"),b("caret return",Te),Te})}(Ne,Le)}).join(" ")}(we,Oe),b("caret",we),we=function(Pe,Le){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Re){var ke=Re?w[le]:w[ue];return De.replace(ke,function(Ae,ge,pe,Se,be){var Te;return b("tilde",De,Ae,ge,pe,Se,be),Ee(ge)?Te="":Ee(pe)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Te=">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":be?(b("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),Te=">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+(+pe+1)+".0"):Te=">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0",b("tilde return",Te),Te})}(Ne,Le)}).join(" ")}(we,Oe),b("tildes",we),we=function(Pe,Le){return b("replaceXRanges",Pe,Le),Pe.split(/\s+/).map(function(Ne){return function(De,Re){De=De.trim();var ke=Re?w[O]:w[S];return De.replace(ke,function(Ae,ge,pe,Se,be,Te){b("xRange",De,Ae,ge,pe,Se,be,Te);var We=Ee(pe),Ve=We||Ee(Se),je=Ve||Ee(be);return ge==="="&&je&&(ge=""),We?Ae=ge===">"||ge==="<"?"<0.0.0":"*":ge&&je?(Ve&&(Se=0),je&&(be=0),ge===">"?(ge=">=",Ve?(pe=+pe+1,Se=0,be=0):je&&(Se=+Se+1,be=0)):ge==="<="&&(ge="<",Ve?pe=+pe+1:Se=+Se+1),Ae=ge+pe+"."+Se+"."+be):Ve?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":je&&(Ae=">="+pe+"."+Se+".0 <"+pe+"."+(+Se+1)+".0"),b("xRange return",Ae),Ae})}(Ne,Le)}).join(" ")}(we,Oe),b("xrange",we),we=function(Pe,Le){return b("replaceStars",Pe,Le),Pe.trim().replace(w[te],"")}(we,Oe),b("stars",we),we}(Ce,V)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(Ce){return!!Ce.match(ae)})),he=he.map(function(Ce){return new fe(Ce,V)})},ve.prototype.intersects=function(F,V){if(!(F instanceof ve))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(ae){return F.set.some(function(he){return he.every(function(Ce){return ae.intersects(Ce,V)})})})})},i.toComparators=function(F,V){return new ve(F,V).set.map(function($){return $.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new _(F,this.loose));for(var V=0;V<this.set.length;V++)if(Me(this.set[V],F))return!0;return!1},i.satisfies=ze,i.maxSatisfying=function(F,V,$){var ae=null,he=null;try{var Ce=new ve(V,$)}catch(we){return null}return F.forEach(function(we){Ce.test(we)&&(ae&&he.compare(we)!==-1||(he=new _(ae=we,$)))}),ae},i.minSatisfying=function(F,V,$){var ae=null,he=null;try{var Ce=new ve(V,$)}catch(we){return null}return F.forEach(function(we){Ce.test(we)&&(ae&&he.compare(we)!==1||(he=new _(ae=we,$)))}),ae},i.validRange=function(F,V){try{return new ve(F,V).range||"*"}catch($){return null}},i.ltr=function(F,V,$){return xe(F,V,"<",$)},i.gtr=function(F,V,$){return xe(F,V,">",$)},i.outside=xe,i.prerelease=function(F,V){var $=Z(F,V);return $&&$.prerelease.length?$.prerelease:null},i.intersects=function(F,V,$){return F=new ve(F,$),V=new ve(V,$),F.intersects(V)},i.coerce=function(F){if(F instanceof _)return F;if(typeof F!="string")return null;var V=F.match(w[N]);return V==null?null:Z((V[1]||"0")+"."+(V[2]||"0")+"."+(V[3]||"0"))}}).call(this,T(1))},function(z,i){var T,I,b=z.exports={};function C(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function w(p){if(T===setTimeout)return setTimeout(p,0);if((T===C||!T)&&setTimeout)return T=setTimeout,setTimeout(p,0);try{return T(p,0)}catch(m){try{return T.call(null,p,0)}catch(P){return T.call(this,p,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:C}catch(p){T=C}try{I=typeof clearTimeout=="function"?clearTimeout:R}catch(p){I=R}})();var l,g=[],y=!1,D=-1;function c(){y&&l&&(y=!1,l.length?g=l.concat(g):D=-1,g.length&&E())}function E(){if(!y){var p=w(c);y=!0;for(var m=g.length;m;){for(l=g,g=[];++D<m;)l&&l[D].run();D=-1,m=g.length}l=null,y=!1,function(P){if(I===clearTimeout)return clearTimeout(P);if((I===R||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(P);try{I(P)}catch(f){try{return I.call(null,P)}catch(s){return I.call(this,P)}}}(p)}}function u(p,m){this.fun=p,this.array=m}function d(){}b.nextTick=function(p){var m=new Array(arguments.length-1);if(arguments.length>1)for(var P=1;P<arguments.length;P++)m[P-1]=arguments[P];g.push(new u(p,m)),g.length!==1||y||w(E)},u.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=d,b.addListener=d,b.once=d,b.off=d,b.removeListener=d,b.removeAllListeners=d,b.emit=d,b.prependListener=d,b.prependOnceListener=d,b.listeners=function(p){return[]},b.binding=function(p){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(p){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Y[59],J([0,1]),function(z,i){"use strict";var T;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class I{constructor(w,l,g){this.level=w,this.key=l,this.value=g,this.forward=[]}}const b=void 0;class C{constructor(w,l=2**16){this.comparator=w,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new I(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,b,b)}has(w){return Boolean(C._search(this,w,this.comparator))}get(w){return C._search(this,w,this.comparator)?.value}set(w,l){return C._insert(this,w,l,this.comparator)&&(this._size+=1),this}delete(w){const l=C._delete(this,w,this.comparator);return l&&(this._size-=1),l}forEach(w,l){let g=this._header.forward[0];for(;g;)w.call(l,g.value,g.key,this),g=g.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",l=this._header.forward[0];for(;l;)w+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return w}static _search(w,l,g){let y=w._header;for(let D=w._level-1;D>=0;D--)for(;y.forward[D]&&g(y.forward[D].key,l)<0;)y=y.forward[D];if(y=y.forward[0],y&&g(y.key,l)===0)return y}static _insert(w,l,g,y){let D=[],c=w._header;for(let E=w._level-1;E>=0;E--){for(;c.forward[E]&&y(c.forward[E].key,l)<0;)c=c.forward[E];D[E]=c}if(c=c.forward[0],c&&y(c.key,l)===0)return c.value=g,!1;{let E=C._randomLevel(w);if(E>w._level){for(let u=w._level;u<E;u++)D[u]=w._header;w._level=E}c=new I(E,l,g);for(let u=0;u<E;u++)c.forward[u]=D[u].forward[u],D[u].forward[u]=c;return!0}}static _randomLevel(w,l=.5){let g=1;for(;Math.random()<l&&g<w._maxLevel;)g+=1;return g}static _delete(w,l,g){let y=[],D=w._header;for(let c=w._level-1;c>=0;c--){for(;D.forward[c]&&g(D.forward[c].key,l)<0;)D=D.forward[c];y[c]=D}if(D=D.forward[0],!D||g(D.key,l)!==0)return!1;for(let c=0;c<w._level&&y[c].forward[c]===D;c++)y[c].forward[c]=D.forward[c];for(;w._level>0&&w._header.forward[w._level-1]===b;)w._level-=1;return!0}}i.SkipList=C}),define(Y[38],J([0,1,7,2]),function(z,i,T,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function b(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(a=>typeof a=="function"):!1}i.isReadableStream=b;function C(f){const s=f;return s?b(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=C;function R(f,s){return new w(f,s)}i.newWriteableStream=R;class w{constructor(s,a){this.reducer=s,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(a=>a(s))}emitError(s){this.listeners.error.length===0?(0,T.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(a=>a(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,a){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(s,a){if(this.state.destroyed)return;let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(f,s){const a=[];let t;for(;(t=f.read())!==null;)a.push(t);return s(a)}i.consumeReadable=l;function g(f,s,a){const t=[];let r;for(;(r=f.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const e=r;return r=void 0,e}return f.read()}}}i.peekReadable=g;function y(f,s){return new Promise((a,t)=>{const r=[];D(f,{onData:e=>{s&&r.push(e)},onError:e=>{s?t(e):a(void 0)},onEnd:()=>{a(s?s(r):void 0)}})})}i.consumeStream=y;function D(f,s){f.on("error",a=>s.onError(a)),f.on("end",()=>s.onEnd()),f.on("data",a=>s.onData(a))}i.listenStream=D;function c(f,s){return new Promise((a,t)=>{const r=new I.DisposableStore,e=[],n=v=>{if(e.push(v),e.length>s)return r.dispose(),f.pause(),a({stream:f,buffer:e,ended:!1})},o=v=>t(v),h=()=>a({stream:f,buffer:e,ended:!0});r.add((0,I.toDisposable)(()=>f.removeListener("error",o))),f.on("error",o),r.add((0,I.toDisposable)(()=>f.removeListener("end",h))),f.on("end",h),r.add((0,I.toDisposable)(()=>f.removeListener("data",n))),f.on("data",n)})}i.peekStream=c;function E(f,s){const a=R(s);return a.end(f),a}i.toStream=E;function u(){const f=R(()=>{throw new Error("not supported")});return f.end(),f}i.emptyStream=u;function d(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}i.toReadable=d;function p(f,s,a){const t=R(a);return D(f,{onData:r=>t.write(s.data(r)),onError:r=>t.error(s.error?s.error(r):r),onEnd:()=>t.end()}),t}i.transform=p;function m(f,s,a){let t=!1;return{read:()=>{const r=s.read();return t?r:(t=!0,r!==null?a([f,r]):f)}}}i.prefixedReadable=m;function P(f,s,a){let t=!1;const r=R(a);return D(s,{onData:e=>t?r.write(e):(t=!0,r.write(a([f,e]))),onError:e=>r.error(e),onEnd:()=>{t||(t=!0,r.write(f)),r.end()}}),r}i.prefixedStream=P}),define(Y[17],J([0,1,38]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const I=typeof Buffer!="undefined";let b,C;class R{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return I?new R(Buffer.allocUnsafe(n)):new R(new Uint8Array(n))}static wrap(n){return I&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new R(n)}static fromString(n,o){return!(o?.dontUseNodeBuffer||!1)&&I?new R(Buffer.from(n)):(b||(b=new TextEncoder),new R(b.encode(n)))}static concat(n,o){if(typeof o=="undefined"){o=0;for(let L=0,S=n.length;L<S;L++)o+=n[L].byteLength}const h=R.alloc(o);let v=0;for(let L=0,S=n.length;L<S;L++){const O=n[L];h.set(O,v),v+=O.byteLength}return h}toString(){return I?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(n,o){return new R(this.buffer.subarray(n,o))}set(n,o){n instanceof R?this.buffer.set(n.buffer,o):this.buffer.set(n,o)}readUInt32BE(n){return g(this.buffer,n)}writeUInt32BE(n,o){y(this.buffer,n,o)}readUInt32LE(n){return D(this.buffer,n)}writeUInt32LE(n,o){c(this.buffer,n,o)}readUInt8(n){return E(this.buffer,n)}writeUInt8(n,o){u(this.buffer,n,o)}}i.VSBuffer=R;function w(e,n){return e[n+0]<<0>>>0|e[n+1]<<8>>>0}i.readUInt16LE=w;function l(e,n,o){e[o+0]=n&255,n=n>>>8,e[o+1]=n&255}i.writeUInt16LE=l;function g(e,n){return e[n]*2**24+e[n+1]*2**16+e[n+2]*2**8+e[n+3]}i.readUInt32BE=g;function y(e,n,o){e[o+3]=n,n=n>>>8,e[o+2]=n,n=n>>>8,e[o+1]=n,n=n>>>8,e[o]=n}i.writeUInt32BE=y;function D(e,n){return e[n+0]<<0>>>0|e[n+1]<<8>>>0|e[n+2]<<16>>>0|e[n+3]<<24>>>0}i.readUInt32LE=D;function c(e,n,o){e[o+0]=n&255,n=n>>>8,e[o+1]=n&255,n=n>>>8,e[o+2]=n&255,n=n>>>8,e[o+3]=n&255}i.writeUInt32LE=c;function E(e,n){return e[n]}i.readUInt8=E;function u(e,n,o){e[o]=n}i.writeUInt8=u;function d(e){return T.consumeReadable(e,n=>R.concat(n))}i.readableToBuffer=d;function p(e){return T.toReadable(e)}i.bufferToReadable=p;function m(e){return T.consumeStream(e,n=>R.concat(n))}i.streamToBuffer=m;async function P(e){return e.ended?R.concat(e.buffer):R.concat([...e.buffer,await m(e.stream)])}i.bufferedStreamToBuffer=P;function f(e){return T.toStream(e,n=>R.concat(n))}i.bufferToStream=f;function s(e){return T.transform(e,{data:n=>typeof n=="string"?R.fromString(n):R.wrap(n)},n=>R.concat(n))}i.streamToBufferReadableStream=s;function a(e){return T.newWriteableStream(n=>R.concat(n),e)}i.newWriteableBufferStream=a;function t(e,n){return T.prefixedReadable(e,n,o=>R.concat(o))}i.prefixedBufferReadable=t;function r(e,n){return T.prefixedStream(e,n,o=>R.concat(o))}i.prefixedBufferStream=r}),define(Y[21],J([0,1,11]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function I(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const p=Array.isArray(d)?[]:{};return Object.keys(d).forEach(m=>{d[m]&&typeof d[m]=="object"?p[m]=I(d[m]):p[m]=d[m]}),p}i.deepClone=I;function b(d){if(!d||typeof d!="object")return d;const p=[d];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const P in m)if(C.call(m,P)){const f=m[P];typeof f=="object"&&!Object.isFrozen(f)&&p.push(f)}}return d}i.deepFreeze=b;const C=Object.prototype.hasOwnProperty;function R(d,p){return w(d,p,new Set)}i.cloneAndChange=R;function w(d,p,m){if((0,T.isUndefinedOrNull)(d))return d;const P=p(d);if(typeof P!="undefined")return P;if((0,T.isArray)(d)){const f=[];for(const s of d)f.push(w(s,p,m));return f}if((0,T.isObject)(d)){if(m.has(d))throw new Error("Cannot clone recursive data-structure");m.add(d);const f={};for(let s in d)C.call(d,s)&&(f[s]=w(d[s],p,m));return m.delete(d),f}return d}function l(d,p,m=!0){return(0,T.isObject)(d)?((0,T.isObject)(p)&&Object.keys(p).forEach(P=>{P in d?m&&((0,T.isObject)(d[P])&&(0,T.isObject)(p[P])?l(d[P],p[P],m):d[P]=p[P]):d[P]=p[P]}),d):p}i.mixin=l;function g(d,p){if(d===p)return!0;if(d==null||p===null||p===void 0||typeof d!=typeof p||typeof d!="object"||Array.isArray(d)!==Array.isArray(p))return!1;let m,P;if(Array.isArray(d)){if(d.length!==p.length)return!1;for(m=0;m<d.length;m++)if(!g(d[m],p[m]))return!1}else{const f=[];for(P in d)f.push(P);f.sort();const s=[];for(P in p)s.push(P);if(s.sort(),!g(f,s))return!1;for(m=0;m<f.length;m++)if(!g(d[f[m]],p[f[m]]))return!1}return!0}i.equals=g;function y(d){const p=new Set;return JSON.stringify(d,(m,P)=>{if((0,T.isObject)(P)||Array.isArray(P)){if(p.has(P))return"[Circular]";p.add(P)}return P})}i.safeStringify=y;function D(d,p,m){const P=p(d);return typeof P=="undefined"?m:P}i.getOrDefault=D;function c(d,p){const m=Object.create(null);return!d||!p||Object.keys(p).forEach(f=>{const s=d[f],a=p[f];g(s,a)||(m[f]=a)}),m}i.distinct=c;function E(d,p){const m=p.toLowerCase(),P=Object.keys(d).find(f=>f.toLowerCase()===m);return P?d[P]:d[p]}i.getCaseInsensitive=E;function u(d,p){const m=Object.create(null);for(const[P,f]of Object.entries(d))p(P,f)&&(m[P]=f);return m}i.filter=u}),define(Y[60],J([0,1,8]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function I(g){const y=g;return y&&typeof y.type=="string"&&typeof y.severity=="string"}i.isRemoteConsoleLog=I;function b(g){const y=[];let D;try{const c=JSON.parse(g.arguments),E=c[c.length-1];E&&E.__$stack&&(c.pop(),D=E.__$stack),y.push(...c)}catch(c){y.push("Unable to log remote console arguments",g.arguments)}return{args:y,stack:D}}i.parse=b;function C(g){if(typeof g!="string")return C(b(g).stack);const y=g;if(y){const D=R(y),c=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if(c&&c.length===4)return{uri:T.URI.file(c[1]),line:Number(c[2]),column:Number(c[3])}}}i.getFirstFrame=C;function R(g){if(!g)return g;const y=g.indexOf(`
`);return y===-1?g:g.substring(0,y)}function w(g,y){const{args:D,stack:c}=b(g),E=typeof D[0]=="string"&&D.length===1;let u=R(c);u&&(u=`(${u.trim()})`);let d=[];if(typeof D[0]=="string"?u&&E?d=[`%c[${y}] %c${D[0]} %c${u}`,l("blue"),l(""),l("grey")]:d=[`%c[${y}] %c${D[0]}`,l("blue"),l(""),...D.slice(1)]:d=[`%c[${y}]%`,l("blue"),...D],u&&!E&&d.push(u),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,d)}i.log=w;function l(g){return`color: ${g}`}}),define(Y[61],J([0,1,17,27,8]),function(z,i,T,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.MarshalledId=i.parse=i.stringify=void 0;function C(y){return JSON.stringify(y,l)}i.stringify=C;function R(y){let D=JSON.parse(y);return D=g(D),D}i.parse=R;var w;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(w=i.MarshalledId||(i.MarshalledId={}));function l(y,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,I.regExpFlags)(D)}:D}function g(y,D=0){if(!y||D>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return b.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof T.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let c=0;c<y.length;++c)y[c]=g(y[c],D+1);else for(const c in y)Object.hasOwnProperty.call(y,c)&&(y[c]=g(y[c],D+1))}return y}i.revive=g}),define(Y[62],J([0,1,47,9,6,12,18,27,8]),function(z,i,T,I,b,C,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function g(n,o,h){if(typeof n=="string"&&(n=l.URI.file(n)),h){const L=h.getWorkspaceFolder(n);if(L){const S=h.getWorkspace().folders.length>1;let O;if((0,R.isEqual)(L.uri,n)?O="":O=(0,R.relativePath)(L.uri,n),S){const N=L.name?L.name:(0,R.basename)(L.uri);O=O?N+" \u2022 "+O:N}return O}}if(n.scheme!==I.Schemas.file&&n.scheme!==I.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(n.fsPath))return(0,b.normalize)(D(n.fsPath));let v=(0,b.normalize)(n.fsPath);return!C.isWindows&&o?.userHome&&(v=E(v,o.userHome.fsPath)),v}i.getPathLabel=g;function y(n){if(!n)return;typeof n=="string"&&(n=l.URI.file(n));const o=(0,R.basename)(n)||(n.scheme===I.Schemas.file?n.fsPath:n.path);return C.isWindows&&(0,T.isRootOrDriveLetter)(o)?D(o):o}i.getBaseLabel=y;function D(n,o){return(0,T.hasDriveLetter)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}i.normalizeDriveLetter=D;let c=Object.create(null);function E(n,o){if(C.isWindows||!n||!o)return n;let h=c.original===o?c.normalized:void 0;return h||(h=`${(0,w.rtrim)(o,b.posix.sep)}${b.posix.sep}`,c={original:o,normalized:h}),(C.isLinux?n.startsWith(h):(0,w.startsWithIgnoreCase)(n,h))&&(n=`~/${n.substr(h.length)}`),n}i.tildify=E;function u(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}i.untildify=u;const d="\u2026",p="\\\\",m="~";function P(n,o=b.sep){const h=new Array(n.length);let v=!1;for(let L=0;L<n.length;L++){let S=n[L];if(S===""){h[L]=`.${o}`;continue}if(!S){h[L]=S;continue}v=!0;let O="";S.indexOf(p)===0?(O=S.substr(0,S.indexOf(p)+p.length),S=S.substr(S.indexOf(p)+p.length)):S.indexOf(o)===0?(O=S.substr(0,S.indexOf(o)+o.length),S=S.substr(S.indexOf(o)+o.length)):S.indexOf(m)===0&&(O=S.substr(0,S.indexOf(m)+m.length),S=S.substr(S.indexOf(m)+m.length));const N=S.split(o);for(let X=1;v&&X<=N.length;X++)for(let ee=N.length-X;v&&ee>=0;ee--){v=!1;let ue=N.slice(ee,ee+X).join(o);for(let le=0;!v&&le<n.length;le++)if(le!==L&&n[le]&&n[le].indexOf(ue)>-1){const se=ee+X===N.length,ce=ee>0&&n[le].indexOf(o)>-1?o+ue:ue,W=n[le].endsWith(ce);v=!se||W}if(!v){let le="";(N[0].endsWith(":")||O!=="")&&(ee===1&&(ee=0,X++,ue=N[0]+o+ue),ee>0&&(le=N[0]+o),le=O+le),ee>0&&(le=le+d+o),le=le+ue,ee+X<N.length&&(le=le+o+d),h[L]=le}}v&&(h[L]=S)}return h}i.shorten=P;var f;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function s(n,o=Object.create(null)){const h=[];let v=!1,L="";for(const S of n)if(S==="$"||v&&S==="{")L&&h.push({value:L,type:f.TEXT}),L="",v=!0;else if(S==="}"&&v){const O=o[L];if(typeof O=="string")O.length&&h.push({value:O,type:f.VARIABLE});else if(O){const N=h[h.length-1];(!N||N.type!==f.SEPARATOR)&&h.push({value:O.label,type:f.SEPARATOR})}L="",v=!1}else L+=S;return L&&!v&&h.push({value:L,type:f.TEXT}),h.filter((S,O)=>{if(S.type===f.SEPARATOR){const N=h[O-1],X=h[O+1];return[N,X].every(ee=>ee&&(ee.type===f.VARIABLE||ee.type===f.TEXT)&&ee.value.length>0)}return!0}).map(S=>S.value).join("")}i.template=s;function a(n,o){return C.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):n.replace(/&&|&/g,h=>h==="&"?"&&":"&")}i.mnemonicMenuLabel=a;function t(n,o){return C.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):C.isWindows?n.replace(/&&|&/g,h=>h==="&"?"&&":"&"):n.replace(/&&/g,"_")}i.mnemonicButtonLabel=t;function r(n){return n.replace(/&/g,"&&")}i.unmnemonicLabel=r;function e(n){const o=n.indexOf("/")!==-1?b.posix:b.win32,h=o.basename(n),v=o.dirname(n);return h.length?{name:h,parentPath:v}:{name:v,parentPath:""}}i.splitName=e}),define(Y[63],J([0,1,131]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class I{constructor(C="utf8"){this.stringDecoder=new T.StringDecoder(C),this.remaining=null}write(C){const R=[],w=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(w.length<1)return R;let l=0,g,y=l;for(;y<w.length;)if(g=w.charCodeAt(y),g===13||g===10){if(R.push(w.substring(l,y)),y++,y<w.length){const D=g;g=w.charCodeAt(y),(D===13&&g===10||D===10&&g===13)&&y++}l=y}else y++;return this.remaining=l<w.length?w.substr(l):null,R}end(){return this.remaining}}i.LineDecoder=I}),define(Y[64],J([0,1,48,6,27,13]),function(z,i,T,I,b,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.realpathSync=i.realpath=i.realcaseSync=void 0;function R(y){const D=(0,I.dirname)(y);if(y===D)return y;const c=((0,I.basename)(y)||y).toLowerCase();try{const u=(0,C.readdirSync)(D).filter(d=>d.toLowerCase()===c);if(u.length===1){const d=R(D);if(d)return(0,I.join)(d,u[0])}else if(u.length>1){const d=u.indexOf(c);if(d>=0){const p=R(D);if(p)return(0,I.join)(p,u[d])}}}catch(E){}return null}i.realcaseSync=R;async function w(y){try{return await C.Promises.realpath(y)}catch(D){const c=g(y);return await C.Promises.access(c,T.constants.R_OK),c}}i.realpath=w;function l(y){try{return T.realpathSync(y)}catch(D){const c=g(y);return T.accessSync(c,T.constants.R_OK),c}}i.realpathSync=l;function g(y){return(0,b.rtrim)((0,I.normalize)(y),I.sep)}}),define(Y[65],J([0,1,34,6,13]),function(z,i,T,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,R=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var l;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(l||(l={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class D{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function c({useAlternateBitness:s=!1}={}){return s?g===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function E({useAlternateBitness:s=!1,findPreview:a=!1}={}){const t=c({useAlternateBitness:s});if(!t)return null;const r=I.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(r))return null;let e=-1,n=null;for(const v of await b.Promises.readdir(r)){let L=-1;if(a){const O=v.indexOf("-");if(O<0)continue;const N=v.substring(0,O);if(!C.test(N)||v.substring(O+1)!=="preview")continue;L=parseInt(N,10)}else{if(!C.test(v))continue;L=parseInt(v,10)}if(L<=e)continue;const S=I.join(r,v,"pwsh.exe");!await b.SymlinkSupport.existsFile(S)||(n=S,e=L)}if(!n)return null;const o=t.includes("x86")?" (x86)":"",h=a?" Preview":"";return new D(n,`PowerShell${h}${o}`,!0)}async function u({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const a=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=s?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const e of await b.Promises.readdir(a))if(t.test(e)){const n=I.join(a,e,"pwsh.exe");return new D(n,r)}return null}function d(){const s=I.join(T.homedir(),".dotnet","tools","pwsh.exe");return new D(s,".NET Core PowerShell Global Tool")}function p(){const s=I.join(process.env.windir,g===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new D(s,"Windows PowerShell",!0)}async function*m(){let s=await E();s&&(yield s),s=await E({useAlternateBitness:!0}),s&&(yield s),s=await u(),s&&(yield s),s=d(),s&&(yield s),s=await E({findPreview:!0}),s&&(yield s),s=await u({findPreview:!0}),s&&(yield s),s=await E({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=p(),s&&(yield s)}async function*P(){for await(const s of m())await s.exists()&&(yield s)}i.enumeratePowerShellInstallations=P;async function f(){for await(const s of P())return s;return null}i.getFirstAvailablePowerShellInstallation=f});var de=this&&this.__decorate||function(z,i,T,I){var b=arguments.length,C=b<3?i:I===null?I=Object.getOwnPropertyDescriptor(i,T):I,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(z,i,T,I);else for(var w=z.length-1;w>=0;w--)(R=z[w])&&(C=(b<3?R(C):b>3?R(i,T,C):R(i,T))||C);return b>3&&C&&Object.defineProperty(i,T,C),C};define(Y[39],J([0,1,19,3,17,24,46,7,10,2,61,27,11]),function(z,i,T,I,b,C,R,w,l,g,y,D,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var E;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(E=i.RequestType||(i.RequestType={}));function u(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(d=i.ResponseType||(i.ResponseType={}));function p(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(m||(m={}));class P{constructor(k){this.buffer=k,this.pos=0}read(k){const j=this.buffer.slice(this.pos,this.pos+k);return this.pos+=j.byteLength,j}}class f{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var s;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(s||(s={}));function a(U){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(U,0),k}function t(U){return U.read(4).readUInt32BE(0)}function r(U){const k=b.VSBuffer.alloc(1);return k.writeUInt8(U,0),k}const e={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object)},n=typeof Buffer!="undefined";function o(U,k){if(typeof k=="undefined")U.write(e.Undefined);else if(typeof k=="string"){const j=b.VSBuffer.fromString(k);U.write(e.String),U.write(a(j.byteLength)),U.write(j)}else if(n&&Buffer.isBuffer(k)){const j=b.VSBuffer.wrap(k);U.write(e.Buffer),U.write(a(j.byteLength)),U.write(j)}else if(k instanceof b.VSBuffer)U.write(e.VSBuffer),U.write(a(k.byteLength)),U.write(k);else if(Array.isArray(k)){U.write(e.Array),U.write(a(k.length));for(const j of k)o(U,j)}else{const j=b.VSBuffer.fromString(JSON.stringify(k));U.write(e.Object),U.write(a(j.byteLength)),U.write(j)}}function h(U){switch(U.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return U.read(t(U)).toString();case s.Buffer:return U.read(t(U)).buffer;case s.VSBuffer:return U.read(t(U));case s.Array:{const j=t(U),G=[];for(let te=0;te<j;te++)G.push(h(U));return G}case s.Object:return JSON.parse(U.read(t(U)).toString())}}class v{constructor(k,j,G=null,te=1e3){this.protocol=k,this.ctx=j,this.logger=G,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(k,j){this.channels.set(k,j),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const j=this.send([k.type]);this.logger&&this.logger.logOutgoing(j,0,1,p(k.type));return}case 201:case 202:case 204:case 203:{const j=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(j,k.id,1,p(k.type),k.data);return}}}send(k,j=void 0){const G=new f;return o(G,k),o(G,j),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(j){return 0}}onRawMessage(k){const j=new P(k),G=h(j),te=h(j),K=G[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(K)}: ${G[2]}.${G[3]}`,te),this.onPromise({type:K,id:G[1],channelName:G[2],name:G[3],arg:te});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(K)}: ${G[2]}.${G[3]}`,te),this.onEventListen({type:K,id:G[1],channelName:G[2],name:G[3],arg:te});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(K)}`),this.disposeActiveRequest({type:K,id:G[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(K)}`),this.disposeActiveRequest({type:K,id:G[1]})}}onPromise(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const G=new C.CancellationTokenSource;let te;try{te=j.call(this.ctx,k.name,k.arg,G.token)}catch(_){te=Promise.reject(_)}const K=k.id;te.then(_=>{this.sendResponse({id:K,data:_,type:201}),this.activeRequests.delete(k.id)},_=>{_ instanceof Error?this.sendResponse({id:K,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:K,data:_,type:203}),this.activeRequests.delete(k.id)});const Z=(0,g.toDisposable)(()=>G.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const G=k.id,K=j.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:G,data:Z,type:204}));this.activeRequests.set(k.id,K)}disposeActiveRequest(k){const j=this.activeRequests.get(k.id);j&&(j.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let j=this.pendingRequests.get(k.channelName);j||(j=[],this.pendingRequests.set(k.channelName,j));const G=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:k,timeoutTimer:G})}flushPendingRequests(k){const j=this.pendingRequests.get(k);if(j){for(const G of j)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}i.ChannelServer=v;var L;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(L=i.RequestInitiator||(i.RequestInitiator={}));class S{constructor(k,j=null){this.protocol=k,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=j}getChannel(k){const j=this;return{call(G,te,K){return j.isDisposed?Promise.reject(w.canceled()):j.requestPromise(k,G,te,K)},listen(G,te){return j.isDisposed?Promise.reject(w.canceled()):j.requestEvent(k,G,te)}}}requestPromise(k,j,G,te=C.CancellationToken.None){const K=this.lastRequestId++,_={id:K,type:100,channelName:k,name:j,arg:G};if(te.isCancellationRequested)return Promise.reject(w.canceled());let M;return new Promise((B,x)=>{if(te.isCancellationRequested)return x(w.canceled());const H=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(K),B(ye.data);break;case 202:this.handlers.delete(K);const fe=new Error(ye.data.message);fe.stack=ye.data.stack,fe.name=ye.data.name,x(fe);break;case 203:this.handlers.delete(K),x(ye.data);break}};this.handlers.set(K,me),this.sendRequest(_)};let Q=null;this.state===m.Idle?H():(Q=(0,I.createCancelablePromise)(me=>this.whenInitialized()),Q.then(()=>{Q=null,H()}));const re=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:K,type:101}),x(w.canceled())},ie=te.onCancellationRequested(re);M=(0,g.combinedDisposable)((0,g.toDisposable)(re),ie),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(k,j,G){const te=this.lastRequestId++,Z={id:te,type:102,channelName:k,name:j,arg:G};let _=null;const M=new l.Emitter({onFirstListenerAdd:()=>{_=(0,I.createCancelablePromise)(B=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(M),this.sendRequest(Z)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(M),this.sendRequest({id:te,type:103}))}}),A=B=>M.fire(B.data);return this.handlers.set(te,A),M.event}sendRequest(k){switch(k.type){case 100:case 102:{const j=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(j,k.id,0,`${u(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const j=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(j,k.id,0,u(k.type));return}}}send(k,j=void 0){const G=new f;return o(G,k),o(G,j),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(j){return 0}}onBuffer(k){const j=new P(k),G=h(j),te=h(j),K=G[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,p(K)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],0,p(K),te),this.onResponse({type:G[0],id:G[1],data:te})}}onResponse(k){if(k.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(k.id);j&&j(k)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}de([R.memoize],S.prototype,"onDidInitializePromise",null),i.ChannelClient=S;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:j,onDidClientDisconnect:G})=>{l.Event.once(j.onMessage)(K=>{const Z=new P(K),_=h(Z),M=new v(j,_),A=new S(j);this.channels.forEach((x,H)=>M.registerChannel(H,x));const B={channelServer:M,channelClient:A,ctx:_};this._connections.add(B),this._onDidAddConnection.fire(B),G(()=>{M.dispose(),A.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const k=[];return this._connections.forEach(j=>k.push(j)),k}getChannel(k,j){const G=this;return{call(te,K,Z){let _;if((0,c.isFunction)(j)){let A=(0,T.getRandomElement)(G.connections.filter(j));_=A?Promise.resolve(A):l.Event.toPromise(l.Event.filter(G.onDidAddConnection,j))}else _=j.routeCall(G,te,K);const M=_.then(A=>A.channelClient.getChannel(k));return X(M).call(te,K,Z)},listen(te,K){if((0,c.isFunction)(j))return G.getMulticastEvent(k,j,te,K);const Z=j.routeEvent(G,te,K).then(_=>_.channelClient.getChannel(k));return X(Z).listen(te,K)}}}getMulticastEvent(k,j,G,te){const K=this;let Z=new g.DisposableStore;const _=new l.Emitter({onFirstListenerAdd:()=>{Z=new g.DisposableStore;const M=new l.EventMultiplexer,A=new Map,B=H=>{const re=H.channelClient.getChannel(k).listen(G,te),ie=M.add(re);A.set(H,ie)},x=H=>{const Q=A.get(H);!Q||(Q.dispose(),A.delete(H))};K.connections.filter(j).forEach(B),l.Event.filter(K.onDidAddConnection,j)(B,void 0,Z),K.onDidRemoveConnection(x,void 0,Z),M.event(_.fire,_,Z),Z.add(M)},onLastListenerRemove:()=>{Z.dispose()}});return _.event}registerChannel(k,j){this.channels.set(k,j),this._connections.forEach(G=>{G.channelServer.registerChannel(k,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=O;class N{constructor(k,j,G=null){const te=new f;o(te,j),k.send(te.buffer),this.channelClient=new S(k,G),this.channelServer=new v(k,j,G)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,j){this.channelServer.registerChannel(k,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=N;function X(U){return{call(k,j,G){return U.then(te=>te.call(k,j,G))},listen(k,j){const G=new l.Relay;return U.then(te=>G.input=te.listen(k,j)),G.event}}}i.getDelayedChannel=X;function ee(U){let k=!1;return{call(j,G,te){return k?U.call(j,G,te):(0,I.timeout)(0).then(()=>k=!0).then(()=>U.call(j,G,te))},listen(j,G){if(k)return U.listen(j,G);const te=new l.Relay;return(0,I.timeout)(0).then(()=>k=!0).then(()=>te.input=U.listen(j,G)),te.event}}}i.getNextTickChannel=ee;class ue{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const j of k.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await l.Event.toPromise(k.onDidAddConnection),await this.route(k)}}i.StaticRouter=ue;var le;(function(U){function k(K,Z){const _=K,M=Z&&Z.disableMarshalling,A=new Map;for(const B in _)G(B)&&A.set(B,l.Event.buffer(_[B],!0));return new class{listen(B,x,H){const Q=A.get(x);if(Q)return Q;if(te(x)){const re=_[x];if(typeof re=="function")return re.call(_,H)}throw new Error(`Event not found: ${x}`)}call(B,x,H){const Q=_[x];if(typeof Q=="function"){if(!M&&Array.isArray(H))for(let re=0;re<H.length;re++)H[re]=(0,y.revive)(H[re]);return Q.apply(_,H)}throw new Error(`Method not found: ${x}`)}}}U.fromService=k;function j(K,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(M,A){if(typeof A=="string")return Z?.properties?.has(A)?Z.properties.get(A):te(A)?function(B){return K.listen(A,B)}:G(A)?K.listen(A):async function(...B){let x;Z&&!(0,c.isUndefinedOrNull)(Z.context)?x=[Z.context,...B]:x=B;const H=await K.call(A,x);return _?H:(0,y.revive)(H)};throw new Error(`Property not found: ${String(A)}`)}})}U.toService=j;function G(K){return K[0]==="o"&&K[1]==="n"&&D.isUpperAsciiLetter(K.charCodeAt(2))}function te(K){return/^onDynamic/.test(K)&&D.isUpperAsciiLetter(K.charCodeAt(9))}})(le=i.ProxyChannel||(i.ProxyChannel={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let k=U.toString();if(k!=="[object Object]")return k}return U}function W(U){return Array.isArray(U)?U.map(ce):ce(U)}function q(U,k,j,G,te,K,Z){Z=W(Z);const _=se[te],M=_[G%_.length];let A=[`%c[${U}]%c[${String(k).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(K)?(A=A.concat(Z),A.push(")")):A.push(Z),console.log.apply(console,A)}i.logWithColors=q;class ne{constructor(k,j){this._outgoingPrefix=k,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,j,G,te,K){this._totalOutgoing+=k,q(this._outgoingPrefix,this._totalOutgoing,k,j,G,te,K)}logIncoming(k,j,G,te,K){this._totalIncoming+=k,q(this._incomingPrefix,this._totalIncoming,k,j,G,te,K)}}i.IPCLogger=ne}),define(Y[66],J([0,1,3,10,2,11]),function(z,i,T,I,b,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var R;(function(D){D[D.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(R=i.StorageHint||(i.StorageHint={}));function w(D){const c=D;return c?.changed instanceof Map||c?.deleted instanceof Set}i.isStorageItemsChangeEvent=w;var l;(function(D){D[D.None=0]="None",D[D.Initialized=1]="Initialized",D[D.Closed=2]="Closed"})(l||(l={}));class g extends b.Disposable{constructor(c,E=Object.create(null)){super();this.database=c,this.options=E,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(c=>this.onDidChangeItemsExternal(c)))}onDidChangeItemsExternal(c){c.changed?.forEach((E,u)=>this.accept(u,E)),c.deleted?.forEach(E=>this.accept(E,void 0))}accept(c,E){if(this.state===l.Closed)return;let u=!1;(0,C.isUndefinedOrNull)(E)?u=this.cache.delete(c):this.cache.get(c)!==E&&(this.cache.set(c,E),u=!0),u&&this._onDidChangeStorage.fire(c)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(c,E){const u=this.cache.get(c);return(0,C.isUndefinedOrNull)(u)?E:u}getBoolean(c,E){const u=this.get(c);return(0,C.isUndefinedOrNull)(u)?E:u==="true"}getNumber(c,E){const u=this.get(c);return(0,C.isUndefinedOrNull)(u)?E:parseInt(u,10)}async set(c,E){if(this.state===l.Closed)return;if((0,C.isUndefinedOrNull)(E))return this.delete(c);const u=String(E);if(this.cache.get(c)!==u)return this.cache.set(c,u),this.pendingInserts.set(c,u),this.pendingDeletes.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async delete(c){if(!(this.state===l.Closed||!this.cache.delete(c)))return this.pendingDeletes.has(c)||this.pendingDeletes.add(c),this.pendingInserts.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch(c){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const c={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(c).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(c){if(!!this.hasPending)return this.doFlush(c)}async doFlush(c){return this.flushDelayer.trigger(()=>this.flushPending(),c)}async whenFlushed(){if(!!this.hasPending)return new Promise(c=>this.whenFlushedCallbacks.push(c))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(c){c.insert&&c.insert.forEach((E,u)=>this.items.set(u,E)),c.delete&&c.delete.forEach(E=>this.items.delete(E))}async close(){}}i.InMemoryStorageDatabase=y}),define(Y[67],J([4,5]),function(z,i){return z.create("vs/base/common/date",i)}),define(Y[68],J([0,1,67]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const I=60,b=I*60,C=b*24,R=C*7,w=C*30,l=C*365;function g(D,c){typeof D!="number"&&(D=D.getTime());const E=Math.round((new Date().getTime()-D)/1e3);if(E<-30)return(0,T.localize)(0,null,g(new Date().getTime()+E*1e3,!1));if(E<30)return(0,T.localize)(1,null);let u;return E<I?(u=E,c?u===1?(0,T.localize)(2,null,u):(0,T.localize)(3,null,u):u===1?(0,T.localize)(4,null,u):(0,T.localize)(5,null,u)):E<b?(u=Math.floor(E/I),c?u===1?(0,T.localize)(6,null,u):(0,T.localize)(7,null,u):u===1?(0,T.localize)(8,null,u):(0,T.localize)(9,null,u)):E<C?(u=Math.floor(E/b),c?u===1?(0,T.localize)(10,null,u):(0,T.localize)(11,null,u):u===1?(0,T.localize)(12,null,u):(0,T.localize)(13,null,u)):E<R?(u=Math.floor(E/C),c?u===1?(0,T.localize)(14,null,u):(0,T.localize)(15,null,u):u===1?(0,T.localize)(16,null,u):(0,T.localize)(17,null,u)):E<w?(u=Math.floor(E/R),c?u===1?(0,T.localize)(18,null,u):(0,T.localize)(19,null,u):u===1?(0,T.localize)(20,null,u):(0,T.localize)(21,null,u)):E<l?(u=Math.floor(E/w),c?u===1?(0,T.localize)(22,null,u):(0,T.localize)(23,null,u):u===1?(0,T.localize)(24,null,u):(0,T.localize)(25,null,u)):(u=Math.floor(E/l),c?u===1?(0,T.localize)(26,null,u):(0,T.localize)(27,null,u):u===1?(0,T.localize)(28,null,u):(0,T.localize)(29,null,u))}i.fromNow=g;function y(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=y}),define(Y[69],J([4,5]),function(z,i){return z.create("vs/base/common/errorMessage",i)}),define(Y[28],J([0,1,19,11,69]),function(z,i,T,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toErrorMessage=void 0;function C(g,y){return y&&(g.stack||g.stacktrace)?b.localize(0,null,w(g),R(g.stack)||R(g.stacktrace)):w(g)}function R(g){return Array.isArray(g)?g.join(`
`):g}function w(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?b.localize(1,null,g.message):g.message||b.localize(2,null)}function l(g=null,y=!1){if(!g)return b.localize(3,null);if(Array.isArray(g)){const D=T.coalesce(g),c=l(D[0],y);return D.length>1?b.localize(4,null,c,D.length):c}if(I.isString(g))return g;if(g.detail){const D=g.detail;if(D.error)return C(D.error,y);if(D.exception)return C(D.exception,y)}return g.stack?C(g,y):g.message?g.message:b.localize(5,null)}i.toErrorMessage=l}),define(Y[70],J([4,5]),function(z,i){return z.create("vs/base/node/processes",i)}),define(Y[49],J([0,1,40,47,9,21,6,12,29,58,11,63,13,70]),function(z,i,T,I,b,C,R,w,l,g,y,D,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function u(t){switch(t){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(t,r){if(w.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const n=T.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise(o=>{n.once("error",h=>{o({success:!1,error:h})}),n.once("exit",(h,v)=>{o(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?u(e.status):1})}else if(w.isLinux||w.isMacintosh)try{const e=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(n=>{T.execFile(e,[t.pid.toString()],{encoding:"utf8",shell:!0},(o,h,v)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}function p(t){!t||(delete t.DEBUG,w.isMacintosh&&delete t.DYLD_LIBRARY_PATH,w.isLinux&&delete t.LD_PRELOAD)}i.removeDangerousEnvVariables=p;function m(t=l.env){return t.comspec||"cmd.exe"}i.getWindowsShell=m;class P{constructor(r,e,n,o){if(e!==void 0&&n!==void 0&&o!==void 0)this.cmd=r,this.args=e,this.shell=n,this.options=o;else{const h=r;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(l.env).forEach(v=>{h[v]=l.env[v]}),Object.keys(this.options.env).forEach(v=>{h[v]=this.options.env[v]}),this.options.env=h}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(R.sep);return e!==-1&&(r=r.substring(e+1)),P.WellKnowCommands[r]?r:"other"}start(r){return w.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(l.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(e=>{let n,o;const h=new Promise((v,L)=>{n=v,o=L});if(e){let v=this.cmd;this.args&&(v=v+" "+this.args.join(" ")),this.childProcess=T.exec(v,this.options,(L,S,O)=>{this.childProcess=null;const N=L;N&&N.killed?o({killed:this.terminateRequested,stdout:S.toString(),stderr:O.toString()}):this.handleExec(n,r,L,S,O)})}else{let v=null;const L=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,n,r,o);const O={terminated:this.terminateRequested};y.isNumber(S)&&(O.cmdCode=S),n(O)};if(this.shell&&w.isWindows){const S=C.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let O=!1,N=!1;const X=[];let ee=this.ensureQuotes(this.cmd);X.push(ee.value),O=ee.quoted,this.args&&this.args.forEach(le=>{ee=this.ensureQuotes(le),X.push(ee.value),N=N&&ee.quoted});const ue=["/s","/c"];O?N?ue.push('"'+X.join(" ")+'"'):X.length>1?ue.push('"'+X[0]+'" '+X.slice(1).join(" ")):ue.push('"'+X[0]+'"'):ue.push(X.join(" ")),v=T.spawn(m(),ue,S)}else this.cmd&&(v=T.spawn(this.cmd,this.args,this.options));v&&(this.childProcess=v,this.childProcessPromise=Promise.resolve(v),this.pidResolve&&(this.pidResolve(y.isNumber(v.pid)?v.pid:-1),this.pidResolve=void 0),v.on("error",S=>{this.childProcess=null,o({terminated:this.terminateRequested,error:S})}),v.pid&&(this.childProcess.on("close",L),this.handleSpawn(v,n,r,o,!0)))}return h})}handleClose(r,e,n,o){}ensureQuotes(r){return P.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,d(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!w.isWindows)return r(!1);const e=T.spawn(m(),["/s","/c"]);e.on("error",n=>r(!0)),e.on("exit",n=>r(!1))})}}i.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class f extends P{constructor(r,e,n,o){super(r,e,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,n,o,h){[o,h].forEach((v,L)=>{const S=new D.LineDecoder;S.write(v).forEach(X=>{e({line:X,source:L===0?0:1})});const N=S.end();N&&e({line:N,source:L===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,e,n,o,h){const v=new D.LineDecoder,L=new D.LineDecoder;r.stdout.on("data",S=>{v.write(S).forEach(N=>n({line:N,source:0}))}),r.stderr.on("data",S=>{L.write(S).forEach(N=>n({line:N,source:1}))}),this.stdoutLineDecoder=v,this.stderrLineDecoder=L}handleClose(r,e,n,o){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&n({line:h,source:0});const v=this.stderrLineDecoder?this.stderrLineDecoder.end():null;v&&n({line:v,source:1})}}i.LineProcess=f;function s(t){let r=[],e=!1;const n=function(o){if(e){r.push(o);return}(!t.send(o,v=>{if(v&&console.error(v),e=!1,r.length>0){const L=r.slice(0);r=[],L.forEach(S=>n(S))}})||w.isWindows)&&(e=!0)};return{send:n}}i.createQueuedSender=s;var a;(function(t){async function r(e,n,o){if(R.isAbsolute(e))return e;if(n===void 0&&(n=l.cwd()),R.dirname(e)!=="."||(o===void 0&&y.isString(l.env.PATH)&&(o=l.env.PATH.split(R.delimiter)),o===void 0||o.length===0))return R.join(n,e);async function v(L){if(await c.Promises.exists(L)){let S;try{S=await c.Promises.stat(L)}catch(O){O.message.startsWith("EACCES")&&(S=await c.Promises.lstat(L))}return S?!S.isDirectory():!1}return!1}for(let L of o){let S;if(R.isAbsolute(L)?S=R.join(L,e):S=R.join(n,L,e),await v(S))return S;let O=S+".com";if(await v(O)||(O=S+".exe",await v(O)))return O}return R.join(n,e)}t.findExecutable=r})(a=i.win32||(i.win32={}))}),define(Y[71],J([0,1,34,12,65,49]),function(z,i,T,I,b,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function R(E,u){return E===1?I.isWindows?D():C.getWindowsShell(u):g(E,u)}i.getSystemShell=R;function w(E,u){return E===1?I.isWindows?c(u):C.getWindowsShell(u):g(E,u)}i.getSystemShellSync=w;let l=null;function g(E,u){if(I.isLinux&&E===2||I.isMacintosh&&E===3)return"/bin/bash";if(!l){let d;if(I.isWindows)d="/bin/bash";else{if(d=u.SHELL,!d)try{d=(0,T.userInfo)().shell}catch(p){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}l=d}return l}let y=null;async function D(){return y||(y=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),y}function c(E){if(y)return y;const u=I.isWindows&&parseFloat((0,T.release)())>=10,d=E.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${E.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?p:C.getWindowsShell(E)}}),define(Y[50],J([0,1,40,3,17,24,60,7,10,2,21,49,39]),function(z,i,T,I,b,C,R,w,l,g,y,D,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class E extends c.ChannelServer{constructor(p){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(P){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",m=>b.VSBuffer.wrap(Buffer.from(m,"base64")))},p);process.once("disconnect",()=>this.dispose())}}i.Server=E;class u{constructor(p,m){this.modulePath=p,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new I.Delayer(P),this.child=null,this._client=null}getChannel(p){const m=this;return{call(P,f,s){return m.requestPromise(p,P,f,s)},listen(P,f){return m.requestEvent(p,P,f)}}}requestPromise(p,m,P,f=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(p),a=(0,I.createCancelablePromise)(e=>s.call(m,P,e)),t=f.onCancellationRequested(()=>a.cancel()),r=(0,g.toDisposable)(()=>a.cancel());return this.activeRequests.add(r),a.finally(()=>{t.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(p,m,P){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let f;const s=new l.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(p).listen(m,P)(s.fire,s),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,D.removeDangerousEnvVariables)(m.env),this.child=(0,T.fork)(this.modulePath,p,m);const P=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,R.isRemoteConsoleLog)(n)){(0,R.log)(n,`IPC Library: ${this.options.serverName}`);return}P.fire(b.VSBuffer.wrap(Buffer.from(n,"base64")))});const s=this.options.useQueue?(0,D.createQueuedSender)(this.child):this.child,a=n=>this.child&&this.child.connected&&s.send(n.buffer.toString("base64")),t=P.event,r={send:a,onMessage:t};this._client=new c.ChannelClient(r);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",e),this.activeRequests.forEach(h=>(0,g.dispose)(h)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(p){let m=this.channels.get(p);return m||(m=this.client.getChannel(p),this.channels.set(p,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=u}),define(Y[72],J([4,5]),function(z,i){return z.create("vs/base/node/zip",i)}),define(Y[73],J([4,5]),function(z,i){return z.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Y[74],J([4,5]),function(z,i){return z.create("vs/platform/environment/node/shellEnv",i)}),define(Y[75],J([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Y[76],J([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Y[77],J([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(Y[78],J([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Y[79],J([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Y[80],J([4,5]),function(z,i){return z.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(Y[81],J([4,5]),function(z,i){return z.create("vs/platform/extensions/common/extensionValidator",i)}),define(Y[82],J([4,5]),function(z,i){return z.create("vs/platform/files/common/fileService",i)}),define(Y[83],J([4,5]),function(z,i){return z.create("vs/platform/files/common/io",i)}),define(Y[84],J([4,5]),function(z,i){return z.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Y[85],J([4,5]),function(z,i){return z.create("vs/platform/request/common/request",i)}),define(Y[86],J([4,5]),function(z,i){return z.create("vs/platform/telemetry/common/telemetryService",i)}),define(Y[87],J([0,1,68,46,9,6,29,18,8]),function(z,i,T,I,b,C,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class g{constructor(d,p,m){this._args=d,this.paths=p,this.productService=m}get appRoot(){return(0,C.dirname)(b.FileAccess.asFileUri("",z).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(l.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=R.env.VSCODE_PORTABLE;return d?l.URI.file((0,C.join)(d,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,w.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,C.resolve)(d):(0,C.normalize)((0,C.join)(b.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,C.resolve)(d):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,C.resolve)(d);const p=R.env.VSCODE_EXTENSIONS;if(p)return p;const m=R.env.VSCODE_PORTABLE;return m?(0,C.join)(m,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(p=>/^[^:/?#]+?:\/\//.test(p)?l.URI.parse(p):l.URI.file((0,C.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?l.URI.parse(d):l.URI.file((0,C.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,w.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([I.memoize],g.prototype,"appRoot",null),de([I.memoize],g.prototype,"userHome",null),de([I.memoize],g.prototype,"userDataPath",null),de([I.memoize],g.prototype,"appSettingsHome",null),de([I.memoize],g.prototype,"tmpDir",null),de([I.memoize],g.prototype,"userRoamingDataHome",null),de([I.memoize],g.prototype,"settingsResource",null),de([I.memoize],g.prototype,"userDataSyncHome",null),de([I.memoize],g.prototype,"userDataSyncLogResource",null),de([I.memoize],g.prototype,"sync",null),de([I.memoize],g.prototype,"machineSettingsResource",null),de([I.memoize],g.prototype,"globalStorageHome",null),de([I.memoize],g.prototype,"workspaceStorageHome",null),de([I.memoize],g.prototype,"keybindingsResource",null),de([I.memoize],g.prototype,"keyboardLayoutResource",null),de([I.memoize],g.prototype,"argvResource",null),de([I.memoize],g.prototype,"snippetsHome",null),de([I.memoize],g.prototype,"isExtensionDevelopment",null),de([I.memoize],g.prototype,"untitledWorkspacesHome",null),de([I.memoize],g.prototype,"installSourcePath",null),de([I.memoize],g.prototype,"builtinExtensionsPath",null),de([I.memoize],g.prototype,"extensionsPath",null),de([I.memoize],g.prototype,"extensionDevelopmentLocationURI",null),de([I.memoize],g.prototype,"extensionDevelopmentKind",null),de([I.memoize],g.prototype,"extensionTestsLocationURI",null),de([I.memoize],g.prototype,"debugExtensionHost",null),de([I.memoize],g.prototype,"serviceMachineIdResource",null),de([I.memoize],g.prototype,"telemetryLogResource",null),de([I.memoize],g.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=g;function y(u,d){return E(u["inspect-extensions"],u["inspect-brk-extensions"],5870,d,u.debugId,u.extensionEnvironment)}i.parseExtensionHostPort=y;function D(u,d){return E(u["inspect-search"],u["inspect-brk-search"],5876,d,u.extensionEnvironment)}i.parseSearchPort=D;function c(u,d){return E(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,d,u.extensionEnvironment)}i.parsePtyHostPort=c;function E(u,d,p,m,P,f){const a=Number(d||u)||(m?null:p),t=a?Boolean(!!d):!1;let r;if(f)try{r=JSON.parse(f)}catch{}return{port:a,break:t,debugId:P,env:r}}}),function(){"use strict";function z(i,T,I,b){function C(w){const l=R(w),g=[l];return i.isAbsolute(l)||g.unshift(b),i.resolve(...g)}function R(w){const l=process.env.VSCODE_PORTABLE;if(l)return i.join(l,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return i.join(g,I);const y=w["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const D=process.env.USERPROFILE;if(typeof D!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=i.join(D,"AppData","Roaming")}break;case"darwin":g=i.join(T.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||i.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(g,I)}return{getUserDataPath:C}}if(typeof define=="function")define(Y[88],J([0,132,34,9,18,29]),function(i,T,I,b,C,R){const w=C.dirname(b.FileAccess.asFileUri("",i)),l=i.__$__nodeRequire(C.joinPath(w,"package.json").fsPath);return z(T,I,l.name,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),T=require("path"),I=require("os");module.exports=z(T,I,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[89],J([0,1,34,87,88]),function(z,i,T,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class C extends I.AbstractNativeEnvironmentService{constructor(w,l){super(w,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,b.getUserDataPath)(w)},l)}}i.NativeEnvironmentService=C}),define(Y[90],J([0,1,21]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const I=/^%([\w\d.-]+)%$/i;function b(C,R){const w=l=>{if(typeof l!="string")return;const g=I.exec(l);if(!g)return;const y=R[g[1]]??l;return typeof y=="string"?y:typeof y.message=="string"?y.message:l};return(0,T.cloneAndChange)(C,w)}i.localizeManifest=b}),define(Y[51],J([0,1,81]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function C(c){return c=c.trim(),c==="*"||I.test(c)}i.isValidVersionStr=C;function R(c){if(!C(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=c.match(I);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}i.parseVersion=R;function w(c){if(!c)return null;let E=c.majorBase,u=c.majorMustEqual,d=c.minorBase,p=c.minorMustEqual,m=c.patchBase,P=c.patchMustEqual;c.hasCaret&&(E===0||(p=!1),P=!1);let f=0;if(c.preRelease){const s=b.exec(c.preRelease);if(s){const[,a,t,r]=s;f=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:E,majorMustEqual:u,minorBase:d,minorMustEqual:p,patchBase:m,patchMustEqual:P,isMinimum:c.hasGreaterEquals,notBefore:f}}i.normalizeVersion=w;function l(c,E,u){let d;typeof c=="string"?d=w(R(c)):d=c;let p;E instanceof Date?p=E.getTime():typeof E=="string"&&(p=new Date(E).getTime());let m;if(typeof u=="string"?m=w(R(u)):m=u,!d||!m)return!1;let P=d.majorBase,f=d.minorBase,s=d.patchBase,a=m.majorBase,t=m.minorBase,r=m.patchBase,e=m.notBefore,n=m.majorMustEqual,o=m.minorMustEqual,h=m.patchMustEqual;return m.isMinimum?P>a?!0:P<a?!1:f>t?!0:f<t||p&&p<e?!1:s>=r:(P===1&&a===0&&(!n||!o||!h)&&(a=1,t=0,r=0,n=!0,o=!1,h=!1),P<a?!1:P>a?!n:f<t?!1:f>t?!o:s<r?!1:s>r?!h:!(p&&p<e))}i.isValidVersion=l;function g(c,E,u,d){return u.isBuiltin||typeof u.main=="undefined"?!0:D(c,E,u.engines.vscode,d)}i.isValidExtensionVersion=g;function y(c,E,u){return c==="*"||D(E,u,c)}i.isEngineValid=y;function D(c,E,u,d=[]){let p=w(R(u));if(!p)return d.push(T.localize(0,null,u)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return d.push(T.localize(1,null,u)),!1}else if(!p.majorMustEqual)return d.push(T.localize(2,null,u)),!1;return l(c,E,p)?!0:(d.push(T.localize(3,null,c,u)),!1)}}),define(Y[41],J([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class T{constructor(b,C=[],R=!1){this.ctor=b,this.staticArguments=C,this.supportsDelayedInstantiation=R}}i.SyncDescriptor=T}),define(Y[91],J([0,1,41]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const I=[];function b(R,w,l){w instanceof T.SyncDescriptor||(w=new T.SyncDescriptor(w,[],l)),I.push([R,w])}i.registerSingleton=b;function C(){return I}i.getSingletonServiceDescriptors=C}),define(Y[92],J([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class T{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}i.Node=T;class I{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let R of this._nodes.values())R.outgoing.size===0&&C.push(R);return C}insertEdge(C,R){const w=this.lookupOrInsertNode(C),l=this.lookupOrInsertNode(R);w.outgoing.set(this._hashFn(R),l),l.incoming.set(this._hashFn(C),w)}removeNode(C){const R=this._hashFn(C);this._nodes.delete(R);for(let w of this._nodes.values())w.outgoing.delete(R),w.incoming.delete(R)}lookupOrInsertNode(C){const R=this._hashFn(C);let w=this._nodes.get(R);return w||(w=new T(C),this._nodes.set(R,w)),w}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[R,w]of this._nodes)C.push(`${R}, (incoming)[${[...w.incoming.keys()].join(", ")}], (outgoing)[${[...w.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,R]of this._nodes){const w=new Set([C]),l=this._findCycle(R,w);if(l)return l}}_findCycle(C,R){for(let[w,l]of C.outgoing){if(R.has(w))return[...R,w].join(" -> ");R.add(w);const g=this._findCycle(l,R);if(g)return g;R.delete(w)}}}i.Graph=I}),define(Y[52],J([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Y[20],J([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,T.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,T.refineServiceDecorator)(i.IEnvironmentService)}),define(Y[22],J([0,1,9,76,14]),function(z,i,T,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";var C;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(C=i.TargetPlatform||(i.TargetPlatform={}));function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=R;function w(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=w;function l(f,s){switch(f){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=l;function g(f,s){return s==="web"&&!f.includes("web")}i.isNotWebExtensionInWebTargetPlatform=g;function y(f,s,a){return g(s,a)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===a?!0:D(a).includes(f)}i.isTargetPlatformCompatible=y;function D(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=D;function c(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}i.isIExtensionIdentifier=c;var E;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(E=i.SortBy||(i.SortBy={}));var u;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(u=i.SortOrder||(i.SortOrder={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d=i.StatisticType||(i.StatisticType={}));var p;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(p=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.Malicious="Malicious",f.Incompatible="Incompatible",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(m=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class P extends Error{constructor(s,a){super(s);this.code=a,this.name=a}}i.ExtensionManagementError=P,i.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",z).toString(!0),i.ExtensionsLabel=(0,I.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,I.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService")}),define(Y[93],J([0,1,40,6,74,24,28,7,12,31,71,133,3]),function(z,i,T,I,b,C,R,w,l,g,y,D,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveShellEnv=void 0;const E=1e4;let u;async function d(m,P,f){return P["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,D.isLaunchedFromCli)(f)&&!P["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,D.isLaunchedFromCli)(f)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=c.Promises.withAsyncBody(async(s,a)=>{const t=new C.CancellationTokenSource,r=setTimeout(()=>{t.dispose(!0),a(new Error((0,b.localize)(0,null)))},E);try{s(await p(m,t.token))}catch(e){!(0,w.isPromiseCanceledError)(e)&&!t.token.isCancellationRequested?a(new Error((0,b.localize)(1,null,(0,R.toErrorMessage)(e)))):s({})}finally{clearTimeout(r),t.dispose()}})),u)}i.resolveShellEnv=d;async function p(m,P){const f=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",f);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",s);const a=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",r);const e=await(0,y.getSystemShell)(l.OS,r);return m.trace("getUnixShellEnvironment#shell",e),new Promise((n,o)=>{if(P.isCancellationRequested)return o((0,w.canceled)());const h=(0,I.basename)(e);let v,L;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(v=`& '${process.execPath}' ${S} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,L=["-Login","-Command"]):(v=`'${process.execPath}' ${S} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,h==="tcsh"?L=["-ic"]:L=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(L),v);const O=(0,T.spawn)(e,[...L,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});P.onCancellationRequested(()=>(O.kill(),o((0,w.canceled)()))),O.on("error",ee=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(ee)),o(ee)});const N=[];O.stdout.on("data",ee=>N.push(ee));const X=[];O.stderr.on("data",ee=>X.push(ee)),O.on("close",(ee,ue)=>{const le=Buffer.concat(N).toString("utf8");m.trace("getUnixShellEnvironment#raw",le);const se=Buffer.concat(X).toString("utf8");if(se.trim()&&m.trace("getUnixShellEnvironment#stderr",se),ee||ue)return o(new Error((0,b.localize)(2,null,ee,ue)));const ce=t.exec(le),W=ce?ce[1]:"{}";try{const q=JSON.parse(W);f?q.ELECTRON_RUN_AS_NODE=f:delete q.ELECTRON_RUN_AS_NODE,s?q.ELECTRON_NO_ATTACH_CONSOLE=s:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",q),n(q)}catch(q){m.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(q)),o(q)}})})}}),define(Y[53],J([0,1,17,7,83,16]),function(z,i,T,I,b,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function R(y,D,c,E,u,d){let p;try{await w(y,D,c,E,u,d)}catch(m){p=m}finally{p&&u.errorTransformer&&(p=u.errorTransformer(p)),typeof p!="undefined"&&c.error(p),c.end()}}i.readFileIntoStream=R;async function w(y,D,c,E,u,d){l(d);const p=await y.open(D,{create:!1});try{l(d);let m=0,P=0,f=u&&typeof u.length=="number"?u.length:void 0,s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),a=u&&typeof u.position=="number"?u.position:0,t=0;do P=await y.read(p,a,s.buffer,t,s.byteLength-t),a+=P,t+=P,m+=P,typeof f=="number"&&(f-=P),t===s.byteLength&&(await c.write(E(s)),s=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),t=0);while(P>0&&(typeof f!="number"||f>0)&&l(d)&&g(m,u));if(t>0){let r=t;typeof f=="number"&&(r=Math.min(t,f)),c.write(E(s.slice(0,r)))}}catch(m){throw(0,C.ensureFileSystemProviderError)(m)}finally{await y.close(p)}}function l(y){if(y.isCancellationRequested)throw(0,I.canceled)();return!0}function g(y,D){if(D?.limits){if(typeof D.limits.memory=="number"&&y>D.limits.memory)throw(0,C.createFileSystemProviderError)((0,b.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof D.limits.size=="number"&&y>D.limits.size)throw(0,C.createFileSystemProviderError)((0,b.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[35],J([0,1,2,12,8,16]),function(z,i,T,I,b,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.coalesceEvents=i.toFileChanges=i.WatcherService=i.AbstractWatcherService=void 0;class R extends T.Disposable{constructor(c,E,u){super();this.onFileChanges=c,this.onLogMessage=E,this.verboseLogging=u,this.serviceDisposables=this._register(new T.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new T.DisposableStore;this.serviceDisposables.value=c,this.service=this.createService(c),this.service.setVerboseLogging(this.verboseLogging),c.add(this.service.onDidChangeFile(E=>this.onFileChanges(E))),c.add(this.service.onDidLogMessage(E=>this.onLogMessage(E))),c.add(this.service.onDidError(E=>this.onError(E)))}onError(c){this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.service?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.service?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${c}`})}dispose(){return this.service=void 0,super.dispose()}}i.AbstractWatcherService=R,R.MAX_RESTARTS=5;class w extends T.Disposable{}i.WatcherService=w;function l(D){return D.map(c=>({type:c.type,resource:b.URI.file(c.path)}))}i.toFileChanges=l;function g(D){const c=new y;for(const E of D)c.processEvent(E);return c.coalesce()}i.coalesceEvents=g;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return I.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const E=this.mapPathToChange.get(this.toKey(c));let u=!1;if(E){const d=E.type,p=c.type;E.path!==c.path&&c.type===2?u=!0:d===1&&p===2?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(E)):d===2&&p===1?E.type=0:d===1&&p===0||(E.type=p)}else u=!0;u&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],E=[];return Array.from(this.coalesced).filter(u=>u.type!==2?(c.push(u),!1):!0).sort((u,d)=>u.path.length-d.path.length).filter(u=>E.some(d=>(0,C.isParent)(u.path,d,!I.isLinux))?!1:(E.push(u.path),!0)).concat(c)}}}),define(Y[94],J([0,1,3,2,6,64,13,134,35]),function(z,i,T,I,b,C,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class g extends I.Disposable{constructor(D,c,E,u){super();this.path=D,this.onDidFilesChange=c,this.onLogMessage=E,this.verboseLogging=u,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(w.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(D){this.verboseLogging=D}async startWatching(){try{const{stat:D,symbolicLink:c}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let E=this.path;if(c)try{E=await(0,C.realpath)(E)}catch(u){if(this.onError(u),c.dangling)return}D.isDirectory()?this._register((0,w.watchFolder)(E,(u,d)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,b.join)(this.path,(0,b.basename)(d))})},u=>this.onError(u))):this._register((0,w.watchFile)(E,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(D){D.code!=="ENOENT"&&this.onError(D)}}onFileChange(D){this.fileChangesBuffer.push(D),this.verboseLogging&&this.onVerbose(`${D.type===1?"[ADDED]":D.type===2?"[DELETED]":"[CHANGED]"} ${D.path}`),this.fileChangesDelayer.trigger(async()=>{const c=this.fileChangesBuffer;this.fileChangesBuffer=[];const E=(0,l.coalesceEvents)(c);if(this.verboseLogging)for(const u of E)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);E.length>0&&this.onDidFilesChange(E)})}onError(D){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${D}`})}onVerbose(D){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${D}`})}dispose(){this.isDisposed=!0,super.dispose()}}i.FileWatcher=g}),define(Y[95],J([0,1,9,39,50,35]),function(z,i,T,I,b,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class R extends C.WatcherService{constructor(l,g,y){super();this.onDidFilesChange=l,this.onLogMessage=g,this.verboseLogging=y,this.isDisposed=!1,this.startWatching()}startWatching(){const l=this._register(new b.Client(T.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=I.ProxyChannel.toService((0,I.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g)))}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}async watch(l){this.isDisposed||await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}i.FileWatcher=R}),define(Y[96],J([0,1,9,39,50,35]),function(z,i,T,I,b,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class R extends C.AbstractWatcherService{constructor(l,g,y){super(l,g,y);this.init()}createService(l){const g=l.add(new b.Client(T.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(g.onDidProcessExit(({code:y,signal:D})=>this.onError(`terminated by itself with code ${y}, signal: ${D}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(g.getChannel("watcher")))}}i.FileWatcher=R}),define(Y[54],J([0,1]),function(z,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class T{constructor(...b){this._entries=new Map;for(let[C,R]of b)this.set(C,R)}set(b,C){const R=this._entries.get(b);return this._entries.set(b,C),R}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}i.ServiceCollection=T}),define(Y[97],J([0,1,3,7,41,92,14,54]),function(z,i,T,I,b,C,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InstantiationService=void 0;const l=!1;class g extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class y{constructor(u=new w.ServiceCollection,d=!1,p){this._activeInstantiations=new Set,this._services=u,this._strict=d,this._parent=p,this._services.set(R.IInstantiationService,this)}createChild(u){return new y(u,this._strict,this)}invokeFunction(u,...d){let p=c.traceInvocation(u),m=!1;try{return u({get:f=>{if(m)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(f,p);if(!s)throw new Error(`[invokeFunction] unknown service '${f}'`);return s}},...d)}finally{m=!0,p.stop()}}createInstance(u,...d){let p,m;return u instanceof b.SyncDescriptor?(p=c.traceCreation(u.ctor),m=this._createInstance(u.ctor,u.staticArguments.concat(d),p)):(p=c.traceCreation(u),m=this._createInstance(u,d,p)),p.stop(),m}_createInstance(u,d=[],p){let m=R._util.getServiceDependencies(u).sort((s,a)=>s.index-a.index),P=[];for(const s of m){let a=this._getOrCreateServiceInstance(s.id,p);if(!a&&this._strict&&!s.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${s.id}.`);P.push(a)}let f=m.length>0?m[0].index:d.length;if(d.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${d.length} static arguments`);let s=f-d.length;s>0?d=d.concat(new Array(s)):d=d.slice(0,f)}return new u(...[...d,...P])}_setServiceInstance(u,d){if(this._services.get(u)instanceof b.SyncDescriptor)this._services.set(u,d);else if(this._parent)this._parent._setServiceInstance(u,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let d=this._services.get(u);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):d}_getOrCreateServiceInstance(u,d){let p=this._getServiceInstanceOrDescriptor(u);return p instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,p,d.branch(u,!0)):(d.branch(u,!1),p)}_safeCreateAndCacheServiceInstance(u,d,p){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,d,p)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,d,p){const m=new C.Graph(s=>s.id.toString());let P=0;const f=[{id:u,desc:d,_trace:p}];for(;f.length;){const s=f.pop();if(m.lookupOrInsertNode(s),P++>1e3)throw new g(m);for(let a of R._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),t instanceof b.SyncDescriptor){const r={id:a.id,desc:t,_trace:s._trace.branch(a.id,!0)};m.insertEdge(s,r),f.push(r)}}}for(;;){const s=m.roots();if(s.length===0){if(!m.isEmpty())throw new g(m);break}for(const{data:a}of s){if(this._getServiceInstanceOrDescriptor(a.id)instanceof b.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}m.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,d,p=[],m,P){if(this._services.get(u)instanceof b.SyncDescriptor)return this._createServiceInstance(d,p,m,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,d,p,m,P);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(u,d=[],p,m){if(p){const P=new T.IdleValue(()=>this._createInstance(u,d,m));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let a=P.value,t=a[s];return typeof t!="function"||(t=t.bind(a),f[s]=t),t},set(f,s,a){return P.value[s]=a,!0}})}else return this._createInstance(u,d,m)}}i.InstantiationService=y;var D;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(D||(D={}));class c{constructor(u,d){this.type=u,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new c(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(u){return l?new c(0,u.name):c._None}branch(u,d){let p=new c(2,u.toString());return this._dep.push([u,d,p]),p}stop(){let u=Date.now()-this._start;c._totals+=u;let d=!1;function p(P,f){let s=[],a=new Array(P+1).join("	");for(const[t,r,e]of f._dep)if(r&&e){d=!0,s.push(`${a}CREATES -> ${t}`);let n=p(P+1,e);n&&s.push(n)}else s.push(`${a}uses -> ${t}`);return s.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(u>2||d)&&console.log(m.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(Y[55],J([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,T.createDecorator)("localizationsService");function I(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const C of b.translations)if(typeof C.id!="string"||typeof C.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}i.isValidLocalization=I}),define(Y[15],J([0,1,28,10,2,12,14]),function(z,i,T,I,b,C,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,R.createDecorator)("logService"),i.ILoggerService=(0,R.createDecorator)("loggerService");function w(){return new Date().toISOString()}var l;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function g(r,e,n){switch(e){case l.Trace:r.trace(n);break;case l.Debug:r.debug(n);break;case l.Info:r.info(n);break;case l.Warning:r.warn(n);break;case l.Error:r.error(n);break;case l.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}i.log=g;function y(r){let e="";for(let n=0;n<r.length;n++){let o=r[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(h){}e+=(n>0?" ":"")+o}return e}i.format=y;class D extends b.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=D;class c extends D{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,y([e,...n]))}debug(e,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,y([e,...n]))}info(e,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,y([e,...n]))}warn(e,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,y([e,...n]))}error(e,...n){if(this.checkLogLevel(l.Error))if(e instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=e.stack,this.log(l.Error,y(o))}else this.log(l.Error,y([e,...n]))}critical(e,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,y([e,...n]))}flush(){}}i.AbstractMessageLogger=c;class E extends D{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!C.isWindows}trace(e,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...n):console.log(`[main ${w()}]`,e,...n))}debug(e,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...n):console.log(`[main ${w()}]`,e,...n))}info(e,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...n):console.log(`[main ${w()}]`,e,...n))}warn(e,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${w()}][0m`,e,...n):console.warn(`[main ${w()}]`,e,...n))}error(e,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${w()}][0m`,e,...n):console.error(`[main ${w()}]`,e,...n))}critical(e,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${w()}][0m`,e,...n):console.error(`[main ${w()}]`,e,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=E;class u extends D{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}i.ConsoleLogger=u;class d extends D{constructor(e,n=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=d;class p extends D{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const o of this.logServices)o.trace(e,...n)}debug(e,...n){for(const o of this.logServices)o.debug(e,...n)}info(e,...n){for(const o of this.logServices)o.info(e,...n)}warn(e,...n){for(const o of this.logServices)o.warn(e,...n)}error(e,...n){for(const o of this.logServices)o.error(e,...n)}critical(e,...n){for(const o of this.logServices)o.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=p;class m extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}i.LogService=m;class P extends b.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(o))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let o=this.loggers.get(e.toString());return o||(o=this.doCreateLogger(e,n?.always?l.Trace:this.logLevel,n),this.loggers.set(e.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=P;class f{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}i.NullLogService=f;function s(r){if(r.verbose)return l.Trace;if(typeof r.logLevel=="string"){const e=a(r.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=s;function a(r){switch(r){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=a;function t(r){switch(r){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=t});var oe=this&&this.__param||function(z,i){return function(T,I){i(T,I,z)}};define(Y[98],J([0,1,40,3,28,10,2,9,6,13,20,15]),function(z,i,T,I,b,C,R,w,l,g,y,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let c=class extends R.Disposable{constructor(u,d){super();this.environmentService=u,this.logService=d,this.processesLimiter=new I.Limiter(5)}async postUninstall(u){const d=this.parseScript(u,"uninstall");return d&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),p=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${p}`)))),g.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,p=>this.logService.error("Error while removing extension storage path",p))}parseScript(u,d){const p=`vscode:${d}`;if(u.location.scheme===w.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[p]=="string"){const m=u.manifest.scripts[p].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${p} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(u,d,p,m,P){return new Promise((f,s)=>{const a=this.start(u,d,p,P);let t;const r=e=>{t&&(clearTimeout(t),t=null),e?s(e):f(void 0)};a.on("error",e=>{r((0,b.toErrorMessage)(e)||"Unknown")}),a.on("exit",(e,n)=>{r(e?`post-${d} process exited with code ${e}`:void 0)}),m&&(t=setTimeout(()=>{t=null,a.kill(),s("timed out")},5e3))})}start(u,d,p,m){const P={silent:!0,execArgv:void 0},f=(0,T.fork)(u,[`--type=extension-post-${d}`,...p],P);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=C.Event.fromNodeEventEmitter(f.stdout,"data"),a=C.Event.fromNodeEventEmitter(f.stderr,"data");s(e=>this.logService.info(m.identifier.id,m.manifest.version,`post-${d}`,e)),a(e=>this.logService.error(m.identifier.id,m.manifest.version,`post-${d}`,e));const t=C.Event.any(C.Event.map(s,e=>({data:`%c${e}`,format:[""]})),C.Event.map(a,e=>({data:`%c${e}`,format:["color: red"]})));return C.Event.debounce(t,(e,n)=>e?{data:e.data+n.data,format:[...e.format,...n.format]}:{data:n.data,format:n.format},100)(e=>{console.group(m.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};c=de([oe(0,y.IEnvironmentService),oe(1,D.ILogService)],c),i.ExtensionsLifecycle=c}),define(Y[99],J([0,1,19,3,7,10,2,6,35,15]),function(z,i,T,I,b,C,R,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class y extends R.Disposable{constructor(c){super();this.logService=c,this._onDidErrorOccur=this._register(new C.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(c,E){return E.recursive?this.watchRecursive(c,E):this.watchNonRecursive(c)}watchRecursive(c,E){const u={path:this.toFilePath(c),excludes:E.excludes},d=(0,T.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,R.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(c=>(0,b.onUnexpectedError)(c))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(c=>this._onDidChangeFile.fire((0,l.toFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(c,E){return c.watch(E)}watchNonRecursive(c){const E=this.createNonRecursiveWatcher(this.toFilePath(c),d=>this._onDidChangeFile.fire((0,l.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===g.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{E.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)});return(0,R.combinedDisposable)(E,u)}onWatcherLogMessage(c){c.type==="error"&&this._onDidErrorOccur.fire(c.message),this.logService[c.type](c.message)}toFilePath(c){return(0,w.normalize)(c.fsPath)}}i.AbstractDiskFileSystemProvider=y}),define(Y[100],J([0,1,19,3,17,24,10,135,2,101,9,102,18,38,82,16,53,15]),function(z,i,T,I,b,C,R,w,l,g,y,D,c,E,u,d,p,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let P=class Ue extends l.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new R.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new d.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new d.FileChangesEvent(a,!0)))),this.watchedResources=g.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,a){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,D.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:a});const t=new l.DisposableStore;return t.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:s}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:a}),this.provider.delete(s),(0,l.dispose)(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){a.push(t)}}),!this.provider.has(s)&&await I.Promises.settled(a)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,a){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return w.Iterable.map(this.provider,([s,a])=>({scheme:s,capabilities:a.capabilities}))}async withProvider(s){if(!(0,c.isAbsolutePath)(s))throw new d.FileOperationError((0,u.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const a=this.provider.get(s.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,u.localize)(1,null,s.toString()),t}return a}async withReadProvider(s){const a=await this.withProvider(s);if((0,d.hasOpenReadWriteCloseCapability)(a)||(0,d.hasReadWriteCapability)(a)||(0,d.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const a=await this.withProvider(s);if((0,d.hasOpenReadWriteCloseCapability)(a)||(0,d.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,a){try{return await this.doResolveFile(s,a)}catch(t){throw(0,d.toFileSystemProviderErrorCode)(t)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,u.localize)(2,null,this.resourceForError(s)),1):(0,d.ensureFileSystemProviderError)(t)}}async doResolveFile(s,a){const t=await this.withProvider(s),r=this.isPathCaseSensitive(t),e=a?.resolveTo,n=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,h=await t.stat(s);let v;return this.toFileStat(t,s,h,void 0,!!o,(L,S)=>(v||(v=g.TernarySearchTree.forUris(()=>!r),v.set(s,!0),e&&v.fill(!0,e)),v.get(L.resource)||v.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&n?S===1:!1))}async toFileStat(s,a,t,r,e,n){const{providerExtUri:o}=this.getExtUri(s),h={resource:a,name:o.basename(a),isFile:(t.type&d.FileType.File)!=0,isDirectory:(t.type&d.FileType.Directory)!=0,isSymbolicLink:(t.type&d.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&d.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,d.etag)({mtime:t.mtime,size:t.size})};if(h.isDirectory&&n(h,r)){try{const v=await s.readdir(a),L=await I.Promises.settled(v.map(async([S,O])=>{try{const N=o.joinPath(a,S),X=e?await s.stat(N):{type:O};return await this.toFileStat(s,N,X,v.length,e,n)}catch(N){return this.logService.trace(N),null}}));h.children=(0,T.coalesce)(L)}catch(v){this.logService.trace(v),h.children=[]}return h}return h}async resolveAll(s){return I.Promises.settled(s.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const a=await this.withProvider(s);try{return!!await a.stat(s)}catch(t){return!1}}async canCreateFile(s,a){try{await this.doValidateCreateFile(s,a)}catch(t){return t}return!0}async doValidateCreateFile(s,a){if(!a?.overwrite&&await this.exists(s))throw new d.FileOperationError((0,u.localize)(3,null,this.resourceForError(s)),3,a)}async createFile(s,a=b.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const r=await this.writeFile(s,a);return this._onDidRunOperation.fire(new d.FileOperationEvent(s,0,r)),r}async writeFile(s,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:e}=this.getExtUri(r);try{await this.validateWriteFile(r,s,t)||await this.mkdirp(r,e.dirname(s));let o;if((0,d.hasReadWriteCapability)(r)&&!(a instanceof b.VSBuffer))if((0,E.isReadableStream)(a)){const h=await(0,E.peekStream)(a,3);h.ended?o=b.VSBuffer.concat(h.buffer):o=h}else o=(0,E.peekReadable)(a,h=>b.VSBuffer.concat(h),3);else o=a;!(0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r)&&o instanceof b.VSBuffer?await this.doWriteUnbuffered(r,s,t,o):await this.doWriteBuffered(r,s,t,o instanceof b.VSBuffer?(0,b.bufferToReadable)(o):o)}catch(n){throw new d.FileOperationError((0,u.localize)(4,null,this.resourceForError(s),(0,d.ensureFileSystemProviderError)(n).toString()),(0,d.toFileOperationResult)(n),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,a,t){if(!!t?.unlock&&!(s.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(a)));let e;try{e=await s.stat(a)}catch(n){return}if((e.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,u.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,e),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==d.ETAG_DISABLED&&typeof e.mtime=="number"&&typeof e.size=="number"&&t.mtime<e.mtime&&t.etag!==(0,d.etag)({mtime:t.mtime,size:e.size}))throw new d.FileOperationError((0,u.localize)(7,null),3,t);return e}async readFile(s,a){const t=await this.withReadProvider(s);return a?.atomic?this.doReadFileAtomic(t,s,a):this.doReadFile(t,s,a)}async doReadFileAtomic(s,a,t){return new Promise((r,e)=>{this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(s,a,t);r(n)}catch(n){e(n)}})})}async doReadFile(s,a,t){const r=await this.doReadFileStream(s,a,{...t,preferUnbuffered:!0});return{...r,value:await(0,b.streamToBuffer)(r.value)}}async readFileStream(s,a){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,a)}async doReadFileStream(s,a,t){const r=new C.CancellationTokenSource,e=this.validateReadFile(a,t).then(o=>o,o=>{throw r.cancel(),o});let n;try{return typeof t?.etag=="string"&&t.etag!==d.ETAG_DISABLED&&await e,!((0,d.hasOpenReadWriteCloseCapability)(s)||(0,d.hasFileReadStreamCapability)(s))||(0,d.hasReadWriteCapability)(s)&&t?.preferUnbuffered?n=this.readFileUnbuffered(s,a,t):(0,d.hasFileReadStreamCapability)(s)?n=this.readFileStreamed(s,a,r.token,t):n=this.readFileBuffered(s,a,r.token,t),{...await e,value:n}}catch(o){n&&await(0,E.consumeStream)(n);const h=(0,u.localize)(8,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(o).toString());throw o instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(h,o.stat,t):new d.FileOperationError(h,(0,d.toFileOperationResult)(o),t)}}readFileStreamed(s,a,t,r=Object.create(null)){const e=s.readFileStream(a,r,t);return(0,E.transform)(e,{data:n=>n instanceof b.VSBuffer?n:b.VSBuffer.wrap(n),error:n=>new d.FileOperationError((0,u.localize)(9,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(n).toString()),(0,d.toFileOperationResult)(n),r)},n=>b.VSBuffer.concat(n))}readFileBuffered(s,a,t,r=Object.create(null)){const e=(0,b.newWriteableBufferStream)();return(0,p.readFileIntoStream)(s,a,e,n=>n,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new d.FileOperationError((0,u.localize)(10,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(n).toString()),(0,d.toFileOperationResult)(n),r)},t),e}readFileUnbuffered(s,a,t){const r=(0,E.newWriteableStream)(e=>b.VSBuffer.concat(e));return(async()=>{try{let e=await s.readFile(a);typeof t?.position=="number"&&(e=e.slice(t.position)),typeof t?.length=="number"&&(e=e.slice(0,t.length)),this.validateReadFileLimits(a,e.byteLength,t),r.end(b.VSBuffer.wrap(e))}catch(e){r.error(e),r.end()}})(),r}async validateReadFile(s,a){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new d.FileOperationError((0,u.localize)(11,null,this.resourceForError(s)),0,a);if(typeof a?.etag=="string"&&a.etag!==d.ETAG_DISABLED&&a.etag===t.etag)throw new d.NotModifiedSinceFileOperationError((0,u.localize)(12,null),t,a);return this.validateReadFileLimits(s,t.size,a),t}validateReadFileLimits(s,a,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new d.FileOperationError((0,u.localize)(13,null,this.resourceForError(s)),r)}}async canMove(s,a,t){return this.doCanMoveCopy(s,a,"move",t)}async canCopy(s,a,t){return this.doCanMoveCopy(s,a,"copy",t)}async doCanMoveCopy(s,a,t,r){if(s.toString()!==a.toString())try{const e=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(e,s,n,a,t,r)}catch(e){return e}return!0}async move(s,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=await this.doMoveCopy(r,s,e,a,"move",!!t),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(s,n==="move"?2:3,o)),o}async copy(s,a,t){const r=await this.withReadProvider(s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=await this.doMoveCopy(r,s,e,a,"copy",!!t),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(s,n==="copy"?3:2,o)),o}async doMoveCopy(s,a,t,r,e,n){if(a.toString()===r.toString())return e;const{exists:o,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(s,a,t,r,e,n);if(o&&!h&&n&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),e==="copy"){if(s===t&&(0,d.hasFileFolderCopyCapability)(s))await s.copy(a,r,{overwrite:n});else{const v=await this.resolve(a);v.isDirectory?await this.doCopyFolder(s,v,t,r):await this.doCopyFile(s,a,t,r)}return e}else return s===t?(await s.rename(a,r,{overwrite:n}),e):(await this.doMoveCopy(s,a,t,r,"copy",n),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(s,a,t,r){if((0,d.hasOpenReadWriteCloseCapability)(s)&&(0,d.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(s,a,t,r);if((0,d.hasOpenReadWriteCloseCapability)(s)&&(0,d.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(s,a,t,r);if((0,d.hasReadWriteCapability)(s)&&(0,d.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(s,a,t,r);if((0,d.hasReadWriteCapability)(s)&&(0,d.hasReadWriteCapability)(t))return this.doPipeUnbuffered(s,a,t,r)}async doCopyFolder(s,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await I.Promises.settled(a.children.map(async e=>{const n=this.getExtUri(t).providerExtUri.joinPath(r,e.name);return e.isDirectory?this.doCopyFolder(s,await this.resolve(e.resource),t,n):this.doCopyFile(s,e.resource,t,n)}))}async doValidateMoveCopy(s,a,t,r,e,n){let o=!1;if(s===t){const{providerExtUri:v,isPathCaseSensitive:L}=this.getExtUri(s);if(L||(o=v.isEqual(a,r)),o&&e==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(a),this.resourceForError(r)));if(!o&&v.isEqualOrParent(r,a))throw new Error((0,u.localize)(15,null,this.resourceForError(a),this.resourceForError(r)))}const h=await this.exists(r);if(h&&!o){if(!n)throw new d.FileOperationError((0,u.localize)(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(s===t){const{providerExtUri:v}=this.getExtUri(s);if(v.isEqualOrParent(a,r))throw new Error((0,u.localize)(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:h,isSameResourceWithDifferentPathCase:o}}getExtUri(s){const a=this.isPathCaseSensitive(s);return{providerExtUri:a?c.extUri:c.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(a,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(s,0,t)),t}async mkdirp(s,a){const t=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(a,r.dirname(a));)try{if(((await s.stat(a)).type&d.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(a)));break}catch(e){if((0,d.toFileSystemProviderErrorCode)(e)!==d.FileSystemProviderErrorCode.FileNotFound)throw e;t.push(r.basename(a)),a=r.dirname(a)}for(let e=t.length-1;e>=0;e--){a=r.joinPath(a,t[e]);try{await s.mkdir(a)}catch(n){if((0,d.toFileSystemProviderErrorCode)(n)!==d.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(s,a){try{await this.doValidateDelete(s,a)}catch(t){return t}return!0}async doValidateDelete(s,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(s)));let e;try{e=await t.stat(s)}catch(o){}if(e)this.throwIfFileIsReadonly(s,e);else throw new d.FileOperationError((0,u.localize)(20,null,this.resourceForError(s)),1);if(!!!a?.recursive){const o=await this.resolve(s);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(s)))}return t}async del(s,a){const t=await this.doValidateDelete(s,a),r=!!a?.useTrash,e=!!a?.recursive;await t.delete(s,{recursive:e,useTrash:r}),this._onDidRunOperation.fire(new d.FileOperationEvent(s,1))}onDidChangeFile(s,a){this._onDidChangeFilesRaw.fire({changes:s});let t,r;{for(const e of s)this.watchedResources.has(e.resource)?(t||(t=[]),t.push(e)):(r||(r=[]),r.push(e));t&&this._onDidFilesChange.fire(new d.FileChangesEvent(t,!a))}if(r){const e=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!e.work(r)&&Ue.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),e.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${e.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,a={recursive:!1,excludes:[]}){const t=new l.DisposableStore;let r=!1,e=()=>{r=!0};return t.add((0,l.toDisposable)(()=>e())),this.doWatch(s,a).then(n=>{r?(0,l.dispose)(n):e=()=>(0,l.dispose)(n)},n=>this.logService.error(n)),a.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),t.add((0,l.toDisposable)(()=>{const n=this.watchedResources.get(s);typeof n=="number"&&(n<=1?this.watchedResources.delete(s):this.watchedResources.set(s,n-1))}))),t}async doWatch(s,a){const t=await this.withProvider(s),r=this.toWatchKey(t,s,a);let e=this.activeWatchers.get(r);return e||(e={count:0,disposable:t.watch(s,a)},this.activeWatchers.set(r,e)),e.count+=1,(0,l.toDisposable)(()=>{e&&(e.count--,e.count===0&&((0,l.dispose)(e.disposable),this.activeWatchers.delete(r)))})}toWatchKey(s,a,t){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,l.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{const e=await s.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,E.isReadableStream)(r)||(0,E.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,e,r):await this.doWriteReadableBufferedQueued(s,e,r)}catch(n){throw(0,d.ensureFileSystemProviderError)(n)}finally{await s.close(e)}})}async doWriteStreamBufferedQueued(s,a,t){let r=0,e;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const n=b.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,a,n,n.byteLength,r,0),r+=n.byteLength}if(t.ended)return;e=t.stream}else e=t;return new Promise((n,o)=>{(0,E.listenStream)(e,{onData:async h=>{e.pause();try{await this.doWriteBuffer(s,a,h,h.byteLength,r,0)}catch(v){return o(v)}r+=h.byteLength,setTimeout(()=>e.resume())},onError:h=>o(h),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(s,a,t){let r=0,e;for(;(e=t.read())!==null;)await this.doWriteBuffer(s,a,e,e.byteLength,r,0),r+=e.byteLength}async doWriteBuffer(s,a,t,r,e,n){let o=0;for(;o<r;)o+=await s.write(a,e+o,t.buffer,n+o,r-o)}async doWriteUnbuffered(s,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,a,t,r))}async doWriteUnbufferedQueued(s,a,t,r){let e;r instanceof b.VSBuffer?e=r:(0,E.isReadableStream)(r)?e=await(0,b.streamToBuffer)(r):(0,E.isReadableBufferedStream)(r)?e=await(0,b.bufferedStreamToBuffer)(r):e=(0,b.readableToBuffer)(r),await s.writeFile(a,e.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,a,t,r))}async doPipeBufferedQueued(s,a,t,r){let e,n;try{e=await s.open(a,{create:!1}),n=await t.open(r,{create:!0,unlock:!1});const o=b.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,v=0,L=0;do L=await s.read(e,h,o.buffer,v,o.byteLength-v),await this.doWriteBuffer(t,n,o,L,h,v),h+=L,v+=L,v===o.byteLength&&(v=0);while(L>0)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await I.Promises.settled([typeof e=="number"?s.close(e):Promise.resolve(),typeof n=="number"?t.close(n):Promise.resolve()])}}async doPipeUnbuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,a,t,r))}async doPipeUnbufferedQueued(s,a,t,r){return t.writeFile(r,await s.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,a,t,r))}async doPipeUnbufferedToBufferedQueued(s,a,t,r){const e=await t.open(r,{create:!0,unlock:!1});try{const n=await s.readFile(a);await this.doWriteBuffer(t,e,b.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,d.ensureFileSystemProviderError)(n)}finally{await t.close(e)}}async doPipeBufferedToUnbuffered(s,a,t,r){const e=await(0,b.streamToBuffer)(this.readFileBuffered(s,a,C.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,e)}throwIfFileSystemIsReadonly(s,a){if(s.capabilities&2048)throw new d.FileOperationError((0,u.localize)(22,null,this.resourceForError(a)),6);return s}throwIfFileIsReadonly(s,a){if((a.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,u.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===y.Schemas.file?s.fsPath:s.toString(!0)}};P.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},P=de([oe(0,m.ILogService)],P),i.FileService=P}),define(Y[103],J([0,1,48,136,3,17,10,47,6,12,18,38,13,84,16,53,94,95,96,99,28]),function(z,i,T,I,b,C,R,w,l,g,y,D,c,E,u,d,p,m,P,f,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(T)}catch(t){console.error(`Error enabling graceful-fs: ${(0,s.toErrorMessage)(t)}`)}})();class a extends f.AbstractDiskFileSystemProvider{constructor(r,e){super(r);this.options=e,this.onDidChangeCapabilities=R.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:e,symbolicLink:n}=await c.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(e,n),ctime:e.birthtime.getTime(),mtime:e.mtime.getTime(),size:e.size}}catch(e){throw this.toFileSystemProviderError(e)}}async readdir(r){try{const e=await c.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),n=[];return await Promise.all(e.map(async o=>{try{let h;o.isSymbolicLink()?h=(await this.stat((0,y.joinPath)(r,o.name))).type:h=this.toType(o),n.push([o.name,h])}catch(h){this.logService.trace(h)}})),n}catch(e){throw this.toFileSystemProviderError(e)}}toType(r,e){let n;return e?.dangling?n=u.FileType.Unknown:r.isFile()?n=u.FileType.File:r.isDirectory()?n=u.FileType.Directory:n=u.FileType.Unknown,e&&(n|=u.FileType.SymbolicLink),n}async readFile(r){try{const e=this.toFilePath(r);return await c.Promises.readFile(e)}catch(e){throw this.toFileSystemProviderError(e)}}readFileStream(r,e,n){const o=(0,D.newWriteableStream)(h=>C.VSBuffer.concat(h.map(v=>C.VSBuffer.wrap(v))).buffer);return(0,d.readFileIntoStream)(this,r,o,h=>h.buffer,{...e,bufferSize:256*1024},n),o}async writeFile(r,e,n){let o;try{const h=this.toFilePath(r);if(!n.create||!n.overwrite){if(await c.Promises.exists(h)){if(!n.overwrite)throw(0,u.createFileSystemProviderError)((0,E.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,u.createFileSystemProviderError)((0,E.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(o,0,e,0,e.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(r,h)}finally{typeof o=="number"&&await this.close(o)}}async open(r,e){try{const n=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(e)&&e.unlock)try{const{stat:v}=await c.SymlinkSupport.stat(n);v.mode&128||await c.Promises.chmod(n,v.mode|128)}catch(v){this.logService.trace(v)}let o;if((0,u.isFileOpenForWriteOptions)(e)){if(g.isWindows)try{await c.Promises.truncate(n,0),o="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}o||(o="w")}else o="r";const h=await c.Promises.open(n,o);return this.mapHandleToPos.set(h,0),(0,u.isFileOpenForWriteOptions)(e)&&this.writeHandles.set(h,r),h}catch(n){throw(0,u.isFileOpenForWriteOptions)(e)?await this.toFileSystemProviderWriteError(r,n):this.toFileSystemProviderError(n)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await c.Promises.fdatasync(r)}catch(e){this.canFlush=!1,this.logService.error(e)}return await c.Promises.close(r)}catch(e){throw this.toFileSystemProviderError(e)}}async read(r,e,n,o,h){const v=this.normalizePos(r,e);let L=null;try{const S=await c.Promises.read(r,n,o,h,v);return typeof S=="number"?L=S:L=S.bytesRead,L}catch(S){throw this.toFileSystemProviderError(S)}finally{this.updatePos(r,v,L)}}normalizePos(r,e){return e===this.mapHandleToPos.get(r)?null:e}updatePos(r,e,n){const o=this.mapHandleToPos.get(r);typeof o=="number"&&(typeof e=="number"||(typeof n=="number"?this.mapHandleToPos.set(r,o+n):this.mapHandleToPos.delete(r)))}async write(r,e,n,o,h){return(0,b.retry)(()=>this.doWrite(r,e,n,o,h),100,3)}async doWrite(r,e,n,o,h){const v=this.normalizePos(r,e);let L=null;try{const S=await c.Promises.write(r,n,o,h,v);return typeof S=="number"?L=S:L=S.bytesWritten,L}catch(S){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),S)}finally{this.updatePos(r,v,L)}}async mkdir(r){try{await c.Promises.mkdir(this.toFilePath(r))}catch(e){throw this.toFileSystemProviderError(e)}}async delete(r,e){try{const n=this.toFilePath(r);await this.doDelete(n,e)}catch(n){throw this.toFileSystemProviderError(n)}}async doDelete(r,e){e.recursive?await c.Promises.rm(r,c.RimRafMode.MOVE):await c.Promises.unlink(r)}async rename(r,e,n){const o=this.toFilePath(r),h=this.toFilePath(e);if(o!==h)try{await this.validateTargetDeleted(r,e,"move",n.overwrite),await c.Promises.move(o,h)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,E.localize)(2,null,(0,l.basename)(o),(0,l.basename)((0,l.dirname)(h)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(r,e,n){const o=this.toFilePath(r),h=this.toFilePath(e);if(o!==h)try{await this.validateTargetDeleted(r,e,"copy",n.overwrite),await c.Promises.copy(o,h,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,E.localize)(3,null,(0,l.basename)(o),(0,l.basename)((0,l.dirname)(h)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(r,e,n,o){const h=this.toFilePath(r),v=this.toFilePath(e);let L=!1;if(!!(this.capabilities&1024)||(L=(0,w.isEqual)(h,v,!0)),L&&n==="copy")throw(0,u.createFileSystemProviderError)((0,E.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!L&&await c.Promises.exists(v)){if(!o)throw(0,u.createFileSystemProviderError)((0,E.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(e,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,e,n){let o,h=!1;return this.options?.watcher?.usePolling?h=!1:h=this.options?.legacyWatcher==="on",h?o=m.FileWatcher:o=P.FileWatcher,new o(v=>r(v),v=>e(v),n,this.options?.watcher)}doWatch(r,e){const n=this.options?.watcher?.usePolling;if(n===!0)for(const o of e)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const o of e)n.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,e)}createNonRecursiveWatcher(r,e,n,o){return new p.FileWatcher(r,h=>e(h),h=>n(h),o)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let e;switch(r.code){case"ENOENT":e=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":e=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":e=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":e=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":e=u.FileSystemProviderErrorCode.NoPermissions;break;default:e=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,e)}async toFileSystemProviderWriteError(r,e){let n=this.toFileSystemProviderError(e);if(r&&n.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await c.SymlinkSupport.stat(this.toFilePath(r));o.mode&128||(n=(0,u.createFileSystemProviderError)(e,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return n}}i.DiskFileSystemProvider=a}),define(Y[104],J([0,1,16,15]),function(z,i,T,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=i.createRotatingLogger=void 0;async function b(l,g,y,D,c){try{const E=await new Promise((d,p)=>{z(["spdlog"],d,p)});E.setFlushOn(I.LogLevel.Trace);const u=await E.createAsyncRotatingLogger(l,g,y,D);return c&&u.clearFormatters(),u}catch(E){console.error(E)}return null}function C(l,g,y,D){const c=z.__$__nodeRequire("spdlog");return c.setFlushOn(I.LogLevel.Trace),c.createRotatingLogger(l,g,y,D)}i.createRotatingLogger=C;function R(l,g,y){switch(g){case I.LogLevel.Trace:l.trace(y);break;case I.LogLevel.Debug:l.debug(y);break;case I.LogLevel.Info:l.info(y);break;case I.LogLevel.Warning:l.warn(y);break;case I.LogLevel.Error:l.error(y);break;case I.LogLevel.Critical:l.critical(y);break;default:throw new Error("Invalid log level")}}class w extends I.AbstractMessageLogger{constructor(g,y,D,c,E){super();this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(g,y,D,c),this._register(this.onDidChangeLogLevel(u=>{this._logger&&this._logger.setLevel(u)}))}async _createSpdLogLogger(g,y,D,c){const E=D?6:1,u=30/E*T.ByteSize.MB,d=await b(g,y,u,E,c);if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:p,message:m}of this.buffer)R(this._logger,p,m);this.buffer=[]}}log(g,y){this._logger?R(this._logger,g,y):this.getLevel()<=g&&this.buffer.push({level:g,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=w}),define(Y[32],J([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IProductService=void 0,i.IProductService=(0,T.createDecorator)("productService")}),define(Y[25],J([0,1,56,11]),function(z,i,T,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class b{constructor(){this.data=new Map}add(R,w){T.ok(I.isString(R)),T.ok(I.isObject(w)),T.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,w)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}i.Registry=new b}),define(Y[105],J([0,1,10,25]),function(z,i,T,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function b(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class C{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,g){this.schemasById[b(l)]=g,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new C;I.Registry.add(i.Extensions.JSONContribution,R)}),define(Y[33],J([0,1,19,10,11,73,105,25]),function(z,i,T,I,b,C,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var l;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(l=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var g;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=w.Registry.as(R.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,t=!0){this.registerConfigurations([a],t)}registerConfigurations(a,t=!0){const r=this.doRegisterConfigurations(a,t);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterConfigurations(a){const t=this.doDeregisterConfigurations(a);y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(t)}updateConfigurations({add:a,remove:t}){const r=[];r.push(...this.doDeregisterConfigurations(t)),r.push(...this.doRegisterConfigurations(a,!1)),y.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,T.distinct)(r))}registerDefaultConfigurations(a){const t=[],r=[];for(const e of a)for(const n in e)if(t.push(n),i.OVERRIDE_PROPERTY_REGEX.test(n)){this.defaultValues[n]={...this.defaultValues[n]||{},...e[n]};const o={type:"object",default:this.defaultValues[n],description:C.localize(1,null,n),$ref:i.resourceLanguageSettingsSchemaId};r.push(...u(n)),this.configurationProperties[n]=o,this.defaultLanguageConfigurationOverridesNode.properties[n]=o}else{this.defaultValues[n]=e[n];const o=this.configurationProperties[n];o&&(this.updatePropertyDefaultValue(n,o),this.updateSchema(n,o))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(t)}deregisterDefaultConfigurations(a){const t=[];for(const r of a)for(const e in r)if(t.push(e),delete this.defaultValues[e],i.OVERRIDE_PROPERTY_REGEX.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const n=this.configurationProperties[e];n&&(this.updatePropertyDefaultValue(e,n),this.updateSchema(e,n))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(t)}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const t of a)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,t){const r=[];return a.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,t,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),r}doDeregisterConfigurations(a){const t=[],r=e=>{if(e.properties)for(const n in e.properties)t.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,e.properties[n]);e.allOf&&e.allOf.forEach(n=>r(n))};for(const e of a){r(e);const n=this.configurationContributors.indexOf(e);n!==-1&&this.configurationContributors.splice(n,1)}return t}validateAndRegisterProperties(a,t=!0,r,e=3){e=b.isUndefinedOrNull(a.scope)?e:a.scope;let n=[],o=a.properties;if(o)for(let v in o){if(t&&P(v)){delete o[v];continue}const L=o[v];if(this.updatePropertyDefaultValue(v,L),i.OVERRIDE_PROPERTY_REGEX.test(v)?L.scope=void 0:(L.scope=b.isUndefinedOrNull(L.scope)?e:L.scope,L.restricted=b.isUndefinedOrNull(L.restricted)?!!r?.restrictedConfigurations?.includes(v):L.restricted),o[v].hasOwnProperty("included")&&!o[v].included){this.excludedConfigurationProperties[v]=o[v],delete o[v];continue}else this.configurationProperties[v]=o[v];!o[v].deprecationMessage&&o[v].markdownDeprecationMessage&&(o[v].deprecationMessage=o[v].markdownDeprecationMessage),n.push(v)}let h=a.allOf;if(h)for(let v of h)n.push(...this.validateAndRegisterProperties(v,t,r,e));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(a){const t=r=>{let e=r.properties;if(e)for(const o in e)this.updateSchema(o,e[o]);let n=r.allOf;n&&n.forEach(t)};t(a)}updateSchema(a,t){switch(i.allSettings.properties[a]=t,t.scope){case 1:i.applicationSettings.properties[a]=t;break;case 2:i.machineSettings.properties[a]=t;break;case 6:i.machineOverridableSettings.properties[a]=t;break;case 3:i.windowSettings.properties[a]=t;break;case 4:i.resourceSettings.properties[a]=t;break;case 5:i.resourceSettings.properties[a]=t,this.resourceLanguageSettingsSchema.properties[a]=t;break}}removeFromSchema(a,t){switch(delete i.allSettings.properties[a],t.scope){case 1:delete i.applicationSettings.properties[a];break;case 2:delete i.machineSettings.properties[a];break;case 6:delete i.machineOverridableSettings.properties[a];break;case 3:delete i.windowSettings.properties[a];break;case 4:case 5:delete i.resourceSettings.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const t=`[${a}]`,r={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(t,r),i.allSettings.properties[t]=r,i.applicationSettings.properties[t]=r,i.machineSettings.properties[t]=r,i.machineOverridableSettings.properties[t]=r,i.windowSettings.properties[t]=r,i.resourceSettings.properties[t]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,t){let r=this.defaultValues[a];b.isUndefined(r)&&(r=t.default),b.isUndefined(r)&&(r=p(t.type)),t.default=r}}const c="\\[([^\\]]+)\\]",E=new RegExp(c,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function u(s){const a=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let t=E.exec(s);for(;t?.length;){const r=t[1].trim();r&&a.push(r),t=E.exec(s)}}return(0,T.distinct)(a)}i.overrideIdentifiersFromKey=u;function d(s){return s.reduce((a,t)=>`${a}[${t}]`,"")}i.keyFromOverrideIdentifiers=d;function p(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=p;const m=new D;w.Registry.add(i.Extensions.Configuration,m);function P(s){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?C.localize(7,null,s):m.getConfigurationProperties()[s]!==void 0?C.localize(8,null,s):null:C.localize(6,null)}i.validateProperty=P;function f(){const s=[],a=m.getConfigurationProperties();for(const t of Object.keys(a))s.push([t,a[t].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=f}),define(Y[26],J([0,1,11,8,33,14,25]),function(z,i,T,I,b,C,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.getDefaultValues=i.getConfigurationKeys=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,C.createDecorator)("configurationService");function w(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof I.URI)}i.isConfigurationOverrides=w;function l(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||T.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof I.URI)}i.isConfigurationUpdateOverrides=l;var g;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(g=i.ConfigurationTarget||(i.ConfigurationTarget={}));function y(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=y;function D(s,a){const t=Object.create(null);for(let r in s)c(t,r,s[r],a);return t}i.toValuesTree=D;function c(s,a,t,r){const e=a.split("."),n=e.pop();let o=s;for(let h=0;h<e.length;h++){let v=e[h],L=o[v];switch(typeof L){case"undefined":L=o[v]=Object.create(null);break;case"object":break;default:r(`Ignoring ${a} as ${e.slice(0,h+1).join(".")} is ${JSON.stringify(L)}`);return}o=L}if(typeof o=="object"&&o!==null)try{o[n]=t}catch(h){r(`Ignoring ${a} as ${e.join(".")} is ${JSON.stringify(o)}`)}else r(`Ignoring ${a} as ${e.join(".")} is ${JSON.stringify(o)}`)}i.addToValueTree=c;function E(s,a){const t=a.split(".");u(s,t)}i.removeFromValueTree=E;function u(s,a){const t=a.shift();if(a.length===0){delete s[t];return}if(Object.keys(s).indexOf(t)!==-1){const r=s[t];typeof r=="object"&&!Array.isArray(r)&&(u(r,a),Object.keys(r).length===0&&delete s[t])}}function d(s,a,t){function r(o,h){let v=o;for(const L of h){if(typeof v!="object"||v===null)return;v=v[L]}return v}const e=a.split("."),n=r(s,e);return typeof n=="undefined"?t:n}i.getConfigurationValue=d;function p(s,a,t){Object.keys(a).forEach(r=>{r!=="__proto__"&&(r in s?T.isObject(s[r])&&T.isObject(a[r])?p(s[r],a[r],t):t&&(s[r]=a[r]):s[r]=a[r])})}i.merge=p;function m(){const s=R.Registry.as(b.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}i.getConfigurationKeys=m;function P(){const s=Object.create(null),a=R.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(let t in a){let r=a[t].default;c(s,t,r,e=>console.error(`Conflict in default settings: ${e}`))}return s}i.getDefaultValues=P;function f(s,a,t){const r=s.inspect(a),e=s.inspect(t);return typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:typeof e.userValue!="undefined"||typeof e.workspaceValue!="undefined"||typeof e.workspaceFolderValue!="undefined"?e.value:r.defaultValue}i.getMigratedSettingValue=f}),define(Y[106],J([0,1,19,10,57,2,101,21,11,8,26,33,25]),function(z,i,T,I,b,C,R,w,l,g,y,D,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class E{constructor(e={},n=[],o=[]){this._contents=e,this._keys=n,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,y.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const o=this.getContentsForOverrideIdentifer(n);return o?e?(0,y.getConfigurationValue)(o,e):o:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const o of this.overrides)o.identifiers.includes(e)&&n.push(...o.keys);return T.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return T.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=w.deepClone(this.contents),o=w.deepClone(this.overrides),h=[...this.keys];for(const v of e){this.mergeContents(n,v.contents);for(const L of v.overrides){const[S]=o.filter(O=>T.equals(O.identifiers,L.identifiers));S?(this.mergeContents(S.contents,L.contents),S.keys.push(...L.keys),S.keys=T.distinct(S.keys)):o.push(w.deepClone(L))}for(const L of v.keys)h.indexOf(L)===-1&&h.push(L)}return new E(n,h,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let o={};for(const h of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let v=this.contents[h],L=n[h];L&&(typeof v=="object"&&typeof L=="object"?(v=w.deepClone(v),this.mergeContents(v,L)):v=L),o[h]=v}return new E(o,this.keys,this.overrides)}mergeContents(e,n){for(const o of Object.keys(n)){if(o in e&&l.isObject(e[o])&&l.isObject(n[o])){this.mergeContents(e[o],n[o]);continue}e[o]=w.deepClone(n[o])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?w.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let n=null,o=null;const h=v=>{v&&(o?this.mergeContents(o,v):o=w.deepClone(v))};for(const v of this.overrides)T.equals(v.identifiers,[e])?n=v.contents:v.identifiers.includes(e)&&h(v.contents);return h(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,y.addToValueTree)(this.contents,e,n,o=>{throw new Error(o)})}removeValue(e){this.removeKey(e)&&(0,y.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let o=0;o<n;o++)e.indexOf(this.keys[o])===0&&(n=o);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=E;class u extends E{constructor(){const e=(0,y.getDefaultValues)(),n=(0,y.getConfigurationKeys)(),o=[];for(const h of Object.keys(e))D.OVERRIDE_PROPERTY_REGEX.test(h)&&o.push({identifiers:(0,D.overrideIdentifiersFromKey)(h),keys:Object.keys(e[h]),contents:(0,y.toValuesTree)(e[h],v=>console.error(`Conflict in default settings file: ${v}`))});super(e,n,o)}}i.DefaultConfigurationModel=u;class d{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!l.isUndefinedOrNull(e)){const o=this.doParseContent(e);this.parseRaw(o,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:o,keys:h,overrides:v,restricted:L}=this.doParseRaw(e,n);this._configurationModel=new E(o,h,v),this._restrictedConfigurations=L||[]}doParseContent(e){let n={},o=null,h=[],v=[],L=[];function S(N){Array.isArray(h)?h.push(N):o!==null&&(h[o]=N)}let O={onObjectBegin:()=>{let N={};S(N),v.push(h),h=N,o=null},onObjectProperty:N=>{o=N},onObjectEnd:()=>{h=v.pop()},onArrayBegin:()=>{let N=[];S(N),v.push(h),h=N,o=null},onArrayEnd:()=>{h=v.pop()},onLiteralValue:S,onError:(N,X,ee)=>{L.push({error:N,offset:X,length:ee})}};if(e)try{b.visit(e,O),n=h[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(e,n){const o=c.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),h=this.filter(e,o,!0,n);e=h.raw;const v=(0,y.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),L=Object.keys(e),S=this.toOverrides(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:v,keys:L,overrides:S,restricted:h.restricted}}filter(e,n,o,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:e,restricted:[]};const v={},L=[];for(let S in e)if(D.OVERRIDE_PROPERTY_REGEX.test(S)&&o){const O=this.filter(e[S],n,!1,h);v[S]=O.raw,L.push(...O.restricted)}else{const O=n[S],N=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&L.push(S),(N===void 0||h.scopes===void 0||h.scopes.includes(N))&&(h.skipRestricted&&O?.restricted||(v[S]=e[S]))}return{raw:v,restricted:L}}toOverrides(e,n){const o=[];for(const h of Object.keys(e))if(D.OVERRIDE_PROPERTY_REGEX.test(h)){const v={};for(const L in e[h])v[L]=e[h][L];o.push({identifiers:(0,D.overrideIdentifiersFromKey)(h),keys:Object.keys(v),contents:(0,y.toValuesTree)(v,n)})}return o}}i.ConfigurationModelParser=d;class p extends C.Disposable{constructor(e,n,o,h){super();this.userSettingsResource=e,this.scopes=n,this.fileService=h,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=p;class m{constructor(e,n,o=new E,h=new E,v=new R.ResourceMap,L=new E,S=new R.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=o,this._workspaceConfiguration=h,this._folderConfigurations=v,this._memoryConfiguration=L,this._memoryConfigurationByResource=S,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(e,n,o){return this.getConsolidateConfigurationModel(n,o).getValue(e)}updateValue(e,n,o={}){let h;o.resource?(h=this._memoryConfigurationByResource.get(o.resource),h||(h=new E,this._memoryConfigurationByResource.set(o.resource,h))):h=this._memoryConfiguration,n===void 0?h.removeValue(e):h.setValue(e,n),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,o){const h=this.getConsolidateConfigurationModel(n,o),v=this.getFolderConfigurationModelForResource(n.resource,o),L=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,S=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),X=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),ee=o?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,ue=v?n.overrideIdentifier?v.freeze().override(n.overrideIdentifier).getValue(e):v.freeze().getValue(e):void 0,le=n.overrideIdentifier?L.override(n.overrideIdentifier).getValue(e):L.getValue(e),se=h.getValue(e),ce=T.distinct(T.flatten(h.overrides.map(W=>W.identifiers))).filter(W=>h.getOverrideValue(e,W)!==void 0);return{defaultValue:S,userValue:O,userLocalValue:N,userRemoteValue:X,workspaceValue:ee,workspaceFolderValue:ue,memoryValue:le,value:se,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:X!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:ee!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:ue!==void 0?{value:v?.freeze().getValue(e),override:n.overrideIdentifier?v?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:le!==void 0?{value:L.getValue(e),override:n.overrideIdentifier?L.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ce.length?ce:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const o=[];for(const h of n)for(const v of(0,D.overrideIdentifiersFromKey)(h)){const L=this._defaultConfiguration.getKeysForOverrideIdentifier(v),S=e.getKeysForOverrideIdentifier(v),O=[...S.filter(N=>L.indexOf(N)===-1),...L.filter(N=>S.indexOf(N)===-1),...L.filter(N=>!w.equals(this._defaultConfiguration.override(v).getValue(N),e.override(v).getValue(N)))];o.push([v,O])}return this.updateDefaultConfiguration(e),{keys:n,overrides:o}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:o,removed:h,overrides:v}=a(this.localUserConfiguration,e),L=[...n,...o,...h];return L.length&&this.updateLocalUserConfiguration(e),{keys:L,overrides:v}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:o,removed:h,overrides:v}=a(this.remoteUserConfiguration,e);let L=[...n,...o,...h];return L.length&&this.updateRemoteUserConfiguration(e),{keys:L,overrides:v}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:o,removed:h,overrides:v}=a(this.workspaceConfiguration,e);let L=[...n,...o,...h];return L.length&&this.updateWorkspaceConfiguration(e),{keys:L,overrides:v}}compareAndUpdateFolderConfiguration(e,n){const o=this.folderConfigurations.get(e),{added:h,updated:v,removed:L,overrides:S}=a(o,n);let O=[...h,...v,...L];return(O.length||!o)&&this.updateFolderConfiguration(e,n),{keys:O,overrides:S}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:o,updated:h,removed:v,overrides:L}=a(n,void 0);return{keys:[...o,...h,...v],overrides:L}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let o=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?o.override(e.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:e},n){let o=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const h=n.getFolder(e);h&&(o=this.getFolderConsolidatedConfiguration(h.uri)||o);const v=this._memoryConfigurationByResource.get(e);v&&(o=o.merge(v))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const o=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(e);h?(n=o.merge(h),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=o}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const o=n.getFolder(e);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:o,overrides:h,keys:v}=this._folderConfigurations.get(n);return e.push([n,{contents:o,overrides:h,keys:v}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(o=>e.add(o))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(o=>e.add(o))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(e).forEach(h=>n.add(h))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),o=this.parseConfigurationModel(e.user),h=this.parseConfigurationModel(e.workspace),v=e.folders.reduce((L,S)=>(L.set(g.URI.revive(S[0]),this.parseConfigurationModel(S[1])),L),new R.ResourceMap);return new m(n,o,new E,h,v,new E,new R.ResourceMap,!1)}static parseConfigurationModel(e){return new E(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=m;function P(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,n=new Map;for(const h of r)h.keys.forEach(v=>e.add(v)),h.overrides.forEach(([v,L])=>{const S=(0,R.getOrSet)(n,v,new Set);L.forEach(O=>S.add(O))});const o=[];return n.forEach((h,v)=>o.push([v,[...h.values()]])),{keys:[...e.values()],overrides:o}}i.mergeChanges=P;class f{constructor(e,n,o,h){this.change=e,this.previous=n,this.currentConfiguraiton=o,this.currentWorkspace=h,this._previousConfiguration=void 0;const v=new Set;e.keys.forEach(S=>v.add(S)),e.overrides.forEach(([,S])=>S.forEach(O=>v.add(O))),this.affectedKeys=[...v.values()];const L=new E;this.affectedKeys.forEach(S=>L.setValue(S,{})),this.affectedKeysTree=L.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const o=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!w.equals(o,h)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let o=(0,y.toValuesTree)({[n]:!0},()=>{}),h;for(;typeof o=="object"&&(h=Object.keys(o)[0]);){if(e=e[h],!e)return!1;o=o[h]}return!0}}i.ConfigurationChangeEvent=f;class s extends f{constructor(e,n,o,h){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=o,this.sourceConfig=h}}i.AllKeysConfigurationChangeEvent=s;function a(r,e){const{added:n,removed:o,updated:h}=t(e,r),v=[],L=r?.getAllOverrideIdentifiers()||[],S=e?.getAllOverrideIdentifiers()||[];if(e){const O=S.filter(N=>!L.includes(N));for(const N of O)v.push([N,e.getKeysForOverrideIdentifier(N)])}if(r){const O=L.filter(N=>!S.includes(N));for(const N of O)v.push([N,r.getKeysForOverrideIdentifier(N)])}if(e&&r){for(const O of L)if(S.includes(O)){const N=t({contents:r.getOverrideValue(void 0,O)||{},keys:r.getKeysForOverrideIdentifier(O)},{contents:e.getOverrideValue(void 0,O)||{},keys:e.getKeysForOverrideIdentifier(O)});v.push([O,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:o,updated:h,overrides:v}}function t(r,e){const n=r?e?r.keys.filter(v=>e.keys.indexOf(v)===-1):[...r.keys]:[],o=e?r?e.keys.filter(v=>r.keys.indexOf(v)===-1):[...e.keys]:[],h=[];if(r&&e){for(const v of e.keys)if(r.keys.indexOf(v)!==-1){const L=(0,y.getConfigurationValue)(e.contents,v),S=(0,y.getConfigurationValue)(r.contents,v);w.equals(L,S)||h.push(v)}}return{added:n,removed:o,updated:h}}}),define(Y[107],J([0,1,3,10,2,18,26,106,33,25]),function(z,i,T,I,b,C,R,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class y extends b.Disposable{constructor(c,E){super();this.settingsResource=c,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,E)),this.configuration=new w.Configuration(new w.DefaultConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const c=await this.userConfiguration.loadConfiguration();this.configuration=new w.Configuration(new w.DefaultConfigurationModel,c)}getConfigurationData(){return this.configuration.toData()}getValue(c,E){const u=typeof c=="string"?c:void 0,d=(0,R.isConfigurationOverrides)(c)?c:(0,R.isConfigurationOverrides)(E)?E:{};return this.configuration.getValue(u,d,void 0)}updateValue(c,E,u,d){return Promise.reject(new Error("not supported"))}inspect(c){return this.configuration.inspect(c,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const c=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(c)}onDidChangeUserConfiguration(c){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(c);this.trigger(u,E,1)}onDidDefaultConfigurationChange(c){const E=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new w.DefaultConfigurationModel,c);this.trigger(u,E,6)}trigger(c,E,u){const d=new w.ConfigurationChangeEvent(c,{data:E},this.configuration);d.source=u,d.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(c){switch(c){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=y}),define(Y[108],J([0,1,9]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isVirtualWorkspace=i.getVirtualWorkspaceScheme=i.getVirtualWorkspaceLocation=i.isVirtualResource=i.getRemoteName=i.getRemoteAuthority=void 0;function I(g){return g.scheme===T.Schemas.vscodeRemote?g.authority:void 0}i.getRemoteAuthority=I;function b(g){if(!g)return;const y=g.indexOf("+");return y<0?g:g.substr(0,y)}i.getRemoteName=b;function C(g){return g.scheme!==T.Schemas.file&&g.scheme!==T.Schemas.vscodeRemote}i.isVirtualResource=C;function R(g){if(g.folders.length)return g.folders.every(y=>C(y.uri))?g.folders[0].uri:void 0;if(g.configuration&&C(g.configuration))return g.configuration}i.getVirtualWorkspaceLocation=R;function w(g){return R(g)?.scheme}i.getVirtualWorkspaceScheme=w;function l(g){return R(g)!==void 0}i.isVirtualWorkspace=l}),define(Y[42],J([0,1,27,14,108]),function(z,i,T,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}i.getWorkspaceSupportTypeMessage=C;function R(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}i.isIExtensionIdentifier=R,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(w=i.ExtensionType||(i.ExtensionType={}));class l{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,u){if(typeof E=="undefined"||E===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof E=="string"||typeof u=="string"){let d=typeof E=="string"?E:E.value,p=typeof u=="string"?u:u.value;return T.equalsIgnoreCase(d,p)}return E._lower===u._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}i.ExtensionIdentifier=l;function g(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}i.isLanguagePackExtension=g;function y(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=y;function D(c,E){if(E){const u=`onResolveRemoteAuthority:${(0,b.getRemoteName)(E)}`;return c.activationEvents?.indexOf(u)!==-1}return!1}i.isResolverExtension=D,i.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[23],J([0,1,27,42]),function(z,i,T,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function b(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,T.compareIgnoreCase)(u.id,d.id)===0}i.areSameExtensions=b;class C{constructor(d,p){this.version=p,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof C?b(this,d)&&this.version===d.version:!1}}i.ExtensionIdentifierWithVersion=C;function R(u,d){return`${u}.${d}`}i.getExtensionId=R;function w(u){return u.toLocaleLowerCase()}i.adoptToGalleryExtensionId=w;function l(u,d){return w(R(u,d))}i.getGalleryExtensionId=l;function g(u,d){const p=[],m=P=>{for(const f of p)if(f.some(s=>b(d(s),d(P))))return f;return null};for(const P of u){const f=m(P);f?f.push(P):p.push([P])}return p}i.groupByExtension=g;function y(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=y;function D(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}i.getGalleryExtensionTelemetryData=D,i.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function c(u){const d=new Set;for(const p of u)p.malicious&&d.add(p.id.id);return d}i.getMaliciousExtensionsSet=c;function E(u,d){const p=[],m=d.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const P=m.shift();if(P&&p.every(f=>!b(f.identifier,{id:P}))){const f=u.filter(s=>b(s.identifier,{id:P}));f.length===1&&(p.push(f[0]),m.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}i.getExtensionDependencies=E}),define(Y[109],J([0,1,24,7,62,9,43,8,77,22,23,42]),function(z,i,T,I,b,C,R,w,l,g,y,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=i.getIdAndVersion=void 0;const c=P=>(0,l.localize)(0,null,P),E=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(P,f){return f?`${P.publisher}.${P.name}@${P.version}`:`${P.publisher}.${P.name}`}const d=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function p(P){const f=d.exec(P);return f&&f[1]?[(0,y.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,y.adoptToGalleryExtensionId)(P),void 0]}i.getIdAndVersion=p;let m=class{constructor(f,s){this.extensionManagementService=f,this.extensionGalleryService=s}get location(){}async listExtensions(f,s,a=console){let t=await this.extensionManagementService.getInstalled(1);const r=D.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(s&&s!==""){if(r.indexOf(s.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}t=t.filter(n=>n.manifest.categories?n.manifest.categories.map(h=>h.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){a.log("Possible Categories: "),r.forEach(n=>{a.log(n)});return}this.location&&a.log((0,l.localize)(2,null,this.location)),t=t.sort((n,o)=>n.identifier.id.localeCompare(o.identifier.id));let e;for(let n of t)e!==n.identifier.id&&(e=n.identifier.id,a.log(u(n.manifest,f)))}async installExtensions(f,s,a,t,r=console){const e=[],n=[];f.length&&r.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const o=await this.extensionManagementService.getInstalled(1),h=(S,O)=>{const N=o.find(X=>(0,y.areSameExtensions)(X.identifier,{id:S}));if(N){if(!O&&!t)return r.log((0,l.localize)(5,null,S,N.manifest.version,S)),!1;if(O&&N.manifest.version===O)return r.log((0,l.localize)(6,null,`${S}@${O}`)),!1}return!0},v=[],L=[];for(const S of f)if(S instanceof w.URI)v.push(S);else{const[O,N]=p(S);h(O,N)&&L.push({id:O,version:N,installOptions:{isBuiltin:!1,isMachineScoped:a}})}for(const S of s){const[O,N]=p(S);h(O,N)&&L.push({id:O,version:N,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(v.length&&await Promise.all(v.map(async S=>{try{const O=await this.installVSIX(S,{isBuiltin:!1,isMachineScoped:a},t,r);O&&n.push(O)}catch(O){r.error(O.message||O.stack||O),e.push(S.toString())}})),L.length){const S=await this.getGalleryExtensions(L);await Promise.all(L.map(async O=>{const N=S.get(O.id.toLowerCase());if(N)try{const X=await this.installFromGallery(O,N,o,t,r);X&&n.push(X)}catch(X){r.error(X.message||X.stack||X),e.push(O.id)}else r.error(`${c(O.version?`${O.id}@${O.version}`:O.id)}
${E}`),e.push(O.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(f,s,a,t){const r=await this.extensionManagementService.getManifest(f);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,a,t))try{return await this.extensionManagementService.install(f,s),t.log((0,l.localize)(8,null,(0,b.getBaseLabel)(f))),r}catch(n){if((0,I.isPromiseCanceledError)(n))return t.log((0,l.localize)(9,null,(0,b.getBaseLabel)(f))),null;throw n}return null}async getGalleryExtensions(f){const s=new Map,a=await this.extensionGalleryService.getExtensions(f,T.CancellationToken.None);for(const t of a)s.set(t.identifier.id.toLowerCase(),t);return s}async installFromGallery({id:f,version:s,installOptions:a},t,r,e,n){const o=await this.extensionGalleryService.getManifest(t,T.CancellationToken.None);if(o&&!this.validateExtensionKind(o,n))return null;const h=r.find(v=>(0,y.areSameExtensions)(v.identifier,t.identifier));if(h){if(t.version===h.manifest.version)return n.log((0,l.localize)(10,null,s?`${f}@${s}`:f)),null;n.log((0,l.localize)(11,null,f,t.version))}try{return a.isBuiltin?n.log(s?(0,l.localize)(12,null,f,s):(0,l.localize)(13,null,f)):n.log(s?(0,l.localize)(14,null,f,s):(0,l.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(t,{...a,installGivenVersion:!!s}),n.log((0,l.localize)(16,null,f,t.version)),o}catch(v){if((0,I.isPromiseCanceledError)(v))return n.log((0,l.localize)(17,null,f)),null;throw v}}validateExtensionKind(f,s){return!0}async validateVSIX(f,s,a){const t={id:(0,y.getGalleryExtensionId)(f.publisher,f.name)},e=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,y.areSameExtensions)(t,n.identifier)&&(0,R.gt)(n.manifest.version,f.version));return e&&!s?(a.log((0,l.localize)(18,null,e.identifier.id,e.manifest.version,f.version)),!1):this.validateExtensionKind(f,a)}async uninstallExtensions(f,s,a=console){const t=async e=>{if(e instanceof w.URI){const n=await this.extensionManagementService.getManifest(e);return u(n)}return e},r=[];for(const e of f){const n=await t(e),h=(await this.extensionManagementService.getInstalled()).filter(v=>(0,y.areSameExtensions)(v.identifier,{id:n}));if(!h.length)throw new Error(`${this.notInstalled(n)}
${E}`);if(h.some(v=>v.type===0)){a.log((0,l.localize)(19,null,n));return}if(!s&&h.some(v=>v.isBuiltin)){a.log((0,l.localize)(20,null,n));return}a.log((0,l.localize)(21,null,n));for(const v of h)await this.extensionManagementService.uninstall(v),r.push(v);this.location?a.log((0,l.localize)(22,null,n,this.location)):a.log((0,l.localize)(23,null,n))}}async locateExtension(f,s=console){const a=await this.extensionManagementService.getInstalled();f.forEach(t=>{a.forEach(r=>{if(r.identifier.id===t&&r.location.scheme===C.Schemas.file){s.log(r.location.fsPath);return}})})}notInstalled(f){return this.location?(0,l.localize)(24,null,f,this.location):(0,l.localize)(25,null,f)}};m=de([oe(0,g.IExtensionManagementService),oe(1,g.IExtensionGalleryService)],m),i.ExtensionManagementCLIService=m}),define(Y[110],J([0,1,3,7,2,12,18,43,8,31,13,20,22,23,16,15]),function(z,i,T,I,b,C,R,w,l,g,y,D,c,E,u,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends b.Disposable{constructor(f,s,a,t){super();this.fileService=s,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=l.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const a=this.getName(f),t=(0,R.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const r=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(f,r,s);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(r)}catch(n){}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,r.path),e}}return t}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,s,a){try{await y.Promises.rename(f.fsPath,s.fsPath)}catch(t){if(C.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],a=[];for(const e of f.children){const n=this.parse(e.name);n&&a.push([n,e])}const t=(0,E.groupByExtension)(a,([e])=>e),r=[];for(const e of t)e.sort((n,o)=>w.rcompare(n[0].version,o[0].version)),s.push(...e.slice(1).map(n=>n[1].resource)),r.push(e[0][1]);r.sort((e,n)=>e.mtime-n.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await T.Promises.settled(s.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new E.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,g.generateUuid)()}parse(f){const s=p.exec(f);return s&&s[1]&&s[2]?new E.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};m=de([oe(0,D.INativeEnvironmentService),oe(1,u.IFileService),oe(2,c.IExtensionGalleryService),oe(3,d.ILogService)],m),i.ExtensionsDownloader=m}),define(Y[111],J([0,1,2,6,13,42]),function(z,i,T,I,b,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class R extends T.Disposable{constructor(l,g){super();this.environmentService=l,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,C.MANIFEST_CACHE_FOLDER,C.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(g.onDidUninstallExtension(y=>this.onDidUnInstallExtension(y)))}onDidInstallExtensions(l){l.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=R}),define(Y[112],J([0,1,137,19,3,2,9,6,13,20,22,23,55,15]),function(z,i,T,I,b,C,R,w,l,g,y,D,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let u=class extends C.Disposable{constructor(m,P,f){super();this.extensionManagementService=m,this.logService=f,this.cache=this._register(new d(P,f)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),P=["en",...Object.keys(m)];return(0,I.distinct)(P)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const P=await this.cache.getLanguagePacks();Object.keys(P).some(f=>P[f]&&P[f].extensions.some(s=>(0,D.areSameExtensions)(s.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,P]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(P);return!(0,I.equals)(Object.keys(m),Object.keys(f))}};u=de([oe(0,y.IExtensionManagementService),oe(1,g.INativeEnvironmentService),oe(2,E.ILogService)],u),i.LocalizationsService=u;let d=class extends C.Disposable{constructor(m,P){super();this.logService=P,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(P=>{Object.keys(P).forEach(f=>delete P[f]),this.createLanguagePacksFromExtensions(P,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...P){for(const f of P)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,f);Object.keys(m).forEach(f=>this.updateHash(m[f]))}createLanguagePacksFromExtension(m,P){const f=P.identifier,s=P.manifest.contributes&&P.manifest.contributes.localizations?P.manifest.contributes.localizations:[];for(const a of s)if(P.location.scheme===R.Schemas.file&&(0,c.isValidLocalization)(a)){let t=m[a.languageId];t||(t={hash:"",extensions:[],translations:{}},m[a.languageId]=t);let r=t.extensions.filter(e=>(0,D.areSameExtensions)(e.extensionIdentifier,f))[0];r?r.version=P.manifest.version:t.extensions.push({extensionIdentifier:f,version:P.manifest.version});for(const e of a.translations)t.translations[e.id]=(0,w.join)(P.location.fsPath,e.path)}}updateHash(m){if(m){const P=(0,T.createHash)("md5");for(const f of m.extensions)P.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);m.hash=P.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let P=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(s){return{}}}).then(f=>(P=m(f),f)).then(f=>{for(const a of Object.keys(f))f[a]||delete f[a];this.languagePacks=f,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),l.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>P,f=>this.logService.error(f))})}};d=de([oe(0,g.INativeEnvironmentService),oe(1,E.ILogService)],d)}),define(Y[44],J([0,1,17,85,33,14,25]),function(z,i,T,I,b,C,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,C.createDecorator)("requestService");function w(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}i.isSuccess=w;function l(u){return u.res.statusCode===204}async function g(u){if(!w(u))throw new Error("Server returned "+u.res.statusCode);return l(u)?null:(await(0,T.streamToBuffer)(u.stream)).toString()}i.asText=g;async function y(u){if(!w(u))throw new Error("Server returned "+u.res.statusCode);if(l(u))return null;const p=(await(0,T.streamToBuffer)(u.stream)).toString();try{return JSON.parse(p)}catch(m){throw m.message+=`:
`+p,m}}i.asJson=y;function D(u){E(u)}i.updateProxyConfigurationsScope=D;let c;function E(u){const d=R.Registry.as(b.Extensions.Configuration),p=c;c={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[c],remove:p?[p]:[]})}E(2)}),define(Y[113],J([0,1,24,9,16,44]),function(z,i,T,I,b,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let R=class{constructor(l,g){this.requestService=l,this.fileService=g}async download(l,g,y=T.CancellationToken.None){if(l.scheme===I.Schemas.file||l.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(l,g);return}const D={type:"GET",url:l.toString()},c=await this.requestService.request(D,y);if(c.res.statusCode===200)await this.fileService.writeFile(g,c.stream);else{const E=await(0,C.asText)(c);throw new Error(`Expected 200, got back ${c.res.statusCode} instead.

${E}`)}}};R=de([oe(0,C.IRequestService),oe(1,b.IFileService)],R),i.DownloadService=R}),define(Y[114],J([0,1,115,11]),function(z,i,T,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function b(R,w){return R.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:R.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function C(R,w,l={}){const g=(0,T.parse)(R),y=l.proxyUrl||b(g,w);if(!y)return null;const D=(0,T.parse)(y);if(!/^https?:$/.test(D.protocol||""))return null;const c={host:D.hostname||"",port:D.port||(D.protocol==="https"?"443":"80"),auth:D.auth,rejectUnauthorized:(0,I.isBoolean)(l.strictSSL)?l.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((E,u)=>{z(["http-proxy-agent"],E,u)}))(c):new(await new Promise((E,u)=>{z(["https-proxy-agent"],E,u)}))(c)}i.getProxyAgent=C}),define(Y[116],J([0,1,17,31]),function(z,i,T,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function b(C,R,w){let l=w&&w.get("storage.serviceMachineId",0)||null;if(l)return l;try{const y=(await R.readFile(C.serviceMachineIdResource)).value.toString();l=(0,I.isUUID)(y)?y:null}catch(g){l=null}if(!l){l=(0,I.generateUuid)();try{await R.writeFile(C.serviceMachineIdResource,T.VSBuffer.fromString(l))}catch(g){}}return w&&w.store("storage.serviceMachineId",l,0,1),l}i.getServiceMachineId=b}),define(Y[117],J([0,1,3,10,2,102,11,66,14]),function(z,i,T,I,b,C,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";i.IStorageService=(0,l.createDecorator)("storageService");var y;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(y=i.WillSaveStateReason||(i.WillSaveStateReason={}));var D;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(D=i.StorageScope||(i.StorageScope={}));var c;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(c=i.StorageTarget||(i.StorageTarget={}));class E extends b.Disposable{constructor(m={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,P){P===g?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:P,target:this.getKeyTargets(m)[P]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,P,f){return this.getStorage(P)?.get(m,f)}getBoolean(m,P,f){return this.getStorage(P)?.getBoolean(m,f)}getNumber(m,P,f){return this.getStorage(P)?.getNumber(m,f)}store(m,P,f,s){if((0,R.isUndefinedOrNull)(P)){this.remove(m,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,f,s),this.getStorage(f)?.set(m,P)})}remove(m,P){this.withPausedEmitters(()=>{this.updateKeyTarget(m,P,void 0),this.getStorage(P)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,P){const f=[],s=this.getKeyTargets(m);for(const a of Object.keys(s))s[a]===P&&f.push(a);return f}updateKeyTarget(m,P,f){const s=this.getKeyTargets(P);typeof f=="number"?s[m]!==f&&(s[m]=f,this.getStorage(P)?.set(g,JSON.stringify(s))):typeof s[m]=="number"&&(delete s[m],this.getStorage(P)?.set(g,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const P=this.get(g,m);if(P)try{return JSON.parse(P)}catch(f){}return Object.create(null)}isNew(m){return this.getBoolean(i.IS_NEW_KEY,m)===!0}async flush(m=y.NONE){this._onWillSaveState.fire({reason:m});const P=this.getStorage(0),f=this.getStorage(1);switch(m){case y.NONE:await T.Promises.settled([P?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await T.Promises.settled([P?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return d(m,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends E{constructor(){super();this.globalStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}i.InMemoryStorageService=u;async function d(p,m,P,f){const s=h=>{try{return JSON.parse(h)}catch(v){return h}},a=new Map,t=new Map;p.forEach((h,v)=>{a.set(v,h),t.set(v,s(h))});const r=new Map,e=new Map;m.forEach((h,v)=>{r.set(v,h),e.set(v,s(h))}),console.group(`Storage: Global (path: ${P})`);let n=[];a.forEach((h,v)=>{n.push({key:v,value:h})}),console.table(n),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${f})`);let o=[];r.forEach((h,v)=>{o.push({key:v,value:h})}),console.table(o),console.groupEnd(),console.log(e)}i.logStorage=d}),define(Y[118],J([0,1,12,29,8,31]),function(z,i,T,I,b,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function R(g){if(T.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function w(g,y,D,c,E,u,d,p,m,P){const f=Object.create(null);f["common.machineId"]=d,f.sessionID=(0,C.generateUuid)()+Date.now(),f.commitHash=E,f.version=u,f["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,T.PlatformToString)(T.platform),f["common.nodePlatform"]=I.platform,f["common.nodeArch"]=c,f["common.product"]=P||"desktop";const s=l(p||[]);s&&(f["common.msftInternal"]=s);let a=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),T.isLinuxSnap&&(f["common.snap"]="true");const r=R(D);r&&(f["common.platformDetail"]=r);try{const e=await g.readFile(b.URI.file(m));f["common.source"]=e.value.toString().slice(0,30)}catch(e){}return f}i.resolveCommonProperties=w;function l(g){const y=I.env.USERDNSDOMAIN;if(!y)return!1;const D=y.toLowerCase();return g.some(c=>D===c)}i.verifyMicrosoftInternalDomain=l}),define(Y[30],J([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,T.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(I=i.TelemetryLevel||(i.TelemetryLevel={}));var b;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(b=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Y[119],J([0,1,19,3,24,7,10,2,12,8,75,22,23,15,32,30]),function(z,i,T,I,b,C,R,w,l,g,y,D,c,E,u,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let p=class extends w.Disposable{constructor(t,r,e,n){super();this.galleryService=t,this.telemetryService=r,this.logService=e,this.productService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(e=>(0,D.isTargetPlatformCompatible)(e,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{return await this.doInstallFromGallery(t,r)}catch(e){throw this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(e),P(e)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.unininstallExtension(t,r)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(y.localize(0,null));const r=await this.findGalleryExtension(t);if(!r)throw new Error(y.localize(1,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(r)}getExtensionsReport(){const t=new Date().getTime();return(!this.reportedExtensions||t-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=t),this.reportedExtensions}registerParticipant(t){this.participants.push(t)}async doInstallFromGallery(t,r={}){if(!this.galleryService.isEnabled())throw new D.ExtensionManagementError(y.localize(2,null),D.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(t)){const n=await this.getTargetPlatform(),o=new D.ExtensionManagementError(y.localize(3,null,t.identifier.id,this.productService.nameLong,(0,D.TargetPlatformToString)(n)),D.ExtensionManagementErrorCode.Incompatible);throw f(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(t),void 0,o),o}try{t=await this.checkAndGetCompatibleVersion(t,!r.installGivenVersion)}catch(n){throw f(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(t),void 0,n),n}const e=await this.galleryService.getManifest(t,b.CancellationToken.None);if(e===null){const n=new D.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,D.ExtensionManagementErrorCode.Invalid);throw f(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(t),void 0,n),n}if(e.version!==t.version){const n=new D.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,D.ExtensionManagementErrorCode.Invalid);throw f(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(t),void 0,n),n}return this.installExtension(e,t,r)}async installExtension(t,r,e){if(!g.URI.isUri(r)){let L=this.installingExtensions.get(new c.ExtensionIdentifierWithVersion(r.identifier,r.version).key());if(L)return this.logService.info("Extensions is already requested to install",r.identifier.id),L.waitUntilTaskIsFinished();e={...e,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],o=[],h=this.createInstallExtensionTask(t,r,e);g.URI.isUri(r)||this.installingExtensions.set(new c.ExtensionIdentifierWithVersion(h.identifier,t.version).key(),h),this._onInstallExtension.fire({identifier:h.identifier,source:r}),this.logService.info("Installing extension:",h.identifier.id),n.push({task:h,manifest:t});let v=!1;try{if(e.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",h.identifier.id);else try{const S=await this.getAllDepsAndPackExtensionsToInstall(h.identifier,t,!!e.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:O,manifest:N}of S)if(v=v||!!N.extensionDependencies?.some(X=>(0,c.areSameExtensions)({id:X},h.identifier)),this.installingExtensions.has(new c.ExtensionIdentifierWithVersion(O.identifier,O.version).key()))this.logService.info("Extension is already requested to install",O.identifier.id);else{const X=this.createInstallExtensionTask(N,O,{...e,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new c.ExtensionIdentifierWithVersion(X.identifier,N.version).key(),X),this._onInstallExtension.fire({identifier:X.identifier,source:O}),this.logService.info("Installing extension:",X.identifier.id),n.push({task:X,manifest:N})}}catch(S){if(g.URI.isUri(h.source))(0,T.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",h.identifier.id,S.message),(0,T.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",h.identifier.id,S.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",h.identifier.id),S}const L=n.reduce((S,{task:O,manifest:N})=>(S.set(O.identifier.id.toLowerCase(),{task:O,manifest:N}),S),new Map);for(;L.size;){let S;const O=[...L.values()].filter(({manifest:N})=>!N.extensionDependencies?.some(X=>L.has(X.toLowerCase())));O.length?S=L.size===1?O:O.filter(({task:N})=>!(N===h&&!v)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:N})=>N.identifier.id)),S=[...L.values()]),await this.joinAllSettled(S.map(async({task:N})=>{const X=new Date().getTime();try{const ee=await N.run();if(await this.joinAllSettled(this.participants.map(ue=>ue.postInstall(ee,N.source,e,b.CancellationToken.None))),!g.URI.isUri(N.source)&&(f(this.telemetryService,N.operation===2?"extensionGallery:update":"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(N.source),new Date().getTime()-X,void 0),l.isWeb&&N.operation===1))try{await this.galleryService.reportStatistic(ee.manifest.publisher,ee.manifest.name,ee.manifest.version,"install")}catch(ue){}o.push({local:ee,identifier:N.identifier,operation:N.operation,source:N.source})}catch(ee){throw g.URI.isUri(N.source)||f(this.telemetryService,N.operation===2?"extensionGallery:update":"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(N.source),new Date().getTime()-X,ee),this.logService.error("Error while installing the extension:",N.identifier.id),ee}finally{L.delete(N.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:S})=>this.logService.info("Extension installed successfully:",S.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:S})=>(0,c.areSameExtensions)(S,h.identifier))[0].local}catch(L){if(n.forEach(({task:S})=>S.cancel()),o.length)try{const S=await Promise.allSettled(o.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0}).run()));for(let O=0;O<S.length;O++){const N=S[O],{identifier:X}=o[O];N.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",X.id):this.logService.warn("Rollback: Error while uninstalling extension",X.id,(0,C.getErrorMessage)(N.reason))}}catch(S){this.logService.warn("Error while rolling back extensions",(0,C.getErrorMessage)(S),o.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(n.map(({task:S})=>({identifier:S.identifier,operation:1,source:S.source}))),L}finally{for(const{task:L,manifest:S}of n)if(!g.URI.isUri(L.source)){const O=new c.ExtensionIdentifierWithVersion(L.identifier,S.version).key();this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(t){const r=[],e=[],n=await Promise.allSettled(t);for(const o of n)o.status==="fulfilled"?r.push(o.value):e.push(o.reason);if(e.length)throw m(e);return r}async getAllDepsAndPackExtensionsToInstall(t,r,e){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const o=[t,...n.map(L=>L.identifier)],h=[],v=async(L,S)=>{const O=S.extensionDependencies||[],N=[...O];if(S.extensionPack){const X=e?n.find(ee=>(0,c.areSameExtensions)(ee.identifier,L)):void 0;for(const ee of S.extensionPack)X&&X.manifest.extensionPack&&X.manifest.extensionPack.some(ue=>(0,c.areSameExtensions)({id:ue},{id:ee}))||N.every(ue=>!(0,c.areSameExtensions)({id:ue},{id:ee}))&&N.push(ee)}if(N.length){const X=[...o,...h.map(ue=>ue.gallery.identifier)],ee=N.filter(ue=>X.every(le=>!(0,c.areSameExtensions)(le,{id:ue})));if(ee.length){const ue=await this.galleryService.query({names:ee,pageSize:N.length},b.CancellationToken.None);for(const le of ue.firstPage){if(X.find(q=>(0,c.areSameExtensions)(q,le.identifier)))continue;if(!O.some(q=>(0,c.areSameExtensions)({id:q},le.identifier))&&!await this.canInstall(le)){this.logService.info("Skipping the packed extension as it cannot be installed",le.identifier.id);continue}const ce=await this.checkAndGetCompatibleVersion(le,!0),W=await this.galleryService.getManifest(ce,b.CancellationToken.None);if(W===null)throw new D.ExtensionManagementError(`Missing manifest for extension ${ce.identifier.id}`,D.ExtensionManagementErrorCode.Invalid);h.push({gallery:ce,manifest:W}),await v(ce.identifier,W)}}}};return await v(t,r),n=await this.getInstalled(),h.filter(L=>!n.some(S=>(0,c.areSameExtensions)(S.identifier,L.gallery.identifier)))}async checkAndGetCompatibleVersion(t,r){if(await this.isMalicious(t))throw new D.ExtensionManagementError(y.localize(4,null,t.identifier.id),D.ExtensionManagementErrorCode.Malicious);const e=await this.getCompatibleVersion(t,r);if(!e)throw new D.ExtensionManagementError(y.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),D.ExtensionManagementErrorCode.Incompatible);return e}async getCompatibleVersion(t,r){const e=await this.getTargetPlatform();let n=null;return await this.galleryService.isExtensionCompatible(t,e)&&(n=t),!n&&r&&(n=await this.galleryService.getCompatibleExtension(t,e)),n}async isMalicious(t){const r=await this.getExtensionsReport();return(0,c.getMaliciousExtensionsSet)(r).has(t.identifier.id)}async unininstallExtension(t,r){const e=this.uninstallingExtensions.get(t.identifier.id.toLowerCase());if(e)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),e.waitUntilTaskIsFinished();const n=(L,S)=>{const O=this.createUninstallExtensionTask(L,S);return this.uninstallingExtensions.set(O.extension.identifier.id.toLowerCase(),O),this.logService.info("Uninstalling extension:",L.identifier.id),this._onUninstallExtension.fire(L.identifier),O},o=(L,S)=>{S?this.logService.error("Failed to uninstall extension:",L.identifier.id,S.message):this.logService.info("Successfully uninstalled extension:",L.identifier.id),f(this.telemetryService,"extensionGallery:uninstall",(0,c.getLocalExtensionTelemetryData)(L),void 0,S),this._onDidUninstallExtension.fire({identifier:L.identifier,error:S?.code})},h=[],v=[];try{h.push(n(t,{}));const L=await this.getInstalled(1);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",t.identifier.id);else{const S=this.getAllPackExtensionsToUninstall(t,L);for(const O of S)this.uninstallingExtensions.has(O.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):h.push(n(O,{}))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",t.identifier.id):this.checkForDependents(h.map(S=>S.extension),L,t),await this.joinAllSettled(h.map(async S=>{try{if(await S.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(S.extension,r,b.CancellationToken.None))),S.extension.identifier.uuid)try{await this.galleryService.reportStatistic(S.extension.manifest.publisher,S.extension.manifest.name,S.extension.manifest.version,"uninstall")}catch(O){}o(S.extension)}catch(O){const N=O instanceof D.ExtensionManagementError?O:new D.ExtensionManagementError((0,C.getErrorMessage)(O),D.ExtensionManagementErrorCode.Internal);throw o(S.extension,N),N}finally{v.push(S)}}))}catch(L){const S=L instanceof D.ExtensionManagementError?L:new D.ExtensionManagementError((0,C.getErrorMessage)(L),D.ExtensionManagementErrorCode.Internal);for(const O of h){try{O.cancel()}catch(N){}v.includes(O)||o(O.extension,S)}throw S}finally{for(const L of h)this.uninstallingExtensions.delete(L.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",L.extension.identifier.id)}}checkForDependents(t,r,e){for(const n of t){const o=this.getDependents(n,r);if(o.length){const h=o.filter(v=>!t.some(L=>(0,c.areSameExtensions)(L.identifier,v.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(n,h,e))}}}getDependentsErrorMessage(t,r,e){return e===t?r.length===1?y.localize(6,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(7,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(8,null,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?y.localize(9,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(10,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(11,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,e=[]){if(e.indexOf(t)!==-1)return[];e.push(t);const n=t.manifest.extensionPack?t.manifest.extensionPack:[];if(n.length){const o=r.filter(v=>!v.isBuiltin&&n.some(L=>(0,c.areSameExtensions)({id:L},v.identifier))),h=[];for(const v of o)h.push(...this.getAllPackExtensionsToUninstall(v,r,e));return[...o,...h]}return[]}getDependents(t,r){return r.filter(e=>e.manifest.extensionDependencies&&e.manifest.extensionDependencies.some(n=>(0,c.areSameExtensions)({id:n},t.identifier)))}async findGalleryExtension(t){if(t.identifier.uuid){const r=await this.findGalleryExtensionById(t.identifier.uuid);return r||this.findGalleryExtensionByName(t.identifier.id)}return this.findGalleryExtensionByName(t.identifier.id)}async findGalleryExtensionById(t){return(await this.galleryService.query({ids:[t],pageSize:1},b.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(t){return(await this.galleryService.query({names:[t],pageSize:1},b.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${t.length} reported extensions from service`),t}catch(t){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};p=de([oe(0,D.IExtensionGalleryService),oe(1,d.ITelemetryService),oe(2,E.ILogService),oe(3,u.IProductService)],p),i.AbstractExtensionManagementService=p;function m(a){const t=Array.isArray(a)?a:[a];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,e)=>new Error(`${r.message}${r.message?",":""}${e instanceof Error?e.message:e}`),new Error(""))}i.joinErrors=m;function P(a){if(a instanceof D.ExtensionManagementError)return a;const t=new D.ExtensionManagementError(a.message,D.ExtensionManagementErrorCode.Internal);return t.stack=a.stack,t}function f(a,t,r,e,n){const o=n?n instanceof D.ExtensionManagementError?n.code:D.ExtensionManagementErrorCode.Internal:void 0;a.publicLogError(t,{...r,success:!n,duration:e,errorcode:o})}i.reportTelemetry=f;class s{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(t=>new Promise((r,e)=>{const n=t.onCancellationRequested(()=>{n.dispose(),e((0,C.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=s}),define(Y[36],J([0,1,21,11,26,30]),function(z,i,T,I,b,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class R{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,P){return Promise.resolve(void 0)}publicLog2(m,P){return this.publicLog(m,P)}publicLogError(m,P){return Promise.resolve(void 0)}publicLogError2(m,P){return this.publicLogError(m,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=R,i.NullTelemetryService=new R;class w{async publicLog(m,P,f){}async publicLogError(m,P,f){}}i.NullEndpointTelemetryService=w,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(p,m){return m.onDidChangeConfiguration(P=>{P.source!==6&&p.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(P.source),configurationKeys:u(P.sourceConfig)})})}i.configurationTelemetry=l;function g(p,m){return!(m.disableTelemetry||!p.enableTelemetry)}i.supportsTelemetry=g;function y(p){const m=p.getValue(C.TELEMETRY_SETTING_ID),P=p.getValue("telemetry.enableCrashReporter");if(p.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=y;function D(p){const m=Object.create(null),P=Object.create(null),f=Object.create(null);E(p,f);for(let s in f){s=s.length>150?s.substr(s.length-149):s;const a=f[s];typeof a=="number"?P[s]=a:typeof a=="boolean"?P[s]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${a.length}`),m[s]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(m[s]=a)}return{properties:m,measurements:P}}i.validateTelemetryData=D;function c(p){if(!p)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{p.indexOf(`${f}+`)===0&&(m=f)}),m}i.cleanRemoteAuthority=c;function E(p,m,P=0,f){if(!!p)for(let s of Object.getOwnPropertyNames(p)){const a=p[s],t=f?f+s:s;Array.isArray(a)?m[t]=(0,T.safeStringify)(a):a instanceof Date?m[t]=a.toISOString():(0,I.isObject)(a)?P<2?E(a,m,P+1,t+"."):m[t]=(0,T.safeStringify)(a):m[t]=a}}function u(p){if(!p)return[];const m=[];return d(m,"",p),m}function d(p,m,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(f=>d(p,m?`${m}.${f}`:f,P[f])):p.push(m)}}),define(Y[120],J([0,1,19,24,7,21,12,29,8,26,20,22,23,51,16,15,32,44,116,117,30,36]),function(z,i,T,I,b,C,R,w,l,g,y,D,c,E,u,d,p,m,P,f,s,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const t=R.isWeb?"web":(0,D.getTargetPlatform)(R.platform,w.arch);var r;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished"})(r||(r={}));function e(...M){return String(M.reduce((A,B)=>A|B,0))}var n;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},L={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class S{constructor(A=L){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,B=this.state.pageSize){return new S({...this.state,pageNumber:A,pageSize:B})}withFilter(A,...B){const x=[...this.state.criteria,...B.length?B.map(H=>({filterType:A,value:H})):[{filterType:A}]];return new S({...this.state,criteria:x})}withSortBy(A){return new S({...this.state,sortBy:A})}withSortOrder(A){return new S({...this.state,sortOrder:A})}withFlags(...A){return new S({...this.state,flags:A.reduce((B,x)=>B|x,0)})}withAssetTypes(...A){return new S({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:B,pageSize:x,sortBy:H,sortOrder:Q,flags:re,assetTypes:ie}=this.state;return{filters:[{criteria:A,pageNumber:B,pageSize:x,sortBy:H,sortOrder:Q}],assetTypes:ie,flags:re}}get searchText(){const A=this.state.criteria.filter(B=>B.filterType===n.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(M,A){const B=(M||[]).filter(x=>x.statisticName===A)[0];return B?B.value:0}function N(M){const A="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(x=>x.assetType.indexOf(A)===0).reduce((x,H)=>{const Q=le(M,H.assetType);return Q&&x.push([H.assetType.substring(A.length),Q]),x},[])}function X(M){if(M.properties){const A=M.properties.filter(H=>H.key===o.Repository),B=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=A.filter(H=>B.test(H.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return le(M,o.Repository)}function ee(M){return{uri:`${M.fallbackAssetUri}/${o.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${o.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function ue(M){const A=le(M,o.Icon);if(A)return A;const B=D.DefaultIconPath;return{uri:B,fallbackUri:B}}function le(M,A){return M.files.filter(x=>x.assetType===A)[0]?{uri:`${M.assetUri}/${A}`,fallbackUri:`${M.fallbackAssetUri}/${A}`}:null}function se(M,A){const B=M.properties?M.properties.filter(H=>H.key===A):[],x=B.length>0&&B[0].value;return x?x.split(",").map(H=>(0,c.adoptToGalleryExtensionId)(H)):[]}function ce(M){const A=M.properties?M.properties.filter(B=>B.key===h.Engine):[];return A.length>0&&A[0].value||""}function W(M){const A=M.properties?M.properties.filter(x=>x.key===h.LocalizedLanguages):[],B=A.length>0&&A[0].value||"";return B?B.split(","):[]}function q(M){return M.indexOf("preview")!==-1}function ne(M){return M.targetPlatform?(0,D.toTargetPlatform)(M.targetPlatform):"undefined"}function U(M){const A=(0,T.distinct)(M.versions.map(ne)),B=!!M.tags?.includes(D.WEB_EXTENSION_TAG),x=A.indexOf("web");return B?x===-1&&A.push("web"):x!==-1&&A.splice(x,1),A}function k(M,A){const B=(0,D.getFallbackTargetPlarforms)(A);for(let x=0;x<M.length;x++){const H=M[x];if(H.version===M[x-1]?.version){let Q=x;const re=ne(H);if(re===A)for(;Q>0&&M[Q-1].version===H.version;)Q--;else if(B.includes(re))for(;Q>0&&M[Q-1].version===H.version&&ne(M[Q-1])!==A;)Q--;Q!==x&&(M.splice(x,1),M.splice(Q,0,H))}}return M}i.sortExtensionVersions=k;function j(M,A,B,x,H){const Q=U(M);let re=M.versions[0];return re=M.versions.find(ie=>ie.version===re.version&&(0,D.isTargetPlatformCompatible)(ne(ie),Q,H))||re,G(M,re,Q,A,B,x)}function G(M,A,B,x,H,Q){const re={manifest:le(A,o.Manifest),readme:le(A,o.Details),changelog:le(A,o.Changelog),license:le(A,o.License),repository:X(A),download:ee(A),icon:ue(A),coreTranslations:N(A)};return{identifier:{id:(0,c.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:A.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,description:M.shortDescription||"",installCount:O(M.statistics,"install"),rating:O(M.statistics,"averagerating"),ratingCount:O(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:B,assets:re,properties:{dependencies:se(A,h.Dependency),extensionPack:se(A,h.ExtensionPack),engine:ce(A),localizedLanguages:W(A),targetPlatform:ne(A)},preview:q(M.flags),telemetryData:{index:(H.pageNumber-1)*H.pageSize+x,querySource:Q}}}let te=class{constructor(A,B,x,H,Q,re,ie,me){this.requestService=B,this.logService=x,this.environmentService=H,this.telemetryService=Q,this.fileService=re,this.productService=ie,this.configurationService=me;const ye=ie.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=_(ie.version,ie,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,B){const x=[];let H=new S().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,A.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...A.map(({id:re})=>re.toLowerCase()));A.every(re=>!re.version)&&(H=H.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:Q}=await this.queryGallery(H,t,I.CancellationToken.None);for(let re=0;re<Q.length;re++){const ie=Q[re];if(!ie.versions.length)continue;const me=(0,c.getGalleryExtensionId)(ie.publisher.publisherName,ie.extensionName),ye=A.find(fe=>(0,c.areSameExtensions)(fe,{id:me}))?.version;if(ye){const fe=ie.versions.find(Ie=>Ie.version===ye);fe&&x.push(G(ie,fe,U(ie),re,H))}else x.push(j(ie,re,H,void 0,t))}return x}async getCompatibleExtension(A,B){const x=(0,D.isIExtensionIdentifier)(A)?null:A;if(x){if((0,D.isNotWebExtensionInWebTargetPlatform)(x.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(x,B))return x}const{id:H,uuid:Q}=x?x.identifier:A;let re=new S().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");Q?re=re.withFilter(n.ExtensionId,Q):re=re.withFilter(n.ExtensionName,H);const{galleryExtensions:ie}=await this.queryGallery(re,B,I.CancellationToken.None),[me]=ie;if(!me||!me.versions.length)return null;const ye=U(me);if((0,D.isNotWebExtensionInWebTargetPlatform)(ye,B))return null;for(let fe of me.versions){if(!ce(fe)){const Ie=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:h.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(fe,ye,B))return G(me,fe,ye,0,re)}return null}async isExtensionCompatible(A,B){if(!(0,D.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,B))return!1;let x=A.properties.engine;if(!x){const H=await this.getManifest(A,I.CancellationToken.None);if(!H)throw new Error("Manifest was not found");x=H.engines.vscode}return(0,E.isEngineValid)(x,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,B,x){if(!(0,D.isTargetPlatformCompatible)(ne(A),B,x))return!1;const H=await this.getEngine(A);return(0,E.isEngineValid)(H,this.productService.version,this.productService.date)}async query(A,B){const x=I.CancellationToken.isCancellationToken(A)?{}:A,H=I.CancellationToken.isCancellationToken(A)?A:B;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Q=x.text||"";const re=(0,C.getOrDefault)(x,ve=>ve.pageSize,50);let ie=new S().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,re).withFilter(n.Target,"Microsoft.VisualStudio.Code");Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Ee,Fe)=>(ie=ie.withFilter(n.Category,Fe||Ee),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Ee,Fe)=>(ie=ie.withFilter(n.Tag,Fe||Ee),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(n.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),ie=ie.withFilter(n.SearchText,Q)),ie=ie.withSortBy(0)):x.ids?ie=ie.withFilter(n.ExtensionId,...x.ids):x.names?ie=ie.withFilter(n.ExtensionName,...x.names):ie=ie.withSortBy(4),typeof x.sortBy=="number"&&(ie=ie.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(ie=ie.withSortOrder(x.sortOrder));const{galleryExtensions:me,total:ye}=await this.queryGallery(ie,t,H),fe=me.map((ve,Ee)=>j(ve,Ee,ie,x.source,t)),Ie=async(ve,Ee)=>{if(Ee.isCancellationRequested)throw(0,b.canceled)();const Fe=ie.withPage(ve+1),{galleryExtensions:Me}=await this.queryGallery(Fe,t,Ee);return Me.map((ze,xe)=>j(ze,xe,Fe,x.source,t))};return{firstPage:fe,total:ye,pageSize:ie.pageSize,getPage:Ie}}async queryGallery(A,B,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,r.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,e(r.Unpublished));const H=await this.commonHeadersPromise,Q=JSON.stringify(A.raw),re={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},ie=new Date().getTime();let me,ye,fe=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:re},x),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:fe};const Ie=await(0,m.asJson)(me);if(Ie){const ve=Ie.results[0],Ee=ve.extensions;Ee.forEach(Me=>k(Me.versions,B));const Fe=ve.resultMetadata&&ve.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return fe=Fe&&Fe.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:fe}}return{galleryExtensions:[],total:fe}}catch(Ie){throw ye=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-ie,success:!!me&&(0,m.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ye?(0,b.isPromiseCanceledError)(ye)?"canceled":(0,b.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(A,B,x,H){if(!this.isEnabled())return;const Q=R.isWeb?this.api(`/itemName/${A}.${B}/version/${x}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${B}/${x}/stats?statType=${H}`),re=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:re};try{await this.requestService.request({type:"POST",url:Q,headers:me},I.CancellationToken.None)}catch(ye){}}async download(A,B,x){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const H=(0,c.getGalleryExtensionTelemetryData)(A),Q=new Date().getTime(),re=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:fe}),ie=x===1?"install":x===2?"update":"",me=ie?{uri:`${A.assets.download.uri}${l.URI.parse(A.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${A.assets.download.fallbackUri}${l.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:A.assets.download,ye=await this.getAsset(me);await this.fileService.writeFile(B,ye.stream),re(new Date().getTime()-Q)}async getReadme(A,B){if(A.assets.readme){const x=await this.getAsset(A.assets.readme,{},B);return await(0,m.asText)(x)||""}return""}async getManifest(A,B){if(A.assets.manifest){const x=await this.getAsset(A.assets.manifest,{},B),H=await(0,m.asText)(x);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(A,B){const x=le(A,o.Manifest);if(!x)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},Q=await this.getAsset(x,{headers:H});return await(0,m.asJson)(Q)}async getCoreTranslation(A,B){const x=A.assets.coreTranslations.filter(H=>H[0]===B.toUpperCase())[0];if(x){const H=await this.getAsset(x[1]),Q=await(0,m.asText)(H);return Q?JSON.parse(Q):null}return null}async getChangelog(A,B){if(A.assets.changelog){const x=await this.getAsset(A.assets.changelog,{},B);return await(0,m.asText)(x)||""}return""}async getAllCompatibleVersions(A,B){let x=new S().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?x=x.withFilter(n.ExtensionId,A.identifier.uuid):x=x.withFilter(n.ExtensionName,A.identifier.id);const{galleryExtensions:H}=await this.queryGallery(x,B,I.CancellationToken.None);if(!H.length)return[];const Q=U(H[0]);if((0,D.isNotWebExtensionInWebTargetPlatform)(Q,B))return[];const re=[];for(const ie of H[0].versions)try{re[re.length-1]?.version!==ie.version&&await this.isRawExtensionVersionCompatible(ie,Q,B)&&re.push({version:ie.version,date:ie.lastUpdated})}catch(me){}return re}async getAsset(A,B={},x=I.CancellationToken.None){const H=await this.commonHeadersPromise,Q={type:"GET"},re={...H,...B.headers||{}};B={...B,...Q,headers:re};const ie=A.uri,me=A.fallbackUri,ye={...B,url:ie};try{const fe=await this.requestService.request(ye,x);if(fe.res.statusCode===200)return fe;const Ie=await(0,m.asText)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${Ie}`)}catch(fe){if((0,b.isPromiseCanceledError)(fe))throw fe;const Ie=(0,b.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:Ie});const ve={...B,url:me};return this.requestService.request(ve,x)}}async getEngine(A){let B=ce(A);if(!B){const x=await this.getManifestFromRawExtensionVersion(A,I.CancellationToken.None);if(!x)throw new Error("Manifest was not found");B=x.engines.vscode}return B}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const B=await(0,m.asJson)(A),x=new Map;if(B)for(const H of B.malicious){const Q=x.get(H)||{id:{id:H},malicious:!0,slow:!1};Q.malicious=!0,x.set(H,Q)}return[...x.values()]}};te=de([oe(1,m.IRequestService),oe(2,d.ILogService),oe(3,y.IEnvironmentService),oe(4,s.ITelemetryService),oe(5,u.IFileService),oe(6,p.IProductService),oe(7,g.IConfigurationService)],te);let K=class extends te{constructor(A,B,x,H,Q,re,ie,me){super(A,B,x,H,Q,re,ie,me)}};K=de([oe(0,f.IStorageService),oe(1,m.IRequestService),oe(2,d.ILogService),oe(3,y.IEnvironmentService),oe(4,s.ITelemetryService),oe(5,u.IFileService),oe(6,p.IProductService),oe(7,g.IConfigurationService)],K),i.ExtensionGalleryService=K;let Z=class extends te{constructor(A,B,x,H,Q,re,ie){super(void 0,A,B,x,H,Q,re,ie)}};Z=de([oe(0,m.IRequestService),oe(1,d.ILogService),oe(2,y.IEnvironmentService),oe(3,s.ITelemetryService),oe(4,u.IFileService),oe(5,p.IProductService),oe(6,g.IConfigurationService)],Z),i.ExtensionGalleryServiceWithNoStorageService=Z;async function _(M,A,B,x,H,Q){const re={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M}`},ie=await(0,P.getServiceMachineId)(B,H,Q);return(0,a.supportsTelemetry)(A,B)&&(0,a.getTelemetryLevel)(x)===3&&(re["X-Market-User-Id"]=ie),re}i.resolveMarketplaceHeaders=_}),define(Y[121],J([0,1,2,21,12,27,86,26,33,122,25,30,36]),function(z,i,T,I,b,C,R,w,l,g,y,D,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let E=class{constructor(p,m){this._configurationService=m,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(P=>{const f=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(p,m){this._experimentProperties[p]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,c.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const p=await this._commonProperties;let m=p.sessionID,P=p["common.machineId"],f=p["common.firstSessionDate"],s=p["common.msftInternal"];return{sessionId:m,machineId:P,firstSessionDate:f,msftInternal:s}}dispose(){this._disposables.dispose()}_log(p,m,P,f){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(s=>{P=(0,I.mixin)(P,s),P=(0,I.mixin)(P,this._experimentProperties),P=(0,I.cloneAndChange)(P,a=>{if(typeof a=="string")return this._cleanupInfo(a,f)}),this._appenders.forEach(a=>a.log(p,P))},s=>{console.error(s)})}publicLog(p,m,P){return this._log(p,3,m,P)}publicLog2(p,m,P){return this.publicLog(p,m,P)}publicLogError(p,m){return this.sendErrorTelemetry?this._log(p,2,m,!0):Promise.resolve(void 0)}publicLogError2(p,m){return this.publicLogError(p,m)}_anonymizeFilePaths(p){let m=p;const P=[];for(let t of this._cleanupPatterns)for(;;){const r=t.exec(p);if(!r)break;P.push([r.index,t.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(m="";;){const t=s.exec(p);if(!t)break;!f.test(t[0])&&P.every(([r,e])=>t.index<r||t.index>=e)&&(m+=p.substring(a,t.index)+"<REDACTED: user-file-path>",a=s.lastIndex)}return a<p.length&&(m+=p.substr(a)),m}_removePropertiesWithPossibleUserInfo(p){if(!p)return p;const m=p.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":P.test(m)?"<REDACTED: email>":p}_cleanupInfo(p,m){let P=p;m&&(P=this._anonymizeFilePaths(P));for(let f of this._cleanupPatterns)P=P.replace(f,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=de([oe(1,w.IConfigurationService)],E),i.TelemetryService=E;function u(){const d=(0,R.localize)(0,null,g.default.nameLong),p=g.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=b.isWeb?"":(0,R.localize)(3,null),P=(0,R.localize)(4,null),f=(0,R.localize)(5,null),s=(0,R.localize)(6,null),a=(0,R.localize)(7,null),t=`
|       | ${P} | ${f} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,R.localize)(8,null);return`
${d} ${p} ${m}

&nbsp;

${a}
${t}

&nbsp;

${r}
`}y.Registry.as(l.Extensions.Configuration).registerConfiguration({id:D.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(9,null),properties:{[D.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(l.Extensions.Configuration).registerConfiguration({id:D.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[D.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,R.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,R.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${D.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[123],J([0,1,7,21,36]),function(z,i,T,I,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function C(w,l){const g=await new Promise((D,c)=>{z(["applicationinsights"],D,c)});let y;return g.defaultClient?(y=new g.TelemetryClient(w),y.channel.setUseDiskRetryCaching(!0)):(g.setup(w).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),y=g.defaultClient),w.indexOf("AIF-")===0&&(y.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),y}class R{constructor(l,g,y,D,c){this._eventPrefix=l,this._defaultData=g,this.testCollector=D,this.mirrored=c,this._defaultData||(this._defaultData=Object.create(null)),typeof y=="function"?this._aiClient=y():this._aiClient=y,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=C(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(g=>{l(g)},g=>{(0,T.onUnexpectedError)(g),console.error(g)})}}log(l,g){!this._aiClient||(g=(0,I.mixin)(g,this._defaultData),g=(0,b.validateTelemetryData)(g),this.testCollector&&(g.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(y=>y.trackEvent({name:this._eventPrefix+"/"+l,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}i.AppInsightsAppender=R}),define(Y[124],J([0,1,6,13]),function(z,i,T,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function b(C,R){const w=Object.create(null),l=(y,D)=>{const c=JSON.parse(y);w[D]=c};if(R){const y=[],D=await I.Promises.readdir(R);for(const E of D)try{(await I.Promises.stat((0,T.join)(R,E))).isDirectory()&&y.push(E)}catch{}const c=[];for(const E of y)(await I.Promises.readdir((0,T.join)(R,E))).filter(d=>d==="telemetry.json").length===1&&c.push(E);for(const E of c){const u=(await I.Promises.readFile((0,T.join)(R,E,"telemetry.json"))).toString();l(u,E)}}let g=(await I.Promises.readFile((0,T.join)(C,"telemetry-core.json"))).toString();return l(g,"vscode-core"),g=(await I.Promises.readFile((0,T.join)(C,"telemetry-extensions.json"))).toString(),l(g,"vscode-extensions"),JSON.stringify(w,null,4)}i.buildTelemetryMessage=b}),define(Y[37],J([0,1,14]),function(z,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(Y[125],J([0,1,10,2,8,20,23,16,15,37]),function(z,i,T,I,b,C,R,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let y=class extends I.Disposable{constructor(c,E,u,d,p){super();this.extensionsManagementService=c,this.logService=d,this.uriIdentityService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(P=>{this.installedExtensions=P.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(c.onInstallExtension(P=>this.onInstallExtension(P))),this._register(c.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(c.onDidUninstallExtension(P=>this.onDidUninstallExtension(P)));const m=b.URI.file(u.extensionsPath);this._register(E.watch(m)),this._register(T.Event.filter(E.onDidChangeFilesRaw,P=>P.changes.some(f=>this.doesChangeAffects(f,m)))(()=>this.onDidChange()))}doesChangeAffects(c,E){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(c.resource),E)?this.uriIdentityService.extUri.isEqual(c.resource,this.uriIdentityService.extUri.joinPath(E,".obsolete"))?!0:!(c.type!==1&&c.type!==2||this.uriIdentityService.extUri.basename(c.resource).startsWith(".")):!1}onInstallExtension(c){this.addInstallingExtension(c.identifier)}onDidInstallExtensions(c){for(const E of c)this.removeInstallingExtension(E.identifier),E.local&&this.addInstalledExtension(E.identifier)}onDidUninstallExtension(c){c.error||this.removeInstalledExtension(c.identifier)}addInstallingExtension(c){this.removeInstallingExtension(c),this.installingExtensions.push(c)}removeInstallingExtension(c){this.installingExtensions=this.installingExtensions.filter(E=>!(0,R.areSameExtensions)(E,c))}addInstalledExtension(c){this.installedExtensions&&(this.removeInstalledExtension(c),this.installedExtensions.push(c))}removeInstalledExtension(c){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(E=>!(0,R.areSameExtensions)(E,c)))}async onDidChange(){if(this.installedExtensions){const c=await this.extensionsManagementService.getInstalled(1),E=c.filter(d=>[...this.installingExtensions,...this.installedExtensions].some(p=>(0,R.areSameExtensions)(p,d.identifier))?!1:d.installedTimestamp&&d.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",d.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",d.identifier.id),!1)),u=this.installedExtensions.filter(d=>this.installingExtensions.some(p=>(0,R.areSameExtensions)(p,d))?!1:c.every(p=>!(0,R.areSameExtensions)(p.identifier,d))?(this.logService.info("Detected extension removed from another source",d.id),!0):!1);this.installedExtensions=c.map(d=>d.identifier),(E.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:E,removed:u})}}};y=de([oe(1,w.IFileService),oe(2,C.INativeEnvironmentService),oe(3,l.ILogService),oe(4,g.IUriIdentityService)],y),i.ExtensionsWatcher=y}),define(Y[126],J([0,1,37,91,16,18,59,10,2]),function(z,i,T,I,b,C,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class g{constructor(c){this.uri=c,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let y=class{constructor(c){this._fileService=c,this._dispooables=new l.DisposableStore,this._limit=2**16;const E=new Map,u=d=>{let p=E.get(d.scheme);return p===void 0&&(p=c.hasProvider(d)&&!this._fileService.hasCapability(d,1024),E.set(d.scheme,p)),p};this._dispooables.add(w.Event.any(c.onDidChangeFileSystemProviderRegistrations,c.onDidChangeFileSystemProviderCapabilities)(d=>{E.delete(d.scheme)})),this.extUri=new C.ExtUri(u),this._canonicalUris=new R.SkipList((d,p)=>this.extUri.compare(d,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(c){this._fileService.hasProvider(c)&&(c=(0,C.normalizePath)(c));let E=this._canonicalUris.get(c);return E?E.touch().uri.with({fragment:c.fragment}):(this._canonicalUris.set(c,new g(c)),this._checkTrim(),c)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const c=[...this._canonicalUris.entries()].sort((u,d)=>u[1].touch<d[1].touch?1:u[1].touch>d[1].touch?-1:0);g._clock=0,this._canonicalUris.clear();const E=this._limit*.5;for(let u=0;u<E;u++)this._canonicalUris.set(c[u][0],c[u][1].touch())}};y=de([oe(0,b.IFileService)],y),i.UriIdentityService=y,(0,I.registerSingleton)(T.IUriIdentityService,y,!0)}),define(Y[45],J([0,1,48,3,6,11,13,72,138,139]),function(z,i,T,I,b,C,R,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class y extends Error{constructor(t,r){let e=r.message;switch(t){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=t,this.cause=r}}i.ExtractError=y;function D(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,e)=>r+e,t&61440)}function c(a){if(a instanceof y)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new y(t,a)}function E(a,t,r,e,n,o){const h=b.dirname(t),v=b.join(e,h);if(!v.startsWith(e))return Promise.reject(new Error(w.localize(0,null,t)));const L=b.join(e,t);let S;return o.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(R.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!o.isCancellationRequested)try{S=(0,T.createWriteStream)(L,{mode:r}),S.once("close",()=>O()),S.once("error",N),a.once("error",N),a.pipe(S)}catch(X){N(X)}}))}function u(a,t,r,e){let n=(0,I.createCancelablePromise)(()=>Promise.resolve()),o=0;return e.onCancellationRequested(()=>{n.cancel(),a.close()}),new Promise((h,v)=>{const L=new I.Sequencer,S=O=>{O.isCancellationRequested||(o++,a.readEntry())};a.once("error",v),a.once("close",()=>n.then(()=>{e.isCancellationRequested||a.entryCount===o?h():v(new y("Incomplete",new Error(w.localize(1,null,o,a.entryCount))))},v)),a.readEntry(),a.on("entry",O=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){S(e);return}const N=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(N)){const ue=b.join(t,N);n=(0,I.createCancelablePromise)(le=>R.Promises.mkdir(ue,{recursive:!0}).then(()=>S(le)).then(void 0,v));return}const X=p(a,O),ee=D(O);n=(0,I.createCancelablePromise)(ue=>L.queue(()=>X.then(le=>E(le,N,ee,t,r,ue).then(()=>S(ue)))).then(null,v))})})}function d(a,t=!1){return new Promise((r,e)=>{(0,l.open)(a,t?{lazyEntries:!0}:void 0,(n,o)=>{n?e(c(n)):r((0,C.assertIsDefined)(o))})})}function p(a,t){return new Promise((r,e)=>{a.openReadStream(t,(n,o)=>{n?e(c(n)):r((0,C.assertIsDefined)(o))})})}function m(a,t){return new Promise((r,e)=>{const n=new g.ZipFile;t.forEach(h=>{h.contents?n.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&n.addFile(h.localPath,h.path)}),n.end();const o=(0,T.createWriteStream)(a);n.outputStream.pipe(o),n.outputStream.once("error",e),o.once("error",e),o.once("finish",()=>r(a))})}i.zip=m;function P(a,t,r={},e){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=d(a,!0);return r.overwrite&&(o=o.then(h=>R.Promises.rm(t).then(()=>h))),o.then(h=>u(h,t,{sourcePathRegex:n},e))}i.extract=P;function f(a,t){return d(a).then(r=>new Promise((e,n)=>{r.on("entry",o=>{o.fileName===t&&p(r,o).then(h=>e(h),h=>n(h))}),r.once("close",()=>n(new Error(w.localize(2,null,t))))}))}function s(a,t){return f(a,t).then(r=>new Promise((e,n)=>{const o=[];r.once("error",n),r.on("data",h=>o.push(h)),r.on("end",()=>e(Buffer.concat(o)))}))}i.buffer=s}),define(Y[127],J([0,1,45,79]),function(z,i,T,I){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function b(C){return(0,T.buffer)(C,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch(w){throw new Error((0,I.localize)(0,null))}})}i.getManifest=b}),define(Y[128],J([0,1,19,3,7,2,9,6,12,18,43,8,31,13,45,80,20,22,23,90,16,15,32]),function(z,i,T,I,b,C,R,w,l,g,y,D,c,E,u,d,p,m,P,f,s,a,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let r=class extends C.Disposable{constructor(n,o,h,v,L){super();this.beforeRemovingExtension=n,this.fileService=o,this.logService=h,this.environmentService=v,this.productService=L,this._devSystemExtensionsPath=null,this.systemExtensionsPath=v.builtinExtensionsPath,this.extensionsPath=v.extensionsPath,this.uninstalledPath=w.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new I.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const o=[];(n===null||n===0)&&o.push(this.scanSystemExtensions().then(null,h=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(h).message,m.ExtensionManagementErrorCode.Internal)))),(n===null||n===1)&&o.push(this.scanUserExtensions(!0).then(null,h=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(h).message,m.ExtensionManagementErrorCode.Internal))));try{const h=await Promise.all(o);return(0,T.flatten)(h)}catch(h){throw this.joinErrors(h)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[o,h]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return h=h.filter(v=>!o[new P.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]),n&&(h=(0,P.groupByExtension)(h,L=>L.identifier).map(L=>L.sort((S,O)=>y.rcompare(S.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",h.length),h}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,o,h,v){const L=n.key(),S=w.join(this.extensionsPath,`.${(0,c.generateUuid)()}`),O=w.join(this.extensionsPath,L);try{await E.Promises.rm(O)}catch(X){try{await E.Promises.rm(O)}catch(ee){}throw new m.ExtensionManagementError((0,d.localize)(0,null,O,n.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(n,o,S,v);let N=await this.scanExtension(D.URI.file(S),1);if(!N)throw new Error((0,d.localize)(1,null,S));await this.storeMetadata(N,{...h,installedTimestamp:Date.now()});try{await this.rename(n,S,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(X){try{await E.Promises.rm(S)}catch(ee){}if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",n.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(X)}. Deleted from extracted location`,S),X}try{N=await this.scanExtension(D.URI.file(O),1)}catch(X){}if(N)return N;throw new Error((0,d.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,o){return this.setMetadata(n,o),await this.storeMetadata(n,{...o,installedTimestamp:n.installedTimestamp}),n}async storeMetadata(n,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const h=w.join(n.location.fsPath,"package.json"),v=await E.Promises.readFile(h,"utf8"),{manifest:L}=await this.parseManifest(v);return L.__metadata=o,await E.Promises.writeFile(h,JSON.stringify(L,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...n){const o=n.map(h=>new P.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version));await this.withUninstalledExtensions(h=>{o.forEach(v=>h[v.key()]=!0)})}async setInstalled(n){await this.withUninstalledExtensions(v=>delete v[n.key()]);const h=(await this.scanExtensions(1)).find(v=>new P.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).equals(n))||null;return h?(await this.storeMetadata(h,{installedTimestamp:Date.now()}),this.scanExtension(h.location,1)):null}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await E.Promises.readFile(this.uninstalledPath,"utf8")}catch(v){if(v.code!=="ENOENT")throw v}let h={};if(o)try{h=JSON.parse(o)}catch(v){}return n&&(n(h),Object.keys(h).length?await E.Promises.writeFile(this.uninstalledPath,JSON.stringify(h)):await E.Promises.rm(this.uninstalledPath)),h})}async removeExtension(n,o){this.logService.trace(`Deleting ${o} extension from disk`,n.identifier.id,n.location.fsPath),await E.Promises.rm(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new P.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,o,h,v){this.logService.trace(`Started extracting the extension from ${o} to ${h}`);try{await E.Promises.rm(h)}catch(L){throw new m.ExtensionManagementError(this.joinErrors(L).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(o,h,{sourcePath:"extension",overwrite:!0},v),this.logService.info(`Extracted extension to ${h}:`,n.id)}catch(L){try{await E.Promises.rm(h)}catch(O){}let S=m.ExtensionManagementErrorCode.Extract;throw L instanceof u.ExtractError&&(L.type==="CorruptZip"?S=m.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(S=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(L.message,S)}}async rename(n,o,h,v){try{await E.Promises.rename(o,h)}catch(L){if(l.isWindows&&L&&L.code==="EPERM"&&Date.now()<v)return this.logService.info(`Failed renaming ${o} to ${h} with 'EPERM' error. Trying again...`,n.id),this.rename(n,o,h,v);throw new m.ExtensionManagementError(L.message||(0,d.localize)(3,null,o,h),L.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const o=this.scanDevSystemExtensions(),[h,v]=await Promise.all([n,o]);return[...h,...v]}async scanExtensionsInDir(n,o){const h=new I.Limiter(10),v=await this.fileService.resolve(D.URI.file(n));return v.children?(await Promise.all(v.children.filter(S=>S.isDirectory).map(S=>h.queue(async()=>o===1&&(0,g.basename)(S.resource).indexOf(".")===0?null:this.scanExtension(S.resource,o))))).filter(S=>S&&S.identifier):[]}async scanExtension(n,o){try{const h=await this.fileService.resolve(n);if(h.children){const{manifest:v,metadata:L}=await this.readManifest(n.fsPath),S=h.children.find(({name:ee})=>/^readme(\.txt|\.md|)$/i.test(ee))?.resource,O=h.children.find(({name:ee})=>/^changelog(\.txt|\.md|)$/i.test(ee))?.resource,N={id:(0,P.getGalleryExtensionId)(v.publisher,v.name)},X={type:o,identifier:N,manifest:v,location:n,readmeUrl:S,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return L&&(this.setMetadata(X,L),X.installedTimestamp=L.installedTimestamp),X}}catch(h){o!==0&&this.logService.trace(h)}return null}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(h=>n.some(v=>(0,P.areSameExtensions)(h.identifier,{id:v})))}else return[]}setMetadata(n,o){n.publisherDisplayName=o.publisherDisplayName||null,n.publisherId=o.publisherId||null,n.identifier.uuid=o.id,n.isMachineScoped=!!o.isMachineScoped,n.isBuiltin=n.type===0||!!o.isBuiltin}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),h=new Set;for(const S of o)n[new P.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()]||h.add(S.identifier.id.toLowerCase());const v=(0,P.groupByExtension)(o,S=>S.identifier);await I.Promises.settled(v.map(async S=>{const O=S.sort((N,X)=>y.rcompare(N.manifest.version,X.manifest.version))[0];h.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const L=o.filter(S=>n[new P.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()]);await I.Promises.settled(L.map(S=>this.removeUninstalledExtension(S)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),o=[],h=(0,P.groupByExtension)(n,v=>v.identifier);o.push(...(0,T.flatten)(h.map(v=>v.sort((L,S)=>y.rcompare(L.manifest.version,S.manifest.version)).slice(1)))),await I.Promises.settled(o.map(v=>this.removeExtension(v,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const o=Array.isArray(n)?n:[n];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((h,v)=>new Error(`${h.message}${h.message?",":""}${v instanceof Error?v.message:v}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=w.normalize(w.join(R.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const o=[E.Promises.readFile(w.join(n,"package.json"),"utf8").then(S=>this.parseManifest(S)),E.Promises.readFile(w.join(n,"package.nls.json"),"utf8").then(void 0,S=>S.code!=="ENOENT"?Promise.reject(S):"{}").then(S=>JSON.parse(S))],[{manifest:h,metadata:v},L]=await Promise.all(o);return{manifest:(0,f.localizeManifest)(h,L),metadata:v}}parseManifest(n){return new Promise((o,h)=>{try{const v=JSON.parse(n),L=v.__metadata||null;o({manifest:v,metadata:L})}catch(v){h(new Error((0,d.localize)(4,null)))}})}};r=de([oe(1,s.IFileService),oe(2,a.ILogService),oe(3,p.INativeEnvironmentService),oe(4,t.IProductService)],r),i.ExtensionsScanner=r}),define(Y[129],J([0,1,28,7,9,6,12,29,18,43,8,31,13,45,78,52,20,119,22,23,110,98,127,111,128,125,51,16,14,15,32,30,37]),function(z,i,T,I,b,C,R,w,l,g,y,D,c,E,u,d,p,m,P,f,s,a,t,r,e,n,o,h,v,L,S,O,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let X=class extends m.AbstractExtensionManagementService{constructor(W,q,ne,U,k,j,G,te,K){super(W,q,ne,te);this.environmentService=U,this.downloadService=k,this.fileService=G;const Z=this._register(j.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(e.ExtensionsScanner,M=>Z.postUninstall(M))),this.manifestCache=this._register(new r.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(j.createInstance(s.ExtensionsDownloader));const _=this._register(new n.ExtensionsWatcher(this,G,U,ne,K));this._register(_.onDidChangeExtensionsByAnotherSource(({added:M,removed:A})=>{M.length&&this._onDidInstallExtensions.fire(M.map(B=>({identifier:B.identifier,operation:0,local:B}))),A.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),q=(0,P.getTargetPlatform)(W?"alpine":R.platform,w.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",q),q})()),this._targetPlatformPromise}async isAlpineLinux(){if(!R.isLinux)return!1;let W;try{W=(await this.fileService.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch(q){try{W=(await this.fileService.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(ne){this.logService.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(ne))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const q=await this.collectFiles(W),ne=await(0,E.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)()).fsPath,q);return y.URI.file(ne)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const q=await this.downloadVsix(W),ne=C.resolve(q.fsPath);return(0,t.getManifest)(ne)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,q={}){this.logService.trace("ExtensionManagementService#install",W.toString());const ne=await this.downloadVsix(W),U=await(0,t.getManifest)(C.resolve(ne.fsPath));if(U.engines&&U.engines.vscode&&!(0,o.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,f.getGalleryExtensionId)(U.publisher,U.name),this.productService.version));return this.installExtension(U,ne,q)}async updateMetadata(W,q){return this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},...q}),this.manifestCache.invalidate(),W}async updateExtensionScope(W,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:q}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===b.Schemas.file)return W;const q=(0,l.joinPath)(this.environmentService.tmpDir,(0,D.generateUuid)());return await this.downloadService.download(W,q),q}createInstallExtensionTask(W,q,ne){return y.URI.isUri(q)?new le(W,q,ne,this.galleryService,this.extensionsScanner,this.logService):new ue(q,ne,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,q){return new se(W,q,this.extensionsScanner)}async collectFiles(W){const q=async U=>{let k=await c.Promises.readdir(U);k=k.map(te=>C.join(U,te));const j=await Promise.all(k.map(te=>c.Promises.stat(te)));let G=Promise.resolve([]);return j.forEach((te,K)=>{const Z=k[K];te.isFile()&&(G=G.then(_=>[..._,Z])),te.isDirectory()&&(G=G.then(_=>q(Z).then(M=>[..._,...M])))}),G};return(await q(W.location.fsPath)).map(U=>({path:`extension/${C.relative(W.location.fsPath,U)}`,localPath:U}))}};X=de([oe(0,P.IExtensionGalleryService),oe(1,O.ITelemetryService),oe(2,L.ILogService),oe(3,p.INativeEnvironmentService),oe(4,d.IDownloadService),oe(5,v.IInstantiationService),oe(6,h.IFileService),oe(7,S.IProductService),oe(8,N.IUriIdentityService)],X),i.ExtensionManagementService=X;class ee extends m.AbstractExtensionTask{constructor(W,q,ne,U){super();this.identifier=W,this.source=q,this.extensionsScanner=ne,this.logService=U,this._operation=1}get operation(){return this._operation}async installExtension(W,q){try{const ne=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(ne)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ne,W.metadata):ne}catch(ne){throw R.isMacintosh?new P.ExtensionManagementError(u.localize(1,null),P.ExtensionManagementErrorCode.Internal):new P.ExtensionManagementError(u.localize(2,null),P.ExtensionManagementErrorCode.Internal)}return this.extract(W,q)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const ne=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),ne}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:q,metadata:ne},U){let k=await this.extensionsScanner.extractUserExtension(q,W,ne,U);return this.logService.info("Extracting completed.",q.id),k}}class ue extends ee{constructor(W,q,ne,U,k){super(W.identifier,W,U,k);this.gallery=W,this.options=q,this.extensionsDownloader=ne}async doRun(W){const ne=(await this.extensionsScanner.scanExtensions(null)).find(k=>(0,f.areSameExtensions)(k.identifier,this.gallery.identifier));ne&&(this._operation=2);const U=await this.downloadInstallableExtension(this.gallery,this._operation);U.metadata.isMachineScoped=this.options.isMachineScoped||ne?.isMachineScoped,U.metadata.isBuiltin=this.options.isBuiltin||ne?.isBuiltin;try{const k=await this.installExtension(U,W);return ne&&g.neq(ne.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ne),k}catch(k){throw await this.deleteDownloadedVSIX(U.zipPath),k}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(y.URI.file(W))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,I.getErrorMessage)(q))}}async downloadInstallableExtension(W,q){const ne={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let U;try{this.logService.trace("Started downloading extension:",W.identifier.id),U=(await this.extensionsDownloader.downloadExtension(W,q)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,U)}catch(k){throw new P.ExtensionManagementError((0,m.joinErrors)(k).message,P.ExtensionManagementErrorCode.Download)}try{const k=await(0,t.getManifest)(U);return{zipPath:U,identifierWithVersion:new f.ExtensionIdentifierWithVersion(W.identifier,k.version),metadata:ne}}catch(k){throw await this.deleteDownloadedVSIX(U),new P.ExtensionManagementError((0,m.joinErrors)(k).message,P.ExtensionManagementErrorCode.Invalid)}}}class le extends ee{constructor(W,q,ne,U,k,j){super({id:(0,f.getGalleryExtensionId)(W.publisher,W.name)},q,k,j);this.manifest=W,this.location=q,this.options=ne,this.galleryService=U}async doRun(W){const q=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),U=(await this.extensionsScanner.scanExtensions(1)).find(j=>(0,f.areSameExtensions)(this.identifier,j.identifier)),k=await this.getMetadata(this.identifier.id,W);if(k.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,k.isBuiltin=this.options.isBuiltin||U?.isBuiltin,U)if(this._operation=2,q.equals(new f.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version)))try{await this.extensionsScanner.removeExtension(U,"existing")}catch(j){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else g.gt(U.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(U);else{const j=await this.unsetUninstalledAndGetLocal(q);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch(G){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:C.resolve(this.location.fsPath),identifierWithVersion:q,metadata:k},W)}async getMetadata(W,q){try{const ne=(await this.galleryService.query({names:[W],pageSize:1},q)).firstPage[0];if(ne)return{id:ne.identifier.uuid,publisherDisplayName:ne.publisherDisplayName,publisherId:ne.publisherId}}catch(ne){}return{}}}class se extends m.AbstractExtensionTask{constructor(W,q,ne){super();this.extension=W,this.options=q,this.extensionsScanner=ne}async doRun(W){const q=[],ne=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const U=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);q.push(...ne.filter(k=>U.equals(new f.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version))))}else q.push(...ne.filter(U=>(0,f.areSameExtensions)(U.identifier,this.extension.identifier)));if(!q.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const U of q)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(U)}catch(k){throw new Error(u.localize(6,null,(0,T.toErrorMessage)(k)))}}}}),define(Y[130],J([0,1,115,3,17,7,2,11,26,20,93,15,114,140]),function(z,i,T,I,b,C,R,w,l,g,y,D,c,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let u=class extends R.Disposable{constructor(p,m,P){super();this.environmentService=m,this.logService=P,this.configure(p.getValue()),this._register(p.onDidChangeConfiguration(()=>this.configure(p.getValue()),this))}configure(p){this.proxyUrl=p.http&&p.http.proxy,this.strictSSL=!!(p.http&&p.http.proxyStrictSSL),this.authorization=p.http&&p.http.proxyAuthorization}async request(p,m){this.logService.trace("RequestService#request",p.url);const{proxyUrl:P,strictSSL:f}=this;let s;try{s=await(0,y.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.logService.error("RequestService#request resolving shell environment failed",r)}const a={...process.env,...s},t=p.agent?p.agent:await(0,c.getProxyAgent)(p.url||"",a,{proxyUrl:P,strictSSL:f});return p.agent=t,p.strictSSL=f,this.authorization&&(p.headers={...p.headers||{},"Proxy-Authorization":this.authorization}),this._request(p,m)}async getNodeRequest(p){return((0,T.parse)(p.url).protocol==="https:"?await new Promise((f,s)=>{z(["https"],f,s)}):await new Promise((f,s)=>{z(["http"],f,s)})).request}_request(p,m){return I.Promises.withAsyncBody(async(P,f)=>{let s;const a=(0,T.parse)(p.url),t=p.getRawRequest?p.getRawRequest(p):await this.getNodeRequest(p),r={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:p.type||"GET",headers:p.headers,agent:p.agent,rejectUnauthorized:(0,w.isBoolean)(p.strictSSL)?p.strictSSL:!0};p.user&&p.password&&(r.auth=p.user+":"+p.password),s=t(r,e=>{const n=(0,w.isNumber)(p.followRedirects)?p.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)this._request({...p,url:e.headers.location,followRedirects:n-1},m).then(P,f);else{let o=e;e.headers["content-encoding"]==="gzip"&&(o=e.pipe((0,E.createGunzip)())),P({res:e,stream:(0,b.streamToBufferReadableStream)(o)})}}),s.on("error",f),p.timeout&&s.setTimeout(p.timeout),p.data&&typeof p.data=="string"&&s.write(p.data),s.end(),m.onCancellationRequested(()=>{s.abort(),f((0,C.canceled)())})})}async resolveProxy(p){}};u=de([oe(0,l.IConfigurationService),oe(1,g.INativeEnvironmentService),oe(2,D.ILogService)],u),i.RequestService=u}),define(Y[141],J([0,1,34,3,17,28,7,2,9,6,29,8,13,26,107,52,113,20,89,120,22,109,129,16,100,103,41,97,54,55,112,15,104,122,32,44,130,118,30,121,36,123,124,37,126]),function(z,i,T,I,b,C,R,w,l,g,y,D,c,E,u,d,p,m,P,f,s,a,t,r,e,n,o,h,v,L,S,O,N,X,ee,ue,le,se,ce,W,q,ne,U,k,j){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class G extends w.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,_]=await this.initServices();return Z.invokeFunction(async M=>{const A=M.get(O.ILogService),B=M.get(r.IFileService),x=M.get(m.INativeEnvironmentService),H=M.get(s.IExtensionManagementCLIService);A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(x,H,B),await Promise.all(_.map(Q=>{(0,I.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const Z=new v.ServiceCollection,_={_serviceBrand:void 0,...X.default};Z.set(ee.IProductService,_);const M=new P.NativeEnvironmentService(this.argv,_);Z.set(m.INativeEnvironmentService,M),await Promise.all([M.appSettingsHome.fsPath,M.extensionsPath].map(me=>me?c.Promises.mkdir(me,{recursive:!0}):void 0));const A=(0,O.getLogLevel)(M),B=[];B.push(new N.SpdLogLogger("cli",(0,g.join)(M.logsPath,"cli.log"),!0,!1,A)),A===O.LogLevel.Trace&&B.push(new O.ConsoleLogger(A));const x=this._register(new O.MultiplexLogService(B));Z.set(O.ILogService,x);const H=this._register(new e.FileService(x));Z.set(r.IFileService,H);const Q=this._register(new n.DiskFileSystemProvider(x));H.registerProvider(l.Schemas.file,Q);const re=this._register(new u.ConfigurationService(M.settingsResource,H));Z.set(E.IConfigurationService,re),await re.initialize(),Z.set(k.IUriIdentityService,new j.UriIdentityService(H)),Z.set(ue.IRequestService,new o.SyncDescriptor(le.RequestService)),Z.set(d.IDownloadService,new o.SyncDescriptor(p.DownloadService)),Z.set(s.IExtensionManagementService,new o.SyncDescriptor(t.ExtensionManagementService)),Z.set(s.IExtensionGalleryService,new o.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService)),Z.set(s.IExtensionManagementCLIService,new o.SyncDescriptor(a.ExtensionManagementCLIService)),Z.set(L.ILocalizationsService,new o.SyncDescriptor(S.LocalizationsService));const ie=[];if((0,q.supportsTelemetry)(_,M)){_.aiConfig&&_.aiConfig.asimovKey&&ie.push(new ne.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ye,installSourcePath:fe}=M,Ie={appenders:ie,sendErrorTelemetry:!1,commonProperties:(async()=>{let ve;try{const Ee=await c.Promises.readFile((0,g.join)(M.userDataPath,"storage.json"));ve=JSON.parse(Ee.toString())[ce.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&x.error(Ee)}return(0,se.resolveCommonProperties)(H,(0,T.release)(),(0,T.hostname)(),process.arch,_.commit,_.version,ve,_.msftInternalDomains,fe)})(),piiPaths:[me,ye]};Z.set(ce.ITelemetryService,new o.SyncDescriptor(W.TelemetryService,[Ie]))}else Z.set(ce.ITelemetryService,q.NullTelemetryService);return[new h.InstantiationService(Z),ie]}registerErrorHandler(Z){(0,R.setUnexpectedErrorHandler)(_=>{const M=(0,C.toErrorMessage)(_,!0);!M||Z.error(`[uncaught exception in CLI]: ${M}`)}),process.on("uncaughtException",_=>(0,R.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,R.onUnexpectedError)(_))}async doRun(Z,_,M){if(this.argv["install-source"])return this.setInstallSource(Z,M,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}asExtensionIdOrVSIX(Z){return Z.map(_=>/\.vsix$/i.test(_)?D.URI.file((0,g.isAbsolute)(_)?_:(0,g.join)((0,y.cwd)(),_)):_)}async setInstallSource(Z,_,M){await _.writeFile(D.URI.file(Z.installSourcePath),b.VSBuffer.fromString(M.slice(0,30)))}}async function te(K){const Z=new G(K);try{await Z.run()}finally{Z.dispose()}}i.main=te})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d450b04c783dfa6f83dc439017767acccd4e9fac/core/vs/code/node/cliProcessMain.js.map
