/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(Y){for(var e=[],m=0,L=Y.length;m<L;m++)e[m]=fe[Y[m]];return e};define(fe[56],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(L,y){if(!L)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=m}),define(fe[73],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function L(P){const I=[];for(let l in P)m.call(P,l)&&I.push(P[l]);return I}e.values=L;function y(P,I){for(let l in P)if(m.call(P,l)&&I({key:l,value:P[l]},function(){delete P[l]})===!1)return}e.forEach=y;function C(P,I){const l=Object.create(null);for(const v of P){const h=I(v);let w=l[h];w||(w=l[h]=[]),w.push(v)}return l}e.groupBy=C;function n(P){const I=Object.create(null);return P&&P.forEach((l,v)=>{I[v]=l}),I}e.fromMap=n;function k(P,I){const l=[],v=[];for(let h of P)I.has(h)||l.push(h);for(let h of I)P.has(h)||v.push(h);return{removed:l,added:v}}e.diffSets=k;function _(P,I){const l=[],v=[];for(let[h,w]of P)I.has(h)||l.push(w);for(let[h,w]of I)P.has(h)||v.push(w);return{removed:l,added:v}}e.diffMaps=_;class D{constructor(){this.map=new Map}add(I,l){let v=this.map.get(I);v||(v=new Set,this.map.set(I,v)),v.add(l)}delete(I,l){const v=this.map.get(I);!v||(v.delete(l),v.size===0&&this.map.delete(I))}forEach(I,l){const v=this.map.get(I);!v||v.forEach(l)}}e.SetMap=D}),define(fe[57],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(n){return(k,_,D)=>{let P=null,I=null;if(typeof D.value=="function"?(P="value",I=D.value):typeof D.get=="function"&&(P="get",I=D.get),!I)throw new Error("not supported");D[P]=n(I,_)}}e.createDecorator=m;function L(n,k,_){let D=null,P=null;if(typeof _.value=="function"?(D="value",P=_.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(D="get",P=_.get),!P)throw new Error("not supported");const I=`$memoize$${k}`;_[D]=function(...l){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,l)}),this[I]}}e.memoize=L;function y(n,k,_){return m((D,P)=>{const I=`$debounce$${P}`,l=`$debounce$result$${P}`;return function(...v){this[l]||(this[l]=_?_():void 0),clearTimeout(this[I]),k&&(this[l]=k(this[l],...v),v=[this[l]]),this[I]=setTimeout(()=>{D.apply(this,v),this[l]=_?_():void 0},n)}})}e.debounce=y;function C(n,k,_){return m((D,P)=>{const I=`$throttle$timer$${P}`,l=`$throttle$result$${P}`,v=`$throttle$lastRun$${P}`,h=`$throttle$pending$${P}`;return function(...w){if(this[l]||(this[l]=_?_():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),k&&(this[l]=k(this[l],...w)),this[h])return;const S=this[v]+n;S<=Date.now()?(this[v]=Date.now(),D.apply(this,[this[l]]),this[l]=_?_():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),D.apply(this,[this[l]]),this[l]=_?_():void 0},S-Date.now()))}})}e.throttle=C}),define(fe[16],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(b=>{b(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=m,e.errorHandler=new m;function L(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=L;function y(g){_(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=y;function C(g){_(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=C;function n(g){if(g instanceof Error){let{name:s,message:b}=g;const i=g.stacktrace||g.stack;return{$isError:!0,name:s,message:b,stack:i}}return g}e.transformErrorForSerialization=n;const k="Canceled";function _(g){return g instanceof Error&&g.name===k&&g.message===k}e.isPromiseCanceledError=_;class D extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=D;function P(){const g=new Error(k);return g.name=g.message,g}e.canceled=P;function I(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=I;function l(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=l;function v(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(g){const s=new Error(`${g} has been disposed`);return s.name="DISPOSED",s}e.disposed=h;function w(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=w;class S extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=S;class A extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=A;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;function a(g){const s=g;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=a;function r(g,s=Object.create(null)){const b=new Error(g);return s.actions&&(b.actions=s.actions),b}e.createErrorWithActions=r}),define(fe[17],me([0,1,16]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(j,X=0){return j[j.length-(1+X)]}e.tail=L;function y(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=y;function C(j,X,Q=(de,Se)=>de===Se){if(j===X)return!0;if(!j||!X||j.length!==X.length)return!1;for(let de=0,Se=j.length;de<Se;de++)if(!Q(j[de],X[de]))return!1;return!0}e.equals=C;function n(j,X,Q){let de=0,Se=j.length-1;for(;de<=Se;){const De=(de+Se)/2|0,Pe=Q(j[De],X);if(Pe<0)de=De+1;else if(Pe>0)Se=De-1;else return De}return-(de+1)}e.binarySearch=n;function k(j,X){let Q=0,de=j.length;if(de===0)return 0;for(;Q<de;){const Se=Math.floor((Q+de)/2);X(j[Se])?de=Se:Q=Se+1}return Q}e.findFirstInSorted=k;function _(j,X,Q){if(j=j|0,j>=X.length)throw new TypeError("invalid index");let de=X[Math.floor(X.length*Math.random())],Se=[],De=[],Pe=[];for(let Be of X){const We=Q(Be,de);We<0?Se.push(Be):We>0?De.push(Be):Pe.push(Be)}return j<Se.length?_(j,Se,Q):j<Se.length+Pe.length?Pe[0]:_(j-(Se.length+Pe.length),De,Q)}e.quickSelect=_;function D(j,X){const Q=[];let de;for(const Se of j.slice(0).sort(X))!de||X(de[0],Se)!==0?(de=[Se],Q.push(de)):de.push(Se);return Q}e.groupBy=D;function P(j,X,Q){const de=[];function Se(Be,We,He){if(We===0&&He.length===0)return;const G=de[de.length-1];G&&G.start+G.deleteCount===Be?(G.deleteCount+=We,G.toInsert.push(...He)):de.push({start:Be,deleteCount:We,toInsert:He})}let De=0,Pe=0;for(;;){if(De===j.length){Se(De,0,X.slice(Pe));break}if(Pe===X.length){Se(De,j.length-De,[]);break}const Be=j[De],We=X[Pe],He=Q(Be,We);He===0?(De+=1,Pe+=1):He<0?(Se(De,1,[]),De+=1):He>0&&(Se(De,0,[We]),Pe+=1)}return de}e.sortedDiff=P;function I(j,X,Q){const de=P(j,X,Q),Se=[],De=[];for(const Pe of de)Se.push(...j.slice(Pe.start,Pe.start+Pe.deleteCount)),De.push(...Pe.toInsert);return{removed:Se,added:De}}e.delta=I;function l(j,X,Q){if(Q===0)return[];const de=j.slice(0,Q).sort(X);return h(j,X,de,Q,j.length),de}e.top=l;function v(j,X,Q,de,Se){return Q===0?Promise.resolve([]):new Promise((De,Pe)=>{(async()=>{const Be=j.length,We=j.slice(0,Q).sort(X);for(let He=Q,G=Math.min(Q+de,Be);He<Be;He=G,G=Math.min(G+de,Be)){if(He>Q&&await new Promise(ee=>setTimeout(ee)),Se&&Se.isCancellationRequested)throw(0,m.canceled)();h(j,X,We,He,G)}return We})().then(De,Pe)})}e.topAsync=v;function h(j,X,Q,de,Se){for(const De=Q.length;de<Se;de++){const Pe=j[de];if(X(Pe,Q[De-1])<0){Q.pop();const Be=k(Q,We=>X(Pe,We)<0);Q.splice(Be,0,Pe)}}}function w(j){return j.filter(X=>!!X)}e.coalesce=w;function S(j){let X=0;for(let Q=0;Q<j.length;Q++)j[Q]&&(j[X]=j[Q],X+=1);j.length=X}e.coalesceInPlace=S;function A(j,X,Q){j.splice(Q,0,j.splice(X,1)[0])}e.move=A;function p(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=p;function a(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=a;function r(j,X=Q=>Q){const Q=new Set;return j.filter(de=>{const Se=X(de);return Q.has(Se)?!1:(Q.add(Se),!0)})}e.distinct=r;function g(j){const X=Object.create(null);return Q=>{const de=j(Q);return X[de]?!1:(X[de]=!0,!0)}}e.uniqueFilter=g;function s(j,X){const Q=b(j,X);if(Q!==-1)return j[Q]}e.findLast=s;function b(j,X){for(let Q=j.length-1;Q>=0;Q--){const de=j[Q];if(X(de))return Q}return-1}e.lastIndex=b;function i(j,X){return j.length>0?j[0]:X}e.firstOrDefault=i;function t(j,X,Q=(de,Se)=>de===Se){let de=0;for(let Se=0,De=Math.min(j.length,X.length);Se<De&&Q(j[Se],X[Se]);Se++)de++;return de}e.commonPrefixLength=t;function c(j){return[].concat(...j)}e.flatten=c;function d(j,X){let Q=typeof X=="number"?j:0;typeof X=="number"?Q=j:(Q=0,X=j);const de=[];if(Q<=X)for(let Se=Q;Se<X;Se++)de.push(Se);else for(let Se=Q;Se>X;Se--)de.push(Se);return de}e.range=d;function o(j,X,Q){return j.reduce((de,Se)=>(de[X(Se)]=Q?Q(Se):Se,de),Object.create(null))}e.index=o;function f(j,X){return j.push(X),()=>u(j,X)}e.insert=f;function u(j,X){const Q=j.indexOf(X);if(Q>-1)return j.splice(Q,1),X}e.remove=u;function E(j,X,Q){const de=j.slice(0,X),Se=j.slice(X);return de.concat(Q,Se)}e.arrayInsert=E;function T(j,X){let Q;if(typeof X=="number"){let de=X;Q=()=>{const Se=Math.sin(de++)*179426549;return Se-Math.floor(Se)}}else Q=Math.random;for(let de=j.length-1;de>0;de-=1){const Se=Math.floor(Q()*(de+1)),De=j[de];j[de]=j[Se],j[Se]=De}}e.shuffle=T;function R(j,X){const Q=j.indexOf(X);Q>-1&&(j.splice(Q,1),j.unshift(X))}e.pushToStart=R;function B(j,X){const Q=j.indexOf(X);Q>-1&&(j.splice(Q,1),j.push(X))}e.pushToEnd=B;function x(j,X){return Array.isArray(j)?j.map(X):X(j)}e.mapArrayOrNot=x;function F(j){return Array.isArray(j)?j:[j]}e.asArray=F;function $(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=$;function M(j,X){for(const Q of j){const de=X(Q);if(de!==void 0)return de}}e.mapFind=M;function H(j,X,Q){const de=U(j,X),Se=j.length,De=Q.length;j.length=Se+De;for(let Pe=Se-1;Pe>=de;Pe--)j[Pe+De]=j[Pe];for(let Pe=0;Pe<De;Pe++)j[Pe+de]=Q[Pe]}e.insertInto=H;function N(j,X,Q,de){const Se=U(j,X),De=j.splice(Se,Q);return H(j,Se,de),De}e.splice=N;function U(j,X){return X<0?Math.max(X+j.length,0):Math.min(X,j.length)}function V(j,X){let Q=Number.MAX_SAFE_INTEGER,de=0;return j.forEach((Se,De)=>{const Pe=X(Se);Pe<Q&&(Q=Pe,de=De)}),de}e.minIndex=V;function O(j,X){let Q=Number.MIN_SAFE_INTEGER,de=0;return j.forEach((Se,De)=>{const Pe=X(Se);Pe>Q&&(Q=Pe,de=De)}),de}e.maxIndex=O;class W{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let Q=this.firstIdx;for(;Q<this.items.length&&X(this.items[Q]);)Q++;const de=Q===this.firstIdx?null:this.items.slice(this.firstIdx,Q);return this.firstIdx=Q,de}takeFromEndWhile(X){let Q=this.lastIdx;for(;Q>=0&&X(this.items[Q]);)Q--;const de=Q===this.lastIdx?null:this.items.slice(Q+1,this.lastIdx+1);return this.lastIdx=Q,de}peek(){return this.items[this.firstIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}takeCount(X){const Q=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,Q}}e.ArrayQueue=W}),define(fe[74],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(L){const y=this;let C=!1,n;return function(){return C||(C=!0,n=L.apply(y,arguments)),n}}e.once=m}),define(fe[75],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(fe[76],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(L){function y(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}L.is=y;const C=Object.freeze([]);function n(){return C}L.empty=n;function*k(g){yield g}L.single=k;function _(g){return g||C}L.from=_;function D(g){return!g||g[Symbol.iterator]().next().done===!0}L.isEmpty=D;function P(g){return g[Symbol.iterator]().next().value}L.first=P;function I(g,s){for(const b of g)if(s(b))return!0;return!1}L.some=I;function l(g,s){for(const b of g)if(s(b))return b}L.find=l;function*v(g,s){for(const b of g)s(b)&&(yield b)}L.filter=v;function*h(g,s){let b=0;for(const i of g)yield s(i,b++)}L.map=h;function*w(...g){for(const s of g)for(const b of s)yield b}L.concat=w;function*S(g){for(const s of g)for(const b of s)yield b}L.concatNested=S;function A(g,s,b){let i=b;for(const t of g)i=s(i,t);return i}L.reduce=A;function*p(g,s,b=g.length){for(s<0&&(s+=g.length),b<0?b+=g.length:b>g.length&&(b=g.length);s<b;s++)yield g[s]}L.slice=p;function a(g,s=Number.POSITIVE_INFINITY){const b=[];if(s===0)return[b,g];const i=g[Symbol.iterator]();for(let t=0;t<s;t++){const c=i.next();if(c.done)return[b,L.empty()];b.push(c.value)}return[b,{[Symbol.iterator](){return i}}]}L.consume=a;function r(g,s,b=(i,t)=>i===t){const i=g[Symbol.iterator](),t=s[Symbol.iterator]();for(;;){const c=i.next(),d=t.next();if(c.done!==d.done)return!1;if(c.done)return!0;if(!b(c.value,d.value))return!1}}L.equals=r})(m=e.Iterable||(e.Iterable={}))}),define(fe[58],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var L;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(s){s.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function n(s,b=!1){let i=0,t=s.length,c="",d=0,o=16,f=0;function u($){let M=0,H=0;for(;M<$;){const N=s.charCodeAt(i);if(N>=48&&N<=57)H=H*16+N-48;else if(N>=65&&N<=70)H=H*16+N-65+10;else if(N>=97&&N<=102)H=H*16+N-97+10;else break;i++,M++}return M<$&&(H=-1),H}function E($){i=$,c="",d=0,o=16,f=0}function T(){const $=i;if(s.charCodeAt(i)===48)i++;else for(i++;i<s.length&&D(s.charCodeAt(i));)i++;if(i<s.length&&s.charCodeAt(i)===46)if(i++,i<s.length&&D(s.charCodeAt(i)))for(i++;i<s.length&&D(s.charCodeAt(i));)i++;else return f=3,s.substring($,i);let M=i;if(i<s.length&&(s.charCodeAt(i)===69||s.charCodeAt(i)===101))if(i++,(i<s.length&&s.charCodeAt(i)===43||s.charCodeAt(i)===45)&&i++,i<s.length&&D(s.charCodeAt(i))){for(i++;i<s.length&&D(s.charCodeAt(i));)i++;M=i}else f=3;return s.substring($,M)}function R(){let $="",M=i;for(;;){if(i>=t){$+=s.substring(M,i),f=2;break}const H=s.charCodeAt(i);if(H===34){$+=s.substring(M,i),i++;break}if(H===92){if($+=s.substring(M,i),i++,i>=t){f=2;break}switch(s.charCodeAt(i++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const U=u(4);U>=0?$+=String.fromCharCode(U):f=4;break;default:f=5}M=i;continue}if(H>=0&&H<=31)if(_(H)){$+=s.substring(M,i),f=2;break}else f=6;i++}return $}function B(){if(c="",f=0,d=i,i>=t)return d=t,o=17;let $=s.charCodeAt(i);if(k($)){do i++,c+=String.fromCharCode($),$=s.charCodeAt(i);while(k($));return o=15}if(_($))return i++,c+=String.fromCharCode($),$===13&&s.charCodeAt(i)===10&&(i++,c+=`
`),o=14;switch($){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,c=R(),o=10;case 47:const M=i-1;if(s.charCodeAt(i+1)===47){for(i+=2;i<t&&!_(s.charCodeAt(i));)i++;return c=s.substring(M,i),o=12}if(s.charCodeAt(i+1)===42){i+=2;const H=t-1;let N=!1;for(;i<H;){if(s.charCodeAt(i)===42&&s.charCodeAt(i+1)===47){i+=2,N=!0;break}i++}return N||(i++,f=1),c=s.substring(M,i),o=13}return c+=String.fromCharCode($),i++,o=16;case 45:if(c+=String.fromCharCode($),i++,i===t||!D(s.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=T(),o=11;default:for(;i<t&&x($);)i++,$=s.charCodeAt(i);if(d!==i){switch(c=s.substring(d,i),c){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return c+=String.fromCharCode($),i++,o=16}}function x($){if(k($)||_($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=B();while($>=12&&$<=15);return $}return{setPosition:E,getPosition:()=>i,scan:b?F:B,getToken:()=>o,getTokenValue:()=>c,getTokenOffset:()=>d,getTokenLength:()=>i-d,getTokenError:()=>f}}e.createScanner=n;function k(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function _(s){return s===10||s===13||s===8232||s===8233}function D(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function I(s,b){const i=[],t=new Object;let c;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function f(u,E,T,R){d.value=u,d.offset=E,d.length=T,d.type=R,d.colonOffset=void 0,c=d}try{a(s,{onObjectBegin:(u,E)=>{if(b<=u)throw t;c=void 0,o=b>u,i.push("")},onObjectProperty:(u,E,T)=>{if(b<E||(f(u,E,T,"property"),i[i.length-1]=u,b<=E+T))throw t},onObjectEnd:(u,E)=>{if(b<=u)throw t;c=void 0,i.pop()},onArrayBegin:(u,E)=>{if(b<=u)throw t;c=void 0,i.push(0)},onArrayEnd:(u,E)=>{if(b<=u)throw t;c=void 0,i.pop()},onLiteralValue:(u,E,T)=>{if(b<E||(f(u,E,T,g(u)),b<=E+T))throw t},onSeparator:(u,E,T)=>{if(b<=E)throw t;if(u===":"&&c&&c.type==="property")c.colonOffset=E,o=!1,c=void 0;else if(u===","){const R=i[i.length-1];typeof R=="number"?i[i.length-1]=R+1:(o=!0,i[i.length-1]=""),c=void 0}}})}catch(u){if(u!==t)throw u}return{path:i,previousNode:c,isAtPropertyKey:o,matches:u=>{let E=0;for(let T=0;E<u.length&&T<i.length;T++)if(u[E]===i[T]||u[E]==="*")E++;else if(u[E]!=="**")return!1;return E===u.length}}}e.getLocation=I;function l(s,b=[],i=C.DEFAULT){let t=null,c=[];const d=[];function o(u){Array.isArray(c)?c.push(u):t!==null&&(c[t]=u)}return a(s,{onObjectBegin:()=>{const u={};o(u),d.push(c),c=u,t=null},onObjectProperty:u=>{t=u},onObjectEnd:()=>{c=d.pop()},onArrayBegin:()=>{const u=[];o(u),d.push(c),c=u,t=null},onArrayEnd:()=>{c=d.pop()},onLiteralValue:o,onError:(u,E,T)=>{b.push({error:u,offset:E,length:T})}},i),c[0]}e.parse=l;function v(s,b=[],i=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(u){t.type==="property"&&(t.length=u-t.offset,t=t.parent)}function d(u){return t.children.push(u),u}a(s,{onObjectBegin:u=>{t=d({type:"object",offset:u,length:-1,parent:t,children:[]})},onObjectProperty:(u,E,T)=>{t=d({type:"property",offset:E,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:u,offset:E,length:T,parent:t})},onObjectEnd:(u,E)=>{t.length=u+E-t.offset,t=t.parent,c(u+E)},onArrayBegin:(u,E)=>{t=d({type:"array",offset:u,length:-1,parent:t,children:[]})},onArrayEnd:(u,E)=>{t.length=u+E-t.offset,t=t.parent,c(u+E)},onLiteralValue:(u,E,T)=>{d({type:g(u),offset:E,length:T,parent:t,value:u}),c(E+T)},onSeparator:(u,E,T)=>{t.type==="property"&&(u===":"?t.colonOffset=E:u===","&&c(E))},onError:(u,E,T)=>{b.push({error:u,offset:E,length:T})}},i);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=v;function h(s,b){if(!s)return;let i=s;for(let t of b)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let c=!1;for(const d of i.children)if(Array.isArray(d.children)&&d.children[0].value===t){i=d.children[1],c=!0;break}if(!c)return}else{const c=t;if(i.type!=="array"||c<0||!Array.isArray(i.children)||c>=i.children.length)return;i=i.children[c]}return i}e.findNodeAtLocation=h;function w(s){if(!s.parent||!s.parent.children)return[];const b=w(s.parent);if(s.parent.type==="property"){const i=s.parent.children[0].value;b.push(i)}else if(s.parent.type==="array"){const i=s.parent.children.indexOf(s);i!==-1&&b.push(i)}return b}e.getNodePath=w;function S(s){switch(s.type){case"array":return s.children.map(S);case"object":const b=Object.create(null);for(let i of s.children){const t=i.children[1];t&&(b[i.children[0].value]=S(t))}return b;case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=S;function A(s,b,i=!1){return b>=s.offset&&b<s.offset+s.length||i&&b===s.offset+s.length}e.contains=A;function p(s,b,i=!1){if(A(s,b,i)){const t=s.children;if(Array.isArray(t))for(let c=0;c<t.length&&t[c].offset<=b;c++){const d=p(t[c],b,i);if(d)return d}return s}}e.findNodeAtOffset=p;function a(s,b,i=C.DEFAULT){const t=n(s,!1);function c(Q){return Q?()=>Q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function d(Q){return Q?de=>Q(de,t.getTokenOffset(),t.getTokenLength()):()=>!0}const o=c(b.onObjectBegin),f=d(b.onObjectProperty),u=c(b.onObjectEnd),E=c(b.onArrayBegin),T=c(b.onArrayEnd),R=d(b.onLiteralValue),B=d(b.onSeparator),x=c(b.onComment),F=d(b.onError),$=i&&i.disallowComments,M=i&&i.allowTrailingComma;function H(){for(;;){const Q=t.scan();switch(t.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:$||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(Q){case 12:case 13:$?N(10):x();break;case 16:N(1);break;case 15:case 14:break;default:return Q}}}function N(Q,de=[],Se=[]){if(F(Q),de.length+Se.length>0){let De=t.getToken();for(;De!==17;){if(de.indexOf(De)!==-1){H();break}else if(Se.indexOf(De)!==-1)break;De=H()}}}function U(Q){const de=t.getTokenValue();return Q?R(de):f(de),H(),!0}function V(){switch(t.getToken()){case 11:let Q=0;try{Q=JSON.parse(t.getTokenValue()),typeof Q!="number"&&(N(2),Q=0)}catch(de){N(2)}R(Q);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return H(),!0}function O(){return t.getToken()!==10?(N(3,[],[2,5]),!1):(U(!1),t.getToken()===6?(B(":"),H(),X()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function W(){o(),H();let Q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Q||N(4,[],[]),B(","),H(),t.getToken()===2&&M)break}else Q&&N(6,[],[]);O()||N(4,[],[2,5]),Q=!0}return u(),t.getToken()!==2?N(7,[2],[]):H(),!0}function j(){E(),H();let Q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Q||N(4,[],[]),B(","),H(),t.getToken()===4&&M)break}else Q&&N(6,[],[]);X()||N(4,[],[4,5]),Q=!0}return T(),t.getToken()!==4?N(8,[4],[]):H(),!0}function X(){switch(t.getToken()){case 3:return j();case 1:return W();case 10:return U(!0);default:return V()}}return H(),t.getToken()===17?i.allowEmptyContent?!0:(N(4,[],[]),!1):X()?(t.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=a;function r(s,b){let i=n(s),t=[],c,d=0,o;do switch(o=i.getPosition(),c=i.scan(),c){case 12:case 13:case 17:d!==o&&t.push(s.substring(d,o)),b!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,b)),d=i.getPosition();break}while(c!==17);return t.join("")}e.stripComments=r;function g(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(fe[138],me([0,1,58]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(_,D,P){let I,l,v,h,w;if(D){for(h=D.offset,w=h+D.length,v=h;v>0&&!k(_,v-1);)v--;let d=w;for(;d<_.length&&!k(_,d);)d++;l=_.substring(v,d),I=C(l,P)}else l=_,I=0,v=0,h=0,w=_.length;const S=n(P,_);let A=!1,p=0,a;P.insertSpaces?a=y(" ",P.tabSize||4):a="	";const r=(0,m.createScanner)(l,!1);let g=!1;function s(){return S+y(a,I+p)}function b(){let d=r.scan();for(A=!1;d===15||d===14;)A=A||d===14,d=r.scan();return g=d===16||r.getTokenError()!==0,d}const i=[];function t(d,o,f){!g&&o<w&&f>h&&_.substring(o,f)!==d&&i.push({offset:o,length:f-o,content:d})}let c=b();if(c!==17){const d=r.getTokenOffset()+v,o=y(a,I);t(o,v,d)}for(;c!==17;){let d=r.getTokenOffset()+r.getTokenLength()+v,o=b(),f="";for(;!A&&(o===12||o===13);){const E=r.getTokenOffset()+v;t(" ",d,E),d=r.getTokenOffset()+r.getTokenLength()+v,f=o===12?s():"",o=b()}if(o===2)c!==1&&(p--,f=s());else if(o===4)c!==3&&(p--,f=s());else{switch(c){case 3:case 1:p++,f=s();break;case 5:case 12:f=s();break;case 13:A?f=s():f=" ";break;case 6:f=" ";break;case 10:if(o===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:o===12||o===13?f=" ":o!==5&&o!==17&&(g=!0);break;case 16:g=!0;break}A&&(o===12||o===13)&&(f=s())}const u=r.getTokenOffset()+v;t(f,d,u),c=o}return i}e.format=L;function y(_,D){let P="";for(let I=0;I<D;I++)P+=_;return P}function C(_,D){let P=0,I=0;const l=D.tabSize||4;for(;P<_.length;){const v=_.charAt(P);if(v===" ")I++;else if(v==="	")I+=l;else break;P++}return Math.floor(I/l)}function n(_,D){for(let P=0;P<D.length;P++){const I=D.charAt(P);if(I==="\r")return P+1<D.length&&D.charAt(P+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return _&&_.eol||`
`}e.getEOL=n;function k(_,D){return`\r
`.indexOf(_.charAt(D))!==-1}e.isEOL=k}),define(fe[139],me([0,1,58,138]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function y(D,P,I){return C(D,P,void 0,I)}e.removeProperty=y;function C(D,P,I,l,v){const h=P.slice(),w=[],S=(0,m.parseTree)(D,w);let A,p;for(;h.length>0&&(p=h.pop(),A=(0,m.findNodeAtLocation)(S,h),A===void 0&&I!==void 0);)typeof p=="string"?I={[p]:I}:I=[I];if(A)if(A.type==="object"&&typeof p=="string"&&Array.isArray(A.children)){const a=(0,m.findNodeAtLocation)(A,[p]);if(a!==void 0)if(I===void 0){if(!a.parent)throw new Error("Malformed AST");const r=A.children.indexOf(a.parent);let g,s=a.parent.offset+a.parent.length;if(r>0){const b=A.children[r-1];g=b.offset+b.length}else g=A.offset+1,A.children.length>1&&(s=A.children[1].offset);return n(D,{offset:g,length:s-g,content:""},l)}else return n(D,{offset:a.offset,length:a.length,content:JSON.stringify(I)},l);else{if(I===void 0)return[];const r=`${JSON.stringify(p)}: ${JSON.stringify(I)}`,g=v?v(A.children.map(b=>b.children[0].value)):A.children.length;let s;if(g>0){const b=A.children[g-1];s={offset:b.offset+b.length,length:0,content:","+r}}else A.children.length===0?s={offset:A.offset+1,length:0,content:r}:s={offset:A.offset+1,length:0,content:r+","};return n(D,s,l)}}else if(A.type==="array"&&typeof p=="number"&&Array.isArray(A.children))if(I!==void 0){const a=`${JSON.stringify(I)}`;let r;if(A.children.length===0||p===0)r={offset:A.offset+1,length:0,content:A.children.length===0?a:a+","};else{const g=p===-1||p>A.children.length?A.children.length:p,s=A.children[g-1];r={offset:s.offset+s.length,length:0,content:","+a}}return n(D,r,l)}else{const a=p,r=A.children[a];let g;if(A.children.length===1)g={offset:A.offset+1,length:A.length-2,content:""};else if(A.children.length-1===a){const s=A.children[a-1],b=s.offset+s.length,i=A.offset+A.length;g={offset:b,length:i-2-b,content:""}}else g={offset:r.offset,length:A.children[a+1].offset-r.offset,content:""};return n(D,g,l)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${A.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return n(D,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(I)},l)}}e.setProperty=C;function n(D,P,I){let l=k(D,P),v=P.offset,h=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;v>0&&!(0,L.isEOL)(l,v-1);)v--;for(;h<l.length&&!(0,L.isEOL)(l,h);)h++}const w=(0,L.format)(l,{offset:v,length:h-v},I);for(let A=w.length-1;A>=0;A--){const p=w[A];l=k(l,p),v=Math.min(v,p.offset),h=Math.max(h,p.offset+p.length),h+=p.content.length-p.length}const S=D.length-(l.length-h)-v;return[{offset:v,length:S,content:l.substring(v,h)}]}e.withFormatting=n;function k(D,P){return D.substring(0,P.offset)+P.content+D.substring(P.offset+P.length)}e.applyEdit=k;function _(D,P){let I=P.slice(0).sort((v,h)=>{const w=v.offset-h.offset;return w===0?v.length-h.length:w}),l=D.length;for(let v=I.length-1;v>=0;v--){let h=I[v];if(h.offset+h.length<=l)D=k(D,h);else throw new Error("Overlapping edit");l=h.offset}return D}e.applyEdits=_}),define(fe[140],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new m(()=>y(this.getValue()))}}e.Lazy=m}),define(fe[6],me([0,1,74,76]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let C=null;function n(t){C=t}if(e.setDisposableTracker=n,y){const t="__is_disposable_tracked__";n(new class{trackDisposable(c){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[t]||console.log(d)},3e3)}setParent(c,d){if(c&&c!==p.None)try{c[t]=!0}catch{}}markAsDisposed(c){if(c&&c!==p.None)try{c[t]=!0}catch{}}markAsSingleton(c){}})}function k(t){return C?.trackDisposable(t),t}function _(t){C?.markAsDisposed(t)}function D(t,c){C?.setParent(t,c)}function P(t,c){if(!!C)for(const d of t)C.setParent(d,c)}function I(t){return C?.markAsSingleton(t),t}e.markAsSingleton=I;class l extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=l;function v(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=v;function h(t){if(L.Iterable.is(t)){let c=[];for(const d of t)if(d)try{d.dispose()}catch(o){c.push(o)}if(c.length===1)throw c[0];if(c.length>1)throw new l(c);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function w(...t){const c=S(()=>h(t));return P(t,c),c}e.combinedDisposable=w;function S(t){const c=k({dispose:(0,m.once)(()=>{_(c),t()})});return c}e.toDisposable=S;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return D(c,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new A,k(this),D(this._store,this)}dispose(){_(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&D(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&D(c,null),c}}e.MutableDisposable=a;class r{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=r;class g{constructor(){this.references=new Map}acquire(c,...d){let o=this.references.get(c);o||(o={counter:0,object:this.createReferencedObject(c,...d)},this.references.set(c,o));const{object:f}=o,u=(0,m.once)(()=>{--o.counter==0&&(this.destroyReferencedObject(c,o.object),this.references.delete(c))});return o.counter++,{object:f,dispose:u}}}e.ReferenceCollection=g;class s{constructor(c){this.referenceCollection=c}async acquire(c,...d){const o=this.referenceCollection.acquire(c,...d);try{return{object:await o.object,dispose:()=>o.dispose()}}catch(f){throw o.dispose(),f}}}e.AsyncReferenceCollection=s;class b{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=b;function i(t){const c=new A;try{t(c)}finally{c.dispose()}}e.disposeOnReturn=i}),define(fe[94],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class L{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const n=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=n}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,n){const k=new m(C);if(this._first===m.Undefined)this._first=k,this._last=k;else if(n){const D=this._last;this._last=k,k.prev=D,D.next=k}else{const D=this._first;this._first=k,k.next=D,D.prev=k}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(k))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const n=C.prev;n.next=C.next,C.next.prev=n}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,ve){for(var Te=0;Te<ve.length;Te++){var se=ve[Te];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Re,se.key,se)}}function e(Re,ve,Te){return ve&&Y(Re.prototype,ve),Te&&Y(Re,Te),Re}function m(Re,ve){if(!!Re){if(typeof Re=="string")return L(Re,ve);var Te=Object.prototype.toString.call(Re).slice(8,-1);if(Te==="Object"&&Re.constructor&&(Te=Re.constructor.name),Te==="Map"||Te==="Set")return Array.from(Re);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return L(Re,ve)}}function L(Re,ve){(ve==null||ve>Re.length)&&(ve=Re.length);for(var Te=0,se=new Array(ve);Te<ve;Te++)se[Te]=Re[Te];return se}function y(Re,ve){var Te=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Te)return(Te=Te.call(Re)).next.bind(Te);if(Array.isArray(Re)||(Te=m(Re))||ve&&Re&&typeof Re.length=="number"){Te&&(Re=Te);var se=0;return function(){return se>=Re.length?{done:!0}:{done:!1,value:Re[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function n(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Re){C.exports.defaults=Re}C.exports={defaults:n(),getDefaults:n,changeDefaults:k};var _=/[&<>"']/,D=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(ve){return l[ve]};function h(Re,ve){if(ve){if(_.test(Re))return Re.replace(D,v)}else if(P.test(Re))return Re.replace(I,v);return Re}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function S(Re){return Re.replace(w,function(ve,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var A=/(^|[^\[])\^/g;function p(Re,ve){Re=Re.source||Re,ve=ve||"";var Te={replace:function(ue,be){return be=be.source||be,be=be.replace(A,"$1"),Re=Re.replace(ue,be),Te},getRegex:function(){return new RegExp(Re,ve)}};return Te}var a=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Re,ve,Te){if(Re){var se;try{se=decodeURIComponent(S(Te)).replace(a,"").toLowerCase()}catch(ue){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ve&&!r.test(Te)&&(Te=c(ve,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ue){return null}return Te}var s={},b=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(Re,ve){s[" "+Re]||(b.test(Re)?s[" "+Re]=Re+"/":s[" "+Re]=u(Re,"/",!0)),Re=s[" "+Re];var Te=Re.indexOf(":")===-1;return ve.substring(0,2)==="//"?Te?ve:Re.replace(i,"$1")+ve:ve.charAt(0)==="/"?Te?ve:Re.replace(t,"$1")+ve:Re+ve}var d={exec:function(){}};function o(Re){for(var ve=1,Te,se;ve<arguments.length;ve++){Te=arguments[ve];for(se in Te)Object.prototype.hasOwnProperty.call(Te,se)&&(Re[se]=Te[se])}return Re}function f(Re,ve){var Te=Re.replace(/\|/g,function(be,we,Fe){for(var qe=!1,ze=we;--ze>=0&&Fe[ze]==="\\";)qe=!qe;return qe?"|":" |"}),se=Te.split(/ \|/),ue=0;if(se[0].trim()||se.shift(),se[se.length-1].trim()||se.pop(),se.length>ve)se.splice(ve);else for(;se.length<ve;)se.push("");for(;ue<se.length;ue++)se[ue]=se[ue].trim().replace(/\\\|/g,"|");return se}function u(Re,ve,Te){var se=Re.length;if(se===0)return"";for(var ue=0;ue<se;){var be=Re.charAt(se-ue-1);if(be===ve&&!Te)ue++;else if(be!==ve&&Te)ue++;else break}return Re.substr(0,se-ue)}function E(Re,ve){if(Re.indexOf(ve[1])===-1)return-1;for(var Te=Re.length,se=0,ue=0;ue<Te;ue++)if(Re[ue]==="\\")ue++;else if(Re[ue]===ve[0])se++;else if(Re[ue]===ve[1]&&(se--,se<0))return ue;return-1}function T(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Re,ve){if(ve<1)return"";for(var Te="";ve>1;)ve&1&&(Te+=Re),ve>>=1,Re+=Re;return Te+Re}var B={escape:h,unescape:S,edit:p,cleanUrl:g,resolveUrl:c,noopTest:d,merge:o,splitCells:f,rtrim:u,findClosingBracket:E,checkSanitizeDeprecation:T,repeatString:R},x=C.exports.defaults,F=B.rtrim,$=B.splitCells,M=B.escape,H=B.findClosingBracket;function N(Re,ve,Te,se){var ue=ve.href,be=ve.title?M(ve.title):null,we=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){se.state.inLink=!0;var Fe={type:"link",raw:Te,href:ue,title:be,text:we,tokens:se.inlineTokens(we,[])};return se.state.inLink=!1,Fe}else return{type:"image",raw:Te,href:ue,title:be,text:M(we)}}function U(Re,ve){var Te=Re.match(/^(\s+)(?:```)/);if(Te===null)return ve;var se=Te[1];return ve.split(`
`).map(function(ue){var be=ue.match(/^\s+/);if(be===null)return ue;var we=be[0];return we.length>=se.length?ue.slice(se.length):ue}).join(`
`)}var V=function(){function Re(Te){this.options=Te||x}var ve=Re.prototype;return ve.space=function(se){var ue=this.rules.block.newline.exec(se);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ve.code=function(se){var ue=this.rules.block.code.exec(se);if(ue){var be=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?be:F(be,`
`)}}},ve.fences=function(se){var ue=this.rules.block.fences.exec(se);if(ue){var be=ue[0],we=U(be,ue[3]||"");return{type:"code",raw:be,lang:ue[2]?ue[2].trim():ue[2],text:we}}},ve.heading=function(se){var ue=this.rules.block.heading.exec(se);if(ue){var be=ue[2].trim();if(/#$/.test(be)){var we=F(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},ve.hr=function(se){var ue=this.rules.block.hr.exec(se);if(ue)return{type:"hr",raw:ue[0]}},ve.blockquote=function(se){var ue=this.rules.block.blockquote.exec(se);if(ue){var be=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},ve.list=function(se){var ue=this.rules.block.list.exec(se);if(ue){var be,we,Fe,qe,ze,Ye,lt,xe,ge,Ee,ae=ue[1].trim(),K=ae.length>1,Ce={type:"list",raw:"",ordered:K,start:K?+ae.slice(0,-1):"",loose:!1,items:[]};ae=K?"\\d{1,9}\\"+ae.slice(-1):"\\"+ae,this.options.pedantic&&(ae=K?ae:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ae+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");se&&!(this.rules.block.hr.test(se)||!(ue=Le.exec(se)));){ge=ue[2].split(`
`),this.options.pedantic?(qe=2,Ee=ge[0].trimLeft()):(qe=ue[2].search(/[^ ]/),qe=ue[1].length+(qe>4?1:qe),Ee=ge[0].slice(qe-ue[1].length)),Ye=!1,be=ue[0],!ge[0]&&/^ *$/.test(ge[1])&&(be=ue[1]+ge.slice(0,2).join(`
`)+`
`,Ce.loose=!0,ge=[]);var nt=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(ze=1;ze<ge.length;ze++){if(xe=ge[ze],this.options.pedantic&&(xe=xe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),nt.test(xe)){be=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}if(!Ye){xe.trim()||(Ye=!0),xe.search(/[^ ]/)>=qe?Ee+=`
`+xe.slice(qe):Ee+=`
`+xe;continue}if(xe.search(/[^ ]/)>=qe||!xe.trim()){Ee+=`
`+xe.slice(qe);continue}else{be=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}}Ce.loose||(lt?Ce.loose=!0:/\n *\n *$/.test(be)&&(lt=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(Ee),we&&(Fe=we[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Ce.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:Ee}),Ce.raw+=be,se=se.slice(be.length)}Ce.items[Ce.items.length-1].raw=be.trimRight(),Ce.items[Ce.items.length-1].text=Ee.trimRight(),Ce.raw=Ce.raw.trimRight();var Ge=Ce.items.length;for(ze=0;ze<Ge;ze++)this.lexer.state.top=!1,Ce.items[ze].tokens=this.lexer.blockTokens(Ce.items[ze].text,[]),Ce.items[ze].tokens.some(function(mt){return mt.type==="space"})&&(Ce.loose=!0,Ce.items[ze].loose=!0);return Ce}},ve.html=function(se){var ue=this.rules.block.html.exec(se);if(ue){var be={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},ve.def=function(se){var ue=this.rules.block.def.exec(se);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var be=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:ue[0],href:ue[2],title:ue[3]}}},ve.table=function(se){var ue=this.rules.block.table.exec(se);if(ue){var be={type:"table",header:$(ue[1]).map(function(lt){return{text:lt}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=ue[0];var we=be.align.length,Fe,qe,ze,Ye;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=$(be.rows[Fe],be.header.length).map(function(lt){return{text:lt}});for(we=be.header.length,qe=0;qe<we;qe++)be.header[qe].tokens=[],this.lexer.inlineTokens(be.header[qe].text,be.header[qe].tokens);for(we=be.rows.length,qe=0;qe<we;qe++)for(Ye=be.rows[qe],ze=0;ze<Ye.length;ze++)Ye[ze].tokens=[],this.lexer.inlineTokens(Ye[ze].text,Ye[ze].tokens);return be}}},ve.lheading=function(se){var ue=this.rules.block.lheading.exec(se);if(ue){var be={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ve.paragraph=function(se){var ue=this.rules.block.paragraph.exec(se);if(ue){var be={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ve.text=function(se){var ue=this.rules.block.text.exec(se);if(ue){var be={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ve.escape=function(se){var ue=this.rules.inline.escape.exec(se);if(ue)return{type:"escape",raw:ue[0],text:M(ue[1])}},ve.tag=function(se){var ue=this.rules.inline.tag.exec(se);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]):ue[0]}},ve.link=function(se){var ue=this.rules.inline.link.exec(se);if(ue){var be=ue[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=F(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=H(ue[2],"()");if(Fe>-1){var qe=ue[0].indexOf("!")===0?5:4,ze=qe+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,ze).trim(),ue[3]=""}}var Ye=ue[2],lt="";if(this.options.pedantic){var xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);xe&&(Ye=xe[1],lt=xe[3])}else lt=ue[3]?ue[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(be)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),N(ue,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:lt&&lt.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ve.reflink=function(se,ue){var be;if((be=this.rules.inline.reflink.exec(se))||(be=this.rules.inline.nolink.exec(se))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=ue[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return N(be,we,be[0],this.lexer)}},ve.emStrong=function(se,ue,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(se);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var qe=we[0].length-1,ze,Ye,lt=qe,xe=0,ge=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ue=ue.slice(-1*se.length+qe);(we=ge.exec(ue))!=null;)if(ze=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!ze){if(Ye=ze.length,we[3]||we[4]){lt+=Ye;continue}else if((we[5]||we[6])&&qe%3&&!((qe+Ye)%3)){xe+=Ye;continue}if(lt-=Ye,!(lt>0)){if(Ye=Math.min(Ye,Ye+lt+xe),Math.min(qe,Ye)%2){var Ee=se.slice(1,qe+we.index+Ye);return{type:"em",raw:se.slice(0,qe+we.index+Ye+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}var ae=se.slice(2,qe+we.index+Ye-1);return{type:"strong",raw:se.slice(0,qe+we.index+Ye+1),text:ae,tokens:this.lexer.inlineTokens(ae,[])}}}}}},ve.codespan=function(se){var ue=this.rules.inline.code.exec(se);if(ue){var be=ue[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=M(be,!0),{type:"codespan",raw:ue[0],text:be}}},ve.br=function(se){var ue=this.rules.inline.br.exec(se);if(ue)return{type:"br",raw:ue[0]}},ve.del=function(se){var ue=this.rules.inline.del.exec(se);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},ve.autolink=function(se,ue){var be=this.rules.inline.autolink.exec(se);if(be){var we,Fe;return be[2]==="@"?(we=M(this.options.mangle?ue(be[1]):be[1]),Fe="mailto:"+we):(we=M(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ve.url=function(se,ue){var be;if(be=this.rules.inline.url.exec(se)){var we,Fe;if(be[2]==="@")we=M(this.options.mangle?ue(be[0]):be[0]),Fe="mailto:"+we;else{var qe;do qe=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(qe!==be[0]);we=M(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ve.inlineText=function(se,ue){var be=this.rules.inline.text.exec(se);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):M(be[0]):be[0]:we=M(this.options.smartypants?ue(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Re}(),O=B.noopTest,W=B.edit,j=B.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=W(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=W(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=W(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=W(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=W(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=W(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=j({},X),X.gfm=j({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=W(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=j({},X.normal,{html:W(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:W(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=W(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=W(X._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=W(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=W(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=W(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=W(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=W(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=W(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=W(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=W(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=j({},Q),Q.pedantic=j({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:W(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:W(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=j({},Q.normal,{escape:W(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=W(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=j({},Q.gfm,{br:W(Q.br).replace("{2,}","*").getRegex(),text:W(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:X,inline:Q},Se=V,De=C.exports.defaults,Pe=de.block,Be=de.inline,We=B.repeatString;function He(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Re){var ve="",Te,se,ue=Re.length;for(Te=0;Te<ue;Te++)se=Re.charCodeAt(Te),Math.random()>.5&&(se="x"+se.toString(16)),ve+="&#"+se+";";return ve}var ee=function(){function Re(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||De,this.options.tokenizer=this.options.tokenizer||new Se,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:Pe.normal,inline:Be.normal};this.options.pedantic?(se.block=Pe.pedantic,se.inline=Be.pedantic):this.options.gfm&&(se.block=Pe.gfm,this.options.breaks?se.inline=Be.breaks:se.inline=Be.gfm),this.tokenizer.rules=se}Re.lex=function(se,ue){var be=new Re(ue);return be.lex(se)},Re.lexInline=function(se,ue){var be=new Re(ue);return be.inlineTokens(se)};var ve=Re.prototype;return ve.lex=function(se){se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ve.blockTokens=function(se,ue){var be=this;ue===void 0&&(ue=[]),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var we,Fe,qe,ze;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(lt){return(we=lt.call({lexer:be},se,ue))?(se=se.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.space(se)){se=se.substring(we.raw.length),we.type&&ue.push(we);continue}if(we=this.tokenizer.code(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(we=this.tokenizer.fences(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.heading(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.hr(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.blockquote(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.list(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.html(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.def(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.lheading(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(qe=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var lt=Infinity,xe=se.slice(1),ge=void 0;be.options.extensions.startBlock.forEach(function(Ee){ge=Ee.call({lexer:this},xe),typeof ge=="number"&&ge>=0&&(lt=Math.min(lt,ge))}),lt<Infinity&&lt>=0&&(qe=se.substring(0,lt+1))}(),this.state.top&&(we=this.tokenizer.paragraph(qe))){Fe=ue[ue.length-1],ze&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we),ze=qe.length!==se.length,se=se.substring(we.raw.length);continue}if(we=this.tokenizer.text(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(se){var Ye="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,ue},ve.inline=function(se,ue){this.inlineQueue.push({src:se,tokens:ue})},ve.inlineTokens=function(se,ue){var be=this;ue===void 0&&(ue=[]);var we,Fe,qe,ze=se,Ye,lt,xe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(ze))!=null;)ge.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(ze=ze.slice(0,Ye.index)+"["+We("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"["+We("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"++"+ze.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(lt||(xe=""),lt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(we=ae.call({lexer:be},se,ue))?(se=se.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.escape(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.tag(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.link(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.emStrong(se,ze,xe)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.codespan(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.br(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.del(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.autolink(se,G)){se=se.substring(we.raw.length),ue.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(se,G))){se=se.substring(we.raw.length),ue.push(we);continue}if(qe=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=Infinity,K=se.slice(1),Ce=void 0;be.options.extensions.startInline.forEach(function(Le){Ce=Le.call({lexer:this},K),typeof Ce=="number"&&Ce>=0&&(ae=Math.min(ae,Ce))}),ae<Infinity&&ae>=0&&(qe=se.substring(0,ae+1))}(),we=this.tokenizer.inlineText(qe,He)){se=se.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(xe=we.raw.slice(-1)),lt=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(se){var Ee="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return ue},e(Re,null,[{key:"rules",get:function(){return{block:Pe,inline:Be}}}]),Re}(),ne=C.exports.defaults,ce=B.cleanUrl,Z=B.escape,re=function(){function Re(Te){this.options=Te||ne}var ve=Re.prototype;return ve.code=function(se,ue,be){var we=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(se,we);Fe!=null&&Fe!==se&&(be=!0,se=Fe)}return se=se.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Z(we,!0)+'">'+(be?se:Z(se,!0))+`</code></pre>
`:"<pre><code>"+(be?se:Z(se,!0))+`</code></pre>
`},ve.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ve.html=function(se){return se},ve.heading=function(se,ue,be,we){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+we.slug(be)+'">'+se+"</h"+ue+`>
`:"<h"+ue+">"+se+"</h"+ue+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(se,ue,be){var we=ue?"ol":"ul",Fe=ue&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+se+"</"+we+`>
`},ve.listitem=function(se){return"<li>"+se+`</li>
`},ve.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(se){return"<p>"+se+`</p>
`},ve.table=function(se,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ue+`</table>
`},ve.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ve.tablecell=function(se,ue){var be=ue.header?"th":"td",we=ue.align?"<"+be+' align="'+ue.align+'">':"<"+be+">";return we+se+"</"+be+`>
`},ve.strong=function(se){return"<strong>"+se+"</strong>"},ve.em=function(se){return"<em>"+se+"</em>"},ve.codespan=function(se){return"<code>"+se+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(se){return"<del>"+se+"</del>"},ve.link=function(se,ue,be){if(se=ce(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var we='<a href="'+Z(se)+'"';return ue&&(we+=' title="'+ue+'"'),we+=">"+be+"</a>",we},ve.image=function(se,ue,be){if(se=ce(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var we='<img src="'+se+'" alt="'+be+'"';return ue&&(we+=' title="'+ue+'"'),we+=this.options.xhtml?"/>":">",we},ve.text=function(se){return se},Re}(),pe=function(){function Re(){}var ve=Re.prototype;return ve.strong=function(se){return se},ve.em=function(se){return se},ve.codespan=function(se){return se},ve.del=function(se){return se},ve.html=function(se){return se},ve.text=function(se){return se},ve.link=function(se,ue,be){return""+be},ve.image=function(se,ue,be){return""+be},ve.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var ve=Re.prototype;return ve.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(se,ue){var be=se,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[se];do we++,be=se+"-"+we;while(this.seen.hasOwnProperty(be))}return ue||(this.seen[se]=we,this.seen[be]=0),be},ve.slug=function(se,ue){ue===void 0&&(ue={});var be=this.serialize(se);return this.getNextSafeSlug(be,ue.dryrun)},Re}(),je=re,Ke=pe,Ze=Me,rt=C.exports.defaults,ct=B.unescape,ye=function(){function Re(Te){this.options=Te||rt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Ze}Re.parse=function(se,ue){var be=new Re(ue);return be.parse(se)},Re.parseInline=function(se,ue){var be=new Re(ue);return be.parseInline(se)};var ve=Re.prototype;return ve.parse=function(se,ue){ue===void 0&&(ue=!0);var be="",we,Fe,qe,ze,Ye,lt,xe,ge,Ee,ae,K,Ce,Le,nt,Ge,mt,yt,_t,gt,bt=se.length;for(we=0;we<bt;we++){if(ae=se[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(gt=this.options.extensions.renderers[ae.type].call({parser:this},ae),gt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){be+=gt||"";continue}switch(ae.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,ct(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(ge="",xe="",ze=ae.header.length,Fe=0;Fe<ze;Fe++)xe+=this.renderer.tablecell(this.parseInline(ae.header[Fe].tokens),{header:!0,align:ae.align[Fe]});for(ge+=this.renderer.tablerow(xe),Ee="",ze=ae.rows.length,Fe=0;Fe<ze;Fe++){for(lt=ae.rows[Fe],xe="",Ye=lt.length,qe=0;qe<Ye;qe++)xe+=this.renderer.tablecell(this.parseInline(lt[qe].tokens),{header:!1,align:ae.align[qe]});Ee+=this.renderer.tablerow(xe)}be+=this.renderer.table(ge,Ee);continue}case"blockquote":{Ee=this.parse(ae.tokens),be+=this.renderer.blockquote(Ee);continue}case"list":{for(K=ae.ordered,Ce=ae.start,Le=ae.loose,ze=ae.items.length,Ee="",Fe=0;Fe<ze;Fe++)Ge=ae.items[Fe],mt=Ge.checked,yt=Ge.task,nt="",Ge.task&&(_t=this.renderer.checkbox(mt),Le?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=_t+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=_t+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:_t}):nt+=_t),nt+=this.parse(Ge.tokens,Le),Ee+=this.renderer.listitem(nt,yt,mt);be+=this.renderer.list(Ee,K,Ce);continue}case"html":{be+=this.renderer.html(ae.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(Ee=ae.tokens?this.parseInline(ae.tokens):ae.text;we+1<bt&&se[we+1].type==="text";)ae=se[++we],Ee+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);be+=ue?this.renderer.paragraph(Ee):Ee;continue}default:{var vt='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return be},ve.parseInline=function(se,ue){ue=ue||this.renderer;var be="",we,Fe,qe,ze=se.length;for(we=0;we<ze;we++){if(Fe=se[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=qe||"";continue}switch(Fe.type){case"escape":{be+=ue.text(Fe.text);break}case"html":{be+=ue.html(Fe.text);break}case"link":{be+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{be+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{be+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{be+=ue.codespan(Fe.text);break}case"br":{be+=ue.br();break}case"del":{be+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{be+=ue.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return be},Re}(),at=ee,J=ye,ie=V,_e=re,Qe=pe,et=Me,le=B.merge,Ie=B.checkSanitizeDeprecation,Ue=B.escape,Xe=C.exports.getDefaults,it=C.exports.changeDefaults,ft=C.exports.defaults;function tt(Re,ve,Te){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof ve=="function"&&(Te=ve,ve=null),ve=le({},tt.defaults,ve||{}),Ie(ve),Te){var se=ve.highlight,ue;try{ue=at.lex(Re,ve)}catch(qe){return Te(qe)}var be=function(ze){var Ye;if(!ze)try{ve.walkTokens&&tt.walkTokens(ue,ve.walkTokens),Ye=J.parse(ue,ve)}catch(lt){ze=lt}return ve.highlight=se,ze?Te(ze):Te(null,Ye)};if(!se||se.length<3||(delete ve.highlight,!ue.length))return be();var we=0;tt.walkTokens(ue,function(qe){qe.type==="code"&&(we++,setTimeout(function(){se(qe.text,qe.lang,function(ze,Ye){if(ze)return be(ze);Ye!=null&&Ye!==qe.text&&(qe.text=Ye,qe.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=at.lex(Re,ve);return ve.walkTokens&&tt.walkTokens(Fe,ve.walkTokens),J.parse(Fe,ve)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+Ue(qe.message+"",!0)+"</pre>";throw qe}}tt.options=tt.setOptions=function(Re){return le(tt.defaults,Re),it(tt.defaults),tt},tt.getDefaults=Xe,tt.defaults=ft,tt.use=function(){for(var Re=this,ve=arguments.length,Te=new Array(ve),se=0;se<ve;se++)Te[se]=arguments[se];var ue=le.apply(void 0,[{}].concat(Te)),be=tt.defaults.extensions||{renderers:{},childTokens:{}},we;Te.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ye=be.renderers?be.renderers[ze.name]:null;Ye?be.renderers[ze.name]=function(){for(var lt=arguments.length,xe=new Array(lt),ge=0;ge<lt;ge++)xe[ge]=arguments[ge];var Ee=ze.renderer.apply(this,xe);return Ee===!1&&(Ee=Ye.apply(this,xe)),Ee}:be.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[ze.level]?be[ze.level].unshift(ze.tokenizer):be[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?be.startBlock?be.startBlock.push(ze.start):be.startBlock=[ze.start]:ze.level==="inline"&&(be.startInline?be.startInline.push(ze.start):be.startInline=[ze.start]))}ze.childTokens&&(be.childTokens[ze.name]=ze.childTokens)})),Fe.renderer&&function(){var ze=tt.defaults.renderer||new _e,Ye=function(ge){var Ee=ze[ge];ze[ge]=function(){for(var ae=arguments.length,K=new Array(ae),Ce=0;Ce<ae;Ce++)K[Ce]=arguments[Ce];var Le=Fe.renderer[ge].apply(ze,K);return Le===!1&&(Le=Ee.apply(ze,K)),Le}};for(var lt in Fe.renderer)Ye(lt);ue.renderer=ze}(),Fe.tokenizer&&function(){var ze=tt.defaults.tokenizer||new ie,Ye=function(ge){var Ee=ze[ge];ze[ge]=function(){for(var ae=arguments.length,K=new Array(ae),Ce=0;Ce<ae;Ce++)K[Ce]=arguments[Ce];var Le=Fe.tokenizer[ge].apply(ze,K);return Le===!1&&(Le=Ee.apply(ze,K)),Le}};for(var lt in Fe.tokenizer)Ye(lt);ue.tokenizer=ze}(),Fe.walkTokens){var qe=tt.defaults.walkTokens;ue.walkTokens=function(ze){Fe.walkTokens.call(Re,ze),qe&&qe(ze)}}we&&(ue.extensions=be),tt.setOptions(ue)})},tt.walkTokens=function(Re,ve){for(var Te=function(){var we=ue.value;switch(ve(we),we.type){case"table":{for(var Fe=y(we.header),qe;!(qe=Fe()).done;){var ze=qe.value;tt.walkTokens(ze.tokens,ve)}for(var Ye=y(we.rows),lt;!(lt=Ye()).done;)for(var xe=lt.value,ge=y(xe),Ee;!(Ee=ge()).done;){var ae=Ee.value;tt.walkTokens(ae.tokens,ve)}break}case"list":{tt.walkTokens(we.items,ve);break}default:tt.defaults.extensions&&tt.defaults.extensions.childTokens&&tt.defaults.extensions.childTokens[we.type]?tt.defaults.extensions.childTokens[we.type].forEach(function(K){tt.walkTokens(we[K],ve)}):we.tokens&&tt.walkTokens(we.tokens,ve)}},se=y(Re),ue;!(ue=se()).done;)Te()},tt.parseInline=function(Re,ve){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");ve=le({},tt.defaults,ve||{}),Ie(ve);try{var Te=at.lexInline(Re,ve);return ve.walkTokens&&tt.walkTokens(Te,ve.walkTokens),J.parseInline(Te,ve)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+Ue(se.message+"",!0)+"</pre>";throw se}},tt.Parser=J,tt.parser=J.parse,tt.Renderer=_e,tt.TextRenderer=Qe,tt.Lexer=at,tt.lexer=at.lex,tt.Tokenizer=ie,tt.Slugger=et,tt.parse=tt;var ut=tt;return ut}),define(fe[77],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(n,k,_){return Math.min(Math.max(n,k),_)}e.clamp=m;function L(n,k){return(k+n%k)%k}e.rot=L;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class C{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(y){const C=[];typeof y=="number"&&C.push("code/timeOrigin",y);function n(_){C.push(_,Date.now())}function k(){const _=[];for(let D=0;D<C.length;D+=2)_.push({name:C[D],startTime:C[D+1]});return _}return{mark:n,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const n of performance.getEntriesByType("mark"))C.push({name:n.name,startTime:Math.round(y+n.startTime)});return C}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function m(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=m(L))}(),define(fe[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let L=!1,y=!1,C=!1,n=!1,k=!1,_=!1,D=!1,P,I=m,l,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const w=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=w&&h?.sandboxed,typeof navigator=="object"&&!w)v=navigator.userAgent,L=v.indexOf("Windows")>=0,y=v.indexOf("Macintosh")>=0,D=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=v.indexOf("Linux")>=0,_=!0,P=navigator.language,I=P;else if(typeof h=="object"){L=h.platform==="win32",y=h.platform==="darwin",C=h.platform==="linux",n=C&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,P=m,I=m;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const t=JSON.parse(i),c=t.availableLanguages["*"];P=t.locale,I=c||m,l=t._translationsConfigFile}catch(t){}k=!0}else console.error("Unable to resolve platform.");var S;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function A(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=A;let p=0;y?p=1:L?p=3:C&&(p=2),e.isWindows=L,e.isMacintosh=y,e.isLinux=C,e.isLinuxSnap=n,e.isNative=k,e.isWeb=_,e.isIOS=D,e.platform=p,e.userAgent=v,e.language=I;var a;(function(i){function t(){return e.language}i.value=t;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=c;function d(){return e.language==="en"}i.isDefault=d})(a=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=l,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",o=>{if(o.data&&o.data.vscodeSetImmediateId)for(let f=0,u=c.length;f<u;f++){const E=c[f];if(E.id===o.data.vscodeSetImmediateId){c.splice(f,1),E.callback();return}}});let d=0;return o=>{const f=++d;c.push({id:f,callback:o}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const t=Promise.resolve();return c=>t.then(c)}();var r;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||D?2:L?1:3;let g=!0,s=!1;function b(){if(!s){s=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,g=new Uint16Array(i.buffer)[0]===(2<<8)+1}return g}e.isLittleEndian=b}),define(fe[37],me([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const y=m.globals.vscode.process;L={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()},nextTick(C){return(0,m.setImmediate)(C)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(y){return process.nextTick(y)}}:L={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},nextTick(y){return(0,m.setImmediate)(y)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(fe[9],me([0,1,37]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,y=97,C=90,n=122,k=46,_=47,D=92,P=58,I=63;class l extends Error{constructor(r,g,s){let b;typeof g=="string"&&g.indexOf("not ")===0?(b="must not be",g=g.replace(/^not /,"")):b="must be";const i=r.indexOf(".")!==-1?"property":"argument";let t=`The "${r}" ${i} ${b} of type ${g}`;t+=`. Received type ${typeof s}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function v(a,r){if(typeof a!="string")throw new l(r,"string",a)}function h(a){return a===_||a===D}function w(a){return a===_}function S(a){return a>=L&&a<=C||a>=y&&a<=n}function A(a,r,g,s){let b="",i=0,t=-1,c=0,d=0;for(let o=0;o<=a.length;++o){if(o<a.length)d=a.charCodeAt(o);else{if(s(d))break;d=_}if(s(d)){if(!(t===o-1||c===1))if(c===2){if(b.length<2||i!==2||b.charCodeAt(b.length-1)!==k||b.charCodeAt(b.length-2)!==k){if(b.length>2){const f=b.lastIndexOf(g);f===-1?(b="",i=0):(b=b.slice(0,f),i=b.length-1-b.lastIndexOf(g)),t=o,c=0;continue}else if(b.length!==0){b="",i=0,t=o,c=0;continue}}r&&(b+=b.length>0?`${g}..`:"..",i=2)}else b.length>0?b+=`${g}${a.slice(t+1,o)}`:b=a.slice(t+1,o),i=o-t-1;t=o,c=0}else d===k&&c!==-1?++c:c=-1}return b}function p(a,r){if(r===null||typeof r!="object")throw new l("pathObject","Object",r);const g=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return g?g===r.root?`${g}${s}`:`${g}${a}${s}`:s}e.win32={resolve(...a){let r="",g="",s=!1;for(let b=a.length-1;b>=-1;b--){let i;if(b>=0){if(i=a[b],v(i,"path"),i.length===0)continue}else r.length===0?i=m.cwd():(i=m.env[`=${r}`]||m.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==r.toLowerCase()&&i.charCodeAt(2)===D)&&(i=`${r}\\`));const t=i.length;let c=0,d="",o=!1;const f=i.charCodeAt(0);if(t===1)h(f)&&(c=1,o=!0);else if(h(f))if(o=!0,h(i.charCodeAt(1))){let u=2,E=u;for(;u<t&&!h(i.charCodeAt(u));)u++;if(u<t&&u!==E){const T=i.slice(E,u);for(E=u;u<t&&h(i.charCodeAt(u));)u++;if(u<t&&u!==E){for(E=u;u<t&&!h(i.charCodeAt(u));)u++;(u===t||u!==E)&&(d=`\\\\${T}\\${i.slice(E,u)}`,c=u)}}}else c=1;else S(f)&&i.charCodeAt(1)===P&&(d=i.slice(0,2),c=2,t>2&&h(i.charCodeAt(2))&&(o=!0,c=3));if(d.length>0)if(r.length>0){if(d.toLowerCase()!==r.toLowerCase())continue}else r=d;if(s){if(r.length>0)break}else if(g=`${i.slice(c)}\\${g}`,s=o,o&&r.length>0)break}return g=A(g,!s,"\\",h),s?`${r}\\${g}`:`${r}${g}`||"."},normalize(a){v(a,"path");const r=a.length;if(r===0)return".";let g=0,s,b=!1;const i=a.charCodeAt(0);if(r===1)return w(i)?"\\":a;if(h(i))if(b=!0,h(a.charCodeAt(1))){let c=2,d=c;for(;c<r&&!h(a.charCodeAt(c));)c++;if(c<r&&c!==d){const o=a.slice(d,c);for(d=c;c<r&&h(a.charCodeAt(c));)c++;if(c<r&&c!==d){for(d=c;c<r&&!h(a.charCodeAt(c));)c++;if(c===r)return`\\\\${o}\\${a.slice(d)}\\`;c!==d&&(s=`\\\\${o}\\${a.slice(d,c)}`,g=c)}}}else g=1;else S(i)&&a.charCodeAt(1)===P&&(s=a.slice(0,2),g=2,r>2&&h(a.charCodeAt(2))&&(b=!0,g=3));let t=g<r?A(a.slice(g),!b,"\\",h):"";return t.length===0&&!b&&(t="."),t.length>0&&h(a.charCodeAt(r-1))&&(t+="\\"),s===void 0?b?`\\${t}`:t:b?`${s}\\${t}`:`${s}${t}`},isAbsolute(a){v(a,"path");const r=a.length;if(r===0)return!1;const g=a.charCodeAt(0);return h(g)||r>2&&S(g)&&a.charCodeAt(1)===P&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let r,g;for(let i=0;i<a.length;++i){const t=a[i];v(t,"path"),t.length>0&&(r===void 0?r=g=t:r+=`\\${t}`)}if(r===void 0)return".";let s=!0,b=0;if(typeof g=="string"&&h(g.charCodeAt(0))){++b;const i=g.length;i>1&&h(g.charCodeAt(1))&&(++b,i>2&&(h(g.charCodeAt(2))?++b:s=!1))}if(s){for(;b<r.length&&h(r.charCodeAt(b));)b++;b>=2&&(r=`\\${r.slice(b)}`)}return e.win32.normalize(r)},relative(a,r){if(v(a,"from"),v(r,"to"),a===r)return"";const g=e.win32.resolve(a),s=e.win32.resolve(r);if(g===s||(a=g.toLowerCase(),r=s.toLowerCase(),a===r))return"";let b=0;for(;b<a.length&&a.charCodeAt(b)===D;)b++;let i=a.length;for(;i-1>b&&a.charCodeAt(i-1)===D;)i--;const t=i-b;let c=0;for(;c<r.length&&r.charCodeAt(c)===D;)c++;let d=r.length;for(;d-1>c&&r.charCodeAt(d-1)===D;)d--;const o=d-c,f=t<o?t:o;let u=-1,E=0;for(;E<f;E++){const R=a.charCodeAt(b+E);if(R!==r.charCodeAt(c+E))break;R===D&&(u=E)}if(E!==f){if(u===-1)return s}else{if(o>f){if(r.charCodeAt(c+E)===D)return s.slice(c+E+1);if(E===2)return s.slice(c+E)}t>f&&(a.charCodeAt(b+E)===D?u=E:E===2&&(u=3)),u===-1&&(u=0)}let T="";for(E=b+u+1;E<=i;++E)(E===i||a.charCodeAt(E)===D)&&(T+=T.length===0?"..":"\\..");return c+=u,T.length>0?`${T}${s.slice(c,d)}`:(s.charCodeAt(c)===D&&++c,s.slice(c,d))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const r=e.win32.resolve(a);if(r.length<=2)return a;if(r.charCodeAt(0)===D){if(r.charCodeAt(1)===D){const g=r.charCodeAt(2);if(g!==I&&g!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(S(r.charCodeAt(0))&&r.charCodeAt(1)===P&&r.charCodeAt(2)===D)return`\\\\?\\${r}`;return a},dirname(a){v(a,"path");const r=a.length;if(r===0)return".";let g=-1,s=0;const b=a.charCodeAt(0);if(r===1)return h(b)?a:".";if(h(b)){if(g=s=1,h(a.charCodeAt(1))){let c=2,d=c;for(;c<r&&!h(a.charCodeAt(c));)c++;if(c<r&&c!==d){for(d=c;c<r&&h(a.charCodeAt(c));)c++;if(c<r&&c!==d){for(d=c;c<r&&!h(a.charCodeAt(c));)c++;if(c===r)return a;c!==d&&(g=s=c+1)}}}}else S(b)&&a.charCodeAt(1)===P&&(g=r>2&&h(a.charCodeAt(2))?3:2,s=g);let i=-1,t=!0;for(let c=r-1;c>=s;--c)if(h(a.charCodeAt(c))){if(!t){i=c;break}}else t=!1;if(i===-1){if(g===-1)return".";i=g}return a.slice(0,i)},basename(a,r){r!==void 0&&v(r,"ext"),v(a,"path");let g=0,s=-1,b=!0,i;if(a.length>=2&&S(a.charCodeAt(0))&&a.charCodeAt(1)===P&&(g=2),r!==void 0&&r.length>0&&r.length<=a.length){if(r===a)return"";let t=r.length-1,c=-1;for(i=a.length-1;i>=g;--i){const d=a.charCodeAt(i);if(h(d)){if(!b){g=i+1;break}}else c===-1&&(b=!1,c=i+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(s=i):(t=-1,s=c))}return g===s?s=c:s===-1&&(s=a.length),a.slice(g,s)}for(i=a.length-1;i>=g;--i)if(h(a.charCodeAt(i))){if(!b){g=i+1;break}}else s===-1&&(b=!1,s=i+1);return s===-1?"":a.slice(g,s)},extname(a){v(a,"path");let r=0,g=-1,s=0,b=-1,i=!0,t=0;a.length>=2&&a.charCodeAt(1)===P&&S(a.charCodeAt(0))&&(r=s=2);for(let c=a.length-1;c>=r;--c){const d=a.charCodeAt(c);if(h(d)){if(!i){s=c+1;break}continue}b===-1&&(i=!1,b=c+1),d===k?g===-1?g=c:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||b===-1||t===0||t===1&&g===b-1&&g===s+1?"":a.slice(g,b)},format:p.bind(null,"\\"),parse(a){v(a,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return r;const g=a.length;let s=0,b=a.charCodeAt(0);if(g===1)return h(b)?(r.root=r.dir=a,r):(r.base=r.name=a,r);if(h(b)){if(s=1,h(a.charCodeAt(1))){let u=2,E=u;for(;u<g&&!h(a.charCodeAt(u));)u++;if(u<g&&u!==E){for(E=u;u<g&&h(a.charCodeAt(u));)u++;if(u<g&&u!==E){for(E=u;u<g&&!h(a.charCodeAt(u));)u++;u===g?s=u:u!==E&&(s=u+1)}}}}else if(S(b)&&a.charCodeAt(1)===P){if(g<=2)return r.root=r.dir=a,r;if(s=2,h(a.charCodeAt(2))){if(g===3)return r.root=r.dir=a,r;s=3}}s>0&&(r.root=a.slice(0,s));let i=-1,t=s,c=-1,d=!0,o=a.length-1,f=0;for(;o>=s;--o){if(b=a.charCodeAt(o),h(b)){if(!d){t=o+1;break}continue}c===-1&&(d=!1,c=o+1),b===k?i===-1?i=o:f!==1&&(f=1):i!==-1&&(f=-1)}return c!==-1&&(i===-1||f===0||f===1&&i===c-1&&i===t+1?r.base=r.name=a.slice(t,c):(r.name=a.slice(t,i),r.base=a.slice(t,c),r.ext=a.slice(i,c))),t>0&&t!==s?r.dir=a.slice(0,t-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let r="",g=!1;for(let s=a.length-1;s>=-1&&!g;s--){const b=s>=0?a[s]:m.cwd();v(b,"path"),b.length!==0&&(r=`${b}/${r}`,g=b.charCodeAt(0)===_)}return r=A(r,!g,"/",w),g?`/${r}`:r.length>0?r:"."},normalize(a){if(v(a,"path"),a.length===0)return".";const r=a.charCodeAt(0)===_,g=a.charCodeAt(a.length-1)===_;return a=A(a,!r,"/",w),a.length===0?r?"/":g?"./":".":(g&&(a+="/"),r?`/${a}`:a)},isAbsolute(a){return v(a,"path"),a.length>0&&a.charCodeAt(0)===_},join(...a){if(a.length===0)return".";let r;for(let g=0;g<a.length;++g){const s=a[g];v(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.posix.normalize(r)},relative(a,r){if(v(a,"from"),v(r,"to"),a===r||(a=e.posix.resolve(a),r=e.posix.resolve(r),a===r))return"";const g=1,s=a.length,b=s-g,i=1,t=r.length-i,c=b<t?b:t;let d=-1,o=0;for(;o<c;o++){const u=a.charCodeAt(g+o);if(u!==r.charCodeAt(i+o))break;u===_&&(d=o)}if(o===c)if(t>c){if(r.charCodeAt(i+o)===_)return r.slice(i+o+1);if(o===0)return r.slice(i+o)}else b>c&&(a.charCodeAt(g+o)===_?d=o:o===0&&(d=0));let f="";for(o=g+d+1;o<=s;++o)(o===s||a.charCodeAt(o)===_)&&(f+=f.length===0?"..":"/..");return`${f}${r.slice(i+d)}`},toNamespacedPath(a){return a},dirname(a){if(v(a,"path"),a.length===0)return".";const r=a.charCodeAt(0)===_;let g=-1,s=!0;for(let b=a.length-1;b>=1;--b)if(a.charCodeAt(b)===_){if(!s){g=b;break}}else s=!1;return g===-1?r?"/":".":r&&g===1?"//":a.slice(0,g)},basename(a,r){r!==void 0&&v(r,"ext"),v(a,"path");let g=0,s=-1,b=!0,i;if(r!==void 0&&r.length>0&&r.length<=a.length){if(r===a)return"";let t=r.length-1,c=-1;for(i=a.length-1;i>=0;--i){const d=a.charCodeAt(i);if(d===_){if(!b){g=i+1;break}}else c===-1&&(b=!1,c=i+1),t>=0&&(d===r.charCodeAt(t)?--t==-1&&(s=i):(t=-1,s=c))}return g===s?s=c:s===-1&&(s=a.length),a.slice(g,s)}for(i=a.length-1;i>=0;--i)if(a.charCodeAt(i)===_){if(!b){g=i+1;break}}else s===-1&&(b=!1,s=i+1);return s===-1?"":a.slice(g,s)},extname(a){v(a,"path");let r=-1,g=0,s=-1,b=!0,i=0;for(let t=a.length-1;t>=0;--t){const c=a.charCodeAt(t);if(c===_){if(!b){g=t+1;break}continue}s===-1&&(b=!1,s=t+1),c===k?r===-1?r=t:i!==1&&(i=1):r!==-1&&(i=-1)}return r===-1||s===-1||i===0||i===1&&r===s-1&&r===g+1?"":a.slice(r,s)},format:p.bind(null,"/"),parse(a){v(a,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return r;const g=a.charCodeAt(0)===_;let s;g?(r.root="/",s=1):s=0;let b=-1,i=0,t=-1,c=!0,d=a.length-1,o=0;for(;d>=s;--d){const f=a.charCodeAt(d);if(f===_){if(!c){i=d+1;break}continue}t===-1&&(c=!1,t=d+1),f===k?b===-1?b=d:o!==1&&(o=1):b!==-1&&(o=-1)}if(t!==-1){const f=i===0&&g?1:i;b===-1||o===0||o===1&&b===t-1&&b===i+1?r.base=r.name=a.slice(f,t):(r.name=a.slice(f,b),r.base=a.slice(f,t),r.ext=a.slice(b,t))}return i>0?r.dir=a.slice(0,i-1):g&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[95],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function y(C,...n){const k=n.reduce((P,I)=>(P[I]=!0,P),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(P=>!k[P]).forEach(P=>{for(let I=0;I<_.length;I++)if(P.search(_[I])!==-1){delete C[P];break}})}e.sanitizeProcessEnvironment=y}),define(fe[47],me([0,1,12]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=m.globals.performance&&typeof m.globals.performance.now=="function";class y{constructor(n){this._highResolution=L&&n,this._startTime=this._now(),this._stopTime=-1}static create(n=!0){return new y(n)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=y}),define(fe[3],me([0,1,16,74,6,94,47]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(r){r.None=()=>y.Disposable.None;function g(M){return(H,N=null,U)=>{let V=!1,O;return O=M(W=>{if(!V)return O?O.dispose():V=!0,H.call(N,W)},null,U),V&&O.dispose(),O}}r.once=g;function s(M,H){return o((N,U=null,V)=>M(O=>N.call(U,H(O)),null,V))}r.map=s;function b(M,H){return o((N,U=null,V)=>M(O=>{H(O),N.call(U,O)},null,V))}r.forEach=b;function i(M,H){return o((N,U=null,V)=>M(O=>H(O)&&N.call(U,O),null,V))}r.filter=i;function t(M){return M}r.signal=t;function c(...M){return(H,N=null,U)=>(0,y.combinedDisposable)(...M.map(V=>V(O=>H.call(N,O),null,U)))}r.any=c;function d(M,H,N){let U=N;return s(M,V=>(U=H(U,V),U))}r.reduce=d;function o(M){let H;const N=new l({onFirstListenerAdd(){H=M(N.fire,N)},onLastListenerRemove(){H.dispose()}});return N.event}function f(M,H,N=100,U=!1,V){let O,W,j,X=0;const Q=new l({leakWarningThreshold:V,onFirstListenerAdd(){O=M(de=>{X++,W=H(W,de),U&&!j&&(Q.fire(W),W=void 0),clearTimeout(j),j=setTimeout(()=>{const Se=W;W=void 0,j=void 0,(!U||X>1)&&Q.fire(Se),X=0},N)})},onLastListenerRemove(){O.dispose()}});return Q.event}r.debounce=f;function u(M,H=(N,U)=>N===U){let N=!0,U;return i(M,V=>{const O=N||!H(V,U);return N=!1,U=V,O})}r.latch=u;function E(M,H){return[r.filter(M,H),r.filter(M,N=>!H(N))]}r.split=E;function T(M,H=!1,N=[]){let U=N.slice(),V=M(j=>{U?U.push(j):W.fire(j)});const O=()=>{U&&U.forEach(j=>W.fire(j)),U=null},W=new l({onFirstListenerAdd(){V||(V=M(j=>W.fire(j)))},onFirstListenerDidAdd(){U&&(H?setTimeout(O):O())},onLastListenerRemove(){V&&V.dispose(),V=null}});return W.event}r.buffer=T;class R{constructor(H){this.event=H}map(H){return new R(s(this.event,H))}forEach(H){return new R(b(this.event,H))}filter(H){return new R(i(this.event,H))}reduce(H,N){return new R(d(this.event,H,N))}latch(){return new R(u(this.event))}debounce(H,N=100,U=!1,V){return new R(f(this.event,H,N,U,V))}on(H,N,U){return this.event(H,N,U)}once(H,N,U){return g(this.event)(H,N,U)}}function B(M){return new R(M)}r.chain=B;function x(M,H,N=U=>U){const U=(...j)=>W.fire(N(...j)),V=()=>M.on(H,U),O=()=>M.removeListener(H,U),W=new l({onFirstListenerAdd:V,onLastListenerRemove:O});return W.event}r.fromNodeEventEmitter=x;function F(M,H,N=U=>U){const U=(...j)=>W.fire(N(...j)),V=()=>M.addEventListener(H,U),O=()=>M.removeEventListener(H,U),W=new l({onFirstListenerAdd:V,onLastListenerRemove:O});return W.event}r.fromDOMEventEmitter=F;function $(M){return new Promise(H=>g(M)(H))}r.toPromise=$})(k=e.Event||(e.Event={}));class _{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${_._idPool++}`}start(g){this._stopWatch=new n.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let D=-1;function P(r){const g=D;return D=r,{dispose(){D=g}}}e.setGlobalLeakWarningThreshold=P;class I{constructor(g,s=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let s=D;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||g<s)return;this._stacks||(this._stacks=new Map);const b=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(b)||0;if(this._stacks.set(b,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let t,c=0;for(const[d,o]of this._stacks)(!t||c<o)&&(t=d,c=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${c}):`),console.warn(t)}return()=>{const t=this._stacks.get(b)||0;this._stacks.set(b,t-1)}}}class l{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=D>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(g,s,b)=>{this._listeners||(this._listeners=new C.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(s?[g,s]:g);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,s);const c=this._leakageMon?.check(this._listeners.size),d=(0,y.toDisposable)(()=>{c&&c(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return b instanceof y.DisposableStore?b.add(d):Array.isArray(b)&&b.push(d),d}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,b]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,b):s[0].call(s[1],b)}catch(i){(0,m.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=l;class v extends l{async fireAsync(g,s,b){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,g]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),c=[],d={...t,waitUntil:o=>{if(Object.isFrozen(c))throw new Error("waitUntil can NOT be called asynchronous");b&&(o=b(o,typeof i=="function"?i:i[0])),c.push(o)}};try{typeof i=="function"?i.call(void 0,d):i[0].call(i[1],d)}catch(o){(0,m.onUnexpectedError)(o);continue}Object.freeze(c),await Promise.allSettled(c).then(o=>{for(const f of o)f.status==="rejected"&&(0,m.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=v;class h extends l{constructor(g){super(g);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=h;class w extends h{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=w;class S extends l{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=S;class A{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const s={event:g,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const b=()=>{this.hasListeners&&this.unhook(s);const i=this.events.indexOf(s);this.events.splice(i,1)};return(0,y.toDisposable)((0,L.once)(b))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(s=>this.emitter.fire(s))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=A;class p{constructor(){this.buffers=[]}wrapEvent(g){return(s,b,i)=>g(t=>{const c=this.buffers[this.buffers.length-1];c?c.push(()=>s.call(b,t)):s.call(b,t)},void 0,i)}bufferEvents(g){const s=[];this.buffers.push(s);const b=g();return this.buffers.pop(),s.forEach(i=>i()),b}}e.EventBufferer=p;class a{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=y.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=a}),define(fe[21],me([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,_){const D=setTimeout(k.bind(_),0);return{dispose(){clearTimeout(D)}}});var y;(function(k){function _(D){return D===k.None||D===k.Cancelled||D instanceof C?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}k.isCancellationToken=_,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(y=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class n{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=y.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=n}),define(fe[78],me([0,1,3]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(P){const I=this._icons.get(P.id);I?P.description?I.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const y=new L;e.iconRegistry=y;function C(D){return D?D.replace(/\$\((.*?)\)/g,(P,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=C;class n{constructor(P,I,l){this.id=P,this.definition=I,this.description=l,y.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n,n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function k(D,P){const I=["codicon","codicon-"+D];return P&&I.push("codicon-modifier-"+P),I}e.getClassNamesArray=k;var _;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function I(h){if(h instanceof n)return["codicon","codicon-"+h.id];const w=P.exec(h.id);if(!w)return I(n.error);let[,S,A]=w;const p=["codicon","codicon-"+S];return A&&p.push("codicon-modifier-"+A.substr(1)),p}D.asClassNameArray=I;function l(h){return I(h).join(" ")}D.asClassName=l;function v(h){return"."+I(h).join(".")}D.asCSSSelector=v})(_=e.CSSIcon||(e.CSSIcon={}))}),define(fe[96],me([0,1,16,6]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function y(a){const r=a;return r?[r.on,r.pause,r.resume,r.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=y;function C(a){const r=a;return r?y(r.stream)&&Array.isArray(r.buffer)&&typeof r.ended=="boolean":!1}e.isReadableBufferedStream=C;function n(a,r){return new k(a,r)}e.newWriteableStream=n;class k{constructor(r,g){this.reducer=r,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(r){if(!this.state.destroyed){if(this.state.flowing)this.emitData(r);else if(this.buffer.data.push(r),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(r){this.state.destroyed||(this.state.flowing?this.emitError(r):this.buffer.error.push(r))}end(r){this.state.destroyed||(typeof r!="undefined"&&this.write(r),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(r){this.listeners.data.slice(0).forEach(g=>g(r))}emitError(r){this.listeners.error.length===0?(0,m.onUnexpectedError)(r):this.listeners.error.slice(0).forEach(g=>g(r))}emitEnd(){this.listeners.end.slice(0).forEach(r=>r())}on(r,g){if(!this.state.destroyed)switch(r){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(r,g){if(this.state.destroyed)return;let s;switch(r){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const b=s.indexOf(g);b>=0&&s.splice(b,1)}}flowData(){if(this.buffer.data.length>0){const r=this.reducer(this.buffer.data);this.emitData(r),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const r of this.buffer.error)this.emitError(r);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(a,r){const g=[];let s;for(;(s=a.read())!==null;)g.push(s);return r(g)}e.consumeReadable=_;function D(a,r,g){const s=[];let b;for(;(b=a.read())!==null&&s.length<g;)s.push(b);return b===null&&s.length>0?r(s):{read:()=>{if(s.length>0)return s.shift();if(typeof b!="undefined"){const i=b;return b=void 0,i}return a.read()}}}e.peekReadable=D;function P(a,r){return new Promise((g,s)=>{const b=[];I(a,{onData:i=>{r&&b.push(i)},onError:i=>{r?s(i):g(void 0)},onEnd:()=>{g(r?r(b):void 0)}})})}e.consumeStream=P;function I(a,r){a.on("error",g=>r.onError(g)),a.on("end",()=>r.onEnd()),a.on("data",g=>r.onData(g))}e.listenStream=I;function l(a,r){return new Promise((g,s)=>{const b=new L.DisposableStore,i=[],t=o=>{if(i.push(o),i.length>r)return b.dispose(),a.pause(),g({stream:a,buffer:i,ended:!1})},c=o=>s(o),d=()=>g({stream:a,buffer:i,ended:!0});b.add((0,L.toDisposable)(()=>a.removeListener("error",c))),a.on("error",c),b.add((0,L.toDisposable)(()=>a.removeListener("end",d))),a.on("end",d),b.add((0,L.toDisposable)(()=>a.removeListener("data",t))),a.on("data",t)})}e.peekStream=l;function v(a,r){const g=n(r);return g.end(a),g}e.toStream=v;function h(){const a=n(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=h;function w(a){let r=!1;return{read:()=>r?null:(r=!0,a)}}e.toReadable=w;function S(a,r,g){const s=n(g);return I(a,{onData:b=>s.write(r.data(b)),onError:b=>s.error(r.error?r.error(b):b),onEnd:()=>s.end()}),s}e.transform=S;function A(a,r,g){let s=!1;return{read:()=>{const b=r.read();return s?b:(s=!0,b!==null?g([a,b]):a)}}}e.prefixedReadable=A;function p(a,r,g){let s=!1;const b=n(g);return I(r,{onData:i=>s?b.write(i):(s=!0,b.write(g([a,i]))),onError:i=>b.error(i),onEnd:()=>{s||(s=!0,b.write(a)),b.end()}}),b}e.prefixedStream=p}),define(fe[22],me([0,1,96]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let y,C;class n{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new n(Buffer.allocUnsafe(t)):new n(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new n(t)}static fromString(t,c){return!(c?.dontUseNodeBuffer||!1)&&L?new n(Buffer.from(t)):(y||(y=new TextEncoder),new n(y.encode(t)))}static concat(t,c){if(typeof c=="undefined"){c=0;for(let f=0,u=t.length;f<u;f++)c+=t[f].byteLength}const d=n.alloc(c);let o=0;for(let f=0,u=t.length;f<u;f++){const E=t[f];d.set(E,o),o+=E.byteLength}return d}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(t,c){return new n(this.buffer.subarray(t,c))}set(t,c){t instanceof n?this.buffer.set(t.buffer,c):this.buffer.set(t,c)}readUInt32BE(t){return D(this.buffer,t)}writeUInt32BE(t,c){P(this.buffer,t,c)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,c){l(this.buffer,t,c)}readUInt8(t){return v(this.buffer,t)}writeUInt8(t,c){h(this.buffer,t,c)}}e.VSBuffer=n;function k(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0}e.readUInt16LE=k;function _(i,t,c){i[c+0]=t&255,t=t>>>8,i[c+1]=t&255}e.writeUInt16LE=_;function D(i,t){return i[t]*2**24+i[t+1]*2**16+i[t+2]*2**8+i[t+3]}e.readUInt32BE=D;function P(i,t,c){i[c+3]=t,t=t>>>8,i[c+2]=t,t=t>>>8,i[c+1]=t,t=t>>>8,i[c]=t}e.writeUInt32BE=P;function I(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0|i[t+2]<<16>>>0|i[t+3]<<24>>>0}e.readUInt32LE=I;function l(i,t,c){i[c+0]=t&255,t=t>>>8,i[c+1]=t&255,t=t>>>8,i[c+2]=t&255,t=t>>>8,i[c+3]=t&255}e.writeUInt32LE=l;function v(i,t){return i[t]}e.readUInt8=v;function h(i,t,c){i[c]=t}e.writeUInt8=h;function w(i){return m.consumeReadable(i,t=>n.concat(t))}e.readableToBuffer=w;function S(i){return m.toReadable(i)}e.bufferToReadable=S;function A(i){return m.consumeStream(i,t=>n.concat(t))}e.streamToBuffer=A;async function p(i){return i.ended?n.concat(i.buffer):n.concat([...i.buffer,await A(i.stream)])}e.bufferedStreamToBuffer=p;function a(i){return m.toStream(i,t=>n.concat(t))}e.bufferToStream=a;function r(i){return m.transform(i,{data:t=>typeof t=="string"?n.fromString(t):n.wrap(t)},t=>n.concat(t))}e.streamToBufferReadableStream=r;function g(i){return m.newWriteableStream(t=>n.concat(t),i)}e.newWriteableBufferStream=g;function s(i,t){return m.prefixedReadable(i,t,c=>n.concat(c))}e.prefixedBufferReadable=s;function b(i,t){return m.prefixedStream(i,t,c=>n.concat(c))}e.prefixedBufferStream=b}),define(fe[8],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function m(le){return!le||typeof le!="string"?!0:le.trim().length===0}e.isFalsyOrWhitespace=m;const L=/{(\d+)}/g;function y(le,...Ie){return Ie.length===0?le:le.replace(L,function(Ue,Xe){const it=parseInt(Xe,10);return isNaN(it)||it<0||it>=Ie.length?Ue:Ie[it]})}e.format=y;const C=/{([^}]+)}/g;function n(le,Ie){return le.replace(C,(Ue,Xe)=>Ie[Xe]??Ue)}e.format2=n;function k(le){return le.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=k;function _(le){return le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function D(le,Ie){let Ue=0;const Xe=Ie.charCodeAt(0);for(let it=le.length-1;it>=0;it--)le.charCodeAt(it)===Xe&&Ue++;return Ue}e.count=D;function P(le,Ie,Ue="\u2026"){return le.length<=Ie?le:`${le.substr(0,Ie)}${Ue}`}e.truncate=P;function I(le,Ie=" "){const Ue=l(le,Ie);return v(Ue,Ie)}e.trim=I;function l(le,Ie){if(!le||!Ie)return le;const Ue=Ie.length;if(Ue===0||le.length===0)return le;let Xe=0;for(;le.indexOf(Ie,Xe)===Xe;)Xe=Xe+Ue;return le.substring(Xe)}e.ltrim=l;function v(le,Ie){if(!le||!Ie)return le;const Ue=Ie.length,Xe=le.length;if(Ue===0||Xe===0)return le;let it=Xe,ft=-1;for(;ft=le.lastIndexOf(Ie,it-1),!(ft===-1||ft+Ue!==it);){if(ft===0)return"";it=ft}return le.substring(0,it)}e.rtrim=v;function h(le){return le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function w(le){return le.replace(/\*/g,"")}e.stripWildcards=w;function S(le,Ie,Ue={}){if(!le)throw new Error("Cannot create regex from empty string");Ie||(le=_(le)),Ue.wholeWord&&(/\B/.test(le.charAt(0))||(le="\\b"+le),/\B/.test(le.charAt(le.length-1))||(le=le+"\\b"));let Xe="";return Ue.global&&(Xe+="g"),Ue.matchCase||(Xe+="i"),Ue.multiline&&(Xe+="m"),Ue.unicode&&(Xe+="u"),new RegExp(le,Xe)}e.createRegExp=S;function A(le){return le.source==="^"||le.source==="^$"||le.source==="$"||le.source==="^\\s*$"?!1:!!(le.exec("")&&le.lastIndex===0)}e.regExpLeadsToEndlessLoop=A;function p(le){return!!le.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function a(le){return(le.global?"g":"")+(le.ignoreCase?"i":"")+(le.multiline?"m":"")+(le.unicode?"u":"")}e.regExpFlags=a;function r(le){return le.split(/\r\n|\r|\n/)}e.splitLines=r;function g(le){for(let Ie=0,Ue=le.length;Ie<Ue;Ie++){const Xe=le.charCodeAt(Ie);if(Xe!==32&&Xe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=g;function s(le,Ie=0,Ue=le.length){for(let Xe=Ie;Xe<Ue;Xe++){const it=le.charCodeAt(Xe);if(it!==32&&it!==9)return le.substring(Ie,Xe)}return le.substring(Ie,Ue)}e.getLeadingWhitespace=s;function b(le,Ie=le.length-1){for(let Ue=Ie;Ue>=0;Ue--){const Xe=le.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return Ue}return-1}e.lastNonWhitespaceIndex=b;function i(le,Ie){return le<Ie?-1:le>Ie?1:0}e.compare=i;function t(le,Ie,Ue=0,Xe=le.length,it=0,ft=Ie.length){for(;Ue<Xe&&it<ft;Ue++,it++){let Re=le.charCodeAt(Ue),ve=Ie.charCodeAt(it);if(Re<ve)return-1;if(Re>ve)return 1}const tt=Xe-Ue,ut=ft-it;return tt<ut?-1:tt>ut?1:0}e.compareSubstring=t;function c(le,Ie){return d(le,Ie,0,le.length,0,Ie.length)}e.compareIgnoreCase=c;function d(le,Ie,Ue=0,Xe=le.length,it=0,ft=Ie.length){for(;Ue<Xe&&it<ft;Ue++,it++){let Re=le.charCodeAt(Ue),ve=Ie.charCodeAt(it);if(Re===ve)continue;if(Re>=128||ve>=128)return t(le.toLowerCase(),Ie.toLowerCase(),Ue,Xe,it,ft);o(Re)&&(Re-=32),o(ve)&&(ve-=32);const Te=Re-ve;if(Te!==0)return Te}const tt=Xe-Ue,ut=ft-it;return tt<ut?-1:tt>ut?1:0}e.compareSubstringIgnoreCase=d;function o(le){return le>=97&&le<=122}e.isLowerAsciiLetter=o;function f(le){return le>=65&&le<=90}e.isUpperAsciiLetter=f;function u(le,Ie){return le.length===Ie.length&&d(le,Ie)===0}e.equalsIgnoreCase=u;function E(le,Ie){const Ue=Ie.length;return Ie.length>le.length?!1:d(le,Ie,0,Ue)===0}e.startsWithIgnoreCase=E;function T(le,Ie){let Ue,Xe=Math.min(le.length,Ie.length);for(Ue=0;Ue<Xe;Ue++)if(le.charCodeAt(Ue)!==Ie.charCodeAt(Ue))return Ue;return Xe}e.commonPrefixLength=T;function R(le,Ie){let Ue,Xe=Math.min(le.length,Ie.length);const it=le.length-1,ft=Ie.length-1;for(Ue=0;Ue<Xe;Ue++)if(le.charCodeAt(it-Ue)!==Ie.charCodeAt(ft-Ue))return Ue;return Xe}e.commonSuffixLength=R;function B(le){return 55296<=le&&le<=56319}e.isHighSurrogate=B;function x(le){return 56320<=le&&le<=57343}e.isLowSurrogate=x;function F(le,Ie){return(le-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=F;function $(le,Ie,Ue){const Xe=le.charCodeAt(Ue);if(B(Xe)&&Ue+1<Ie){const it=le.charCodeAt(Ue+1);if(x(it))return F(Xe,it)}return Xe}e.getNextCodePoint=$;function M(le,Ie){const Ue=le.charCodeAt(Ie-1);if(x(Ue)&&Ie>1){const Xe=le.charCodeAt(Ie-2);if(B(Xe))return F(Xe,Ue)}return Ue}function H(le,Ie){const Ue=ye.getInstance(),Xe=Ie,it=le.length,ft=$(le,it,Ie);Ie+=ft>=65536?2:1;let tt=Ue.getGraphemeBreakType(ft);for(;Ie<it;){const ut=$(le,it,Ie),Re=Ue.getGraphemeBreakType(ut);if(rt(tt,Re))break;Ie+=ut>=65536?2:1,tt=Re}return Ie-Xe}e.nextCharLength=H;function N(le,Ie){const Ue=ye.getInstance(),Xe=Ie,it=M(le,Ie);Ie-=it>=65536?2:1;let ft=Ue.getGraphemeBreakType(it);for(;Ie>0;){const tt=M(le,Ie),ut=Ue.getGraphemeBreakType(tt);if(rt(ut,ft))break;Ie-=tt>=65536?2:1,ft=ut}return Xe-Ie}e.prevCharLength=N;function U(le,Ie){const Ue=ye.getInstance(),Xe=le.length,it=Ie,ft=$(le,Xe,Ie),tt=Ue.getGraphemeBreakType(ft);Ie+=ft>=65536?2:1;let ut=tt;for(;Ie<Xe;){const ve=$(le,Xe,Ie),Te=Ue.getGraphemeBreakType(ve);if(rt(ut,Te))break;Ie+=ve>=65536?2:1,ut=Te}const Re=Ie;for(Ie=it,ut=tt;Ie>0;){const ve=M(le,Ie),Te=Ue.getGraphemeBreakType(ve);if(rt(Te,ut))break;Ie-=ve>=65536?2:1,ut=Te}return[Ie,Re]}function V(le,Ie){return Ie>0&&x(le.charCodeAt(Ie))?U(le,Ie-1):U(le,Ie)}e.getCharContainingOffset=V;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(le){return O.test(le)}e.containsRTL=W;const j=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(le){return j.test(le)}e.containsEmoji=X;const Q=/^[\t\n\r\x20-\x7E]*$/;function de(le){return Q.test(le)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Se(le){return e.UNUSUAL_LINE_TERMINATORS.test(le)}e.containsUnusualLineTerminators=Se;function De(le){for(let Ie=0,Ue=le.length;Ie<Ue;Ie++)if(Pe(le.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=De;function Pe(le){return le>=11904&&le<=55215||le>=63744&&le<=64255||le>=65281&&le<=65374}e.isFullWidthCharacter=Pe;function Be(le){return le>=127462&&le<=127487||le===8986||le===8987||le===9200||le===9203||le>=9728&&le<=10175||le===11088||le===11093||le>=127744&&le<=128591||le>=128640&&le<=128764||le>=128992&&le<=129003||le>=129280&&le<=129535||le>=129648&&le<=129750}e.isEmojiImprecise=Be;function We(le,Ie){if(le.length<Ie)return le;const Ue=/\b/g;let Xe=0;for(;Ue.test(le)&&!(le.length-Ue.lastIndex<Ie);)Xe=Ue.lastIndex,Ue.lastIndex+=1;return le.substring(Xe).replace(/^\s/,"")}e.lcut=We;const He=/\x1B\x5B[12]?K/g,G=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function ne(le){return le&&(le=le.replace(He,""),le=le.replace(G,""),le=le.replace(ee,"")),le}e.removeAnsiEscapeCodes=ne,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(le){return!!(le&&le.length>0&&le.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function Z(le){return ce(le)?le.substr(1):le}e.stripUTF8BOM=Z;function re(le,Ie){if(!le||!Ie||le.length<Ie.length)return!1;const Ue=Ie.length,Xe=le.toLowerCase();let it=0,ft=-1;for(;it<Ue;){const tt=Xe.indexOf(Ie[it],ft+1);if(tt<0)return!1;ft=tt,it++}return!0}e.fuzzyContains=re;function pe(le,Ie=!1){return le?(Ie&&(le=le.replace(/\\./g,"")),le.toLowerCase()!==le):!1}e.containsUppercaseCharacter=pe;function Me(le){return le.charAt(0).toUpperCase()+le.slice(1)}e.uppercaseFirstLetter=Me;function je(le,Ie=1){if(Ie===0)return"";let Ue=-1;do Ue=le.indexOf(`
`,Ue+1),Ie--;while(Ie>0&&Ue>=0);return Ue===-1?le:(le[Ue-1]==="\r"&&Ue--,le.substr(0,Ue))}e.getNLines=je;function Ke(le){const Ie=90-65+1;return le=le%(2*Ie),le<Ie?String.fromCharCode(97+le):String.fromCharCode(65+le-Ie)}e.singleLetterHash=Ke;function Ze(le){return ye.getInstance().getGraphemeBreakType(le)}e.getGraphemeBreakType=Ze;function rt(le,Ie){return le===0?Ie!==5&&Ie!==7:le===2&&Ie===3?!1:le===4||le===2||le===3||Ie===4||Ie===2||Ie===3?!0:!(le===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(le===11||le===9)&&(Ie===9||Ie===10)||(le===12||le===10)&&Ie===10||Ie===5||Ie===13||Ie===7||le===1||le===13&&Ie===14||le===6&&Ie===6)}e.breakBetweenGraphemeBreakType=rt;var ct;(function(le){le[le.Other=0]="Other",le[le.Prepend=1]="Prepend",le[le.CR=2]="CR",le[le.LF=3]="LF",le[le.Control=4]="Control",le[le.Extend=5]="Extend",le[le.Regional_Indicator=6]="Regional_Indicator",le[le.SpacingMark=7]="SpacingMark",le[le.L=8]="L",le[le.V=9]="V",le[le.T=10]="T",le[le.LV=11]="LV",le[le.LVT=12]="LVT",le[le.ZWJ=13]="ZWJ",le[le.Extended_Pictographic=14]="Extended_Pictographic"})(ct=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=at()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ue=this._data,Xe=Ue.length/3;let it=1;for(;it<=Xe;)if(Ie<Ue[3*it])it=2*it;else if(Ie>Ue[3*it+1])it=2*it+1;else return Ue[3*it+2];return 0}}ye._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function J(le,Ie){if(le===0)return 0;const Ue=ie(le,Ie);if(Ue!==void 0)return Ue;const Xe=M(Ie,le);return le-=_e(Xe),le}e.getLeftDeleteOffset=J;function ie(le,Ie){let Ue=M(Ie,le);for(le-=_e(Ue);Qe(Ue)||Ue===65039||Ue===8419;){if(le===0)return;Ue=M(Ie,le),le-=_e(Ue)}if(!!Be(Ue)){if(le>=0){const Xe=M(Ie,le);Xe===8205&&(le-=_e(Xe))}return le}}function _e(le){return le>=65536?2:1}function Qe(le){return 127995<=le&&le<=127999}var et;(function(le){le[le.zwj=8205]="zwj",le[le.emojiVariantSelector=65039]="emojiVariantSelector",le[le.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={})),e.noBreakWhitespace="\xA0"}),define(fe[48],me([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(A){return y(A,0)}e.hash=L;function y(A,p){switch(typeof A){case"object":return A===null?C(349,p):Array.isArray(A)?_(A,p):D(A,p);case"string":return k(A,p);case"boolean":return n(A,p);case"number":return C(A,p);case"undefined":return C(937,p);default:return C(617,p)}}e.doHash=y;function C(A,p){return(p<<5)-p+A|0}e.numberHash=C;function n(A,p){return C(A?433:863,p)}function k(A,p){p=C(149417,p);for(let a=0,r=A.length;a<r;a++)p=C(A.charCodeAt(a),p);return p}e.stringHash=k;function _(A,p){return p=C(104579,p),A.reduce((a,r)=>y(r,a),p)}function D(A,p){return p=C(181387,p),Object.keys(A).sort().reduce((a,r)=>(a=k(r,a),y(A[r],a)),p)}class P{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=y(p,this._value),this._value}}e.Hasher=P;var I;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function l(A,p,a=32){const r=a-p,g=~((1<<r)-1);return(A<<p|(g&A)>>>r)>>>0}function v(A,p=0,a=A.byteLength,r=0){for(let g=0;g<a;g++)A[p+g]=r}function h(A,p,a="0"){for(;A.length<p;)A=a+A;return A}function w(A,p=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(a=>a.toString(16).padStart(2,"0")).join(""):h((A>>>0).toString(16),p/4)}e.toHexString=w;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const a=p.length;if(a===0)return;const r=this._buff;let g=this._buffLen,s=this._leftoverHighSurrogate,b,i;for(s!==0?(b=s,i=-1,s=0):(b=p.charCodeAt(0),i=0);;){let t=b;if(m.isHighSurrogate(b))if(i+1<a){const c=p.charCodeAt(i+1);m.isLowSurrogate(c)?(i++,t=m.computeCodePoint(b,c)):t=65533}else{s=b;break}else m.isLowSurrogate(b)&&(t=65533);if(g=this._push(r,g,t),i++,i<a)b=p.charCodeAt(i);else break}this._buffLen=g,this._leftoverHighSurrogate=s}_push(p,a,r){return r<128?p[a++]=r:r<2048?(p[a++]=192|(r&1984)>>>6,p[a++]=128|(r&63)>>>0):r<65536?(p[a++]=224|(r&61440)>>>12,p[a++]=128|(r&4032)>>>6,p[a++]=128|(r&63)>>>0):(p[a++]=240|(r&1835008)>>>18,p[a++]=128|(r&258048)>>>12,p[a++]=128|(r&4032)>>>6,p[a++]=128|(r&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=S._bigBlock32,a=this._buffDV;for(let o=0;o<64;o+=4)p.setUint32(o,a.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)p.setUint32(o,l(p.getUint32(o-12,!1)^p.getUint32(o-32,!1)^p.getUint32(o-56,!1)^p.getUint32(o-64,!1),1),!1);let r=this._h0,g=this._h1,s=this._h2,b=this._h3,i=this._h4,t,c,d;for(let o=0;o<80;o++)o<20?(t=g&s|~g&b,c=1518500249):o<40?(t=g^s^b,c=1859775393):o<60?(t=g&s|g&b|s&b,c=2400959708):(t=g^s^b,c=3395469782),d=l(r,5)+t+i+c+p.getUint32(o*4,!1)&4294967295,i=b,b=s,s=l(g,30),g=r,r=d;this._h0=this._h0+r&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+b&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))});var st=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[24],me([0,1,17,8]),function(Y,e,m,L){"use strict";var y,C,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(i,t,c){let d=i.get(t);return d===void 0&&(d=c,i.set(t,d)),d}e.getOrSet=k;function _(i){const t=[];return i.forEach((c,d)=>{t.push(`${d} => ${c}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=_;function D(i){const t=[];return i.forEach(c=>{t.push(c)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=D;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const c=t.charCodeAt(0),d=this._value.charCodeAt(this._pos);return c-d}value(){return this._value[this._pos]}}e.StringIterator=P;class I{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class l{constructor(t=!0,c=!0){this._splitOnBackslash=t,this._caseSensitive=c}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var v;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(S||(S={}));class A{constructor(t){this._iter=t}static forUris(t=()=>!1){return new A(new h(t))}static forPaths(){return new A(new l)}static forStrings(){return new A(new P)}static forConfigKeys(){return new A(new I)}clear(){this._root=void 0}fill(t,c){if(c){const d=c.slice(0);(0,m.shuffle)(d);for(let o of d)this.set(o,t)}else{const d=t.slice(0);(0,m.shuffle)(d);for(let o of d)this.set(o[0],o[1])}}set(t,c){const d=this._iter.reset(t);let o;this._root||(this._root=new w,this._root.segment=d.value());const f=[];for(o=this._root;;){const E=d.cmp(o.segment);if(E>0)o.left||(o.left=new w,o.left.segment=d.value()),f.push([-1,o]),o=o.left;else if(E<0)o.right||(o.right=new w,o.right.segment=d.value()),f.push([1,o]),o=o.right;else if(d.hasNext())d.next(),o.mid||(o.mid=new w,o.mid.segment=d.value()),f.push([0,o]),o=o.mid;else break}const u=o.value;o.value=c,o.key=t;for(let E=f.length-1;E>=0;E--){const T=f[E][1];T.updateHeight();const R=T.balanceFactor();if(R<-1||R>1){const B=f[E][0],x=f[E+1][0];if(B===1&&x===1)f[E][1]=T.rotateLeft();else if(B===-1&&x===-1)f[E][1]=T.rotateRight();else if(B===1&&x===-1)T.right=f[E+1][1]=f[E+1][1].rotateRight(),f[E][1]=T.rotateLeft();else if(B===-1&&x===1)T.left=f[E+1][1]=f[E+1][1].rotateLeft(),f[E][1]=T.rotateRight();else throw new Error;if(E>0)switch(f[E-1][0]){case-1:f[E-1][1].left=f[E][1];break;case 1:f[E-1][1].right=f[E][1];break;case 0:f[E-1][1].mid=f[E][1];break}else this._root=f[0][1]}}return u}get(t){return this._getNode(t)?.value}_getNode(t){const c=this._iter.reset(t);let d=this._root;for(;d;){const o=c.cmp(d.segment);if(o>0)d=d.left;else if(o<0)d=d.right;else if(c.hasNext())c.next(),d=d.mid;else break}return d}has(t){const c=this._getNode(t);return!(c?.value===void 0&&c?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,c){const d=this._iter.reset(t),o=[];let f=this._root;for(;f;){const u=d.cmp(f.segment);if(u>0)o.push([-1,f]),f=f.left;else if(u<0)o.push([1,f]),f=f.right;else if(d.hasNext())d.next(),o.push([0,f]),f=f.mid;else break}if(!!f){if(c?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const u=this._min(f.right),{key:E,value:T,segment:R}=u;this._delete(u.key,!1),f.key=E,f.value=T,f.segment=R}else{const u=f.left??f.right;if(o.length>0){const[E,T]=o[o.length-1];switch(E){case-1:T.left=u;break;case 0:T.mid=u;break;case 1:T.right=u;break}}else this._root=u}for(let u=o.length-1;u>=0;u--){const E=o[u][1];E.updateHeight();const T=E.balanceFactor();if(T>1?(E.right.balanceFactor()>=0||(E.right=o[u+1][1]=o[u+1][1].rotateRight()),o[u][1]=E.rotateLeft()):T<-1&&(E.left.balanceFactor()<=0||(E.left=o[u+1][1]=o[u+1][1].rotateLeft()),o[u][1]=E.rotateRight()),u>0)switch(o[u-1][0]){case-1:o[u-1][1].left=o[u][1];break;case 1:o[u-1][1].right=o[u][1];break;case 0:o[u-1][1].mid=o[u][1];break}else this._root=o[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const c=this._iter.reset(t);let d=this._root,o;for(;d;){const f=c.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(c.hasNext())c.next(),o=d.value||o,d=d.mid;else break}return d&&d.value||o}findSuperstr(t){const c=this._iter.reset(t);let d=this._root;for(;d;){const o=c.cmp(d.segment);if(o>0)d=d.left;else if(o<0)d=d.right;else if(c.hasNext())c.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(t){for(const[c,d]of this)t(d,c)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=c=>{if(!c)return!0;const d=c.balanceFactor();return d<-1||d>1?!1:t(c.left)&&t(c.right)};return t(this._root)}}e.TernarySearchTree=A;class p{constructor(t,c){this.uri=t,this.value=c}}class a{constructor(t,c){this[y]="ResourceMap",t instanceof a?(this.map=new Map(t.map),this.toKey=c??a.defaultToKey):(this.map=new Map,this.toKey=t??a.defaultToKey)}set(t,c){return this.map.set(this.toKey(t),new p(t,c)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,c){typeof c!="undefined"&&(t=t.bind(c));for(let[d,o]of this.map)t(o.value,o.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=a,a.defaultToKey=i=>i.toString();var r;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(r=e.Touch||(e.Touch={}));class g{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,c=0){const d=this._map.get(t);if(!!d)return c!==0&&this.touch(d,c),d.value}set(t,c,d=0){let o=this._map.get(t);if(o)o.value=c,d!==0&&this.touch(o,d);else{switch(o={key:t,value:c,next:void 0,previous:void 0},d){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(t,o),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this._map.get(t);if(!!c)return this._map.delete(t),this.removeItem(c),this._size--,c.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,c){const d=this._state;let o=this._head;for(;o;){if(c?t.bind(c)(o.value,o.key,this):t(o.value,o.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const t=this,c=this._state;let d=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(d){const f={value:d.key,done:!1};return d=d.next,f}else return{value:void 0,done:!0}}};return o}values(){const t=this,c=this._state;let d=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(d){const f={value:d.value,done:!1};return d=d.next,f}else return{value:void 0,done:!0}}};return o}entries(){const t=this,c=this._state;let d=this._head;const o={[Symbol.iterator](){return o},next(){if(t._state!==c)throw new Error("LinkedMap got modified during iteration.");if(d){const f={value:[d.key,d.value],done:!1};return d=d.next,f}else return{value:void 0,done:!0}}};return o}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this._head,d=this.size;for(;c&&d>t;)this._map.delete(c.key),c=c.next,d--;this._head=c,this._size=d,c&&(c.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const c=t.next,d=t.previous;if(!c||!d)throw new Error("Invalid list");c.previous=d,d.next=c}t.next=void 0,t.previous=void 0,this._state++}touch(t,c){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this._head)return;const d=t.next,o=t.previous;t===this._tail?(o.next=void 0,this._tail=o):(d.previous=o,o.next=d),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(c===2){if(t===this._tail)return;const d=t.next,o=t.previous;t===this._head?(d.previous=void 0,this._head=d):(d.previous=o,o.next=d),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((c,d)=>{t.push([d,c])}),t}fromJSON(t){this.clear();for(const[c,d]of t)this.set(c,d)}}e.LinkedMap=g;class s extends g{constructor(t,c=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,c),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class b{constructor(t){n.set(this,void 0),st(this,n,t,"f")}get size(){return Ne(this,n,"f").size}forEach(t,c){Ne(this,n,"f").forEach(t,c)}get(t){return Ne(this,n,"f").get(t)}has(t){return Ne(this,n,"f").has(t)}entries(){return Ne(this,n,"f").entries()}keys(){return Ne(this,n,"f").keys()}values(){return Ne(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return Ne(this,n,"f").entries()}}e.ReadonlyMapView=b}),define(fe[97],me([0,1,24,8]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Z){return function(re,pe){for(let Me=0,je=Z.length;Me<je;Me++){const Ke=Z[Me](re,pe);if(Ke)return Ke}return null}}e.or=y,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Z,re,pe){if(!pe||pe.length<re.length)return null;let Me;return Z?Me=L.startsWithIgnoreCase(pe,re):Me=pe.indexOf(re)===0,Me?re.length>0?[{start:0,end:re.length}]:[]:null}function n(Z,re){const pe=re.toLowerCase().indexOf(Z.toLowerCase());return pe===-1?null:[{start:pe,end:pe+Z.length}]}e.matchesContiguousSubString=n;function k(Z,re){return _(Z.toLowerCase(),re.toLowerCase(),0,0)}e.matchesSubString=k;function _(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]===re[Me]){let je=null;return(je=_(Z,re,pe+1,Me+1))?A({start:Me,end:Me+1},je):null}return _(Z,re,pe,Me+1)}function D(Z){return 97<=Z&&Z<=122}function P(Z){return 65<=Z&&Z<=90}e.isUpper=P;function I(Z){return 48<=Z&&Z<=57}function l(Z){return Z===32||Z===9||Z===10||Z===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>v.add(Z.charCodeAt(0)));function h(Z){return l(Z)||v.has(Z)}function w(Z,re){return Z===re||h(Z)&&h(re)}function S(Z){return D(Z)||P(Z)||I(Z)}function A(Z,re){return re.length===0?re=[Z]:Z.end===re[0].start?re[0].start=Z.start:re.unshift(Z),re}function p(Z,re){for(let pe=re;pe<Z.length;pe++){const Me=Z.charCodeAt(pe);if(P(Me)||I(Me)||pe>0&&!S(Z.charCodeAt(pe-1)))return pe}return Z.length}function a(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]!==re[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=a(Z,re,pe+1,Me+1);!je&&(Ke=p(re,Ke))<re.length;)je=a(Z,re,pe+1,Ke),Ke++;return je===null?null:A({start:Me,end:Me+1},je)}}function r(Z){let re=0,pe=0,Me=0,je=0,Ke=0;for(let at=0;at<Z.length;at++)Ke=Z.charCodeAt(at),P(Ke)&&re++,D(Ke)&&pe++,S(Ke)&&Me++,I(Ke)&&je++;const Ze=re/Z.length,rt=pe/Z.length,ct=Me/Z.length,ye=je/Z.length;return{upperPercent:Ze,lowerPercent:rt,alphaPercent:ct,numericPercent:ye}}function g(Z){const{upperPercent:re,lowerPercent:pe}=Z;return pe===0&&re>.6}function s(Z){const{upperPercent:re,lowerPercent:pe,alphaPercent:Me,numericPercent:je}=Z;return pe>.2&&re<.8&&Me>.6&&je<.2}function b(Z){let re=0,pe=0,Me=0,je=0;for(let Ke=0;Ke<Z.length;Ke++)Me=Z.charCodeAt(Ke),P(Me)&&re++,D(Me)&&pe++,l(Me)&&je++;return(re===0||pe===0)&&je===0?Z.length<=30:re<=5}function i(Z,re){if(!re||(re=re.trim(),re.length===0)||!b(Z)||re.length>60)return null;const pe=r(re);if(!s(pe)){if(!g(pe))return null;re=re.toLowerCase()}let Me=null,je=0;for(Z=Z.toLowerCase();je<re.length&&(Me=a(Z,re,0,je))===null;)je=p(re,je+1);return Me}e.matchesCamelCase=i;function t(Z,re,pe=!1){if(!re||re.length===0)return null;let Me=null,je=0;for(Z=Z.toLowerCase(),re=re.toLowerCase();je<re.length&&(Me=c(Z,re,0,je,pe))===null;)je=d(re,je+1);return Me}e.matchesWords=t;function c(Z,re,pe,Me,je){if(pe===Z.length)return[];if(Me===re.length)return null;if(w(Z.charCodeAt(pe),re.charCodeAt(Me))){let Ke=null,Ze=Me+1;if(Ke=c(Z,re,pe+1,Me+1,je),!je)for(;!Ke&&(Ze=d(re,Ze))<re.length;)Ke=c(Z,re,pe+1,Ze,je),Ze++;return Ke===null?null:A({start:Me,end:Me+1},Ke)}else return null}function d(Z,re){for(let pe=re;pe<Z.length;pe++)if(h(Z.charCodeAt(pe))||pe>0&&h(Z.charCodeAt(pe-1)))return pe;return Z.length}const o=y(e.matchesPrefix,i,n),f=y(e.matchesPrefix,i,k),u=new m.LRUCache(1e4);function E(Z,re,pe=!1){if(typeof Z!="string"||typeof re!="string")return null;let Me=u.get(Z);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),u.set(Z,Me));const je=Me.exec(re);return je?[{start:je.index,end:je.index+je[0].length}]:pe?f(Z,re):o(Z,re)}e.matchesFuzzy=E;function T(Z,re){const pe=Be(Z,Z.toLowerCase(),0,re,re.toLowerCase(),0,!0);return pe?B(pe):null}e.matchesFuzzy2=T;function R(Z,re,pe,Me,je,Ke){const Ze=Math.min(13,Z.length);for(;pe<Ze;pe++){const rt=Be(Z,re,pe,Me,je,Ke,!1);if(rt)return rt}return[0,Ke]}e.anyScore=R;function B(Z){if(typeof Z=="undefined")return[];const re=[],pe=Z[1];for(let Me=Z.length-1;Me>1;Me--){const je=Z[Me]+pe,Ke=re[re.length-1];Ke&&Ke.end===je?Ke.end=je+1:re.push({start:je,end:je+1})}return re}e.createMatches=B;const x=128;function F(){const Z=[],re=[];for(let pe=0;pe<=x;pe++)re[pe]=0;for(let pe=0;pe<=x;pe++)Z.push(re.slice(0));return Z}function $(Z){const re=[];for(let pe=0;pe<=Z;pe++)re[pe]=0;return re}const M=$(2*x),H=$(2*x),N=F(),U=F(),V=F(),O=!1;function W(Z,re,pe,Me,je){function Ke(rt,ct,ye=" "){for(;rt.length<ct;)rt=ye+rt;return rt}let Ze=` |   |${Me.split("").map(rt=>Ke(rt,3)).join("|")}
`;for(let rt=0;rt<=pe;rt++)rt===0?Ze+=" |":Ze+=`${re[rt-1]}|`,Ze+=Z[rt].slice(0,je+1).map(ct=>Ke(ct.toString(),3)).join("|")+`
`;return Ze}function j(Z,re,pe,Me){Z=Z.substr(re),pe=pe.substr(Me),console.log(W(U,Z,Z.length,pe,pe.length)),console.log(W(V,Z,Z.length,pe,pe.length)),console.log(W(N,Z,Z.length,pe,pe.length))}function X(Z,re){if(re<0||re>=Z.length)return!1;const pe=Z.codePointAt(re);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(pe)}}function Q(Z,re){if(re<0||re>=Z.length)return!1;switch(Z.charCodeAt(re)){case 32:case 9:return!0;default:return!1}}function de(Z,re,pe){return re[Z]!==pe[Z]}function Se(Z,re,pe,Me,je,Ke,Ze=!1){for(;re<pe&&je<Ke;)Z[re]===Me[je]&&(Ze&&(M[re]=je),re+=1),je+=1;return re===pe}e.isPatternInWord=Se;var De;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(De||(De={}));var Pe;(function(Z){Z.Default=[-100,0];function re(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}Z.isDefault=re})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Be(Z,re,pe,Me,je,Ke,Ze){const rt=Z.length>x?x:Z.length,ct=Me.length>x?x:Me.length;if(pe>=rt||Ke>=ct||rt-pe>ct-Ke||!Se(re,pe,rt,je,Ke,ct,!0))return;We(rt,ct,pe,Ke,re,je);let ye=1,at=1,J=pe,ie=Ke;const _e=[!1];for(ye=1,J=pe;J<rt;ye++,J++){const Ue=M[J],Xe=H[J],it=J+1<rt?H[J+1]:ct;for(at=Ue-Ke+1,ie=Ue;ie<it;at++,ie++){let ft=Number.MIN_SAFE_INTEGER,tt=!1;ie<=Xe&&(ft=He(Z,re,J,pe,Me,je,ie,ct,Ke,N[ye-1][at-1]===0,_e));let ut=0;ft!==Number.MAX_SAFE_INTEGER&&(tt=!0,ut=ft+U[ye-1][at-1]);const Re=ie>Ue,ve=Re?U[ye][at-1]+(N[ye][at-1]>0?-5:0):0,Te=ie>Ue+1&&N[ye][at-1]>0,se=Te?U[ye][at-2]+(N[ye][at-2]>0?-5:0):0;if(Te&&(!Re||se>=ve)&&(!tt||se>=ut))U[ye][at]=se,V[ye][at]=3,N[ye][at]=0;else if(Re&&(!tt||ve>=ut))U[ye][at]=ve,V[ye][at]=2,N[ye][at]=0;else if(tt)U[ye][at]=ut,V[ye][at]=1,N[ye][at]=N[ye-1][at-1]+1;else throw new Error("not possible")}}if(O&&j(Z,pe,Me,Ke),!_e[0]&&!Ze)return;ye--,at--;const Qe=[U[ye][at],Ke];let et=0,le=0;for(;ye>=1;){let Ue=at;do{const Xe=V[ye][Ue];if(Xe===3)Ue=Ue-2;else if(Xe===2)Ue=Ue-1;else break}while(Ue>=1);et>1&&re[pe+ye-1]===je[Ke+at-1]&&!de(Ue+Ke-1,Me,je)&&et+1>N[ye][Ue]&&(Ue=at),Ue===at?et++:et=1,le||(le=Ue),ye--,at=Ue-1,Qe.push(at)}ct===rt&&(Qe[0]+=2);const Ie=le-rt;return Qe[0]-=Ie,Qe}e.fuzzyScore=Be;function We(Z,re,pe,Me,je,Ke){let Ze=Z-1,rt=re-1;for(;Ze>=pe&&rt>=Me;)je[Ze]===Ke[rt]&&(H[Ze]=rt,Ze--),rt--}function He(Z,re,pe,Me,je,Ke,Ze,rt,ct,ye,at){if(re[pe]!==Ke[Ze])return Number.MIN_SAFE_INTEGER;let J=1,ie=!1;return Ze===pe-Me?J=Z[pe]===je[Ze]?7:5:de(Ze,je,Ke)&&(Ze===0||!de(Ze-1,je,Ke))?(J=Z[pe]===je[Ze]?7:5,ie=!0):X(Ke,Ze)&&(Ze===0||!X(Ke,Ze-1))?J=5:(X(Ke,Ze-1)||Q(Ke,Ze-1))&&(J=5,ie=!0),J>1&&pe===Me&&(at[0]=!0),ie||(ie=de(Ze,je,Ke)||X(Ke,Ze-1)||Q(Ke,Ze-1)),pe===Me?Ze>ct&&(J-=ie?3:5):ye?J+=ie?2:0:J+=ie?0:1,Ze+1===rt&&(J-=ie?3:5),J}function G(Z,re,pe,Me,je,Ke,Ze){return ne(Z,re,pe,Me,je,Ke,!0,Ze)}e.fuzzyScoreGracefulAggressive=G;function ee(Z,re,pe,Me,je,Ke,Ze){return ne(Z,re,pe,Me,je,Ke,!1,Ze)}e.fuzzyScoreGraceful=ee;function ne(Z,re,pe,Me,je,Ke,Ze,rt){let ct=Be(Z,re,pe,Me,je,Ke,rt);if(ct&&!Ze)return ct;if(Z.length>=3){const ye=Math.min(7,Z.length-1);for(let at=pe+1;at<ye;at++){const J=ce(Z,at);if(J){const ie=Be(J,J.toLowerCase(),pe,Me,je,Ke,rt);ie&&(ie[0]-=3,(!ct||ie[0]>ct[0])&&(ct=ie))}}}return ct}function ce(Z,re){if(re+1>=Z.length)return;const pe=Z[re],Me=Z[re+1];if(pe!==Me)return Z.slice(0,re)+Me+pe+Z.slice(re+2)}}),define(fe[141],me([0,1,78,97,8]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),n=new RegExp(m.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${C.source}`,"g");function _(S){return S.replace(k,(A,p)=>p?A:`\\${A}`)}e.escapeIcons=_;const D=new RegExp(`\\\\${C.source}`,"g");function P(S){return S.replace(D,A=>`\\${A}`)}e.markdownEscapeEscapedIcons=P;const I=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function l(S){return S.indexOf(e.iconStartMarker)===-1?S:S.replace(I,(A,p,a,r)=>a?A:p||r||"")}e.stripIcons=l;function v(S){const A=S.indexOf(e.iconStartMarker);return A===-1?{text:S}:h(S,A)}e.parseLabelWithIcons=v;function h(S,A){const p=[];let a="";function r(o){if(o){a+=o;for(const f of o)p.push(b)}}let g=-1,s="",b=0,i,t,c=A;const d=S.length;for(r(S.substr(0,A));c<d;)i=S[c],t=S[c+1],i===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(g=c,r(s),s=e.iconStartMarker,c++):i===")"&&g!==-1?(b+=c-g+1,g=-1,s=""):g!==-1?n.test(i)?s+=i:(r(s),g=-1,s=""):r(i),c++;return r(s),{text:a,iconOffsets:p}}function w(S,A,p=!1){const{text:a,iconOffsets:r}=A;if(!r||r.length===0)return(0,L.matchesFuzzy)(S,a,p);const g=(0,y.ltrim)(a," "),s=a.length-g.length,b=(0,L.matchesFuzzy)(S,g,p);if(b)for(const i of b){const t=r[i.start+s]+s;i.start+=t,i.end+=t}return b}e.matchesFuzzyIconAware=w}),define(fe[98],me([0,1,16,141]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(v="",h=!1){if(this.value=v,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(v,h=0){return this.value+=D(this.supportThemeIcons?(0,L.escapeIcons)(v):v).replace(/([ \t]+)/g,(w,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,h){return this.value+="\n```",this.value+=v,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=C;function n(l){return k(l)?!l.value:Array.isArray(l)?l.every(n):!0}e.isEmptyMarkdownString=n;function k(l){return l instanceof C?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function _(l,v){return l===v?!0:!l||!v?!1:l.value===v.value&&l.isTrusted===v.isTrusted&&l.supportThemeIcons===v.supportThemeIcons}e.markdownStringEqual=_;function D(l){return l.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function P(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=P;function I(l){const v=[],h=l.split("|").map(S=>S.trim());l=h[0];const w=h[1];if(w){const S=/height=(\d+)/.exec(w),A=/width=(\d+)/.exec(w),p=S?S[1]:"",a=A?A[1]:"",r=isFinite(parseInt(a)),g=isFinite(parseInt(p));r&&v.push(`width="${a}"`),g&&v.push(`height="${p}"`)}return{href:l,dimensions:v}}e.parseHrefAndDimensions=I}),define(fe[79],me([0,1,24]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new m.LRUCache(1e4);function y(D){return _(D,"NFC",L)}e.normalizeNFC=y;const C=new m.LRUCache(1e4);function n(D){return _(D,"NFD",C)}e.normalizeNFD=n;const k=/[^\u0000-\u0080]/;function _(D,P,I){if(!D)return D;const l=I.get(D);if(l)return l;let v;return k.test(D)?v=D.normalize(P):v=D,I.set(D,v),v}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(P){return n(P).replace(D,"")}}()}),define(fe[49],me([0,1,8]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(L||(L={})),function(y){const C="error",n="warning",k="warn",_="info",D="ignore";function P(l){return l?m.equalsIgnoreCase(C,l)?y.Error:m.equalsIgnoreCase(n,l)||m.equalsIgnoreCase(k,l)?y.Warning:m.equalsIgnoreCase(_,l)?y.Info:y.Ignore:y.Ignore}y.fromValue=P;function I(l){switch(l){case y.Error:return C;case y.Warning:return n;case y.Info:return _;default:return D}}y.toString=I}(L||(L={})),e.default=L}),define(fe[13],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(f){return Array.isArray(f)}e.isArray=m;function L(f){return typeof f=="string"}e.isString=L;function y(f){return Array.isArray(f)&&f.every(u=>L(u))}e.isStringArray=y;function C(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=C;function n(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=n;function k(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=k;function _(f){return f===!0||f===!1}e.isBoolean=_;function D(f){return typeof f=="undefined"}e.isUndefined=D;function P(f){return!I(f)}e.isDefined=P;function I(f){return D(f)||f===null}e.isUndefinedOrNull=I;function l(f,u){if(!f)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=l;function v(f){if(I(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=v;function h(...f){const u=[];for(let E=0;E<f.length;E++){const T=f[E];if(I(T))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);u.push(T)}return u}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function S(f){if(!C(f))return!1;for(let u in f)if(w.call(f,u))return!1;return!0}e.isEmptyObject=S;function A(f){return typeof f=="function"}e.isFunction=A;function p(...f){return f.length>0&&f.every(A)}e.areFunctions=p;function a(f,u){const E=Math.min(f.length,u.length);for(let T=0;T<E;T++)r(f[T],u[T])}e.validateConstraints=a;function r(f,u){if(L(u)){if(typeof f!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(A(u)){try{if(f instanceof u)return}catch{}if(!I(f)&&f.constructor===u||u.length===1&&u.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=r;function g(f){let u=[],E=Object.getPrototypeOf(f);for(;Object.prototype!==E;)u=u.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return u}e.getAllPropertyNames=g;function s(f){const u=[];for(const E of g(f))typeof f[E]=="function"&&u.push(E);return u}e.getAllMethodNames=s;function b(f,u){const E=R=>function(){const B=Array.prototype.slice.call(arguments,0);return u(R,B)};let T={};for(const R of f)T[R]=E(R);return T}e.createProxyObject=b;function i(f){return f===null?void 0:f}e.withNullAsUndefined=i;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function c(f){return class{constructor(){return new Proxy({},{get(u,E){if(u[E])return u[E];throw new Error(`Not Implemented: ${f}->${String(E)}`)}})}}}e.NotImplementedProxy=c;function d(f,u="Unreachable"){throw new Error(u)}e.assertNever=d;function o(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=o}),define(fe[30],me([0,1,9,12,8,13]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(i){return i===47||i===92}e.isPathSeparator=n;function k(i){return i.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=k;function _(i){return i.indexOf("/")===-1&&(i=k(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=_;function D(i,t=m.posix.sep){if(!i)return"";const c=i.length,d=i.charCodeAt(0);if(n(d)){if(n(i.charCodeAt(1))&&!n(i.charCodeAt(2))){let f=3;const u=f;for(;f<c&&!n(i.charCodeAt(f));f++);if(u!==f&&!n(i.charCodeAt(f+1))){for(f+=1;f<c;f++)if(n(i.charCodeAt(f)))return i.slice(0,f+1).replace(/[\\/]/g,t)}}return t}else if(A(d)&&i.charCodeAt(1)===58)return n(i.charCodeAt(2))?i.slice(0,2)+t:i.slice(0,2);let o=i.indexOf("://");if(o!==-1){for(o+=3;o<c;o++)if(n(i.charCodeAt(o)))return i.slice(0,o+1)}return""}e.getRoot=D;function P(i){if(!L.isWindows||!i||i.length<5)return!1;let t=i.charCodeAt(0);if(t!==92||(t=i.charCodeAt(1),t!==92))return!1;let c=2;const d=c;for(;c<i.length&&(t=i.charCodeAt(c),t!==92);c++);return!(d===c||(t=i.charCodeAt(c+1),isNaN(t)||t===92))}e.isUNC=P;const I=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,t=L.isWindows){const c=t?I:l;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||t&&v.test(i)||i==="."||i===".."||t&&i[i.length-1]==="."||t&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function w(i,t,c){const d=i===t;return!c||d?d:!i||!t?!1:(0,y.equalsIgnoreCase)(i,t)}e.isEqual=w;function S(i,t,c,d=m.sep){if(i===t)return!0;if(!i||!t||t.length>i.length)return!1;if(c){if(!(0,y.startsWithIgnoreCase)(i,t))return!1;if(t.length===i.length)return!0;let f=t.length;return t.charAt(t.length-1)===d&&f--,i.charAt(f)===d}return t.charAt(t.length-1)!==d&&(t+=d),i.indexOf(t)===0}e.isEqualOrParent=S;function A(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=A;function p(i,t){return L.isWindows&&i.endsWith(":")&&(i+=m.sep),(0,m.isAbsolute)(i)||(i=(0,m.join)(t,i)),i=(0,m.normalize)(i),L.isWindows?(i=(0,y.rtrim)(i,m.sep),i.endsWith(":")&&(i+=m.sep)):(i=(0,y.rtrim)(i,m.sep),i||(i=m.sep)),i}e.sanitizeFilePath=p;function a(i){const t=(0,m.normalize)(i);return L.isWindows?i.length>3?!1:r(t)&&(i.length===2||t.charCodeAt(2)===92):t===m.posix.sep}e.isRootOrDriveLetter=a;function r(i,t){return(t!==void 0?t:L.isWindows)?A(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=r;function g(i){return r(i)?i[0]:void 0}e.getDriveLetter=g;function s(i,t,c){return t.length>i.length?-1:i===t?0:(c&&(i=i.toLowerCase(),t=t.toLowerCase()),i.indexOf(t))}e.indexOfPath=s;function b(i){const t=i.split(":");let c,d,o;if(t.forEach(f=>{const u=Number(f);(0,C.isNumber)(u)?d===void 0?d=u:o===void 0&&(o=u):c=c?[c,f].join(":"):f}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:d!==void 0?d:void 0,column:o!==void 0?o:d!==void 0?1:void 0}}e.parseLineAndColumnAware=b}),define(fe[25],me([0,1,13]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const S=Array.isArray(w)?[]:{};return Object.keys(w).forEach(A=>{w[A]&&typeof w[A]=="object"?S[A]=L(w[A]):S[A]=w[A]}),S}e.deepClone=L;function y(w){if(!w||typeof w!="object")return w;const S=[w];for(;S.length>0;){const A=S.shift();Object.freeze(A);for(const p in A)if(C.call(A,p)){const a=A[p];typeof a=="object"&&!Object.isFrozen(a)&&S.push(a)}}return w}e.deepFreeze=y;const C=Object.prototype.hasOwnProperty;function n(w,S){return k(w,S,new Set)}e.cloneAndChange=n;function k(w,S,A){if((0,m.isUndefinedOrNull)(w))return w;const p=S(w);if(typeof p!="undefined")return p;if((0,m.isArray)(w)){const a=[];for(const r of w)a.push(k(r,S,A));return a}if((0,m.isObject)(w)){if(A.has(w))throw new Error("Cannot clone recursive data-structure");A.add(w);const a={};for(let r in w)C.call(w,r)&&(a[r]=k(w[r],S,A));return A.delete(w),a}return w}function _(w,S,A=!0){return(0,m.isObject)(w)?((0,m.isObject)(S)&&Object.keys(S).forEach(p=>{p in w?A&&((0,m.isObject)(w[p])&&(0,m.isObject)(S[p])?_(w[p],S[p],A):w[p]=S[p]):w[p]=S[p]}),w):S}e.mixin=_;function D(w,S){if(w===S)return!0;if(w==null||S===null||S===void 0||typeof w!=typeof S||typeof w!="object"||Array.isArray(w)!==Array.isArray(S))return!1;let A,p;if(Array.isArray(w)){if(w.length!==S.length)return!1;for(A=0;A<w.length;A++)if(!D(w[A],S[A]))return!1}else{const a=[];for(p in w)a.push(p);a.sort();const r=[];for(p in S)r.push(p);if(r.sort(),!D(a,r))return!1;for(A=0;A<a.length;A++)if(!D(w[a[A]],S[a[A]]))return!1}return!0}e.equals=D;function P(w){const S=new Set;return JSON.stringify(w,(A,p)=>{if((0,m.isObject)(p)||Array.isArray(p)){if(S.has(p))return"[Circular]";S.add(p)}return p})}e.safeStringify=P;function I(w,S,A){const p=S(w);return typeof p=="undefined"?A:p}e.getOrDefault=I;function l(w,S){const A=Object.create(null);return!w||!S||Object.keys(S).forEach(a=>{const r=w[a],g=S[a];D(r,g)||(A[a]=g)}),A}e.distinct=l;function v(w,S){const A=S.toLowerCase(),p=Object.keys(w).find(a=>a.toLowerCase()===A);return p?w[p]:w[S]}e.getCaseInsensitive=v;function h(w,S){const A=Object.create(null);for(const[p,a]of Object.entries(w))S(p,a)&&(A[p]=a);return A}e.filter=h}),define(fe[99],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function y(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=y}),define(fe[2],me([0,1,9,12]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,C=/^\//,n=/^\/\//;function k(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!y.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!C.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(n.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(i,t){return!i&&!t?"file":i}function D(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const P="",I="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(t,c,d,o,f,u=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=_(t,u),this.authority=c||P,this.path=D(this.scheme,d||P),this.query=o||P,this.fragment=f||P,k(this,u))}static isUri(t){return t instanceof v?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return a(this,!1)}with(t){if(!t)return this;let{scheme:c,authority:d,path:o,query:f,fragment:u}=t;return c===void 0?c=this.scheme:c===null&&(c=P),d===void 0?d=this.authority:d===null&&(d=P),o===void 0?o=this.path:o===null&&(o=P),f===void 0?f=this.query:f===null&&(f=P),u===void 0?u=this.fragment:u===null&&(u=P),c===this.scheme&&d===this.authority&&o===this.path&&f===this.query&&u===this.fragment?this:new w(c,d,o,f,u)}static parse(t,c=!1){const d=l.exec(t);return d?new w(d[2]||P,b(d[4]||P),b(d[5]||P),b(d[7]||P),b(d[9]||P),c):new w(P,P,P,P,P)}static file(t){let c=P;if(L.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const d=t.indexOf(I,2);d===-1?(c=t.substring(2),t=I):(c=t.substring(2,d),t=t.substring(d)||I)}return new w("file",c,t,P,P)}static from(t){const c=new w(t.scheme,t.authority,t.path,t.query,t.fragment);return k(c,!0),c}static joinPath(t,...c){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return L.isWindows&&t.scheme==="file"?d=v.file(m.win32.join(a(t,!0),...c)).path:d=m.posix.join(t.path,...c),t.with({path:d})}toString(t=!1){return r(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof v)return t;{const c=new w(t);return c._formatted=t.external,c._fsPath=t._sep===h?t.fsPath:null,c}}else return t}}e.URI=v;const h=L.isWindows?1:void 0;class w extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(t=!1){return t?r(this,!0):(this._formatted||(this._formatted=r(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(i,t){let c,d=-1;for(let o=0;o<i.length;o++){const f=i.charCodeAt(o);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)d!==-1&&(c+=encodeURIComponent(i.substring(d,o)),d=-1),c!==void 0&&(c+=i.charAt(o));else{c===void 0&&(c=i.substr(0,o));const u=S[f];u!==void 0?(d!==-1&&(c+=encodeURIComponent(i.substring(d,o)),d=-1),c+=u):d===-1&&(d=o)}}return d!==-1&&(c+=encodeURIComponent(i.substring(d))),c!==void 0?c:i}function p(i){let t;for(let c=0;c<i.length;c++){const d=i.charCodeAt(c);d===35||d===63?(t===void 0&&(t=i.substr(0,c)),t+=S[d]):t!==void 0&&(t+=i[c])}return t!==void 0?t:i}function a(i,t){let c;return i.authority&&i.path.length>1&&i.scheme==="file"?c=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?c=i.path.substr(1):c=i.path[1].toLowerCase()+i.path.substr(2):c=i.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=a;function r(i,t){const c=t?p:A;let d="",{scheme:o,authority:f,path:u,query:E,fragment:T}=i;if(o&&(d+=o,d+=":"),(f||o==="file")&&(d+=I,d+=I),f){let R=f.indexOf("@");if(R!==-1){const B=f.substr(0,R);f=f.substr(R+1),R=B.indexOf(":"),R===-1?d+=c(B,!1):(d+=c(B.substr(0,R),!1),d+=":",d+=c(B.substr(R+1),!1)),d+="@"}f=f.toLowerCase(),R=f.indexOf(":"),R===-1?d+=c(f,!1):(d+=c(f.substr(0,R),!1),d+=f.substr(R))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const R=u.charCodeAt(1);R>=65&&R<=90&&(u=`/${String.fromCharCode(R+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const R=u.charCodeAt(0);R>=65&&R<=90&&(u=`${String.fromCharCode(R+32)}:${u.substr(2)}`)}d+=c(u,!0)}return E&&(d+="?",d+=c(E,!1)),T&&(d+="#",d+=t?T:A(T,!1)),d}function g(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+g(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(i){return i.match(s)?i.replace(s,t=>g(t)):i}}),define(fe[59],me([0,1,22,8,2]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(P){return JSON.stringify(P,_)}e.stringify=C;function n(P){let I=JSON.parse(P);return I=D(I),I}e.parse=n;var k;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function _(P,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function D(P,I=0){if(!P||I>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return y.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof m.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let l=0;l<P.length;++l)P[l]=D(P[l],I+1);else for(const l in P)Object.hasOwnProperty.call(P,l)&&(P[l]=D(P[l],I+1))}return P}e.revive=D}),define(fe[10],me([0,1,12,2]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var y;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(y=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,D,P){this._hosts[_]=D,this._ports[_]=P}setConnectionToken(_,D){this._connectionTokens[_]=D}rewrite(_){if(this._delegate)return this._delegate(_);const D=_.authority;let P=this._hosts[D];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const I=this._ports[D],l=this._connectionTokens[D];let v=`path=${encodeURIComponent(_.path)}`;return typeof l=="string"&&(v+=`&tkn=${encodeURIComponent(l)}`),L.URI.from({scheme:m.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${P}:${I}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new C;class n{asBrowserUri(_,D){const P=this.toUri(_,D);return P.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===y.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${y.vscodeFileResource}://${n.FALLBACK_AUTHORITY}`)?P.with({scheme:y.vscodeFileResource,authority:P.authority||n.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(_,D){const P=this.toUri(_,D);return P.scheme===y.vscodeFileResource?P.with({scheme:y.file,authority:P.authority!==n.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(_,D){return L.URI.isUri(_)?_:L.URI.parse(D.toUrl(_))}}n.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new n}),define(fe[23],me([0,1,30,10,9,12,8,2]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(v){return(0,k.uriToFsPath)(v,!0)}e.originalFSPath=_;class D{constructor(h){this._ignorePathCasing=h}compare(h,w,S=!1){return h===w?0:(0,n.compare)(this.getComparisonKey(h,S),this.getComparisonKey(w,S))}isEqual(h,w,S=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,S)===this.getComparisonKey(w,S)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,S=!1){if(h.scheme===w.scheme){if(h.scheme===L.Schemas.file)return m.isEqualOrParent(_(h),_(w),this._ignorePathCasing(h))&&h.query===w.query&&(S||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return m.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(S||h.fragment===w.fragment)}return!1}joinPath(h,...w){return k.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===L.Schemas.file?w=k.URI.file(y.dirname(_(h))).path:(w=y.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===L.Schemas.file?w=k.URI.file(y.normalize(_(h))).path:w=y.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))return;if(h.scheme===L.Schemas.file){const p=y.relative(_(h),_(w));return C.isWindows?m.toSlashes(p):p}let S=h.path||"/",A=w.path||"/";if(this._ignorePathCasing(h)){let p=0;for(const a=Math.min(S.length,A.length);p<a&&!(S.charCodeAt(p)!==A.charCodeAt(p)&&S.charAt(p).toLowerCase()!==A.charAt(p).toLowerCase());p++);S=A.substr(0,p)+S.substr(p)}return y.posix.relative(S,A)}resolvePath(h,w){if(h.scheme===L.Schemas.file){const S=k.URI.file(y.resolve(_(h),w));return h.with({authority:S.authority,path:S.path})}return w=m.toPosixPath(w),h.with({path:y.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||h!==void 0&&w!==void 0&&(0,n.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=y.sep){if(h.scheme===L.Schemas.file){const S=_(h);return S.length>m.getRoot(S).length&&S[S.length-1]===w}else{const S=h.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=y.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=y.sep){let S=!1;if(h.scheme===L.Schemas.file){const A=_(h);S=A!==void 0&&A.length===m.getRoot(A).length&&A[A.length-1]===w}else{w="/";const A=h.path;S=A.length===1&&A.charCodeAt(A.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(v=>v.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new D(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(v,h){const w=[];for(let S=0;S<v.length;S++){const A=h(v[S]);v.some((p,a)=>a===S?!1:(0,e.isEqualOrParent)(A,h(p)))||w.push(v[S])}return w}e.distinctParents=P;var I;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(w){const S=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(a=>{const[r,g]=a.split(":");r&&g&&S.set(r,g)});const p=w.path.substring(0,w.path.indexOf(";"));return p&&S.set(v.META_DATA_MIME,p),S}v.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function l(v,h,w){if(h){let S=v.path;return S&&S[0]!==y.posix.sep&&(S=y.posix.sep+S),v.with({scheme:w,authority:h,path:S})}return v.with({scheme:w})}e.toLocalResource=l}),define(fe[18],me([0,1,21,16,3,6,23]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(N){return!!N&&typeof N.then=="function"}e.isThenable=k;function _(N){const U=new m.CancellationTokenSource,V=N(U.token),O=new Promise((W,j)=>{const X=U.token.onCancellationRequested(()=>{X.dispose(),U.dispose(),j((0,L.canceled)())});Promise.resolve(V).then(Q=>{X.dispose(),U.dispose(),W(Q)},Q=>{X.dispose(),U.dispose(),j(Q)})});return new class{cancel(){U.cancel()}then(W,j){return O.then(W,j)}catch(W){return this.then(void 0,W)}finally(W){return O.finally(W)}}}e.createCancelablePromise=_;function D(N,U,V){return Promise.race([N,new Promise(O=>U.onCancellationRequested(()=>O(V)))])}e.raceCancellation=D;async function P(N){let U=-1;const V=N.map((W,j)=>W.then(X=>(U=j,X))),O=await Promise.race(V);return N.forEach((W,j)=>{j!==U&&W.cancel()}),O}e.raceCancellablePromises=P;function I(N,U,V){let O;const W=setTimeout(()=>{O?.(void 0),V?.()},U);return Promise.race([N.finally(()=>clearTimeout(W)),new Promise(j=>O=j)])}e.raceTimeout=I;function l(N){return new Promise((U,V)=>{const O=N();k(O)?O.then(U,V):U(O)})}e.asPromise=l;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(V,V).then(O)})}return new Promise((V,O)=>{this.queuedPromise.then(V,O)})}return this.activePromise=U(),new Promise((V,O)=>{this.activePromise.then(W=>{this.activePromise=null,V(W)},W=>{this.activePromise=null,O(W)})})}}e.Throttler=v;class h{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=h;class w{constructor(){this.promiseMap=new Map}queue(U,V){const W=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(U)===W&&this.promiseMap.delete(U)});return this.promiseMap.set(U,W),W}}e.SequencerByKey=w;class S{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,V=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,W)=>{this.doResolve=O,this.doReject=W}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},V),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class A{constructor(U){this.delayer=new S(U),this.throttler=new v}trigger(U,V){return this.delayer.trigger(()=>this.throttler.queue(U),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=A;class p{constructor(){this._isOpen=!1,this._promise=new Promise((U,V)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;class a extends p{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function r(N,U){return U?new Promise((V,O)=>{const W=setTimeout(()=>{j.dispose(),V()},N),j=U.onCancellationRequested(()=>{clearTimeout(W),j.dispose(),O((0,L.canceled)())})}):_(V=>r(N,V))}e.timeout=r;function g(N,U=0){const V=setTimeout(N,U);return(0,C.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=g;function s(N){const U=[];let V=0;const O=N.length;function W(){return V<O?N[V++]():null}function j(X){X!=null&&U.push(X);const Q=W();return Q?Q.then(j):Promise.resolve(U)}return Promise.resolve(null).then(j)}e.sequence=s;function b(N,U=O=>!!O,V=null){let O=0;const W=N.length,j=()=>{if(O>=W)return Promise.resolve(V);const X=N[O++];return Promise.resolve(X()).then(de=>U(de)?Promise.resolve(de):j())};return j()}e.first=b;function i(N,U=O=>!!O,V=null){if(N.length===0)return Promise.resolve(V);let O=N.length;const W=()=>{O=-1;for(const j of N)j.cancel?.()};return new Promise((j,X)=>{for(const Q of N)Q.then(de=>{--O>=0&&U(de)?(W(),j(de)):O===0&&j(V)}).catch(de=>{--O>=0&&(W(),X(de))})})}e.firstParallel=i;class t{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new y.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((V,O)=>{this.outstandingPromises.push({factory:U,c:V,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const V=U.factory();V.then(U.c,U.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class c extends t{constructor(){super(1)}}e.Queue=c;class d{constructor(){this.queues=new Map}queueFor(U,V=n.extUri){const O=V.getComparisonKey(U);let W=this.queues.get(O);return W||(W=new c,y.Event.once(W.onFinished)(()=>{W?.dispose(),this.queues.delete(O)}),this.queues.set(O,W)),W}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=d;class o{constructor(U,V){this._token=-1,typeof U=="function"&&typeof V=="number"&&this.setIfNotSet(U,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},V)}setIfNotSet(U,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},V))}}e.TimeoutTimer=o;class f{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,V){this.cancel(),this._token=setInterval(()=>{U()},V)}}e.IntervalTimer=f;class u{constructor(U,V){this.timeoutToken=-1,this.runner=U,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=u;class E{constructor(U,V){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class T extends u{constructor(U,V){super(U,V);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T;class R extends C.Disposable{constructor(U,V,O,W){super();this.maxWorkChunkSize=U,this.maxPendingWork=V,this.throttleDelay=O,this.handler=W,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new u(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{const U=setTimeout(()=>{const O=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0,clearTimeout(U))}}}:e.runWhenIdle=(N,U)=>{const V=requestIdleCallback(N,typeof U=="number"?{timeout:U}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(V))}}}}();class B{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function x(N,U,V){let O;for(let W=0;W<V;W++)try{return await N()}catch(j){O=j,await r(U)}throw O}e.retry=x;class F{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,V,O){return this._pending={taskId:U,cancel:()=>O?.(),promise:V},V.then(()=>this.donePending(U),()=>this.donePending(U)),V}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let V,O;const W=new Promise((j,X)=>{V=j,O=X});this._next={run:U,promise:W,promiseResolve:V,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=F;class ${constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,V)=>{this.completeCallback=U,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(V=>{this.completeCallback(U),this.resolved=!0,V()})}error(U){return new Promise(V=>{this.errorCallback(U),this.rejected=!0,V()})}cancel(){new Promise(U=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=M;var H;(function(N){async function U(O){let W;const j=await Promise.all(O.map(X=>X.then(Q=>Q,Q=>{W||(W=Q)})));if(typeof W!="undefined")throw W;return j}N.settled=U;function V(O){return new Promise(async(W,j)=>{try{await O(W,j)}catch(X){j(X)}})}N.withAsyncBody=V})(H=e.Promises||(e.Promises={}))}),define(fe[100],me([0,1,18,9]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new m.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),n=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,E,T=!1){const R=u||"",B=E||"",x=y.value.collator.compare(R,B);return y.value.collatorIsNumeric&&x===0&&R!==B?R<B?-1:1:x}e.compareFileNames=k;function _(u,E){const T=C.value.collator;return u=u||"",E=E||"",g(T,u,E)}e.compareFileNamesDefault=_;function D(u,E){const T=C.value.collator;return u=u||"",E=E||"",t(u,E)||g(T,u,E)}e.compareFileNamesUpper=D;function P(u,E){const T=C.value.collator;return u=u||"",E=E||"",i(u,E)||g(T,u,E)}e.compareFileNamesLower=P;function I(u,E){return u=u||"",E=E||"",u===E?0:u<E?-1:1}e.compareFileNamesUnicode=I;function l(u,E,T=!1){T||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase());const[R,B]=a(u),[x,F]=a(E);return R!==x?R<x?-1:1:B===F?0:B<F?-1:1}e.noIntlCompareFileNames=l;function v(u,E){const[T,R]=a(u),[B,x]=a(E);let F=y.value.collator.compare(R,x);if(F===0){if(y.value.collatorIsNumeric&&R!==x)return R<x?-1:1;if(F=y.value.collator.compare(T,B),y.value.collatorIsNumeric&&F===0&&T!==B)return T<B?-1:1}return F}e.compareFileExtensions=v;function h(u,E){u=u||"",E=E||"";const T=r(u),R=r(E),B=C.value.collator,x=n.value.collator;return g(x,T,R)||g(B,u,E)}e.compareFileExtensionsDefault=h;function w(u,E){u=u||"",E=E||"";const T=r(u),R=r(E),B=C.value.collator,x=n.value.collator;return g(x,T,R)||t(u,E)||g(B,u,E)}e.compareFileExtensionsUpper=w;function S(u,E){u=u||"",E=E||"";const T=r(u),R=r(E),B=C.value.collator,x=n.value.collator;return g(x,T,R)||i(u,E)||g(B,u,E)}e.compareFileExtensionsLower=S;function A(u,E){u=u||"",E=E||"";const T=r(u).toLowerCase(),R=r(E).toLowerCase();return T!==R?T<R?-1:1:u!==E?u<E?-1:1:0}e.compareFileExtensionsUnicode=A;const p=/^(.*?)(\.([^.]*))?$/;function a(u,E=!1){const T=u?p.exec(u):[];let R=[T&&T[1]||"",T&&T[3]||""];return E&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function r(u){const E=u?p.exec(u):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function g(u,E,T){let R=u.compare(E,T);return R!==0?R:E.length!==T.length?E.length<T.length?-1:1:0}function s(u){const E=u.charAt(0);return E.toLocaleUpperCase()!==E}function b(u){const E=u.charAt(0);return E.toLocaleLowerCase()!==E}function i(u,E){return s(u)&&b(E)?-1:b(u)&&s(E)?1:0}function t(u,E){return b(u)&&s(E)?-1:s(u)&&b(E)?1:0}function c(u,E,T=!1){return T||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase()),u===E?0:u<E?-1:1}function d(u,E,T=!1){const R=u.split(L.sep),B=E.split(L.sep),x=R.length-1,F=B.length-1;let $,M;for(let H=0;;H++){if($=x===H,M=F===H,$&&M)return k(R[H],B[H],T);if($)return-1;if(M)return 1;const N=c(R[H],B[H],T);if(N!==0)return N}}e.comparePaths=d;function o(u,E,T){const R=u.toLowerCase(),B=E.toLowerCase(),x=f(u,E,T);if(x)return x;const F=R.endsWith(T),$=B.endsWith(T);if(F!==$)return F?-1:1;const M=k(R,B);return M!==0?M:R.localeCompare(B)}e.compareAnything=o;function f(u,E,T){const R=u.toLowerCase(),B=E.toLowerCase(),x=R.startsWith(T),F=B.startsWith(T);if(x!==F)return x?-1:1;if(x&&F){if(R.length<B.length)return-1;if(R.length>B.length)return 1}return 0}e.compareByPrefix=f}),define(fe[101],me([0,1,100,97,48,9,12,8]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,D=[_,[]];function P(N,U,V,O){if(!N||!U)return D;const W=N.length,j=U.length;if(W<j)return D;const X=N.toLowerCase();return I(U,V,j,N,X,W,O)}e.scoreFuzzy=P;function I(N,U,V,O,W,j,X){const Q=[],de=[];for(let Be=0;Be<V;Be++){const We=Be*j,He=We-j,G=Be>0,ee=N[Be],ne=U[Be];for(let ce=0;ce<j;ce++){const Z=ce>0,re=We+ce,pe=re-1,Me=He+ce-1,je=Z?Q[pe]:0,Ke=G&&Z?Q[Me]:0,Ze=G&&Z?de[Me]:0;let rt;!Ke&&G?rt=0:rt=l(ee,ne,O,W,ce,Ze),rt&&Ke+rt>=je&&(X||G||W.startsWith(U,ce))?(de[re]=Ze+1,Q[re]=Ke+rt):(de[re]=_,Q[re]=je)}}const Se=[];let De=V-1,Pe=j-1;for(;De>=0&&Pe>=0;){const Be=De*j+Pe;de[Be]===_||(Se.push(Pe),De--),Pe--}return[Q[V*j-1],Se.reverse()]}function l(N,U,V,O,W,j){let X=0;if(!v(U,O[W]))return X;if(X+=1,j>0&&(X+=j*5),N===V[W]&&(X+=1),W===0)X+=8;else{const Q=h(V.charCodeAt(W-1));Q?X+=Q:(0,L.isUpper)(V.charCodeAt(W))&&j===0&&(X+=2)}return X}function v(N,U){return N===U?!0:N==="/"||N==="\\"?U==="/"||U==="\\":!1}function h(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function S(N,U,V=0,O=0){const W=U;return W.values&&W.values.length>1?A(N,W.values,V,O):p(N,U,V,O)}e.scoreFuzzy2=S;function A(N,U,V,O){let W=0;const j=[];for(const X of U){const[Q,de]=p(N,X,V,O);if(typeof Q!="number")return w;W+=Q,j.push(...de)}return[W,f(j)]}function p(N,U,V,O){const W=(0,L.fuzzyScore)(U.original,U.originalLowercase,V,N,N.toLowerCase(),O,!0);return W?[W[0],(0,L.createMatches)(W)]:w}const a=Object.freeze({score:0}),r=1<<18,g=1<<17,s=1<<16;function b(N,U,V,O){const W=O.values?O.values:[O];return(0,y.hash)({[O.normalized]:{values:W.map(X=>({value:X.normalized,expectContiguousMatch:X.expectContiguousMatch})),label:N,description:U,allowNonContiguousMatches:V}})}function i(N,U,V,O,W){if(!N||!U.normalized)return a;const j=O.getItemLabel(N);if(!j)return a;const X=O.getItemDescription(N),Q=b(j,X,V,U),de=W[Q];if(de)return de;const Se=t(j,X,O.getItemPath(N),U,V);return W[Q]=Se,Se}e.scoreItemFuzzy=i;function t(N,U,V,O,W){const j=!V||!O.containsPathSeparator;return V&&(n.isLinux?O.pathNormalized===V:(0,k.equalsIgnoreCase)(O.pathNormalized,V))?{score:r,labelMatch:[{start:0,end:N.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:O.values&&O.values.length>1?c(N,U,V,O.values,j,W):d(N,U,V,O,j,W)}function c(N,U,V,O,W,j){let X=0;const Q=[],de=[];for(const Se of O){const{score:De,labelMatch:Pe,descriptionMatch:Be}=d(N,U,V,Se,W,j);if(De===_)return a;X+=De,Pe&&Q.push(...Pe),Be&&de.push(...Be)}return{score:X,labelMatch:f(Q),descriptionMatch:f(de)}}function d(N,U,V,O,W,j){if(W||!U){const[X,Q]=P(N,O.normalized,O.normalizedLowercase,j&&!O.expectContiguousMatch);if(X){const de=(0,L.matchesPrefix)(O.normalized,N);let Se;return de?(Se=g,Se+=Math.round(O.normalized.length/N.length*100)):Se=s,{score:Se+X,labelMatch:de||o(Q)}}}if(U){let X=U;V&&(X=`${U}${C.sep}`);const Q=X.length,de=`${X}${N}`,[Se,De]=P(de,O.normalized,O.normalizedLowercase,j&&!O.expectContiguousMatch);if(Se){const Pe=o(De),Be=[],We=[];return Pe.forEach(He=>{He.start<Q&&He.end>Q?(Be.push({start:0,end:He.end-Q}),We.push({start:He.start,end:Q})):He.start>=Q?Be.push({start:He.start-Q,end:He.end-Q}):We.push(He)}),{score:Se,labelMatch:Be,descriptionMatch:We}}}return a}function o(N){const U=[];if(!N)return U;let V;for(const O of N)V&&V.end===O?V.end+=1:(V={start:O,end:O+1},U.push(V));return U}function f(N){const U=N.sort((W,j)=>W.start-j.start),V=[];let O;for(const W of U)!O||!u(O,W)?(O=W,V.push(W)):(O.start=Math.min(O.start,W.start),O.end=Math.max(O.end,W.end));return V}function u(N,U){return!(N.end<U.start||U.end<N.start)}function E(N,U,V,O,W,j){const X=i(N,V,O,W,j),Q=i(U,V,O,W,j),de=X.score,Se=Q.score;if((de===r||Se===r)&&de!==Se)return de===r?-1:1;if(de>s||Se>s){if(de!==Se)return de>Se?-1:1;if(de<g&&Se<g){const ee=R(X.labelMatch,Q.labelMatch);if(ee!==0)return ee}const He=W.getItemLabel(N)||"",G=W.getItemLabel(U)||"";if(He.length!==G.length)return He.length-G.length}if(de!==Se)return de>Se?-1:1;const De=Array.isArray(X.labelMatch)&&X.labelMatch.length>0,Pe=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(De&&!Pe)return-1;if(Pe&&!De)return 1;const Be=T(N,X,W),We=T(U,Q,W);return Be&&We&&Be!==We?We>Be?-1:1:B(N,U,V,W)}e.compareItemsByFuzzyScore=E;function T(N,U,V){let O=-1,W=-1;if(U.descriptionMatch&&U.descriptionMatch.length?O=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&(O=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(W=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const j=V.getItemDescription(N);j&&(W+=j.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(W=U.descriptionMatch[U.descriptionMatch.length-1].end);return W-O}function R(N,U){if(!N&&!U||(!N||!N.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!N||!N.length)return 1;const V=N[0].start,W=N[N.length-1].end-V,j=U[0].start,Q=U[U.length-1].end-j;return W===Q?0:Q<W?1:-1}function B(N,U,V,O){const W=O.getItemLabel(N)||"",j=O.getItemLabel(U)||"",X=O.getItemDescription(N),Q=O.getItemDescription(U),de=W.length+(X?X.length:0),Se=j.length+(Q?Q.length:0);if(de!==Se)return de-Se;const De=O.getItemPath(N),Pe=O.getItemPath(U);return De&&Pe&&De.length!==Pe.length?De.length-Pe.length:W!==j?(0,m.compareAnything)(W,j,V.normalized):X&&Q&&X!==Q?(0,m.compareAnything)(X,Q,V.normalized):De&&Pe&&De!==Pe?(0,m.compareAnything)(De,Pe,V.normalized):0}function x(N){return N.startsWith('"')&&N.endsWith('"')}const F=" ";function $(N){typeof N!="string"&&(N="");const U=N.toLowerCase(),{pathNormalized:V,normalized:O,normalizedLowercase:W}=M(N),j=V.indexOf(C.sep)>=0,X=x(N);let Q;const de=N.split(F);if(de.length>1)for(const Se of de){const De=x(Se),{pathNormalized:Pe,normalized:Be,normalizedLowercase:We}=M(Se);Be&&(Q||(Q=[]),Q.push({original:Se,originalLowercase:Se.toLowerCase(),pathNormalized:Pe,normalized:Be,normalizedLowercase:We,expectContiguousMatch:De}))}return{original:N,originalLowercase:U,pathNormalized:V,normalized:O,normalizedLowercase:W,values:Q,containsPathSeparator:j,expectContiguousMatch:X}}e.prepareQuery=$;function M(N){let U;n.isWindows?U=N.replace(/\//g,C.sep):U=N.replace(/\\/g,C.sep);const V=(0,k.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:V,normalizedLowercase:V.toLowerCase()}}function H(N){return Array.isArray(N)?$(N.map(U=>U.original).join(F)):$(N.original)}e.pieceToQuery=H}),define(fe[31],me([0,1,18,30,24,9,8]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const _="**",D="/",P="[/\\\\]",I="[^/\\\\]",l=/\//g;function v(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${P}|${I}+${P}|${P}${I}+)*?`}}function h(O,W){if(!O)return[];const j=[];let X=!1,Q=!1,de="";for(const Se of O){switch(Se){case W:if(!X&&!Q){j.push(de),de="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}de+=Se}return de&&j.push(de),j}e.splitGlobAware=h;function w(O){if(!O)return"";let W="";const j=h(O,D);if(j.every(X=>X===_))W=".*";else{let X=!1;j.forEach((Q,de)=>{if(Q===_){X||(W+=v(2),X=!0);return}let Se=!1,De="",Pe=!1,Be="";for(const We of Q){if(We!=="}"&&Se){De+=We;continue}if(Pe&&(We!=="]"||!Be)){let He;We==="-"?He=We:(We==="^"||We==="!")&&!Be?He="^":We===D?He="":He=n.escapeRegExpCharacters(We),Be+=He;continue}switch(We){case"{":Se=!0;continue;case"[":Pe=!0;continue;case"}":W+=`(?:${h(De,",").map(ee=>w(ee)).join("|")})`,Se=!1,De="";break;case"]":W+="["+Be+"]",Pe=!1,Be="";break;case"?":W+=I;continue;case"*":W+=v(1);continue;default:W+=n.escapeRegExpCharacters(We)}}de<j.length-1&&(j[de+1]!==_||de+2<j.length)&&(W+=P),X=!1})}return W}const S=/^\*\*\/\*\.[\w\.-]+$/,A=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,a=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new y.LRUCache(1e4),b=function(){return!1},i=function(){return null};function t(O,W){if(!O)return i;let j;typeof O!="string"?j=O.pattern:j=O,j=j.trim();const X=`${j}_${!!W.trimForExclusions}`;let Q=s.get(X);if(Q)return c(Q,O);let de;if(S.test(j)){const Se=j.substr(4);Q=function(De,Pe){return typeof De=="string"&&De.endsWith(Se)?j:null}}else(de=A.exec(d(j,W)))?Q=o(de[1],j):(W.trimForExclusions?a:p).test(j)?Q=f(j,W):(de=r.exec(d(j,W)))?Q=u(de[1].substr(1),j,!0):(de=g.exec(d(j,W)))?Q=u(de[1],j,!1):Q=E(j);return s.set(X,Q),c(Q,O)}function c(O,W){return typeof W=="string"?O:function(j,X){return L.isEqualOrParent(j,W.base)?O(C.relative(W.base,j),X):null}}function d(O,W){return W.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function o(O,W){const j=`/${O}`,X=`\\${O}`,Q=function(Se,De){return typeof Se!="string"?null:De?De===O?W:null:Se===O||Se.endsWith(j)||Se.endsWith(X)?W:null},de=[O];return Q.basenames=de,Q.patterns=[W],Q.allBasenames=de,Q}function f(O,W){const j=V(O.slice(1,-1).split(",").map(De=>t(De,W)).filter(De=>De!==i),O),X=j.length;if(!X)return i;if(X===1)return j[0];const Q=function(De,Pe){for(let Be=0,We=j.length;Be<We;Be++)if(j[Be](De,Pe))return O;return null},de=j.find(De=>!!De.allBasenames);de&&(Q.allBasenames=de.allBasenames);const Se=j.reduce((De,Pe)=>Pe.allPaths?De.concat(Pe.allPaths):De,[]);return Se.length&&(Q.allPaths=Se),Q}function u(O,W,j){const X=C.sep===C.posix.sep,Q=X?O:O.replace(l,C.sep),de=C.sep+Q,Se=C.posix.sep+O,De=j?function(Pe,Be){return typeof Pe=="string"&&(Pe===Q||Pe.endsWith(de)||!X&&(Pe===O||Pe.endsWith(Se)))?W:null}:function(Pe,Be){return typeof Pe=="string"&&(Pe===Q||!X&&Pe===O)?W:null};return De.allPaths=[(j?"*/":"./")+O],De}function E(O){try{const W=new RegExp(`^${w(O)}$`);return function(j){return W.lastIndex=0,typeof j=="string"&&W.test(j)?O:null}}catch(W){return i}}function T(O,W,j){return!O||typeof W!="string"?!1:R(O)(W,void 0,j)}e.match=T;function R(O,W={}){if(!O)return b;if(typeof O=="string"||$(O)){const j=t(O,W);if(j===i)return b;const X=function(Q,de){return!!j(Q,de)};return j.allBasenames&&(X.allBasenames=j.allBasenames),j.allPaths&&(X.allPaths=j.allPaths),X}return N(O,W)}e.parse=R;function B(O){if(!O)return;let W;return j=>(W||(W=(O()||Promise.resolve([])).then(X=>X?F(X):{})),W.then(X=>!!X[j]))}e.hasSiblingPromiseFn=B;function x(O){if(!O)return;let W;return j=>{if(!W){const X=O();W=X?F(X):{}}return!!W[j]}}e.hasSiblingFn=x;function F(O){const W={};for(const j of O)W[j]=!0;return W}function $(O){const W=O;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=$;function M(O){return O.allBasenames||[]}e.getBasenameTerms=M;function H(O){return O.allPaths||[]}e.getPathTerms=H;function N(O,W){const j=V(Object.getOwnPropertyNames(O).map(De=>U(De,O[De],W)).filter(De=>De!==i)),X=j.length;if(!X)return i;if(!j.some(De=>!!De.requiresSiblings)){if(X===1)return j[0];const De=function(We,He){for(let G=0,ee=j.length;G<ee;G++){const ne=j[G](We,He);if(ne)return ne}return null},Pe=j.find(We=>!!We.allBasenames);Pe&&(De.allBasenames=Pe.allBasenames);const Be=j.reduce((We,He)=>He.allPaths?We.concat(He.allPaths):We,[]);return Be.length&&(De.allPaths=Be),De}const Q=function(De,Pe,Be){let We;for(let He=0,G=j.length;He<G;He++){const ee=j[He];ee.requiresSiblings&&Be&&(Pe||(Pe=C.basename(De)),We||(We=Pe.substr(0,Pe.length-C.extname(De).length)));const ne=ee(De,Pe,We,Be);if(ne)return ne}return null},de=j.find(De=>!!De.allBasenames);de&&(Q.allBasenames=de.allBasenames);const Se=j.reduce((De,Pe)=>Pe.allPaths?De.concat(Pe.allPaths):De,[]);return Se.length&&(Q.allPaths=Se),Q}function U(O,W,j){if(W===!1)return i;const X=t(O,j);if(X===i)return i;if(typeof W=="boolean")return X;if(W){const Q=W.when;if(typeof Q=="string"){const de=(Se,De,Pe,Be)=>{if(!Be||!X(Se,De))return null;const We=Q.replace("$(basename)",Pe),He=Be(We);return(0,m.isThenable)(He)?He.then(G=>G?O:null):He?O:null};return de.requiresSiblings=!0,de}}return X}function V(O,W){const j=O.filter(De=>!!De.basenames);if(j.length<2)return O;const X=j.reduce((De,Pe)=>{const Be=Pe.basenames;return Be?De.concat(Be):De},[]);let Q;if(W){Q=[];for(let De=0,Pe=X.length;De<Pe;De++)Q.push(W)}else Q=j.reduce((De,Pe)=>{const Be=Pe.patterns;return Be?De.concat(Be):De},[]);const de=function(De,Pe){if(typeof De!="string")return null;if(!Pe){let We;for(We=De.length;We>0;We--){const He=De.charCodeAt(We-1);if(He===47||He===92)break}Pe=De.substr(We)}const Be=X.indexOf(Pe);return Be!==-1?Q[Be]:null};de.basenames=X,de.patterns=Q,de.allBasenames=X;const Se=O.filter(De=>!De.basenames);return Se.push(de),Se}}),define(fe[80],me([0,1,30,10,9,12,23,8,2]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function D(t,c,d){if(typeof t=="string"&&(t=_.URI.file(t)),d){const f=d.getWorkspaceFolder(t);if(f){const u=d.getWorkspace().folders.length>1;let E;if((0,n.isEqual)(f.uri,t)?E="":E=(0,n.relativePath)(f.uri,t),u){const T=f.name?f.name:(0,n.basename)(f.uri);E=E?T+" \u2022 "+E:T}return E}}if(t.scheme!==L.Schemas.file&&t.scheme!==L.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(t.fsPath))return(0,y.normalize)(I(t.fsPath));let o=(0,y.normalize)(t.fsPath);return!C.isWindows&&c?.userHome&&(o=v(o,c.userHome.fsPath)),o}e.getPathLabel=D;function P(t){if(!t)return;typeof t=="string"&&(t=_.URI.file(t));const c=(0,n.basename)(t)||(t.scheme===L.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(c)?I(c):c}e.getBaseLabel=P;function I(t,c){return(0,m.hasDriveLetter)(t,c)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=I;let l=Object.create(null);function v(t,c){if(C.isWindows||!t||!c)return t;let d=l.original===c?l.normalized:void 0;return d||(d=`${(0,k.rtrim)(c,y.posix.sep)}${y.posix.sep}`,l={original:c,normalized:d}),(C.isLinux?t.startsWith(d):(0,k.startsWithIgnoreCase)(t,d))&&(t=`~/${t.substr(d.length)}`),t}e.tildify=v;function h(t,c){return t.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=h;const w="\u2026",S="\\\\",A="~";function p(t,c=y.sep){const d=new Array(t.length);let o=!1;for(let f=0;f<t.length;f++){let u=t[f];if(u===""){d[f]=`.${c}`;continue}if(!u){d[f]=u;continue}o=!0;let E="";u.indexOf(S)===0?(E=u.substr(0,u.indexOf(S)+S.length),u=u.substr(u.indexOf(S)+S.length)):u.indexOf(c)===0?(E=u.substr(0,u.indexOf(c)+c.length),u=u.substr(u.indexOf(c)+c.length)):u.indexOf(A)===0&&(E=u.substr(0,u.indexOf(A)+A.length),u=u.substr(u.indexOf(A)+A.length));const T=u.split(c);for(let R=1;o&&R<=T.length;R++)for(let B=T.length-R;o&&B>=0;B--){o=!1;let x=T.slice(B,B+R).join(c);for(let F=0;!o&&F<t.length;F++)if(F!==f&&t[F]&&t[F].indexOf(x)>-1){const $=B+R===T.length,M=B>0&&t[F].indexOf(c)>-1?c+x:x,H=t[F].endsWith(M);o=!$||H}if(!o){let F="";(T[0].endsWith(":")||E!=="")&&(B===1&&(B=0,R++,x=T[0]+c+x),B>0&&(F=T[0]+c),F=E+F),B>0&&(F=F+w+c),F=F+x,B+R<T.length&&(F=F+c+w),d[f]=F}}o&&(d[f]=u)}return d}e.shorten=p;var a;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function r(t,c=Object.create(null)){const d=[];let o=!1,f="";for(const u of t)if(u==="$"||o&&u==="{")f&&d.push({value:f,type:a.TEXT}),f="",o=!0;else if(u==="}"&&o){const E=c[f];if(typeof E=="string")E.length&&d.push({value:E,type:a.VARIABLE});else if(E){const T=d[d.length-1];(!T||T.type!==a.SEPARATOR)&&d.push({value:E.label,type:a.SEPARATOR})}f="",o=!1}else f+=u;return f&&!o&&d.push({value:f,type:a.TEXT}),d.filter((u,E)=>{if(u.type===a.SEPARATOR){const T=d[E-1],R=d[E+1];return[T,R].every(B=>B&&(B.type===a.VARIABLE||B.type===a.TEXT)&&B.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=r;function g(t,c){return C.isMacintosh||c?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function s(t,c){return C.isMacintosh||c?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,d=>d==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function b(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=b;function i(t){const c=t.indexOf("/")!==-1?y.posix:y.win32,d=c.basename(t),o=c.dirname(t);return d.length?{name:d,parentPath:o}:{name:o,parentPath:""}}e.splitName=i}),define(fe[102],me([0,1,31,10,9,23,8]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let _=[],D=[],P=[];function I(t,c=!1){const d=l(t);_.push(d),d.userConfigured?P.push(d):D.push(d),c&&!d.userConfigured&&_.forEach(o=>{o.mime===d.mime||o.userConfigured||(d.extension&&o.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&o.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&o.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&o.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=I;function l(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,m.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(y.posix.sep)>=0:!1}}function v(t){t?(_=_.filter(c=>!c.userConfigured),P=[]):(_=[],D=[],P=[])}e.clearTextMimes=v;function h(t,c){let d;if(t)switch(t.scheme){case L.Schemas.file:d=t.fsPath;break;case L.Schemas.data:d=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break;default:d=t.path}if(!d)return[k.unknown];d=d.toLowerCase();const o=(0,y.basename)(d),f=w(d,o,P);if(f)return[f,k.text];const u=w(d,o,D);if(u)return[u,k.text];if(c){const E=S(c);if(E)return[E,k.text]}return[k.unknown]}e.guessMimeTypes=h;function w(t,c,d){let o=null,f=null,u=null;for(let E=d.length-1;E>=0;E--){const T=d[E];if(c===T.filenameLowercase){o=T;break}if(T.filepattern&&(!f||T.filepattern.length>f.filepattern.length)){const R=T.filepatternOnPath?t:c;T.filepatternLowercase?.(R)&&(f=T)}T.extension&&(!u||T.extension.length>u.extension.length)&&c.endsWith(T.extensionLowercase)&&(u=T)}return o?o.mime:f?f.mime:u?u.mime:null}function S(t){if((0,n.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let c=_.length-1;c>=0;c--){const d=_[c];if(!d.firstline)continue;const o=t.match(d.firstline);if(o&&o.length>0)return d.mime}return null}function A(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&A(t[0]):!0}e.isUnspecific=A;const p={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},a={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function r(t){const c=(0,y.extname)(t),d=p[c.toLowerCase()];return d!==void 0?d:g(t)}e.getMediaOrTextMime=r;function g(t){const c=(0,y.extname)(t);return a[c.toLowerCase()]}e.getMediaMime=g;function s(t){for(const c in a)if(a[c]===t)return c}e.getExtensionForMimeType=s;const b=/^(.+)\/(.+?)(;.+)?$/;function i(t,c){const d=b.exec(t);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:c?void 0:t}e.normalizeMimeType=i}),define(fe[103],me([0,1,2]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(P){return P.toJSON()}class y{constructor(I){this._uriTransformer=I}transformIncoming(I){const l=this._uriTransformer.transformIncoming(I);return l===I?I:L(m.URI.from(l))}transformOutgoing(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:L(m.URI.from(l))}transformOutgoingURI(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:m.URI.from(l)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function C(P,I,l){if(!P||l>200)return null;if(typeof P=="object"){if(P instanceof m.URI)return I.transformOutgoing(P);for(let v in P)if(Object.hasOwnProperty.call(P,v)){const h=C(P[v],I,l+1);h!==null&&(P[v]=h)}}return null}function n(P,I){const l=C(P,I,0);return l===null?P:l}e.transformOutgoingURIs=n;function k(P,I,l,v){if(!P||v>200)return null;if(typeof P=="object"){if(P.$mid===1)return l?m.URI.revive(I.transformIncoming(P)):I.transformIncoming(P);for(let h in P)if(Object.hasOwnProperty.call(P,h)){const w=k(P[h],I,l,v+1);w!==null&&(P[h]=w)}}return null}function _(P,I){const l=k(P,I,!1,0);return l===null?P:l}e.transformIncomingURIs=_;function D(P,I){const l=k(P,I,!0,0);return l===null?P:l}e.transformAndReviveIncomingURIs=D}),define(fe[32],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(_){return m.test(_)}e.isUUID=L;const y=new Uint8Array(16),C=[];for(let _=0;_<256;_++)C.push(_.toString(16).padStart(2,"0"));let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(_){for(let D=0;D<_.length;D++)_[D]=Math.floor(Math.random()*256);return _};function k(){n(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let _=0,D="";return D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D}e.generateUuid=k}),define(fe[142],me([0,1,104]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const n=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return n;let _=0,D,P=_;for(;P<k.length;)if(D=k.charCodeAt(P),D===13||D===10){if(n.push(k.substring(_,P)),P++,P<k.length){const I=D;D=k.charCodeAt(P),(I===13&&D===10||I===10&&D===13)&&P++}_=P}else P++;return this.remaining=_<k.length?k.substr(_):null,n}end(){return this.remaining}}e.LineDecoder=L}),define(fe[28],me([0,1,60,81,289,18,30,79,9,12,23,2,32]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function h(M,H=v.UNLINK){if((0,n.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return H===v.UNLINK?S(M):w(M)}async function w(M){try{const H=(0,_.join)((0,L.tmpdir)(),(0,l.generateUuid)());try{await e.Promises.rename(M,H)}catch(N){return S(M)}S(H).catch(N=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function S(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function A(M){if((0,n.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(M,{recursive:!0})}e.rimrafSync=A;async function p(M,H){return g(await(H?a(M):(0,y.promisify)(m.readdir)(M)))}async function a(M){try{return await(0,y.promisify)(m.readdir)(M,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const H=[],N=await p(M);for(const U of N){let V=!1,O=!1,W=!1;try{const j=await e.Promises.lstat((0,_.join)(M,U));V=j.isFile(),O=j.isDirectory(),W=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}H.push({name:U,isFile:()=>V,isDirectory:()=>O,isSymbolicLink:()=>W})}return H}function r(M){return g(m.readdirSync(M))}e.readdirSync=r;function g(M){return M.map(H=>typeof H=="string"?D.isMacintosh?(0,k.normalizeNFC)(H):H:(H.name=D.isMacintosh?(0,k.normalizeNFC)(H.name):H.name,H))}async function s(M){const H=await p(M),N=[];for(const U of H)await i.existsDirectory((0,_.join)(M,U))&&N.push(U);return N}function b(M,H=1e3){return new Promise(N=>{let U=!1;const V=setInterval(()=>{U||(U=!0,m.access(M,O=>{U=!1,O&&(clearInterval(V),N(void 0))}))},H)})}e.whenDeleted=b;var i;(function(M){async function H(V){let O;try{if(O=await e.Promises.lstat(V),!O.isSymbolicLink())return{stat:O}}catch(W){}try{return{stat:await e.Promises.stat(V),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw j}throw W}}M.stat=H;async function N(V){try{const{stat:O,symbolicLink:W}=await M.stat(V);return O.isFile()&&W?.dangling!==!0}catch(O){}return!1}M.existsFile=N;async function U(V){try{const{stat:O,symbolicLink:W}=await M.stat(V);return O.isDirectory()&&W?.dangling!==!0}catch(O){}return!1}M.existsDirectory=U})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new C.ResourceQueue;function c(M,H,N){return t.queueFor(I.URI.file(M),P.extUriBiasedIgnorePathCase).queue(()=>{const U=u(N);return new Promise((V,O)=>o(M,H,U,W=>W?O(W):V()))})}let d=!0;function o(M,H,N,U){if(!d)return m.writeFile(M,H,{mode:N.mode,flag:N.flag},U);m.open(M,N.flag,N.mode,(V,O)=>{if(V)return U(V);m.writeFile(O,H,W=>{if(W)return m.close(O,()=>U(W));m.fdatasync(O,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),d=!1),m.close(O,X=>U(X))))})})}function f(M,H,N){const U=u(N);if(!d)return m.writeFileSync(M,H,{mode:U.mode,flag:U.flag});const V=m.openSync(M,U.flag,U.mode);try{m.writeFileSync(V,H);try{m.fdatasyncSync(V)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),d=!1}}finally{m.closeSync(V)}}e.writeFileSync=f;function u(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function E(M,H){if(M===H)return;async function N(U){try{const V=await e.Promises.lstat(U);if(V.isDirectory()||V.isSymbolicLink())return;await e.Promises.utimes(U,V.atime,new Date)}catch(V){}}try{await e.Promises.rename(M,H),await N(H)}catch(U){if(M.toLowerCase()!==H.toLowerCase()&&U.code==="EXDEV"||M.endsWith("."))await T(M,H,{preserveSymlinks:!1}),await h(M,v.MOVE),await N(H);else throw U}}async function T(M,H,N){return B(M,H,{root:{source:M,target:H},options:N,handledSourcePaths:new Set})}const R=511;async function B(M,H,N){if(N.handledSourcePaths.has(M))return;N.handledSourcePaths.add(M);const{stat:U,symbolicLink:V}=await i.stat(M);if(V){if(N.options.preserveSymlinks)try{return await $(M,H,N)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(V.dangling)return}return U.isDirectory()?x(M,H,U.mode&R,N):F(M,H,U.mode&R)}async function x(M,H,N,U){await e.Promises.mkdir(H,{recursive:!0,mode:N});const V=await p(M);for(const O of V)await B((0,_.join)(M,O),(0,_.join)(H,O),U)}async function F(M,H,N){await e.Promises.copyFile(M,H),await e.Promises.chmod(H,N)}async function $(M,H,N){let U=await e.Promises.readlink(M);(0,n.isEqualOrParent)(U,N.root.source,!D.isLinux)&&(U=(0,_.join)(N.root.target,U.substr(N.root.source.length+1))),await e.Promises.symlink(U,H)}e.Promises=new class{get access(){return(0,y.promisify)(m.access)}get stat(){return(0,y.promisify)(m.stat)}get lstat(){return(0,y.promisify)(m.lstat)}get utimes(){return(0,y.promisify)(m.utimes)}get read(){return(0,y.promisify)(m.read)}get readFile(){return(0,y.promisify)(m.readFile)}get write(){return(0,y.promisify)(m.write)}get appendFile(){return(0,y.promisify)(m.appendFile)}get fdatasync(){return(0,y.promisify)(m.fdatasync)}get truncate(){return(0,y.promisify)(m.truncate)}get rename(){return(0,y.promisify)(m.rename)}get copyFile(){return(0,y.promisify)(m.copyFile)}get open(){return(0,y.promisify)(m.open)}get close(){return(0,y.promisify)(m.close)}get symlink(){return(0,y.promisify)(m.symlink)}get readlink(){return(0,y.promisify)(m.readlink)}get chmod(){return(0,y.promisify)(m.chmod)}get mkdir(){return(0,y.promisify)(m.mkdir)}get unlink(){return(0,y.promisify)(m.unlink)}get rmdir(){return(0,y.promisify)(m.rmdir)}get realpath(){return(0,y.promisify)(m.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return s}get writeFile(){return c}get rm(){return h}get move(){return E}get copy(){return T}}}),define(fe[105],me([0,1,60,9,8,28]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(P){const I=(0,L.dirname)(P);if(P===I)return P;const l=((0,L.basename)(P)||P).toLowerCase();try{const h=(0,C.readdirSync)(I).filter(w=>w.toLowerCase()===l);if(h.length===1){const w=n(I);if(w)return(0,L.join)(w,h[0])}else if(h.length>1){const w=h.indexOf(l);if(w>=0){const S=n(I);if(S)return(0,L.join)(S,h[w])}}}catch(v){}return null}e.realcaseSync=n;async function k(P){try{return await C.Promises.realpath(P)}catch(I){const l=D(P);return await C.Promises.access(l,m.constants.R_OK),l}}e.realpath=k;function _(P){try{return m.realpathSync(P)}catch(I){const l=D(P);return m.accessSync(l,m.constants.R_OK),l}}e.realpathSync=_;function D(P){return(0,y.rtrim)((0,L.normalize)(P),L.sep)}});var Ve=this&&this.__decorate||function(Y,e,m,L){var y=arguments.length,C=y<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,m):L,n;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,m,L);else for(var k=Y.length-1;k>=0;k--)(n=Y[k])&&(C=(y<3?n(C):y>3?n(e,m,C):n(e,m))||C);return y>3&&C&&Object.defineProperty(e,m,C),C};define(fe[106],me([0,1,17,18,22,21,57,16,3,6,59,8,13]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function S(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var A;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(A||(A={}));class p{constructor(O){this.buffer=O,this.pos=0}read(O){const W=this.buffer.slice(this.pos,this.pos+O);return this.pos+=W.byteLength,W}}class a{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var r;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(r||(r={}));function g(V){const O=y.VSBuffer.alloc(4);return O.writeUInt32BE(V,0),O}function s(V){return V.read(4).readUInt32BE(0)}function b(V){const O=y.VSBuffer.alloc(1);return O.writeUInt8(V,0),O}const i={Undefined:b(r.Undefined),String:b(r.String),Buffer:b(r.Buffer),VSBuffer:b(r.VSBuffer),Array:b(r.Array),Object:b(r.Object)},t=typeof Buffer!="undefined";function c(V,O){if(typeof O=="undefined")V.write(i.Undefined);else if(typeof O=="string"){const W=y.VSBuffer.fromString(O);V.write(i.String),V.write(g(W.byteLength)),V.write(W)}else if(t&&Buffer.isBuffer(O)){const W=y.VSBuffer.wrap(O);V.write(i.Buffer),V.write(g(W.byteLength)),V.write(W)}else if(O instanceof y.VSBuffer)V.write(i.VSBuffer),V.write(g(O.byteLength)),V.write(O);else if(Array.isArray(O)){V.write(i.Array),V.write(g(O.length));for(const W of O)c(V,W)}else{const W=y.VSBuffer.fromString(JSON.stringify(O));V.write(i.Object),V.write(g(W.byteLength)),V.write(W)}}function d(V){switch(V.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return V.read(s(V)).toString();case r.Buffer:return V.read(s(V)).buffer;case r.VSBuffer:return V.read(s(V));case r.Array:{const W=s(V),j=[];for(let X=0;X<W;X++)j.push(d(V));return j}case r.Object:return JSON.parse(V.read(s(V)).toString())}}class o{constructor(O,W,j=null,X=1e3){this.protocol=O,this.ctx=W,this.logger=j,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(O,W){this.channels.set(O,W),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const W=this.send([O.type]);this.logger&&this.logger.logOutgoing(W,0,1,S(O.type));return}case 201:case 202:case 204:case 203:{const W=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(W,O.id,1,S(O.type),O.data);return}}}send(O,W=void 0){const j=new a;return c(j,O),c(j,W),this.sendBuffer(j.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(W){return 0}}onRawMessage(O){const W=new p(O),j=d(W),X=d(W),Q=j[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${h(Q)}: ${j[2]}.${j[3]}`,X),this.onPromise({type:Q,id:j[1],channelName:j[2],name:j[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${h(Q)}: ${j[2]}.${j[3]}`,X),this.onEventListen({type:Q,id:j[1],channelName:j[2],name:j[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:j[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:j[1]})}}onPromise(O){const W=this.channels.get(O.channelName);if(!W){this.collectPendingRequest(O);return}const j=new C.CancellationTokenSource;let X;try{X=W.call(this.ctx,O.name,O.arg,j.token)}catch(Se){X=Promise.reject(Se)}const Q=O.id;X.then(Se=>{this.sendResponse({id:Q,data:Se,type:201}),this.activeRequests.delete(O.id)},Se=>{Se instanceof Error?this.sendResponse({id:Q,data:{message:Se.message,name:Se.name,stack:Se.stack?Se.stack.split?Se.stack.split(`
`):Se.stack:void 0},type:202}):this.sendResponse({id:Q,data:Se,type:203}),this.activeRequests.delete(O.id)});const de=(0,D.toDisposable)(()=>j.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const W=this.channels.get(O.channelName);if(!W){this.collectPendingRequest(O);return}const j=O.id,Q=W.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:j,data:de,type:204}));this.activeRequests.set(O.id,Q)}disposeActiveRequest(O){const W=this.activeRequests.get(O.id);W&&(W.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let W=this.pendingRequests.get(O.channelName);W||(W=[],this.pendingRequests.set(O.channelName,W));const j=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:O,timeoutTimer:j})}flushPendingRequests(O){const W=this.pendingRequests.get(O);if(W){for(const j of W)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=o;var f;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(O,W=null){this.protocol=O,this.isDisposed=!1,this.state=A.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=W}getChannel(O){const W=this;return{call(j,X,Q){return W.isDisposed?Promise.reject(k.canceled()):W.requestPromise(O,j,X,Q)},listen(j,X){return W.isDisposed?Promise.reject(k.canceled()):W.requestEvent(O,j,X)}}}requestPromise(O,W,j,X=C.CancellationToken.None){const Q=this.lastRequestId++,Se={id:Q,type:100,channelName:O,name:W,arg:j};if(X.isCancellationRequested)return Promise.reject(k.canceled());let De;return new Promise((Be,We)=>{if(X.isCancellationRequested)return We(k.canceled());const He=()=>{const ce=Z=>{switch(Z.type){case 201:this.handlers.delete(Q),Be(Z.data);break;case 202:this.handlers.delete(Q);const re=new Error(Z.data.message);re.stack=Z.data.stack,re.name=Z.data.name,We(re);break;case 203:this.handlers.delete(Q),We(Z.data);break}};this.handlers.set(Q,ce),this.sendRequest(Se)};let G=null;this.state===A.Idle?He():(G=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),G.then(()=>{G=null,He()}));const ee=()=>{G?(G.cancel(),G=null):this.sendRequest({id:Q,type:101}),We(k.canceled())},ne=X.onCancellationRequested(ee);De=(0,D.combinedDisposable)((0,D.toDisposable)(ee),ne),this.activeRequests.add(De)}).finally(()=>{this.activeRequests.delete(De)})}requestEvent(O,W,j){const X=this.lastRequestId++,de={id:X,type:102,channelName:O,name:W,arg:j};let Se=null;const De=new _.Emitter({onFirstListenerAdd:()=>{Se=(0,L.createCancelablePromise)(Be=>this.whenInitialized()),Se.then(()=>{Se=null,this.activeRequests.add(De),this.sendRequest(de)})},onLastListenerRemove:()=>{Se?(Se.cancel(),Se=null):(this.activeRequests.delete(De),this.sendRequest({id:X,type:103}))}}),Pe=Be=>De.fire(Be.data);return this.handlers.set(X,Pe),De.event}sendRequest(O){switch(O.type){case 100:case 102:{const W=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(W,O.id,0,`${h(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const W=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(W,O.id,0,h(O.type));return}}}send(O,W=void 0){const j=new a;return c(j,O),c(j,W),this.sendBuffer(j.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(W){return 0}}onBuffer(O){const W=new p(O),j=d(W),X=d(W),Q=j[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,S(Q)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],0,S(Q),X),this.onResponse({type:j[0],id:j[1],data:X})}}onResponse(O){if(O.type===200){this.state=A.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(O.id);W&&W(O)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===A.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([n.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class E{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:W,onDidClientDisconnect:j})=>{_.Event.once(W.onMessage)(Q=>{const de=new p(Q),Se=d(de),De=new o(W,Se),Pe=new u(W);this.channels.forEach((We,He)=>De.registerChannel(He,We));const Be={channelServer:De,channelClient:Pe,ctx:Se};this._connections.add(Be),this._onDidAddConnection.fire(Be),j(()=>{De.dispose(),Pe.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const O=[];return this._connections.forEach(W=>O.push(W)),O}getChannel(O,W){const j=this;return{call(X,Q,de){let Se;if((0,l.isFunction)(W)){let Pe=(0,m.getRandomElement)(j.connections.filter(W));Se=Pe?Promise.resolve(Pe):_.Event.toPromise(_.Event.filter(j.onDidAddConnection,W))}else Se=W.routeCall(j,X,Q);const De=Se.then(Pe=>Pe.channelClient.getChannel(O));return R(De).call(X,Q,de)},listen(X,Q){if((0,l.isFunction)(W))return j.getMulticastEvent(O,W,X,Q);const de=W.routeEvent(j,X,Q).then(Se=>Se.channelClient.getChannel(O));return R(de).listen(X,Q)}}}getMulticastEvent(O,W,j,X){const Q=this;let de=new D.DisposableStore;const Se=new _.Emitter({onFirstListenerAdd:()=>{de=new D.DisposableStore;const De=new _.EventMultiplexer,Pe=new Map,Be=He=>{const ee=He.channelClient.getChannel(O).listen(j,X),ne=De.add(ee);Pe.set(He,ne)},We=He=>{const G=Pe.get(He);!G||(G.dispose(),Pe.delete(He))};Q.connections.filter(W).forEach(Be),_.Event.filter(Q.onDidAddConnection,W)(Be,void 0,de),Q.onDidRemoveConnection(We,void 0,de),De.event(Se.fire,Se,de),de.add(De)},onLastListenerRemove:()=>{de.dispose()}});return Se.event}registerChannel(O,W){this.channels.set(O,W),this._connections.forEach(j=>{j.channelServer.registerChannel(O,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=E;class T{constructor(O,W,j=null){const X=new a;c(X,W),O.send(X.buffer),this.channelClient=new u(O,j),this.channelServer=new o(O,W,j)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,W){this.channelServer.registerChannel(O,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function R(V){return{call(O,W,j){return V.then(X=>X.call(O,W,j))},listen(O,W){const j=new _.Relay;return V.then(X=>j.input=X.listen(O,W)),j.event}}}e.getDelayedChannel=R;function B(V){let O=!1;return{call(W,j,X){return O?V.call(W,j,X):(0,L.timeout)(0).then(()=>O=!0).then(()=>V.call(W,j,X))},listen(W,j){if(O)return V.listen(W,j);const X=new _.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>X.input=V.listen(W,j)),X.event}}}e.getNextTickChannel=B;class x{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const W of O.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await _.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=x;var F;(function(V){function O(Q,de){const Se=Q,De=de&&de.disableMarshalling,Pe=new Map;for(const Be in Se)j(Be)&&Pe.set(Be,_.Event.buffer(Se[Be],!0));return new class{listen(Be,We,He){const G=Pe.get(We);if(G)return G;if(X(We)){const ee=Se[We];if(typeof ee=="function")return ee.call(Se,He)}throw new Error(`Event not found: ${We}`)}call(Be,We,He){const G=Se[We];if(typeof G=="function"){if(!De&&Array.isArray(He))for(let ee=0;ee<He.length;ee++)He[ee]=(0,P.revive)(He[ee]);return G.apply(Se,He)}throw new Error(`Method not found: ${We}`)}}}V.fromService=O;function W(Q,de){const Se=de&&de.disableMarshalling;return new Proxy({},{get(De,Pe){if(typeof Pe=="string")return de?.properties?.has(Pe)?de.properties.get(Pe):X(Pe)?function(Be){return Q.listen(Pe,Be)}:j(Pe)?Q.listen(Pe):async function(...Be){let We;de&&!(0,l.isUndefinedOrNull)(de.context)?We=[de.context,...Be]:We=Be;const He=await Q.call(Pe,We);return Se?He:(0,P.revive)(He)};throw new Error(`Property not found: ${String(Pe)}`)}})}V.toService=W;function j(Q){return Q[0]==="o"&&Q[1]==="n"&&I.isUpperAsciiLetter(Q.charCodeAt(2))}function X(Q){return/^onDynamic/.test(Q)&&I.isUpperAsciiLetter(Q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let O=V.toString();if(O!=="[object Object]")return O}return V}function H(V){return Array.isArray(V)?V.map(M):M(V)}function N(V,O,W,j,X,Q,de){de=H(de);const Se=$[X],De=Se[j%Se.length];let Pe=[`%c[${V}]%c[${String(O).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${De}`];/\($/.test(Q)?(Pe=Pe.concat(de),Pe.push(")")):Pe.push(de),console.log.apply(console,Pe)}e.logWithColors=N;class U{constructor(O,W){this._outgoingPrefix=O,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,W,j,X,Q){this._totalOutgoing+=O,N(this._outgoingPrefix,this._totalOutgoing,O,W,j,X,Q)}logIncoming(O,W,j,X,Q){this._totalIncoming+=O,N(this._incomingPrefix,this._totalIncoming,O,W,j,X,Q)}}e.IPCLogger=U}),define(fe[107],me([0,1,22,3,6,12,37,106]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var _;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function P(){return D||(D=m.VSBuffer.alloc(0)),D}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,c){if(t===0)return P();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const u=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=t),u}if(this._chunks[0].byteLength>t){const u=this._chunks[0].slice(0,t);return c&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),u}let d=m.VSBuffer.alloc(t),o=0,f=0;for(;t>0;){const u=this._chunks[f];if(u.byteLength>t){const E=u.slice(0,t);d.set(E,o),o+=t,c&&(this._chunks[f]=u.slice(t),this._totalLength-=t),t-=t}else d.set(u,o),o+=u.byteLength,c?(this._chunks.shift(),this._totalLength-=u.byteLength):f++,t-=u.byteLength}return d}}e.ChunkStream=I;var l;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(l||(l={}));var v;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(t,c,d,o){this.type=t,this.id=c,this.ack=d,this.data=o,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends y.Disposable{constructor(t){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5);else{const d=this._state.messageType,o=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(d,o,f,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=m.VSBuffer.alloc(13);c.writeUInt8(t.type,0),c.writeUInt32BE(t.id,1),c.writeUInt32BE(t.ack,5),c.writeUInt32BE(t.data.byteLength,9),this._writeSoon(c,t.data)}_bufferAdd(t,c){const d=this._totalLength===0;return this._data.push(t,c),this._totalLength+=t.byteLength+c.byteLength,d}_bufferTake(){const t=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,c){this._bufferAdd(t,c)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class A extends y.Disposable{constructor(t){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new h(1,0,0,t))}}e.Protocol=A;class p extends k.IPCClient{constructor(t,c,d=null){super(t,c,d);this.protocol=t}static fromSocket(t,c){return new p(new A(t),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=p;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class r{constructor(t){this.data=t,this.next=null}}class g{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],c=0,d=this._first;for(;d;)t[c++]=d.data,d=d.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const c=new r(t);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class s{constructor(){this.lastRuns=[];const t=Date.now();for(let c=0;c<s._HISTORY_LENGTH;c++)this.lastRuns[c]=t-1e3*c;setInterval(()=>{for(let c=s._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const t=Date.now(),c=(1+s._HISTORY_LENGTH)*1e3;let d=0;for(let o=0;o<s._HISTORY_LENGTH;o++)t-this.lastRuns[o]<=c&&d++;return 1-d/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class b{constructor(t,c=null,d=s.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=d,this._isReconnecting=!1,this._outgoingUnackMsg=new g,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),c&&this._socketReader.acceptChunk(c),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new h(5,0,0,P());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const c=new h(4,0,0,P());this._socketWriter.write(c),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,c){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let c=0,d=t.length;c<d;c++)this._socketWriter.write(t[c]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new h(6,0,0,P())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const c=this._outgoingUnackMsg.toArray();for(let d=0,o=c.length;d<o;d++)this._socketWriter.write(c[d]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new h(1,c,this._incomingAckId,t);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(t){const c=new h(2,0,0,t);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),c=Date.now()-t.writtenTime;if(c>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-c,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new h(3,0,this._incomingAckId,P());this._socketWriter.write(t)}}e.PersistentProtocol=b}),define(fe[108],me([0,1,99]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(k){let _=(0,m.toUint8)(k);this._defaultValue=_,this._asciiMap=L._createAsciiMap(_),this._map=new Map}static _createAsciiMap(k){let _=new Uint8Array(256);for(let D=0;D<256;D++)_[D]=k;return _}set(k,_){let D=(0,m.toUint8)(_);k>=0&&k<256?this._asciiMap[k]=D:this._map.set(k,D)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=L;var y;(function(n){n[n.False=0]="False",n[n.True=1]="True"})(y||(y={}));class C{constructor(){this._actual=new L(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(fe[143],me([0,1,108]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(n){n[n.Regular=0]="Regular",n[n.Whitespace=1]="Whitespace",n[n.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class y extends m.CharacterClassifier{constructor(k){super(0);for(let _=0,D=k.length;_<D;_++)this.set(k.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function C(n){let k={};return _=>(k.hasOwnProperty(_)||(k[_]=n(_)),k[_])}e.getMapForWordSeparators=C(n=>new y(n))}),define(fe[50],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(y,C){this.lineNumber=y,this.column=C}with(y=this.lineNumber,C=this.column){return y===this.lineNumber&&C===this.column?this:new m(y,C)}delta(y=0,C=0){return this.with(this.lineNumber+y,this.column+C)}equals(y){return m.equals(this,y)}static equals(y,C){return!y&&!C?!0:!!y&&!!C&&y.lineNumber===C.lineNumber&&y.column===C.column}isBefore(y){return m.isBefore(this,y)}static isBefore(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<C.column}isBeforeOrEqual(y){return m.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<=C.column}static compare(y,C){let n=y.lineNumber|0,k=C.lineNumber|0;if(n===k){let _=y.column|0,D=C.column|0;return _-D}return n-k}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new m(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=m}),define(fe[41],me([0,1,50]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,n,k,_){C>k||C===k&&n>_?(this.startLineNumber=k,this.startColumn=_,this.endLineNumber=C,this.endColumn=n):(this.startLineNumber=C,this.startColumn=n,this.endLineNumber=k,this.endColumn=_)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,n){return!(n.lineNumber<C.startLineNumber||n.lineNumber>C.endLineNumber||n.lineNumber===C.startLineNumber&&n.column<C.startColumn||n.lineNumber===C.endLineNumber&&n.column>C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,n){return!(n.startLineNumber<C.startLineNumber||n.endLineNumber<C.startLineNumber||n.startLineNumber>C.endLineNumber||n.endLineNumber>C.endLineNumber||n.startLineNumber===C.startLineNumber&&n.startColumn<C.startColumn||n.endLineNumber===C.endLineNumber&&n.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,n){return!(n.startLineNumber<C.startLineNumber||n.endLineNumber<C.startLineNumber||n.startLineNumber>C.endLineNumber||n.endLineNumber>C.endLineNumber||n.startLineNumber===C.startLineNumber&&n.startColumn<=C.startColumn||n.endLineNumber===C.endLineNumber&&n.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,n){let k,_,D,P;return n.startLineNumber<C.startLineNumber?(k=n.startLineNumber,_=n.startColumn):n.startLineNumber===C.startLineNumber?(k=n.startLineNumber,_=Math.min(n.startColumn,C.startColumn)):(k=C.startLineNumber,_=C.startColumn),n.endLineNumber>C.endLineNumber?(D=n.endLineNumber,P=n.endColumn):n.endLineNumber===C.endLineNumber?(D=n.endLineNumber,P=Math.max(n.endColumn,C.endColumn)):(D=C.endLineNumber,P=C.endColumn),new L(k,_,D,P)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,n){let k=C.startLineNumber,_=C.startColumn,D=C.endLineNumber,P=C.endColumn,I=n.startLineNumber,l=n.startColumn,v=n.endLineNumber,h=n.endColumn;return k<I?(k=I,_=l):k===I&&(_=Math.max(_,l)),D>v?(D=v,P=h):D===v&&(P=Math.min(P,h)),k>D||k===D&&_>P?null:new L(k,_,D,P)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,n){return!!C&&!!n&&C.startLineNumber===n.startLineNumber&&C.startColumn===n.startColumn&&C.endLineNumber===n.endLineNumber&&C.endColumn===n.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,n){return new L(this.startLineNumber,this.startColumn,C,n)}setStartPosition(C,n){return new L(C,n,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,n=C){return new L(C.lineNumber,C.column,n.lineNumber,n.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,n){return!(C.endLineNumber<n.startLineNumber||C.endLineNumber===n.startLineNumber&&C.endColumn<n.startColumn||n.endLineNumber<C.startLineNumber||n.endLineNumber===C.startLineNumber&&n.endColumn<C.startColumn)}static areIntersecting(C,n){return!(C.endLineNumber<n.startLineNumber||C.endLineNumber===n.startLineNumber&&C.endColumn<=n.startColumn||n.endLineNumber<C.startLineNumber||n.endLineNumber===C.startLineNumber&&n.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,n){if(C&&n){const D=C.startLineNumber|0,P=n.startLineNumber|0;if(D===P){const I=C.startColumn|0,l=n.startColumn|0;if(I===l){const v=C.endLineNumber|0,h=n.endLineNumber|0;if(v===h){const w=C.endColumn|0,S=n.endColumn|0;return w-S}return v-h}return I-l}return D-P}return(C?1:0)-(n?1:0)}static compareRangesUsingEnds(C,n){return C.endLineNumber===n.endLineNumber?C.endColumn===n.endColumn?C.startLineNumber===n.startLineNumber?C.startColumn-n.startColumn:C.startLineNumber-n.startLineNumber:C.endColumn-n.endColumn:C.endLineNumber-n.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(fe[144],me([0,1,50,41]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(y=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(k,_,D,P){super(k,_,D,P);this.selectionStartLineNumber=k,this.selectionStartColumn=_,this.positionLineNumber=D,this.positionColumn=P}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,_){return k.selectionStartLineNumber===_.selectionStartLineNumber&&k.selectionStartColumn===_.selectionStartColumn&&k.positionLineNumber===_.positionLineNumber&&k.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,_){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,_):new C(k,_,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new m.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,_){return this.getDirection()===0?new C(k,_,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,_)}static fromPositions(k,_=k){return new C(k.lineNumber,k.column,_.lineNumber,_.column)}static fromRange(k,_){return _===0?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new C(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,_){if(k&&!_||!k&&_)return!1;if(!k&&!_)return!0;if(k.length!==_.length)return!1;for(let D=0,P=k.length;D<P;D++)if(!this.selectionsEqual(k[D],_[D]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,_,D,P,I){return I===0?new C(k,_,D,P):new C(D,P,k,_)}}e.Selection=C}),define(fe[109],me([0,1,25]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var n;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(n=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace),this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class D{constructor(a,r){this._findMatchBrand=void 0,this.range=a,this.matches=r}}e.FindMatch=D;var P;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(p){p[p.Disabled=0]="Disabled",p[p.EnabledForActive=1]="EnabledForActive",p[p.Enabled=2]="Enabled"})(I=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class l{constructor(a,r,g){this.visibleColumn=a,this.className=r,this.horizontalLine=g}}e.IndentGuide=l;class v{constructor(a,r){this.top=a,this.endColumn=r}}e.IndentGuideHorizontalLine=v;var h;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(h=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class S{constructor(a,r,g,s,b,i){this.identifier=a,this.range=r,this.text=g,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=b,this._isTracked=i}}e.ValidAnnotatedEditOperation=S;class A{constructor(a,r,g){this.reverseEdits=a,this.changes=r,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=A}),define(fe[145],me([0,1,8,143,50,41,109]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class _{constructor(a,r,g,s){this.searchString=a,this.isRegex=r,this.matchCase=g,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let a;this.isRegex?a=D(this.searchString):a=this.searchString.indexOf(`
`)>=0;let r=null;try{r=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:a,global:!0,unicode:!0})}catch(s){return null}if(!r)return null;let g=!this.isRegex&&!a;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new P(r,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=_;function D(p){if(!p||p.length===0)return!1;for(let a=0,r=p.length;a<r;a++)if(p.charCodeAt(a)===92){if(a++,a>=r)break;const s=p.charCodeAt(a);if(s===110||s===114||s===87)return!0}return!1}e.isMultilineRegexSource=D;class P{constructor(a,r,g){this.regex=a,this.wordSeparators=r,this.simpleSearch=g}}e.SearchData=P;function I(p,a,r){if(!r)return new n.FindMatch(p,null);let g=[];for(let s=0,b=a.length;s<b;s++)g[s]=a[s];return new n.FindMatch(p,g)}e.createFindMatch=I;class l{constructor(a){let r=[],g=0;for(let s=0,b=a.length;s<b;s++)a.charCodeAt(s)===10&&(r[g++]=s);this._lineFeedsOffsets=r}findLineFeedCountBeforeOffset(a){const r=this._lineFeedsOffsets;let g=0,s=r.length-1;if(s===-1||a<=r[0])return 0;for(;g<s;){const b=g+((s-g)/2>>0);r[b]>=a?s=b-1:r[b+1]>=a?(g=b,s=b):g=b+1}return g+1}}class v{static findMatches(a,r,g,s,b){const i=r.parseSearchRequest();return i?i.regex.multiline?this._doFindMatchesMultiline(a,g,new A(i.wordSeparators,i.regex),s,b):this._doFindMatchesLineByLine(a,g,i,s,b):[]}static _getMultilineMatchRange(a,r,g,s,b,i){let t,c=0;s?(c=s.findLineFeedCountBeforeOffset(b),t=r+b+c):t=r+b;let d;if(s){let E=s.findLineFeedCountBeforeOffset(b+i.length)-c;d=t+i.length+E}else d=t+i.length;const o=a.getPositionAt(t),f=a.getPositionAt(d);return new C.Range(o.lineNumber,o.column,f.lineNumber,f.column)}static _doFindMatchesMultiline(a,r,g,s,b){const i=a.getOffsetAt(r.getStartPosition()),t=a.getValueInRange(r,1),c=a.getEOL()===`\r
`?new l(t):null,d=[];let o=0,f;for(g.reset(0);f=g.next(t);)if(d[o++]=I(this._getMultilineMatchRange(a,i,t,c,f.index,f[0]),f,s),o>=b)return d;return d}static _doFindMatchesLineByLine(a,r,g,s,b){const i=[];let t=0;if(r.startLineNumber===r.endLineNumber){const d=a.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return t=this._findMatchesInLine(g,d,r.startLineNumber,r.startColumn-1,t,i,s,b),i}const c=a.getLineContent(r.startLineNumber).substring(r.startColumn-1);t=this._findMatchesInLine(g,c,r.startLineNumber,r.startColumn-1,t,i,s,b);for(let d=r.startLineNumber+1;d<r.endLineNumber&&t<b;d++)t=this._findMatchesInLine(g,a.getLineContent(d),d,0,t,i,s,b);if(t<b){const d=a.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);t=this._findMatchesInLine(g,d,r.endLineNumber,0,t,i,s,b)}return i}static _findMatchesInLine(a,r,g,s,b,i,t,c){const d=a.wordSeparators;if(!t&&a.simpleSearch){const u=a.simpleSearch,E=u.length,T=r.length;let R=-E;for(;(R=r.indexOf(u,R+E))!==-1;)if((!d||S(d,r,T,R,E))&&(i[b++]=new n.FindMatch(new C.Range(g,R+1+s,g,R+1+E+s),null),b>=c))return b;return b}const o=new A(a.wordSeparators,a.regex);let f;o.reset(0);do if(f=o.next(r),f&&(i[b++]=I(new C.Range(g,f.index+1+s,g,f.index+1+f[0].length+s),f,t),b>=c))return b;while(f);return b}static findNextMatch(a,r,g,s){const b=r.parseSearchRequest();if(!b)return null;const i=new A(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindNextMatchMultiline(a,g,i,s):this._doFindNextMatchLineByLine(a,g,i,s)}static _doFindNextMatchMultiline(a,r,g,s){const b=new y.Position(r.lineNumber,1),i=a.getOffsetAt(b),t=a.getLineCount(),c=a.getValueInRange(new C.Range(b.lineNumber,b.column,t,a.getLineMaxColumn(t)),1),d=a.getEOL()===`\r
`?new l(c):null;g.reset(r.column-1);let o=g.next(c);return o?I(this._getMultilineMatchRange(a,i,c,d,o.index,o[0]),o,s):r.lineNumber!==1||r.column!==1?this._doFindNextMatchMultiline(a,new y.Position(1,1),g,s):null}static _doFindNextMatchLineByLine(a,r,g,s){const b=a.getLineCount(),i=r.lineNumber,t=a.getLineContent(i),c=this._findFirstMatchInLine(g,t,i,r.column,s);if(c)return c;for(let d=1;d<=b;d++){const o=(i+d-1)%b,f=a.getLineContent(o+1),u=this._findFirstMatchInLine(g,f,o+1,1,s);if(u)return u}return null}static _findFirstMatchInLine(a,r,g,s,b){a.reset(s-1);const i=a.next(r);return i?I(new C.Range(g,i.index+1,g,i.index+1+i[0].length),i,b):null}static findPreviousMatch(a,r,g,s){const b=r.parseSearchRequest();if(!b)return null;const i=new A(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindPreviousMatchMultiline(a,g,i,s):this._doFindPreviousMatchLineByLine(a,g,i,s)}static _doFindPreviousMatchMultiline(a,r,g,s){const b=this._doFindMatchesMultiline(a,new C.Range(1,1,r.lineNumber,r.column),g,s,10*k);if(b.length>0)return b[b.length-1];const i=a.getLineCount();return r.lineNumber!==i||r.column!==a.getLineMaxColumn(i)?this._doFindPreviousMatchMultiline(a,new y.Position(i,a.getLineMaxColumn(i)),g,s):null}static _doFindPreviousMatchLineByLine(a,r,g,s){const b=a.getLineCount(),i=r.lineNumber,t=a.getLineContent(i).substring(0,r.column-1),c=this._findLastMatchInLine(g,t,i,s);if(c)return c;for(let d=1;d<=b;d++){const o=(b+i-d-1)%b,f=a.getLineContent(o+1),u=this._findLastMatchInLine(g,f,o+1,s);if(u)return u}return null}static _findLastMatchInLine(a,r,g,s){let b=null,i;for(a.reset(0);i=a.next(r);)b=I(new C.Range(g,i.index+1,g,i.index+1+i[0].length),i,s);return b}}e.TextModelSearch=v;function h(p,a,r,g,s){if(g===0)return!0;const b=a.charCodeAt(g-1);if(p.get(b)!==0||b===13||b===10)return!0;if(s>0){const i=a.charCodeAt(g);if(p.get(i)!==0)return!0}return!1}function w(p,a,r,g,s){if(g+s===r)return!0;const b=a.charCodeAt(g+s);if(p.get(b)!==0||b===13||b===10)return!0;if(s>0){const i=a.charCodeAt(g+s-1);if(p.get(i)!==0)return!0}return!1}function S(p,a,r,g,s){return h(p,a,r,g,s)&&w(p,a,r,g,s)}e.isValidMatch=S;class A{constructor(a,r){this._wordSeparators=a,this._searchRegex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(a){this._searchRegex.lastIndex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(a){const r=a.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===r||(g=this._searchRegex.exec(a),!g))return null;const s=g.index,b=g[0].length;if(s===this._prevMatchStartIndex&&b===this._prevMatchLength){if(b===0){m.getNextCodePoint(a,r,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=s,this._prevMatchLength=b,!this._wordSeparators||S(this._wordSeparators,a,r,s,b))return g}while(g);return null}}e.Searcher=A}),define(fe[110],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(k=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)k.indexOf(D)>=0||(_+="\\"+D);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=m();function L(k){let _=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)_=k;else{let D="g";k.ignoreCase&&(D+="i"),k.multiline&&(D+="m"),k.unicode&&(D+="u"),_=new RegExp(k.source,D)}return _.lastIndex=0,_}e.ensureValidWordDefinition=L;const y={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,_,D,P,I=y){if(D.length>I.maxLen){let S=k-I.maxLen/2;return S<0?S=0:P+=S,D=D.substring(S,k+I.maxLen/2),C(k,_,D,P,I)}const l=Date.now(),v=k-1-P;let h=-1,w=null;for(let S=1;!(Date.now()-l>=I.timeBudget);S++){const A=v-I.windowSize*S;_.lastIndex=Math.max(0,A);const p=n(_,D,v,h);if(!p&&w||(w=p,A<=0))break;h=A}if(w){let S={word:w[0],startColumn:P+1+w.index,endColumn:P+1+w.index+w[0].length};return _.lastIndex=0,S}return null}e.getWordAtText=C;function n(k,_,D,P){let I;for(;I=k.exec(_);){const l=I.index||0;if(l<=D&&k.lastIndex>=D)return I;if(P>0&&l>P)return null}return null}}),define(fe[146],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class L{constructor(k){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let _=0,D=k.notIn.length;_<D;_++)switch(k.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=L;class y{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of k)C(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),C(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),C(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),C(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&C(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=y;function C(n,k,_){n.has(k)?n.get(k).push(_):n.set(k,[_])}}),define(fe[82],me([0,1,31,9]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(C,n,k,_){if(Array.isArray(C)){let D=0;for(const P of C){const I=y(P,n,k,_);if(I===10)return I;I>D&&(D=I)}return D}else{if(typeof C=="string")return _?C==="*"?5:C===k?10:0:0;if(C){const{language:D,pattern:P,scheme:I,hasAccessToAllModels:l}=C;if(!_&&!l)return 0;let v=0;if(I)if(I===n.scheme)v=10;else if(I==="*")v=5;else return 0;if(D)if(D===k)v=10;else if(D==="*")v=Math.max(v,5);else return 0;if(P){let h;if(typeof P=="string"?h=P:h={...P,base:(0,L.normalize)(P.base)},h===n.fsPath||(0,m.match)(h,n.fsPath))v=10;else return 0}return v}else return 0}}e.score=y}),define(fe[147],me([0,1,108]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class y{constructor(h,w,S){const A=new Uint8Array(h*w);for(let p=0,a=h*w;p<a;p++)A[p]=S;this._data=A,this.rows=h,this.cols=w}get(h,w){return this._data[h*this.cols+w]}set(h,w,S){this._data[h*this.cols+w]=S}}e.Uint8Matrix=y;class C{constructor(h){let w=0,S=0;for(let p=0,a=h.length;p<a;p++){let[r,g,s]=h[p];g>w&&(w=g),r>S&&(S=r),s>S&&(S=s)}w++,S++;let A=new y(S,w,0);for(let p=0,a=h.length;p<a;p++){let[r,g,s]=h[p];A.set(r,g,s)}this._states=A,this._maxCharCode=w}nextState(h,w){return w<0||w>=this._maxCharCode?0:this._states.get(h,w)}}e.StateMachine=C;let n=null;function k(){return n===null&&(n=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),n}var _;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let D=null;function P(){if(D===null){D=new m.CharacterClassifier(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<v.length;w++)D.set(v.charCodeAt(w),1);const h=".,;";for(let w=0;w<h.length;w++)D.set(h.charCodeAt(w),2)}return D}class I{static _createLink(h,w,S,A,p){let a=p-1;do{const r=w.charCodeAt(a);if(h.get(r)!==2)break;a--}while(a>A);if(A>0){const r=w.charCodeAt(A-1),g=w.charCodeAt(a);(r===40&&g===41||r===91&&g===93||r===123&&g===125)&&a--}return{range:{startLineNumber:S,startColumn:A+1,endLineNumber:S,endColumn:a+2},url:w.substring(A,a+1)}}static computeLinks(h,w=k()){const S=P();let A=[];for(let p=1,a=h.getLineCount();p<=a;p++){const r=h.getLineContent(p),g=r.length;let s=0,b=0,i=0,t=1,c=!1,d=!1,o=!1,f=!1;for(;s<g;){let u=!1;const E=r.charCodeAt(s);if(t===13){let T;switch(E){case 40:c=!0,T=0;break;case 41:T=c?0:1;break;case 91:o=!0,d=!0,T=0;break;case 93:o=!1,T=d?0:1;break;case 123:f=!0,T=0;break;case 125:T=f?0:1;break;case 39:T=i===34||i===96?0:1;break;case 34:T=i===39||i===96?0:1;break;case 96:T=i===39||i===34?0:1;break;case 42:T=i===42?1:0;break;case 124:T=i===124?1:0;break;case 32:T=o?0:1;break;default:T=S.get(E)}T===1&&(A.push(I._createLink(S,r,p,b,s)),u=!0)}else if(t===12){let T;E===91?(d=!0,T=0):T=S.get(E),T===1?u=!0:t=13}else t=w.nextState(t,E),t===0&&(u=!0);u&&(t=1,c=!1,d=!1,f=!1,b=s+1,i=E),s++}t===13&&A.push(I._createLink(S,r,p,b,g))}return A}}e.LinkComputer=I;function l(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:I.computeLinks(v)}e.computeLinks=l}),define(fe[148],me([0,1,3,6]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class y{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(n){this._onDidChange.fire({changedLanguages:n,changedColorMap:!1})}register(n,k){return this._map.set(n,k),this.fire([n]),(0,L.toDisposable)(()=>{this._map.get(n)===k&&(this._map.delete(n),this.fire([n]))})}registerPromise(n,k){let _=null,D=!1;return this._promises.set(n,k.then(P=>{this._promises.delete(n),!(D||!P)&&(_=this.register(n,P))})),(0,L.toDisposable)(()=>{D=!0,_&&_.dispose()})}getPromise(n){const k=this.get(n);if(k)return Promise.resolve(k);const _=this._promises.get(n);return _?_.then(D=>this.get(n)):null}get(n){return this._map.get(n)||null}setColorMap(n){this._colorMap=n,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=y}),define(fe[111],me([0,1,22,12]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(y||(y={}));function C(I){for(let l=0,v=I.length;l<v;l+=4){const h=I[l+0],w=I[l+1],S=I[l+2],A=I[l+3];I[l+0]=A,I[l+1]=S,I[l+2]=w,I[l+3]=h}}function n(I){const l=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||C(l),m.VSBuffer.wrap(l)}function k(I){const l=I.buffer;if(L.isLittleEndian()||C(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const v=new Uint8Array(l.byteLength);return v.set(l),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function _(I){const l=new Uint32Array(D(I));let v=0;if(l[v++]=I.id,I.type==="full")l[v++]=1,l[v++]=I.data.length,l.set(I.data,v),v+=I.data.length;else{l[v++]=2,l[v++]=I.deltas.length;for(const h of I.deltas)l[v++]=h.start,l[v++]=h.deleteCount,h.data?(l[v++]=h.data.length,l.set(h.data,v),v+=h.data.length):l[v++]=0}return n(l)}e.encodeSemanticTokensDto=_;function D(I){let l=0;if(l+=1+1,I.type==="full")l+=1+I.data.length;else{l+=1,l+=(1+1+1)*I.deltas.length;for(const v of I.deltas)v.data&&(l+=v.data.length)}return l}function P(I){const l=k(I);let v=0;const h=l[v++];if(l[v++]===1){const p=l[v++],a=l.subarray(v,v+p);return v+=p,{id:h,type:"full",data:a}}const S=l[v++];let A=[];for(let p=0;p<S;p++){const a=l[v++],r=l[v++],g=l[v++];let s;g>0&&(s=l.subarray(v,v+g),v+=g),A[p]={start:a,deleteCount:r,data:s}}return{id:h,type:"delta",deltas:A}}e.decodeSemanticTokensDto=P}),define(fe[112],me([0,1,17,99]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class y{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,D){_=(0,L.toUint32)(_);const P=this.values,I=this.prefixSum,l=D.length;return l===0?!1:(this.values=new Uint32Array(P.length+l),this.values.set(P.subarray(0,_),0),this.values.set(P.subarray(_),_+l),this.values.set(D,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,D){return _=(0,L.toUint32)(_),D=(0,L.toUint32)(D),this.values[_]===D?!1:(this.values[_]=D,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,D){_=(0,L.toUint32)(_),D=(0,L.toUint32)(D);const P=this.values,I=this.prefixSum;if(_>=P.length)return!1;let l=P.length-_;return D>=l&&(D=l),D===0?!1:(this.values=new Uint32Array(P.length-D),this.values.set(P.subarray(0,_),0),this.values.set(P.subarray(_+D),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,L.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),_>=this.values.length&&(_=this.values.length-1);for(let P=D;P<=_;P++)this.prefixSum[P]=this.prefixSum[P-1]+this.values[P];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let D=0,P=this.values.length-1,I=0,l=0,v=0;for(;D<=P;)if(I=D+(P-D)/2|0,l=this.prefixSum[I],v=l-this.values[I],_<v)P=I-1;else if(_>=l)D=I+1;else break;return new n(I,_-v)}}e.PrefixSumComputer=y;class C{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const D=this._indexBySum[_],P=D>0?this._prefixSum[D-1]:0;return new n(D,_-P)}removeValues(_,D){this._values.splice(_,D),this._invalidate(_)}insertValues(_,D){this._values=(0,m.arrayInsert)(this._values,_,D),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,D=this._values.length;_<D;_++){const P=this._values[_],I=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=I+P;for(let l=0;l<P;l++)this._indexBySum[I+l]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,D){this._values[_]!==D&&(this._values[_]=D,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=C;class n{constructor(_,D){this.index=_,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=D}}e.PrefixSumIndexOfResult=n}),define(fe[149],me([0,1,8,50,112]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,_,D,P){this._uri=k,this._lines=_,this._eol=D,this._versionId=P,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const _=k.changes;for(const D of _)this._acceptDeleteRange(D.range),this._acceptInsertText(new L.Position(D.range.startLineNumber,D.range.startColumn),D.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,_=this._lines.length,D=new Uint32Array(_);for(let P=0;P<_;P++)D[P]=this._lines[P].length+k;this._lineStarts=new y.PrefixSumComputer(D)}}_setLineText(k,_){this._lines[k]=_,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,_){if(_.length===0)return;let D=(0,m.splitLines)(_);if(D.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+D[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}D[D.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+D[0]);let P=new Uint32Array(D.length-1);for(let I=1;I<D.length;I++)this._lines.splice(k.lineNumber+I-1,0,D[I]),P[I-1]=D[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,P)}}e.MirrorTextModel=C}),define(fe[150],me([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(fe[151],me([0,1,150]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,y=L*60,C=y*24,n=C*7,k=C*30,_=C*365;function D(I,l){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,m.localize)(0,null,D(new Date().getTime()+v*1e3,!1));if(v<30)return(0,m.localize)(1,null);let h;return v<L?(h=v,l?h===1?(0,m.localize)(2,null,h):(0,m.localize)(3,null,h):h===1?(0,m.localize)(4,null,h):(0,m.localize)(5,null,h)):v<y?(h=Math.floor(v/L),l?h===1?(0,m.localize)(6,null,h):(0,m.localize)(7,null,h):h===1?(0,m.localize)(8,null,h):(0,m.localize)(9,null,h)):v<C?(h=Math.floor(v/y),l?h===1?(0,m.localize)(10,null,h):(0,m.localize)(11,null,h):h===1?(0,m.localize)(12,null,h):(0,m.localize)(13,null,h)):v<n?(h=Math.floor(v/C),l?h===1?(0,m.localize)(14,null,h):(0,m.localize)(15,null,h):h===1?(0,m.localize)(16,null,h):(0,m.localize)(17,null,h)):v<k?(h=Math.floor(v/n),l?h===1?(0,m.localize)(18,null,h):(0,m.localize)(19,null,h):h===1?(0,m.localize)(20,null,h):(0,m.localize)(21,null,h)):v<_?(h=Math.floor(v/k),l?h===1?(0,m.localize)(22,null,h):(0,m.localize)(23,null,h):h===1?(0,m.localize)(24,null,h):(0,m.localize)(25,null,h)):(h=Math.floor(v/_),l?h===1?(0,m.localize)(26,null,h):(0,m.localize)(27,null,h):h===1?(0,m.localize)(28,null,h):(0,m.localize)(29,null,h))}e.fromNow=D;function P(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(fe[152],me([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(fe[51],me([0,1,17,13,152]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(D,P){return P&&(D.stack||D.stacktrace)?y.localize(0,null,k(D),n(D.stack)||n(D.stacktrace)):k(D)}function n(D){return Array.isArray(D)?D.join(`
`):D}function k(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?y.localize(1,null,D.message):D.message||y.localize(2,null)}function _(D=null,P=!1){if(!D)return y.localize(3,null);if(Array.isArray(D)){const I=m.coalesce(D),l=_(I[0],P);return I.length>1?y.localize(4,null,l,I.length):l}if(L.isString(D))return D;if(D.detail){const I=D.detail;if(I.error)return C(I.error,P);if(I.exception)return C(I.exception,P)}return D.stack?C(D,P):D.message?D.message:y.localize(5,null)}e.toErrorMessage=_}),define(fe[153],me([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(fe[113],me([0,1,38,30,10,25,9,12,37,95,13,142,28,153]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function h(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(s,b){if(k.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};b&&(i.cwd=b);const t=m.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(c=>{t.once("error",d=>{c({success:!1,error:d})}),t.once("exit",(d,o)=>{c(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?h(i.status):1})}else if(k.isLinux||k.isMacintosh)try{const i=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{m.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(c,d,o)=>{t(c?{success:!1,error:c}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function S(s){!s||(delete s.DEBUG,k.isMacintosh&&delete s.DYLD_LIBRARY_PATH,k.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=S;function A(s=_.env){return s.comspec||"cmd.exe"}e.getWindowsShell=A;class p{constructor(b,i,t,c){if(i!==void 0&&t!==void 0&&c!==void 0)this.cmd=b,this.args=i,this.shell=t,this.options=c;else{const d=b;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(_.env).forEach(o=>{d[o]=_.env[o]}),Object.keys(this.options.env).forEach(o=>{d[o]=this.options.env[o]}),this.options.env=d}}getSanitizedCommand(){let b=this.cmd.toLowerCase();const i=b.lastIndexOf(n.sep);return i!==-1&&(b=b.substring(i+1)),p.WellKnowCommands[b]?b:"other"}start(b){return k.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(_.cwd()))?Promise.reject(new Error(v.localize(0,null))):this.useExec().then(i=>{let t,c;const d=new Promise((o,f)=>{t=o,c=f});if(i){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=m.exec(o,this.options,(f,u,E)=>{this.childProcess=null;const T=f;T&&T.killed?c({killed:this.terminateRequested,stdout:u.toString(),stderr:E.toString()}):this.handleExec(t,b,f,u,E)})}else{let o=null;const f=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,t,b,c);const E={terminated:this.terminateRequested};P.isNumber(u)&&(E.cmdCode=u),t(E)};if(this.shell&&k.isWindows){const u=C.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let E=!1,T=!1;const R=[];let B=this.ensureQuotes(this.cmd);R.push(B.value),E=B.quoted,this.args&&this.args.forEach(F=>{B=this.ensureQuotes(F),R.push(B.value),T=T&&B.quoted});const x=["/s","/c"];E?T?x.push('"'+R.join(" ")+'"'):R.length>1?x.push('"'+R[0]+'" '+R.slice(1).join(" ")):x.push('"'+R[0]+'"'):x.push(R.join(" ")),o=m.spawn(A(),x,u)}else this.cmd&&(o=m.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(P.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",u=>{this.childProcess=null,c({terminated:this.terminateRequested,error:u})}),o.pid&&(this.childProcess.on("close",f),this.handleSpawn(o,t,b,c,!0)))}return d})}handleClose(b,i,t,c){}ensureQuotes(b){return p.regexp.test(b)?{value:'"'+b+'"',quoted:!0}:{value:b,quoted:b.length>0&&b[0]==='"'&&b[b.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(b=>b.pid,b=>-1):new Promise(b=>{this.pidResolve=b})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(b=>(this.terminateRequested=!0,w(b,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),b=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(b=>{if(!this.shell||!k.isWindows)return b(!1);const i=m.spawn(A(),["/s","/c"]);i.on("error",t=>b(!0)),i.on("exit",t=>b(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class a extends p{constructor(b,i,t,c){super(b,i,t,c);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(b,i,t,c,d){[c,d].forEach((o,f)=>{const u=new I.LineDecoder;u.write(o).forEach(R=>{i({line:R,source:f===0?0:1})});const T=u.end();T&&i({line:T,source:f===0?0:1})}),b({terminated:this.terminateRequested,error:t})}handleSpawn(b,i,t,c,d){const o=new I.LineDecoder,f=new I.LineDecoder;b.stdout.on("data",u=>{o.write(u).forEach(T=>t({line:T,source:0}))}),b.stderr.on("data",u=>{f.write(u).forEach(T=>t({line:T,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=f}handleClose(b,i,t,c){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&t({line:d,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&t({line:o,source:1})}}e.LineProcess=a;function r(s){let b=[],i=!1;const t=function(c){if(i){b.push(c);return}(!s.send(c,o=>{if(o&&console.error(o),i=!1,b.length>0){const f=b.slice(0);b=[],f.forEach(u=>t(u))}})||k.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=r;var g;(function(s){async function b(i,t,c){if(n.isAbsolute(i))return i;if(t===void 0&&(t=_.cwd()),n.dirname(i)!=="."||(c===void 0&&P.isString(_.env.PATH)&&(c=_.env.PATH.split(n.delimiter)),c===void 0||c.length===0))return n.join(t,i);async function o(f){if(await l.Promises.exists(f)){let u;try{u=await l.Promises.stat(f)}catch(E){E.message.startsWith("EACCES")&&(u=await l.Promises.lstat(f))}return u?!u.isDirectory():!1}return!1}for(let f of c){let u;if(n.isAbsolute(f)?u=n.join(f,i):u=n.join(t,f,i),await o(u))return u;let E=u+".com";if(await o(E)||(E=u+".exe",await o(E)))return E}return n.join(t,i)}s.findExecutable=b})(g=e.win32||(e.win32={}))}),define(fe[154],me([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(fe[114],me([0,1,154,12,110]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class n{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=n;class k{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,_e){this._values[ie]=_e}}e.ValidatedEditorOptions=k;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class D{constructor(ie,_e,Qe,et){this.id=ie,this.name=_e,this.defaultValue=Qe,this.schema=et}compute(ie,_e,Qe){return Qe}}class P{constructor(ie,_e=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(ie){return this.defaultValue}}class I{constructor(ie,_e,Qe,et){this.id=ie,this.name=_e,this.defaultValue=Qe,this.schema=et}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,_e,Qe){return Qe}}function l(J,ie){return typeof J=="undefined"?ie:J==="false"?!1:Boolean(J)}e.boolean=l;class v extends I{constructor(ie,_e,Qe,et=void 0){typeof et!="undefined"&&(et.type="boolean",et.default=Qe),super(ie,_e,Qe,et)}validate(ie){return l(ie,this.defaultValue)}}function h(J,ie,_e,Qe){if(typeof J=="undefined")return ie;let et=parseInt(J,10);return isNaN(et)?ie:(et=Math.max(_e,et),et=Math.min(Qe,et),et|0)}e.clampedInt=h;class w extends I{constructor(ie,_e,Qe,et,le,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="integer",Ie.default=Qe,Ie.minimum=et,Ie.maximum=le),super(ie,_e,Qe,Ie),this.minimum=et,this.maximum=le}static clampedInt(ie,_e,Qe,et){return h(ie,_e,Qe,et)}validate(ie){return w.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class S extends I{constructor(ie,_e,Qe,et,le){typeof le!="undefined"&&(le.type="number",le.default=Qe),super(ie,_e,Qe,le),this.validationFn=et}static clamp(ie,_e,Qe){return ie<_e?_e:ie>Qe?Qe:ie}static float(ie,_e){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return _e;const Qe=parseFloat(ie);return isNaN(Qe)?_e:Qe}validate(ie){return this.validationFn(S.float(ie,this.defaultValue))}}class A extends I{static string(ie,_e){return typeof ie!="string"?_e:ie}constructor(ie,_e,Qe,et=void 0){typeof et!="undefined"&&(et.type="string",et.default=Qe),super(ie,_e,Qe,et)}validate(ie){return A.string(ie,this.defaultValue)}}function p(J,ie,_e){return typeof J!="string"||_e.indexOf(J)===-1?ie:J}e.stringSet=p;class a extends I{constructor(ie,_e,Qe,et,le=void 0){typeof le!="undefined"&&(le.type="string",le.enum=et,le.default=Qe),super(ie,_e,Qe,le),this._allowedValues=et}validate(ie){return p(ie,this.defaultValue,this._allowedValues)}}class r extends D{constructor(ie,_e,Qe,et,le,Ie,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=le,Ue.default=et),super(ie,_e,Qe,Ue),this._allowedValues=le,this._convert=Ie}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function g(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,_e,Qe){return Qe===0?ie.accessibilitySupport:Qe}}class b extends D{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertSpace:l(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var c;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(c=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(J){switch(J){case c.Line:return"line";case c.Block:return"block";case c.Underline:return"underline";case c.LineThin:return"line-thin";case c.BlockOutline:return"block-outline";case c.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function o(J){switch(J){case"line":return c.Line;case"block":return c.Block;case"underline":return c.Underline;case"line-thin":return c.LineThin;case"block-outline":return c.BlockOutline;case"underline-thin":return c.UnderlineThin}}class f extends P{constructor(){super(126,[65,33])}compute(ie,_e,Qe){const et=["monaco-editor"];return _e.get(33)&&et.push(_e.get(33)),ie.extraEditorClassName&&et.push(ie.extraEditorClassName),_e.get(65)==="default"?et.push("mouse-default"):_e.get(65)==="copy"&&et.push("mouse-copy"),_e.get(99)&&et.push("showUnused"),_e.get(124)&&et.push("showDeprecated"),et.join(" ")}}class u extends v{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ie,_e,Qe){return Qe&&ie.emptySelectionClipboard}}class E extends D{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ie.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:m.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:m.localize(18,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{cursorMoveOnType:l(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ie.seedSearchStringFromSelection=="boolean"?ie.seedSearchStringFromSelection?"always":"never":p(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":p(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(_e.loop,this.defaultValue.loop)}}}class T extends D{constructor(){super(44,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?T.OFF:ie==="true"?T.ON:ie:Boolean(ie)?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class R extends P{constructor(){super(43)}compute(ie,_e,Qe){return ie.fontInfo}}class B extends I{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(ie){let _e=S.float(ie,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:S.clamp(_e,6,100)}compute(ie,_e,Qe){return ie.fontInfo.fontSize}}class x extends D{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(w.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class F extends D{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),..._e},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),..._e},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),..._e},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),..._e},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),..._e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Qe,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Qe,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Qe,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Qe,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Qe,description:m.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{multiple:p(_e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:_e.multipleDefinitions??p(_e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:_e.multipleTypeDefinitions??p(_e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:_e.multipleDeclarations??p(_e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:_e.multipleImplementations??p(_e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:_e.multipleReferences??p(_e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:A.string(_e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:A.string(_e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:A.string(_e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:A.string(_e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:A.string(_e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends D{constructor(){const ie={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:m.localize(41,null)},"editor.hover.above":{type:"boolean",default:ie.above,description:m.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:l(_e.enabled,this.defaultValue.enabled),delay:w.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:l(_e.sticky,this.defaultValue.sticky),above:l(_e.above,this.defaultValue.above)}}}var M;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class H extends P{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(ie,_e,Qe){return H.computeLayout(_e,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const _e=ie.height/ie.lineHeight,Qe=ie.scrollBeyondLastLine?_e-1:0,et=(ie.viewLineCount+Qe)/(ie.pixelRatio*ie.height),le=Math.floor(ie.viewLineCount/et);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Qe,desiredRatio:et,minimapLineCount:le}}static _computeMinimapLayout(ie,_e){const Qe=ie.outerWidth,et=ie.outerHeight,le=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(le*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const Ie=_e.stableMinimapLayoutInput,Ue=Ie&&ie.outerHeight===Ie.outerHeight&&ie.lineHeight===Ie.lineHeight&&ie.typicalHalfwidthCharacterWidth===Ie.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Ie.pixelRatio&&ie.scrollBeyondLastLine===Ie.scrollBeyondLastLine&&ie.minimap.enabled===Ie.minimap.enabled&&ie.minimap.side===Ie.minimap.side&&ie.minimap.size===Ie.minimap.size&&ie.minimap.showSlider===Ie.minimap.showSlider&&ie.minimap.renderCharacters===Ie.minimap.renderCharacters&&ie.minimap.maxColumn===Ie.minimap.maxColumn&&ie.minimap.scale===Ie.minimap.scale&&ie.verticalScrollbarWidth===Ie.verticalScrollbarWidth&&ie.isViewportWrapping===Ie.isViewportWrapping,Xe=ie.lineHeight,it=ie.typicalHalfwidthCharacterWidth,ft=ie.scrollBeyondLastLine,tt=ie.minimap.renderCharacters;let ut=le>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const Re=ie.minimap.maxColumn,ve=ie.minimap.size,Te=ie.minimap.side,se=ie.verticalScrollbarWidth,ue=ie.viewLineCount,be=ie.remainingWidth,we=ie.isViewportWrapping,Fe=tt?2:3;let qe=Math.floor(le*et);const ze=qe/le;let Ye=!1,lt=!1,xe=Fe*ut,ge=ut/le,Ee=1;if(ve==="fill"||ve==="fit"){const{typicalViewportLineCount:mt,extraLinesBeyondLastLine:yt,desiredRatio:_t,minimapLineCount:gt}=H.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:ft,height:et,lineHeight:Xe,pixelRatio:le});if(ue/gt>1)Ye=!0,lt=!0,ut=1,xe=1,ge=ut/le;else{let vt=!1,Tt=ut+1;if(ve==="fit"){const Dt=Math.ceil((ue+yt)*xe);we&&Ue&&be<=_e.stableFitRemainingWidth?(vt=!0,Tt=_e.stableFitMaxMinimapScale):vt=Dt>qe}if(ve==="fill"||vt){Ye=!0;const Dt=ut;xe=Math.min(Xe*le,Math.max(1,Math.floor(1/_t))),we&&Ue&&be<=_e.stableFitRemainingWidth&&(Tt=_e.stableFitMaxMinimapScale),ut=Math.min(Tt,Math.max(1,Math.floor(xe/Fe))),ut>Dt&&(Ee=Math.min(2,ut/Dt)),ge=ut/le/Ee,qe=Math.ceil(Math.max(mt,ue+yt)*xe),we?(_e.stableMinimapLayoutInput=ie,_e.stableFitRemainingWidth=be,_e.stableFitMaxMinimapScale=ut):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0)}}}const ae=Math.floor(Re*ge),K=Math.min(ae,Math.max(0,Math.floor((be-se-2)*ge/(it+ge)))+e.MINIMAP_GUTTER_WIDTH);let Ce=Math.floor(le*K);const Le=Ce/le;Ce=Math.floor(Ce*Ee);const nt=tt?1:2,Ge=Te==="left"?0:Qe-K-se;return{renderMinimap:nt,minimapLeft:Ge,minimapWidth:K,minimapHeightIsEditorHeight:Ye,minimapIsSampling:lt,minimapScale:ut,minimapLineHeight:xe,minimapCanvasInnerWidth:Ce,minimapCanvasInnerHeight:qe,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:ze}}static computeLayout(ie,_e){const Qe=_e.outerWidth|0,et=_e.outerHeight|0,le=_e.lineHeight|0,Ie=_e.lineNumbersDigitCount|0,Ue=_e.typicalHalfwidthCharacterWidth,Xe=_e.maxDigitWidth,it=_e.pixelRatio,ft=_e.viewLineCount,tt=ie.get(121),ut=tt==="inherit"?ie.get(120):tt,Re=ut==="inherit"?ie.get(116):ut,ve=ie.get(119),Te=ie.get(2),se=_e.isDominatedByLongLines,ue=ie.get(49),be=ie.get(59).renderType!==0,we=ie.get(60),Fe=ie.get(93),qe=ie.get(64),ze=ie.get(91),Ye=ze.verticalScrollbarSize,lt=ze.verticalHasArrows,xe=ze.arrowSize,ge=ze.horizontalScrollbarSize,Ee=ie.get(57),ae=ie.get(37);let K;if(typeof Ee=="string"&&/^\d+(\.\d+)?ch$/.test(Ee)){const kt=parseFloat(Ee.substr(0,Ee.length-2));K=w.clampedInt(kt*Ue,0,0,1e3)}else K=w.clampedInt(Ee,0,0,1e3);ae&&(K+=16);let Ce=0;if(be){const kt=Math.max(Ie,we);Ce=Math.round(kt*Xe)}let Le=0;ue&&(Le=le);let nt=0,Ge=nt+Le,mt=Ge+Ce,yt=mt+K;const _t=Qe-Le-Ce-K;let gt=!1,bt=!1,vt=-1;Te!==2&&(ut==="inherit"&&se?(gt=!0,bt=!0):Re==="on"||Re==="bounded"?bt=!0:Re==="wordWrapColumn"&&(vt=ve));const Tt=H._computeMinimapLayout({outerWidth:Qe,outerHeight:et,lineHeight:le,typicalHalfwidthCharacterWidth:Ue,pixelRatio:it,scrollBeyondLastLine:Fe,minimap:qe,verticalScrollbarWidth:Ye,viewLineCount:ft,remainingWidth:_t,isViewportWrapping:bt},_e.memory||new _);Tt.renderMinimap!==0&&Tt.minimapLeft===0&&(nt+=Tt.minimapWidth,Ge+=Tt.minimapWidth,mt+=Tt.minimapWidth,yt+=Tt.minimapWidth);const Dt=_t-Tt.minimapWidth,Bt=Math.max(1,Math.floor((Dt-Ye-2)/Ue)),Vt=lt?xe:0;return bt&&(vt=Math.max(1,Bt),Re==="bounded"&&(vt=Math.min(vt,ve))),{width:Qe,height:et,glyphMarginLeft:nt,glyphMarginWidth:Le,lineNumbersLeft:Ge,lineNumbersWidth:Ce,decorationsLeft:mt,decorationsWidth:K,contentLeft:yt,contentWidth:Dt,minimap:Tt,viewportColumn:Bt,isWordWrapMinified:gt,isViewportWrapping:bt,wrappingColumn:vt,verticalScrollbarWidth:Ye,horizontalScrollbarHeight:ge,overviewRuler:{top:Vt,width:Ye,height:et-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=H;class N extends D{constructor(){const ie={enabled:!0};super(56,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:m.localize(43,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:l(ie.enabled,this.defaultValue.enabled)}}}class U extends D{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:m.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:m.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,markdownDescription:m.localize(46,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:l(_e.enabled,this.defaultValue.enabled),fontSize:w.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:A.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class V extends S{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>S.clamp(ie,0,150),{markdownDescription:m.localize(47,null)})}compute(ie,_e,Qe){return ie.fontInfo.lineHeight}}class O extends D{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:m.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(49,null),m.localize(50,null),m.localize(51,null)],default:ie.size,description:m.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:m.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:m.localize(54,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:m.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:m.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:l(_e.enabled,this.defaultValue.enabled),size:p(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(_e.side,this.defaultValue.side,["right","left"]),showSlider:p(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(_e.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(_e.scale,1,1,3),maxColumn:w.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function W(J){return J==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends D{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(59,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{top:w.clampedInt(_e.top,0,0,1e3),bottom:w.clampedInt(_e.bottom,0,0,1e3)}}}class X extends D{constructor(){const ie={enabled:!0,cycle:!1};super(75,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:m.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:m.localize(61,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:l(_e.enabled,this.defaultValue.enabled),cycle:l(_e.cycle,this.defaultValue.cycle)}}}class Q extends P{constructor(){super(127)}compute(ie,_e,Qe){return ie.pixelRatio}}class de extends D{constructor(){const ie={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:m.localize(62,null)},comments:{type:"boolean",default:ie.comments,description:m.localize(63,null)},other:{type:"boolean",default:ie.other,description:m.localize(64,null)}}}],default:ie,description:m.localize(65,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const _e=ie,Qe={other:l(_e.other,this.defaultValue.other),comments:l(_e.comments,this.defaultValue.comments),strings:l(_e.strings,this.defaultValue.strings)};return Qe.other&&Qe.comments&&Qe.strings?!0:!Qe.other&&!Qe.comments&&!Qe.strings?!1:Qe}return this.defaultValue}}var Se;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(Se=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class De extends D{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null),m.localize(69,null)],default:"on",description:m.localize(70,null)})}validate(ie){let _e=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(_e=4,Qe=ie):ie==="interval"?_e=3:ie==="relative"?_e=2:ie==="on"?_e=1:_e=0),{renderType:_e,renderFn:Qe}}}function Pe(J){const ie=J.get(86);return ie==="editable"?J.get(80):ie!=="on"}e.filterValidationDecorations=Pe;class Be extends D{constructor(){const ie=[],_e={type:"number",description:m.localize(71,null)};super(90,"rulers",ie,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:m.localize(72,null),format:"color-hex"}}}]},default:ie,description:m.localize(73,null)})}validate(ie){if(Array.isArray(ie)){let _e=[];for(let Qe of ie)if(typeof Qe=="number")_e.push({column:w.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const et=Qe;_e.push({column:w.clampedInt(et.column,0,0,1e4),color:et.color})}return _e.sort((Qe,et)=>Qe.column-et.column),_e}return this.defaultValue}}function We(J,ie){if(typeof J!="string")return ie;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends D{constructor(){const ie={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(78,null),m.localize(79,null),m.localize(80,null)],default:"auto",description:m.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:m.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:m.localize(84,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie,Qe=w.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=w.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:We(_e.vertical,this.defaultValue.vertical),horizontal:We(_e.horizontal,this.defaultValue.horizontal),useShadows:l(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:w.clampedInt(_e.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:w.clampedInt(_e.verticalSliderSize,et,0,1e3),scrollByPage:l(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class G extends D{constructor(){const ie={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:m.localize(85,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:l(_e.enabled,this.defaultValue.enabled),mode:p(_e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends D{constructor(){const ie={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ie,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ie.enabled,description:m.localize(86,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:l(ie.enabled,this.defaultValue.enabled)}}}class ne extends D{constructor(){const ie={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ie,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(87,null),m.localize(88,null),m.localize(89,null)],default:ie.bracketPairs,description:m.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(91,null),m.localize(92,null),m.localize(93,null)],default:ie.bracketPairsHorizontal,description:m.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ie.highlightActiveBracketPair,description:m.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:ie.indentation,description:m.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ie.highlightActiveIndentation,description:m.localize(97,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{bracketPairs:ce(_e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ce(_e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:l(_e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:l(_e.indentation,this.defaultValue.indentation),highlightActiveIndentation:l(_e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ce(J,ie,_e){const Qe=_e.indexOf(J);return Qe===-1?ie:_e[Qe]}class Z extends D{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(98,null),m.localize(99,null)],default:ie.insertMode,description:m.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:m.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:m.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:m.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:m.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:m.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:m.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:m.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:m.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(139,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertMode:p(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(_e.showIcons,this.defaultValue.showIcons),showStatusBar:l(_e.showStatusBar,this.defaultValue.showStatusBar),preview:l(_e.preview,this.defaultValue.preview),previewMode:p(_e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(_e.showMethods,this.defaultValue.showMethods),showFunctions:l(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:l(_e.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(_e.showDeprecated,this.defaultValue.showDeprecated),showFields:l(_e.showFields,this.defaultValue.showFields),showVariables:l(_e.showVariables,this.defaultValue.showVariables),showClasses:l(_e.showClasses,this.defaultValue.showClasses),showStructs:l(_e.showStructs,this.defaultValue.showStructs),showInterfaces:l(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:l(_e.showModules,this.defaultValue.showModules),showProperties:l(_e.showProperties,this.defaultValue.showProperties),showEvents:l(_e.showEvents,this.defaultValue.showEvents),showOperators:l(_e.showOperators,this.defaultValue.showOperators),showUnits:l(_e.showUnits,this.defaultValue.showUnits),showValues:l(_e.showValues,this.defaultValue.showValues),showConstants:l(_e.showConstants,this.defaultValue.showConstants),showEnums:l(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:l(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(_e.showKeywords,this.defaultValue.showKeywords),showWords:l(_e.showWords,this.defaultValue.showWords),showColors:l(_e.showColors,this.defaultValue.showColors),showFiles:l(_e.showFiles,this.defaultValue.showFiles),showReferences:l(_e.showReferences,this.defaultValue.showReferences),showFolders:l(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:l(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(_e.showSnippets,this.defaultValue.showSnippets),showUsers:l(_e.showUsers,this.defaultValue.showUsers),showIssues:l(_e.showIssues,this.defaultValue.showIssues)}}}class re extends D{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(140,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class pe extends P{constructor(){super(128,[80])}compute(ie,_e,Qe){return _e.get(80)?!0:ie.tabFocusMode}}var Me;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Me=e.WrappingIndent||(e.WrappingIndent={}));function je(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Ke extends P{constructor(){super(130,[129])}compute(ie,_e,Qe){const et=_e.get(129);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}const Ze="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?rt:L.isLinux?ct:Ze,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(J){return e.editorOptionsRegistry[J.id]=J,J}var at;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unusualLineTerminators=112]="unusualLineTerminators",J[J.useShadowDOM=113]="useShadowDOM",J[J.useTabStops=114]="useTabStops",J[J.wordSeparators=115]="wordSeparators",J[J.wordWrap=116]="wordWrap",J[J.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=119]="wordWrapColumn",J[J.wordWrapOverride1=120]="wordWrapOverride1",J[J.wordWrapOverride2=121]="wordWrapOverride2",J[J.wrappingIndent=122]="wrappingIndent",J[J.wrappingStrategy=123]="wrappingStrategy",J[J.showDeprecated=124]="showDeprecated",J[J.inlayHints=125]="inlayHints",J[J.editorClassName=126]="editorClassName",J[J.pixelRatio=127]="pixelRatio",J[J.tabFocusMode=128]="tabFocusMode",J[J.layoutInfo=129]="layoutInfo",J[J.wrappingInfo=130]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new v(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(141,null)})),acceptSuggestionOnEnter:ye(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(142,null),""],markdownDescription:m.localize(143,null)})),accessibilitySupport:ye(new s),accessibilityPageSize:ye(new w(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(144,null)})),ariaLabel:ye(new A(4,"ariaLabel",m.localize(145,null))),autoClosingBrackets:ye(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(146,null),m.localize(147,null),""],description:m.localize(148,null)})),autoClosingDelete:ye(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(149,null),""],description:m.localize(150,null)})),autoClosingOvertype:ye(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(151,null),""],description:m.localize(152,null)})),autoClosingQuotes:ye(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(153,null),m.localize(154,null),""],description:m.localize(155,null)})),autoIndent:ye(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[m.localize(156,null),m.localize(157,null),m.localize(158,null),m.localize(159,null),m.localize(160,null)],description:m.localize(161,null)})),automaticLayout:ye(new v(10,"automaticLayout",!1)),autoSurround:ye(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(162,null),m.localize(163,null),m.localize(164,null),""],description:m.localize(165,null)})),bracketPairColorization:ye(new ee),bracketPairGuides:ye(new ne),stickyTabStops:ye(new v(103,"stickyTabStops",!1,{description:m.localize(166,null)})),codeLens:ye(new v(14,"codeLens",!0,{description:m.localize(167,null)})),codeLensFontFamily:ye(new A(15,"codeLensFontFamily","",{description:m.localize(168,null)})),codeLensFontSize:ye(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(169,null)})),colorDecorators:ye(new v(17,"colorDecorators",!0,{description:m.localize(170,null)})),columnSelection:ye(new v(18,"columnSelection",!1,{description:m.localize(171,null)})),comments:ye(new b),contextmenu:ye(new v(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new v(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(172,null)})),cursorBlinking:ye(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:m.localize(173,null)})),cursorSmoothCaretAnimation:ye(new v(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(174,null)})),cursorStyle:ye(new r(24,"cursorStyle",c.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],o,{description:m.localize(175,null)})),cursorSurroundingLines:ye(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(176,null)})),cursorSurroundingLinesStyle:ye(new a(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(177,null),m.localize(178,null)],description:m.localize(179,null)})),cursorWidth:ye(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(180,null)})),disableLayerHinting:ye(new v(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new v(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new v(30,"domReadOnly",!1)),dragAndDrop:ye(new v(31,"dragAndDrop",!0,{description:m.localize(181,null)})),emptySelectionClipboard:ye(new u),extraEditorClassName:ye(new A(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new S(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:m.localize(182,null)})),find:ye(new E),fixedOverflowWidgets:ye(new v(36,"fixedOverflowWidgets",!1)),folding:ye(new v(37,"folding",!0,{description:m.localize(183,null)})),foldingStrategy:ye(new a(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(184,null),m.localize(185,null)],description:m.localize(186,null)})),foldingHighlight:ye(new v(39,"foldingHighlight",!0,{description:m.localize(187,null)})),foldingImportsByDefault:ye(new v(40,"foldingImportsByDefault",!1,{description:m.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new v(41,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(189,null)})),fontFamily:ye(new A(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(190,null)})),fontInfo:ye(new R),fontLigatures2:ye(new T),fontSize:ye(new B),fontWeight:ye(new x),formatOnPaste:ye(new v(47,"formatOnPaste",!1,{description:m.localize(191,null)})),formatOnType:ye(new v(48,"formatOnType",!1,{description:m.localize(192,null)})),glyphMargin:ye(new v(49,"glyphMargin",!0,{description:m.localize(193,null)})),gotoLocation:ye(new F),hideCursorInOverviewRuler:ye(new v(51,"hideCursorInOverviewRuler",!1,{description:m.localize(194,null)})),hover:ye(new $),inDiffEditor:ye(new v(53,"inDiffEditor",!1)),letterSpacing:ye(new S(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>S.clamp(J,-5,20),{description:m.localize(195,null)})),lightbulb:ye(new N),lineDecorationsWidth:ye(new I(57,"lineDecorationsWidth",10)),lineHeight:ye(new V),lineNumbers:ye(new De),lineNumbersMinChars:ye(new w(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new v(61,"linkedEditing",!1,{description:m.localize(196,null)})),links:ye(new v(62,"links",!0,{description:m.localize(197,null)})),matchBrackets:ye(new a(63,"matchBrackets","always",["always","near","never"],{description:m.localize(198,null)})),minimap:ye(new O),mouseStyle:ye(new a(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new S(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:m.localize(199,null)})),mouseWheelZoom:ye(new v(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(200,null)})),multiCursorMergeOverlapping:ye(new v(68,"multiCursorMergeOverlapping",!0,{description:m.localize(201,null)})),multiCursorModifier:ye(new r(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],W,{markdownEnumDescriptions:[m.localize(202,null),m.localize(203,null)],markdownDescription:m.localize(204,null)})),multiCursorPaste:ye(new a(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(205,null),m.localize(206,null)],markdownDescription:m.localize(207,null)})),occurrencesHighlight:ye(new v(71,"occurrencesHighlight",!0,{description:m.localize(208,null)})),overviewRulerBorder:ye(new v(72,"overviewRulerBorder",!0,{description:m.localize(209,null)})),overviewRulerLanes:ye(new w(73,"overviewRulerLanes",3,0,3)),padding:ye(new j),parameterHints:ye(new X),peekWidgetDefaultFocus:ye(new a(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(210,null),m.localize(211,null)],description:m.localize(212,null)})),definitionLinkOpensInPeek:ye(new v(77,"definitionLinkOpensInPeek",!1,{description:m.localize(213,null)})),quickSuggestions:ye(new de),quickSuggestionsDelay:ye(new w(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(214,null)})),readOnly:ye(new v(80,"readOnly",!1)),renameOnType:ye(new v(81,"renameOnType",!1,{description:m.localize(215,null),markdownDeprecationMessage:m.localize(216,null)})),renderControlCharacters:ye(new v(82,"renderControlCharacters",!0,{description:m.localize(217,null),restricted:!0})),renderFinalNewline:ye(new v(83,"renderFinalNewline",!0,{description:m.localize(218,null)})),renderLineHighlight:ye(new a(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(219,null)],description:m.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new v(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(221,null)})),renderValidationDecorations:ye(new a(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new a(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(222,null),m.localize(223,null),m.localize(224,null),""],description:m.localize(225,null)})),revealHorizontalRightPadding:ye(new w(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new v(89,"roundedSelection",!0,{description:m.localize(226,null)})),rulers:ye(new Be),scrollbar:ye(new He),scrollBeyondLastColumn:ye(new w(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(227,null)})),scrollBeyondLastLine:ye(new v(93,"scrollBeyondLastLine",!0,{description:m.localize(228,null)})),scrollPredominantAxis:ye(new v(94,"scrollPredominantAxis",!0,{description:m.localize(229,null)})),selectionClipboard:ye(new v(95,"selectionClipboard",!0,{description:m.localize(230,null),included:L.isLinux})),selectionHighlight:ye(new v(96,"selectionHighlight",!0,{description:m.localize(231,null)})),selectOnLineNumbers:ye(new v(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new a(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(232,null),m.localize(233,null)],description:m.localize(234,null)})),showUnused:ye(new v(99,"showUnused",!0,{description:m.localize(235,null)})),showDeprecated:ye(new v(124,"showDeprecated",!0,{description:m.localize(236,null)})),inlayHints:ye(new U),snippetSuggestions:ye(new a(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(237,null),m.localize(238,null),m.localize(239,null),m.localize(240,null)],description:m.localize(241,null)})),smartSelect:ye(new re),smoothScrolling:ye(new v(102,"smoothScrolling",!1,{description:m.localize(242,null)})),stopRenderingLineAfter:ye(new w(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new Z),inlineSuggest:ye(new G),suggestFontSize:ye(new w(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(243,null)})),suggestLineHeight:ye(new w(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(244,null)})),suggestOnTriggerCharacters:ye(new v(108,"suggestOnTriggerCharacters",!0,{description:m.localize(245,null)})),suggestSelection:ye(new a(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(246,null),m.localize(247,null),m.localize(248,null)],description:m.localize(249,null)})),tabCompletion:ye(new a(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(250,null),m.localize(251,null),m.localize(252,null)],description:m.localize(253,null)})),tabIndex:ye(new w(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new a(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(254,null),m.localize(255,null),m.localize(256,null)],description:m.localize(257,null)})),useShadowDOM:ye(new v(113,"useShadowDOM",!0)),useTabStops:ye(new v(114,"useTabStops",!0,{description:m.localize(258,null)})),wordSeparators:ye(new A(115,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:m.localize(259,null)})),wordWrap:ye(new a(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(260,null),m.localize(261,null),m.localize(262,null),m.localize(263,null)],description:m.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new A(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new A(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new w(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(265,null)})),wordWrapOverride1:ye(new a(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new a(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new r(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[m.localize(266,null),m.localize(267,null),m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),wrappingStrategy:ye(new a(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(271,null),m.localize(272,null)],description:m.localize(273,null)})),editorClassName:ye(new f),pixelRatio:ye(new Q),tabFocusMode:ye(new pe),layoutInfo:ye(new H),wrappingInfo:ye(new Ke)}}),define(fe[155],me([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[156],me([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[157],me([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[158],me([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[159],me([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(fe[160],me([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(fe[161],me([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[162],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[163],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[164],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[165],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[166],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[167],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[168],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[169],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[170],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(fe[171],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(fe[172],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[173],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[174],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[175],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[176],me([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[177],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(n){n[n.ACTIVATE=1]="ACTIVATE",n[n.RESTORE=2]="RESTORE",n[n.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var L;(function(n){n[n.PICK=0]="PICK",n[n.DISABLED=1]="DISABLED",n[n.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var y;(function(n){n[n.API=0]="API",n[n.USER=1]="USER"})(y=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(n){n[n.Center=0]="Center",n[n.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",n[n.NearTop=2]="NearTop",n[n.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[178],me([0,1,157]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function C(l){return l=l.trim(),l==="*"||L.test(l)}e.isValidVersionStr=C;function n(l){if(!C(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=l.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=n;function k(l){if(!l)return null;let v=l.majorBase,h=l.majorMustEqual,w=l.minorBase,S=l.minorMustEqual,A=l.patchBase,p=l.patchMustEqual;l.hasCaret&&(v===0||(S=!1),p=!1);let a=0;if(l.preRelease){const r=y.exec(l.preRelease);if(r){const[,g,s,b]=r;a=Date.UTC(Number(g),Number(s)-1,Number(b))}}return{majorBase:v,majorMustEqual:h,minorBase:w,minorMustEqual:S,patchBase:A,patchMustEqual:p,isMinimum:l.hasGreaterEquals,notBefore:a}}e.normalizeVersion=k;function _(l,v,h){let w;typeof l=="string"?w=k(n(l)):w=l;let S;v instanceof Date?S=v.getTime():typeof v=="string"&&(S=new Date(v).getTime());let A;if(typeof h=="string"?A=k(n(h)):A=h,!w||!A)return!1;let p=w.majorBase,a=w.minorBase,r=w.patchBase,g=A.majorBase,s=A.minorBase,b=A.patchBase,i=A.notBefore,t=A.majorMustEqual,c=A.minorMustEqual,d=A.patchMustEqual;return A.isMinimum?p>g?!0:p<g?!1:a>s?!0:a<s||S&&S<i?!1:r>=b:(p===1&&g===0&&(!t||!c||!d)&&(g=1,s=0,b=0,t=!0,c=!1,d=!1),p<g?!1:p>g?!t:a<s?!1:a>s?!c:r<b?!1:r>b?!d:!(S&&S<i))}e.isValidVersion=_;function D(l,v,h,w){return h.isBuiltin||typeof h.main=="undefined"?!0:I(l,v,h.engines.vscode,w)}e.isValidExtensionVersion=D;function P(l,v,h){return l==="*"||I(v,h,l)}e.isEngineValid=P;function I(l,v,h,w=[]){let S=k(n(h));if(!S)return w.push(m.localize(0,null,h)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return w.push(m.localize(1,null,h)),!1}else if(!S.majorMustEqual)return w.push(m.localize(2,null,h)),!1;return _(l,v,S)?!0:(w.push(m.localize(3,null,l,h)),!1)}}),define(fe[115],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(y,C=[],n=!1){this.ctor=y,this.staticArguments=C,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=m}),define(fe[83],me([0,1,115]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function y(n,k,_){k instanceof m.SyncDescriptor||(k=new m.SyncDescriptor(k,[],_)),L.push([n,k])}e.registerSingleton=y;function C(){return L}e.getSingletonServiceDescriptors=C}),define(fe[179],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let n of this._nodes.values())n.outgoing.size===0&&C.push(n);return C}insertEdge(C,n){const k=this.lookupOrInsertNode(C),_=this.lookupOrInsertNode(n);k.outgoing.set(this._hashFn(n),_),_.incoming.set(this._hashFn(C),k)}removeNode(C){const n=this._hashFn(C);this._nodes.delete(n);for(let k of this._nodes.values())k.outgoing.delete(n),k.incoming.delete(n)}lookupOrInsertNode(C){const n=this._hashFn(C);let k=this._nodes.get(n);return k||(k=new m(C),this._nodes.set(n,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[n,k]of this._nodes)C.push(`${n}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,n]of this._nodes){const k=new Set([C]),_=this._findCycle(n,k);if(_)return _}}_findCycle(C,n){for(let[k,_]of C.outgoing){if(n.has(k))return[...n,k].join(" -> ");n.add(k);const D=this._findCycle(_,n);if(D)return D;n.delete(k)}}}e.Graph=L}),define(fe[4],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function k(_){return _[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=k})(m=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function L(n,k,_,D){k[m.DI_TARGET]===k?k[m.DI_DEPENDENCIES].push({id:n,index:_,optional:D}):(k[m.DI_DEPENDENCIES]=[{id:n,index:_,optional:D}],k[m.DI_TARGET]=k)}function y(n){if(m.serviceIds.has(n))return m.serviceIds.get(n);const k=function(_,D,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,_,P,!1)};return k.toString=()=>n,m.serviceIds.set(n,k),k}e.createDecorator=y;function C(n){return n}e.refineServiceDecorator=C}),define(fe[180],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function L(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(fe[181],me([0,1,3,48,6,24,77,82,180]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function D(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(D):!!w.exclusive}class P{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(S,A){let p={selector:S,provider:A,_score:-1,_time:this._clock++};return this._entries.push(p),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,y.toDisposable)(()=>{if(p){let a=this._entries.indexOf(p);a>=0&&(this._entries.splice(a,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),p=void 0)}})}has(S){return this.all(S).length>0}all(S){if(!S)return[];this._updateScores(S);const A=[];for(let p of this._entries)p._score>0&&A.push(p.provider);return A}ordered(S){const A=[];return this._orderedForEach(S,p=>A.push(p.provider)),A}orderedGroups(S){const A=[];let p,a;return this._orderedForEach(S,r=>{p&&a===r._score?p.push(r.provider):(a=r._score,p=[r.provider],A.push(p))}),A}_orderedForEach(S,A){if(!!S){this._updateScores(S);for(const p of this._entries)p._score>0&&A(p)}}_updateScores(S){let A={uri:S.uri.toString(),language:S.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===A.language&&this._lastCandidate.uri===A.uri)){this._lastCandidate=A;for(let p of this._entries)if(p._score=(0,k.score)(p.selector,S.uri,S.getLanguageId(),(0,_.shouldSynchronizeModel)(S)),D(p.selector)&&p._score>0){for(let a of this._entries)a._score=0;p._score=1e3;break}this._entries.sort(P._compareByScoreAndTime)}}static _compareByScoreAndTime(S,A){return S._score<A._score?1:S._score>A._score?-1:S._time<A._time?1:S._time>A._time?-1:0}}e.LanguageFeatureRegistry=P;const I=new WeakMap;let l=0;function v(w){let S=I.get(w);return S===void 0&&(S=++l,I.set(w,S)),S}class h{constructor(S,A,p=Number.MAX_SAFE_INTEGER){this._registry=S,this.min=A,this.max=p,this._cache=new C.LRUCache(50,.7)}_key(S){return S.id+this._registry.all(S).reduce((A,p)=>(0,L.doHash)(v(p),A),0)}_clamp(S){return S===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(S*1.3)))}get(S){const A=this._key(S),p=this._cache.get(A);return this._clamp(p?.value)}update(S,A){const p=this._key(S);let a=this._cache.get(p);return a||(a=new n.MovingAverage,this._cache.set(p,a)),a.update(A),this.get(S)}}e.LanguageFeatureRequestDelays=h}),define(fe[84],me([0,1,2,41,181,148,78]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var _;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(_=e.FontStyle||(e.FontStyle={}));var D;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(D=e.ColorId||(e.ColorId={}));var P;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class l{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let T=this.getForeground(E),R="mtk"+T,B=this.getFontStyle(E);return B&1&&(R+=" mtki"),B&2&&(R+=" mtkb"),B&4&&(R+=" mtku"),R}static getInlineStyleFromMetadata(E,T){const R=this.getForeground(E),B=this.getFontStyle(E);let x=`color: ${T[R]};`;return B&1&&(x+="font-style: italic;"),B&2&&(x+="font-weight: bold;"),B&4&&(x+="text-decoration: underline;"),x}}e.TokenMetadata=l;var v;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(v=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(E){const T=u[E];let R=T&&n.iconRegistry.get(T);return R||(console.info("No codicon found for CompletionItemKind "+E),R=n.Codicon.symbolProperty),R.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(E,T){let R=u[E];return typeof R=="undefined"&&!T&&(R=9),R}}();var h;(function(u){u[u.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var S;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(S=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var A;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(A=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var a;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(a=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var r;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(r=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(u){return u&&m.URI.isUri(u.uri)&&L.Range.isIRange(u.range)&&(L.Range.isIRange(u.originSelectionRange)||L.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=g;var s;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var b;(function(u){u[u.Deprecated=1]="Deprecated"})(b=e.SymbolTag||(e.SymbolTag={}));var i;(function(u){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const T=new Map;T.set(0,"file"),T.set(1,"module"),T.set(2,"namespace"),T.set(3,"package"),T.set(4,"class"),T.set(5,"method"),T.set(6,"property"),T.set(7,"field"),T.set(8,"constructor"),T.set(9,"enum"),T.set(10,"interface"),T.set(11,"function"),T.set(12,"variable"),T.set(13,"constant"),T.set(14,"string"),T.set(15,"number"),T.set(16,"boolean"),T.set(17,"array"),T.set(18,"object"),T.set(19,"key"),T.set(20,"null"),T.set(21,"enum-member"),T.set(22,"struct"),T.set(23,"event"),T.set(24,"operator"),T.set(25,"type-parameter");function R(F){return E.get(F)}u.fromString=R;function B(F){return T.get(F)}u.toString=B;function x(F,$){const M=T.get(F);let H=M&&n.iconRegistry.get("symbol-"+M);return H||(console.info("No codicon found for SymbolKind "+F),H=n.Codicon.symbolProperty),`${$?"inline":"block"} ${H.classNames}`}u.toCssClassName=x})(i=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(E){this.value=E}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var c;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var d;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(d=e.CommentMode||(e.CommentMode={}));var o;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(o=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new y.LanguageFeatureRegistry,e.RenameProviderRegistry=new y.LanguageFeatureRegistry,e.CompletionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new y.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new y.LanguageFeatureRegistry,e.HoverProviderRegistry=new y.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new y.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new y.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new y.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new y.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new y.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.LinkProviderRegistry=new y.LanguageFeatureRegistry,e.ColorProviderRegistry=new y.LanguageFeatureRegistry,e.SelectionRangeRegistry=new y.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var f;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(f=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[61],me([0,1,12,8,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const n=new Map;n.set("false",!1),n.set("true",!0),n.set("isMac",m.isMacintosh),n.set("isLinux",m.isLinux),n.set("isWindows",m.isWindows),n.set("isWeb",m.isWeb),n.set("isMacNative",m.isMacintosh&&!m.isWeb),n.set("isEdge",C.indexOf("Edg/")>=0),n.set("isFirefox",C.indexOf("Firefox")>=0),n.set("isChrome",C.indexOf("Chrome")>=0),n.set("isSafari",C.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var _;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return l.INSTANCE}static true(){return v.INSTANCE}static has(F){return h.create(F)}static equals(F,$){return w.create(F,$)}static notEquals(F,$){return p.create(F,$)}static regex(F,$){return t.create(F,$)}static in(F,$){return S.create(F,$)}static not(F){return a.create(F)}static and(...F){return o.create(F,null)}static or(...F){return f.create(F,null,!0)}static greater(F,$){return g.create(F,$)}static greaterEquals(F,$){return s.create(F,$)}static smaller(F,$){return b.create(F,$)}static smallerEquals(F,$){return i.create(F,$)}static deserialize(F,$=!1){if(!!F)return this._deserializeOrExpression(F,$)}static _deserializeOrExpression(F,$){let M=F.split("||");return f.create(M.map(H=>this._deserializeAndExpression(H,$)),null,!0)}static _deserializeAndExpression(F,$){let M=F.split("&&");return o.create(M.map(H=>this._deserializeOne(H,$)),null)}static _deserializeOne(F,$){if(F=F.trim(),F.indexOf("!=")>=0){let M=F.split("!=");return p.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("==")>=0){let M=F.split("==");return w.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("=~")>=0){let M=F.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],$))}if(F.indexOf(" in ")>=0){let M=F.split(" in ");return S.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const M=F.split(">=");return s.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const M=F.split(">");return g.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const M=F.split("<=");return i.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const M=F.split("<");return b.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(F)?a.create(F.substr(1).trim()):h.create(F)}static _deserializeValue(F,$){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let M=/^'([^']*)'$/.exec(F);return M?M[1].trim():F}static _deserializeRegexValue(F,$){if((0,L.isFalsyOrWhitespace)(F)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=F.indexOf("/"),H=F.lastIndexOf("/");if(M===H||M<0){if($)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let N=F.slice(M+1,H),U=F[H+1]==="i"?"i":"";try{return new RegExp(N,U)}catch(V){if($)throw new Error(`bad regexp-value '${F}', parse error: ${V}`);return console.warn(`bad regexp-value '${F}', parse error: ${V}`),null}}}e.ContextKeyExpr=D;function P(x,F){const $=x?x.substituteConstants():void 0,M=F?F.substituteConstants():void 0;return!$&&!M?!0:!$||!M?!1:$.equals(M)}e.expressionsAreEqualWithConstantSubstitution=P;function I(x,F){return x.cmp(F)}class l{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=l,l.INSTANCE=new l;class v{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return l.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class h{constructor(F,$){this.key=F,this.negated=$,this.type=2}static create(F,$=null){const M=n.get(F);return typeof M=="boolean"?M?v.INSTANCE:l.INSTANCE:new h(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:E(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=n.get(this.key);return typeof F=="boolean"?F?v.INSTANCE:l.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class w{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=4}static create(F,$,M=null){if(typeof $=="boolean")return $?h.create(F,M):a.create(F,M);const H=n.get(F);return typeof H=="boolean"?$===(H?"true":"false")?v.INSTANCE:l.INSTANCE:new w(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=n.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?v.INSTANCE:l.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class S{constructor(F,$){this.key=F,this.valueKey=$,this.type=10,this.negated=null}static create(F,$){return new S(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.valueKey),M=F.getValue(this.key);return Array.isArray($)?$.indexOf(M)>=0:typeof M=="string"&&typeof $=="object"&&$!==null?k.call($,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=A.create(this)),this.negated}}e.ContextKeyInExpr=S;class A{constructor(F){this._actual=F,this.type=11}static create(F){return new A(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new A(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=A;class p{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=5}static create(F,$,M=null){if(typeof $=="boolean")return $?a.create(F,M):h.create(F,M);const H=n.get(F);return typeof H=="boolean"?$===(H?"true":"false")?l.INSTANCE:v.INSTANCE:new p(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=n.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?l.INSTANCE:v.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class a{constructor(F,$){this.key=F,this.negated=$,this.type=3}static create(F,$=null){const M=n.get(F);return typeof M=="boolean"?M?l.INSTANCE:v.INSTANCE:new a(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:E(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=n.get(this.key);return typeof F=="boolean"?F?l.INSTANCE:v.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=a;function r(x,F){if(typeof x=="string"){const $=parseFloat(x);isNaN($)||(x=$)}return typeof x=="string"||typeof x=="number"?F(x):l.INSTANCE}class g{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=12}static create(F,$,M=null){return r($,H=>new g(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class s{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=13}static create(F,$,M=null){return r($,H=>new s(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=s;class b{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=14}static create(F,$,M=null){return r($,H=>new b(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=b;class i{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=15}static create(F,$,M=null){return r($,H=>new i(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class t{constructor(F,$){this.key=F,this.regexp=$,this.type=7,this.negated=null}static create(F,$){return new t(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return $<M?-1:$>M?1:0}equals(F){if(F.type===this.type){const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return this.key===F.key&&$===M}return!1}substituteConstants(){return this}evaluate(F){let $=F.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=c.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class c{constructor(F){this._actual=F,this.type=8}static create(F){return new c(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new c(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=c;function d(x){let F=null;for(let $=0,M=x.length;$<M;$++){const H=x[$].substituteConstants();if(x[$]!==H&&F===null){F=[];for(let N=0;N<$;N++)F[N]=x[N]}F!==null&&(F[$]=H)}return F===null?x:F}class o{constructor(F,$){this.expr=F,this.negated=$,this.type=6}static create(F,$){return o._normalizeArr(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const H=I(this.expr[$],F.expr[$]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:o.create(F,this.negated)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].evaluate(F))return!1;return!0}static _normalizeArr(F,$){const M=[];let H=!1;for(const N of F)if(!!N){if(N.type===1){H=!0;continue}if(N.type===0)return l.INSTANCE;if(N.type===6){M.push(...N.expr);continue}M.push(N)}if(M.length===0&&H)return v.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(I);for(let N=1;N<M.length;N++)M[N-1].equals(M[N])&&(M.splice(N,1),N--);if(M.length===1)return M[0];for(;M.length>1;){const N=M[M.length-1];if(N.type!==9)break;M.pop();const U=M.pop(),V=M.length===0,O=f.create(N.expr.map(W=>o.create([W,U],null)),null,V);O&&(M.push(O),M.sort(I))}return M.length===1?M[0]:new o(M,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new o(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){const F=[];for(let $ of this.expr)F.push($.negate());this.negated=f.create(F,this,!0)}return this.negated}}class f{constructor(F,$){this.expr=F,this.negated=$,this.type=9}static create(F,$,M){return f._normalizeArr(F,$,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const H=I(this.expr[$],F.expr[$]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=d(this.expr);return F===this.expr?this:f.create(F,this.negated,!1)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(this.expr[$].evaluate(F))return!0;return!1}static _normalizeArr(F,$,M){let H=[],N=!1;if(F){for(let U=0,V=F.length;U<V;U++){const O=F[U];if(!!O){if(O.type===0){N=!0;continue}if(O.type===1)return v.INSTANCE;if(O.type===9){H=H.concat(O.expr);continue}H.push(O)}}if(H.length===0&&N)return l.INSTANCE;H.sort(I)}if(H.length!==0){if(H.length===1)return H[0];for(let U=1;U<H.length;U++)H[U-1].equals(H[U])&&(H.splice(U,1),U--);if(H.length===1)return H[0];if(M){for(let U=0;U<H.length;U++)for(let V=U+1;V<H.length;V++)R(H[U],H[V])&&(H.splice(V,1),V--);if(H.length===1)return H[0]}return new f(H,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new f(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){let F=[];for(let $ of this.expr)F.push($.negate());for(;F.length>1;){const $=F.shift(),M=F.shift(),H=[];for(const U of B($))for(const V of B(M))H.push(o.create([U,V],null));const N=F.length===0;F.unshift(f.create(H,null,N))}this.negated=F[0]}return this.negated}}class u extends h{constructor(F,$,M){super(F,null);this._defaultValue=$,typeof M=="object"?u._info.push({...M,key:F}):M!==!0&&u._info.push({key:F,description:M,type:$!=null?typeof $:void 0})}static all(){return u._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return w.create(this.key,F)}notEqualsTo(F){return p.create(this.key,F)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(x,F){return x<F?-1:x>F?1:0}function T(x,F,$,M){return x<$?-1:x>$?1:F<M?-1:F>M?1:0}function R(x,F){if(F.type===6&&x.type!==9&&x.type!==6){for(const H of F.expr)if(x.equals(H))return!0}const $=x.negate(),M=B($).concat(B(F));M.sort(I);for(let H=0;H<M.length;H++){const U=M[H].negate();for(let V=H+1;V<M.length;V++){const O=M[V];if(U.equals(O))return!0}}return!1}e.implies=R;function B(x){return x.type===9?x.expr:[x]}}),define(fe[182],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[183],me([0,1,10,156,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(a){a.WIN32_X64="win32-x64",a.WIN32_IA32="win32-ia32",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function n(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function k(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function _(a,r){switch(a){case 3:return r==="x64"?"win32-x64":r==="ia32"?"win32-ia32":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function D(a,r){return r==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function P(a,r,g){return D(r,g)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===g?!0:I(g).includes(a)}e.isTargetPlatformCompatible=P;function I(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function l(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=l;var v;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var h;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var w;(function(a){a.Install="install",a.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var S;(function(a){a[a.None=0]="None",a[a.Install=1]="Install",a[a.Update=2]="Update"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var A;(function(a){a.Unsupported="Unsupported",a.Malicious="Malicious",a.Incompatible="Incompatible",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(A=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class p extends Error{constructor(r,g){super(r);this.code=g,this.name=g}}e.ExtensionManagementError=p,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(fe[184],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(fe[185],me([0,1,38,10,9,12,95,28,113,158,184]),function(Y,e,m,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=D.localize(0,null);class l{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends l{openTerminal(r,g){return this.spawnTerminal(m,r,_.getWindowsShell(),g)}spawnTerminal(r,g,s,b){const i=g.windowsExec||v.getDefaultTerminalWindows();b&&b[1]===":"&&(b=b[0].toUpperCase()+b.substr(1));const t=y.basename(i).toLowerCase();if(t==="cmder"||t==="cmder.exe")return r.spawn(i,b?[b]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return i.indexOf(" ")>=0&&c.push('""'),c.push(i),(t==="wt"||t==="wt.exe")&&c.push("-d ."),new Promise((d,o)=>{const f=S(process),u=r.spawn(s,c,{cwd:b,env:f});u.on("error",o),u.on("exit",()=>d())})}runInTerminal(r,g,s,b,i){const t="windowsExec"in i&&i.windowsExec?i.windowsExec:v.getDefaultTerminalWindows();return new Promise((c,d)=>{const o=`"${g} - ${I}"`,f=`""${s.join('" "')}" & pause"`,u=["/c","start",o,"/wait",t,"/c",f],E=Object.assign({},S(process),b);Object.keys(E).filter(B=>E[B]===null).forEach(B=>delete E[B]);const T={cwd:g,env:E,windowsVerbatimArguments:!0};m.spawn(v.CMD,u,T).on("error",B=>{d(A(B))}),c(void 0)})}static getDefaultTerminalWindows(){if(!v._DEFAULT_TERMINAL_WINDOWS){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return v._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=v,v.CMD="cmd.exe";class h extends l{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,s,b,i){const t=i.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((c,d)=>{if(t===P.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const o=t===P.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,Y).fsPath,"-t",r||I,"-w",g];for(let R of s)u.push("-a"),u.push(R);if(b){const R=Object.assign({},S(process),b);for(let B in R){const x=R[B];x===null?(u.push("-u"),u.push(B)):(u.push("-e"),u.push(`${B}=${x}`))}}let E="";const T=m.spawn(h.OSASCRIPT,u);T.on("error",R=>{d(A(R))}),T.stderr.on("data",R=>{E+=R.toString()}),T.on("exit",R=>{if(R===0)c(void 0);else if(E){const B=E.split(`
`,1);d(new Error(B[0]))}else d(new Error(D.localize(1,null,o,R)))})}else d(new Error(D.localize(2,null,t)))})}spawnTerminal(r,g,s){const b=g.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((i,t)=>{const c=["-a",b];s&&c.push(s);const d=S(process),o=r.spawn("/usr/bin/open",c,{cwd:s,env:d});o.on("error",t),o.on("exit",()=>i())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class w extends l{openTerminal(r,g){return this.spawnTerminal(m,r,g)}runInTerminal(r,g,s,b,i){const t=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((c,d)=>{let o=[];t.then(f=>{f.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const u=`${p(s)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;o.push(`''${u}''`);const E=Object.assign({},S(process),b);Object.keys(E).filter(x=>E[x]===null).forEach(x=>delete E[x]);const T={cwd:g,env:E};let R="";const B=m.spawn(f,o,T);B.on("error",x=>{d(A(x))}),B.stderr.on("data",x=>{R+=x.toString()}),B.on("exit",x=>{if(x===0)c(void 0);else if(R){const F=R.split(`
`,1);d(new Error(F[0]))}else d(new Error(D.localize(4,null,f,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const r=await k.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{r?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(r,g,s){const b=g.linuxExec?Promise.resolve(g.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,t)=>{b.then(c=>{const d=S(process),o=r.spawn(c,[],{cwd:s,env:d});o.on("error",t),o.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=D.localize(3,null);function S(a){const r={...a.env};return(0,n.sanitizeProcessEnvironment)(r),r}function A(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(D.localize(5,null,a.path)):a}function p(a){let r="";for(let g of a)g.indexOf(" ")>=0?r+='"'+g+'"':r+=g,r+=" ";return r}}),define(fe[42],me([0,1,24,9,8,13,2,159,4]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function D(M){return M.create===!0}e.isFileOpenForWriteOptions=D;var P;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var I;(function(M){M[M.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var l;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=v;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function w(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function S(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=S;var A;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(H,N){super(H);this.code=N}}e.FileSystemProviderError=p;function a(M,H){const N=new p(M.toString(),H);return g(N,H),N}e.createFileSystemProviderError=a;function r(M){return M||a((0,k.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=r;function g(M,H){return M.name=H?`${H} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=g;function s(M){if(!M)return A.Unknown;if(M instanceof p)return M.code;const H=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!H)return A.Unknown;switch(H[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=s;function b(M){if(M instanceof f)return M.fileOperationResult;switch(s(M)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=b;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class t{constructor(H,N,U){this.resource=H,this.operation=N,this.target=U}isOperation(H){return this.operation===H}}e.FileOperationEvent=t;var c;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class d{constructor(H,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;const U=new Map;for(const V of H){const O=U.get(V.type);O?O.push([V.resource,V]):U.set(V.type,[[V.resource,V]])}for(const[V,O]of U)switch(V){case 1:this.added=m.TernarySearchTree.forUris(()=>N),this.added.fill(O);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>N),this.updated.fill(O);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>N),this.deleted.fill(O);break}}contains(H,...N){return this.doContains(H,{includeChildren:!1},...N)}affects(H,...N){return this.doContains(H,{includeChildren:!0},...N)}doContains(H,N,...U){if(!H)return!1;const V=U.length>0;return!!((!V||U.includes(1))&&(this.added?.get(H)||N.includeChildren&&this.added?.findSuperstr(H))||(!V||U.includes(0))&&(this.updated?.get(H)||N.includeChildren&&this.updated?.findSuperstr(H))||(!V||U.includes(2))&&(this.deleted?.findSubstr(H)||N.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function o(M,H,N){return!M||!H||M===H||H.length>M.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),N?(0,y.startsWithIgnoreCase)(M,H):M.indexOf(H)===0)}e.isParent=o;class f extends Error{constructor(H,N,U){super(H);this.fileOperationResult=N,this.options=U}}e.FileOperationError=f;class u extends f{constructor(H,N,U){super(H,2,U);this.stat=N}}e.NotModifiedSinceFileOperationError=u;var E;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=R;async function B(M,H){if(!H.hasProvider(n.URI.from({scheme:M.scheme})))return new Promise(N=>{const U=H.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===M.scheme&&V.added&&(U.dispose(),N())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(H){return(0,C.isNumber)(H)||(H=0),H<x.KB?(0,k.localize)(1,null,H.toFixed(0)):H<x.MB?(0,k.localize)(2,null,(H/x.KB).toFixed(2)):H<x.GB?(0,k.localize)(3,null,(H/x.MB).toFixed(2)):H<x.TB?(0,k.localize)(4,null,(H/x.GB).toFixed(2)):(0,k.localize)(5,null,(H/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(M){return{maxFileSize:M===0?300*x.MB:16*x.GB,maxHeapSize:M===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=$}),define(fe[85],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...y){this._entries=new Map;for(let[C,n]of y)this.set(C,n)}set(y,C){const n=this._entries.get(y);return this._entries.set(y,C),n}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=m}),define(fe[186],me([0,1,18,16,115,179,4,85]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class D extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class P{constructor(h=new k.ServiceCollection,w=!1,S){this._activeInstantiations=new Set,this._services=h,this._strict=w,this._parent=S,this._services.set(n.IInstantiationService,this)}createChild(h){return new P(h,this._strict,this)}invokeFunction(h,...w){let S=l.traceInvocation(h),A=!1;try{return h({get:a=>{if(A)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(a,S);if(!r)throw new Error(`[invokeFunction] unknown service '${a}'`);return r}},...w)}finally{A=!0,S.stop()}}createInstance(h,...w){let S,A;return h instanceof y.SyncDescriptor?(S=l.traceCreation(h.ctor),A=this._createInstance(h.ctor,h.staticArguments.concat(w),S)):(S=l.traceCreation(h),A=this._createInstance(h,w,S)),S.stop(),A}_createInstance(h,w=[],S){let A=n._util.getServiceDependencies(h).sort((r,g)=>r.index-g.index),p=[];for(const r of A){let g=this._getOrCreateServiceInstance(r.id,S);if(!g&&this._strict&&!r.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${r.id}.`);p.push(g)}let a=A.length>0?A[0].index:w.length;if(w.length!==a){console.warn(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${w.length} static arguments`);let r=a-w.length;r>0?w=w.concat(new Array(r)):w=w.slice(0,a)}return new h(...[...w,...p])}_setServiceInstance(h,w){if(this._services.get(h)instanceof y.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){let S=this._getServiceInstanceOrDescriptor(h);return S instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,S,w.branch(h,!0)):(w.branch(h,!1),S)}_safeCreateAndCacheServiceInstance(h,w,S){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,S)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,S){const A=new C.Graph(r=>r.id.toString());let p=0;const a=[{id:h,desc:w,_trace:S}];for(;a.length;){const r=a.pop();if(A.lookupOrInsertNode(r),p++>1e3)throw new D(A);for(let g of n._util.getServiceDependencies(r.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(g.id);if(!s&&!g.optional&&console.warn(`[createInstance] ${h} depends on ${g.id} which is NOT registered.`),s instanceof y.SyncDescriptor){const b={id:g.id,desc:s,_trace:r._trace.branch(g.id,!0)};A.insertEdge(r,b),a.push(b)}}}for(;;){const r=A.roots();if(r.length===0){if(!A.isEmpty())throw new D(A);break}for(const{data:g}of r){if(this._getServiceInstanceOrDescriptor(g.id)instanceof y.SyncDescriptor){const b=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,b)}A.removeNode(g)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,S=[],A,p){if(this._services.get(h)instanceof y.SyncDescriptor)return this._createServiceInstance(w,S,A,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,S,A,p);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w=[],S,A){if(S){const p=new m.IdleValue(()=>this._createInstance(h,w,A));return new Proxy(Object.create(null),{get(a,r){if(r in a)return a[r];let g=p.value,s=g[r];return typeof s!="function"||(s=s.bind(g),a[r]=s),s},set(a,r,g){return p.value[r]=g,!0}})}else return this._createInstance(h,w,A)}}e.InstantiationService=P;var I;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(I||(I={}));class l{constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return _?new l(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(h){return _?new l(0,h.name):l._None}branch(h,w){let S=new l(2,h.toString());return this._dep.push([h,w,S]),S}stop(){let h=Date.now()-this._start;l._totals+=h;let w=!1;function S(p,a){let r=[],g=new Array(p+1).join("	");for(const[s,b,i]of a._dep)if(b&&i){w=!0,r.push(`${g}CREATES -> ${s}`);let t=S(p+1,i);t&&r.push(t)}else r.push(`${g}uses -> ${s}`);return r.join(`
`)}let A=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(h>2||w)&&console.log(A.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(fe[11],me([0,1,51,3,6,12,4]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,n.createDecorator)("logService"),e.ILoggerService=(0,n.createDecorator)("loggerService");function k(){return new Date().toISOString()}var _;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;function D(b,i,t){switch(i){case _.Trace:b.trace(t);break;case _.Debug:b.debug(t);break;case _.Info:b.info(t);break;case _.Warning:b.warn(t);break;case _.Error:b.error(t);break;case _.Critical:b.critical(t);break;default:throw new Error("Invalid log level")}}e.log=D;function P(b){let i="";for(let t=0;t<b.length;t++){let c=b[t];if(typeof c=="object")try{c=JSON.stringify(c)}catch(d){}i+=(t>0?" ":"")+c}return i}e.format=P;class I extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class l extends I{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(_.Trace)&&this.log(_.Trace,P([i,...t]))}debug(i,...t){this.checkLogLevel(_.Debug)&&this.log(_.Debug,P([i,...t]))}info(i,...t){this.checkLogLevel(_.Info)&&this.log(_.Info,P([i,...t]))}warn(i,...t){this.checkLogLevel(_.Warning)&&this.log(_.Warning,P([i,...t]))}error(i,...t){if(this.checkLogLevel(_.Error))if(i instanceof Error){const c=Array.prototype.slice.call(arguments);c[0]=i.stack,this.log(_.Error,P(c))}else this.log(_.Error,P([i,...t]))}critical(i,...t){this.checkLogLevel(_.Critical)&&this.log(_.Critical,P([i,...t]))}flush(){}}e.AbstractMessageLogger=l;class v extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!C.isWindows}trace(i,...t){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...t):console.log(`[main ${k()}]`,i,...t))}debug(i,...t){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...t):console.log(`[main ${k()}]`,i,...t))}info(i,...t){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...t):console.log(`[main ${k()}]`,i,...t))}warn(i,...t){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,i,...t):console.warn(`[main ${k()}]`,i,...t))}error(i,...t){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,i,...t):console.error(`[main ${k()}]`,i,...t))}critical(i,...t){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,i,...t):console.error(`[main ${k()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class w extends I{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,m.toErrorMessage)(i,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class S extends I{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const c of this.logServices)c.trace(i,...t)}debug(i,...t){for(const c of this.logServices)c.debug(i,...t)}info(i,...t){for(const c of this.logServices)c.info(i,...t)}warn(i,...t){for(const c of this.logServices)c.warn(i,...t)}error(i,...t){for(const c of this.logServices)c.error(i,...t)}critical(i,...t){for(const c of this.logServices)c.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=S;class A extends y.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=A;class p extends y.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(c=>{this.logLevel=c,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(c))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let c=this.loggers.get(i.toString());return c||(c=this.doCreateLogger(i,t?.always?_.Trace:this.logLevel,t),this.loggers.set(i.toString(),c),t?.always||this.logLevelChangeableLoggers.push(c)),c}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class a{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return _.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=a;function r(b){if(b.verbose)return _.Trace;if(typeof b.logLevel=="string"){const i=g(b.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function g(b){switch(b){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=g;function s(b){switch(b){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=s}),define(fe[187],me([0,1,42,11]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function y(_,D,P,I,l){try{const v=await new Promise((w,S)=>{Y(["spdlog"],w,S)});v.setFlushOn(L.LogLevel.Trace);const h=await v.createAsyncRotatingLogger(_,D,P,I);return l&&h.clearFormatters(),h}catch(v){console.error(v)}return null}function C(_,D,P,I){const l=Y.__$__nodeRequire("spdlog");return l.setFlushOn(L.LogLevel.Trace),l.createRotatingLogger(_,D,P,I)}e.createRotatingLogger=C;function n(_,D,P){switch(D){case L.LogLevel.Trace:_.trace(P);break;case L.LogLevel.Debug:_.debug(P);break;case L.LogLevel.Info:_.info(P);break;case L.LogLevel.Warning:_.warn(P);break;case L.LogLevel.Error:_.error(P);break;case L.LogLevel.Critical:_.critical(P);break;default:throw new Error("Invalid log level")}}class k extends L.AbstractMessageLogger{constructor(D,P,I,l,v){super();this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(D,P,I,l),this._register(this.onDidChangeLogLevel(h=>{this._logger&&this._logger.setLevel(h)}))}async _createSpdLogLogger(D,P,I,l){const v=I?6:1,h=30/v*m.ByteSize.MB,w=await y(D,P,h,v,l);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:S,message:A}of this.buffer)n(this._logger,S,A);this.buffer=[]}}log(D,P){this._logger?n(this._logger,D,P):this.getLevel()<=D&&this.buffer.push({level:D,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(fe[116],me([0,1,49,160,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var n;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(n=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function D(h,w){return w-h}_.compare=D;const P=Object.create(null);P[_.Error]=(0,L.localize)(0,null),P[_.Warning]=(0,L.localize)(1,null),P[_.Info]=(0,L.localize)(2,null);function I(h){return P[h]||""}_.toString=I;function l(h){switch(h){case m.default.Error:return _.Error;case m.default.Warning:return _.Warning;case m.default.Info:return _.Info;case m.default.Ignore:return _.Hint}}_.fromSeverity=l;function v(h){switch(h){case _.Error:return m.default.Error;case _.Warning:return m.default.Warning;case _.Info:return m.default.Info;case _.Hint:return m.default.Ignore}}_.toSeverity=v}(n=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(_){const D="";function P(l){return I(l,!0)}_.makeKey=P;function I(l,v){let h=[D];return l.source?h.push(l.source.replace("\xA6","\\\xA6")):h.push(D),l.code?typeof l.code=="string"?h.push(l.code.replace("\xA6","\\\xA6")):h.push(l.code.value.replace("\xA6","\\\xA6")):h.push(D),l.severity!==void 0&&l.severity!==null?h.push(n.toString(l.severity)):h.push(D),l.message&&v?h.push(l.message.replace("\xA6","\\\xA6")):h.push(D),l.startLineNumber!==void 0&&l.startLineNumber!==null?h.push(l.startLineNumber.toString()):h.push(D),l.startColumn!==void 0&&l.startColumn!==null?h.push(l.startColumn.toString()):h.push(D),l.endLineNumber!==void 0&&l.endLineNumber!==null?h.push(l.endLineNumber.toString()):h.push(D),l.endColumn!==void 0&&l.endColumn!==null?h.push(l.endColumn.toString()):h.push(D),h.push(D),h.join("\xA6")}_.makeKeyOptionalMessage=I})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(fe[188],me([0,1,3,49,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,y.createDecorator)("notificationService");var C;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var n;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(n=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new _,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.NoOpNotification=k;class _{infinite(){}done(){}total(P){}worked(P){}}e.NoOpProgress=_}),define(fe[189],me([0,1,6,8,2,4]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function n(_,D){return y.URI.isUri(_)?(0,L.equalsIgnoreCase)(_.scheme,D):(0,L.startsWithIgnoreCase)(_,D+":")}e.matchesScheme=n;function k(_,...D){return D.some(P=>n(_,P))}e.matchesSomeScheme=k}),define(fe[190],me([0,1,10,12,37,23]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const k=L.globals.vscode.context.configuration();if(k)n=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const k=(0,C.dirname)(m.FileAccess.asFileUri("",Y));n=Y.__$__nodeRequire((0,C.joinPath)(k,"product.json").fsPath);const _=Y.__$__nodeRequire((0,C.joinPath)(k,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`}),Object.assign(n,{version:_.version})}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=n});var $e=this&&this.__param||function(Y,e){return function(m,L){e(m,L,Y)}};define(fe[117],me([0,1,18,21,6,4]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var n;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(n=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let _=class extends y.Disposable{constructor(I,l){super();this.deferred=new m.DeferredPromise,l.withProgress(I,v=>(this.reporter=v,this.lastStep&&v.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=Ve([$e(1,e.IProgressService)],_),e.UnmanagedProgress=_;class D extends y.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(I){this.stop();const l=++this.currentOperationId,v=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>v.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:v.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(fe[43],me([0,1,56,13]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(n,k){m.ok(L.isString(n)),m.ok(L.isObject(k)),m.ok(!this.data.has(n),"There is already an extension with this id"),this.data.set(n,k)}knows(n){return this.data.has(n)}as(n){return this.data.get(n)||null}}e.Registry=new y}),define(fe[191],me([0,1,3,43]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,D){this.schemasById[y(_)]=D,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const n=new C;L.Registry.add(e.Extensions.JSONContribution,n)}),define(fe[86],me([0,1,17,3,13,155,191,43]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(r){r.Multiline="multilineText",r.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.MACHINE=2]="MACHINE",r[r.WINDOW=3]="WINDOW",r[r.RESOURCE=4]="RESOURCE",r[r.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",r[r.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=k.Registry.as(n.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,s=!0){this.registerConfigurations([g],s)}registerConfigurations(g,s=!0){const b=this.doRegisterConfigurations(g,s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(b)}deregisterConfigurations(g){const s=this.doDeregisterConfigurations(g);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}updateConfigurations({add:g,remove:s}){const b=[];b.push(...this.doDeregisterConfigurations(s)),b.push(...this.doRegisterConfigurations(g,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,m.distinct)(b))}registerDefaultConfigurations(g){const s=[],b=[];for(const i of g)for(const t in i)if(s.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){this.defaultValues[t]={...this.defaultValues[t]||{},...i[t]};const c={type:"object",default:this.defaultValues[t],description:C.localize(1,null,t),$ref:e.resourceLanguageSettingsSchemaId};b.push(...h(t)),this.configurationProperties[t]=c,this.defaultLanguageConfigurationOverridesNode.properties[t]=c}else{this.defaultValues[t]=i[t];const c=this.configurationProperties[t];c&&(this.updatePropertyDefaultValue(t,c),this.updateSchema(t,c))}this.registerOverrideIdentifiers(b),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(g){const s=[];for(const b of g)for(const i in b)if(s.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const t=this.configurationProperties[i];t&&(this.updatePropertyDefaultValue(i,t),this.updateSchema(i,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const s of g)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,s){const b=[];return g.forEach(i=>{b.push(...this.validateAndRegisterProperties(i,s,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),b}doDeregisterConfigurations(g){const s=[],b=i=>{if(i.properties)for(const t in i.properties)s.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t]);i.allOf&&i.allOf.forEach(t=>b(t))};for(const i of g){b(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}return s}validateAndRegisterProperties(g,s=!0,b,i=3){i=y.isUndefinedOrNull(g.scope)?i:g.scope;let t=[],c=g.properties;if(c)for(let o in c){if(s&&p(o)){delete c[o];continue}const f=c[o];if(this.updatePropertyDefaultValue(o,f),e.OVERRIDE_PROPERTY_REGEX.test(o)?f.scope=void 0:(f.scope=y.isUndefinedOrNull(f.scope)?i:f.scope,f.restricted=y.isUndefinedOrNull(f.restricted)?!!b?.restrictedConfigurations?.includes(o):f.restricted),c[o].hasOwnProperty("included")&&!c[o].included){this.excludedConfigurationProperties[o]=c[o],delete c[o];continue}else this.configurationProperties[o]=c[o];!c[o].deprecationMessage&&c[o].markdownDeprecationMessage&&(c[o].deprecationMessage=c[o].markdownDeprecationMessage),t.push(o)}let d=g.allOf;if(d)for(let o of d)t.push(...this.validateAndRegisterProperties(o,s,b,i));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(g){const s=b=>{let i=b.properties;if(i)for(const c in i)this.updateSchema(c,i[c]);let t=b.allOf;t&&t.forEach(s)};s(g)}updateSchema(g,s){switch(e.allSettings.properties[g]=s,s.scope){case 1:e.applicationSettings.properties[g]=s;break;case 2:e.machineSettings.properties[g]=s;break;case 6:e.machineOverridableSettings.properties[g]=s;break;case 3:e.windowSettings.properties[g]=s;break;case 4:e.resourceSettings.properties[g]=s;break;case 5:e.resourceSettings.properties[g]=s,this.resourceLanguageSettingsSchema.properties[g]=s;break}}removeFromSchema(g,s){switch(delete e.allSettings.properties[g],s.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const s=`[${g}]`,b={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,b),e.allSettings.properties[s]=b,e.applicationSettings.properties[s]=b,e.machineSettings.properties[s]=b,e.machineOverridableSettings.properties[s]=b,e.windowSettings.properties[s]=b,e.resourceSettings.properties[s]=b}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const g={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,s){let b=this.defaultValues[g];y.isUndefined(b)&&(b=s.default),y.isUndefined(b)&&(b=S(s.type)),s.default=b}}const l="\\[([^\\]]+)\\]",v=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(r){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(r)){let s=v.exec(r);for(;s?.length;){const b=s[1].trim();b&&g.push(b),s=v.exec(r)}}return(0,m.distinct)(g)}e.overrideIdentifiersFromKey=h;function w(r){return r.reduce((g,s)=>`${g}[${s}]`,"")}e.keyFromOverrideIdentifiers=w;function S(r){switch(Array.isArray(r)?r[0]:r){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=S;const A=new I;k.Registry.add(e.Extensions.Configuration,A);function p(r){return r.trim()?e.OVERRIDE_PROPERTY_REGEX.test(r)?C.localize(7,null,r):A.getConfigurationProperties()[r]!==void 0?C.localize(8,null,r):null:C.localize(6,null)}e.validateProperty=p;function a(){const r=[],g=A.getConfigurationProperties();for(const s of Object.keys(g))r.push([s,g[s].scope]);return r.push(["launch",4]),r.push(["task",4]),r}e.getScopes=a}),define(fe[118],me([0,1,13,2,86,4,43]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function k(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=k;function _(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||m.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=_;var D;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=P;function I(r,g){const s=Object.create(null);for(let b in r)l(s,b,r[b],g);return s}e.toValuesTree=I;function l(r,g,s,b){const i=g.split("."),t=i.pop();let c=r;for(let d=0;d<i.length;d++){let o=i[d],f=c[o];switch(typeof f){case"undefined":f=c[o]=Object.create(null);break;case"object":break;default:b(`Ignoring ${g} as ${i.slice(0,d+1).join(".")} is ${JSON.stringify(f)}`);return}c=f}if(typeof c=="object"&&c!==null)try{c[t]=s}catch(d){b(`Ignoring ${g} as ${i.join(".")} is ${JSON.stringify(c)}`)}else b(`Ignoring ${g} as ${i.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=l;function v(r,g){const s=g.split(".");h(r,s)}e.removeFromValueTree=v;function h(r,g){const s=g.shift();if(g.length===0){delete r[s];return}if(Object.keys(r).indexOf(s)!==-1){const b=r[s];typeof b=="object"&&!Array.isArray(b)&&(h(b,g),Object.keys(b).length===0&&delete r[s])}}function w(r,g,s){function b(c,d){let o=c;for(const f of d){if(typeof o!="object"||o===null)return;o=o[f]}return o}const i=g.split("."),t=b(r,i);return typeof t=="undefined"?s:t}e.getConfigurationValue=w;function S(r,g,s){Object.keys(g).forEach(b=>{b!=="__proto__"&&(b in r?m.isObject(r[b])&&m.isObject(g[b])?S(r[b],g[b],s):s&&(r[b]=g[b]):r[b]=g[b])})}e.merge=S;function A(){const r=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=A;function p(){const r=Object.create(null),g=n.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(let s in g){let b=g[s].default;l(r,s,b,i=>console.error(`Conflict in default settings: ${i}`))}return r}e.getDefaultValues=p;function a(r,g,s){const b=r.inspect(g),i=r.inspect(s);return typeof b.userValue!="undefined"||typeof b.workspaceValue!="undefined"||typeof b.workspaceFolderValue!="undefined"?b.value:typeof i.userValue!="undefined"||typeof i.workspaceValue!="undefined"||typeof i.workspaceFolderValue!="undefined"?i.value:b.defaultValue}e.getMigratedSettingValue=a}),define(fe[192],me([0,1,17,3,58,6,24,25,13,2,118,86,43]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(i={},t=[],c=[]){this._contents=i,this._keys=t,this._overrides=c,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const c=this.getContentsForOverrideIdentifer(t);return c?i?(0,P.getConfigurationValue)(c,i):c:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const c of this.overrides)c.identifiers.includes(i)&&t.push(...c.keys);return m.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return m.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=k.deepClone(this.contents),c=k.deepClone(this.overrides),d=[...this.keys];for(const o of i){this.mergeContents(t,o.contents);for(const f of o.overrides){const[u]=c.filter(E=>m.equals(E.identifiers,f.identifiers));u?(this.mergeContents(u.contents,f.contents),u.keys.push(...f.keys),u.keys=m.distinct(u.keys)):c.push(k.deepClone(f))}for(const f of o.keys)d.indexOf(f)===-1&&d.push(f)}return new v(t,d,c)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let c={};for(const d of m.distinct([...Object.keys(this.contents),...Object.keys(t)])){let o=this.contents[d],f=t[d];f&&(typeof o=="object"&&typeof f=="object"?(o=k.deepClone(o),this.mergeContents(o,f)):o=f),c[d]=o}return new v(c,this.keys,this.overrides)}mergeContents(i,t){for(const c of Object.keys(t)){if(c in i&&_.isObject(i[c])&&_.isObject(t[c])){this.mergeContents(i[c],t[c]);continue}i[c]=k.deepClone(t[c])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?k.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,c=null;const d=o=>{o&&(c?this.mergeContents(c,o):c=k.deepClone(o))};for(const o of this.overrides)m.equals(o.identifiers,[i])?t=o.contents:o.identifiers.includes(i)&&d(o.contents);return d(t),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,P.addToValueTree)(this.contents,i,t,c=>{throw new Error(c)})}removeValue(i){this.removeKey(i)&&(0,P.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let c=0;c<t;c++)i.indexOf(this.keys[c])===0&&(t=c);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=v;class h extends v{constructor(){const i=(0,P.getDefaultValues)(),t=(0,P.getConfigurationKeys)(),c=[];for(const d of Object.keys(i))I.OVERRIDE_PROPERTY_REGEX.test(d)&&c.push({identifiers:(0,I.overrideIdentifiersFromKey)(d),keys:Object.keys(i[d]),contents:(0,P.toValuesTree)(i[d],o=>console.error(`Conflict in default settings file: ${o}`))});super(i,t,c)}}e.DefaultConfigurationModel=h;class w{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!_.isUndefinedOrNull(i)){const c=this.doParseContent(i);this.parseRaw(c,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:c,keys:d,overrides:o,restricted:f}=this.doParseRaw(i,t);this._configurationModel=new v(c,d,o),this._restrictedConfigurations=f||[]}doParseContent(i){let t={},c=null,d=[],o=[],f=[];function u(T){Array.isArray(d)?d.push(T):c!==null&&(d[c]=T)}let E={onObjectBegin:()=>{let T={};u(T),o.push(d),d=T,c=null},onObjectProperty:T=>{c=T},onObjectEnd:()=>{d=o.pop()},onArrayBegin:()=>{let T=[];u(T),o.push(d),d=T,c=null},onArrayEnd:()=>{d=o.pop()},onLiteralValue:u,onError:(T,R,B)=>{f.push({error:T,offset:R,length:B})}};if(i)try{y.visit(i,E),t=d[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return t}doParseRaw(i,t){const c=l.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),d=this.filter(i,c,!0,t);i=d.raw;const o=(0,P.toValuesTree)(i,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),f=Object.keys(i),u=this.toOverrides(i,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:o,keys:f,overrides:u,restricted:d.restricted}}filter(i,t,c,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:i,restricted:[]};const o={},f=[];for(let u in i)if(I.OVERRIDE_PROPERTY_REGEX.test(u)&&c){const E=this.filter(i[u],t,!1,d);o[u]=E.raw,f.push(...E.restricted)}else{const E=t[u],T=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&f.push(u),(T===void 0||d.scopes===void 0||d.scopes.includes(T))&&(d.skipRestricted&&E?.restricted||(o[u]=i[u]))}return{raw:o,restricted:f}}toOverrides(i,t){const c=[];for(const d of Object.keys(i))if(I.OVERRIDE_PROPERTY_REGEX.test(d)){const o={};for(const f in i[d])o[f]=i[d][f];c.push({identifiers:(0,I.overrideIdentifiersFromKey)(d),keys:Object.keys(o),contents:(0,P.toValuesTree)(o,t)})}return c}}e.ConfigurationModelParser=w;class S extends C.Disposable{constructor(i,t,c,d){super();this.userSettingsResource=i,this.scopes=t,this.fileService=d,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(c.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class A{constructor(i,t,c=new v,d=new v,o=new n.ResourceMap,f=new v,u=new n.ResourceMap,E=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=c,this._workspaceConfiguration=d,this._folderConfigurations=o,this._memoryConfiguration=f,this._memoryConfigurationByResource=u,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new n.ResourceMap,this._userConfiguration=null}getValue(i,t,c){return this.getConsolidateConfigurationModel(t,c).getValue(i)}updateValue(i,t,c={}){let d;c.resource?(d=this._memoryConfigurationByResource.get(c.resource),d||(d=new v,this._memoryConfigurationByResource.set(c.resource,d))):d=this._memoryConfiguration,t===void 0?d.removeValue(i):d.setValue(i,t),c.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,c){const d=this.getConsolidateConfigurationModel(t,c),o=this.getFolderConfigurationModelForResource(t.resource,c),f=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,u=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),E=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),T=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),R=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),B=c?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,x=o?t.overrideIdentifier?o.freeze().override(t.overrideIdentifier).getValue(i):o.freeze().getValue(i):void 0,F=t.overrideIdentifier?f.override(t.overrideIdentifier).getValue(i):f.getValue(i),$=d.getValue(i),M=m.distinct(m.flatten(d.overrides.map(H=>H.identifiers))).filter(H=>d.getOverrideValue(i,H)!==void 0);return{defaultValue:u,userValue:E,userLocalValue:T,userRemoteValue:R,workspaceValue:B,workspaceFolderValue:x,memoryValue:F,value:$,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:R!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:x!==void 0?{value:o?.freeze().getValue(i),override:t.overrideIdentifier?o?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:f.getValue(i),override:t.overrideIdentifier?f.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const c=[];for(const d of t)for(const o of(0,I.overrideIdentifiersFromKey)(d)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(o),u=i.getKeysForOverrideIdentifier(o),E=[...u.filter(T=>f.indexOf(T)===-1),...f.filter(T=>u.indexOf(T)===-1),...f.filter(T=>!k.equals(this._defaultConfiguration.override(o).getValue(T),i.override(o).getValue(T)))];c.push([o,E])}return this.updateDefaultConfiguration(i),{keys:t,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:c,removed:d,overrides:o}=g(this.localUserConfiguration,i),f=[...t,...c,...d];return f.length&&this.updateLocalUserConfiguration(i),{keys:f,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:c,removed:d,overrides:o}=g(this.remoteUserConfiguration,i);let f=[...t,...c,...d];return f.length&&this.updateRemoteUserConfiguration(i),{keys:f,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:c,removed:d,overrides:o}=g(this.workspaceConfiguration,i);let f=[...t,...c,...d];return f.length&&this.updateWorkspaceConfiguration(i),{keys:f,overrides:o}}compareAndUpdateFolderConfiguration(i,t){const c=this.folderConfigurations.get(i),{added:d,updated:o,removed:f,overrides:u}=g(c,t);let E=[...d,...o,...f];return(E.length||!c)&&this.updateFolderConfiguration(i,t),{keys:E,overrides:u}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:c,updated:d,removed:o,overrides:f}=g(t,void 0);return{keys:[...c,...d,...o],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let c=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?c.override(i.overrideIdentifier):c}getConsolidatedConfigurationModelForResource({resource:i},t){let c=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const d=t.getFolder(i);d&&(c=this.getFolderConsolidatedConfiguration(d.uri)||c);const o=this._memoryConfigurationByResource.get(i);o&&(c=c.merge(o))}return c}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const c=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(i);d?(t=c.merge(d),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=c}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const c=t.getFolder(i);if(c)return this._folderConfigurations.get(c.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:c,overrides:d,keys:o}=this._folderConfigurations.get(t);return i.push([t,{contents:c,overrides:d,keys:o}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(c=>i.add(c))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(c=>i.add(c))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(c=>t.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(c=>t.add(c)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(c=>t.add(c)),this._folderConfigurations.forEach(c=>c.getKeysForOverrideIdentifier(i).forEach(d=>t.add(d))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),c=this.parseConfigurationModel(i.user),d=this.parseConfigurationModel(i.workspace),o=i.folders.reduce((f,u)=>(f.set(D.URI.revive(u[0]),this.parseConfigurationModel(u[1])),f),new n.ResourceMap);return new A(t,c,new v,d,o,new v,new n.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=A;function p(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const i=new Set,t=new Map;for(const d of b)d.keys.forEach(o=>i.add(o)),d.overrides.forEach(([o,f])=>{const u=(0,n.getOrSet)(t,o,new Set);f.forEach(E=>u.add(E))});const c=[];return t.forEach((d,o)=>c.push([o,[...d.values()]])),{keys:[...i.values()],overrides:c}}e.mergeChanges=p;class a{constructor(i,t,c,d){this.change=i,this.previous=t,this.currentConfiguraiton=c,this.currentWorkspace=d,this._previousConfiguration=void 0;const o=new Set;i.keys.forEach(u=>o.add(u)),i.overrides.forEach(([,u])=>u.forEach(E=>o.add(E))),this.affectedKeys=[...o.values()];const f=new v;this.affectedKeys.forEach(u=>f.setValue(u,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=A.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const c=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!k.equals(c,d)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let c=(0,P.toValuesTree)({[t]:!0},()=>{}),d;for(;typeof c=="object"&&(d=Object.keys(c)[0]);){if(i=i[d],!i)return!1;c=c[d]}return!0}}e.ConfigurationChangeEvent=a;class r extends a{constructor(i,t,c,d){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=c,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=r;function g(b,i){const{added:t,removed:c,updated:d}=s(i,b),o=[],f=b?.getAllOverrideIdentifiers()||[],u=i?.getAllOverrideIdentifiers()||[];if(i){const E=u.filter(T=>!f.includes(T));for(const T of E)o.push([T,i.getKeysForOverrideIdentifier(T)])}if(b){const E=f.filter(T=>!u.includes(T));for(const T of E)o.push([T,b.getKeysForOverrideIdentifier(T)])}if(i&&b){for(const E of f)if(u.includes(E)){const T=s({contents:b.getOverrideValue(void 0,E)||{},keys:b.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});o.push([E,[...T.added,...T.removed,...T.updated]])}}return{added:t,removed:c,updated:d,overrides:o}}function s(b,i){const t=b?i?b.keys.filter(o=>i.keys.indexOf(o)===-1):[...b.keys]:[],c=i?b?i.keys.filter(o=>b.keys.indexOf(o)===-1):[...i.keys]:[],d=[];if(b&&i){for(const o of i.keys)if(b.keys.indexOf(o)!==-1){const f=(0,P.getConfigurationValue)(i.contents,o),u=(0,P.getConfigurationValue)(b.contents,o);k.equals(f,u)||d.push(o)}}return{added:t,removed:c,updated:d}}}),define(fe[119],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(n,k=L.Unknown,_){super(n);this._message=n,this._code=k,this._detail=_,this.isHandled=k===L.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(n){return n instanceof y&&n._code===L.TemporarilyNotAvailable}static isNoResolverFound(n){return n instanceof y&&n._code===L.NoResolverFound}static isHandled(n){return n instanceof y&&n.isHandled}}e.RemoteAuthorityResolverError=y}),define(fe[62],me([0,1,10]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(D){return D.scheme===m.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=L;function y(D){if(!D)return;const P=D.indexOf("+");return P<0?D:D.substr(0,P)}e.getRemoteName=y;function C(D){return D.scheme!==m.Schemas.file&&D.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function n(D){if(D.folders.length)return D.folders.every(P=>C(P.uri))?D.folders[0].uri:void 0;if(D.configuration&&C(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=n;function k(D){return n(D)?.scheme}e.getVirtualWorkspaceScheme=k;function _(D){return n(D)!==void 0}e.isVirtualWorkspace=_}),define(fe[27],me([0,1,8,4,62]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=C;function n(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=n,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class _{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,h){if(typeof v=="undefined"||v===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof v=="string"||typeof h=="string"){let w=typeof v=="string"?v:v.value,S=typeof h=="string"?h:h.value;return m.equalsIgnoreCase(w,S)}return v._lower===h._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=_;function D(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function P(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function I(l,v){if(v){const h=`onResolveRemoteAuthority:${(0,y.getRemoteName)(v)}`;return l.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[193],me([0,1,8,27]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function y(h,w){return h.uuid&&w.uuid?h.uuid===w.uuid:h.id===w.id?!0:(0,m.compareIgnoreCase)(h.id,w.id)===0}e.areSameExtensions=y;class C{constructor(w,S){this.version=S,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof C?y(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=C;function n(h,w){return`${h}.${w}`}e.getExtensionId=n;function k(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function _(h,w){return k(n(h,w))}e.getGalleryExtensionId=_;function D(h,w){const S=[],A=p=>{for(const a of S)if(a.some(r=>y(w(r),w(p))))return a;return null};for(const p of h){const a=A(p);a?a.push(p):S.push([p])}return S}e.groupByExtension=D;function P(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function l(h){const w=new Set;for(const S of h)S.malicious&&w.add(S.id.id);return w}e.getMaliciousExtensionsSet=l;function v(h,w){const S=[],A=w.manifest.extensionDependencies?.slice(0)??[];for(;A.length;){const p=A.shift();if(p&&S.every(a=>!y(a.identifier,{id:p}))){const a=h.filter(r=>y(r.identifier,{id:p}));a.length===1&&(S.push(a[0]),A.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=v}),define(fe[120],me([0,1,3,12,4,11]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var n;(function(h){h.Http="http",h.Https="https"})(n=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function l(h,w){return w?w!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=l;let v=class{constructor(w){this.logService=w,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,S){return this._tunnelProvider=w,w?(this._canElevate=S.elevation,this._privacyOptions=S.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],S=Array.from(this._tunnels.values());for(let A of S){const p=Array.from(A.values());for(let a of p){const r=await a.value;r&&w.push(r)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:S}of w.values())await S.then(A=>A?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,S,A,p,a=!1,r=k.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${S}:${A} on local port ${p}.`),!w)return;S||(S="localhost");const s=this.retainOrCreateTunnel(w,S,A,p,a,r,g);return s?s.then(b=>{if(!b){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(S,A);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(b);return(b.tunnelRemoteHost!==S||b.tunnelRemotePort!==A)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const S=this._tunnels.get(w.tunnelRemoteHost);if(S){const A=S.get(w.tunnelRemotePort);A&&(A.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,A))}}}}async tryDisposeTunnel(w,S,A){if(A.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${S}.`);const p=A.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(S),p}}async closeTunnel(w,S){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${S} `);const A=this._tunnels.get(w);if(A&&A.has(S)){const p=A.get(S);p.refcount=0,await this.tryDisposeTunnel(w,S,p)}}addTunnelToMap(w,S,A){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(S,{refcount:1,value:A})}async removeEmptyTunnelFromMap(w,S){const A=this._tunnels.get(w);A&&(await A.get(S)||A.delete(S),A.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,S){let A=[w];P(w)?(A.push(...e.LOCALHOST_ADDRESSES),A.push(...e.ALL_INTERFACES_ADDRESSES)):I(w)&&A.push(...e.ALL_INTERFACES_ADDRESSES);const p=A.map(a=>this._tunnels.get(a));for(const a of p){const r=a?.get(S);if(r)return r}}canTunnel(w){return!!D(w)}createWithProvider(w,S,A,p,a,r,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${S}:${A} on local port ${p}.`);const b={elevationRequired:a?l(p===void 0?A:p):!1},i={remoteAddress:{host:S,port:A},localAddressPort:p,privacy:r,public:r!==k.Private,protocol:g},t=w.forwardPort(i,b);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(S,A,t),t}};v=Ve([$e(0,C.ILogService)],v),e.AbstractTunnelService=v}),define(fe[194],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((y,C)=>Y(["vsda"],y,C))}async createNewMessage(y){try{const C=await this.vsda(),n=new C.validator;if(n){const k=String(m._nextId++);return this.validators.set(k,n),{id:k,data:n.createNewMessage(y)}}}catch(C){}return{id:"",data:y}}async validate(y,C){if(!y.id)return!0;const n=this.validators.get(y.id);if(!n)return!1;this.validators.delete(y.id);try{return n.validate(C)==="ok"}catch(k){return!1}}async sign(y){try{const C=await this.vsda(),n=new C.signer;if(n)return n.sign(y)}catch(C){}return y}}e.SignService=m,m._nextId=1}),define(fe[195],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,C,n=5){let k;return k=C(_=>{const D=typeof _=="string"?_:_.data;let P=this._terminalBufferMap.get(y);if(P){P.data.push(D);return}const I=setTimeout(()=>this.flushBuffer(y),n);P={data:[D],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(y),k.dispose()}},this._terminalBufferMap.set(y,P)}),k}stopBuffering(y){const C=this._terminalBufferMap.get(y);C&&C.dispose()}flushBuffer(y){const C=this._terminalBufferMap.get(y);C&&(this._terminalBufferMap.delete(y),this._callback(y,C.data.join("")))}}e.TerminalDataBufferer=m}),define(fe[196],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(fe[87],me([0,1,78,3,6,4,43,196]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var _;(function(S){function A(p){return p&&typeof p=="object"&&typeof p.id=="string"}S.isThemeColor=A})(_=e.ThemeColor||(e.ThemeColor={}));function D(S){return{id:S}}e.themeColorFromId=D;var P;(function(S){function A(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||_.isThemeColor(i.color))}S.isThemeIcon=A;const p=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function a(i){const t=p.exec(i);if(!t)return;let[,c]=t;return{id:c}}S.fromString=a;function r(i,t){let c=i.id;const d=c.lastIndexOf("~");return d!==-1&&(c=c.substring(0,d)),t&&(c=`${c}~${t}`),{id:c}}S.modify=r;function g(i){const t=i.id.lastIndexOf("~");if(t!==-1)return i.id.substring(t+1)}S.getModifier=g;function s(i,t){return i.id===t.id&&i.color?.id===t.color?.id}S.isEqual=s;function b(i,t){return{id:i.id,color:t?D(t):void 0}}S.asThemeIcon=b,S.asClassNameArray=m.CSSIcon.asClassNameArray,S.asClassName=m.CSSIcon.asClassName,S.asCSSSelector=m.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function I(S){switch(S){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(A){return this.themingParticipants.push(A),this.onThemingParticipantAddedEmitter.fire(A),(0,y.toDisposable)(()=>{const p=this.themingParticipants.indexOf(A);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new l;n.Registry.add(e.Extensions.ThemingContribution,v);function h(S){return v.onColorThemeChange(S)}e.registerThemingParticipant=h;class w extends y.Disposable{constructor(A){super();this.themeService=A,this.theme=A.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(A){this.theme=A,this.updateStyles()}updateStyles(){}getColor(A,p){let a=this.theme.getColor(A);return a&&p&&(a=p(a,this.theme)),a?a.toString():null}}e.Themable=w}),define(fe[44],me([0,1,24,23,2,4]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var n;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(n=e.WorkbenchState||(e.WorkbenchState={}));function k(l){const v=l;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=k;function _(l){const v=l;return!!(v&&typeof v=="object"&&y.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=_;class D{constructor(v,h,w,S,A){this._id=v,this._transient=w,this._configuration=S,this._ignorePathCasing=A,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(v){this._id=v.id,this._configuration=v.configuration,this._transient=v.transient,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=D;class P{constructor(v,h){this.raw=h,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,L.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=P;function I(l){return new P({uri:l,index:0,name:(0,L.basenameOrAuthority)(l)},{uri:l.toString()})}e.toWorkspaceFolder=I}),define(fe[197],me([0,1,30,58,139,80,10,9,12,23,2,161,4,62,44]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(M){return(typeof M=="string"?(0,k.extname)(M):(0,D.extname)(M))===w}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=(0,l.createDecorator)("workspacesService");function A(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=A;function p(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=p;function a(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=a;function r(M){const H=M;return typeof H?.id=="string"&&P.URI.isUri(H.uri)}e.isSingleFolderWorkspaceIdentifier=r;function g(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=g;function s(M){const H=M;return typeof H?.id=="string"&&P.URI.isUri(H.configPath)}e.isWorkspaceIdentifier=s;function b(M){const H=M;if(H?.uri)return{id:H.id,uri:P.URI.revive(H.uri)};const N=M;if(N?.configPath)return{id:N.id,configPath:P.URI.revive(N.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=b;function i(M,H){return D.extUriBiasedIgnorePathCase.isEqualOrParent(M,H.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function t(M){return c(M)||d(M)}e.isStoredWorkspaceFolder=t;function c(M){const H=M;return typeof H?.path=="string"&&(!H.name||typeof H.name=="string")}e.isRawFileWorkspaceFolder=c;function d(M){const H=M;return typeof H?.uri=="string"&&(!H.name||typeof H.name=="string")}e.isRawUriWorkspaceFolder=d;function o(M,H,N,U,V=!_.isWindows,O){if(M.scheme!==U.scheme)return{name:N,uri:M.toString(!0)};let W=H?void 0:O.relativePath(U,M);if(W!==void 0)W.length===0?W=".":_.isWindows&&M.scheme===n.Schemas.file&&!V&&(W=W.replace(/\//g,"\\"));else if(M.scheme===n.Schemas.file)W=M.fsPath,_.isWindows&&(W=(0,C.normalizeDriveLetter)(W),V&&(W=(0,m.toSlashes)(W)));else{if(!O.isEqualAuthority(M.authority,U.authority))return{name:N,uri:M.toString(!0)};W=M.path}return{name:N,path:W}}e.getStoredWorkspaceFolder=o;function f(M,H,N){let U=[],V=new Set;const O=N.dirname(H);for(let W of M){let j;if(c(W))W.path&&(j=N.resolvePath(O,W.path));else if(d(W))try{j=P.URI.parse(W.uri),j.path[0]!=="/"&&(j=j.with({path:"/"+j.path}))}catch(X){console.warn(X)}if(j){let X=N.getComparisonKey(j);if(!V.has(X)){V.add(X);const Q=W.name||N.basenameOrAuthority(j);U.push(new h.WorkspaceFolder({uri:j,name:Q,index:U.length},W))}}}return U}e.toWorkspaceFolders=f;function u(M,H,N,U,V){let O=E(H,M);const W=V.dirname(H),j=V.dirname(U),X=[],Q=T(O.folders);for(const Pe of O.folders){const Be=c(Pe)?V.resolvePath(W,Pe.path):P.URI.parse(Pe.uri);let We;N?We=!1:We=!c(Pe)||(0,k.isAbsolute)(Pe.path),X.push(o(Be,We,Pe.name,j,Q,V))}const de={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},Se=y.setProperty(M,["folders"],X,de);let De=y.applyEdits(M,Se);return(0,D.isEqualAuthority)(O.remoteAuthority,(0,v.getRemoteAuthority)(U))&&(De=y.applyEdits(De,y.removeProperty(De,["remoteAuthority"],de))),De}e.rewriteWorkspaceFileForNewLocation=u;function E(M,H){let N=L.parse(H);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(U=>t(U));else throw new Error(`${M} looks like an invalid workspace file.`);return N}function T(M){return _.isWindows?M.some(H=>c(H)&&H.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function R(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function B(M){return typeof M.folderUri=="string"}function x(M){return typeof M.fileUri=="string"}function F(M,H){const N={workspaces:[],files:[]};if(M){const U=function(O,W){for(let j=0;j<O.length;j++)try{W(O[j],j)}catch(X){H.warn(`Error restoring recent entry ${JSON.stringify(O[j])}: ${X.toString()}. Skip entry.`)}},V=M;if(Array.isArray(V.entries))U(V.entries,O=>{const W=O.label,j=O.remoteAuthority;R(O)?N.workspaces.push({label:W,remoteAuthority:j,workspace:{id:O.workspace.id,configPath:P.URI.parse(O.workspace.configPath)}}):B(O)?N.workspaces.push({label:W,remoteAuthority:j,folderUri:P.URI.parse(O.folderUri)}):x(O)&&N.files.push({label:W,remoteAuthority:j,fileUri:P.URI.parse(O.fileUri)})});else{const O=M;Array.isArray(O.workspaces3)&&U(O.workspaces3,(W,j)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[j]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?N.workspaces.push({label:X,workspace:{id:W.id,configPath:P.URI.parse(W.configURIPath)}}):typeof W=="string"&&N.workspaces.push({label:X,folderUri:P.URI.parse(W)})}),Array.isArray(O.files2)&&U(O.files2,(W,j)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[j]||void 0;typeof W=="string"&&N.files.push({label:X,fileUri:P.URI.parse(W)})})}}return N}e.restoreRecentlyOpened=F;function $(M){const H={entries:[]};for(const N of M.workspaces)p(N)?H.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):H.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of M.files)H.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return H}e.toStoreData=$}),define(fe[88],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const C=this._idPool++;return this._data.set(C,y),this.logDebugInfo(),C}get(y,C){return this._data.has(y)?this._data.get(y)[C]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(fe[45],me([0,1,10,23,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(k=>{const _=this._providerInfo.get(k.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(k,_){_===null?this._providerInfo.delete(k):this._providerInfo.set(k,_)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(fe[26],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(fe[198],me([0,1,18]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(n,k,_){this._deferredPromises=new Map,this._id=n,this._shared=k,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const P of D.values())P.complete()}catch(P){for(const I of D.values())I.error(P)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,n])=>n!==void 0).map(([n])=>n)}get whenReady(){return this._init}get(n,k){let _=this._value[n];return typeof _=="undefined"&&(_=k),_}update(n,k){this._value[n]=k;let _=this._deferredPromises.get(n);if(_!==void 0)return _.p;const D=new m.DeferredPromise;return this._deferredPromises.set(n,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class y extends L{constructor(n,k){super(n.identifier.value,!0,k);this._extension=n}setKeysForSync(n){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},n)}}e.ExtensionGlobalMemento=y}),define(fe[199],me([0,1,3,2,11]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,_){this._logService=k,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,_,D){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptModelChanged(_.value,D)}$acceptDirtyStateChanged(k,_){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptDirty(_)}$acceptModelSaved(k){const _=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(k,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,_);const D=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));D.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:D.apiNotebook})}};C=Ve([$e(0,y.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(fe[14],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var st=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[200],me([0,1,27,3]),function(Y,e,m,L){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,_){y.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(k.identifier),st(this,y,_,"f"),Ne(this,y,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(k){return Ne(this,y,"f").get(this._id,k)}store(k,_){return Ne(this,y,"f").store(this._id,k,_)}delete(k){return Ne(this,y,"f").delete(this._id,k)}}e.ExtensionSecrets=C,y=new WeakMap}),define(fe[121],me([0,1,4,3]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(n){this._enabled=n}$onDidChangeTelemetryEnabled(n){this._enabled=n,this._onDidChangeTelemetryEnabled.fire(n)}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(fe[63],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(p){p[p.Upsert=0]="Upsert",p[p.RemoveChild=1]="RemoveChild",p[p.Invalidated=2]="Invalidated",p[p.SetProp=3]="SetProp",p[p.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,y=(p,a)=>{const r={controllerId:a};return L.set(p,r),r};e.createPrivateApiFor=y;const C=p=>L.get(p);e.getPrivateApiFor=C;const n=(p,a,r,g)=>{let s=r;return{enumerable:!0,configurable:!1,get(){return s},set(b){if(!g(s,b)){const i=s;s=b,p.listener?.({op:3,key:a,value:b,previous:i})}}}},k=(p,a)=>p===a,_={range:(p,a)=>p===a?!0:!p||!a?!1:p.isEqual(a),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(p,a)=>!(p.length!==a.length||p.some(r=>!a.find(g=>r.id===g.id)))},D=Object.keys(_),P=(p,a)=>({range:n(p,"range",void 0,_.range),label:n(p,"label",a,_.label),description:n(p,"description",void 0,_.description),canResolveChildren:n(p,"canResolveChildren",!1,_.canResolveChildren),busy:n(p,"busy",!1,_.busy),error:n(p,"error",void 0,_.error),tags:n(p,"tags",[],_.tags)}),I=(p,a)=>{const r=new Map;for(const g of D)_[g](p[g],a[g])||r.set(g,a[g]);return r};e.diffTestItems=I;class l extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=l;class v extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=v;class h extends Error{constructor(a,r,g){super(`TestItem with ID "${a}" is from controller "${r}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=h;const w=p=>{const a=(0,e.getPrivateApiFor)(p);let r=new Map;return{get size(){return r.size},forEach(g,s){for(const b of r.values())g.call(s,b,this)},replace(g){const s=new Map,b=new Set(r.keys()),i={op:4,ops:[]};for(const t of g){if(!(t instanceof S))throw new v(t.id);const c=(0,e.getPrivateApiFor)(t).controllerId;if(c!==a.controllerId)throw new h(t.id,c,a.controllerId);if(s.has(t.id))throw new l(t.id);s.set(t.id,t),b.delete(t.id),i.ops.push({op:0,item:t})}for(const t of b.keys())i.ops.push({op:1,id:t});a.listener?.(i),r=s},add(g){if(!(g instanceof S))throw new v(g.id);r.set(g.id,g),a.listener?.({op:0,item:g})},delete(g){r.delete(g)&&a.listener?.({op:1,id:g})},get(g){return r.get(g)},toJSON(){return Array.from(r.values())},[Symbol.iterator](){return r.values()}}};class S{constructor(a,r,g,s){if(r.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(r)} symbol`);const b=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:r,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return b.parent instanceof A?void 0:b.parent}},children:{value:w(this),enumerable:!0,writable:!1},...P(b,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=S;class A extends S{constructor(a,r){super(a,a,r,void 0)}}e.TestItemRootImpl=A}),define(fe[52],me([0,1,4,120,3,14]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var n;(function(_){function D(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:I.protocol}}_.fromApiTunnel=D;function P(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==L.TunnelPrivacyId.ConstantPrivate&&I.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}_.fromServiceTunnel=P})(n=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let k=class{constructor(D){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,I,l,v){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([$e(0,C.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var st=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[7],me([0,1,17,16,98,24,102,8,13,2,32,42,119]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l){"use strict";var v,h,w,S,A,p,a,r,g,s,b,i,t,c,d,o,f,u,E,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(q){function z(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(z,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(z,q),Object.setPrototypeOf(z.prototype,q.prototype),z}let B=A=class{constructor(z){v.set(this,void 0),st(this,v,z,"f")}static from(...z){let oe=z;return new A(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}dispose(){typeof Ne(this,v,"f")=="function"&&(Ne(this,v,"f").call(this),st(this,v,void 0,"f"))}};v=new WeakMap,B=A=Ve([R],B),e.Disposable=B;let x=p=class{constructor(z,oe){if(z<0)throw(0,L.illegalArgument)("line must be non-negative");if(oe<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=z,this._character=oe}static Min(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let ke=1;ke<z.length;ke++){const Je=z[ke];Je.isBefore(oe)&&(oe=Je)}return oe}static Max(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let ke=1;ke<z.length;ke++){const Je=z[ke];Je.isAfter(oe)&&(oe=Je)}return oe}static isPosition(z){if(!z)return!1;if(z instanceof p)return!0;let{line:oe,character:ke}=z;return typeof oe=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,oe=0){if(z===null||oe===null)throw(0,L.illegalArgument)();let ke;return typeof z=="undefined"?ke=0:typeof z=="number"?ke=z:(ke=typeof z.lineDelta=="number"?z.lineDelta:0,oe=typeof z.characterDelta=="number"?z.characterDelta:0),ke===0&&oe===0?this:new p(this.line+ke,this.character+oe)}with(z,oe=this.character){if(z===null||oe===null)throw(0,L.illegalArgument)();let ke;return typeof z=="undefined"?ke=this.line:typeof z=="number"?ke=z:(ke=typeof z.line=="number"?z.line:this.line,oe=typeof z.character=="number"?z.character:this.character),ke===this.line&&oe===this.character?this:new p(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};x=p=Ve([R],x),e.Position=x;let F=a=class{constructor(z,oe,ke,Je){let ot,dt;if(typeof z=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new x(z,oe),dt=new x(ke,Je)):z instanceof x&&oe instanceof x&&(ot=z,dt=oe),!ot||!dt)throw new Error("Invalid arguments");ot.isBefore(dt)?(this._start=ot,this._end=dt):(this._start=dt,this._end=ot)}static isRange(z){return z instanceof a?!0:z?x.isPosition(z.start)&&x.isPosition(z.end):!1}get start(){return this._start}get end(){return this._end}contains(z){return z instanceof a?this.contains(z._start)&&this.contains(z._end):z instanceof x?!(z.isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const oe=x.Max(z.start,this._start),ke=x.Min(z.end,this._end);if(!oe.isAfter(ke))return new a(oe,ke)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const oe=x.Min(z.start,this._start),ke=x.Max(z.end,this.end);return new a(oe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,oe=this.end){if(z===null||oe===null)throw(0,L.illegalArgument)();let ke;return z?x.isPosition(z)?ke=z:(ke=z.start||this.start,oe=z.end||this.end):ke=this.start,ke.isEqual(this._start)&&oe.isEqual(this.end)?this:new a(ke,oe)}toJSON(){return[this.start,this.end]}};F=a=Ve([R],F),e.Range=F;let $=r=class extends F{constructor(z,oe,ke,Je){let ot,dt;if(typeof z=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new x(z,oe),dt=new x(ke,Je)):z instanceof x&&oe instanceof x&&(ot=z,dt=oe),!ot||!dt)throw new Error("Invalid arguments");super(ot,dt);this._anchor=ot,this._active=dt}static isSelection(z){return z instanceof r?!0:z?F.isRange(z)&&x.isPosition(z.anchor)&&x.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};$=r=Ve([R],$),e.Selection=$;class M{constructor(z,oe,ke){if(typeof z!="string"||z.length===0)throw(0,L.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,L.illegalArgument)("connectionToken");this.host=z,this.port=Math.round(oe),this.connectionToken=ke}}e.ResolvedAuthority=M;class H extends Error{constructor(z,oe=l.RemoteAuthorityResolverErrorCode.Unknown,ke){super(z);this._message=z,this._code=oe,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(z,oe){return new H(z,l.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(z){return new H(z,l.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var N;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var U;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let V=g=class{constructor(z,oe){this._range=z,this._newText=oe}static isTextEdit(z){return z instanceof g?!0:z?F.isRange(z)&&typeof z.newText=="string":!1}static replace(z,oe){return new g(z,oe)}static insert(z,oe){return g.replace(new F(z,z),oe)}static delete(z){return g.replace(z,"")}static setEndOfLine(z){const oe=new g(new F(new x(0,0),new x(0,0)),"");return oe.newEol=z,oe}get range(){return this._range}set range(z){if(z&&!F.isRange(z))throw(0,L.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,L.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,L.illegalArgument)("newEol");this._newEol=z}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};V=g=Ve([R],V),e.TextEdit=V;var O;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let W=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,oe,ke,Je){this._edits.push({_type:1,from:z,to:oe,options:ke,metadata:Je})}createFile(z,oe,ke){this._edits.push({_type:1,from:void 0,to:z,options:oe,metadata:ke})}deleteFile(z,oe,ke){this._edits.push({_type:1,from:z,to:void 0,options:oe,metadata:ke})}replaceNotebookMetadata(z,oe,ke){this._edits.push({_type:3,metadata:ke,uri:z,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(z,oe,ke,Je,ot){let dt,pt,It=[],Rt;if(zt.isNotebookRange(oe)&&Oe.isNotebookCellDataArray(ke)&&!Oe.isNotebookCellDataArray(Je)?(dt=oe.start,pt=oe.end,It=ke,Rt=Je):typeof oe=="number"&&typeof ke=="number"&&Oe.isNotebookCellDataArray(Je)&&(dt=oe,pt=ke,It=Je,Rt=ot),dt===void 0||pt===void 0)throw new Error("Invalid arguments");(dt!==pt||It.length>0)&&this._edits.push({_type:5,uri:z,index:dt,count:pt-dt,cells:It,metadata:Rt})}replaceNotebookCellMetadata(z,oe,ke,Je){this._edits.push({_type:3,metadata:Je,uri:z,edit:{editType:8,index:oe,metadata:ke}})}replace(z,oe,ke,Je){this._edits.push({_type:2,uri:z,edit:new V(oe,ke),metadata:Je})}insert(z,oe,ke,Je){this.replace(z,new F(oe,oe),ke,Je)}delete(z,oe,ke){this.replace(z,oe,"",ke)}has(z){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===z.toString())}set(z,oe){if(oe)for(const ke of oe)ke&&this._edits.push({_type:2,uri:z,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Je=this._edits[ke];Je._type===2&&Je.uri.toString()===z.toString()&&(this._edits[ke]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get(z){const oe=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===z.toString()&&oe.push(ke.edit);return oe}entries(){const z=new C.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ke=z.get(oe.uri);ke||(ke=[oe.uri,[]],z.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};W=Ve([R],W),e.WorkspaceEdit=W;let j=s=class{constructor(z){this._tabstop=1,this.value=z||""}static isSnippetString(z){return z instanceof s?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}appendText(z){return this.value+=s._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,oe=this._tabstop++){if(typeof z=="function"){const ke=new s;ke._tabstop=this._tabstop,z(ke),this._tabstop=ke._tabstop,z=ke.value}else z=s._escape(z);return this.value+="${",this.value+=oe,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,oe=this._tabstop++){const ke=z.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(z,oe){if(typeof oe=="function"){const ke=new s;ke._tabstop=this._tabstop,oe(ke),this._tabstop=ke._tabstop,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};j=s=Ve([R],j),e.SnippetString=j;var X;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(X=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=b=class{constructor(z,oe){if(this.uri=z,oe)if(oe instanceof F)this.range=oe;else if(oe instanceof x)this.range=new F(oe,oe);else throw new Error("Illegal argument")}static isLocation(z){return z instanceof b?!0:z?F.isRange(z.range)&&D.URI.isUri(z.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};de=b=Ve([R],de),e.Location=de;let Se=class{constructor(z,oe){this.location=z,this.message=oe}static is(z){return z?typeof z.message=="string"&&z.location&&F.isRange(z.location.range)&&D.URI.isUri(z.location.uri):!1}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.location.range.isEqual(oe.location.range)&&z.location.uri.toString()===oe.location.uri.toString()}};Se=Ve([R],Se),e.DiagnosticRelatedInformation=Se;let De=class{constructor(z,oe,ke=Q.Error){if(!F.isRange(z))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=z,this.message=oe,this.severity=ke}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.severity===oe.severity&&z.code===oe.code&&z.severity===oe.severity&&z.source===oe.source&&z.range.isEqual(oe.range)&&(0,m.equals)(z.tags,oe.tags)&&(0,m.equals)(z.relatedInformation,oe.relatedInformation,Se.isEqual)}};De=Ve([R],De),e.Diagnostic=De;let Pe=class{constructor(z,oe){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=oe}};Pe=Ve([R],Pe),e.Hover=Pe;var Be;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(z,oe=Be.Text){this.range=z,this.kind=oe}toJSON(){return{range:this.range,kind:Be[this.kind]}}};We=Ve([R],We),e.DocumentHighlight=We;var He;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var G;(function(q){q[q.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let ee=i=class{constructor(z,oe,ke,Je,ot){this.name=z,this.kind=oe,this.containerName=ot,typeof ke=="string"&&(this.containerName=ke),Je instanceof de?this.location=Je:ke instanceof F&&(this.location=new de(Je,ke)),i.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};ee=i=Ve([R],ee),e.SymbolInformation=ee;let ne=t=class{constructor(z,oe,ke,Je,ot){this.name=z,this.detail=oe,this.kind=ke,this.range=Je,this.selectionRange=ot,this.children=[],t.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children&&z.children.forEach(t.validate)}};ne=t=Ve([R],ne),e.DocumentSymbol=ne;var ce;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(ce=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Z=class{constructor(z,oe){this.title=z,this.kind=oe}};Z=Ve([R],Z),e.CodeAction=Z;let re=c=class{constructor(z){this.value=z}append(z){return new c(this.value?this.value+c.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+c.sep)}};re.sep=".",re=c=Ve([R],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let pe=class{constructor(z,oe){if(this.range=z,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};pe=Ve([R],pe),e.SelectionRange=pe;class Me{constructor(z,oe,ke,Je,ot,dt){this.kind=z,this.name=oe,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=dt}}e.CallHierarchyItem=Me;class je{constructor(z,oe){this.fromRanges=oe,this.from=z}}e.CallHierarchyIncomingCall=je;class Ke{constructor(z,oe){this.fromRanges=oe,this.to=z}}e.CallHierarchyOutgoingCall=Ke;var Ze;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(z,oe){this.range=z,this.command=oe}get isResolved(){return!!this.command}};rt=Ve([R],rt),e.CodeLens=rt;let ct=d=class{constructor(z,oe=!1){h.set(this,void 0),st(this,h,new y.MarkdownString(z,{supportThemeIcons:oe}),"f")}static isMarkdownString(z){return z instanceof d?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}get value(){return Ne(this,h,"f").value}set value(z){Ne(this,h,"f").value=z}get isTrusted(){return Ne(this,h,"f").isTrusted}set isTrusted(z){Ne(this,h,"f").isTrusted=z}get supportThemeIcons(){return Ne(this,h,"f").supportThemeIcons}set supportThemeIcons(z){Ne(this,h,"f").supportThemeIcons=z}get supportHtml(){return Ne(this,h,"f").supportHtml}set supportHtml(z){Ne(this,h,"f").supportHtml=z}appendText(z){return Ne(this,h,"f").appendText(z),this}appendMarkdown(z){return Ne(this,h,"f").appendMarkdown(z),this}appendCodeblock(z,oe){return Ne(this,h,"f").appendCodeblock(oe??"",z),this}};h=new WeakMap,ct=d=Ve([R],ct),e.MarkdownString=ct;let ye=class{constructor(z,oe){this.label=z,this.documentation=oe}};ye=Ve([R],ye),e.ParameterInformation=ye;let at=class{constructor(z,oe){this.label=z,this.documentation=oe,this.parameters=[]}};at=Ve([R],at),e.SignatureInformation=at;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ve([R],J),e.SignatureHelp=J;var ie;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(ie=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _e;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(_e=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(z,oe,ke){this.text=z,this.position=oe,this.kind=ke}};Qe=Ve([R],Qe),e.InlayHint=Qe;var et;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var le;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(le=e.CompletionItemKind||(e.CompletionItemKind={}));var Ie;(function(q){q[q.Deprecated=1]="Deprecated"})(Ie=e.CompletionItemTag||(e.CompletionItemTag={}));let Ue=class{constructor(z,oe){this.label=z,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ue=Ve([R],Ue),e.CompletionItem=Ue;let Xe=class{constructor(z=[],oe=!1){this.items=z,this.isIncomplete=oe}};Xe=Ve([R],Xe),e.CompletionList=Xe;let it=class{constructor(z,oe,ke){this.text=z,this.range=oe,this.command=ke}};it=Ve([R],it),e.InlineSuggestion=it;let ft=class{constructor(z){this.items=z}};ft=Ve([R],ft),e.InlineSuggestions=ft;var tt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var ut;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Re;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Re=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ve;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Te;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var se;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var be;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(be=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function z(oe){switch(oe){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=z}(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let we=class{constructor(z,oe){if(oe&&!D.URI.isUri(oe))throw(0,L.illegalArgument)("target");if(!F.isRange(z)||z.isEmpty)throw(0,L.illegalArgument)("range");this.range=z,this.target=oe}};we=Ve([R],we),e.DocumentLink=we;let Fe=class{constructor(z,oe,ke,Je){this.red=z,this.green=oe,this.blue=ke,this.alpha=Je}};Fe=Ve([R],Fe),e.Color=Fe;let qe=class{constructor(z,oe){if(oe&&!(oe instanceof Fe))throw(0,L.illegalArgument)("color");if(!F.isRange(z)||z.isEmpty)throw(0,L.illegalArgument)("range");this.range=z,this.color=oe}};qe=Ve([R],qe),e.ColorInformation=qe;let ze=class{constructor(z){if(!z||typeof z!="string")throw(0,L.illegalArgument)("label");this.label=z}};ze=Ve([R],ze),e.ColorPresentation=ze;var Ye;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ye=e.ColorFormat||(e.ColorFormat={}));var lt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class xe{constructor(z,oe,ke){if(this.startIndex=z,this.length=oe,this.tooltip=ke,typeof z!="number"||z<0)throw(0,L.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=xe;var ge;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(ge=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(z){this.options=z,typeof z!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ee;var ae;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(ae=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=o=class{constructor(z,oe){if(this.label=oe,typeof z!="string"||typeof oe!="string")throw(0,L.illegalArgument)("name");this._id=z}static from(z){switch(z){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};Ce.Clean=new o("clean","Clean"),Ce.Build=new o("build","Build"),Ce.Rebuild=new o("rebuild","Rebuild"),Ce.Test=new o("test","Test"),Ce=o=Ve([R],Ce),e.TaskGroup=Ce;function Le(q){let z="";for(let oe=0;oe<q.length;oe++)z+=q[oe].replace(/,/g,",,")+",";return z}let nt=class{constructor(z,oe,ke){if(typeof z!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=z,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ke):this._options=oe)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,L.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)z.push(oe);return Le(z)}};nt=Ve([R],nt),e.ProcessExecution=nt;let Ge=class{constructor(z,oe,ke){if(this._args=[],Array.isArray(oe)){if(!z)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,L.illegalArgument)("command");this._command=z,this._args=oe,this._options=ke}else{if(typeof z!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=z,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,L.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)z.push(typeof oe=="string"?oe:oe.value);return Le(z)}};Ge=Ve([R],Ge),e.ShellExecution=Ge;var mt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class _t{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=_t;let gt=f=class{constructor(z,oe,ke,Je,ot,dt){this.__deprecated=!1,this._definition=this.definition=z;let pt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ke,this.execution=Je,pt=ot,this.__deprecated=!0):oe===yt.Global||oe===yt.Workspace?(this.target=oe,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,pt=dt):(this.target=oe,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,pt=dt),typeof pt=="string"?(this._problemMatchers=[pt],this._hasDefinedMatchers=!0):Array.isArray(pt)?(this._problemMatchers=pt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof nt?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const oe=this._definition.type;(f.EmptyType===oe||f.ProcessType===oe||f.ShellType===oe||f.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=f=Ve([R],gt),e.Task=gt;var bt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(bt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(z,oe=Tt.None){this.collapsibleState=oe,D.URI.isUri(z)?this.resourceUri=z:this.label=z}};vt=Ve([R],vt),e.TreeItem=vt;var Tt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Dt=class{constructor(z,oe){this.id=z,this.color=oe}};Dt=Ve([R],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let Bt=class{constructor(z){this.id=z}};Bt=Ve([R],Bt),e.ThemeColor=Bt;var Vt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(z,oe){if(typeof z!="string"&&(!z||!D.URI.isUri(z)&&!D.URI.isUri(z.uri)))throw(0,L.illegalArgument)("base");if(typeof oe!="string")throw(0,L.illegalArgument)("pattern");typeof z=="string"?(this.baseFolder=D.URI.file(z),this.base=z):D.URI.isUri(z)?(this.baseFolder=z,this.base=z.fsPath):(this.baseFolder=z.uri,this.base=z.uri.fsPath),this.pattern=oe}};kt=Ve([R],kt),e.RelativePattern=kt;let $t=class{constructor(z,oe,ke,Je){this.enabled=typeof z=="boolean"?z:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};$t=Ve([R],$t),e.Breakpoint=$t;let tn=class extends $t{constructor(z,oe,ke,Je,ot){super(oe,ke,Je,ot);if(z===null)throw(0,L.illegalArgument)("location");this.location=z}};tn=Ve([R],tn),e.SourceBreakpoint=tn;let St=class extends $t{constructor(z,oe,ke,Je,ot){super(oe,ke,Je,ot);this.functionName=z}};St=Ve([R],St),e.FunctionBreakpoint=St;let Qt=class extends $t{constructor(z,oe,ke,Je,ot,dt,pt){super(Je,ot,dt,pt);if(!oe)throw(0,L.illegalArgument)("dataId");this.label=z,this.dataId=oe,this.canPersist=ke}};Qt=Ve([R],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(z,oe,ke){this.command=z,this.args=oe||[],this.options=ke}};jt=Ve([R],jt),e.DebugAdapterExecutable=jt;let nn=class{constructor(z,oe){this.port=z,this.host=oe}};nn=Ve([R],nn),e.DebugAdapterServer=nn;let rn=class{constructor(z){this.path=z}};rn=Ve([R],rn),e.DebugAdapterNamedPipeServer=rn;let At=class{constructor(z){this.implementation=z}};At=Ve([R],At),e.DebugAdapterInlineImplementation=At;let Xt=class{constructor(z,oe){this.range=z,this.expression=oe}};Xt=Ve([R],Xt),e.EvaluatableExpression=Xt;var bn;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(bn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Wt=class{constructor(z,oe){this.range=z,this.text=oe}};Wt=Ve([R],Wt),e.InlineValueText=Wt;let Ht=class{constructor(z,oe,ke=!0){this.range=z,this.variableName=oe,this.caseSensitiveLookup=ke}};Ht=Ve([R],Ht),e.InlineValueVariableLookup=Ht;let wt=class{constructor(z,oe){this.range=z,this.expression=oe}};wt=Ve([R],wt),e.InlineValueEvaluatableExpression=wt;let sn=class{constructor(z,oe){this.frameId=z,this.stoppedLocation=oe}};sn=Ve([R],sn),e.InlineValueContext=sn;var Ot;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=u=class extends Error{constructor(z,oe=I.FileSystemProviderErrorCode.Unknown,ke){super(D.URI.isUri(z)?z.toString(!0):z);this.code=ke?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(z){return new u(z,I.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(z){return new u(z,I.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(z){return new u(z,I.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(z){return new u(z,I.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(z){return new u(z,I.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(z){return new u(z,I.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};Nt=u=Ve([R],Nt),e.FileSystemError=Nt;let Yt=class{constructor(z,oe,ke){this.start=z,this.end=oe,this.kind=ke}};Yt=Ve([R],Yt),e.FoldingRange=Yt;var En;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(En=e.FoldingRangeKind||(e.FoldingRangeKind={}));var hn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(hn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _n;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(_n=e.CommentMode||(e.CommentMode={}));class fn{constructor(z,oe=[]){this.tokenTypes=z,this.tokenModifiers=oe}}e.SemanticTokensLegend=fn;function Jt(q){return typeof q=="undefined"||(0,_.isStringArray)(q)}class on{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let oe=0,ke=z.tokenTypes.length;oe<ke;oe++)this._tokenTypeStrToInt.set(z.tokenTypes[oe],oe);for(let oe=0,ke=z.tokenModifiers.length;oe<ke;oe++)this._tokenModifierStrToInt.set(z.tokenModifiers[oe],oe)}}push(z,oe,ke,Je,ot){if(typeof z=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof ot=="number"||typeof ot=="undefined"))return typeof ot=="undefined"&&(ot=0),this._pushEncoded(z,oe,ke,Je,ot);if(F.isRange(z)&&typeof oe=="string"&&Jt(ke))return this._push(z,oe,ke);throw(0,L.illegalArgument)()}_push(z,oe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Je=z.start.line,ot=z.start.character,dt=z.end.character-z.start.character,pt=this._tokenTypeStrToInt.get(oe);let It=0;if(ke)for(const Rt of ke){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(Rt);It|=1<<Ft>>>0}this._pushEncoded(Je,ot,dt,pt,It)}_pushEncoded(z,oe,ke,Je,ot){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const It=this._data.length/5|0;let Rt=0,Ft=0;for(let Mt=0;Mt<It;Mt++){let Ut=this._data[5*Mt],un=this._data[5*Mt+1];Ut===0?(Ut=Rt,un+=Ft):Ut+=Rt,this._data[5*Mt]=Ut,this._data[5*Mt+1]=un,Rt=Ut,Ft=un}}let dt=z,pt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(dt-=this._prevLine,dt===0&&(pt-=this._prevChar)),this._data[this._dataLen++]=dt,this._data[this._dataLen++]=pt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=ot,this._prevLine=z,this._prevChar=oe}static _sortAndDeltaEncode(z){let oe=[];const ke=z.length/5|0;for(let pt=0;pt<ke;pt++)oe[pt]=pt;oe.sort((pt,It)=>{const Rt=z[5*pt],Ft=z[5*It];if(Rt===Ft){const Mt=z[5*pt+1],Ut=z[5*It+1];return Mt-Ut}return Rt-Ft});const Je=new Uint32Array(z.length);let ot=0,dt=0;for(let pt=0;pt<ke;pt++){const It=5*oe[pt],Rt=z[It+0],Ft=z[It+1],Mt=z[It+2],Ut=z[It+3],un=z[It+4],$n=Rt-ot,Qn=$n===0?Ft-dt:Ft,dn=5*pt;Je[dn+0]=$n,Je[dn+1]=Qn,Je[dn+2]=Mt,Je[dn+3]=Ut,Je[dn+4]=un,ot=Rt,dt=Ft}return Je}build(z){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),z):new qt(on._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=on;class qt{constructor(z,oe){this.resultId=oe,this.data=z}}e.SemanticTokens=qt;class an{constructor(z,oe,ke){this.start=z,this.deleteCount=oe,this.data=ke}}e.SemanticTokensEdit=an;class Sn{constructor(z,oe){this.resultId=oe,this.edits=z}}e.SemanticTokensEdits=Sn;var Cn;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Cn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Zt=class{constructor(){}};Zt.Back={iconPath:new Dt("arrow-left")},Zt=Ve([R],Zt),e.QuickInputButtons=Zt;var yn;(function(q){q[q.Default=1]="Default",q[q.Separator=2]="Separator"})(yn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Dn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(z,oe,ke){this.badge=z,this.tooltip=oe,this.color=ke}static validate(z){if(z.badge){let oe=(0,k.nextCharLength)(z.badge,0);if(oe<z.badge.length&&(oe+=(0,k.nextCharLength)(z.badge,oe)),z.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=kn;let Kt=class{constructor(z){this.kind=z}};Kt=Ve([R],Kt),e.ColorTheme=Kt;var mn;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(mn=e.ColorThemeKind||(e.ColorThemeKind={}));class zt{constructor(z,oe){if(z<0)throw(0,L.illegalArgument)("start must be positive");if(oe<0)throw(0,L.illegalArgument)("end must be positive");z<=oe?(this._start=z,this._end=oe):(this._start=oe,this._end=z)}static isNotebookRange(z){return z instanceof zt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(z){let oe=this._start,ke=this._end;return z.start!==void 0&&(oe=z.start),z.end!==void 0&&(ke=z.end),oe===this._start&&ke===this._end?this:new zt(oe,ke)}}e.NotebookRange=zt;class Oe{constructor(z,oe,ke,Je,ot,dt,pt){this.kind=z,this.value=oe,this.languageId=ke,this.mime=Je,this.outputs=ot??[],this.metadata=dt,this.executionSummary=pt,Oe.validate(this)}static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(oe=>Oe.isNotebookCellData(oe))}static isNotebookCellData(z){return!0}}e.NotebookCellData=Oe;class ln{constructor(z){this.cells=z}}e.NotebookData=ln;class Lt{constructor(z,oe){this.data=z,this.mime=oe;const ke=(0,n.normalizeMimeType)(oe,!0);if(!ke)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}static isNotebookCellOutputItem(z){return z instanceof Lt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const oe={name:z.name,message:z.message,stack:z.stack};return Lt.json(oe,"application/vnd.code.notebook.error")}static stdout(z){return Lt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Lt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,oe="application/octet-stream"){return new Lt(z,oe)}static text(z,oe=n.Mimes.text){const ke=Ne(Lt,w,"f",S).encode(String(z));return new Lt(ke,oe)}static json(z,oe="application/json"){const ke=JSON.stringify(z,void 0,"	");return Lt.text(ke,oe)}}e.NotebookCellOutputItem=Lt,w=Lt,S={value:new TextEncoder};class Et{constructor(z,oe,ke){this.items=Et.ensureUniqueMimeTypes(z,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,P.generateUuid)(),this.metadata=oe??ke)}static isNotebookCellOutput(z){return z instanceof Et?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&(0,_.isArray)(z.items)}static ensureUniqueMimeTypes(z,oe=!1){const ke=new Set,Je=new Set;for(let ot=0;ot<z.length;ot++){const dt=z[ot],pt=(0,n.normalizeMimeType)(dt.mime);if(!ke.has(pt)){ke.add(pt);continue}Je.add(ot),oe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Je.size===0?z:z.filter((ot,dt)=>!Je.has(dt))}}e.NotebookCellOutput=Et;var In;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(In=e.NotebookCellKind||(e.NotebookCellKind={}));var Pn;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Pn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var gn;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var pn;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Tn{constructor(z,oe){this.text=z,this.alignment=oe}}e.NotebookCellStatusBarItem=Tn;var An;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(An=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Rn{constructor(z,oe=[]){this.uri=z,this.provides=(0,m.asArray)(oe)}}e.NotebookRendererScript=Rn;let cn=class{constructor(z,oe){this.label=z,this.timestamp=oe}};cn=Ve([R],cn),e.TimelineItem=cn;var vn;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var Ln;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(Ln=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fn;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Fn=e.StandardTokenType||(e.StandardTokenType={}));class Mn{constructor(z,oe){this.ranges=z,this.wordPattern=oe}}e.LinkedEditingRanges=Mn;class On{constructor(z,oe){this._port=z,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=On;var Nn;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(Nn=e.TestResultState||(e.TestResultState={}));var te;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(te=e.TestRunProfileKind||(e.TestRunProfileKind={}));let he=class{constructor(z=void 0,oe=void 0,ke=void 0){this.include=z,this.exclude=oe,this.profile=ke}};he=Ve([R],he),e.TestRunRequest=he;let Ae=E=class{constructor(z){this.message=z}static diff(z,oe,ke){const Je=new E(z);return Je.expectedOutput=oe,Je.actualOutput=ke,Je}};Ae=E=Ve([R],Ae),e.TestMessage=Ae;let ht=class{constructor(z){this.id=z}};ht=Ve([R],ht),e.TestTag=ht;let Ct=class{constructor(z,oe){this.covered=z,this.total=oe}};Ct=Ve([R],Ct),e.CoveredCount=Ct;let Pt=T=class{constructor(z,oe,ke,Je){this.uri=z,this.statementCoverage=oe,this.branchCoverage=ke,this.functionCoverage=Je}static fromDetails(z,oe){const ke=new Ct(0,0),Je=new Ct(0,0),ot=new Ct(0,0);for(const pt of oe)if("branches"in pt){ke.total+=1,ke.covered+=pt.executionCount>0?1:0;for(const It of pt.branches)Je.total+=1,Je.covered+=It.executionCount>0?1:0}else ot.total+=1,ot.covered+=pt.executionCount>0?1:0;const dt=new T(z,ke,Je.total>0?Je:void 0,ot.total>0?ot:void 0);return dt.detailedCoverage=oe,dt}};Pt=T=Ve([R],Pt),e.FileCoverage=Pt;let Un=class{constructor(z,oe,ke=[]){this.executionCount=z,this.location=oe,this.branches=ke}};Un=Ve([R],Un),e.StatementCoverage=Un;let xn=class{constructor(z,oe){this.executionCount=z,this.location=oe}};xn=Ve([R],xn),e.BranchCoverage=xn;let Bn=class{constructor(z,oe){this.executionCount=z,this.location=oe}};Bn=Ve([R],Bn),e.FunctionCoverage=Bn;var jn;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(jn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var qn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(qn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Gn;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(Gn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Kn{constructor(z,oe,ke,Je,ot,dt){this.kind=z,this.name=oe,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=dt}}e.TypeHierarchyItem=Kn}),define(fe[122],me([0,1,56,10,8,149,110,7,17]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const D=new Map;function P(h,w){w?D.set(h,w):D.delete(h)}e.setWordDefinitionFor=P;function I(h){return D.get(h)}e.getWordDefinitionFor=I;class l extends C.MirrorTextModel{constructor(w,S,A,p,a,r,g,s){super(S,A,p,a);this._proxy=w,this._languageId=r,this._isDirty=g,this._notebook=s,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,_.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===L.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(S){return S?w._getTextInRange(S):w.getText()},get eol(){return w._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(S){return w._lineAt(S)},offsetAt(S){return w._offsetAt(S)},positionAt(S){return w._positionAt(S)},validateRange(S){return w._validateRange(S)},validatePosition(S){return w._validatePosition(S)},getWordRangeAtPosition(S,A){return w._getWordRangeAtPosition(S,A)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,m.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,m.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const S=this._validateRange(w);if(S.isEmpty)return"";if(S.isSingleLine)return this._lines[S.start.line].substring(S.start.character,S.end.character);const A=this._eol,p=S.start.line,a=S.end.line,r=[];r.push(this._lines[p].substring(S.start.character));for(let g=p+1;g<a;g++)r.push(this._lines[g]);return r.push(this._lines[a].substring(0,S.end.character)),r.join(A)}_lineAt(w){let S;if(w instanceof k.Position?S=w.line:typeof w=="number"&&(S=w),typeof S!="number"||S<0||S>=this._lines.length||Math.floor(S)!==S)throw new Error("Illegal value for `line`");return new v(S,this._lines[S],S===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const S=this._lineStarts.getIndexOf(w),A=this._lines[S.index].length;return new k.Position(S.index,Math.min(S.remainder,A))}_validateRange(w){if(!(w instanceof k.Range))throw new Error("Invalid argument");const S=this._validatePosition(w.start),A=this._validatePosition(w.end);return S===w.start&&A===w.end?w:new k.Range(S.line,S.character,A.line,A.character)}_validatePosition(w){if(!(w instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:S,character:A}=w,p=!1;if(S<0)S=0,A=0,p=!0;else if(S>=this._lines.length)S=this._lines.length-1,A=this._lines[S].length,p=!0;else{const a=this._lines[S].length;A<0?(A=0,p=!0):A>a&&(A=a,p=!0)}return p?new k.Position(S,A):w}_getWordRangeAtPosition(w,S){const A=this._validatePosition(w);if(!S)S=I(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(S))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${S.source}' because it matches the empty string.`);const p=(0,n.getWordAtText)(A.character+1,(0,n.ensureValidWordDefinition)(S),this._lines[A.line],0);if(p)return new k.Range(A.line,p.startColumn-1,A.line,p.endColumn-1)}}e.ExtHostDocumentData=l;class v{constructor(w,S,A){this._line=w,this._text=S,this._isLastLine=A}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=v}),define(fe[201],me([0,1,7,3,112,6,82,24,2,32]),function(Y,e,m,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class P{constructor(l,v,h,w){this._notebook=h,this._selector=w,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,D.generateUuid)()}),this._init(),this._disposables.add(v.onDidChangeDocument(A=>{const p=this._cellUris.get(A.document.uri);p!==void 0&&(this._cellLengths.setValue(p,this._cells[p].document.getText().length+1),this._cellLines.setValue(p,this._cells[p].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const S=A=>{A===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(A=>S(A.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const l=[],v=[];for(const h of this._notebook.getCells())h.kind===m.NotebookCellKind.Code&&(!this._selector||(0,n.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),l.push(h.document.getText().length+1),v.push(h.document.lineCount));this._cellLengths=new y.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new y.PrefixSumComputer(new Uint32Array(v))}get version(){return this._versionId}getText(l){if(!l){let p="";for(const a of this._cells)p+=a.document.getText()+`
`;return p=p.slice(0,-1),p}if(l.isEmpty)return"";const v=this.locationAt(l.start),h=this.locationAt(l.end),w=this._cellUris.get(v.uri),S=this._cellUris.get(h.uri);if(w===void 0||S===void 0)return"";if(w===S)return this._cells[w].document.getText(new m.Range(v.range.start,h.range.end));const A=[this._cells[w].document.getText(new m.Range(v.range.start,new m.Position(this._cells[w].document.lineCount,0)))];for(let p=w+1;p<S;p++)A.push(this._cells[p].document.getText());return A.push(this._cells[S].document.getText(new m.Range(new m.Position(0,0),h.range.end))),A.join(`
`)}offsetAt(l){const v=this._cellLines.getIndexOf(l.line),h=this._cellLengths.getPrefixSum(v.index-1),w=this._cells[v.index].document.offsetAt(l.with(v.remainder));return h+w}positionAt(l){if(typeof l=="number"){const h=this._cellLengths.getIndexOf(l),w=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(w)}const v=this._cellUris.get(l.uri);if(v!==void 0){const h=this._cellLines.getPrefixSum(v-1);return new m.Position(h+l.range.start.line,l.range.start.character)}return new m.Position(0,0)}locationAt(l){m.Range.isRange(l)||(l=new m.Range(l,l));const v=this._cellLines.getIndexOf(l.start.line);let h=v;l.isEmpty||(h=this._cellLines.getIndexOf(l.end.line));const w=new m.Position(v.remainder,l.start.character),S=new m.Position(h.remainder,l.end.character),A=new m.Range(w,S),p=this._cells[v.index];return new m.Location(p.document.uri,p.document.validateRange(A))}contains(l){return this._cellUris.has(l)}validateRange(l){const v=this.validatePosition(l.start),h=this.validatePosition(l.end);return l.with(v,h)}validatePosition(l){const v=this._cellLines.getIndexOf(l.line),h=new m.Position(v.remainder,l.character),w=this._cells[v.index].document.validatePosition(h),S=this._cellLines.getPrefixSum(v.index-1);return new m.Position(S+w.line,w.character)}}e.ExtHostNotebookConcatDocument=P}),define(fe[202],me([0,1,7,14,3]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let _=k==="light"?m.ColorThemeKind.Light:k==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(fe[64],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=n=>n,this.transformOutgoing=n=>n,this.transformOutgoingURI=n=>n,this.transformOutgoingScheme=n=>n)}}e.URITransformerService=L}),define(fe[203],me([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(_){let D=this.buffers.indexOf(_);return D<0&&(D=this.buffers.length,this.buffers.push(_)),D}}function y(k,_){if(_.serializeBuffersForPostMessage){const D=new L,P=(v,h)=>{if(h instanceof ArrayBuffer){const w=D.add(h);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(h)){const w=C(h);if(w){const S=D.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:S,view:{type:w,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},I=JSON.stringify(k,P),l=D.buffers.map(v=>{const h=new Uint8Array(v);return m.VSBuffer.wrap(h)});return{message:I,buffers:l}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=y;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function n(k,_){const D=_.map(l=>{const v=new ArrayBuffer(l.byteLength);return new Uint8Array(v).set(l.buffer),v}),P=_.length?(l,v)=>{if(typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const h=v,{index:w}=h,S=D[w];if(h.view)switch(h.view.type){case 1:return new Int8Array(S,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(S,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(S,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(S,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(S,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(S,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(S,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(S,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(S,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(S,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(S,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return S}return v}:void 0;return{message:JSON.parse(k,P),arrayBuffers:D}}e.deserializeWebviewMessage=n}),define(fe[204],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(L){function y(n){const k={items:new Map};return n.types.forEach((_,D)=>{k.items.set(_,{asString:async()=>n.items[D].asString})}),k}L.toITreeDataTransfer=y;async function C(n){const k={types:[],items:[]},_=Array.from(n.items.entries());for(const D of _)k.types.push(D[0]),k.items.push({asString:await D[1].asString()});return k}L.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[89],me([0,1,10,2]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function y(k,_){return k.scheme===m.Schemas.http||k.scheme===m.Schemas.https?k:(_&&_.authority&&_.isRemote&&k.scheme===m.Schemas.file&&(k=L.URI.from({scheme:m.Schemas.vscodeRemote,authority:_.authority,path:k.path})),L.URI.from({scheme:m.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=y;function C(k){return k.replace(/./g,_=>{const D=_.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?_:"-"+D.toString(16).padStart(4,"0")})}function n(k){return k.replace(/-([0-9a-f]{4})/g,(_,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=n}),define(fe[205],me([0,1,3,6,89]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,_,D){this._proxy=k,this._editors=_,this._initData=D,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const P=_.getVisibleTextEditors();for(const I of this._insets.values())P.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,_,D,P,I){let l;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===k){l=a;break}if(!l)throw new Error("not a visible editor");const v=this,h=this._handlePool++,w=new m.Emitter,S=new m.Emitter,A=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,y.asWebviewUri)(a,v._initData.remote)}get cspSource(){return y.webviewGenericCspSource}set options(a){this._options=a,v._proxy.$setOptions(h,a)}get options(){return this._options}set html(a){this._html=a,v._proxy.$setHtml(h,a)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(a){return v._proxy.$postMessage(h,a)}},p=new class{constructor(){this.editor=k,this.line=_,this.height=D,this.webview=A,this.onDidDispose=S.event}dispose(){v._insets.has(h)&&(v._insets.delete(h),v._proxy.$disposeEditorInset(h),S.fire(),S.dispose(),w.dispose())}};return this._proxy.$createEditorInset(h,l.id,l.value.document.uri,_+1,D,P||{},I.identifier,I.extensionLocation),this._insets.set(h,{editor:k,inset:p,onDidReceiveMessage:w}),p}$onDidDispose(k){const _=this._insets.get(k);_&&_.inset.dispose()}$onDidReceiveMessage(k,_){const D=this._insets.get(k);D&&D.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=C}),define(fe[206],me([0,1,171,13,2,6,4,61,43,42,17,10]),function(Y,e,m,L,y,C,n,k,_,D,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function l(x,F,$){for(const M of $.visibleEditorPanes)if(M.group.id===F&&x.matches(M.input))return M.getViewState()}e.findViewStateForEditor=l;function v(x){if(g(x))return!1;const F=x;return y.URI.isUri(F?.resource)}e.isResourceEditorInput=v;function h(x){if(g(x))return!1;const F=x;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=h;function w(x){if(g(x)||h(x))return!1;const F=x;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function S(x){if(g(x))return!1;const F=x;return F?F.resource===void 0||F.resource.scheme===I.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=S;var A;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(A=e.Verbosity||(e.Verbosity={}));var p;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p=e.SaveReason||(e.SaveReason={}));var a;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription"})(a=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class r extends C.Disposable{}e.AbstractEditorInput=r;function g(x){return x instanceof r}e.isEditorInput=g;function s(x){const F=x;return y.URI.isUri(F?.preferredResource)}function b(x){const F=x;return g(F?.primary)&&g(F?.secondary)}e.isSideBySideEditorInput=b;function i(x){const F=x;return g(F?.modified)&&g(F?.original)}e.isDiffEditorInput=i;function t(x){return g(x?.editor)}e.isEditorInputWithOptions=t;function c(x){const F=x;return t(x)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=c;function d(x){const F=x;return typeof F?.groupId=="number"&&g(F.editor)}e.isEditorIdentifier=d;var o;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(o=e.EditorCloseContext||(e.EditorCloseContext={}));var f;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(f=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:H,secondary:N}=this.getSideEditors(F);if(H&&N){if($?.supportSideBySide===f.BOTH)return{primary:this.getOriginalUri(H,{filterByScheme:$.filterByScheme}),secondary:this.getOriginalUri(N,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===f.ANY)return this.getOriginalUri(H,{filterByScheme:$.filterByScheme})??this.getOriginalUri(N,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===f.PRIMARY?H:N}}if(h(F)||w(F))return;const M=s(F)?F.preferredResource:F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}getSideEditors(F){return b(F)||w(F)?{primary:F.primary,secondary:F.secondary}:i(F)||h(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:H,secondary:N}=this.getSideEditors(F);if(H&&N){if($?.supportSideBySide===f.BOTH)return{primary:this.getCanonicalUri(H,{filterByScheme:$.filterByScheme}),secondary:this.getCanonicalUri(N,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===f.ANY)return this.getCanonicalUri(H,{filterByScheme:$.filterByScheme})??this.getCanonicalUri(N,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===f.PRIMARY?H:N}}if(h(F)||w(F))return;const M=F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}filterUri(F,$){if(Array.isArray($)){if($.some(M=>F.scheme===M))return F}else if($===F.scheme)return F}}e.EditorResourceAccessor=new u;var E;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class T{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const $=this.instantiationService=F.get(n.IInstantiationService);for(const[M,H]of this.editorSerializerConstructors)this.createEditorSerializer(M,H,$);this.editorSerializerConstructors.clear()}createEditorSerializer(F,$,M){const H=M.createInstance($);this.editorSerializerInstances.set(F,H)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,$){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,$,this.instantiationService):this.editorSerializerConstructors.set(F,$),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new T);async function R(x,F){if(!x||!x.length)return[];const $=await Promise.all(x.map(async M=>{const H=y.URI.revive(M.fileUri);if(!H||!await F.canHandleResource(H))return;let U=M.exists,V=M.type;if(typeof U!="boolean"||typeof V!="number")try{V=(await F.resolve(H)).isFile?D.FileType.File:D.FileType.Unknown,U=!0}catch{U=!1}if(!U&&M.openOnlyIfExists||V!==D.FileType.File)return;const O={selection:U?M.selection:void 0,pinned:!0,override:M.editorOverrideId};let W;return U?W={resource:H,options:O}:W={resource:H,options:O,forceUntitled:!0},W}));return(0,P.coalesce)($)}e.pathsToEditors=R;var B;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[123],me([0,1,3,18,172]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,_,D,P){const I={command:k};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof P=="number"){const l=setTimeout(()=>{clearTimeout(l);const v=this.pendingRequests.get(I.seq);if(v){this.pendingRequests.delete(I.seq);const h={type:"response",seq:0,request_seq:I.seq,success:!1,command:k,message:(0,y.localize)(0,null,P,k)};v(h)}},P)}return D&&this.pendingRequests.set(I.seq,D),I.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,_){return k.type!=="event"||_.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,L.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const _=k,D=this.pendingRequests.get(_.request_seq);D&&(this.pendingRequests.delete(_.request_seq),D(_));break}}}internalSend(k,_){_.type=k,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((_,D)=>k.set(D,_)),await(0,L.timeout)(500),k.forEach((_,D)=>{_({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(fe[207],me([0,1,8,2,9,25,10]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function _(i,t,c){return i.replace(k,function(d,o){return t&&o.length>0&&o[0]!=="_"?d:c&&c.hasOwnProperty(o)?c[o]:d})}e.formatPII=_;function D(i){const t={};for(const c of Object.keys(i))c.startsWith("!")||(t[c]=i[c]);return t}e.filterExceptionsFromTelemetry=D;function P(i){return i.configuration.request==="attach"&&!I(i)&&(!i.parentSession||P(i.parentSession))}e.isSessionAttach=P;function I(i){let t=i.configuration.type;if(!!t)return t==="vslsShare"&&(t=i.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(t,"extensionhost")||(0,m.equalsIgnoreCase)(t,"pwa-extensionhost")?i:i.parentSession?I(i.parentSession):void 0}e.getExtensionHostDebugSession=I;function l(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=l;function v(i,t,c){let d,o=0,f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,u=null;for(;u=f.exec(i);){let E=u.index+1,T=E+u[0].length;if(E<=t&&T>=c){d=u[0],o=E;break}}if(d){let E=/\w+/g,T=null;for(;(T=E.exec(d))&&!(T.index+1+o+T[0].length>=c););T&&(d=d.substring(0,E.lastIndex))}return d?{start:o,end:o+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=v;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(i){return!!(i&&i.match(h))}e.isUri=w;function S(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(w(i.path))return L.URI.parse(i.path);if((0,y.isAbsolute)(i.path))return L.URI.file(i.path)}return i.path}function A(i){if(typeof i.path=="object"){const t=L.URI.revive(i.path);if(t)return t.scheme===n.Schemas.file?t.fsPath:t.toString()}return i.path}function p(i,t){const c=t?S:A,d=(0,C.deepClone)(i);return r(d,(o,f)=>{o&&f&&(f.path=c(f))}),d}e.convertToDAPaths=p;function a(i,t){const c=t?S:A,d=(0,C.deepClone)(i);return r(d,(o,f)=>{!o&&f&&(f.path=c(f))}),d}e.convertToVSCPaths=a;function r(i,t){switch(i.type){case"event":const c=i;switch(c.event){case"output":t(!1,c.body.source);break;case"loadedSource":t(!1,c.body.source);break;case"breakpoint":t(!1,c.body.breakpoint.source);break;default:break}break;case"request":const d=i;switch(d.command){case"setBreakpoints":t(!0,d.arguments.source);break;case"breakpointLocations":t(!0,d.arguments.source);break;case"source":t(!0,d.arguments.source);break;case"gotoTargets":t(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(f=>t(!1,f));break;default:break}break;case"response":const o=i;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(f=>t(!1,f.source));break;case"loadedSources":o.body.sources.forEach(f=>t(!1,f));break;case"scopes":o.body.scopes.forEach(f=>t(!1,f.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(f=>t(!1,f.source));break;case"setBreakpoints":o.body.breakpoints.forEach(f=>t(!1,f.source));break;default:break}break}}function g(i){return i.filter(t=>!t.presentation?.hidden).sort((t,c)=>t.presentation?c.presentation?t.presentation.group?c.presentation.group?t.presentation.group!==c.presentation.group?t.presentation.group.localeCompare(c.presentation.group):s(t.presentation.order,c.presentation.order):-1:c.presentation.group?1:s(t.presentation.order,c.presentation.order):-1:c.presentation?1:0)}e.getVisibleAndSorted=g;function s(i,t){return typeof i!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:i-t}async function b(i,t){const c=i.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(c!=="none"&&(await t.saveAll(),c==="allEditorsInActiveGroup")){const d=t.activeEditorPane;d&&await t.save({editor:d.input,groupId:d.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=b}),define(fe[208],me([0,1,28,38,173,124,9,8,25,12,183,123]),function(Y,e,m,L,y,C,n,k,_,D,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(p,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,p.on("data",r=>this.handleData(r))}sendMessage(p){if(this.outputStream){const a=JSON.stringify(p);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${l.TWO_CRLF}${a}`,"utf8")}}handleData(p){for(this.rawData=Buffer.concat([this.rawData,p]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(r){this._onError.fire(new Error((r.message||r)+`
`+a))}continue}}else{const a=this.rawData.indexOf(l.TWO_CRLF);if(a!==-1){const g=this.rawData.toString("utf8",0,a).split(l.HEADER_LINESEPARATOR);for(const s of g){const b=s.split(l.HEADER_FIELDSEPARATOR);b[0]==="Content-Length"&&(this.contentLength=Number(b[1]))}this.rawData=this.rawData.slice(a+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class v extends l{startSession(){return new Promise((p,a)=>{let r=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),p(),r=!0}),this.socket.on("close",()=>{r?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",g=>{r?this._onError.fire(g):a(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=v;class h extends v{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",p)}}e.SocketDebugAdapter=h;class w extends v{constructor(p){super();this.adapterServer=p}createConnection(p){return C.createConnection(this.adapterServer.path,p)}}e.NamedPipeDebugAdapter=w;class S extends l{constructor(p,a,r){super();this.adapterExecutable=p,this.debugType=a,this.outputService=r}async startSession(){const p=this.adapterExecutable.command,a=this.adapterExecutable.args,r=this.adapterExecutable.options||{};try{if(p)if(n.isAbsolute(p)){if(!await m.Promises.exists(p))throw new Error(y.localize(0,null,p))}else p.indexOf("/")<0&&p.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let g=process.env;if(r.env&&Object.keys(r.env).length>0&&(g=_.mixin(_.deepClone(process.env),r.env)),p==="node")if(Array.isArray(a)&&a.length>0){const b=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:g,execArgv:b?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(i.cwd=r.cwd);const t=L.fork(a[0],a.slice(1),i);if(!t.pid)throw new Error(y.localize(2,null,a[0]));this.serverProcess=t}else throw new Error(y.localize(3,null));else{const b={env:g};r.cwd&&(b.cwd=r.cwd),this.serverProcess=L.spawn(p,a,b)}this.serverProcess.on("error",b=>{this._onError.fire(b)}),this.serverProcess.on("exit",(b,i)=>{this._onExit.fire(b)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",b=>{this._onError.fire(b)}),this.serverProcess.stdin.on("error",b=>{this._onError.fire(b)});const s=this.outputService;if(s){const b=i=>i.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",i=>{const t=s.getChannel(P.ExtensionsChannelId);t&&t.append(b(i))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),D.isWindows?new Promise((p,a)=>{const r=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,s,b){if(g)return a(g)});r.on("exit",p),r.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(p,a){if(!p)return;const r=Object.create(null);p.runtime&&(p.runtime.indexOf("./")===0?r.runtime=n.join(a,p.runtime):r.runtime=p.runtime),p.runtimeArgs&&(r.runtimeArgs=p.runtimeArgs),p.program&&(n.isAbsolute(p.program)?r.program=p.program:r.program=n.join(a,p.program)),p.args&&(r.args=p.args);const g=p;return g.win&&(r.win=S.extract(g.win,a)),g.winx86&&(r.winx86=S.extract(g.winx86,a)),g.windows&&(r.windows=S.extract(g.windows,a)),g.osx&&(r.osx=S.extract(g.osx,a)),g.linux&&(r.linux=S.extract(g.linux,a)),r}static platformAdapterExecutable(p,a){let r=Object.create(null);a=a.toLowerCase();for(const c of p)if(c.contributes){const d=c.contributes.debuggers;d&&d.length>0&&d.filter(o=>typeof o.type=="string"&&k.equalsIgnoreCase(o.type,a)).forEach(o=>{const f=S.extract(o,c.extensionLocation.fsPath);r=_.mixin(r,f,c.isBuiltin)})}let g;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=r.winx86||r.win||r.windows:D.isWindows?g=r.win||r.windows:D.isMacintosh?g=r.osx:D.isLinux&&(g=r.linux),g=g||r;let s=g.program||r.program;const b=g.args||r.args;let i=g.runtime||r.runtime;const t=g.runtimeArgs||r.runtimeArgs;if(i)return{type:"executable",command:i,args:(t||[]).concat(typeof s=="string"?[s]:[]).concat(b||[])};if(s)return{type:"executable",command:s,args:b||[]}}}e.ExecutableDebugAdapter=S}),define(fe[209],me([0,1,38,12,30,185]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function n(l,v){return new Promise((h,w)=>{let S="";const A=m.spawn(l,v);A.pid&&A.stdout.on("data",p=>{S+=p.toString()}),A.on("error",p=>{w(p)}),A.on("close",p=>{h(S)})})}let k;function _(l,v){if(!k)if(L.isWindows)k=new C.WindowsExternalTerminalService;else if(L.isMacintosh)k=new C.MacExternalTerminalService;else if(L.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=v.getConfiguration("terminal");return k.runInTerminal(l.title,l.cwd,l.args,l.env||{},h.external||{})}e.runInExternalTerminal=_;async function D(l){if(l)if(L.isWindows){const v=await new Promise((h,w)=>{Y(["windows-process-tree"],h,w)});return new Promise(h=>{v.getProcessTree(l,w=>{h(w.children.length>0)})})}else return n("/usr/bin/pgrep",["-lP",String(l)]).then(v=>{const h=v.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},v=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var P;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(P||(P={}));function I(l,v,h,w){l=l.trim().toLowerCase();let S;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?S=1:l.indexOf("cmd.exe")>=0?S=0:l.indexOf("bash")>=0?S=2:L.isWindows?S=0:S=2;let A,p=" ";switch(S){case 1:if(A=r=>(r=r.replace(/\'/g,"''"),r.length>0&&r.charAt(r.length-1)==="\\"?`'${r}\\'`:`'${r}'`),h){const r=(0,y.getDriveLetter)(h);r&&(p+=`${r}:; `),p+=`cd ${A(h)}; `}if(w)for(let r in w){const g=w[r];g===null?p+=`Remove-Item env:${r}; `:p+=`\${env:${r}}='${g}'; `}if(v.length>0){const r=A(v.shift());p+=r[0]==="'"?`& ${r} `:`${r} `;for(let g of v)p+=`${A(g)} `}break;case 0:if(A=r=>(r=r.replace(/\"/g,'""'),r.indexOf(" ")>=0||r.indexOf('"')>=0||r.length===0?`"${r}"`:r),h){const r=(0,y.getDriveLetter)(h);r&&(p+=`${r}: && `),p+=`cd ${A(h)} && `}if(w){p+='cmd /C "';for(let r in w){let g=w[r];g===null?p+=`set "${r}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,s=>`^${s}`),p+=`set "${r}=${g}" && `)}}for(let r of v)p+=`${A(r)} `;w&&(p+='"');break;case 2:A=r=>(r=r.replace(/(["'\\\$])/g,"\\$1"),r.indexOf(" ")>=0||r.indexOf(";")>=0||r.length===0?`"${r}"`:r);const a=r=>/[^\w@%\/+=,.:^-]/.test(r)?`'${r.replace(/'/g,"'\\''")}'`:r;if(h&&(p+=`cd ${A(h)} ; `),w){p+="/usr/bin/env";for(let r in w){const g=w[r];g===null?p+=` -u ${a(r)}`:p+=` ${a(`${r}=${g}`)}`}p+=" "}for(let r of v)p+=`${A(r)} `;break}return p}e.prepareCommand=I}),define(fe[125],me([0,1,31,76,102,10,9,12,61]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var l;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(l=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var S;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(S=e.CellEditType||(e.CellEditType={}));var A;(function(E){E.scheme=C.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function R(M,H){return M.with({scheme:E.scheme,fragment:`ch${H.toString().padStart(7,"0")}${M.scheme!==C.Schemas.file?M.scheme:""}`})}E.generate=R;function B(M){if(M.scheme!==E.scheme)return;const H=T.exec(M.fragment);return H?{handle:Number(H[1]),notebook:M.with({scheme:M.fragment.substr(H[0].length)||C.Schemas.file,fragment:null})}:void 0}E.parse=B;function x(M){if(M.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const H=T.exec(M.fragment);return H?{handle:Number(H[1]),notebook:M.with({scheme:M.fragment.substr(H[0].length)||C.Schemas.file,fragment:null})}:void 0}E.parseCellMetadataUri=x;function F(M,H,N){return M.with({scheme:N,fragment:`ch${H.toString().padStart(7,"0")}${M.scheme!==C.Schemas.file?M.scheme:""}`})}E.generateCellUri=F;function $(M,H){if(M.scheme!==H)return;const N=T.exec(M.fragment);return N?{handle:Number(N[1]),notebook:M.with({scheme:M.fragment.substr(N[0].length)||C.Schemas.file,fragment:null})}:void 0}E.parseCellUri=$})(A=e.CellUri||(e.CellUri={}));const p=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function a(E){return p.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=a;function r(E){return p.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=r;function g(E){return p.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=g;const s=E=>k.isWindows?E.replace(/\//g,"\\"):E;class b{constructor(T=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(T)].map(B=>({pattern:B,matches:m.parse(s(B))}))}sort(T){const R=new Map(L.Iterable.map(T,x=>[x,s(x)]));let B=[];for(const{matches:x}of this.order)for(const[F,$]of R)if(x($)){B.push(F),R.delete(F);break}return R.size&&(B=B.concat([...R.keys()].sort((x,F)=>this.defaultOrder.indexOf(x)-this.defaultOrder.indexOf(F)))),B}prioritize(T,R){const B=this.findIndex(T);if(B===-1){this.order.unshift({pattern:T,matches:m.parse(s(T))});return}const x=new Set(R.map($=>this.findIndex($,B)));x.delete(-1);const F=Array.from(x).sort();this.order.splice(B+1,0,...F.map($=>this.order[$]));for(let $=F.length-1;$>=0;$--)this.order.splice(F[$],1)}toArray(){return this.order.map(T=>T.pattern)}findIndex(T,R=this.order.length){const B=s(T);for(let x=0;x<R;x++)if(this.order[x].matches(B))return x;return-1}}e.MimeTypeDisplayOrder=b;function i(E,T,R,B=(x,F)=>x===F){const x=[];function F(H,N,U){if(N===0&&U.length===0)return;const V=x[x.length-1];V&&V.start+V.deleteCount===H?(V.deleteCount+=N,V.toInsert.push(...U)):x.push({start:H,deleteCount:N,toInsert:U})}let $=0,M=0;for(;;){if($===E.length){F($,0,T.slice(M));break}if(M===T.length){F($,E.length-$,[]);break}const H=E[$],N=T[M];if(B(H,N)){$+=1,M+=1;continue}R(N)?(F($,1,[]),$+=1):(F($,0,[N]),M+=1)}return x}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(E){E.default="default",E.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(E){const T=E;return!!((typeof T.include=="string"||m.isRelativePattern(T.include))&&(typeof T.exclude=="string"||m.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=c;function d(E,T,R){if(Array.isArray(E.viewType)&&E.viewType.indexOf(T)>=0||E.viewType===T)return!0;if(E.filenamePattern){let B=c(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,x=c(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(m.match(B,(0,n.basename)(R.fsPath).toLowerCase()))return!(x&&m.match(x,(0,n.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class o{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)T[R]=this.textModel.cells[R].getHashValue();return T}}e.CellSequence=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var f;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(T){return`${u._prefix}${T}`}static parse(T){if(T.startsWith(u._prefix))return T.substr(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(fe[210],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState",y[y.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(fe[211],me([0,1,4,61]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new L.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new L.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new L.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,m.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(fe[212],me([0,1,175,4,61]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new y.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new y.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new y.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[213],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=m;function L(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=L}),define(fe[126],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(y=e.TestMessageType||(e.TestMessageType={}));var C;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const n=(I,l)=>{l.expand!==void 0&&(I.expand=l.expand),l.item!==void 0&&(I.item=I.item?Object.assign(I.item,l.item):l.item)};e.applyTestItemUpdate=n;var k;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var _;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class D{add(l){}update(l){}remove(l,v){}complete(){}}e.IncrementalChangeCollector=D;class P{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(l){const v=this.createChangeCollector();for(const h of l)switch(h[0]){case 0:{const w=h[1];if(w.parent){if(this.items.has(w.parent)){const S=this.items.get(w.parent);S.children.add(w.item.extId);const A=this.createItem(w,S);this.items.set(w.item.extId,A),v.add(A)}}else{const S=this.createItem(w);this.roots.add(S),this.items.set(w.item.extId,S),v.add(S)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=h[1],S=this.items.get(w.extId);if(!S)break;w.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,w),v.update(S);break}case 2:{const w=this.items.get(h[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const S=[[h[1]]];for(;S.length;)for(const A of S.pop()){const p=this.items.get(A);p&&(S.push(p.children),this.items.delete(A),v.remove(p,p!==w),p.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}v.complete()}retireTest(l){}updatePendingRoots(l){this.pendingRootCount+=l}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=P}),define(fe[90],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class y{constructor(n,k=n.length){if(this.path=n,this.viewEnd=k,n.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(n,k,_=n.parent){if(n.id===k)return new y([k]);let D=[n.id];for(let P=_;P&&P.id!==k;P=P.parent)D.push(P.id);return D.push(k),new y(D.reverse())}static isRoot(n){return!n.includes("\0")}static fromString(n){return new y(n.split("\0"))}static join(n,k){return new y([...n.path,k])}static joinToString(n,k){return n.toString()+"\0"+k}static compare(n,k){return n===k?0:k.startsWith(n+"\0")?2:n.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let n=1;n<=this.viewEnd;n++)yield new y(this.path,n)}compare(n){if(typeof n=="string")return y.compare(this.toString(),n);for(let k=0;k<n.viewEnd&&k<this.viewEnd;k++)if(n.path[k]!==this.path[k])return 1;return n.viewEnd>this.viewEnd?2:n.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let n=1;n<this.viewEnd;n++)this.stringifed+="\0",this.stringifed+=this.path[n]}return this.stringifed}}e.TestId=y}),define(fe[214],me([0,1,9,37,13,25,12,80,176]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(I,l,v){this._contributedVariables=new Map,this._context=I,this._labelService=l,v&&(this._envVariablesPromise=v.then(h=>this.prepareEnv(h)))}prepareEnv(I){if(n.isWindows){const l=Object.create(null);return Object.keys(I).forEach(v=>{l[v.toLowerCase()]=I[v]}),l}return I}resolveWithEnvironment(I,l,v){return this.recursiveResolve(this.prepareEnv(I),l?l.uri:void 0,v)}async resolveAsync(I,l){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,l)}async resolveAnyBase(I,l,v,h){const w=C.deepClone(l);return n.isWindows&&w.windows?Object.keys(w.windows).forEach(S=>w[S]=w.windows[S]):n.isMacintosh&&w.osx?Object.keys(w.osx).forEach(S=>w[S]=w.osx[S]):n.isLinux&&w.linux&&Object.keys(w.linux).forEach(S=>w[S]=w.linux[S]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,w,v,h)}async resolveAnyAsync(I,l,v){return this.resolveAnyBase(I,l,v)}async resolveAnyMap(I,l,v){const h=new Map;return{newConfig:await this.resolveAnyBase(I,l,v,h),resolvedVariables:h}}resolveWithInteractionReplace(I,l,v,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,l,v,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,l){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,l)}recursiveResolve(I,l,v,h,w){if(y.isString(v))return this.resolveString(I,l,v,h,w);if(y.isArray(v))return v.map(S=>this.recursiveResolve(I,l,S,h,w));if(y.isObject(v)){let S=Object.create(null);return Object.keys(v).forEach(A=>{const p=this.resolveString(I,l,A,h,w);S[p]=this.recursiveResolve(I,l,v[A],h,w)}),S}return v}resolveString(I,l,v,h,w){return v.replace(D.VARIABLE_REGEXP,(A,p)=>{if(p.includes(D.VARIABLE_LHS))return A;let a=this.evaluateSingleVariable(I,A,p,l,h);return w&&w.set(p,a),a!==A&&y.isString(a)&&a.match(D.VARIABLE_REGEXP)&&(a=this.resolveString(I,l,a,h,w)),a})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,l,v,h,w){let S;const A=v.split(":");A.length>1&&(v=A[0],S=A[1]);const p=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,_.localize)(0,null,l))},a=()=>{const g=p();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,_.localize)(1,null,l,m.basename(g)))},r=()=>{if(S){const g=this._context.getFolderUri(S);if(g)return g;throw new Error((0,_.localize)(2,null,l,S))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,l)):new Error((0,_.localize)(4,null,l))};switch(v){case"env":if(S){if(I){const g=I[n.isWindows?S.toLowerCase():S];if(y.isString(g))return g}return""}throw new Error((0,_.localize)(5,null,l));case"config":if(S){const g=this._context.getConfigurationValue(h,S);if(y.isUndefinedOrNull(g))throw new Error((0,_.localize)(6,null,l,S));if(y.isObject(g))throw new Error((0,_.localize)(7,null,l,S));return g}throw new Error((0,_.localize)(8,null,l));case"command":return this.resolveFromMap(l,S,w,"command");case"input":return this.resolveFromMap(l,S,w,"input");default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(r()));case"cwd":return h||S?(0,k.normalizeDriveLetter)(this.fsPath(r())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(r()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error((0,_.localize)(9,null,l));case"selectedText":const s=this._context.getSelectedText();if(s)return s;throw new Error((0,_.localize)(10,null,l));case"file":return p();case"fileWorkspaceFolder":return a();case"relativeFile":return h||S?m.relative(this.fsPath(r()),p()):p();case"relativeFileDirname":const b=m.dirname(p());if(h||S){const d=m.relative(this.fsPath(r()),b);return d.length===0?".":d}return b;case"fileDirname":return m.dirname(p());case"fileExtname":return m.extname(p());case"fileBasename":return m.basename(p());case"fileBasenameNoExtension":const i=m.basename(p());return i.slice(0,i.length-m.extname(i).length);case"fileDirnameBasename":return m.basename(m.dirname(p()));case"execPath":const t=this._context.getExecPath();return t||l;case"execInstallFolder":const c=this._context.getAppRoot();return c||l;case"pathSeparator":return m.sep;default:try{const d=S?`${v}:${S}`:v;return this.resolveFromMap(l,d,w,void 0)}catch(d){return l}}}}resolveFromMap(I,l,v,h){if(l&&v){const w=h===void 0?v[l]:v[h+":"+l];if(typeof w=="string")return w;throw new Error((0,_.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[127],me([0,1,4,206]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var y;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var C;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var n;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(n=e.GroupLocation||(e.GroupLocation={}));var k;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function D(w){const S=w;return(0,L.isEditorInput)(S?.editor)&&(0,L.isEditorInput)(S?.replacement)}e.isEditorReplacement=D;var P;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.GROUP_LOCKED=2]="GROUP_LOCKED",w[w.EDITOR_OPEN=3]="EDITOR_OPEN",w[w.EDITOR_CLOSE=4]="EDITOR_CLOSE",w[w.EDITOR_MOVE=5]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=7]="EDITOR_LABEL",w[w.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",w[w.EDITOR_PIN=9]="EDITOR_PIN",w[w.EDITOR_STICKY=10]="EDITOR_STICKY",w[w.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var l;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(l=e.OpenEditorContext||(e.OpenEditorContext={}));function v(w){const S=w;return!!S&&typeof S.id=="number"&&Array.isArray(S.editors)}e.isEditorGroup=v;function h(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=h}),define(fe[215],me([0,1,4,127]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(C){const n=C;return typeof C=="number"||(0,L.isEditorGroup)(n)}e.isPreferredGroup=y}),define(fe[15],me([0,1,17,22,98,290,59,25,13,2,41,84,177,116,63,125,90,215,7]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(ge){function Ee(K){const{selectionStartLineNumber:Ce,selectionStartColumn:Le,positionLineNumber:nt,positionColumn:Ge}=K,mt=new p.Position(Ce-1,Le-1),yt=new p.Position(nt-1,Ge-1);return new p.Selection(mt,yt)}ge.to=Ee;function ae(K){const{anchor:Ce,active:Le}=K;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ge.from=ae})(a=e.Selection||(e.Selection={}));var r;(function(ge){function Ee(K){if(!K)return;const{start:Ce,end:Le}=K;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ge.from=Ee;function ae(K){if(!K)return;const{startLineNumber:Ce,startColumn:Le,endLineNumber:nt,endColumn:Ge}=K;return new p.Range(Ce-1,Le-1,nt-1,Ge-1)}ge.to=ae})(r=e.Range||(e.Range={}));var g;(function(ge){function Ee(ae){switch(ae){case 1:return p.StandardTokenType.Comment;case 0:return p.StandardTokenType.Other;case 4:return p.StandardTokenType.RegEx;case 2:return p.StandardTokenType.String}}ge.to=Ee})(g=e.TokenType||(e.TokenType={}));var s;(function(ge){function Ee(K){return new p.Position(K.lineNumber-1,K.column-1)}ge.to=Ee;function ae(K){return{lineNumber:K.line+1,column:K.character+1}}ge.from=ae})(s=e.Position||(e.Position={}));var b;(function(ge){function Ee(Ce,Le){return(0,m.coalesce)((0,m.asArray)(Ce).map(nt=>ae(nt,Le)))}ge.from=Ee;function ae(Ce,Le){if(typeof Ce=="string")return{$serialized:!0,language:Ce};if(Ce)return{$serialized:!0,language:Ce.language,scheme:K(Ce.scheme,Le),pattern:typeof Ce.pattern=="undefined"?void 0:le.from(Ce.pattern),exclusive:Ce.exclusive}}function K(Ce,Le){return Le&&typeof Ce=="string"?Le.transformOutgoingScheme(Ce):Ce}})(b=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(ge){function Ee(K){switch(K){case p.DiagnosticTag.Unnecessary:return 1;case p.DiagnosticTag.Deprecated:return 2}}ge.from=Ee;function ae(K){switch(K){case 1:return p.DiagnosticTag.Unnecessary;case 2:return p.DiagnosticTag.Deprecated;default:return}}ge.to=ae})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(ge){function Ee(K){let Ce;return K.code&&((0,_.isString)(K.code)||(0,_.isNumber)(K.code)?Ce=String(K.code):Ce={value:String(K.code.value),target:K.code.target}),{...r.from(K.range),message:K.message,source:K.source,code:Ce,severity:d.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(c.from),tags:Array.isArray(K.tags)?(0,m.coalesce)(K.tags.map(i.from)):void 0}}ge.from=Ee;function ae(K){const Ce=new p.Diagnostic(r.to(K),K.message,d.to(K.severity));return Ce.source=K.source,Ce.code=(0,_.isString)(K.code)?K.code:K.code?.value,Ce.relatedInformation=K.relatedInformation&&K.relatedInformation.map(c.to),Ce.tags=K.tags&&(0,m.coalesce)(K.tags.map(i.to)),Ce}ge.to=ae})(t=e.Diagnostic||(e.Diagnostic={}));var c;(function(ge){function Ee(K){return{...r.from(K.location.range),message:K.message,resource:K.location.uri}}ge.from=Ee;function ae(K){return new p.DiagnosticRelatedInformation(new p.Location(K.resource,r.to(K)),K.message)}ge.to=ae})(c=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(ge){function Ee(K){switch(K){case p.DiagnosticSeverity.Error:return v.MarkerSeverity.Error;case p.DiagnosticSeverity.Warning:return v.MarkerSeverity.Warning;case p.DiagnosticSeverity.Information:return v.MarkerSeverity.Info;case p.DiagnosticSeverity.Hint:return v.MarkerSeverity.Hint}return v.MarkerSeverity.Error}ge.from=Ee;function ae(K){switch(K){case v.MarkerSeverity.Info:return p.DiagnosticSeverity.Information;case v.MarkerSeverity.Warning:return p.DiagnosticSeverity.Warning;case v.MarkerSeverity.Error:return p.DiagnosticSeverity.Error;case v.MarkerSeverity.Hint:return p.DiagnosticSeverity.Hint;default:return p.DiagnosticSeverity.Error}}ge.to=ae})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var o;(function(ge){function Ee(K){return typeof K=="number"&&K>=p.ViewColumn.One?K-1:K===p.ViewColumn.Beside?A.SIDE_GROUP:A.ACTIVE_GROUP}ge.from=Ee;function ae(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=ae})(o=e.ViewColumn||(e.ViewColumn={}));function f(ge){return typeof ge.range!="undefined"}function u(ge){return ge.length===0?!0:!!f(ge[0])}e.isDecorationOptionsArr=u;var E;(function(ge){function Ee(Ge){return Ge.map(ge.from)}ge.fromMany=Ee;function ae(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function K(Ge){let mt;if(ae(Ge)){const{language:bt,value:vt}=Ge;mt={value:"```"+bt+`
`+vt+"\n```\n"}}else p.MarkdownString.isMarkdownString(Ge)?mt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml}:typeof Ge=="string"?mt={value:Ge}:mt={value:""};const yt=Object.create(null);mt.uris=yt;const _t=bt=>{try{let vt=D.URI.parse(bt,!0);vt=vt.with({query:Ce(vt.query,yt)}),yt[bt]=vt}catch(vt){}return""},gt=new C.Renderer;return gt.link=_t,gt.image=bt=>_t(y.parseHrefAndDimensions(bt).href),C(mt.value,{renderer:gt}),mt}ge.from=K;function Ce(Ge,mt){if(!Ge)return Ge;let yt;try{yt=(0,n.parse)(Ge)}catch(gt){}if(!yt)return Ge;let _t=!1;return yt=(0,k.cloneAndChange)(yt,gt=>{if(D.URI.isUri(gt)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[bt]=gt,_t=!0,bt}else return}),_t?JSON.stringify(yt):Ge}function Le(Ge){const mt=new p.MarkdownString(Ge.value,Ge.supportThemeIcons);return mt.isTrusted=Ge.isTrusted,mt.supportHtml=Ge.supportHtml,mt}ge.to=Le;function nt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ge.from(Ge)}ge.fromStrict=nt})(E=e.MarkdownString||(e.MarkdownString={}));function T(ge){return u(ge)?ge.map(Ee=>({range:r.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?E.fromMany(Ee.hoverMessage):Ee.hoverMessage?E.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):ge.map(Ee=>({range:r.from(Ee)}))}e.fromRangeOrRangeWithMessage=T;function R(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?D.URI.file(ge):ge}e.pathOrURIToURI=R;var B;(function(ge){function Ee(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?R(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ge.from=Ee})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var x;(function(ge){function Ee(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?B.from(ae.before):void 0,after:ae.after?B.from(ae.after):void 0}}ge.from=Ee})(x=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ge){function Ee(ae){if(typeof ae=="undefined")return ae;switch(ae){case p.DecorationRangeBehavior.OpenOpen:return 0;case p.DecorationRangeBehavior.ClosedClosed:return 1;case p.DecorationRangeBehavior.OpenClosed:return 2;case p.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=Ee})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(ge){function Ee(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?F.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?x.from(ae.light):void 0,dark:ae.dark?x.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?B.from(ae.before):void 0,after:ae.after?B.from(ae.after):void 0}}ge.from=Ee})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(ge){function Ee(K){return{text:K.newText,eol:K.newEol&&J.from(K.newEol),range:r.from(K.range)}}ge.from=Ee;function ae(K){const Ce=new p.TextEdit(r.to(K.range),K.text);return Ce.newEol=typeof K.eol=="undefined"?void 0:J.to(K.eol),Ce}ge.to=ae})(M=e.TextEdit||(e.TextEdit={}));var H;(function(ge){function Ee(K,Ce,Le){const nt={edits:[]};if(K instanceof p.WorkspaceEdit)for(let Ge of K._allEntries())if(Ge._type===1)nt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const mt=Ce?.getDocument(Ge.uri);nt.edits.push({_type:2,resource:Ge.uri,edit:M.from(Ge.edit),modelVersionId:mt?.version,metadata:Ge.metadata})}else Ge._type===3?nt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&nt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(tt.from)}});return nt}ge.from=Ee;function ae(K){const Ce=new p.WorkspaceEdit;for(const Le of K.edits)Le.edit?Ce.replace(D.URI.revive(Le.resource),r.to(Le.edit.range),Le.edit.text):Ce.renameFile(D.URI.revive(Le.oldUri),D.URI.revive(Le.newUri),Le.options);return Ce}ge.to=ae})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(ge){const Ee=Object.create(null);Ee[p.SymbolKind.File]=0,Ee[p.SymbolKind.Module]=1,Ee[p.SymbolKind.Namespace]=2,Ee[p.SymbolKind.Package]=3,Ee[p.SymbolKind.Class]=4,Ee[p.SymbolKind.Method]=5,Ee[p.SymbolKind.Property]=6,Ee[p.SymbolKind.Field]=7,Ee[p.SymbolKind.Constructor]=8,Ee[p.SymbolKind.Enum]=9,Ee[p.SymbolKind.Interface]=10,Ee[p.SymbolKind.Function]=11,Ee[p.SymbolKind.Variable]=12,Ee[p.SymbolKind.Constant]=13,Ee[p.SymbolKind.String]=14,Ee[p.SymbolKind.Number]=15,Ee[p.SymbolKind.Boolean]=16,Ee[p.SymbolKind.Array]=17,Ee[p.SymbolKind.Object]=18,Ee[p.SymbolKind.Key]=19,Ee[p.SymbolKind.Null]=20,Ee[p.SymbolKind.EnumMember]=21,Ee[p.SymbolKind.Struct]=22,Ee[p.SymbolKind.Event]=23,Ee[p.SymbolKind.Operator]=24,Ee[p.SymbolKind.TypeParameter]=25;function ae(Ce){return typeof Ee[Ce]=="number"?Ee[Ce]:6}ge.from=ae;function K(Ce){for(const Le in Ee)if(Ee[Le]===Ce)return Number(Le);return p.SymbolKind.Property}ge.to=K})(N=e.SymbolKind||(e.SymbolKind={}));var U;(function(ge){function Ee(K){switch(K){case p.SymbolTag.Deprecated:return 1}}ge.from=Ee;function ae(K){switch(K){case 1:return p.SymbolTag.Deprecated}}ge.to=ae})(U=e.SymbolTag||(e.SymbolTag={}));var V;(function(ge){function Ee(K){return{name:K.name,kind:N.from(K.kind),tags:K.tags&&K.tags.map(U.from),containerName:K.containerName,location:Q.from(K.location)}}ge.from=Ee;function ae(K){const Ce=new p.SymbolInformation(K.name,N.to(K.kind),K.containerName,Q.to(K.location));return Ce.tags=K.tags&&K.tags.map(U.to),Ce}ge.to=ae})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ge){function Ee(K){const Ce={name:K.name||"!!MISSING: name!!",detail:K.detail,range:r.from(K.range),selectionRange:r.from(K.selectionRange),kind:N.from(K.kind),tags:K.tags?.map(U.from)??[]};return K.children&&(Ce.children=K.children.map(Ee)),Ce}ge.from=Ee;function ae(K){const Ce=new p.DocumentSymbol(K.name,K.detail,N.to(K.kind),r.to(K.range),r.to(K.selectionRange));return(0,m.isNonEmptyArray)(K.tags)&&(Ce.tags=K.tags.map(U.to)),K.children&&(Ce.children=K.children.map(ae)),Ce}ge.to=ae})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var W;(function(ge){function Ee(K){const Ce=new p.CallHierarchyItem(N.to(K.kind),K.name,K.detail||"",D.URI.revive(K.uri),r.to(K.range),r.to(K.selectionRange));return Ce._sessionId=K._sessionId,Ce._itemId=K._itemId,Ce}ge.to=Ee;function ae(K,Ce,Le){if(Ce=Ce??K._sessionId,Le=Le??K._itemId,Ce===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Le,name:K.name,detail:K.detail,kind:N.from(K.kind),uri:K.uri,range:r.from(K.range),selectionRange:r.from(K.selectionRange),tags:K.tags?.map(U.from)}}ge.from=ae})(W=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(ge){function Ee(ae){return new p.CallHierarchyIncomingCall(W.to(ae.from),ae.fromRanges.map(K=>r.to(K)))}ge.to=Ee})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var X;(function(ge){function Ee(ae){return new p.CallHierarchyOutgoingCall(W.to(ae.to),ae.fromRanges.map(K=>r.to(K)))}ge.to=Ee})(X=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(ge){function Ee(K){return{range:K.range&&r.from(K.range),uri:K.uri}}ge.from=Ee;function ae(K){return new p.Location(D.URI.revive(K.uri),r.to(K.range))}ge.to=ae})(Q=e.location||(e.location={}));var de;(function(ge){function Ee(K){const Ce=K,Le=K;return{originSelectionRange:Ce.originSelectionRange?r.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Le.uri,range:r.from(Ce.targetRange?Ce.targetRange:Le.range),targetSelectionRange:Ce.targetSelectionRange?r.from(Ce.targetSelectionRange):void 0}}ge.from=Ee;function ae(K){return{targetUri:D.URI.revive(K.uri),targetRange:r.to(K.range),targetSelectionRange:K.targetSelectionRange?r.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?r.to(K.originSelectionRange):void 0}}ge.to=ae})(de=e.DefinitionLink||(e.DefinitionLink={}));var Se;(function(ge){function Ee(K){return{range:r.from(K.range),contents:E.fromMany(K.contents)}}ge.from=Ee;function ae(K){return new p.Hover(K.contents.map(E.to),r.to(K.range))}ge.to=ae})(Se=e.Hover||(e.Hover={}));var De;(function(ge){function Ee(K){return{range:r.from(K.range),expression:K.expression}}ge.from=Ee;function ae(K){return new p.EvaluatableExpression(r.to(K.range),K.expression)}ge.to=ae})(De=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ge){function Ee(K){if(K instanceof p.InlineValueText)return{type:"text",range:r.from(K.range),text:K.text};if(K instanceof p.InlineValueVariableLookup)return{type:"variable",range:r.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof p.InlineValueEvaluatableExpression)return{type:"expression",range:r.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=Ee;function ae(K){switch(K.type){case"text":return{range:r.to(K.range),text:K.text};case"variable":return{range:r.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:r.to(K.range),expression:K.expression}}}ge.to=ae})(Pe=e.InlineValue||(e.InlineValue={}));var Be;(function(ge){function Ee(K){return{frameId:K.frameId,stoppedLocation:r.from(K.stoppedLocation)}}ge.from=Ee;function ae(K){return new p.InlineValueContext(K.frameId,r.to(K.stoppedLocation))}ge.to=ae})(Be=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(ge){function Ee(K){return{range:r.from(K.range),kind:K.kind}}ge.from=Ee;function ae(K){return new p.DocumentHighlight(r.to(K.range),K.kind)}ge.to=ae})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ge){function Ee(ae){switch(ae){case 1:return p.CompletionTriggerKind.TriggerCharacter;case 2:return p.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return p.CompletionTriggerKind.Invoke}}ge.to=Ee})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(ge){function Ee(ae){return{triggerKind:He.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ge.to=Ee})(G=e.CompletionContext||(e.CompletionContext={}));var ee;(function(ge){function Ee(K){switch(K){case p.CompletionItemTag.Deprecated:return 1}}ge.from=Ee;function ae(K){switch(K){case 1:return p.CompletionItemTag.Deprecated}}ge.to=ae})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(ge){const Ee=new Map([[p.CompletionItemKind.Method,0],[p.CompletionItemKind.Function,1],[p.CompletionItemKind.Constructor,2],[p.CompletionItemKind.Field,3],[p.CompletionItemKind.Variable,4],[p.CompletionItemKind.Class,5],[p.CompletionItemKind.Interface,7],[p.CompletionItemKind.Struct,6],[p.CompletionItemKind.Module,8],[p.CompletionItemKind.Property,9],[p.CompletionItemKind.Unit,12],[p.CompletionItemKind.Value,13],[p.CompletionItemKind.Constant,14],[p.CompletionItemKind.Enum,15],[p.CompletionItemKind.EnumMember,16],[p.CompletionItemKind.Keyword,17],[p.CompletionItemKind.Snippet,27],[p.CompletionItemKind.Text,18],[p.CompletionItemKind.Color,19],[p.CompletionItemKind.File,20],[p.CompletionItemKind.Reference,21],[p.CompletionItemKind.Folder,23],[p.CompletionItemKind.Event,10],[p.CompletionItemKind.Operator,11],[p.CompletionItemKind.TypeParameter,24],[p.CompletionItemKind.Issue,26],[p.CompletionItemKind.User,25]]);function ae(Le){return Ee.get(Le)??9}ge.from=ae;const K=new Map([[0,p.CompletionItemKind.Method],[1,p.CompletionItemKind.Function],[2,p.CompletionItemKind.Constructor],[3,p.CompletionItemKind.Field],[4,p.CompletionItemKind.Variable],[5,p.CompletionItemKind.Class],[7,p.CompletionItemKind.Interface],[6,p.CompletionItemKind.Struct],[8,p.CompletionItemKind.Module],[9,p.CompletionItemKind.Property],[12,p.CompletionItemKind.Unit],[13,p.CompletionItemKind.Value],[14,p.CompletionItemKind.Constant],[15,p.CompletionItemKind.Enum],[16,p.CompletionItemKind.EnumMember],[17,p.CompletionItemKind.Keyword],[27,p.CompletionItemKind.Snippet],[18,p.CompletionItemKind.Text],[19,p.CompletionItemKind.Color],[20,p.CompletionItemKind.File],[21,p.CompletionItemKind.Reference],[23,p.CompletionItemKind.Folder],[10,p.CompletionItemKind.Event],[11,p.CompletionItemKind.Operator],[24,p.CompletionItemKind.TypeParameter],[25,p.CompletionItemKind.User],[26,p.CompletionItemKind.Issue]]);function Ce(Le){return K.get(Le)??p.CompletionItemKind.Property}ge.to=Ce})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(ge){function Ee(ae,K){const Ce=new p.CompletionItem(ae.label);return Ce.insertText=ae.insertText,Ce.kind=ne.to(ae.kind),Ce.tags=ae.tags?.map(ee.to),Ce.detail=ae.detail,Ce.documentation=y.isMarkdownString(ae.documentation)?E.to(ae.documentation):ae.documentation,Ce.sortText=ae.sortText,Ce.filterText=ae.filterText,Ce.preselect=ae.preselect,Ce.commitCharacters=ae.commitCharacters,P.Range.isIRange(ae.range)?Ce.range=r.to(ae.range):typeof ae.range=="object"&&(Ce.range={inserting:r.to(ae.range.insert),replacing:r.to(ae.range.replace)}),Ce.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Ce.insertText=new p.SnippetString(ae.insertText):(Ce.insertText=ae.insertText,Ce.textEdit=Ce.range instanceof p.Range?new p.TextEdit(Ce.range,Ce.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Ce.additionalTextEdits=ae.additionalTextEdits.map(Le=>M.to(Le))),Ce.command=K&&ae.command?K.fromInternal(ae.command):void 0,Ce}ge.to=Ee})(ce=e.CompletionItem||(e.CompletionItem={}));var Z;(function(ge){function Ee(K){return{label:K.label,documentation:K.documentation?E.fromStrict(K.documentation):void 0}}ge.from=Ee;function ae(K){return{label:K.label,documentation:y.isMarkdownString(K.documentation)?E.to(K.documentation):K.documentation}}ge.to=ae})(Z=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(ge){function Ee(K){return{label:K.label,documentation:K.documentation?E.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.from):[],activeParameter:K.activeParameter}}ge.from=Ee;function ae(K){return{label:K.label,documentation:y.isMarkdownString(K.documentation)?E.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.to):[],activeParameter:K.activeParameter}}ge.to=ae})(re=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(ge){function Ee(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(re.from):[]}}ge.from=Ee;function ae(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(re.to):[]}}ge.to=ae})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ge){function Ee(K){return{text:K.text,position:s.from(K.position),kind:je.from(K.kind??p.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}ge.from=Ee;function ae(K){const Ce=new p.InlayHint(K.text,s.to(K.position),je.to(K.kind));return Ce.whitespaceAfter=K.whitespaceAfter,Ce.whitespaceBefore=K.whitespaceBefore,Ce}ge.to=ae})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(ge){function Ee(K){return K}ge.from=Ee;function ae(K){return K}ge.to=ae})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(ge){function Ee(K){return{range:r.from(K.range),url:K.target,tooltip:K.tooltip}}ge.from=Ee;function ae(K){let Ce;if(K.url)try{Ce=typeof K.url=="string"?D.URI.parse(K.url,!0):D.URI.revive(K.url)}catch(Le){}return new p.DocumentLink(r.to(K.range),Ce)}ge.to=ae})(Ke=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(ge){function Ee(K){const Ce=new p.ColorPresentation(K.label);return K.textEdit&&(Ce.textEdit=M.to(K.textEdit)),K.additionalTextEdits&&(Ce.additionalTextEdits=K.additionalTextEdits.map(Le=>M.to(Le))),Ce}ge.to=Ee;function ae(K){return{label:K.label,textEdit:K.textEdit?M.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ce=>M.from(Ce)):void 0}}ge.from=ae})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(ge){function Ee(K){return new p.Color(K[0],K[1],K[2],K[3])}ge.to=Ee;function ae(K){return[K.red,K.green,K.blue,K.alpha]}ge.from=ae})(rt=e.Color||(e.Color={}));var ct;(function(ge){function Ee(K){return{range:r.from(K.range)}}ge.from=Ee;function ae(K){return new p.SelectionRange(r.to(K.range))}ge.to=ae})(ct=e.SelectionRange||(e.SelectionRange={}));var ye;(function(ge){function Ee(ae){switch(ae){case 2:return p.TextDocumentSaveReason.AfterDelay;case 1:return p.TextDocumentSaveReason.Manual;case 3:case 4:return p.TextDocumentSaveReason.FocusOut}}ge.to=Ee})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var at;(function(ge){function Ee(K){switch(K){case p.TextEditorLineNumbersStyle.Off:return 0;case p.TextEditorLineNumbersStyle.Relative:return 2;case p.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=Ee;function ae(K){switch(K){case 0:return p.TextEditorLineNumbersStyle.Off;case 2:return p.TextEditorLineNumbersStyle.Relative;case 1:default:return p.TextEditorLineNumbersStyle.On}}ge.to=ae})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(ge){function Ee(K){if(K===p.EndOfLine.CRLF)return 1;if(K===p.EndOfLine.LF)return 0}ge.from=Ee;function ae(K){if(K===1)return p.EndOfLine.CRLF;if(K===0)return p.EndOfLine.LF}ge.to=ae})(J=e.EndOfLine||(e.EndOfLine={}));var ie;(function(ge){function Ee(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case p.ProgressLocation.SourceControl:return 3;case p.ProgressLocation.Window:return 10;case p.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=Ee})(ie=e.ProgressLocation||(e.ProgressLocation={}));var _e;(function(ge){function Ee(ae){const K={start:ae.start+1,end:ae.end+1};return ae.kind&&(K.kind=Qe.from(ae.kind)),K}ge.from=Ee})(_e=e.FoldingRange||(e.FoldingRange={}));var Qe;(function(ge){function Ee(ae){if(ae)switch(ae){case p.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case p.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case p.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}ge.from=Ee})(Qe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(ge){function Ee(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?r.from(ae.selection):void 0,override:typeof ae.override=="boolean"?l.EditorResolution.DISABLED:void 0}}ge.from=Ee})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(ge){function Ee(K){return K instanceof p.RelativePattern||typeof K=="string"?K:ae(K)?new p.RelativePattern(K.base,K.pattern):K}ge.from=Ee;function ae(K){const Ce=K;return Ce&&typeof Ce.base=="string"&&typeof Ce.pattern=="string"}})(le=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(ge){function Ee(ae){if(ae){if(Array.isArray(ae))return ae.map(Ee);if(typeof ae=="string")return ae;{const K=ae;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:le.from(K.pattern),exclusive:K.exclusive}}}else return}ge.from=Ee})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var Ue;(function(ge){function Ee(K){return{start:K.start,end:K.end}}ge.from=Ee;function ae(K){return new p.NotebookRange(K.start,K.end)}ge.to=ae})(Ue=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(ge){function Ee(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ge.to=Ee;function ae(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ge.from=ae})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var it;(function(ge){function Ee(K){switch(K){case p.NotebookCellKind.Markup:return w.CellKind.Markup;case p.NotebookCellKind.Code:default:return w.CellKind.Code}}ge.from=Ee;function ae(K){switch(K){case w.CellKind.Markup:return p.NotebookCellKind.Markup;case w.CellKind.Code:default:return p.NotebookCellKind.Code}}ge.to=ae})(it=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ge){function Ee(K){const Ce={metadata:K.metadata??Object.create(null),cells:[]};for(let Le of K.cells)p.NotebookCellData.validate(Le),Ce.cells.push(tt.from(Le));return Ce}ge.from=Ee;function ae(K){const Ce=new p.NotebookData(K.cells.map(tt.to));return(0,_.isEmptyObject)(K.metadata)||(Ce.metadata=K.metadata),Ce}ge.to=ae})(ft=e.NotebookData||(e.NotebookData={}));var tt;(function(ge){function Ee(K){return{cellKind:it.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Xe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Re.from):[]}}ge.from=Ee;function ae(K){return new p.NotebookCellData(it.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Re.to):void 0,K.metadata,K.internalMetadata?Xe.to(K.internalMetadata):void 0)}ge.to=ae})(tt=e.NotebookCellData||(e.NotebookCellData={}));var ut;(function(ge){function Ee(K){return{mime:K.mime,valueBytes:L.VSBuffer.wrap(K.data)}}ge.from=Ee;function ae(K){return new p.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}ge.to=ae})(ut=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(ge){function Ee(K){return{outputId:K.id,items:K.items.map(ut.from),metadata:K.metadata}}ge.from=Ee;function ae(K){const Ce=K.items.map(ut.to);return new p.NotebookCellOutput(Ce,K.outputId,K.metadata)}ge.to=ae})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ve;(function(ge){function Ee(Le){if(Le!=null){if(Le instanceof p.RelativePattern||typeof Le=="string")return Le;if(Ce(Le))return new p.RelativePattern(Le.base,Le.pattern);if(K(Le))return{include:le.from(Le.include)||void 0,exclude:le.from(Le.exclude)||void 0}}}ge.from=Ee;function ae(Le){return typeof Le=="string"?Le:Ce(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ge.to=ae;function K(Le){const nt=Le,Ge=le.from(nt.include);if(!(Ge&&Ge instanceof p.RelativePattern||typeof Ge=="string"))return!1;const mt=le.from(nt.exclude);return!!(mt&&mt instanceof p.RelativePattern||typeof mt=="string")}function Ce(Le){const nt=Le;return nt&&typeof nt.base=="string"&&typeof nt.pattern=="string"}})(ve=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(ge){function Ee(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?B.from(ae.top):void 0}}ge.from=Ee})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var se;(function(ge){function Ee(ae,K,Ce){const Le=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===p.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Ce),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ge.from=Ee})(se=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ge){function Ee(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{}}}ge.from=Ee})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var be;(function(ge){function Ee(K){return{uri:K.uri,provides:K.provides}}ge.from=Ee;function ae(K){return new p.NotebookRendererScript(D.URI.revive(K.uri),K.provides)}ge.to=ae})(be=e.NotebookRendererScript||(e.NotebookRendererScript={}));var we;(function(ge){function Ee(K){return{message:E.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?Q.from(K.location):void 0}}ge.from=Ee;function ae(K){const Ce=new p.TestMessage(typeof K.message=="string"?K.message:E.to(K.message));return Ce.actualOutput=K.actual,Ce.expectedOutput=K.expected,Ce.location=K.location?Q.to(K.location):void 0,Ce}ge.to=ae})(we=e.TestMessage||(e.TestMessage={}));var Fe;(function(ge){let Ee;(function(ae){ae.Delimiter="\0"})(Ee||(Ee={})),ge.namespace=(ae,K)=>ae+"\0"+K,ge.denamespace=ae=>{const K=ae.indexOf("\0");return{ctrlId:ae.slice(0,K),tagId:ae.slice(K+1)}}})(Fe=e.TestTag||(e.TestTag={}));var qe;(function(ge){function Ee(Le){const nt=(0,h.getPrivateApiFor)(Le).controllerId;return{extId:S.TestId.fromExtHostTestItem(Le,nt).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(Ge=>Fe.namespace(nt,Ge.id)),range:r.from(Le.range)||null,description:Le.description||null,error:Le.error&&E.fromStrict(Le.error)||null}}ge.from=Ee;function ae(Le){return{parent:void 0,error:void 0,id:S.TestId.fromString(Le.extId).localId,label:Le.label,uri:D.URI.revive(Le.uri),tags:(Le.tags||[]).map(nt=>{const{tagId:Ge}=Fe.denamespace(nt);return new p.TestTag(Ge)}),range:r.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ge.toPlain=ae;function K(Le){const nt=S.TestId.fromString(Le.extId),Ge=new h.TestItemImpl(nt.controllerId,nt.localId,Le.label,D.URI.revive(Le.uri));return Ge.range=r.to(Le.range||void 0),Ge.description=Le.description||void 0,Ge}function Ce(Le){let nt;for(const Ge of Le.tests){const mt=K(Ge.item);(0,h.getPrivateApiFor)(mt).parent=nt,nt=mt}return nt}ge.toItemFromContext=Ce})(qe=e.TestItem||(e.TestItem={})),function(ge){function Ee(K){return{id:K.id}}ge.from=Ee;function ae(K){return new p.TestTag(K.id)}ge.to=ae}(Fe=e.TestTag||(e.TestTag={}));var ze;(function(ge){const Ee=(K,Ce)=>{const Le={...qe.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(nt=>({state:nt.state,duration:nt.duration,messages:nt.messages.filter(Ge=>Ge.type===0).map(we.to)})),children:K.children.map(nt=>Ce.get(nt)).filter(_.isDefined).map(nt=>Ee(nt,Ce))};for(const nt of Le.children)nt.parent=Le;return Le};function ae(K){const Ce=[],Le=new Map;for(const nt of K.items)Le.set(nt.item.extId,nt),K.request.targets.some(Ge=>Ge.controllerId===nt.controllerId&&Ge.testIds.includes(nt.item.extId))&&Ce.push(nt);return{completedAt:K.completedAt,results:Ce.map(nt=>Ee(nt,Le))}}ge.to=ae})(ze=e.TestResults||(e.TestResults={}));var Ye;(function(ge){function Ee(Le){return{covered:Le.covered,total:Le.covered}}function ae(Le){return"line"in Le?s.from(Le):r.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:ae(Le.location),type:1,branches:Le.branches.length?Le.branches.map(nt=>({count:nt.executionCount,location:nt.location&&ae(nt.location)})):void 0}:{type:0,count:Le.executionCount,location:ae(Le.location)}}ge.fromDetailed=K;function Ce(Le){return{uri:Le.uri,statement:Ee(Le.statementCoverage),branch:Le.branchCoverage&&Ee(Le.branchCoverage),function:Le.functionCoverage&&Ee(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}ge.fromFile=Ce})(Ye=e.TestCoverage||(e.TestCoverage={}));var lt;(function(ge){function Ee(ae){switch(ae){case 1:return p.CodeActionTriggerKind.Invoke;case 2:return p.CodeActionTriggerKind.Automatic}}ge.to=Ee})(lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(ge){function Ee(K){const Ce=new p.TypeHierarchyItem(N.to(K.kind),K.name,K.detail||"",D.URI.revive(K.uri),r.to(K.range),r.to(K.selectionRange));return Ce._sessionId=K._sessionId,Ce._itemId=K._itemId,Ce}ge.to=Ee;function ae(K,Ce,Le){if(Ce=Ce??K._sessionId,Le=Le??K._itemId,Ce===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Le,kind:N.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:r.from(K.range),selectionRange:r.from(K.selectionRange),tags:K.tags?.map(U.from)}}ge.from=ae})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[216],me([0,1,2,16,7,15,94]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(D,P,I,l={timeout:1500,errors:3}){this._logService=D,this._documents=P,this._mainThreadBulkEdits=I,this._thresholds=l,this._callbacks=new n.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(P,I,l)=>{const h={dispose:this._callbacks.push([P,I,D])};return Array.isArray(l)&&l.push(h),h}}async $participateInSave(D,P){const I=m.URI.revive(D);let l=!1;const v=setTimeout(()=>l=!0,this._thresholds.timeout),h=[];try{for(let w of[...this._callbacks]){if(l)break;const S=this._documents.getDocument(I),A=await this._deliverEventAsyncAndBlameBadListeners(w,{document:S,reason:C.TextDocumentSaveReason.to(P)});h.push(A)}}finally{clearTimeout(v)}return h}_deliverEventAsyncAndBlameBadListeners([D,P,I],l){const v=this._badListeners.get(D);return typeof v=="number"&&v>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,D,P,l).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const w=this._badListeners.get(D);this._badListeners.set(D,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,P,I,l){const v=[],h=Date.now(),{document:w,reason:S}=l,{version:A}=w,p=Object.freeze({document:w,reason:S,waitUntil(a){if(Object.isFrozen(v))throw(0,L.illegalState)("waitUntil can not be called async");v.push(Promise.resolve(a))}});try{P.apply(I,[p])}catch(a){return Promise.reject(a)}return Object.freeze(v),new Promise((a,r)=>{const g=setTimeout(()=>r(new Error("timeout")),this._thresholds.timeout);return Promise.all(v).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(g),a(s)}).catch(s=>{clearTimeout(g),r(s)})}).then(a=>{const r={edits:[]};for(const g of a)if(Array.isArray(g)&&g.every(s=>s instanceof y.TextEdit))for(const{newText:s,newEol:b,range:i}of g)r.edits.push({_type:2,resource:w.uri,edit:{range:i&&C.Range.from(i),text:s,eol:b&&C.EndOfLine.from(b)}});if(r.edits.length!==0)return A===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(fe[217],me([0,1,3,31,2,15,7]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(P,I,l,v,h){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,l&&(this._config+=1),v&&(this._config+=2),h&&(this._config+=4);const w=(0,L.parse)(I),S=P(A=>{if(!l)for(let p of A.created){const a=y.URI.revive(p);w(a.fsPath)&&this._onDidCreate.fire(a)}if(!v)for(let p of A.changed){const a=y.URI.revive(p);w(a.fsPath)&&this._onDidChange.fire(a)}if(!h)for(let p of A.deleted){const a=y.URI.revive(p);w(a.fsPath)&&this._onDidDelete.fire(a)}});this._disposable=n.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,S)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(P,I,l){this._logService=I,this._extHostDocumentsAndEditors=l,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,I,l,v){return new k(this._onFileSystemEvent.event,P,I,l,v)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,I){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(l=>({oldUri:y.URI.revive(l.source),newUri:y.URI.revive(l.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(l=>y.URI.revive(l.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(l=>y.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,I){return(l,v,h)=>{const w=function(A){l.call(v,A)};return w.extension=P,I.event(w,void 0,h)}}async $onWillRunFileOperation(P,I,l,v){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))},l,v);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(h=>y.URI.revive(h.target))},l,v);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(h=>y.URI.revive(h.target))},l,v)}}async _fireWillEvent(P,I,l,v){const h=new Set,w=[];if(await P.fireAsync(I,v,async(A,p)=>{const a=Date.now(),r=await Promise.resolve(A);r instanceof n.WorkspaceEdit&&(w.push(r),h.add(p.extension.displayName??p.extension.identifier.value)),Date.now()-a>l&&this._logService.warn("SLOW file-participant",p.extension.identifier)}),v.isCancellationRequested||w.length===0)return;const S={edits:[]};for(let A of w){let{edits:p}=C.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);S.edits=S.edits.concat(p)}return{edit:S,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=_}),define(fe[218],me([0,1,10,25,2,15,7,125]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(l,v,h,w){this.start=l,this.deletedCount=v,this.deletedItems=h,this.items=w}static asApiEvents(l){return l.map(v=>({start:v.start,deletedCount:v.deletedCount,deletedItems:v.deletedItems,items:v.items.map(h=>h.apiCell)}))}}class D{constructor(l,v,h){this.notebook=l,this._extHostDocument=v,this._cellData=h,this.handle=h.handle,this.uri=y.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(l,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,v=this._extHostDocument.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:v.document,get mime(){return l._mime},set mime(h){l._mime=h},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(C.NotebookCellOutput.to)}setOutputItems(l,v,h){const w=h.map(C.NotebookCellOutputItem.to),S=this._outputs.find(A=>A.id===l);S&&(v||(S.items.length=0),S.items.push(...w))}setMetadata(l){this._metadata=Object.freeze(l)}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(l))}setMime(l){}}e.ExtHostCell=D;class P{constructor(l,v,h,w,S,A){this._proxy=l,this._textDocumentsAndEditors=v,this._textDocuments=h,this._emitter=w,this.uri=S,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=A.viewType,this._metadata=Object.freeze(A.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,A.cells]],!0),this._versionId=A.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===m.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(v){return v=l._validateIndex(v),l._cells[v].apiCell},getCells(v){return(v?l._getCells(v):l._cells).map(w=>w.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.freeze({...this._metadata,...l.metadata}))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,v){this._versionId=l.versionId,this._isDirty=v;for(const h of l.rawEvents)h.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===k.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let v=l.start|0,h=l.end|0;return v<0&&(v=0),h>this._cells.length&&(h=this._cells.length),l.with({start:v,end:h})}_getCells(l){l=this._validateRange(l);const v=[];for(let h=l.start;h<l.end;h++)v.push(this._cells[h]);return v}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,v){if(this._disposed)return;const h=[],w=[],S=[];l.reverse().forEach(A=>{const a=A[2].map(s=>{const b=new D(this,this._textDocumentsAndEditors,s);return v||w.push(D.asModelAddData(this.apiNotebook,s)),b}),r=new _(A[0],A[1],[],a),g=this._cells.splice(A[0],A[1],...a);for(const s of g)S.push(s.uri),r.deletedItems.push(s.apiCell);h.push(r)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:S}),v||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(h)}))}_moveCell(l,v){const h=this._cells.splice(l,1);this._cells.splice(v,0,...h);const w=[new _(l,1,h.map(S=>S.apiCell),[]),new _(v,0,[],h)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(w)}))}_setCellOutputs(l,v){const h=this._cells[l];h.setOutputs(v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(l,v,h,w){const S=this._cells[l];S.setOutputItems(v,h,w),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[S.apiCell]}))}_changeCellLanguage(l,v){const h=this._cells[l];h.apiCell.document.languageId!==v&&this._textDocuments.$acceptModelModeChanged(h.uri,v)}_changeCellMime(l,v){const h=this._cells[l];h.apiCell.mime=v}_changeCellMetadata(l,v){const h=this._cells[l],w=h.apiCell.metadata;h.setMetadata(v);const S=h.apiCell.metadata;(0,L.equals)(w,S)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(l,v){const h=this._cells[l],w=h.internalMetadata;if(h.setInternalMetadata(v),w.runState!==v.runState){const S=v.runState??n.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:S}))}}getCellFromApiCell(l){return this._cells.find(v=>v.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(v=>v.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(fe[128],me([0,1,7,15,16]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,D){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:D})}replaceCells(_,D,P){this._throwIfFinalized(),!(_===D&&P.length===0)&&this._collectedEdits.push({editType:1,index:_,count:D-_,cells:P.map(L.NotebookCellData.from)})}}class n{constructor(_,D,P,I,l,v){this.id=_,this._proxy=D,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=I,this._viewColumn=v}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(D){if(!Array.isArray(D)||!D.every(m.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");_._selections=D,_._trySetSelections(D)},get visibleRanges(){return _._visibleRanges},revealRange(D,P){_._proxy.$tryRevealRange(_.id,L.NotebookRange.from(D),P??m.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(D){const P=new C(this.document.version);return D(P),_._applyEdit(P.finalize())},setDecorations(D,P){return _.setDecorations(D,P)}},n.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(L.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const D=[];let P=-1;for(let I=0;I<_.cellEdits.length;I++){if(P<0){D.push(_.cellEdits[I]),P++;continue}const v=D[P],h=_.cellEdits[I];if(v.editType===1&&h.editType===1&&v.index===h.index){v.cells.push(..._.cellEdits[I].cells),v.count+=_.cellEdits[I].count;continue}D.push(_.cellEdits[I]),P++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,D)}setDecorations(_,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return D.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(D),_.key)}}e.ExtHostNotebookEditor=n,n.apiEditorsToExtHost=new WeakMap}),define(fe[219],me([0,1,15,117,164,21,57,16]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(l){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=l}async withProgress(l,v,h){const w=this._handles++,{title:S,location:A,cancellable:p}=v,a={label:(0,y.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this._proxy.$startProgress(w,{location:m.ProgressLocation.from(A),title:S,source:a,cancellable:p},l).catch(k.onUnexpectedExternalError),this._withProgress(w,h,!!p)}_withProgress(l,v,h){let w;h&&(w=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(l,w));const S=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),w&&w.dispose()};let A;try{A=v(new P(this._proxy,l),h&&w?w.token:C.CancellationToken.None)}catch(p){throw S(l),p}return A.then(p=>S(l),p=>S(l)),A}$acceptProgressCanceled(l){const v=this._mapHandleToCancellationSource.get(l);v&&(v.cancel(),this._mapHandleToCancellationSource.delete(l))}}e.ExtHostProgress=_;function D(I,l){return I.message=l.message,typeof l.increment=="number"&&(typeof I.increment=="number"?I.increment+=l.increment:I.increment=l.increment),I}class P extends L.Progress{constructor(l,v){super(h=>this.throttledReport(h));this._proxy=l,this._handle=v}throttledReport(l){this._proxy.$progressReport(this._handle,l)}}Ve([(0,n.throttle)(100,(I,l)=>D(I,l),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(fe[129],me([0,1,56,16,75,15,7]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(l,v,h){const w=k._Keys.nextId();l.$registerTextEditorDecorationType(v.identifier,w,C.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:w,dispose(){l.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=k,k._Keys=new y.IdGenerator("TextEditorDecorationType");class _{constructor(l,v){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=v.undoStopBefore,this._undoStopAfter=v.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,v){this._throwIfFinalized();let h=null;if(l instanceof n.Position)h=new n.Range(l,l);else if(l instanceof n.Range)h=l;else throw new Error("Unrecognized location");this._pushEdit(h,v,!1)}insert(l,v){this._throwIfFinalized(),this._pushEdit(new n.Range(l,l),v,!0)}delete(l){this._throwIfFinalized();let v=null;if(l instanceof n.Range)v=l;else throw new Error("Unrecognized location");this._pushEdit(v,null,!0)}_pushEdit(l,v,h){const w=this._document.validateRange(l);this._collectedEdits.push({range:w,text:v,forceMoveMarkers:h})}setEndOfLine(l){if(this._throwIfFinalized(),l!==n.EndOfLine.LF&&l!==n.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=_;class D{constructor(l,v,h,w){this._proxy=l,this._id=v,this._accept(h),this._logService=w;const S=this;this.value={get tabSize(){return S._tabSize},set tabSize(A){S._setTabSize(A)},get insertSpaces(){return S._insertSpaces},set insertSpaces(A){S._setInsertSpaces(A)},get cursorStyle(){return S._cursorStyle},set cursorStyle(A){S._setCursorStyle(A)},get lineNumbers(){return S._lineNumbers},set lineNumbers(A){S._setLineNumbers(A)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const v=Math.floor(l);return v>0?v:null}if(typeof l=="string"){const v=parseInt(l,10);return isNaN(v)?null:v>0?v:null}return null}_setTabSize(l){const v=this._validateTabSize(l);if(v!==null){if(typeof v=="number"){if(this._tabSize===v)return;this._tabSize=v}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:v}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const v=this._validateInsertSpaces(l);if(typeof v=="boolean"){if(this._insertSpaces===v)return;this._insertSpaces=v}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:v}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(l)})))}assign(l){const v={};let h=!1;if(typeof l.tabSize!="undefined"){const w=this._validateTabSize(l.tabSize);w==="auto"?(h=!0,v.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,h=!0,v.tabSize=w)}if(typeof l.insertSpaces!="undefined"){const w=this._validateInsertSpaces(l.insertSpaces);w==="auto"?(h=!0,v.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,h=!0,v.insertSpaces=w)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,h=!0,v.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,h=!0,v.lineNumbers=C.TextEditorLineNumbersStyle.from(l.lineNumbers)),h&&this._warnOnError(this._proxy.$trySetOptions(this._id,v))}_warnOnError(l){l.catch(v=>this._logService.warn(v))}}e.ExtHostTextEditorOptions=D;class P{constructor(l,v,h,w,S,A,p,a){this.id=l,this._proxy=v,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=S,this._options=new D(this._proxy,this.id,A,h),this._visibleRanges=p,this._viewColumn=a;const r=this;this.value=Object.freeze({get document(){return w.getValue()},set document(g){throw(0,L.readonly)("document")},get selection(){return r._selections&&r._selections[0]},set selection(g){if(!(g instanceof n.Selection))throw(0,L.illegalArgument)("selection");r._selections=[g],r._trySetSelection()},get selections(){return r._selections},set selections(g){if(!Array.isArray(g)||g.some(s=>!(s instanceof n.Selection)))throw(0,L.illegalArgument)("selections");r._selections=g,r._trySetSelection()},get visibleRanges(){return r._visibleRanges},set visibleRanges(g){throw(0,L.readonly)("visibleRanges")},get options(){return r._options.value},set options(g){r._disposed||r._options.assign(g)},get viewColumn(){return r._viewColumn},set viewColumn(g){throw(0,L.readonly)("viewColumn")},edit(g,s={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new _(w.getValue(),s);return g(b),r._applyEdit(b)},insertSnippet(g,s,b={undoStopBefore:!0,undoStopAfter:!0}){if(r._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!s||Array.isArray(s)&&s.length===0)i=r._selections.map(t=>C.Range.from(t));else if(s instanceof n.Position){const{lineNumber:t,column:c}=C.Position.from(s);i=[{startLineNumber:t,startColumn:c,endLineNumber:t,endColumn:c}]}else if(s instanceof n.Range)i=[C.Range.from(s)];else{i=[];for(const t of s)if(t instanceof n.Range)i.push(C.Range.from(t));else{const{lineNumber:c,column:d}=C.Position.from(t);i.push({startLineNumber:c,startColumn:d,endLineNumber:c,endColumn:d})}}return v.$tryInsertSnippet(l,g.value,i,b)},setDecorations(g,s){const b=s.length===0;b&&!r._hasDecorationsForKey.has(g.key)||(b?r._hasDecorationsForKey.delete(g.key):r._hasDecorationsForKey.add(g.key),r._runOnProxy(()=>{if(C.isDecorationOptionsArr(s))return v.$trySetDecorations(l,g.key,C.fromRangeOrRangeWithMessage(s));{const i=new Array(4*s.length);for(let t=0,c=s.length;t<c;t++){const d=s[t];i[4*t]=d.start.line+1,i[4*t+1]=d.start.character+1,i[4*t+2]=d.end.line+1,i[4*t+3]=d.end.character+1}return v.$trySetDecorationsFast(l,g.key,i)}}))},revealRange(g,s){r._runOnProxy(()=>v.$tryRevealRange(l,C.Range.from(g),s||n.TextEditorRevealType.Default))},show(g){v.$tryShowEditor(l,C.ViewColumn.from(g))},hide(){v.$tryHideEditor(l)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(l){(0,m.ok)(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){(0,m.ok)(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){(0,m.ok)(!this._disposed),this._viewColumn=l}_acceptSelections(l){(0,m.ok)(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const v=l.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const h=v.edits.map(S=>S.range);h.sort((S,A)=>S.end.line===A.end.line?S.end.character===A.end.character?S.start.line===A.start.line?S.start.character-A.start.character:S.start.line-A.start.line:S.end.character-A.end.character:S.end.line-A.end.line);for(let S=0,A=h.length-1;S<A;S++){const p=h[S].end;if(h[S+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=v.edits.map(S=>({range:C.Range.from(S.range),text:S.text,forceMoveMarkers:S.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,v.documentVersionId,w,{setEndOfLine:typeof v.setEndOfLine=="number"?C.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this._logService.warn(v),null))}}e.ExtHostTextEditor=P}),define(fe[220],me([0,1,167,23,2,3,6,18,7,13,17,15,21,204]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(A,p){if((0,D.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let a;return Array.isArray(A.highlights)&&(a=A.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),a=a.length?a:void 0),{label:A.label,highlights:a}}}class w{constructor(p,a,r){this._proxy=p,this.commands=a,this.logService=r,this.treeViews=new Map;function g(s){return s&&s.$treeViewId&&s.$treeItemHandle}a.registerArgumentProcessor({processArgument:s=>g(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(b=>g(b)?this.convertArgument(b):b):s})}registerTreeDataProvider(p,a,r){const g=this.createTreeView(p,{treeDataProvider:a},r);return{dispose:()=>g.dispose()}}createTreeView(p,a,r){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=a.dragAndDropController!==void 0,s=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,canDragAndDrop:g}),b=this.createExtHostTreeView(p,a,r);return{get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get message(){return b.message},set message(i){b.message=i},get title(){return b.title},set title(i){b.title=i},get description(){return b.description},set description(i){b.description=i},reveal:(i,t)=>b.reveal(i,t),dispose:async()=>{await s,this.treeViews.delete(p),b.dispose()}}}$getChildren(p,a){const r=this.treeViews.get(p);return r?r.getChildren(a):Promise.reject(new Error((0,m.localize)(0,null,p)))}async $onDrop(p,a,r,g,s){const b=this.treeViews.get(p);if(!b)return Promise.reject(new Error((0,m.localize)(1,null,p)));const i=v.TreeDataTransferConverter.toITreeDataTransfer(a);if(g===p&&s){const t=await b.onWillDrop(s);t&&t.items.forEach((c,d)=>{c&&i.items.set(d,c)})}return b.onDrop(i,r)}async $hasResolve(p){const a=this.treeViews.get(p);if(!a)throw new Error((0,m.localize)(2,null,p));return a.hasResolve}$resolve(p,a,r){const g=this.treeViews.get(p);if(!g)throw new Error((0,m.localize)(3,null,p));return g.resolveTreeItem(a,r)}$setExpanded(p,a,r){const g=this.treeViews.get(p);if(!g)throw new Error((0,m.localize)(4,null,p));g.setExpanded(a,r)}$setSelection(p,a){const r=this.treeViews.get(p);if(!r)throw new Error((0,m.localize)(5,null,p));r.setSelection(a)}$setVisible(p,a){const r=this.treeViews.get(p);if(!r)throw new Error((0,m.localize)(6,null,p));r.setVisible(a)}createExtHostTreeView(p,a,r){const g=new S(p,a,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(p,g),g}convertArgument(p){const a=this.treeViews.get(p.$treeViewId);return a?a.getExtensionElement(p.$treeItemHandle):null}}e.ExtHostTreeViews=w;class S extends n.Disposable{constructor(p,a,r,g,s,b){super();if(this.viewId=p,this.proxy=r,this.commands=g,this.logService=s,this.extension=b,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,b.contributes&&b.contributes.views)for(const c in b.contributes.views)for(const d of b.contributes.views[c])d.id===p&&(this._title=d.name);this.dataProvider=a.treeDataProvider,this.dndController=a.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(c=>this._onDidChangeData.fire({message:!1,element:c}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let i,t;this._register(C.Event.debounce(this._onDidChangeData.event,(c,d)=>(c||(c={message:!1,elements:[]}),d.element!==!1&&(i||(i=new Promise(o=>t=o),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(d.element)?c.elements.push(...d.element):c.elements.push(d.element)),d.message&&(c.message=!0),c),200,!0)(({message:c,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const o=t;return i=null,this.refresh(d).then(()=>o())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,D.isUndefinedOrNull)(p))}async getChildren(p){const a=p?this.getExtensionElement(p):void 0;if(p&&!a)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(p);return r||(r=await this.fetchChildrenNodes(a)),r?r.map(g=>g.item):void 0}getExtensionElement(p){return this.elements.get(p)}reveal(p,a){a=a||{select:!0,focus:!1};const r=(0,D.isUndefinedOrNull)(a.select)?!0:a.select,g=(0,D.isUndefinedOrNull)(a.focus)?!1:a.focus,s=(0,D.isUndefinedOrNull)(a.expand)?!1:a.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(b=>this.resolveTreeNode(p,b[b.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:b.map(t=>t.item)},{select:r,focus:g,expand:s})),b=>this.logService.error(b)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:g,expand:s})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}setExpanded(p,a){const r=this.getExtensionElement(p);r&&(a?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(p){(0,P.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(p){const a=[];for(const r of p){const g=this.getExtensionElement(r);g&&a.push(g)}if(!(!this.dndController?.onWillDrop||a.length===0))return this.dndController.onWillDrop(a)}async onDrop(p,a){const r=this.getExtensionElement(a);if(!!r)return(0,k.asPromise)(()=>this.dndController?.onDrop(p,r))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,a){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(p);if(r){const g=this.nodes.get(r);if(g){const s=await this.dataProvider.resolveTreeItem(g.extensionItem,r,a)??g.extensionItem;return g.item.tooltip=this.getTooltip(s.tooltip),g.item.command=this.getCommand(g.disposableStore,s.command),g.item}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(a=>a?this.resolveUnknownParentChain(a).then(r=>this.resolveTreeNode(a,r[r.length-1]).then(g=>(r.push(g),r))):Promise.resolve([]))}resolveParent(p){const a=this.nodes.get(p);return a?Promise.resolve(a.parent?this.elements.get(a.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,a){const r=this.nodes.get(p);return r?Promise.resolve(r):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(g=>this.createHandle(p,g,a,!0)).then(g=>this.getChildren(a?a.item.handle:void 0).then(()=>{const s=this.getExtensionElement(g);if(s){const b=this.nodes.get(s);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${g}`)}))}getChildrenNodes(p){if(p){let a;if(typeof p=="string"){const r=this.getExtensionElement(p);a=r?this.nodes.get(r):void 0}else a=p;return a&&a.children||void 0}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const a=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=p?this.nodes.get(p):void 0,g=await this.dataProvider.getChildren(p);if(a.token.isCancellationRequested)return;const s=await Promise.all((0,P.coalesce)(g||[]).map(async b=>{const i=await this.dataProvider.getTreeItem(b);return i&&!a.token.isCancellationRequested?this.createAndRegisterTreeNode(b,i,r):null}));return a.token.isCancellationRequested?void 0:(0,P.coalesce)(s)}finally{a.dispose()}}refresh(p){if(p.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(p);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const a=new Set,r=p.map(s=>this.nodes.get(s));for(const s of r)if(s&&!a.has(s.item.handle)){let b=s;for(;b&&b.parent&&r.findIndex(i=>b&&b.parent&&i&&i.item.handle===b.parent.item.handle)===-1;){const i=this.elements.get(b.parent.item.handle);b=i?this.nodes.get(i):void 0}b&&!b.parent&&a.add(s.item.handle)}const g=[];return a.forEach(s=>{const b=this.elements.get(s);if(b){const i=this.nodes.get(b);i&&(!i.parent||!a.has(i.parent.item.handle))&&g.push(s)}}),g}refreshHandles(p){const a={};return Promise.all(p.map(r=>this.refreshNode(r).then(g=>{g&&(a[r]=g.item)}))).then(()=>Object.keys(a).length?this.proxy.$refresh(this.viewId,a):void 0)}refreshNode(p){const a=this.getExtensionElement(p);if(a){const r=this.nodes.get(a);if(r)return this.clearChildren(a),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(g=>{if(g){const s=this.createTreeNode(a,g,r.parent);return this.updateNodeCache(a,s,r,r.parent),r.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,a,r){const g=this.createTreeNode(p,a,r);if(a.id&&this.elements.has(g.item.handle))throw new Error((0,m.localize)(7,null,a.id));return this.addNodeToCache(p,g),this.addNodeToParentCache(g,r),g}getTooltip(p){return _.MarkdownString.isMarkdownString(p)?I.MarkdownString.from(p):p}getCommand(p,a){return a?this.commands.toInternal(a,p):void 0}createTreeNode(p,a,r){const g=new n.DisposableStore,s=this.createHandle(p,a,r),b=this.getLightIconPath(a);return{item:{handle:s,parentHandle:r?r.item.handle:void 0,label:h(a.label,this.extension),description:a.description,resourceUri:a.resourceUri,tooltip:this.getTooltip(a.tooltip),command:this.getCommand(g,a.command),contextValue:a.contextValue,icon:b,iconDark:this.getDarkIconPath(a)||b,themeIcon:this.getThemeIcon(a),collapsibleState:(0,D.isUndefinedOrNull)(a.collapsibleState)?_.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation},extensionItem:a,parent:r,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(p){return p.iconPath instanceof _.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:a,label:r,resourceUri:g},s,b){if(a)return`${S.ID_HANDLE_PREFIX}/${a}`;const i=h(r,this.extension),t=s?s.item.handle:S.LABEL_HANDLE_PREFIX;let c=i?i.label:g?(0,L.basename)(g):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const d=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,o=this.getChildrenNodes(s)||[];let f,u=0;do{if(f=`${t}/${u}:${c}`,b||!this.elements.has(f)||d===f)break;u++}while(u<=o.length);return f}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof _.ThemeIcon))return typeof p.iconPath=="string"||y.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof _.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return y.URI.isUri(p)?p:y.URI.file(p)}addNodeToCache(p,a){this.elements.set(a.item.handle,p),this.nodes.set(p,a)}updateNodeCache(p,a,r,g){this.elements.delete(a.item.handle),this.nodes.delete(p),a.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(p,a);const s=this.getChildrenNodes(g)||[],b=s.filter(i=>i.item.handle===r.item.handle)[0];b&&s.splice(s.indexOf(b),1,a)}addNodeToParentCache(p,a){a?(a.children||(a.children=[]),a.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const a=this.nodes.get(p);if(a){if(a.children)for(const r of a.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}a.children=void 0}}else this.clearAll()}clear(p){const a=this.nodes.get(p);if(a){if(a.children)for(const r of a.children){const g=this.elements.get(r.item.handle);g&&this.clear(g)}this.nodes.delete(p),this.elements.delete(a.item.handle),a.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(fe[221],me([0,1,18,3,6,13,63,15,126,90]),function(Y,e,m,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class P extends y.Disposable{constructor(l){super();this.controllerId=l,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new n.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(l){this._resolveHandler=l;for(const v of this.tree.values())this.updateExpandability(v)}collectDiff(){const l=this.diff;return this.diff=[],l}pushDiff(l){const v=this.diff[this.diff.length-1];if(v&&l[0]===1){if(v[0]===1&&v[1].extId===l[1].extId){(0,_.applyTestItemUpdate)(v[1],l[1]);return}if(v[0]===0&&v[1].item.extId===l[1].extId){(0,_.applyTestItemUpdate)(v[1],l[1]);return}}this.diff.push(l),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(l,v){const h=this.tree.get(l);if(!!h){if((h.expandLevels===void 0||v>h.expandLevels)&&(h.expandLevels=v),h.expand===1){const w=this.resolveChildren(h);return w.isOpen()?this.expandChildren(h,v-1):w.wait().then(()=>this.expandChildren(h,v-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,v-1)):this.expandChildren(h,v-1)}}dispose(){for(const l of this.tree.values())(0,n.getPrivateApiFor)(l.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(l,v){switch(v.op){case 2:this.pushDiff([4,l.fullId.toString()]);break;case 1:this.removeItem(D.TestId.joinToString(l.fullId,v.id));break;case 0:this.upsertItem(v.item,l);break;case 4:for(const p of v.ops)this.onTestItemEvent(l,p);break;case 3:const{key:h,value:w,previous:S}=v,A=l.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(l);break;case"tags":this.diffTagRefs(w,S,A);break;case"range":this.pushDiff([1,{extId:A,item:{range:k.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:A,item:{error:k.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:A,item:{[h]:w??null}}]);break}break;default:(0,C.assertNever)(v)}}upsertItem(l,v){if(!(l instanceof n.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${l.id} did not`);const h=D.TestId.fromExtHostTestItem(l,this.root.id,v?.actual),w=(0,n.getPrivateApiFor)(l);w.parent&&w.parent!==v?.actual&&w.parent.children.delete(l.id);let S=this.tree.get(h.toString());if(!S){S={fullId:h,actual:l,parent:v?h.parentId:null,expandLevels:v?.expandLevels?v.expandLevels-1:void 0,expand:0},l.tags.forEach(this.incrementTagRefs,this),this.tree.set(S.fullId.toString(),S),this.setItemParent(l,v),this.pushDiff([0,{parent:S.parent&&S.parent.toString(),controllerId:this.controllerId,expand:S.expand,item:k.TestItem.from(l)}]),this.connectItemAndChildren(l,S,v);return}if(S.actual===l){this.connectItem(l,S,v);return}const A=S.actual.children,p=S.actual,a=(0,n.diffTestItems)(p,l);(0,n.getPrivateApiFor)(p).listener=void 0,S.actual=l,S.expand=0;for(const[r,g]of a)this.onTestItemEvent(S,{op:3,key:r,value:g,previous:p[r]});this.connectItemAndChildren(l,S,v);for(const r of A)l.children.get(r.id)||this.removeItem(D.TestId.joinToString(h,r.id))}diffTagRefs(l,v,h){const w=new Set(v.map(S=>S.id));for(const S of l)w.delete(S.id)||this.incrementTagRefs(S);this.pushDiff([1,{extId:h,item:{tags:l.map(S=>k.TestTag.namespace(this.controllerId,S.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(l){const v=this.tags.get(l.id);v?v.refCount++:(this.tags.set(l.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,l.id),ctrlLabel:this.root.label}]))}decrementTagRefs(l){const v=this.tags.get(l);v&&!--v.refCount&&(this.tags.delete(l),this.pushDiff([6,k.TestTag.namespace(this.controllerId,l)]))}setItemParent(l,v){(0,n.getPrivateApiFor)(l).parent=v&&v.actual!==this.root?v.actual:void 0}connectItem(l,v,h){this.setItemParent(l,h);const w=(0,n.getPrivateApiFor)(l);w.parent=h?.actual,w.listener=S=>this.onTestItemEvent(v,S),this.updateExpandability(v)}connectItemAndChildren(l,v,h){this.connectItem(l,v,h);for(const w of l.children)this.upsertItem(w,v)}updateExpandability(l){let v;this._resolveHandler?l.resolveBarrier?v=l.resolveBarrier.isOpen()?3:2:v=l.actual.canResolveChildren?1:0:v=0,v!==l.expand&&(l.expand=v,this.pushDiff([1,{extId:l.fullId.toString(),expand:v}]),v===1&&l.expandLevels!==void 0&&this.resolveChildren(l))}expandChildren(l,v){if(v<0)return;const h=[];for(const w of l.actual.children){const S=this.expand(D.TestId.joinToString(l.fullId,w.id),v);(0,m.isThenable)(S)&&h.push(S)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this._resolveHandler){const S=new m.Barrier;return S.open(),S}l.expand=2,this.pushExpandStateUpdate(l);const v=l.resolveBarrier=new m.Barrier,h=S=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),l.actual!==this.root&&(l.actual.error=S.stack||S.message||String(S))};let w;try{w=this._resolveHandler(l.actual===this.root?void 0:l.actual)}catch(S){h(S)}return(0,m.isThenable)(w)?w.catch(h).then(()=>{v.open(),this.updateExpandability(l)}):(v.open(),this.updateExpandability(l)),l.resolveBarrier}pushExpandStateUpdate(l){this.pushDiff([1,{extId:l.fullId.toString(),expand:l.expand}])}removeItem(l){const v=this.tree.get(l);if(!v)throw new Error("attempting to remove non-existent child");this.pushDiff([2,l]);const h=[v];for(;h.length;){const w=h.pop();if(!!w){(0,n.getPrivateApiFor)(w.actual).listener=void 0;for(const S of w.actual.tags)this.decrementTagRefs(S.id);this.tree.delete(w.fullId.toString());for(const S of w.actual.children)h.push(this.tree.get(D.TestId.joinToString(w.fullId,S.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.diffOpEmitter.fire(l)}}e.SingleUseTestCollection=P}),define(fe[222],me([0,1,4,182]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(L.IEnvironmentService)}),define(fe[223],me([0,1,27,3,9]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=C;class n{constructor(P){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=P,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const P of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(P.identifier),P),this._extensionsArr.push(P),Array.isArray(P.activationEvents))for(let I of P.activationEvents)I==="onUri"&&(I=`onUri:${m.ExtensionIdentifier.toKey(P.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(P)}}keepOnly(P){const I=new Set;P.forEach(l=>I.add(m.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>I.has(m.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(P,I){P.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(P));const l=n._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(l.map(v=>v.identifier)),I.length>0){const v=new Set;I.forEach(h=>v.add(m.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!v.has(m.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(l)}static _findLoopingExtensions(P){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(S){this._nodesSet.has(S)||(this._nodesSet.add(S),this._nodesArr.push(S))}addArc(S,A){this.addNode(S),this.addNode(A),this._arcs.has(S)?this._arcs.get(S).push(A):this._arcs.set(S,[A])}getArcs(S){return this._arcs.has(S)?this._arcs.get(S):[]}hasOnlyGoodArcs(S,A){const p=I.getArcs(S);for(let a=0;a<p.length;a++)if(!A.has(p[a]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let S of P){const A=m.ExtensionIdentifier.toKey(S.identifier);if(l.set(A,S),S.extensionDependencies)for(let p of S.extensionDependencies){const a=m.ExtensionIdentifier.toKey(p);I.addArc(A,a)}}let v=new Set;I.getNodes().filter(S=>I.getArcs(S).length===0).forEach(S=>v.add(S));let h=I.getNodes().filter(S=>!v.has(S)),w;do{w=!1;for(let S=0;S<h.length;S++){const A=h[S];I.hasOnlyGoodArcs(A,v)&&(h.splice(S,1),S--,v.add(A),w=!0)}}while(w);return h.map(S=>l.get(S))}containsActivationEvent(P){return this._activationMap.has(P)}containsExtension(P){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const I=this._activationMap.get(P);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(P){const I=this._extensionsMap.get(m.ExtensionIdentifier.toKey(P));return I||void 0}}e.ExtensionDescriptionRegistry=n;var k;(function(D){D[D.Builtin=0]="Builtin",D[D.User=1]="User",D[D.Dev=2]="Dev"})(k||(k={}));function _(D,P){const I=D.isBuiltin?0:D.isUnderDevelopment?2:1,l=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(I!==l)return I-l;const v=y.posix.basename(D.extensionLocation.path),h=y.posix.basename(P.extensionLocation.path);return v<h?-1:v>h?1:0}}),define(fe[224],me([0,1,22]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var y;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(y=e.MessageType||(e.MessageType={}));function C(k){const _=m.VSBuffer.alloc(1);switch(k){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=C;function n(k,_){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=n}),define(fe[29],me([0,1,3,2,4,27,193]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");var k;(function(r){r[r.None=0]="None",r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function _(r){switch(r){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=_;class D{constructor(g){this.dependency=g}}e.MissingExtensionDependency=D;var P;(function(r){r[r.LocalProcess=0]="LocalProcess",r[r.LocalWebWorker=1]="LocalWebWorker",r[r.Remote=2]="Remote"})(P=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(r){switch(r){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=I;function l(r,g){return r.enabledApiProposals?.includes(g)?!0:Boolean(r.enableProposedApi)}e.isProposedApiEnabled=l;function v(r,g){if(!l(r,g))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${g}.
According to its package.json#enabledApiProposals-property it wants: ${r.enabledApiProposals?.join(", ")??"<none>"}.
 You MUST start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=v;class h{constructor(g,s,b,i){this.codeLoadingTime=g,this.activateCallTime=s,this.activateResolvedTime=b,this.activationReason=i}}e.ActivationTimes=h;class w{constructor(g,s){this.description=g,this.value=s}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost";var S;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(S=e.ActivationKind||(e.ActivationKind={}));function A(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,n.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation}}e.toExtension=A;function p(r,g){return{identifier:new C.ExtensionIdentifier(r.identifier.id),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!g,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid}}e.toExtensionDescription=p;class a{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,s){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,s,b,i,t){}_onDidActivateExtensionError(g,s){}_onExtensionRuntimeError(g,s){}_onExtensionHostExit(g){}}e.NullExtensionService=a}),define(fe[225],me([0,1,27,29,11]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class n{constructor(h,w,S,A){this.startup=h,this.codeLoadingTime=w,this.activateCallTime=S,this.activateResolvedTime=A}}e.ExtensionActivationTimes=n,n.NONE=new n(!1,-1,-1,-1);class k{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,w){return h===-1||w===-1?-1:w-h}build(){return new n(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class _{constructor(h,w,S,A,p,a){this.activationFailed=h,this.activationFailedError=w,this.activationTimes=S,this.module=A,this.exports=p,this.subscriptions=a}}e.ActivatedExtension=_;class D extends _{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class P extends _{constructor(){super(!1,null,n.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class I extends _{constructor(h){super(!0,h,n.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let l=class{constructor(h,w,S,A,p){this._logService=p,this._registry=h,this._resolvedExtensionsSet=new Set,w.forEach(a=>this._resolvedExtensionsSet.add(m.ExtensionIdentifier.toKey(a))),this._hostExtensionsMap=new Map,S.forEach(a=>this._hostExtensionsMap.set(m.ExtensionIdentifier.toKey(a),a)),this._host=A,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const w=m.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(w)}getActivatedExtension(h){const w=m.ExtensionIdentifier.toKey(h),S=this._activatedExtensions.get(w);if(!S)throw new Error("Extension `"+h.value+"` is not known or not activated");return S}activateByEvent(h,w){if(this._alreadyActivatedEvents[h])return C;const S=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(S.map(A=>({id:A.identifier,reason:{startup:w,extensionId:A.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,w){const S=this._registry.getExtensionDescription(h);if(!S)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:S.identifier,reason:w}])}_handleActivateRequest(h,w,S){if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(h.id))){w[m.ExtensionIdentifier.toKey(h.id)]=h;return}const A=this._registry.getExtensionDescription(h.id);if(!A){const r=new Error(`Cannot activate unknown extension '${h.id.value}'`);this._host.onExtensionActivationError(h.id,r,new L.MissingExtensionDependency(h.id.value)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(h.id),new I(r));return}const p=typeof A.extensionDependencies=="undefined"?[]:A.extensionDependencies;let a=!0;for(let r=0,g=p.length;r<g;r++){const s=p[r];if(this._resolvedExtensionsSet.has(m.ExtensionIdentifier.toKey(s)))continue;const b=this._activatedExtensions.get(m.ExtensionIdentifier.toKey(s));if(b&&!b.activationFailed)continue;if(b&&b.activationFailed){const d=A.displayName||A.identifier.value,o=this._registry.getExtensionDescription(s),f=o&&o.displayName||s,u=new Error(`Cannot activate the '${d}' extension because its dependency '${f}' failed to activate`);u.detail=b.activationFailedError,this._host.onExtensionActivationError(A.identifier,u,null),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(A.identifier),new I(u));return}if(this._hostExtensionsMap.has(m.ExtensionIdentifier.toKey(s))){a=!1,w[m.ExtensionIdentifier.toKey(s)]={id:this._hostExtensionsMap.get(m.ExtensionIdentifier.toKey(s)),reason:h.reason};continue}const i=this._registry.getExtensionDescription(s);if(i){if(!i.main&&!i.browser)continue;a=!1,w[m.ExtensionIdentifier.toKey(s)]={id:i.identifier,reason:h.reason};continue}const t=A.displayName||A.identifier.value,c=new Error(`Cannot activate the '${t}' extension because it depends on unknown extension '${s}'`);this._host.onExtensionActivationError(A.identifier,c,new L.MissingExtensionDependency(s)),this._activatedExtensions.set(m.ExtensionIdentifier.toKey(A.identifier),new I(c));return}a?w[m.ExtensionIdentifier.toKey(A.identifier)]=h:S.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(p=>!this._activatedExtensions.has(m.ExtensionIdentifier.toKey(p.id))),h.length===0))return Promise.resolve(void 0);const w=Object.create(null),S=[];for(let p=0,a=h.length;p<a;p++)this._handleActivateRequest(h[p],w,S);for(let p=0,a=S.length;p<a;p++){const r=m.ExtensionIdentifier.toKey(S[p].id);w[r]&&delete w[r]}const A=Object.keys(w).map(p=>w[p]);return S.length===0?Promise.all(A.map(p=>this._activateExtension(p.id,p.reason))).then(p=>{}):this._activateExtensions(A).then(p=>this._activateExtensions(S))}_activateExtension(h,w){const S=m.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(S))return Promise.resolve(void 0);const A=this._activatingExtensions.get(S);if(A)return A;const p=this._host.actualActivateExtension(h,w).then(void 0,a=>{const r=new Error;return a&&a.name&&(r.name=a.name),a&&a.message?r.message=`Activating extension '${h.value}' failed: ${a.message}.`:r.message=`Activating extension '${h.value}' failed: ${a}.`,a&&a.stack&&(r.stack=a.stack),this._host.onExtensionActivationError(h,r,null),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(a),new I(a)}).then(a=>{this._activatedExtensions.set(S,a),this._activatingExtensions.delete(S)});return this._activatingExtensions.set(S,p),p}};l=Ve([$e(4,y.ILogService)],l),e.ExtensionsActivator=l}),define(fe[226],me([0,1,11,26,29]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(k,_){super(k.createLogger(_.logFile,{name:y.ExtensionHostLogFileName}))}};C=Ve([$e(0,m.ILoggerService),$e(1,L.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(fe[227],me([0,1,16]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,n)=>{this._actualOk=C,this._actualErr=n,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,n){return this._ensureActual().then(C,n)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(fe[53],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(D,P){this._proxyIdentifierBrand=void 0,this.isMain=D,this.sid=P,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const L=[];function y(_){const D=new m(!0,_);return L[D.nid]=D,D}e.createMainContextProxyIdentifier=y;function C(_){const D=new m(!1,_);return L[D.nid]=D,D}e.createExtHostContextProxyIdentifier=C;function n(_){return L[_].sid}e.getStringIdentifierForProxy=n;class k{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=k}),define(fe[5],me([0,1,59,2,53]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var n;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(n=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var D;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(D=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(a){a.name="$ident";function r(s,b){return Object.defineProperty(s,a.name,{value:b,enumerable:!0}),s}a.mixin=r;function g(s){return s[a.name]}a.of=g})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class v{static mixin(r){return r._id=v._n++,r}}e.IdObject=v,v._n=0;var h;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(a){a[a.File=1]="File",a[a.Text=2]="Text",a[a.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function A(a){if(a&&a.edits)for(const r of a.edits)typeof r.resource=="object"?r.resource=L.URI.revive(r.resource):(r.newUri=L.URI.revive(r.newUri),r.oldUri=L.URI.revive(r.oldUri)),r.metadata&&r.metadata.iconPath&&(r.metadata=(0,m.revive)(r.metadata));return a}e.reviveWorkspaceEditDto=A;var p;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[91],me([0,1,5,3,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,_){return this._proxy.$getPassword(k,_)}store(k,_,D){return this._proxy.$setPassword(k,_,D)}delete(k,_){return this._proxy.$deletePassword(k,_)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(fe[65],me([0,1,4,11,5,14]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let n=class{constructor(_,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(y.MainContext.MainThreadTelemetry)}report(_,D,P){const I=this.getUsageKey(_,D);this._reportedUsages.has(I)||(this._reportedUsages.add(I),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${P}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:_}))}getUsageKey(_,D){return`${_}-${D.identifier.value}`}};n=Ve([$e(0,C.IExtHostRpcService),$e(1,L.ILogService)],n),e.ExtHostApiDeprecationService=n,e.NullApiDeprecationService=Object.freeze(new class{report(k,_,D){}})}),define(fe[228],me([0,1,3,5,7,27]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class n{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,D,P,I={}){const l=C.ExtensionIdentifier.toKey(_.identifier),v=this._inFlightRequests.get(l)||[],h=[...P].sort().join(" ");let w=v.find(S=>S.scopes===h);if(w)return w.result;{const S=this._getSession(_,l,D,P,I);w={scopes:h,result:S},v.push(w),this._inFlightRequests.set(l,v);try{await S}finally{const A=v.findIndex(p=>p.scopes===h);A>-1&&(v.splice(A),this._inFlightRequests.set(l,v))}return S}}async _getSession(_,D,P,I,l={}){await this._proxy.$ensureProvider(P);const v=_.displayName||_.name;return this._proxy.$getSession(P,I,D,v,l)}async removeSession(_,D){const P=this._authenticationProviders.get(_);return P?P.provider.removeSession(D):this._proxy.$removeSession(_,D)}registerAuthenticationProvider(_,D,P,I){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:D,provider:P,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(v=>v.id===_)||this._providers.push({id:_,label:D});const l=P.onDidChangeSessions(v=>{this._proxy.$sendDidChangeSessions(_,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,D,I?.supportsMultipleAccounts??!1),new y.Disposable(()=>{l.dispose(),this._authenticationProviders.delete(_);const v=this._providers.findIndex(h=>h.id===_);v>-1&&this._providers.splice(v),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,D){const P=this._authenticationProviders.get(_);if(P)return Promise.resolve(P.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,D){const P=this._authenticationProviders.get(_);if(P)return Promise.resolve(P.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,D){const P=this._authenticationProviders.get(_);if(P)return Promise.resolve(P.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,D){return this._onDidChangeSessions.fire({provider:{id:_,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=n}),define(fe[229],me([0,1,5,14,15]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,_){this._extHostDocumentsAndEditors=_,this._proxy=k.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const _=y.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(fe[230],me([0,1,5]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const n=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return n.$readText()},writeText(k){return n.$writeText(k)}})}}e.ExtHostClipboard=L}),define(fe[39],me([0,1,13,7,15,25,5,17,11,59,41,50,2,6,4,14,63,22,53,51]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(c,d){this._commands=new Map,this._apiCommands=new Map,this._proxy=c.getProxy(n.MainContext.MainThreadCommands),this._logService=d,this.converter=new g(this,o=>{const f=this._apiCommands.get(o);return f?.result===b.Void?f:void 0},d),this._argumentProcessors=[{processArgument(o){return(0,D.revive)(o)}},{processArgument(o){return(0,C.cloneAndChange)(o,function(f){if(P.Range.isIRange(f))return y.Range.to(f);if(I.Position.isIPosition(f))return y.Position.to(f);if(P.Range.isIRange(f.range)&&l.URI.isUri(f.uri))return y.location.to(f);if(f instanceof A.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const d=this.registerCommand(!1,c.id,async(...o)=>{const f=c.args.map((E,T)=>{if(!E.validate(o[T]))throw new Error(`Invalid argument '${E.name}' when running '${c.id}', received: ${o[T]}`);return E.convert(o[T])}),u=await this.executeCommand(c.internalId,...f);return c.result.convert(u,o,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new L.Disposable(()=>{d.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,d,o,f,u,E){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:o,thisArg:f,description:u,extension:E}),c&&this._proxy.$registerCommand(d),new L.Disposable(()=>{this._commands.delete(d)&&c&&this._proxy.$unregisterCommand(d)})}executeCommand(c,...d){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,d,!0)}async _doExecuteCommand(c,d,o){if(this._commands.has(c))return this._executeContributedCommand(c,d,!1);{let f=!1;const u=(0,C.cloneAndChange)(d,function(E){if(E instanceof L.Position)return y.Position.from(E);if(E instanceof L.Range)return y.Range.from(E);if(E instanceof L.Location)return y.location.from(E);if(L.NotebookRange.isNotebookRange(E))return y.NotebookRange.from(E);if(E instanceof ArrayBuffer)return f=!0,A.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return f=!0,A.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(c,f?new p.SerializableObjectWithBuffers(u):u,o);return(0,D.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(c,d,!1);throw E}}}async _executeContributedCommand(c,d,o){const f=this._commands.get(c);if(!f)throw new Error("Unknown command");let{callback:u,thisArg:E,description:T}=f;if(T)for(let R=0;R<T.args.length;R++)try{(0,m.validateConstraint)(d[R],T.args[R].constraint)}catch(B){throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${T.args[R].name}' - ${T.args[R].description}`)}try{return await u.apply(E,d)}catch(R){if(c===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...d);B&&(c=B.command)}throw this._logService.error(R,c,f.extension?.identifier),o?new class extends Error{constructor(){super((0,a.toErrorMessage)(R));this.id=c,this.source=f.extension?.displayName??f.extension?.name}}:R}}$executeContributedCommand(c,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(d=d.map(o=>this._argumentProcessors.reduce((f,u)=>u.processArgument(f),o)),this._executeContributedCommand(c,d,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),this._proxy.$getCommands().then(d=>(c&&(d=d.filter(o=>o[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(let[d,o]of this._commands){let{description:f}=o;f&&(c[d]=f)}return Promise.resolve(c)}};r=Ve([$e(0,w.IExtHostRpcService),$e(1,_.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class g{constructor(c,d,o){this._commands=c,this._lookupApiCommand=d,this._logService=o,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,d){if(!c)return;const o={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return o;const f=this._lookupApiCommand(c.command);if(f)o.id=f.internalId,o.arguments=f.args.map((u,E)=>u.convert(c.arguments&&c.arguments[E]));else if((0,k.isNonEmptyArray)(c.arguments)){const u=++this._cachIdPool;this._cache.set(u,c),d.add((0,v.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),o.$ident=u,o.id=this.delegatingCommandId,o.arguments=[u],this._logService.trace("CommandsConverter#CREATE",c.command,u)}return o}fromInternal(c){const d=n.ObjectIdentifier.of(c);return typeof d=="number"?this._cache.get(d):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const d=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class s{constructor(c,d,o,f){this.name=c,this.description=d,this.validate=o,this.convert=f}optional(){return new s(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,d){return new s(c??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=s,s.Uri=new s("uri","Uri of a text document",t=>l.URI.isUri(t),t=>t),s.Position=new s("position","A position in a text document",t=>L.Position.isPosition(t),y.Position.from),s.Range=new s("range","A range in a text document",t=>L.Range.isRange(t),y.Range.from),s.Selection=new s("selection","A selection in a text document",t=>L.Selection.isSelection(t),y.Selection.from),s.Number=new s("number","",t=>typeof t=="number",t=>t),s.String=new s("string","",t=>typeof t=="string",t=>t),s.CallHierarchyItem=new s("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,y.CallHierarchyItem.from),s.TypeHierarchyItem=new s("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,y.TypeHierarchyItem.from),s.TestItem=new s("testItem","A VS Code TestItem",t=>t instanceof S.TestItemImpl,y.TestItem.from);class b{constructor(c,d){this.description=c,this.convert=d}}e.ApiCommandResult=b,b.Void=new b("no result",t=>t);class i{constructor(c,d,o,f,u){this.id=c,this.internalId=d,this.description=o,this.args=f,this.result=u}}e.ApiCommand=i}),define(fe[231],me([0,1,15,7,84,39,17,111]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",P(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,v)=>{if((0,n.isFalsyOrEmpty)(l))return;class h extends L.SymbolInformation{static to(S){const A=new h(S.name,m.SymbolKind.to(S.kind),S.containerName||"",new L.Location(v[0],m.Range.to(S.range)));return A.detail=S.detail,A.range=A.location.range,A.selectionRange=m.Range.to(S.selectionRange),A.children=S.children?S.children.map(h.to):[],A}}return l.map(h.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new C.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",P(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",P(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(v=>L.Position.isPosition(v)),l=>l.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(v=>{let h;for(const w of v.reverse())h=new L.SelectionRange(m.Range.to(w),h);return h}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(m.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",l=>{if(!!l)return{range:m.Range.to(l.range),placeholder:l.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return m.WorkspaceEdit.to(l)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new L.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const v=(0,k.decodeSemanticTokensDto)(l);if(v.type==="full")return new L.SemanticTokens(v.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new L.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const v=(0,k.decodeSemanticTokensDto)(l);if(v.type==="full")return new L.SemanticTokens(v.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,v,h)=>{if(!l)return new L.CompletionList([]);const w=l.suggestions.map(S=>m.CompletionItem.to(S,h));return new L.CompletionList(w,l.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return m.SignatureHelp.to(l)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,v,h)=>P(w=>new L.CodeLens(m.Range.to(w.range),w.command&&h.fromInternal(w.command)))(l))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>L.Range.isRange(l),l=>L.Selection.isSelection(l)?m.Selection.from(l):m.Range.from(l)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,v,h)=>P(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(w.command)}else{const S=new L.CodeAction(w.title,w.kind?new L.CodeActionKind(w.kind):void 0);return w.edit&&(S.edit=m.WorkspaceEdit.to(w.edit)),w.command&&(S.command=h.fromInternal(w.command)),S.isPreferred=w.isPreferred,S}})(l))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(v=>new L.ColorInformation(m.Range.to(v.range),m.Color.to(v.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",l=>l instanceof L.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:m.Range.from(l.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",P(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(v=>m.NotebookExclusiveDocumentPattern.to(v))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[m.ViewColumn.from(l.viewColumn),m.TextEditorOpenOptions.from(l)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",l=>l.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class D{static register(v){_.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=D;function P(l){return v=>{if(Array.isArray(v))return v.map(l)}}function I(l){if(!Array.isArray(l))return;const v=[];for(const h of l)y.isLocationLink(h)?v.push(m.DefinitionLink.to(h)):v.push(m.location.to(h));return v}}),define(fe[232],me([0,1,18,57,3,6,2,84,27,15,7,5]),function(Y,e,m,L,y,C,n,k,_,D,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function l(v,h,w){const S=v.getProxy(I.MainContext.MainThreadComments);class A{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const c=this._commentControllers.get(t.handle);return c||t}else if(t&&t.$mid===7){const c=this._commentControllers.get(t.commentControlHandle);if(!c)return t;const d=c.getCommentThread(t.commentThreadHandle);return d||t}else if(t&&t.$mid===8){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const d=c.getCommentThread(t.thread.commentThreadHandle);return d?{thread:d,text:t.text}:t}else if(t&&t.$mid===9){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const d=c.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let o=t.commentUniqueId,f=d.getCommentByUniqueId(o);return f||t}else if(t&&t.$mid===10){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const d=c.getCommentThread(t.thread.commentThreadHandle);if(!d)return t;let o=t.text,f=t.commentUniqueId,u=d.getCommentByUniqueId(f);return u?(u.body=o,u):t}return t}})}createCommentController(t,c,d){const o=A.handlePool++,f=new a(t,o,c,d);this._commentControllers.set(f.handle,f);const u=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(t.identifier))||[];return u.push(f),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(t.identifier),u),f.value}$createCommentThreadTemplate(t,c,d){const o=this._commentControllers.get(t);!o||o.$createCommentThreadTemplate(c,d)}async $updateCommentThreadTemplate(t,c,d){const o=this._commentControllers.get(t);!o||o.$updateCommentThreadTemplate(c,d)}$deleteCommentThread(t,c){const d=this._commentControllers.get(t);d&&d.$deleteCommentThread(c)}$provideCommentingRanges(t,c,d){const o=this._commentControllers.get(t);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const f=w.getDocument(n.URI.revive(c));return(0,m.asPromise)(()=>o.commentingRangeProvider.provideCommentingRanges(f,d)).then(u=>u?u.map(E=>D.Range.from(E)):void 0)}$toggleReaction(t,c,d,o,f){const u=this._commentControllers.get(t);return!u||!u.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const E=u.getCommentThread(c);if(E){const T=E.getCommentByUniqueId(o.uniqueIdInThread);if(u!==void 0&&T&&u.reactionHandler)return u.reactionHandler(T,s(f))}return Promise.resolve(void 0)})}dispose(){}}A.handlePool=0;class p{constructor(t,c,d,o,f,u,E){this._commentControllerHandle=c,this._id=d,this._uri=o,this._range=f,this._comments=u,this.handle=p._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),S.$createCommentThread(c,this.handle,this._id,this._uri,D.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u,this._localDisposables.push({dispose:()=>{S.$deleteCommentThread(c,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(R){T.range=R},get comments(){return T.comments},set comments(R){T.comments=R},get collapsibleState(){return T.collapsibleState},set collapsibleState(R){T.collapsibleState=R},get canReply(){return T.canReply},set canReply(R){T.canReply=R},get contextValue(){return T.contextValue},set contextValue(R){T.contextValue=R},get label(){return T.label},set label(R){T.label=R},dispose:()=>{T.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),c={};t("range")&&(c.range=D.Range.from(this._range)),t("label")&&(c.label=this.label),t("contextValue")&&(c.contextValue=this.contextValue??null),t("comments")&&(c.comments=this._comments.map(d=>r(this,d,this._commentsMap))),t("collapsibleState")&&(c.collapseState=b(this._collapseState)),t("canReply")&&(c.canReply=this.canReply),this.modifications={},S.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(t){for(let c of this._commentsMap){let d=c[0],o=c[1];if(t===o)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}p._handlePool=0,Ve([(0,L.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(t,c,d,o){this._extension=t,this._handle=c,this._id=d,this._label=o,this._threads=new Map,S.$registerCommentController(this.handle,d,o);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(u){f.options=u},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(u){f.commentingRangeProvider=u},get reactionHandler(){return f.reactionHandler},set reactionHandler(u){f.reactionHandler=u},createCommentThread(u,E,T){return f.createCommentThread(u,E,T).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{S.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,S.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,S.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,S.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,c,d,o){if(typeof t=="string"){const f=new p(this.id,this.handle,t,c,d,o,this._extension.identifier);return this._threads.set(f.handle,f),f}else{const f=new p(this.id,this.handle,void 0,t,c,d,this._extension.identifier);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(t,c){const d=new p(this.id,this.handle,void 0,n.URI.revive(t),D.Range.to(c),[],this._extension.identifier);return d.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(t,c){let d=this._threads.get(t);d&&(d.range=D.Range.to(c))}$deleteCommentThread(t){let c=this._threads.get(t);c&&c.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function r(i,t,c){let d=c.get(t);d||(d=++i.commentHandle,c.set(t,d));const o=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:d,body:D.MarkdownString.from(t.body),userName:t.author.name,userIconPath:o,label:t.label,commentReactions:t.reactions?t.reactions.map(f=>g(f)):void 0}}function g(i){return{label:i.label,iconPath:i.iconPath?D.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function s(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?n.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function b(i){if(i!==void 0)switch(i){case P.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new A}e.createExtHostComments=l}),define(fe[130],me([0,1,2,5,7,4,14,11,17,8,9]),function(Y,e,m,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(v,h){this._logService=h,this._provider=new Map,this._proxy=v.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(v,h){const w=wn._handlePool++;this._provider.set(w,{provider:v,extensionId:h}),this._proxy.$registerDecorationProvider(w,h.value);const S=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(A=>{if(!A){this._proxy.$onDidChange(w,null);return}let p=(0,_.asArray)(A);if(p.length<=wn._maxEventSize){this._proxy.$onDidChange(w,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,p.length);const a=p.map(s=>({uri:s,rank:(0,D.count)(s.path,"/")})),r=(0,_.groupBy)(a,(s,b)=>s.rank-b.rank||(0,D.compare)(s.uri.path,b.uri.path));let g=[];e:for(let s of r){let b;for(let i of s){let t=(0,P.dirname)(i.uri.path);if(b!==t&&(b=t,g.push(i.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(w,g)});return new y.Disposable(()=>{S?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(v,h,w){if(!this._provider.has(v))return Object.create(null);const S=Object.create(null),{provider:A,extensionId:p}=this._provider.get(v);return await Promise.all(h.map(async a=>{try{const{uri:r,id:g}=a,s=await Promise.resolve(A.provideFileDecoration(m.URI.revive(r),w));if(!s)return;try{y.FileDecoration.validate(s),S[g]=[s.propagate,s.tooltip,s.badge,s.color]}catch(b){this._logService.warn(`INVALID decoration from extension '${p.value}': ${b}`)}}catch(r){this._logService.error(r)}})),S}};I._handlePool=0,I._maxEventSize=250,I=Ve([$e(0,n.IExtHostRpcService),$e(1,k.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var st=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[233],me([0,1,162,116,2,5,7,15,3,11,24,45]),function(Y,e,m,L,y,C,n,k,_,D,P,I){"use strict";var l,v,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(p,a,r,g,s,b){this._name=p,this._owner=a,this._maxDiagnosticsPerFile=r,l.set(this,void 0),v.set(this,void 0),h.set(this,void 0),this._isDisposed=!1,st(this,h,new P.ResourceMap(i=>g.getComparisonKey(i)),"f"),st(this,l,s,"f"),st(this,v,b,"f")}dispose(){this._isDisposed||(Ne(this,v,"f").fire([...Ne(this,h,"f").keys()]),Ne(this,l,"f")&&Ne(this,l,"f").$clear(this._owner),Ne(this,h,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,a){if(!p){this.clear();return}this._checkDisposed();let r=[];if(y.URI.isUri(p)){if(!a){this.delete(p);return}Ne(this,h,"f").set(p,a.slice()),r=[p]}else if(Array.isArray(p)){r=[];let s;p=[...p].sort(w._compareIndexedTuplesByUri);for(const b of p){const[i,t]=b;if((!s||i.toString()!==s.toString())&&(s&&Ne(this,h,"f").get(s).length===0&&Ne(this,h,"f").delete(s),s=i,r.push(i),Ne(this,h,"f").set(i,[])),t){const c=Ne(this,h,"f").get(i);c&&c.push(...t)}else{const c=Ne(this,h,"f").get(i);c&&(c.length=0)}}}if(Ne(this,v,"f").fire(r),!Ne(this,l,"f"))return;const g=[];for(let s of r){let b=[];const i=Ne(this,h,"f").get(s);if(i)if(i.length>this._maxDiagnosticsPerFile){b=[];const t=[n.DiagnosticSeverity.Error,n.DiagnosticSeverity.Warning,n.DiagnosticSeverity.Information,n.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(let d of i)if(d.severity===t[c]&&b.push(k.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;b.push({severity:L.MarkerSeverity.Info,message:(0,m.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:b[b.length-1].startLineNumber,startColumn:b[b.length-1].startColumn,endLineNumber:b[b.length-1].endLineNumber,endColumn:b[b.length-1].endColumn})}else b=i.map(t=>k.Diagnostic.from(t));g.push([s,b])}Ne(this,l,"f").$changeMany(this._owner,g)}delete(p){this._checkDisposed(),Ne(this,v,"f").fire([p]),Ne(this,h,"f").delete(p),Ne(this,l,"f")&&Ne(this,l,"f").$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Ne(this,v,"f").fire([...Ne(this,h,"f").keys()]),Ne(this,h,"f").clear(),Ne(this,l,"f")&&Ne(this,l,"f").$clear(this._owner)}forEach(p,a){this._checkDisposed();for(let r of Ne(this,h,"f").keys())p.apply(a,[r,this.get(r),this])}get(p){this._checkDisposed();const a=Ne(this,h,"f").get(p);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Ne(this,h,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,a){return p[0].toString()<a[0].toString()?-1:p[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=w,l=new WeakMap,v=new WeakMap,h=new WeakMap;let S=class en{constructor(p,a,r){this._logService=a,this._fileSystemInfoService=r,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,en._mapper),this._proxy=p.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(p){const a=new P.ResourceMap;for(const r of p)a.set(r,r);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(p,a){const{_collections:r,_proxy:g,_onDidChangeDiagnostics:s,_logService:b,_fileSystemInfoService:i}=this,t=new class{$changeMany(o,f){g.$changeMany(o,f),b.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,o,f.length===0?"CLEARING":f)}$clear(o){g.$clear(o),b.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,o)}dispose(){g.dispose()}};let c;if(!a)a="_generated_diagnostic_collection_name_#"+en._idPool++,c=a;else if(!r.has(a))c=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do c=a+en._idPool++;while(r.has(c))}return new class extends w{constructor(){super(a,c,en._maxDiagnosticsPerFile,i.extUri,t,s);r.set(c,this)}dispose(){super.dispose(),r.delete(c)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const a=new Map,r=[];for(const g of this._collections.values())g.forEach((s,b)=>{let i=a.get(s.toString());typeof i=="undefined"&&(i=r.length,a.set(s.toString(),i),r.push([s,[]])),r[i][1]=r[i][1].concat(...b)});return r}}_getDiagnostics(p){let a=[];for(let r of this._collections.values())r.has(p)&&(a=a.concat(r.get(p)));return a}$acceptMarkersChange(p){if(!this._mirrorCollection){const a="_generated_mirror",r=new w(a,a,en._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,r),this._mirrorCollection=r}for(const[a,r]of p)this._mirrorCollection.set(y.URI.revive(a),r.map(k.Diagnostic.to))}};S._idPool=0,S._maxDiagnosticsPerFile=1e3,S=Ve([$e(1,D.ILogService),$e(2,I.IExtHostFileSystemInfo)],S),e.ExtHostDiagnostics=S}),define(fe[234],me([0,1,2,5]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(n){this._proxy=n.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(n){return this._proxy.$showOpenDialog(n).then(k=>k?k.map(_=>m.URI.revive(_)):void 0)}showSaveDialog(n){return this._proxy.$showSaveDialog(n).then(k=>k?m.URI.revive(k):void 0)}}e.ExtHostDialogs=y}),define(fe[235],me([0,1,16,2,7,5,10,21,8]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(I,l,v){this._documentsAndEditors=l,this._logService=v,this._documentContentProviders=new Map,this._proxy=I.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,l){if(Object.keys(n.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const v=D._handlePool++;this._documentContentProviders.set(v,l),this._proxy.$registerTextContentProvider(v,I);let h;return typeof l.onDidChange=="function"&&(h=l.onDidChange(w=>{if(w.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(v,w).then(S=>{if(!S&&typeof S!="string")return;const A=this._documentsAndEditors.getDocument(w);if(!A)return;const p=(0,_.splitLines)(S);if(!A.equalLines(p))return this._proxy.$onVirtualDocumentChange(w,S)},m.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(v)&&this._proxy.$unregisterTextContentProvider(v),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(I,l){const v=this._documentContentProviders.get(I);return v?Promise.resolve(v.provideTextDocumentContent(L.URI.revive(l),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=D,D._handlePool=0}),define(fe[236],me([0,1,3,6,2,5,122,15,13,25,7]),function(Y,e,m,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(v,h){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=v.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const S of w)this._onDidRemoveDocument.fire(S.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const S of w)this._onDidAddDocument.fire(S.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(v){if(!v)return;const h=this._documentsAndEditors.getDocument(v);if(h)return h}getDocument(v){const h=this.getDocumentData(v);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return h.document}ensureDocumentData(v){const h=this._documentsAndEditors.getDocument(v);if(h)return Promise.resolve(h);let w=this._documentLoader.get(v.toString());return w||(w=this._proxy.$tryOpenDocument(v).then(S=>{this._documentLoader.delete(v.toString());const A=y.URI.revive(S);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(A))},S=>(this._documentLoader.delete(v.toString()),Promise.reject(S))),this._documentLoader.set(v.toString(),w)),w}createDocumentData(v){return this._proxy.$tryCreateDocument(v).then(h=>y.URI.revive(h))}$acceptModelModeChanged(v,h){const w=y.URI.revive(v),S=this._documentsAndEditors.getDocument(w);if(!S)throw new Error("unknown document");this._onDidRemoveDocument.fire(S.document),S._acceptLanguageId(h),this._onDidAddDocument.fire(S.document)}$acceptModelSaved(v){const h=y.URI.revive(v),w=this._documentsAndEditors.getDocument(h);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(v,h){const w=y.URI.revive(v),S=this._documentsAndEditors.getDocument(w);if(!S)throw new Error("unknown document");S._acceptIsDirty(h),this._onDidChangeDocument.fire({document:S.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,h,w){const S=y.URI.revive(v),A=this._documentsAndEditors.getDocument(S);if(!A)throw new Error("unknown document");A._acceptIsDirty(w),A.onEvents(h);let p;h.isUndoing?p=P.TextDocumentChangeReason.Undo:h.isRedoing&&(p=P.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,D.deepFreeze)({document:A.document,contentChanges:h.changes.map(a=>({range:k.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:p}))}setWordDefinitionFor(v,h){(0,n.setWordDefinitionFor)(v,h)}}e.ExtHostDocuments=I}),define(fe[46],me([0,1,56,3,6,2,4,5,122,14,129,15,11,24,10,76,140]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class A{constructor(r){this.value=r,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let p=class{constructor(r,g){this._extHostRpc=r,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new v.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const g=[],s=[],b=[];if(r.removedDocuments)for(const i of r.removedDocuments){const t=C.URI.revive(i),c=this._documents.get(t);c?.unref()&&(this._documents.delete(t),g.push(c.value))}if(r.addedDocuments)for(const i of r.addedDocuments){const t=C.URI.revive(i.uri);let c=this._documents.get(t);if(c&&t.scheme!==h.Schemas.vscodeNotebookCell&&t.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);c||(c=new A(new _.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(t,c),s.push(c.value)),c.ref()}if(r.removedEditors)for(const i of r.removedEditors){const t=this._editors.get(i);this._editors.delete(i),t&&b.push(t)}if(r.addedEditors)for(const i of r.addedEditors){const t=C.URI.revive(i.documentUri);m.ok(this._documents.has(t),`document '${t}' does not exist`),m.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const c=this._documents.get(t).value,d=new P.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new S.Lazy(()=>c.document),i.selections.map(I.Selection.to),i.options,i.visibleRanges.map(o=>I.Range.to(o)),typeof i.editorPosition=="number"?I.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,d)}r.newActiveEditor!==void 0&&(m.ok(r.newActiveEditor===null||this._editors.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this._activeEditorId=r.newActiveEditor),(0,y.dispose)(g),(0,y.dispose)(b),r.removedDocuments&&this._onDidRemoveDocuments.fire(g),r.addedDocuments&&this._onDidAddDocuments.fire(s),(r.removedEditors||r.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),r.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(r){return this._documents.get(r)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),r=>r.value)}getEditor(r){return this._editors.get(r)}activeEditor(r){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return r?g:g?.value}allEditors(){return[...this._editors.values()]}};p=Ve([$e(0,D.IExtHostRpcService),$e(1,l.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,n.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[54],me([0,1,15,5,2,3,4,14,18]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,n.createDecorator)("IExtHostEditorTabs");let D=class{constructor(I){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=I.getProxy(L.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(I){let l=-1;this._tabs=I.map((h,w)=>(h.isActive&&(l=w),Object.freeze({label:h.label,viewColumn:m.ViewColumn.to(h.viewColumn),index:w,resource:y.URI.revive(h.resource),additionalResourcesAndViewIds:h.additionalResourcesAndViewIds.map(({resource:S,viewId:A})=>({resource:y.URI.revive(S),viewId:A})),viewId:h.editorId,isActive:h.isActive,move:async(S,A)=>{this._proxy.$moveTab(h,S,m.ViewColumn.from(A)),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(h),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((h,w)=>h.viewColumn===w.viewColumn?h.index-w.index:h.viewColumn-w.viewColumn);const v=this._activeTab;this._activeTab=l===-1?void 0:this._tabs[l],this._activeTab!==v&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};D=Ve([$e(0,k.IExtHostRpcService)],D),e.ExtHostEditorTabs=D}),define(fe[237],me([0,1,2,5,6,7,15,147,8,22,29]),function(Y,e,m,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const w=this._schemes.indexOf(h);w>=0&&(this._schemes.splice(w,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),w=[];let S,A,p=14,a=14;for(const r of h){let g=S?(0,_.commonPrefixLength)(S,r):0;for(g===0?A=1:A=a;g<r.length;g++)g+1===r.length?(p=a,a=9):a+=1,w.push([A,r.toUpperCase().charCodeAt(g),a]),w.push([A,r.toLowerCase().charCodeAt(g),a]),A=a;S=r,a=p}w.push([9,58,10]),w.push([10,47,12]),this._stateMachine=new k.StateMachine(w)}}provideDocumentLinks(h){this._initStateMachine();const w=[],S=k.LinkComputer.computeLinks({getLineContent(A){return h.lineAt(A-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const A of S){const p=n.DocumentLink.to(A);p.target&&w.push(p)}return w}}class l{constructor(h,w){this._extHostLanguageFeatures=w,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,w,S,A={}){if(this._registeredSchemes.has(w))throw new Error(`a provider for the scheme '${w}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const p=this._handlePool++;this._linkProvider.add(w),this._registeredSchemes.add(w),this._fsProvider.set(p,S);let a=2;A.isCaseSensitive&&(a+=1024),A.isReadonly&&(a+=2048),typeof S.copy=="function"&&(a+=8),typeof S.open=="function"&&typeof S.close=="function"&&typeof S.read=="function"&&typeof S.write=="function"&&((0,P.checkProposedApiEnabled)(h,"fsChunks"),a+=4),this._proxy.$registerFileSystemProvider(p,w,a).catch(g=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${w}`),console.error(g)});const r=S.onDidChangeFile(g=>{const s=[];for(const b of g){let{uri:i,type:t}=b;if(i.scheme!==w)continue;let c;switch(t){case C.FileChangeType.Changed:c=0;break;case C.FileChangeType.Created:c=1;break;case C.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:i,type:c})}this._proxy.$onFileSystemChange(p,s)});return(0,y.toDisposable)(()=>{r.dispose(),this._linkProvider.delete(w),this._registeredSchemes.delete(w),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(h){const{type:w,ctime:S,mtime:A,size:p,permissions:a}=h;return{type:w,ctime:S,mtime:A,size:p,permissions:a}}$stat(h,w){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(w))).then(S=>l._asIStat(S))}$readdir(h,w){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(w)))}$readFile(h,w){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(w))).then(S=>D.VSBuffer.wrap(S))}$writeFile(h,w,S,A){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(w),S.buffer,A))}$delete(h,w,S){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(w),S))}$rename(h,w,S,A){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(w),m.URI.revive(S),A))}$copy(h,w,S,A){const p=this._getFsProvider(h);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(m.URI.revive(w),m.URI.revive(S),A))}$mkdir(h,w){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(w)))}$watch(h,w,S,A){const p=this._getFsProvider(h).watch(m.URI.revive(S),A);this._watches.set(w,p)}$unwatch(h,w){const S=this._watches.get(w);S&&(S.dispose(),this._watches.delete(w))}$open(h,w,S){const A=this._getFsProvider(h);if(!A.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(A.open(m.URI.revive(w),S))}$close(h,w){const S=this._getFsProvider(h);if(!S.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(S.close(w))}$read(h,w,S,A){const p=this._getFsProvider(h);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const a=D.VSBuffer.alloc(A);return Promise.resolve(p.read(w,S,a.buffer,0,A)).then(r=>a.slice(0,r))}$write(h,w,S,A){const p=this._getFsProvider(h);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(w,S,A.buffer,0,A.byteLength))}_getFsProvider(h){const w=this._fsProvider.get(h);if(!w){const S=new Error;throw S.name="ENOPRO",S.message="no provider",S}return w}}e.ExtHostFileSystem=l}),define(fe[66],me([0,1,5,42,7,22,4,14,45]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let D=class xt{constructor(I,l){const v=I.getProxy(m.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(h){return v.$stat(h).catch(xt._handleError)},readDirectory(h){return v.$readdir(h).catch(xt._handleError)},createDirectory(h){return v.$mkdir(h).catch(xt._handleError)},async readFile(h){return v.$readFile(h).then(w=>w.buffer).catch(xt._handleError)},writeFile(h,w){return v.$writeFile(h,C.VSBuffer.wrap(w)).catch(xt._handleError)},delete(h,w){return v.$delete(h,{recursive:!1,useTrash:!1,...w}).catch(xt._handleError)},rename(h,w,S){return v.$rename(h,w,{overwrite:!1,...S}).catch(xt._handleError)},copy(h,w,S){return v.$copy(h,w,{overwrite:!1,...S}).catch(xt._handleError)},isWritableFileSystem(h){const w=l.getCapabilities(h);if(typeof w=="number")return!(w&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new y.FileSystemError(String(I));if(I.name==="ENOPRO")throw y.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(I.message);default:throw new y.FileSystemError(I.message,I.name)}}};D=Ve([$e(0,k.IExtHostRpcService),$e(1,_.IExtHostFileSystemInfo)],D),e.ExtHostConsumerFileSystem=D,e.IExtHostConsumerFileSystem=(0,n.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[238],me([0,1,2,39]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(n,k,_,D){this._extHostNotebooks=k,this._textDocumentsAndEditors=_,this._commands=D;const P=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const l=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:m.URI.revive(I.notebookUri),inputUri:m.URI.revive(I.inputUri),notebookEditor:l.apiEditor}}return{notebookUri:m.URI.revive(I.notebookUri),inputUri:m.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(P)}$willAddInteractiveDocument(n,k,_,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:_,uri:n,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(n,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[n]})}}e.ExtHostInteractive=y}),define(fe[239],me([0,1,6,5]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(n){this._handlePool=0,this._proxy=n.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(n){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,n),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=y}),define(fe[240],me([0,1,2,25,15,7,5,8,41,17,13,144,6,111,75,88,47,16,3]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class a{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentSymbols(G,ee){const ne=this._documents.getDocument(G),ce=await this._provider.provideDocumentSymbols(ne,ee);if(!(0,D.isFalsyOrEmpty)(ce))return ce[0]instanceof C.DocumentSymbol?ce.map(y.DocumentSymbol.from):a._asDocumentSymbolTree(ce)}static _asDocumentSymbolTree(G){G=G.slice(0).sort((ce,Z)=>{let re=ce.location.range.start.compareTo(Z.location.range.start);return re===0&&(re=Z.location.range.end.compareTo(ce.location.range.end)),re});const ee=[],ne=[];for(const ce of G){const Z={name:ce.name||"!!MISSING: name!!",kind:y.SymbolKind.from(ce.kind),tags:ce.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:ce.containerName,range:y.Range.from(ce.location.range),selectionRange:y.Range.from(ce.location.range),children:[]};for(;;){if(ne.length===0){ne.push(Z),ee.push(Z);break}const re=ne[ne.length-1];if(_.Range.containsRange(re.range,Z.range)&&!_.Range.equalsRange(re.range,Z.range)){re.children&&re.children.push(Z),ne.push(Z);break}ne.pop()}}return ee}}class r{constructor(G,ee,ne){this._documents=G,this._commands=ee,this._provider=ne,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(G,ee){const ne=this._documents.getDocument(G),ce=await this._provider.provideCodeLenses(ne,ee);if(!ce||ee.isCancellationRequested)return;const Z=this._cache.add(ce),re=new l.DisposableStore;this._disposables.set(Z,re);const pe={cacheId:Z,lenses:[]};for(let Me=0;Me<ce.length;Me++)pe.lenses.push({cacheId:[Z,Me],range:y.Range.from(ce[Me].range),command:this._commands.toInternal(ce[Me].command,re)});return pe}async resolveCodeLens(G,ee){const ne=G.cacheId&&this._cache.get(...G.cacheId);if(!ne)return;let ce;if(typeof this._provider.resolveCodeLens!="function"||ne.isResolved?ce=ne:ce=await this._provider.resolveCodeLens(ne,ee),ce||(ce=ne),ee.isCancellationRequested)return;const Z=G.cacheId&&this._disposables.get(G.cacheId[0]);if(!!Z)return G.command=this._commands.toInternal(ce.command??r._badCmd,Z),G}releaseCodeLenses(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}}r._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(He){return Array.isArray(He)?He.map(y.DefinitionLink.from):He?[y.DefinitionLink.from(He)]:[]}class s{constructor(G,ee){this._documents=G,this._provider=ee}async provideDefinition(G,ee,ne){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideDefinition(ce,Z,ne);return g(re)}}class b{constructor(G,ee){this._documents=G,this._provider=ee}async provideDeclaration(G,ee,ne){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideDeclaration(ce,Z,ne);return g(re)}}class i{constructor(G,ee){this._documents=G,this._provider=ee}async provideImplementation(G,ee,ne){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideImplementation(ce,Z,ne);return g(re)}}class t{constructor(G,ee){this._documents=G,this._provider=ee}async provideTypeDefinition(G,ee,ne){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideTypeDefinition(ce,Z,ne);return g(re)}}class c{constructor(G,ee){this._documents=G,this._provider=ee}async provideHover(G,ee,ne){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideHover(ce,Z,ne);if(!(!re||(0,D.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=ce.getWordRangeAtPosition(Z)),re.range||(re.range=new C.Range(Z,Z)),y.Hover.from(re)}}class d{constructor(G,ee){this._documents=G,this._provider=ee}async provideEvaluatableExpression(G,ee,ne){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideEvaluatableExpression(ce,Z,ne);if(re)return y.EvaluatableExpression.from(re)}}class o{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlineValues(G,ee,ne,ce){const Z=this._documents.getDocument(G),re=await this._provider.provideInlineValues(Z,y.Range.to(ee),y.InlineValueContext.to(ne),ce);if(Array.isArray(re))return re.map(pe=>y.InlineValue.from(pe))}}class f{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentHighlights(G,ee,ne){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideDocumentHighlights(ce,Z,ne);if(Array.isArray(re))return re.map(y.DocumentHighlight.from)}}class u{constructor(G,ee){this._documents=G,this._provider=ee}async provideLinkedEditingRanges(G,ee,ne){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideLinkedEditingRanges(ce,Z,ne);if(re&&Array.isArray(re.ranges))return{ranges:(0,D.coalesce)(re.ranges.map(y.Range.from)),wordPattern:re.wordPattern}}}class E{constructor(G,ee){this._documents=G,this._provider=ee}async provideReferences(G,ee,ne,ce){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=await this._provider.provideReferences(Z,re,ne,ce);if(Array.isArray(pe))return pe.map(y.location.from)}}class T{constructor(G,ee,ne,ce,Z,re,pe){this._documents=G,this._commands=ee,this._diagnostics=ne,this._provider=ce,this._logService=Z,this._extension=re,this._apiDeprecation=pe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(G,ee,ne,ce){const Z=this._documents.getDocument(G),re=I.Selection.isISelection(ee)?y.Selection.to(ee):y.Range.to(ee),pe=[];for(const ct of this._diagnostics.getDiagnostics(G))if(re.intersection(ct.range)&&pe.push(ct)>T._maxCodeActionsPerFile)break;const Me={diagnostics:pe,only:ne.only?new C.CodeActionKind(ne.only):void 0,triggerKind:y.CodeActionTriggerKind.to(ne.trigger)},je=await this._provider.provideCodeActions(Z,re,Me,ce);if(!(0,D.isNonEmptyArray)(je)||ce.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new l.DisposableStore;this._disposables.set(Ke,Ze);const rt=[];for(let ct=0;ct<je.length;ct++){const ye=je[ct];!ye||(T._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Ze)})):(Me.only&&(ye.kind?Me.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Ke,ct],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Ze),diagnostics:ye.diagnostics&&ye.diagnostics.map(y.Diagnostic.from),edit:ye.edit&&y.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:Ke,actions:rt}}async resolveCodeAction(G,ee){const[ne,ce]=G,Z=this._cache.get(ne,ce);if(!Z||T._isCommand(Z)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(Z,ee)??Z;return re?.edit?y.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}static _isCommand(G){return typeof G.command=="string"&&typeof G.title=="string"}}T._maxCodeActionsPerFile=1e3;class R{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentFormattingEdits(G,ee,ne){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentFormattingEdits(ce,ee,ne);if(Array.isArray(Z))return Z.map(y.TextEdit.from)}}class B{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeFormattingEdits(G,ee,ne,ce){const Z=this._documents.getDocument(G),re=y.Range.to(ee),pe=await this._provider.provideDocumentRangeFormattingEdits(Z,re,ne,ce);if(Array.isArray(pe))return pe.map(y.TextEdit.from)}}class x{constructor(G,ee){this._documents=G,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(G,ee,ne,ce,Z){const re=this._documents.getDocument(G),pe=y.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(re,pe,ne,ce,Z);if(Array.isArray(Me))return Me.map(y.TextEdit.from)}}class F{constructor(G,ee){this._provider=G,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(G,ee){const ne=n.IdObject.mixin({symbols:[]}),ce=await this._provider.provideWorkspaceSymbols(G,ee);if((0,D.isNonEmptyArray)(ce))for(const Z of ce){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const re=n.IdObject.mixin(y.WorkspaceSymbol.from(Z));this._symbolCache.set(re._id,Z),ne.symbols.push(re)}return ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne}async resolveWorkspaceSymbol(G,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return G;const ne=this._symbolCache.get(G._id);if(ne){const ce=await this._provider.resolveWorkspaceSymbol(ne,ee);return ce&&(0,L.mixin)(G,y.WorkspaceSymbol.from(ce),!0)}}releaseWorkspaceSymbols(G){const ee=this._resultCache.get(G);if(ee){for(let[ne,ce]=ee;ne<=ce;ne++)this._symbolCache.delete(ne);this._resultCache.delete(G)}}}class ${constructor(G,ee,ne){this._documents=G,this._provider=ee,this._logService=ne}static supportsResolving(G){return typeof G.prepareRename=="function"}async provideRenameEdits(G,ee,ne,ce){const Z=this._documents.getDocument(G),re=y.Position.to(ee);try{const pe=await this._provider.provideRenameEdits(Z,re,ne,ce);return pe?y.WorkspaceEdit.from(pe):void 0}catch(pe){const Me=$._asMessage(pe);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(G,ee,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ce=this._documents.getDocument(G),Z=y.Position.to(ee);try{const re=await this._provider.prepareRename(ce,Z,ne);let pe,Me;if(C.Range.isRange(re)?(pe=re,Me=ce.getText(re)):(0,P.isObject)(re)&&(pe=re.range,Me=re.placeholder),!pe||!Me)return;if(pe.start.line>Z.line||pe.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(pe),text:Me}}catch(re){const pe=$._asMessage(re);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(G){return typeof G=="string"?G:G instanceof Error&&typeof G.message=="string"?G.message:void 0}}class M{constructor(G,ee){this.resultId=G,this.tokens=ee}}class H{constructor(G,ee){this._documents=G,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(G,ee,ne){const ce=this._documents.getDocument(G),Z=ee!==0?this._previousResults.get(ee):null;let re=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ce,Z.resultId,ne):await this._provider.provideDocumentSemanticTokens(ce,ne);return Z&&this._previousResults.delete(ee),re?(re=H._fixProvidedSemanticTokens(re),this._send(H._convertToEdits(Z,re),re)):null}async releaseDocumentSemanticColoring(G){this._previousResults.delete(G)}static _fixProvidedSemanticTokens(G){return H._isSemanticTokens(G)?H._isCorrectSemanticTokens(G)?G:new C.SemanticTokens(new Uint32Array(G.data),G.resultId):H._isSemanticTokensEdits(G)?H._isCorrectSemanticTokensEdits(G)?G:new C.SemanticTokensEdits(G.edits.map(ee=>new C.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),G.resultId):G}static _isSemanticTokens(G){return G&&!!G.data}static _isCorrectSemanticTokens(G){return G.data instanceof Uint32Array}static _isSemanticTokensEdits(G){return G&&Array.isArray(G.edits)}static _isCorrectSemanticTokensEdits(G){for(const ee of G.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(G,ee){if(!H._isSemanticTokens(ee)||!G||!G.tokens)return ee;const ne=G.tokens,ce=ne.length,Z=ee.data,re=Z.length;let pe=0;const Me=Math.min(ce,re);for(;pe<Me&&ne[pe]===Z[pe];)pe++;if(pe===ce&&pe===re)return new C.SemanticTokensEdits([],ee.resultId);let je=0;const Ke=Me-pe;for(;je<Ke&&ne[ce-je-1]===Z[re-je-1];)je++;return new C.SemanticTokensEdits([{start:pe,deleteCount:ce-pe-je,data:Z.subarray(pe,re-je)}],ee.resultId)}_send(G,ee){if(H._isSemanticTokens(G)){const ne=this._nextResultId++;return this._previousResults.set(ne,new M(G.resultId,G.data)),(0,v.encodeSemanticTokensDto)({id:ne,type:"full",data:G.data})}if(H._isSemanticTokensEdits(G)){const ne=this._nextResultId++;return H._isSemanticTokens(ee)?this._previousResults.set(ne,new M(ee.resultId,ee.data)):this._previousResults.set(ne,new M(G.resultId)),(0,v.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(G.edits||[]).map(ce=>({start:ce.start,deleteCount:ce.deleteCount,data:ce.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class N{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeSemanticTokens(G,ee,ne){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentRangeSemanticTokens(ce,y.Range.to(ee),ne);return Z?this._send(Z):null}_send(G){return(0,v.encodeSemanticTokensDto)({id:0,type:"full",data:G.data})}}e.DocumentRangeSemanticTokensAdapter=N;class U{constructor(G,ee,ne,ce,Z){this._documents=G,this._commands=ee,this._provider=ne,this._apiDeprecation=ce,this._extension=Z,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(G){return typeof G.resolveCompletionItem=="function"}async provideCompletionItems(G,ee,ne,ce){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=Z.getWordRangeAtPosition(re)||new C.Range(re,re),Me=pe.with({end:re}),je=new S.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Z,re,ce,y.CompletionContext.to(ne));if(!Ke||ce.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new C.CompletionList(Ke):Ke,rt=U.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),ct=new l.DisposableStore;this._disposables.set(rt,ct);const ye=[],at={x:rt,b:ye,a:{replace:y.Range.from(pe),insert:y.Range.from(Me)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let J=0;J<Ze.items.length;J++){const ie=Ze.items[J],_e=this._convertCompletionItem(ie,[rt,J],Me,pe);ye.push(_e)}return at}async resolveCompletionItem(G,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...G);if(!ne)return;const ce=await this._provider.resolveCompletionItem(ne,ee);if(!!ce)return this._convertCompletionItem(ce,G)}releaseCompletionItems(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}_convertCompletionItem(G,ee,ne,ce){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const re={x:ee,a:G.label,b:G.kind!==void 0?y.CompletionItemKind.from(G.kind):void 0,n:G.tags&&G.tags.map(y.CompletionItemTag.from),c:G.detail,d:typeof G.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(G.documentation),e:G.sortText!==G.label?G.sortText:void 0,f:G.filterText!==G.label?G.filterText:void 0,g:G.preselect||void 0,i:G.keepWhitespace?1:0,k:G.commitCharacters,l:G.additionalTextEdits&&G.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(G.command,Z)};G.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=G.textEdit.newText):typeof G.insertText=="string"?re.h=G.insertText:G.insertText instanceof C.SnippetString&&(re.h=G.insertText.value,re.i|=4);let pe;return G.textEdit?pe=G.textEdit.range:G.range&&(pe=G.range),C.Range.isRange(pe)?re.j=y.Range.from(pe):pe&&(!ne?.isEqual(pe.inserting)||!ce?.isEqual(pe.replacing))&&(re.j={insert:y.Range.from(pe.inserting),replace:y.Range.from(pe.replacing)}),re}}class V{constructor(G,ee,ne){this._documents=G,this._provider=ee,this._commands=ne,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(G,ee,ne,ce){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=await this._provider.provideInlineCompletionItems(Z,re,{selectedCompletionInfo:ne.selectedSuggestionInfo?{range:y.Range.to(ne.selectedSuggestionInfo.range),text:ne.selectedSuggestionInfo.text}:void 0,triggerKind:ne.triggerKind},ce);if(!pe||ce.isCancellationRequested)return;const Me=(0,P.isArray)(pe)?{items:pe}:pe,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Ze,rt)=>{let ct;return Ze.command&&(Ke||(Ke=new l.DisposableStore,this._disposables.set(je,Ke)),ct=this._commands.toInternal(Ze.command,Ke)),{text:Ze.text,range:Ze.range?y.Range.from(Ze.range):void 0,command:ct,idx:rt}})}}disposeCompletions(G){this._cache.delete(G);const ee=this._disposables.get(G);ee&&ee.clear(),this._disposables.delete(G)}handleDidShowCompletionItem(G,ee){const ne=this._cache.get(G,ee);ne&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new p.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(G){let ee=O.map.get(G);return ee||(ee=new O,O.map.set(G,ee)),ee}fireOnDidShowCompletionItem(G){this._onDidShowCompletionItemEmitter.fire(G)}}e.InlineCompletionController=O,O.map=new WeakMap;class W{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(G,ee,ne,ce){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=this.reviveContext(ne),Me=await this._provider.provideSignatureHelp(Z,re,ce,pe);if(Me){const je=this._cache.add([Me]);return{...y.SignatureHelp.from(Me),id:je}}}reviveContext(G){let ee;if(G.activeSignatureHelp){const ne=y.SignatureHelp.to(G.activeSignatureHelp),ce=this._cache.get(G.activeSignatureHelp.id,0);ce?(ee=ce,ee.activeSignature=ne.activeSignature,ee.activeParameter=ne.activeParameter):ee=ne}return{...G,activeSignatureHelp:ee}}releaseSignatureHelp(G){this._cache.delete(G)}}class j{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlayHints(G,ee,ne){const ce=this._documents.getDocument(G),Z=await this._provider.provideInlayHints(ce,y.Range.to(ee),ne);return Z?{hints:Z.map(y.InlayHint.from)}:void 0}}class X{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("DocumentLink")}async provideLinks(G,ee){const ne=this._documents.getDocument(G),ce=await this._provider.provideDocumentLinks(ne,ee);if(!(!Array.isArray(ce)||ce.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ce.filter(X._validateLink).map(y.DocumentLink.from)};{const Z=this._cache.add(ce),re={links:[],id:Z};for(let pe=0;pe<ce.length;pe++){if(!X._validateLink(ce[pe]))continue;const Me=y.DocumentLink.from(ce[pe]);Me.cacheId=[Z,pe],re.links.push(Me)}return re}}}static _validateLink(G){return G.target&&G.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(G,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...G);if(!ne)return;const ce=await this._provider.resolveDocumentLink(ne,ee);if(!(!ce||!X._validateLink(ce)))return y.DocumentLink.from(ce)}releaseLinks(G){this._cache.delete(G)}}class Q{constructor(G,ee){this._documents=G,this._provider=ee}async provideColors(G,ee){const ne=this._documents.getDocument(G),ce=await this._provider.provideDocumentColors(ne,ee);return Array.isArray(ce)?ce.map(re=>({color:y.Color.from(re.color),range:y.Range.from(re.range)})):[]}async provideColorPresentations(G,ee,ne){const ce=this._documents.getDocument(G),Z=y.Range.to(ee.range),re=y.Color.to(ee.color),pe=await this._provider.provideColorPresentations(re,{document:ce,range:Z},ne);if(!!Array.isArray(pe))return pe.map(y.ColorPresentation.from)}}class de{constructor(G,ee){this._documents=G,this._provider=ee}async provideFoldingRanges(G,ee,ne){const ce=this._documents.getDocument(G),Z=await this._provider.provideFoldingRanges(ce,ee,ne);if(!!Array.isArray(Z))return Z.map(y.FoldingRange.from)}}class Se{constructor(G,ee,ne){this._documents=G,this._provider=ee,this._logService=ne}async provideSelectionRanges(G,ee,ne){const ce=this._documents.getDocument(G),Z=ee.map(y.Position.to),re=await this._provider.provideSelectionRanges(ce,Z,ne);if(!(0,D.isNonEmptyArray)(re))return[];if(re.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Me=0;Me<Z.length;Me++){const je=[];pe.push(je);let Ke=Z[Me],Ze=re[Me];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(y.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return pe}}class De{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,ne){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.prepareCallHierarchy(ce,Z,ne);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideCallsTo(G,ee,ne){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(ce,ne);if(!!Z)return Z.map(re=>({from:this._cacheAndConvertItem(G,re.from),fromRanges:re.fromRanges.map(pe=>y.Range.from(pe))}))}async provideCallsFrom(G,ee,ne){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(ce,ne);if(!!Z)return Z.map(re=>({to:this._cacheAndConvertItem(G,re.to),fromRanges:re.fromRanges.map(pe=>y.Range.from(pe))}))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const ne=this._cache.get(G),ce=y.CallHierarchyItem.from(ee,G,ne.size.toString(36));return ne.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Pe{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,ne){const ce=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.prepareTypeHierarchy(ce,Z,ne);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideSupertypes(G,ee,ne){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(ce,ne);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}async provideSubtypes(G,ee,ne){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(ce,ne);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const ne=this._cache.get(G),ce=y.TypeHierarchyItem.from(ee,G,ne.size.toString(36));return ne.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Be{constructor(G,ee){this.adapter=G,this.extension=ee}}class We{constructor(G,ee,ne,ce,Z,re,pe){this._adapter=new Map,this._uriTransformer=ee,this._proxy=G.getProxy(n.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=ce,this._diagnostics=Z,this._logService=re,this._apiDeprecation=pe}_transformDocumentSelector(G){return y.DocumentSelector.from(G,this._uriTransformer)}_createDisposable(G){return new C.Disposable(()=>{this._adapter.delete(G),this._proxy.$unregister(G)})}_nextHandle(){return We._handlePool++}_withAdapter(G,ee,ne,ce,Z=!1){const re=this._adapter.get(G);if(!re)return Promise.resolve(ce);if(re.adapter instanceof ee){let pe;re.extension&&(pe=Date.now(),this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=ne(re.adapter,re.extension),je=re.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-pe}ms`),Ke=>{Z&&Ke instanceof A.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(G,ee){const ne=this._nextHandle();return this._adapter.set(ne,new Be(G,ee)),ne}static _extLabel(G){return G.displayName||G.name}registerDocumentSymbolProvider(G,ee,ne,ce){const Z=this._addNewAdapter(new a(this._documents,ne),G),re=ce&&ce.label||We._extLabel(G);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),re),this._createDisposable(Z)}$provideDocumentSymbols(G,ee,ne){return this._withAdapter(G,a,ce=>ce.provideDocumentSymbols(m.URI.revive(ee),ne),void 0)}registerCodeLensProvider(G,ee,ne){const ce=this._nextHandle(),Z=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new r(this._documents,this._commands.converter,ne),G)),this._proxy.$registerCodeLensSupport(ce,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(ce);if(Z!==void 0){const pe=ne.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));re=C.Disposable.from(re,pe)}return re}$provideCodeLenses(G,ee,ne){return this._withAdapter(G,r,ce=>ce.provideCodeLenses(m.URI.revive(ee),ne),void 0)}$resolveCodeLens(G,ee,ne){return this._withAdapter(G,r,ce=>ce.resolveCodeLens(ee,ne),void 0)}$releaseCodeLenses(G,ee){this._withAdapter(G,r,ne=>Promise.resolve(ne.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(G,ee,ne){const ce=this._addNewAdapter(new s(this._documents,ne),G);return this._proxy.$registerDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDefinition(G,ee,ne,ce){return this._withAdapter(G,s,Z=>Z.provideDefinition(m.URI.revive(ee),ne,ce),[])}registerDeclarationProvider(G,ee,ne){const ce=this._addNewAdapter(new b(this._documents,ne),G);return this._proxy.$registerDeclarationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDeclaration(G,ee,ne,ce){return this._withAdapter(G,b,Z=>Z.provideDeclaration(m.URI.revive(ee),ne,ce),[])}registerImplementationProvider(G,ee,ne){const ce=this._addNewAdapter(new i(this._documents,ne),G);return this._proxy.$registerImplementationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideImplementation(G,ee,ne,ce){return this._withAdapter(G,i,Z=>Z.provideImplementation(m.URI.revive(ee),ne,ce),[])}registerTypeDefinitionProvider(G,ee,ne){const ce=this._addNewAdapter(new t(this._documents,ne),G);return this._proxy.$registerTypeDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideTypeDefinition(G,ee,ne,ce){return this._withAdapter(G,t,Z=>Z.provideTypeDefinition(m.URI.revive(ee),ne,ce),[])}registerHoverProvider(G,ee,ne,ce){const Z=this._addNewAdapter(new c(this._documents,ne),G);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(G,ee,ne,ce){return this._withAdapter(G,c,Z=>Z.provideHover(m.URI.revive(ee),ne,ce),void 0)}registerEvaluatableExpressionProvider(G,ee,ne,ce){const Z=this._addNewAdapter(new d(this._documents,ne),G);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(G,ee,ne,ce){return this._withAdapter(G,d,Z=>Z.provideEvaluatableExpression(m.URI.revive(ee),ne,ce),void 0)}registerInlineValuesProvider(G,ee,ne,ce){const Z=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new o(this._documents,ne),G);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(ee),Z);let pe=this._createDisposable(re);if(Z!==void 0){const Me=ne.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Z));pe=C.Disposable.from(pe,Me)}return pe}$provideInlineValues(G,ee,ne,ce,Z){return this._withAdapter(G,o,re=>re.provideInlineValues(m.URI.revive(ee),ne,ce,Z),void 0)}registerDocumentHighlightProvider(G,ee,ne){const ce=this._addNewAdapter(new f(this._documents,ne),G);return this._proxy.$registerDocumentHighlightProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentHighlights(G,ee,ne,ce){return this._withAdapter(G,f,Z=>Z.provideDocumentHighlights(m.URI.revive(ee),ne,ce),void 0)}registerLinkedEditingRangeProvider(G,ee,ne){const ce=this._addNewAdapter(new u(this._documents,ne),G);return this._proxy.$registerLinkedEditingRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideLinkedEditingRanges(G,ee,ne,ce){return this._withAdapter(G,u,async Z=>{const re=await Z.provideLinkedEditingRanges(m.URI.revive(ee),ne,ce);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?We._serializeRegExp(re.wordPattern):void 0}},void 0)}registerReferenceProvider(G,ee,ne){const ce=this._addNewAdapter(new E(this._documents,ne),G);return this._proxy.$registerReferenceSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideReferences(G,ee,ne,ce,Z){return this._withAdapter(G,E,re=>re.provideReferences(m.URI.revive(ee),ne,ce,Z),void 0)}registerCodeActionProvider(G,ee,ne,ce){const Z=new l.DisposableStore,re=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,G,this._apiDeprecation),G);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(ee),{providedKinds:ce?.providedCodeActionKinds?.map(pe=>pe.value),documentation:ce?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,Z)}))},We._extLabel(G),Boolean(ne.resolveCodeAction)),Z.add(this._createDisposable(re)),Z}$provideCodeActions(G,ee,ne,ce,Z){return this._withAdapter(G,T,re=>re.provideCodeActions(m.URI.revive(ee),ne,ce,Z),void 0)}$resolveCodeAction(G,ee,ne){return this._withAdapter(G,T,ce=>ce.resolveCodeAction(ee,ne),void 0)}$releaseCodeActions(G,ee){this._withAdapter(G,T,ne=>Promise.resolve(ne.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(G,ee,ne){const ce=this._addNewAdapter(new R(this._documents,ne),G);return this._proxy.$registerDocumentFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentFormattingEdits(G,ee,ne,ce){return this._withAdapter(G,R,Z=>Z.provideDocumentFormattingEdits(m.URI.revive(ee),ne,ce),void 0)}registerDocumentRangeFormattingEditProvider(G,ee,ne){const ce=this._addNewAdapter(new B(this._documents,ne),G);return this._proxy.$registerRangeFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentRangeFormattingEdits(G,ee,ne,ce,Z){return this._withAdapter(G,B,re=>re.provideDocumentRangeFormattingEdits(m.URI.revive(ee),ne,ce,Z),void 0)}registerOnTypeFormattingEditProvider(G,ee,ne,ce){const Z=this._addNewAdapter(new x(this._documents,ne),G);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),ce,G.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(G,ee,ne,ce,Z,re){return this._withAdapter(G,x,pe=>pe.provideOnTypeFormattingEdits(m.URI.revive(ee),ne,ce,Z,re),void 0)}registerWorkspaceSymbolProvider(G,ee){const ne=this._addNewAdapter(new F(ee,this._logService),G);return this._proxy.$registerNavigateTypeSupport(ne,typeof ee.resolveWorkspaceSymbol=="function"),this._createDisposable(ne)}$provideWorkspaceSymbols(G,ee,ne){return this._withAdapter(G,F,ce=>ce.provideWorkspaceSymbols(ee,ne),{symbols:[]})}$resolveWorkspaceSymbol(G,ee,ne){return this._withAdapter(G,F,ce=>ce.resolveWorkspaceSymbol(ee,ne),void 0)}$releaseWorkspaceSymbols(G,ee){this._withAdapter(G,F,ne=>ne.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(G,ee,ne){const ce=this._addNewAdapter(new $(this._documents,ne,this._logService),G);return this._proxy.$registerRenameSupport(ce,this._transformDocumentSelector(ee),$.supportsResolving(ne)),this._createDisposable(ce)}$provideRenameEdits(G,ee,ne,ce,Z){return this._withAdapter(G,$,re=>re.provideRenameEdits(m.URI.revive(ee),ne,ce,Z),void 0)}$resolveRenameLocation(G,ee,ne,ce){return this._withAdapter(G,$,Z=>Z.resolveRenameLocation(m.URI.revive(ee),ne,ce),void 0)}registerDocumentSemanticTokensProvider(G,ee,ne,ce){const Z=this._nextHandle(),re=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Be(new H(this._documents,ne),G)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce,re);let pe=this._createDisposable(Z);if(re){const Me=ne.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(re));pe=C.Disposable.from(pe,Me)}return pe}$provideDocumentSemanticTokens(G,ee,ne,ce){return this._withAdapter(G,H,Z=>Z.provideDocumentSemanticTokens(m.URI.revive(ee),ne,ce),null,!0)}$releaseDocumentSemanticTokens(G,ee){this._withAdapter(G,H,ne=>ne.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(G,ee,ne,ce){const Z=this._addNewAdapter(new N(this._documents,ne),G);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(G,ee,ne,ce){return this._withAdapter(G,N,Z=>Z.provideDocumentRangeSemanticTokens(m.URI.revive(ee),ne,ce),null,!0)}registerCompletionItemProvider(G,ee,ne,ce){const Z=this._addNewAdapter(new U(this._documents,this._commands.converter,ne,this._apiDeprecation,G),G);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),ce,U.supportsResolving(ne),`${G.identifier.value}(${ce.join("")})`),this._createDisposable(Z)}$provideCompletionItems(G,ee,ne,ce,Z){return this._withAdapter(G,U,re=>re.provideCompletionItems(m.URI.revive(ee),ne,ce,Z),void 0)}$resolveCompletionItem(G,ee,ne){return this._withAdapter(G,U,ce=>ce.resolveCompletionItem(ee,ne),void 0)}$releaseCompletionItems(G,ee){this._withAdapter(G,U,ne=>ne.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(G,ee,ne){const ce=this._addNewAdapter(new V(this._documents,ne,this._commands.converter),G);return this._proxy.$registerInlineCompletionsSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideInlineCompletions(G,ee,ne,ce,Z){return this._withAdapter(G,V,re=>re.provideInlineCompletions(m.URI.revive(ee),ne,ce,Z),void 0)}$handleInlineCompletionDidShow(G,ee,ne){this._withAdapter(G,V,async ce=>{ce.handleDidShowCompletionItem(ee,ne)},void 0)}$freeInlineCompletionsList(G,ee){this._withAdapter(G,V,async ne=>{ne.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(G,ee,ne,ce){const Z=Array.isArray(ce)?{triggerCharacters:ce,retriggerCharacters:[]}:ce,re=this._addNewAdapter(new W(this._documents,ne),G);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(ee),Z),this._createDisposable(re)}$provideSignatureHelp(G,ee,ne,ce,Z){return this._withAdapter(G,W,re=>re.provideSignatureHelp(m.URI.revive(ee),ne,ce,Z),void 0)}$releaseSignatureHelp(G,ee){this._withAdapter(G,W,ne=>ne.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(G,ee,ne){const ce=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new j(this._documents,ne),G);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),ce);let re=this._createDisposable(Z);if(ce!==void 0){const pe=ne.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ce));re=C.Disposable.from(re,pe)}return re}$provideInlayHints(G,ee,ne,ce){return this._withAdapter(G,j,Z=>Z.provideInlayHints(m.URI.revive(ee),ne,ce),void 0)}registerDocumentLinkProvider(G,ee,ne){const ce=this._addNewAdapter(new X(this._documents,ne),G);return this._proxy.$registerDocumentLinkProvider(ce,this._transformDocumentSelector(ee),typeof ne.resolveDocumentLink=="function"),this._createDisposable(ce)}$provideDocumentLinks(G,ee,ne){return this._withAdapter(G,X,ce=>ce.provideLinks(m.URI.revive(ee),ne),void 0)}$resolveDocumentLink(G,ee,ne){return this._withAdapter(G,X,ce=>ce.resolveLink(ee,ne),void 0)}$releaseDocumentLinks(G,ee){this._withAdapter(G,X,ne=>ne.releaseLinks(ee),void 0)}registerColorProvider(G,ee,ne){const ce=this._addNewAdapter(new Q(this._documents,ne),G);return this._proxy.$registerDocumentColorProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentColors(G,ee,ne){return this._withAdapter(G,Q,ce=>ce.provideColors(m.URI.revive(ee),ne),[])}$provideColorPresentations(G,ee,ne,ce){return this._withAdapter(G,Q,Z=>Z.provideColorPresentations(m.URI.revive(ee),ne,ce),void 0)}registerFoldingRangeProvider(G,ee,ne){const ce=this._nextHandle(),Z=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ce,new Be(new de(this._documents,ne),G)),this._proxy.$registerFoldingRangeProvider(ce,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(ce);if(Z!==void 0){const pe=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));re=C.Disposable.from(re,pe)}return re}$provideFoldingRanges(G,ee,ne,ce){return this._withAdapter(G,de,Z=>Z.provideFoldingRanges(m.URI.revive(ee),ne,ce),void 0)}registerSelectionRangeProvider(G,ee,ne){const ce=this._addNewAdapter(new Se(this._documents,ne,this._logService),G);return this._proxy.$registerSelectionRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideSelectionRanges(G,ee,ne,ce){return this._withAdapter(G,Se,Z=>Z.provideSelectionRanges(m.URI.revive(ee),ne,ce),[])}registerCallHierarchyProvider(G,ee,ne){const ce=this._addNewAdapter(new De(this._documents,ne),G);return this._proxy.$registerCallHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareCallHierarchy(G,ee,ne,ce){return this._withAdapter(G,De,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),ne,ce)),void 0)}$provideCallHierarchyIncomingCalls(G,ee,ne,ce){return this._withAdapter(G,De,Z=>Z.provideCallsTo(ee,ne,ce),void 0)}$provideCallHierarchyOutgoingCalls(G,ee,ne,ce){return this._withAdapter(G,De,Z=>Z.provideCallsFrom(ee,ne,ce),void 0)}$releaseCallHierarchy(G,ee){this._withAdapter(G,De,ne=>Promise.resolve(ne.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(G,ee,ne){const ce=this._addNewAdapter(new Pe(this._documents,ne),G);return this._proxy.$registerTypeHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareTypeHierarchy(G,ee,ne,ce){return this._withAdapter(G,Pe,Z=>Promise.resolve(Z.prepareSession(m.URI.revive(ee),ne,ce)),void 0)}$provideTypeHierarchySupertypes(G,ee,ne,ce){return this._withAdapter(G,Pe,Z=>Z.provideSupertypes(ee,ne,ce),void 0)}$provideTypeHierarchySubtypes(G,ee,ne,ce){return this._withAdapter(G,Pe,Z=>Z.provideSubtypes(ee,ne,ce),void 0)}$releaseTypeHierarchy(G,ee){this._withAdapter(G,Pe,ne=>Promise.resolve(ne.releaseSession(ee)),void 0)}static _serializeRegExp(G){return{pattern:G.source,flags:(0,k.regExpFlags)(G)}}static _serializeIndentationRule(G){return{decreaseIndentPattern:We._serializeRegExp(G.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(G.increaseIndentPattern),indentNextLinePattern:G.indentNextLinePattern?We._serializeRegExp(G.indentNextLinePattern):void 0,unIndentedLinePattern:G.unIndentedLinePattern?We._serializeRegExp(G.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(G){return{beforeText:We._serializeRegExp(G.beforeText),afterText:G.afterText?We._serializeRegExp(G.afterText):void 0,previousLineText:G.previousLineText?We._serializeRegExp(G.previousLineText):void 0,action:G.action}}static _serializeOnEnterRules(G){return G.map(We._serializeOnEnterRule)}setLanguageConfiguration(G,ee,ne){let{wordPattern:ce}=ne;if(ce&&(0,k.regExpLeadsToEndlessLoop)(ce))throw new Error(`Invalid language configuration: wordPattern '${ce}' is not allowed to match the empty string.`);ce?this._documents.setWordDefinitionFor(ee,ce):this._documents.setWordDefinitionFor(ee,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",G,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",G,"Do not use.");const Z=this._nextHandle(),re={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?We._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?We._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?We._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,re),this._createDisposable(Z)}$setWordDefinitions(G){for(const ee of G)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(fe[241],me([0,1,5,15,7,49,18,6]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(P,I,l,v){this._documents=I,this._commands=l,this._uriTransformer=v,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=P.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(P){this._languageIds=P}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(P,I){await this._proxy.$changeLanguage(P,I);const l=this._documents.getDocumentData(P);if(!l)throw new Error(`document '${P.toString}' NOT found`);return l.document}async tokenAtPosition(P,I){const l=P.version,v=L.Position.from(I),h=await this._proxy.$tokensAtPosition(P.uri,v),w={type:y.StandardTokenType.Other,range:P.getWordRangeAtPosition(I)??new y.Range(I.line,I.character,I.line,I.character)};if(!h)return w;const S={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!S.range.contains(I)||l!==P.version?w:S}createLanguageStatusItem(P,I,l){const v=this._handlePool++,h=this._proxy,w=this._ids,S=`${P.identifier.value}/${I}`;if(w.has(S))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);w.add(S);const A={selector:l,id:I,name:P.displayName??P.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let p,a=new k.DisposableStore;const r=()=>{p?.dispose(),p=(0,n.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(v,{id:S,name:A.name??P.displayName??P.name,source:P.displayName??P.name,selector:L.DocumentSelector.from(A.selector,this._uriTransformer),label:A.text,detail:A.detail??"",severity:A.severity===y.LanguageStatusSeverity.Error?C.default.Error:A.severity===y.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:A.command&&this._commands.toInternal(A.command,a),accessibilityInfo:A.accessibilityInformation})},0)},g={dispose(){a.dispose(),p?.dispose(),h.$removeLanguageStatus(v),w.delete(S)},get id(){return A.id},get name(){return A.name},set name(s){A.name=s,r()},get selector(){return A.selector},set selector(s){A.selector=s,r()},get text(){return A.text},set text(s){A.text=s,r()},get detail(){return A.detail},set detail(s){A.detail=s,r()},get severity(){return A.severity},set severity(s){A.severity=s,r()},get accessibilityInformation(){return A.accessibilityInformation},set accessibilityInformation(s){A.accessibilityInformation=s,r()},get command(){return A.command},set command(s){A.command=s,r()}};return r(),g}}e.ExtHostLanguages=_}),define(fe[131],me([0,1,11,5,26,14,3]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends m.AbstractLoggerService{constructor(P,I){const l=new n.Emitter;super(I.logLevel,l.event);this._proxy=P.getProxy(L.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(l)}$setLevel(P){this._onDidChangeLogLevel.fire(P)}doCreateLogger(P,I,l){return new _(this._proxy,P,I,l)}};k=Ve([$e(0,C.IExtHostRpcService),$e(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class _ extends m.AbstractMessageLogger{constructor(P,I,l,v){super(v?.always);this.proxy=P,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.proxy.$createLogger(I,v).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(P,I){const l=[[P,I]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(P){this.proxy.$log(this.file,P)}}}),define(fe[242],me([0,1,5,11,29]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let n=class{constructor(_,D){this._logService=D,this._proxy=_.getProxy(m.MainContext.MainThreadMessageService)}showMessage(_,D,P,I,l){const v={extension:_};let h;typeof I=="string"||C(I)?h=[I,...l]:(v.modal=I?.modal,v.useCustom=I?.useCustom,v.detail=I?.detail,h=l),v.useCustom&&(0,y.checkProposedApiEnabled)(_,"resolvers");const w=[];for(let S=0;S<h.length;S++){const A=h[S];if(typeof A=="string")w.push({title:A,handle:S,isCloseAffordance:!1});else if(typeof A=="object"){let{title:p,isCloseAffordance:a}=A;w.push({title:p,isCloseAffordance:!!a,handle:S})}else this._logService.warn("Invalid message item:",A)}return this._proxy.$showMessage(D,P,v,w).then(S=>{if(typeof S=="number")return h[S]})}};n=Ve([$e(1,L.ILogService)],n),e.ExtHostMessageService=n}),define(fe[243],me([0,1,22,3,48,6,24,8,13,2,88,5,15,7,53,218,128]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class A{constructor(a,r,g,s,b){this._textDocumentsAndEditors=g,this._textDocuments=s,this._extensionStoragePaths=b,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new n.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=r.converter,r.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===12){const t=i.notebookEditor?.notebookUri,c=i.cell.handle,o=this._documents.get(t)?.getCell(c);if(o)return o.apiCell}return i}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const r=this._editors.get(a);if(!r)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return r}getIdByEditor(a){for(const[r,g]of this._editors)if(g.apiEditor===a)return r}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,r){const g=this._documents.get(a);if(!g&&!r)throw new Error(`NO notebook document for '${a}'`);return g}_getProviderData(a){const r=this._notebookContentProviders.get(a);if(!r)throw new Error(`NO provider for '${a}'`);return r}registerNotebookContentProvider(a,r,g,s,b){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(r))throw new Error(`Notebook provider for '${r}' already registered`);this._notebookContentProviders.set(r,{extension:a,provider:g});let i;return g.onDidChangeNotebookContentOptions&&(i=g.onDidChangeNotebookContentOptions(()=>{const t=l.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(r,t)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},r,l.NotebookDocumentContentOptions.from(s),A._convertNotebookRegistrationData(a,b)),new v.Disposable(()=>{i?.dispose(),this._notebookContentProviders.delete(r),this._notebookProxy.$unregisterNotebookProvider(r)})}static _convertNotebookRegistrationData(a,r){if(!r)return;const g=r.filenamePattern.map(s=>l.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(r.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${r.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:r.displayName,filenamePattern:g,exclusive:r.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,r,g){const s=A._notebookStatusBarItemProviderHandlePool++,b=typeof g.onDidChangeCellStatusBarItems=="function"?A._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,b,r);let i;return b!==void 0&&(i=g.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(b))),new v.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,b),i&&i.dispose()})}async createNotebookDocument(a){const r=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&l.NotebookData.from(a.content)});return D.URI.revive(r)}async openNotebookDocument(a){const r=this._documents.get(a);if(r)return r.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(a),s=this._documents.get(D.URI.revive(g));return(0,_.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(a,r){D.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let g;typeof r=="object"?g={position:l.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus,selections:r.selections&&r.selections.map(l.NotebookRange.from),pinned:typeof r.preview=="boolean"?!r.preview:void 0}:g={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,g),b=s&&this._editors.get(s)?.apiEditor;if(b)return b;throw s?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,r,g,s){const b=this._notebookStatusBarItemProviders.get(a),i=D.URI.revive(r),t=this._documents.get(i);if(!t||!b)return;const c=t.getCellFromIndex(g);if(!c)return;const d=await b.provideCellStatusBarItems(c.apiCell,s);if(!d)return;const o=new C.DisposableStore,f=this._statusBarCache.add([o]),E=(Array.isArray(d)?d:[d]).map(T=>l.NotebookStatusBarItem.from(T,this._commandsConverter,o));return{cacheId:f,items:E}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,r,g,s,b){if((0,k.isFalsyOrWhitespace)(r))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,g),this._notebookProxy.$registerNotebookSerializer(i,{id:a.identifier,location:a.extensionLocation},r,l.NotebookDocumentContentOptions.from(s),A._convertNotebookRegistrationData(a,b)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(a,r,g){const s=this._notebookSerializer.get(a);if(!s)throw new Error("NO serializer found");const b=await s.deserializeNotebook(r.buffer,g);return new h.SerializableObjectWithBuffers(l.NotebookData.from(b))}async $notebookToData(a,r,g){const s=this._notebookSerializer.get(a);if(!s)throw new Error("NO serializer found");const b=await s.serializeNotebook(l.NotebookData.to(r.value),g);return m.VSBuffer.wrap(b)}async $openNotebook(a,r,g,s,b){const{provider:i}=this._getProviderData(a),t=await i.openNotebook(D.URI.revive(r),{backupId:g,untitledDocumentData:s?.buffer},b);return new h.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(l.NotebookCellData.from)})}async $saveNotebook(a,r,g){const s=this.getNotebookDocument(D.URI.revive(r)),{provider:b}=this._getProviderData(a);return await b.saveNotebook(s.apiNotebook,g),!0}async $saveNotebookAs(a,r,g,s){const b=this.getNotebookDocument(D.URI.revive(r)),{provider:i}=this._getProviderData(a);return await i.saveNotebookAs(D.URI.revive(g),b.apiNotebook,s),!0}async $backupNotebook(a,r,g){const s=this.getNotebookDocument(D.URI.revive(r)),b=this._getProviderData(a),i=this._extensionStoragePaths.workspaceValue(b.extension)??this._extensionStoragePaths.globalValue(b.extension),t=String((0,y.hash)([s.uri.toString(),this._backupIdPool++])),c=D.URI.joinPath(i,t),d=await b.provider.backupNotebook(s.apiNotebook,{destination:c},g);return s.updateBackup(d),d.id}_createExtHostEditor(a,r,g){if(this._editors.has(r))throw new Error(`editor with id ALREADY EXSIST: ${r}`);const s=new S.ExtHostNotebookEditor(r,this._notebookEditorsProxy,a,g.visibleRanges.map(l.NotebookRange.to),g.selections.map(l.NotebookRange.to),typeof g.viewColumn=="number"?l.ViewColumn.to(g.viewColumn):void 0);this._editors.set(r,s)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const g of a.value.removedDocuments){const s=D.URI.revive(g),b=this._documents.get(s);b&&(b.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===s.toString()&&this._editors.delete(i.id)}if(a.value.addedDocuments){const g=[];for(const s of a.value.addedDocuments){const b=D.URI.revive(s.uri);if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const i=this,t=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(c){i._onDidChangeNotebookCells.fire(c)},emitCellOutputsChange(c){i._onDidChangeCellOutputs.fire(c)},emitCellMetadataChange(c){i._onDidChangeCellMetadata.fire(c)},emitCellExecutionStateChange(c){i._onDidChangeCellExecutionState.fire(c)}},b,s);g.push(...s.cells.map(c=>w.ExtHostCell.asModelAddData(t.apiNotebook,c))),this._documents.get(b)?.dispose(),this._documents.set(b,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(a.value.addedEditors)for(const g of a.value.addedEditors){if(this._editors.has(g.id))return;const s=D.URI.revive(g.documentUri),b=this._documents.get(s);b&&this._createExtHostEditor(b,g.id,g)}const r=[];if(a.value.removedEditors)for(const g of a.value.removedEditors){const s=this._editors.get(g);s&&(this._editors.delete(g),this._activeNotebookEditor?.id===s.id&&(this._activeNotebookEditor=void 0),r.push(s))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const g=new Set;this._visibleNotebookEditors.forEach(s=>g.add(s.id));for(const s of this._editors.values()){const b=g.has(s.id);s._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=A,A._notebookStatusBarItemProviderHandlePool=0}),define(fe[244],me([0,1,3,75,11,5,14,15]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(I,l){const v=_._Keys.nextId();I.$registerNotebookEditorDecorationType(v,k.NotebookDecorationRenderOptions.from(l)),this.value={key:v,dispose(){I.$removeNotebookEditorDecorationType(v)}}}}_._Keys=new L.IdGenerator("NotebookEditorDecorationType");let D=class{constructor(I,l,v){this._logService=I,this._extHostRpc=l,this._notebooksAndEditors=v,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new _(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,l);const v=this._notebooksAndEditors.getEditorById(I);l.visibleRanges&&v._acceptVisibleRanges(l.visibleRanges.ranges.map(k.NotebookRange.to)),l.selections&&v._acceptSelections(l.selections.selections.map(k.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:v.apiEditor,visibleRanges:v.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:v.apiEditor,selections:v.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const l in I)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(k.ViewColumn.to(I[l]))}};D=Ve([$e(0,y.ILogService),$e(1,n.IExtHostRpcService)],D),e.ExtHostNotebookEditors=D}),define(fe[245],me([0,1,17,18,21,3,6,24,2,27,11,5,39,15,7,89,210,29,53]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(i,t,c,d,o){this._initData=t,this._extHostNotebook=c,this._commands=d,this._logService=o,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=i.getProxy(I.MainContext.MainThreadNotebookKernels);const f=new l.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.ApiCommandArgument("options","Select kernel options",u=>!0,u=>{if(u&&"notebookEditor"in u&&"id"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);return{id:u.id,extension:u.extension,notebookEditorId:E}}else if(u&&"notebookEditor"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${u.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return u})],l.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(i,t,c,d,o,f){for(let W of this._kernelData.values())if(W.controller.id===t&&D.ExtensionIdentifier.equals(i.identifier,W.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const u=this._handlePool++,E=this;this._logService.trace(`NotebookController[${u}], CREATED by ${i.identifier.value}, ${t}`);const T=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${i.identifier}'`);let R=!1;const B=new n.DisposableStore,x=new C.Emitter,F=new C.Emitter,$={id:`${i.identifier.value}/${t}`,notebookType:c,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:d||i.identifier.value,preloads:f?f.map(v.NotebookRendererScript.from):[]};let M=o??T,H;this._proxy.$addKernel(u,$).catch(W=>{console.log(W),R=!0});let N=0;const U=()=>{if(R)return;const W=++N;Promise.resolve().then(()=>{W===N&&this._proxy.$updateKernel(u,$)})},V=new k.ResourceMap,O={get id(){return t},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return $.label},set label(W){$.label=W??i.displayName??i.name,U()},get detail(){return $.detail??""},set detail(W){$.detail=W,U()},get description(){return $.description??""},set description(W){$.description=W,U()},get kind(){return(0,A.checkProposedApiEnabled)(i,"notebookControllerKind"),$.kind??""},set kind(W){(0,A.checkProposedApiEnabled)(i,"notebookControllerKind"),$.kind=W,U()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(W){$.supportedLanguages=W,U()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(W){$.supportsExecutionOrder=W,U()},get rendererScripts(){return $.preloads?$.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(W){M=W??T},get interruptHandler(){return H},set interruptHandler(W){H=W,$.supportsInterrupt=Boolean(W),U()},createNotebookCellExecution(W){if(R)throw new Error("notebook controller is DISPOSED");if(!V.has(W.notebook.uri))throw E._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${W.notebook.uri.toString()}`);return E._createNotebookCellExecution(W)},dispose:()=>{R||(this._logService.trace(`NotebookController[${u}], DISPOSED`),R=!0,this._kernelData.delete(u),B.dispose(),x.dispose(),F.dispose(),this._proxy.$removeKernel(u))},updateNotebookAffinity(W,j){E._proxy.$updateNotebookPriority(u,W.uri,j)},onDidReceiveMessage:F.event,postMessage(W,j){return(0,A.checkProposedApiEnabled)(i,"notebookMessaging"),E._proxy.$postMessage(u,j&&E._extHostNotebook.getIdByEditor(j),W)},asWebviewUri(W){return(0,A.checkProposedApiEnabled)(i,"notebookMessaging"),(0,w.asWebviewUri)(W,E._initData.remote)}};return this._kernelData.set(u,{extensionId:i.identifier,controller:O,onDidReceiveMessage:F,onDidChangeSelection:x,associatedNotebooks:V}),O}$acceptNotebookAssociation(i,t,c){const d=this._kernelData.get(i);if(d){const o=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));c?d.associatedNotebooks.set(o.uri,!0):d.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,o.uri.toString(),c),d.onDidChangeSelection.fire({selected:c,notebook:o.apiNotebook})}}async $executeCells(i,t,c){const d=this._kernelData.get(i);if(!d)return;const o=this._extHostNotebook.getNotebookDocument(_.URI.revive(t)),f=[];for(let u of c){const E=o.getCell(u);E&&f.push(E.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,o.uri.toString(),f.length),await d.controller.executeHandler.call(d.controller,f,o.apiNotebook,d.controller)}catch(u){this._logService.error(`NotebookController[${i}] execute cells FAILED`,u),console.error(u)}}async $cancelCells(i,t,c){const d=this._kernelData.get(i);if(!d)return;const o=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,o.apiNotebook);else for(let f of c){const u=o.getCell(f);u&&this._activeExecutions.get(u.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,t,c){const d=this._kernelData.get(i);if(!d)return;const o=this._extHostNotebook.getEditorById(t);d.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:c}))}_createNotebookCellExecution(i){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const d=new g(c.notebook,c,this._proxy);this._activeExecutions.set(c.uri,d);const o=d.onDidChangeState(()=>{d.state===r.Resolved&&(d.dispose(),o.dispose(),this._activeExecutions.delete(c.uri))});return d.asApiObject()}};a=Ve([$e(4,P.ILogService)],a),e.ExtHostNotebookKernels=a;var r;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(r||(r={}));class g extends n.Disposable{constructor(i,t,c){super();this._document=i,this._cell=t,this._proxy=c,this._handle=g.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=r.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new s(10,d=>this.update(d)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const t=Array.isArray(i)?i:[i];return this._proxy.$updateExecutions(new p.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===r.Init)throw new Error("Must call start before modifying cell output");if(this._state===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let t=this._cell;if(i&&(t=this._document.getCellFromApiCell(i)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(i){return i.map(t=>{const c=h.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return c===t.items?v.NotebookCellOutput.from(t):v.NotebookCellOutput.from({items:c,id:t.id,metadata:t.metadata})})}async updateOutputs(i,t,c){const d=this.cellIndexToHandle(t),o=this.validateAndConvertOutputs((0,m.asArray)(i));return this.updateSoon({editType:S.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:d,append:c,outputs:o})}async updateOutputItems(i,t,c){return i=h.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(i),!0),this.updateSoon({editType:S.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:i.map(v.NotebookCellOutputItem.from),outputId:t.id,append:c})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(c){i._executionOrder=c,i.update([{editType:S.CellExecutionUpdateType.ExecutionState,executionHandle:i._handle,executionOrder:i._executionOrder}])},start(c){if(i._state===r.Resolved||i._state===r.Started)throw new Error("Cannot call start again");i._state=r.Started,i._onDidChangeState.fire(),i.update({editType:S.CellExecutionUpdateType.ExecutionState,executionHandle:i._handle,runStartTime:c})},end(c,d){if(i._state===r.Resolved)throw new Error("Cannot call resolve twice");i._state=r.Resolved,i._onDidChangeState.fire(),i.updateSoon({editType:S.CellExecutionUpdateType.Complete,executionHandle:i._handle,runEndTime:d,lastRunSuccess:c}),i._collector.flush(),i._proxy.$removeExecution(i._handle)},clearOutput(c){return i.verifyStateForOutput(),i.updateOutputs([],c,!1)},appendOutput(c,d){return i.verifyStateForOutput(),i.updateOutputs(c,d,!0)},replaceOutput(c,d){return i.verifyStateForOutput(),i.updateOutputs(c,d,!1)},appendOutputItems(c,d){return i.verifyStateForOutput(),i.updateOutputItems(c,d,!0)},replaceOutputItems(c,d){return i.verifyStateForOutput(),i.updateOutputItems(c,d,!1)}})}}g.HANDLE=0;class s{constructor(i,t){this.delay=i,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>i.complete())}}}),define(fe[246],me([0,1,3,5,128,29]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class n{constructor(_,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,D,P){const I=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(D)?.fire({editor:I.apiEditor,message:P})}createRendererMessaging(_,D){if(!_.contributes?.notebookRenderer?.some(v=>v.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const P=(0,C.isProposedApiEnabled)(_,"notebookEditor"),I=new WeakMap;return{onDidReceiveMessage:(v,h,w)=>{const S=P?v:A=>{const p={};I.set(p,A.editor),v({editor:p,message:A.message})};return this.getOrCreateEmitterFor(D).event(S,h,w)},postMessage:(v,h)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(v)&&([v,h]=[h,v]);const w=P?h:I.get(h),S=w&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(S?.id,D,v)}}}getOrCreateEmitterFor(_){let D=this._rendererMessageEmitters.get(_);return D||(D=new m.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,D),D)}}e.ExtHostNotebookRenderers=n}),define(fe[132],me([0,1,5,6,4,14,11,211,66,26,45,151,22]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class v extends L.Disposable{constructor(S,A,p,a){super();this.id=S,this.name=A,this.logger=p,this.proxy=a,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(S){this.append(S+`
`)}append(S){this.write(S),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const S=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,S)}replace(S){const A=this.offset;this.write(S),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,A),this.visible&&this.logger.flush()}show(S,A){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof S=="boolean"?S:A))}hide(){this.proxy.$close(this.id)}write(S){this.offset+=l.VSBuffer.fromString(S).byteLength,this.logger.info(S)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=v;let h=class{constructor(S,A,p,a,r){this.extHostFileSystem=p,this.extHostFileSystemInfo=a,this.loggerService=r,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=S.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(A.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(S){this.visibleChannelId=S;for(const[A,p]of this.channels)p.visible=A===this.visibleChannelId}createOutputChannel(S,A){if(S=S.trim(),!S)throw new Error("illegal argument `name`. must not be falsy");const p=this.doCreateOutputChannel(S,A);return p.then(a=>{this.channels.set(a.id,a),a.visible=a.id===this.visibleChannelId}),this.createExtHostOutputChannel(S,p)}async doCreateOutputChannel(S,A){const p=await this.createOutputDirectory(),a=this.extHostFileSystemInfo.extUri.joinPath(p,`${this.namePool++}-${S.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.loggerService.createLogger(a,{always:!0,donotRotate:!0,donotUseFormatters:!0}),g=await this.proxy.$register(S,!1,a,A.identifier.value);return new v(g,S,r,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(S,A){let p=!1;const a=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return S},append(r){a(),A.then(g=>g.append(r))},appendLine(r){a(),A.then(g=>g.appendLine(r))},clear(){a(),A.then(r=>r.clear())},replace(r){a(),A.then(g=>g.replace(r))},show(r,g){a(),A.then(s=>s.show(r,g))},hide(){a(),A.then(r=>r.hide())},dispose(){p=!0,A.then(r=>r.dispose())}}}};h=Ve([$e(0,C.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,_.IExtHostConsumerFileSystem),$e(3,P.IExtHostFileSystemInfo),$e(4,n.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(fe[247],me([0,1,18,21,3,6,5,2,7,16,17,49,87,29]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(w,S,A){const p=w.getProxy(n.MainContext.MainThreadQuickOpen);class a{constructor(o,f){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=f}showQuickPick(o,f,u=L.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(o),T=++this._instances,R=p.$show(T,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},u),B={},x=R.then(()=>B);return Promise.race([x,E]).then(F=>{if(F!==B)return E.then($=>{const M=[];for(let H=0;H<$.length;H++){const N=$[H];typeof N=="string"?M.push({label:N,handle:H}):N.kind===_.QuickPickItemKind.Separator?M.push({type:"separator",label:N.label}):M.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:H})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{f.onDidSelectItem($[H])}),p.$setItems(T,M),R.then(H=>{if(typeof H=="number")return $[H];if(Array.isArray(H))return H.map(N=>$[N])})})}).then(void 0,F=>{if(!(0,D.isPromiseCanceledError)(F))return p.$setError(T,F),Promise.reject(F)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,f=L.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,p.$input(o,typeof this._validateInput=="function",f).then(void 0,u=>{if(!(0,D.isPromiseCanceledError)(u))return Promise.reject(u)})}$validateInput(o){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,f=L.CancellationToken.None){const u=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!u)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(T=>T.uri.toString()===u.uri.toString())}createQuickPick(o){const f=new t(o,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(o){const f=new c(o,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(o,f){const u=this._sessions.get(o);u&&u._fireDidChangeValue(f)}$onDidAccept(o){const f=this._sessions.get(o);f&&f._fireDidAccept()}$onDidChangeActive(o,f){const u=this._sessions.get(o);u instanceof t&&u._fireDidChangeActive(f)}$onDidChangeSelection(o,f){const u=this._sessions.get(o);u instanceof t&&u._fireDidChangeSelection(f)}$onDidTriggerButton(o,f){const u=this._sessions.get(o);u&&u._fireDidTriggerButton(f)}$onDidTriggerItemButton(o,f,u){const E=this._sessions.get(o);E instanceof t&&E._fireDidTriggerItemButton(f,u)}$onDidHide(o){const f=this._sessions.get(o);f&&f._fireDidHide()}}class r{constructor(o,f){this._extensionId=o,this._onDidDispose=f,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((f,u)=>{const E=f===_.QuickInputButtons.Back?-1:u;this._handlesToButtons.set(E,f)}),this.update({buttons:o.map((f,u)=>({...i(f),tooltip:f.tooltip,handle:f===_.QuickInputButtons.Back?-1:u}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const f=this._handlesToButtons.get(o);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(o){if(!this._disposed){for(const f of Object.keys(o)){const u=o[f];this._pendingUpdate[f]=u===void 0?null:u}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}r._nextId=1;function g(d){if(d instanceof _.ThemeIcon)return{id:d.id};const o=b(d),f=s(d);return{dark:typeof o=="string"?k.URI.file(o):o,light:typeof f=="string"?k.URI.file(f):f}}function s(d){return typeof d=="object"&&"light"in d?d.light:d}function b(d){return typeof d=="object"&&"dark"in d?d.dark:d}function i(d){const o=g(d.iconPath);let f,u;return"id"in o?u=l.ThemeIcon.asClassName(o):f=o,{iconPath:f,iconClass:u}}class t extends r{constructor(o,f){super(o.identifier,f);this.extension=o,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){o.some(u=>u.kind!==void 0)&&(0,v.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((u,E)=>{this._handlesToItems.set(E,u),this._itemsToHandles.set(u,E)});const f=[];for(let u=0;u<o.length;u++){const E=o[u];E.kind===_.QuickPickItemKind.Separator?f.push({type:"separator",label:E.label}):f.push({handle:u,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((T,R)=>({...i(T),tooltip:T.tooltip,handle:R}))})}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(o){const f=(0,P.coalesce)(o.map(u=>this._handlesToItems.get(u)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(o){const f=(0,P.coalesce)(o.map(u=>this._handlesToItems.get(u)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(o,f){const u=this._handlesToItems.get(o);if(!u||!u.buttons||!u.buttons.length)return;const E=u.buttons[f];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:u})}}class c extends r{constructor(o,f){super(o,f);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?I.default.Error:I.default.Ignore})}}return new a(S,A)}e.createExtHostQuickOpen=h}),define(fe[248],me([0,1,2,3,57,6,18,5,17,100,11,27,87,15,29]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function w(d){if(d)return typeof d.iconPath=="string"?m.URI.file(d.iconPath):m.URI.isUri(d.iconPath)||l.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function S(d,o){if(!d.iconPath&&!o.iconPath)return 0;if(d.iconPath){if(!o.iconPath)return 1}else return-1;const f=typeof d.iconPath=="string"?d.iconPath:m.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,u=typeof o.iconPath=="string"?o.iconPath:m.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id;return(0,D.comparePaths)(f,u)}function A(d,o){let f=0;if(d.strikeThrough!==o.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==o.faded)return d.faded?1:-1;if(d.tooltip!==o.tooltip)return(d.tooltip||"").localeCompare(o.tooltip||"");if(f=S(d,o),f!==0)return f;if(d.light&&o.light)f=S(d.light,o.light);else{if(d.light)return 1;if(o.light)return-1}if(f!==0)return f;if(d.dark&&o.dark)f=S(d.dark,o.dark);else{if(d.dark)return 1;if(o.dark)return-1}return f}function p(d,o){if(d.command!==o.command)return d.command<o.command?-1:1;if(d.title!==o.title)return d.title<o.title?-1:1;if(d.tooltip!==o.tooltip){if(d.tooltip!==void 0&&o.tooltip!==void 0)return d.tooltip<o.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(d.arguments===o.arguments)return 0;if(d.arguments)if(o.arguments){if(d.arguments.length!==o.arguments.length)return d.arguments.length-o.arguments.length}else return 1;else return-1;for(let f=0;f<d.arguments.length;f++){const u=d.arguments[f],E=o.arguments[f];if(u!==E)return u<E?-1:1}return 0}function a(d,o){let f=(0,D.comparePaths)(d.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(f!==0)return f;if(d.command&&o.command)f=p(d.command,o.command);else{if(d.command)return 1;if(o.command)return-1}if(f!==0)return f;if(d.decorations&&o.decorations)f=A(d.decorations,o.decorations);else{if(d.decorations)return 1;if(o.decorations)return-1}return f}function r(d,o){for(let f=0;f<d.length;f++)if(d[f]!==o[f])return!1;return!0}function g(d,o){return d.command===o.command&&d.title===o.title&&d.tooltip===o.tooltip&&(d.arguments&&o.arguments?r(d.arguments,o.arguments):d.arguments===o.arguments)}function s(d,o){return(0,_.equals)(d,o,g)}class b{constructor(o,f,u){this._extension=o,this._proxy=f,this._sourceControlHandle=u,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(o){if((0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}showValidationMessage(o,f){(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,o,f)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=b;class i{constructor(o,f,u,E,T){this._proxy=o,this._commands=f,this._sourceControlHandle=u,this._id=E,this._label=T,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=i._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,f){const u=this._resourceStatesCommandsMap.get(o);return u?(0,n.asPromise)(()=>this._commands.executeCommand(u.command,...u.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const o=[...this._resourceStates].sort(a),u=(0,_.sortedDiff)(this._resourceSnapshot,o,a).map(R=>{const B=R.toInsert.map(x=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,x);const $=x.resourceUri;let M;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const de=new C.DisposableStore;M=this._commands.converter.toInternal(x.command,de),this._resourceStatesDisposablesMap.set(F,de)}else this._resourceStatesCommandsMap.set(F,x.command);const H=w(x.decorations),N=x.decorations&&w(x.decorations.light)||H,U=x.decorations&&w(x.decorations.dark)||H,V=[N,U],O=x.decorations&&x.decorations.tooltip||"",W=x.decorations&&!!x.decorations.strikeThrough,j=x.decorations&&!!x.decorations.faded,X=x.contextValue||"";return{rawResource:[F,$,V,O,W,j,X,M],handle:F}});return{start:R.start,deleteCount:R.deleteCount,toInsert:B}}),E=u.map(({start:R,deleteCount:B,toInsert:x})=>[R,B,x.map(F=>F.rawResource)]),T=u.reverse();for(const{start:R,deleteCount:B,toInsert:x}of T){const F=x.map(M=>M.handle),$=this._handlesSnapshot.splice(R,B,...F);for(const M of $)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=o,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}i._handlePool=0;class t{constructor(o,f,u,E,T,R){this._extension=o,this._proxy=f,this._commands=u,this._id=E,this._label=T,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new b(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,T,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=o;const f=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get actionButton(){return(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(o){(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=o;const f=o!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:f??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&s(this._statusBarCommands,o))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=o;const f=(o||[]).map(u=>this._commands.converter.toInternal(u,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}get selected(){return this._selected}createResourceGroup(o,f){const u=new i(this._proxy,this._commands,this.handle,o,f),E=L.Event.once(u.onDidDispose)(()=>this.createdResourceGroups.delete(u));return this.createdResourceGroups.set(u,E),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const o=[],f=[];for(const[u,E]of this.createdResourceGroups){E.dispose();const T=u.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(u),this.eventuallyUpdateResourceStates()});L.Event.once(u.onDidDispose)(()=>{this.updatedResourceGroups.delete(u),T.dispose(),this._groups.delete(u.handle),this._proxy.$unregisterGroup(this.handle,u.handle)}),o.push([u.handle,u.id,u.label,u.features]);const R=u._takeResourceStateSnapshot();R.length>0&&f.push([u.handle,R]),this._groups.set(u.handle,u)}this._proxy.$registerGroups(this.handle,o,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(f=>{const u=f._takeResourceStateSnapshot();u.length!==0&&o.push([f.handle,u])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,Ve([(0,y.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ve([(0,y.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let c=class Wn{constructor(o,f,u){this._commands=f,this.logService=u,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=o.getProxy(k.MainContext.MainThreadSCM),this._telemetry=o.getProxy(k.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const T=this._sourceControls.get(E.sourceControlHandle);if(!T)return E;const R=T.getResourceGroup(E.groupHandle);return R?R.getResourceState(E.handle):E}else if(E&&E.$mid===4){const T=this._sourceControls.get(E.sourceControlHandle);return T?T.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const T=this._sourceControls.get(E.handle);return T||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,f,u,E){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,f,u,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const T=Wn._handlePool++,R=new t(o,this._proxy,this._commands,f,u,E);this._sourceControls.set(T,R);const B=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier))||[];return B.push(R),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(o.identifier),B),R}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const f=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier)),u=f&&f[f.length-1];return u&&u.inputBox}$provideOriginalResource(o,f,u){const E=m.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,E.toString());const T=this._sourceControls.get(o);return!T||!T.quickDiffProvider||!T.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,n.asPromise)(()=>T.quickDiffProvider.provideOriginalResource(E,u)).then(R=>R||null)}$onInputBoxValueChange(o,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const u=this._sourceControls.get(o);return u&&u.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(o,f,u,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,f,u);const T=this._sourceControls.get(o);if(!T)return Promise.resolve(void 0);const R=T.getResourceGroup(f);return R?R.$executeResourceCommand(u,E):Promise.resolve(void 0)}$validateInput(o,f,u){this.logService.trace("ExtHostSCM#$validateInput",o);const E=this._sourceControls.get(o);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,n.asPromise)(()=>E.inputBox.validateInput(f,u)).then(T=>{if(!T)return Promise.resolve(void 0);const R=v.MarkdownString.fromStrict(T.message);return R?Promise.resolve([R,T.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(o){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&this._sourceControls.get(o)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};c._handlePool=0,c=Ve([$e(2,P.ILogService)],c),e.ExtHostSCM=c});var st=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[249],me([0,1,7,5,165,6,15,13]),function(Y,e,m,L,y,C,n,k){"use strict";var _,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(h,w,S,A,p=m.StatusBarAlignment.Left,a){_.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,st(this,_,h,"f"),st(this,D,w,"f"),this._entryId=P.ID_GEN++,this._extension=S,this._id=A,this._alignment=p,this._priority=this.validatePriority(a)}validatePriority(h){if(!!(0,k.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!P.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Ne(this,D,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Ne(this,D,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ne(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let w;this._name?w=this._name:w=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let S=this._color;this._backgroundColor&&(S=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const A=this._tooltip?n.MarkdownString.fromStrict(this._tooltip):void 0;Ne(this,_,"f").$setEntry(this._entryId,h,w,this._text,A,this._command?.internal,S,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,_=new WeakMap,D=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const w={message:h};return this._messages.unshift(w),this._update(),new m.Disposable(()=>{const S=this._messages.indexOf(w);S>=0&&(this._messages.splice(S,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class l{constructor(h,w){this._proxy=h.getProxy(L.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new I(this)}createStatusBarEntry(h,w,S,A){return new P(this._proxy,this._commands,h,w,S,A)}setStatusBarMessage(h,w){const S=this._statusMessage.setMessage(h);let A;return typeof w=="number"?A=setTimeout(()=>S.dispose(),w):typeof w!="undefined"&&w.then(()=>S.dispose(),()=>S.dispose()),new m.Disposable(()=>{S.dispose(),clearTimeout(A)})}}e.ExtHostStatusBar=l}),define(fe[92],me([0,1,5,3,4]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,_){this._proxy.$registerExtensionStorageKeysToSync(k,_)}getValue(k,_,D){return this._proxy.$getValue(k,_).then(P=>P||D)}setValue(k,_,D){return this._proxy.$setValue(k,_,D)}$acceptValue(k,_,D){this._onDidChangeStorage.fire({shared:k,key:_,value:D})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(fe[67],me([0,1,4,26,11,66,2]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let k=class{constructor(D,P,I){this._logService=P,this._extHostFileSystem=I,this._workspace=D.workspace??void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(l=>this._value=l)}async _getWorkspaceStorageURI(D){return n.URI.joinPath(this._environment.workspaceStorageHome,D)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const D=this._workspace.id,P=await this._getWorkspaceStorageURI(D);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(n.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:n.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),P}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(D){if(this._value)return n.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return n.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Ve([$e(0,L.IExtHostInitDataService),$e(1,y.ILogService),$e(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(fe[34],me([0,1,3,5,4,2,14,6,7,166,16,213,21,32,195,87,13,18]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class p{constructor(d,o,f,u){this._proxy=d,this._id=o,this._creationOptions=f,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(T,R=!0){E._checkDisposed(),E._proxy.$sendText(E._id,T,R)},show(T){E._checkDisposed(),E._proxy.$show(E._id,T)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(d,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:d.name,shellPath:(0,S.withNullAsUndefined)(d.shellPath),shellArgs:(0,S.withNullAsUndefined)(d.shellArgs),cwd:(0,S.withNullAsUndefined)(d.cwd),env:(0,S.withNullAsUndefined)(d.env),icon:(0,S.withNullAsUndefined)(i(d.iconPath)),color:w.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:(0,S.withNullAsUndefined)(d.message),strictEnv:(0,S.withNullAsUndefined)(d.strictEnv),hideFromUser:(0,S.withNullAsUndefined)(d.hideFromUser),isFeatureTerminal:(0,S.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,S.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(d.location,o?.resolvedExtHostIdentifier)})}async createExtensionTerminal(d,o,f,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:w.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(d,o)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(d,o){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in d?{viewColumn:d.viewColumn,preserveFocus:d.preserveFocus}:void 0:d}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(d){this._name=d}setExitCode(d){this._exitStatus=Object.freeze({code:d})}setDimensions(d,o){return d===this._cols&&o===this._rows||d===0||o===0?!1:(this._cols=d,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(d){this._pidPromiseComplete?(this._pidPromiseComplete(d),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==d&&(this._pidPromise=Promise.resolve(d))})}}e.ExtHostTerminal=p;class a{constructor(d){this._pty=d,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(d){this._pty.handleInput?.(d)}resize(d,o){this._pty.setDimensions?.({columns:d,rows:o})}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(d){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(d||void 0),d&&this._pty.setDimensions?.(d),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=a;let r=1,g=class extends k.Disposable{constructor(d,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(d),this._register({dispose:()=>{for(const[f,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(d=>d.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(d,o){const f=new p(this._proxy,(0,v.generateUuid)(),d,d.name),u=new a(d.pty);return f.createExtensionTerminal(d.location,this._serializeParentTerminal(d,o).resolvedExtHostIdentifier,i(d.iconPath),t(d.color)).then(E=>{const T=this._setupExtHostProcessListeners(E,u);this._terminalProcessDisposables[E]=T}),this._terminals.push(f),f.value}_serializeParentTerminal(d,o){if(o=o||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const f=d.location.parentTerminal;if(f){const u=this._terminals.find(E=>E.value===f);u&&(o.resolvedExtHostIdentifier=u._id)}}else d.location&&typeof d.location!="object"?o.location=d.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(d,o){if(!this._getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const u=new a(o),E=this._setupExtHostProcessListeners(d,u);this._terminalProcessDisposables[d]=E}async $acceptActiveTerminalChanged(d){const o=this._activeTerminal;if(d===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(d);f&&(this._activeTerminal=f,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(d,o){const f=this._getTerminalById(d);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:o})}async $acceptTerminalDimensions(d,o,f){const u=this._getTerminalById(d);u&&u.setDimensions(o,f)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(d,o,f){this._terminalProcesses.get(d)?.resize(o,f)}async $acceptTerminalTitleChange(d,o){const f=this._getTerminalById(d);f&&(f.name=o)}async $acceptTerminalClosed(d,o){const f=this._getTerminalObjectIndexById(this._terminals,d);if(f!==null){const u=this._terminals.splice(f,1)[0];u.setExitCode(o),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(d,o,f,u){if(o){const R=this._getTerminalObjectIndexById(this._terminals,o);if(R!==null){this._terminals[R]._id=d,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const E={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:C.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},T=new p(this._proxy,d,E,f);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(d,o){const f=this._getTerminalById(d);f&&f._setProcessId(o)}async $startExtensionTerminal(d,o){const f=this._getTerminalById(d);if(!f)return{message:(0,D.localize)(0,null,d)};f.isOpen||await new Promise(E=>{const T=this.onDidOpenTerminal(async R=>{R===f.value&&(T.dispose(),E())})});const u=this._terminalProcesses.get(d);u?u.startSendingEvents(o):this._extensionTerminalAwaitingStart[d]={initialDimensions:o}}_setupExtHostProcessListeners(d,o){const f=new k.DisposableStore;f.add(o.onProcessReady(E=>this._proxy.$sendProcessReady(d,E.pid,E.cwd))),f.add(o.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(d,E))),this._bufferer.startBuffering(d,o.onProcessData),f.add(o.onProcessExit(E=>this._onProcessExit(d,E))),this._terminalProcesses.set(d,o);const u=this._extensionTerminalAwaitingStart[d];return u&&o instanceof a&&(o.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[d]),f}$acceptProcessAckDataEvent(d,o){this._terminalProcesses.get(d)?.acknowledgeDataEvent(o)}$acceptProcessInput(d,o){this._terminalProcesses.get(d)?.input(o)}$acceptTerminalInteraction(d){const o=this._getTerminalById(d);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(d,o,f){try{this._terminalProcesses.get(d)?.resize(o,f)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(d,o){this._terminalProcesses.get(d)?.shutdown(o)}$acceptProcessRequestInitialCwd(d){this._terminalProcesses.get(d)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(d,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(d){this._terminalProcesses.get(d)?.getCwd().then(o=>this._proxy.$sendProcessProperty(d,{type:"cwd",value:o}))}$acceptProcessRequestLatency(d){return d}registerLinkProvider(d){return this._linkProviders.add(d),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(d),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(d,o,f){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,f),this._proxy.$registerProfileProvider(o,d.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(d,o){const f=new l.CancellationTokenSource().token;let u=await this._profileProviders.get(d)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(u&&!("options"in u)&&(u={options:u}),!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,o);return}this.createTerminalFromOptions(u.options,o)}}async $provideLinks(d,o){const f=this._getTerminalById(d);if(!f)return[];this._terminalLinkCache.delete(d);const u=this._terminalLinkCancellationSource.get(d);u&&u.dispose(!0);const E=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(d,E);const T=[],R={terminal:f.value,line:o},B=[];for(const $ of this._linkProviders)B.push(A.Promises.withAsyncBody(async M=>{E.token.onCancellationRequested(()=>M({provider:$,links:[]}));const H=await $.provideTerminalLinks(R,E.token)||[];E.token.isCancellationRequested||M({provider:$,links:H})}));const x=await Promise.all(B);if(E.token.isCancellationRequested)return[];const F=new Map;for(const $ of x)$&&$.links.length>0&&T.push(...$.links.map(M=>{const H={id:r++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return F.set(H.id,{provider:$.provider,link:M}),H}));return this._terminalLinkCache.set(d,F),T}$activateLink(d,o){const f=this._terminalLinkCache.get(d)?.get(o);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(d,o){this._bufferer.stopBuffering(d),this._terminalProcesses.delete(d),delete this._extensionTerminalAwaitingStart[d];const f=this._terminalProcessDisposables[d];f&&(f.dispose(),delete this._terminalProcessDisposables[d]),this._proxy.$sendProcessExit(d,o)}_getTerminalById(d){return this._getTerminalObjectById(this._terminals,d)}_getTerminalObjectById(d,o){const f=this._getTerminalObjectIndexById(d,o);return f!==null?d[f]:null}_getTerminalObjectIndexById(d,o){let f=null;return d.some((u,E)=>u._id===o?(f=E,!0):!1),f}getEnvironmentVariableCollection(d){let o=this._environmentVariableCollections.get(d.identifier.value);return o||(o=new s,this._setEnvironmentVariableCollection(d.identifier.value,o)),o}_syncEnvironmentVariableCollection(d,o){const f=(0,I.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(d,o.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(d){d.forEach(o=>{const f=o[0],u=new s(o[1]);this._setEnvironmentVariableCollection(f,u)})}$acceptDefaultProfile(d,o){this._defaultProfile=d,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(d,o){this._environmentVariableCollections.set(d,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(d,o)})}};g=Ve([$e(1,n.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class s{constructor(d){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(d)}get persistent(){return this._persistent}set persistent(d){this._persistent=d,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(d,o){this._setIfDiffers(d,{value:o,type:_.EnvironmentVariableMutatorType.Replace})}append(d,o){this._setIfDiffers(d,{value:o,type:_.EnvironmentVariableMutatorType.Append})}prepend(d,o){this._setIfDiffers(d,{value:o,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(d,o){const f=this.map.get(d);(!f||f.value!==o.value||f.type!==o.type)&&(this.map.set(d,o),this._onDidChangeCollection.fire())}get(d){return this.map.get(d)}forEach(d,o){this.map.forEach((f,u)=>d.call(o,u,f,this))}delete(d){this.map.delete(d),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let b=class extends g{constructor(d){super(!1,d)}createTerminal(d,o,f){throw new P.NotSupportedError}createTerminalFromOptions(d,o){throw new P.NotSupportedError}};b=Ve([$e(0,n.IExtHostRpcService)],b),e.WorkerExtHostTerminalService=b;function i(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function t(c){return w.ThemeColor.isThemeColor(c)?c:void 0}});var st=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[250],me([0,1,17,22,21,3,74,48,6,25,13,32,5,14,63,15,7,221,126,90]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p,a){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(R,B){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(l.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new b(this.proxy),B.registerArgumentProcessor({processArgument:x=>x?.$mid===13?w.TestItem.toItemFromContext(x):x})}createTestController(R,B){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const x=new _.DisposableStore,F=x.add(new A.SingleUseTestCollection(R));F.root.label=B;const $=new Map,M=this.proxy,H={items:F.root.children,get label(){return B},set label(U){B=U,F.root.label=U,M.$updateControllerLabel(R,B)},get id(){return R},createRunProfile:(U,V,O,W,j)=>{let X=(0,k.hash)(U);for(;$.has(X);)X++;const Q=new u(this.proxy,R,X,U,V,O,W,j);return $.set(X,Q),Q},createTestItem(U,V,O){return new h.TestItemImpl(R,U,V,O)},createTestRun:(U,V,O=!0)=>this.runTracker.createTestRun(R,F,U,V,O),set resolveHandler(U){F.resolveHandler=U},get resolveHandler(){return F.resolveHandler},dispose:()=>{x.dispose()}};H.createRunConfiguration=H.createRunProfile,M.$registerTestController(R,B),x.add((0,_.toDisposable)(()=>M.$unregisterTestController(R)));const N={controller:H,collection:F,profiles:$};return this.controllers.set(R,N),x.add((0,_.toDisposable)(()=>this.controllers.delete(R))),x.add(F.onDidGenerateDiff(U=>M.$publishDiff(R,U))),H}createTestObserver(){return this.observer.checkout()}async runTests(R,B=y.CancellationToken.None){const x=i(R);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(x.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map($=>$.id)??[F.collection.root.id],profileGroup:E[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:R.exclude?.map($=>$.id)},B)}$provideFileCoverage(R,B,x){return(0,m.mapFind)(this.runTracker.trackers,$=>$.id===R?$.getCoverage(B):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(R,B,x,F){return(0,m.mapFind)(this.runTracker.trackers,M=>M.id===R?M.getCoverage(B):void 0)?.resolveFileCoverage(x,F)??Promise.resolve([])}$configureRunProfile(R,B){this.controllers.get(R)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(B=>(0,D.deepFreeze)(w.TestResults.to(B))).concat(this.results).sort((B,x)=>x.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,B){const x=this.controllers.get(a.TestId.fromString(R).controllerId)?.collection;x&&(await x.expand(R,B<0?Infinity:B),x.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,B){const x=this.controllers.get(R.controllerId);if(!x)return;const{collection:F,profiles:$}=x,M=$.get(R.profileId);if(!M)return;const H=R.testIds.map(O=>F.tree.get(O)).filter(P.isDefined),N=R.excludeExtIds.map(O=>x.collection.tree.get(O)).filter(P.isDefined).filter(O=>H.some(W=>W.fullId.compare(O.fullId)===2));if(!H.length)return;const U=new S.TestRunRequest(H.some(O=>O.actual instanceof h.TestItemRootImpl)?void 0:H.map(O=>O.actual),N.map(O=>O.actual),M),V=this.runTracker.prepareForMainThreadTestRun(U,t.fromInternal(R,x.collection),B);try{await M.runHandler(U,B)}finally{V.isRunning&&!B.isCancellationRequested&&await C.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};g=Ve([$e(0,v.IExtHostRpcService)],g),e.ExtHostTesting=g;class s extends _.Disposable{constructor(R,B,x){super();this.dto=R,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const B=this.dto.id,x=this.dto.controllerId,F=(0,I.generateUuid)(),$=new c(this.proxy,B,F),M=V=>(O,...W)=>{if(N){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),V(O,...W))},H=(V,O)=>{const W=O instanceof Array?O.map(w.TestMessage.from):[w.TestMessage.from(O)];if(V.uri&&V.range){const j={range:w.Range.from(V.range),uri:V.uri};for(const X of W)X.location=X.location||j}this.proxy.$appendTestMessagesInRun(B,F,a.TestId.fromExtHostTestItem(V,x).toString(),W)};let N=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return $.coverageProvider},set coverageProvider(V){$.coverageProvider=V},enqueued:M(V=>{this.proxy.$updateTestStateInRun(B,F,a.TestId.fromExtHostTestItem(V,x).toString(),1)}),skipped:M(V=>{this.proxy.$updateTestStateInRun(B,F,a.TestId.fromExtHostTestItem(V,x).toString(),5)}),started:M(V=>{this.proxy.$updateTestStateInRun(B,F,a.TestId.fromExtHostTestItem(V,x).toString(),2)}),errored:M((V,O,W)=>{H(V,O),this.proxy.$updateTestStateInRun(B,F,a.TestId.fromExtHostTestItem(V,x).toString(),6,W)}),failed:M((V,O,W)=>{H(V,O),this.proxy.$updateTestStateInRun(B,F,a.TestId.fromExtHostTestItem(V,x).toString(),4,W)}),passed:M((V,O)=>{this.proxy.$updateTestStateInRun(B,F,a.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,O)}),appendOutput:(V,O,W)=>{N||(W&&(this.dto.isIncluded(W)?this.ensureTestIsKnown(W):W=void 0),this.proxy.$appendOutputToRun(B,F,L.VSBuffer.fromString(V),O&&w.location.from(O),W&&a.TestId.fromExtHostTestItem(W,x).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(B,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:U,coverage:$}),this.proxy.$startedTestRunTask(B,{id:F,name:R,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof h.TestItemImpl))throw new h.InvalidTestItemError(R.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const B=[],x=this.dto.colllection.root;for(;;){const F=w.TestItem.from(R);if(B.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===x))break;R=R.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class b{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,B,x){return this.getTracker(R,B,x)}cancelRunById(R){for(const B of this.tracked.values())if(B.id===R){B.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,B,x,F,$){const M=this.tracked.get(x);if(M)return M.createRun(F);const H=t.fromPublic(R,B,x,$),N=i(x);this.proxy.$startedExtensionTestRun({controllerId:R,profile:N&&{group:E[N.kind],id:N.profileId},exclude:x.exclude?.map(V=>V.id)??[],id:H.id,include:x.include?.map(V=>V.id)??[B.root.id],persist:$});const U=this.getTracker(x,H);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),U.createRun(F)}getTracker(R,B,x){const F=new s(B,this.proxy,x);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=b;const i=T=>{if(!!T.profile){if(!(T.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class t{constructor(R,B,x,F,$,M){this.controllerId=R,this.id=B,this.isPersisted=$,this.colllection=M,this.includePrefix=x.map(H=>H+"\0"),this.excludePrefix=F.map(H=>H+"\0")}static fromPublic(R,B,x,F){return new t(R,(0,I.generateUuid)(),x.include?.map($=>a.TestId.fromExtHostTestItem($,R).toString())??[R],x.exclude?.map($=>a.TestId.fromExtHostTestItem($,R).toString())??[],F,B)}static fromInternal(R,B){return new t(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,B)}isIncluded(R){const B=a.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(B===x||B.startsWith(x))return!1;for(const x of this.includePrefix)if(B===x||B.startsWith(x))return!0;return!1}}e.TestRunDto=t;class c{constructor(R,B,x){this.proxy=R,this.runId=B,this.taskId=x}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(R,B){const x=await this.fileCoverage;let F=x?.[R];return!this._coverageProvider||!x||!F?[]:(F.detailedCoverage||(F=x[R]=await this._coverageProvider.resolveFileCoverage?.(F,B)??F),F.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class d extends p.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,w.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:B,removed:x}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...B].map(F=>F.revived)},get removed(){return[...x].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,B){return{...R,revived:w.TestItem.toPlain(R.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=o;class f{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(B=>B.revived)},dispose:(0,n.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new o;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class u{constructor(R,B,x,F,$,M,H=!1,N=void 0){this.controllerId=B,this.profileId=x,this._label=F,this.kind=$,this.runHandler=M,this._isDefault=H,this._tag=N,r.set(this,void 0),st(this,r,R,"f");const U=E[$];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Ne(this,r,"f").$publishTestRunProfile({profileId:x,controllerId:B,tag:N?w.TestTag.namespace(this.controllerId,N.id):null,label:F,group:U,isDefault:H,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?w.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Ne(this,r,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Ne(this,r,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,r=new WeakMap;const E={[S.TestRunProfileKind.Coverage]:8,[S.TestRunProfileKind.Debug]:4,[S.TestRunProfileKind.Run]:2}}),define(fe[251],me([0,1,3,17,5,129,15,7]),function(Y,e,m,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(P,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=P.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(P){const I=this._extHostDocumentsAndEditors.allEditors();return P?I:I.map(l=>l.value)}async showTextDocument(P,I,l){let v;typeof I=="number"?v={position:n.ViewColumn.from(I),preserveFocus:l}:typeof I=="object"?v={position:n.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?n.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:v={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(P.uri,v),w=h&&this._extHostDocumentsAndEditors.getEditor(h);if(w)return w.value;throw h?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,I){return new C.TextEditorDecorationType(this._proxy,P,I).value}$acceptEditorPropertiesChanged(P,I){const l=this._extHostDocumentsAndEditors.getEditor(P);if(!l)throw new Error("unknown text editor");if(I.options&&l._acceptOptions(I.options),I.selections){const v=I.selections.selections.map(n.Selection.to);l._acceptSelections(v)}if(I.visibleRanges){const v=L.coalesce(I.visibleRanges.map(n.Range.to));l._acceptVisibleRanges(v)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:{...I.options,lineNumbers:n.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const v=k.TextEditorSelectionChangeKind.fromValue(I.selections.source),h=I.selections.selections.map(n.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:h,kind:v})}if(I.visibleRanges){const v=L.coalesce(I.visibleRanges.map(n.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:v})}}$acceptEditorPositionData(P){for(const I in P){const l=this._extHostDocumentsAndEditors.getEditor(I);if(!l)throw new Error("Unknown text editor");const v=n.ViewColumn.to(P[I]);l.value.viewColumn!==v&&(l._acceptViewColumn(v),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:v}))}}getDiffInformation(P){return Promise.resolve(this._proxy.$getDiffInformation(P))}}e.ExtHostEditors=_}),define(fe[252],me([0,1,2,4,5,6,7]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class k{constructor(P,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=P.getProxy(y.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===11){const v=l.uri===void 0?void 0:m.URI.revive(l.uri);return this._itemsBySourceAndUriMap.get(l.source)?.get(_(v))?.get(l.handle)}return l}})}async $getTimeline(P,I,l,v,h){return this._providers.get(P)?.provideTimeline(m.URI.revive(I),l,v,h)}registerTimelineProvider(P,I,l,v){const h=new C.DisposableStore,w=this.convertTimelineItem(I.id,v,h).bind(this);let S;I.onDidChange&&(S=I.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:I.id}),this));const A=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:P,onDidChange:void 0,async provideTimeline(p,a,r,g){g?.resetCache&&(h.clear(),A.get(I.id)?.clear());const s=await I.provideTimeline(p,a,r);if(s==null)return;const b=w(p,g);return{...s,source:I.id,items:s.items.map(b)}},dispose(){for(const p of A.values())p.get(I.id)?.clear();S?.dispose(),h.dispose()}})}convertTimelineItem(P,I,l){return(v,h)=>{let w;if(h?.cacheResults){let S=this._itemsBySourceAndUriMap.get(P);S===void 0&&(S=new Map,this._itemsBySourceAndUriMap.set(P,S));const A=_(v);w=S.get(A),w===void 0&&(w=new Map,S.set(A,w))}return S=>{const{iconPath:A,...p}=S,a=`${P}|${S.id??S.timestamp}`;w?.set(a,S);let r,g,s;return S.iconPath&&(A instanceof n.ThemeIcon?s={id:A.id,color:A.color}:m.URI.isUri(A)?(r=A,g=A):{light:r,dark:g}=A),{...p,id:p.id??void 0,handle:a,source:P,command:S.command?I.toInternal(S.command,l):void 0,icon:r,iconDark:g,themeIcon:s,accessibilityInformation:S.accessibilityInformation}}}}registerTimelineProviderCore(P){if(this._providers.get(P.id))throw new Error(`Timeline Provider ${P.id} already exists.`);return this._proxy.$registerTimelineProvider({id:P.id,label:P.label,scheme:P.scheme}),this._providers.set(P.id,P),(0,C.toDisposable)(()=>{for(const l of this._itemsBySourceAndUriMap.values())l.get(P.id)?.clear();this._providers.delete(P.id),this._proxy.$unregisterTimelineProvider(P.id),P.dispose()})}}e.ExtHostTimeline=k;function _(D){return D?.toString()}}),define(fe[253],me([0,1,6,10,2,5]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class n{constructor(_){this._openers=new Map,this._proxy=_.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,D,P,I){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const l=I.schemes.find(v=>!n.supportedSchemes.has(v));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,P),this._proxy.$registerUriOpener(D,I.schemes,_,I.label),(0,m.toDisposable)(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(_,D,P){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const l=y.URI.revive(D);return I.canOpenExternalUri(l,P)}async $openUri(_,D,P){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(y.URI.revive(D.resolvedUri),{sourceUri:y.URI.revive(D.sourceUri)},P)}}e.ExtHostUriOpeners=n,n.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(fe[254],me([0,1,5,2,6,16,27]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(D,P){if(this.handles.has(n.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const I=k.HandlePool++;return this.handles.add(n.ExtensionIdentifier.toKey(D)),this.handlers.set(I,P),this._proxy.$registerUriHandler(I,D),(0,y.toDisposable)(()=>{this.handles.delete(n.ExtensionIdentifier.toKey(D)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(D,P){const I=this.handlers.get(D);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(P))}catch(l){(0,C.onUnexpectedError)(l)}return Promise.resolve(void 0)}async createAppUri(D){return L.URI.revive(await this._proxy.$createAppUri(D))}}e.ExtHostUrls=k,k.HandlePool=0});var st=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[68],me([0,1,3,10,2,178,203,89,5]),function(Y,e,m,L,y,C,n,k,_){"use strict";var D,P,I,l,v,h,w,S,A,p,a,r;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(f,u,E,T,R,B,x){D.set(this,void 0),P.set(this,void 0),I.set(this,void 0),l.set(this,void 0),v.set(this,void 0),h.set(this,void 0),w.set(this,""),S.set(this,void 0),A.set(this,!1),p.set(this,!1),a.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new m.Emitter),this._onDidDispose=Ne(this,r,"f").event,st(this,D,f,"f"),st(this,P,u,"f"),st(this,S,E,"f"),st(this,l,T,"f"),st(this,v,R,"f"),st(this,h,B,"f"),st(this,a,s(B),"f"),st(this,I,x,"f")}dispose(){st(this,A,!0,"f"),Ne(this,r,"f").fire(),Ne(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return st(this,p,!0,"f"),(0,k.asWebviewUri)(f,Ne(this,l,"f").remote)}get cspSource(){const f=Ne(this,h,"f").extensionLocation;if(f.scheme===L.Schemas.https||f.scheme===L.Schemas.http){let u=f.toString();return u.endsWith("/")||(u+="/"),u+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ne(this,w,"f")}set html(f){this.assertNotDisposed(),Ne(this,w,"f")!==f&&(st(this,w,f,"f"),!Ne(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(st(this,p,!0,"f"),Ne(this,I,"f").report("Webview vscode-resource: uris",Ne(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,P,"f").$setHtml(Ne(this,D,"f"),f))}get options(){return this.assertNotDisposed(),Ne(this,S,"f")}set options(f){this.assertNotDisposed(),Ne(this,P,"f").$setOptions(Ne(this,D,"f"),t(Ne(this,h,"f"),Ne(this,v,"f"),f)),st(this,S,f,"f")}async postMessage(f){if(Ne(this,A,"f"))return!1;const u=(0,n.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:Ne(this,a,"f")});return Ne(this,P,"f").$postMessage(Ne(this,D,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Ne(this,A,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,D=new WeakMap,P=new WeakMap,I=new WeakMap,l=new WeakMap,v=new WeakMap,h=new WeakMap,w=new WeakMap,S=new WeakMap,A=new WeakMap,p=new WeakMap,a=new WeakMap,r=new WeakMap;function s(o){try{const f=(0,C.normalizeVersion)((0,C.parseVersion)(o.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;class b{constructor(f,u,E,T,R){this.initData=u,this.workspace=E,this._logService=T,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=f.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(f,u,...E){const T=this.getWebview(f);if(T){const{message:R}=(0,n.deserializeWebviewMessage)(u,E);T._onMessageEmitter.fire(R)}}$onMissingCsp(f,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,u,E){const T=new g(f,this._webviewProxy,c(u),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(f,T),T._onDidDispose(()=>{this._webviews.delete(f)}),T}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=b;function i(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=i;function t(o,f,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||d(o,f)}}e.serializeWebviewOptions=t;function c(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(f=>y.URI.from(f))}}e.reviveOptions=c;function d(o,f){return[...(f?.getWorkspaceFolders()||[]).map(u=>u.uri),o.extensionLocation]}}),define(fe[255],me([0,1,21,48,6,10,23,2,15,68,88,5,7]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class v{constructor(s,b){this.document=s,this._storagePath=b,this._backupCounter=1,this._edits=new P.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,b){await this.getEdit(s).undo(),b||this.disposeBackup()}async redo(s,b){await this.getEdit(s).redo(),b||this.disposeBackup()}disposeEdits(s){for(const b of s)this._edits.delete(b)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=r(this.document.uri)+this._backupCounter++;return(0,n.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const b=this._edits.get(s,0);if(!b)throw new Error("No edit found");return b}}class h{constructor(){this._documents=new Map}get(s,b){return this._documents.get(this.key(s,b))}add(s,b,i){const t=this.key(s,b.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${s} resource:${b.uri}`);const c=new v(b,i);return this._documents.set(t,c),c}delete(s,b){const i=this.key(s,b.uri);this._documents.delete(i)}key(s,b){return`${s}@@@${b}`}}var w;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(w||(w={}));class S{constructor(){this._providers=new Map}addTextProvider(s,b,i){return this.add(0,s,b,i)}addCustomProvider(s,b,i){return this.add(1,s,b,i)}get(s){return this._providers.get(s)}add(s,b,i,t){if(this._providers.has(b))throw new Error(`Provider for viewType:${b} already registered`);return this._providers.set(b,{type:s,extension:i,provider:t}),new l.Disposable(()=>this._providers.delete(b))}}class A{constructor(s,b,i,t,c){this._extHostDocuments=b,this._extensionStoragePaths=i,this._extHostWebview=t,this._extHostWebviewPanels=c,this._editorProviders=new S,this._documents=new h,this._proxy=s.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,b,i,t){const c=new y.DisposableStore;return p(i)?(c.add(this._editorProviders.addTextProvider(b,s,i)),this._proxy.$registerTextEditorProvider((0,D.toExtensionData)(s),b,t.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(s))):(c.add(this._editorProviders.addCustomProvider(b,s,i)),this.supportEditing(i)&&c.add(i.onDidChangeCustomDocument(d=>{const o=this.getCustomDocumentEntry(b,d.document.uri);if(a(d)){const f=o.addEdit(d);this._proxy.$onDidEdit(d.document.uri,b,f,d.label)}else this._proxy.$onContentChange(d.document.uri,b)})),this._proxy.$registerCustomEditorProvider((0,D.toExtensionData)(s),b,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(s))),l.Disposable.from(c,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(b)}))}async $createCustomDocument(s,b,i,t,c){const d=this._editorProviders.get(b);if(!d)throw new Error(`No provider found for '${b}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${b}'`);const o=k.URI.revive(s),f=await d.provider.openCustomDocument(o,{backupId:i,untitledDocumentData:t?.buffer},c);let u;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(b,f,u),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(s,b){const i=this._editorProviders.get(b);if(!i)throw new Error(`No provider found for '${b}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${b}'`);const t=k.URI.revive(s),{document:c}=this.getCustomDocumentEntry(b,t);this._documents.delete(b,c),c.dispose()}async $resolveWebviewEditor(s,b,i,t,c,d){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);const f=_.ViewColumn.to(c),u=this._extHostWebview.createNewWebview(b,t.webviewOptions,o.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(b,i,t.title,f,t.panelOptions,u),T=k.URI.revive(s);switch(o.type){case 1:{const{document:R}=this.getCustomDocumentEntry(i,T);return o.provider.resolveCustomEditor(R,E,d)}case 0:{const R=this._extHostDocuments.getDocument(T);return o.provider.resolveCustomTextEditor(R,E,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,b,i){this.getCustomDocumentEntry(b,s).disposeEdits(i)}async $onMoveCustomEditor(s,b,i){const t=this._editorProviders.get(i);if(!t)throw new Error(`No provider found for '${i}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const c=this._extHostWebviewPanels.getWebviewPanel(s);if(!c)throw new Error("No webview found");const d=k.URI.revive(b),o=this._extHostDocuments.getDocument(d);await t.provider.moveCustomTextEditor(o,c,m.CancellationToken.None)}async $undo(s,b,i,t){return this.getCustomDocumentEntry(b,s).undo(i,t)}async $redo(s,b,i,t){return this.getCustomDocumentEntry(b,s).redo(i,t)}async $revert(s,b,i){const t=this.getCustomDocumentEntry(b,s);await this.getCustomEditorProvider(b).revertCustomDocument(t.document,i),t.disposeBackup()}async $onSave(s,b,i){const t=this.getCustomDocumentEntry(b,s);await this.getCustomEditorProvider(b).saveCustomDocument(t.document,i),t.disposeBackup()}async $onSaveAs(s,b,i,t){const c=this.getCustomDocumentEntry(b,s);return this.getCustomEditorProvider(b).saveCustomDocumentAs(c.document,k.URI.revive(i),t)}async $backup(s,b,i){const t=this.getCustomDocumentEntry(b,s),d=await this.getCustomEditorProvider(b).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},i);return t.updateBackup(d),d.id}getCustomDocumentEntry(s,b){const i=this._documents.get(s,k.URI.revive(b));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(s){const i=this._editorProviders.get(s)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(s){return!!s.onDidChangeCustomDocument}}e.ExtHostCustomEditors=A;function p(g){return typeof g.resolveCustomTextEditor=="function"}function a(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function r(g){const s=g.scheme===C.Schemas.file||g.scheme===C.Schemas.untitled?g.fsPath:g.toString();return(0,L.hash)(s)+""}});var st=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[256],me([0,1,3,6,2,32,15,68,5,7]),function(Y,e,m,L,y,C,n,k,_,D){"use strict";var P,I,l,v,h,w,S,A,p,a,r,g,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class b extends L.Disposable{constructor(d,o,f,u,E,T,R){super();P.set(this,void 0),I.set(this,void 0),l.set(this,void 0),v.set(this,void 0),h.set(this,void 0),w.set(this,void 0),S.set(this,void 0),A.set(this,void 0),p.set(this,!0),a.set(this,!0),r.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Ne(this,g,"f").event,s.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Ne(this,s,"f").event,st(this,P,d,"f"),st(this,I,o,"f"),st(this,l,f,"f"),st(this,h,T,"f"),st(this,A,E,"f"),st(this,w,u,"f"),st(this,v,R,"f")}dispose(){Ne(this,r,"f")||(st(this,r,!0,"f"),Ne(this,g,"f").fire(),Ne(this,I,"f").$disposeWebview(Ne(this,P,"f")),Ne(this,v,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ne(this,v,"f")}get viewType(){return this.assertNotDisposed(),Ne(this,l,"f")}get title(){return this.assertNotDisposed(),Ne(this,w,"f")}set title(d){this.assertNotDisposed(),Ne(this,w,"f")!==d&&(st(this,w,d,"f"),Ne(this,I,"f").$setTitle(Ne(this,P,"f"),d))}get iconPath(){return this.assertNotDisposed(),Ne(this,S,"f")}set iconPath(d){this.assertNotDisposed(),Ne(this,S,"f")!==d&&(st(this,S,d,"f"),Ne(this,I,"f").$setIconPath(Ne(this,P,"f"),y.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Ne(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ne(this,A,"f")=="number"&&Ne(this,A,"f")<0))return Ne(this,A,"f")}get active(){return this.assertNotDisposed(),Ne(this,a,"f")}get visible(){return this.assertNotDisposed(),Ne(this,p,"f")}_updateViewState(d){Ne(this,r,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(st(this,a,d.active,"f"),st(this,p,d.visible,"f"),st(this,A,d.viewColumn,"f"),Ne(this,s,"f").fire({webviewPanel:this}))}reveal(d,o){this.assertNotDisposed(),Ne(this,I,"f").$reveal(Ne(this,P,"f"),{viewColumn:d?n.ViewColumn.from(d):void 0,preserveFocus:!!o})}assertNotDisposed(){if(Ne(this,r,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,I=new WeakMap,l=new WeakMap,v=new WeakMap,h=new WeakMap,w=new WeakMap,S=new WeakMap,A=new WeakMap,p=new WeakMap,a=new WeakMap,r=new WeakMap,g=new WeakMap,s=new WeakMap;class i{constructor(d,o,f){this.webviews=o,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(d,o,f,u,E={}){const T=typeof u=="object"?u.viewColumn:u,R={viewColumn:n.ViewColumn.from(T),preserveFocus:typeof u=="object"&&!!u.preserveFocus},B=(0,k.shouldSerializeBuffersForPostMessage)(d),x=i.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(d),x,o,{title:f,panelOptions:t(E),webviewOptions:(0,k.serializeWebviewOptions)(d,this.workspace,E),serializeBuffersForPostMessage:B},R);const F=this.webviews.createNewWebview(x,E,d);return this.createNewWebviewPanel(x,o,f,T,E,F)}$onDidChangeWebviewPanelViewStates(d){const o=Object.keys(d);o.sort((f,u)=>{const E=d[f],T=d[u];return E.active?1:T.active?-1:+E.visible-+T.visible});for(const f of o){const u=this.getWebviewPanel(f);if(!u)continue;const E=d[f];u._updateViewState({active:E.active,visible:E.visible,viewColumn:n.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,o,f){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:f,extension:d}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(d)}),new D.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(d,o,f,u){const E=this._serializers.get(o);if(!E)throw new Error(`No serializer found for '${o}'`);const{serializer:T,extension:R}=E,B=this.webviews.createNewWebview(d,f.webviewOptions,R),x=this.createNewWebviewPanel(d,o,f.title,u,f.panelOptions,B);await T.deserializeWebviewPanel(x,f.state)}createNewWebviewPanel(d,o,f,u,E,T){const R=new b(d,this._proxy,o,f,u,E,T);return this._webviewPanels.set(d,R),R}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=i;function t(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var st=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[257],me([0,1,3,6,68,5,7]),function(Y,e,m,L,y,C,n){"use strict";var k,_,D,P,I,l,v,h,w,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class A extends L.Disposable{constructor(r,g,s,b,i,t){super();k.set(this,void 0),_.set(this,void 0),D.set(this,void 0),P.set(this,void 0),I.set(this,!1),l.set(this,void 0),v.set(this,void 0),h.set(this,void 0),w.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Ne(this,w,"f").event,S.set(this,this._register(new m.Emitter)),this.onDidDispose=Ne(this,S,"f").event,st(this,D,s,"f"),st(this,v,b,"f"),st(this,k,r,"f"),st(this,_,g,"f"),st(this,P,i,"f"),st(this,l,t,"f")}dispose(){Ne(this,I,"f")||(st(this,I,!0,"f"),Ne(this,S,"f").fire(),Ne(this,P,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ne(this,v,"f")}set title(r){this.assertNotDisposed(),Ne(this,v,"f")!==r&&(st(this,v,r,"f"),Ne(this,_,"f").$setWebviewViewTitle(Ne(this,k,"f"),r))}get description(){return this.assertNotDisposed(),Ne(this,h,"f")}set description(r){this.assertNotDisposed(),Ne(this,h,"f")!==r&&(st(this,h,r,"f"),Ne(this,_,"f").$setWebviewViewDescription(Ne(this,k,"f"),r))}get visible(){return Ne(this,l,"f")}get webview(){return Ne(this,P,"f")}get viewType(){return Ne(this,D,"f")}_setVisible(r){r===Ne(this,l,"f")||Ne(this,I,"f")||(st(this,l,r,"f"),Ne(this,w,"f").fire())}show(r){this.assertNotDisposed(),Ne(this,_,"f").$show(Ne(this,k,"f"),!!r)}assertNotDisposed(){if(Ne(this,I,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,_=new WeakMap,D=new WeakMap,P=new WeakMap,I=new WeakMap,l=new WeakMap,v=new WeakMap,h=new WeakMap,w=new WeakMap,S=new WeakMap;class p{constructor(r,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,g,s,b){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:s,extension:r}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(r),g,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new n.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(r,g,s,b,i){const t=this._viewProviders.get(g);if(!t)throw new Error(`No view provider found for '${g}'`);const{provider:c,extension:d}=t,o=this._extHostWebview.createNewWebview(r,{},d),f=new A(r,this._proxy,g,s,o,!0);this._webviewViews.set(r,f),await c.resolveWebviewView(f,{state:b},i)}async $onDidChangeWebviewViewVisibility(r,g){this.getWebviewView(r)._setVisible(g)}async $disposeWebviewView(r){const g=this.getWebviewView(r);this._webviewViews.delete(r),g.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const g=this._webviewViews.get(r);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=p}),define(fe[133],me([0,1,3,5,2,10,8,4,14]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class Hn{constructor(I){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Hn.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,l){let v;if(typeof I=="string"){v=I;try{I=y.URI.parse(I)}catch(h){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,n.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,v,l)}async asExternalUri(I,l){if((0,n.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this._proxy.$asExternalUri(I,l);return y.URI.from(v)}};D.InitialState={focused:!0},D=Ve([$e(0,_.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(fe[258],me([0,1,9,81,32,39,6,5,2,14]),function(Y,e,m,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let P=class extends n.Disposable{constructor(l,v){super();const h=l.getProxy(k.MainContext.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async w=>{const S=_.URI.file((0,m.join)((0,L.tmpdir)(),(0,y.generateUuid)()));return await h.$download(w,S),S})}};P=Ve([$e(0,D.IExtHostRpcService),$e(1,C.IExtHostCommands)],P),e.ExtHostDownloadService=P}),define(fe[259],me([0,1,131,10,187,32]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class n extends m.ExtHostLoggerService{doCreateLogger(_,D,P){return _.scheme===L.Schemas.file?new y.SpdLogLogger(P?.name||(0,C.generateUuid)(),_.fsPath,!P?.donotRotate,!!P?.donotUseFormatters,D):super.doCreateLogger(_,D,P)}}e.ExtHostLoggerService=n}),define(fe[260],me([0,1,60,9,2,67,6,10,18,28]),function(Y,e,m,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class P extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(s){const b=await super._getWorkspaceStorageURI(s);if(b.scheme!==k.Schemas.file)return b;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${b.fsPath}.`),b;const i=b.fsPath;let t=0;do{let c;t===0?c=i:c=/[/\\]$/.test(i)?`${i.substr(0,i.length-1)}-${t}`:`${i}-${t}`,await I(c);const d=L.join(c,"vscode.lock"),o=await w(this._logService,d,!1);if(o)return this._workspaceStorageLock=o,process.on("exit",()=>{o.dispose()}),y.URI.file(c);t++}while(t<10);return b}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=P;async function I(g){try{await D.Promises.stat(g);return}catch{}try{await D.Promises.mkdir(g,{recursive:!0})}catch{}}const l=1e3,v=10*60*1e3;class h extends n.Disposable{constructor(s,b){super();this.logService=s,this.filename=b,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const i=await S(s,b);(!i||i.pid!==process.pid)&&(s.info(`Lock '${b}': The lock was lost unexpectedly.`),this._timer.cancel());try{await D.Promises.utimes(b,new Date,new Date)}catch(t){s.error(t),s.info(`Lock '${b}': Could not update mtime.`)}},l)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch(s){}}async setWillRelease(s){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const b={pid:process.pid,willReleaseAt:Date.now()+s};await D.Promises.writeFile(this.filename,JSON.stringify(b),{flag:"w"})}catch(b){this.logService.error(b)}}}async function w(g,s,b){try{const t={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(s,JSON.stringify(t),{flag:"wx"})}catch(t){g.error(t)}const i=await S(g,s);return!i||i.pid!==process.pid?b?(g.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),a(g,s)):(g.info(`Lock '${s}': Lock acquired.`),new h(g,s))}async function S(g,s){let b;try{b=await D.Promises.readFile(s)}catch(i){return g.error(i),null}try{return JSON.parse(String(b))}catch(i){return g.error(i),null}}async function A(g,s){let b;try{b=await D.Promises.stat(s)}catch(i){return g.error(i),0}return b.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch(s){return!1}}async function a(g,s){const b=await S(g,s);if(!b)return g.info(`Lock '${s}': Could not read pid of lock holder.`),r(g,s);if(b.willReleaseAt){let o=b.willReleaseAt-Date.now();if(o<5e3){for(o>0?g.info(`Lock '${s}': The lockfile is scheduled to be released in ${o} ms.`):g.info(`Lock '${s}': The lockfile is scheduled to have been released.`);o>0;){if(await(0,_.timeout)(Math.min(100,o)),await A(g,s)===0)return r(g,s);o=b.willReleaseAt-Date.now()}return r(g,s)}}if(!p(b.pid))return g.info(`Lock '${s}': The pid ${b.pid} appears to be gone.`),r(g,s);const i=await A(g,s),t=Date.now()-i;if(t<=v)return g.info(`Lock '${s}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;g.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const c=await A(g,s),d=Date.now()-c;return d<=v?(g.info(`Lock '${s}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(g.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),r(g,s))}async function r(g,s){g.info(`Lock '${s}': Deleting a stale lock.`);try{await D.Promises.unlink(s)}catch(b){}return w(g,s,!0)}}),define(fe[261],me([0,1,32,14,34]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends y.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,_,D){return this.createTerminalFromOptions({name:k,shellPath:_,shellArgs:D})}createTerminalFromOptions(k,_){const D=new y.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),k,k.name);return this._terminals.push(D),D.create(k,this._serializeParentTerminal(k,_)),D.value}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(fe[262],me([0,1,5,14,170,6,26,2,38,23,28,7,12,52,3,120,77,11]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class p{constructor(f,u,E){this.remoteAddress=f,this.localAddress=u,this._dispose=E,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function a(o){const f=o.trim().split(`
`),u=[];return f.forEach(T=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);R&&R.length>=3&&u.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),u.reduce((T,R)=>(T[R.socket]=R,T),{})}e.getSockets=a;function r(...o){const f=[].concat(...o.map(s));return[...new Map(f.filter(u=>u.st==="0A").map(u=>{const E=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:g(E[0]),port:parseInt(E[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=r;function g(o){let f="";if(o.length===8)for(let u=o.length-2;u>=0;u-=2)f+=parseInt(o.substr(u,2),16),u!==0&&(f+=".");else for(let u=o.length-4;u>=0;u-=4)f+=parseInt(o.substr(u,4),16).toString(16),u!==0&&(f+=":");return f}e.parseIpAddress=g;function s(o){const f=o.trim().split(`
`),u=f.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return f.map(T=>T.trim().split(/\s+/).reduce((R,B,x)=>(R[u[x]||x]=B,R),{}))}e.loadConnectionTable=s;function b(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/vs/server/main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function i(o){const f=o.trim().split(`
`),u=[];return f.forEach(E=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);T&&T.length>=4&&u.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),u}e.getRootProcesses=i;async function t(o,f,u){const E=u.reduce((R,B)=>(R[B.pid]=B,R),{}),T=[];return o.forEach(({socket:R,ip:B,port:x})=>{const F=f[R]?f[R].pid:void 0,$=F?E[F]?.cmd:void 0;F&&$&&!b($)&&T.push({host:B,port:x,detail:$,pid:F})}),T}e.findPorts=t;function c(o,f,u){const E=new Map,T=i(f);for(const R of o){const B=u.get(R.port);if(B){E.set(R.port,B);continue}const x=T.find(F=>F.cmd.includes(`${R.port}`));if(x){let F=x,$;do $=T.find(M=>M.ppid===F.pid),$&&(F=$);while($);E.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else E.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=c;let d=class extends C.Disposable{constructor(f,u,E){super();this.logService=E,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(m.MainContext.MainThreadTunnelService),l.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const E=await this._proxy.$openTunnel(u,f.displayName);if(E){const T=new p(E.remoteAddress,E.localAddress,()=>this._proxy.$closeTunnel(E.remoteAddress));return this._register(T),T}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,u){const E=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(E,{selector:f,provider:u}),this._proxy.$registerPortsAttributesProvider(f,E),new I.Disposable(()=>{this._portAttributesProviders.delete(E),this._proxy.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(f,u,E,T,R){const B=[];for(const F of f){const $=this._portAttributesProviders.get(F);if(!$)return[];B.push(...await Promise.all(u.map(async M=>$.provider.providePortAttributes(M,E,T,R))))}const x=B.filter(F=>!!F);return x.length>0?x.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let u=new S.MovingAverage,E;for(;this._candidateFindingEnabled;){const T=new Date().getTime(),R=(await this.findCandidatePorts()).filter(x=>(0,w.isLocalhost)(x.host)||(0,w.isAllInterfaces)(x.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(x=>x.port).join(", ")}`);const B=new Date().getTime()-T;u.update(B),(!E||JSON.stringify(E)!==JSON.stringify(R))&&(E=R,await this._proxy.$onFoundNewCandidates(E)),await new Promise(x=>setTimeout(()=>x(),this.calculateDelay(u.value)))}}async setTunnelExtensionFunctions(f){if(f){if(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory){this._forwardPortProvider=f.tunnelFactory;let u=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:u})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,u){if(this._extensionTunnels.has(f.host)){const E=this._extensionTunnels.get(f.host);E.has(f.port)&&(u&&E.get(f.port).disposeListener.dispose(),await E.get(f.port).tunnel.dispose(),E.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this._forwardPortProvider(f,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const T=await E;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const R=this._register(T.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(T.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:T,disposeListener:R}),v.TunnelDto.fromApiTunnel(T)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(E){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const u=await Promise.all(f.map(T=>this._showCandidatePort(T.host,T.port,T.detail??""))),E=f.filter((T,R)=>u[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(T=>T.port).join(", ")} to ${E.map(T=>T.port).join(", ")}`),E}async findCandidatePorts(){let f="",u="";try{f=await P.Promises.readFile("/proc/net/tcp","utf8"),u=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch(N){}const E=r(f,u),T=await new Promise(N=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,V,O)=>{N(V)})}),R=a(T),B=await P.Promises.readdir("/proc"),x=[];for(let N of B)try{const U=Number(N),V=D.joinPath(k.URI.file("/proc"),N);if((await P.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(U)){const W=await P.Promises.readlink(D.joinPath(V,"cwd").fsPath),j=await P.Promises.readFile(D.joinPath(V,"cmdline").fsPath,"utf8");x.push({pid:U,cwd:W,cmd:j})}}catch(U){}const F=[],$=E.filter(N=>{const U=R[N.socket];return U||F.push(N),U}),M=t($,R,x);let H;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const N=await new Promise(U=>{(0,_.exec)("ps -F -A -l | grep root",(V,O,W)=>{U(O)})});this._foundRootPorts=c(F,N,this._foundRootPorts),H=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${H.join(", ")}`)}return M.then(N=>H?N.concat(H):N)}};d=Ve([$e(0,L.IExtHostRpcService),$e(1,n.IExtHostInitDataService),$e(2,A.ILogService)],d),e.ExtHostTunnelService=d}),define(fe[263],me([0,1,18,22,21,16,3,6,103,227,53]),function(Y,e,m,L,y,C,n,k,_,D,P){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function l(E,T){try{return JSON.stringify(E,T)}catch(R){return"null"}}const v="$$ref$$",h={[v]:-1};class w{constructor(T,R){this.jsonString=T,this.referencedBuffers=R}}function S(E,T=null,R=!1){const B=[];return{jsonString:(R?l:JSON.stringify)(E,(F,$)=>{if(typeof $=="undefined")return h;if(typeof $=="object"){if($ instanceof L.VSBuffer){const M=B.push($)-1;return{[v]:M}}if(T)return T(F,$)}return $}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=S;function A(E,T,R){return JSON.parse(E,(B,x)=>{if(x){const F=x[v];if(typeof F=="number")return T[F];if(R&&x.$mid===1)return R.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=A;function p(E,T){return JSON.stringify(E,T)}function a(E){return E?(T,R)=>R&&R.$mid===1?E.transformOutgoing(R):R:null}var r;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(r=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},b=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(T,R=null,B=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new n.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=R,this._uriTransformer=B,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let x=0,F=P.ProxyIdentifier.count;x<F;x++)this._locals[x]=null,this._proxies[x]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(x=>this._receiveOneMessage(x))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,_.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:R,sid:B}=T;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,B)),this._proxies[R]}_createProxy(T,R){let B={get:(x,F)=>(typeof F=="string"&&!x[F]&&F.charCodeAt(0)===36&&(x[F]=(...$)=>this._remoteCall(T,F,$)),F===i?R:x[F])};return new Proxy(Object.create(null),B)}set(T,R){return this._locals[T.nid]=R,R}assertRegistered(T){for(let R=0,B=T.length;R<B;R++){const x=T[R];if(!this._locals[x.nid])throw new Error(`Missing actor ${x.sid} (isMain: ${x.isMain})`)}}_receiveOneMessage(T){if(this._isDisposed)return;const R=T.byteLength,B=c.read(T,0),x=B.readUInt8(),F=B.readUInt32();switch(x){case 1:case 2:{let{rpcId:$,method:M,args:H}=o.deserializeRequestJSONArgs(B);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(R,F,$,M,H,x===2);break}case 3:case 4:{let{rpcId:$,method:M,args:H}=o.deserializeRequestMixedArgs(B);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(R,F,$,M,H,x===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let $=o.deserializeReplyOKJSON(B);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(R,F,$);break}case 10:{const $=o.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(R,F,$);break}case 8:{let $=o.deserializeReplyOKVSBuffer(B);this._receiveReply(R,F,$);break}case 11:{let $=o.deserializeReplyErrError(B);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(R,F,$);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,R,B,x,F,$){this._logger&&this._logger.logIncoming(T,R,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(B)}.${x}(`,F);const M=String(R);let H,N;if($){const V=new y.CancellationTokenSource;F.push(V.token),H=this._invokeHandler(B,x,F),N=()=>V.cancel()}else H=this._invokeHandler(B,x,F),N=s;this._cancelInvokedHandlers[M]=N;const U=o.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(U.byteLength,R,1,"ack"),this._protocol.send(U),H.then(V=>{delete this._cancelInvokedHandlers[M];const O=o.serializeReplyOK(R,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"reply:",V),this._protocol.send(O)},V=>{delete this._cancelInvokedHandlers[M];const O=o.serializeReplyErr(R,V);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"replyErr:",V),this._protocol.send(O)})}_receiveCancel(T,R){this._logger&&this._logger.logIncoming(T,R,1,"receiveCancel");const B=String(R);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(T,R,B){this._logger&&this._logger.logIncoming(T,R,0,"receiveReply:",B);const x=String(R);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x],F.resolveOk(B)}_receiveReplyErr(T,R,B){this._logger&&this._logger.logIncoming(T,R,0,"receiveReplyErr:",B);const x=String(R);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x];let $;B&&(B.$isError?($=new Error,$.name=B.name,$.message=B.message,$.stack=B.stack):$=B),F.resolveErr($)}_invokeHandler(T,R,B){try{return Promise.resolve(this._doInvokeHandler(T,R,B))}catch(x){return Promise.reject(x)}}_doInvokeHandler(T,R,B){const x=this._locals[T];if(!x)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(T));let F=x[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,P.getStringIdentifierForProxy)(T));return F.apply(x,B)}_remoteCall(T,R,B){if(this._isDisposed)return Promise.reject(C.canceled());let x=null;if(B.length>0&&y.CancellationToken.isCancellationToken(B[B.length-1])&&(x=B.pop()),x&&x.isCancellationRequested)return Promise.reject(C.canceled());const F=o.serializeRequestArguments(B,this._uriReplacer),$=++this._lastMessageId,M=String($),H=new D.LazyPromise;x&&x.onCancellationRequested(()=>{const U=o.serializeCancel($);this._logger&&this._logger.logOutgoing(U.byteLength,$,0,"cancel"),this._protocol.send(o.serializeCancel($))}),this._pendingRPCReplies[M]=H,this._onWillSendRequest($);const N=o.serializeRequest($,T,R,F,!!x);return this._logger&&this._logger.logOutgoing(N.byteLength,$,0,`request: ${(0,P.getStringIdentifierForProxy)(T)}.${R}(`,B),this._protocol.send(N),H}}e.RPCProtocol=t,I=b,t.UNRESPONSIVE_TIME=3*1e3;class c{constructor(T,R){this._buff=T,this._offset=R}static alloc(T,R,B){let x=new c(L.VSBuffer.alloc(B+1+4),0);return x.writeUInt8(T),x.writeUInt32(R),x}static read(T,R){return new c(T,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,B}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,B}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,R}static sizeMixedArray(T){let R=0;R+=1;for(let B=0,x=T.length;B<x;B++){const F=T[B];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let $=0;$<F.buffers.length;++$)R+=this.sizeVSBuffer(F.buffers[$]);break;case 4:break}}return R}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let R=0,B=T.length;R<B;R++){const x=T[R];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let F=0;F<x.buffers.length;++F)this.writeBuffer(x.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(T);for(let B=0;B<T;B++)switch(this.readUInt8()){case 1:R[B]=this.readLongString();break;case 2:R[B]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),$=this.readLongString(),M=[];for(let H=0;H<F;++H)M.push(this.readVSBuffer());R[B]=new P.SerializableObjectWithBuffers(A($,M,null));break;case 4:R[B]=void 0;break}return R}}c.sizeUInt32=4;var d;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(d||(d={}));class o{static _useMixedArgSerialization(T){for(let R=0,B=T.length;R<B;R++)if(T[R]instanceof L.VSBuffer||T[R]instanceof P.SerializableObjectWithBuffers||typeof T[R]=="undefined")return!0;return!1}static serializeRequestArguments(T,R){if(this._useMixedArgSerialization(T)){const B=[];for(let x=0,F=T.length;x<F;x++){const $=T[x];if($ instanceof L.VSBuffer)B[x]={type:2,value:$};else if(typeof $=="undefined")B[x]={type:4};else if($ instanceof P.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:H}=S($.value,R);B[x]={type:3,value:L.VSBuffer.fromString(M),buffers:H}}else B[x]={type:1,value:L.VSBuffer.fromString(p($,R))}}return{type:1,args:B}}return{type:0,args:p(T,R)}}static serializeRequest(T,R,B,x,F){switch(x.type){case 0:return this._requestJSONArgs(T,R,B,x.args,F);case 1:return this._requestMixedArgs(T,R,B,x.args,F)}}static _requestJSONArgs(T,R,B,x,F){const $=L.VSBuffer.fromString(B),M=L.VSBuffer.fromString(x);let H=0;H+=c.sizeUInt8(),H+=c.sizeShortString($),H+=c.sizeLongString(M);let N=c.alloc(F?2:1,T,H);return N.writeUInt8(R),N.writeShortString($),N.writeLongString(M),N.buffer}static deserializeRequestJSONArgs(T){const R=T.readUInt8(),B=T.readShortString(),x=T.readLongString();return{rpcId:R,method:B,args:JSON.parse(x)}}static _requestMixedArgs(T,R,B,x,F){const $=L.VSBuffer.fromString(B);let M=0;M+=c.sizeUInt8(),M+=c.sizeShortString($),M+=c.sizeMixedArray(x);let H=c.alloc(F?4:3,T,M);return H.writeUInt8(R),H.writeShortString($),H.writeMixedArray(x),H.buffer}static deserializeRequestMixedArgs(T){const R=T.readUInt8(),B=T.readShortString(),x=T.readMixedArray(),F=new Array(x.length);for(let $=0,M=x.length;$<M;$++){const H=x[$];typeof H=="string"?F[$]=JSON.parse(H):F[$]=H}return{rpcId:R,method:B,args:F}}static serializeAcknowledged(T){return c.alloc(5,T,0).buffer}static serializeCancel(T){return c.alloc(6,T,0).buffer}static serializeReplyOK(T,R,B){if(typeof R=="undefined")return this._serializeReplyOKEmpty(T);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(T,R);if(R instanceof P.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:F}=S(R.value,B,!0);return this._serializeReplyOKJSONWithBuffers(T,x,F)}else return this._serializeReplyOKJSON(T,l(R,B))}static _serializeReplyOKEmpty(T){return c.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,R){let B=0;B+=c.sizeVSBuffer(R);let x=c.alloc(8,T,B);return x.writeVSBuffer(R),x.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,R){const B=L.VSBuffer.fromString(R);let x=0;x+=c.sizeLongString(B);let F=c.alloc(9,T,x);return F.writeLongString(B),F.buffer}static _serializeReplyOKJSONWithBuffers(T,R,B){const x=L.VSBuffer.fromString(R);let F=0;F+=c.sizeUInt32,F+=c.sizeLongString(x);for(const M of B)F+=c.sizeVSBuffer(M);let $=c.alloc(10,T,F);$.writeUInt32(B.length),$.writeLongString(x);for(const M of B)$.writeBuffer(M);return $.buffer}static deserializeReplyOKJSON(T){const R=T.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(T,R){const B=T.readUInt32(),x=T.readLongString(),F=[];for(let $=0;$<B;++$)F.push(T.readVSBuffer());return new P.SerializableObjectWithBuffers(A(x,F,R))}static serializeReplyErr(T,R){return R?this._serializeReplyErrEror(T,R):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,R){const B=L.VSBuffer.fromString(l(C.transformErrorForSerialization(R),null));let x=0;x+=c.sizeLongString(B);let F=c.alloc(11,T,x);return F.writeLongString(B),F.buffer}static deserializeReplyErrError(T){const R=T.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(T){return c.alloc(12,T,0).buffer}}var f;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var u;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(u||(u={}))}),define(fe[264],me([0,1,4]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(fe[265],me([0,1,10,9,12,2,4,62,44,222,264]),function(Y,e,m,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,n.createDecorator)("pathService");let I=class zn{constructor(v,h,w,S){this.localUserHome=v,this.remoteAgentService=h,this.environmentService=w,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||y.OS)(),this.resolveUserHome=(async()=>{const A=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=A?.userHome||v})()}get defaultUriScheme(){return zn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(v,h){if(v.remoteAuthority)return m.Schemas.vscodeRemote;const w=(0,k.getVirtualWorkspaceScheme)(h.getWorkspace());if(w)return w;const S=h.getWorkspace().folders[0];if(S)return S.uri.scheme;const A=h.getWorkspace().configuration;return A?A.scheme:m.Schemas.file}async userHome(v){return v?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(v=>v===1?L.win32:L.posix)}async fileURI(v){let h="";if(await this.resolveOS===1&&(v=v.replace(/\\/g,"/")),v[0]==="/"&&v[1]==="/"){const S=v.indexOf("/",2);S===-1?(h=v.substring(2),v="/"):(h=v.substring(2,S),v=v.substring(S)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:h,path:v,query:"",fragment:""})}};I=Ve([$e(1,P.IRemoteAgentService),$e(2,D.IWorkbenchEnvironmentService),$e(3,_.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(fe[69],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(n,k){this.line=n,this.character=k}isBefore(n){return!1}isBeforeOrEqual(n){return!1}isAfter(n){return!1}isAfterOrEqual(n){return!1}isEqual(n){return!1}compareTo(n){return 0}translate(n,k){return new m(0,0)}with(n){return new m(0,0)}}e.Position=m;class L{constructor(n,k,_,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(n,k),this.end=new m(_,D)}contains(n){return!1}isEqual(n){return!1}intersection(n){}union(n){return new L(0,0,0,0)}with(n){return new L(0,0,0,0)}}e.Range=L;var y;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[33],me([0,1,17,31,25,30,8,4,9,16,69,13]),function(Y,e,m,L,y,C,n,k,_,D,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const l="\u27EA ",v=" characters skipped \u27EB",h=(l.length+v.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var w;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var S;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(S=e.QueryType||(e.QueryType={}));function A(U){return!!U.preview}e.resultIsMatch=A;function p(U){return!!U.resource}e.isFileMatch=p;function a(U){return!!U.message}e.isProgressMessage=a;var r;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(r=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=g;class s{constructor(V,O,W){this.ranges=O;const j=Array.isArray(O)?O:[O];if(W&&W.matchLines===1&&b(j)){V=(0,n.getNLines)(V,W.matchLines);let X="",Q=0,de=0;const Se=Math.floor(W.charsPerLine/5),De=[];for(const Pe of j){const Be=Math.max(Pe.startColumn-Se,0),We=Pe.startColumn+W.charsPerLine;if(Be>de+Se+h){const He=l+(Be-de)+v;X+=He+V.slice(Be,We),Q+=Be-(de+He.length)}else X+=V.slice(de,We);De.push(new t(0,Pe.startColumn-Q,Pe.endColumn-Q)),de=We}this.preview={text:X,matches:Array.isArray(this.ranges)?De:De[0]}}else{const X=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:V,matches:(0,m.mapArrayOrNot)(O,Q=>new i(Q.startLineNumber-X,Q.startColumn,Q.endLineNumber-X,Q.endColumn))}}}}e.TextSearchMatch=s;function b(U){const V=U[0].startLineNumber;for(const O of U)if(O.startLineNumber!==V||O.endLineNumber!==V)return!1;return!0}class i{constructor(V,O,W,j){this.startLineNumber=V,this.startColumn=O,this.endLineNumber=W,this.endColumn=j}}e.SearchRange=i;class t extends i{constructor(V,O,W){super(V,O,V,W)}}e.OneLineRange=t;var c;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function d(U,V=!0){const O=U&&U.files&&U.files.exclude,W=V&&U&&U.search&&U.search.exclude;if(!O&&!W)return;if(!O||!W)return O||W;let j=Object.create(null);return j=y.mixin(j,y.deepClone(O)),j=y.mixin(j,y.deepClone(W),!0),j}e.getExcludes=d;function o(U,V){return U.excludePattern&&L.match(U.excludePattern,V)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&L.match(U.includePattern,V)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(O=>{const W=O.folder.fsPath;if(C.isEqualOrParent(V,W)){const j=_.relative(W,V);return!O.includePattern||!!L.match(O.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var f;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(V,O){super(V);this.code=O}}e.SearchError=u;function E(U){const V=U.message;if((0,D.isPromiseCanceledError)(U))return new u(V,f.canceled);try{const O=JSON.parse(V);return new u(O.message,O.code)}catch(O){return new u(V,f.other)}}e.deserializeSearchError=E;function T(U){const V={message:U.message,code:U.code};return new Error(JSON.stringify(V))}e.serializeSearchError=T;function R(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=R;function B(U){return U.type==="success"}e.isSerializedSearchSuccess=B;function x(U){return!!U.path}e.isSerializedFileMatch=x;function F(U,V){const O=U.searchPath?U.searchPath:U.relativePath;return(0,n.fuzzyContains)(O,V)}e.isFilePatternMatch=F;class ${constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function M(U,V){const O={...U||{},...V||{}};return Object.keys(O).filter(W=>{const j=O[W];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=M;class H{constructor(V,O){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let W=V.includePattern;O.includePattern&&(W?W={...W,...O.includePattern}:W=O.includePattern),W&&(this._parsedIncludeExpression=L.parse(W))}matchesExcludesSync(V,O,W){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,O,W))}includedInQuerySync(V,O,W){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,O,W)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,O,W))}includedInQuery(V,O,W){const j=this._parsedExcludeExpression(V,O,W),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(V,O,W):!0;return(0,I.isPromise)(j)?j.then(Q=>Q?!1:X()):X()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=H;function N(U){for(const V in U)if(typeof U[V]!="boolean")return!0;return!1}}),define(fe[35],me([0,1,17,18,21,3,24,10,77,23,8,13,2,168,4,11,188,44,45,26,14,7,33,5]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p,a,r,g,s,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(T,R,B){return new D.ExtUri(x=>o(x,B)).isEqual(T,R)}function t(T,R,B){return i(T.uri,R.uri,B)?0:(0,P.compare)(T.uri.toString(),R.uri.toString())}function c(T,R,B){return T.index!==R.index?T.index<R.index?-1:1:i(T.uri,R.uri,B)?(0,P.compare)(T.name,R.name):(0,P.compare)(T.uri.toString(),R.uri.toString())}function d(T,R,B,x){const F=T.slice(0).sort((M,H)=>B(M,H,x)),$=R.slice(0).sort((M,H)=>B(M,H,x));return(0,m.delta)(F,$,(M,H)=>B(M,H,x))}function o(T,R){const B=R.getCapabilities(T.scheme);return!(B&&B&1024)}class f extends A.Workspace{constructor(R,B,x,F,$,M,H){super(R,x.map(N=>new A.WorkspaceFolder(N)),F,$,H);this._name=B,this._isUntitled=M,this._workspaceFolders=[],this._structure=n.TernarySearchTree.forUris(H),x.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(R,B,x,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:$,name:M,folders:H,configuration:N,transient:U,isUntitled:V}=R,O=[],W=B;B?H.forEach((de,Se)=>{const De=l.URI.revive(de.uri),Pe=f._findFolder(x||B,De,F);Pe?(Pe.name=de.name,Pe.index=de.index,O.push(Pe)):O.push({uri:De,name:de.name,index:Se})}):O.push(...H.map(({uri:de,name:Se,index:De})=>({uri:l.URI.revive(de),name:Se,index:De}))),O.sort((de,Se)=>de.index<Se.index?-1:1);const j=new f($,M,O,!!U,N?l.URI.revive(N):null,!!V,de=>o(de,F)),{added:X,removed:Q}=d(W?W.workspaceFolders:[],j.workspaceFolders,t,F);return{workspace:j,added:X,removed:Q}}static _findFolder(R,B,x){for(let F=0;F<R.folders.length;F++){const $=R.workspaceFolders[F];if(i($.uri,B,x))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,B){return B&&this._structure.get(R)&&(R=(0,D.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let u=class{constructor(R,B,x,F){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=x,this._requestIdProvider=new _.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(b.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(b.MainContext.MainThreadMessageService);const $=B.workspace;this._confirmedWorkspace=$?new f($.id,$.name,[],!!$.transient,$.configuration?l.URI.revive($.configuration):null,!!$.isUntitled,M=>o(M,x)):void 0}$initializeWorkspace(R,B){this._trusted=B,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:k.Schemas.untitled,path:(0,D.basename)((0,D.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,B,x,...F){const $=[];if(Array.isArray(F)&&F.forEach(V=>{l.URI.isUri(V.uri)&&!$.some(O=>i(O.uri,V.uri,this._extHostFileSystemInfo))&&$.push({uri:V.uri,name:V.name||(0,D.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[B,x].some(V=>typeof V!="number"||V<0)||x===0&&$.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+x>M.length)return!1;const H=M.slice(0);H.splice(B,x,...$.map(V=>({uri:V.uri,name:V.name||(0,D.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<H.length;V++){const O=H[V];if(H.some((W,j)=>j!==V&&i(O.uri,W.uri,this._extHostFileSystemInfo)))return!1}H.forEach((V,O)=>V.index=O);const{added:N,removed:U}=d(M,H,c,this._extHostFileSystemInfo);if(N.length===0&&U.length===0)return!1;if(this._proxy){const V=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(V,B,x,$).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(S.Severity.Error,(0,v.localize)(0,null,V,O.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(R,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async getWorkspaceFolder2(R,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,B){let x,F="";if(typeof R=="string"?(x=l.URI.file(R),F=R):typeof R!="undefined"&&(x=R,F=R.fsPath),!x)return F;const $=this.getWorkspaceFolder(x,!0);if(!$)return F;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let M=(0,D.relativePath)($.uri,x);return B&&$.name&&(M=`${$.name}/${M}`),M}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:B,added:x,removed:F}=f.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:x,removed:F}))}findFiles(R,B,x,F,$=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let M;if(B===null?M=!1:B&&(typeof B=="string"?M=B:M=B.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:N}=E(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(H),(0,I.withUndefinedAsNull)(N),(0,I.withUndefinedAsNull)(M),(0,I.withUndefinedAsNull)(x),$).then(U=>Array.isArray(U)?U.map(V=>l.URI.revive(V)):[])}async findTextInFiles(R,B,x,F,$=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),H=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:N,folder:U}=E(B.include),V=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,O={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:H,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:N,excludePattern:V},W=!1;if(this._activeSearchCallbacks[M]=j=>{if(W)return;const X=l.URI.revive(j.resource);j.results.forEach(Q=>{(0,s.resultIsMatch)(Q)?x({uri:X,preview:{text:Q.preview.text,matches:(0,m.mapArrayOrNot)(Q.preview.matches,de=>new g.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,m.mapArrayOrNot)(Q.ranges,de=>new g.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):x({uri:X,text:Q.text,lineNumber:Q.lineNumber})})},$.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(U),O,M,$);return delete this._activeSearchCallbacks[M],j||{}}catch(j){throw delete this._activeSearchCallbacks[M],j}}$handleTextSearchResult(R,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=Ve([$e(0,r.IExtHostRpcService),$e(1,a.IExtHostInitDataService),$e(2,p.IExtHostFileSystemInfo),$e(3,w.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function E(T){let R,B;return T&&(typeof T=="string"?R=T:(R=T.pattern,B=T.baseFolder||l.URI.file(T.base))),{includePattern:R,folder:B}}}),define(fe[36],me([0,1,25,3,35,5,7,192,86,13,18,4,14,11,2]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(b,i){if(i){const t=i.split(".");let c=b;for(let d=0;c&&d<t.length;d++)c=c[t[d]];return c}}function S(b){return b instanceof h.URI}function A(b){return b&&b.uri instanceof h.URI&&b.languageId&&typeof b.languageId=="string"}function p(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function a(b){return b&&b.uri instanceof h.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function r(b){if(S(b))return{resource:b};if(A(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(p(b))return{overrideIdentifier:b.languageId};if(a(b))return{resource:b.uri};if(b===null)return{resource:null}}let g=class{constructor(i,t,c){this._proxy=i.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=c,this._barrier=new P.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new s(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,t){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(i,t))}};g=Ve([$e(0,l.IExtHostRpcService),$e(1,y.IExtHostWorkspace),$e(2,v.ILogService)],g),e.ExtHostConfiguration=g;class s{constructor(i,t,c,d){this._onDidChangeConfiguration=new L.Emitter,this._proxy=i,this._logService=d,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(c),this._configurationScopes=this._toMap(c.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,t){const c={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,c))}getConfiguration(i,t,c){const d=r(t)||{},o=this._toReadonlyValue(i?w(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,d,c?.identifier);function f(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case n.ConfigurationTarget.Global:return 1;case n.ConfigurationTarget.Workspace:return 4;case n.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(E){return typeof w(o,E)!="undefined"},get:(E,T)=>{this._validateConfigurationAccess(i?`${i}.${E}`:E,d,c?.identifier);let R=w(o,E);if(typeof R=="undefined")R=T;else{let B;const x=(F,$)=>{let M;const H=()=>{B=B||(0,m.deepClone)(o),M=M||w(B,$)};return(0,D.isObject)(F)?new Proxy(F,{get:(N,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return H(),()=>M;if(B)return M=M||w(B,$),M[U];const V=N[U];return typeof U=="string"?x(V,`${$}.${U}`):V},set:(N,U,V)=>(H(),M&&(M[U]=V),!0),deleteProperty:(N,U)=>(H(),M&&delete M[U],!0),defineProperty:(N,U,V)=>(H(),M&&Object.defineProperty(M,U,V),!0)}):F};R=x(R,E)}return R},update:(E,T,R,B)=>{E=i?`${i}.${E}`:E;const x=f(R);return T!==void 0?this._proxy.$updateConfigurationOption(x,E,T,d,B):this._proxy.$removeConfigurationOption(x,E,d,B)},inspect:E=>{E=i?`${i}.${E}`:E;const T=(0,m.deepClone)(this._configuration.inspect(E,d,this._extHostWorkspace.workspace));if(T)return{key:E,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof o=="object"&&(0,m.mixin)(u,o,!1),Object.freeze(u)}_toReadonlyValue(i){const t=c=>(0,D.isObject)(c)?new Proxy(c,{get:(d,o)=>t(d[o]),set:(d,o,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(d,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(d,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return t(i)}_validateConfigurationAccess(i,t,c){const d=_.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),o=c?`[${c.value}] `:"";if(d===4){typeof t?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){t?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,t){const c=new k.ConfigurationChangeEvent(i,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,o)=>c.affectsConfiguration(d,r(o))})}_toMap(i){return i.reduce((t,c)=>(t.set(c[0],c[1]),t),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var st=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[70],me([0,1,2,18,3,5,7,35,46,36,21,34,14,26,4,10,12,11,65,212,16]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p,a,r){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var b;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(b=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function($){function M(U){if(U){const V=U;return V&&!!V.process}else return!1}$.is=M;function H(U){if(U==null)return;const V={process:U.process,args:U.args};return U.options&&(V.options=i.from(U.options)),V}$.from=H;function N(U){if(U!=null)return new n.ProcessExecution(U.process,U.args,U.options)}$.to=N})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var c;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(c=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function($){function M(U){if(U){const V=U;return V&&(!!V.commandLine||!!V.command)}else return!1}$.is=M;function H(U){if(U==null)return;const V={};return U.commandLine!==void 0?V.commandLine=U.commandLine:(V.command=U.command,V.args=U.args),U.options&&(V.options=c.from(U.options)),V}$.from=H;function N(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new n.ShellExecution(U.commandLine,U.options):new n.ShellExecution(U.command,U.args?U.args:[],U.options)}$.to=N})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function($){function M(U){if(U){let V=U;return V&&V.customExecution==="customExecution"}else return!1}$.is=M;function H(U){return{customExecution:"customExecution"}}$.from=H;function N(U,V){return V.get(U)}$.to=N})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function($){function M(H,N){let U;return H.scope!==void 0&&typeof H.scope!="number"?U=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===n.TaskScope.Workspace&&N&&N.workspaceFile?U=N.workspaceFile:U=a.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:U}}$.from=M})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function($){function M(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}$.from=M})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function($){function M(U,V){if(U==null)return[];const O=[];for(let W of U){const j=H(W,V);j&&O.push(j)}return O}$.fromMany=M;function H(U,V){if(U==null)return;let O;U.execution instanceof n.ProcessExecution?O=t.from(U.execution):U.execution instanceof n.ShellExecution?O=d.from(U.execution):U.execution&&U.execution instanceof n.CustomExecution&&(O=o.from(U.execution));const W=s.from(U.definition);let j;return U.scope?typeof U.scope=="number"?j=U.scope:j=U.scope.uri:j=n.TaskScope.Workspace,!W||!j?void 0:{_id:U._id,definition:W,name:U.name,source:{extensionId:V.identifier.value,label:U.source,scope:j},execution:O,isBackground:U.isBackground,group:u.from(U.group),presentationOptions:b.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}$.from=H;async function N(U,V,O){if(U==null)return;let W;t.is(U.execution)?W=t.to(U.execution):d.is(U.execution)?W=d.to(U.execution):o.is(U.execution)&&(W=o.to(U._id,O));const j=s.to(U.definition);let X;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?X=U.source.scope:X=await V.resolveWorkspaceFolder(m.URI.revive(U.source.scope)):X=n.TaskScope.Workspace),!j||!X)return;const Q=new n.Task(j,X,U.name,U.source.label,W,U.problemMatchers);return U.isBackground!==void 0&&(Q.isBackground=U.isBackground),U.group!==void 0&&(Q.group=n.TaskGroup.from(U.group._id),Q.group&&U.group.isDefault&&(Q.group=new n.TaskGroup(Q.group.id,Q.group.label),U.group.isDefault&&(Q.group.isDefault=U.group.isDefault))),U.presentationOptions&&(Q.presentationOptions=b.to(U.presentationOptions)),U._id&&(Q._id=U._id),U.detail&&(Q.detail=U.detail),Q}$.to=N})(E=e.TaskDTO||(e.TaskDTO={}));var T;(function($){function M(N){return N}$.from=M;function H(N){if(!!N)return Object.assign(Object.create(null),N)}$.to=H})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(M,H,N){this._id=H,this._task=N,g.set(this,void 0),st(this,g,M,"f")}get task(){return this._task}terminate(){Ne(this,g,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}g=new WeakMap;var B;(function($){function M(H){return{id:H._id,task:void 0}}$.from=M})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(M,H,N,U,V,O,W,j){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=M.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=U,this._configurationService=V,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,H,N){if(!N)return new n.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:H,provider:N,extension:M}),this._proxy.$registerTaskProvider(U,H),new n.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(M,H){this._proxy.$registerTaskSystem(M,H)}fetchTasks(M){return this._proxy.$fetchTasks(T.from(M)).then(async H=>{const N=[];for(let U of H){const V=await E.to(U,this._workspaceProvider,this._providedCustomExecutions2);V&&N.push(V)}return N})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(H=>M.push(H)),M}terminateTask(M){if(!(M instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,H,N){const U=this._providedCustomExecutions2.get(M.id);U&&(this._activeCustomExecutions2.set(M.id,U),this._terminalService.attachPtyToTerminal(H,await U.callback(N))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const H=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const H=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:H,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const H=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:M.exitCode})}$provideTasks(M,H){const N=this._handlers.get(M);if(!N)return Promise.reject(new Error("no handler found"));const U=[],V=(0,L.asPromise)(()=>N.provider.provideTasks(P.CancellationToken.None)).then(O=>this.provideTasksInternal(H,U,N,O));return new Promise(O=>{V.then(W=>{Promise.all(U).then(()=>{O(W)})})})}async $resolveTask(M,H){const N=this._handlers.get(M);if(!N)return Promise.reject(new Error("no handler found"));if(H.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${N.type}].`);const U=await E.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const V=await N.provider.resolveTask(U,P.CancellationToken.None);if(!V)return;this.checkDeprecation(V,N);const O=E.from(V,N.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(O.execution)&&await this.addCustomExecution(O,V,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,H,N){const U=await this._proxy.$createTaskId(M);!N&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,H.execution)),this._providedCustomExecutions2.set(U,H.execution)}async getTaskExecution(M,H){if(typeof M=="string"){const V=this._taskExecutionPromises.get(M);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let N=this._taskExecutionPromises.get(M.id);if(N)return N;const U=new Promise((V,O)=>{function W(j,X,Q){Q?V(new R(j,X.id,Q)):O("Unexpected: Task does not exist.")}H?W(this,M,H):E.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(j=>W(this,M,j))});return this._taskExecutionPromises.set(M.id,U),U.then(V=>(this._taskExecutions.set(M.id,V),V),V=>Promise.reject(V))}checkDeprecation(M,H){M._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let N=this._notProvidedCustomExecutions.values(),U=N.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=N.next()}};x=Ve([$e(0,l.IExtHostRpcService),$e(1,v.IExtHostInitDataService),$e(2,k.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,A.ILogService),$e(7,p.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let F=class extends x{constructor(M,H,N,U,V,O,W,j){super(M,H,N,U,V,O,W,j);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:S.PlatformToString(0)})}async executeTask(M,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const N=E.from(H,M);if(N===void 0)throw new Error("Task is not valid");if(o.is(N.execution))await this.addCustomExecution(N,H,!1);else throw new r.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),H);return this._proxy.$executeTask(N).catch(V=>{throw new Error(V)}),U}provideTasksInternal(M,H,N,U){const V=[];if(U)for(let O of U){this.checkDeprecation(O,N),(!O.definition||!M[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const W=E.from(O,N.extension);W&&o.is(W.execution)?(V.push(W),H.push(this.addCustomExecution(W,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:N.extension}}async resolveTaskInternal(M){if(o.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,H,N){}};F=Ve([$e(0,l.IExtHostRpcService),$e(1,v.IExtHostInitDataService),$e(2,k.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,A.ILogService),$e(7,p.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(fe[266],me([0,1,17,73,31,80,24,10,9,23,8,13,2,145,174,118,44,127,265,33]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let r=class{constructor(f,u,E,T){this.configurationService=f,this.workspaceContextService=u,this.editorGroupsService=E,this.pathService=T}text(f,u,E={}){f=this.getContentPattern(f,E);const T=this.configurationService.getValue(),R=u&&u.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(u?.map(S.toWorkspaceFolder),E),type:2,contentPattern:f,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:T.search.usePCRE2||R||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(f,u){const E=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const T={...f,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(f,u)&&(T.isCaseSensitive=!0),this.isMultiline(f)&&(T.isMultiline=!0),T}file(f,u={}){return{...this.commonQuery(f,u),type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey}}handleIncludeExclude(f,u){return f?(f=Array.isArray(f)?f.map(t):t(f),u?this.parseSearchPaths(f):{pattern:s(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],u={}){const E=this.handleIncludeExclude(u.includePattern,u.expandPatterns),T=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),R=f.length>1,B=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map($=>this.getFolderQueryForSearchPath($,u,T)):f.map($=>this.getFolderQueryForRoot($,u,T,R))).filter($=>!!$),x={_reason:u._reason,folderQueries:B,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:T.pattern,includePattern:E.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const M=m.coalesce(m.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(U=>U.resource)))).filter(N=>(0,a.pathIncludedInQuery)(x,N.fsPath)),H=this.commonQueryFromFileList(M);return{...x,...H}}const F=u.extraFileResources&&u.extraFileResources.filter($=>(0,a.pathIncludedInQuery)(x,$.fsPath));return x.extraFileResources=F&&F.length?F:void 0,x}commonQueryFromFileList(f){const u=[],E=new n.ResourceMap,T={};let R=!1;return f.forEach(B=>{if(B.scheme===k.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(B)){const F=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:_.dirname(B.fsPath)});let $=E.get(F);$||(R=!0,$={folder:F,includePattern:{}},u.push($),E.set(F,$));const M=_.relative(F.fsPath,B.fsPath);(0,I.assertIsDefined)($.includePattern)[M.replace(/\\/g,"/")]=!0}else B.fsPath&&(R=!0,T[B.fsPath]=!0)}),{folderQueries:u,includePattern:T,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(f,u){if(u.isSmartCase){if(f.isRegExp){if(P.containsUppercaseCharacter(f.pattern,!0))return!0}else if(P.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,v.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const u=H=>_.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),T=(Array.isArray(f)?f:b(f)).map(H=>{const N=this.pathService.resolvedUserHome;return N?(0,C.untildify)(H,N.scheme===k.Schemas.file?N.fsPath:N.path):H}),R=L.groupBy(T,H=>u(H)?"searchPaths":"exprSegments"),B=(R.exprSegments||[]).map(H=>P.rtrim(H,"/")).map(H=>P.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),i(H))),x={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(x.searchPaths=F);const $=m.flatten(B),M=s(...$);return M&&(x.pattern=M),x}getExcludesForFolder(f,u){return u.disregardExcludeSettings?void 0:(0,a.getExcludes)(f,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const u=m.flatten(f.map(T=>{let{pathPortion:R,globPortion:B}=g(T);B&&(B=c(B));const x=this.expandOneSearchPath(R);return m.flatten(x.map(F=>this.resolveOneSearchPathPattern(F,B)))})),E=new Map;return u.forEach(T=>{const R=T.searchPath.toString(),B=E.get(R);B?T.pattern&&(B.pattern=B.pattern||{},B.pattern[T.pattern]=!0):E.set(R,{searchPath:T.searchPath,pattern:T.pattern?s(T.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(f){if(_.isAbsolute(f)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==k.Schemas.file?[{searchPath:u[0].uri.with({path:f})}]:[{searchPath:l.URI.file(_.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=t(f),f.startsWith("../")||f===".."){const T=_.posix.resolve(u.path,f);return[{searchPath:u.with({path:T})}]}const E=c(f);return[{searchPath:u,pattern:E}]}else{if(f==="./"||f===".\\")return[];{const u=f.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(R=>{const B=u.match(new RegExp(`^${P.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return B?{match:B,folder:R}:null}).filter(I.isDefined);if(T.length)return T.map(R=>{const B=R.match[1];return{searchPath:R.folder.uri,pattern:B&&c(B)}});{const R=f.match(/\.[\/\\](.+)[\/\\]?/),B=R?R[1]:f,x=h.localize(0,null,B);throw new Error(x)}}}}resolveOneSearchPathPattern(f,u){const E=f.pattern&&u?`${f.pattern}/${u}`:f.pattern||u,T=[{searchPath:f.searchPath,pattern:E}];return E&&!E.endsWith("**")&&T.push({searchPath:f.searchPath,pattern:E+"/**"}),T}getFolderQueryForSearchPath(f,u,E){const T=this.getFolderQueryForRoot((0,S.toWorkspaceFolder)(f.searchPath),u,E,!1);return T?{...T,includePattern:f.pattern}:null}getFolderQueryForRoot(f,u,E,T){let R;const B=l.URI.isUri(f)?f:f.uri;if(E.searchPaths){const H=E.searchPaths.filter(N=>(0,D.isEqual)(N.searchPath,B))[0];if(H&&!H.pattern)return null;H&&(R=H.pattern)}const x=this.configurationService.getValue({resource:B}),$={...this.getExcludesForFolder(x,u)||{},...R||{}},M=l.URI.isUri(f)?(0,D.basename)(f):f.name;return{folder:B,folderName:T?M:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!x.search.followSymlinks}}};r=Ve([$e(0,w.IConfigurationService),$e(1,S.IWorkspaceContextService),$e(2,A.IEditorGroupsService),$e(3,p.IPathService)],r),e.QueryBuilder=r;function g(o){const f=o.match(/[\*\{\}\(\)\[\]\?]/);if(f){const u=f.index,E=o.substr(0,u).match(/[/|\\][^/\\]*$/);if(E){let T=o.substr(0,E.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:o.substr((E.index||0)+1)}}}return{pathPortion:o}}function s(...o){return o.length?o.reduce((f,u)=>(f[u]=!0,f),Object.create(null)):void 0}function b(o){return y.splitGlobAware(o,",").map(f=>f.trim()).filter(f=>!!f.length)}function i(o){return[`**/${o}/**`,`**/${o}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function t(o){return o.replace(/\\/g,"/")}function c(o){return t(o).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(o,f){o=m.distinct(o,T=>T.toString());const u=[],E=f.getWorkspace();return o&&o.forEach(T=>{let R;if(f.getWorkbenchState()===2)R=(0,D.relativePath)(E.folders[0].uri,T),R&&R!=="."&&(R="./"+R);else{const B=f.getWorkspaceFolder(T);if(B){const x=B.name;if(E.folders.filter($=>$.name===x).length===1){const $=(0,D.relativePath)(B.uri,T);$===""?R=`./${B.name}`:R=`./${B.name}/${$}`}else R=T.fsPath}}R&&u.push(R)}),u}e.resolveResourcesForSearchIncludes=d}),define(fe[267],me([0,1,23,2,21,16,4,266,33,44]),function(Y,e,m,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const P=7e3;function I(w,S){const A=S.activationEvents;if(!A)return Promise.resolve(void 0);const p=[],a=[];for(const t of A)if(/^workspaceContains:/.test(t)){const c=t.substr("workspaceContains:".length);c.indexOf("*")>=0||c.indexOf("?")>=0||w.forceUsingSearch?a.push(c):p.push(c)}if(p.length===0&&a.length===0)return Promise.resolve(void 0);let r;const g=new Promise((t,c)=>{r=t}),s=t=>r({activationEvent:t}),b=Promise.all(p.map(t=>l(w,t,s))).then(()=>{}),i=v(w,S.identifier,a,s);return Promise.all([b,i]).then(()=>{r(void 0)}),g}e.checkActivateWorkspaceContainsExtension=I;async function l(w,S,A){for(const p of w.folders)if(await w.exists(m.joinPath(L.URI.revive(p),S))){A(`workspaceContains:${S}`);return}}async function v(w,S,A,p){if(A.length===0)return Promise.resolve(void 0);const a=new y.CancellationTokenSource,r=w.checkExists(w.folders,A,a.token),g=setTimeout(async()=>{a.cancel(),p(`workspaceContainsTimeout:${A.join(",")}`)},P);let s=!1;try{s=await r}catch(b){C.isPromiseCanceledError(b)||C.onUnexpectedError(b)}a.dispose(),clearTimeout(g),s&&p(`workspaceContains:${A.join(",")}`)}function h(w,S,A,p){const a=w.get(n.IInstantiationService),r=w.get(_.ISearchService),s=a.createInstance(k.QueryBuilder).file(S.map(b=>(0,D.toWorkspaceFolder)(L.URI.revive(b))),{_reason:"checkExists",includePattern:A,exists:!0});return r.fileSearch(s,p).then(b=>!!b.limitHit,b=>C.isPromiseCanceledError(b)?!1:Promise.reject(b))}e.checkGlobFileExists=h});var st=this&&this.__classPrivateFieldSet||function(Y,e,m,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,m):y?y.value=m:e.set(Y,m),m},Ne=this&&this.__classPrivateFieldGet||function(Y,e,m,L){if(m==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?L:m==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[40],me([0,1,163,9,71,23,18,6,24,2,11,5,36,225,92,35,29,223,16,27,22,198,7,119,4,26,67,14,85,52,34,3,267,91,200,10]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p,a,r,g,s,b,i,t,c,d,o,f,u,E,T,R,B,x){"use strict";var F,$,M;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let H=class Vn extends k.Disposable{constructor(O,W,j,X,Q,de,Se,De,Pe,Be){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=W,this._extHostContext=j,this._initData=Se,this._extHostWorkspace=X,this._extHostConfiguration=Q,this._logService=de,this._extHostTunnelService=Pe,this._extHostTerminalService=Be,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new n.Barrier,this._readyToStartExtensionHost=new n.Barrier,this._readyToRunExtensions=new n.Barrier,this._eagerExtensionsActivated=new n.Barrier,this._registry=new A.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=De,this._instaService=O.createChild(new o.ServiceCollection([h.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(He=>We.add(a.ExtensionIdentifier.toKey(He))),this._activator=new v.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,G,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,p.transformErrorForSerialization(G),ee)},actualActivateExtension:async(He,G)=>{if(We.has(a.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,G),new v.HostExtension;const ee=this._registry.getExtensionDescription(He);return this._activateExtension(ee,G)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){p.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(W){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,W){return this._activator.activateByEvent(O,W)}_activateById(O,W){return this._activator.activateById(O,W)}activateByIdWithErrors(O,W){return this._activateById(O,W).then(()=>{const j=this._activator.getActivatedExtension(O);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}async _realPathExtensionUri(O){if(O.scheme!==x.Schemas.file)return O;const W=await this._hostUtils.realpath(O.fsPath);return D.URI.file(W)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const O=_.TernarySearchTree.forUris(W=>C.extUriBiasedIgnorePathCase.ignorePathCasing(W));for(const W of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(W)){const j=await this._realPathExtensionUri(W.extensionLocation);O.set(j,W)}return O})()),this._extensionPathIndex}_deactivate(O){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return W;const j=this._activator.getActivatedExtension(O);if(!j)return W;try{typeof j.module.deactivate=="function"&&(W=Promise.resolve(j.module.deactivate()).then(void 0,X=>(this._logService.error(X),Promise.resolve(void 0))))}catch(X){this._logService.error(X)}try{(0,k.dispose)(j.subscriptions)}catch(X){this._logService.error(X)}return W}async _activateExtension(O,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,W).then(j=>{const X=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,W),this._logExtensionActivationTimes(O,W,"success",X),j},j=>{throw this._logExtensionActivationTimes(O,W,"failure"),j})}_logExtensionActivationTimes(O,W,j,X){const Q=N(O,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...X||{},outcome:j})}_doActivateExtension(O,W){const j=N(O,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new v.EmptyExtension(v.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${O.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this._logService.flush();const Q=new v.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,C.joinPath)(O.extensionLocation,X),Q),this._loadExtensionContext(O)]).then(de=>(y.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),Vn._callActivate(this._logService,O.identifier,de[0],de[1],Q))).then(de=>(y.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),de))}_loadExtensionContext(O){const W=new g.ExtensionGlobalMemento(O,this._storage),j=new g.ExtensionMemento(O.identifier.value,!1,this._storage),X=new B.ExtensionSecrets(O,this._secretState),Q=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,de=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([W.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const Se=this;let De;return Object.freeze({globalState:W,workspaceState:j,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Pe){return L.join(O.extensionLocation.fsPath,Pe)},get storagePath(){return Se._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return Se._storagePath.globalValue(O).fsPath},get logPath(){return L.join(Se._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return D.URI.joinPath(Se._initData.logsLocation,O.identifier.value)},get storageUri(){return Se._storagePath.workspaceValue(O)},get globalStorageUri(){return Se._storagePath.globalValue(O)},get extensionMode(){return Q},get extension(){return De===void 0&&(De=new U(Se,O.identifier,O,de)),De},get extensionRuntime(){return(0,S.checkProposedApiEnabled)(O,"extensionRuntime"),Se.extensionRuntime},get environmentVariableCollection(){return Se._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,W,j,X,Q){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,W,j,X,Q).then(de=>new v.ActivatedExtension(!1,null,Q.build(),j,de,X.subscriptions))}static _callActivateOptional(O,W,j,X,Q){if(typeof j.activate=="function")try{Q.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${W.value}`);const de=typeof global=="object"?global:self,Se=j.activate.apply(de,[X]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(Se).then(De=>(Q.activateResolveStop(),De))}catch(de){return Promise.reject(de)}else return Promise.resolve(j)}_activateOneStartupFinished(O,W){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:W}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const W of O.activationEvents)W==="onStartupFinished"&&this._activateOneStartupFinished(O,W)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(W),X=Promise.all([O,j]).then(()=>{});return Promise.race([X,(0,n.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(O,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,W){if(this.isActivated(W.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(de=>de.uri),forceUsingSearch:j,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,Se,De)=>this._mainThreadWorkspaceProxy.$checkExists(de,Se,De)},Q=await(0,T.checkActivateWorkspaceContainsExtension)(X,W);if(!!Q)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:Q.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:W}=this._initData.environment;if(!O||!W)throw new Error(m.localize(0,null));const j=await this._loadCommonJSModule(null,W,new v.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(m.localize(1,null,W.toString()));return new Promise((X,Q)=>{const de=(Pe,Be)=>{Pe?Q(Pe):X(typeof Be=="number"&&Be>0?1:0)},Se=(0,C.originalFSPath)(W),De=j.run(Se,de);De&&De.then&&De.then(()=>{X(0)}).catch(Pe=>{Q(Pe.toString())})})}async $extensionTestsExit(O){this._logService.info(`Extension host terminating: test runner requested exit with code ${O}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(O,W){return this._resolvers[O]=W,(0,k.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const W=O.indexOf("+");if(W===-1)throw new Error("Not an authority that can be resolved!");const j=O.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(O,W){const{authorityPrefix:j,resolver:X}=await this._activateAndGetResolver(O);if(!X)return{type:"error",error:{code:b.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(X)),y.mark(`code/extHost/willResolveAuthority/${j}`);const Q=await X.resolve(O,{resolveAttempt:W});y.mark(`code/extHost/didResolveAuthorityOK/${j}`);const de={authority:O,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},Se={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted,authenticationSession:Q.authenticationSessionForInitializingExtensions?{id:Q.authenticationSessionForInitializingExtensions.id,providerId:Q.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:de,options:Se,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(y.mark(`code/extHost/didResolveAuthorityError/${j}`),Q instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(O,W){const{authorityPrefix:j,resolver:X}=await this._activateAndGetResolver(O);if(!X)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const Q=D.URI.revive(W);if(typeof X.getCanonicalURI=="undefined")return Q;const de=await(0,n.asPromise)(()=>X.getCanonicalURI(Q));return de||Q}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,W){return W===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(O,!1))}async $activate(O,W){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,W),!0):!1}async $deltaExtensions(O,W){O.forEach(X=>X.extensionLocation=D.URI.revive(X.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(W.map(async X=>{const Q=this._registry.getExtensionDescription(X);Q&&j.delete(await this._realPathExtensionUri(Q.extensionLocation))})),await Promise.all(O.map(async X=>{const Q=await this._realPathExtensionUri(X.extensionLocation);j.set(Q,X)})),this._registry.deltaExtensions(O,W),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let W=r.VSBuffer.alloc(O),j=Math.random()%256;for(let X=0;X<O;X++)W.writeUInt8(j,X);return W}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};H=Ve([$e(0,i.IInstantiationService),$e(1,e.IHostUtils),$e(2,d.IExtHostRpcService),$e(3,w.IExtHostWorkspace),$e(4,l.IExtHostConfiguration),$e(5,P.ILogService),$e(6,t.IExtHostInitDataService),$e(7,c.IExtensionStoragePaths),$e(8,f.IExtHostTunnelService),$e(9,u.IExtHostTerminalService)],H),e.AbstractExtHostExtensionService=H;function N(V,O){return{id:V.identifier.value,name:V.name,extensionVersion:V.version,publisherDisplayName:V.publisher,activationEvents:V.activationEvents?V.activationEvents.join(","):null,isBuiltin:V.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class U{constructor(O,W,j,X){F.set(this,void 0),$.set(this,void 0),M.set(this,void 0),st(this,F,O,"f"),st(this,$,W,"f"),st(this,M,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=X}get isActive(){return Ne(this,F,"f").isActivated(Ne(this,M,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ne(this,F,"f").getExtensionExports(Ne(this,M,"f"))}activate(){return Ne(this,F,"f").activateByIdWithErrors(Ne(this,M,"f"),{startup:!1,extensionId:Ne(this,$,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=U,F=new WeakMap,$=new WeakMap,M=new WeakMap}),define(fe[55],me([0,1,9,2,3,18,5,7,123,35,40,46,214,36,207,14,4,13,37,54]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let r=class{constructor(o,f,u,E,T,R){this._workspaceService=f,this._extensionService=u,this._editorsService=E,this._configurationService=T,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=o.getProxy(n.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new s(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(x=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,f){const u=o;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let E=`debug:${encodeURIComponent(u.path||"")}`,T="?";return f&&(E+=`${T}session=${encodeURIComponent(f.id)}`,T="&"),E+=`${T}ref=${u.sourceReference}`,L.URI.parse(E)}else{if(u.path)return L.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const f=[];for(const u of o.getAllExtensionDescriptions())if(u.contributes){const E=u.contributes.debuggers;if(E&&E.length>0)for(const T of E)(0,h.isDebuggerMainContribution)(T)&&f.push(T.type)}this._debugServiceProxy.$registerDebugTypes(f)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(f=>o.push(f)),o}addBreakpoints(o){this.startBreakpoints();const f=o.filter(T=>{const R=T.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,T),!0)});this.fireBreakpointChanges(f,[],[]);const u=[],E=new Map;for(const T of f)if(T instanceof k.SourceBreakpoint){let R=E.get(T.location.uri.toString());R||(R={type:"sourceMulti",uri:T.location.uri,lines:[]},E.set(T.location.uri.toString(),R),u.push(R)),R.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof k.FunctionBreakpoint&&u.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(o){this.startBreakpoints();const f=o.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],f,[]);const u=f.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),E=f.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),T=f.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(u,E,T)}startDebugging(o,f,u){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,f,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,f,u){if(!f)return new k.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:E,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,u,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,E),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(o,f,u){if(!u)return new k.Disposable(()=>{});if(!this.definesDebugType(o,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:E,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,E),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(o,f){if(!f)return new k.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:u,factory:f}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==f)})}async $runInTerminal(o,f){return Promise.resolve(void 0)}async $substituteVariables(o,f){if(!this._variableResolver){const[T,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,R)}let u;const E=await this.getFolder(o);return E&&(u={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,f)}createDebugAdapter(o,f){if(o.type==="implementation")return new t(o.implementation)}createSignService(){}async $startDASession(o,f){const u=this,E=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const R=this.convertToDto(T),B=this.createDebugAdapter(R,E);if(!B)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const x=B;return this._debugAdapters.set(o,x),this.getDebugAdapterTrackers(E).then(F=>(F&&this._debugAdaptersTrackers.set(o,F),x.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const M=$,H={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(M.arguments.value);H.body={signature:N},x.sendResponse(H)}else throw new Error("no signer")}catch(N){H.success=!1,H.message=N.message,x.sendResponse(H)}}else F&&F.onDidSendMessage&&F.onDidSendMessage($),$=(0,h.convertToVSCPaths)($,!0),u._debugServiceProxy.$acceptDAMessage(o,$)}),x.onError($=>{F&&F.onError&&F.onError($),this._debugServiceProxy.$acceptDAError(o,$.name,$.message,$.stack)}),x.onExit($=>{F&&F.onExit&&F.onExit((0,A.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,A.withNullAsUndefined)($),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),x.startSession()))})}$sendDAMessage(o,f){f=(0,h.convertToDAPaths)(f,!1);const u=this._debugAdaptersTrackers.get(o);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(f);const E=this._debugAdapters.get(o);E&&E.sendMessage(f)}$stopDASession(o){const f=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),f&&f.onWillStopSession&&f.onWillStopSession();const u=this._debugAdapters.get(o);return this._debugAdapters.delete(o),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const f=[],u=[],E=[];if(o.added)for(const T of o.added){const R=T.id;if(R&&!this._breakpoints.has(R)){let B;if(T.type==="function")B=new k.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")B=new k.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const x=L.URI.revive(T.uri);B=new k.SourceBreakpoint(new k.Location(x,new k.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}B._id=R,this._breakpoints.set(R,B),f.push(B)}}if(o.removed)for(const T of o.removed){const R=this._breakpoints.get(T);R&&(this._breakpoints.delete(T),u.push(R))}if(o.changed){for(const T of o.changed)if(T.id){const R=this._breakpoints.get(T.id);if(R){if(R instanceof k.FunctionBreakpoint&&T.type==="function"){const B=R;B.enabled=T.enabled,B.condition=T.condition,B.hitCondition=T.hitCondition,B.logMessage=T.logMessage,B.functionName=T.functionName}else if(R instanceof k.SourceBreakpoint&&T.type==="source"){const B=R;B.enabled=T.enabled,B.condition=T.condition,B.hitCondition=T.hitCondition,B.logMessage=T.logMessage,B.location=new k.Location(L.URI.revive(T.uri),new k.Position(T.line,T.character))}E.push(R)}}}this.fireBreakpointChanges(f,u,E)}$provideDebugConfigurations(o,f,u){return(0,C.asPromise)(async()=>{const E=this.getConfigProviderByHandle(o);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(f);return E.provideDebugConfigurations(T,u)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(o,f,u,E){return(0,C.asPromise)(async()=>{const T=this.getConfigProviderByHandle(o);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(f);return T.resolveDebugConfiguration(R,u,E)})}$resolveDebugConfigurationWithSubstitutedVariables(o,f,u,E){return(0,C.asPromise)(async()=>{const T=this.getConfigProviderByHandle(o);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(f);return T.resolveDebugConfigurationWithSubstitutedVariables(R,u,E)})}async $provideDebugAdapter(o,f){const u=this.getAdapterDescriptorFactoryByHandle(o);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(f);return this.getAdapterDescriptor(u,E).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(o){const f=await this.getSession(o);this._onDidStartDebugSession.fire(f)}async $acceptDebugSessionTerminated(o){const f=await this.getSession(o);f&&(this._onDidTerminateDebugSession.fire(f),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,f){const u=await this.getSession(o);u&&u._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(o,f){const E={session:await this.getSession(o),event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(o){if(o instanceof k.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof k.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const f=this._adapterFactories.filter(u=>u.type===o);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(o){const f=this._adapterFactories.filter(u=>u.handle===o);if(f.length>0)return f[0].factory}getConfigProviderByHandle(o){const f=this._configProviders.filter(u=>u.handle===o);if(f.length>0)return f[0].provider}definesDebugType(o,f){if(o.contributes){const u=o.contributes.debuggers;if(u&&u.length>0){for(const E of u)if(E.label&&E.type&&E.type===f)return!0}}return!1}getDebugAdapterTrackers(o){const u=o.configuration.type,E=this._trackerFactories.filter(T=>T.type===u||T.type==="*").map(T=>(0,C.asPromise)(()=>T.factory.createDebugAdapterTracker(o)).then(R=>R,R=>null));return Promise.race([Promise.all(E).then(T=>{const R=T.filter(B=>!!B);if(R.length>0)return new i(R)}),new Promise((T,R)=>{const B=setTimeout(()=>{clearTimeout(B),R(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(o,f){const u=f.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new k.DebugAdapterServer(u));if(o){const T=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>o.createDebugAdapterDescriptor(f,this.daExecutableFromPackage(f,T))).then(R=>{if(R)return R})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,E))}daExecutableFromPackage(o,f){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,f,u){(o.length>0||f.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:f,changed:u}))}async getSession(o){if(o)if(typeof o=="string"){const f=this._debugSessions.get(o);if(f)return f}else{let f=this._debugSessions.get(o.id);if(!f){const u=await this.getFolder(o.folderUri),E=o.parent?this._debugSessions.get(o.parent):void 0;f=new g(this._debugServiceProxy,o.id,o.type,o.name,u,o.configuration,E),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(o){if(o){const f=L.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}};r=Ve([$e(0,w.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,v.IExtHostConfiguration),$e(5,a.IExtHostEditorTabs)],r),e.ExtHostDebugServiceBase=r;class g{constructor(o,f,u,E,T,R,B){this._debugServiceProxy=o,this._id=f,this._type=u,this._name=E,this._workspaceFolder=T,this._configuration=R,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,f){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,f)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=g;class s{constructor(o){this.value=Object.freeze({append(f){o.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=s;class b extends l.AbstractVariableResolverService{constructor(o,f,u,E,T){function R(){if(f){const B=f.activeEditor();if(B)return B.document.uri;const x=E.tabs.filter(F=>F.isActive);if(x.length>0){const F=x[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:x[0].resource}}}super({getFolderUri:B=>{const x=o.filter(F=>F.name===B);if(x&&x.length>0)return x[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(B,x)=>u.getConfiguration(void 0,B).get(x),getAppRoot:()=>p.cwd(),getExecPath:()=>p.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=R();if(B)return m.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const B=R();if(B){const x=T.getWorkspaceFolder(B);if(x)return m.normalize(x.uri.fsPath)}}},getSelectedText:()=>{if(f){const B=f.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(f){const B=f.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(p.env))}}e.ExtHostVariableResolverService=b;class i{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(f=>f.onError?f.onError(o):void 0)}onExit(o,f){this.trackers.forEach(u=>u.onExit?u.onExit(o,f):void 0)}}class t extends _.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let c=class extends r{constructor(o,f,u,E,T,R){super(o,f,u,E,T,R)}createVariableResolver(o,f,u){return new b(o,f,u,this._editorTabs)}};c=Ve([$e(0,w.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,v.IExtHostConfiguration),$e(5,a.IExtHostEditorTabs)],c),e.WorkerExtHostDebugService=c}),define(fe[268],me([0,1,71,2,5,36,29,27,14,26,4,40,37,11]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(a,r,g,s,b,i,t){this._apiFactory=a,this._extensionRegistry=r,this._instaService=g,this._extHostConfiguration=s,this._extHostExtensionService=b,this._initData=i,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const a=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,r,this._extensionRegistry,a,this._logService)),this.register(this._instaService.createInstance(S,r)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(A,r,this._initData.environment.appUriScheme))}register(a){if(Array.isArray(a.nodeModuleName))for(let r of a.nodeModuleName)this._factories.set(r,a);else this._factories.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this._alternatives.push(r=>a.alternativeModuleName(r))}};h=Ve([$e(2,P.IInstantiationService),$e(3,C.IExtHostConfiguration),$e(4,I.IExtHostExtensionService),$e(5,D.IExtHostInitDataService),$e(6,v.ILogService)],h),e.RequireInterceptor=h;class w{constructor(a,r,g,s,b){this._apiFactory=a,this._extensionPaths=r,this._extensionRegistry=g,this._configProvider=s,this._logService=b,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(a,r){const g=this._extensionPaths.findSubstr(r);if(g){let s=this._extApiImpl.get(k.ExtensionIdentifier.toKey(g.identifier));return s||(s=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(g.identifier),s)),s}if(!this._defaultApiImpl){let s="";this._extensionPaths.forEach((b,i)=>s+=`	${i} -> ${b.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${s}`),this._defaultApiImpl=this._apiFactory(n.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(a,r,g){this._extensionPaths=a,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(y.MainContext.MainThreadTelemetry);const{environment:s}=g,b=r.getProxy(y.MainContext.MainThreadKeytar);if(s.appRoot){let i=s.appRoot.fsPath;l.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,t)=>b.$getPassword(i,t),setPassword:(i,t,c)=>b.$setPassword(i,t,c),deletePassword:(i,t)=>b.$deletePassword(i,t),findPassword:i=>b.$findPassword(i),findCredentials(i){return b.$findCredentials(i)}}}load(a,r){const g=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:g?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(a){const r=a.length;if(r<=7||!this.alternativeNames)return;const g=r-7;if((a.charAt(g)==="/"||a.charAt(g)==="\\")&&a.endsWith("keytar")&&(a=a.replace(/\\/g,"/"),this.alternativeNames.has(a)))return"keytar"}};S=Ve([$e(1,_.IExtHostRpcService),$e(2,D.IExtHostInitDataService)],S);let A=class{constructor(a,r,g){this._extensionPaths=a,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(y.MainContext.MainThreadTelemetry);const s=g.getProxy(y.MainContext.MainThreadWindow);this._impl=(b,i)=>{const t=L.URI.parse(b);return i?this.callOriginal(b,i):t.scheme==="http"||t.scheme==="https"?s.$openUri(t,b,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?s.$openUri(t,b,{}):this.callOriginal(b,i)}}load(a,r,g){const s=this._extensionPaths.findSubstr(r);return s&&(this._extensionId=s.identifier.value,this.sendShimmingTelemetry()),this._original=g(a),this._impl}callOriginal(a,r){return this.sendNoForwardTelemetry(),this._original(a,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};A=Ve([$e(2,_.IExtHostRpcService)],A)}),define(fe[269],me([0,1,169,12,7,208,35,40,46,36,34,14,55,194,18,209,54]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let A=class extends l.ExtHostDebugServiceBase{constructor(r,g,s,b,i,t,c){super(r,g,s,b,i,c);this._terminalService=t,this._integratedTerminalInstances=new p}createDebugAdapter(r,g){switch(r.type){case"server":return new C.SocketDebugAdapter(r);case"pipeServer":return new C.NamedPipeDebugAdapter(r);case"executable":return new C.ExecutableDebugAdapter(r,g.type)}return super.createDebugAdapter(r,g)}daExecutableFromPackage(r,g){const s=C.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),r.type);if(s)return new y.DebugAdapterExecutable(s.command,s.args,s.options)}createSignService(){return new v.SignService}async $runInTerminal(r,g){if(r.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const s=await this._configurationService.getConfigProvider(),b=this._terminalService.getDefaultShell(!0),i=this._terminalService.getDefaultShellArgs(!0),t=r.title||m.localize(0,null),c=JSON.stringify({shell:b,shellArgs:i});let d=await this._integratedTerminalInstances.checkout(c,t),o,f=!1;if(d)o=r.cwd;else{const R={shellPath:b,shellArgs:i,cwd:r.cwd,name:t,iconPath:new y.ThemeIcon("debug")};f=!0,d=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(d,c)}d.show(!0);const u=await d.processId;f?await new Promise(R=>setTimeout(R,1e3)):s.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0||b.indexOf("cmd.exe")>=0?d.sendText("cls"):b.indexOf("bash")>=0?d.sendText("clear"):L.isWindows?d.sendText("cls"):d.sendText("clear"));const E=(0,w.prepareCommand)(b,r.args,o,r.env);d.sendText(E);const T=this.onDidTerminateDebugSession(R=>{R.id===g&&(this._integratedTerminalInstances.free(d),T.dispose())});return u}else if(r.kind==="external")return(0,w.runInExternalTerminal)(r,await this._configurationService.getConfigProvider());return super.$runInTerminal(r,g)}createVariableResolver(r,g,s){return new l.ExtHostVariableResolverService(r,g,s,this._editorTabs,this._workspaceService)}};A=Ve([$e(0,I.IExtHostRpcService),$e(1,n.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,S.IExtHostEditorTabs)],A),e.ExtHostDebugService=A;class p{constructor(){this._terminalInstances=new Map}async checkout(r,g){const b=[...this._terminalInstances.entries()].map(([i,t])=>(0,h.createCancelablePromise)(async c=>{if(i.name!==g||t.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await i.processId))return null;const d=Date.now();return t.lastUsedAt+p.minUseDelay>d||c.isCancellationRequested||t.config!==r?null:(t.lastUsedAt=d,i)}));return await(0,h.firstParallel)(b,i=>!!i)}insert(r,g){this._terminalInstances.set(r,{lastUsedAt:Date.now(),config:g})}free(r){const g=this._terminalInstances.get(r);g&&(g.lastUsedAt=-1)}onTerminalClosed(r){this._terminalInstances.delete(r)}}p.minUseDelay=1e3}),define(fe[270],me([0,1,9,2,113,35,55,46,36,44,34,14,26,70,10,11,65,54,23,81]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let r=class extends v.ExtHostTaskBase{constructor(s,b,i,t,c,d,o,f,u){super(s,b,i,t,c,d,o,f);this.workspaceService=i,this.editorTabs=u,b.remote.isRemote&&b.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:b.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,b){const i=b;if(!b.execution&&i._id===void 0)throw new Error("Tasks to execute must include an execution");if(i._id!==void 0){const t=v.TaskHandleDTO.from(i,this.workspaceService),c=await this._proxy.$getTaskExecution(t);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const d=await this.getTaskExecution(c,b);return this._proxy.$executeTask(t).catch(()=>{}),d}else{const t=v.TaskDTO.from(b,s);if(t===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,b,!1);const c=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),b);return this._proxy.$executeTask(t).catch(()=>{}),c}}provideTasksInternal(s,b,i,t){const c=[];if(t)for(let d of t){this.checkDeprecation(d,i),(!d.definition||!s[d.definition.type])&&this._logService.warn(`The task [${d.source}, ${d.name}] uses an undefined task type. The task will be ignored in the future.`);const o=v.TaskDTO.from(d,i.extension);o&&(c.push(o),v.CustomExecutionDTO.is(o.execution)&&b.push(this.addCustomExecution(o,d,!0)))}return{tasks:c,extension:i.extension}}async resolveTaskInternal(s){return s}async getVariableResolver(s){if(this._variableResolver===void 0){const b=await this._configurationService.getConfigProvider();this._variableResolver=new n.ExtHostVariableResolverService(s,this._editorService,b,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(s){let b=s&&s.length>0?s[0]:void 0;if(!b){const i=L.URI.file((0,a.homedir)());b=new D.WorkspaceFolder({uri:i,name:p.basename(i),index:0})}return{uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,b){const i=L.URI.revive(s),t={process:void 0,variables:Object.create(null)},c=await this._workspaceProvider.resolveWorkspaceFolder(i),d=await this._workspaceProvider.getWorkspaceFolders2()??[],o=await this.getVariableResolver(d),f=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(d);for(let u of b.variables)t.variables[u]=await o.resolveAsync(f,u);if(b.process!==void 0){let u;if(b.process.path!==void 0){u=b.process.path.split(m.delimiter);for(let E=0;E<u.length;E++)u[E]=await o.resolveAsync(f,u[E])}t.process=await y.win32.findExecutable(await o.resolveAsync(f,b.process.name),b.process.cwd!==void 0?await o.resolveAsync(f,b.process.cwd):void 0,u)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(s,b,i){return y.win32.findExecutable(s,b,i)}};r=Ve([$e(0,I.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,k.IExtHostDocumentsAndEditors),$e(4,_.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,w.ILogService),$e(7,S.IExtHostApiDeprecationService),$e(8,A.IExtHostEditorTabs)],r),e.ExtHostTask=r}),define(fe[271],me([0,1,18,16,71,6,2,5,263,11,83,85,26,186,14,64,40,34]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(r,g,s,b){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=s,this._rpcProtocol=new _.RPCProtocol(r,null,b),g=p._transform(g,this._rpcProtocol);const i=new I.ServiceCollection(...(0,P.getSingletonServiceDescriptors)());i.set(l.IExtHostInitDataService,{_serviceBrand:void 0,...g}),i.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),i.set(w.IURITransformerService,new w.URITransformerService(b)),i.set(S.IHostUtils,s);const t=new v.InstantiationService(i,!0),c=t.invokeFunction(u=>u.get(A.IExtHostTerminalService));this._disposables.add(c),this._logService=t.invokeFunction(u=>u.get(D.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=t.invokeFunction(u=>u.get(S.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const d=new WeakMap;this._extensionService.getExtensionPathIndex().then(u=>{Error.prepareStackTrace=(E,T)=>{let R="",B,x;for(const F of T)R+=`
	at ${F.toString()}`,x=F.getFileName(),!B&&x&&(B=u.findSubstr(n.URI.file(x)));return d.set(E,B),`${E.name||"Error"}: ${E.message||""}${R}`}});const o=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),f=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(u=>{const E=L.transformErrorForSerialization(u),T=d.get(u);T?o.$onExtensionRuntimeError(T.identifier,E):f.$onUnexpectedError(E)})}terminate(r){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${r}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(s=>{this._logService.error(s)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();Promise.race([(0,m.timeout)(5e3),g]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(r,g){r.extensions.forEach(b=>b.extensionLocation=n.URI.revive(g.transformIncomingURIs(b.extensionLocation))),r.environment.appRoot=n.URI.revive(g.transformIncomingURIs(r.environment.appRoot));const s=r.environment.extensionDevelopmentLocationURI;return s&&(r.environment.extensionDevelopmentLocationURI=s.map(b=>n.URI.revive(g.transformIncomingURIs(b)))),r.environment.extensionTestsLocationURI=n.URI.revive(g.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=n.URI.revive(g.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=n.URI.revive(g.transformIncomingURIs(r.environment.workspaceStorageHome)),r.logsLocation=n.URI.revive(g.transformIncomingURIs(r.logsLocation)),r.logFile=n.URI.revive(g.transformIncomingURIs(r.logFile)),r.workspace=g.transformIncomingURIs(r.workspace),r}}e.ExtensionHostMain=p}),define(fe[272],me([0,1,9,21,51,31,23,47,33]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(l,v,h){this.config=l,this.provider=v,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&C.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&C.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const v=this.config.folderQueries||[];return new Promise((h,w)=>{const S=A=>{this.resultCount++,l(A)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(A=>{const p=A.toString(),a=m.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,a)||this.matchFile(S,{base:A,basename:a})}),Promise.all(v.map(A=>this.searchInFolder(A,S))).then(A=>{h({limitHit:this.isLimitHit,stats:A[0]||void 0})},A=>{w(new Error((0,y.toErrorMessage)(A)))})})}async searchInFolder(l,v){const h=new L.CancellationTokenSource,w=this.getSearchOptionsForFolder(l),S=this.initDirectoryTree(),A=new _.QueryGlobTester(this.config,l),p=!A.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(h),a=k.StopWatch.create();const r=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,h.token),g=a.elapsed(),s=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(r&&r.forEach(b=>{const i=m.posix.relative(l.folder.path,b.path);if(p){const t=m.basename(b.path);this.matchFile(v,{base:l.folder,relativePath:i,basename:t});return}this.addDirectoryEntries(S,l.folder,i,v)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(S,A,v),{providerTime:g,postProcessTime:s.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(l){const v=(0,_.resolvePatternsForProvider)(this.config.includePattern,l.includePattern),h=(0,_.resolvePatternsForProvider)(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:h,includes:v,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},v,h,w){if(h===this.filePattern){const A=m.basename(this.filePattern);this.matchFile(w,{base:v,relativePath:this.filePattern,basename:A})}function S(A){const p=m.basename(A),a=m.dirname(A);let r=l[a];r||(r=l[a]=[],S(a)),r.push({base:v,relativePath:A,basename:p})}S(h)}matchDirectoryTree({rootEntries:l,pathToEntries:v},h,w){const S=this,A=this.filePattern;function p(a){const r=C.hasSiblingFn(()=>a.map(g=>g.basename));for(let g=0,s=a.length;g<s;g++){const b=a[g],{relativePath:i,basename:t}=b;if(h.matchesExcludesSync(i,t,A!==t?r:void 0))continue;const c=v[i];if(c)p(c);else{if(i===A)continue;S.matchFile(w,b)}if(S.isLimitHit)break}}p(l)}matchFile(l,v){(!this.includePattern||v.relativePath&&this.includePattern(v.relativePath,v.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(v))}}class P{constructor(){this.sessions=new Map}fileSearch(l,v,h,w){const S=this.getSessionTokenSource(l.cacheKey),A=new D(l,v,S&&S.token);let p=0;const a=r=>{p+=r.length,h(r.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(A,P.BATCH_SIZE,a,w).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:r.stats}}))}clearCache(l){const v=this.getSessionTokenSource(l);v&&v.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new L.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:n.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,v,h,w){w.onCancellationRequested(()=>{l.cancel()});const S=p=>{p&&(A.push(p),v>0&&A.length>=v&&(h(A),A=[]))};let A=[];return l.search(S).then(p=>(A.length&&h(A),p),p=>(A.length&&h(A),Promise.reject(p)))}}e.FileSearchManager=P,P.BATCH_SIZE=512}),define(fe[134],me([0,1,17,21,51,31,10,9,23,13,2,33]),function(Y,e,m,L,y,C,n,k,_,D,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(a,r,g,s){this.query=a,this.provider=r,this.fileUtils=g,this.processType=s,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(a,r){const g=this.query.folderQueries||[],s=new L.CancellationTokenSource;return r.onCancellationRequested(()=>s.cancel()),new Promise((b,i)=>{this.collector=new h(a);let t=!1;const c=(d,o)=>{if(!t&&!this.isLimitHit){const f=this.resultSize(d);S(d)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,t=!0,s.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const u=this.resultSize(d);this.resultCount+=u,(u>0||!S(d))&&this.collector.add(d,o)}};Promise.all(g.map((d,o)=>this.searchInFolder(d,f=>c(f,o),s.token))).then(d=>{s.dispose(),this.collector.flush();const o=d.some(f=>!!f&&!!f.limitHit);b({limitHit:this.isLimitHit||o,messages:(0,m.flatten)(d.map(f=>f?.message?(0,D.isArray)(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},d=>{s.dispose();const o=(0,y.toErrorMessage)(d);i(new Error(o))})})}resultSize(a){return S(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}trimResultToSize(a,r){const g=Array.isArray(a.ranges)?a.ranges:[a.ranges],s=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:g.slice(0,r),preview:{matches:s.slice(0,r),text:a.preview.text},uri:a.uri}}async searchInFolder(a,r,g){const s=new I.QueryGlobTester(this.query,a),b=[],i={report:d=>{if(!this.validateProviderResult(d))return;const o=a.folder.scheme===n.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(d.uri))):void 0,f=_.relativePath(a.folder,d.uri);if(f){const u=s.includedInQuery(f,k.basename(f),o);(0,D.isPromise)(u)?b.push(u.then(E=>{E&&r(d)})):u&&r(d)}}},t=this.getSearchOptionsForFolder(a),c=await this.provider.provideTextSearchResults(v(this.query.contentPattern),t,i,g);return b.length&&await Promise.all(b),c}validateProviderResult(a){if(S(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(a){const r=(0,I.resolvePatternsForProvider)(this.query.includePattern,a.includePattern),g=(0,I.resolvePatternsForProvider)(this.query.excludePattern,a.excludePattern),s={folder:P.URI.from(a.folder),excludes:g,includes:r,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.fileUtils.toCanonicalName(a.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return s.usePCRE2=this.query.usePCRE2,s}}e.TextSearchManager=l;function v(p){return{isCaseSensitive:p.isCaseSensitive||!1,isRegExp:p.isRegExp||!1,isWordMatch:p.isWordMatch||!1,isMultiline:p.isMultiline||!1,pattern:p.pattern}}class h{constructor(a){this._onResult=a,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new A(512,r=>this.sendItems(r))}add(a,r){this._currentFileMatch&&(this._currentFolderIdx!==r||!_.isEqual(this._currentUri,a.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=r,this._currentFileMatch={resource:a.uri,results:[]}),this._currentFileMatch.results.push(w(a))}pushToCollector(){const a=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,a)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(a){this._onResult(a)}}e.TextSearchResultsCollector=h;function w(p){return S(p)?{preview:{matches:(0,m.mapArrayOrNot)(p.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:p.preview.text},ranges:(0,m.mapArrayOrNot)(p.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:p.text,lineNumber:p.lineNumber}}function S(p){return!!p.preview}e.extensionResultIsMatch=S;class A{constructor(a,r){this.maxBatchSize=a,this.cb=r,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(a,r){!a||this.addItemToBatch(a,r)}addItems(a,r){!a||this.addItemsToBatch(a,r)}addItemToBatch(a,r){this.batch.push(a),this.batchSize+=r,this.onUpdate()}addItemsToBatch(a,r){this.batch=this.batch.concat(a),this.batchSize+=r,this.onUpdate()}onUpdate(){this.totalNumberCompleted<A.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},A.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=A,A.TIMEOUT=4e3,A.START_BATCH_AFTER_COUNT=50}),define(fe[72],me([0,1,6,5,4,272,14,64,11,2,134]),function(Y,e,m,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let I=class{constructor(w,S,A){this.extHostRpc=w,this._uriTransformer=S,this._logService=A,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,S){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const A=this._handlePool++;return this._textSearchProvider.set(A,S),this._proxy.$registerTextSearchProvider(A,this._transformScheme(w)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}registerFileSearchProvider(w,S){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const A=this._handlePool++;return this._fileSearchProvider.set(A,S),this._proxy.$registerFileSearchProvider(A,this._transformScheme(w)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}$provideFileSearchResults(w,S,A,p){const a=l(A),r=this._fileSearchProvider.get(w);if(r)return this._fileSearchManager.fileSearch(a,r,g=>{this._proxy.$handleFileMatch(w,S,g.map(s=>s.resource))},p);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,S,A,p){const a=this._textSearchProvider.get(w);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const r=l(A);return this.createTextSearchManager(r,a).search(s=>this._proxy.$handleTextMatch(w,S,s),p)}$enableExtensionHostSearch(){}createTextSearchManager(w,S){return new P.TextSearchManager(w,S,{readdir:A=>Promise.resolve([]),toCanonicalName:A=>A},"textSearchProvider")}};I=Ve([$e(0,n.IExtHostRpcService),$e(1,k.IURITransformerService),$e(2,_.ILogService)],I),e.ExtHostSearch=I;function l(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(v),extraFileResources:h.extraFileResources&&h.extraFileResources.map(w=>D.URI.revive(w))}}e.reviveQuery=l;function v(h){return{...h,folder:D.URI.revive(h.folder)}}}),define(fe[273],me([0,1,21,16,3,49,2,114,109,146,82,42,5,231,230,39,232,36,233,234,235,216,236,46,40,237,217,240,241,242,132,219,247,248,249,92,34,251,220,15,7,254,68,133,35,73,205,239,62,130,70,55,72,11,64,14,26,243,202,52,65,228,252,201,67,66,257,255,256,229,45,250,253,91,54,121,245,69,246,10,189,244,199,238,29]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p,a,r,g,s,b,i,t,c,d,o,f,u,E,T,R,B,x,F,$,M,H,N,U,V,O,W,j,X,Q,de,Se,De,Pe,Be,We,He,G,ee,ne,ce,Z,re,pe,Me,je,Ke,Ze,rt,ct,ye,at,J,ie,_e,Qe,et,le,Ie,Ue,Xe,it,ft,tt,ut,Re,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Te(se){const ue=se.get(ee.IExtHostInitDataService),be=se.get(J.IExtHostFileSystemInfo),we=se.get(Ze.IExtHostConsumerFileSystem),Fe=se.get(i.IExtHostExtensionService),qe=se.get(W.IExtHostWorkspace),ze=se.get(le.IExtHostTelemetry),Ye=se.get(A.IExtHostConfiguration),lt=se.get(He.IURITransformerService),xe=se.get(G.IExtHostRpcService),ge=se.get(x.IExtHostStorage),Ee=se.get(Ke.IExtensionStoragePaths),ae=se.get(We.ILoggerService),K=se.get(We.ILogService),Ce=se.get(Z.IExtHostTunnelService),Le=se.get(re.IExtHostApiDeprecationService),nt=se.get(O.IExtHostWindow),Ge=se.get(Qe.IExtHostSecretState),mt=se.get(et.IExtHostEditorTabs);xe.set(l.ExtHostContext.ExtHostFileSystemInfo,be),xe.set(l.ExtHostContext.ExtHostLogLevelServiceShape,ae),xe.set(l.ExtHostContext.ExtHostWorkspace,qe),xe.set(l.ExtHostContext.ExtHostConfiguration,Ye),xe.set(l.ExtHostContext.ExtHostExtensionService,Fe),xe.set(l.ExtHostContext.ExtHostStorage,ge),xe.set(l.ExtHostContext.ExtHostTunnelService,Ce),xe.set(l.ExtHostContext.ExtHostWindow,nt),xe.set(l.ExtHostContext.ExtHostSecretState,Ge),xe.set(l.ExtHostContext.ExtHostTelemetry,ze),xe.set(l.ExtHostContext.ExtHostEditorTabs,mt);const yt=xe.set(l.ExtHostContext.ExtHostDecorations,se.get(Se.IExtHostDecorations)),_t=xe.set(l.ExtHostContext.ExtHostDocumentsAndEditors,se.get(b.IExtHostDocumentsAndEditors)),gt=xe.set(l.ExtHostContext.ExtHostCommands,se.get(w.IExtHostCommands)),bt=xe.set(l.ExtHostContext.ExtHostTerminalService,se.get(F.IExtHostTerminalService)),vt=xe.set(l.ExtHostContext.ExtHostDebugService,se.get(Pe.IExtHostDebugService)),Tt=xe.set(l.ExtHostContext.ExtHostSearch,se.get(Be.IExtHostSearch)),Dt=xe.set(l.ExtHostContext.ExtHostTask,se.get(De.IExtHostTask)),Bt=xe.set(l.ExtHostContext.ExtHostOutputService,se.get(u.IExtHostOutputService)),Vt=xe.set(l.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(xe)),kt=xe.set(l.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(xe,_t)),$t=xe.set(l.ExtHostContext.ExtHostDocumentContentProviders,new r.ExtHostDocumentContentProvider(xe,_t,K)),tn=xe.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(K,kt,xe.getProxy(l.MainContext.MainThreadBulkEdits))),St=xe.set(l.ExtHostContext.ExtHostNotebook,new ne.ExtHostNotebookController(xe,gt,_t,kt,Ee)),Qt=xe.set(l.ExtHostContext.ExtHostNotebookDocuments,new ut.ExtHostNotebookDocuments(K,St)),jt=xe.set(l.ExtHostContext.ExtHostNotebookEditors,new tt.ExtHostNotebookEditors(K,xe,St)),nn=xe.set(l.ExtHostContext.ExtHostNotebookKernels,new Ie.ExtHostNotebookKernels(xe,ue,St,gt,K)),rn=xe.set(l.ExtHostContext.ExtHostNotebookRenderers,new Xe.ExtHostNotebookRenderers(xe,St)),At=xe.set(l.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(xe,_t)),Xt=xe.set(l.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(xe.getProxy(l.MainContext.MainThreadTreeViews),gt,K)),bn=xe.set(l.ExtHostContext.ExtHostEditorInsets,new X.ExtHostEditorInsets(xe.getProxy(l.MainContext.MainThreadEditorInsets),At,ue)),Wt=xe.set(l.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(xe,K,be)),Ht=xe.set(l.ExtHostContext.ExtHostLanguages,new o.ExtHostLanguages(xe,kt,gt.converter,lt)),wt=xe.set(l.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(xe,lt,kt,gt,Wt,K,Le)),sn=xe.set(l.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(xe,wt)),Ot=xe.set(l.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(xe,K,_t)),Nt=xe.set(l.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(xe,qe,gt)),Yt=xe.set(l.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(xe,gt,K)),En=xe.set(l.ExtHostContext.ExtHostComments,(0,S.createExtHostComments)(xe,gt,kt)),hn=xe.set(l.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(xe.getProxy(l.MainContext.MainThreadProgress))),_n=xe.set(l.ExtHostContext.ExtHosLabelService,new Q.ExtHostLabelService(xe)),fn=xe.set(l.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(xe)),Jt=xe.set(l.ExtHostContext.ExtHostAuthentication,new pe.ExtHostAuthentication(xe)),on=xe.set(l.ExtHostContext.ExtHostTimeline,new Me.ExtHostTimeline(xe,gt)),qt=xe.set(l.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(xe,{remote:ue.remote},qe,K,Le)),an=xe.set(l.ExtHostContext.ExtHostWebviewPanels,new ye.ExtHostWebviewPanels(xe,qt,qe)),Sn=xe.set(l.ExtHostContext.ExtHostCustomEditors,new ct.ExtHostCustomEditors(xe,kt,Ee,qt,an)),Cn=xe.set(l.ExtHostContext.ExtHostWebviewViews,new rt.ExtHostWebviewViews(xe,qt)),Gt=xe.set(l.ExtHostContext.ExtHostTesting,new ie.ExtHostTesting(xe,gt)),Zt=xe.set(l.ExtHostContext.ExtHostUriOpeners,new _e.ExtHostUriOpeners(xe));xe.set(l.ExtHostContext.ExtHostInteractive,new Re.ExtHostInteractive(xe,St,_t,gt));const yn=(0,j.values)(l.ExtHostContext);xe.assertRegistered(yn);const Dn=new at.ExtHostBulkEdits(xe,_t),kn=new h.ExtHostClipboard(xe),Kt=new f.ExtHostMessageService(xe,K),mn=new a.ExtHostDialogs(xe),zt=new B.ExtHostStatusBar(xe,gt.converter);return v.ExtHostApiCommands.register(gt),function(Oe,ln,Lt){const Et=function(){let te=!Oe.isUnderDevelopment;function he(){te||(K.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(ht){if(Array.isArray(ht))ht.forEach(Ae);else if(typeof ht=="string")he();else{const Ct=ht;typeof Ct.scheme=="undefined"&&he(),typeof Ct.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Oe,"documentFiltersExclusive")}return ht}}(),In={getSession(te,he,Ae){return Jt.getSession(Oe,te,he,Ae)},async hasSession(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"authSession"),!!await Jt.getSession(Oe,te,he,{silent:!0})},get onDidChangeSessions(){return Jt.onDidChangeSessions},registerAuthenticationProvider(te,he,Ae,ht){return Jt.registerAuthenticationProvider(te,he,Ae,ht)}},Pn={registerCommand(te,he,Ae){return gt.registerCommand(!0,te,he,Ae,void 0,Oe)},registerTextEditorCommand(te,he,Ae){return gt.registerCommand(!0,te,(...ht)=>{const Ct=At.getActiveTextEditor();if(!Ct){K.warn("Cannot execute "+te+" because there is no active text editor.");return}return Ct.edit(Pt=>{he.apply(Ae,[Ct,Pt,...ht])}).then(Pt=>{Pt||K.warn("Edits from command "+te+" were not applied.")},Pt=>{K.warn("An error occurred while running command "+te,Pt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(te,he,Ae)=>((0,ve.checkProposedApiEnabled)(Oe,"diffCommand"),gt.registerCommand(!0,te,async(...ht)=>{const Ct=_t.activeEditor(!0);if(!Ct){K.warn("Cannot execute "+te+" because there is no active text editor.");return}const Pt=await At.getDiffInformation(Ct.id);he.apply(Ae,[Pt,...ht])},void 0,void 0,Oe)),executeCommand(te,...he){return gt.executeCommand(te,...he)},getCommands(te=!1){return gt.getCommands(te)}},gn={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return kn.value},get shell(){return bt.getDefaultShell(!1)},get isTelemetryEnabled(){return ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,he){return nt.openUri(te,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ue.environment.appUriScheme)return Vt.createAppUri(te);try{return await nt.asExternalUri(te,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,ft.matchesScheme)(te,it.Schemas.http)||(0,ft.matchesScheme)(te,it.Schemas.https))return te;throw he}},get remoteName(){return(0,de.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Oe,"resolvers"),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(gn);const pn=ue.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Tn={createTestController(te,he){return Gt.createTestController(te,he)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Oe,"testObserver"),Gt.createTestObserver()},runTests(te){return(0,ve.checkProposedApiEnabled)(Oe,"testObserver"),Gt.runTests(te)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Oe,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Oe,"testObserver"),Gt.results}},An={getExtension(te){const he=ln.getExtensionDescription(te);if(he)return new i.Extension(Fe,Oe.identifier,he,pn)},get all(){return ln.getAllExtensionDescriptions().map(te=>new i.Extension(Fe,Oe.identifier,te,pn))},get onDidChange(){return ln.onDidChange}},Rn={createDiagnosticCollection(te){return Wt.createDiagnosticCollection(Oe.identifier,te)},get onDidChangeDiagnostics(){return Wt.onDidChangeDiagnostics},getDiagnostics:te=>Wt.getDiagnostics(te),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(te,he){return Ht.changeLanguage(te.uri,he)},match(te,he){return(0,P.score)(H.LanguageSelector.from(te),he.uri,he.languageId,!0)},registerCodeActionsProvider(te,he,Ae){return wt.registerCodeActionProvider(Oe,Et(te),he,Ae)},registerCodeLensProvider(te,he){return wt.registerCodeLensProvider(Oe,Et(te),he)},registerDefinitionProvider(te,he){return wt.registerDefinitionProvider(Oe,Et(te),he)},registerDeclarationProvider(te,he){return wt.registerDeclarationProvider(Oe,Et(te),he)},registerImplementationProvider(te,he){return wt.registerImplementationProvider(Oe,Et(te),he)},registerTypeDefinitionProvider(te,he){return wt.registerTypeDefinitionProvider(Oe,Et(te),he)},registerHoverProvider(te,he){return wt.registerHoverProvider(Oe,Et(te),he,Oe.identifier)},registerEvaluatableExpressionProvider(te,he){return wt.registerEvaluatableExpressionProvider(Oe,Et(te),he,Oe.identifier)},registerInlineValuesProvider(te,he){return wt.registerInlineValuesProvider(Oe,Et(te),he,Oe.identifier)},registerDocumentHighlightProvider(te,he){return wt.registerDocumentHighlightProvider(Oe,Et(te),he)},registerLinkedEditingRangeProvider(te,he){return wt.registerLinkedEditingRangeProvider(Oe,Et(te),he)},registerReferenceProvider(te,he){return wt.registerReferenceProvider(Oe,Et(te),he)},registerRenameProvider(te,he){return wt.registerRenameProvider(Oe,Et(te),he)},registerDocumentSymbolProvider(te,he,Ae){return wt.registerDocumentSymbolProvider(Oe,Et(te),he,Ae)},registerWorkspaceSymbolProvider(te){return wt.registerWorkspaceSymbolProvider(Oe,te)},registerDocumentFormattingEditProvider(te,he){return wt.registerDocumentFormattingEditProvider(Oe,Et(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return wt.registerDocumentRangeFormattingEditProvider(Oe,Et(te),he)},registerOnTypeFormattingEditProvider(te,he,Ae,...ht){return wt.registerOnTypeFormattingEditProvider(Oe,Et(te),he,[Ae].concat(ht))},registerDocumentSemanticTokensProvider(te,he,Ae){return wt.registerDocumentSemanticTokensProvider(Oe,Et(te),he,Ae)},registerDocumentRangeSemanticTokensProvider(te,he,Ae){return wt.registerDocumentRangeSemanticTokensProvider(Oe,Et(te),he,Ae)},registerSignatureHelpProvider(te,he,Ae,...ht){return typeof Ae=="object"?wt.registerSignatureHelpProvider(Oe,Et(te),he,Ae):wt.registerSignatureHelpProvider(Oe,Et(te),he,typeof Ae=="undefined"?[]:[Ae,...ht])},registerCompletionItemProvider(te,he,...Ae){return wt.registerCompletionItemProvider(Oe,Et(te),he,Ae)},registerInlineCompletionItemProvider(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"inlineCompletions"),wt.registerInlineCompletionsProvider(Oe,Et(te),he)},registerDocumentLinkProvider(te,he){return wt.registerDocumentLinkProvider(Oe,Et(te),he)},registerColorProvider(te,he){return wt.registerColorProvider(Oe,Et(te),he)},registerFoldingRangeProvider(te,he){return wt.registerFoldingRangeProvider(Oe,Et(te),he)},registerSelectionRangeProvider(te,he){return wt.registerSelectionRangeProvider(Oe,te,he)},registerCallHierarchyProvider(te,he){return wt.registerCallHierarchyProvider(Oe,te,he)},registerTypeHierarchyProvider(te,he){return wt.registerTypeHierarchyProvider(Oe,te,he)},setLanguageConfiguration:(te,he)=>wt.setLanguageConfiguration(Oe,te,he),getTokenInformationAtPosition(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"tokenInformation"),Ht.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"inlayHints"),wt.registerInlayHintsProvider(Oe,te,he)},createLanguageStatusItem(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"languageStatus"),Ht.createLanguageStatusItem(Oe,te,he)}},cn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(te,he,Ae){const ht=await(n.URI.isUri(te)?Promise.resolve(vn.openTextDocument(te)):Promise.resolve(te));return At.showTextDocument(ht,he,Ae)},createTextEditorDecorationType(te){return At.createTextEditorDecorationType(Oe,te)},onDidChangeActiveTextEditor(te,he,Ae){return At.onDidChangeActiveTextEditor(te,he,Ae)},onDidChangeVisibleTextEditors(te,he,Ae){return At.onDidChangeVisibleTextEditors(te,he,Ae)},onDidChangeTextEditorSelection(te,he,Ae){return At.onDidChangeTextEditorSelection(te,he,Ae)},onDidChangeTextEditorOptions(te,he,Ae){return At.onDidChangeTextEditorOptions(te,he,Ae)},onDidChangeTextEditorVisibleRanges(te,he,Ae){return At.onDidChangeTextEditorVisibleRanges(te,he,Ae)},onDidChangeTextEditorViewColumn(te,he,Ae){return At.onDidChangeTextEditorViewColumn(te,he,Ae)},onDidCloseTerminal(te,he,Ae){return bt.onDidCloseTerminal(te,he,Ae)},onDidOpenTerminal(te,he,Ae){return bt.onDidOpenTerminal(te,he,Ae)},onDidChangeActiveTerminal(te,he,Ae){return bt.onDidChangeActiveTerminal(te,he,Ae)},onDidChangeTerminalDimensions(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"terminalDimensions"),bt.onDidChangeTerminalDimensions(te,he,Ae)},onDidChangeTerminalState(te,he,Ae){return bt.onDidChangeTerminalState(te,he,Ae)},onDidWriteTerminalData(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(te,he,Ae)},get state(){return nt.state},onDidChangeWindowState(te,he,Ae){return nt.onDidChangeWindowState(te,he,Ae)},showInformationMessage(te,...he){return Kt.showMessage(Oe,C.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return Kt.showMessage(Oe,C.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return Kt.showMessage(Oe,C.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Ae){return Array.isArray(te)&&te.some(ht=>ht.kind!==void 0)&&(0,ve.checkProposedApiEnabled)(Oe,"quickPickSeparators"),Nt.showQuickPick(te,he,Ae)},showWorkspaceFolderPick(te){return Nt.showWorkspaceFolderPick(te)},showInputBox(te,he){return Nt.showInput(te,he)},showOpenDialog(te){return mn.showOpenDialog(te)},showSaveDialog(te){return mn.showSaveDialog(te)},createStatusBarItem(te,he,Ae){let ht,Ct,Pt;return typeof te=="string"?(ht=te,Ct=he,Pt=Ae):(Ct=te,Pt=he),zt.createStatusBarEntry(Oe,ht,Ct,Pt)},setStatusBarMessage(te,he){return zt.setStatusBarMessage(te,he)},withScmProgress(te){return Le.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),hn.withProgress(Oe,{location:N.ProgressLocation.SourceControl},(he,Ae)=>te({report(ht){}}))},withProgress(te,he){return hn.withProgress(Oe,te,he)},createOutputChannel(te){return Bt.createOutputChannel(te,Oe)},createWebviewPanel(te,he,Ae,ht){return an.createWebviewPanel(Oe,te,he,Ae,ht)},createWebviewTextEditorInset(te,he,Ae,ht){return(0,ve.checkProposedApiEnabled)(Oe,"editorInsets"),bn.createWebviewEditorInset(te,he,Ae,ht,Oe)},createTerminal(te,he,Ae){return typeof te=="object"?("location"in te&&(0,ve.checkProposedApiEnabled)(Oe,"terminalLocation"),"pty"in te?bt.createExtensionTerminal(te):bt.createTerminalFromOptions(te)):bt.createTerminal(te,he,Ae)},registerTerminalLinkProvider(te){return bt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return bt.registerProfileProvider(Oe,te,he)},registerTreeDataProvider(te,he){return Xt.registerTreeDataProvider(te,he,Oe)},createTreeView(te,he){return Xt.createTreeView(te,he,Oe)},registerWebviewPanelSerializer:(te,he)=>an.registerWebviewPanelSerializer(Oe,te,he),registerCustomEditorProvider:(te,he,Ae={})=>Sn.registerCustomEditorProvider(Oe,te,he,Ae),registerFileDecorationProvider(te){return yt.registerFileDecorationProvider(te,Oe.identifier)},registerUriHandler(te){return Vt.registerUriHandler(Oe.identifier,te)},createQuickPick(){return Nt.createQuickPick(Oe)},createInputBox(){return Nt.createInputBox(Oe.identifier)},get activeColorTheme(){return fn.activeColorTheme},onDidChangeActiveColorTheme(te,he,Ae){return fn.onDidChangeActiveColorTheme(te,he,Ae)},registerWebviewViewProvider(te,he,Ae){return Cn.registerWebviewViewProvider(Oe,te,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.onDidChangeActiveNotebookEditor(te,he,Ae)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(te,he,Ae)},onDidChangeNotebookEditorVisibleRanges(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(te,he,Ae)},showNotebookDocument(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"externalUriOpener"),Zt.registerExternalUriOpener(Oe.identifier,te,he,Ae)},get tabs(){return(0,ve.checkProposedApiEnabled)(Oe,"tabs"),mt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Oe,"tabs"),mt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Oe,"tabs"),mt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Oe,"tabs"),mt.onDidChangeActiveTab},getInlineCompletionItemController(te){return(0,ve.checkProposedApiEnabled)(Oe,"inlineCompletions"),d.InlineCompletionController.get(te)}},vn={get rootPath(){return Le.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),qe.getPath()},set rootPath(te){throw L.readonly()},getWorkspaceFolder(te){return qe.getWorkspaceFolder(te)},get workspaceFolders(){return qe.getWorkspaceFolders()},get name(){return qe.name},set name(te){throw L.readonly()},get workspaceFile(){return qe.workspaceFile},set workspaceFile(te){throw L.readonly()},updateWorkspaceFolders:(te,he,...Ae)=>qe.updateWorkspaceFolders(Oe,te,he||0,...Ae),onDidChangeWorkspaceFolders:function(te,he,Ae){return qe.onDidChangeWorkspace(te,he,Ae)},asRelativePath:(te,he)=>qe.getRelativePath(te,he),findFiles:(te,he,Ae,ht)=>qe.findFiles(H.GlobPattern.from(te),H.GlobPattern.from(he),Ae,Oe.identifier,ht),findTextInFiles:(te,he,Ae,ht)=>{(0,ve.checkProposedApiEnabled)(Oe,"findTextInFiles");let Ct,Pt;return typeof he=="object"?(Ct=he,Pt=Ae):(Ct={},Pt=he,ht=Ae),qe.findTextInFiles(te,Ct||{},Pt,Oe.identifier,ht)},saveAll:te=>qe.saveAll(te),applyEdit(te){return Dn.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,he,Ae,ht)=>Ot.createFileSystemWatcher(H.GlobPattern.from(te),he,Ae,ht),get textDocuments(){return kt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw L.readonly()},openTextDocument(te){let he;const Ae=te;if(typeof te=="string")he=Promise.resolve(n.URI.file(te));else if(n.URI.isUri(te))he=Promise.resolve(te);else if(!Ae||typeof Ae=="object")he=kt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ht=>kt.ensureDocumentData(ht).then(Ct=>Ct.document))},onDidOpenTextDocument:(te,he,Ae)=>kt.onDidAddDocument(te,he,Ae),onDidCloseTextDocument:(te,he,Ae)=>kt.onDidRemoveDocument(te,he,Ae),onDidChangeTextDocument:(te,he,Ae)=>kt.onDidChangeDocument(te,he,Ae),onDidSaveTextDocument:(te,he,Ae)=>kt.onDidSaveDocument(te,he,Ae),onWillSaveTextDocument:(te,he,Ae)=>tn.getOnWillSaveTextDocumentEvent(Oe)(te,he,Ae),get notebookDocuments(){return St.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Ae;if(n.URI.isUri(te))Ae=te,await St.openNotebookDocument(te);else if(typeof te=="string")Ae=n.URI.revive(await St.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(te,he,Ae,ht){return St.registerNotebookSerializer(Oe,te,he,Ae,(0,ve.isProposedApiEnabled)(Oe,"notebookLiveShare")?ht:void 0)},registerNotebookContentProvider:(te,he,Ae,ht)=>((0,ve.checkProposedApiEnabled)(Oe,"notebookContentProvider"),St.registerNotebookContentProvider(Oe,te,he,Ae,(0,ve.isProposedApiEnabled)(Oe,"notebookLiveShare")?ht:void 0)),onDidChangeConfiguration:(te,he,Ae)=>Lt.onDidChangeConfiguration(te,he,Ae),getConfiguration(te,he){return he=arguments.length===1?void 0:he,Lt.getConfiguration(te,he,Oe)},registerTextDocumentContentProvider(te,he){return $t.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(Le.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Dt.registerTaskProvider(Oe,te,he)),registerFileSystemProvider(te,he,Ae){return sn.registerFileSystemProvider(Oe,te,he,Ae)},get fs(){return we.value},registerFileSearchProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Oe,"fileSearchProvider"),Tt.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Oe,"textSearchProvider"),Tt.registerTextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>((0,ve.checkProposedApiEnabled)(Oe,"resolvers"),Fe.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>((0,ve.checkProposedApiEnabled)(Oe,"resolvers"),_n.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,he,Ae)=>Ot.onDidCreateFile(te,he,Ae),onDidDeleteFiles:(te,he,Ae)=>Ot.onDidDeleteFile(te,he,Ae),onDidRenameFiles:(te,he,Ae)=>Ot.onDidRenameFile(te,he,Ae),onWillCreateFiles:(te,he,Ae)=>Ot.getOnWillCreateFileEvent(Oe)(te,he,Ae),onWillDeleteFiles:(te,he,Ae)=>Ot.getOnWillDeleteFileEvent(Oe)(te,he,Ae),onWillRenameFiles:(te,he,Ae)=>Ot.getOnWillRenameFileEvent(Oe)(te,he,Ae),openTunnel:te=>((0,ve.checkProposedApiEnabled)(Oe,"resolvers"),Ce.openTunnel(Oe,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Oe,"resolvers"),Ce.getTunnels()},onDidChangeTunnels:(te,he,Ae)=>((0,ve.checkProposedApiEnabled)(Oe,"resolvers"),Ce.onDidChangeTunnels(te,he,Ae)),registerPortAttributesProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Oe,"portsAttributes"),Ce.registerPortsAttributesProvider(te,he)),registerTimelineProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Oe,"timeline"),on.registerTimelineProvider(te,he,Oe.identifier,gt.converter)),get isTrusted(){return qe.trusted},requestWorkspaceTrust:te=>((0,ve.checkProposedApiEnabled)(Oe,"workspaceTrust"),qe.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Ae)=>qe.onDidGrantWorkspaceTrust(te,he,Ae)},Ln={get inputBox(){return Le.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Oe)},createSourceControl(te,he,Ae){return Yt.createSourceControl(Oe,te,he,Ae)}},Fn={createCommentController(te,he){return En.createCommentController(Oe,te,he)}},Mn={get activeDebugSession(){return vt.activeDebugSession},get activeDebugConsole(){return vt.activeDebugConsole},get breakpoints(){return vt.breakpoints},onDidStartDebugSession(te,he,Ae){return vt.onDidStartDebugSession(te,he,Ae)},onDidTerminateDebugSession(te,he,Ae){return vt.onDidTerminateDebugSession(te,he,Ae)},onDidChangeActiveDebugSession(te,he,Ae){return vt.onDidChangeActiveDebugSession(te,he,Ae)},onDidReceiveDebugSessionCustomEvent(te,he,Ae){return vt.onDidReceiveDebugSessionCustomEvent(te,he,Ae)},onDidChangeBreakpoints(te,he,Ae){return vt.onDidChangeBreakpoints(te,he,Ae)},registerDebugConfigurationProvider(te,he,Ae){return vt.registerDebugConfigurationProvider(te,he,Ae||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return vt.registerDebugAdapterDescriptorFactory(Oe,te,he)},registerDebugAdapterTrackerFactory(te,he){return vt.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?vt.startDebugging(te,he,{parentSession:Ae}):vt.startDebugging(te,he,Ae||{})},stopDebugging(te){return vt.stopDebugging(te)},addBreakpoints(te){return vt.addBreakpoints(te)},removeBreakpoints(te){return vt.removeBreakpoints(te)},asDebugSourceUri(te,he){return vt.asDebugSourceUri(te,he)}},On={registerTaskProvider:(te,he)=>Dt.registerTaskProvider(Oe,te,he),fetchTasks:te=>Dt.fetchTasks(te),executeTask:te=>Dt.executeTask(Oe,te),get taskExecutions(){return Dt.taskExecutions},onDidStartTask:(te,he,Ae)=>Dt.onDidStartTask(te,he,Ae),onDidEndTask:(te,he,Ae)=>Dt.onDidEndTask(te,he,Ae),onDidStartTaskProcess:(te,he,Ae)=>Dt.onDidStartTaskProcess(te,he,Ae),onDidEndTaskProcess:(te,he,Ae)=>Dt.onDidEndTaskProcess(te,he,Ae)},Nn={createNotebookController(te,he,Ae,ht,Ct){return nn.createNotebookController(Oe,te,he,Ae,ht,(0,ve.isProposedApiEnabled)(Oe,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>St.registerNotebookCellStatusBarItemProvider(Oe,te,he),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return rn.createRendererMessaging(Oe,te)},onDidChangeNotebookDocumentMetadata(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(te,he,Ae)},onDidChangeNotebookCells(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.onDidChangeNotebookCells(te,he,Ae)},onDidChangeNotebookCellExecutionState(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookCellExecutionState"),St.onDidChangeNotebookCellExecutionState(te,he,Ae)},onDidChangeCellOutputs(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.onDidChangeCellOutputs(te,he,Ae)},onDidChangeCellMetadata(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Oe,"notebookEditor"),St.onDidChangeCellMetadata(te,he,Ae)},createConcatTextDocument(te,he){return(0,ve.checkProposedApiEnabled)(Oe,"notebookConcatTextDocument"),new je.ExtHostNotebookConcatDocument(St,kt,te,he)}};return{version:ue.version,authentication:In,commands:Pn,comments:Fn,debug:Mn,env:gn,extensions:An,languages:Rn,notebooks:Nn,scm:Ln,tasks:On,tests:Tn,window:cn,workspace:vn,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:D.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:l.UIKind,Uri:n.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:Ue.TextSearchCompleteMessageType,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity,QuickPickItemKind:N.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Te}),define(fe[274],me([0,1,83,132,35,130,36,39,46,34,70,55,72,92,52,65,133,66,45,91,121,54,131,11,226]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p,a,r,g,s,b,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(b.ILoggerService,s.ExtHostLoggerService),(0,m.registerSingleton)(b.ILogService,i.ExtHostLogService),(0,m.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,m.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,m.registerSingleton)(n.IExtHostConfiguration,n.ExtHostConfiguration),(0,m.registerSingleton)(A.IExtHostConsumerFileSystem,A.ExtHostConsumerFileSystem),(0,m.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo),(0,m.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,m.registerSingleton)(l.IExtHostSearch,l.ExtHostSearch),(0,m.registerSingleton)(v.IExtHostStorage,v.ExtHostStorage),(0,m.registerSingleton)(P.IExtHostTask,P.WorkerExtHostTask),(0,m.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService),(0,m.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,m.registerSingleton)(S.IExtHostWindow,S.ExtHostWindow),(0,m.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,m.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,m.registerSingleton)(r.IExtHostTelemetry,r.ExtHostTelemetry),(0,m.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(fe[93],me([0,1,17,11,33,69]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function n(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=n;function k(I,l,v,h){const w=(0,m.mapArrayOrNot)(v,_),S=new y.TextSearchMatch(l,w,h),A=S.preview.matches;return{ranges:(0,m.mapArrayOrNot)(w,D),uri:I,preview:{text:S.preview.text,matches:(0,m.mapArrayOrNot)(A,D)}}}e.createTextSearchResult=k;function _(I){return new y.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function D(I){return new C.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let P=class{constructor(l,v){this.prefix=l,this.logService=v}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};P=Ve([$e(1,L.ILogService)],P),e.OutputChannel=P}),define(fe[275],me([0,1,96,22]),function(Y,e,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(b=>b===s)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,n=512,k=512*8,_=512*128;class D{constructor(b){this.iconvLiteDecoder=b}static async create(b){let i;if(b!==e.UTF8)i=(await new Promise((c,d)=>{Y(["iconv-lite-umd"],c,d)})).getDecoder(v(b));else{const t=new TextDecoder;i={write(c){return t.decode(c,{stream:!0})},end(){return t.decode()}}}return new D(i)}write(b){return this.iconvLiteDecoder.write(b)}end(){return this.iconvLiteDecoder.end()}}function P(s,b){const i=b.minBytesRequiredForDetection??b.guessEncoding?k:n;return new Promise((t,c)=>{const d=(0,m.newWriteableStream)(T=>T.join("")),o=[];let f=0,u;const E=async()=>{try{const T=await g({buffer:L.VSBuffer.concat(o),bytesRead:f},b.guessEncoding);T.encoding=await b.overwriteEncoding(T.encoding),u=await D.create(T.encoding);const R=u.write(L.VSBuffer.concat(o).buffer);d.write(R),o.length=0,f=0,t({stream:d,detected:T})}catch(T){c(T)}};(0,m.listenStream)(s,{onData:async T=>{u?d.write(u.write(T.buffer)):(o.push(T),f+=T.byteLength,f>=i&&(s.pause(),await E(),setTimeout(()=>s.resume())))},onError:T=>d.error(T),onEnd:async()=>{u||await E(),d.end(u?.end())}})})}e.toDecodeStream=P;async function I(s,b,i){const c=(await new Promise((f,u)=>{Y(["iconv-lite-umd"],f,u)})).getEncoder(v(b),i);let d=!1,o=!1;return{read(){if(o)return null;const f=s.read();if(typeof f!="string"){if(o=!0,!d&&i?.addBOM)switch(b){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=c.end();return u&&u.length>0?(d=!0,L.VSBuffer.wrap(u)):null}return d=!0,L.VSBuffer.wrap(c.write(f))}}}e.toEncodeReadable=I;async function l(s){return(await new Promise((i,t)=>{Y(["iconv-lite-umd"],i,t)})).encodingExists(v(s))}e.encodingExists=l;function v(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=v;function h(s,b){if(!s||b<e.UTF16be_BOM.length)return null;const i=s.readUInt8(0),t=s.readUInt8(1);if(i===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(i===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(b<e.UTF8_BOM.length)return null;const c=s.readUInt8(2);return i===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const w=["ascii","utf-16","utf-32"];async function S(s){const b=await new Promise((o,f)=>{Y(["jschardet"],o,f)}),i=s.slice(0,_),t=a(i.buffer),c=b.detect(t);if(!c||!c.encoding)return null;const d=c.encoding.toLowerCase();return 0<=w.indexOf(d)?null:p(c.encoding)}const A={ibm866:"cp866",big5:"cp950"};function p(s){const b=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return A[b]||b}function a(s){let b="";for(let i=0;i<s.length;i++)b+=String.fromCharCode(s[i]);return b}function r(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const b=s.match(/windows(\d+)/);return b?"windows-"+b[1]:s}}e.toCanonicalName=r;function g({buffer:s,bytesRead:b},i){let t=h(s,b),c=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&s){let d=!0,o=!0,f=!1;for(let u=0;u<b&&u<C;u++){const E=u%2==1,T=s.readUInt8(u)===0;if(T&&(f=!0),d&&(E&&!T||!E&&T)&&(d=!1),o&&(E&&T||!E&&!T)&&(o=!1),T&&!d&&!o)break}f&&(d?t=e.UTF16le:o?t=e.UTF16be:c=!0)}return i&&!c&&!t&&s?S(s.slice(0,b)).then(d=>({seemsBinary:!1,encoding:d})):{seemsBinary:c,encoding:t}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[135],me([0,1,275,28,134]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends y.TextSearchManager{constructor(k,_,D=L,P="searchProcess"){super(k,_,{readdir:I=>D.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,m.toCanonicalName)(I)},P)}}e.NativeTextSearchManager=C}),define(fe[276],me([0,1,277,291,292,2,293]),function(Y,e,m,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(I,l,v,h,w,S){const A=S.environment.useHostProxy,p=typeof A=="boolean"?A:!S.remote.isRemote,a=(0,n.createProxyResolver)({resolveProxy:g=>I.resolveProxy(g),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(g,s,...b)=>{switch(g){case n.LogLevel.Trace:h.trace(s,...b);break;case n.LogLevel.Debug:h.debug(s,...b);break;case n.LogLevel.Info:h.info(s,...b);break;case n.LogLevel.Warning:h.warn(s,...b);break;case n.LogLevel.Error:h.error(s,...b);break;case n.LogLevel.Critical:h.critical(s,...b);break;case n.LogLevel.Off:break;default:i(g,s,b);break}function i(t,c,...d){h.error("Unknown log level",t),h.error(c,...d)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:g=>{w.$publicLog2("resolveProxy",g)},useHostProxy:p,env:process.env}),r=_(l,a);return P(v,r)}e.connectProxyResolver=k;function _(I,l){const v={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(w=>{v.config=I.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(w=>{h.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,n.createHttpPatch)(m,l,{config:"off"},h,!0)),on:Object.assign({},m,(0,n.createHttpPatch)(m,l,{config:"on"},h,!0)),override:Object.assign({},m,(0,n.createHttpPatch)(m,l,{config:"override"},h,!0)),onRequest:Object.assign({},m,(0,n.createHttpPatch)(m,l,v,h,!0)),default:Object.assign(m,(0,n.createHttpPatch)(m,l,v,h,!1))},https:{off:Object.assign({},L,(0,n.createHttpPatch)(L,l,{config:"off"},h,!0)),on:Object.assign({},L,(0,n.createHttpPatch)(L,l,{config:"on"},h,!0)),override:Object.assign({},L,(0,n.createHttpPatch)(L,l,{config:"override"},h,!0)),onRequest:Object.assign({},L,(0,n.createHttpPatch)(L,l,v,h,!0)),default:Object.assign(L,(0,n.createHttpPatch)(L,l,v,h,!1))},tls:Object.assign(y,(0,n.createTlsPatch)(y))}}const D=new Map;function P(I,l){return I.getExtensionPathIndex().then(v=>{const h=Y.__$__nodeRequire("module"),w=h._load;h._load=function(A,p,a){if(A==="tls")return l.tls;if(A!=="http"&&A!=="https")return w.apply(this,arguments);const r=l[A],g=v.findSubstr(C.URI.file(p.filename));let s=D.get(g);if(s||D.set(g,s={}),!s[A]){let b=r.default;s[A]={...b}}return s[A]}})}}),define(fe[278],me([0,1,38,9,79,30,12,8,93,279]),function(Y,e,m,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const P=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(a,r,g,s){const b=l(a,r,g,s),i=r.folder.fsPath;return{cmd:m.spawn(P,b.args,{cwd:i}),rgDiskPath:P,siblingClauses:b.siblingClauses,rgArgs:b,cwd:i}}e.spawnRipgrepCmd=I;function l(a,r,g,s){const b=["--files","--hidden","--case-sensitive"];h([r],g,!1).forEach(t=>{const c=(0,_.anchorGlob)(t);if(b.push("-g",c),n.isMacintosh){const d=(0,y.normalizeNFD)(c);d!==c&&b.push("-g",d)}});const i=v([r],s,void 0,!1);return i.globArgs.forEach(t=>{const c=`!${(0,_.anchorGlob)(t)}`;if(b.push("-g",c),n.isMacintosh){const d=(0,y.normalizeNFD)(c);d!==c&&b.push("-g",d)}}),r.disregardIgnoreFiles!==!1?b.push("--no-ignore"):b.push("--no-ignore-parent"),r.ignoreSymlinks||b.push("--follow"),a.exists&&b.push("--quiet"),b.push("--no-config"),r.disregardGlobalIgnoreFiles&&b.push("--no-ignore-global"),{args:b,siblingClauses:i.siblingClauses}}function v(a,r,g,s=!0){const b=[];let i={};return a.forEach(t=>{const c=Object.assign({},t.excludePattern||{},r||{}),d=w(c,s?t.folder.fsPath:void 0,g);b.push(...d.globArgs),d.siblingClauses&&(i=Object.assign(i,d.siblingClauses))}),{globArgs:b,siblingClauses:i}}e.foldersToRgExcludeGlobs=v;function h(a,r,g=!0){const s=[];return a.forEach(b=>{const i=Object.assign({},r||{},b.includePattern||{}),t=w(i,g?b.folder.fsPath:void 0);s.push(...t.globArgs)}),s}e.foldersToIncludeGlobs=h;function w(a,r,g){const s=[],b={};return Object.keys(a).forEach(i=>{if(g&&g.has(i)||!i)return;const t=a[i];i=A(r?S(r,i):i),i.startsWith("\\\\")?i="\\\\"+i.substr(2).replace(/\\/g,"/"):i=i.replace(/\\/g,"/"),typeof t=="boolean"&&t?(i.startsWith("\\\\")&&(i+="**"),s.push(p(i))):t&&t.when&&(b[i]=t)}),{globArgs:s,siblingClauses:b}}function S(a,r){return L.isAbsolute(r)?r:L.join(a,r)}e.getAbsoluteGlob=S;function A(a){return a=k.rtrim(a,"\\"),k.rtrim(a,"/")}function p(a){return C.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=p}),define(fe[280],me([0,1,38,60,9,104,17,51,31,79,30,12,47,8,13,28,33,278,101]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(i=>i())});class r{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&_.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,p.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&_.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(c=>{const d=Object.assign({},c.excludePattern||{},this.config.excludePattern||{}),o=c.folder.fsPath;t.folderQueries.map(f=>f.folder.fsPath).filter(f=>f!==o).forEach(f=>{(0,P.isEqualOrParent)(f,o)&&(d[y.relative(o,f)]=!0)}),this.folderExcludePatterns.set(o,new s(d,o))})}cancel(){this.isCanceled=!0,a.forEach(t=>t())}walk(t,c,d,o,f){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return f(null,this.isLimitHit);c.forEach(u=>{const E=y.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,E)||this.matchFile(d,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(t,(u,E)=>{this.call(this.cmdTraversal,this,u,d,o,T=>{if(T){const R=(0,k.toErrorMessage)(T);console.error(R),this.errors.push(R),E(T,void 0)}else E(null,void 0)})},(u,E)=>{this.fileWalkSW.stop();const T=u?n.coalesce(u)[0]:null;f(T,this.isLimitHit)})}parallel(t,c,d){const o=new Array(t.length),f=new Array(t.length);let u=!1,E=0;if(t.length===0)return d(null,[]);t.forEach((T,R)=>{c(T,(B,x)=>{if(B?(u=!0,o[R]=null,f[R]=B):(o[R]=x,f[R]=null),++E===t.length)return d(u?f:null,o)})})}call(t,c,...d){try{t.apply(c,d)}catch(o){d[d.length-1](o)}}cmdTraversal(t,c,d,o){const f=t.folder.fsPath,u=I.isMacintosh;let E;const T=()=>E&&E.kill();a.add(T);let R=N=>{a.delete(T),R=()=>{},o(N)},B="";const x=this.initDirectoryTree();let F;const $=(0,A.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);E=$.cmd,F=!Object.keys($.siblingClauses).length;const M=$.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let H=`${$.rgDiskPath} ${M}
 - cwd: ${$.cwd}`;$.rgArgs.siblingClauses&&(H+=`
 - Sibling clauses: ${JSON.stringify($.rgArgs.siblingClauses)}`),d({message:H}),this.cmdResultCount=0,this.collectStdout(E,"utf8",d,(N,U,V)=>{if(N){R(N);return}if(this.isLimitHit){R();return}const W=(B+(u?D.normalizeNFC(U||""):U)).split(`
`);if(V){const j=W.length;W[j-1]=W[j-1].trim(),W[j-1]||W.pop()}else B=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,F){for(const j of W)if(this.matchFile(c,{base:f,relativePath:j,searchPath:this.getSearchPath(t,j)}),this.isLimitHit){T();break}(V||this.isLimitHit)&&R();return}this.addDirectoryEntries(t,x,f,W,c),V&&(this.matchDirectoryTree(x,f,c),R())})}spawnFindCmd(t){const c=this.folderExcludePatterns.get(t.folder.fsPath),d=c.getBasenameTerms(),o=c.getPathTerms(),f=["-L","."];if(d.length||o.length){f.push("-not","(","(");for(const u of d)f.push("-name",u),f.push("-o");for(const u of o)f.push("-path",u),f.push("-o");f.pop(),f.push(")","-prune",")")}return f.push("-type","f"),m.spawn("find",f,{cwd:t.folder.fsPath})}readStdout(t,c,d){let o="";this.collectStdout(t,c,()=>{},(f,u,E)=>{if(f){d(f);return}o+=u,E&&d(null,o)})}collectStdout(t,c,d,o){let f=(T,R,B)=>{(T||B)&&(f=()=>{},this.cmdSW&&this.cmdSW.stop()),o(T,R,B)},u=!1;t.stdout?(this.forwardData(t.stdout,c,f),t.stdout.once("data",()=>u=!0)):d({message:"stdout is null"});let E;t.stderr?E=this.collectData(t.stderr):d({message:"stderr is null"}),t.on("error",T=>{f(T)}),t.on("close",T=>{let R;!u&&(R=this.decodeData(E,c))&&b(R)?f(new Error(`command failed with error code ${T}: ${this.decodeData(E,c)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),f(null,"",!0))})}forwardData(t,c,d){const o=new C.StringDecoder(c);return t.on("data",f=>{d(null,o.write(f))}),o}collectData(t){const c=[];return t.on("data",d=>{c.push(d)}),c}decodeData(t,c){const d=new C.StringDecoder(c);return t.map(o=>d.write(o)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:c},d,o,f){o.indexOf(this.filePattern)!==-1&&this.matchFile(f,{base:d,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const u=E=>{const T=y.basename(E),R=y.dirname(E);let B=c[R];B||(B=c[R]=[],u(R)),B.push({base:d,relativePath:E,basename:T,searchPath:this.getSearchPath(t,E)})};o.forEach(u)}matchDirectoryTree({rootEntries:t,pathToEntries:c},d,o){const f=this,u=this.folderExcludePatterns.get(d),E=this.filePattern;function T(R){f.directoriesWalked++;const B=_.hasSiblingFn(()=>R.map(x=>x.basename));for(let x=0,F=R.length;x<F;x++){const $=R[x],{relativePath:M,basename:H}=$;if(u.test(M,H,E!==H?B:void 0))continue;const N=c[M];if(N)T(N);else{if(f.filesWalked++,M===E)continue;f.matchFile(o,$)}if(f.isLimitHit)break}}T(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,c,d,o,f){const u=t.folder,E=_.hasSiblingFn(()=>d);this.parallel(d,(T,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const B=c?[c,T].join(y.sep):T;if(this.folderExcludePatterns.get(t.folder.fsPath).test(B,T,this.config.filePattern!==T?E:void 0))return R(null);const x=[u.fsPath,B].join(y.sep);L.lstat(x,(F,$)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(x,$,(M,H)=>M||this.isCanceled||this.isLimitHit?R(null):H.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(x,$,(N,U)=>N||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?R(null):(this.walkedPaths[U]=!0,w.Promises.readdir(x).then(V=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(t,B,V,o,O=>R(O||null))},V=>{R(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&h.isNumber(H.size)&&H.size>this.maxFilesize||this.matchFile(o,{base:u.fsPath,relativePath:B,searchPath:this.getSearchPath(t,B)}),R(null,void 0)))})},T=>{const R=T&&n.coalesce(T);return f(R&&R.length>0?R[0]:void 0)})}matchFile(t,c){this.isFileMatch(c)&&(!this.includePattern||this.includePattern(c.relativePath,y.basename(c.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(c))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,S.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,c,d){return c.isSymbolicLink()?L.stat(t,d):d(null,c)}realPathIfNeeded(t,c,d){return c.isSymbolicLink()?L.realpath(t,(o,f)=>o?d(o):d(null,f)):d(null,t)}getSearchPath(t,c){return t.folderName?y.join(t.folderName,c):c}}e.FileWalker=r;class g{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new r(t)}search(t,c,d){this.walker.walk(this.folderQueries,this.extraFiles,t,c,(o,f)=>{d(o,{limitHit:f,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class s{constructor(t,c){this.expression=t,this.root=c,this.init(t)}init(t){let c,d;Object.keys(t).filter(o=>t[o]).forEach(o=>{y.isAbsolute(o)?(c=c||_.getEmptyExpression(),c[o]=t[o]):(d=d||_.getEmptyExpression(),d[o]=t[o])}),this.absoluteParsedExpr=c&&_.parse(c,{trimForExclusions:!0}),this.relativeParsedExpr=d&&_.parse(d,{trimForExclusions:!0})}test(t,c,d){return this.relativeParsedExpr&&this.relativeParsedExpr(t,c,d)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,t),c,d)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getPathTerms(this.relativeParsedExpr)),t}}function b(i){const t=i.trim().split(`
`),c=t[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return v.uppercaseFirstLetter(t[t.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}e.rgErrorMsgForDisplay=b}),define(fe[136],me([0,1,38,294,104,17,73,31,9,8,2,33,69,295,279,93]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const S=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class A{constructor(u){this.outputChannel=u}provideTextSearchResults(u,E,T,R){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((B,x)=>{R.onCancellationRequested(()=>O());const F=b(u,E),$=E.folder.fsPath,M=F.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${S} ${M}
 - cwd: ${$}`);let H=m.spawn(S,F,{cwd:$});H.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),x((0,I.serializeSearchError)(new I.SearchError(de&&de.message,I.SearchErrorCode.rgProcessError)))});let N=!1;const U=new r(E.maxResults,$,E.previewOptions);U.on("result",de=>{N=!0,j="",T.report(de)});let V=!1;const O=()=>{V=!0,H&&H.kill(),U&&U.cancel()};let W=!1;U.on("hitLimit",()=>{W=!0,O()});let j="";H.stdout.on("data",de=>{U.handleData(de),N||(j+=de)});let X=!1;H.stdout.once("data",()=>X=!0);let Q="";H.stderr.on("data",de=>{const Se=de.toString();this.outputChannel.appendLine(Se),Q+=Se}),H.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),j&&this.outputChannel.appendLine(`Got data without result: ${j}`),this.outputChannel.appendLine(""),V)B({limitHit:W});else{U.flush(),H=null;let de;Q&&!X&&(de=p(Q))?x((0,I.serializeSearchError)(new I.SearchError(de.message,de.code))):B({limitHit:W})}})})}}e.RipgrepTextSearchEngine=A;function p(f){const u=f.split(`
`),E=u[0].trim();if(u.some(R=>R.startsWith("regex parse error")))return new I.SearchError(a(u),I.SearchErrorCode.regexParseError);const T=E.match(/grep config error: unknown encoding: (.*)/);if(T)return new I.SearchError(`Unknown encoding: ${T[1]}`,I.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new I.SearchError(E.charAt(0).toUpperCase()+E.substr(1),I.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(E,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=p;function a(f){const u=["Regex parse error"],E=f.filter(T=>T.startsWith("PCRE2:"));if(E.length>=1){const T=E[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const R=T.split(":")[1];u.push(":"+R)}}return u.join("")}e.buildRegexParseError=a;class r extends L.EventEmitter{constructor(u,E,T){super();this.maxResults=u,this.rootFolder=E,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,E){return super.on(u,E),this}handleData(u){if(this.isDone)return;const E=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(E)}handleDecodedData(u){let E=u.indexOf(`
`);const T=this.remainder+u;if(E>=0)E+=this.remainder.length;else{this.remainder=T;return}let R=0;for(;E>=0;)this.handleLine(T.substring(R,E).trim()),R=E+1,E=T.indexOf(`
`,R);this.remainder=T.substring(R)}handleLine(u){if(this.isDone||!u)return;let E;try{E=JSON.parse(u)}catch(T){throw new Error(`malformed line from rg: ${u}`)}if(E.type==="match"){const T=g(E.data.path),R=P.URI.file(_.join(this.rootFolder,T)),B=this.createTextSearchMatch(E.data,R);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const T=g(E.data.path),R=P.URI.file(_.join(this.rootFolder,T));this.createTextSearchContext(E.data,R).forEach(x=>this.onResult(x))}}createTextSearchMatch(u,E){const T=u.line_number-1,R=g(u.lines),B=Buffer.from(R);let x=0,F=0,$=T;u.submatches.length===0&&u.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const M=(0,C.coalesce)(u.submatches.map((H,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const U=g(H.match),V=B.slice(x,H.start).toString().length,O=F+V,W=s(U),j=$,X=W.numLines+j,Q=W.numLines>0?W.lastLineLength:W.lastLineLength+O;return x=H.end,F=Q,$=X,new l.Range(j,O,X,Q)}));return(0,w.createTextSearchResult)(E,R,M,this.previewOptions)}createTextSearchContext(u,E){const T=g(u.lines),R=u.line_number;return T.replace(/\r?\n$/,"").split(`
`).map((B,x)=>({text:B,uri:E,lineNumber:R+x}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=r;function g(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function s(f){const u=/\n/g;let E=0,T=-1,R;for(;R=u.exec(f);)E++,T=R.index;const B=T>=0?f.length-T-1:f.length;return{numLines:E,lastLineLength:B}}function b(f,u){const E=["--hidden"];E.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:R}=(0,n.groupBy)(u.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const x=new Set;R.forEach(F=>{x.add(F)}),E.push("-g","!*"),x.forEach(F=>{i(F).map(w.anchorGlob).forEach($=>{E.push("-g",$)})})}T&&T.length&&T.forEach(x=>{E.push("-g",x)}),u.excludes.map(w.anchorGlob).forEach(x=>E.push("-g",`!${x}`)),u.maxFileSize&&E.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?E.push("--no-ignore-parent"):E.push("--no-ignore"),u.followSymlinks&&E.push("--follow"),u.encoding&&u.encoding!=="utf8"&&E.push("--encoding",u.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,D.escapeRegExpCharacters)(f.pattern),f.isRegExp=!0),u.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),f.isRegExp&&(f.pattern=t(f.pattern),E.push("--auto-hybrid-regex"));let B;if(f.isWordMatch){const F=(0,D.createRegExp)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",F)}else if(f.isRegExp){let x=d(f.pattern);x=o(x),E.push("--regexp",x)}else B=f.pattern,E.push("--fixed-strings");return E.push("--no-config"),u.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),f.isMultiline&&E.push("--multiline"),u.beforeContext&&E.push("--before-context",u.beforeContext+""),u.afterContext&&E.push("--after-context",u.afterContext+""),E.push("--"),B&&E.push(B),E.push("."),E}function i(f){const u=(0,k.splitGlobAware)(f,"/");return u.map((E,T)=>u.slice(0,T+1).join("/"))}e.spreadGlobComponents=i;function t(f){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(u);)f=f.replace(u,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(E);)f=f.replace(E,"$1\\x{$2}");return f}e.unicodeEscapesToPCRE2=t;const c=f=>f.type==="Assertion"&&f.kind==="lookbehind";function d(f){let u;try{u=new v.RegExpParser().parsePattern(f)}catch{return f}let E="",T=0;const R=(F,$,M)=>{E+=f.slice(T,F)+M,T=$},B=[];return new v.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const $=B[0];if(!$)R(F.start,F.end,"\\r?\\n");else if(!B.some(c))if($.type==="CharacterClass")if($.negate){const M=f.slice($.start+2,F.start)+f.slice(F.end,$.end-1);if($.parent?.type==="Quantifier"){const H=$.parent;R(H.start,H.end,(M?`[^${M}]`:".")+(H.greedy?"+":"*"))}else R($.start,$.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=f.slice($.start+1,F.start)+f.slice(F.end,$.end-1);R($.start,$.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else $.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){B.unshift(F)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(F){B.unshift(F)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(F){B.unshift(F)},onCharacterClassLeave(){B.shift()},onAssertionEnter(F){c(F)&&B.push(F)},onAssertionLeave(F){B[0]===F&&B.shift()}}).visit(u),E+=f.slice(T),E}e.fixRegexNewline=d;function o(f){return f.replace(/\n/g,"\\r?\\n")}e.fixNewline=o}),define(fe[281],me([0,1,21,136,117,10]),function(Y,e,m,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class n{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,P,I,l){const v=new L.RipgrepTextSearchEngine(this.outputChannel);if(P.folder.scheme===C.Schemas.userData){const h={...P,folder:P.folder.with({scheme:C.Schemas.file})},w=new y.Progress(S=>I.report({...S,uri:S.uri.with({scheme:P.folder.scheme})}));return this.withToken(l,S=>v.provideTextSearchResults(D,h,w,S))}else return this.withToken(l,h=>v.provideTextSearchResults(D,P,I,h))}async withToken(D,P){const I=k(D);this.inProgress.add(I);const l=await P(I.token);return this.inProgress.delete(I),l}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=n;function k(_){const D=new m.CancellationTokenSource;return _.onCancellationRequested(()=>D.cancel()),D}}),define(fe[282],me([0,1,28,136,135]),function(Y,e,m,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(_){this.query=_}search(_,D,P){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(v){P({message:v})}},l=new y.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),m);return new Promise((v,h)=>l.search(w=>{D(w.map(n))},_).then(w=>v({limitHit:w.limitHit,type:"success",stats:w.stats}),h))}}e.TextSearchEngineAdapter=C;function n(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((_,D)=>{if(D.ranges){const P=D;return _+(Array.isArray(P.ranges)?P.ranges.length:1)}else return _+1},0)}}}),define(fe[283],me([0,1,17,18,16,3,101,9,47,2,42,33,280,282]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class h{constructor(r="searchProcess"){this.processType=r,this.caches=Object.create(null)}fileSearch(r){let g;const s=A(r),b=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,L.createCancelablePromise)(i=>this.doFileSearchWithEngine(l.Engine,s,t=>b.fire(t),i)),g.then(i=>b.fire(i),i=>b.fire({type:"error",error:{message:i.message,stack:i.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return b.event}textSearch(r){let g;const s=A(r),b=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,L.createCancelablePromise)(i=>this.ripgrepTextSearch(s,t=>b.fire(t),i)),g.then(i=>b.fire(i),i=>b.fire({type:"error",error:{message:i.message,stack:i.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return b.event}ripgrepTextSearch(r,g,s){return r.maxFileSize=(0,P.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(r).search(s,g,g)}doFileSearch(r,g,s){return this.doFileSearchWithEngine(l.Engine,r,g,s)}doFileSearchWithEngine(r,g,s,b,i=h.BATCH_SIZE){let t=0;const c=o=>{Array.isArray(o)?(t+=o.length,s(o.map(f=>this.rawMatchToSearchItem(f)))):o.relativePath?(t++,s(this.rawMatchToSearchItem(o))):s(o)};if(g.sortByScore){let o=this.trySortedSearchFromCache(g,c,b);if(!o){const f=g.maxResults?Object.assign({},g,{maxResults:null}):g,u=new r(f);o=this.doSortedSearch(u,g,s,c,b)}return new Promise((f,u)=>{o.then(([E,T])=>{const R=T.map(B=>this.rawMatchToSearchItem(B));this.sendProgress(R,s,i),f(E)},u)})}const d=new r(g);return this.doSearch(d,c,i,b).then(o=>({limitHit:o.limitHit,type:"success",stats:{detailStats:o.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(r){return{path:r.base?(0,k.join)(r.base,r.relativePath):r.relativePath}}doSortedSearch(r,g,s,b,i){const t=new C.Emitter;let c=(0,L.createCancelablePromise)(o=>{let f=[];const u=E=>{Array.isArray(E)?f=E:(b(E),t.fire(E))};return this.doSearch(r,u,-1,o).then(E=>[E,f])}),d;if(g.cacheKey){d=this.getOrCreateCache(g.cacheKey);const o={promise:c,event:t.event,resolved:!1};d.resultsToSearchCache[g.filePattern||""]=o,c.then(()=>{o.resolved=!0},f=>{delete d.resultsToSearchCache[g.filePattern||""]}),c=this.preventCancellation(c)}return c.then(([o,f])=>{const u=d?d.scorerCache:Object.create(null),E=(typeof g.maxResults!="number"||g.maxResults>0)&&_.StopWatch.create(!1);return this.sortResults(g,f,u,i).then(T=>{const R=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:o.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:T.length},messages:o.messages,limitHit:o.limitHit||typeof g.maxResults=="number"&&f.length>g.maxResults},T]})})}getOrCreateCache(r){const g=this.caches[r];return g||(this.caches[r]=new w)}trySortedSearchFromCache(r,g,s){const b=r.cacheKey&&this.caches[r.cacheKey];if(!b)return;const i=this.getResultsFromCache(b,r.filePattern||"",g,s);if(i)return i.then(([t,c,d])=>{const o=_.StopWatch.create(!1);return this.sortResults(r,c,b.scorerCache,s).then(f=>{const u=o.elapsed(),E={fromCache:!0,detailStats:d,type:this.processType,resultCount:c.length,sortingTime:u};return[{type:"success",limitHit:t.limitHit||typeof r.maxResults=="number"&&c.length>r.maxResults,stats:E},f]})})}sortResults(r,g,s,b){const i=(0,n.prepareQuery)(r.filePattern||""),t=(d,o)=>(0,n.compareItemsByFuzzyScore)(d,o,i,!0,S,s),c=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return m.topAsync(g,t,c,1e4,b)}sendProgress(r,g,s){if(s&&s>0)for(let b=0;b<r.length;b+=s)g(r.slice(b,b+s));else g(r)}getResultsFromCache(r,g,s,b){const i=_.StopWatch.create(!1),t=g.indexOf(k.sep)>=0;let c;for(const u in r.resultsToSearchCache)if(g.startsWith(u)){if(t&&u.indexOf(k.sep)<0&&u!=="")continue;const E=r.resultsToSearchCache[u];c={promise:this.preventCancellation(E.promise),event:E.event,resolved:E.resolved};break}if(!c)return null;const d=i.elapsed(),o=_.StopWatch.create(!1),f=c.event(s);return b&&b.onCancellationRequested(()=>{f.dispose()}),c.promise.then(([u,E])=>{if(b&&b.isCancellationRequested)throw(0,y.canceled)();const T=[],R=(0,n.prepareQuery)(g).normalizedLowercase;for(const B of E)!(0,I.isFilePatternMatch)(B,R)||T.push(B);return[u,T,{cacheWasResolved:c.resolved,cacheLookupTime:d,cacheFilterTime:o.elapsed(),cacheEntryCount:E.length}]})}doSearch(r,g,s,b){return new Promise((i,t)=>{let c=[];b&&b.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(s?(c.push(d),s>0&&c.length>=s&&(g(c),c=[])):g(d))},d=>{g(d)},(d,o)=>{c.length&&g(c),d?t(d):i(o)})})}clearCache(r){return delete this.caches[r],Promise.resolve(void 0)}preventCancellation(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,s){return r.then(g,s)}catch(g){return this.then(void 0,g)}finally(g){return r.finally(g)}}}}e.SearchService=h,h.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const S=new class{getItemLabel(a){return(0,k.basename)(a.relativePath)}getItemDescription(a){return(0,k.dirname)(a.relativePath)}getItemPath(a){return a.relativePath}};function A(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(p),extraFileResources:a.extraFileResources&&a.extraFileResources.map(r=>D.URI.revive(r))}}function p(a){return{...a,folder:D.URI.revive(a.folder)}}}),define(fe[284],me([0,1,6,10,2,28,11,26,14,72,64,33,283,281,93,135]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let S=class extends D.ExtHostSearch{constructor(p,a,r,g){super(p,r,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const s=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new v.RipgrepSearchProvider(s)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const p=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new v.RipgrepSearchProvider(p)),this.registerInternalFileSearchProvider(L.Schemas.file,new l.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(p,a){const r=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=r,this._proxy.$registerFileSearchProvider(r,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(r)})}$provideFileSearchResults(p,a,r,g){const s=(0,D.reviveQuery)(r);return p===this._internalFileSearchHandle?this.doInternalFileSearch(p,a,s,g):super.$provideFileSearchResults(p,a,r,g)}doInternalFileSearch(p,a,r,g){const s=b=>{if((0,I.isSerializedFileMatch)(b)&&(b=[b]),Array.isArray(b)){this._proxy.$handleFileMatch(p,a,b.map(i=>y.URI.file(i.path)));return}b.message&&this._logService.debug("ExtHostSearch",b.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(r,s,g)}$clearCache(p){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(p),super.$clearCache(p)}createTextSearchManager(p,a){return new w.NativeTextSearchManager(p,a,void 0,"textSearchProvider")}};S=Ve([$e(0,_.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,P.IURITransformerService),$e(3,n.ILogService)],S),e.NativeExtHostSearch=S}),define(fe[137],me([0,1,296,124,81,22,16,3,6,9,12,32,106,107,297]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(o){this.socket=o,this._errorListener=f=>{if(f){if(f.code==="EPIPE")return;(0,n.onUnexpectedError)(f)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(o){const f=u=>o(C.VSBuffer.wrap(u));return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(o){const f=u=>{o({type:0,hadError:u,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(o){return this.socket.on("end",o),{dispose:()=>this.socket.off("end",o)}}write(o){if(!this.socket.destroyed)try{this.socket.write(o.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,n.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,n.onUnexpectedError)(f)}}end(){this.socket.end()}drain(){return new Promise((o,f)=>{if(this.socket.bufferSize===0){o();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),o()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=w;var S;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var A;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(A||(A={}));class p extends _.Disposable{constructor(o,f,u,E){super();this._onDidZlibFlush=this._register(new k.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=f,this._recordInflateBytes=E,f?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),(0,n.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),(0,n.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new v.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this._onData.event(o)}onClose(o){return this._onClose.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this._totalOutgoingDataBytes+=o.byteLength,this._zlibDeflate?(this._zlibDeflate.write(o.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let f=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,f=f.slice(0,f.length-4),this._isEnded||this._write(C.VSBuffer.wrap(f),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(o,!1)}_write(o,f){let u=2;o.byteLength<126?u+=0:o.byteLength<2**16?u+=2:u+=8;const E=C.VSBuffer.alloc(u);if(f?E.writeUInt8(194,0):E.writeUInt8(130,0),o.byteLength<126)E.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){E.writeUInt8(126,1);let T=1;E.writeUInt8(o.byteLength>>>8&255,++T),E.writeUInt8(o.byteLength>>>0&255,++T)}else{E.writeUInt8(127,1);let T=1;E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(0,++T),E.writeUInt8(o.byteLength>>>24&255,++T),E.writeUInt8(o.byteLength>>>16&255,++T),E.writeUInt8(o.byteLength>>>8&255,++T),E.writeUInt8(o.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=E.byteLength+o.byteLength,this.socket.write(C.VSBuffer.concat([E,o]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(o){if(o.byteLength!==0){for(this._totalIncomingWireBytes+=o.byteLength,this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const f=this._incomingData.peek(this._state.readLen),u=f.readUInt8(0),E=(u&128)>>>7,T=(u&64)>>>6,R=f.readUInt8(1),B=(R&128)>>>7,x=R&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=E,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(E),this._state.mask=0}else if(this._state.state===2){const f=this._incomingData.read(this._state.readLen),u=f.readUInt8(1),E=(u&128)>>>7;let T=u&127,R=1;T===126?T=f.readUInt8(++R)*2**8+f.readUInt8(++R):T===127&&(T=f.readUInt8(++R)*0+f.readUInt8(++R)*0+f.readUInt8(++R)*0+f.readUInt8(++R)*0+f.readUInt8(++R)*2**24+f.readUInt8(++R)*2**16+f.readUInt8(++R)*2**8+f.readUInt8(++R));let B=0;E&&(B=f.readUInt8(++R)*2**24+f.readUInt8(++R)*2**16+f.readUInt8(++R)*2**8+f.readUInt8(++R)),this._state.state=3,this._state.readLen=T,this._state.mask=B}else if(this._state.state===3){const f=this._incomingData.read(this._state.readLen);a(f,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(f.buffer)),this._zlibInflate.write(f.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(C.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=f.byteLength,this._onData.fire(f))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await k.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=p;function a(d,o){if(o===0)return;let f=d.byteLength>>>2;for(let x=0;x<f;x++){const F=d.readUInt32BE(x*4);d.writeUInt32BE(F^o,x*4)}let u=f*4,E=d.byteLength-u;const T=o>>>24&255,R=o>>>16&255,B=o>>>8&255;E>=1&&d.writeUInt8(d.readUInt8(u)^T,u),E>=2&&d.writeUInt8(d.readUInt8(u+1)^R,u+1),E>=3&&d.writeUInt8(d.readUInt8(u+2)^B,u+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function g(){const d=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):o=(0,D.join)((0,y.tmpdir)(),`vscode-ipc-${d}.sock`),b(o),o}e.createRandomIPCHandle=g;function s(d,o,f){const u=(0,m.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${f}-${o}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${f}-${o}.sock`):E=(0,D.join)(d,`${f}-${o}.sock`),b(E),E}e.createStaticIPCHandle=s;function b(d){const o=r[P.platform];typeof o=="number"&&d.length>=o&&console.warn(`WARNING: IPC handle "${d}" is longer than ${o} chars, try a shorter --user-data-dir`)}class i extends l.IPCServer{constructor(o){super(i.toClientConnectionEvent(o));this.server=o}static toClientConnectionEvent(o){const f=k.Event.fromNodeEventEmitter(o,"connection");return k.Event.map(f,u=>({protocol:new v.Protocol(new w(u)),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function t(d){return new Promise((o,f)=>{const u=(0,L.createServer)();u.on("error",f),u.listen(d,()=>{u.removeListener("error",f),o(new i(u))})})}e.serve=t;function c(d,o){return new Promise((f,u)=>{const E=(0,L.createConnection)(d,()=>{E.removeListener("error",u),f(v.Client.fromSocket(new w(E),o))});E.once("error",u)})}e.connect=c}),define(fe[285],me([0,1,137,277,60,39,2,197,11]),function(Y,e,m,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(l,v,h){this._commands=l,this.logService=v,this._ipcHandlePath=h,this._server=L.createServer((w,S)=>this.onRequest(w,S)),this.setup().catch(w=>(v.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch(l){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,v){const h=[];l.setEncoding("utf8"),l.on("data",w=>h.push(w)),l.on("end",()=>{const w=JSON.parse(h.join(""));switch(w.type){case"open":this.open(w,v);break;case"openExternal":this.openExternal(w,v);break;case"status":this.getStatus(w,v);break;case"extensionManagement":this.manageExtensions(w,v).catch(this.logService.error);break;default:v.writeHead(404),v.write(`Unknown message type: ${w.type}`,S=>{S&&this.logService.error(S)}),v.end();break}})}open(l,v){let{fileURIs:h,folderURIs:w,forceNewWindow:S,diffMode:A,addMode:p,forceReuseWindow:a,gotoLineMode:r,waitMarkerFilePath:g}=l;const s=[];if(Array.isArray(w))for(const b of w)try{s.push({folderUri:n.URI.parse(b)})}catch(i){}if(Array.isArray(h))for(const b of h)try{(0,k.hasWorkspaceFileExtension)(b)?s.push({workspaceUri:n.URI.parse(b)}):s.push({fileUri:n.URI.parse(b)})}catch(i){}if(s.length){const b=g?n.URI.file(g):void 0,t={forceNewWindow:S,diffMode:A,addMode:p,gotoLineMode:r,forceReuseWindow:a,preferNewWindow:!a&&!b&&!p,waitMarkerFileURI:b};this._commands.executeCommand("_remoteCLI.windowOpen",s,t)}v.writeHead(200),v.end()}async openExternal(l,v){for(const h of l.uris){const w=n.URI.parse(h),S=w.scheme==="file"?w:h;await this._commands.executeCommand("_remoteCLI.openExternal",S)}v.writeHead(200),v.end()}async manageExtensions(l,v){try{const h=A=>A?.map(p=>/\.vsix$/i.test(p)?n.URI.parse(p):p),w={list:l.list,install:h(l.install),uninstall:h(l.uninstall),force:l.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);v.writeHead(200),v.write(S)}catch(h){v.writeHead(500),v.write(String(h),w=>{w&&this.logService.error(w)})}v.end()}async getStatus(l,v){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");v.writeHead(200),v.write(h),v.end()}catch(h){v.writeHead(500),v.write(String(h),w=>{w&&this.logService.error(w)}),v.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let P=class extends D{constructor(l,v){super(l,v,(0,m.createRandomIPCHandle)())}};P=Ve([$e(0,C.IExtHostCommands),$e(1,_.ILogService)],P),e.CLIServer=P}),define(fe[286],me([0,1,71,273,268,5,276,40,258,2,10,7,285,105]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends y.RequireInterceptor{_installInterceptor(){const A=this,p=Y.__$__nodeRequire("module"),a=p._load;p._load=function(g,s,b){for(let i of A._alternatives){let t=i(g);if(t){g=t;break}}return A._factories.has(g)?A._factories.get(g).load(g,D.URI.file((0,v.realpathSync)(s.filename)),i=>a.apply(this,[i,s,b])):a.apply(this,arguments)}}}class w extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const A=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const s=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}await this._instaService.createInstance(h,A,this._registry).install(),m.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,n.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const r=process.send,g=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...s)=>s.length===0||!s[0]||s[0].type!=="__$console"?r.apply(process,s):(g.$logExtensionHostMessage(s[0]),!1)}_getEntryPoint(A){return A.main}_loadCommonJSModule(A,p,a){if(p.scheme!==P.Schemas.file)throw new Error(`Cannot load URI: '${p}', must be of file-scheme`);let r=null;a.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${p.toString(!0)}`),this._logService.flush();try{A&&m.mark(`code/extHost/willLoadExtensionCode/${A.value}`),r=Y.__$__nodeRequire(p.fsPath)}catch(g){return Promise.reject(g)}finally{A&&m.mark(`code/extHost/didLoadExtensionCode/${A.value}`),a.codeLoadingStop()}return Promise.resolve(r)}async $setRemoteEnvironment(A){if(!!this._initData.remote.isRemote)for(const p in A){const a=A[p];a===null?delete process.env[p]:process.env[p]=a}}}e.ExtHostExtensionService=w}),define(fe[287],me([0,1,83,261,270,269,284,286,262,55,40,72,70,34,52,67,260,259,11]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(P.IExtHostExtensionService,k.ExtHostExtensionService),(0,m.registerSingleton)(p.ILoggerService,A.ExtHostLoggerService),(0,m.registerSingleton)(w.IExtensionStoragePaths,S.ExtensionStoragePaths),(0,m.registerSingleton)(D.IExtHostDebugService,C.ExtHostDebugService),(0,m.registerSingleton)(I.IExtHostSearch,n.NativeExtHostSearch),(0,m.registerSingleton)(l.IExtHostTask,y.ExtHostTask),(0,m.registerSingleton)(v.IExtHostTerminalService,L.ExtHostTerminalService),(0,m.registerSingleton)(h.IExtHostTunnelService,_.ExtHostTunnelService)}),define(fe[288],me([0,1,124,298,71,16,107,137,190,224,271,22,103,28,105,18,114,274,287]),function(Y,e,m,L,y,C,n,k,_,D,P,I,l,v,h,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let c=0;c<process.execArgv.length;c++)process.execArgv[c]==="--inspect-port=0"&&(process.execArgv.splice(c,1),c--)}();const A=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),c=t._load;t._load=function(d){if(d==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return c.apply(this,arguments)}})();const p=process.exit.bind(process);function a(t){process.exit=function(c){if(t)p(c);else{const d=new Error("An extension called process.exit() and this was prevented.");console.warn(d.stack)}},process.crash=function(){const c=new Error("An extension called process.crash() and this was prevented.");console.warn(c.stack)}}let r=function(t){p()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,c)=>{let d=null,o=setTimeout(()=>{r("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const f=108e5,u=3e5,E=new w.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (1)"),f),T=new w.ProcessTimeRunOnceScheduler(()=>r("renderer disconnected for too long (2)"),u);process.on("message",(B,x)=>{if(B&&B.type==="VSCODE_EXTHOST_IPC_SOCKET"){const F=I.VSBuffer.wrap(Buffer.from(B.initialDataChunk,"base64"));let $;if(B.skipWebSocketFrames)$=new k.NodeSocket(x);else{const M=I.VSBuffer.wrap(Buffer.from(B.inflateBytes,"base64"));$=new k.WebSocketNodeSocket(new k.NodeSocket(x),B.permessageDeflate,M,!1)}d?(E.cancel(),T.cancel(),d.beginAcceptReconnection($,F),d.endAcceptReconnection()):(clearTimeout(o),d=new n.PersistentProtocol($,F),d.onDidDispose(()=>r("renderer disconnected")),t(d),d.onSocketClose(()=>{E.schedule()}))}if(B&&B.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;E.isScheduled()&&T.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((c,d)=>{const o=m.createConnection(t,()=>{o.removeListener("error",d),c(new n.PersistentProtocol(new k.NodeSocket(o)))});o.once("error",d),o.on("close",()=>{r("renderer closed the socket")})})}}async function s(){const t=await g();return new class{constructor(){this._onMessage=new n.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(c=>{(0,D.isMessageOfType)(c,2)?(this._terminating=!0,r("received terminate message from renderer")):this._onMessage.fire(c)})}send(c){this._terminating||t.send(c)}drain(){return t.drain()}}}function b(t){return new Promise(c=>{const d=t.onMessage(o=>{d.dispose();const f=JSON.parse(o.toString()),u=f.commit,E=_.default.commit;u&&E&&u!==E&&p(55);let T=0;setInterval(function(){try{process.kill(f.parentPid,0),T=0}catch(B){B&&B.code==="EPERM"?(T++,T>=3&&r(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${B.message} (code: ${B.code}) (errno: ${B.errno})`)):r(`parent process ${f.parentPid} does not exist anymore: ${B.message} (code: ${B.code}) (errno: ${B.errno})`)}},1e3);let R;try{R=Y.__$__nodeRequire("native-watchdog"),R.start(f.parentPid)}catch(B){(0,C.onUnexpectedError)(B)}t.send((0,D.createMessageOfType)(0)),c({protocol:t,initData:f})});t.send((0,D.createMessageOfType)(1))})}async function i(){const t=[];process.on("unhandledRejection",(T,R)=>{t.push(R),setTimeout(()=>{const B=t.indexOf(R);B>=0&&R.catch(x=>{t.splice(B,1),(0,C.isPromiseCanceledError)(x)||(console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),T&&(0,C.onUnexpectedError)(T))})},1e3)}),process.on("rejectionHandled",T=>{const R=t.indexOf(T);R>=0&&t.splice(R,1)}),process.on("uncaughtException",function(T){(0,C.onUnexpectedError)(T)}),y.mark("code/extHost/willConnectToRenderer");const c=await s();y.mark("code/extHost/didConnectToRenderer");const d=await b(c);y.mark("code/extHost/didWaitForInitData");const{initData:o}=d;a(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=A.useHostProxy!==void 0?A.useHostProxy!=="false":void 0,o.environment.skipWorkspaceStorageLock=(0,S.boolean)(A.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(R){p(R)}exists(R){return v.Promises.exists(R)}realpath(R){return(0,h.realpath)(R)}};let u=null;if(o.remote.authority&&A.uriTransformerPath)try{const R=Y.__$__nodeRequire(A.uriTransformerPath)(o.remote.authority);u=new l.URITransformer(R)}catch(T){console.error(T)}const E=new P.ExtensionHostMain(d.protocol,o,f,u);r=T=>E.terminate(T)}e.startExtensionHostProcess=i}),define(fe[299],me([0,1,288]),function(Y,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d450b04c783dfa6f83dc439017767acccd4e9fac/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
