/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/resources","vs/base/common/platform","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(re){for(var e=[],c=0,M=re.length;c<M;c++)e[c]=we[re[c]];return e};define(we[41],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function c(M,w){if(!M)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=c}),define(we[75],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const c=Object.prototype.hasOwnProperty;function M(F){const _=[];for(let r in F)c.call(F,r)&&_.push(F[r]);return _}e.values=M;function w(F,_){for(let r in F)if(c.call(F,r)&&_({key:r,value:F[r]},function(){delete F[r]})===!1)return}e.forEach=w;function T(F,_){const r=Object.create(null);for(const m of F){const o=_(m);let d=r[o];d||(d=r[o]=[]),d.push(m)}return r}e.groupBy=T;function t(F){const _=Object.create(null);return F&&F.forEach((r,m)=>{_[m]=r}),_}e.fromMap=t;function R(F,_){const r=[],m=[];for(let o of F)_.has(o)||r.push(o);for(let o of _)F.has(o)||m.push(o);return{removed:r,added:m}}e.diffSets=R;function C(F,_){const r=[],m=[];for(let[o,d]of F)_.has(o)||r.push(d);for(let[o,d]of _)F.has(o)||m.push(d);return{removed:r,added:m}}e.diffMaps=C;class k{constructor(){this.map=new Map}add(_,r){let m=this.map.get(_);m||(m=new Set,this.map.set(_,m)),m.add(r)}delete(_,r){const m=this.map.get(_);!m||(m.delete(r),m.size===0&&this.map.delete(_))}forEach(_,r){const m=this.map.get(_);!m||m.forEach(r)}}e.SetMap=k}),define(we[52],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function c(t){return(R,C,k)=>{let F=null,_=null;if(typeof k.value=="function"?(F="value",_=k.value):typeof k.get=="function"&&(F="get",_=k.get),!_)throw new Error("not supported");k[F]=t(_,C)}}e.createDecorator=c;function M(t,R,C){let k=null,F=null;if(typeof C.value=="function"?(k="value",F=C.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(k="get",F=C.get),!F)throw new Error("not supported");const _=`$memoize$${R}`;C[k]=function(...r){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,r)}),this[_]}}e.memoize=M;function w(t,R,C){return c((k,F)=>{const _=`$debounce$${F}`,r=`$debounce$result$${F}`;return function(...m){this[r]||(this[r]=C?C():void 0),clearTimeout(this[_]),R&&(this[r]=R(this[r],...m),m=[this[r]]),this[_]=setTimeout(()=>{k.apply(this,m),this[r]=C?C():void 0},t)}})}e.debounce=w;function T(t,R,C){return c((k,F)=>{const _=`$throttle$timer$${F}`,r=`$throttle$result$${F}`,m=`$throttle$lastRun$${F}`,o=`$throttle$pending$${F}`;return function(...d){if(this[r]||(this[r]=C?C():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),R&&(this[r]=R(this[r],...d)),this[o])return;const p=this[m]+t;p<=Date.now()?(this[m]=Date.now(),k.apply(this,[this[r]]),this[r]=C?C():void 0):(this[o]=!0,this[_]=setTimeout(()=>{this[o]=!1,this[m]=Date.now(),k.apply(this,[this[r]]),this[r]=C?C():void 0},p-Date.now()))}})}e.throttle=T}),define(we[53],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class c{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=c,e.defaultGenerator=new c("id#")}),define(we[101],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var c;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(c=e.ScanError||(e.ScanError={}));var M;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(a){a.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function t(a,P=!1){let n=0,i=a.length,v="",g=0,s=16,b=0;function u(x){let N=0,V=0;for(;N<x;){const $=a.charCodeAt(n);if($>=48&&$<=57)V=V*16+$-48;else if($>=65&&$<=70)V=V*16+$-65+10;else if($>=97&&$<=102)V=V*16+$-97+10;else break;n++,N++}return N<x&&(V=-1),V}function E(x){n=x,v="",g=0,s=16,b=0}function A(){const x=n;if(a.charCodeAt(n)===48)n++;else for(n++;n<a.length&&k(a.charCodeAt(n));)n++;if(n<a.length&&a.charCodeAt(n)===46)if(n++,n<a.length&&k(a.charCodeAt(n)))for(n++;n<a.length&&k(a.charCodeAt(n));)n++;else return b=3,a.substring(x,n);let N=n;if(n<a.length&&(a.charCodeAt(n)===69||a.charCodeAt(n)===101))if(n++,(n<a.length&&a.charCodeAt(n)===43||a.charCodeAt(n)===45)&&n++,n<a.length&&k(a.charCodeAt(n))){for(n++;n<a.length&&k(a.charCodeAt(n));)n++;N=n}else b=3;return a.substring(x,N)}function I(){let x="",N=n;for(;;){if(n>=i){x+=a.substring(N,n),b=2;break}const V=a.charCodeAt(n);if(V===34){x+=a.substring(N,n),n++;break}if(V===92){if(x+=a.substring(N,n),n++,n>=i){b=2;break}switch(a.charCodeAt(n++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const z=u(4);z>=0?x+=String.fromCharCode(z):b=4;break;default:b=5}N=n;continue}if(V>=0&&V<=31)if(C(V)){x+=a.substring(N,n),b=2;break}else b=6;n++}return x}function B(){if(v="",b=0,g=n,n>=i)return g=i,s=17;let x=a.charCodeAt(n);if(R(x)){do n++,v+=String.fromCharCode(x),x=a.charCodeAt(n);while(R(x));return s=15}if(C(x))return n++,v+=String.fromCharCode(x),x===13&&a.charCodeAt(n)===10&&(n++,v+=`
`),s=14;switch(x){case 123:return n++,s=1;case 125:return n++,s=2;case 91:return n++,s=3;case 93:return n++,s=4;case 58:return n++,s=6;case 44:return n++,s=5;case 34:return n++,v=I(),s=10;case 47:const N=n-1;if(a.charCodeAt(n+1)===47){for(n+=2;n<i&&!C(a.charCodeAt(n));)n++;return v=a.substring(N,n),s=12}if(a.charCodeAt(n+1)===42){n+=2;const V=i-1;let $=!1;for(;n<V;){if(a.charCodeAt(n)===42&&a.charCodeAt(n+1)===47){n+=2,$=!0;break}n++}return $||(n++,b=1),v=a.substring(N,n),s=13}return v+=String.fromCharCode(x),n++,s=16;case 45:if(v+=String.fromCharCode(x),n++,n===i||!k(a.charCodeAt(n)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=A(),s=11;default:for(;n<i&&O(x);)n++,x=a.charCodeAt(n);if(g!==n){switch(v=a.substring(g,n),v){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return v+=String.fromCharCode(x),n++,s=16}}function O(x){if(R(x)||C(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function S(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>n,scan:P?S:B,getToken:()=>s,getTokenValue:()=>v,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>b}}e.createScanner=t;function R(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function C(a){return a===10||a===13||a===8232||a===8233}function k(a){return a>=48&&a<=57}var F;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(F||(F={}));function _(a,P){const n=[],i=new Object;let v;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function b(u,E,A,I){g.value=u,g.offset=E,g.length=A,g.type=I,g.colonOffset=void 0,v=g}try{l(a,{onObjectBegin:(u,E)=>{if(P<=u)throw i;v=void 0,s=P>u,n.push("")},onObjectProperty:(u,E,A)=>{if(P<E||(b(u,E,A,"property"),n[n.length-1]=u,P<=E+A))throw i},onObjectEnd:(u,E)=>{if(P<=u)throw i;v=void 0,n.pop()},onArrayBegin:(u,E)=>{if(P<=u)throw i;v=void 0,n.push(0)},onArrayEnd:(u,E)=>{if(P<=u)throw i;v=void 0,n.pop()},onLiteralValue:(u,E,A)=>{if(P<E||(b(u,E,A,y(u)),P<=E+A))throw i},onSeparator:(u,E,A)=>{if(P<=E)throw i;if(u===":"&&v&&v.type==="property")v.colonOffset=E,s=!1,v=void 0;else if(u===","){const I=n[n.length-1];typeof I=="number"?n[n.length-1]=I+1:(s=!0,n[n.length-1]=""),v=void 0}}})}catch(u){if(u!==i)throw u}return{path:n,previousNode:v,isAtPropertyKey:s,matches:u=>{let E=0;for(let A=0;E<u.length&&A<n.length;A++)if(u[E]===n[A]||u[E]==="*")E++;else if(u[E]!=="**")return!1;return E===u.length}}}e.getLocation=_;function r(a,P=[],n=T.DEFAULT){let i=null,v=[];const g=[];function s(u){Array.isArray(v)?v.push(u):i!==null&&(v[i]=u)}return l(a,{onObjectBegin:()=>{const u={};s(u),g.push(v),v=u,i=null},onObjectProperty:u=>{i=u},onObjectEnd:()=>{v=g.pop()},onArrayBegin:()=>{const u=[];s(u),g.push(v),v=u,i=null},onArrayEnd:()=>{v=g.pop()},onLiteralValue:s,onError:(u,E,A)=>{P.push({error:u,offset:E,length:A})}},n),v[0]}e.parse=r;function m(a,P=[],n=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(u){i.type==="property"&&(i.length=u-i.offset,i=i.parent)}function g(u){return i.children.push(u),u}l(a,{onObjectBegin:u=>{i=g({type:"object",offset:u,length:-1,parent:i,children:[]})},onObjectProperty:(u,E,A)=>{i=g({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:u,offset:E,length:A,parent:i})},onObjectEnd:(u,E)=>{i.length=u+E-i.offset,i=i.parent,v(u+E)},onArrayBegin:(u,E)=>{i=g({type:"array",offset:u,length:-1,parent:i,children:[]})},onArrayEnd:(u,E)=>{i.length=u+E-i.offset,i=i.parent,v(u+E)},onLiteralValue:(u,E,A)=>{g({type:y(u),offset:E,length:A,parent:i,value:u}),v(E+A)},onSeparator:(u,E,A)=>{i.type==="property"&&(u===":"?i.colonOffset=E:u===","&&v(E))},onError:(u,E,A)=>{P.push({error:u,offset:E,length:A})}},n);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=m;function o(a,P){if(!a)return;let n=a;for(let i of P)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let v=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===i){n=g.children[1],v=!0;break}if(!v)return}else{const v=i;if(n.type!=="array"||v<0||!Array.isArray(n.children)||v>=n.children.length)return;n=n.children[v]}return n}e.findNodeAtLocation=o;function d(a){if(!a.parent||!a.parent.children)return[];const P=d(a.parent);if(a.parent.type==="property"){const n=a.parent.children[0].value;P.push(n)}else if(a.parent.type==="array"){const n=a.parent.children.indexOf(a);n!==-1&&P.push(n)}return P}e.getNodePath=d;function p(a){switch(a.type){case"array":return a.children.map(p);case"object":const P=Object.create(null);for(let n of a.children){const i=n.children[1];i&&(P[n.children[0].value]=p(i))}return P;case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=p;function D(a,P,n=!1){return P>=a.offset&&P<a.offset+a.length||n&&P===a.offset+a.length}e.contains=D;function f(a,P,n=!1){if(D(a,P,n)){const i=a.children;if(Array.isArray(i))for(let v=0;v<i.length&&i[v].offset<=P;v++){const g=f(i[v],P,n);if(g)return g}return a}}e.findNodeAtOffset=f;function l(a,P,n=T.DEFAULT){const i=t(a,!1);function v(ue){return ue?()=>ue(i.getTokenOffset(),i.getTokenLength()):()=>!0}function g(ue){return ue?Fe=>ue(Fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const s=v(P.onObjectBegin),b=g(P.onObjectProperty),u=v(P.onObjectEnd),E=v(P.onArrayBegin),A=v(P.onArrayEnd),I=g(P.onLiteralValue),B=g(P.onSeparator),O=v(P.onComment),S=g(P.onError),x=n&&n.disallowComments,N=n&&n.allowTrailingComma;function V(){for(;;){const ue=i.scan();switch(i.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:x||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ue){case 12:case 13:x?$(10):O();break;case 16:$(1);break;case 15:case 14:break;default:return ue}}}function $(ue,Fe=[],Ke=[]){if(S(ue),Fe.length+Ke.length>0){let Oe=i.getToken();for(;Oe!==17;){if(Fe.indexOf(Oe)!==-1){V();break}else if(Ke.indexOf(Oe)!==-1)break;Oe=V()}}}function z(ue){const Fe=i.getTokenValue();return ue?I(Fe):b(Fe),V(),!0}function ee(){switch(i.getToken()){case 11:let ue=0;try{ue=JSON.parse(i.getTokenValue()),typeof ue!="number"&&($(2),ue=0)}catch(Fe){$(2)}I(ue);break;case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return V(),!0}function j(){return i.getToken()!==10?($(3,[],[2,5]),!1):(z(!1),i.getToken()===6?(B(":"),V(),ve()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function Q(){s(),V();let ue=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ue||$(4,[],[]),B(","),V(),i.getToken()===2&&N)break}else ue&&$(6,[],[]);j()||$(4,[],[2,5]),ue=!0}return u(),i.getToken()!==2?$(7,[2],[]):V(),!0}function ce(){E(),V();let ue=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ue||$(4,[],[]),B(","),V(),i.getToken()===4&&N)break}else ue&&$(6,[],[]);ve()||$(4,[],[4,5]),ue=!0}return A(),i.getToken()!==4?$(8,[4],[]):V(),!0}function ve(){switch(i.getToken()){case 3:return ce();case 1:return Q();case 10:return z(!0);default:return ee()}}return V(),i.getToken()===17?n.allowEmptyContent?!0:($(4,[],[]),!1):ve()?(i.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=l;function h(a,P){let n=t(a),i=[],v,g=0,s;do switch(s=n.getPosition(),v=n.scan(),v){case 12:case 13:case 17:g!==s&&i.push(a.substring(g,s)),P!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,P)),g=n.getPosition();break}while(v!==17);return i.join("")}e.stripComments=h;function y(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(we[102],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class c{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new c(()=>w(this.getValue()))}}e.Lazy=c}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Ie,ge){for(var Ce=0;Ce<ge.length;Ce++){var Z=ge[Ce];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(Ie,Z.key,Z)}}function e(Ie,ge,Ce){return ge&&re(Ie.prototype,ge),Ce&&re(Ie,Ce),Ie}function c(Ie,ge){if(!!Ie){if(typeof Ie=="string")return M(Ie,ge);var Ce=Object.prototype.toString.call(Ie).slice(8,-1);if(Ce==="Object"&&Ie.constructor&&(Ce=Ie.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Ie);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Ie,ge)}}function M(Ie,ge){(ge==null||ge>Ie.length)&&(ge=Ie.length);for(var Ce=0,Z=new Array(ge);Ce<ge;Ce++)Z[Ce]=Ie[Ce];return Z}function w(Ie,ge){var Ce=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(Ce)return(Ce=Ce.call(Ie)).next.bind(Ce);if(Array.isArray(Ie)||(Ce=c(Ie))||ge&&Ie&&typeof Ie.length=="number"){Ce&&(Ie=Ce);var Z=0;return function(){return Z>=Ie.length?{done:!0}:{done:!1,value:Ie[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function t(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function R(Ie){T.exports.defaults=Ie}T.exports={defaults:t(),getDefaults:t,changeDefaults:R};var C=/[&<>"']/,k=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(ge){return r[ge]};function o(Ie,ge){if(ge){if(C.test(Ie))return Ie.replace(k,m)}else if(F.test(Ie))return Ie.replace(_,m);return Ie}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(Ie){return Ie.replace(d,function(ge,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var D=/(^|[^\[])\^/g;function f(Ie,ge){Ie=Ie.source||Ie,ge=ge||"";var Ce={replace:function(se,fe){return fe=fe.source||fe,fe=fe.replace(D,"$1"),Ie=Ie.replace(se,fe),Ce},getRegex:function(){return new RegExp(Ie,ge)}};return Ce}var l=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(Ie,ge,Ce){if(Ie){var Z;try{Z=decodeURIComponent(p(Ce)).replace(l,"").toLowerCase()}catch(se){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ge&&!h.test(Ce)&&(Ce=v(ge,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(se){return null}return Ce}var a={},P=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Ie,ge){a[" "+Ie]||(P.test(Ie)?a[" "+Ie]=Ie+"/":a[" "+Ie]=u(Ie,"/",!0)),Ie=a[" "+Ie];var Ce=Ie.indexOf(":")===-1;return ge.substring(0,2)==="//"?Ce?ge:Ie.replace(n,"$1")+ge:ge.charAt(0)==="/"?Ce?ge:Ie.replace(i,"$1")+ge:Ie+ge}var g={exec:function(){}};function s(Ie){for(var ge=1,Ce,Z;ge<arguments.length;ge++){Ce=arguments[ge];for(Z in Ce)Object.prototype.hasOwnProperty.call(Ce,Z)&&(Ie[Z]=Ce[Z])}return Ie}function b(Ie,ge){var Ce=Ie.replace(/\|/g,function(fe,he,ke){for(var Le=!1,Me=he;--Me>=0&&ke[Me]==="\\";)Le=!Le;return Le?"|":" |"}),Z=Ce.split(/ \|/),se=0;if(Z[0].trim()||Z.shift(),Z[Z.length-1].trim()||Z.pop(),Z.length>ge)Z.splice(ge);else for(;Z.length<ge;)Z.push("");for(;se<Z.length;se++)Z[se]=Z[se].trim().replace(/\\\|/g,"|");return Z}function u(Ie,ge,Ce){var Z=Ie.length;if(Z===0)return"";for(var se=0;se<Z;){var fe=Ie.charAt(Z-se-1);if(fe===ge&&!Ce)se++;else if(fe!==ge&&Ce)se++;else break}return Ie.substr(0,Z-se)}function E(Ie,ge){if(Ie.indexOf(ge[1])===-1)return-1;for(var Ce=Ie.length,Z=0,se=0;se<Ce;se++)if(Ie[se]==="\\")se++;else if(Ie[se]===ge[0])Z++;else if(Ie[se]===ge[1]&&(Z--,Z<0))return se;return-1}function A(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Ie,ge){if(ge<1)return"";for(var Ce="";ge>1;)ge&1&&(Ce+=Ie),ge>>=1,Ie+=Ie;return Ce+Ie}var B={escape:o,unescape:p,edit:f,cleanUrl:y,resolveUrl:v,noopTest:g,merge:s,splitCells:b,rtrim:u,findClosingBracket:E,checkSanitizeDeprecation:A,repeatString:I},O=T.exports.defaults,S=B.rtrim,x=B.splitCells,N=B.escape,V=B.findClosingBracket;function $(Ie,ge,Ce,Z){var se=ge.href,fe=ge.title?N(ge.title):null,he=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){Z.state.inLink=!0;var ke={type:"link",raw:Ce,href:se,title:fe,text:he,tokens:Z.inlineTokens(he,[])};return Z.state.inLink=!1,ke}else return{type:"image",raw:Ce,href:se,title:fe,text:N(he)}}function z(Ie,ge){var Ce=Ie.match(/^(\s+)(?:```)/);if(Ce===null)return ge;var Z=Ce[1];return ge.split(`
`).map(function(se){var fe=se.match(/^\s+/);if(fe===null)return se;var he=fe[0];return he.length>=Z.length?se.slice(Z.length):se}).join(`
`)}var ee=function(){function Ie(Ce){this.options=Ce||O}var ge=Ie.prototype;return ge.space=function(Z){var se=this.rules.block.newline.exec(Z);if(se)return se[0].length>1?{type:"space",raw:se[0]}:{raw:`
`}},ge.code=function(Z){var se=this.rules.block.code.exec(Z);if(se){var fe=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:S(fe,`
`)}}},ge.fences=function(Z){var se=this.rules.block.fences.exec(Z);if(se){var fe=se[0],he=z(fe,se[3]||"");return{type:"code",raw:fe,lang:se[2]?se[2].trim():se[2],text:he}}},ge.heading=function(Z){var se=this.rules.block.heading.exec(Z);if(se){var fe=se[2].trim();if(/#$/.test(fe)){var he=S(fe,"#");(this.options.pedantic||!he||/ $/.test(he))&&(fe=he.trim())}var ke={type:"heading",raw:se[0],depth:se[1].length,text:fe,tokens:[]};return this.lexer.inline(ke.text,ke.tokens),ke}},ge.hr=function(Z){var se=this.rules.block.hr.exec(Z);if(se)return{type:"hr",raw:se[0]}},ge.blockquote=function(Z){var se=this.rules.block.blockquote.exec(Z);if(se){var fe=se[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},ge.list=function(Z){var se=this.rules.block.list.exec(Z);if(se){var fe,he,ke,Le,Me,He,it,Re,le,me,ne=se[1].trim(),W=ne.length>1,be={type:"list",raw:"",ordered:W,start:W?+ne.slice(0,-1):"",loose:!1,items:[]};ne=W?"\\d{1,9}\\"+ne.slice(-1):"\\"+ne,this.options.pedantic&&(ne=W?ne:"[*+-]");for(var De=new RegExp("^( {0,3}"+ne+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");Z&&!(this.rules.block.hr.test(Z)||!(se=De.exec(Z)));){le=se[2].split(`
`),this.options.pedantic?(Le=2,me=le[0].trimLeft()):(Le=se[2].search(/[^ ]/),Le=se[1].length+(Le>4?1:Le),me=le[0].slice(Le-se[1].length)),He=!1,fe=se[0],!le[0]&&/^ *$/.test(le[1])&&(fe=se[1]+le.slice(0,2).join(`
`)+`
`,be.loose=!0,le=[]);var Ge=new RegExp("^ {0,"+Math.min(3,Le-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Me=1;Me<le.length;Me++){if(Re=le[Me],this.options.pedantic&&(Re=Re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ge.test(Re)){fe=se[1]+le.slice(0,Me).join(`
`)+`
`;break}if(!He){Re.trim()||(He=!0),Re.search(/[^ ]/)>=Le?me+=`
`+Re.slice(Le):me+=`
`+Re;continue}if(Re.search(/[^ ]/)>=Le||!Re.trim()){me+=`
`+Re.slice(Le);continue}else{fe=se[1]+le.slice(0,Me).join(`
`)+`
`;break}}be.loose||(it?be.loose=!0:/\n *\n *$/.test(fe)&&(it=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(me),he&&(ke=he[0]!=="[ ] ",me=me.replace(/^\[[ xX]\] +/,""))),be.items.push({type:"list_item",raw:fe,task:!!he,checked:ke,loose:!1,text:me}),be.raw+=fe,Z=Z.slice(fe.length)}be.items[be.items.length-1].raw=fe.trimRight(),be.items[be.items.length-1].text=me.trimRight(),be.raw=be.raw.trimRight();var xe=be.items.length;for(Me=0;Me<xe;Me++)this.lexer.state.top=!1,be.items[Me].tokens=this.lexer.blockTokens(be.items[Me].text,[]),be.items[Me].tokens.some(function(lt){return lt.type==="space"})&&(be.loose=!0,be.items[Me].loose=!0);return be}},ge.html=function(Z){var se=this.rules.block.html.exec(Z);if(se){var fe={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};return this.options.sanitize&&(fe.type="paragraph",fe.text=this.options.sanitizer?this.options.sanitizer(se[0]):N(se[0]),fe.tokens=[],this.lexer.inline(fe.text,fe.tokens)),fe}},ge.def=function(Z){var se=this.rules.block.def.exec(Z);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var fe=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:se[0],href:se[2],title:se[3]}}},ge.table=function(Z){var se=this.rules.block.table.exec(Z);if(se){var fe={type:"table",header:x(se[1]).map(function(it){return{text:it}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]?se[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=se[0];var he=fe.align.length,ke,Le,Me,He;for(ke=0;ke<he;ke++)/^ *-+: *$/.test(fe.align[ke])?fe.align[ke]="right":/^ *:-+: *$/.test(fe.align[ke])?fe.align[ke]="center":/^ *:-+ *$/.test(fe.align[ke])?fe.align[ke]="left":fe.align[ke]=null;for(he=fe.rows.length,ke=0;ke<he;ke++)fe.rows[ke]=x(fe.rows[ke],fe.header.length).map(function(it){return{text:it}});for(he=fe.header.length,Le=0;Le<he;Le++)fe.header[Le].tokens=[],this.lexer.inlineTokens(fe.header[Le].text,fe.header[Le].tokens);for(he=fe.rows.length,Le=0;Le<he;Le++)for(He=fe.rows[Le],Me=0;Me<He.length;Me++)He[Me].tokens=[],this.lexer.inlineTokens(He[Me].text,He[Me].tokens);return fe}}},ge.lheading=function(Z){var se=this.rules.block.lheading.exec(Z);if(se){var fe={type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ge.paragraph=function(Z){var se=this.rules.block.paragraph.exec(Z);if(se){var fe={type:"paragraph",raw:se[0],text:se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ge.text=function(Z){var se=this.rules.block.text.exec(Z);if(se){var fe={type:"text",raw:se[0],text:se[0],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ge.escape=function(Z){var se=this.rules.inline.escape.exec(Z);if(se)return{type:"escape",raw:se[0],text:N(se[1])}},ge.tag=function(Z){var se=this.rules.inline.tag.exec(Z);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):N(se[0]):se[0]}},ge.link=function(Z){var se=this.rules.inline.link.exec(Z);if(se){var fe=se[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var he=S(fe.slice(0,-1),"\\");if((fe.length-he.length)%2==0)return}else{var ke=V(se[2],"()");if(ke>-1){var Le=se[0].indexOf("!")===0?5:4,Me=Le+se[1].length+ke;se[2]=se[2].substring(0,ke),se[0]=se[0].substring(0,Me).trim(),se[3]=""}}var He=se[2],it="";if(this.options.pedantic){var Re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(He);Re&&(He=Re[1],it=Re[3])}else it=se[3]?se[3].slice(1,-1):"";return He=He.trim(),/^</.test(He)&&(this.options.pedantic&&!/>$/.test(fe)?He=He.slice(1):He=He.slice(1,-1)),$(se,{href:He&&He.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},ge.reflink=function(Z,se){var fe;if((fe=this.rules.inline.reflink.exec(Z))||(fe=this.rules.inline.nolink.exec(Z))){var he=(fe[2]||fe[1]).replace(/\s+/g," ");if(he=se[he.toLowerCase()],!he||!he.href){var ke=fe[0].charAt(0);return{type:"text",raw:ke,text:ke}}return $(fe,he,fe[0],this.lexer)}},ge.emStrong=function(Z,se,fe){fe===void 0&&(fe="");var he=this.rules.inline.emStrong.lDelim.exec(Z);if(!!he&&!(he[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=he[1]||he[2]||"";if(!ke||ke&&(fe===""||this.rules.inline.punctuation.exec(fe))){var Le=he[0].length-1,Me,He,it=Le,Re=0,le=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(le.lastIndex=0,se=se.slice(-1*Z.length+Le);(he=le.exec(se))!=null;)if(Me=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Me){if(He=Me.length,he[3]||he[4]){it+=He;continue}else if((he[5]||he[6])&&Le%3&&!((Le+He)%3)){Re+=He;continue}if(it-=He,!(it>0)){if(He=Math.min(He,He+it+Re),Math.min(Le,He)%2){var me=Z.slice(1,Le+he.index+He);return{type:"em",raw:Z.slice(0,Le+he.index+He+1),text:me,tokens:this.lexer.inlineTokens(me,[])}}var ne=Z.slice(2,Le+he.index+He-1);return{type:"strong",raw:Z.slice(0,Le+he.index+He+1),text:ne,tokens:this.lexer.inlineTokens(ne,[])}}}}}},ge.codespan=function(Z){var se=this.rules.inline.code.exec(Z);if(se){var fe=se[2].replace(/\n/g," "),he=/[^ ]/.test(fe),ke=/^ /.test(fe)&&/ $/.test(fe);return he&&ke&&(fe=fe.substring(1,fe.length-1)),fe=N(fe,!0),{type:"codespan",raw:se[0],text:fe}}},ge.br=function(Z){var se=this.rules.inline.br.exec(Z);if(se)return{type:"br",raw:se[0]}},ge.del=function(Z){var se=this.rules.inline.del.exec(Z);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2],[])}},ge.autolink=function(Z,se){var fe=this.rules.inline.autolink.exec(Z);if(fe){var he,ke;return fe[2]==="@"?(he=N(this.options.mangle?se(fe[1]):fe[1]),ke="mailto:"+he):(he=N(fe[1]),ke=he),{type:"link",raw:fe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},ge.url=function(Z,se){var fe;if(fe=this.rules.inline.url.exec(Z)){var he,ke;if(fe[2]==="@")he=N(this.options.mangle?se(fe[0]):fe[0]),ke="mailto:"+he;else{var Le;do Le=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(Le!==fe[0]);he=N(fe[0]),fe[1]==="www."?ke="http://"+he:ke=he}return{type:"link",raw:fe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},ge.inlineText=function(Z,se){var fe=this.rules.inline.text.exec(Z);if(fe){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):N(fe[0]):fe[0]:he=N(this.options.smartypants?se(fe[0]):fe[0]),{type:"text",raw:fe[0],text:he}}},Ie}(),j=B.noopTest,Q=B.edit,ce=B.merge,ve={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:j,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ve._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ve._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ve.def=Q(ve.def).replace("label",ve._label).replace("title",ve._title).getRegex(),ve.bullet=/(?:[*+-]|\d{1,9}[.)])/,ve.listItemStart=Q(/^( *)(bull) */).replace("bull",ve.bullet).getRegex(),ve.list=Q(ve.list).replace(/bull/g,ve.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ve.def.source+")").getRegex(),ve._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ve._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ve.html=Q(ve.html,"i").replace("comment",ve._comment).replace("tag",ve._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ve.paragraph=Q(ve._paragraph).replace("hr",ve.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ve._tag).getRegex(),ve.blockquote=Q(ve.blockquote).replace("paragraph",ve.paragraph).getRegex(),ve.normal=ce({},ve),ve.gfm=ce({},ve.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ve.gfm.table=Q(ve.gfm.table).replace("hr",ve.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ve._tag).getRegex(),ve.pedantic=ce({},ve.normal,{html:Q(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ve._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:j,paragraph:Q(ve.normal._paragraph).replace("hr",ve.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ve.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ue={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:j,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:j,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ue._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ue.punctuation=Q(ue.punctuation).replace(/punctuation/g,ue._punctuation).getRegex(),ue.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ue.escapedEmSt=/\\\*|\\_/g,ue._comment=Q(ve._comment).replace("(?:-->|$)","-->").getRegex(),ue.emStrong.lDelim=Q(ue.emStrong.lDelim).replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimAst=Q(ue.emStrong.rDelimAst,"g").replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimUnd=Q(ue.emStrong.rDelimUnd,"g").replace(/punct/g,ue._punctuation).getRegex(),ue._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ue._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ue._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ue.autolink=Q(ue.autolink).replace("scheme",ue._scheme).replace("email",ue._email).getRegex(),ue._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ue.tag=Q(ue.tag).replace("comment",ue._comment).replace("attribute",ue._attribute).getRegex(),ue._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ue._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ue._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ue.link=Q(ue.link).replace("label",ue._label).replace("href",ue._href).replace("title",ue._title).getRegex(),ue.reflink=Q(ue.reflink).replace("label",ue._label).getRegex(),ue.reflinkSearch=Q(ue.reflinkSearch,"g").replace("reflink",ue.reflink).replace("nolink",ue.nolink).getRegex(),ue.normal=ce({},ue),ue.pedantic=ce({},ue.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:Q(/^!?\[(label)\]\((.*?)\)/).replace("label",ue._label).getRegex(),reflink:Q(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ue._label).getRegex()}),ue.gfm=ce({},ue.normal,{escape:Q(ue.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ue.gfm.url=Q(ue.gfm.url,"i").replace("email",ue.gfm._extended_email).getRegex(),ue.breaks=ce({},ue.gfm,{br:Q(ue.br).replace("{2,}","*").getRegex(),text:Q(ue.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Fe={block:ve,inline:ue},Ke=ee,Oe=T.exports.defaults,We=Fe.block,Xe=Fe.inline,Ye=B.repeatString;function Qe(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Ie){var ge="",Ce,Z,se=Ie.length;for(Ce=0;Ce<se;Ce++)Z=Ie.charCodeAt(Ce),Math.random()>.5&&(Z="x"+Z.toString(16)),ge+="&#"+Z+";";return ge}var K=function(){function Ie(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Oe,this.options.tokenizer=this.options.tokenizer||new Ke,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:We.normal,inline:Xe.normal};this.options.pedantic?(Z.block=We.pedantic,Z.inline=Xe.pedantic):this.options.gfm&&(Z.block=We.gfm,this.options.breaks?Z.inline=Xe.breaks:Z.inline=Xe.gfm),this.tokenizer.rules=Z}Ie.lex=function(Z,se){var fe=new Ie(se);return fe.lex(Z)},Ie.lexInline=function(Z,se){var fe=new Ie(se);return fe.inlineTokens(Z)};var ge=Ie.prototype;return ge.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},ge.blockTokens=function(Z,se){var fe=this;se===void 0&&(se=[]),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var he,ke,Le,Me;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(he=it.call({lexer:fe},Z,se))?(Z=Z.substring(he.raw.length),se.push(he),!0):!1}))){if(he=this.tokenizer.space(Z)){Z=Z.substring(he.raw.length),he.type&&se.push(he);continue}if(he=this.tokenizer.code(Z)){Z=Z.substring(he.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(he);continue}if(he=this.tokenizer.fences(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.heading(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.hr(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.blockquote(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.list(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.html(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.def(Z)){Z=Z.substring(he.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.lheading(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(Le=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,Re=Z.slice(1),le=void 0;fe.options.extensions.startBlock.forEach(function(me){le=me.call({lexer:this},Re),typeof le=="number"&&le>=0&&(it=Math.min(it,le))}),it<Infinity&&it>=0&&(Le=Z.substring(0,it+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Le))){ke=se[se.length-1],Me&&ke.type==="paragraph"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(he),Me=Le.length!==Z.length,Z=Z.substring(he.raw.length);continue}if(he=this.tokenizer.text(Z)){Z=Z.substring(he.raw.length),ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(he);continue}if(Z){var He="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return this.state.top=!0,se},ge.inline=function(Z,se){this.inlineQueue.push({src:Z,tokens:se})},ge.inlineTokens=function(Z,se){var fe=this;se===void 0&&(se=[]);var he,ke,Le,Me=Z,He,it,Re;if(this.tokens.links){var le=Object.keys(this.tokens.links);if(le.length>0)for(;(He=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)le.includes(He[0].slice(He[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,He.index)+"["+Ye("a",He[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(He=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,He.index)+"["+Ye("a",He[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(He=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,He.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(it||(Re=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ne){return(he=ne.call({lexer:fe},Z,se))?(Z=Z.substring(he.raw.length),se.push(he),!0):!1}))){if(he=this.tokenizer.escape(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.tag(Z)){Z=Z.substring(he.raw.length),ke=se[se.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):se.push(he);continue}if(he=this.tokenizer.link(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(he.raw.length),ke=se[se.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):se.push(he);continue}if(he=this.tokenizer.emStrong(Z,Me,Re)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.codespan(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.br(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.del(Z)){Z=Z.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.autolink(Z,H)){Z=Z.substring(he.raw.length),se.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(Z,H))){Z=Z.substring(he.raw.length),se.push(he);continue}if(Le=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ne=Infinity,W=Z.slice(1),be=void 0;fe.options.extensions.startInline.forEach(function(De){be=De.call({lexer:this},W),typeof be=="number"&&be>=0&&(ne=Math.min(ne,be))}),ne<Infinity&&ne>=0&&(Le=Z.substring(0,ne+1))}(),he=this.tokenizer.inlineText(Le,Qe)){Z=Z.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(Re=he.raw.slice(-1)),it=!0,ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):se.push(he);continue}if(Z){var me="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(me);break}else throw new Error(me)}}return se},e(Ie,null,[{key:"rules",get:function(){return{block:We,inline:Xe}}}]),Ie}(),J=T.exports.defaults,oe=B.cleanUrl,G=B.escape,ie=function(){function Ie(Ce){this.options=Ce||J}var ge=Ie.prototype;return ge.code=function(Z,se,fe){var he=(se||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(Z,he);ke!=null&&ke!==Z&&(fe=!0,Z=ke)}return Z=Z.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+G(he,!0)+'">'+(fe?Z:G(Z,!0))+`</code></pre>
`:"<pre><code>"+(fe?Z:G(Z,!0))+`</code></pre>
`},ge.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ge.html=function(Z){return Z},ge.heading=function(Z,se,fe,he){return this.options.headerIds?"<h"+se+' id="'+this.options.headerPrefix+he.slug(fe)+'">'+Z+"</h"+se+`>
`:"<h"+se+">"+Z+"</h"+se+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(Z,se,fe){var he=se?"ol":"ul",ke=se&&fe!==1?' start="'+fe+'"':"";return"<"+he+ke+`>
`+Z+"</"+he+`>
`},ge.listitem=function(Z){return"<li>"+Z+`</li>
`},ge.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(Z){return"<p>"+Z+`</p>
`},ge.table=function(Z,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+se+`</table>
`},ge.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ge.tablecell=function(Z,se){var fe=se.header?"th":"td",he=se.align?"<"+fe+' align="'+se.align+'">':"<"+fe+">";return he+Z+"</"+fe+`>
`},ge.strong=function(Z){return"<strong>"+Z+"</strong>"},ge.em=function(Z){return"<em>"+Z+"</em>"},ge.codespan=function(Z){return"<code>"+Z+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(Z){return"<del>"+Z+"</del>"},ge.link=function(Z,se,fe){if(Z=oe(this.options.sanitize,this.options.baseUrl,Z),Z===null)return fe;var he='<a href="'+G(Z)+'"';return se&&(he+=' title="'+se+'"'),he+=">"+fe+"</a>",he},ge.image=function(Z,se,fe){if(Z=oe(this.options.sanitize,this.options.baseUrl,Z),Z===null)return fe;var he='<img src="'+Z+'" alt="'+fe+'"';return se&&(he+=' title="'+se+'"'),he+=this.options.xhtml?"/>":">",he},ge.text=function(Z){return Z},Ie}(),de=function(){function Ie(){}var ge=Ie.prototype;return ge.strong=function(Z){return Z},ge.em=function(Z){return Z},ge.codespan=function(Z){return Z},ge.del=function(Z){return Z},ge.html=function(Z){return Z},ge.text=function(Z){return Z},ge.link=function(Z,se,fe){return""+fe},ge.image=function(Z,se,fe){return""+fe},ge.br=function(){return""},Ie}(),Te=function(){function Ie(){this.seen={}}var ge=Ie.prototype;return ge.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(Z,se){var fe=Z,he=0;if(this.seen.hasOwnProperty(fe)){he=this.seen[Z];do he++,fe=Z+"-"+he;while(this.seen.hasOwnProperty(fe))}return se||(this.seen[Z]=he,this.seen[fe]=0),fe},ge.slug=function(Z,se){se===void 0&&(se={});var fe=this.serialize(Z);return this.getNextSafeSlug(fe,se.dryrun)},Ie}(),Ne=ie,ze=de,je=Te,et=T.exports.defaults,ot=B.unescape,ye=function(){function Ie(Ce){this.options=Ce||et,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ze,this.slugger=new je}Ie.parse=function(Z,se){var fe=new Ie(se);return fe.parse(Z)},Ie.parseInline=function(Z,se){var fe=new Ie(se);return fe.parseInline(Z)};var ge=Ie.prototype;return ge.parse=function(Z,se){se===void 0&&(se=!0);var fe="",he,ke,Le,Me,He,it,Re,le,me,ne,W,be,De,Ge,xe,lt,_t,bt,ct,gt=Z.length;for(he=0;he<gt;he++){if(ne=Z[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ne.type]&&(ct=this.options.extensions.renderers[ne.type].call({parser:this},ne),ct!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ne.type))){fe+=ct||"";continue}switch(ne.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(ne.tokens),ne.depth,ot(this.parseInline(ne.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(ne.text,ne.lang,ne.escaped);continue}case"table":{for(le="",Re="",Me=ne.header.length,ke=0;ke<Me;ke++)Re+=this.renderer.tablecell(this.parseInline(ne.header[ke].tokens),{header:!0,align:ne.align[ke]});for(le+=this.renderer.tablerow(Re),me="",Me=ne.rows.length,ke=0;ke<Me;ke++){for(it=ne.rows[ke],Re="",He=it.length,Le=0;Le<He;Le++)Re+=this.renderer.tablecell(this.parseInline(it[Le].tokens),{header:!1,align:ne.align[Le]});me+=this.renderer.tablerow(Re)}fe+=this.renderer.table(le,me);continue}case"blockquote":{me=this.parse(ne.tokens),fe+=this.renderer.blockquote(me);continue}case"list":{for(W=ne.ordered,be=ne.start,De=ne.loose,Me=ne.items.length,me="",ke=0;ke<Me;ke++)xe=ne.items[ke],lt=xe.checked,_t=xe.task,Ge="",xe.task&&(bt=this.renderer.checkbox(lt),De?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=bt+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=bt+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:bt}):Ge+=bt),Ge+=this.parse(xe.tokens,De),me+=this.renderer.listitem(Ge,_t,lt);fe+=this.renderer.list(me,W,be);continue}case"html":{fe+=this.renderer.html(ne.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(ne.tokens));continue}case"text":{for(me=ne.tokens?this.parseInline(ne.tokens):ne.text;he+1<gt&&Z[he+1].type==="text";)ne=Z[++he],me+=`
`+(ne.tokens?this.parseInline(ne.tokens):ne.text);fe+=se?this.renderer.paragraph(me):me;continue}default:{var dt='Token with "'+ne.type+'" type was not found.';if(this.options.silent){console.error(dt);return}else throw new Error(dt)}}}return fe},ge.parseInline=function(Z,se){se=se||this.renderer;var fe="",he,ke,Le,Me=Z.length;for(he=0;he<Me;he++){if(ke=Z[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Le=this.options.extensions.renderers[ke.type].call({parser:this},ke),Le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){fe+=Le||"";continue}switch(ke.type){case"escape":{fe+=se.text(ke.text);break}case"html":{fe+=se.html(ke.text);break}case"link":{fe+=se.link(ke.href,ke.title,this.parseInline(ke.tokens,se));break}case"image":{fe+=se.image(ke.href,ke.title,ke.text);break}case"strong":{fe+=se.strong(this.parseInline(ke.tokens,se));break}case"em":{fe+=se.em(this.parseInline(ke.tokens,se));break}case"codespan":{fe+=se.codespan(ke.text);break}case"br":{fe+=se.br();break}case"del":{fe+=se.del(this.parseInline(ke.tokens,se));break}case"text":{fe+=se.text(ke.text);break}default:{var He='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return fe},Ie}(),nt=K,q=ye,X=ee,pe=ie,$e=de,qe=Te,rt=B.merge,ft=B.checkSanitizeDeprecation,ht=B.escape,Ct=T.exports.getDefaults,It=T.exports.changeDefaults,Pt=T.exports.defaults;function Ze(Ie,ge,Ce){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof ge=="function"&&(Ce=ge,ge=null),ge=rt({},Ze.defaults,ge||{}),ft(ge),Ce){var Z=ge.highlight,se;try{se=nt.lex(Ie,ge)}catch(Le){return Ce(Le)}var fe=function(Me){var He;if(!Me)try{ge.walkTokens&&Ze.walkTokens(se,ge.walkTokens),He=q.parse(se,ge)}catch(it){Me=it}return ge.highlight=Z,Me?Ce(Me):Ce(null,He)};if(!Z||Z.length<3||(delete ge.highlight,!se.length))return fe();var he=0;Ze.walkTokens(se,function(Le){Le.type==="code"&&(he++,setTimeout(function(){Z(Le.text,Le.lang,function(Me,He){if(Me)return fe(Me);He!=null&&He!==Le.text&&(Le.text=He,Le.escaped=!0),he--,he===0&&fe()})},0))}),he===0&&fe();return}try{var ke=nt.lex(Ie,ge);return ge.walkTokens&&Ze.walkTokens(ke,ge.walkTokens),q.parse(ke,ge)}catch(Le){if(Le.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+ht(Le.message+"",!0)+"</pre>";throw Le}}Ze.options=Ze.setOptions=function(Ie){return rt(Ze.defaults,Ie),It(Ze.defaults),Ze},Ze.getDefaults=Ct,Ze.defaults=Pt,Ze.use=function(){for(var Ie=this,ge=arguments.length,Ce=new Array(ge),Z=0;Z<ge;Z++)Ce[Z]=arguments[Z];var se=rt.apply(void 0,[{}].concat(Ce)),fe=Ze.defaults.extensions||{renderers:{},childTokens:{}},he;Ce.forEach(function(ke){if(ke.extensions&&(he=!0,ke.extensions.forEach(function(Me){if(!Me.name)throw new Error("extension name required");if(Me.renderer){var He=fe.renderers?fe.renderers[Me.name]:null;He?fe.renderers[Me.name]=function(){for(var it=arguments.length,Re=new Array(it),le=0;le<it;le++)Re[le]=arguments[le];var me=Me.renderer.apply(this,Re);return me===!1&&(me=He.apply(this,Re)),me}:fe.renderers[Me.name]=Me.renderer}if(Me.tokenizer){if(!Me.level||Me.level!=="block"&&Me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Me.level]?fe[Me.level].unshift(Me.tokenizer):fe[Me.level]=[Me.tokenizer],Me.start&&(Me.level==="block"?fe.startBlock?fe.startBlock.push(Me.start):fe.startBlock=[Me.start]:Me.level==="inline"&&(fe.startInline?fe.startInline.push(Me.start):fe.startInline=[Me.start]))}Me.childTokens&&(fe.childTokens[Me.name]=Me.childTokens)})),ke.renderer&&function(){var Me=Ze.defaults.renderer||new pe,He=function(le){var me=Me[le];Me[le]=function(){for(var ne=arguments.length,W=new Array(ne),be=0;be<ne;be++)W[be]=arguments[be];var De=ke.renderer[le].apply(Me,W);return De===!1&&(De=me.apply(Me,W)),De}};for(var it in ke.renderer)He(it);se.renderer=Me}(),ke.tokenizer&&function(){var Me=Ze.defaults.tokenizer||new X,He=function(le){var me=Me[le];Me[le]=function(){for(var ne=arguments.length,W=new Array(ne),be=0;be<ne;be++)W[be]=arguments[be];var De=ke.tokenizer[le].apply(Me,W);return De===!1&&(De=me.apply(Me,W)),De}};for(var it in ke.tokenizer)He(it);se.tokenizer=Me}(),ke.walkTokens){var Le=Ze.defaults.walkTokens;se.walkTokens=function(Me){ke.walkTokens.call(Ie,Me),Le&&Le(Me)}}he&&(se.extensions=fe),Ze.setOptions(se)})},Ze.walkTokens=function(Ie,ge){for(var Ce=function(){var he=se.value;switch(ge(he),he.type){case"table":{for(var ke=w(he.header),Le;!(Le=ke()).done;){var Me=Le.value;Ze.walkTokens(Me.tokens,ge)}for(var He=w(he.rows),it;!(it=He()).done;)for(var Re=it.value,le=w(Re),me;!(me=le()).done;){var ne=me.value;Ze.walkTokens(ne.tokens,ge)}break}case"list":{Ze.walkTokens(he.items,ge);break}default:Ze.defaults.extensions&&Ze.defaults.extensions.childTokens&&Ze.defaults.extensions.childTokens[he.type]?Ze.defaults.extensions.childTokens[he.type].forEach(function(W){Ze.walkTokens(he[W],ge)}):he.tokens&&Ze.walkTokens(he.tokens,ge)}},Z=w(Ie),se;!(se=Z()).done;)Ce()},Ze.parseInline=function(Ie,ge){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");ge=rt({},Ze.defaults,ge||{}),ft(ge);try{var Ce=nt.lexInline(Ie,ge);return ge.walkTokens&&Ze.walkTokens(Ce,ge.walkTokens),q.parseInline(Ce,ge)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+ht(Z.message+"",!0)+"</pre>";throw Z}},Ze.Parser=q,Ze.parser=q.parse,Ze.Renderer=pe,Ze.TextRenderer=$e,Ze.Lexer=nt,Ze.lexer=nt.lex,Ze.Tokenizer=X,Ze.Slugger=qe,Ze.parse=Ze;var pt=Ze;return pt}),define(we[76],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function c(t,R,C){return Math.min(Math.max(t,R),C)}e.clamp=c;function M(t,R){return(R+t%R)%R}e.rot=M;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class T{constructor(){this._n=1,this._val=0}update(R){return this._val=this._val+(R-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function re(w){const T=[];typeof w=="number"&&T.push("code/timeOrigin",w);function t(C){T.push(C,Date.now())}function R(){const C=[];for(let k=0;k<T.length;k+=2)C.push({name:T[k],startTime:T[k+1]});return C}return{mark:t,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const t of performance.getEntriesByType("mark"))T.push({name:t.name,startTime:Math.round(w+t.startTime)});return T}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function c(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=c(M))}(),define(we[54],Ee([0,1,3]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new c.Emitter}add(F){const _=this._icons.get(F.id);_?F.description?_.description=F.description:console.error(`Duplicate registration of codicon ${F.id}`):(this._icons.set(F.id,F),this._onDidRegister.fire(F))}get(F){return this._icons.get(F)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const w=new M;e.iconRegistry=w;function T(k){return k?k.replace(/\$\((.*?)\)/g,(F,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=T;class t{constructor(F,_,r){this.id=F,this.definition=_,this.description=r,w.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=t,t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function R(k,F){const _=["codicon","codicon-"+k];return F&&_.push("codicon-modifier-"+F),_}e.getClassNamesArray=R;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const F=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function _(o){if(o instanceof t)return["codicon","codicon-"+o.id];const d=F.exec(o.id);if(!d)return _(t.error);let[,p,D]=d;const f=["codicon","codicon-"+p];return D&&f.push("codicon-modifier-"+D.substr(1)),f}k.asClassNameArray=_;function r(o){return _(o).join(" ")}k.asClassName=r;function m(o){return"."+_(o).join(".")}k.asCSSSelector=m})(C=e.CSSIcon||(e.CSSIcon={}))}),define(we[103],Ee([0,1,15,7]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function w(l){const h=l;return h?[h.on,h.pause,h.resume,h.destroy].every(y=>typeof y=="function"):!1}e.isReadableStream=w;function T(l){const h=l;return h?w(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=T;function t(l,h){return new R(l,h)}e.newWriteableStream=t;class R{constructor(h,y){this.reducer=h,this.options=y,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(y=>this.pendingWritePromises.push(y))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(y=>y(h))}emitError(h){this.listeners.error.length===0?(0,c.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(y=>y(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,y){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(y),this.resume();break;case"end":this.listeners.end.push(y),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(y),this.state.flowing&&this.flowErrors();break}}removeListener(h,y){if(this.state.destroyed)return;let a;switch(h){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const P=a.indexOf(y);P>=0&&a.splice(P,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const y=[...this.pendingWritePromises];this.pendingWritePromises.length=0,y.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(l,h){const y=[];let a;for(;(a=l.read())!==null;)y.push(a);return h(y)}e.consumeReadable=C;function k(l,h,y){const a=[];let P;for(;(P=l.read())!==null&&a.length<y;)a.push(P);return P===null&&a.length>0?h(a):{read:()=>{if(a.length>0)return a.shift();if(typeof P!="undefined"){const n=P;return P=void 0,n}return l.read()}}}e.peekReadable=k;function F(l,h){return new Promise((y,a)=>{const P=[];_(l,{onData:n=>{h&&P.push(n)},onError:n=>{h?a(n):y(void 0)},onEnd:()=>{y(h?h(P):void 0)}})})}e.consumeStream=F;function _(l,h){l.on("error",y=>h.onError(y)),l.on("end",()=>h.onEnd()),l.on("data",y=>h.onData(y))}e.listenStream=_;function r(l,h){return new Promise((y,a)=>{const P=new M.DisposableStore,n=[],i=s=>{if(n.push(s),n.length>h)return P.dispose(),l.pause(),y({stream:l,buffer:n,ended:!1})},v=s=>a(s),g=()=>y({stream:l,buffer:n,ended:!0});P.add((0,M.toDisposable)(()=>l.removeListener("error",v))),l.on("error",v),P.add((0,M.toDisposable)(()=>l.removeListener("end",g))),l.on("end",g),P.add((0,M.toDisposable)(()=>l.removeListener("data",i))),l.on("data",i)})}e.peekStream=r;function m(l,h){const y=t(h);return y.end(l),y}e.toStream=m;function o(){const l=t(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=o;function d(l){let h=!1;return{read:()=>h?null:(h=!0,l)}}e.toReadable=d;function p(l,h,y){const a=t(y);return _(l,{onData:P=>a.write(h.data(P)),onError:P=>a.error(h.error?h.error(P):P),onEnd:()=>a.end()}),a}e.transform=p;function D(l,h,y){let a=!1;return{read:()=>{const P=h.read();return a?P:(a=!0,P!==null?y([l,P]):l)}}}e.prefixedReadable=D;function f(l,h,y){let a=!1;const P=t(y);return _(h,{onData:n=>a?P.write(n):(a=!0,P.write(y([l,n]))),onError:n=>P.error(n),onEnd:()=>{a||(a=!0,P.write(l)),P.end()}}),P}e.prefixedStream=f}),define(we[22],Ee([0,1,103]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let w,T;class t{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return M?new t(Buffer.allocUnsafe(i)):new t(new Uint8Array(i))}static wrap(i){return M&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new t(i)}static fromString(i,v){return!(v?.dontUseNodeBuffer||!1)&&M?new t(Buffer.from(i)):(w||(w=new TextEncoder),new t(w.encode(i)))}static concat(i,v){if(typeof v=="undefined"){v=0;for(let b=0,u=i.length;b<u;b++)v+=i[b].byteLength}const g=t.alloc(v);let s=0;for(let b=0,u=i.length;b<u;b++){const E=i[b];g.set(E,s),s+=E.byteLength}return g}toString(){return M?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(i,v){return new t(this.buffer.subarray(i,v))}set(i,v){i instanceof t?this.buffer.set(i.buffer,v):this.buffer.set(i,v)}readUInt32BE(i){return k(this.buffer,i)}writeUInt32BE(i,v){F(this.buffer,i,v)}readUInt32LE(i){return _(this.buffer,i)}writeUInt32LE(i,v){r(this.buffer,i,v)}readUInt8(i){return m(this.buffer,i)}writeUInt8(i,v){o(this.buffer,i,v)}}e.VSBuffer=t;function R(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0}e.readUInt16LE=R;function C(n,i,v){n[v+0]=i&255,i=i>>>8,n[v+1]=i&255}e.writeUInt16LE=C;function k(n,i){return n[i]*2**24+n[i+1]*2**16+n[i+2]*2**8+n[i+3]}e.readUInt32BE=k;function F(n,i,v){n[v+3]=i,i=i>>>8,n[v+2]=i,i=i>>>8,n[v+1]=i,i=i>>>8,n[v]=i}e.writeUInt32BE=F;function _(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0|n[i+2]<<16>>>0|n[i+3]<<24>>>0}e.readUInt32LE=_;function r(n,i,v){n[v+0]=i&255,i=i>>>8,n[v+1]=i&255,i=i>>>8,n[v+2]=i&255,i=i>>>8,n[v+3]=i&255}e.writeUInt32LE=r;function m(n,i){return n[i]}e.readUInt8=m;function o(n,i,v){n[v]=i}e.writeUInt8=o;function d(n){return c.consumeReadable(n,i=>t.concat(i))}e.readableToBuffer=d;function p(n){return c.toReadable(n)}e.bufferToReadable=p;function D(n){return c.consumeStream(n,i=>t.concat(i))}e.streamToBuffer=D;async function f(n){return n.ended?t.concat(n.buffer):t.concat([...n.buffer,await D(n.stream)])}e.bufferedStreamToBuffer=f;function l(n){return c.toStream(n,i=>t.concat(i))}e.bufferToStream=l;function h(n){return c.transform(n,{data:i=>typeof i=="string"?t.fromString(i):t.wrap(i)},i=>t.concat(i))}e.streamToBufferReadableStream=h;function y(n){return c.newWriteableStream(i=>t.concat(i),n)}e.newWriteableBufferStream=y;function a(n,i){return c.prefixedReadable(n,i,v=>t.concat(v))}e.prefixedBufferReadable=a;function P(n,i){return c.prefixedStream(n,i,v=>t.concat(v))}e.prefixedBufferStream=P});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[21],Ee([0,1,16,9]),function(re,e,c,M){"use strict";var w,T,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(n,i,v){let g=n.get(i);return g===void 0&&(g=v,n.set(i,g)),g}e.getOrSet=R;function C(n){const i=[];return n.forEach((v,g)=>{i.push(`${g} => ${v}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=C;function k(n){const i=[];return n.forEach(v=>{i.push(v)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=k;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const v=i.charCodeAt(0),g=this._value.charCodeAt(this._pos);return v-g}value(){return this._value[this._pos]}}e.StringIterator=F;class _{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,M.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class r{constructor(i=!0,v=!0){this._splitOnBackslash=i,this._caseSensitive=v}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const v=this._value.charCodeAt(this._to);if(v===47||this._splitOnBackslash&&v===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,M.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=r;var m;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(m||(m={}));class o{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new r(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,M.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(p||(p={}));class D{constructor(i){this._iter=i}static forUris(i=()=>!1){return new D(new o(i))}static forPaths(){return new D(new r)}static forStrings(){return new D(new F)}static forConfigKeys(){return new D(new _)}clear(){this._root=void 0}fill(i,v){if(v){const g=v.slice(0);(0,c.shuffle)(g);for(let s of g)this.set(s,i)}else{const g=i.slice(0);(0,c.shuffle)(g);for(let s of g)this.set(s[0],s[1])}}set(i,v){const g=this._iter.reset(i);let s;this._root||(this._root=new d,this._root.segment=g.value());const b=[];for(s=this._root;;){const E=g.cmp(s.segment);if(E>0)s.left||(s.left=new d,s.left.segment=g.value()),b.push([-1,s]),s=s.left;else if(E<0)s.right||(s.right=new d,s.right.segment=g.value()),b.push([1,s]),s=s.right;else if(g.hasNext())g.next(),s.mid||(s.mid=new d,s.mid.segment=g.value()),b.push([0,s]),s=s.mid;else break}const u=s.value;s.value=v,s.key=i;for(let E=b.length-1;E>=0;E--){const A=b[E][1];A.updateHeight();const I=A.balanceFactor();if(I<-1||I>1){const B=b[E][0],O=b[E+1][0];if(B===1&&O===1)b[E][1]=A.rotateLeft();else if(B===-1&&O===-1)b[E][1]=A.rotateRight();else if(B===1&&O===-1)A.right=b[E+1][1]=b[E+1][1].rotateRight(),b[E][1]=A.rotateLeft();else if(B===-1&&O===1)A.left=b[E+1][1]=b[E+1][1].rotateLeft(),b[E][1]=A.rotateRight();else throw new Error;if(E>0)switch(b[E-1][0]){case-1:b[E-1][1].left=b[E][1];break;case 1:b[E-1][1].right=b[E][1];break;case 0:b[E-1][1].mid=b[E][1];break}else this._root=b[0][1]}}return u}get(i){return this._getNode(i)?.value}_getNode(i){const v=this._iter.reset(i);let g=this._root;for(;g;){const s=v.cmp(g.segment);if(s>0)g=g.left;else if(s<0)g=g.right;else if(v.hasNext())v.next(),g=g.mid;else break}return g}has(i){const v=this._getNode(i);return!(v?.value===void 0&&v?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,v){const g=this._iter.reset(i),s=[];let b=this._root;for(;b;){const u=g.cmp(b.segment);if(u>0)s.push([-1,b]),b=b.left;else if(u<0)s.push([1,b]),b=b.right;else if(g.hasNext())g.next(),s.push([0,b]),b=b.mid;else break}if(!!b){if(v?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const u=this._min(b.right),{key:E,value:A,segment:I}=u;this._delete(u.key,!1),b.key=E,b.value=A,b.segment=I}else{const u=b.left??b.right;if(s.length>0){const[E,A]=s[s.length-1];switch(E){case-1:A.left=u;break;case 0:A.mid=u;break;case 1:A.right=u;break}}else this._root=u}for(let u=s.length-1;u>=0;u--){const E=s[u][1];E.updateHeight();const A=E.balanceFactor();if(A>1?(E.right.balanceFactor()>=0||(E.right=s[u+1][1]=s[u+1][1].rotateRight()),s[u][1]=E.rotateLeft()):A<-1&&(E.left.balanceFactor()<=0||(E.left=s[u+1][1]=s[u+1][1].rotateLeft()),s[u][1]=E.rotateRight()),u>0)switch(s[u-1][0]){case-1:s[u-1][1].left=s[u][1];break;case 1:s[u-1][1].right=s[u][1];break;case 0:s[u-1][1].mid=s[u][1];break}else this._root=s[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const v=this._iter.reset(i);let g=this._root,s;for(;g;){const b=v.cmp(g.segment);if(b>0)g=g.left;else if(b<0)g=g.right;else if(v.hasNext())v.next(),s=g.value||s,g=g.mid;else break}return g&&g.value||s}findSuperstr(i){const v=this._iter.reset(i);let g=this._root;for(;g;){const s=v.cmp(g.segment);if(s>0)g=g.left;else if(s<0)g=g.right;else if(v.hasNext())v.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(i){for(const[v,g]of this)i(g,v)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=v=>{if(!v)return!0;const g=v.balanceFactor();return g<-1||g>1?!1:i(v.left)&&i(v.right)};return i(this._root)}}e.TernarySearchTree=D;class f{constructor(i,v){this.uri=i,this.value=v}}class l{constructor(i,v){this[w]="ResourceMap",i instanceof l?(this.map=new Map(i.map),this.toKey=v??l.defaultToKey):(this.map=new Map,this.toKey=i??l.defaultToKey)}set(i,v){return this.map.set(this.toKey(i),new f(i,v)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,v){typeof v!="undefined"&&(i=i.bind(v));for(let[g,s]of this.map)i(s.value,s.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=l,l.defaultToKey=n=>n.toString();var h;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class y{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,v=0){const g=this._map.get(i);if(!!g)return v!==0&&this.touch(g,v),g.value}set(i,v,g=0){let s=this._map.get(i);if(s)s.value=v,g!==0&&this.touch(s,g);else{switch(s={key:i,value:v,next:void 0,previous:void 0},g){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(i,s),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const v=this._map.get(i);if(!!v)return this._map.delete(i),this.removeItem(v),this._size--,v.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,v){const g=this._state;let s=this._head;for(;s;){if(v?i.bind(v)(s.value,s.key,this):i(s.value,s.key,this),this._state!==g)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const i=this,v=this._state;let g=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==v)throw new Error("LinkedMap got modified during iteration.");if(g){const b={value:g.key,done:!1};return g=g.next,b}else return{value:void 0,done:!0}}};return s}values(){const i=this,v=this._state;let g=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==v)throw new Error("LinkedMap got modified during iteration.");if(g){const b={value:g.value,done:!1};return g=g.next,b}else return{value:void 0,done:!0}}};return s}entries(){const i=this,v=this._state;let g=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==v)throw new Error("LinkedMap got modified during iteration.");if(g){const b={value:[g.key,g.value],done:!1};return g=g.next,b}else return{value:void 0,done:!0}}};return s}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let v=this._head,g=this.size;for(;v&&g>i;)this._map.delete(v.key),v=v.next,g--;this._head=v,this._size=g,v&&(v.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const v=i.next,g=i.previous;if(!v||!g)throw new Error("Invalid list");v.previous=g,g.next=v}i.next=void 0,i.previous=void 0,this._state++}touch(i,v){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(i===this._head)return;const g=i.next,s=i.previous;i===this._tail?(s.next=void 0,this._tail=s):(g.previous=s,s.next=g),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(v===2){if(i===this._tail)return;const g=i.next,s=i.previous;i===this._head?(g.previous=void 0,this._head=g):(g.previous=s,s.next=g),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((v,g)=>{i.push([g,v])}),i}fromJSON(i){this.clear();for(const[v,g]of i)this.set(v,g)}}e.LinkedMap=y;class a extends y{constructor(i,v=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,v),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,v=2){return super.get(i,v)}peek(i){return super.get(i,0)}set(i,v){return super.set(i,v,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class P{constructor(i){t.set(this,void 0),Je(this,t,i,"f")}get size(){return Ae(this,t,"f").size}forEach(i,v){Ae(this,t,"f").forEach(i,v)}get(i){return Ae(this,t,"f").get(i)}has(i){return Ae(this,t,"f").has(i)}entries(){return Ae(this,t,"f").entries()}keys(){return Ae(this,t,"f").keys()}values(){return Ae(this,t,"f").values()}[(t=new WeakMap,Symbol.iterator)](){return Ae(this,t,"f").entries()}}e.ReadonlyMapView=P}),define(we[104],Ee([0,1,21,9]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...G){return function(ie,de){for(let Te=0,Ne=G.length;Te<Ne;Te++){const ze=G[Te](ie,de);if(ze)return ze}return null}}e.or=w,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(G,ie,de){if(!de||de.length<ie.length)return null;let Te;return G?Te=M.startsWithIgnoreCase(de,ie):Te=de.indexOf(ie)===0,Te?ie.length>0?[{start:0,end:ie.length}]:[]:null}function t(G,ie){const de=ie.toLowerCase().indexOf(G.toLowerCase());return de===-1?null:[{start:de,end:de+G.length}]}e.matchesContiguousSubString=t;function R(G,ie){return C(G.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=R;function C(G,ie,de,Te){if(de===G.length)return[];if(Te===ie.length)return null;if(G[de]===ie[Te]){let Ne=null;return(Ne=C(G,ie,de+1,Te+1))?D({start:Te,end:Te+1},Ne):null}return C(G,ie,de,Te+1)}function k(G){return 97<=G&&G<=122}function F(G){return 65<=G&&G<=90}e.isUpper=F;function _(G){return 48<=G&&G<=57}function r(G){return G===32||G===9||G===10||G===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>m.add(G.charCodeAt(0)));function o(G){return r(G)||m.has(G)}function d(G,ie){return G===ie||o(G)&&o(ie)}function p(G){return k(G)||F(G)||_(G)}function D(G,ie){return ie.length===0?ie=[G]:G.end===ie[0].start?ie[0].start=G.start:ie.unshift(G),ie}function f(G,ie){for(let de=ie;de<G.length;de++){const Te=G.charCodeAt(de);if(F(Te)||_(Te)||de>0&&!p(G.charCodeAt(de-1)))return de}return G.length}function l(G,ie,de,Te){if(de===G.length)return[];if(Te===ie.length)return null;if(G[de]!==ie[Te].toLowerCase())return null;{let Ne=null,ze=Te+1;for(Ne=l(G,ie,de+1,Te+1);!Ne&&(ze=f(ie,ze))<ie.length;)Ne=l(G,ie,de+1,ze),ze++;return Ne===null?null:D({start:Te,end:Te+1},Ne)}}function h(G){let ie=0,de=0,Te=0,Ne=0,ze=0;for(let nt=0;nt<G.length;nt++)ze=G.charCodeAt(nt),F(ze)&&ie++,k(ze)&&de++,p(ze)&&Te++,_(ze)&&Ne++;const je=ie/G.length,et=de/G.length,ot=Te/G.length,ye=Ne/G.length;return{upperPercent:je,lowerPercent:et,alphaPercent:ot,numericPercent:ye}}function y(G){const{upperPercent:ie,lowerPercent:de}=G;return de===0&&ie>.6}function a(G){const{upperPercent:ie,lowerPercent:de,alphaPercent:Te,numericPercent:Ne}=G;return de>.2&&ie<.8&&Te>.6&&Ne<.2}function P(G){let ie=0,de=0,Te=0,Ne=0;for(let ze=0;ze<G.length;ze++)Te=G.charCodeAt(ze),F(Te)&&ie++,k(Te)&&de++,r(Te)&&Ne++;return(ie===0||de===0)&&Ne===0?G.length<=30:ie<=5}function n(G,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!P(G)||ie.length>60)return null;const de=h(ie);if(!a(de)){if(!y(de))return null;ie=ie.toLowerCase()}let Te=null,Ne=0;for(G=G.toLowerCase();Ne<ie.length&&(Te=l(G,ie,0,Ne))===null;)Ne=f(ie,Ne+1);return Te}e.matchesCamelCase=n;function i(G,ie,de=!1){if(!ie||ie.length===0)return null;let Te=null,Ne=0;for(G=G.toLowerCase(),ie=ie.toLowerCase();Ne<ie.length&&(Te=v(G,ie,0,Ne,de))===null;)Ne=g(ie,Ne+1);return Te}e.matchesWords=i;function v(G,ie,de,Te,Ne){if(de===G.length)return[];if(Te===ie.length)return null;if(d(G.charCodeAt(de),ie.charCodeAt(Te))){let ze=null,je=Te+1;if(ze=v(G,ie,de+1,Te+1,Ne),!Ne)for(;!ze&&(je=g(ie,je))<ie.length;)ze=v(G,ie,de+1,je,Ne),je++;return ze===null?null:D({start:Te,end:Te+1},ze)}else return null}function g(G,ie){for(let de=ie;de<G.length;de++)if(o(G.charCodeAt(de))||de>0&&o(G.charCodeAt(de-1)))return de;return G.length}const s=w(e.matchesPrefix,n,t),b=w(e.matchesPrefix,n,R),u=new c.LRUCache(1e4);function E(G,ie,de=!1){if(typeof G!="string"||typeof ie!="string")return null;let Te=u.get(G);Te||(Te=new RegExp(M.convertSimple2RegExpPattern(G),"i"),u.set(G,Te));const Ne=Te.exec(ie);return Ne?[{start:Ne.index,end:Ne.index+Ne[0].length}]:de?b(G,ie):s(G,ie)}e.matchesFuzzy=E;function A(G,ie){const de=Xe(G,G.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return de?B(de):null}e.matchesFuzzy2=A;function I(G,ie,de,Te,Ne,ze){const je=Math.min(13,G.length);for(;de<je;de++){const et=Xe(G,ie,de,Te,Ne,ze,!1);if(et)return et}return[0,ze]}e.anyScore=I;function B(G){if(typeof G=="undefined")return[];const ie=[],de=G[1];for(let Te=G.length-1;Te>1;Te--){const Ne=G[Te]+de,ze=ie[ie.length-1];ze&&ze.end===Ne?ze.end=Ne+1:ie.push({start:Ne,end:Ne+1})}return ie}e.createMatches=B;const O=128;function S(){const G=[],ie=[];for(let de=0;de<=O;de++)ie[de]=0;for(let de=0;de<=O;de++)G.push(ie.slice(0));return G}function x(G){const ie=[];for(let de=0;de<=G;de++)ie[de]=0;return ie}const N=x(2*O),V=x(2*O),$=S(),z=S(),ee=S(),j=!1;function Q(G,ie,de,Te,Ne){function ze(et,ot,ye=" "){for(;et.length<ot;)et=ye+et;return et}let je=` |   |${Te.split("").map(et=>ze(et,3)).join("|")}
`;for(let et=0;et<=de;et++)et===0?je+=" |":je+=`${ie[et-1]}|`,je+=G[et].slice(0,Ne+1).map(ot=>ze(ot.toString(),3)).join("|")+`
`;return je}function ce(G,ie,de,Te){G=G.substr(ie),de=de.substr(Te),console.log(Q(z,G,G.length,de,de.length)),console.log(Q(ee,G,G.length,de,de.length)),console.log(Q($,G,G.length,de,de.length))}function ve(G,ie){if(ie<0||ie>=G.length)return!1;const de=G.codePointAt(ie);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(de)}}function ue(G,ie){if(ie<0||ie>=G.length)return!1;switch(G.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function Fe(G,ie,de){return ie[G]!==de[G]}function Ke(G,ie,de,Te,Ne,ze,je=!1){for(;ie<de&&Ne<ze;)G[ie]===Te[Ne]&&(je&&(N[ie]=Ne),ie+=1),Ne+=1;return ie===de}e.isPatternInWord=Ke;var Oe;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(Oe||(Oe={}));var We;(function(G){G.Default=[-100,0];function ie(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}G.isDefault=ie})(We=e.FuzzyScore||(e.FuzzyScore={}));function Xe(G,ie,de,Te,Ne,ze,je){const et=G.length>O?O:G.length,ot=Te.length>O?O:Te.length;if(de>=et||ze>=ot||et-de>ot-ze||!Ke(ie,de,et,Ne,ze,ot,!0))return;Ye(et,ot,de,ze,ie,Ne);let ye=1,nt=1,q=de,X=ze;const pe=[!1];for(ye=1,q=de;q<et;ye++,q++){const ht=N[q],Ct=V[q],It=q+1<et?V[q+1]:ot;for(nt=ht-ze+1,X=ht;X<It;nt++,X++){let Pt=Number.MIN_SAFE_INTEGER,Ze=!1;X<=Ct&&(Pt=Qe(G,ie,q,de,Te,Ne,X,ot,ze,$[ye-1][nt-1]===0,pe));let pt=0;Pt!==Number.MAX_SAFE_INTEGER&&(Ze=!0,pt=Pt+z[ye-1][nt-1]);const Ie=X>ht,ge=Ie?z[ye][nt-1]+($[ye][nt-1]>0?-5:0):0,Ce=X>ht+1&&$[ye][nt-1]>0,Z=Ce?z[ye][nt-2]+($[ye][nt-2]>0?-5:0):0;if(Ce&&(!Ie||Z>=ge)&&(!Ze||Z>=pt))z[ye][nt]=Z,ee[ye][nt]=3,$[ye][nt]=0;else if(Ie&&(!Ze||ge>=pt))z[ye][nt]=ge,ee[ye][nt]=2,$[ye][nt]=0;else if(Ze)z[ye][nt]=pt,ee[ye][nt]=1,$[ye][nt]=$[ye-1][nt-1]+1;else throw new Error("not possible")}}if(j&&ce(G,de,Te,ze),!pe[0]&&!je)return;ye--,nt--;const $e=[z[ye][nt],ze];let qe=0,rt=0;for(;ye>=1;){let ht=nt;do{const Ct=ee[ye][ht];if(Ct===3)ht=ht-2;else if(Ct===2)ht=ht-1;else break}while(ht>=1);qe>1&&ie[de+ye-1]===Ne[ze+nt-1]&&!Fe(ht+ze-1,Te,Ne)&&qe+1>$[ye][ht]&&(ht=nt),ht===nt?qe++:qe=1,rt||(rt=ht),ye--,nt=ht-1,$e.push(nt)}ot===et&&($e[0]+=2);const ft=rt-et;return $e[0]-=ft,$e}e.fuzzyScore=Xe;function Ye(G,ie,de,Te,Ne,ze){let je=G-1,et=ie-1;for(;je>=de&&et>=Te;)Ne[je]===ze[et]&&(V[je]=et,je--),et--}function Qe(G,ie,de,Te,Ne,ze,je,et,ot,ye,nt){if(ie[de]!==ze[je])return Number.MIN_SAFE_INTEGER;let q=1,X=!1;return je===de-Te?q=G[de]===Ne[je]?7:5:Fe(je,Ne,ze)&&(je===0||!Fe(je-1,Ne,ze))?(q=G[de]===Ne[je]?7:5,X=!0):ve(ze,je)&&(je===0||!ve(ze,je-1))?q=5:(ve(ze,je-1)||ue(ze,je-1))&&(q=5,X=!0),q>1&&de===Te&&(nt[0]=!0),X||(X=Fe(je,Ne,ze)||ve(ze,je-1)||ue(ze,je-1)),de===Te?je>ot&&(q-=X?3:5):ye?q+=X?2:0:q+=X?0:1,je+1===et&&(q-=X?3:5),q}function H(G,ie,de,Te,Ne,ze,je){return J(G,ie,de,Te,Ne,ze,!0,je)}e.fuzzyScoreGracefulAggressive=H;function K(G,ie,de,Te,Ne,ze,je){return J(G,ie,de,Te,Ne,ze,!1,je)}e.fuzzyScoreGraceful=K;function J(G,ie,de,Te,Ne,ze,je,et){let ot=Xe(G,ie,de,Te,Ne,ze,et);if(ot&&!je)return ot;if(G.length>=3){const ye=Math.min(7,G.length-1);for(let nt=de+1;nt<ye;nt++){const q=oe(G,nt);if(q){const X=Xe(q,q.toLowerCase(),de,Te,Ne,ze,et);X&&(X[0]-=3,(!ot||X[0]>ot[0])&&(ot=X))}}}return ot}function oe(G,ie){if(ie+1>=G.length)return;const de=G[ie],Te=G[ie+1];if(de!==Te)return G.slice(0,ie)+Te+de+G.slice(ie+2)}}),define(we[105],Ee([0,1,54,104,9]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?\\)`,"g"),t=new RegExp(c.CSSIcon.iconNameCharacter),R=new RegExp(`(\\\\)?${T.source}`,"g");function C(p){return p.replace(R,(D,f)=>f?D:`\\${D}`)}e.escapeIcons=C;const k=new RegExp(`\\\\${T.source}`,"g");function F(p){return p.replace(k,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=F;const _=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function r(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(_,(D,f,l,h)=>l?D:f||h||"")}e.stripIcons=r;function m(p){const D=p.indexOf(e.iconStartMarker);return D===-1?{text:p}:o(p,D)}e.parseLabelWithIcons=m;function o(p,D){const f=[];let l="";function h(s){if(s){l+=s;for(const b of s)f.push(P)}}let y=-1,a="",P=0,n,i,v=D;const g=p.length;for(h(p.substr(0,D));v<g;)n=p[v],i=p[v+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(y=v,h(a),a=e.iconStartMarker,v++):n===")"&&y!==-1?(P+=v-y+1,y=-1,a=""):y!==-1?t.test(n)?a+=n:(h(a),y=-1,a=""):h(n),v++;return h(a),{text:l,iconOffsets:f}}function d(p,D,f=!1){const{text:l,iconOffsets:h}=D;if(!h||h.length===0)return(0,M.matchesFuzzy)(p,l,f);const y=(0,w.ltrim)(l," "),a=l.length-y.length,P=(0,M.matchesFuzzy)(p,y,f);if(P)for(const n of P){const i=h[n.start+a]+a;n.start+=i,n.end+=i}return P}e.matchesFuzzyIconAware=d}),define(we[77],Ee([0,1,15,105]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(w=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(m="",o=!1){if(this.value=m,typeof this.value!="string")throw(0,c.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(m,o=0){return this.value+=k(this.supportThemeIcons?(0,M.escapeIcons)(m):m).replace(/([ \t]+)/g,(d,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,o){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=T;function t(r){return R(r)?!r.value:Array.isArray(r)?r.every(t):!0}e.isEmptyMarkdownString=t;function R(r){return r instanceof T?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function C(r,m){return r===m?!0:!r||!m?!1:r.value===m.value&&r.isTrusted===m.isTrusted&&r.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=C;function k(r){return r.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function F(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=F;function _(r){const m=[],o=r.split("|").map(p=>p.trim());r=o[0];const d=o[1];if(d){const p=/height=(\d+)/.exec(d),D=/width=(\d+)/.exec(d),f=p?p[1]:"",l=D?D[1]:"",h=isFinite(parseInt(l)),y=isFinite(parseInt(f));h&&m.push(`width="${l}"`),y&&m.push(`height="${f}"`)}return{href:r,dimensions:m}}e.parseHrefAndDimensions=_}),define(we[35],Ee([0,1,9]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(M||(M={})),function(w){const T="error",t="warning",R="warn",C="info",k="ignore";function F(r){return r?c.equalsIgnoreCase(T,r)?w.Error:c.equalsIgnoreCase(t,r)||c.equalsIgnoreCase(R,r)?w.Warning:c.equalsIgnoreCase(C,r)?w.Info:w.Ignore:w.Ignore}w.fromValue=F;function _(r){switch(r){case w.Error:return T;case w.Warning:return t;case w.Info:return C;default:return k}}w.toString=_}(M||(M={})),e.default=M}),define(we[42],Ee([0,1,17,24,9,10]),function(re,e,c,M,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function t(n){return n===47||n===92}e.isPathSeparator=t;function R(n){return n.replace(/[\\/]/g,c.posix.sep)}e.toSlashes=R;function C(n){return n.indexOf("/")===-1&&(n=R(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=C;function k(n,i=c.posix.sep){if(!n)return"";const v=n.length,g=n.charCodeAt(0);if(t(g)){if(t(n.charCodeAt(1))&&!t(n.charCodeAt(2))){let b=3;const u=b;for(;b<v&&!t(n.charCodeAt(b));b++);if(u!==b&&!t(n.charCodeAt(b+1))){for(b+=1;b<v;b++)if(t(n.charCodeAt(b)))return n.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(D(g)&&n.charCodeAt(1)===58)return t(n.charCodeAt(2))?n.slice(0,2)+i:n.slice(0,2);let s=n.indexOf("://");if(s!==-1){for(s+=3;s<v;s++)if(t(n.charCodeAt(s)))return n.slice(0,s+1)}return""}e.getRoot=k;function F(n){if(!M.isWindows||!n||n.length<5)return!1;let i=n.charCodeAt(0);if(i!==92||(i=n.charCodeAt(1),i!==92))return!1;let v=2;const g=v;for(;v<n.length&&(i=n.charCodeAt(v),i!==92);v++);return!(g===v||(i=n.charCodeAt(v+1),isNaN(i)||i===92))}e.isUNC=F;const _=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(n,i=M.isWindows){const v=i?_:r;return!(!n||n.length===0||/^\s+$/.test(n)||(v.lastIndex=0,v.test(n))||i&&m.test(n)||n==="."||n===".."||i&&n[n.length-1]==="."||i&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=o;function d(n,i,v){const g=n===i;return!v||g?g:!n||!i?!1:(0,w.equalsIgnoreCase)(n,i)}e.isEqual=d;function p(n,i,v,g=c.sep){if(n===i)return!0;if(!n||!i||i.length>n.length)return!1;if(v){if(!(0,w.startsWithIgnoreCase)(n,i))return!1;if(i.length===n.length)return!0;let b=i.length;return i.charAt(i.length-1)===g&&b--,n.charAt(b)===g}return i.charAt(i.length-1)!==g&&(i+=g),n.indexOf(i)===0}e.isEqualOrParent=p;function D(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=D;function f(n,i){return M.isWindows&&n.endsWith(":")&&(n+=c.sep),(0,c.isAbsolute)(n)||(n=(0,c.join)(i,n)),n=(0,c.normalize)(n),M.isWindows?(n=(0,w.rtrim)(n,c.sep),n.endsWith(":")&&(n+=c.sep)):(n=(0,w.rtrim)(n,c.sep),n||(n=c.sep)),n}e.sanitizeFilePath=f;function l(n){const i=(0,c.normalize)(n);return M.isWindows?n.length>3?!1:h(i)&&(n.length===2||i.charCodeAt(2)===92):i===c.posix.sep}e.isRootOrDriveLetter=l;function h(n,i){return(i!==void 0?i:M.isWindows)?D(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function y(n){return h(n)?n[0]:void 0}e.getDriveLetter=y;function a(n,i,v){return i.length>n.length?-1:n===i?0:(v&&(n=n.toLowerCase(),i=i.toLowerCase()),n.indexOf(i))}e.indexOfPath=a;function P(n){const i=n.split(":");let v,g,s;if(i.forEach(b=>{const u=Number(b);(0,T.isNumber)(u)?g===void 0?g=u:s===void 0&&(s=u):v=v?[v,b].join(":"):b}),!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:g!==void 0?g:void 0,column:s!==void 0?s:g!==void 0?1:void 0}}e.parseLineAndColumnAware=P}),define(we[25],Ee([0,1,10]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const p=Array.isArray(d)?[]:{};return Object.keys(d).forEach(D=>{d[D]&&typeof d[D]=="object"?p[D]=M(d[D]):p[D]=d[D]}),p}e.deepClone=M;function w(d){if(!d||typeof d!="object")return d;const p=[d];for(;p.length>0;){const D=p.shift();Object.freeze(D);for(const f in D)if(T.call(D,f)){const l=D[f];typeof l=="object"&&!Object.isFrozen(l)&&p.push(l)}}return d}e.deepFreeze=w;const T=Object.prototype.hasOwnProperty;function t(d,p){return R(d,p,new Set)}e.cloneAndChange=t;function R(d,p,D){if((0,c.isUndefinedOrNull)(d))return d;const f=p(d);if(typeof f!="undefined")return f;if((0,c.isArray)(d)){const l=[];for(const h of d)l.push(R(h,p,D));return l}if((0,c.isObject)(d)){if(D.has(d))throw new Error("Cannot clone recursive data-structure");D.add(d);const l={};for(let h in d)T.call(d,h)&&(l[h]=R(d[h],p,D));return D.delete(d),l}return d}function C(d,p,D=!0){return(0,c.isObject)(d)?((0,c.isObject)(p)&&Object.keys(p).forEach(f=>{f in d?D&&((0,c.isObject)(d[f])&&(0,c.isObject)(p[f])?C(d[f],p[f],D):d[f]=p[f]):d[f]=p[f]}),d):p}e.mixin=C;function k(d,p){if(d===p)return!0;if(d==null||p===null||p===void 0||typeof d!=typeof p||typeof d!="object"||Array.isArray(d)!==Array.isArray(p))return!1;let D,f;if(Array.isArray(d)){if(d.length!==p.length)return!1;for(D=0;D<d.length;D++)if(!k(d[D],p[D]))return!1}else{const l=[];for(f in d)l.push(f);l.sort();const h=[];for(f in p)h.push(f);if(h.sort(),!k(l,h))return!1;for(D=0;D<l.length;D++)if(!k(d[l[D]],p[l[D]]))return!1}return!0}e.equals=k;function F(d){const p=new Set;return JSON.stringify(d,(D,f)=>{if((0,c.isObject)(f)||Array.isArray(f)){if(p.has(f))return"[Circular]";p.add(f)}return f})}e.safeStringify=F;function _(d,p,D){const f=p(d);return typeof f=="undefined"?D:f}e.getOrDefault=_;function r(d,p){const D=Object.create(null);return!d||!p||Object.keys(p).forEach(l=>{const h=d[l],y=p[l];k(h,y)||(D[l]=y)}),D}e.distinct=r;function m(d,p){const D=p.toLowerCase(),f=Object.keys(d).find(l=>l.toLowerCase()===D);return f?d[f]:d[p]}e.getCaseInsensitive=m;function o(d,p){const D=Object.create(null);for(const[f,l]of Object.entries(d))p(f,l)&&(D[f]=l);return D}e.filter=o}),define(we[55],Ee([0,1,22,9,2]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(F){return JSON.stringify(F,C)}e.stringify=T;function t(F){let _=JSON.parse(F);return _=k(_),_}e.parse=t;var R;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function C(F,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,M.regExpFlags)(_)}:_}function k(F,_=0){if(!F||_>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return w.URI.revive(F);case 2:return new RegExp(F.source,F.flags)}if(F instanceof c.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let r=0;r<F.length;++r)F[r]=k(F[r],_+1);else for(const r in F)Object.hasOwnProperty.call(F,r)&&(F[r]=k(F[r],_+1))}return F}e.revive=k}),define(we[11],Ee([0,1,24,2]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var w;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(w=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,k,F){this._hosts[C]=k,this._ports[C]=F}setConnectionToken(C,k){this._connectionTokens[C]=k}rewrite(C){if(this._delegate)return this._delegate(C);const k=C.authority;let F=this._hosts[k];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const _=this._ports[k],r=this._connectionTokens[k];let m=`path=${encodeURIComponent(C.path)}`;return typeof r=="string"&&(m+=`&tkn=${encodeURIComponent(r)}`),M.URI.from({scheme:c.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${F}:${_}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new T;class t{asBrowserUri(C,k){const F=this.toUri(C,k);return F.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===w.file&&(c.isNative||typeof c.globals.importScripts=="function"&&c.globals.origin===`${w.vscodeFileResource}://${t.FALLBACK_AUTHORITY}`)?F.with({scheme:w.vscodeFileResource,authority:F.authority||t.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(C,k){const F=this.toUri(C,k);return F.scheme===w.vscodeFileResource?F.with({scheme:w.file,authority:F.authority!==t.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(C,k){return M.URI.isUri(C)?C:M.URI.parse(k.toUrl(C))}}t.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new t}),define(we[23],Ee([0,1,42,11,17,24,9,2]),function(re,e,c,M,w,T,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(m){return(0,R.uriToFsPath)(m,!0)}e.originalFSPath=C;class k{constructor(o){this._ignorePathCasing=o}compare(o,d,p=!1){return o===d?0:(0,t.compare)(this.getComparisonKey(o,p),this.getComparisonKey(d,p))}isEqual(o,d,p=!1){return o===d?!0:!o||!d?!1:this.getComparisonKey(o,p)===this.getComparisonKey(d,p)}getComparisonKey(o,d=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,d,p=!1){if(o.scheme===d.scheme){if(o.scheme===M.Schemas.file)return c.isEqualOrParent(C(o),C(d),this._ignorePathCasing(o))&&o.query===d.query&&(p||o.fragment===d.fragment);if((0,e.isEqualAuthority)(o.authority,d.authority))return c.isEqualOrParent(o.path,d.path,this._ignorePathCasing(o),"/")&&o.query===d.query&&(p||o.fragment===d.fragment)}return!1}joinPath(o,...d){return R.URI.joinPath(o,...d)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return w.posix.basename(o.path)}extname(o){return w.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let d;return o.scheme===M.Schemas.file?d=R.URI.file(w.dirname(C(o))).path:(d=w.posix.dirname(o.path),o.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),d="/")),o.with({path:d})}normalizePath(o){if(!o.path.length)return o;let d;return o.scheme===M.Schemas.file?d=R.URI.file(w.normalize(C(o))).path:d=w.posix.normalize(o.path),o.with({path:d})}relativePath(o,d){if(o.scheme!==d.scheme||!(0,e.isEqualAuthority)(o.authority,d.authority))return;if(o.scheme===M.Schemas.file){const f=w.relative(C(o),C(d));return T.isWindows?c.toSlashes(f):f}let p=o.path||"/",D=d.path||"/";if(this._ignorePathCasing(o)){let f=0;for(const l=Math.min(p.length,D.length);f<l&&!(p.charCodeAt(f)!==D.charCodeAt(f)&&p.charAt(f).toLowerCase()!==D.charAt(f).toLowerCase());f++);p=D.substr(0,f)+p.substr(f)}return w.posix.relative(p,D)}resolvePath(o,d){if(o.scheme===M.Schemas.file){const p=R.URI.file(w.resolve(C(o),d));return o.with({authority:p.authority,path:p.path})}return d=c.toPosixPath(d),o.with({path:w.posix.resolve(o.path,d)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,d){return o===d||o!==void 0&&d!==void 0&&(0,t.equalsIgnoreCase)(o,d)}hasTrailingPathSeparator(o,d=w.sep){if(o.scheme===M.Schemas.file){const p=C(o);return p.length>c.getRoot(p).length&&p[p.length-1]===d}else{const p=o.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,d=w.sep){return(0,e.hasTrailingPathSeparator)(o,d)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,d=w.sep){let p=!1;if(o.scheme===M.Schemas.file){const D=C(o);p=D!==void 0&&D.length===c.getRoot(D).length&&D[D.length-1]===d}else{d="/";const D=o.path;p=D.length===1&&D.charCodeAt(D.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(o,d)?o.with({path:o.path+"/"}):o}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(m=>m.scheme===M.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new k(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(m,o){const d=[];for(let p=0;p<m.length;p++){const D=o(m[p]);m.some((f,l)=>l===p?!1:(0,e.isEqualOrParent)(D,o(f)))||d.push(m[p])}return d}e.distinctParents=F;var _;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function o(d){const p=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(l=>{const[h,y]=l.split(":");h&&y&&p.set(h,y)});const f=d.path.substring(0,d.path.indexOf(";"));return f&&p.set(m.META_DATA_MIME,f),p}m.parseMetaData=o})(_=e.DataUri||(e.DataUri={}));function r(m,o,d){if(o){let p=m.path;return p&&p[0]!==w.posix.sep&&(p=w.posix.sep+p),m.with({scheme:d,authority:o,path:p})}return m.with({scheme:d})}e.toLocalResource=r}),define(we[14],Ee([0,1,20,15,3,7,23]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function R($){return!!$&&typeof $.then=="function"}e.isThenable=R;function C($){const z=new c.CancellationTokenSource,ee=$(z.token),j=new Promise((Q,ce)=>{const ve=z.token.onCancellationRequested(()=>{ve.dispose(),z.dispose(),ce((0,M.canceled)())});Promise.resolve(ee).then(ue=>{ve.dispose(),z.dispose(),Q(ue)},ue=>{ve.dispose(),z.dispose(),ce(ue)})});return new class{cancel(){z.cancel()}then(Q,ce){return j.then(Q,ce)}catch(Q){return this.then(void 0,Q)}finally(Q){return j.finally(Q)}}}e.createCancelablePromise=C;function k($,z,ee){return Promise.race([$,new Promise(j=>z.onCancellationRequested(()=>j(ee)))])}e.raceCancellation=k;async function F($){let z=-1;const ee=$.map((Q,ce)=>Q.then(ve=>(z=ce,ve))),j=await Promise.race(ee);return $.forEach((Q,ce)=>{ce!==z&&Q.cancel()}),j}e.raceCancellablePromises=F;function _($,z,ee){let j;const Q=setTimeout(()=>{j?.(void 0),ee?.()},z);return Promise.race([$.finally(()=>clearTimeout(Q)),new Promise(ce=>j=ce)])}e.raceTimeout=_;function r($){return new Promise((z,ee)=>{const j=$();R(j)?j.then(z,ee):z(j)})}e.asPromise=r;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const ee=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(ee,ee).then(j)})}return new Promise((ee,j)=>{this.queuedPromise.then(ee,j)})}return this.activePromise=z(),new Promise((ee,j)=>{this.activePromise.then(Q=>{this.activePromise=null,ee(Q)},Q=>{this.activePromise=null,j(Q)})})}}e.Throttler=m;class o{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=o;class d{constructor(){this.promiseMap=new Map}queue(z,ee){const Q=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(ee).finally(()=>{this.promiseMap.get(z)===Q&&this.promiseMap.delete(z)});return this.promiseMap.set(z,Q),Q}}e.SequencerByKey=d;class p{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,ee=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Q)=>{this.doResolve=j,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ee),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class D{constructor(z){this.delayer=new p(z),this.throttler=new m}trigger(z,ee){return this.delayer.trigger(()=>this.throttler.queue(z),ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class f{constructor(){this._isOpen=!1,this._promise=new Promise((z,ee)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class l extends f{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function h($,z){return z?new Promise((ee,j)=>{const Q=setTimeout(()=>{ce.dispose(),ee()},$),ce=z.onCancellationRequested(()=>{clearTimeout(Q),ce.dispose(),j((0,M.canceled)())})}):C(ee=>h($,ee))}e.timeout=h;function y($,z=0){const ee=setTimeout($,z);return(0,T.toDisposable)(()=>clearTimeout(ee))}e.disposableTimeout=y;function a($){const z=[];let ee=0;const j=$.length;function Q(){return ee<j?$[ee++]():null}function ce(ve){ve!=null&&z.push(ve);const ue=Q();return ue?ue.then(ce):Promise.resolve(z)}return Promise.resolve(null).then(ce)}e.sequence=a;function P($,z=j=>!!j,ee=null){let j=0;const Q=$.length,ce=()=>{if(j>=Q)return Promise.resolve(ee);const ve=$[j++];return Promise.resolve(ve()).then(Fe=>z(Fe)?Promise.resolve(Fe):ce())};return ce()}e.first=P;function n($,z=j=>!!j,ee=null){if($.length===0)return Promise.resolve(ee);let j=$.length;const Q=()=>{j=-1;for(const ce of $)ce.cancel?.()};return new Promise((ce,ve)=>{for(const ue of $)ue.then(Fe=>{--j>=0&&z(Fe)?(Q(),ce(Fe)):j===0&&ce(ee)}).catch(Fe=>{--j>=0&&(Q(),ve(Fe))})})}e.firstParallel=n;class i{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((ee,j)=>{this.outstandingPromises.push({factory:z,c:ee,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const ee=z.factory();ee.then(z.c,z.e),ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class v extends i{constructor(){super(1)}}e.Queue=v;class g{constructor(){this.queues=new Map}queueFor(z,ee=t.extUri){const j=ee.getComparisonKey(z);let Q=this.queues.get(j);return Q||(Q=new v,w.Event.once(Q.onFinished)(()=>{Q?.dispose(),this.queues.delete(j)}),this.queues.set(j,Q)),Q}dispose(){this.queues.forEach(z=>z.dispose()),this.queues.clear()}}e.ResourceQueue=g;class s{constructor(z,ee){this._token=-1,typeof z=="function"&&typeof ee=="number"&&this.setIfNotSet(z,ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},ee)}setIfNotSet(z,ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},ee))}}e.TimeoutTimer=s;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,ee){this.cancel(),this._token=setInterval(()=>{z()},ee)}}e.IntervalTimer=b;class u{constructor(z,ee){this.timeoutToken=-1,this.runner=z,this.timeout=ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=u;class E{constructor(z,ee){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class A extends u{constructor(z,ee){super(z,ee);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class I extends T.Disposable{constructor(z,ee,j,Q){super();this.maxWorkChunkSize=z,this.maxPendingWork=ee,this.throttleDelay=j,this.handler=Q,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new u(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=I,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=$=>{const z=setTimeout(()=>{const j=Date.now()+15;$(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0,clearTimeout(z))}}}:e.runWhenIdle=($,z)=>{const ee=requestIdleCallback($,typeof z=="number"?{timeout:z}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(ee))}}}}();class B{constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(ee){this._error=ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function O($,z,ee){let j;for(let Q=0;Q<ee;Q++)try{return await $()}catch(ce){j=ce,await h(z)}throw j}e.retry=O;class S{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,ee,j){return this._pending={taskId:z,cancel:()=>j?.(),promise:ee},ee.then(()=>this.donePending(z),()=>this.donePending(z)),ee}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let ee,j;const Q=new Promise((ce,ve)=>{ee=ce,j=ve});this._next={run:z,promise:Q,promiseResolve:ee,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=S;class x{constructor(z){this.interval=z,this.lastIncrementTime=0,this.value=0}increment(){const z=Date.now();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,ee)=>{this.completeCallback=z,this.errorCallback=ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(ee=>{this.completeCallback(z),this.resolved=!0,ee()})}error(z){return new Promise(ee=>{this.errorCallback(z),this.rejected=!0,ee()})}cancel(){new Promise(z=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=N;var V;(function($){async function z(j){let Q;const ce=await Promise.all(j.map(ve=>ve.then(ue=>ue,ue=>{Q||(Q=ue)})));if(typeof Q!="undefined")throw Q;return ce}$.settled=z;function ee(j){return new Promise(async(Q,ce)=>{try{await j(Q,ce)}catch(ve){ce(ve)}})}$.withAsyncBody=ee})(V=e.Promises||(e.Promises={}))}),define(we[106],Ee([0,1,14,17]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new c.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),T=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),t=new c.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(u,E,A=!1){const I=u||"",B=E||"",O=w.value.collator.compare(I,B);return w.value.collatorIsNumeric&&O===0&&I!==B?I<B?-1:1:O}e.compareFileNames=R;function C(u,E){const A=T.value.collator;return u=u||"",E=E||"",y(A,u,E)}e.compareFileNamesDefault=C;function k(u,E){const A=T.value.collator;return u=u||"",E=E||"",i(u,E)||y(A,u,E)}e.compareFileNamesUpper=k;function F(u,E){const A=T.value.collator;return u=u||"",E=E||"",n(u,E)||y(A,u,E)}e.compareFileNamesLower=F;function _(u,E){return u=u||"",E=E||"",u===E?0:u<E?-1:1}e.compareFileNamesUnicode=_;function r(u,E,A=!1){A||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase());const[I,B]=l(u),[O,S]=l(E);return I!==O?I<O?-1:1:B===S?0:B<S?-1:1}e.noIntlCompareFileNames=r;function m(u,E){const[A,I]=l(u),[B,O]=l(E);let S=w.value.collator.compare(I,O);if(S===0){if(w.value.collatorIsNumeric&&I!==O)return I<O?-1:1;if(S=w.value.collator.compare(A,B),w.value.collatorIsNumeric&&S===0&&A!==B)return A<B?-1:1}return S}e.compareFileExtensions=m;function o(u,E){u=u||"",E=E||"";const A=h(u),I=h(E),B=T.value.collator,O=t.value.collator;return y(O,A,I)||y(B,u,E)}e.compareFileExtensionsDefault=o;function d(u,E){u=u||"",E=E||"";const A=h(u),I=h(E),B=T.value.collator,O=t.value.collator;return y(O,A,I)||i(u,E)||y(B,u,E)}e.compareFileExtensionsUpper=d;function p(u,E){u=u||"",E=E||"";const A=h(u),I=h(E),B=T.value.collator,O=t.value.collator;return y(O,A,I)||n(u,E)||y(B,u,E)}e.compareFileExtensionsLower=p;function D(u,E){u=u||"",E=E||"";const A=h(u).toLowerCase(),I=h(E).toLowerCase();return A!==I?A<I?-1:1:u!==E?u<E?-1:1:0}e.compareFileExtensionsUnicode=D;const f=/^(.*?)(\.([^.]*))?$/;function l(u,E=!1){const A=u?f.exec(u):[];let I=[A&&A[1]||"",A&&A[3]||""];return E&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function h(u){const E=u?f.exec(u):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function y(u,E,A){let I=u.compare(E,A);return I!==0?I:E.length!==A.length?E.length<A.length?-1:1:0}function a(u){const E=u.charAt(0);return E.toLocaleUpperCase()!==E}function P(u){const E=u.charAt(0);return E.toLocaleLowerCase()!==E}function n(u,E){return a(u)&&P(E)?-1:P(u)&&a(E)?1:0}function i(u,E){return P(u)&&a(E)?-1:a(u)&&P(E)?1:0}function v(u,E,A=!1){return A||(u=u&&u.toLowerCase(),E=E&&E.toLowerCase()),u===E?0:u<E?-1:1}function g(u,E,A=!1){const I=u.split(M.sep),B=E.split(M.sep),O=I.length-1,S=B.length-1;let x,N;for(let V=0;;V++){if(x=O===V,N=S===V,x&&N)return R(I[V],B[V],A);if(x)return-1;if(N)return 1;const $=v(I[V],B[V],A);if($!==0)return $}}e.comparePaths=g;function s(u,E,A){const I=u.toLowerCase(),B=E.toLowerCase(),O=b(u,E,A);if(O)return O;const S=I.endsWith(A),x=B.endsWith(A);if(S!==x)return S?-1:1;const N=R(I,B);return N!==0?N:I.localeCompare(B)}e.compareAnything=s;function b(u,E,A){const I=u.toLowerCase(),B=E.toLowerCase(),O=I.startsWith(A),S=B.startsWith(A);if(O!==S)return O?-1:1;if(O&&S){if(I.length<B.length)return-1;if(I.length>B.length)return 1}return 0}e.compareByPrefix=b}),define(we[29],Ee([0,1,14,42,21,17,9]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const C="**",k="/",F="[/\\\\]",_="[^/\\\\]",r=/\//g;function m(j){switch(j){case 0:return"";case 1:return`${_}*?`;default:return`(?:${F}|${_}+${F}|${F}${_}+)*?`}}function o(j,Q){if(!j)return[];const ce=[];let ve=!1,ue=!1,Fe="";for(const Ke of j){switch(Ke){case Q:if(!ve&&!ue){ce.push(Fe),Fe="";continue}break;case"{":ve=!0;break;case"}":ve=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Fe+=Ke}return Fe&&ce.push(Fe),ce}e.splitGlobAware=o;function d(j){if(!j)return"";let Q="";const ce=o(j,k);if(ce.every(ve=>ve===C))Q=".*";else{let ve=!1;ce.forEach((ue,Fe)=>{if(ue===C){ve||(Q+=m(2),ve=!0);return}let Ke=!1,Oe="",We=!1,Xe="";for(const Ye of ue){if(Ye!=="}"&&Ke){Oe+=Ye;continue}if(We&&(Ye!=="]"||!Xe)){let Qe;Ye==="-"?Qe=Ye:(Ye==="^"||Ye==="!")&&!Xe?Qe="^":Ye===k?Qe="":Qe=t.escapeRegExpCharacters(Ye),Xe+=Qe;continue}switch(Ye){case"{":Ke=!0;continue;case"[":We=!0;continue;case"}":Q+=`(?:${o(Oe,",").map(K=>d(K)).join("|")})`,Ke=!1,Oe="";break;case"]":Q+="["+Xe+"]",We=!1,Xe="";break;case"?":Q+=_;continue;case"*":Q+=m(1);continue;default:Q+=t.escapeRegExpCharacters(Ye)}}Fe<ce.length-1&&(ce[Fe+1]!==C||Fe+2<ce.length)&&(Q+=F),ve=!1})}return Q}const p=/^\*\*\/\*\.[\w\.-]+$/,D=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new w.LRUCache(1e4),P=function(){return!1},n=function(){return null};function i(j,Q){if(!j)return n;let ce;typeof j!="string"?ce=j.pattern:ce=j,ce=ce.trim();const ve=`${ce}_${!!Q.trimForExclusions}`;let ue=a.get(ve);if(ue)return v(ue,j);let Fe;if(p.test(ce)){const Ke=ce.substr(4);ue=function(Oe,We){return typeof Oe=="string"&&Oe.endsWith(Ke)?ce:null}}else(Fe=D.exec(g(ce,Q)))?ue=s(Fe[1],ce):(Q.trimForExclusions?l:f).test(ce)?ue=b(ce,Q):(Fe=h.exec(g(ce,Q)))?ue=u(Fe[1].substr(1),ce,!0):(Fe=y.exec(g(ce,Q)))?ue=u(Fe[1],ce,!1):ue=E(ce);return a.set(ve,ue),v(ue,j)}function v(j,Q){return typeof Q=="string"?j:function(ce,ve){return M.isEqualOrParent(ce,Q.base)?j(T.relative(Q.base,ce),ve):null}}function g(j,Q){return Q.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function s(j,Q){const ce=`/${j}`,ve=`\\${j}`,ue=function(Ke,Oe){return typeof Ke!="string"?null:Oe?Oe===j?Q:null:Ke===j||Ke.endsWith(ce)||Ke.endsWith(ve)?Q:null},Fe=[j];return ue.basenames=Fe,ue.patterns=[Q],ue.allBasenames=Fe,ue}function b(j,Q){const ce=ee(j.slice(1,-1).split(",").map(Oe=>i(Oe,Q)).filter(Oe=>Oe!==n),j),ve=ce.length;if(!ve)return n;if(ve===1)return ce[0];const ue=function(Oe,We){for(let Xe=0,Ye=ce.length;Xe<Ye;Xe++)if(ce[Xe](Oe,We))return j;return null},Fe=ce.find(Oe=>!!Oe.allBasenames);Fe&&(ue.allBasenames=Fe.allBasenames);const Ke=ce.reduce((Oe,We)=>We.allPaths?Oe.concat(We.allPaths):Oe,[]);return Ke.length&&(ue.allPaths=Ke),ue}function u(j,Q,ce){const ve=T.sep===T.posix.sep,ue=ve?j:j.replace(r,T.sep),Fe=T.sep+ue,Ke=T.posix.sep+j,Oe=ce?function(We,Xe){return typeof We=="string"&&(We===ue||We.endsWith(Fe)||!ve&&(We===j||We.endsWith(Ke)))?Q:null}:function(We,Xe){return typeof We=="string"&&(We===ue||!ve&&We===j)?Q:null};return Oe.allPaths=[(ce?"*/":"./")+j],Oe}function E(j){try{const Q=new RegExp(`^${d(j)}$`);return function(ce){return Q.lastIndex=0,typeof ce=="string"&&Q.test(ce)?j:null}}catch(Q){return n}}function A(j,Q,ce){return!j||typeof Q!="string"?!1:I(j)(Q,void 0,ce)}e.match=A;function I(j,Q={}){if(!j)return P;if(typeof j=="string"||x(j)){const ce=i(j,Q);if(ce===n)return P;const ve=function(ue,Fe){return!!ce(ue,Fe)};return ce.allBasenames&&(ve.allBasenames=ce.allBasenames),ce.allPaths&&(ve.allPaths=ce.allPaths),ve}return $(j,Q)}e.parse=I;function B(j){if(!j)return;let Q;return ce=>(Q||(Q=(j()||Promise.resolve([])).then(ve=>ve?S(ve):{})),Q.then(ve=>!!ve[ce]))}e.hasSiblingPromiseFn=B;function O(j){if(!j)return;let Q;return ce=>{if(!Q){const ve=j();Q=ve?S(ve):{}}return!!Q[ce]}}e.hasSiblingFn=O;function S(j){const Q={};for(const ce of j)Q[ce]=!0;return Q}function x(j){const Q=j;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=x;function N(j){return j.allBasenames||[]}e.getBasenameTerms=N;function V(j){return j.allPaths||[]}e.getPathTerms=V;function $(j,Q){const ce=ee(Object.getOwnPropertyNames(j).map(Oe=>z(Oe,j[Oe],Q)).filter(Oe=>Oe!==n)),ve=ce.length;if(!ve)return n;if(!ce.some(Oe=>!!Oe.requiresSiblings)){if(ve===1)return ce[0];const Oe=function(Ye,Qe){for(let H=0,K=ce.length;H<K;H++){const J=ce[H](Ye,Qe);if(J)return J}return null},We=ce.find(Ye=>!!Ye.allBasenames);We&&(Oe.allBasenames=We.allBasenames);const Xe=ce.reduce((Ye,Qe)=>Qe.allPaths?Ye.concat(Qe.allPaths):Ye,[]);return Xe.length&&(Oe.allPaths=Xe),Oe}const ue=function(Oe,We,Xe){let Ye;for(let Qe=0,H=ce.length;Qe<H;Qe++){const K=ce[Qe];K.requiresSiblings&&Xe&&(We||(We=T.basename(Oe)),Ye||(Ye=We.substr(0,We.length-T.extname(Oe).length)));const J=K(Oe,We,Ye,Xe);if(J)return J}return null},Fe=ce.find(Oe=>!!Oe.allBasenames);Fe&&(ue.allBasenames=Fe.allBasenames);const Ke=ce.reduce((Oe,We)=>We.allPaths?Oe.concat(We.allPaths):Oe,[]);return Ke.length&&(ue.allPaths=Ke),ue}function z(j,Q,ce){if(Q===!1)return n;const ve=i(j,ce);if(ve===n)return n;if(typeof Q=="boolean")return ve;if(Q){const ue=Q.when;if(typeof ue=="string"){const Fe=(Ke,Oe,We,Xe)=>{if(!Xe||!ve(Ke,Oe))return null;const Ye=ue.replace("$(basename)",We),Qe=Xe(Ye);return(0,c.isThenable)(Qe)?Qe.then(H=>H?j:null):Qe?j:null};return Fe.requiresSiblings=!0,Fe}}return ve}function ee(j,Q){const ce=j.filter(Oe=>!!Oe.basenames);if(ce.length<2)return j;const ve=ce.reduce((Oe,We)=>{const Xe=We.basenames;return Xe?Oe.concat(Xe):Oe},[]);let ue;if(Q){ue=[];for(let Oe=0,We=ve.length;Oe<We;Oe++)ue.push(Q)}else ue=ce.reduce((Oe,We)=>{const Xe=We.patterns;return Xe?Oe.concat(Xe):Oe},[]);const Fe=function(Oe,We){if(typeof Oe!="string")return null;if(!We){let Ye;for(Ye=Oe.length;Ye>0;Ye--){const Qe=Oe.charCodeAt(Ye-1);if(Qe===47||Qe===92)break}We=Oe.substr(Ye)}const Xe=ve.indexOf(We);return Xe!==-1?ue[Xe]:null};Fe.basenames=ve,Fe.patterns=ue,Fe.allBasenames=ve;const Ke=j.filter(Oe=>!Oe.basenames);return Ke.push(Fe),Ke}}),define(we[78],Ee([0,1,42,11,17,24,23,9,2]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(i,v,g){if(typeof i=="string"&&(i=C.URI.file(i)),g){const b=g.getWorkspaceFolder(i);if(b){const u=g.getWorkspace().folders.length>1;let E;if((0,t.isEqual)(b.uri,i)?E="":E=(0,t.relativePath)(b.uri,i),u){const A=b.name?b.name:(0,t.basename)(b.uri);E=E?A+" \u2022 "+E:A}return E}}if(i.scheme!==M.Schemas.file&&i.scheme!==M.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,c.hasDriveLetter)(i.fsPath))return(0,w.normalize)(_(i.fsPath));let s=(0,w.normalize)(i.fsPath);return!T.isWindows&&v?.userHome&&(s=m(s,v.userHome.fsPath)),s}e.getPathLabel=k;function F(i){if(!i)return;typeof i=="string"&&(i=C.URI.file(i));const v=(0,t.basename)(i)||(i.scheme===M.Schemas.file?i.fsPath:i.path);return T.isWindows&&(0,c.isRootOrDriveLetter)(v)?_(v):v}e.getBaseLabel=F;function _(i,v){return(0,c.hasDriveLetter)(i,v)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=_;let r=Object.create(null);function m(i,v){if(T.isWindows||!i||!v)return i;let g=r.original===v?r.normalized:void 0;return g||(g=`${(0,R.rtrim)(v,w.posix.sep)}${w.posix.sep}`,r={original:v,normalized:g}),(T.isLinux?i.startsWith(g):(0,R.startsWithIgnoreCase)(i,g))&&(i=`~/${i.substr(g.length)}`),i}e.tildify=m;function o(i,v){return i.replace(/^~($|\/|\\)/,`${v}$1`)}e.untildify=o;const d="\u2026",p="\\\\",D="~";function f(i,v=w.sep){const g=new Array(i.length);let s=!1;for(let b=0;b<i.length;b++){let u=i[b];if(u===""){g[b]=`.${v}`;continue}if(!u){g[b]=u;continue}s=!0;let E="";u.indexOf(p)===0?(E=u.substr(0,u.indexOf(p)+p.length),u=u.substr(u.indexOf(p)+p.length)):u.indexOf(v)===0?(E=u.substr(0,u.indexOf(v)+v.length),u=u.substr(u.indexOf(v)+v.length)):u.indexOf(D)===0&&(E=u.substr(0,u.indexOf(D)+D.length),u=u.substr(u.indexOf(D)+D.length));const A=u.split(v);for(let I=1;s&&I<=A.length;I++)for(let B=A.length-I;s&&B>=0;B--){s=!1;let O=A.slice(B,B+I).join(v);for(let S=0;!s&&S<i.length;S++)if(S!==b&&i[S]&&i[S].indexOf(O)>-1){const x=B+I===A.length,N=B>0&&i[S].indexOf(v)>-1?v+O:O,V=i[S].endsWith(N);s=!x||V}if(!s){let S="";(A[0].endsWith(":")||E!=="")&&(B===1&&(B=0,I++,O=A[0]+v+O),B>0&&(S=A[0]+v),S=E+S),B>0&&(S=S+d+v),S=S+O,B+I<A.length&&(S=S+v+d),g[b]=S}}s&&(g[b]=u)}return g}e.shorten=f;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function h(i,v=Object.create(null)){const g=[];let s=!1,b="";for(const u of i)if(u==="$"||s&&u==="{")b&&g.push({value:b,type:l.TEXT}),b="",s=!0;else if(u==="}"&&s){const E=v[b];if(typeof E=="string")E.length&&g.push({value:E,type:l.VARIABLE});else if(E){const A=g[g.length-1];(!A||A.type!==l.SEPARATOR)&&g.push({value:E.label,type:l.SEPARATOR})}b="",s=!1}else b+=u;return b&&!s&&g.push({value:b,type:l.TEXT}),g.filter((u,E)=>{if(u.type===l.SEPARATOR){const A=g[E-1],I=g[E+1];return[A,I].every(B=>B&&(B.type===l.VARIABLE||B.type===l.TEXT)&&B.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=h;function y(i,v){return T.isMacintosh||v?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):i.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=y;function a(i,v){return T.isMacintosh||v?i.replace(/\(&&\w\)|&&/g,""):T.isWindows?i.replace(/&&|&/g,g=>g==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function P(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=P;function n(i){const v=i.indexOf("/")!==-1?w.posix:w.win32,g=v.basename(i),s=v.dirname(i);return g.length?{name:g,parentPath:s}:{name:s,parentPath:""}}e.splitName=n}),define(we[79],Ee([0,1,29,11,17,23,9]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(R=e.Mimes||(e.Mimes={}));let C=[],k=[],F=[];function _(i,v=!1){const g=r(i);C.push(g),g.userConfigured?F.push(g):k.push(g),v&&!g.userConfigured&&C.forEach(s=>{s.mime===g.mime||s.userConfigured||(g.extension&&s.extension===g.extension&&console.warn(`Overwriting extension <<${g.extension}>> to now point to mime <<${g.mime}>>`),g.filename&&s.filename===g.filename&&console.warn(`Overwriting filename <<${g.filename}>> to now point to mime <<${g.mime}>>`),g.filepattern&&s.filepattern===g.filepattern&&console.warn(`Overwriting filepattern <<${g.filepattern}>> to now point to mime <<${g.mime}>>`),g.firstline&&s.firstline===g.firstline&&console.warn(`Overwriting firstline <<${g.firstline}>> to now point to mime <<${g.mime}>>`))})}e.registerTextMime=_;function r(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,c.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(w.posix.sep)>=0:!1}}function m(i){i?(C=C.filter(v=>!v.userConfigured),F=[]):(C=[],k=[],F=[])}e.clearTextMimes=m;function o(i,v){let g;if(i)switch(i.scheme){case M.Schemas.file:g=i.fsPath;break;case M.Schemas.data:g=T.DataUri.parseMetaData(i).get(T.DataUri.META_DATA_LABEL);break;default:g=i.path}if(!g)return[R.unknown];g=g.toLowerCase();const s=(0,w.basename)(g),b=d(g,s,F);if(b)return[b,R.text];const u=d(g,s,k);if(u)return[u,R.text];if(v){const E=p(v);if(E)return[E,R.text]}return[R.unknown]}e.guessMimeTypes=o;function d(i,v,g){let s=null,b=null,u=null;for(let E=g.length-1;E>=0;E--){const A=g[E];if(v===A.filenameLowercase){s=A;break}if(A.filepattern&&(!b||A.filepattern.length>b.filepattern.length)){const I=A.filepatternOnPath?i:v;A.filepatternLowercase?.(I)&&(b=A)}A.extension&&(!u||A.extension.length>u.extension.length)&&v.endsWith(A.extensionLowercase)&&(u=A)}return s?s.mime:b?b.mime:u?u.mime:null}function p(i){if((0,t.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let v=C.length-1;v>=0;v--){const g=C[v];if(!g.firstline)continue;const s=i.match(g.firstline);if(s&&s.length>0)return g.mime}return null}function D(i){return i?typeof i=="string"?i===R.binary||i===R.text||i===R.unknown:i.length===1&&D(i[0]):!0}e.isUnspecific=D;const f={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function h(i){const v=(0,w.extname)(i),g=f[v.toLowerCase()];return g!==void 0?g:y(i)}e.getMediaOrTextMime=h;function y(i){const v=(0,w.extname)(i);return l[v.toLowerCase()]}e.getMediaMime=y;function a(i){for(const v in l)if(l[v]===i)return v}e.getExtensionForMimeType=a;const P=/^(.+)\/(.+?)(;.+)?$/;function n(i,v){const g=P.exec(i);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:v?void 0:i}e.normalizeMimeType=n}),define(we[107],Ee([0,1,2]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(F){return F.toJSON()}class w{constructor(_){this._uriTransformer=_}transformIncoming(_){const r=this._uriTransformer.transformIncoming(_);return r===_?_:M(c.URI.from(r))}transformOutgoing(_){const r=this._uriTransformer.transformOutgoing(_);return r===_?_:M(c.URI.from(r))}transformOutgoingURI(_){const r=this._uriTransformer.transformOutgoing(_);return r===_?_:c.URI.from(r)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function T(F,_,r){if(!F||r>200)return null;if(typeof F=="object"){if(F instanceof c.URI)return _.transformOutgoing(F);for(let m in F)if(Object.hasOwnProperty.call(F,m)){const o=T(F[m],_,r+1);o!==null&&(F[m]=o)}}return null}function t(F,_){const r=T(F,_,0);return r===null?F:r}e.transformOutgoingURIs=t;function R(F,_,r,m){if(!F||m>200)return null;if(typeof F=="object"){if(F.$mid===1)return r?c.URI.revive(_.transformIncoming(F)):_.transformIncoming(F);for(let o in F)if(Object.hasOwnProperty.call(F,o)){const d=R(F[o],_,r,m+1);d!==null&&(F[o]=d)}}return null}function C(F,_){const r=R(F,_,!1,0);return r===null?F:r}e.transformIncomingURIs=C;function k(F,_){const r=R(F,_,!0,0);return r===null?F:r}e.transformAndReviveIncomingURIs=k}),define(we[36],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return c.test(C)}e.isUUID=M;const w=new Uint8Array(16),T=[];for(let C=0;C<256;C++)T.push(C.toString(16).padStart(2,"0"));let t;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?t=crypto.getRandomValues.bind(crypto):t=function(C){for(let k=0;k<C.length;k++)C[k]=Math.floor(Math.random()*256);return C};function R(){t(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let C=0,k="";return k+=T[w[C++]],k+=T[w[C++]],k+=T[w[C++]],k+=T[w[C++]],k+="-",k+=T[w[C++]],k+=T[w[C++]],k+="-",k+=T[w[C++]],k+=T[w[C++]],k+="-",k+=T[w[C++]],k+=T[w[C++]],k+="-",k+=T[w[C++]],k+=T[w[C++]],k+=T[w[C++]],k+=T[w[C++]],k+=T[w[C++]],k+=T[w[C++]],k}e.generateUuid=R}),define(we[108],Ee([0,1,227]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(t){t[t.Regular=0]="Regular",t[t.Whitespace=1]="Whitespace",t[t.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class w extends c.CharacterClassifier{constructor(R){super(0);for(let C=0,k=R.length;C<k;C++)this.set(R.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=w;function T(t){let R={};return C=>(R.hasOwnProperty(C)||(R[C]=t(C)),R[C])}e.getMapForWordSeparators=T(t=>new w(t))}),define(we[80],Ee([0,1,25]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var w;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(w=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var t;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(t=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var R;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(R=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(l){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace),this.bracketPairColorizationOptions=l.bracketPairColorizationOptions}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace&&(0,c.equals)(this.bracketPairColorizationOptions,l.bracketPairColorizationOptions)}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class k{constructor(l,h){this._findMatchBrand=void 0,this.range=l,this.matches=h}}e.FindMatch=k;var F;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(F=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(f){f[f.Disabled=0]="Disabled",f[f.EnabledForActive=1]="EnabledForActive",f[f.Enabled=2]="Enabled"})(_=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class r{constructor(l,h,y){this.visibleColumn=l,this.className=h,this.horizontalLine=y}}e.IndentGuide=r;class m{constructor(l,h){this.top=l,this.endColumn=h}}e.IndentGuideHorizontalLine=m;var o;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None"})(o=e.PositionAffinity||(e.PositionAffinity={}));var d;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(d=e.ModelConstants||(e.ModelConstants={}));class p{constructor(l,h,y,a,P,n){this.identifier=l,this.range=h,this.text=y,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=P,this._isTracked=n}}e.ValidAnnotatedEditOperation=p;class D{constructor(l,h,y){this.reverseEdits=l,this.changes=h,this.trimAutoWhitespaceLineNumbers=y}}e.ApplyEditsResult=D}),define(we[109],Ee([0,1,9,108,110,43,80]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const R=999;class C{constructor(l,h,y,a){this.searchString=l,this.isRegex=h,this.matchCase=y,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=k(this.searchString):l=this.searchString.indexOf(`
`)>=0;let h=null;try{h=c.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(a){return null}if(!h)return null;let y=!this.isRegex&&!l;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new F(h,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,y?this.searchString:null)}}e.SearchParams=C;function k(f){if(!f||f.length===0)return!1;for(let l=0,h=f.length;l<h;l++)if(f.charCodeAt(l)===92){if(l++,l>=h)break;const a=f.charCodeAt(l);if(a===110||a===114||a===87)return!0}return!1}e.isMultilineRegexSource=k;class F{constructor(l,h,y){this.regex=l,this.wordSeparators=h,this.simpleSearch=y}}e.SearchData=F;function _(f,l,h){if(!h)return new t.FindMatch(f,null);let y=[];for(let a=0,P=l.length;a<P;a++)y[a]=l[a];return new t.FindMatch(f,y)}e.createFindMatch=_;class r{constructor(l){let h=[],y=0;for(let a=0,P=l.length;a<P;a++)l.charCodeAt(a)===10&&(h[y++]=a);this._lineFeedsOffsets=h}findLineFeedCountBeforeOffset(l){const h=this._lineFeedsOffsets;let y=0,a=h.length-1;if(a===-1||l<=h[0])return 0;for(;y<a;){const P=y+((a-y)/2>>0);h[P]>=l?a=P-1:h[P+1]>=l?(y=P,a=P):y=P+1}return y+1}}class m{static findMatches(l,h,y,a,P){const n=h.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(l,y,new D(n.wordSeparators,n.regex),a,P):this._doFindMatchesLineByLine(l,y,n,a,P):[]}static _getMultilineMatchRange(l,h,y,a,P,n){let i,v=0;a?(v=a.findLineFeedCountBeforeOffset(P),i=h+P+v):i=h+P;let g;if(a){let E=a.findLineFeedCountBeforeOffset(P+n.length)-v;g=i+n.length+E}else g=i+n.length;const s=l.getPositionAt(i),b=l.getPositionAt(g);return new T.Range(s.lineNumber,s.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(l,h,y,a,P){const n=l.getOffsetAt(h.getStartPosition()),i=l.getValueInRange(h,1),v=l.getEOL()===`\r
`?new r(i):null,g=[];let s=0,b;for(y.reset(0);b=y.next(i);)if(g[s++]=_(this._getMultilineMatchRange(l,n,i,v,b.index,b[0]),b,a),s>=P)return g;return g}static _doFindMatchesLineByLine(l,h,y,a,P){const n=[];let i=0;if(h.startLineNumber===h.endLineNumber){const g=l.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return i=this._findMatchesInLine(y,g,h.startLineNumber,h.startColumn-1,i,n,a,P),n}const v=l.getLineContent(h.startLineNumber).substring(h.startColumn-1);i=this._findMatchesInLine(y,v,h.startLineNumber,h.startColumn-1,i,n,a,P);for(let g=h.startLineNumber+1;g<h.endLineNumber&&i<P;g++)i=this._findMatchesInLine(y,l.getLineContent(g),g,0,i,n,a,P);if(i<P){const g=l.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);i=this._findMatchesInLine(y,g,h.endLineNumber,0,i,n,a,P)}return n}static _findMatchesInLine(l,h,y,a,P,n,i,v){const g=l.wordSeparators;if(!i&&l.simpleSearch){const u=l.simpleSearch,E=u.length,A=h.length;let I=-E;for(;(I=h.indexOf(u,I+E))!==-1;)if((!g||p(g,h,A,I,E))&&(n[P++]=new t.FindMatch(new T.Range(y,I+1+a,y,I+1+E+a),null),P>=v))return P;return P}const s=new D(l.wordSeparators,l.regex);let b;s.reset(0);do if(b=s.next(h),b&&(n[P++]=_(new T.Range(y,b.index+1+a,y,b.index+1+b[0].length+a),b,i),P>=v))return P;while(b);return P}static findNextMatch(l,h,y,a){const P=h.parseSearchRequest();if(!P)return null;const n=new D(P.wordSeparators,P.regex);return P.regex.multiline?this._doFindNextMatchMultiline(l,y,n,a):this._doFindNextMatchLineByLine(l,y,n,a)}static _doFindNextMatchMultiline(l,h,y,a){const P=new w.Position(h.lineNumber,1),n=l.getOffsetAt(P),i=l.getLineCount(),v=l.getValueInRange(new T.Range(P.lineNumber,P.column,i,l.getLineMaxColumn(i)),1),g=l.getEOL()===`\r
`?new r(v):null;y.reset(h.column-1);let s=y.next(v);return s?_(this._getMultilineMatchRange(l,n,v,g,s.index,s[0]),s,a):h.lineNumber!==1||h.column!==1?this._doFindNextMatchMultiline(l,new w.Position(1,1),y,a):null}static _doFindNextMatchLineByLine(l,h,y,a){const P=l.getLineCount(),n=h.lineNumber,i=l.getLineContent(n),v=this._findFirstMatchInLine(y,i,n,h.column,a);if(v)return v;for(let g=1;g<=P;g++){const s=(n+g-1)%P,b=l.getLineContent(s+1),u=this._findFirstMatchInLine(y,b,s+1,1,a);if(u)return u}return null}static _findFirstMatchInLine(l,h,y,a,P){l.reset(a-1);const n=l.next(h);return n?_(new T.Range(y,n.index+1,y,n.index+1+n[0].length),n,P):null}static findPreviousMatch(l,h,y,a){const P=h.parseSearchRequest();if(!P)return null;const n=new D(P.wordSeparators,P.regex);return P.regex.multiline?this._doFindPreviousMatchMultiline(l,y,n,a):this._doFindPreviousMatchLineByLine(l,y,n,a)}static _doFindPreviousMatchMultiline(l,h,y,a){const P=this._doFindMatchesMultiline(l,new T.Range(1,1,h.lineNumber,h.column),y,a,10*R);if(P.length>0)return P[P.length-1];const n=l.getLineCount();return h.lineNumber!==n||h.column!==l.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(l,new w.Position(n,l.getLineMaxColumn(n)),y,a):null}static _doFindPreviousMatchLineByLine(l,h,y,a){const P=l.getLineCount(),n=h.lineNumber,i=l.getLineContent(n).substring(0,h.column-1),v=this._findLastMatchInLine(y,i,n,a);if(v)return v;for(let g=1;g<=P;g++){const s=(P+n-g-1)%P,b=l.getLineContent(s+1),u=this._findLastMatchInLine(y,b,s+1,a);if(u)return u}return null}static _findLastMatchInLine(l,h,y,a){let P=null,n;for(l.reset(0);n=l.next(h);)P=_(new T.Range(y,n.index+1,y,n.index+1+n[0].length),n,a);return P}}e.TextModelSearch=m;function o(f,l,h,y,a){if(y===0)return!0;const P=l.charCodeAt(y-1);if(f.get(P)!==0||P===13||P===10)return!0;if(a>0){const n=l.charCodeAt(y);if(f.get(n)!==0)return!0}return!1}function d(f,l,h,y,a){if(y+a===h)return!0;const P=l.charCodeAt(y+a);if(f.get(P)!==0||P===13||P===10)return!0;if(a>0){const n=l.charCodeAt(y+a-1);if(f.get(n)!==0)return!0}return!1}function p(f,l,h,y,a){return o(f,l,h,y,a)&&d(f,l,h,y,a)}e.isValidMatch=p;class D{constructor(l,h){this._wordSeparators=l,this._searchRegex=h,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const h=l.length;let y;do{if(this._prevMatchStartIndex+this._prevMatchLength===h||(y=this._searchRegex.exec(l),!y))return null;const a=y.index,P=y[0].length;if(a===this._prevMatchStartIndex&&P===this._prevMatchLength){if(P===0){c.getNextCodePoint(l,h,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=a,this._prevMatchLength=P,!this._wordSeparators||p(this._wordSeparators,l,h,a,P))return y}while(y);return null}}e.Searcher=D}),define(we[111],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var c;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(c=e.IndentAction||(e.IndentAction={}));class M{constructor(R){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=R.open,this.close=R.close,this._standardTokenMask=0,Array.isArray(R.notIn))for(let C=0,k=R.notIn.length;C<k;C++)switch(R.notIn[C]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(R){return(this._standardTokenMask&R)==0}}e.StandardAutoClosingPairConditional=M;class w{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of R)T(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),T(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),T(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),T(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&T(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=w;function T(t,R,C){t.has(R)?t.get(R).push(C):t.set(R,[C])}}),define(we[56],Ee([0,1,29,17]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(T,t,R,C){if(Array.isArray(T)){let k=0;for(const F of T){const _=w(F,t,R,C);if(_===10)return _;_>k&&(k=_)}return k}else{if(typeof T=="string")return C?T==="*"?5:T===R?10:0:0;if(T){const{language:k,pattern:F,scheme:_,hasAccessToAllModels:r}=T;if(!C&&!r)return 0;let m=0;if(_)if(_===t.scheme)m=10;else if(_==="*")m=5;else return 0;if(k)if(k===R)m=10;else if(k==="*")m=Math.max(m,5);else return 0;if(F){let o;if(typeof F=="string"?o=F:o={...F,base:(0,M.normalize)(F.base)},o===t.fsPath||(0,c.match)(o,t.fsPath))m=10;else return 0}return m}else return 0}}e.score=w}),define(we[112],Ee([0,1,3,7]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class w{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new c.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(t){this._onDidChange.fire({changedLanguages:t,changedColorMap:!1})}register(t,R){return this._map.set(t,R),this.fire([t]),(0,M.toDisposable)(()=>{this._map.get(t)===R&&(this._map.delete(t),this.fire([t]))})}registerPromise(t,R){let C=null,k=!1;return this._promises.set(t,R.then(F=>{this._promises.delete(t),!(k||!F)&&(C=this.register(t,F))})),(0,M.toDisposable)(()=>{k=!0,C&&C.dispose()})}getPromise(t){const R=this.get(t);if(R)return Promise.resolve(R);const C=this._promises.get(t);return C?C.then(k=>this.get(t)):null}get(t){return this._map.get(t)||null}setColorMap(t){this._colorMap=t,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=w}),define(we[81],Ee([0,1,22,24]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(w||(w={}));function T(_){for(let r=0,m=_.length;r<m;r+=4){const o=_[r+0],d=_[r+1],p=_[r+2],D=_[r+3];_[r+0]=D,_[r+1]=p,_[r+2]=d,_[r+3]=o}}function t(_){const r=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return M.isLittleEndian()||T(r),c.VSBuffer.wrap(r)}function R(_){const r=_.buffer;if(M.isLittleEndian()||T(r),r.byteOffset%4==0)return new Uint32Array(r.buffer,r.byteOffset,r.length/4);{const m=new Uint8Array(r.byteLength);return m.set(r),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function C(_){const r=new Uint32Array(k(_));let m=0;if(r[m++]=_.id,_.type==="full")r[m++]=1,r[m++]=_.data.length,r.set(_.data,m),m+=_.data.length;else{r[m++]=2,r[m++]=_.deltas.length;for(const o of _.deltas)r[m++]=o.start,r[m++]=o.deleteCount,o.data?(r[m++]=o.data.length,r.set(o.data,m),m+=o.data.length):r[m++]=0}return t(r)}e.encodeSemanticTokensDto=C;function k(_){let r=0;if(r+=1+1,_.type==="full")r+=1+_.data.length;else{r+=1,r+=(1+1+1)*_.deltas.length;for(const m of _.deltas)m.data&&(r+=m.data.length)}return r}function F(_){const r=R(_);let m=0;const o=r[m++];if(r[m++]===1){const f=r[m++],l=r.subarray(m,m+f);return m+=f,{id:o,type:"full",data:l}}const p=r[m++];let D=[];for(let f=0;f<p;f++){const l=r[m++],h=r[m++],y=r[m++];let a;y>0&&(a=r.subarray(m,m+y),m+=y),D[f]={start:l,deleteCount:h,data:a}}return{id:o,type:"delta",deltas:D}}e.decodeSemanticTokensDto=F}),define(we[113],Ee([18,19]),function(re,e){return re.create("vs/base/common/date",e)}),define(we[114],Ee([0,1,113]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,w=M*60,T=w*24,t=T*7,R=T*30,C=T*365;function k(_,r){typeof _!="number"&&(_=_.getTime());const m=Math.round((new Date().getTime()-_)/1e3);if(m<-30)return(0,c.localize)(0,null,k(new Date().getTime()+m*1e3,!1));if(m<30)return(0,c.localize)(1,null);let o;return m<M?(o=m,r?o===1?(0,c.localize)(2,null,o):(0,c.localize)(3,null,o):o===1?(0,c.localize)(4,null,o):(0,c.localize)(5,null,o)):m<w?(o=Math.floor(m/M),r?o===1?(0,c.localize)(6,null,o):(0,c.localize)(7,null,o):o===1?(0,c.localize)(8,null,o):(0,c.localize)(9,null,o)):m<T?(o=Math.floor(m/w),r?o===1?(0,c.localize)(10,null,o):(0,c.localize)(11,null,o):o===1?(0,c.localize)(12,null,o):(0,c.localize)(13,null,o)):m<t?(o=Math.floor(m/T),r?o===1?(0,c.localize)(14,null,o):(0,c.localize)(15,null,o):o===1?(0,c.localize)(16,null,o):(0,c.localize)(17,null,o)):m<R?(o=Math.floor(m/t),r?o===1?(0,c.localize)(18,null,o):(0,c.localize)(19,null,o):o===1?(0,c.localize)(20,null,o):(0,c.localize)(21,null,o)):m<C?(o=Math.floor(m/R),r?o===1?(0,c.localize)(22,null,o):(0,c.localize)(23,null,o):o===1?(0,c.localize)(24,null,o):(0,c.localize)(25,null,o)):(o=Math.floor(m/C),r?o===1?(0,c.localize)(26,null,o):(0,c.localize)(27,null,o):o===1?(0,c.localize)(28,null,o):(0,c.localize)(29,null,o))}e.fromNow=k;function F(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(we[115],Ee([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(we[44],Ee([0,1,16,10,115]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(k,F){return F&&(k.stack||k.stacktrace)?w.localize(0,null,R(k),t(k.stack)||t(k.stacktrace)):R(k)}function t(k){return Array.isArray(k)?k.join(`
`):k}function R(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?w.localize(1,null,k.message):k.message||w.localize(2,null)}function C(k=null,F=!1){if(!k)return w.localize(3,null);if(Array.isArray(k)){const _=c.coalesce(k),r=C(_[0],F);return _.length>1?w.localize(4,null,r,_.length):r}if(M.isString(k))return k;if(k.detail){const _=k.detail;if(_.error)return T(_.error,F);if(_.exception)return T(_.exception,F)}return k.stack?T(k,F):k.message?k.message:w.localize(5,null)}e.toErrorMessage=C}),define(we[116],Ee([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(we[117],Ee([0,1,116,24,118]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class t{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=t;class R{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,pe){this._values[X]=pe}}e.ValidatedEditorOptions=R;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class k{constructor(X,pe,$e,qe){this.id=X,this.name=pe,this.defaultValue=$e,this.schema=qe}compute(X,pe,$e){return $e}}class F{constructor(X,pe=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(X){return this.defaultValue}}class _{constructor(X,pe,$e,qe){this.id=X,this.name=pe,this.defaultValue=$e,this.schema=qe}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,pe,$e){return $e}}function r(q,X){return typeof q=="undefined"?X:q==="false"?!1:Boolean(q)}e.boolean=r;class m extends _{constructor(X,pe,$e,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=$e),super(X,pe,$e,qe)}validate(X){return r(X,this.defaultValue)}}function o(q,X,pe,$e){if(typeof q=="undefined")return X;let qe=parseInt(q,10);return isNaN(qe)?X:(qe=Math.max(pe,qe),qe=Math.min($e,qe),qe|0)}e.clampedInt=o;class d extends _{constructor(X,pe,$e,qe,rt,ft=void 0){typeof ft!="undefined"&&(ft.type="integer",ft.default=$e,ft.minimum=qe,ft.maximum=rt),super(X,pe,$e,ft),this.minimum=qe,this.maximum=rt}static clampedInt(X,pe,$e,qe){return o(X,pe,$e,qe)}validate(X){return d.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class p extends _{constructor(X,pe,$e,qe,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=$e),super(X,pe,$e,rt),this.validationFn=qe}static clamp(X,pe,$e){return X<pe?pe:X>$e?$e:X}static float(X,pe){if(typeof X=="number")return X;if(typeof X=="undefined")return pe;const $e=parseFloat(X);return isNaN($e)?pe:$e}validate(X){return this.validationFn(p.float(X,this.defaultValue))}}class D extends _{static string(X,pe){return typeof X!="string"?pe:X}constructor(X,pe,$e,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=$e),super(X,pe,$e,qe)}validate(X){return D.string(X,this.defaultValue)}}function f(q,X,pe){return typeof q!="string"||pe.indexOf(q)===-1?X:q}e.stringSet=f;class l extends _{constructor(X,pe,$e,qe,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=qe,rt.default=$e),super(X,pe,$e,rt),this._allowedValues=qe}validate(X){return f(X,this.defaultValue,this._allowedValues)}}class h extends k{constructor(X,pe,$e,qe,rt,ft,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=rt,ht.default=qe),super(X,pe,$e,ht),this._allowedValues=rt,this._convert=ft}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function y(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",description:c.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,pe,$e){return $e===0?X.accessibilitySupport:$e}}class P extends k{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:c.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertSpace:r(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function g(q){switch(q){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=g;function s(q){switch(q){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class b extends F{constructor(){super(126,[65,33])}compute(X,pe,$e){const qe=["monaco-editor"];return pe.get(33)&&qe.push(pe.get(33)),X.extraEditorClassName&&qe.push(X.extraEditorClassName),pe.get(65)==="default"?qe.push("mouse-default"):pe.get(65)==="copy"&&qe.push("mouse-copy"),pe.get(99)&&qe.push("showUnused"),pe.get(124)&&qe.push("showDeprecated"),qe.join(" ")}}class u extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(X,pe,$e){return $e&&X.emptySelectionClipboard}}class E extends k{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:c.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:c.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{cursorMoveOnType:r(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":f(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":f(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(pe.loop,this.defaultValue.loop)}}}class A extends k{constructor(){super(44,"fontLigatures",A.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?A.OFF:X==="true"?A.ON:X:Boolean(X)?A.ON:A.OFF}}e.EditorFontLigatures=A,A.OFF='"liga" off, "calt" off',A.ON='"liga" on, "calt" on';class I extends F{constructor(){super(43)}compute(X,pe,$e){return X.fontInfo}}class B extends _{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(22,null)})}validate(X){let pe=p.float(X,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(pe,6,100)}compute(X,pe,$e){return X.fontInfo.fontSize}}class O extends k{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:O.MINIMUM_VALUE,maximum:O.MAXIMUM_VALUE,errorMessage:c.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:O.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(d.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,O.MINIMUM_VALUE,O.MAXIMUM_VALUE))}}O.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],O.MINIMUM_VALUE=1,O.MAXIMUM_VALUE=1e3;class S extends k{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[c.localize(25,null),c.localize(26,null),c.localize(27,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:c.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:c.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:c.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:$e,description:c.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:$e,description:c.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:$e,description:c.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:$e,description:c.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:$e,description:c.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{multiple:f(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??f(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??f(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??f(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??f(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??f(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends k{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:c.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,description:c.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:c.localize(41,null)},"editor.hover.above":{type:"boolean",default:X.above,description:c.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:r(pe.enabled,this.defaultValue.enabled),delay:d.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:r(pe.sticky,this.defaultValue.sticky),above:r(pe.above,this.defaultValue.above)}}}var N;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class V extends F{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(X,pe,$e){return V.computeLayout(pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const pe=X.height/X.lineHeight,$e=X.scrollBeyondLastLine?pe-1:0,qe=(X.viewLineCount+$e)/(X.pixelRatio*X.height),rt=Math.floor(X.viewLineCount/qe);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:$e,desiredRatio:qe,minimapLineCount:rt}}static _computeMinimapLayout(X,pe){const $e=X.outerWidth,qe=X.outerHeight,rt=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const ft=pe.stableMinimapLayoutInput,ht=ft&&X.outerHeight===ft.outerHeight&&X.lineHeight===ft.lineHeight&&X.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&X.pixelRatio===ft.pixelRatio&&X.scrollBeyondLastLine===ft.scrollBeyondLastLine&&X.minimap.enabled===ft.minimap.enabled&&X.minimap.side===ft.minimap.side&&X.minimap.size===ft.minimap.size&&X.minimap.showSlider===ft.minimap.showSlider&&X.minimap.renderCharacters===ft.minimap.renderCharacters&&X.minimap.maxColumn===ft.minimap.maxColumn&&X.minimap.scale===ft.minimap.scale&&X.verticalScrollbarWidth===ft.verticalScrollbarWidth&&X.isViewportWrapping===ft.isViewportWrapping,Ct=X.lineHeight,It=X.typicalHalfwidthCharacterWidth,Pt=X.scrollBeyondLastLine,Ze=X.minimap.renderCharacters;let pt=rt>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Ie=X.minimap.maxColumn,ge=X.minimap.size,Ce=X.minimap.side,Z=X.verticalScrollbarWidth,se=X.viewLineCount,fe=X.remainingWidth,he=X.isViewportWrapping,ke=Ze?2:3;let Le=Math.floor(rt*qe);const Me=Le/rt;let He=!1,it=!1,Re=ke*pt,le=pt/rt,me=1;if(ge==="fill"||ge==="fit"){const{typicalViewportLineCount:lt,extraLinesBeyondLastLine:_t,desiredRatio:bt,minimapLineCount:ct}=V.computeContainedMinimapLineCount({viewLineCount:se,scrollBeyondLastLine:Pt,height:qe,lineHeight:Ct,pixelRatio:rt});if(se/ct>1)He=!0,it=!0,pt=1,Re=1,le=pt/rt;else{let dt=!1,Tt=pt+1;if(ge==="fit"){const yt=Math.ceil((se+_t)*Re);he&&ht&&fe<=pe.stableFitRemainingWidth?(dt=!0,Tt=pe.stableFitMaxMinimapScale):dt=yt>Le}if(ge==="fill"||dt){He=!0;const yt=pt;Re=Math.min(Ct*rt,Math.max(1,Math.floor(1/bt))),he&&ht&&fe<=pe.stableFitRemainingWidth&&(Tt=pe.stableFitMaxMinimapScale),pt=Math.min(Tt,Math.max(1,Math.floor(Re/ke))),pt>yt&&(me=Math.min(2,pt/yt)),le=pt/rt/me,Le=Math.ceil(Math.max(lt,se+_t)*Re),he?(pe.stableMinimapLayoutInput=X,pe.stableFitRemainingWidth=fe,pe.stableFitMaxMinimapScale=pt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ne=Math.floor(Ie*le),W=Math.min(ne,Math.max(0,Math.floor((fe-Z-2)*le/(It+le)))+e.MINIMAP_GUTTER_WIDTH);let be=Math.floor(rt*W);const De=be/rt;be=Math.floor(be*me);const Ge=Ze?1:2,xe=Ce==="left"?0:$e-W-Z;return{renderMinimap:Ge,minimapLeft:xe,minimapWidth:W,minimapHeightIsEditorHeight:He,minimapIsSampling:it,minimapScale:pt,minimapLineHeight:Re,minimapCanvasInnerWidth:be,minimapCanvasInnerHeight:Le,minimapCanvasOuterWidth:De,minimapCanvasOuterHeight:Me}}static computeLayout(X,pe){const $e=pe.outerWidth|0,qe=pe.outerHeight|0,rt=pe.lineHeight|0,ft=pe.lineNumbersDigitCount|0,ht=pe.typicalHalfwidthCharacterWidth,Ct=pe.maxDigitWidth,It=pe.pixelRatio,Pt=pe.viewLineCount,Ze=X.get(121),pt=Ze==="inherit"?X.get(120):Ze,Ie=pt==="inherit"?X.get(116):pt,ge=X.get(119),Ce=X.get(2),Z=pe.isDominatedByLongLines,se=X.get(49),fe=X.get(59).renderType!==0,he=X.get(60),ke=X.get(93),Le=X.get(64),Me=X.get(91),He=Me.verticalScrollbarSize,it=Me.verticalHasArrows,Re=Me.arrowSize,le=Me.horizontalScrollbarSize,me=X.get(57),ne=X.get(37);let W;if(typeof me=="string"&&/^\d+(\.\d+)?ch$/.test(me)){const St=parseFloat(me.substr(0,me.length-2));W=d.clampedInt(St*ht,0,0,1e3)}else W=d.clampedInt(me,0,0,1e3);ne&&(W+=16);let be=0;if(fe){const St=Math.max(ft,he);be=Math.round(St*Ct)}let De=0;se&&(De=rt);let Ge=0,xe=Ge+De,lt=xe+be,_t=lt+W;const bt=$e-De-be-W;let ct=!1,gt=!1,dt=-1;Ce!==2&&(pt==="inherit"&&Z?(ct=!0,gt=!0):Ie==="on"||Ie==="bounded"?gt=!0:Ie==="wordWrapColumn"&&(dt=ge));const Tt=V._computeMinimapLayout({outerWidth:$e,outerHeight:qe,lineHeight:rt,typicalHalfwidthCharacterWidth:ht,pixelRatio:It,scrollBeyondLastLine:ke,minimap:Le,verticalScrollbarWidth:He,viewLineCount:Pt,remainingWidth:bt,isViewportWrapping:gt},pe.memory||new C);Tt.renderMinimap!==0&&Tt.minimapLeft===0&&(Ge+=Tt.minimapWidth,xe+=Tt.minimapWidth,lt+=Tt.minimapWidth,_t+=Tt.minimapWidth);const yt=bt-Tt.minimapWidth,Bt=Math.max(1,Math.floor((yt-He-2)/ht)),Vt=it?Re:0;return gt&&(dt=Math.max(1,Bt),Ie==="bounded"&&(dt=Math.min(dt,ge))),{width:$e,height:qe,glyphMarginLeft:Ge,glyphMarginWidth:De,lineNumbersLeft:xe,lineNumbersWidth:be,decorationsLeft:lt,decorationsWidth:W,contentLeft:_t,contentWidth:yt,minimap:Tt,viewportColumn:Bt,isWordWrapMinified:ct,isViewportWrapping:gt,wrappingColumn:dt,verticalScrollbarWidth:He,horizontalScrollbarHeight:le,overviewRuler:{top:Vt,width:He,height:qe-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=V;class $ extends k{constructor(){const X={enabled:!0};super(56,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:c.localize(43,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:r(X.enabled,this.defaultValue.enabled)}}}class z extends k{constructor(){const X={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",X,{"editor.inlayHints.enabled":{type:"boolean",default:X.enabled,description:c.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:c.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:c.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:r(pe.enabled,this.defaultValue.enabled),fontSize:d.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class ee extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>p.clamp(X,0,150),{markdownDescription:c.localize(47,null)})}compute(X,pe,$e){return X.fontInfo.lineHeight}}class j extends k{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:c.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(49,null),c.localize(50,null),c.localize(51,null)],default:X.size,description:c.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:c.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:c.localize(54,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:c.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:c.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:r(pe.enabled,this.defaultValue.enabled),size:f(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(pe.side,this.defaultValue.side,["right","left"]),showSlider:f(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(pe.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(pe.scale,1,1,3),maxColumn:d.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(q){return q==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ce extends k{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{top:d.clampedInt(pe.top,0,0,1e3),bottom:d.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends k{constructor(){const X={enabled:!0,cycle:!1};super(75,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:c.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:c.localize(61,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:r(pe.enabled,this.defaultValue.enabled),cycle:r(pe.cycle,this.defaultValue.cycle)}}}class ue extends F{constructor(){super(127)}compute(X,pe,$e){return X.pixelRatio}}class Fe extends k{constructor(){const X={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:c.localize(62,null)},comments:{type:"boolean",default:X.comments,description:c.localize(63,null)},other:{type:"boolean",default:X.other,description:c.localize(64,null)}}}],default:X,description:c.localize(65,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const pe=X,$e={other:r(pe.other,this.defaultValue.other),comments:r(pe.comments,this.defaultValue.comments),strings:r(pe.strings,this.defaultValue.strings)};return $e.other&&$e.comments&&$e.strings?!0:!$e.other&&!$e.comments&&!$e.strings?!1:$e}return this.defaultValue}}var Ke;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(Ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Oe extends k{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null),c.localize(69,null)],default:"on",description:c.localize(70,null)})}validate(X){let pe=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(pe=4,$e=X):X==="interval"?pe=3:X==="relative"?pe=2:X==="on"?pe=1:pe=0),{renderType:pe,renderFn:$e}}}function We(q){const X=q.get(86);return X==="editable"?q.get(80):X!=="on"}e.filterValidationDecorations=We;class Xe extends k{constructor(){const X=[],pe={type:"number",description:c.localize(71,null)};super(90,"rulers",X,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:c.localize(72,null),format:"color-hex"}}}]},default:X,description:c.localize(73,null)})}validate(X){if(Array.isArray(X)){let pe=[];for(let $e of X)if(typeof $e=="number")pe.push({column:d.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const qe=$e;pe.push({column:d.clampedInt(qe.column,0,0,1e4),color:qe.color})}return pe.sort(($e,qe)=>$e.column-qe.column),pe}return this.defaultValue}}function Ye(q,X){if(typeof q!="string")return X;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Qe extends k{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(74,null),c.localize(75,null),c.localize(76,null)],default:"auto",description:c.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(78,null),c.localize(79,null),c.localize(80,null)],default:"auto",description:c.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:c.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:c.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:c.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X,$e=d.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=d.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ye(pe.vertical,this.defaultValue.vertical),horizontal:Ye(pe.horizontal,this.defaultValue.horizontal),useShadows:r(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:d.clampedInt(pe.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:d.clampedInt(pe.verticalSliderSize,qe,0,1e3),scrollByPage:r(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class H extends k{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:c.localize(85,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:r(pe.enabled,this.defaultValue.enabled),mode:f(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class K extends k{constructor(){const X={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,description:c.localize(86,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:r(X.enabled,this.defaultValue.enabled)}}}class J extends k{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(87,null),c.localize(88,null),c.localize(89,null)],default:X.bracketPairs,description:c.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(91,null),c.localize(92,null),c.localize(93,null)],default:X.bracketPairsHorizontal,description:c.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:c.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:c.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:X.highlightActiveIndentation,description:c.localize(97,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{bracketPairs:oe(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:oe(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:r(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function oe(q,X,pe){const $e=pe.indexOf(q);return $e===-1?X:pe[$e]}class G extends k{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(98,null),c.localize(99,null)],default:X.insertMode,description:c.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:c.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:c.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:c.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:c.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:c.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:c.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:c.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:c.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(139,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertMode:f(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:r(pe.showIcons,this.defaultValue.showIcons),showStatusBar:r(pe.showStatusBar,this.defaultValue.showStatusBar),preview:r(pe.preview,this.defaultValue.preview),previewMode:f(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(pe.showMethods,this.defaultValue.showMethods),showFunctions:r(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:r(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:r(pe.showFields,this.defaultValue.showFields),showVariables:r(pe.showVariables,this.defaultValue.showVariables),showClasses:r(pe.showClasses,this.defaultValue.showClasses),showStructs:r(pe.showStructs,this.defaultValue.showStructs),showInterfaces:r(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:r(pe.showModules,this.defaultValue.showModules),showProperties:r(pe.showProperties,this.defaultValue.showProperties),showEvents:r(pe.showEvents,this.defaultValue.showEvents),showOperators:r(pe.showOperators,this.defaultValue.showOperators),showUnits:r(pe.showUnits,this.defaultValue.showUnits),showValues:r(pe.showValues,this.defaultValue.showValues),showConstants:r(pe.showConstants,this.defaultValue.showConstants),showEnums:r(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:r(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(pe.showKeywords,this.defaultValue.showKeywords),showWords:r(pe.showWords,this.defaultValue.showWords),showColors:r(pe.showColors,this.defaultValue.showColors),showFiles:r(pe.showFiles,this.defaultValue.showFiles),showReferences:r(pe.showReferences,this.defaultValue.showReferences),showFolders:r(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:r(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(pe.showSnippets,this.defaultValue.showSnippets),showUsers:r(pe.showUsers,this.defaultValue.showUsers),showIssues:r(pe.showIssues,this.defaultValue.showIssues)}}}class ie extends k{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(140,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends F{constructor(){super(128,[80])}compute(X,pe,$e){return pe.get(80)?!0:X.tabFocusMode}}var Te;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(Te=e.WrappingIndent||(e.WrappingIndent={}));function Ne(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ze extends F{constructor(){super(130,[129])}compute(X,pe,$e){const qe=pe.get(129);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const je="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",ot="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?et:M.isLinux?ot:je,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(q){return e.editorOptionsRegistry[q.id]=q,q}var nt;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=42]="fontFamily",q[q.fontInfo=43]="fontInfo",q[q.fontLigatures=44]="fontLigatures",q[q.fontSize=45]="fontSize",q[q.fontWeight=46]="fontWeight",q[q.formatOnPaste=47]="formatOnPaste",q[q.formatOnType=48]="formatOnType",q[q.glyphMargin=49]="glyphMargin",q[q.gotoLocation=50]="gotoLocation",q[q.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",q[q.hover=52]="hover",q[q.inDiffEditor=53]="inDiffEditor",q[q.inlineSuggest=54]="inlineSuggest",q[q.letterSpacing=55]="letterSpacing",q[q.lightbulb=56]="lightbulb",q[q.lineDecorationsWidth=57]="lineDecorationsWidth",q[q.lineHeight=58]="lineHeight",q[q.lineNumbers=59]="lineNumbers",q[q.lineNumbersMinChars=60]="lineNumbersMinChars",q[q.linkedEditing=61]="linkedEditing",q[q.links=62]="links",q[q.matchBrackets=63]="matchBrackets",q[q.minimap=64]="minimap",q[q.mouseStyle=65]="mouseStyle",q[q.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=67]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",q[q.multiCursorModifier=69]="multiCursorModifier",q[q.multiCursorPaste=70]="multiCursorPaste",q[q.occurrencesHighlight=71]="occurrencesHighlight",q[q.overviewRulerBorder=72]="overviewRulerBorder",q[q.overviewRulerLanes=73]="overviewRulerLanes",q[q.padding=74]="padding",q[q.parameterHints=75]="parameterHints",q[q.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",q[q.quickSuggestions=78]="quickSuggestions",q[q.quickSuggestionsDelay=79]="quickSuggestionsDelay",q[q.readOnly=80]="readOnly",q[q.renameOnType=81]="renameOnType",q[q.renderControlCharacters=82]="renderControlCharacters",q[q.renderFinalNewline=83]="renderFinalNewline",q[q.renderLineHighlight=84]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=86]="renderValidationDecorations",q[q.renderWhitespace=87]="renderWhitespace",q[q.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",q[q.roundedSelection=89]="roundedSelection",q[q.rulers=90]="rulers",q[q.scrollbar=91]="scrollbar",q[q.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=93]="scrollBeyondLastLine",q[q.scrollPredominantAxis=94]="scrollPredominantAxis",q[q.selectionClipboard=95]="selectionClipboard",q[q.selectionHighlight=96]="selectionHighlight",q[q.selectOnLineNumbers=97]="selectOnLineNumbers",q[q.showFoldingControls=98]="showFoldingControls",q[q.showUnused=99]="showUnused",q[q.snippetSuggestions=100]="snippetSuggestions",q[q.smartSelect=101]="smartSelect",q[q.smoothScrolling=102]="smoothScrolling",q[q.stickyTabStops=103]="stickyTabStops",q[q.stopRenderingLineAfter=104]="stopRenderingLineAfter",q[q.suggest=105]="suggest",q[q.suggestFontSize=106]="suggestFontSize",q[q.suggestLineHeight=107]="suggestLineHeight",q[q.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",q[q.suggestSelection=109]="suggestSelection",q[q.tabCompletion=110]="tabCompletion",q[q.tabIndex=111]="tabIndex",q[q.unusualLineTerminators=112]="unusualLineTerminators",q[q.useShadowDOM=113]="useShadowDOM",q[q.useTabStops=114]="useTabStops",q[q.wordSeparators=115]="wordSeparators",q[q.wordWrap=116]="wordWrap",q[q.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=119]="wordWrapColumn",q[q.wordWrapOverride1=120]="wordWrapOverride1",q[q.wordWrapOverride2=121]="wordWrapOverride2",q[q.wrappingIndent=122]="wrappingIndent",q[q.wrappingStrategy=123]="wrappingStrategy",q[q.showDeprecated=124]="showDeprecated",q[q.inlayHints=125]="inlayHints",q[q.editorClassName=126]="editorClassName",q[q.pixelRatio=127]="pixelRatio",q[q.tabFocusMode=128]="tabFocusMode",q[q.layoutInfo=129]="layoutInfo",q[q.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(141,null)})),acceptSuggestionOnEnter:ye(new l(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(142,null),""],markdownDescription:c.localize(143,null)})),accessibilitySupport:ye(new a),accessibilityPageSize:ye(new d(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(144,null)})),ariaLabel:ye(new D(4,"ariaLabel",c.localize(145,null))),autoClosingBrackets:ye(new l(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(146,null),c.localize(147,null),""],description:c.localize(148,null)})),autoClosingDelete:ye(new l(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(149,null),""],description:c.localize(150,null)})),autoClosingOvertype:ye(new l(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(151,null),""],description:c.localize(152,null)})),autoClosingQuotes:ye(new l(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(153,null),c.localize(154,null),""],description:c.localize(155,null)})),autoIndent:ye(new h(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(156,null),c.localize(157,null),c.localize(158,null),c.localize(159,null),c.localize(160,null)],description:c.localize(161,null)})),automaticLayout:ye(new m(10,"automaticLayout",!1)),autoSurround:ye(new l(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(162,null),c.localize(163,null),c.localize(164,null),""],description:c.localize(165,null)})),bracketPairColorization:ye(new K),bracketPairGuides:ye(new J),stickyTabStops:ye(new m(103,"stickyTabStops",!1,{description:c.localize(166,null)})),codeLens:ye(new m(14,"codeLens",!0,{description:c.localize(167,null)})),codeLensFontFamily:ye(new D(15,"codeLensFontFamily","",{description:c.localize(168,null)})),codeLensFontSize:ye(new d(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(169,null)})),colorDecorators:ye(new m(17,"colorDecorators",!0,{description:c.localize(170,null)})),columnSelection:ye(new m(18,"columnSelection",!1,{description:c.localize(171,null)})),comments:ye(new P),contextmenu:ye(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new m(21,"copyWithSyntaxHighlighting",!0,{description:c.localize(172,null)})),cursorBlinking:ye(new h(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:c.localize(173,null)})),cursorSmoothCaretAnimation:ye(new m(23,"cursorSmoothCaretAnimation",!1,{description:c.localize(174,null)})),cursorStyle:ye(new h(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],s,{description:c.localize(175,null)})),cursorSurroundingLines:ye(new d(25,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(176,null)})),cursorSurroundingLinesStyle:ye(new l(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(177,null),c.localize(178,null)],description:c.localize(179,null)})),cursorWidth:ye(new d(27,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(180,null)})),disableLayerHinting:ye(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new m(30,"domReadOnly",!1)),dragAndDrop:ye(new m(31,"dragAndDrop",!0,{description:c.localize(181,null)})),emptySelectionClipboard:ye(new u),extraEditorClassName:ye(new D(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new p(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:c.localize(182,null)})),find:ye(new E),fixedOverflowWidgets:ye(new m(36,"fixedOverflowWidgets",!1)),folding:ye(new m(37,"folding",!0,{description:c.localize(183,null)})),foldingStrategy:ye(new l(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(184,null),c.localize(185,null)],description:c.localize(186,null)})),foldingHighlight:ye(new m(39,"foldingHighlight",!0,{description:c.localize(187,null)})),foldingImportsByDefault:ye(new m(40,"foldingImportsByDefault",!1,{description:c.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new m(41,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(189,null)})),fontFamily:ye(new D(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(190,null)})),fontInfo:ye(new I),fontLigatures2:ye(new A),fontSize:ye(new B),fontWeight:ye(new O),formatOnPaste:ye(new m(47,"formatOnPaste",!1,{description:c.localize(191,null)})),formatOnType:ye(new m(48,"formatOnType",!1,{description:c.localize(192,null)})),glyphMargin:ye(new m(49,"glyphMargin",!0,{description:c.localize(193,null)})),gotoLocation:ye(new S),hideCursorInOverviewRuler:ye(new m(51,"hideCursorInOverviewRuler",!1,{description:c.localize(194,null)})),hover:ye(new x),inDiffEditor:ye(new m(53,"inDiffEditor",!1)),letterSpacing:ye(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>p.clamp(q,-5,20),{description:c.localize(195,null)})),lightbulb:ye(new $),lineDecorationsWidth:ye(new _(57,"lineDecorationsWidth",10)),lineHeight:ye(new ee),lineNumbers:ye(new Oe),lineNumbersMinChars:ye(new d(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new m(61,"linkedEditing",!1,{description:c.localize(196,null)})),links:ye(new m(62,"links",!0,{description:c.localize(197,null)})),matchBrackets:ye(new l(63,"matchBrackets","always",["always","near","never"],{description:c.localize(198,null)})),minimap:ye(new j),mouseStyle:ye(new l(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new p(66,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:c.localize(199,null)})),mouseWheelZoom:ye(new m(67,"mouseWheelZoom",!1,{markdownDescription:c.localize(200,null)})),multiCursorMergeOverlapping:ye(new m(68,"multiCursorMergeOverlapping",!0,{description:c.localize(201,null)})),multiCursorModifier:ye(new h(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[c.localize(202,null),c.localize(203,null)],markdownDescription:c.localize(204,null)})),multiCursorPaste:ye(new l(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(205,null),c.localize(206,null)],markdownDescription:c.localize(207,null)})),occurrencesHighlight:ye(new m(71,"occurrencesHighlight",!0,{description:c.localize(208,null)})),overviewRulerBorder:ye(new m(72,"overviewRulerBorder",!0,{description:c.localize(209,null)})),overviewRulerLanes:ye(new d(73,"overviewRulerLanes",3,0,3)),padding:ye(new ce),parameterHints:ye(new ve),peekWidgetDefaultFocus:ye(new l(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(210,null),c.localize(211,null)],description:c.localize(212,null)})),definitionLinkOpensInPeek:ye(new m(77,"definitionLinkOpensInPeek",!1,{description:c.localize(213,null)})),quickSuggestions:ye(new Fe),quickSuggestionsDelay:ye(new d(79,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(214,null)})),readOnly:ye(new m(80,"readOnly",!1)),renameOnType:ye(new m(81,"renameOnType",!1,{description:c.localize(215,null),markdownDeprecationMessage:c.localize(216,null)})),renderControlCharacters:ye(new m(82,"renderControlCharacters",!0,{description:c.localize(217,null),restricted:!0})),renderFinalNewline:ye(new m(83,"renderFinalNewline",!0,{description:c.localize(218,null)})),renderLineHighlight:ye(new l(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(219,null)],description:c.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(221,null)})),renderValidationDecorations:ye(new l(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new l(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(222,null),c.localize(223,null),c.localize(224,null),""],description:c.localize(225,null)})),revealHorizontalRightPadding:ye(new d(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new m(89,"roundedSelection",!0,{description:c.localize(226,null)})),rulers:ye(new Xe),scrollbar:ye(new Qe),scrollBeyondLastColumn:ye(new d(92,"scrollBeyondLastColumn",5,0,1073741824,{description:c.localize(227,null)})),scrollBeyondLastLine:ye(new m(93,"scrollBeyondLastLine",!0,{description:c.localize(228,null)})),scrollPredominantAxis:ye(new m(94,"scrollPredominantAxis",!0,{description:c.localize(229,null)})),selectionClipboard:ye(new m(95,"selectionClipboard",!0,{description:c.localize(230,null),included:M.isLinux})),selectionHighlight:ye(new m(96,"selectionHighlight",!0,{description:c.localize(231,null)})),selectOnLineNumbers:ye(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new l(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[c.localize(232,null),c.localize(233,null)],description:c.localize(234,null)})),showUnused:ye(new m(99,"showUnused",!0,{description:c.localize(235,null)})),showDeprecated:ye(new m(124,"showDeprecated",!0,{description:c.localize(236,null)})),inlayHints:ye(new z),snippetSuggestions:ye(new l(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(237,null),c.localize(238,null),c.localize(239,null),c.localize(240,null)],description:c.localize(241,null)})),smartSelect:ye(new ie),smoothScrolling:ye(new m(102,"smoothScrolling",!1,{description:c.localize(242,null)})),stopRenderingLineAfter:ye(new d(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new G),inlineSuggest:ye(new H),suggestFontSize:ye(new d(106,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(243,null)})),suggestLineHeight:ye(new d(107,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(244,null)})),suggestOnTriggerCharacters:ye(new m(108,"suggestOnTriggerCharacters",!0,{description:c.localize(245,null)})),suggestSelection:ye(new l(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(246,null),c.localize(247,null),c.localize(248,null)],description:c.localize(249,null)})),tabCompletion:ye(new l(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(250,null),c.localize(251,null),c.localize(252,null)],description:c.localize(253,null)})),tabIndex:ye(new d(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new l(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(254,null),c.localize(255,null),c.localize(256,null)],description:c.localize(257,null)})),useShadowDOM:ye(new m(113,"useShadowDOM",!0)),useTabStops:ye(new m(114,"useTabStops",!0,{description:c.localize(258,null)})),wordSeparators:ye(new D(115,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:c.localize(259,null)})),wordWrap:ye(new l(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(260,null),c.localize(261,null),c.localize(262,null),c.localize(263,null)],description:c.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new D(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new D(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new d(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(265,null)})),wordWrapOverride1:ye(new l(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new l(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new h(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ne,{enumDescriptions:[c.localize(266,null),c.localize(267,null),c.localize(268,null),c.localize(269,null)],description:c.localize(270,null)})),wrappingStrategy:ye(new l(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[c.localize(271,null),c.localize(272,null)],description:c.localize(273,null)})),editorClassName:ye(new b),pixelRatio:ye(new ue),tabFocusMode:ye(new de),layoutInfo:ye(new V),wrappingInfo:ye(new ze)}}),define(we[119],Ee([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[120],Ee([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[121],Ee([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(we[122],Ee([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(we[123],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[124],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[125],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(we[126],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[127],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[128],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[129],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[130],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(we[131],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[132],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[133],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[134],Ee([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[135],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var c;(function(t){t[t.ACTIVATE=1]="ACTIVATE",t[t.RESTORE=2]="RESTORE",t[t.PRESERVE=3]="PRESERVE"})(c=e.EditorActivation||(e.EditorActivation={}));var M;(function(t){t[t.PICK=0]="PICK",t[t.DISABLED=1]="DISABLED",t[t.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var w;(function(t){t[t.API=0]="API",t[t.USER=1]="USER"})(w=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(t){t[t.Center=0]="Center",t[t.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",t[t.NearTop=2]="NearTop",t[t.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[136],Ee([0,1,120]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function T(r){return r=r.trim(),r==="*"||M.test(r)}e.isValidVersionStr=T;function t(r){if(!T(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=r.match(M);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=t;function R(r){if(!r)return null;let m=r.majorBase,o=r.majorMustEqual,d=r.minorBase,p=r.minorMustEqual,D=r.patchBase,f=r.patchMustEqual;r.hasCaret&&(m===0||(p=!1),f=!1);let l=0;if(r.preRelease){const h=w.exec(r.preRelease);if(h){const[,y,a,P]=h;l=Date.UTC(Number(y),Number(a)-1,Number(P))}}return{majorBase:m,majorMustEqual:o,minorBase:d,minorMustEqual:p,patchBase:D,patchMustEqual:f,isMinimum:r.hasGreaterEquals,notBefore:l}}e.normalizeVersion=R;function C(r,m,o){let d;typeof r=="string"?d=R(t(r)):d=r;let p;m instanceof Date?p=m.getTime():typeof m=="string"&&(p=new Date(m).getTime());let D;if(typeof o=="string"?D=R(t(o)):D=o,!d||!D)return!1;let f=d.majorBase,l=d.minorBase,h=d.patchBase,y=D.majorBase,a=D.minorBase,P=D.patchBase,n=D.notBefore,i=D.majorMustEqual,v=D.minorMustEqual,g=D.patchMustEqual;return D.isMinimum?f>y?!0:f<y?!1:l>a?!0:l<a||p&&p<n?!1:h>=P:(f===1&&y===0&&(!i||!v||!g)&&(y=1,a=0,P=0,i=!0,v=!1,g=!1),f<y?!1:f>y?!i:l<a?!1:l>a?!v:h<P?!1:h>P?!g:!(p&&p<n))}e.isValidVersion=C;function k(r,m,o,d){return o.isBuiltin||typeof o.main=="undefined"?!0:_(r,m,o.engines.vscode,d)}e.isValidExtensionVersion=k;function F(r,m,o){return r==="*"||_(m,o,r)}e.isEngineValid=F;function _(r,m,o,d=[]){let p=R(t(o));if(!p)return d.push(c.localize(0,null,o)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return d.push(c.localize(1,null,o)),!1}else if(!p.majorMustEqual)return d.push(c.localize(2,null,o)),!1;return C(r,m,p)?!0:(d.push(c.localize(3,null,r,o)),!1)}}),define(we[82],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class c{constructor(w,T=[],t=!1){this.ctor=w,this.staticArguments=T,this.supportsDelayedInstantiation=t}}e.SyncDescriptor=c}),define(we[57],Ee([0,1,82]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function w(t,R,C){R instanceof c.SyncDescriptor||(R=new c.SyncDescriptor(R,[],C)),M.push([t,R])}e.registerSingleton=w;function T(){return M}e.getSingletonServiceDescriptors=T}),define(we[137],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class c{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=c;class M{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let t of this._nodes.values())t.outgoing.size===0&&T.push(t);return T}insertEdge(T,t){const R=this.lookupOrInsertNode(T),C=this.lookupOrInsertNode(t);R.outgoing.set(this._hashFn(t),C),C.incoming.set(this._hashFn(T),R)}removeNode(T){const t=this._hashFn(T);this._nodes.delete(t);for(let R of this._nodes.values())R.outgoing.delete(t),R.incoming.delete(t)}lookupOrInsertNode(T){const t=this._hashFn(T);let R=this._nodes.get(t);return R||(R=new c(T),this._nodes.set(t,R)),R}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[t,R]of this._nodes)T.push(`${t}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,t]of this._nodes){const R=new Set([T]),C=this._findCycle(t,R);if(C)return C}}_findCycle(T,t){for(let[R,C]of T.outgoing){if(t.has(R))return[...t,R].join(" -> ");t.add(R);const k=this._findCycle(C,t);if(k)return k;t.delete(R)}}}e.Graph=M}),define(we[4],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var c;(function(t){t.serviceIds=new Map,t.DI_TARGET="$di$target",t.DI_DEPENDENCIES="$di$dependencies";function R(C){return C[t.DI_DEPENDENCIES]||[]}t.getServiceDependencies=R})(c=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function M(t,R,C,k){R[c.DI_TARGET]===R?R[c.DI_DEPENDENCIES].push({id:t,index:C,optional:k}):(R[c.DI_DEPENDENCIES]=[{id:t,index:C,optional:k}],R[c.DI_TARGET]=R)}function w(t){if(c.serviceIds.has(t))return c.serviceIds.get(t);const R=function(C,k,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(R,C,F,!1)};return R.toString=()=>t,c.serviceIds.set(t,R),R}e.createDecorator=w;function T(t){return t}e.refineServiceDecorator=T}),define(we[138],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,c.createDecorator)("modelService");function M(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(we[139],Ee([0,1,3,58,7,21,76,56,138]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(k):!!d.exclusive}class F{constructor(){this._clock=0,this._entries=[],this._onDidChange=new c.Emitter}get onDidChange(){return this._onDidChange.event}register(p,D){let f={selector:p,provider:D,_score:-1,_time:this._clock++};return this._entries.push(f),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,w.toDisposable)(()=>{if(f){let l=this._entries.indexOf(f);l>=0&&(this._entries.splice(l,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),f=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const D=[];for(let f of this._entries)f._score>0&&D.push(f.provider);return D}ordered(p){const D=[];return this._orderedForEach(p,f=>D.push(f.provider)),D}orderedGroups(p){const D=[];let f,l;return this._orderedForEach(p,h=>{f&&l===h._score?f.push(h.provider):(l=h._score,f=[h.provider],D.push(f))}),D}_orderedForEach(p,D){if(!!p){this._updateScores(p);for(const f of this._entries)f._score>0&&D(f)}}_updateScores(p){let D={uri:p.uri.toString(),language:p.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===D.language&&this._lastCandidate.uri===D.uri)){this._lastCandidate=D;for(let f of this._entries)if(f._score=(0,R.score)(f.selector,p.uri,p.getLanguageId(),(0,C.shouldSynchronizeModel)(p)),k(f.selector)&&f._score>0){for(let l of this._entries)l._score=0;f._score=1e3;break}this._entries.sort(F._compareByScoreAndTime)}}static _compareByScoreAndTime(p,D){return p._score<D._score?1:p._score>D._score?-1:p._time<D._time?1:p._time>D._time?-1:0}}e.LanguageFeatureRegistry=F;const _=new WeakMap;let r=0;function m(d){let p=_.get(d);return p===void 0&&(p=++r,_.set(d,p)),p}class o{constructor(p,D,f=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=D,this.max=f,this._cache=new T.LRUCache(50,.7)}_key(p){return p.id+this._registry.all(p).reduce((D,f)=>(0,M.doHash)(m(f),D),0)}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const D=this._key(p),f=this._cache.get(D);return this._clamp(f?.value)}update(p,D){const f=this._key(p);let l=this._cache.get(f);return l||(l=new t.MovingAverage,this._cache.set(f,l)),l.update(D),this.get(p)}}e.LanguageFeatureRequestDelays=o}),define(we[59],Ee([0,1,2,43,139,112,54]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var R;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(R=e.LanguageId||(e.LanguageId={}));var C;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var k;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(k=e.ColorId||(e.ColorId={}));var F;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(F=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class r{static getLanguageId(E){return(E&255)>>>0}static getTokenType(E){return(E&1792)>>>8}static getFontStyle(E){return(E&14336)>>>11}static getForeground(E){return(E&8372224)>>>14}static getBackground(E){return(E&4286578688)>>>23}static getClassNameFromMetadata(E){let A=this.getForeground(E),I="mtk"+A,B=this.getFontStyle(E);return B&1&&(I+=" mtki"),B&2&&(I+=" mtkb"),B&4&&(I+=" mtku"),I}static getInlineStyleFromMetadata(E,A){const I=this.getForeground(E),B=this.getFontStyle(E);let O=`color: ${A[I]};`;return B&1&&(O+="font-style: italic;"),B&2&&(O+="font-weight: bold;"),B&4&&(O+="text-decoration: underline;"),O}}e.TokenMetadata=r;var m;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(E){const A=u[E];let I=A&&t.iconRegistry.get(A);return I||(console.info("No codicon found for CompletionItemKind "+E),I=t.Codicon.symbolProperty),I.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(E,A){let I=u[E];return typeof I=="undefined"&&!A&&(I=9),I}}();var o;(function(u){u[u.Deprecated=1]="Deprecated"})(o=e.CompletionItemTag||(e.CompletionItemTag={}));var d;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(d=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var D;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(D=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function y(u){return u&&c.URI.isUri(u.uri)&&M.Range.isIRange(u.range)&&(M.Range.isIRange(u.originSelectionRange)||M.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=y;var a;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(a=e.SymbolKind||(e.SymbolKind={}));var P;(function(u){u[u.Deprecated=1]="Deprecated"})(P=e.SymbolTag||(e.SymbolTag={}));var n;(function(u){const E=new Map;E.set("file",0),E.set("module",1),E.set("namespace",2),E.set("package",3),E.set("class",4),E.set("method",5),E.set("property",6),E.set("field",7),E.set("constructor",8),E.set("enum",9),E.set("interface",10),E.set("function",11),E.set("variable",12),E.set("constant",13),E.set("string",14),E.set("number",15),E.set("boolean",16),E.set("array",17),E.set("object",18),E.set("key",19),E.set("null",20),E.set("enum-member",21),E.set("struct",22),E.set("event",23),E.set("operator",24),E.set("type-parameter",25);const A=new Map;A.set(0,"file"),A.set(1,"module"),A.set(2,"namespace"),A.set(3,"package"),A.set(4,"class"),A.set(5,"method"),A.set(6,"property"),A.set(7,"field"),A.set(8,"constructor"),A.set(9,"enum"),A.set(10,"interface"),A.set(11,"function"),A.set(12,"variable"),A.set(13,"constant"),A.set(14,"string"),A.set(15,"number"),A.set(16,"boolean"),A.set(17,"array"),A.set(18,"object"),A.set(19,"key"),A.set(20,"null"),A.set(21,"enum-member"),A.set(22,"struct"),A.set(23,"event"),A.set(24,"operator"),A.set(25,"type-parameter");function I(S){return E.get(S)}u.fromString=I;function B(S){return A.get(S)}u.toString=B;function O(S,x){const N=A.get(S);let V=N&&t.iconRegistry.get("symbol-"+N);return V||(console.info("No codicon found for SymbolKind "+S),V=t.Codicon.symbolProperty),`${x?"inline":"block"} ${V.classNames}`}u.toCssClassName=O})(n=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(E){this.value=E}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var v;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var g;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(g=e.CommentMode||(e.CommentMode={}));var s;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(s=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new w.LanguageFeatureRegistry,e.RenameProviderRegistry=new w.LanguageFeatureRegistry,e.CompletionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new w.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new w.LanguageFeatureRegistry,e.HoverProviderRegistry=new w.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new w.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new w.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new w.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new w.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new w.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.LinkProviderRegistry=new w.LanguageFeatureRegistry,e.ColorProviderRegistry=new w.LanguageFeatureRegistry,e.SelectionRangeRegistry=new w.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var b;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[45],Ee([0,1,24,9,4]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=c.userAgent||"";const t=new Map;t.set("false",!1),t.set("true",!0),t.set("isMac",c.isMacintosh),t.set("isLinux",c.isLinux),t.set("isWindows",c.isWindows),t.set("isWeb",c.isWeb),t.set("isMacNative",c.isMacintosh&&!c.isWeb),t.set("isEdge",T.indexOf("Edg/")>=0),t.set("isFirefox",T.indexOf("Firefox")>=0),t.set("isChrome",T.indexOf("Chrome")>=0),t.set("isSafari",T.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var C;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return r.INSTANCE}static true(){return m.INSTANCE}static has(S){return o.create(S)}static equals(S,x){return d.create(S,x)}static notEquals(S,x){return f.create(S,x)}static regex(S,x){return i.create(S,x)}static in(S,x){return p.create(S,x)}static not(S){return l.create(S)}static and(...S){return s.create(S,null)}static or(...S){return b.create(S,null,!0)}static greater(S,x){return y.create(S,x)}static greaterEquals(S,x){return a.create(S,x)}static smaller(S,x){return P.create(S,x)}static smallerEquals(S,x){return n.create(S,x)}static deserialize(S,x=!1){if(!!S)return this._deserializeOrExpression(S,x)}static _deserializeOrExpression(S,x){let N=S.split("||");return b.create(N.map(V=>this._deserializeAndExpression(V,x)),null,!0)}static _deserializeAndExpression(S,x){let N=S.split("&&");return s.create(N.map(V=>this._deserializeOne(V,x)),null)}static _deserializeOne(S,x){if(S=S.trim(),S.indexOf("!=")>=0){let N=S.split("!=");return f.create(N[0].trim(),this._deserializeValue(N[1],x))}if(S.indexOf("==")>=0){let N=S.split("==");return d.create(N[0].trim(),this._deserializeValue(N[1],x))}if(S.indexOf("=~")>=0){let N=S.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],x))}if(S.indexOf(" in ")>=0){let N=S.split(" in ");return p.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(S)){const N=S.split(">=");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(S)){const N=S.split(">");return y.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(S)){const N=S.split("<=");return n.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(S)){const N=S.split("<");return P.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(S)?l.create(S.substr(1).trim()):o.create(S)}static _deserializeValue(S,x){if(S=S.trim(),S==="true")return!0;if(S==="false")return!1;let N=/^'([^']*)'$/.exec(S);return N?N[1].trim():S}static _deserializeRegexValue(S,x){if((0,M.isFalsyOrWhitespace)(S)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=S.indexOf("/"),V=S.lastIndexOf("/");if(N===V||N<0){if(x)throw new Error(`bad regexp-value '${S}', missing /-enclosure`);return console.warn(`bad regexp-value '${S}', missing /-enclosure`),null}let $=S.slice(N+1,V),z=S[V+1]==="i"?"i":"";try{return new RegExp($,z)}catch(ee){if(x)throw new Error(`bad regexp-value '${S}', parse error: ${ee}`);return console.warn(`bad regexp-value '${S}', parse error: ${ee}`),null}}}e.ContextKeyExpr=k;function F(O,S){const x=O?O.substituteConstants():void 0,N=S?S.substituteConstants():void 0;return!x&&!N?!0:!x||!N?!1:x.equals(N)}e.expressionsAreEqualWithConstantSubstitution=F;function _(O,S){return O.cmp(S)}class r{constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=r,r.INSTANCE=new r;class m{constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return r.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class o{constructor(S,x){this.key=S,this.negated=x,this.type=2}static create(S,x=null){const N=t.get(S);return typeof N=="boolean"?N?m.INSTANCE:r.INSTANCE:new o(S,x)}cmp(S){return S.type!==this.type?this.type-S.type:E(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=t.get(this.key);return typeof S=="boolean"?S?m.INSTANCE:r.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class d{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=4}static create(S,x,N=null){if(typeof x=="boolean")return x?o.create(S,N):l.create(S,N);const V=t.get(S);return typeof V=="boolean"?x===(V?"true":"false")?m.INSTANCE:r.INSTANCE:new d(S,x,N)}cmp(S){return S.type!==this.type?this.type-S.type:A(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=t.get(this.key);if(typeof S=="boolean"){const x=S?"true":"false";return this.value===x?m.INSTANCE:r.INSTANCE}return this}evaluate(S){return S.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(S){return S.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class p{constructor(S,x){this.key=S,this.valueKey=x,this.type=10,this.negated=null}static create(S,x){return new p(S,x)}cmp(S){return S.type!==this.type?this.type-S.type:A(this.key,this.valueKey,S.key,S.valueKey)}equals(S){return S.type===this.type?this.key===S.key&&this.valueKey===S.valueKey:!1}substituteConstants(){return this}evaluate(S){const x=S.getValue(this.valueKey),N=S.getValue(this.key);return Array.isArray(x)?x.indexOf(N)>=0:typeof N=="string"&&typeof x=="object"&&x!==null?R.call(x,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(S){return S.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=p;class D{constructor(S){this._actual=S,this.type=11}static create(S){return new D(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}substituteConstants(){return this}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new D(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class f{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=5}static create(S,x,N=null){if(typeof x=="boolean")return x?l.create(S,N):o.create(S,N);const V=t.get(S);return typeof V=="boolean"?x===(V?"true":"false")?r.INSTANCE:m.INSTANCE:new f(S,x,N)}cmp(S){return S.type!==this.type?this.type-S.type:A(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=t.get(this.key);if(typeof S=="boolean"){const x=S?"true":"false";return this.value===x?r.INSTANCE:m.INSTANCE}return this}evaluate(S){return S.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(S){return S.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=f;class l{constructor(S,x){this.key=S,this.negated=x,this.type=3}static create(S,x=null){const N=t.get(S);return typeof N=="boolean"?N?r.INSTANCE:m.INSTANCE:new l(S,x)}cmp(S){return S.type!==this.type?this.type-S.type:E(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=t.get(this.key);return typeof S=="boolean"?S?r.INSTANCE:m.INSTANCE:this}evaluate(S){return!S.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(S){return S.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=l;function h(O,S){if(typeof O=="string"){const x=parseFloat(O);isNaN(x)||(O=x)}return typeof O=="string"||typeof O=="number"?S(O):r.INSTANCE}class y{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=12}static create(S,x,N=null){return h(x,V=>new y(S,V,N))}cmp(S){return S.type!==this.type?this.type-S.type:A(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=y;class a{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=13}static create(S,x,N=null){return h(x,V=>new a(S,V,N))}cmp(S){return S.type!==this.type?this.type-S.type:A(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class P{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=14}static create(S,x,N=null){return h(x,V=>new P(S,V,N))}cmp(S){return S.type!==this.type?this.type-S.type:A(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=P;class n{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=15}static create(S,x,N=null){return h(x,V=>new n(S,V,N))}cmp(S){return S.type!==this.type?this.type-S.type:A(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class i{constructor(S,x){this.key=S,this.regexp=x,this.type=7,this.negated=null}static create(S,x){return new i(S,x)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.key<S.key)return-1;if(this.key>S.key)return 1;const x=this.regexp?this.regexp.source:"",N=S.regexp?S.regexp.source:"";return x<N?-1:x>N?1:0}equals(S){if(S.type===this.type){const x=this.regexp?this.regexp.source:"",N=S.regexp?S.regexp.source:"";return this.key===S.key&&x===N}return!1}substituteConstants(){return this}evaluate(S){let x=S.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const S=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${S}`}keys(){return[this.key]}map(S){return S.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class v{constructor(S){this._actual=S,this.type=8}static create(S){return new v(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}substituteConstants(){return this}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new v(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=v;function g(O){let S=null;for(let x=0,N=O.length;x<N;x++){const V=O[x].substituteConstants();if(O[x]!==V&&S===null){S=[];for(let $=0;$<x;$++)S[$]=O[$]}S!==null&&(S[x]=V)}return S===null?O:S}class s{constructor(S,x){this.expr=S,this.negated=x,this.type=6}static create(S,x){return s._normalizeArr(S,x)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=_(this.expr[x],S.expr[x]);if(V!==0)return V}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(S.expr[x]))return!1;return!0}return!1}substituteConstants(){const S=g(this.expr);return S===this.expr?this:s.create(S,this.negated)}evaluate(S){for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].evaluate(S))return!1;return!0}static _normalizeArr(S,x){const N=[];let V=!1;for(const $ of S)if(!!$){if($.type===1){V=!0;continue}if($.type===0)return r.INSTANCE;if($.type===6){N.push(...$.expr);continue}N.push($)}if(N.length===0&&V)return m.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(_);for(let $=1;$<N.length;$++)N[$-1].equals(N[$])&&(N.splice($,1),$--);if(N.length===1)return N[0];for(;N.length>1;){const $=N[N.length-1];if($.type!==9)break;N.pop();const z=N.pop(),ee=N.length===0,j=b.create($.expr.map(Q=>s.create([Q,z],null)),null,ee);j&&(N.push(j),N.sort(_))}return N.length===1?N[0]:new s(N,x)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(let x of this.expr)S.push(...x.keys());return S}map(S){return new s(this.expr.map(x=>x.map(S)),null)}negate(){if(!this.negated){const S=[];for(let x of this.expr)S.push(x.negate());this.negated=b.create(S,this,!0)}return this.negated}}class b{constructor(S,x){this.expr=S,this.negated=x,this.type=9}static create(S,x,N){return b._normalizeArr(S,x,N)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=_(this.expr[x],S.expr[x]);if(V!==0)return V}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(S.expr[x]))return!1;return!0}return!1}substituteConstants(){const S=g(this.expr);return S===this.expr?this:b.create(S,this.negated,!1)}evaluate(S){for(let x=0,N=this.expr.length;x<N;x++)if(this.expr[x].evaluate(S))return!0;return!1}static _normalizeArr(S,x,N){let V=[],$=!1;if(S){for(let z=0,ee=S.length;z<ee;z++){const j=S[z];if(!!j){if(j.type===0){$=!0;continue}if(j.type===1)return m.INSTANCE;if(j.type===9){V=V.concat(j.expr);continue}V.push(j)}}if(V.length===0&&$)return r.INSTANCE;V.sort(_)}if(V.length!==0){if(V.length===1)return V[0];for(let z=1;z<V.length;z++)V[z-1].equals(V[z])&&(V.splice(z,1),z--);if(V.length===1)return V[0];if(N){for(let z=0;z<V.length;z++)for(let ee=z+1;ee<V.length;ee++)I(V[z],V[ee])&&(V.splice(ee,1),ee--);if(V.length===1)return V[0]}return new b(V,x)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(let x of this.expr)S.push(...x.keys());return S}map(S){return new b(this.expr.map(x=>x.map(S)),null)}negate(){if(!this.negated){let S=[];for(let x of this.expr)S.push(x.negate());for(;S.length>1;){const x=S.shift(),N=S.shift(),V=[];for(const z of B(x))for(const ee of B(N))V.push(s.create([z,ee],null));const $=S.length===0;S.unshift(b.create(V,null,$))}this.negated=S[0]}return this.negated}}class u extends o{constructor(S,x,N){super(S,null);this._defaultValue=x,typeof N=="object"?u._info.push({...N,key:S}):N!==!0&&u._info.push({key:S,description:N,type:x!=null?typeof x:void 0})}static all(){return u._info.values()}bindTo(S){return S.createKey(this.key,this._defaultValue)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return d.create(this.key,S)}notEqualsTo(S){return f.create(this.key,S)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(O,S){return O<S?-1:O>S?1:0}function A(O,S,x,N){return O<x?-1:O>x?1:S<N?-1:S>N?1:0}function I(O,S){if(S.type===6&&O.type!==9&&O.type!==6){for(const V of S.expr)if(O.equals(V))return!0}const x=O.negate(),N=B(x).concat(B(S));N.sort(_);for(let V=0;V<N.length;V++){const z=N[V].negate();for(let ee=V+1;ee<N.length;ee++){const j=N[ee];if(z.equals(j))return!0}}return!1}e.implies=I;function B(O){return O.type===9?O.expr:[O]}}),define(we[140],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,c.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,c.refineServiceDecorator)(e.IEnvironmentService)}),define(we[46],Ee([0,1,21,17,9,10,2,121,4]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function k(N){return N.create===!0}e.isFileOpenForWriteOptions=k;var F;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var r;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(r=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function o(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=o;function d(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function p(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=p;var D;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(V,$){super(V);this.code=$}}e.FileSystemProviderError=f;function l(N,V){const $=new f(N.toString(),V);return y($,V),$}e.createFileSystemProviderError=l;function h(N){return N||l((0,R.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=h;function y(N,V){return N.name=V?`${V} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=y;function a(N){if(!N)return D.Unknown;if(N instanceof f)return N.code;const V=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!V)return D.Unknown;switch(V[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=a;function P(N){if(N instanceof b)return N.fileOperationResult;switch(a(N)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=P;var n;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class i{constructor(V,$,z){this.resource=V,this.operation=$,this.target=z}isOperation(V){return this.operation===V}}e.FileOperationEvent=i;var v;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(v=e.FileChangeType||(e.FileChangeType={}));class g{constructor(V,$){this.added=void 0,this.updated=void 0,this.deleted=void 0;const z=new Map;for(const ee of V){const j=z.get(ee.type);j?j.push([ee.resource,ee]):z.set(ee.type,[[ee.resource,ee]])}for(const[ee,j]of z)switch(ee){case 1:this.added=c.TernarySearchTree.forUris(()=>$),this.added.fill(j);break;case 0:this.updated=c.TernarySearchTree.forUris(()=>$),this.updated.fill(j);break;case 2:this.deleted=c.TernarySearchTree.forUris(()=>$),this.deleted.fill(j);break}}contains(V,...$){return this.doContains(V,{includeChildren:!1},...$)}affects(V,...$){return this.doContains(V,{includeChildren:!0},...$)}doContains(V,$,...z){if(!V)return!1;const ee=z.length>0;return!!((!ee||z.includes(1))&&(this.added?.get(V)||$.includeChildren&&this.added?.findSuperstr(V))||(!ee||z.includes(0))&&(this.updated?.get(V)||$.includeChildren&&this.updated?.findSuperstr(V))||(!ee||z.includes(2))&&(this.deleted?.findSubstr(V)||$.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=g;function s(N,V,$){return!N||!V||N===V||V.length>N.length?!1:(V.charAt(V.length-1)!==M.sep&&(V+=M.sep),$?(0,w.startsWithIgnoreCase)(N,V):N.indexOf(V)===0)}e.isParent=s;class b extends Error{constructor(V,$,z){super(V);this.fileOperationResult=$,this.options=z}}e.FileOperationError=b;class u extends b{constructor(V,$,z){super(V,2,z);this.stat=$}}e.NotModifiedSinceFileOperationError=u;var E;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(E=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function I(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=I;async function B(N,V){if(!V.hasProvider(t.URI.from({scheme:N.scheme})))return new Promise($=>{const z=V.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===N.scheme&&ee.added&&(z.dispose(),$())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(V){return(0,T.isNumber)(V)||(V=0),V<O.KB?(0,R.localize)(1,null,V.toFixed(0)):V<O.MB?(0,R.localize)(2,null,(V/O.KB).toFixed(2)):V<O.GB?(0,R.localize)(3,null,(V/O.MB).toFixed(2)):V<O.TB?(0,R.localize)(4,null,(V/O.GB).toFixed(2)):(0,R.localize)(5,null,(V/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var S;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(S=e.Arch||(e.Arch={}));function x(N){return{maxFileSize:N===0?300*O.MB:16*O.GB,maxHeapSize:N===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=x}),define(we[60],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class c{constructor(...w){this._entries=new Map;for(let[T,t]of w)this.set(T,t)}set(w,T){const t=this._entries.get(w);return this._entries.set(w,T),t}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=c}),define(we[141],Ee([0,1,14,15,82,137,4,60]),function(re,e,c,M,w,T,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class k extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class F{constructor(o=new R.ServiceCollection,d=!1,p){this._activeInstantiations=new Set,this._services=o,this._strict=d,this._parent=p,this._services.set(t.IInstantiationService,this)}createChild(o){return new F(o,this._strict,this)}invokeFunction(o,...d){let p=r.traceInvocation(o),D=!1;try{return o({get:l=>{if(D)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(l,p);if(!h)throw new Error(`[invokeFunction] unknown service '${l}'`);return h}},...d)}finally{D=!0,p.stop()}}createInstance(o,...d){let p,D;return o instanceof w.SyncDescriptor?(p=r.traceCreation(o.ctor),D=this._createInstance(o.ctor,o.staticArguments.concat(d),p)):(p=r.traceCreation(o),D=this._createInstance(o,d,p)),p.stop(),D}_createInstance(o,d=[],p){let D=t._util.getServiceDependencies(o).sort((h,y)=>h.index-y.index),f=[];for(const h of D){let y=this._getOrCreateServiceInstance(h.id,p);if(!y&&this._strict&&!h.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${h.id}.`);f.push(y)}let l=D.length>0?D[0].index:d.length;if(d.length!==l){console.warn(`[createInstance] First service dependency of ${o.name} at position ${l+1} conflicts with ${d.length} static arguments`);let h=l-d.length;h>0?d=d.concat(new Array(h)):d=d.slice(0,l)}return new o(...[...d,...f])}_setServiceInstance(o,d){if(this._services.get(o)instanceof w.SyncDescriptor)this._services.set(o,d);else if(this._parent)this._parent._setServiceInstance(o,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let d=this._services.get(o);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):d}_getOrCreateServiceInstance(o,d){let p=this._getServiceInstanceOrDescriptor(o);return p instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,p,d.branch(o,!0)):(d.branch(o,!1),p)}_safeCreateAndCacheServiceInstance(o,d,p){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,d,p)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,d,p){const D=new T.Graph(h=>h.id.toString());let f=0;const l=[{id:o,desc:d,_trace:p}];for(;l.length;){const h=l.pop();if(D.lookupOrInsertNode(h),f++>1e3)throw new k(D);for(let y of t._util.getServiceDependencies(h.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(y.id);if(!a&&!y.optional&&console.warn(`[createInstance] ${o} depends on ${y.id} which is NOT registered.`),a instanceof w.SyncDescriptor){const P={id:y.id,desc:a,_trace:h._trace.branch(y.id,!0)};D.insertEdge(h,P),l.push(P)}}}for(;;){const h=D.roots();if(h.length===0){if(!D.isEmpty())throw new k(D);break}for(const{data:y}of h){if(this._getServiceInstanceOrDescriptor(y.id)instanceof w.SyncDescriptor){const P=this._createServiceInstanceWithOwner(y.id,y.desc.ctor,y.desc.staticArguments,y.desc.supportsDelayedInstantiation,y._trace);this._setServiceInstance(y.id,P)}D.removeNode(y)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,d,p=[],D,f){if(this._services.get(o)instanceof w.SyncDescriptor)return this._createServiceInstance(d,p,D,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,d,p,D,f);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(o,d=[],p,D){if(p){const f=new c.IdleValue(()=>this._createInstance(o,d,D));return new Proxy(Object.create(null),{get(l,h){if(h in l)return l[h];let y=f.value,a=y[h];return typeof a!="function"||(a=a.bind(y),l[h]=a),a},set(l,h,y){return f.value[h]=y,!0}})}else return this._createInstance(o,d,D)}}e.InstantiationService=F;var _;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(_||(_={}));class r{constructor(o,d){this.type=o,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return C?new r(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):r._None}static traceCreation(o){return C?new r(0,o.name):r._None}branch(o,d){let p=new r(2,o.toString());return this._dep.push([o,d,p]),p}stop(){let o=Date.now()-this._start;r._totals+=o;let d=!1;function p(f,l){let h=[],y=new Array(f+1).join("	");for(const[a,P,n]of l._dep)if(P&&n){d=!0,h.push(`${y}CREATES -> ${a}`);let i=p(f+1,n);i&&h.push(i)}else h.push(`${y}uses -> ${a}`);return h.join(`
`)}let D=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${r._totals.toFixed(2)}ms)`];(o>2||d)&&console.log(D.join(`
`))}}r._None=new class extends r{constructor(){super(-1,null)}stop(){}branch(){return this}},r._totals=0}),define(we[12],Ee([0,1,44,3,7,24,4]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,t.createDecorator)("logService"),e.ILoggerService=(0,t.createDecorator)("loggerService");function R(){return new Date().toISOString()}var C;(function(P){P[P.Trace=0]="Trace",P[P.Debug=1]="Debug",P[P.Info=2]="Info",P[P.Warning=3]="Warning",P[P.Error=4]="Error",P[P.Critical=5]="Critical",P[P.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function k(P,n,i){switch(n){case C.Trace:P.trace(i);break;case C.Debug:P.debug(i);break;case C.Info:P.info(i);break;case C.Warning:P.warn(i);break;case C.Error:P.error(i);break;case C.Critical:P.critical(i);break;default:throw new Error("Invalid log level")}}e.log=k;function F(P){let n="";for(let i=0;i<P.length;i++){let v=P[i];if(typeof v=="object")try{v=JSON.stringify(v)}catch(g){}n+=(i>0?" ":"")+v}return n}e.format=F;class _ extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class r extends _{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(C.Trace)&&this.log(C.Trace,F([n,...i]))}debug(n,...i){this.checkLogLevel(C.Debug)&&this.log(C.Debug,F([n,...i]))}info(n,...i){this.checkLogLevel(C.Info)&&this.log(C.Info,F([n,...i]))}warn(n,...i){this.checkLogLevel(C.Warning)&&this.log(C.Warning,F([n,...i]))}error(n,...i){if(this.checkLogLevel(C.Error))if(n instanceof Error){const v=Array.prototype.slice.call(arguments);v[0]=n.stack,this.log(C.Error,F(v))}else this.log(C.Error,F([n,...i]))}critical(n,...i){this.checkLogLevel(C.Critical)&&this.log(C.Critical,F([n,...i]))}flush(){}}e.AbstractMessageLogger=r;class m extends _{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!T.isWindows}trace(n,...i){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...i):console.log(`[main ${R()}]`,n,...i))}debug(n,...i){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...i):console.log(`[main ${R()}]`,n,...i))}info(n,...i){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...i):console.log(`[main ${R()}]`,n,...i))}warn(n,...i){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,n,...i):console.warn(`[main ${R()}]`,n,...i))}error(n,...i){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,n,...i):console.error(`[main ${R()}]`,n,...i))}critical(n,...i){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,n,...i):console.error(`[main ${R()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class o extends _{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...i){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=o;class d extends _{constructor(n,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,c.toErrorMessage)(n,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class p extends _{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const v of this.logServices)v.trace(n,...i)}debug(n,...i){for(const v of this.logServices)v.debug(n,...i)}info(n,...i){for(const v of this.logServices)v.info(n,...i)}warn(n,...i){for(const v of this.logServices)v.warn(n,...i)}error(n,...i){for(const v of this.logServices)v.error(n,...i)}critical(n,...i){for(const v of this.logServices)v.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=p;class D extends w.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=D;class f extends w.Disposable{constructor(n,i){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(v=>{this.logLevel=v,this.logLevelChangeableLoggers.forEach(g=>g.setLevel(v))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let v=this.loggers.get(n.toString());return v||(v=this.doCreateLogger(n,i?.always?C.Trace:this.logLevel,i),this.loggers.set(n.toString(),v),i?.always||this.logLevelChangeableLoggers.push(v)),v}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=f;class l{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(n){}getLevel(){return C.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=l;function h(P){if(P.verbose)return C.Trace;if(typeof P.logLevel=="string"){const n=y(P.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function y(P){switch(P){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=y;function a(P){switch(P){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=a}),define(we[83],Ee([0,1,35,122,4]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var t;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(t=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function k(o,d){return d-o}C.compare=k;const F=Object.create(null);F[C.Error]=(0,M.localize)(0,null),F[C.Warning]=(0,M.localize)(1,null),F[C.Info]=(0,M.localize)(2,null);function _(o){return F[o]||""}C.toString=_;function r(o){switch(o){case c.default.Error:return C.Error;case c.default.Warning:return C.Warning;case c.default.Info:return C.Info;case c.default.Ignore:return C.Hint}}C.fromSeverity=r;function m(o){switch(o){case C.Error:return c.default.Error;case C.Warning:return c.default.Warning;case C.Info:return c.default.Info;case C.Hint:return c.default.Ignore}}C.toSeverity=m}(t=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(C){const k="";function F(r){return _(r,!0)}C.makeKey=F;function _(r,m){let o=[k];return r.source?o.push(r.source.replace("\xA6","\\\xA6")):o.push(k),r.code?typeof r.code=="string"?o.push(r.code.replace("\xA6","\\\xA6")):o.push(r.code.value.replace("\xA6","\\\xA6")):o.push(k),r.severity!==void 0&&r.severity!==null?o.push(t.toString(r.severity)):o.push(k),r.message&&m?o.push(r.message.replace("\xA6","\\\xA6")):o.push(k),r.startLineNumber!==void 0&&r.startLineNumber!==null?o.push(r.startLineNumber.toString()):o.push(k),r.startColumn!==void 0&&r.startColumn!==null?o.push(r.startColumn.toString()):o.push(k),r.endLineNumber!==void 0&&r.endLineNumber!==null?o.push(r.endLineNumber.toString()):o.push(k),r.endColumn!==void 0&&r.endColumn!==null?o.push(r.endColumn.toString()):o.push(k),o.push(k),o.join("\xA6")}C.makeKeyOptionalMessage=_})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(we[142],Ee([0,1,3,35,4]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,w.createDecorator)("notificationService");var T;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var t;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(t=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new C,this.onDidClose=c.Event.None,this.onDidChangeVisibility=c.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=R;class C{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=C}),define(we[143],Ee([0,1,7,9,2,4]),function(re,e,c,M,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return c.Disposable.None},registerValidator(){return c.Disposable.None},registerExternalUriResolver(){return c.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return c.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function t(C,k){return w.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,k):(0,M.startsWithIgnoreCase)(C,k+":")}e.matchesScheme=t;function R(C,...k){return k.some(F=>t(C,F))}e.matchesSomeScheme=R});var Ue=this&&this.__decorate||function(re,e,c,M){var w=arguments.length,T=w<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,c):M,t;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(re,e,c,M);else for(var R=re.length-1;R>=0;R--)(t=re[R])&&(T=(w<3?t(T):w>3?t(e,c,T):t(e,c))||T);return w>3&&T&&Object.defineProperty(e,c,T),T},Be=this&&this.__param||function(re,e){return function(c,M){e(c,M,re)}};define(we[144],Ee([0,1,14,20,7,4]),function(re,e,c,M,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var t;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(t=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=R,R.None=Object.freeze({report(){}});let C=class extends w.Disposable{constructor(_,r){super();this.deferred=new c.DeferredPromise,r.withProgress(_,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};C=Ue([Be(1,e.IProgressService)],C),e.UnmanagedProgress=C;class k extends w.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(_){this.stop();const r=++this.currentOperationId,m=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{r===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:r,token:m.token,stop:()=>this.doStop(r),isCurrent:()=>this.currentOperationId===r}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(we[30],Ee([0,1,41,10]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(t,R){c.ok(M.isString(t)),c.ok(M.isObject(R)),c.ok(!this.data.has(t),"There is already an extension with this id"),this.data.set(t,R)}knows(t){return this.data.has(t)}as(t){return this.data.get(t)||null}}e.Registry=new w}),define(we[145],Ee([0,1,3,30]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this._onDidChangeSchema=new c.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,k){this.schemasById[w(C)]=k,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const t=new T;M.Registry.add(e.Extensions.JSONContribution,t)}),define(we[61],Ee([0,1,16,3,10,119,145,30]),function(re,e,c,M,w,T,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const F=R.Registry.as(t.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(y,a=!0){this.registerConfigurations([y],a)}registerConfigurations(y,a=!0){const P=this.doRegisterConfigurations(y,a);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(P)}deregisterConfigurations(y){const a=this.doDeregisterConfigurations(y);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}updateConfigurations({add:y,remove:a}){const P=[];P.push(...this.doDeregisterConfigurations(a)),P.push(...this.doRegisterConfigurations(y,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,c.distinct)(P))}registerDefaultConfigurations(y){const a=[],P=[];for(const n of y)for(const i in n)if(a.push(i),e.OVERRIDE_PROPERTY_REGEX.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...n[i]};const v={type:"object",default:this.defaultValues[i],description:T.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};P.push(...o(i)),this.configurationProperties[i]=v,this.defaultLanguageConfigurationOverridesNode.properties[i]=v}else{this.defaultValues[i]=n[i];const v=this.configurationProperties[i];v&&(this.updatePropertyDefaultValue(i,v),this.updateSchema(i,v))}this.registerOverrideIdentifiers(P),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(y){const a=[];for(const P of y)for(const n in P)if(a.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const i=this.configurationProperties[n];i&&(this.updatePropertyDefaultValue(n,i),this.updateSchema(n,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...y){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(y){for(const a of y)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(y,a){const P=[];return y.forEach(n=>{P.push(...this.validateAndRegisterProperties(n,a,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),P}doDeregisterConfigurations(y){const a=[],P=n=>{if(n.properties)for(const i in n.properties)a.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,n.properties[i]);n.allOf&&n.allOf.forEach(i=>P(i))};for(const n of y){P(n);const i=this.configurationContributors.indexOf(n);i!==-1&&this.configurationContributors.splice(i,1)}return a}validateAndRegisterProperties(y,a=!0,P,n=3){n=w.isUndefinedOrNull(y.scope)?n:y.scope;let i=[],v=y.properties;if(v)for(let s in v){if(a&&f(s)){delete v[s];continue}const b=v[s];if(this.updatePropertyDefaultValue(s,b),e.OVERRIDE_PROPERTY_REGEX.test(s)?b.scope=void 0:(b.scope=w.isUndefinedOrNull(b.scope)?n:b.scope,b.restricted=w.isUndefinedOrNull(b.restricted)?!!P?.restrictedConfigurations?.includes(s):b.restricted),v[s].hasOwnProperty("included")&&!v[s].included){this.excludedConfigurationProperties[s]=v[s],delete v[s];continue}else this.configurationProperties[s]=v[s];!v[s].deprecationMessage&&v[s].markdownDeprecationMessage&&(v[s].deprecationMessage=v[s].markdownDeprecationMessage),i.push(s)}let g=y.allOf;if(g)for(let s of g)i.push(...this.validateAndRegisterProperties(s,a,P,n));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(y){const a=P=>{let n=P.properties;if(n)for(const v in n)this.updateSchema(v,n[v]);let i=P.allOf;i&&i.forEach(a)};a(y)}updateSchema(y,a){switch(e.allSettings.properties[y]=a,a.scope){case 1:e.applicationSettings.properties[y]=a;break;case 2:e.machineSettings.properties[y]=a;break;case 6:e.machineOverridableSettings.properties[y]=a;break;case 3:e.windowSettings.properties[y]=a;break;case 4:e.resourceSettings.properties[y]=a;break;case 5:e.resourceSettings.properties[y]=a,this.resourceLanguageSettingsSchema.properties[y]=a;break}}removeFromSchema(y,a){switch(delete e.allSettings.properties[y],a.scope){case 1:delete e.applicationSettings.properties[y];break;case 2:delete e.machineSettings.properties[y];break;case 6:delete e.machineOverridableSettings.properties[y];break;case 3:delete e.windowSettings.properties[y];break;case 4:case 5:delete e.resourceSettings.properties[y];break}}updateOverridePropertyPatternKey(){for(const y of this.overrideIdentifiers.values()){const a=`[${y}]`,P={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,P),e.allSettings.properties[a]=P,e.applicationSettings.properties[a]=P,e.machineSettings.properties[a]=P,e.machineOverridableSettings.properties[a]=P,e.windowSettings.properties[a]=P,e.resourceSettings.properties[a]=P}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const y={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=y,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(y,a){let P=this.defaultValues[y];w.isUndefined(P)&&(P=a.default),w.isUndefined(P)&&(P=p(a.type)),a.default=P}}const r="\\[([^\\]]+)\\]",m=new RegExp(r,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${r})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(h){const y=[];if(e.OVERRIDE_PROPERTY_REGEX.test(h)){let a=m.exec(h);for(;a?.length;){const P=a[1].trim();P&&y.push(P),a=m.exec(h)}}return(0,c.distinct)(y)}e.overrideIdentifiersFromKey=o;function d(h){return h.reduce((y,a)=>`${y}[${a}]`,"")}e.keyFromOverrideIdentifiers=d;function p(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const D=new _;R.Registry.add(e.Extensions.Configuration,D);function f(h){return h.trim()?e.OVERRIDE_PROPERTY_REGEX.test(h)?T.localize(7,null,h):D.getConfigurationProperties()[h]!==void 0?T.localize(8,null,h):null:T.localize(6,null)}e.validateProperty=f;function l(){const h=[],y=D.getConfigurationProperties();for(const a of Object.keys(y))h.push([a,y[a].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.getScopes=l}),define(we[84],Ee([0,1,10,2,61,4,30]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function R(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof M.URI)}e.isConfigurationOverrides=R;function C(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||c.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof M.URI)}e.isConfigurationUpdateOverrides=C;var k;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function F(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=F;function _(h,y){const a=Object.create(null);for(let P in h)r(a,P,h[P],y);return a}e.toValuesTree=_;function r(h,y,a,P){const n=y.split("."),i=n.pop();let v=h;for(let g=0;g<n.length;g++){let s=n[g],b=v[s];switch(typeof b){case"undefined":b=v[s]=Object.create(null);break;case"object":break;default:P(`Ignoring ${y} as ${n.slice(0,g+1).join(".")} is ${JSON.stringify(b)}`);return}v=b}if(typeof v=="object"&&v!==null)try{v[i]=a}catch(g){P(`Ignoring ${y} as ${n.join(".")} is ${JSON.stringify(v)}`)}else P(`Ignoring ${y} as ${n.join(".")} is ${JSON.stringify(v)}`)}e.addToValueTree=r;function m(h,y){const a=y.split(".");o(h,a)}e.removeFromValueTree=m;function o(h,y){const a=y.shift();if(y.length===0){delete h[a];return}if(Object.keys(h).indexOf(a)!==-1){const P=h[a];typeof P=="object"&&!Array.isArray(P)&&(o(P,y),Object.keys(P).length===0&&delete h[a])}}function d(h,y,a){function P(v,g){let s=v;for(const b of g){if(typeof s!="object"||s===null)return;s=s[b]}return s}const n=y.split("."),i=P(h,n);return typeof i=="undefined"?a:i}e.getConfigurationValue=d;function p(h,y,a){Object.keys(y).forEach(P=>{P!=="__proto__"&&(P in h?c.isObject(h[P])&&c.isObject(y[P])?p(h[P],y[P],a):a&&(h[P]=y[P]):h[P]=y[P])})}e.merge=p;function D(){const h=t.Registry.as(w.Extensions.Configuration).getConfigurationProperties();return Object.keys(h)}e.getConfigurationKeys=D;function f(){const h=Object.create(null),y=t.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(let a in y){let P=y[a].default;r(h,a,P,n=>console.error(`Conflict in default settings: ${n}`))}return h}e.getDefaultValues=f;function l(h,y,a){const P=h.inspect(y),n=h.inspect(a);return typeof P.userValue!="undefined"||typeof P.workspaceValue!="undefined"||typeof P.workspaceFolderValue!="undefined"?P.value:typeof n.userValue!="undefined"||typeof n.workspaceValue!="undefined"||typeof n.workspaceFolderValue!="undefined"?n.value:P.defaultValue}e.getMigratedSettingValue=l}),define(we[146],Ee([0,1,16,3,101,7,21,25,10,2,84,61,30]),function(re,e,c,M,w,T,t,R,C,k,F,_,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(n={},i=[],v=[]){this._contents=n,this._keys=i,this._overrides=v,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,F.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,i){const v=this.getContentsForOverrideIdentifer(i);return v?n?(0,F.getConfigurationValue)(v,n):v:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const v of this.overrides)v.identifiers.includes(n)&&i.push(...v.keys);return c.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return c.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=R.deepClone(this.contents),v=R.deepClone(this.overrides),g=[...this.keys];for(const s of n){this.mergeContents(i,s.contents);for(const b of s.overrides){const[u]=v.filter(E=>c.equals(E.identifiers,b.identifiers));u?(this.mergeContents(u.contents,b.contents),u.keys.push(...b.keys),u.keys=c.distinct(u.keys)):v.push(R.deepClone(b))}for(const b of s.keys)g.indexOf(b)===-1&&g.push(b)}return new m(i,g,v)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let v={};for(const g of c.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[g],b=i[g];b&&(typeof s=="object"&&typeof b=="object"?(s=R.deepClone(s),this.mergeContents(s,b)):s=b),v[g]=s}return new m(v,this.keys,this.overrides)}mergeContents(n,i){for(const v of Object.keys(i)){if(v in n&&C.isObject(n[v])&&C.isObject(i[v])){this.mergeContents(n[v],i[v]);continue}n[v]=R.deepClone(i[v])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?R.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let i=null,v=null;const g=s=>{s&&(v?this.mergeContents(v,s):v=R.deepClone(s))};for(const s of this.overrides)c.equals(s.identifiers,[n])?i=s.contents:s.identifiers.includes(n)&&g(s.contents);return g(i),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.addKey(n),(0,F.addToValueTree)(this.contents,n,i,v=>{throw new Error(v)})}removeValue(n){this.removeKey(n)&&(0,F.removeFromValueTree)(this.contents,n)}addKey(n){let i=this.keys.length;for(let v=0;v<i;v++)n.indexOf(this.keys[v])===0&&(i=v);this.keys.splice(i,1,n)}removeKey(n){let i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=m;class o extends m{constructor(){const n=(0,F.getDefaultValues)(),i=(0,F.getConfigurationKeys)(),v=[];for(const g of Object.keys(n))_.OVERRIDE_PROPERTY_REGEX.test(g)&&v.push({identifiers:(0,_.overrideIdentifiersFromKey)(g),keys:Object.keys(n[g]),contents:(0,F.toValuesTree)(n[g],s=>console.error(`Conflict in default settings file: ${s}`))});super(n,i,v)}}e.DefaultConfigurationModel=o;class d{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!C.isUndefinedOrNull(n)){const v=this.doParseContent(n);this.parseRaw(v,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:v,keys:g,overrides:s,restricted:b}=this.doParseRaw(n,i);this._configurationModel=new m(v,g,s),this._restrictedConfigurations=b||[]}doParseContent(n){let i={},v=null,g=[],s=[],b=[];function u(A){Array.isArray(g)?g.push(A):v!==null&&(g[v]=A)}let E={onObjectBegin:()=>{let A={};u(A),s.push(g),g=A,v=null},onObjectProperty:A=>{v=A},onObjectEnd:()=>{g=s.pop()},onArrayBegin:()=>{let A=[];u(A),s.push(g),g=A,v=null},onArrayEnd:()=>{g=s.pop()},onLiteralValue:u,onError:(A,I,B)=>{b.push({error:A,offset:I,length:B})}};if(n)try{w.visit(n,E),i=g[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(n,i){const v=r.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),g=this.filter(n,v,!0,i);n=g.raw;const s=(0,F.toValuesTree)(n,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),b=Object.keys(n),u=this.toOverrides(n,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:s,keys:b,overrides:u,restricted:g.restricted}}filter(n,i,v,g){if(!g?.scopes&&!g?.skipRestricted)return{raw:n,restricted:[]};const s={},b=[];for(let u in n)if(_.OVERRIDE_PROPERTY_REGEX.test(u)&&v){const E=this.filter(n[u],i,!1,g);s[u]=E.raw,b.push(...E.restricted)}else{const E=i[u],A=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&b.push(u),(A===void 0||g.scopes===void 0||g.scopes.includes(A))&&(g.skipRestricted&&E?.restricted||(s[u]=n[u]))}return{raw:s,restricted:b}}toOverrides(n,i){const v=[];for(const g of Object.keys(n))if(_.OVERRIDE_PROPERTY_REGEX.test(g)){const s={};for(const b in n[g])s[b]=n[g][b];v.push({identifiers:(0,_.overrideIdentifiersFromKey)(g),keys:Object.keys(s),contents:(0,F.toValuesTree)(s,i)})}return v}}e.ConfigurationModelParser=d;class p extends T.Disposable{constructor(n,i,v,g){super();this.userSettingsResource=n,this.scopes=i,this.fileService=g,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(v.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class D{constructor(n,i,v=new m,g=new m,s=new t.ResourceMap,b=new m,u=new t.ResourceMap,E=!0){this._defaultConfiguration=n,this._localUserConfiguration=i,this._remoteUserConfiguration=v,this._workspaceConfiguration=g,this._folderConfigurations=s,this._memoryConfiguration=b,this._memoryConfigurationByResource=u,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new t.ResourceMap,this._userConfiguration=null}getValue(n,i,v){return this.getConsolidateConfigurationModel(i,v).getValue(n)}updateValue(n,i,v={}){let g;v.resource?(g=this._memoryConfigurationByResource.get(v.resource),g||(g=new m,this._memoryConfigurationByResource.set(v.resource,g))):g=this._memoryConfiguration,i===void 0?g.removeValue(n):g.setValue(n,i),v.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,v){const g=this.getConsolidateConfigurationModel(i,v),s=this.getFolderConfigurationModelForResource(i.resource,v),b=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,u=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),E=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),A=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),I=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),B=v?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,O=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(n):s.freeze().getValue(n):void 0,S=i.overrideIdentifier?b.override(i.overrideIdentifier).getValue(n):b.getValue(n),x=g.getValue(n),N=c.distinct(c.flatten(g.overrides.map(V=>V.identifiers))).filter(V=>g.getOverrideValue(n,V)!==void 0);return{defaultValue:u,userValue:E,userLocalValue:A,userRemoteValue:I,workspaceValue:B,workspaceFolderValue:O,memoryValue:S,value:x,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userRemote:I!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:s?.freeze().getValue(n),override:i.overrideIdentifier?s?.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,memory:S!==void 0?{value:b.getValue(n),override:i.overrideIdentifier?b.getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:N.length?N:void 0}}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const v=[];for(const g of i)for(const s of(0,_.overrideIdentifiersFromKey)(g)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(s),u=n.getKeysForOverrideIdentifier(s),E=[...u.filter(A=>b.indexOf(A)===-1),...b.filter(A=>u.indexOf(A)===-1),...b.filter(A=>!R.equals(this._defaultConfiguration.override(s).getValue(A),n.override(s).getValue(A)))];v.push([s,E])}return this.updateDefaultConfiguration(n),{keys:i,overrides:v}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:v,removed:g,overrides:s}=y(this.localUserConfiguration,n),b=[...i,...v,...g];return b.length&&this.updateLocalUserConfiguration(n),{keys:b,overrides:s}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:v,removed:g,overrides:s}=y(this.remoteUserConfiguration,n);let b=[...i,...v,...g];return b.length&&this.updateRemoteUserConfiguration(n),{keys:b,overrides:s}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:v,removed:g,overrides:s}=y(this.workspaceConfiguration,n);let b=[...i,...v,...g];return b.length&&this.updateWorkspaceConfiguration(n),{keys:b,overrides:s}}compareAndUpdateFolderConfiguration(n,i){const v=this.folderConfigurations.get(n),{added:g,updated:s,removed:b,overrides:u}=y(v,i);let E=[...g,...s,...b];return(E.length||!v)&&this.updateFolderConfiguration(n,i),{keys:E,overrides:u}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:v,updated:g,removed:s,overrides:b}=y(i,void 0);return{keys:[...v,...g,...s],overrides:b}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,i){let v=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier?v.override(n.overrideIdentifier):v}getConsolidatedConfigurationModelForResource({resource:n},i){let v=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const g=i.getFolder(n);g&&(v=this.getFolderConsolidatedConfiguration(g.uri)||v);const s=this._memoryConfigurationByResource.get(n);s&&(v=v.merge(s))}return v}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const v=this.getWorkspaceConsolidatedConfiguration(),g=this._folderConfigurations.get(n);g?(i=v.merge(g),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(n,i)):i=v}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const v=i.getFolder(n);if(v)return this._folderConfigurations.get(v.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:v,overrides:g,keys:s}=this._folderConfigurations.get(i);return n.push([i,{contents:v,overrides:g,keys:s}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(v=>n.add(v))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(v=>n.add(v))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(v=>i.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(v=>i.add(v)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(v=>i.add(v)),this._folderConfigurations.forEach(v=>v.getKeysForOverrideIdentifier(n).forEach(g=>i.add(g))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),v=this.parseConfigurationModel(n.user),g=this.parseConfigurationModel(n.workspace),s=n.folders.reduce((b,u)=>(b.set(k.URI.revive(u[0]),this.parseConfigurationModel(u[1])),b),new t.ResourceMap);return new D(i,v,new m,g,s,new m,new t.ResourceMap,!1)}static parseConfigurationModel(n){return new m(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=D;function f(...P){if(P.length===0)return{keys:[],overrides:[]};if(P.length===1)return P[0];const n=new Set,i=new Map;for(const g of P)g.keys.forEach(s=>n.add(s)),g.overrides.forEach(([s,b])=>{const u=(0,t.getOrSet)(i,s,new Set);b.forEach(E=>u.add(E))});const v=[];return i.forEach((g,s)=>v.push([s,[...g.values()]])),{keys:[...n.values()],overrides:v}}e.mergeChanges=f;class l{constructor(n,i,v,g){this.change=n,this.previous=i,this.currentConfiguraiton=v,this.currentWorkspace=g,this._previousConfiguration=void 0;const s=new Set;n.keys.forEach(u=>s.add(u)),n.overrides.forEach(([,u])=>u.forEach(E=>s.add(E))),this.affectedKeys=[...s.values()];const b=new m;this.affectedKeys.forEach(u=>b.setValue(u,{})),this.affectedKeysTree=b.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(i){const v=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,g=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!R.equals(v,g)}return!0}return!1}doesAffectedKeysTreeContains(n,i){let v=(0,F.toValuesTree)({[i]:!0},()=>{}),g;for(;typeof v=="object"&&(g=Object.keys(v)[0]);){if(n=n[g],!n)return!1;v=v[g]}return!0}}e.ConfigurationChangeEvent=l;class h extends l{constructor(n,i,v,g){super({keys:n.allKeys(),overrides:[]},void 0,n,i);this.source=v,this.sourceConfig=g}}e.AllKeysConfigurationChangeEvent=h;function y(P,n){const{added:i,removed:v,updated:g}=a(n,P),s=[],b=P?.getAllOverrideIdentifiers()||[],u=n?.getAllOverrideIdentifiers()||[];if(n){const E=u.filter(A=>!b.includes(A));for(const A of E)s.push([A,n.getKeysForOverrideIdentifier(A)])}if(P){const E=b.filter(A=>!u.includes(A));for(const A of E)s.push([A,P.getKeysForOverrideIdentifier(A)])}if(n&&P){for(const E of b)if(u.includes(E)){const A=a({contents:P.getOverrideValue(void 0,E)||{},keys:P.getKeysForOverrideIdentifier(E)},{contents:n.getOverrideValue(void 0,E)||{},keys:n.getKeysForOverrideIdentifier(E)});s.push([E,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:v,updated:g,overrides:s}}function a(P,n){const i=P?n?P.keys.filter(s=>n.keys.indexOf(s)===-1):[...P.keys]:[],v=n?P?n.keys.filter(s=>P.keys.indexOf(s)===-1):[...n.keys]:[],g=[];if(P&&n){for(const s of n.keys)if(P.keys.indexOf(s)!==-1){const b=(0,F.getConfigurationValue)(n.contents,s),u=(0,F.getConfigurationValue)(P.contents,s);R.equals(b,u)||g.push(s)}}return{added:i,removed:v,updated:g}}}),define(we[85],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,c.createDecorator)("remoteAuthorityResolverService");var M;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(t,R=M.Unknown,C){super(t);this._message=t,this._code=R,this._detail=C,this.isHandled=R===M.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(t){return t instanceof w&&t._code===M.TemporarilyNotAvailable}static isNoResolverFound(t){return t instanceof w&&t._code===M.NoResolverFound}static isHandled(t){return t instanceof w&&t.isHandled}}e.RemoteAuthorityResolverError=w}),define(we[62],Ee([0,1,11]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(k){return k.scheme===c.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=M;function w(k){if(!k)return;const F=k.indexOf("+");return F<0?k:k.substr(0,F)}e.getRemoteName=w;function T(k){return k.scheme!==c.Schemas.file&&k.scheme!==c.Schemas.vscodeRemote}e.isVirtualResource=T;function t(k){if(k.folders.length)return k.folders.every(F=>T(F.uri))?k.folders[0].uri:void 0;if(k.configuration&&T(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=t;function R(k){return t(k)?.scheme}e.getVirtualWorkspaceScheme=R;function C(k){return t(k)!==void 0}e.isVirtualWorkspace=C}),define(we[26],Ee([0,1,9,4,62]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.getWorkspaceSupportTypeMessage=T;function t(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=t,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class C{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m=="undefined"||m===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){let d=typeof m=="string"?m:m.value,p=typeof o=="string"?o:o.value;return c.equalsIgnoreCase(d,p)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=C;function k(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function F(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function _(r,m){if(m){const o=`onResolveRemoteAuthority:${(0,w.getRemoteName)(m)}`;return r.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[147],Ee([0,1,9,26]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(o,d){return o.uuid&&d.uuid?o.uuid===d.uuid:o.id===d.id?!0:(0,c.compareIgnoreCase)(o.id,d.id)===0}e.areSameExtensions=w;class T{constructor(d,p){this.version=p,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof T?w(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=T;function t(o,d){return`${o}.${d}`}e.getExtensionId=t;function R(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function C(o,d){return R(t(o,d))}e.getGalleryExtensionId=C;function k(o,d){const p=[],D=f=>{for(const l of p)if(l.some(h=>w(d(h),d(f))))return l;return null};for(const f of o){const l=D(f);l?l.push(f):p.push([f])}return p}e.groupByExtension=k;function F(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function _(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function r(o){const d=new Set;for(const p of o)p.malicious&&d.add(p.id.id);return d}e.getMaliciousExtensionsSet=r;function m(o,d){const p=[],D=d.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const f=D.shift();if(f&&p.every(l=>!w(l.identifier,{id:f}))){const l=o.filter(h=>w(h.identifier,{id:f}));l.length===1&&(p.push(l[0]),D.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=m}),define(we[148],Ee([0,1,3,24,4,12]),function(re,e,c,M,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var t;(function(o){o.Http="http",o.Https="https"})(t=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=_;function r(o,d){return d?d!==1&&o<1024:!M.isWindows&&o<1024}e.isPortPrivileged=r;let m=class{constructor(d){this.logService=d,this._onTunnelOpened=new c.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new c.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new c.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d,p){return this._tunnelProvider=d,d?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],p=Array.from(this._tunnels.values());for(let D of p){const f=Array.from(D.values());for(let l of f){const h=await l.value;h&&d.push(h)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:p}of d.values())await p.then(D=>D?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,p,D,f,l=!1,h=R.Private,y){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${D} on local port ${f}.`),!d)return;p||(p="localhost");const a=this.retainOrCreateTunnel(d,p,D,f,l,h,y);return a?a.then(P=>{if(!P){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(P);return(P.tunnelRemoteHost!==p||P.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const p=this._tunnels.get(d.tunnelRemoteHost);if(p){const D=p.get(d.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,D))}}}}async tryDisposeTunnel(d,p,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${p}.`);const f=D.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(p),f}}async closeTunnel(d,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${p} `);const D=this._tunnels.get(d);if(D&&D.has(p)){const f=D.get(p);f.refcount=0,await this.tryDisposeTunnel(d,p,f)}}addTunnelToMap(d,p,D){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(p,{refcount:1,value:D})}async removeEmptyTunnelFromMap(d,p){const D=this._tunnels.get(d);D&&(await D.get(p)||D.delete(p),D.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,p){let D=[d];F(d)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):_(d)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const f=D.map(l=>this._tunnels.get(l));for(const l of f){const h=l?.get(p);if(h)return h}}canTunnel(d){return!!k(d)}createWithProvider(d,p,D,f,l,h,y){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${D} on local port ${f}.`);const P={elevationRequired:l?r(f===void 0?D:f):!1},n={remoteAddress:{host:p,port:D},localAddressPort:f,privacy:h,public:h!==R.Private,protocol:y},i=d.forwardPort(n,P);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(p,D,i),i}};m=Ue([Be(0,T.ILogService)],m),e.AbstractTunnelService=m}),define(we[149],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class c{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,T,t=5){let R;return R=T(C=>{const k=typeof C=="string"?C:C.data;let F=this._terminalBufferMap.get(w);if(F){F.data.push(k);return}const _=setTimeout(()=>this.flushBuffer(w),t);F={data:[k],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(w),R.dispose()}},this._terminalBufferMap.set(w,F)}),R}stopBuffering(w){const T=this._terminalBufferMap.get(w);T&&T.dispose()}flushBuffer(w){const T=this._terminalBufferMap.get(w);T&&(this._terminalBufferMap.delete(w),this._callback(w,T.data.join("")))}}e.TerminalDataBufferer=c}),define(we[150],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var c;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(c=e.ColorScheme||(e.ColorScheme={}))}),define(we[63],Ee([0,1,54,3,7,4,30,150]),function(re,e,c,M,w,T,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var C;(function(p){function D(f){return f&&typeof f=="object"&&typeof f.id=="string"}p.isThemeColor=D})(C=e.ThemeColor||(e.ThemeColor={}));function k(p){return{id:p}}e.themeColorFromId=k;var F;(function(p){function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||C.isThemeColor(n.color))}p.isThemeIcon=D;const f=new RegExp(`^\\$\\((${c.CSSIcon.iconNameExpression}(?:${c.CSSIcon.iconModifierExpression})?)\\)$`);function l(n){const i=f.exec(n);if(!i)return;let[,v]=i;return{id:v}}p.fromString=l;function h(n,i){let v=n.id;const g=v.lastIndexOf("~");return g!==-1&&(v=v.substring(0,g)),i&&(v=`${v}~${i}`),{id:v}}p.modify=h;function y(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}p.getModifier=y;function a(n,i){return n.id===i.id&&n.color?.id===i.color?.id}p.isEqual=a;function P(n,i){return{id:n.id,color:i?k(i):void 0}}p.asThemeIcon=P,p.asClassNameArray=c.CSSIcon.asClassNameArray,p.asClassName=c.CSSIcon.asClassName,p.asCSSSelector=c.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=c.Codicon.file,e.FolderThemeIcon=c.Codicon.folder;function _(p){switch(p){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class r{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,w.toDisposable)(()=>{const f=this.themingParticipants.indexOf(D);this.themingParticipants.splice(f,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new r;t.Registry.add(e.Extensions.ThemingContribution,m);function o(p){return m.onColorThemeChange(p)}e.registerThemingParticipant=o;class d extends w.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(f=>this.onThemeChange(f)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,f){let l=this.theme.getColor(D);return l&&f&&(l=f(l,this.theme)),l?l.toString():null}}e.Themable=d}),define(we[47],Ee([0,1,21,23,2,4]),function(re,e,c,M,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var t;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(t=e.WorkbenchState||(e.WorkbenchState={}));function R(r){const m=r;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=R;function C(r){const m=r;return!!(m&&typeof m=="object"&&w.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=C;class k{constructor(m,o,d,p,D){this._id=m,this._transient=d,this._configuration=p,this._ignorePathCasing=D,this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=c.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=k;class F{constructor(m,o){this.raw=o,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,M.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function _(r){return new F({uri:r,index:0,name:(0,M.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=_}),define(we[64],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class c{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const T=this._idPool++;return this._data.set(T,w),this.logDebugInfo(),T}get(w,T){return this._data.has(w)?this._data.get(w)[T]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!c.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=c,c.enableDebugLogging=!1}),define(we[31],Ee([0,1,11,23,4]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(c.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(R=>{const C=this._providerInfo.get(R.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(R,C){C===null?this._providerInfo.delete(R):this._providerInfo.set(R,C)}isFreeScheme(R){return!this._providerInfo.has(R)&&!this._systemSchemes.has(R)}getCapabilities(R){return this._providerInfo.get(R)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(we[28],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,c.createDecorator)("IExtHostInitDataService")}),define(we[151],Ee([0,1,14]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(t,R,C){this._deferredPromises=new Map,this._id=t,this._shared=R,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new c.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of k.values())F.complete()}catch(F){for(const _ of k.values())_.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,t])=>t!==void 0).map(([t])=>t)}get whenReady(){return this._init}get(t,R){let C=this._value[t];return typeof C=="undefined"&&(C=R),C}update(t,R){this._value[t]=R;let C=this._deferredPromises.get(t);if(C!==void 0)return C.p;const k=new c.DeferredPromise;return this._deferredPromises.set(t,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class w extends M{constructor(t,R){super(t.identifier.value,!0,R);this._extension=t}setKeysForSync(t){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},t)}}e.ExtensionGlobalMemento=w}),define(we[152],Ee([0,1,3,2,12]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(R,C){this._logService=R,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new c.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new c.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(R,C,k){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(R)).acceptModelChanged(C.value,k)}$acceptDirtyStateChanged(R,C){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(R)).acceptDirty(C)}$acceptModelSaved(R){const C=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(R));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(R,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",R.path,C);const k=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(R));k.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};T=Ue([Be(0,w.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(we[13],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,c.createDecorator)("IExtHostRpcService");class M{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=M});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[153],Ee([0,1,26,3]),function(re,e,c,M){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(R,C){w.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=c.ExtensionIdentifier.toKey(R.identifier),Je(this,w,C,"f"),Ae(this,w,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(R){return Ae(this,w,"f").get(this._id,R)}store(R,C){return Ae(this,w,"f").store(this._id,R,C)}delete(R){return Ae(this,w,"f").delete(this._id,R)}}e.ExtensionSecrets=T,w=new WeakMap}),define(we[86],Ee([0,1,4,3]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(t){this._enabled=t}$onDidChangeTelemetryEnabled(t){this._enabled=t,this._onDidChangeTelemetryEnabled.fire(t)}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,c.createDecorator)("IExtHostTelemetry")}),define(we[48],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var c;(function(f){f[f.Upsert=0]="Upsert",f[f.RemoveChild=1]="RemoveChild",f[f.Invalidated=2]="Invalidated",f[f.SetProp=3]="SetProp",f[f.Bulk=4]="Bulk"})(c=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,w=(f,l)=>{const h={controllerId:l};return M.set(f,h),h};e.createPrivateApiFor=w;const T=f=>M.get(f);e.getPrivateApiFor=T;const t=(f,l,h,y)=>{let a=h;return{enumerable:!0,configurable:!1,get(){return a},set(P){if(!y(a,P)){const n=a;a=P,f.listener?.({op:3,key:l,value:P,previous:n})}}}},R=(f,l)=>f===l,C={range:(f,l)=>f===l?!0:!f||!l?!1:f.isEqual(l),label:R,description:R,busy:R,error:R,canResolveChildren:R,tags:(f,l)=>!(f.length!==l.length||f.some(h=>!l.find(y=>h.id===y.id)))},k=Object.keys(C),F=(f,l)=>({range:t(f,"range",void 0,C.range),label:t(f,"label",l,C.label),description:t(f,"description",void 0,C.description),canResolveChildren:t(f,"canResolveChildren",!1,C.canResolveChildren),busy:t(f,"busy",!1,C.busy),error:t(f,"error",void 0,C.error),tags:t(f,"tags",[],C.tags)}),_=(f,l)=>{const h=new Map;for(const y of k)C[y](f[y],l[y])||h.set(y,l[y]);return h};e.diffTestItems=_;class r extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.DuplicateTestItemError=r;class m extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class o extends Error{constructor(l,h,y){super(`TestItem with ID "${l}" is from controller "${h}" and cannot be added as a child of an item from controller "${y}".`)}}e.MixedTestItemController=o;const d=f=>{const l=(0,e.getPrivateApiFor)(f);let h=new Map;return{get size(){return h.size},forEach(y,a){for(const P of h.values())y.call(a,P,this)},replace(y){const a=new Map,P=new Set(h.keys()),n={op:4,ops:[]};for(const i of y){if(!(i instanceof p))throw new m(i.id);const v=(0,e.getPrivateApiFor)(i).controllerId;if(v!==l.controllerId)throw new o(i.id,v,l.controllerId);if(a.has(i.id))throw new r(i.id);a.set(i.id,i),P.delete(i.id),n.ops.push({op:0,item:i})}for(const i of P.keys())n.ops.push({op:1,id:i});l.listener?.(n),h=a},add(y){if(!(y instanceof p))throw new m(y.id);h.set(y.id,y),l.listener?.({op:0,item:y})},delete(y){h.delete(y)&&l.listener?.({op:1,id:y})},get(y){return h.get(y)},toJSON(){return Array.from(h.values())},[Symbol.iterator](){return h.values()}}};class p{constructor(l,h,y,a){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const P=(0,e.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return P.parent instanceof D?void 0:P.parent}},children:{value:d(this),enumerable:!0,writable:!1},...F(P,y)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class D extends p{constructor(l,h){super(l,l,h,void 0)}}e.TestItemRootImpl=D}),define(we[65],Ee([0,1,4,148,3,13]),function(re,e,c,M,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var t;(function(C){function k(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:_.protocol}}C.fromApiTunnel=k;function F(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==M.TunnelPrivacyId.ConstantPrivate&&_.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}C.fromServiceTunnel=F})(t=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,c.createDecorator)("IExtHostTunnelService");let R=class{constructor(k){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,F){}async getTunnels(){return[]}async setTunnelExtensionFunctions(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,F){return{dispose:()=>{}}}async $providePortAttributes(k,F,_,r,m){return[]}async $forwardPort(k,F){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Ue([Be(0,T.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[6],Ee([0,1,16,15,77,21,79,9,10,2,36,46,85]),function(re,e,c,M,w,T,t,R,C,k,F,_,r){"use strict";var m,o,d,p,D,f,l,h,y,a,P,n,i,v,g,s,b,u,E,A;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function I(U){function L(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(L,U),Object.setPrototypeOf(L.prototype,U.prototype),L}let B=D=class{constructor(L){m.set(this,void 0),Je(this,m,L,"f")}static from(...L){let te=L;return new D(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof Ae(this,m,"f")=="function"&&(Ae(this,m,"f").call(this),Je(this,m,void 0,"f"))}};m=new WeakMap,B=D=Ue([I],B),e.Disposable=B;let O=f=class{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("line must be non-negative");if(te<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=L,this._character=te}static Min(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ve=L[_e];Ve.isBefore(te)&&(te=Ve)}return te}static Max(...L){if(L.length===0)throw new TypeError;let te=L[0];for(let _e=1;_e<L.length;_e++){const Ve=L[_e];Ve.isAfter(te)&&(te=Ve)}return te}static isPosition(L){if(!L)return!1;if(L instanceof f)return!0;let{line:te,character:_e}=L;return typeof te=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,te=0){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=0:typeof L=="number"?_e=L:(_e=typeof L.lineDelta=="number"?L.lineDelta:0,te=typeof L.characterDelta=="number"?L.characterDelta:0),_e===0&&te===0?this:new f(this.line+_e,this.character+te)}with(L,te=this.character){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof L=="undefined"?_e=this.line:typeof L=="number"?_e=L:(_e=typeof L.line=="number"?L.line:this.line,te=typeof L.character=="number"?L.character:this.character),_e===this.line&&te===this.character?this:new f(_e,te)}toJSON(){return{line:this.line,character:this.character}}};O=f=Ue([I],O),e.Position=O;let S=l=class{constructor(L,te,_e,Ve){let tt,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ve=="number"?(tt=new O(L,te),st=new O(_e,Ve)):L instanceof O&&te instanceof O&&(tt=L,st=te),!tt||!st)throw new Error("Invalid arguments");tt.isBefore(st)?(this._start=tt,this._end=st):(this._start=st,this._end=tt)}static isRange(L){return L instanceof l?!0:L?O.isPosition(L.start)&&O.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof l?this.contains(L._start)&&this.contains(L._end):L instanceof O?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const te=O.Max(L.start,this._start),_e=O.Min(L.end,this._end);if(!te.isAfter(_e))return new l(te,_e)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const te=O.Min(L.start,this._start),_e=O.Max(L.end,this.end);return new l(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,te=this.end){if(L===null||te===null)throw(0,M.illegalArgument)();let _e;return L?O.isPosition(L)?_e=L:(_e=L.start||this.start,te=L.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new l(_e,te)}toJSON(){return[this.start,this.end]}};S=l=Ue([I],S),e.Range=S;let x=h=class extends S{constructor(L,te,_e,Ve){let tt,st;if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ve=="number"?(tt=new O(L,te),st=new O(_e,Ve)):L instanceof O&&te instanceof O&&(tt=L,st=te),!tt||!st)throw new Error("Invalid arguments");super(tt,st);this._anchor=tt,this._active=st}static isSelection(L){return L instanceof h?!0:L?S.isRange(L)&&O.isPosition(L.anchor)&&O.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=h=Ue([I],x),e.Selection=x;class N{constructor(L,te,_e){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=N;class V extends Error{constructor(L,te=r.RemoteAuthorityResolverErrorCode.Unknown,_e){super(L);this._message=L,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(L,te){return new V(L,r.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(L){return new V(L,r.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var $;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var z;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ee=y=class{constructor(L,te){this._range=L,this._newText=te}static isTextEdit(L){return L instanceof y?!0:L?S.isRange(L)&&typeof L.newText=="string":!1}static replace(L,te){return new y(L,te)}static insert(L,te){return y.replace(new S(L,L),te)}static delete(L){return y.replace(L,"")}static setEndOfLine(L){const te=new y(new S(new O(0,0),new O(0,0)),"");return te.newEol=L,te}get range(){return this._range}set range(L){if(L&&!S.isRange(L))throw(0,M.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,M.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,M.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ee=y=Ue([I],ee),e.TextEdit=ee;var j;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(j=e.FileEditType||(e.FileEditType={}));let Q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,te,_e,Ve){this._edits.push({_type:1,from:L,to:te,options:_e,metadata:Ve})}createFile(L,te,_e){this._edits.push({_type:1,from:void 0,to:L,options:te,metadata:_e})}deleteFile(L,te,_e){this._edits.push({_type:1,from:L,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(L,te,_e){this._edits.push({_type:3,metadata:_e,uri:L,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(L,te,_e,Ve,tt){let st,ut,Dt=[],Rt;if(Wt.isNotebookRange(te)&&Pe.isNotebookCellDataArray(_e)&&!Pe.isNotebookCellDataArray(Ve)?(st=te.start,ut=te.end,Dt=_e,Rt=Ve):typeof te=="number"&&typeof _e=="number"&&Pe.isNotebookCellDataArray(Ve)&&(st=te,ut=_e,Dt=Ve,Rt=tt),st===void 0||ut===void 0)throw new Error("Invalid arguments");(st!==ut||Dt.length>0)&&this._edits.push({_type:5,uri:L,index:st,count:ut-st,cells:Dt,metadata:Rt})}replaceNotebookCellMetadata(L,te,_e,Ve){this._edits.push({_type:3,metadata:Ve,uri:L,edit:{editType:8,index:te,metadata:_e}})}replace(L,te,_e,Ve){this._edits.push({_type:2,uri:L,edit:new ee(te,_e),metadata:Ve})}insert(L,te,_e,Ve){this.replace(L,new S(te,te),_e,Ve)}delete(L,te,_e){this.replace(L,te,"",_e)}has(L){return this._edits.some(te=>te._type===2&&te.uri.toString()===L.toString())}set(L,te){if(te)for(const _e of te)_e&&this._edits.push({_type:2,uri:L,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ve=this._edits[_e];Ve._type===2&&Ve.uri.toString()===L.toString()&&(this._edits[_e]=void 0)}(0,c.coalesceInPlace)(this._edits)}}get(L){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===L.toString()&&te.push(_e.edit);return te}entries(){const L=new T.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=L.get(te.uri);_e||(_e=[te.uri,[]],L.set(te.uri,_e)),_e[1].push(te.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Q=Ue([I],Q),e.WorkspaceEdit=Q;let ce=a=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof a?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=a._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,te=this._tabstop++){if(typeof L=="function"){const _e=new a;_e._tabstop=this._tabstop,L(_e),this._tabstop=_e._tabstop,L=_e.value}else L=a._escape(L);return this.value+="${",this.value+=te,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,te=this._tabstop++){const _e=L.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(L,te){if(typeof te=="function"){const _e=new a;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ce=a=Ue([I],ce),e.SnippetString=ce;var ve;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(ve=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=P=class{constructor(L,te){if(this.uri=L,te)if(te instanceof S)this.range=te;else if(te instanceof O)this.range=new S(te,te);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof P?!0:L?S.isRange(L.range)&&k.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=P=Ue([I],Fe),e.Location=Fe;let Ke=class{constructor(L,te){this.location=L,this.message=te}static is(L){return L?typeof L.message=="string"&&L.location&&S.isRange(L.location.range)&&k.URI.isUri(L.location.uri):!1}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.location.range.isEqual(te.location.range)&&L.location.uri.toString()===te.location.uri.toString()}};Ke=Ue([I],Ke),e.DiagnosticRelatedInformation=Ke;let Oe=class{constructor(L,te,_e=ue.Error){if(!S.isRange(L))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=L,this.message=te,this.severity=_e}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,te){return L===te?!0:!L||!te?!1:L.message===te.message&&L.severity===te.severity&&L.code===te.code&&L.severity===te.severity&&L.source===te.source&&L.range.isEqual(te.range)&&(0,c.equals)(L.tags,te.tags)&&(0,c.equals)(L.relatedInformation,te.relatedInformation,Ke.isEqual)}};Oe=Ue([I],Oe),e.Diagnostic=Oe;let We=class{constructor(L,te){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=te}};We=Ue([I],We),e.Hover=We;var Xe;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Xe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ye=class{constructor(L,te=Xe.Text){this.range=L,this.kind=te}toJSON(){return{range:this.range,kind:Xe[this.kind]}}};Ye=Ue([I],Ye),e.DocumentHighlight=Ye;var Qe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var H;(function(U){U[U.Deprecated=1]="Deprecated"})(H=e.SymbolTag||(e.SymbolTag={}));let K=n=class{constructor(L,te,_e,Ve,tt){this.name=L,this.kind=te,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ve instanceof Fe?this.location=Ve:_e instanceof S&&(this.location=new Fe(Ve,_e)),n.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};K=n=Ue([I],K),e.SymbolInformation=K;let J=i=class{constructor(L,te,_e,Ve,tt){this.name=L,this.detail=te,this.kind=_e,this.range=Ve,this.selectionRange=tt,this.children=[],i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(i.validate)}};J=i=Ue([I],J),e.DocumentSymbol=J;var oe;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(oe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(L,te){this.title=L,this.kind=te}};G=Ue([I],G),e.CodeAction=G;let ie=v=class{constructor(L){this.value=L}append(L){return new v(this.value?this.value+v.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+v.sep)}};ie.sep=".",ie=v=Ue([I],ie),e.CodeActionKind=ie,ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll");let de=class{constructor(L,te){if(this.range=L,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};de=Ue([I],de),e.SelectionRange=de;class Te{constructor(L,te,_e,Ve,tt,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ve,this.range=tt,this.selectionRange=st}}e.CallHierarchyItem=Te;class Ne{constructor(L,te){this.fromRanges=te,this.from=L}}e.CallHierarchyIncomingCall=Ne;class ze{constructor(L,te){this.fromRanges=te,this.to=L}}e.CallHierarchyOutgoingCall=ze;var je;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(L,te){this.range=L,this.command=te}get isResolved(){return!!this.command}};et=Ue([I],et),e.CodeLens=et;let ot=g=class{constructor(L,te=!1){o.set(this,void 0),Je(this,o,new w.MarkdownString(L,{supportThemeIcons:te}),"f")}static isMarkdownString(L){return L instanceof g?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ae(this,o,"f").value}set value(L){Ae(this,o,"f").value=L}get isTrusted(){return Ae(this,o,"f").isTrusted}set isTrusted(L){Ae(this,o,"f").isTrusted=L}get supportThemeIcons(){return Ae(this,o,"f").supportThemeIcons}set supportThemeIcons(L){Ae(this,o,"f").supportThemeIcons=L}get supportHtml(){return Ae(this,o,"f").supportHtml}set supportHtml(L){Ae(this,o,"f").supportHtml=L}appendText(L){return Ae(this,o,"f").appendText(L),this}appendMarkdown(L){return Ae(this,o,"f").appendMarkdown(L),this}appendCodeblock(L,te){return Ae(this,o,"f").appendCodeblock(te??"",L),this}};o=new WeakMap,ot=g=Ue([I],ot),e.MarkdownString=ot;let ye=class{constructor(L,te){this.label=L,this.documentation=te}};ye=Ue([I],ye),e.ParameterInformation=ye;let nt=class{constructor(L,te){this.label=L,this.documentation=te,this.parameters=[]}};nt=Ue([I],nt),e.SignatureInformation=nt;let q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};q=Ue([I],q),e.SignatureHelp=q;var X;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(pe=e.InlayHintKind||(e.InlayHintKind={}));let $e=class{constructor(L,te,_e){this.text=L,this.position=te,this.kind=_e}};$e=Ue([I],$e),e.InlayHint=$e;var qe;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var rt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(rt=e.CompletionItemKind||(e.CompletionItemKind={}));var ft;(function(U){U[U.Deprecated=1]="Deprecated"})(ft=e.CompletionItemTag||(e.CompletionItemTag={}));let ht=class{constructor(L,te){this.label=L,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ht=Ue([I],ht),e.CompletionItem=ht;let Ct=class{constructor(L=[],te=!1){this.items=L,this.isIncomplete=te}};Ct=Ue([I],Ct),e.CompletionList=Ct;let It=class{constructor(L,te,_e){this.text=L,this.range=te,this.command=_e}};It=Ue([I],It),e.InlineSuggestion=It;let Pt=class{constructor(L){this.items=L}};Pt=Ue([I],Pt),e.InlineSuggestions=Pt;var Ze;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Ze=e.ViewColumn||(e.ViewColumn={}));var pt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(pt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ge;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ce;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Z;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Z=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var se;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(se=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var fe;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function L(te){switch(te){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(Z=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let he=class{constructor(L,te){if(te&&!k.URI.isUri(te))throw(0,M.illegalArgument)("target");if(!S.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.target=te}};he=Ue([I],he),e.DocumentLink=he;let ke=class{constructor(L,te,_e,Ve){this.red=L,this.green=te,this.blue=_e,this.alpha=Ve}};ke=Ue([I],ke),e.Color=ke;let Le=class{constructor(L,te){if(te&&!(te instanceof ke))throw(0,M.illegalArgument)("color");if(!S.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.color=te}};Le=Ue([I],Le),e.ColorInformation=Le;let Me=class{constructor(L){if(!L||typeof L!="string")throw(0,M.illegalArgument)("label");this.label=L}};Me=Ue([I],Me),e.ColorPresentation=Me;var He;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(He=e.ColorFormat||(e.ColorFormat={}));var it;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Re{constructor(L,te,_e){if(this.startIndex=L,this.length=te,this.tooltip=_e,typeof L!="number"||L<0)throw(0,M.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Re;var le;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(le=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(L){this.options=L,typeof L!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=me;var ne;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ne=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let be=s=class{constructor(L,te){if(this.label=te,typeof L!="string"||typeof te!="string")throw(0,M.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};be.Clean=new s("clean","Clean"),be.Build=new s("build","Build"),be.Rebuild=new s("rebuild","Rebuild"),be.Test=new s("test","Test"),be=s=Ue([I],be),e.TaskGroup=be;function De(U){let L="";for(let te=0;te<U.length;te++)L+=U[te].replace(/,/g,",,")+",";return L}let Ge=class{constructor(L,te,_e){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=L,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let te of this._args)L.push(te);return De(L)}};Ge=Ue([I],Ge),e.ProcessExecution=Ge;let xe=class{constructor(L,te,_e){if(this._args=[],Array.isArray(te)){if(!L)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L,this._args=te,this._options=_e}else{if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L,this._options=te}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)L.push(typeof te=="string"?te:te.value);return De(L)}};xe=Ue([I],xe),e.ShellExecution=xe;var lt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(lt=e.ShellQuoting||(e.ShellQuoting={}));var _t;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(_t=e.TaskScope||(e.TaskScope={}));class bt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=bt;let ct=b=class{constructor(L,te,_e,Ve,tt,st){this.__deprecated=!1,this._definition=this.definition=L;let ut;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=Ve,ut=tt,this.__deprecated=!0):te===_t.Global||te===_t.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=Ve,this.execution=tt,ut=st):(this.target=te,this._name=this.name=_e,this._source=this.source=Ve,this.execution=tt,ut=st),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof bt?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const te=this._definition.type;(b.EmptyType===te||b.ProcessType===te||b.ShellType===te||b.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ct.ExtensionCallbackType="customExecution",ct.ProcessType="process",ct.ShellType="shell",ct.EmptyType="$empty",ct=b=Ue([I],ct),e.Task=ct;var gt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(L,te=Tt.None){this.collapsibleState=te,k.URI.isUri(L)?this.resourceUri=L:this.label=L}};dt=Ue([I],dt),e.TreeItem=dt;var Tt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor(L,te){this.id=L,this.color=te}};yt=Ue([I],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let Bt=class{constructor(L){this.id=L}};Bt=Ue([I],Bt),e.ThemeColor=Bt;var Vt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Vt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let St=class{constructor(L,te){if(typeof L!="string"&&(!L||!k.URI.isUri(L)&&!k.URI.isUri(L.uri)))throw(0,M.illegalArgument)("base");if(typeof te!="string")throw(0,M.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=k.URI.file(L),this.base=L):k.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=te}};St=Ue([I],St),e.RelativePattern=St;let $t=class{constructor(L,te,_e,Ve){this.enabled=typeof L=="boolean"?L:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};$t=Ue([I],$t),e.Breakpoint=$t;let ti=class extends $t{constructor(L,te,_e,Ve,tt){super(te,_e,Ve,tt);if(L===null)throw(0,M.illegalArgument)("location");this.location=L}};ti=Ue([I],ti),e.SourceBreakpoint=ti;let wt=class extends $t{constructor(L,te,_e,Ve,tt){super(te,_e,Ve,tt);this.functionName=L}};wt=Ue([I],wt),e.FunctionBreakpoint=wt;let Qt=class extends $t{constructor(L,te,_e,Ve,tt,st,ut){super(Ve,tt,st,ut);if(!te)throw(0,M.illegalArgument)("dataId");this.label=L,this.dataId=te,this.canPersist=_e}};Qt=Ue([I],Qt),e.DataBreakpoint=Qt;let jt=class{constructor(L,te,_e){this.command=L,this.args=te||[],this.options=_e}};jt=Ue([I],jt),e.DebugAdapterExecutable=jt;let ii=class{constructor(L,te){this.port=L,this.host=te}};ii=Ue([I],ii),e.DebugAdapterServer=ii;let ni=class{constructor(L){this.path=L}};ni=Ue([I],ni),e.DebugAdapterNamedPipeServer=ni;let At=class{constructor(L){this.implementation=L}};At=Ue([I],At),e.DebugAdapterInlineImplementation=At;let Yt=class{constructor(L,te){this.range=L,this.expression=te}};Yt=Ue([I],Yt),e.EvaluatableExpression=Yt;var bi;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let zt=class{constructor(L,te){this.range=L,this.text=te}};zt=Ue([I],zt),e.InlineValueText=zt;let Ht=class{constructor(L,te,_e=!0){this.range=L,this.variableName=te,this.caseSensitiveLookup=_e}};Ht=Ue([I],Ht),e.InlineValueVariableLookup=Ht;let mt=class{constructor(L,te){this.range=L,this.expression=te}};mt=Ue([I],mt),e.InlineValueEvaluatableExpression=mt;let ri=class{constructor(L,te){this.frameId=L,this.stoppedLocation=te}};ri=Ue([I],ri),e.InlineValueContext=ri;var Ot;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Ot=e.FileChangeType||(e.FileChangeType={}));let Nt=u=class extends Error{constructor(L,te=_.FileSystemProviderErrorCode.Unknown,_e){super(k.URI.isUri(L)?L.toString(!0):L);this.code=_e?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(L){return new u(L,_.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(L){return new u(L,_.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(L){return new u(L,_.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(L){return new u(L,_.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(L){return new u(L,_.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(L){return new u(L,_.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};Nt=u=Ue([I],Nt),e.FileSystemError=Nt;let Xt=class{constructor(L,te,_e){this.start=L,this.end=te,this.kind=_e}};Xt=Ue([I],Xt),e.FoldingRange=Xt;var wi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(wi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var di;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(di=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ei;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(Ei=e.CommentMode||(e.CommentMode={}));class hi{constructor(L,te=[]){this.tokenTypes=L,this.tokenModifiers=te}}e.SemanticTokensLegend=hi;function Jt(U){return typeof U=="undefined"||(0,C.isStringArray)(U)}class oi{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let te=0,_e=L.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(L.tokenTypes[te],te);for(let te=0,_e=L.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(L.tokenModifiers[te],te)}}push(L,te,_e,Ve,tt){if(typeof L=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ve=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,te,_e,Ve,tt);if(S.isRange(L)&&typeof te=="string"&&Jt(_e))return this._push(L,te,_e);throw(0,M.illegalArgument)()}_push(L,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ve=L.start.line,tt=L.start.character,st=L.end.character-L.start.character,ut=this._tokenTypeStrToInt.get(te);let Dt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(Rt);Dt|=1<<Mt>>>0}this._pushEncoded(Ve,tt,st,ut,Dt)}_pushEncoded(L,te,_e,Ve,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Rt=0,Mt=0;for(let Lt=0;Lt<Dt;Lt++){let xt=this._data[5*Lt],ci=this._data[5*Lt+1];xt===0?(xt=Rt,ci+=Mt):xt+=Rt,this._data[5*Lt]=xt,this._data[5*Lt+1]=ci,Rt=xt,Mt=ci}}let st=L,ut=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=te}static _sortAndDeltaEncode(L){let te=[];const _e=L.length/5|0;for(let ut=0;ut<_e;ut++)te[ut]=ut;te.sort((ut,Dt)=>{const Rt=L[5*ut],Mt=L[5*Dt];if(Rt===Mt){const Lt=L[5*ut+1],xt=L[5*Dt+1];return Lt-xt}return Rt-Mt});const Ve=new Uint32Array(L.length);let tt=0,st=0;for(let ut=0;ut<_e;ut++){const Dt=5*te[ut],Rt=L[Dt+0],Mt=L[Dt+1],Lt=L[Dt+2],xt=L[Dt+3],ci=L[Dt+4],Bi=Rt-tt,Ki=Bi===0?Mt-st:Mt,ui=5*ut;Ve[ui+0]=Bi,Ve[ui+1]=Ki,Ve[ui+2]=Lt,Ve[ui+3]=xt,Ve[ui+4]=ci,tt=Rt,st=Mt}return Ve}build(L){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),L):new qt(oi._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=oi;class qt{constructor(L,te){this.resultId=te,this.data=L}}e.SemanticTokens=qt;class si{constructor(L,te,_e){this.start=L,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=si;class _i{constructor(L,te){this.resultId=te,this.edits=L}}e.SemanticTokensEdits=_i;var yi;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Gt;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Gt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Zt=class{constructor(){}};Zt.Back={iconPath:new yt("arrow-left")},Zt=Ue([I],Zt),e.QuickInputButtons=Zt;var Si;(function(U){U[U.Default=1]="Default",U[U.Separator=2]="Separator"})(Si=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Ci;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Ci=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(L,te,_e){this.badge=L,this.tooltip=te,this.color=_e}static validate(L){if(L.badge){let te=(0,R.nextCharLength)(L.badge,0);if(te<L.badge.length&&(te+=(0,R.nextCharLength)(L.badge,te)),L.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Di;let Kt=class{constructor(L){this.kind=L}};Kt=Ue([I],Kt),e.ColorTheme=Kt;var fi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(fi=e.ColorThemeKind||(e.ColorThemeKind={}));class Wt{constructor(L,te){if(L<0)throw(0,M.illegalArgument)("start must be positive");if(te<0)throw(0,M.illegalArgument)("end must be positive");L<=te?(this._start=L,this._end=te):(this._start=te,this._end=L)}static isNotebookRange(L){return L instanceof Wt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let te=this._start,_e=this._end;return L.start!==void 0&&(te=L.start),L.end!==void 0&&(_e=L.end),te===this._start&&_e===this._end?this:new Wt(te,_e)}}e.NotebookRange=Wt;class Pe{constructor(L,te,_e,Ve,tt,st,ut){this.kind=L,this.value=te,this.languageId=_e,this.mime=Ve,this.outputs=tt??[],this.metadata=st,this.executionSummary=ut,Pe.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(te=>Pe.isNotebookCellData(te))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Pe;class ai{constructor(L){this.cells=L}}e.NotebookData=ai;class Ft{constructor(L,te){this.data=L,this.mime=te;const _e=(0,t.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(L){return L instanceof Ft?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const te={name:L.name,message:L.message,stack:L.stack};return Ft.json(te,"application/vnd.code.notebook.error")}static stdout(L){return Ft.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Ft.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,te="application/octet-stream"){return new Ft(L,te)}static text(L,te=t.Mimes.text){const _e=Ae(Ft,d,"f",p).encode(String(L));return new Ft(_e,te)}static json(L,te="application/json"){const _e=JSON.stringify(L,void 0,"	");return Ft.text(_e,te)}}e.NotebookCellOutputItem=Ft,d=Ft,p={value:new TextEncoder};class vt{constructor(L,te,_e){this.items=vt.ensureUniqueMimeTypes(L,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,F.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(L){return L instanceof vt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,C.isArray)(L.items)}static ensureUniqueMimeTypes(L,te=!1){const _e=new Set,Ve=new Set;for(let tt=0;tt<L.length;tt++){const st=L[tt],ut=(0,t.normalizeMimeType)(st.mime);if(!_e.has(ut)){_e.add(ut);continue}Ve.add(tt),te&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return Ve.size===0?L:L.filter((tt,st)=>!Ve.has(st))}}e.NotebookCellOutput=vt;var ki;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Ii;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Ii=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var mi;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(mi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pi{constructor(L,te){this.text=L,this.alignment=te}}e.NotebookCellStatusBarItem=Pi;var Ti;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Ti=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ai{constructor(L,te=[]){this.uri=L,this.provides=(0,c.asArray)(te)}}e.NotebookRendererScript=Ai;let li=class{constructor(L,te){this.label=L,this.timestamp=te}};li=Ue([I],li),e.TimelineItem=li;var pi;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(pi=e.ExtensionMode||(e.ExtensionMode={}));var Ri;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Ri=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fi;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Fi=e.StandardTokenType||(e.StandardTokenType={}));class Mi{constructor(L,te){this.ranges=L,this.wordPattern=te}}e.LinkedEditingRanges=Mi;class Li{constructor(L,te){this._port=L,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Li;var Oi;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Oi=e.TestResultState||(e.TestResultState={}));var Y;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(Y=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ae=class{constructor(L=void 0,te=void 0,_e=void 0){this.include=L,this.exclude=te,this.profile=_e}};ae=Ue([I],ae),e.TestRunRequest=ae;let Se=E=class{constructor(L){this.message=L}static diff(L,te,_e){const Ve=new E(L);return Ve.expectedOutput=te,Ve.actualOutput=_e,Ve}};Se=E=Ue([I],Se),e.TestMessage=Se;let at=class{constructor(L){this.id=L}};at=Ue([I],at),e.TestTag=at;let Et=class{constructor(L,te){this.covered=L,this.total=te}};Et=Ue([I],Et),e.CoveredCount=Et;let kt=A=class{constructor(L,te,_e,Ve){this.uri=L,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=Ve}static fromDetails(L,te){const _e=new Et(0,0),Ve=new Et(0,0),tt=new Et(0,0);for(const ut of te)if("branches"in ut){_e.total+=1,_e.covered+=ut.executionCount>0?1:0;for(const Dt of ut.branches)Ve.total+=1,Ve.covered+=Dt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ut.executionCount>0?1:0;const st=new A(L,_e,Ve.total>0?Ve:void 0,tt.total>0?tt:void 0);return st.detailedCoverage=te,st}};kt=A=Ue([I],kt),e.FileCoverage=kt;let Ni=class{constructor(L,te,_e=[]){this.executionCount=L,this.location=te,this.branches=_e}};Ni=Ue([I],Ni),e.StatementCoverage=Ni;let xi=class{constructor(L,te){this.executionCount=L,this.location=te}};xi=Ue([I],xi),e.BranchCoverage=xi;let Ui=class{constructor(L,te){this.executionCount=L,this.location=te}};Ui=Ue([I],Ui),e.FunctionCoverage=Ui;var Vi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Vi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var ji;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(ji=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qi;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Gi{constructor(L,te,_e,Ve,tt,st){this.kind=L,this.name=te,this.detail=_e,this.uri=Ve,this.range=tt,this.selectionRange=st}}e.TypeHierarchyItem=Gi}),define(we[87],Ee([0,1,41,11,9,228,118,6,16]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function F(o,d){d?k.set(o,d):k.delete(o)}e.setWordDefinitionFor=F;function _(o){return k.get(o)}e.getWordDefinitionFor=_;class r extends T.MirrorTextModel{constructor(d,p,D,f,l,h,y,a){super(p,D,f,l);this._proxy=d,this._languageId=h,this._isDirty=y,this._notebook=a,this._isDisposed=!1}dispose(){(0,c.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,C.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===M.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(p){return p?d._getTextInRange(p):d.getText()},get eol(){return d._eol===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(p){return d._lineAt(p)},offsetAt(p){return d._offsetAt(p)},positionAt(p){return d._positionAt(p)},validateRange(p){return d._validateRange(p)},validatePosition(p){return d._validatePosition(p)},getWordRangeAtPosition(p,D){return d._getWordRangeAtPosition(p,D)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,c.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,c.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const p=this._validateRange(d);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const D=this._eol,f=p.start.line,l=p.end.line,h=[];h.push(this._lines[f].substring(p.start.character));for(let y=f+1;y<l;y++)h.push(this._lines[y]);return h.push(this._lines[l].substring(0,p.end.character)),h.join(D)}_lineAt(d){let p;if(d instanceof R.Position?p=d.line:typeof d=="number"&&(p=d),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new m(p,this._lines[p],p===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(d),D=this._lines[p.index].length;return new R.Position(p.index,Math.min(p.remainder,D))}_validateRange(d){if(!(d instanceof R.Range))throw new Error("Invalid argument");const p=this._validatePosition(d.start),D=this._validatePosition(d.end);return p===d.start&&D===d.end?d:new R.Range(p.line,p.character,D.line,D.character)}_validatePosition(d){if(!(d instanceof R.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:p,character:D}=d,f=!1;if(p<0)p=0,D=0,f=!0;else if(p>=this._lines.length)p=this._lines.length-1,D=this._lines[p].length,f=!0;else{const l=this._lines[p].length;D<0?(D=0,f=!0):D>l&&(D=l,f=!0)}return f?new R.Position(p,D):d}_getWordRangeAtPosition(d,p){const D=this._validatePosition(d);if(!p)p=_(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const f=(0,t.getWordAtText)(D.character+1,(0,t.ensureValidWordDefinition)(p),this._lines[D.line],0);if(f)return new R.Range(D.line,f.startColumn-1,D.line,f.endColumn-1)}}e.ExtHostDocumentData=r;class m{constructor(d,p,D){this._line=d,this._text=p,this._isLastLine=D}get lineNumber(){return this._line}get text(){return this._text}get range(){return new R.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new R.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(we[154],Ee([0,1,6,3,229,7,56,21,2,36]),function(re,e,c,M,w,T,t,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(r,m,o,d){this._notebook=o,this._selector=d,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(D=>{const f=this._cellUris.get(D.document.uri);f!==void 0&&(this._cellLengths.setValue(f,this._cells[f].document.getText().length+1),this._cellLines.setValue(f,this._cells[f].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=D=>{D===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(r.onDidChangeNotebookCells(D=>p(D.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new R.ResourceMap;const r=[],m=[];for(const o of this._notebook.getCells())o.kind===c.NotebookCellKind.Code&&(!this._selector||(0,t.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),r.push(o.document.getText().length+1),m.push(o.document.lineCount));this._cellLengths=new w.PrefixSumComputer(new Uint32Array(r)),this._cellLines=new w.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(r){if(!r){let f="";for(const l of this._cells)f+=l.document.getText()+`
`;return f=f.slice(0,-1),f}if(r.isEmpty)return"";const m=this.locationAt(r.start),o=this.locationAt(r.end),d=this._cellUris.get(m.uri),p=this._cellUris.get(o.uri);if(d===void 0||p===void 0)return"";if(d===p)return this._cells[d].document.getText(new c.Range(m.range.start,o.range.end));const D=[this._cells[d].document.getText(new c.Range(m.range.start,new c.Position(this._cells[d].document.lineCount,0)))];for(let f=d+1;f<p;f++)D.push(this._cells[f].document.getText());return D.push(this._cells[p].document.getText(new c.Range(new c.Position(0,0),o.range.end))),D.join(`
`)}offsetAt(r){const m=this._cellLines.getIndexOf(r.line),o=this._cellLengths.getPrefixSum(m.index-1),d=this._cells[m.index].document.offsetAt(r.with(m.remainder));return o+d}positionAt(r){if(typeof r=="number"){const o=this._cellLengths.getIndexOf(r),d=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(d)}const m=this._cellUris.get(r.uri);if(m!==void 0){const o=this._cellLines.getPrefixSum(m-1);return new c.Position(o+r.range.start.line,r.range.start.character)}return new c.Position(0,0)}locationAt(r){c.Range.isRange(r)||(r=new c.Range(r,r));const m=this._cellLines.getIndexOf(r.start.line);let o=m;r.isEmpty||(o=this._cellLines.getIndexOf(r.end.line));const d=new c.Position(m.remainder,r.start.character),p=new c.Position(o.remainder,r.end.character),D=new c.Range(d,p),f=this._cells[m.index];return new c.Location(f.document.uri,f.document.validateRange(D))}contains(r){return this._cellUris.has(r)}validateRange(r){const m=this.validatePosition(r.start),o=this.validatePosition(r.end);return r.with(m,o)}validatePosition(r){const m=this._cellLines.getIndexOf(r.line),o=new c.Position(m.remainder,r.character),d=this._cells[m.index].document.validatePosition(o),p=this._cellLines.getPrefixSum(m.index-1);return new c.Position(p+d.line,d.character)}}e.ExtHostNotebookConcatDocument=F}),define(we[155],Ee([0,1,6,13,3]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(R){this._actual=new c.ColorTheme(c.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(R){let C=R==="light"?c.ColorThemeKind.Light:R==="dark"?c.ColorThemeKind.Dark:c.ColorThemeKind.HighContrast;this._actual=new c.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ue([Be(0,M.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(we[66],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,c.createDecorator)("IURITransformerService");class M{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=t=>t,this.transformOutgoing=t=>t,this.transformOutgoingURI=t=>t,this.transformOutgoingScheme=t=>t)}}e.URITransformerService=M}),define(we[156],Ee([0,1,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(C){let k=this.buffers.indexOf(C);return k<0&&(k=this.buffers.length,this.buffers.push(C)),k}}function w(R,C){if(C.serializeBuffersForPostMessage){const k=new M,F=(m,o)=>{if(o instanceof ArrayBuffer){const d=k.add(o);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(o)){const d=T(o);if(d){const p=k.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:d,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},_=JSON.stringify(R,F),r=k.buffers.map(m=>{const o=new Uint8Array(m);return c.VSBuffer.wrap(o)});return{message:_,buffers:r}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=w;function T(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function t(R,C){const k=C.map(r=>{const m=new ArrayBuffer(r.byteLength);return new Uint8Array(m).set(r.buffer),m}),F=C.length?(r,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const o=m,{index:d}=o,p=k[d];if(o.view)switch(o.view.type){case 1:return new Int8Array(p,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return m}:void 0;return{message:JSON.parse(R,F),arrayBuffers:k}}e.deserializeWebviewMessage=t}),define(we[157],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var c;(function(M){function w(t){const R={items:new Map};return t.types.forEach((C,k)=>{R.items.set(C,{asString:async()=>t.items[k].asString})}),R}M.toITreeDataTransfer=w;async function T(t){const R={types:[],items:[]},C=Array.from(t.items.entries());for(const k of C)R.types.push(k[0]),R.items.push({asString:await k[1].asString()});return R}M.toTreeDataTransferDTO=T})(c=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[67],Ee([0,1,11,2]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function w(R,C){return R.scheme===c.Schemas.http||R.scheme===c.Schemas.https?R:(C&&C.authority&&C.isRemote&&R.scheme===c.Schemas.file&&(R=M.URI.from({scheme:c.Schemas.vscodeRemote,authority:C.authority,path:R.path})),M.URI.from({scheme:c.Schemas.https,authority:`${R.scheme}+${T(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=w;function T(R){return R.replace(/./g,C=>{const k=C.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?C:"-"+k.toString(16).padStart(4,"0")})}function t(R){return R.replace(/-([0-9a-f]{4})/g,(C,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=t}),define(we[158],Ee([0,1,3,7,67]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(R,C,k){this._proxy=R,this._editors=C,this._initData=k,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const F=C.getVisibleTextEditors();for(const _ of this._insets.values())F.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(R=>R.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(R,C,k,F,_){let r;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===R){r=l;break}if(!r)throw new Error("not a visible editor");const m=this,o=this._handlePool++,d=new c.Emitter,p=new c.Emitter,D=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,w.asWebviewUri)(l,m._initData.remote)}get cspSource(){return w.webviewGenericCspSource}set options(l){this._options=l,m._proxy.$setOptions(o,l)}get options(){return this._options}set html(l){this._html=l,m._proxy.$setHtml(o,l)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(l){return m._proxy.$postMessage(o,l)}},f=new class{constructor(){this.editor=R,this.line=C,this.height=k,this.webview=D,this.onDidDispose=p.event}dispose(){m._insets.has(o)&&(m._insets.delete(o),m._proxy.$disposeEditorInset(o),p.fire(),p.dispose(),d.dispose())}};return this._proxy.$createEditorInset(o,r.id,r.value.document.uri,C+1,k,F||{},_.identifier,_.extensionLocation),this._insets.set(o,{editor:R,inset:f,onDidReceiveMessage:d}),f}$onDidDispose(R){const C=this._insets.get(R);C&&C.inset.dispose()}$onDidReceiveMessage(R,C){const k=this._insets.get(R);k&&k.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=T}),define(we[159],Ee([0,1,130,10,2,7,4,45,30,46,16,11]),function(re,e,c,M,w,T,t,R,C,k,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,c.localize)(0,null),providerDisplayName:(0,c.localize)(1,null)},e.ActiveEditorDirtyContext=new R.RawContextKey("activeEditorIsDirty",!1,(0,c.localize)(2,null)),e.ActiveEditorPinnedContext=new R.RawContextKey("activeEditorIsNotPreview",!1,(0,c.localize)(3,null)),e.ActiveEditorStickyContext=new R.RawContextKey("activeEditorIsPinned",!1,(0,c.localize)(4,null)),e.ActiveEditorReadonlyContext=new R.RawContextKey("activeEditorIsReadonly",!1,(0,c.localize)(5,null)),e.ActiveEditorCanRevertContext=new R.RawContextKey("activeEditorCanRevert",!1,(0,c.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new R.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new R.RawContextKey("activeEditor",null,{type:"string",description:(0,c.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new R.RawContextKey("activeEditorAvailableEditorIds","",(0,c.localize)(8,null)),e.TextCompareEditorVisibleContext=new R.RawContextKey("textCompareEditorVisible",!1,(0,c.localize)(9,null)),e.TextCompareEditorActiveContext=new R.RawContextKey("textCompareEditorActive",!1,(0,c.localize)(10,null)),e.SideBySideEditorActiveContext=new R.RawContextKey("sideBySideEditorActive",!1,(0,c.localize)(11,null)),e.EditorGroupEditorsCountContext=new R.RawContextKey("groupEditorsCount",0,(0,c.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new R.RawContextKey("activeEditorGroupEmpty",!1,(0,c.localize)(13,null)),e.ActiveEditorGroupIndexContext=new R.RawContextKey("activeEditorGroupIndex",0,(0,c.localize)(14,null)),e.ActiveEditorGroupLastContext=new R.RawContextKey("activeEditorGroupLast",!1,(0,c.localize)(15,null)),e.ActiveEditorGroupLockedContext=new R.RawContextKey("activeEditorGroupLocked",!1,(0,c.localize)(16,null)),e.MultipleEditorGroupsContext=new R.RawContextKey("multipleEditorGroups",!1,(0,c.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new R.RawContextKey("editorIsOpen",!1,(0,c.localize)(18,null)),e.InEditorZenModeContext=new R.RawContextKey("inZenMode",!1,(0,c.localize)(19,null)),e.IsCenteredLayoutContext=new R.RawContextKey("isCenteredLayout",!1,(0,c.localize)(20,null)),e.SplitEditorsVertically=new R.RawContextKey("splitEditorsVertically",!1,(0,c.localize)(21,null)),e.EditorAreaVisibleContext=new R.RawContextKey("editorAreaVisible",!0,(0,c.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function r(O,S,x){for(const N of x.visibleEditorPanes)if(N.group.id===S&&O.matches(N.input))return N.getViewState()}e.findViewStateForEditor=r;function m(O){if(y(O))return!1;const S=O;return w.URI.isUri(S?.resource)}e.isResourceEditorInput=m;function o(O){if(y(O))return!1;const S=O;return S?.original!==void 0&&S.modified!==void 0}e.isResourceDiffEditorInput=o;function d(O){if(y(O)||o(O))return!1;const S=O;return S?.primary!==void 0&&S.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function p(O){if(y(O))return!1;const S=O;return S?S.resource===void 0||S.resource.scheme===_.Schemas.untitled||S.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;var D;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var f;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f=e.SaveReason||(e.SaveReason={}));var l;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(l=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class h extends T.Disposable{}e.AbstractEditorInput=h;function y(O){return O instanceof h}e.isEditorInput=y;function a(O){const S=O;return w.URI.isUri(S?.preferredResource)}function P(O){const S=O;return y(S?.primary)&&y(S?.secondary)}e.isSideBySideEditorInput=P;function n(O){const S=O;return y(S?.modified)&&y(S?.original)}e.isDiffEditorInput=n;function i(O){return y(O?.editor)}e.isEditorInputWithOptions=i;function v(O){const S=O;return i(O)&&S?.group!==void 0}e.isEditorInputWithOptionsAndGroup=v;function g(O){const S=O;return typeof S?.groupId=="number"&&y(S.editor)}e.isEditorIdentifier=g;var s;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var b;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(b=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(S,x){if(!S)return;if(x?.supportSideBySide){const{primary:V,secondary:$}=this.getSideEditors(S);if(V&&$){if(x?.supportSideBySide===b.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri($,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getOriginalUri(V,{filterByScheme:x.filterByScheme})??this.getOriginalUri($,{filterByScheme:x.filterByScheme});S=x.supportSideBySide===b.PRIMARY?V:$}}if(o(S)||d(S))return;const N=a(S)?S.preferredResource:S.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}getSideEditors(S){return P(S)||d(S)?{primary:S.primary,secondary:S.secondary}:n(S)||o(S)?{primary:S.modified,secondary:S.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(S,x){if(!S)return;if(x?.supportSideBySide){const{primary:V,secondary:$}=this.getSideEditors(S);if(V&&$){if(x?.supportSideBySide===b.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri($,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getCanonicalUri(V,{filterByScheme:x.filterByScheme})??this.getCanonicalUri($,{filterByScheme:x.filterByScheme});S=x.supportSideBySide===b.PRIMARY?V:$}}if(o(S)||d(S))return;const N=S.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}filterUri(S,x){if(Array.isArray(x)){if(x.some(N=>S.scheme===N))return S}else if(x===S.scheme)return S}}e.EditorResourceAccessor=new u;var E;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(E=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(S){const x=this.instantiationService=S.get(t.IInstantiationService);for(const[N,V]of this.editorSerializerConstructors)this.createEditorSerializer(N,V,x);this.editorSerializerConstructors.clear()}createEditorSerializer(S,x,N){const V=N.createInstance(x);this.editorSerializerInstances.set(S,V)}registerFileEditorFactory(S){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=S}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(S,x){if(this.editorSerializerConstructors.has(S)||this.editorSerializerInstances.has(S))throw new Error(`A editor serializer with type ID '${S}' was already registered.`);return this.instantiationService?this.createEditorSerializer(S,x,this.instantiationService):this.editorSerializerConstructors.set(S,x),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(S),this.editorSerializerInstances.delete(S)})}getEditorSerializer(S){return this.editorSerializerInstances.get(typeof S=="string"?S:S.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new A);async function I(O,S){if(!O||!O.length)return[];const x=await Promise.all(O.map(async N=>{const V=w.URI.revive(N.fileUri);if(!V||!await S.canHandleResource(V))return;let z=N.exists,ee=N.type;if(typeof z!="boolean"||typeof ee!="number")try{ee=(await S.resolve(V)).isFile?k.FileType.File:k.FileType.Unknown,z=!0}catch{z=!1}if(!z&&N.openOnlyIfExists||ee!==k.FileType.File)return;const j={selection:z?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let Q;return z?Q={resource:V,options:j}:Q={resource:V,options:j,forceUntitled:!0},Q}));return(0,F.coalesce)(x)}e.pathsToEditors=I;var B;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[160],Ee([0,1,3,14,131]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new c.Emitter,this._onExit=new c.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(R){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=R}onEvent(R){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=R}onRequest(R){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=R}sendResponse(R){R.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.internalSend("response",R)}sendRequest(R,C,k,F){const _={command:R};if(C&&Object.keys(C).length>0&&(_.arguments=C),this.internalSend("request",_),typeof F=="number"){const r=setTimeout(()=>{clearTimeout(r);const m=this.pendingRequests.get(_.seq);if(m){this.pendingRequests.delete(_.seq);const o={type:"response",seq:0,request_seq:_.seq,success:!1,command:R,message:(0,w.localize)(0,null,F,R)};m(o)}},F)}return k&&this.pendingRequests.set(_.seq,k),_.seq}acceptMessage(R){this.messageCallback?this.messageCallback(R):(this.queue.push(R),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(R,C){return R.type!=="event"||C.type!=="event"}async processQueue(){let R;for(;this.queue.length;){if((!R||this.needsTaskBoundaryBetween(this.queue[0],R))&&await(0,M.timeout)(0),R=this.queue.shift(),!R)return;switch(R.type){case"event":this.eventCallback&&this.eventCallback(R);break;case"request":this.requestCallback&&this.requestCallback(R);break;case"response":const C=R,k=this.pendingRequests.get(C.request_seq);k&&(this.pendingRequests.delete(C.request_seq),k(C));break}}}internalSend(R,C){C.type=R,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const R=new Map;this.pendingRequests.forEach((C,k)=>R.set(k,C)),await(0,M.timeout)(500),R.forEach((C,k)=>{C({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(we[161],Ee([0,1,9,2,17,25,11]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const R=/{([^}]+)}/g;function C(n,i,v){return n.replace(R,function(g,s){return i&&s.length>0&&s[0]!=="_"?g:v&&v.hasOwnProperty(s)?v[s]:g})}e.formatPII=C;function k(n){const i={};for(const v of Object.keys(n))v.startsWith("!")||(i[v]=n[v]);return i}e.filterExceptionsFromTelemetry=k;function F(n){return n.configuration.request==="attach"&&!_(n)&&(!n.parentSession||F(n.parentSession))}e.isSessionAttach=F;function _(n){let i=n.configuration.type;if(!!i)return i==="vslsShare"&&(i=n.configuration.adapterProxy.configuration.type),(0,c.equalsIgnoreCase)(i,"extensionhost")||(0,c.equalsIgnoreCase)(i,"pwa-extensionhost")?n:n.parentSession?_(n.parentSession):void 0}e.getExtensionHostDebugSession=_;function r(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=r;function m(n,i,v){let g,s=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,u=null;for(;u=b.exec(n);){let E=u.index+1,A=E+u[0].length;if(E<=i&&A>=v){g=u[0],s=E;break}}if(g){let E=/\w+/g,A=null;for(;(A=E.exec(g))&&!(A.index+1+s+A[0].length>=v););A&&(g=g.substring(0,E.lastIndex))}return g?{start:s,end:s+g.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(n){return!!(n&&n.match(o))}e.isUri=d;function p(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(d(n.path))return M.URI.parse(n.path);if((0,w.isAbsolute)(n.path))return M.URI.file(n.path)}return n.path}function D(n){if(typeof n.path=="object"){const i=M.URI.revive(n.path);if(i)return i.scheme===t.Schemas.file?i.fsPath:i.toString()}return n.path}function f(n,i){const v=i?p:D,g=(0,T.deepClone)(n);return h(g,(s,b)=>{s&&b&&(b.path=v(b))}),g}e.convertToDAPaths=f;function l(n,i){const v=i?p:D,g=(0,T.deepClone)(n);return h(g,(s,b)=>{!s&&b&&(b.path=v(b))}),g}e.convertToVSCPaths=l;function h(n,i){switch(n.type){case"event":const v=n;switch(v.event){case"output":i(!1,v.body.source);break;case"loadedSource":i(!1,v.body.source);break;case"breakpoint":i(!1,v.body.breakpoint.source);break;default:break}break;case"request":const g=n;switch(g.command){case"setBreakpoints":i(!0,g.arguments.source);break;case"breakpointLocations":i(!0,g.arguments.source);break;case"source":i(!0,g.arguments.source);break;case"gotoTargets":i(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(b=>i(!1,b));break;default:break}break;case"response":const s=n;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(b=>i(!1,b.source));break;case"loadedSources":s.body.sources.forEach(b=>i(!1,b));break;case"scopes":s.body.scopes.forEach(b=>i(!1,b.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(b=>i(!1,b.source));break;case"setBreakpoints":s.body.breakpoints.forEach(b=>i(!1,b.source));break;default:break}break}}function y(n){return n.filter(i=>!i.presentation?.hidden).sort((i,v)=>i.presentation?v.presentation?i.presentation.group?v.presentation.group?i.presentation.group!==v.presentation.group?i.presentation.group.localeCompare(v.presentation.group):a(i.presentation.order,v.presentation.order):-1:v.presentation.group?1:a(i.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.getVisibleAndSorted=y;function a(n,i){return typeof n!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:n-i}async function P(n,i){const v=n.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(v!=="none"&&(await i.saveAll(),v==="allEditorsInActiveGroup")){const g=i.activeEditorPane;g&&await i.save({editor:g.input,groupId:g.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=P}),define(we[88],Ee([0,1,29,162,79,11,17,24,45]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var r;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(r=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var D;(function(E){E.scheme=T.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function I(N,V){return N.with({scheme:E.scheme,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==T.Schemas.file?N.scheme:""}`})}E.generate=I;function B(N){if(N.scheme!==E.scheme)return;const V=A.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||T.Schemas.file,fragment:null})}:void 0}E.parse=B;function O(N){if(N.scheme!==T.Schemas.vscodeNotebookCellMetadata)return;const V=A.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||T.Schemas.file,fragment:null})}:void 0}E.parseCellMetadataUri=O;function S(N,V,$){return N.with({scheme:$,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==T.Schemas.file?N.scheme:""}`})}E.generateCellUri=S;function x(N,V){if(N.scheme!==V)return;const $=A.exec(N.fragment);return $?{handle:Number($[1]),notebook:N.with({scheme:N.fragment.substr($[0].length)||T.Schemas.file,fragment:null})}:void 0}E.parseCellUri=x})(D=e.CellUri||(e.CellUri={}));const f=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function l(E){return f.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=l;function h(E){return f.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=h;function y(E){return f.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=y;const a=E=>R.isWindows?E.replace(/\//g,"\\"):E;class P{constructor(A=[],I=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=I,this.order=[...new Set(A)].map(B=>({pattern:B,matches:c.parse(a(B))}))}sort(A){const I=new Map(M.Iterable.map(A,O=>[O,a(O)]));let B=[];for(const{matches:O}of this.order)for(const[S,x]of I)if(O(x)){B.push(S),I.delete(S);break}return I.size&&(B=B.concat([...I.keys()].sort((O,S)=>this.defaultOrder.indexOf(O)-this.defaultOrder.indexOf(S)))),B}prioritize(A,I){const B=this.findIndex(A);if(B===-1){this.order.unshift({pattern:A,matches:c.parse(a(A))});return}const O=new Set(I.map(x=>this.findIndex(x,B)));O.delete(-1);const S=Array.from(O).sort();this.order.splice(B+1,0,...S.map(x=>this.order[x]));for(let x=S.length-1;x>=0;x--)this.order.splice(S[x],1)}toArray(){return this.order.map(A=>A.pattern)}findIndex(A,I=this.order.length){const B=a(A);for(let O=0;O<I;O++)if(this.order[O].matches(B))return O;return-1}}e.MimeTypeDisplayOrder=P;function n(E,A,I,B=(O,S)=>O===S){const O=[];function S(V,$,z){if($===0&&z.length===0)return;const ee=O[O.length-1];ee&&ee.start+ee.deleteCount===V?(ee.deleteCount+=$,ee.toInsert.push(...z)):O.push({start:V,deleteCount:$,toInsert:z})}let x=0,N=0;for(;;){if(x===E.length){S(x,0,A.slice(N));break}if(N===A.length){S(x,E.length-x,[]);break}const V=E[x],$=A[N];if(B(V,$)){x+=1,N+=1;continue}I($)?(S(x,1,[]),x+=1):(S(x,0,[$]),N+=1)}return O}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(E){E.default="default",E.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function v(E){const A=E;return!!((typeof A.include=="string"||c.isRelativePattern(A.include))&&(typeof A.exclude=="string"||c.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=v;function g(E,A,I){if(Array.isArray(E.viewType)&&E.viewType.indexOf(A)>=0||E.viewType===A)return!0;if(E.filenamePattern){let B=v(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,O=v(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(c.match(B,(0,t.basename)(I.fsPath).toLowerCase()))return!(O&&c.match(O,(0,t.basename)(I.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=g;class s{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let I=0;I<this.textModel.cells.length;I++)A[I]=this.textModel.cells[I].getHashValue();return A}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var b;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(A){return`${u._prefix}${A}`}static parse(A){if(A.startsWith(u._prefix))return A.substr(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(we[163],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState",w[w.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,c.createDecorator)("INotebookExecutionService")}),define(we[164],Ee([0,1,4,45]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new M.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new M.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new M.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,c.createDecorator)(e.OUTPUT_SERVICE_ID);var w;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(we[165],Ee([0,1,133,4,45]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new w.RawContextKey("customExecutionSupported",!0,c.localize(0,null)),e.ShellExecutionSupportedContext=new w.RawContextKey("shellExecutionSupported",!1,c.localize(1,null)),e.ProcessExecutionSupportedContext=new w.RawContextKey("processExecutionSupported",!1,c.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[166],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function c(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=c;function M(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=M}),define(we[89],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var c;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(c=e.TestResultState||(e.TestResultState={}));var M;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var w;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(w=e.TestMessageType||(e.TestMessageType={}));var T;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const t=(_,r)=>{r.expand!==void 0&&(_.expand=r.expand),r.item!==void 0&&(_.item=_.item?Object.assign(_.item,r.item):r.item)};e.applyTestItemUpdate=t;var R;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(R=e.DetailType||(e.DetailType={}));var C;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(r){}update(r){}remove(r,m){}complete(){}}e.IncrementalChangeCollector=k;class F{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(r){const m=this.createChangeCollector();for(const o of r)switch(o[0]){case 0:{const d=o[1];if(d.parent){if(this.items.has(d.parent)){const p=this.items.get(d.parent);p.children.add(d.item.extId);const D=this.createItem(d,p);this.items.set(d.item.extId,D),m.add(D)}}else{const p=this.createItem(d);this.roots.add(p),this.items.set(d.item.extId,p),m.add(p)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=o[1],p=this.items.get(d.extId);if(!p)break;d.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,d),m.update(p);break}case 2:{const d=this.items.get(o[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d);const p=[[o[1]]];for(;p.length;)for(const D of p.pop()){const f=this.items.get(D);f&&(p.push(f.children),this.items.delete(D),m.remove(f,f!==d),f.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}m.complete()}retireTest(r){}updatePendingRoots(r){this.pendingRootCount+=r}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=F}),define(we[68],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var c;(function(T){T.Delimiter="\0"})(c=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class w{constructor(t,R=t.length){if(this.path=t,this.viewEnd=R,t.length===0||R<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(t,R,C=t.parent){if(t.id===R)return new w([R]);let k=[t.id];for(let F=C;F&&F.id!==R;F=F.parent)k.push(F.id);return k.push(R),new w(k.reverse())}static isRoot(t){return!t.includes("\0")}static fromString(t){return new w(t.split("\0"))}static join(t,R){return new w([...t.path,R])}static joinToString(t,R){return t.toString()+"\0"+R}static compare(t,R){return t===R?0:R.startsWith(t+"\0")?2:t.startsWith(R+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let t=1;t<=this.viewEnd;t++)yield new w(this.path,t)}compare(t){if(typeof t=="string")return w.compare(this.toString(),t);for(let R=0;R<t.viewEnd&&R<this.viewEnd;R++)if(t.path[R]!==this.path[R])return 1;return t.viewEnd>this.viewEnd?2:t.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let t=1;t<this.viewEnd;t++)this.stringifed+="\0",this.stringifed+=this.path[t]}return this.stringifed}}e.TestId=w}),define(we[167],Ee([0,1,17,90,10,25,24,78,134]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(_,r,m){this._contributedVariables=new Map,this._context=_,this._labelService=r,m&&(this._envVariablesPromise=m.then(o=>this.prepareEnv(o)))}prepareEnv(_){if(t.isWindows){const r=Object.create(null);return Object.keys(_).forEach(m=>{r[m.toLowerCase()]=_[m]}),r}return _}resolveWithEnvironment(_,r,m){return this.recursiveResolve(this.prepareEnv(_),r?r.uri:void 0,m)}async resolveAsync(_,r){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,r)}async resolveAnyBase(_,r,m,o){const d=T.deepClone(r);return t.isWindows&&d.windows?Object.keys(d.windows).forEach(p=>d[p]=d.windows[p]):t.isMacintosh&&d.osx?Object.keys(d.osx).forEach(p=>d[p]=d.osx[p]):t.isLinux&&d.linux&&Object.keys(d.linux).forEach(p=>d[p]=d.linux[p]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,d,m,o)}async resolveAnyAsync(_,r,m){return this.resolveAnyBase(_,r,m)}async resolveAnyMap(_,r,m){const o=new Map;return{newConfig:await this.resolveAnyBase(_,r,m,o),resolvedVariables:o}}resolveWithInteractionReplace(_,r,m,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,r,m,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,r){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,r)}recursiveResolve(_,r,m,o,d){if(w.isString(m))return this.resolveString(_,r,m,o,d);if(w.isArray(m))return m.map(p=>this.recursiveResolve(_,r,p,o,d));if(w.isObject(m)){let p=Object.create(null);return Object.keys(m).forEach(D=>{const f=this.resolveString(_,r,D,o,d);p[f]=this.recursiveResolve(_,r,m[D],o,d)}),p}return m}resolveString(_,r,m,o,d){return m.replace(k.VARIABLE_REGEXP,(D,f)=>{if(f.includes(k.VARIABLE_LHS))return D;let l=this.evaluateSingleVariable(_,D,f,r,o);return d&&d.set(f,l),l!==D&&w.isString(l)&&l.match(k.VARIABLE_REGEXP)&&(l=this.resolveString(_,r,l,o,d)),l})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,r,m,o,d){let p;const D=m.split(":");D.length>1&&(m=D[0],p=D[1]);const f=()=>{const y=this._context.getFilePath();if(y)return y;throw new Error((0,C.localize)(0,null,r))},l=()=>{const y=f();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,C.localize)(1,null,r,c.basename(y)))},h=()=>{if(p){const y=this._context.getFolderUri(p);if(y)return y;throw new Error((0,C.localize)(2,null,r,p))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,r)):new Error((0,C.localize)(4,null,r))};switch(m){case"env":if(p){if(_){const y=_[t.isWindows?p.toLowerCase():p];if(w.isString(y))return y}return""}throw new Error((0,C.localize)(5,null,r));case"config":if(p){const y=this._context.getConfigurationValue(o,p);if(w.isUndefinedOrNull(y))throw new Error((0,C.localize)(6,null,r,p));if(w.isObject(y))throw new Error((0,C.localize)(7,null,r,p));return y}throw new Error((0,C.localize)(8,null,r));case"command":return this.resolveFromMap(r,p,d,"command");case"input":return this.resolveFromMap(r,p,d,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.fsPath(h()));case"cwd":return o||p?(0,R.normalizeDriveLetter)(this.fsPath(h())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return c.basename(this.fsPath(h()));case"lineNumber":const y=this._context.getLineNumber();if(y)return y;throw new Error((0,C.localize)(9,null,r));case"selectedText":const a=this._context.getSelectedText();if(a)return a;throw new Error((0,C.localize)(10,null,r));case"file":return f();case"fileWorkspaceFolder":return l();case"relativeFile":return o||p?c.relative(this.fsPath(h()),f()):f();case"relativeFileDirname":const P=c.dirname(f());if(o||p){const g=c.relative(this.fsPath(h()),P);return g.length===0?".":g}return P;case"fileDirname":return c.dirname(f());case"fileExtname":return c.extname(f());case"fileBasename":return c.basename(f());case"fileBasenameNoExtension":const n=c.basename(f());return n.slice(0,n.length-c.extname(n).length);case"fileDirnameBasename":return c.basename(c.dirname(f()));case"execPath":const i=this._context.getExecPath();return i||r;case"execInstallFolder":const v=this._context.getAppRoot();return v||r;case"pathSeparator":return c.sep;default:try{const g=p?`${m}:${p}`:m;return this.resolveFromMap(r,g,d,void 0)}catch(g){return r}}}}resolveFromMap(_,r,m,o){if(r&&m){const d=o===void 0?m[r]:m[o+":"+r];if(typeof d=="string")return d;throw new Error((0,C.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[91],Ee([0,1,4,159]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,c.createDecorator)("editorGroupsService");var w;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var T;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var t;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(t=e.GroupLocation||(e.GroupLocation={}));var R;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function k(d){const p=d;return(0,M.isEditorInput)(p?.editor)&&(0,M.isEditorInput)(p?.replacement)}e.isEditorReplacement=k;var F;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.GROUP_LOCKED=2]="GROUP_LOCKED",d[d.EDITOR_OPEN=3]="EDITOR_OPEN",d[d.EDITOR_CLOSE=4]="EDITOR_CLOSE",d[d.EDITOR_MOVE=5]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=7]="EDITOR_LABEL",d[d.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",d[d.EDITOR_PIN=9]="EDITOR_PIN",d[d.EDITOR_STICKY=10]="EDITOR_STICKY",d[d.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function m(d){const p=d;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=m;function o(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=o}),define(we[168],Ee([0,1,4,91]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,c.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(T){const t=T;return typeof T=="number"||(0,M.isEditorGroup)(t)}e.isPreferredGroup=w}),define(we[8],Ee([0,1,16,22,77,230,55,25,10,2,43,59,135,83,48,88,68,168,6]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(le){function me(W){const{selectionStartLineNumber:be,selectionStartColumn:De,positionLineNumber:Ge,positionColumn:xe}=W,lt=new f.Position(be-1,De-1),_t=new f.Position(Ge-1,xe-1);return new f.Selection(lt,_t)}le.to=me;function ne(W){const{anchor:be,active:De}=W;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:De.line+1,positionColumn:De.character+1}}le.from=ne})(l=e.Selection||(e.Selection={}));var h;(function(le){function me(W){if(!W)return;const{start:be,end:De}=W;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:De.line+1,endColumn:De.character+1}}le.from=me;function ne(W){if(!W)return;const{startLineNumber:be,startColumn:De,endLineNumber:Ge,endColumn:xe}=W;return new f.Range(be-1,De-1,Ge-1,xe-1)}le.to=ne})(h=e.Range||(e.Range={}));var y;(function(le){function me(ne){switch(ne){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 4:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}le.to=me})(y=e.TokenType||(e.TokenType={}));var a;(function(le){function me(W){return new f.Position(W.lineNumber-1,W.column-1)}le.to=me;function ne(W){return{lineNumber:W.line+1,column:W.character+1}}le.from=ne})(a=e.Position||(e.Position={}));var P;(function(le){function me(be,De){return(0,c.coalesce)((0,c.asArray)(be).map(Ge=>ne(Ge,De)))}le.from=me;function ne(be,De){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:W(be.scheme,De),pattern:typeof be.pattern=="undefined"?void 0:rt.from(be.pattern),exclusive:be.exclusive}}function W(be,De){return De&&typeof be=="string"?De.transformOutgoingScheme(be):be}})(P=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(le){function me(W){switch(W){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}le.from=me;function ne(W){switch(W){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}le.to=ne})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(le){function me(W){let be;return W.code&&((0,C.isString)(W.code)||(0,C.isNumber)(W.code)?be=String(W.code):be={value:String(W.code.value),target:W.code.target}),{...h.from(W.range),message:W.message,source:W.source,code:be,severity:g.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(v.from),tags:Array.isArray(W.tags)?(0,c.coalesce)(W.tags.map(n.from)):void 0}}le.from=me;function ne(W){const be=new f.Diagnostic(h.to(W),W.message,g.to(W.severity));return be.source=W.source,be.code=(0,C.isString)(W.code)?W.code:W.code?.value,be.relatedInformation=W.relatedInformation&&W.relatedInformation.map(v.to),be.tags=W.tags&&(0,c.coalesce)(W.tags.map(n.to)),be}le.to=ne})(i=e.Diagnostic||(e.Diagnostic={}));var v;(function(le){function me(W){return{...h.from(W.location.range),message:W.message,resource:W.location.uri}}le.from=me;function ne(W){return new f.DiagnosticRelatedInformation(new f.Location(W.resource,h.to(W)),W.message)}le.to=ne})(v=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(le){function me(W){switch(W){case f.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}le.from=me;function ne(W){switch(W){case m.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}le.to=ne})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(le){function me(W){return typeof W=="number"&&W>=f.ViewColumn.One?W-1:W===f.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}le.from=me;function ne(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}le.to=ne})(s=e.ViewColumn||(e.ViewColumn={}));function b(le){return typeof le.range!="undefined"}function u(le){return le.length===0?!0:!!b(le[0])}e.isDecorationOptionsArr=u;var E;(function(le){function me(xe){return xe.map(le.from)}le.fromMany=me;function ne(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function W(xe){let lt;if(ne(xe)){const{language:gt,value:dt}=xe;lt={value:"```"+gt+`
`+dt+"\n```\n"}}else f.MarkdownString.isMarkdownString(xe)?lt={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?lt={value:xe}:lt={value:""};const _t=Object.create(null);lt.uris=_t;const bt=gt=>{try{let dt=k.URI.parse(gt,!0);dt=dt.with({query:be(dt.query,_t)}),_t[gt]=dt}catch(dt){}return""},ct=new T.Renderer;return ct.link=bt,ct.image=gt=>bt(w.parseHrefAndDimensions(gt).href),T(lt.value,{renderer:ct}),lt}le.from=W;function be(xe,lt){if(!xe)return xe;let _t;try{_t=(0,t.parse)(xe)}catch(ct){}if(!_t)return xe;let bt=!1;return _t=(0,R.cloneAndChange)(_t,ct=>{if(k.URI.isUri(ct)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[gt]=ct,bt=!0,gt}else return}),bt?JSON.stringify(_t):xe}function De(xe){const lt=new f.MarkdownString(xe.value,xe.supportThemeIcons);return lt.isTrusted=xe.isTrusted,lt.supportHtml=xe.supportHtml,lt}le.to=De;function Ge(xe){if(!!xe)return typeof xe=="string"?xe:le.from(xe)}le.fromStrict=Ge})(E=e.MarkdownString||(e.MarkdownString={}));function A(le){return u(le)?le.map(me=>({range:h.from(me.range),hoverMessage:Array.isArray(me.hoverMessage)?E.fromMany(me.hoverMessage):me.hoverMessage?E.from(me.hoverMessage):void 0,renderOptions:me.renderOptions})):le.map(me=>({range:h.from(me)}))}e.fromRangeOrRangeWithMessage=A;function I(le){return typeof le=="undefined"?le:typeof le=="string"?k.URI.file(le):le}e.pathOrURIToURI=I;var B;(function(le){function me(ne){return typeof ne=="undefined"?ne:{contentText:ne.contentText,contentIconPath:ne.contentIconPath?I(ne.contentIconPath):void 0,border:ne.border,borderColor:ne.borderColor,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,color:ne.color,backgroundColor:ne.backgroundColor,margin:ne.margin,width:ne.width,height:ne.height}}le.from=me})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(le){function me(ne){return typeof ne=="undefined"?ne:{backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?I(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?B.from(ne.before):void 0,after:ne.after?B.from(ne.after):void 0}}le.from=me})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var S;(function(le){function me(ne){if(typeof ne=="undefined")return ne;switch(ne){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}le.from=me})(S=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(le){function me(ne){return{isWholeLine:ne.isWholeLine,rangeBehavior:ne.rangeBehavior?S.from(ne.rangeBehavior):void 0,overviewRulerLane:ne.overviewRulerLane,light:ne.light?O.from(ne.light):void 0,dark:ne.dark?O.from(ne.dark):void 0,backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?I(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?B.from(ne.before):void 0,after:ne.after?B.from(ne.after):void 0}}le.from=me})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(le){function me(W){return{text:W.newText,eol:W.newEol&&q.from(W.newEol),range:h.from(W.range)}}le.from=me;function ne(W){const be=new f.TextEdit(h.to(W.range),W.text);return be.newEol=typeof W.eol=="undefined"?void 0:q.to(W.eol),be}le.to=ne})(N=e.TextEdit||(e.TextEdit={}));var V;(function(le){function me(W,be,De){const Ge={edits:[]};if(W instanceof f.WorkspaceEdit)for(let xe of W._allEntries())if(xe._type===1)Ge.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const lt=be?.getDocument(xe.uri);Ge.edits.push({_type:2,resource:xe.uri,edit:N.from(xe.edit),modelVersionId:lt?.version,metadata:xe.metadata})}else xe._type===3?Ge.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&Ge.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Ze.from)}});return Ge}le.from=me;function ne(W){const be=new f.WorkspaceEdit;for(const De of W.edits)De.edit?be.replace(k.URI.revive(De.resource),h.to(De.edit.range),De.edit.text):be.renameFile(k.URI.revive(De.oldUri),k.URI.revive(De.newUri),De.options);return be}le.to=ne})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(le){const me=Object.create(null);me[f.SymbolKind.File]=0,me[f.SymbolKind.Module]=1,me[f.SymbolKind.Namespace]=2,me[f.SymbolKind.Package]=3,me[f.SymbolKind.Class]=4,me[f.SymbolKind.Method]=5,me[f.SymbolKind.Property]=6,me[f.SymbolKind.Field]=7,me[f.SymbolKind.Constructor]=8,me[f.SymbolKind.Enum]=9,me[f.SymbolKind.Interface]=10,me[f.SymbolKind.Function]=11,me[f.SymbolKind.Variable]=12,me[f.SymbolKind.Constant]=13,me[f.SymbolKind.String]=14,me[f.SymbolKind.Number]=15,me[f.SymbolKind.Boolean]=16,me[f.SymbolKind.Array]=17,me[f.SymbolKind.Object]=18,me[f.SymbolKind.Key]=19,me[f.SymbolKind.Null]=20,me[f.SymbolKind.EnumMember]=21,me[f.SymbolKind.Struct]=22,me[f.SymbolKind.Event]=23,me[f.SymbolKind.Operator]=24,me[f.SymbolKind.TypeParameter]=25;function ne(be){return typeof me[be]=="number"?me[be]:6}le.from=ne;function W(be){for(const De in me)if(me[De]===be)return Number(De);return f.SymbolKind.Property}le.to=W})($=e.SymbolKind||(e.SymbolKind={}));var z;(function(le){function me(W){switch(W){case f.SymbolTag.Deprecated:return 1}}le.from=me;function ne(W){switch(W){case 1:return f.SymbolTag.Deprecated}}le.to=ne})(z=e.SymbolTag||(e.SymbolTag={}));var ee;(function(le){function me(W){return{name:W.name,kind:$.from(W.kind),tags:W.tags&&W.tags.map(z.from),containerName:W.containerName,location:ue.from(W.location)}}le.from=me;function ne(W){const be=new f.SymbolInformation(W.name,$.to(W.kind),W.containerName,ue.to(W.location));return be.tags=W.tags&&W.tags.map(z.to),be}le.to=ne})(ee=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(le){function me(W){const be={name:W.name||"!!MISSING: name!!",detail:W.detail,range:h.from(W.range),selectionRange:h.from(W.selectionRange),kind:$.from(W.kind),tags:W.tags?.map(z.from)??[]};return W.children&&(be.children=W.children.map(me)),be}le.from=me;function ne(W){const be=new f.DocumentSymbol(W.name,W.detail,$.to(W.kind),h.to(W.range),h.to(W.selectionRange));return(0,c.isNonEmptyArray)(W.tags)&&(be.tags=W.tags.map(z.to)),W.children&&(be.children=W.children.map(ne)),be}le.to=ne})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var Q;(function(le){function me(W){const be=new f.CallHierarchyItem($.to(W.kind),W.name,W.detail||"",k.URI.revive(W.uri),h.to(W.range),h.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}le.to=me;function ne(W,be,De){if(be=be??W._sessionId,De=De??W._itemId,be===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:De,name:W.name,detail:W.detail,kind:$.from(W.kind),uri:W.uri,range:h.from(W.range),selectionRange:h.from(W.selectionRange),tags:W.tags?.map(z.from)}}le.from=ne})(Q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ce;(function(le){function me(ne){return new f.CallHierarchyIncomingCall(Q.to(ne.from),ne.fromRanges.map(W=>h.to(W)))}le.to=me})(ce=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(le){function me(ne){return new f.CallHierarchyOutgoingCall(Q.to(ne.to),ne.fromRanges.map(W=>h.to(W)))}le.to=me})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ue;(function(le){function me(W){return{range:W.range&&h.from(W.range),uri:W.uri}}le.from=me;function ne(W){return new f.Location(k.URI.revive(W.uri),h.to(W.range))}le.to=ne})(ue=e.location||(e.location={}));var Fe;(function(le){function me(W){const be=W,De=W;return{originSelectionRange:be.originSelectionRange?h.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:De.uri,range:h.from(be.targetRange?be.targetRange:De.range),targetSelectionRange:be.targetSelectionRange?h.from(be.targetSelectionRange):void 0}}le.from=me;function ne(W){return{targetUri:k.URI.revive(W.uri),targetRange:h.to(W.range),targetSelectionRange:W.targetSelectionRange?h.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?h.to(W.originSelectionRange):void 0}}le.to=ne})(Fe=e.DefinitionLink||(e.DefinitionLink={}));var Ke;(function(le){function me(W){return{range:h.from(W.range),contents:E.fromMany(W.contents)}}le.from=me;function ne(W){return new f.Hover(W.contents.map(E.to),h.to(W.range))}le.to=ne})(Ke=e.Hover||(e.Hover={}));var Oe;(function(le){function me(W){return{range:h.from(W.range),expression:W.expression}}le.from=me;function ne(W){return new f.EvaluatableExpression(h.to(W.range),W.expression)}le.to=ne})(Oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var We;(function(le){function me(W){if(W instanceof f.InlineValueText)return{type:"text",range:h.from(W.range),text:W.text};if(W instanceof f.InlineValueVariableLookup)return{type:"variable",range:h.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}le.from=me;function ne(W){switch(W.type){case"text":return{range:h.to(W.range),text:W.text};case"variable":return{range:h.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:h.to(W.range),expression:W.expression}}}le.to=ne})(We=e.InlineValue||(e.InlineValue={}));var Xe;(function(le){function me(W){return{frameId:W.frameId,stoppedLocation:h.from(W.stoppedLocation)}}le.from=me;function ne(W){return new f.InlineValueContext(W.frameId,h.to(W.stoppedLocation))}le.to=ne})(Xe=e.InlineValueContext||(e.InlineValueContext={}));var Ye;(function(le){function me(W){return{range:h.from(W.range),kind:W.kind}}le.from=me;function ne(W){return new f.DocumentHighlight(h.to(W.range),W.kind)}le.to=ne})(Ye=e.DocumentHighlight||(e.DocumentHighlight={}));var Qe;(function(le){function me(ne){switch(ne){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}le.to=me})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var H;(function(le){function me(ne){return{triggerKind:Qe.to(ne.triggerKind),triggerCharacter:ne.triggerCharacter}}le.to=me})(H=e.CompletionContext||(e.CompletionContext={}));var K;(function(le){function me(W){switch(W){case f.CompletionItemTag.Deprecated:return 1}}le.from=me;function ne(W){switch(W){case 1:return f.CompletionItemTag.Deprecated}}le.to=ne})(K=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(le){const me=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function ne(De){return me.get(De)??9}le.from=ne;const W=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function be(De){return W.get(De)??f.CompletionItemKind.Property}le.to=be})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var oe;(function(le){function me(ne,W){const be=new f.CompletionItem(ne.label);return be.insertText=ne.insertText,be.kind=J.to(ne.kind),be.tags=ne.tags?.map(K.to),be.detail=ne.detail,be.documentation=w.isMarkdownString(ne.documentation)?E.to(ne.documentation):ne.documentation,be.sortText=ne.sortText,be.filterText=ne.filterText,be.preselect=ne.preselect,be.commitCharacters=ne.commitCharacters,F.Range.isIRange(ne.range)?be.range=h.to(ne.range):typeof ne.range=="object"&&(be.range={inserting:h.to(ne.range.insert),replacing:h.to(ne.range.replace)}),be.keepWhitespace=typeof ne.insertTextRules=="undefined"?!1:Boolean(ne.insertTextRules&1),typeof ne.insertTextRules!="undefined"&&ne.insertTextRules&4?be.insertText=new f.SnippetString(ne.insertText):(be.insertText=ne.insertText,be.textEdit=be.range instanceof f.Range?new f.TextEdit(be.range,be.insertText):void 0),ne.additionalTextEdits&&ne.additionalTextEdits.length>0&&(be.additionalTextEdits=ne.additionalTextEdits.map(De=>N.to(De))),be.command=W&&ne.command?W.fromInternal(ne.command):void 0,be}le.to=me})(oe=e.CompletionItem||(e.CompletionItem={}));var G;(function(le){function me(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0}}le.from=me;function ne(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation}}le.to=ne})(G=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(le){function me(W){return{label:W.label,documentation:W.documentation?E.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(G.from):[],activeParameter:W.activeParameter}}le.from=me;function ne(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?E.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(G.to):[],activeParameter:W.activeParameter}}le.to=ne})(ie=e.SignatureInformation||(e.SignatureInformation={}));var de;(function(le){function me(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(ie.from):[]}}le.from=me;function ne(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(ie.to):[]}}le.to=ne})(de=e.SignatureHelp||(e.SignatureHelp={}));var Te;(function(le){function me(W){return{text:W.text,position:a.from(W.position),kind:Ne.from(W.kind??f.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}le.from=me;function ne(W){const be=new f.InlayHint(W.text,a.to(W.position),Ne.to(W.kind));return be.whitespaceAfter=W.whitespaceAfter,be.whitespaceBefore=W.whitespaceBefore,be}le.to=ne})(Te=e.InlayHint||(e.InlayHint={}));var Ne;(function(le){function me(W){return W}le.from=me;function ne(W){return W}le.to=ne})(Ne=e.InlayHintKind||(e.InlayHintKind={}));var ze;(function(le){function me(W){return{range:h.from(W.range),url:W.target,tooltip:W.tooltip}}le.from=me;function ne(W){let be;if(W.url)try{be=typeof W.url=="string"?k.URI.parse(W.url,!0):k.URI.revive(W.url)}catch(De){}return new f.DocumentLink(h.to(W.range),be)}le.to=ne})(ze=e.DocumentLink||(e.DocumentLink={}));var je;(function(le){function me(W){const be=new f.ColorPresentation(W.label);return W.textEdit&&(be.textEdit=N.to(W.textEdit)),W.additionalTextEdits&&(be.additionalTextEdits=W.additionalTextEdits.map(De=>N.to(De))),be}le.to=me;function ne(W){return{label:W.label,textEdit:W.textEdit?N.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(be=>N.from(be)):void 0}}le.from=ne})(je=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(le){function me(W){return new f.Color(W[0],W[1],W[2],W[3])}le.to=me;function ne(W){return[W.red,W.green,W.blue,W.alpha]}le.from=ne})(et=e.Color||(e.Color={}));var ot;(function(le){function me(W){return{range:h.from(W.range)}}le.from=me;function ne(W){return new f.SelectionRange(h.to(W.range))}le.to=ne})(ot=e.SelectionRange||(e.SelectionRange={}));var ye;(function(le){function me(ne){switch(ne){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}le.to=me})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(le){function me(W){switch(W){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}le.from=me;function ne(W){switch(W){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}le.to=ne})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var q;(function(le){function me(W){if(W===f.EndOfLine.CRLF)return 1;if(W===f.EndOfLine.LF)return 0}le.from=me;function ne(W){if(W===1)return f.EndOfLine.CRLF;if(W===0)return f.EndOfLine.LF}le.to=ne})(q=e.EndOfLine||(e.EndOfLine={}));var X;(function(le){function me(ne){if(typeof ne=="object")return ne.viewId;switch(ne){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}le.from=me})(X=e.ProgressLocation||(e.ProgressLocation={}));var pe;(function(le){function me(ne){const W={start:ne.start+1,end:ne.end+1};return ne.kind&&(W.kind=$e.from(ne.kind)),W}le.from=me})(pe=e.FoldingRange||(e.FoldingRange={}));var $e;(function(le){function me(ne){if(ne)switch(ne){case f.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}le.from=me})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var qe;(function(le){function me(ne){if(ne)return{pinned:typeof ne.preview=="boolean"?!ne.preview:void 0,inactive:ne.background,preserveFocus:ne.preserveFocus,selection:typeof ne.selection=="object"?h.from(ne.selection):void 0,override:typeof ne.override=="boolean"?r.EditorResolution.DISABLED:void 0}}le.from=me})(qe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var rt;(function(le){function me(W){return W instanceof f.RelativePattern||typeof W=="string"?W:ne(W)?new f.RelativePattern(W.base,W.pattern):W}le.from=me;function ne(W){const be=W;return be&&typeof be.base=="string"&&typeof be.pattern=="string"}})(rt=e.GlobPattern||(e.GlobPattern={}));var ft;(function(le){function me(ne){if(ne){if(Array.isArray(ne))return ne.map(me);if(typeof ne=="string")return ne;{const W=ne;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:rt.from(W.pattern),exclusive:W.exclusive}}}else return}le.from=me})(ft=e.LanguageSelector||(e.LanguageSelector={}));var ht;(function(le){function me(W){return{start:W.start,end:W.end}}le.from=me;function ne(W){return new f.NotebookRange(W.start,W.end)}le.to=ne})(ht=e.NotebookRange||(e.NotebookRange={}));var Ct;(function(le){function me(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}le.to=me;function ne(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}le.from=ne})(Ct=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var It;(function(le){function me(W){switch(W){case f.NotebookCellKind.Markup:return d.CellKind.Markup;case f.NotebookCellKind.Code:default:return d.CellKind.Code}}le.from=me;function ne(W){switch(W){case d.CellKind.Markup:return f.NotebookCellKind.Markup;case d.CellKind.Code:default:return f.NotebookCellKind.Code}}le.to=ne})(It=e.NotebookCellKind||(e.NotebookCellKind={}));var Pt;(function(le){function me(W){const be={metadata:W.metadata??Object.create(null),cells:[]};for(let De of W.cells)f.NotebookCellData.validate(De),be.cells.push(Ze.from(De));return be}le.from=me;function ne(W){const be=new f.NotebookData(W.cells.map(Ze.to));return(0,C.isEmptyObject)(W.metadata)||(be.metadata=W.metadata),be}le.to=ne})(Pt=e.NotebookData||(e.NotebookData={}));var Ze;(function(le){function me(W){return{cellKind:It.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:Ct.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Ie.from):[]}}le.from=me;function ne(W){return new f.NotebookCellData(It.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Ie.to):void 0,W.metadata,W.internalMetadata?Ct.to(W.internalMetadata):void 0)}le.to=ne})(Ze=e.NotebookCellData||(e.NotebookCellData={}));var pt;(function(le){function me(W){return{mime:W.mime,valueBytes:M.VSBuffer.wrap(W.data)}}le.from=me;function ne(W){return new f.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}le.to=ne})(pt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(le){function me(W){return{outputId:W.id,items:W.items.map(pt.from),metadata:W.metadata}}le.from=me;function ne(W){const be=W.items.map(pt.to);return new f.NotebookCellOutput(be,W.outputId,W.metadata)}le.to=ne})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ge;(function(le){function me(De){if(De!=null){if(De instanceof f.RelativePattern||typeof De=="string")return De;if(be(De))return new f.RelativePattern(De.base,De.pattern);if(W(De))return{include:rt.from(De.include)||void 0,exclude:rt.from(De.exclude)||void 0}}}le.from=me;function ne(De){return typeof De=="string"?De:be(De)?{base:De.base,pattern:De.pattern}:{include:De.include,exclude:De.exclude}}le.to=ne;function W(De){const Ge=De,xe=rt.from(Ge.include);if(!(xe&&xe instanceof f.RelativePattern||typeof xe=="string"))return!1;const lt=rt.from(Ge.exclude);return!!(lt&&lt instanceof f.RelativePattern||typeof lt=="string")}function be(De){const Ge=De;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(ge=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ce;(function(le){function me(ne){return{backgroundColor:ne.backgroundColor,borderColor:ne.borderColor,top:ne.top?B.from(ne.top):void 0}}le.from=me})(Ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Z;(function(le){function me(ne,W,be){const De=typeof ne.command=="string"?{title:"",command:ne.command}:ne.command;return{alignment:ne.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(De,be),text:ne.text,tooltip:ne.tooltip,accessibilityInformation:ne.accessibilityInformation,priority:ne.priority}}le.from=me})(Z=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var se;(function(le){function me(ne){return{transientOutputs:ne?.transientOutputs??!1,transientCellMetadata:ne?.transientCellMetadata??{},transientDocumentMetadata:ne?.transientDocumentMetadata??{}}}le.from=me})(se=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var fe;(function(le){function me(W){return{uri:W.uri,provides:W.provides}}le.from=me;function ne(W){return new f.NotebookRendererScript(k.URI.revive(W.uri),W.provides)}le.to=ne})(fe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var he;(function(le){function me(W){return{message:E.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ue.from(W.location):void 0}}le.from=me;function ne(W){const be=new f.TestMessage(typeof W.message=="string"?W.message:E.to(W.message));return be.actualOutput=W.actual,be.expectedOutput=W.expected,be.location=W.location?ue.to(W.location):void 0,be}le.to=ne})(he=e.TestMessage||(e.TestMessage={}));var ke;(function(le){let me;(function(ne){ne.Delimiter="\0"})(me||(me={})),le.namespace=(ne,W)=>ne+"\0"+W,le.denamespace=ne=>{const W=ne.indexOf("\0");return{ctrlId:ne.slice(0,W),tagId:ne.slice(W+1)}}})(ke=e.TestTag||(e.TestTag={}));var Le;(function(le){function me(De){const Ge=(0,o.getPrivateApiFor)(De).controllerId;return{extId:p.TestId.fromExtHostTestItem(De,Ge).toString(),label:De.label,uri:De.uri,tags:De.tags.map(xe=>ke.namespace(Ge,xe.id)),range:h.from(De.range)||null,description:De.description||null,error:De.error&&E.fromStrict(De.error)||null}}le.from=me;function ne(De){return{parent:void 0,error:void 0,id:p.TestId.fromString(De.extId).localId,label:De.label,uri:k.URI.revive(De.uri),tags:(De.tags||[]).map(Ge=>{const{tagId:xe}=ke.denamespace(Ge);return new f.TestTag(xe)}),range:h.to(De.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:De.description||void 0}}le.toPlain=ne;function W(De){const Ge=p.TestId.fromString(De.extId),xe=new o.TestItemImpl(Ge.controllerId,Ge.localId,De.label,k.URI.revive(De.uri));return xe.range=h.to(De.range||void 0),xe.description=De.description||void 0,xe}function be(De){let Ge;for(const xe of De.tests){const lt=W(xe.item);(0,o.getPrivateApiFor)(lt).parent=Ge,Ge=lt}return Ge}le.toItemFromContext=be})(Le=e.TestItem||(e.TestItem={})),function(le){function me(W){return{id:W.id}}le.from=me;function ne(W){return new f.TestTag(W.id)}le.to=ne}(ke=e.TestTag||(e.TestTag={}));var Me;(function(le){const me=(W,be)=>{const De={...Le.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(xe=>xe.type===0).map(he.to)})),children:W.children.map(Ge=>be.get(Ge)).filter(C.isDefined).map(Ge=>me(Ge,be))};for(const Ge of De.children)Ge.parent=De;return De};function ne(W){const be=[],De=new Map;for(const Ge of W.items)De.set(Ge.item.extId,Ge),W.request.targets.some(xe=>xe.controllerId===Ge.controllerId&&xe.testIds.includes(Ge.item.extId))&&be.push(Ge);return{completedAt:W.completedAt,results:be.map(Ge=>me(Ge,De))}}le.to=ne})(Me=e.TestResults||(e.TestResults={}));var He;(function(le){function me(De){return{covered:De.covered,total:De.covered}}function ne(De){return"line"in De?a.from(De):h.from(De)}function W(De){return"branches"in De?{count:De.executionCount,location:ne(De.location),type:1,branches:De.branches.length?De.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ne(Ge.location)})):void 0}:{type:0,count:De.executionCount,location:ne(De.location)}}le.fromDetailed=W;function be(De){return{uri:De.uri,statement:me(De.statementCoverage),branch:De.branchCoverage&&me(De.branchCoverage),function:De.functionCoverage&&me(De.functionCoverage),details:De.detailedCoverage?.map(W)}}le.fromFile=be})(He=e.TestCoverage||(e.TestCoverage={}));var it;(function(le){function me(ne){switch(ne){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}le.to=me})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Re;(function(le){function me(W){const be=new f.TypeHierarchyItem($.to(W.kind),W.name,W.detail||"",k.URI.revive(W.uri),h.to(W.range),h.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}le.to=me;function ne(W,be,De){if(be=be??W._sessionId,De=De??W._itemId,be===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:De,kind:$.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:h.from(W.range),selectionRange:h.from(W.selectionRange),tags:W.tags?.map(z.from)}}le.from=ne})(Re=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[169],Ee([0,1,2,15,6,8,231]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(k,F,_,r={timeout:1500,errors:3}){this._logService=k,this._documents=F,this._mainThreadBulkEdits=_,this._thresholds=r,this._callbacks=new t.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(F,_,r)=>{const o={dispose:this._callbacks.push([F,_,k])};return Array.isArray(r)&&r.push(o),o}}async $participateInSave(k,F){const _=c.URI.revive(k);let r=!1;const m=setTimeout(()=>r=!0,this._thresholds.timeout),o=[];try{for(let d of[...this._callbacks]){if(r)break;const p=this._documents.getDocument(_),D=await this._deliverEventAsyncAndBlameBadListeners(d,{document:p,reason:T.TextDocumentSaveReason.to(F)});o.push(D)}}finally{clearTimeout(m)}return o}_deliverEventAsyncAndBlameBadListeners([k,F,_],r){const m=this._badListeners.get(k);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,k,F,r).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const d=this._badListeners.get(k);this._badListeners.set(k,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,F,_,r){const m=[],o=Date.now(),{document:d,reason:p}=r,{version:D}=d,f=Object.freeze({document:d,reason:p,waitUntil(l){if(Object.isFrozen(m))throw(0,M.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(l))}});try{F.apply(_,[f])}catch(l){return Promise.reject(l)}return Object.freeze(m),new Promise((l,h)=>{const y=setTimeout(()=>h(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(y),l(a)}).catch(a=>{clearTimeout(y),h(a)})}).then(l=>{const h={edits:[]};for(const y of l)if(Array.isArray(y)&&y.every(a=>a instanceof w.TextEdit))for(const{newText:a,newEol:P,range:n}of y)h.edits.push({_type:2,resource:d.uri,edit:{range:n&&T.Range.from(n),text:a,eol:P&&T.EndOfLine.from(P)}});if(h.edits.length!==0)return D===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(h):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(we[170],Ee([0,1,3,29,2,8,6]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class R{constructor(F,_,r,m,o){this._onDidCreate=new c.Emitter,this._onDidChange=new c.Emitter,this._onDidDelete=new c.Emitter,this._config=0,r&&(this._config+=1),m&&(this._config+=2),o&&(this._config+=4);const d=(0,M.parse)(_),p=F(D=>{if(!r)for(let f of D.created){const l=w.URI.revive(f);d(l.fsPath)&&this._onDidCreate.fire(l)}if(!m)for(let f of D.changed){const l=w.URI.revive(f);d(l.fsPath)&&this._onDidChange.fire(l)}if(!o)for(let f of D.deleted){const l=w.URI.revive(f);d(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=t.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(F,_,r){this._logService=_,this._extHostDocumentsAndEditors=r,this._onFileSystemEvent=new c.Emitter,this._onDidRenameFile=new c.Emitter,this._onDidCreateFile=new c.Emitter,this._onDidDeleteFile=new c.Emitter,this._onWillRenameFile=new c.AsyncEmitter,this._onWillCreateFile=new c.AsyncEmitter,this._onWillDeleteFile=new c.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(F,_,r,m){return new R(this._onFileSystemEvent.event,F,_,r,m)}$onFileEvent(F){this._onFileSystemEvent.fire(F)}$onDidRunFileOperation(F,_){switch(F){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(r=>({oldUri:w.URI.revive(r.source),newUri:w.URI.revive(r.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(r=>w.URI.revive(r.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(r=>w.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(F){return this._createWillExecuteEvent(F,this._onWillRenameFile)}getOnWillCreateFileEvent(F){return this._createWillExecuteEvent(F,this._onWillCreateFile)}getOnWillDeleteFileEvent(F){return this._createWillExecuteEvent(F,this._onWillDeleteFile)}_createWillExecuteEvent(F,_){return(r,m,o)=>{const d=function(D){r.call(m,D)};return d.extension=F,_.event(d,void 0,o)}}async $onWillRunFileOperation(F,_,r,m){switch(F){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(o=>({oldUri:w.URI.revive(o.source),newUri:w.URI.revive(o.target)}))},r,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(o=>w.URI.revive(o.target))},r,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(o=>w.URI.revive(o.target))},r,m)}}async _fireWillEvent(F,_,r,m){const o=new Set,d=[];if(await F.fireAsync(_,m,async(D,f)=>{const l=Date.now(),h=await Promise.resolve(D);h instanceof t.WorkspaceEdit&&(d.push(h),o.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-l>r&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),m.isCancellationRequested||d.length===0)return;const p={edits:[]};for(let D of d){let{edits:f}=T.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(f)}return{edit:p,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=C}),define(we[171],Ee([0,1,11,25,2,8,6,88]),function(re,e,c,M,w,T,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(r,m,o,d){this.start=r,this.deletedCount=m,this.deletedItems=o,this.items=d}static asApiEvents(r){return r.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(o=>o.apiCell)}))}}class k{constructor(r,m,o){this.notebook=r,this._extHostDocument=m,this._cellData=o,this.handle=o.handle,this.uri=w.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(r,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:r}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const r=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return r.notebook.getCellIndex(r)},notebook:r.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return r._mime},set mime(o){r._mime=o},get outputs(){return r._outputs.slice(0)},get metadata(){return r._metadata},get executionSummary(){return r._previousResult}})}return this._apiCell}setOutputs(r){this._outputs=r.map(T.NotebookCellOutput.to)}setOutputItems(r,m,o){const d=o.map(T.NotebookCellOutputItem.to),p=this._outputs.find(D=>D.id===r);p&&(m||(p.items.length=0),p.items.push(...d))}setMetadata(r){this._metadata=Object.freeze(r)}setInternalMetadata(r){this._internalMetadata=r,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(r))}setMime(r){}}e.ExtHostCell=k;class F{constructor(r,m,o,d,p,D){this._proxy=r,this._textDocumentsAndEditors=m,this._textDocuments=o,this._emitter=d,this.uri=p,this.handle=F._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=D.viewType,this._metadata=Object.freeze(D.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,D.cells]],!0),this._versionId=D.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const r=this;this._notebook={get uri(){return r.uri},get version(){return r._versionId},get notebookType(){return r._notebookType},get isDirty(){return r._isDirty},get isUntitled(){return r.uri.scheme===c.Schemas.untitled},get isClosed(){return r._disposed},get metadata(){return r._metadata},get cellCount(){return r._cells.length},cellAt(m){return m=r._validateIndex(m),r._cells[m].apiCell},getCells(m){return(m?r._getCells(m):r._cells).map(d=>d.apiCell)},save(){return r._save()}}}return this._notebook}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(r){r.metadata&&(this._metadata=Object.freeze({...this._metadata,...r.metadata}))}acceptDirty(r){this._isDirty=r}acceptModelChanged(r,m){this._versionId=r.versionId,this._isDirty=m;for(const o of r.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===R.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===R.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===R.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===R.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(r){return r=r|0,r<0?0:r>=this._cells.length?this._cells.length-1:r}_validateRange(r){let m=r.start|0,o=r.end|0;return m<0&&(m=0),o>this._cells.length&&(o=this._cells.length),r.with({start:m,end:o})}_getCells(r){r=this._validateRange(r);const m=[];for(let o=r.start;o<r.end;o++)m.push(this._cells[o]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(r,m){if(this._disposed)return;const o=[],d=[],p=[];r.reverse().forEach(D=>{const l=D[2].map(a=>{const P=new k(this,this._textDocumentsAndEditors,a);return m||d.push(k.asModelAddData(this.apiNotebook,a)),P}),h=new C(D[0],D[1],[],l),y=this._cells.splice(D[0],D[1],...l);for(const a of y)p.push(a.uri),h.deletedItems.push(a.apiCell);o.push(h)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:p}),m||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(o)}))}_moveCell(r,m){const o=this._cells.splice(r,1);this._cells.splice(m,0,...o);const d=[new C(r,1,o.map(p=>p.apiCell),[]),new C(m,0,[],o)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(d)}))}_setCellOutputs(r,m){const o=this._cells[r];o.setOutputs(m),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(r,m,o,d){const p=this._cells[r];p.setOutputItems(m,o,d),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(r,m){const o=this._cells[r];o.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(o.uri,m)}_changeCellMime(r,m){const o=this._cells[r];o.apiCell.mime=m}_changeCellMetadata(r,m){const o=this._cells[r],d=o.apiCell.metadata;o.setMetadata(m);const p=o.apiCell.metadata;(0,M.equals)(d,p)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(r,m){const o=this._cells[r],d=o.internalMetadata;if(o.setInternalMetadata(m),d.runState!==m.runState){const p=m.runState??t.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,state:p}))}}getCellFromApiCell(r){return this._cells.find(m=>m.apiCell===r)}getCellFromIndex(r){return this._cells[r]}getCell(r){return this._cells.find(m=>m.handle===r)}getCellIndex(r){return this._cells.indexOf(r)}}e.ExtHostNotebookDocument=F,F._handlePool=0}),define(we[92],Ee([0,1,6,8,15]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:k})}replaceCells(C,k,F){this._throwIfFinalized(),!(C===k&&F.length===0)&&this._collectedEdits.push({editType:1,index:C,count:k-C,cells:F.map(M.NotebookCellData.from)})}}class t{constructor(C,k,F,_,r,m){this.id=C,this._proxy=k,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=r,this._visibleRanges=_,this._viewColumn=m}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(k){if(!Array.isArray(k)||!k.every(c.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");C._selections=k,C._trySetSelections(k)},get visibleRanges(){return C._visibleRanges},revealRange(k,F){C._proxy.$tryRevealRange(C.id,M.NotebookRange.from(k),F??c.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(k){const F=new T(this.document.version);return k(F),C._applyEdit(F.finalize())},setDecorations(k,F){return C.setDecorations(k,F)}},t.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(M.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const k=[];let F=-1;for(let _=0;_<C.cellEdits.length;_++){if(F<0){k.push(C.cellEdits[_]),F++;continue}const m=k[F],o=C.cellEdits[_];if(m.editType===1&&o.editType===1&&m.index===o.index){m.cells.push(...C.cellEdits[_].cells),m.count+=C.cellEdits[_].count;continue}k.push(C.cellEdits[_]),F++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,k)}setDecorations(C,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return k.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(k),C.key)}}e.ExtHostNotebookEditor=t,t.apiEditorsToExtHost=new WeakMap}),define(we[172],Ee([0,1,8,144,125,20,52,15]),function(re,e,c,M,w,T,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(r){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=r}async withProgress(r,m,o){const d=this._handles++,{title:p,location:D,cancellable:f}=m,l={label:(0,w.localize)(0,null,r.displayName||r.name),id:r.identifier.value};return this._proxy.$startProgress(d,{location:c.ProgressLocation.from(D),title:p,source:l,cancellable:f},r).catch(R.onUnexpectedExternalError),this._withProgress(d,o,!!f)}_withProgress(r,m,o){let d;o&&(d=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(r,d));const p=f=>{this._proxy.$progressEnd(f),this._mapHandleToCancellationSource.delete(f),d&&d.dispose()};let D;try{D=m(new F(this._proxy,r),o&&d?d.token:T.CancellationToken.None)}catch(f){throw p(r),f}return D.then(f=>p(r),f=>p(r)),D}$acceptProgressCanceled(r){const m=this._mapHandleToCancellationSource.get(r);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(r))}}e.ExtHostProgress=C;function k(_,r){return _.message=r.message,typeof r.increment=="number"&&(typeof _.increment=="number"?_.increment+=r.increment:_.increment=r.increment),_}class F extends M.Progress{constructor(r,m){super(o=>this.throttledReport(o));this._proxy=r,this._handle=m}throttledReport(r){this._proxy.$progressReport(this._handle,r)}}Ue([(0,t.throttle)(100,(_,r)=>k(_,r),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(we[93],Ee([0,1,41,15,53,8,6]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class R{constructor(r,m,o){const d=R._Keys.nextId();r.$registerTextEditorDecorationType(m.identifier,d,T.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:d,dispose(){r.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=R,R._Keys=new w.IdGenerator("TextEditorDecorationType");class C{constructor(r,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=r,this._documentVersionId=r.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(r,m){this._throwIfFinalized();let o=null;if(r instanceof t.Position)o=new t.Range(r,r);else if(r instanceof t.Range)o=r;else throw new Error("Unrecognized location");this._pushEdit(o,m,!1)}insert(r,m){this._throwIfFinalized(),this._pushEdit(new t.Range(r,r),m,!0)}delete(r){this._throwIfFinalized();let m=null;if(r instanceof t.Range)m=r;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(r,m,o){const d=this._document.validateRange(r);this._collectedEdits.push({range:d,text:m,forceMoveMarkers:o})}setEndOfLine(r){if(this._throwIfFinalized(),r!==t.EndOfLine.LF&&r!==t.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=r}}e.TextEditorEdit=C;class k{constructor(r,m,o,d){this._proxy=r,this._id=m,this._accept(o),this._logService=d;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(D){p._setTabSize(D)},get insertSpaces(){return p._insertSpaces},set insertSpaces(D){p._setInsertSpaces(D)},get cursorStyle(){return p._cursorStyle},set cursorStyle(D){p._setCursorStyle(D)},get lineNumbers(){return p._lineNumbers},set lineNumbers(D){p._setLineNumbers(D)}}}_accept(r){this._tabSize=r.tabSize,this._insertSpaces=r.insertSpaces,this._cursorStyle=r.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(r.lineNumbers)}_validateTabSize(r){if(r==="auto")return"auto";if(typeof r=="number"){const m=Math.floor(r);return m>0?m:null}if(typeof r=="string"){const m=parseInt(r,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(r){const m=this._validateTabSize(r);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(r){return r==="auto"?"auto":r==="false"?!1:Boolean(r)}_setInsertSpaces(r){const m=this._validateInsertSpaces(r);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(r){this._cursorStyle!==r&&(this._cursorStyle=r,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:r})))}_setLineNumbers(r){this._lineNumbers!==r&&(this._lineNumbers=r,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(r)})))}assign(r){const m={};let o=!1;if(typeof r.tabSize!="undefined"){const d=this._validateTabSize(r.tabSize);d==="auto"?(o=!0,m.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,o=!0,m.tabSize=d)}if(typeof r.insertSpaces!="undefined"){const d=this._validateInsertSpaces(r.insertSpaces);d==="auto"?(o=!0,m.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,o=!0,m.insertSpaces=d)}typeof r.cursorStyle!="undefined"&&this._cursorStyle!==r.cursorStyle&&(this._cursorStyle=r.cursorStyle,o=!0,m.cursorStyle=r.cursorStyle),typeof r.lineNumbers!="undefined"&&this._lineNumbers!==r.lineNumbers&&(this._lineNumbers=r.lineNumbers,o=!0,m.lineNumbers=T.TextEditorLineNumbersStyle.from(r.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(r){r.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=k;class F{constructor(r,m,o,d,p,D,f,l){this.id=r,this._proxy=m,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new k(this._proxy,this.id,D,o),this._visibleRanges=f,this._viewColumn=l;const h=this;this.value=Object.freeze({get document(){return d.getValue()},set document(y){throw(0,M.readonly)("document")},get selection(){return h._selections&&h._selections[0]},set selection(y){if(!(y instanceof t.Selection))throw(0,M.illegalArgument)("selection");h._selections=[y],h._trySetSelection()},get selections(){return h._selections},set selections(y){if(!Array.isArray(y)||y.some(a=>!(a instanceof t.Selection)))throw(0,M.illegalArgument)("selections");h._selections=y,h._trySetSelection()},get visibleRanges(){return h._visibleRanges},set visibleRanges(y){throw(0,M.readonly)("visibleRanges")},get options(){return h._options.value},set options(y){h._disposed||h._options.assign(y)},get viewColumn(){return h._viewColumn},set viewColumn(y){throw(0,M.readonly)("viewColumn")},edit(y,a={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const P=new C(d.getValue(),a);return y(P),h._applyEdit(P)},insertSnippet(y,a,P={undoStopBefore:!0,undoStopAfter:!0}){if(h._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!a||Array.isArray(a)&&a.length===0)n=h._selections.map(i=>T.Range.from(i));else if(a instanceof t.Position){const{lineNumber:i,column:v}=T.Position.from(a);n=[{startLineNumber:i,startColumn:v,endLineNumber:i,endColumn:v}]}else if(a instanceof t.Range)n=[T.Range.from(a)];else{n=[];for(const i of a)if(i instanceof t.Range)n.push(T.Range.from(i));else{const{lineNumber:v,column:g}=T.Position.from(i);n.push({startLineNumber:v,startColumn:g,endLineNumber:v,endColumn:g})}}return m.$tryInsertSnippet(r,y.value,n,P)},setDecorations(y,a){const P=a.length===0;P&&!h._hasDecorationsForKey.has(y.key)||(P?h._hasDecorationsForKey.delete(y.key):h._hasDecorationsForKey.add(y.key),h._runOnProxy(()=>{if(T.isDecorationOptionsArr(a))return m.$trySetDecorations(r,y.key,T.fromRangeOrRangeWithMessage(a));{const n=new Array(4*a.length);for(let i=0,v=a.length;i<v;i++){const g=a[i];n[4*i]=g.start.line+1,n[4*i+1]=g.start.character+1,n[4*i+2]=g.end.line+1,n[4*i+3]=g.end.character+1}return m.$trySetDecorationsFast(r,y.key,n)}}))},revealRange(y,a){h._runOnProxy(()=>m.$tryRevealRange(r,T.Range.from(y),a||t.TextEditorRevealType.Default))},show(y){m.$tryShowEditor(r,T.ViewColumn.from(y))},hide(){m.$tryHideEditor(r)}})}dispose(){(0,c.ok)(!this._disposed),this._disposed=!0}_acceptOptions(r){(0,c.ok)(!this._disposed),this._options._accept(r)}_acceptVisibleRanges(r){(0,c.ok)(!this._disposed),this._visibleRanges=r}_acceptViewColumn(r){(0,c.ok)(!this._disposed),this._viewColumn=r}_acceptSelections(r){(0,c.ok)(!this._disposed),this._selections=r}async _trySetSelection(){const r=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,r)),this.value}_applyEdit(r){const m=r.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const o=m.edits.map(p=>p.range);o.sort((p,D)=>p.end.line===D.end.line?p.end.character===D.end.character?p.start.line===D.start.line?p.start.character-D.start.character:p.start.line-D.start.line:p.end.character-D.end.character:p.end.line-D.end.line);for(let p=0,D=o.length-1;p<D;p++){const f=o[p].end;if(o[p+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=m.edits.map(p=>({range:T.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,d,{setEndOfLine:typeof m.setEndOfLine=="number"?T.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(r){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):r().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=F}),define(we[173],Ee([0,1,128,23,2,3,7,14,6,10,16,8,20,157]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(D,f){if((0,k.isString)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let l;return Array.isArray(D.highlights)&&(l=D.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),l=l.length?l:void 0),{label:D.label,highlights:l}}}class d{constructor(f,l,h){this._proxy=f,this.commands=l,this.logService=h,this.treeViews=new Map;function y(a){return a&&a.$treeViewId&&a.$treeItemHandle}l.registerArgumentProcessor({processArgument:a=>y(a)?this.convertArgument(a):Array.isArray(a)&&a.length>0?a.map(P=>y(P)?this.convertArgument(P):P):a})}registerTreeDataProvider(f,l,h){const y=this.createTreeView(f,{treeDataProvider:l},h);return{dispose:()=>y.dispose()}}createTreeView(f,l,h){if(!l||!l.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const y=l.dragAndDropController!==void 0,a=this._proxy.$registerTreeViewDataProvider(f,{showCollapseAll:!!l.showCollapseAll,canSelectMany:!!l.canSelectMany,canDragAndDrop:y}),P=this.createExtHostTreeView(f,l,h);return{get onDidCollapseElement(){return P.onDidCollapseElement},get onDidExpandElement(){return P.onDidExpandElement},get selection(){return P.selectedElements},get onDidChangeSelection(){return P.onDidChangeSelection},get visible(){return P.visible},get onDidChangeVisibility(){return P.onDidChangeVisibility},get message(){return P.message},set message(n){P.message=n},get title(){return P.title},set title(n){P.title=n},get description(){return P.description},set description(n){P.description=n},reveal:(n,i)=>P.reveal(n,i),dispose:async()=>{await a,this.treeViews.delete(f),P.dispose()}}}$getChildren(f,l){const h=this.treeViews.get(f);return h?h.getChildren(l):Promise.reject(new Error((0,c.localize)(0,null,f)))}async $onDrop(f,l,h,y,a){const P=this.treeViews.get(f);if(!P)return Promise.reject(new Error((0,c.localize)(1,null,f)));const n=m.TreeDataTransferConverter.toITreeDataTransfer(l);if(y===f&&a){const i=await P.onWillDrop(a);i&&i.items.forEach((v,g)=>{v&&n.items.set(g,v)})}return P.onDrop(n,h)}async $hasResolve(f){const l=this.treeViews.get(f);if(!l)throw new Error((0,c.localize)(2,null,f));return l.hasResolve}$resolve(f,l,h){const y=this.treeViews.get(f);if(!y)throw new Error((0,c.localize)(3,null,f));return y.resolveTreeItem(l,h)}$setExpanded(f,l,h){const y=this.treeViews.get(f);if(!y)throw new Error((0,c.localize)(4,null,f));y.setExpanded(l,h)}$setSelection(f,l){const h=this.treeViews.get(f);if(!h)throw new Error((0,c.localize)(5,null,f));h.setSelection(l)}$setVisible(f,l){const h=this.treeViews.get(f);if(!h)throw new Error((0,c.localize)(6,null,f));h.setVisible(l)}createExtHostTreeView(f,l,h){const y=new p(f,l,this._proxy,this.commands.converter,this.logService,h);return this.treeViews.set(f,y),y}convertArgument(f){const l=this.treeViews.get(f.$treeViewId);return l?l.getExtensionElement(f.$treeItemHandle):null}}e.ExtHostTreeViews=d;class p extends t.Disposable{constructor(f,l,h,y,a,P){super();if(this.viewId=f,this.proxy=h,this.commands=y,this.logService=a,this.extension=P,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new r.CancellationTokenSource,P.contributes&&P.contributes.views)for(const v in P.contributes.views)for(const g of P.contributes.views[v])g.id===f&&(this._title=g.name);this.dataProvider=l.treeDataProvider,this.dndController=l.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(v=>this._onDidChangeData.fire({message:!1,element:v}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(v=>this._onDidChangeData.fire({message:!1,element:v})));let n,i;this._register(T.Event.debounce(this._onDidChangeData.event,(v,g)=>(v||(v={message:!1,elements:[]}),g.element!==!1&&(n||(n=new Promise(s=>i=s),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(g.element)?v.elements.push(...g.element):v.elements.push(g.element)),g.message&&(v.message=!0),v),200,!0)(({message:v,elements:g})=>{g.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const s=i;return n=null,this.refresh(g).then(()=>s())})),v&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(f=>this.getExtensionElement(f)).filter(f=>!(0,k.isUndefinedOrNull)(f))}async getChildren(f){const l=f?this.getExtensionElement(f):void 0;if(f&&!l)return this.logService.error(`No tree item with id '${f}' found.`),Promise.resolve([]);let h=this.getChildrenNodes(f);return h||(h=await this.fetchChildrenNodes(l)),h?h.map(y=>y.item):void 0}getExtensionElement(f){return this.elements.get(f)}reveal(f,l){l=l||{select:!0,focus:!1};const h=(0,k.isUndefinedOrNull)(l.select)?!0:l.select,y=(0,k.isUndefinedOrNull)(l.focus)?!1:l.focus,a=(0,k.isUndefinedOrNull)(l.expand)?!1:l.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.refreshPromise.then(()=>this.resolveUnknownParentChain(f)).then(P=>this.resolveTreeNode(f,P[P.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:P.map(i=>i.item)},{select:h,focus:y,expand:a})),P=>this.logService.error(P)):this.proxy.$reveal(this.viewId,void 0,{select:h,focus:y,expand:a})}get message(){return this._message}set message(f){this._message=f,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(f){this._title=f,this.proxy.$setTitle(this.viewId,f,this._description)}get description(){return this._description}set description(f){this._description=f,this.proxy.$setTitle(this.viewId,this._title,f)}setExpanded(f,l){const h=this.getExtensionElement(f);h&&(l?this._onDidExpandElement.fire(Object.freeze({element:h})):this._onDidCollapseElement.fire(Object.freeze({element:h})))}setSelection(f){(0,F.equals)(this._selectedHandles,f)||(this._selectedHandles=f,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(f){f!==this._visible&&(this._visible=f,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(f){const l=[];for(const h of f){const y=this.getExtensionElement(h);y&&l.push(y)}if(!(!this.dndController?.onWillDrop||l.length===0))return this.dndController.onWillDrop(l)}async onDrop(f,l){const h=this.getExtensionElement(l);if(!!h)return(0,R.asPromise)(()=>this.dndController?.onDrop(f,h))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(f,l){if(!this.dataProvider.resolveTreeItem)return;const h=this.elements.get(f);if(h){const y=this.nodes.get(h);if(y){const a=await this.dataProvider.resolveTreeItem(y.extensionItem,h,l)??y.extensionItem;return y.item.tooltip=this.getTooltip(a.tooltip),y.item.command=this.getCommand(y.disposableStore,a.command),y.item}}}resolveUnknownParentChain(f){return this.resolveParent(f).then(l=>l?this.resolveUnknownParentChain(l).then(h=>this.resolveTreeNode(l,h[h.length-1]).then(y=>(h.push(y),h))):Promise.resolve([]))}resolveParent(f){const l=this.nodes.get(f);return l?Promise.resolve(l.parent?this.elements.get(l.parent.item.handle):void 0):(0,R.asPromise)(()=>this.dataProvider.getParent(f))}resolveTreeNode(f,l){const h=this.nodes.get(f);return h?Promise.resolve(h):(0,R.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(y=>this.createHandle(f,y,l,!0)).then(y=>this.getChildren(l?l.item.handle:void 0).then(()=>{const a=this.getExtensionElement(y);if(a){const P=this.nodes.get(a);if(P)return Promise.resolve(P)}throw new Error(`Cannot resolve tree item for element ${y}`)}))}getChildrenNodes(f){if(f){let l;if(typeof f=="string"){const h=this.getExtensionElement(f);l=h?this.nodes.get(h):void 0}else l=f;return l&&l.children||void 0}return this.roots}async fetchChildrenNodes(f){this.clearChildren(f);const l=new r.CancellationTokenSource(this._refreshCancellationSource.token);try{const h=f?this.nodes.get(f):void 0,y=await this.dataProvider.getChildren(f);if(l.token.isCancellationRequested)return;const a=await Promise.all((0,F.coalesce)(y||[]).map(async P=>{const n=await this.dataProvider.getTreeItem(P);return n&&!l.token.isCancellationRequested?this.createAndRegisterTreeNode(P,n,h):null}));return l.token.isCancellationRequested?void 0:(0,F.coalesce)(a)}finally{l.dispose()}}refresh(f){if(f.some(h=>!h))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new r.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const h=this.getHandlesToRefresh(f);if(h.length)return this.refreshHandles(h)}return Promise.resolve(void 0)}getHandlesToRefresh(f){const l=new Set,h=f.map(a=>this.nodes.get(a));for(const a of h)if(a&&!l.has(a.item.handle)){let P=a;for(;P&&P.parent&&h.findIndex(n=>P&&P.parent&&n&&n.item.handle===P.parent.item.handle)===-1;){const n=this.elements.get(P.parent.item.handle);P=n?this.nodes.get(n):void 0}P&&!P.parent&&l.add(a.item.handle)}const y=[];return l.forEach(a=>{const P=this.elements.get(a);if(P){const n=this.nodes.get(P);n&&(!n.parent||!l.has(n.parent.item.handle))&&y.push(a)}}),y}refreshHandles(f){const l={};return Promise.all(f.map(h=>this.refreshNode(h).then(y=>{y&&(l[h]=y.item)}))).then(()=>Object.keys(l).length?this.proxy.$refresh(this.viewId,l):void 0)}refreshNode(f){const l=this.getExtensionElement(f);if(l){const h=this.nodes.get(l);if(h)return this.clearChildren(l),(0,R.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(y=>{if(y){const a=this.createTreeNode(l,y,h.parent);return this.updateNodeCache(l,a,h,h.parent),h.dispose(),a}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(f,l,h){const y=this.createTreeNode(f,l,h);if(l.id&&this.elements.has(y.item.handle))throw new Error((0,c.localize)(7,null,l.id));return this.addNodeToCache(f,y),this.addNodeToParentCache(y,h),y}getTooltip(f){return C.MarkdownString.isMarkdownString(f)?_.MarkdownString.from(f):f}getCommand(f,l){return l?this.commands.toInternal(l,f):void 0}createTreeNode(f,l,h){const y=new t.DisposableStore,a=this.createHandle(f,l,h),P=this.getLightIconPath(l);return{item:{handle:a,parentHandle:h?h.item.handle:void 0,label:o(l.label,this.extension),description:l.description,resourceUri:l.resourceUri,tooltip:this.getTooltip(l.tooltip),command:this.getCommand(y,l.command),contextValue:l.contextValue,icon:P,iconDark:this.getDarkIconPath(l)||P,themeIcon:this.getThemeIcon(l),collapsibleState:(0,k.isUndefinedOrNull)(l.collapsibleState)?C.TreeItemCollapsibleState.None:l.collapsibleState,accessibilityInformation:l.accessibilityInformation},extensionItem:l,parent:h,children:void 0,disposableStore:y,dispose(){y.dispose()}}}getThemeIcon(f){return f.iconPath instanceof C.ThemeIcon?f.iconPath:void 0}createHandle(f,{id:l,label:h,resourceUri:y},a,P){if(l)return`${p.ID_HANDLE_PREFIX}/${l}`;const n=o(h,this.extension),i=a?a.item.handle:p.LABEL_HANDLE_PREFIX;let v=n?n.label:y?(0,M.basename)(y):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const g=this.nodes.has(f)?this.nodes.get(f).item.handle:void 0,s=this.getChildrenNodes(a)||[];let b,u=0;do{if(b=`${i}/${u}:${v}`,P||!this.elements.has(b)||g===b)break;u++}while(u<=s.length);return b}getLightIconPath(f){if(f.iconPath&&!(f.iconPath instanceof C.ThemeIcon))return typeof f.iconPath=="string"||w.URI.isUri(f.iconPath)?this.getIconPath(f.iconPath):this.getIconPath(f.iconPath.light)}getDarkIconPath(f){if(f.iconPath&&!(f.iconPath instanceof C.ThemeIcon)&&f.iconPath.dark)return this.getIconPath(f.iconPath.dark)}getIconPath(f){return w.URI.isUri(f)?f:w.URI.file(f)}addNodeToCache(f,l){this.elements.set(l.item.handle,f),this.nodes.set(f,l)}updateNodeCache(f,l,h,y){this.elements.delete(l.item.handle),this.nodes.delete(f),l.item.handle!==h.item.handle&&this.elements.delete(h.item.handle),this.addNodeToCache(f,l);const a=this.getChildrenNodes(y)||[],P=a.filter(n=>n.item.handle===h.item.handle)[0];P&&a.splice(a.indexOf(P),1,l)}addNodeToParentCache(f,l){l?(l.children||(l.children=[]),l.children.push(f)):(this.roots||(this.roots=[]),this.roots.push(f))}clearChildren(f){if(f){const l=this.nodes.get(f);if(l){if(l.children)for(const h of l.children){const y=this.elements.get(h.item.handle);y&&this.clear(y)}l.children=void 0}}else this.clearAll()}clear(f){const l=this.nodes.get(f);if(l){if(l.children)for(const h of l.children){const y=this.elements.get(h.item.handle);y&&this.clear(y)}this.nodes.delete(f),this.elements.delete(l.item.handle),l.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(f=>f.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}p.LABEL_HANDLE_PREFIX="0",p.ID_HANDLE_PREFIX="1"}),define(we[174],Ee([0,1,14,3,7,10,48,8,89,68]),function(re,e,c,M,w,T,t,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends w.Disposable{constructor(r){super();this.controllerId=r,this.debounceSendDiff=this._register(new c.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new t.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(r){this._resolveHandler=r;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const r=this.diff;return this.diff=[],r}pushDiff(r){const m=this.diff[this.diff.length-1];if(m&&r[0]===1){if(m[0]===1&&m[1].extId===r[1].extId){(0,C.applyTestItemUpdate)(m[1],r[1]);return}if(m[0]===0&&m[1].item.extId===r[1].extId){(0,C.applyTestItemUpdate)(m[1],r[1]);return}}this.diff.push(r),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(r,m){const o=this.tree.get(r);if(!!o){if((o.expandLevels===void 0||m>o.expandLevels)&&(o.expandLevels=m),o.expand===1){const d=this.resolveChildren(o);return d.isOpen()?this.expandChildren(o,m-1):d.wait().then(()=>this.expandChildren(o,m-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,m-1)):this.expandChildren(o,m-1)}}dispose(){for(const r of this.tree.values())(0,t.getPrivateApiFor)(r.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(r,m){switch(m.op){case 2:this.pushDiff([4,r.fullId.toString()]);break;case 1:this.removeItem(k.TestId.joinToString(r.fullId,m.id));break;case 0:this.upsertItem(m.item,r);break;case 4:for(const f of m.ops)this.onTestItemEvent(r,f);break;case 3:const{key:o,value:d,previous:p}=m,D=r.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(r);break;case"tags":this.diffTagRefs(d,p,D);break;case"range":this.pushDiff([1,{extId:D,item:{range:R.Range.from(d)}}]);break;case"error":this.pushDiff([1,{extId:D,item:{error:R.MarkdownString.fromStrict(d)||null}}]);break;default:this.pushDiff([1,{extId:D,item:{[o]:d??null}}]);break}break;default:(0,T.assertNever)(m)}}upsertItem(r,m){if(!(r instanceof t.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${r.id} did not`);const o=k.TestId.fromExtHostTestItem(r,this.root.id,m?.actual),d=(0,t.getPrivateApiFor)(r);d.parent&&d.parent!==m?.actual&&d.parent.children.delete(r.id);let p=this.tree.get(o.toString());if(!p){p={fullId:o,actual:r,parent:m?o.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},r.tags.forEach(this.incrementTagRefs,this),this.tree.set(p.fullId.toString(),p),this.setItemParent(r,m),this.pushDiff([0,{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:R.TestItem.from(r)}]),this.connectItemAndChildren(r,p,m);return}if(p.actual===r){this.connectItem(r,p,m);return}const D=p.actual.children,f=p.actual,l=(0,t.diffTestItems)(f,r);(0,t.getPrivateApiFor)(f).listener=void 0,p.actual=r,p.expand=0;for(const[h,y]of l)this.onTestItemEvent(p,{op:3,key:h,value:y,previous:f[h]});this.connectItemAndChildren(r,p,m);for(const h of D)r.children.get(h.id)||this.removeItem(k.TestId.joinToString(o,h.id))}diffTagRefs(r,m,o){const d=new Set(m.map(p=>p.id));for(const p of r)d.delete(p.id)||this.incrementTagRefs(p);this.pushDiff([1,{extId:o,item:{tags:r.map(p=>R.TestTag.namespace(this.controllerId,p.id))}}]),d.forEach(this.decrementTagRefs,this)}incrementTagRefs(r){const m=this.tags.get(r.id);m?m.refCount++:(this.tags.set(r.id,{refCount:1}),this.pushDiff([5,{id:R.TestTag.namespace(this.controllerId,r.id),ctrlLabel:this.root.label}]))}decrementTagRefs(r){const m=this.tags.get(r);m&&!--m.refCount&&(this.tags.delete(r),this.pushDiff([6,R.TestTag.namespace(this.controllerId,r)]))}setItemParent(r,m){(0,t.getPrivateApiFor)(r).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(r,m,o){this.setItemParent(r,o);const d=(0,t.getPrivateApiFor)(r);d.parent=o?.actual,d.listener=p=>this.onTestItemEvent(m,p),this.updateExpandability(m)}connectItemAndChildren(r,m,o){this.connectItem(r,m,o);for(const d of r.children)this.upsertItem(d,m)}updateExpandability(r){let m;this._resolveHandler?r.resolveBarrier?m=r.resolveBarrier.isOpen()?3:2:m=r.actual.canResolveChildren?1:0:m=0,m!==r.expand&&(r.expand=m,this.pushDiff([1,{extId:r.fullId.toString(),expand:m}]),m===1&&r.expandLevels!==void 0&&this.resolveChildren(r))}expandChildren(r,m){if(m<0)return;const o=[];for(const d of r.actual.children){const p=this.expand(k.TestId.joinToString(r.fullId,d.id),m);(0,c.isThenable)(p)&&o.push(p)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this._resolveHandler){const p=new c.Barrier;return p.open(),p}r.expand=2,this.pushExpandStateUpdate(r);const m=r.resolveBarrier=new c.Barrier,o=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),r.actual!==this.root&&(r.actual.error=p.stack||p.message||String(p))};let d;try{d=this._resolveHandler(r.actual===this.root?void 0:r.actual)}catch(p){o(p)}return(0,c.isThenable)(d)?d.catch(o).then(()=>{m.open(),this.updateExpandability(r)}):(m.open(),this.updateExpandability(r)),r.resolveBarrier}pushExpandStateUpdate(r){this.pushDiff([1,{extId:r.fullId.toString(),expand:r.expand}])}removeItem(r){const m=this.tree.get(r);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,r]);const o=[m];for(;o.length;){const d=o.pop();if(!!d){(0,t.getPrivateApiFor)(d.actual).listener=void 0;for(const p of d.actual.tags)this.decrementTagRefs(p.id);this.tree.delete(d.fullId.toString());for(const p of d.actual.children)o.push(this.tree.get(k.TestId.joinToString(d.fullId,p.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.diffOpEmitter.fire(r)}}e.SingleUseTestCollection=F}),define(we[175],Ee([0,1,4,140]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,c.refineServiceDecorator)(M.IEnvironmentService)}),define(we[176],Ee([0,1,26,3,17]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=T;class t{constructor(F){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(c.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(c.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let _ of F.activationEvents)_==="onUri"&&(_=`onUri:${c.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(F)}}keepOnly(F){const _=new Set;F.forEach(r=>_.add(c.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>_.has(c.ExtensionIdentifier.toKey(r.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,_){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const r=t._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(r.map(m=>m.identifier)),_.length>0){const m=new Set;_.forEach(o=>m.add(c.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!m.has(c.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(r)}static _findLoopingExtensions(F){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,D){this.addNode(p),this.addNode(D),this._arcs.has(p)?this._arcs.get(p).push(D):this._arcs.set(p,[D])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,D){const f=_.getArcs(p);for(let l=0;l<f.length;l++)if(!D.has(f[l]))return!1;return!0}getNodes(){return this._nodesArr}};let r=new Map;for(let p of F){const D=c.ExtensionIdentifier.toKey(p.identifier);if(r.set(D,p),p.extensionDependencies)for(let f of p.extensionDependencies){const l=c.ExtensionIdentifier.toKey(f);_.addArc(D,l)}}let m=new Set;_.getNodes().filter(p=>_.getArcs(p).length===0).forEach(p=>m.add(p));let o=_.getNodes().filter(p=>!m.has(p)),d;do{d=!1;for(let p=0;p<o.length;p++){const D=o[p];_.hasOnlyGoodArcs(D,m)&&(o.splice(p,1),p--,m.add(D),d=!0)}}while(d);return o.map(p=>r.get(p))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(c.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const _=this._activationMap.get(F);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const _=this._extensionsMap.get(c.ExtensionIdentifier.toKey(F));return _||void 0}}e.ExtensionDescriptionRegistry=t;var R;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(R||(R={}));function C(k,F){const _=k.isBuiltin?0:k.isUnderDevelopment?2:1,r=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(_!==r)return _-r;const m=w.posix.basename(k.extensionLocation.path),o=w.posix.basename(F.extensionLocation.path);return m<o?-1:m>o?1:0}}),define(we[177],Ee([0,1,22]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(R){R[R.VersionMismatch=55]="VersionMismatch",R[R.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var w;(function(R){R[R.Initialized=0]="Initialized",R[R.Ready=1]="Ready",R[R.Terminate=2]="Terminate"})(w=e.MessageType||(e.MessageType={}));function T(R){const C=c.VSBuffer.alloc(1);switch(R){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=T;function t(R,C){if(R.byteLength!==1)return!1;switch(R.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=t}),define(we[27],Ee([0,1,3,2,4,26,147]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");var R;(function(h){h[h.None=0]="None",h[h.LocalProcess=1]="LocalProcess",h[h.LocalWebWorker=2]="LocalWebWorker",h[h.Remote=3]="Remote"})(R=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(h){switch(h){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class k{constructor(y){this.dependency=y}}e.MissingExtensionDependency=k;var F;(function(h){h[h.LocalProcess=0]="LocalProcess",h[h.LocalWebWorker=1]="LocalWebWorker",h[h.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(h){switch(h){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;function r(h,y){return h.enabledApiProposals?.includes(y)?!0:Boolean(h.enableProposedApi)}e.isProposedApiEnabled=r;function m(h,y){if(!r(h,y))throw new Error(`Extension '${h.identifier.value}' CANNOT use API proposal: ${y}.
According to its package.json#enabledApiProposals-property it wants: ${h.enabledApiProposals?.join(", ")??"<none>"}.
 You MUST start in extension development mode or use the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.checkProposedApiEnabled=m;class o{constructor(y,a,P,n){this.codeLoadingTime=y,this.activateCallTime=a,this.activateResolvedTime=P,this.activationReason=n}}e.ActivationTimes=o;class d{constructor(y,a){this.description=y,this.value=a}}e.ExtensionPointContribution=d,e.ExtensionHostLogFileName="exthost";var p;(function(h){h[h.Normal=0]="Normal",h[h.Immediate=1]="Immediate"})(p=e.ActivationKind||(e.ActivationKind={}));function D(h){return{type:h.isBuiltin?0:1,isBuiltin:h.isBuiltin||h.isUserBuiltin,identifier:{id:(0,t.getGalleryExtensionId)(h.publisher,h.name),uuid:h.uuid},manifest:h,location:h.extensionLocation}}e.toExtension=D;function f(h,y){return{identifier:new T.ExtensionIdentifier(h.identifier.id),isBuiltin:h.type===0,isUserBuiltin:h.type===1&&h.isBuiltin,isUnderDevelopment:!!y,extensionLocation:h.location,...h.manifest,uuid:h.identifier.uuid}}e.toExtensionDescription=f;class l{constructor(){this.onDidRegisterExtensions=c.Event.None,this.onDidChangeExtensionsStatus=c.Event.None,this.onDidChangeExtensions=c.Event.None,this.onWillActivateByEvent=c.Event.None,this.onDidChangeResponsiveChange=c.Event.None}activateByEvent(y){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(y){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(y){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(y){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(y,a){return Promise.resolve()}_onWillActivateExtension(y){}_onDidActivateExtension(y,a,P,n,i){}_onDidActivateExtensionError(y,a){}_onExtensionRuntimeError(y,a){}_onExtensionHostExit(y){}}e.NullExtensionService=l}),define(we[178],Ee([0,1,26,27,12]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class t{constructor(o,d,p,D){this.startup=o,this.codeLoadingTime=d,this.activateCallTime=p,this.activateResolvedTime=D}}e.ExtensionActivationTimes=t,t.NONE=new t(!1,-1,-1,-1);class R{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,d){return o===-1||d===-1?-1:d-o}build(){return new t(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=R;class C{constructor(o,d,p,D,f,l){this.activationFailed=o,this.activationFailedError=d,this.activationTimes=p,this.module=D,this.exports=f,this.subscriptions=l}}e.ActivatedExtension=C;class k extends C{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class F extends C{constructor(){super(!1,null,t.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=F;class _ extends C{constructor(o){super(!0,o,t.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let r=class{constructor(o,d,p,D,f){this._logService=f,this._registry=o,this._resolvedExtensionsSet=new Set,d.forEach(l=>this._resolvedExtensionsSet.add(c.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,p.forEach(l=>this._hostExtensionsMap.set(c.ExtensionIdentifier.toKey(l),l)),this._host=D,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(o){const d=c.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(d)}getActivatedExtension(o){const d=c.ExtensionIdentifier.toKey(o),p=this._activatedExtensions.get(d);if(!p)throw new Error("Extension `"+o.value+"` is not known or not activated");return p}activateByEvent(o,d){if(this._alreadyActivatedEvents[o])return T;const p=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(p.map(D=>({id:D.identifier,reason:{startup:d,extensionId:D.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,d){const p=this._registry.getExtensionDescription(o);if(!p)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:p.identifier,reason:d}])}_handleActivateRequest(o,d,p){if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(o.id))){d[c.ExtensionIdentifier.toKey(o.id)]=o;return}const D=this._registry.getExtensionDescription(o.id);if(!D){const h=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,h,new M.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(o.id),new _(h));return}const f=typeof D.extensionDependencies=="undefined"?[]:D.extensionDependencies;let l=!0;for(let h=0,y=f.length;h<y;h++){const a=f[h];if(this._resolvedExtensionsSet.has(c.ExtensionIdentifier.toKey(a)))continue;const P=this._activatedExtensions.get(c.ExtensionIdentifier.toKey(a));if(P&&!P.activationFailed)continue;if(P&&P.activationFailed){const g=D.displayName||D.identifier.value,s=this._registry.getExtensionDescription(a),b=s&&s.displayName||a,u=new Error(`Cannot activate the '${g}' extension because its dependency '${b}' failed to activate`);u.detail=P.activationFailedError,this._host.onExtensionActivationError(D.identifier,u,null),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(D.identifier),new _(u));return}if(this._hostExtensionsMap.has(c.ExtensionIdentifier.toKey(a))){l=!1,d[c.ExtensionIdentifier.toKey(a)]={id:this._hostExtensionsMap.get(c.ExtensionIdentifier.toKey(a)),reason:o.reason};continue}const n=this._registry.getExtensionDescription(a);if(n){if(!n.main&&!n.browser)continue;l=!1,d[c.ExtensionIdentifier.toKey(a)]={id:n.identifier,reason:o.reason};continue}const i=D.displayName||D.identifier.value,v=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${a}'`);this._host.onExtensionActivationError(D.identifier,v,new M.MissingExtensionDependency(a)),this._activatedExtensions.set(c.ExtensionIdentifier.toKey(D.identifier),new _(v));return}l?d[c.ExtensionIdentifier.toKey(D.identifier)]=o:p.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(f=>!this._activatedExtensions.has(c.ExtensionIdentifier.toKey(f.id))),o.length===0))return Promise.resolve(void 0);const d=Object.create(null),p=[];for(let f=0,l=o.length;f<l;f++)this._handleActivateRequest(o[f],d,p);for(let f=0,l=p.length;f<l;f++){const h=c.ExtensionIdentifier.toKey(p[f].id);d[h]&&delete d[h]}const D=Object.keys(d).map(f=>d[f]);return p.length===0?Promise.all(D.map(f=>this._activateExtension(f.id,f.reason))).then(f=>{}):this._activateExtensions(D).then(f=>this._activateExtensions(p))}_activateExtension(o,d){const p=c.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const D=this._activatingExtensions.get(p);if(D)return D;const f=this._host.actualActivateExtension(o,d).then(void 0,l=>{const h=new Error;return l&&l.name&&(h.name=l.name),l&&l.message?h.message=`Activating extension '${o.value}' failed: ${l.message}.`:h.message=`Activating extension '${o.value}' failed: ${l}.`,l&&l.stack&&(h.stack=l.stack),this._host.onExtensionActivationError(o,h,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(l),new _(l)}).then(l=>{this._activatedExtensions.set(p,l),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,f),f}};r=Ue([Be(4,w.ILogService)],r),e.ExtensionsActivator=r}),define(we[179],Ee([0,1,12,28,27]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends c.LogService{constructor(R,C){super(R.createLogger(C.logFile,{name:w.ExtensionHostLogFileName}))}};T=Ue([Be(0,c.ILoggerService),Be(1,M.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(we[180],Ee([0,1,15]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,t)=>{this._actualOk=T,this._actualErr=t,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,c.onUnexpectedError)(T))}then(T,t){return this._ensureActual().then(T,t)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=M}),define(we[37],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class c{constructor(k,F){this._proxyIdentifierBrand=void 0,this.isMain=k,this.sid=F,this.nid=++c.count}}e.ProxyIdentifier=c,c.count=0;const M=[];function w(C){const k=new c(!0,C);return M[k.nid]=k,k}e.createMainContextProxyIdentifier=w;function T(C){const k=new c(!1,C);return M[k.nid]=k,k}e.createExtHostContextProxyIdentifier=T;function t(C){return M[C].sid}e.getStringIdentifierForProxy=t;class R{constructor(k){this.value=k}}e.SerializableObjectWithBuffers=R}),define(we[5],Ee([0,1,55,2,37]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var t;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var R;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(R=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var r;(function(l){l.name="$ident";function h(a,P){return Object.defineProperty(a,l.name,{value:P,enumerable:!0}),a}l.mixin=h;function y(a){return a[l.name]}l.of=y})(r=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(h){return h._id=m._n++,h}}e.IdObject=m,m._n=0;var o;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(l){if(l&&l.edits)for(const h of l.edits)typeof h.resource=="object"?h.resource=M.URI.revive(h.resource):(h.newUri=M.URI.revive(h.newUri),h.oldUri=M.URI.revive(h.oldUri)),h.metadata&&h.metadata.iconPath&&(h.metadata=(0,c.revive)(h.metadata));return l}e.reviveWorkspaceEditDto=D;var f;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[69],Ee([0,1,5,3,4]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(R){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=R.getProxy(c.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this._onDidChangePassword.fire(R)}get(R,C){return this._proxy.$getPassword(R,C)}store(R,C,k){return this._proxy.$setPassword(R,C,k)}delete(R,C){return this._proxy.$deletePassword(R,C)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")}),define(we[70],Ee([0,1,4,12,5,13]),function(re,e,c,M,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,c.createDecorator)("IExtHostApiDeprecationService");let t=class{constructor(C,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(w.MainContext.MainThreadTelemetry)}report(C,k,F){const _=this.getUsageKey(C,k);this._reportedUsages.has(_)||(this._reportedUsages.add(_),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:C}))}getUsageKey(C,k){return`${C}-${k.identifier.value}`}};t=Ue([Be(0,T.IExtHostRpcService),Be(1,M.ILogService)],t),e.ExtHostApiDeprecationService=t,e.NullApiDeprecationService=Object.freeze(new class{report(R,C,k){}})}),define(we[181],Ee([0,1,3,5,6,26]),function(re,e,c,M,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class t{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new c.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,k,F,_={}){const r=T.ExtensionIdentifier.toKey(C.identifier),m=this._inFlightRequests.get(r)||[],o=[...F].sort().join(" ");let d=m.find(p=>p.scopes===o);if(d)return d.result;{const p=this._getSession(C,r,k,F,_);d={scopes:o,result:p},m.push(d),this._inFlightRequests.set(r,m);try{await p}finally{const D=m.findIndex(f=>f.scopes===o);D>-1&&(m.splice(D),this._inFlightRequests.set(r,m))}return p}}async _getSession(C,k,F,_,r={}){await this._proxy.$ensureProvider(F);const m=C.displayName||C.name;return this._proxy.$getSession(F,_,k,m,r)}async removeSession(C,k){const F=this._authenticationProviders.get(C);return F?F.provider.removeSession(k):this._proxy.$removeSession(C,k)}registerAuthenticationProvider(C,k,F,_){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:k,provider:F,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===C)||this._providers.push({id:C,label:k});const r=F.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(C,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,k,_?.supportsMultipleAccounts??!1),new w.Disposable(()=>{r.dispose(),this._authenticationProviders.delete(C);const m=this._providers.findIndex(o=>o.id===C);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,k){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,k){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,k){const F=this._authenticationProviders.get(C);if(F)return Promise.resolve(F.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,k){return this._onDidChangeSessions.fire({provider:{id:C,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=t}),define(we[182],Ee([0,1,5,13,8]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(R,C){this._extHostDocumentsAndEditors=C,this._proxy=R.getProxy(c.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(R){const C=w.WorkspaceEdit.from(R,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};T=Ue([Be(0,M.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(we[183],Ee([0,1,5]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(T){const t=T.getProxy(c.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return t.$readText()},writeText(R){return t.$writeText(R)}})}}e.ExtHostClipboard=M}),define(we[38],Ee([0,1,10,6,8,25,5,16,12,55,43,110,2,7,4,13,48,22,37,44]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let h=class{constructor(v,g){this._commands=new Map,this._apiCommands=new Map,this._proxy=v.getProxy(t.MainContext.MainThreadCommands),this._logService=g,this.converter=new y(this,s=>{const b=this._apiCommands.get(s);return b?.result===P.Void?b:void 0},g),this._argumentProcessors=[{processArgument(s){return(0,k.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(b){if(F.Range.isIRange(b))return w.Range.to(b);if(_.Position.isIPosition(b))return w.Position.to(b);if(F.Range.isIRange(b.range)&&r.URI.isUri(b.uri))return w.location.to(b);if(b instanceof D.VSBuffer)return b.buffer.buffer;if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(v){this._argumentProcessors.push(v)}registerApiCommand(v){const g=this.registerCommand(!1,v.id,async(...s)=>{const b=v.args.map((E,A)=>{if(!E.validate(s[A]))throw new Error(`Invalid argument '${E.name}' when running '${v.id}', received: ${s[A]}`);return E.convert(s[A])}),u=await this.executeCommand(v.internalId,...b);return v.result.convert(u,s,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this._apiCommands.set(v.id,v),new M.Disposable(()=>{g.dispose(),this._apiCommands.delete(v.id)})}registerCommand(v,g,s,b,u,E){if(this._logService.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this._commands.has(g))throw new Error(`command '${g}' already exists`);return this._commands.set(g,{callback:s,thisArg:b,description:u,extension:E}),v&&this._proxy.$registerCommand(g),new M.Disposable(()=>{this._commands.delete(g)&&v&&this._proxy.$unregisterCommand(g)})}executeCommand(v,...g){return this._logService.trace("ExtHostCommands#executeCommand",v),this._doExecuteCommand(v,g,!0)}async _doExecuteCommand(v,g,s){if(this._commands.has(v))return this._executeContributedCommand(v,g,!1);{let b=!1;const u=(0,T.cloneAndChange)(g,function(E){if(E instanceof M.Position)return w.Position.from(E);if(E instanceof M.Range)return w.Range.from(E);if(E instanceof M.Location)return w.location.from(E);if(M.NotebookRange.isNotebookRange(E))return w.NotebookRange.from(E);if(E instanceof ArrayBuffer)return b=!0,D.VSBuffer.wrap(new Uint8Array(E));if(E instanceof Uint8Array)return b=!0,D.VSBuffer.wrap(E);if(!Array.isArray(E))return E});try{const E=await this._proxy.$executeCommand(v,b?new f.SerializableObjectWithBuffers(u):u,s);return(0,k.revive)(E)}catch(E){if(E instanceof Error&&E.message==="$executeCommand:retry")return this._doExecuteCommand(v,g,!1);throw E}}}async _executeContributedCommand(v,g,s){const b=this._commands.get(v);if(!b)throw new Error("Unknown command");let{callback:u,thisArg:E,description:A}=b;if(A)for(let I=0;I<A.args.length;I++)try{(0,c.validateConstraint)(g[I],A.args[I].constraint)}catch(B){throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${A.args[I].name}' - ${A.args[I].description}`)}try{return await u.apply(E,g)}catch(I){if(v===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...g);B&&(v=B.command)}throw this._logService.error(I,v,b.extension?.identifier),s?new class extends Error{constructor(){super((0,l.toErrorMessage)(I));this.id=v,this.source=b.extension?.displayName??b.extension?.name}}:I}}$executeContributedCommand(v,...g){return this._logService.trace("ExtHostCommands#$executeContributedCommand",v),this._commands.has(v)?(g=g.map(s=>this._argumentProcessors.reduce((b,u)=>u.processArgument(b),s)),this._executeContributedCommand(v,g,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this._logService.trace("ExtHostCommands#getCommands",v),this._proxy.$getCommands().then(g=>(v&&(g=g.filter(s=>s[0]!=="_")),g))}$getContributedCommandHandlerDescriptions(){const v=Object.create(null);for(let[g,s]of this._commands){let{description:b}=s;b&&(v[g]=b)}return Promise.resolve(v)}};h=Ue([Be(0,d.IExtHostRpcService),Be(1,C.ILogService)],h),e.ExtHostCommands=h,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class y{constructor(v,g,s){this._commands=v,this._lookupApiCommand=g,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(v,g){if(!v)return;const s={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return s;const b=this._lookupApiCommand(v.command);if(b)s.id=b.internalId,s.arguments=b.args.map((u,E)=>u.convert(v.arguments&&v.arguments[E]));else if((0,R.isNonEmptyArray)(v.arguments)){const u=++this._cachIdPool;this._cache.set(u,v),g.add((0,m.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),s.$ident=u,s.id=this.delegatingCommandId,s.arguments=[u],this._logService.trace("CommandsConverter#CREATE",v.command,u)}return s}fromInternal(v){const g=t.ObjectIdentifier.of(v);return typeof g=="number"?this._cache.get(g):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this._cache.get(v[0])}_executeConvertedCommand(...v){const g=this.getActualCommand(...v);return this._logService.trace("CommandsConverter#EXECUTE",v[0],g?g.command:"MISSING"),g?this._commands.executeCommand(g.command,...g.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=y;class a{constructor(v,g,s,b){this.name=v,this.description=g,this.validate=s,this.convert=b}optional(){return new a(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,g){return new a(v??this.name,g??this.description,this.validate,this.convert)}}e.ApiCommandArgument=a,a.Uri=new a("uri","Uri of a text document",i=>r.URI.isUri(i),i=>i),a.Position=new a("position","A position in a text document",i=>M.Position.isPosition(i),w.Position.from),a.Range=new a("range","A range in a text document",i=>M.Range.isRange(i),w.Range.from),a.Selection=new a("selection","A selection in a text document",i=>M.Selection.isSelection(i),w.Selection.from),a.Number=new a("number","",i=>typeof i=="number",i=>i),a.String=new a("string","",i=>typeof i=="string",i=>i),a.CallHierarchyItem=new a("item","A call hierarchy item",i=>i instanceof M.CallHierarchyItem,w.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",i=>i instanceof M.TypeHierarchyItem,w.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",i=>i instanceof p.TestItemImpl,w.TestItem.from);class P{constructor(v,g){this.description=v,this.convert=g}}e.ApiCommandResult=P,P.Void=new P("no result",i=>i);class n{constructor(v,g,s,b,u){this.id=v,this.internalId=g,this.description=s,this.args=b,this.result=u}}e.ApiCommand=n}),define(we[184],Ee([0,1,8,6,59,38,16,81]),function(re,e,c,M,w,T,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",F(c.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,m)=>{if((0,t.isFalsyOrEmpty)(r))return;class o extends M.SymbolInformation{static to(p){const D=new o(p.name,c.SymbolKind.to(p.kind),p.containerName||"",new M.Location(m[0],c.Range.to(p.range)));return D.detail=p.detail,D.range=D.location.range,D.selectionRange=c.Range.to(p.selectionRange),D.children=p.children?p.children.map(o.to):[],D}}return r.map(o.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(c.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(c.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new T.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(c.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",F(c.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",F(c.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(m=>M.Position.isPosition(m)),r=>r.map(c.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(m=>{let o;for(const d of m.reverse())o=new M.SelectionRange(c.Range.to(d),o);return o}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(c.WorkspaceSymbol.to))),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(c.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(c.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(c.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to a range and placeholder text.",r=>{if(!!r)return{range:c.Range.to(r.range),placeholder:r.text}})),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return c.WorkspaceEdit.to(r)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(c.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new M.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const m=(0,R.decodeSemanticTokensDto)(r);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range.optional()],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new M.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const m=(0,R.decodeSemanticTokensDto)(r);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,m,o)=>{if(!r)return new M.CompletionList([]);const d=r.suggestions.map(p=>c.CompletionItem.to(p,o));return new M.CompletionList(d,r.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return c.SignatureHelp.to(r)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,m,o)=>F(d=>new M.CodeLens(c.Range.to(d.range),d.command&&o.fromInternal(d.command)))(r))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>M.Range.isRange(r),r=>M.Selection.isSelection(r)?c.Selection.from(r):c.Range.from(r)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,m,o)=>F(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(d.command)}else{const p=new M.CodeAction(d.title,d.kind?new M.CodeActionKind(d.kind):void 0);return d.edit&&(p.edit=c.WorkspaceEdit.to(d.edit)),d.command&&(p.command=o.fromInternal(d.command)),p.isPreferred=d.isPreferred,p}})(r))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(m=>new M.ColorInformation(c.Range.to(m.range),c.Color.to(m.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",r=>r instanceof M.Color,c.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:c.Range.from(r.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(c.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(c.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",F(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(m=>c.NotebookExclusiveDocumentPattern.to(m))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(c.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(c.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(c.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(c.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class k{static register(m){C.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=k;function F(r){return m=>{if(Array.isArray(m))return m.map(r)}}function _(r){if(!Array.isArray(r))return;const m=[];for(const o of r)w.isLocationLink(o)?m.push(c.DefinitionLink.to(o)):m.push(c.location.to(o));return m}}),define(we[185],Ee([0,1,14,52,3,7,2,59,26,8,6,5]),function(re,e,c,M,w,T,t,R,C,k,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function r(m,o,d){const p=m.getProxy(_.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const v=this._commentControllers.get(i.handle);return v||i}else if(i&&i.$mid===7){const v=this._commentControllers.get(i.commentControlHandle);if(!v)return i;const g=v.getCommentThread(i.commentThreadHandle);return g||i}else if(i&&i.$mid===8){const v=this._commentControllers.get(i.thread.commentControlHandle);if(!v)return i;const g=v.getCommentThread(i.thread.commentThreadHandle);return g?{thread:g,text:i.text}:i}else if(i&&i.$mid===9){const v=this._commentControllers.get(i.thread.commentControlHandle);if(!v)return i;const g=v.getCommentThread(i.thread.commentThreadHandle);if(!g)return i;let s=i.commentUniqueId,b=g.getCommentByUniqueId(s);return b||i}else if(i&&i.$mid===10){const v=this._commentControllers.get(i.thread.commentControlHandle);if(!v)return i;const g=v.getCommentThread(i.thread.commentThreadHandle);if(!g)return i;let s=i.text,b=i.commentUniqueId,u=g.getCommentByUniqueId(b);return u?(u.body=s,u):i}return i}})}createCommentController(i,v,g){const s=D.handlePool++,b=new l(i,s,v,g);this._commentControllers.set(b.handle,b);const u=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(i.identifier))||[];return u.push(b),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(i.identifier),u),b.value}$createCommentThreadTemplate(i,v,g){const s=this._commentControllers.get(i);!s||s.$createCommentThreadTemplate(v,g)}async $updateCommentThreadTemplate(i,v,g){const s=this._commentControllers.get(i);!s||s.$updateCommentThreadTemplate(v,g)}$deleteCommentThread(i,v){const g=this._commentControllers.get(i);g&&g.$deleteCommentThread(v)}$provideCommentingRanges(i,v,g){const s=this._commentControllers.get(i);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const b=d.getDocument(t.URI.revive(v));return(0,c.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(b,g)).then(u=>u?u.map(E=>k.Range.from(E)):void 0)}$toggleReaction(i,v,g,s,b){const u=this._commentControllers.get(i);return!u||!u.reactionHandler?Promise.resolve(void 0):(0,c.asPromise)(()=>{const E=u.getCommentThread(v);if(E){const A=E.getCommentByUniqueId(s.uniqueIdInThread);if(u!==void 0&&A&&u.reactionHandler)return u.reactionHandler(A,a(b))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class f{constructor(i,v,g,s,b,u,E){this._commentControllerHandle=v,this._id=g,this._uri=s,this._range=b,this._comments=u,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),p.$createCommentThread(v,this.handle,this._id,this._uri,k.Range.from(this._range),E),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(v,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(I){A.range=I},get comments(){return A.comments},set comments(I){A.comments=I},get collapsibleState(){return A.collapsibleState},set collapsibleState(I){A.collapsibleState=I},get canReply(){return A.canReply},set canReply(I){A.canReply=I},get contextValue(){return A.contextValue},set contextValue(I){A.contextValue=I},get label(){return A.label},set label(I){A.label=I},dispose:()=>{A.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const i=g=>Object.prototype.hasOwnProperty.call(this.modifications,g),v={};i("range")&&(v.range=k.Range.from(this._range)),i("label")&&(v.label=this.label),i("contextValue")&&(v.contextValue=this.contextValue??null),i("comments")&&(v.comments=this._comments.map(g=>h(this,g,this._commentsMap))),i("collapsibleState")&&(v.collapseState=P(this._collapseState)),i("canReply")&&(v.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,v)}getCommentByUniqueId(i){for(let v of this._commentsMap){let g=v[0],s=v[1];if(i===s)return g}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}f._handlePool=0,Ue([(0,M.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(i,v,g,s){this._extension=i,this._handle=v,this._id=g,this._label=s,this._threads=new Map,p.$registerCommentController(this.handle,g,s);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(u){b.options=u},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(u){b.commentingRangeProvider=u},get reactionHandler(){return b.reactionHandler},set reactionHandler(u){b.reactionHandler=u},createCommentThread(u,E,A){return b.createCommentThread(u,E,A).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,v,g,s){if(typeof i=="string"){const b=new f(this.id,this.handle,i,v,g,s,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new f(this.id,this.handle,void 0,i,v,g,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,v){const g=new f(this.id,this.handle,void 0,t.URI.revive(i),k.Range.to(v),[],this._extension.identifier);return g.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this._threads.set(g.handle,g),g}$updateCommentThreadTemplate(i,v){let g=this._threads.get(i);g&&(g.range=k.Range.to(v))}$deleteCommentThread(i){let v=this._threads.get(i);v&&v.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function h(n,i,v){let g=v.get(i);g||(g=++n.commentHandle,v.set(i,g));const s=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:g,body:k.MarkdownString.from(i.body),userName:i.author.name,userIconPath:s,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>y(b)):void 0}}function y(n){return{label:n.label,iconPath:n.iconPath?k.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function a(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?t.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function P(n){if(n!==void 0)switch(n){case F.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}return new D}e.createExtHostComments=r}),define(we[94],Ee([0,1,2,5,6,4,13,12,16,9,17]),function(re,e,c,M,w,T,t,R,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class vi{constructor(m,o){this._logService=o,this._provider=new Map,this._proxy=m.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,o){const d=vi._handlePool++;this._provider.set(d,{provider:m,extensionId:o}),this._proxy.$registerDecorationProvider(d,o.value);const p=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(D=>{if(!D){this._proxy.$onDidChange(d,null);return}let f=(0,C.asArray)(D);if(f.length<=vi._maxEventSize){this._proxy.$onDidChange(d,f);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,f.length);const l=f.map(a=>({uri:a,rank:(0,k.count)(a.path,"/")})),h=(0,C.groupBy)(l,(a,P)=>a.rank-P.rank||(0,k.compare)(a.uri.path,P.uri.path));let y=[];e:for(let a of h){let P;for(let n of a){let i=(0,F.dirname)(n.uri.path);if(P!==i&&(P=i,y.push(n.uri)>=vi._maxEventSize))break e}}this._proxy.$onDidChange(d,y)});return new w.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(m,o,d){if(!this._provider.has(m))return Object.create(null);const p=Object.create(null),{provider:D,extensionId:f}=this._provider.get(m);return await Promise.all(o.map(async l=>{try{const{uri:h,id:y}=l,a=await Promise.resolve(D.provideFileDecoration(c.URI.revive(h),d));if(!a)return;try{w.FileDecoration.validate(a),p[y]=[a.propagate,a.tooltip,a.badge,a.color]}catch(P){this._logService.warn(`INVALID decoration from extension '${f.value}': ${P}`)}}catch(h){this._logService.error(h)}})),p}};_._handlePool=0,_._maxEventSize=250,_=Ue([Be(0,t.IExtHostRpcService),Be(1,R.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[186],Ee([0,1,123,83,2,5,6,8,3,12,21,31]),function(re,e,c,M,w,T,t,R,C,k,F,_){"use strict";var r,m,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(f,l,h,y,a,P){this._name=f,this._owner=l,this._maxDiagnosticsPerFile=h,r.set(this,void 0),m.set(this,void 0),o.set(this,void 0),this._isDisposed=!1,Je(this,o,new F.ResourceMap(n=>y.getComparisonKey(n)),"f"),Je(this,r,a,"f"),Je(this,m,P,"f")}dispose(){this._isDisposed||(Ae(this,m,"f").fire([...Ae(this,o,"f").keys()]),Ae(this,r,"f")&&Ae(this,r,"f").$clear(this._owner),Ae(this,o,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(f,l){if(!f){this.clear();return}this._checkDisposed();let h=[];if(w.URI.isUri(f)){if(!l){this.delete(f);return}Ae(this,o,"f").set(f,l.slice()),h=[f]}else if(Array.isArray(f)){h=[];let a;f=[...f].sort(d._compareIndexedTuplesByUri);for(const P of f){const[n,i]=P;if((!a||n.toString()!==a.toString())&&(a&&Ae(this,o,"f").get(a).length===0&&Ae(this,o,"f").delete(a),a=n,h.push(n),Ae(this,o,"f").set(n,[])),i){const v=Ae(this,o,"f").get(n);v&&v.push(...i)}else{const v=Ae(this,o,"f").get(n);v&&(v.length=0)}}}if(Ae(this,m,"f").fire(h),!Ae(this,r,"f"))return;const y=[];for(let a of h){let P=[];const n=Ae(this,o,"f").get(a);if(n)if(n.length>this._maxDiagnosticsPerFile){P=[];const i=[t.DiagnosticSeverity.Error,t.DiagnosticSeverity.Warning,t.DiagnosticSeverity.Information,t.DiagnosticSeverity.Hint];e:for(let v=0;v<4;v++)for(let g of n)if(g.severity===i[v]&&P.push(R.Diagnostic.from(g))===this._maxDiagnosticsPerFile)break e;P.push({severity:M.MarkerSeverity.Info,message:(0,c.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:P[P.length-1].startLineNumber,startColumn:P[P.length-1].startColumn,endLineNumber:P[P.length-1].endLineNumber,endColumn:P[P.length-1].endColumn})}else P=n.map(i=>R.Diagnostic.from(i));y.push([a,P])}Ae(this,r,"f").$changeMany(this._owner,y)}delete(f){this._checkDisposed(),Ae(this,m,"f").fire([f]),Ae(this,o,"f").delete(f),Ae(this,r,"f")&&Ae(this,r,"f").$changeMany(this._owner,[[f,void 0]])}clear(){this._checkDisposed(),Ae(this,m,"f").fire([...Ae(this,o,"f").keys()]),Ae(this,o,"f").clear(),Ae(this,r,"f")&&Ae(this,r,"f").$clear(this._owner)}forEach(f,l){this._checkDisposed();for(let h of Ae(this,o,"f").keys())f.apply(l,[h,this.get(h),this])}get(f){this._checkDisposed();const l=Ae(this,o,"f").get(f);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(f){return this._checkDisposed(),Array.isArray(Ae(this,o,"f").get(f))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(f,l){return f[0].toString()<l[0].toString()?-1:f[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=d,r=new WeakMap,m=new WeakMap,o=new WeakMap;let p=class ei{constructor(f,l,h){this._logService=l,this._fileSystemInfoService=h,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:y=>y.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,ei._mapper),this._proxy=f.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(f){const l=new F.ResourceMap;for(const h of f)l.set(h,h);return{uris:Object.freeze(Array.from(l.values()))}}createDiagnosticCollection(f,l){const{_collections:h,_proxy:y,_onDidChangeDiagnostics:a,_logService:P,_fileSystemInfoService:n}=this,i=new class{$changeMany(s,b){y.$changeMany(s,b),P.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,s,b.length===0?"CLEARING":b)}$clear(s){y.$clear(s),P.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,s)}dispose(){y.dispose()}};let v;if(!l)l="_generated_diagnostic_collection_name_#"+ei._idPool++,v=l;else if(!h.has(l))v=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do v=l+ei._idPool++;while(h.has(v))}return new class extends d{constructor(){super(l,v,ei._maxDiagnosticsPerFile,n.extUri,i,a);h.set(v,this)}dispose(){super.dispose(),h.delete(v)}}}getDiagnostics(f){if(f)return this._getDiagnostics(f);{const l=new Map,h=[];for(const y of this._collections.values())y.forEach((a,P)=>{let n=l.get(a.toString());typeof n=="undefined"&&(n=h.length,l.set(a.toString(),n),h.push([a,[]])),h[n][1]=h[n][1].concat(...P)});return h}}_getDiagnostics(f){let l=[];for(let h of this._collections.values())h.has(f)&&(l=l.concat(h.get(f)));return l}$acceptMarkersChange(f){if(!this._mirrorCollection){const l="_generated_mirror",h=new d(l,l,ei._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(l,h),this._mirrorCollection=h}for(const[l,h]of f)this._mirrorCollection.set(w.URI.revive(l),h.map(R.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=Ue([Be(1,k.ILogService),Be(2,_.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(we[187],Ee([0,1,2,5]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(t){this._proxy=t.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(t){return this._proxy.$showOpenDialog(t).then(R=>R?R.map(C=>c.URI.revive(C)):void 0)}showSaveDialog(t){return this._proxy.$showSaveDialog(t).then(R=>R?c.URI.revive(R):void 0)}}e.ExtHostDialogs=w}),define(we[188],Ee([0,1,15,2,6,5,11,20,9]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(_,r,m){this._documentsAndEditors=r,this._logService=m,this._documentContentProviders=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,r){if(Object.keys(t.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const m=k._handlePool++;this._documentContentProviders.set(m,r),this._proxy.$registerTextContentProvider(m,_);let o;return typeof r.onDidChange=="function"&&(o=r.onDidChange(d=>{if(d.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(m,d).then(p=>{if(!p&&typeof p!="string")return;const D=this._documentsAndEditors.getDocument(d);if(!D)return;const f=(0,C.splitLines)(p);if(!D.equalLines(f))return this._proxy.$onVirtualDocumentChange(d,p)},c.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(_,r){const m=this._documentContentProviders.get(_);return m?Promise.resolve(m.provideTextDocumentContent(M.URI.revive(r),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${r.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(we[189],Ee([0,1,3,7,2,5,87,8,10,25,6]),function(re,e,c,M,w,T,t,R,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(m,o){this._onDidAddDocument=new c.Emitter,this._onDidRemoveDocument=new c.Emitter,this._onDidChangeDocument=new c.Emitter,this._onDidSaveDocument=new c.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const p of d)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const p of d)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const o=this._documentsAndEditors.getDocument(m);if(o)return o}getDocument(m){const o=this.getDocumentData(m);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return o.document}ensureDocumentData(m){const o=this._documentsAndEditors.getDocument(m);if(o)return Promise.resolve(o);let d=this._documentLoader.get(m.toString());return d||(d=this._proxy.$tryOpenDocument(m).then(p=>{this._documentLoader.delete(m.toString());const D=w.URI.revive(p);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(D))},p=>(this._documentLoader.delete(m.toString()),Promise.reject(p))),this._documentLoader.set(m.toString(),d)),d}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(o=>w.URI.revive(o))}$acceptModelModeChanged(m,o){const d=w.URI.revive(m),p=this._documentsAndEditors.getDocument(d);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(o),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(m){const o=w.URI.revive(m),d=this._documentsAndEditors.getDocument(o);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(m,o){const d=w.URI.revive(m),p=this._documentsAndEditors.getDocument(d);if(!p)throw new Error("unknown document");p._acceptIsDirty(o),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,o,d){const p=w.URI.revive(m),D=this._documentsAndEditors.getDocument(p);if(!D)throw new Error("unknown document");D._acceptIsDirty(d),D.onEvents(o);let f;o.isUndoing?f=F.TextDocumentChangeReason.Undo:o.isRedoing&&(f=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:D.document,contentChanges:o.changes.map(l=>({range:R.Range.to(l.range),rangeOffset:l.rangeOffset,rangeLength:l.rangeLength,text:l.text})),reason:f}))}setWordDefinitionFor(m,o){(0,t.setWordDefinitionFor)(m,o)}}e.ExtHostDocuments=_}),define(we[49],Ee([0,1,41,3,7,2,4,5,87,13,93,8,12,21,11,162,102]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class D{constructor(h){this.value=h,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let f=class{constructor(h,y){this._extHostRpc=h,this._logService=y,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(h){this.acceptDocumentsAndEditorsDelta(h)}acceptDocumentsAndEditorsDelta(h){const y=[],a=[],P=[];if(h.removedDocuments)for(const n of h.removedDocuments){const i=T.URI.revive(n),v=this._documents.get(i);v?.unref()&&(this._documents.delete(i),y.push(v.value))}if(h.addedDocuments)for(const n of h.addedDocuments){const i=T.URI.revive(n.uri);let v=this._documents.get(i);if(v&&i.scheme!==o.Schemas.vscodeNotebookCell&&i.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);v||(v=new D(new C.ExtHostDocumentData(this._extHostRpc.getProxy(R.MainContext.MainThreadDocuments),i,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(i,v),a.push(v.value)),v.ref()}if(h.removedEditors)for(const n of h.removedEditors){const i=this._editors.get(n);this._editors.delete(n),i&&P.push(i)}if(h.addedEditors)for(const n of h.addedEditors){const i=T.URI.revive(n.documentUri);c.ok(this._documents.has(i),`document '${i}' does not exist`),c.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const v=this._documents.get(i).value,g=new F.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(R.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>v.document),n.selections.map(_.Selection.to),n.options,n.visibleRanges.map(s=>_.Range.to(s)),typeof n.editorPosition=="number"?_.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,g)}h.newActiveEditor!==void 0&&(c.ok(h.newActiveEditor===null||this._editors.has(h.newActiveEditor),`active editor '${h.newActiveEditor}' does not exist`),this._activeEditorId=h.newActiveEditor),(0,w.dispose)(y),(0,w.dispose)(P),h.removedDocuments&&this._onDidRemoveDocuments.fire(y),h.addedDocuments&&this._onDidAddDocuments.fire(a),(h.removedEditors||h.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),h.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(h){return this._documents.get(h)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),h=>h.value)}getEditor(h){return this._editors.get(h)}activeEditor(h){if(!this._activeEditorId)return;const y=this._editors.get(this._activeEditorId);return h?y:y?.value}allEditors(){return[...this._editors.values()]}};f=Ue([Be(0,k.IExtHostRpcService),Be(1,r.ILogService)],f),e.ExtHostDocumentsAndEditors=f,e.IExtHostDocumentsAndEditors=(0,t.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[71],Ee([0,1,8,5,2,3,4,13,14]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,t.createDecorator)("IExtHostEditorTabs");let k=class{constructor(_){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new T.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let r=-1;this._tabs=_.map((o,d)=>(o.isActive&&(r=d),Object.freeze({label:o.label,viewColumn:c.ViewColumn.to(o.viewColumn),index:d,resource:w.URI.revive(o.resource),additionalResourcesAndViewIds:o.additionalResourcesAndViewIds.map(({resource:p,viewId:D})=>({resource:w.URI.revive(p),viewId:D})),viewId:o.editorId,isActive:o.isActive,move:async(p,D)=>{this._proxy.$moveTab(o,p,c.ViewColumn.from(D)),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(o),await(0,C.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((o,d)=>o.viewColumn===d.viewColumn?o.index-d.index:o.viewColumn-d.viewColumn);const m=this._activeTab;this._activeTab=r===-1?void 0:this._tabs[r],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};k=Ue([Be(0,R.IExtHostRpcService)],k),e.ExtHostEditorTabs=k}),define(we[190],Ee([0,1,2,5,7,6,8,232,9,22,27]),function(re,e,c,M,w,T,t,R,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class _{constructor(){this._schemes=[]}add(o){this._stateMachine=void 0,this._schemes.push(o)}delete(o){const d=this._schemes.indexOf(o);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const o=this._schemes.sort(),d=[];let p,D,f=14,l=14;for(const h of o){let y=p?(0,C.commonPrefixLength)(p,h):0;for(y===0?D=1:D=l;y<h.length;y++)y+1===h.length?(f=l,l=9):l+=1,d.push([D,h.toUpperCase().charCodeAt(y),l]),d.push([D,h.toLowerCase().charCodeAt(y),l]),D=l;p=h,l=f}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new R.StateMachine(d)}}provideDocumentLinks(o){this._initStateMachine();const d=[],p=R.LinkComputer.computeLinks({getLineContent(D){return o.lineAt(D-1).text},getLineCount(){return o.lineCount}},this._stateMachine);for(const D of p){const f=t.DocumentLink.to(D);f.target&&d.push(f)}return d}}class r{constructor(o,d){this._extHostLanguageFeatures=d,this._linkProvider=new _,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=o.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(o,d,p,D={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const f=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(f,p);let l=2;D.isCaseSensitive&&(l+=1024),D.isReadonly&&(l+=2048),typeof p.copy=="function"&&(l+=8),typeof p.open=="function"&&typeof p.close=="function"&&typeof p.read=="function"&&typeof p.write=="function"&&((0,F.checkProposedApiEnabled)(o,"fsChunks"),l+=4),this._proxy.$registerFileSystemProvider(f,d,l).catch(y=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${d}`),console.error(y)});const h=p.onDidChangeFile(y=>{const a=[];for(const P of y){let{uri:n,type:i}=P;if(n.scheme!==d)continue;let v;switch(i){case T.FileChangeType.Changed:v=0;break;case T.FileChangeType.Created:v=1;break;case T.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:n,type:v})}this._proxy.$onFileSystemChange(f,a)});return(0,w.toDisposable)(()=>{h.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(f),this._proxy.$unregisterProvider(f)})}static _asIStat(o){const{type:d,ctime:p,mtime:D,size:f,permissions:l}=o;return{type:d,ctime:p,mtime:D,size:f,permissions:l}}$stat(o,d){return Promise.resolve(this._getFsProvider(o).stat(c.URI.revive(d))).then(p=>r._asIStat(p))}$readdir(o,d){return Promise.resolve(this._getFsProvider(o).readDirectory(c.URI.revive(d)))}$readFile(o,d){return Promise.resolve(this._getFsProvider(o).readFile(c.URI.revive(d))).then(p=>k.VSBuffer.wrap(p))}$writeFile(o,d,p,D){return Promise.resolve(this._getFsProvider(o).writeFile(c.URI.revive(d),p.buffer,D))}$delete(o,d,p){return Promise.resolve(this._getFsProvider(o).delete(c.URI.revive(d),p))}$rename(o,d,p,D){return Promise.resolve(this._getFsProvider(o).rename(c.URI.revive(d),c.URI.revive(p),D))}$copy(o,d,p,D){const f=this._getFsProvider(o);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(c.URI.revive(d),c.URI.revive(p),D))}$mkdir(o,d){return Promise.resolve(this._getFsProvider(o).createDirectory(c.URI.revive(d)))}$watch(o,d,p,D){const f=this._getFsProvider(o).watch(c.URI.revive(p),D);this._watches.set(d,f)}$unwatch(o,d){const p=this._watches.get(d);p&&(p.dispose(),this._watches.delete(d))}$open(o,d,p){const D=this._getFsProvider(o);if(!D.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(D.open(c.URI.revive(d),p))}$close(o,d){const p=this._getFsProvider(o);if(!p.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(p.close(d))}$read(o,d,p,D){const f=this._getFsProvider(o);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const l=k.VSBuffer.alloc(D);return Promise.resolve(f.read(d,p,l.buffer,0,D)).then(h=>l.slice(0,h))}$write(o,d,p,D){const f=this._getFsProvider(o);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(d,p,D.buffer,0,D.byteLength))}_getFsProvider(o){const d=this._fsProvider.get(o);if(!d){const p=new Error;throw p.name="ENOPRO",p.message="no provider",p}return d}}e.ExtHostFileSystem=r}),define(we[50],Ee([0,1,5,46,6,22,4,13,31]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ut{constructor(_,r){const m=_.getProxy(c.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return m.$stat(o).catch(Ut._handleError)},readDirectory(o){return m.$readdir(o).catch(Ut._handleError)},createDirectory(o){return m.$mkdir(o).catch(Ut._handleError)},async readFile(o){return m.$readFile(o).then(d=>d.buffer).catch(Ut._handleError)},writeFile(o,d){return m.$writeFile(o,T.VSBuffer.wrap(d)).catch(Ut._handleError)},delete(o,d){return m.$delete(o,{recursive:!1,useTrash:!1,...d}).catch(Ut._handleError)},rename(o,d,p){return m.$rename(o,d,{overwrite:!1,...p}).catch(Ut._handleError)},copy(o,d,p){return m.$copy(o,d,{overwrite:!1,...p}).catch(Ut._handleError)},isWritableFileSystem(o){const d=r.getCapabilities(o);if(typeof d=="number")return!(d&2048)}})}static _handleError(_){if(!(_ instanceof Error))throw new w.FileSystemError(String(_));if(_.name==="ENOPRO")throw w.FileSystemError.Unavailable(_.message);switch(_.name){case M.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(_.message);case M.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(_.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(_.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(_.message);case M.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(_.message);case M.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(_.message);default:throw new w.FileSystemError(_.message,_.name)}}};k=Ue([Be(0,R.IExtHostRpcService),Be(1,C.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,t.createDecorator)("IExtHostConsumerFileSystem")}),define(we[191],Ee([0,1,2,38]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(t,R,C,k){this._extHostNotebooks=R,this._textDocumentsAndEditors=C,this._commands=k;const F=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new M.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new M.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new M.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new M.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const r=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:c.URI.revive(_.notebookUri),inputUri:c.URI.revive(_.inputUri),notebookEditor:r.apiEditor}}return{notebookUri:c.URI.revive(_.notebookUri),inputUri:c.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(t,R,C,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:C,uri:t,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(c.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(t,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[t]})}}e.ExtHostInteractive=w}),define(we[192],Ee([0,1,7,5]),function(re,e,c,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(t){this._handlePool=0,this._proxy=t.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(t){const R=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(R,t),(0,c.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=w}),define(we[193],Ee([0,1,2,25,8,6,5,9,43,16,10,233,7,81,53,64,194,15,3]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class l{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentSymbols(H,K){const J=this._documents.getDocument(H),oe=await this._provider.provideDocumentSymbols(J,K);if(!(0,k.isFalsyOrEmpty)(oe))return oe[0]instanceof T.DocumentSymbol?oe.map(w.DocumentSymbol.from):l._asDocumentSymbolTree(oe)}static _asDocumentSymbolTree(H){H=H.slice(0).sort((oe,G)=>{let ie=oe.location.range.start.compareTo(G.location.range.start);return ie===0&&(ie=G.location.range.end.compareTo(oe.location.range.end)),ie});const K=[],J=[];for(const oe of H){const G={name:oe.name||"!!MISSING: name!!",kind:w.SymbolKind.from(oe.kind),tags:oe.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:w.Range.from(oe.location.range),selectionRange:w.Range.from(oe.location.range),children:[]};for(;;){if(J.length===0){J.push(G),K.push(G);break}const ie=J[J.length-1];if(C.Range.containsRange(ie.range,G.range)&&!C.Range.equalsRange(ie.range,G.range)){ie.children&&ie.children.push(G),J.push(G);break}J.pop()}}return K}}class h{constructor(H,K,J){this._documents=H,this._commands=K,this._provider=J,this._cache=new d.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,K){const J=this._documents.getDocument(H),oe=await this._provider.provideCodeLenses(J,K);if(!oe||K.isCancellationRequested)return;const G=this._cache.add(oe),ie=new r.DisposableStore;this._disposables.set(G,ie);const de={cacheId:G,lenses:[]};for(let Te=0;Te<oe.length;Te++)de.lenses.push({cacheId:[G,Te],range:w.Range.from(oe[Te].range),command:this._commands.toInternal(oe[Te].command,ie)});return de}async resolveCodeLens(H,K){const J=H.cacheId&&this._cache.get(...H.cacheId);if(!J)return;let oe;if(typeof this._provider.resolveCodeLens!="function"||J.isResolved?oe=J:oe=await this._provider.resolveCodeLens(J,K),oe||(oe=J),K.isCancellationRequested)return;const G=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!G)return H.command=this._commands.toInternal(oe.command??h._badCmd,G),H}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function y(Qe){return Array.isArray(Qe)?Qe.map(w.DefinitionLink.from):Qe?[w.DefinitionLink.from(Qe)]:[]}class a{constructor(H,K){this._documents=H,this._provider=K}async provideDefinition(H,K,J){const oe=this._documents.getDocument(H),G=w.Position.to(K),ie=await this._provider.provideDefinition(oe,G,J);return y(ie)}}class P{constructor(H,K){this._documents=H,this._provider=K}async provideDeclaration(H,K,J){const oe=this._documents.getDocument(H),G=w.Position.to(K),ie=await this._provider.provideDeclaration(oe,G,J);return y(ie)}}class n{constructor(H,K){this._documents=H,this._provider=K}async provideImplementation(H,K,J){const oe=this._documents.getDocument(H),G=w.Position.to(K),ie=await this._provider.provideImplementation(oe,G,J);return y(ie)}}class i{constructor(H,K){this._documents=H,this._provider=K}async provideTypeDefinition(H,K,J){const oe=this._documents.getDocument(H),G=w.Position.to(K),ie=await this._provider.provideTypeDefinition(oe,G,J);return y(ie)}}class v{constructor(H,K){this._documents=H,this._provider=K}async provideHover(H,K,J){const oe=this._documents.getDocument(H),G=w.Position.to(K),ie=await this._provider.provideHover(oe,G,J);if(!(!ie||(0,k.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=oe.getWordRangeAtPosition(G)),ie.range||(ie.range=new T.Range(G,G)),w.Hover.from(ie)}}class g{constructor(H,K){this._documents=H,this._provider=K}async provideEvaluatableExpression(H,K,J){const oe=this._documents.getDocument(H),G=w.Position.to(K),ie=await this._provider.provideEvaluatableExpression(oe,G,J);if(ie)return w.EvaluatableExpression.from(ie)}}class s{constructor(H,K){this._documents=H,this._provider=K}async provideInlineValues(H,K,J,oe){const G=this._documents.getDocument(H),ie=await this._provider.provideInlineValues(G,w.Range.to(K),w.InlineValueContext.to(J),oe);if(Array.isArray(ie))return ie.map(de=>w.InlineValue.from(de))}}class b{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentHighlights(H,K,J){const oe=this._documents.getDocument(H),G=w.Position.to(K),ie=await this._provider.provideDocumentHighlights(oe,G,J);if(Array.isArray(ie))return ie.map(w.DocumentHighlight.from)}}class u{constructor(H,K){this._documents=H,this._provider=K}async provideLinkedEditingRanges(H,K,J){const oe=this._documents.getDocument(H),G=w.Position.to(K),ie=await this._provider.provideLinkedEditingRanges(oe,G,J);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,k.coalesce)(ie.ranges.map(w.Range.from)),wordPattern:ie.wordPattern}}}class E{constructor(H,K){this._documents=H,this._provider=K}async provideReferences(H,K,J,oe){const G=this._documents.getDocument(H),ie=w.Position.to(K),de=await this._provider.provideReferences(G,ie,J,oe);if(Array.isArray(de))return de.map(w.location.from)}}class A{constructor(H,K,J,oe,G,ie,de){this._documents=H,this._commands=K,this._diagnostics=J,this._provider=oe,this._logService=G,this._extension=ie,this._apiDeprecation=de,this._cache=new d.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,K,J,oe){const G=this._documents.getDocument(H),ie=_.Selection.isISelection(K)?w.Selection.to(K):w.Range.to(K),de=[];for(const ot of this._diagnostics.getDiagnostics(H))if(ie.intersection(ot.range)&&de.push(ot)>A._maxCodeActionsPerFile)break;const Te={diagnostics:de,only:J.only?new T.CodeActionKind(J.only):void 0,triggerKind:w.CodeActionTriggerKind.to(J.trigger)},Ne=await this._provider.provideCodeActions(G,ie,Te,oe);if(!(0,k.isNonEmptyArray)(Ne)||oe.isCancellationRequested)return;const ze=this._cache.add(Ne),je=new r.DisposableStore;this._disposables.set(ze,je);const et=[];for(let ot=0;ot<Ne.length;ot++){const ye=Ne[ot];!ye||(A._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,je)})):(Te.only&&(ye.kind?Te.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[ze,ot],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,je),diagnostics:ye.diagnostics&&ye.diagnostics.map(w.Diagnostic.from),edit:ye.edit&&w.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:ze,actions:et}}async resolveCodeAction(H,K){const[J,oe]=H,G=this._cache.get(J,oe);if(!G||A._isCommand(G)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(G,K)??G;return ie?.edit?w.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}A._maxCodeActionsPerFile=1e3;class I{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentFormattingEdits(H,K,J){const oe=this._documents.getDocument(H),G=await this._provider.provideDocumentFormattingEdits(oe,K,J);if(Array.isArray(G))return G.map(w.TextEdit.from)}}class B{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentRangeFormattingEdits(H,K,J,oe){const G=this._documents.getDocument(H),ie=w.Range.to(K),de=await this._provider.provideDocumentRangeFormattingEdits(G,ie,J,oe);if(Array.isArray(de))return de.map(w.TextEdit.from)}}class O{constructor(H,K){this._documents=H,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,K,J,oe,G){const ie=this._documents.getDocument(H),de=w.Position.to(K),Te=await this._provider.provideOnTypeFormattingEdits(ie,de,J,oe,G);if(Array.isArray(Te))return Te.map(w.TextEdit.from)}}class S{constructor(H,K){this._provider=H,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(H,K){const J=t.IdObject.mixin({symbols:[]}),oe=await this._provider.provideWorkspaceSymbols(H,K);if((0,k.isNonEmptyArray)(oe))for(const G of oe){if(!G)continue;if(!G.name){this._logService.warn("INVALID SymbolInformation, lacks name",G);continue}const ie=t.IdObject.mixin(w.WorkspaceSymbol.from(G));this._symbolCache.set(ie._id,G),J.symbols.push(ie)}return J.symbols.length>0&&this._resultCache.set(J._id,[J.symbols[0]._id,J.symbols[J.symbols.length-1]._id]),J}async resolveWorkspaceSymbol(H,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const J=this._symbolCache.get(H._id);if(J){const oe=await this._provider.resolveWorkspaceSymbol(J,K);return oe&&(0,M.mixin)(H,w.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(H){const K=this._resultCache.get(H);if(K){for(let[J,oe]=K;J<=oe;J++)this._symbolCache.delete(J);this._resultCache.delete(H)}}}class x{constructor(H,K,J){this._documents=H,this._provider=K,this._logService=J}static supportsResolving(H){return typeof H.prepareRename=="function"}async provideRenameEdits(H,K,J,oe){const G=this._documents.getDocument(H),ie=w.Position.to(K);try{const de=await this._provider.provideRenameEdits(G,ie,J,oe);return de?w.WorkspaceEdit.from(de):void 0}catch(de){const Te=x._asMessage(de);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(de)}}async resolveRenameLocation(H,K,J){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(H),G=w.Position.to(K);try{const ie=await this._provider.prepareRename(oe,G,J);let de,Te;if(T.Range.isRange(ie)?(de=ie,Te=oe.getText(ie)):(0,F.isObject)(ie)&&(de=ie.range,Te=ie.placeholder),!de||!Te)return;if(de.start.line>G.line||de.end.line<G.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(de),text:Te}}catch(ie){const de=x._asMessage(ie);return de?{rejectReason:de,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class N{constructor(H,K){this.resultId=H,this.tokens=K}}class V{constructor(H,K){this._documents=H,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,K,J){const oe=this._documents.getDocument(H),G=K!==0?this._previousResults.get(K):null;let ie=typeof G?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(oe,G.resultId,J):await this._provider.provideDocumentSemanticTokens(oe,J);return G&&this._previousResults.delete(K),ie?(ie=V._fixProvidedSemanticTokens(ie),this._send(V._convertToEdits(G,ie),ie)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return V._isSemanticTokens(H)?V._isCorrectSemanticTokens(H)?H:new T.SemanticTokens(new Uint32Array(H.data),H.resultId):V._isSemanticTokensEdits(H)?V._isCorrectSemanticTokensEdits(H)?H:new T.SemanticTokensEdits(H.edits.map(K=>new T.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const K of H.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,K){if(!V._isSemanticTokens(K)||!H||!H.tokens)return K;const J=H.tokens,oe=J.length,G=K.data,ie=G.length;let de=0;const Te=Math.min(oe,ie);for(;de<Te&&J[de]===G[de];)de++;if(de===oe&&de===ie)return new T.SemanticTokensEdits([],K.resultId);let Ne=0;const ze=Te-de;for(;Ne<ze&&J[oe-Ne-1]===G[ie-Ne-1];)Ne++;return new T.SemanticTokensEdits([{start:de,deleteCount:oe-de-Ne,data:G.subarray(de,ie-Ne)}],K.resultId)}_send(H,K){if(V._isSemanticTokens(H)){const J=this._nextResultId++;return this._previousResults.set(J,new N(H.resultId,H.data)),(0,m.encodeSemanticTokensDto)({id:J,type:"full",data:H.data})}if(V._isSemanticTokensEdits(H)){const J=this._nextResultId++;return V._isSemanticTokens(K)?this._previousResults.set(J,new N(K.resultId,K.data)):this._previousResults.set(J,new N(H.resultId)),(0,m.encodeSemanticTokensDto)({id:J,type:"delta",deltas:(H.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class ${constructor(H,K){this._documents=H,this._provider=K}async provideDocumentRangeSemanticTokens(H,K,J){const oe=this._documents.getDocument(H),G=await this._provider.provideDocumentRangeSemanticTokens(oe,w.Range.to(K),J);return G?this._send(G):null}_send(H){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=$;class z{constructor(H,K,J,oe,G){this._documents=H,this._commands=K,this._provider=J,this._apiDeprecation=oe,this._extension=G,this._cache=new d.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,K,J,oe){const G=this._documents.getDocument(H),ie=w.Position.to(K),de=G.getWordRangeAtPosition(ie)||new T.Range(ie,ie),Te=de.with({end:ie}),Ne=new p.StopWatch(!0),ze=await this._provider.provideCompletionItems(G,ie,oe,w.CompletionContext.to(J));if(!ze||oe.isCancellationRequested)return;const je=Array.isArray(ze)?new T.CompletionList(ze):ze,et=z.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),ot=new r.DisposableStore;this._disposables.set(et,ot);const ye=[],nt={x:et,b:ye,a:{replace:w.Range.from(de),insert:w.Range.from(Te)},c:je.isIncomplete||void 0,d:Ne.elapsed()};for(let q=0;q<je.items.length;q++){const X=je.items[q],pe=this._convertCompletionItem(X,[et,q],Te,de);ye.push(pe)}return nt}async resolveCompletionItem(H,K){if(typeof this._provider.resolveCompletionItem!="function")return;const J=this._cache.get(...H);if(!J)return;const oe=await this._provider.resolveCompletionItem(J,K);if(!!oe)return this._convertCompletionItem(oe,H)}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,K,J,oe){const G=this._disposables.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const ie={x:K,a:H.label,b:H.kind!==void 0?w.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(w.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:w.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal(H.command,G)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=H.textEdit.newText):typeof H.insertText=="string"?ie.h=H.insertText:H.insertText instanceof T.SnippetString&&(ie.h=H.insertText.value,ie.i|=4);let de;return H.textEdit?de=H.textEdit.range:H.range&&(de=H.range),T.Range.isRange(de)?ie.j=w.Range.from(de):de&&(!J?.isEqual(de.inserting)||!oe?.isEqual(de.replacing))&&(ie.j={insert:w.Range.from(de.inserting),replace:w.Range.from(de.replacing)}),ie}}class ee{constructor(H,K,J){this._documents=H,this._provider=K,this._commands=J,this._cache=new d.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(H,K,J,oe){const G=this._documents.getDocument(H),ie=w.Position.to(K),de=await this._provider.provideInlineCompletionItems(G,ie,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:w.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:J.triggerKind},oe);if(!de||oe.isCancellationRequested)return;const Te=(0,F.isArray)(de)?{items:de}:de,Ne=this._cache.add(Te.items);let ze;return{pid:Ne,items:Te.items.map((je,et)=>{let ot;return je.command&&(ze||(ze=new r.DisposableStore,this._disposables.set(Ne,ze)),ot=this._commands.toInternal(je.command,ze)),{text:je.text,range:je.range?w.Range.from(je.range):void 0,command:ot,idx:et}})}}disposeCompletions(H){this._cache.delete(H);const K=this._disposables.get(H);K&&K.clear(),this._disposables.delete(H)}handleDidShowCompletionItem(H,K){const J=this._cache.get(H,K);J&&j.get(this._provider).fireOnDidShowCompletionItem({completionItem:J})}}class j{constructor(){this._onDidShowCompletionItemEmitter=new f.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(H){let K=j.map.get(H);return K||(K=new j,j.map.set(H,K)),K}fireOnDidShowCompletionItem(H){this._onDidShowCompletionItemEmitter.fire(H)}}e.InlineCompletionController=j,j.map=new WeakMap;class Q{constructor(H,K){this._documents=H,this._provider=K,this._cache=new d.Cache("SignatureHelp")}async provideSignatureHelp(H,K,J,oe){const G=this._documents.getDocument(H),ie=w.Position.to(K),de=this.reviveContext(J),Te=await this._provider.provideSignatureHelp(G,ie,oe,de);if(Te){const Ne=this._cache.add([Te]);return{...w.SignatureHelp.from(Te),id:Ne}}}reviveContext(H){let K;if(H.activeSignatureHelp){const J=w.SignatureHelp.to(H.activeSignatureHelp),oe=this._cache.get(H.activeSignatureHelp.id,0);oe?(K=oe,K.activeSignature=J.activeSignature,K.activeParameter=J.activeParameter):K=J}return{...H,activeSignatureHelp:K}}releaseSignatureHelp(H){this._cache.delete(H)}}class ce{constructor(H,K){this._documents=H,this._provider=K}async provideInlayHints(H,K,J){const oe=this._documents.getDocument(H),G=await this._provider.provideInlayHints(oe,w.Range.to(K),J);return G?{hints:G.map(w.InlayHint.from)}:void 0}}class ve{constructor(H,K){this._documents=H,this._provider=K,this._cache=new d.Cache("DocumentLink")}async provideLinks(H,K){const J=this._documents.getDocument(H),oe=await this._provider.provideDocumentLinks(J,K);if(!(!Array.isArray(oe)||oe.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(ve._validateLink).map(w.DocumentLink.from)};{const G=this._cache.add(oe),ie={links:[],id:G};for(let de=0;de<oe.length;de++){if(!ve._validateLink(oe[de]))continue;const Te=w.DocumentLink.from(oe[de]);Te.cacheId=[G,de],ie.links.push(Te)}return ie}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,K){if(typeof this._provider.resolveDocumentLink!="function")return;const J=this._cache.get(...H);if(!J)return;const oe=await this._provider.resolveDocumentLink(J,K);if(!(!oe||!ve._validateLink(oe)))return w.DocumentLink.from(oe)}releaseLinks(H){this._cache.delete(H)}}class ue{constructor(H,K){this._documents=H,this._provider=K}async provideColors(H,K){const J=this._documents.getDocument(H),oe=await this._provider.provideDocumentColors(J,K);return Array.isArray(oe)?oe.map(ie=>({color:w.Color.from(ie.color),range:w.Range.from(ie.range)})):[]}async provideColorPresentations(H,K,J){const oe=this._documents.getDocument(H),G=w.Range.to(K.range),ie=w.Color.to(K.color),de=await this._provider.provideColorPresentations(ie,{document:oe,range:G},J);if(!!Array.isArray(de))return de.map(w.ColorPresentation.from)}}class Fe{constructor(H,K){this._documents=H,this._provider=K}async provideFoldingRanges(H,K,J){const oe=this._documents.getDocument(H),G=await this._provider.provideFoldingRanges(oe,K,J);if(!!Array.isArray(G))return G.map(w.FoldingRange.from)}}class Ke{constructor(H,K,J){this._documents=H,this._provider=K,this._logService=J}async provideSelectionRanges(H,K,J){const oe=this._documents.getDocument(H),G=K.map(w.Position.to),ie=await this._provider.provideSelectionRanges(oe,G,J);if(!(0,k.isNonEmptyArray)(ie))return[];if(ie.length!==G.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const de=[];for(let Te=0;Te<G.length;Te++){const Ne=[];de.push(Ne);let ze=G[Te],je=ie[Te];for(;;){if(!je.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(Ne.push(w.SelectionRange.from(je)),!je.parent)break;ze=je.range,je=je.parent}}return de}}class Oe{constructor(H,K){this._documents=H,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(H,K,J){const oe=this._documents.getDocument(H),G=w.Position.to(K),ie=await this._provider.prepareCallHierarchy(oe,G,J);if(!ie)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ie)?ie.map(Te=>this._cacheAndConvertItem(de,Te)):[this._cacheAndConvertItem(de,ie)]}async provideCallsTo(H,K,J){const oe=this._itemFromCache(H,K);if(!oe)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyIncomingCalls(oe,J);if(!!G)return G.map(ie=>({from:this._cacheAndConvertItem(H,ie.from),fromRanges:ie.fromRanges.map(de=>w.Range.from(de))}))}async provideCallsFrom(H,K,J){const oe=this._itemFromCache(H,K);if(!oe)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyOutgoingCalls(oe,J);if(!!G)return G.map(ie=>({to:this._cacheAndConvertItem(H,ie.to),fromRanges:ie.fromRanges.map(de=>w.Range.from(de))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,K){const J=this._cache.get(H),oe=w.CallHierarchyItem.from(K,H,J.size.toString(36));return J.set(oe._itemId,K),oe}_itemFromCache(H,K){return this._cache.get(H)?.get(K)}}class We{constructor(H,K){this._documents=H,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(H,K,J){const oe=this._documents.getDocument(H),G=w.Position.to(K),ie=await this._provider.prepareTypeHierarchy(oe,G,J);if(!ie)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ie)?ie.map(Te=>this._cacheAndConvertItem(de,Te)):[this._cacheAndConvertItem(de,ie)]}async provideSupertypes(H,K,J){const oe=this._itemFromCache(H,K);if(!oe)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySupertypes(oe,J);if(!!G)return G.map(ie=>this._cacheAndConvertItem(H,ie))}async provideSubtypes(H,K,J){const oe=this._itemFromCache(H,K);if(!oe)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySubtypes(oe,J);if(!!G)return G.map(ie=>this._cacheAndConvertItem(H,ie))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,K){const J=this._cache.get(H),oe=w.TypeHierarchyItem.from(K,H,J.size.toString(36));return J.set(oe._itemId,K),oe}_itemFromCache(H,K){return this._cache.get(H)?.get(K)}}class Xe{constructor(H,K){this.adapter=H,this.extension=K}}class Ye{constructor(H,K,J,oe,G,ie,de){this._adapter=new Map,this._uriTransformer=K,this._proxy=H.getProxy(t.MainContext.MainThreadLanguageFeatures),this._documents=J,this._commands=oe,this._diagnostics=G,this._logService=ie,this._apiDeprecation=de}_transformDocumentSelector(H){return w.DocumentSelector.from(H,this._uriTransformer)}_createDisposable(H){return new T.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Ye._handlePool++}_withAdapter(H,K,J,oe,G=!1){const ie=this._adapter.get(H);if(!ie)return Promise.resolve(oe);if(ie.adapter instanceof K){let de;ie.extension&&(de=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${K.name}'`));const Te=J(ie.adapter,ie.extension),Ne=ie.extension;return Ne&&Promise.resolve(Te).then(()=>this._logService.trace(`[${Ne.identifier.value}] provider DONE after ${Date.now()-de}ms`),ze=>{G&&ze instanceof D.CancellationError||(this._logService.error(`[${Ne.identifier.value}] provider FAILED`),this._logService.error(ze))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,K){const J=this._nextHandle();return this._adapter.set(J,new Xe(H,K)),J}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,K,J,oe){const G=this._addNewAdapter(new l(this._documents,J),H),ie=oe&&oe.label||Ye._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(G,this._transformDocumentSelector(K),ie),this._createDisposable(G)}$provideDocumentSymbols(H,K,J){return this._withAdapter(H,l,oe=>oe.provideDocumentSymbols(c.URI.revive(K),J),void 0)}registerCodeLensProvider(H,K,J){const oe=this._nextHandle(),G=typeof J.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Xe(new h(this._documents,this._commands.converter,J),H)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(K),G);let ie=this._createDisposable(oe);if(G!==void 0){const de=J.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(G));ie=T.Disposable.from(ie,de)}return ie}$provideCodeLenses(H,K,J){return this._withAdapter(H,h,oe=>oe.provideCodeLenses(c.URI.revive(K),J),void 0)}$resolveCodeLens(H,K,J){return this._withAdapter(H,h,oe=>oe.resolveCodeLens(K,J),void 0)}$releaseCodeLenses(H,K){this._withAdapter(H,h,J=>Promise.resolve(J.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(H,K,J){const oe=this._addNewAdapter(new a(this._documents,J),H);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDefinition(H,K,J,oe){return this._withAdapter(H,a,G=>G.provideDefinition(c.URI.revive(K),J,oe),[])}registerDeclarationProvider(H,K,J){const oe=this._addNewAdapter(new P(this._documents,J),H);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDeclaration(H,K,J,oe){return this._withAdapter(H,P,G=>G.provideDeclaration(c.URI.revive(K),J,oe),[])}registerImplementationProvider(H,K,J){const oe=this._addNewAdapter(new n(this._documents,J),H);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideImplementation(H,K,J,oe){return this._withAdapter(H,n,G=>G.provideImplementation(c.URI.revive(K),J,oe),[])}registerTypeDefinitionProvider(H,K,J){const oe=this._addNewAdapter(new i(this._documents,J),H);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideTypeDefinition(H,K,J,oe){return this._withAdapter(H,i,G=>G.provideTypeDefinition(c.URI.revive(K),J,oe),[])}registerHoverProvider(H,K,J,oe){const G=this._addNewAdapter(new v(this._documents,J),H);return this._proxy.$registerHoverProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideHover(H,K,J,oe){return this._withAdapter(H,v,G=>G.provideHover(c.URI.revive(K),J,oe),void 0)}registerEvaluatableExpressionProvider(H,K,J,oe){const G=this._addNewAdapter(new g(this._documents,J),H);return this._proxy.$registerEvaluatableExpressionProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideEvaluatableExpression(H,K,J,oe){return this._withAdapter(H,g,G=>G.provideEvaluatableExpression(c.URI.revive(K),J,oe),void 0)}registerInlineValuesProvider(H,K,J,oe){const G=typeof J.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new s(this._documents,J),H);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(K),G);let de=this._createDisposable(ie);if(G!==void 0){const Te=J.onDidChangeInlineValues(Ne=>this._proxy.$emitInlineValuesEvent(G));de=T.Disposable.from(de,Te)}return de}$provideInlineValues(H,K,J,oe,G){return this._withAdapter(H,s,ie=>ie.provideInlineValues(c.URI.revive(K),J,oe,G),void 0)}registerDocumentHighlightProvider(H,K,J){const oe=this._addNewAdapter(new b(this._documents,J),H);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDocumentHighlights(H,K,J,oe){return this._withAdapter(H,b,G=>G.provideDocumentHighlights(c.URI.revive(K),J,oe),void 0)}registerLinkedEditingRangeProvider(H,K,J){const oe=this._addNewAdapter(new u(this._documents,J),H);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideLinkedEditingRanges(H,K,J,oe){return this._withAdapter(H,u,async G=>{const ie=await G.provideLinkedEditingRanges(c.URI.revive(K),J,oe);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?Ye._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(H,K,J){const oe=this._addNewAdapter(new E(this._documents,J),H);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideReferences(H,K,J,oe,G){return this._withAdapter(H,E,ie=>ie.provideReferences(c.URI.revive(K),J,oe,G),void 0)}registerCodeActionProvider(H,K,J,oe){const G=new r.DisposableStore,ie=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,J,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(K),{providedKinds:oe?.providedCodeActionKinds?.map(de=>de.value),documentation:oe?.documentation?.map(de=>({kind:de.kind.value,command:this._commands.converter.toInternal(de.command,G)}))},Ye._extLabel(H),Boolean(J.resolveCodeAction)),G.add(this._createDisposable(ie)),G}$provideCodeActions(H,K,J,oe,G){return this._withAdapter(H,A,ie=>ie.provideCodeActions(c.URI.revive(K),J,oe,G),void 0)}$resolveCodeAction(H,K,J){return this._withAdapter(H,A,oe=>oe.resolveCodeAction(K,J),void 0)}$releaseCodeActions(H,K){this._withAdapter(H,A,J=>Promise.resolve(J.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(H,K,J){const oe=this._addNewAdapter(new I(this._documents,J),H);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(K),H.identifier,H.displayName||H.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(H,K,J,oe){return this._withAdapter(H,I,G=>G.provideDocumentFormattingEdits(c.URI.revive(K),J,oe),void 0)}registerDocumentRangeFormattingEditProvider(H,K,J){const oe=this._addNewAdapter(new B(this._documents,J),H);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(K),H.identifier,H.displayName||H.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(H,K,J,oe,G){return this._withAdapter(H,B,ie=>ie.provideDocumentRangeFormattingEdits(c.URI.revive(K),J,oe,G),void 0)}registerOnTypeFormattingEditProvider(H,K,J,oe){const G=this._addNewAdapter(new O(this._documents,J),H);return this._proxy.$registerOnTypeFormattingSupport(G,this._transformDocumentSelector(K),oe,H.identifier),this._createDisposable(G)}$provideOnTypeFormattingEdits(H,K,J,oe,G,ie){return this._withAdapter(H,O,de=>de.provideOnTypeFormattingEdits(c.URI.revive(K),J,oe,G,ie),void 0)}registerWorkspaceSymbolProvider(H,K){const J=this._addNewAdapter(new S(K,this._logService),H);return this._proxy.$registerNavigateTypeSupport(J,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(J)}$provideWorkspaceSymbols(H,K,J){return this._withAdapter(H,S,oe=>oe.provideWorkspaceSymbols(K,J),{symbols:[]})}$resolveWorkspaceSymbol(H,K,J){return this._withAdapter(H,S,oe=>oe.resolveWorkspaceSymbol(K,J),void 0)}$releaseWorkspaceSymbols(H,K){this._withAdapter(H,S,J=>J.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(H,K,J){const oe=this._addNewAdapter(new x(this._documents,J,this._logService),H);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(K),x.supportsResolving(J)),this._createDisposable(oe)}$provideRenameEdits(H,K,J,oe,G){return this._withAdapter(H,x,ie=>ie.provideRenameEdits(c.URI.revive(K),J,oe,G),void 0)}$resolveRenameLocation(H,K,J,oe){return this._withAdapter(H,x,G=>G.resolveRenameLocation(c.URI.revive(K),J,oe),void 0)}registerDocumentSemanticTokensProvider(H,K,J,oe){const G=this._nextHandle(),ie=typeof J.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(G,new Xe(new V(this._documents,J),H)),this._proxy.$registerDocumentSemanticTokensProvider(G,this._transformDocumentSelector(K),oe,ie);let de=this._createDisposable(G);if(ie){const Te=J.onDidChangeSemanticTokens(Ne=>this._proxy.$emitDocumentSemanticTokensEvent(ie));de=T.Disposable.from(de,Te)}return de}$provideDocumentSemanticTokens(H,K,J,oe){return this._withAdapter(H,V,G=>G.provideDocumentSemanticTokens(c.URI.revive(K),J,oe),null,!0)}$releaseDocumentSemanticTokens(H,K){this._withAdapter(H,V,J=>J.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(H,K,J,oe){const G=this._addNewAdapter(new $(this._documents,J),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(G,this._transformDocumentSelector(K),oe),this._createDisposable(G)}$provideDocumentRangeSemanticTokens(H,K,J,oe){return this._withAdapter(H,$,G=>G.provideDocumentRangeSemanticTokens(c.URI.revive(K),J,oe),null,!0)}registerCompletionItemProvider(H,K,J,oe){const G=this._addNewAdapter(new z(this._documents,this._commands.converter,J,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(G,this._transformDocumentSelector(K),oe,z.supportsResolving(J),`${H.identifier.value}(${oe.join("")})`),this._createDisposable(G)}$provideCompletionItems(H,K,J,oe,G){return this._withAdapter(H,z,ie=>ie.provideCompletionItems(c.URI.revive(K),J,oe,G),void 0)}$resolveCompletionItem(H,K,J){return this._withAdapter(H,z,oe=>oe.resolveCompletionItem(K,J),void 0)}$releaseCompletionItems(H,K){this._withAdapter(H,z,J=>J.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(H,K,J){const oe=this._addNewAdapter(new ee(this._documents,J,this._commands.converter),H);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideInlineCompletions(H,K,J,oe,G){return this._withAdapter(H,ee,ie=>ie.provideInlineCompletions(c.URI.revive(K),J,oe,G),void 0)}$handleInlineCompletionDidShow(H,K,J){this._withAdapter(H,ee,async oe=>{oe.handleDidShowCompletionItem(K,J)},void 0)}$freeInlineCompletionsList(H,K){this._withAdapter(H,ee,async J=>{J.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(H,K,J,oe){const G=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ie=this._addNewAdapter(new Q(this._documents,J),H);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(K),G),this._createDisposable(ie)}$provideSignatureHelp(H,K,J,oe,G){return this._withAdapter(H,Q,ie=>ie.provideSignatureHelp(c.URI.revive(K),J,oe,G),void 0)}$releaseSignatureHelp(H,K){this._withAdapter(H,Q,J=>J.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(H,K,J){const oe=typeof J.onDidChangeInlayHints=="function"?this._nextHandle():void 0,G=this._addNewAdapter(new ce(this._documents,J),H);this._proxy.$registerInlayHintsProvider(G,this._transformDocumentSelector(K),oe);let ie=this._createDisposable(G);if(oe!==void 0){const de=J.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(oe));ie=T.Disposable.from(ie,de)}return ie}$provideInlayHints(H,K,J,oe){return this._withAdapter(H,ce,G=>G.provideInlayHints(c.URI.revive(K),J,oe),void 0)}registerDocumentLinkProvider(H,K,J){const oe=this._addNewAdapter(new ve(this._documents,J),H);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(K),typeof J.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(H,K,J){return this._withAdapter(H,ve,oe=>oe.provideLinks(c.URI.revive(K),J),void 0)}$resolveDocumentLink(H,K,J){return this._withAdapter(H,ve,oe=>oe.resolveLink(K,J),void 0)}$releaseDocumentLinks(H,K){this._withAdapter(H,ve,J=>J.releaseLinks(K),void 0)}registerColorProvider(H,K,J){const oe=this._addNewAdapter(new ue(this._documents,J),H);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDocumentColors(H,K,J){return this._withAdapter(H,ue,oe=>oe.provideColors(c.URI.revive(K),J),[])}$provideColorPresentations(H,K,J,oe){return this._withAdapter(H,ue,G=>G.provideColorPresentations(c.URI.revive(K),J,oe),void 0)}registerFoldingRangeProvider(H,K,J){const oe=this._nextHandle(),G=typeof J.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Xe(new Fe(this._documents,J),H)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(K),G);let ie=this._createDisposable(oe);if(G!==void 0){const de=J.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(G));ie=T.Disposable.from(ie,de)}return ie}$provideFoldingRanges(H,K,J,oe){return this._withAdapter(H,Fe,G=>G.provideFoldingRanges(c.URI.revive(K),J,oe),void 0)}registerSelectionRangeProvider(H,K,J){const oe=this._addNewAdapter(new Ke(this._documents,J,this._logService),H);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideSelectionRanges(H,K,J,oe){return this._withAdapter(H,Ke,G=>G.provideSelectionRanges(c.URI.revive(K),J,oe),[])}registerCallHierarchyProvider(H,K,J){const oe=this._addNewAdapter(new Oe(this._documents,J),H);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$prepareCallHierarchy(H,K,J,oe){return this._withAdapter(H,Oe,G=>Promise.resolve(G.prepareSession(c.URI.revive(K),J,oe)),void 0)}$provideCallHierarchyIncomingCalls(H,K,J,oe){return this._withAdapter(H,Oe,G=>G.provideCallsTo(K,J,oe),void 0)}$provideCallHierarchyOutgoingCalls(H,K,J,oe){return this._withAdapter(H,Oe,G=>G.provideCallsFrom(K,J,oe),void 0)}$releaseCallHierarchy(H,K){this._withAdapter(H,Oe,J=>Promise.resolve(J.releaseSession(K)),void 0)}registerTypeHierarchyProvider(H,K,J){const oe=this._addNewAdapter(new We(this._documents,J),H);return this._proxy.$registerTypeHierarchyProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$prepareTypeHierarchy(H,K,J,oe){return this._withAdapter(H,We,G=>Promise.resolve(G.prepareSession(c.URI.revive(K),J,oe)),void 0)}$provideTypeHierarchySupertypes(H,K,J,oe){return this._withAdapter(H,We,G=>G.provideSupertypes(K,J,oe),void 0)}$provideTypeHierarchySubtypes(H,K,J,oe){return this._withAdapter(H,We,G=>G.provideSubtypes(K,J,oe),void 0)}$releaseTypeHierarchy(H,K){this._withAdapter(H,We,J=>Promise.resolve(J.releaseSession(K)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,R.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Ye._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Ye._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Ye._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Ye._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Ye._serializeRegExp(H.beforeText),afterText:H.afterText?Ye._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Ye._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Ye._serializeOnEnterRule)}setLanguageConfiguration(H,K,J){let{wordPattern:oe}=J;if(oe&&(0,R.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(K,oe):this._documents.setWordDefinitionFor(K,void 0),J.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),J.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const G=this._nextHandle(),ie={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ye._serializeRegExp(J.wordPattern):void 0,indentationRules:J.indentationRules?Ye._serializeIndentationRule(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ye._serializeOnEnterRules(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport};return this._proxy.$setLanguageConfiguration(G,K,ie),this._createDisposable(G)}$setWordDefinitions(H){for(const K of H)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Ye,Ye._handlePool=0}),define(we[195],Ee([0,1,5,8,6,35,14,7]),function(re,e,c,M,w,T,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(F,_,r,m){this._documents=_,this._commands=r,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(c.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,_){await this._proxy.$changeLanguage(F,_);const r=this._documents.getDocumentData(F);if(!r)throw new Error(`document '${F.toString}' NOT found`);return r.document}async tokenAtPosition(F,_){const r=F.version,m=M.Position.from(_),o=await this._proxy.$tokensAtPosition(F.uri,m),d={type:w.StandardTokenType.Other,range:F.getWordRangeAtPosition(_)??new w.Range(_.line,_.character,_.line,_.character)};if(!o)return d;const p={range:M.Range.to(o.range),type:M.TokenType.to(o.type)};return!p.range.contains(_)||r!==F.version?d:p}createLanguageStatusItem(F,_,r){const m=this._handlePool++,o=this._proxy,d=this._ids,p=`${F.identifier.value}/${_}`;if(d.has(p))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);d.add(p);const D={selector:r,id:_,name:F.displayName??F.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let f,l=new R.DisposableStore;const h=()=>{f?.dispose(),f=(0,t.disposableTimeout)(()=>{l.clear(),this._proxy.$setLanguageStatus(m,{id:p,name:D.name??F.displayName??F.name,source:F.displayName??F.name,selector:M.DocumentSelector.from(D.selector,this._uriTransformer),label:D.text,detail:D.detail??"",severity:D.severity===w.LanguageStatusSeverity.Error?T.default.Error:D.severity===w.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:D.command&&this._commands.toInternal(D.command,l),accessibilityInfo:D.accessibilityInformation})},0)},y={dispose(){l.dispose(),f?.dispose(),o.$removeLanguageStatus(m),d.delete(p)},get id(){return D.id},get name(){return D.name},set name(a){D.name=a,h()},get selector(){return D.selector},set selector(a){D.selector=a,h()},get text(){return D.text},set text(a){D.text=a,h()},get detail(){return D.detail},set detail(a){D.detail=a,h()},get severity(){return D.severity},set severity(a){D.severity=a,h()},get accessibilityInformation(){return D.accessibilityInformation},set accessibilityInformation(a){D.accessibilityInformation=a,h()},get command(){return D.command},set command(a){D.command=a,h()}};return h(),y}}e.ExtHostLanguages=C}),define(we[196],Ee([0,1,12,5,28,13,3]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let R=class extends c.AbstractLoggerService{constructor(F,_){const r=new t.Emitter;super(_.logLevel,r.event);this._proxy=F.getProxy(M.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(r)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,_,r){return new C(this._proxy,F,_,r)}};R=Ue([Be(0,T.IExtHostRpcService),Be(1,w.IExtHostInitDataService)],R),e.ExtHostLoggerService=R;class C extends c.AbstractMessageLogger{constructor(F,_,r,m){super(m?.always);this.proxy=F,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(r),this.proxy.$createLogger(_,m).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,_){const r=[[F,_]];this.isLoggerCreated?this.doLog(r):this.buffer.push(...r)}doLog(F){this.proxy.$log(this.file,F)}}}),define(we[197],Ee([0,1,5,12,27]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(R){return R&&R.title}let t=class{constructor(C,k){this._logService=k,this._proxy=C.getProxy(c.MainContext.MainThreadMessageService)}showMessage(C,k,F,_,r){const m={extension:C};let o;typeof _=="string"||T(_)?o=[_,...r]:(m.modal=_?.modal,m.useCustom=_?.useCustom,m.detail=_?.detail,o=r),m.useCustom&&(0,w.checkProposedApiEnabled)(C,"resolvers");const d=[];for(let p=0;p<o.length;p++){const D=o[p];if(typeof D=="string")d.push({title:D,handle:p,isCloseAffordance:!1});else if(typeof D=="object"){let{title:f,isCloseAffordance:l}=D;d.push({title:f,isCloseAffordance:!!l,handle:p})}else this._logService.warn("Invalid message item:",D)}return this._proxy.$showMessage(k,F,m,d).then(p=>{if(typeof p=="number")return o[p]})}};t=Ue([Be(1,M.ILogService)],t),e.ExtHostMessageService=t}),define(we[198],Ee([0,1,22,3,58,7,21,9,10,2,64,5,8,6,37,171,92]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class D{constructor(l,h,y,a,P){this._textDocumentsAndEditors=y,this._textDocuments=a,this._extensionStoragePaths=P,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new t.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=h.converter,h.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const i=n.notebookEditor?.notebookUri,v=n.cell.handle,s=this._documents.get(i)?.getCell(v);if(s)return s.apiCell}return n}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const h=this._editors.get(l);if(!h)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return h}getIdByEditor(l){for(const[h,y]of this._editors)if(y.apiEditor===l)return h}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,h){const y=this._documents.get(l);if(!y&&!h)throw new Error(`NO notebook document for '${l}'`);return y}_getProviderData(l){const h=this._notebookContentProviders.get(l);if(!h)throw new Error(`NO provider for '${l}'`);return h}registerNotebookContentProvider(l,h,y,a,P){if((0,R.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(h))throw new Error(`Notebook provider for '${h}' already registered`);this._notebookContentProviders.set(h,{extension:l,provider:y});let n;return y.onDidChangeNotebookContentOptions&&(n=y.onDidChangeNotebookContentOptions(()=>{const i=r.NotebookDocumentContentOptions.from(y.options);this._notebookProxy.$updateNotebookProviderOptions(h,i)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},h,r.NotebookDocumentContentOptions.from(a),D._convertNotebookRegistrationData(l,P)),new m.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(h),this._notebookProxy.$unregisterNotebookProvider(h)})}static _convertNotebookRegistrationData(l,h){if(!h)return;const y=h.filenamePattern.map(a=>r.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(h.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:h.displayName,filenamePattern:y,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,h,y){const a=D._notebookStatusBarItemProviderHandlePool++,P=typeof y.onDidChangeCellStatusBarItems=="function"?D._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,y),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,P,h);let n;return P!==void 0&&(n=y.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(P))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,P),n&&n.dispose()})}async createNotebookDocument(l){const h=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&r.NotebookData.from(l.content)});return k.URI.revive(h)}async openNotebookDocument(l){const h=this._documents.get(l);if(h)return h.apiNotebook;const y=await this._notebookDocumentsProxy.$tryOpenNotebook(l),a=this._documents.get(k.URI.revive(y));return(0,C.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(l,h){k.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let y;typeof h=="object"?y={position:r.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(r.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:y={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,y),P=a&&this._editors.get(a)?.apiEditor;if(P)return P;throw a?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,h,y,a){const P=this._notebookStatusBarItemProviders.get(l),n=k.URI.revive(h),i=this._documents.get(n);if(!i||!P)return;const v=i.getCellFromIndex(y);if(!v)return;const g=await P.provideCellStatusBarItems(v.apiCell,a);if(!g)return;const s=new T.DisposableStore,b=this._statusBarCache.add([s]),E=(Array.isArray(g)?g:[g]).map(A=>r.NotebookStatusBarItem.from(A,this._commandsConverter,s));return{cacheId:b,items:E}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,h,y,a,P){if((0,R.isFalsyOrWhitespace)(h))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,y),this._notebookProxy.$registerNotebookSerializer(n,{id:l.identifier,location:l.extensionLocation},h,r.NotebookDocumentContentOptions.from(a),D._convertNotebookRegistrationData(l,P)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(l,h,y){const a=this._notebookSerializer.get(l);if(!a)throw new Error("NO serializer found");const P=await a.deserializeNotebook(h.buffer,y);return new o.SerializableObjectWithBuffers(r.NotebookData.from(P))}async $notebookToData(l,h,y){const a=this._notebookSerializer.get(l);if(!a)throw new Error("NO serializer found");const P=await a.serializeNotebook(r.NotebookData.to(h.value),y);return c.VSBuffer.wrap(P)}async $openNotebook(l,h,y,a,P){const{provider:n}=this._getProviderData(l),i=await n.openNotebook(k.URI.revive(h),{backupId:y,untitledDocumentData:a?.buffer},P);return new o.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(r.NotebookCellData.from)})}async $saveNotebook(l,h,y){const a=this.getNotebookDocument(k.URI.revive(h)),{provider:P}=this._getProviderData(l);return await P.saveNotebook(a.apiNotebook,y),!0}async $saveNotebookAs(l,h,y,a){const P=this.getNotebookDocument(k.URI.revive(h)),{provider:n}=this._getProviderData(l);return await n.saveNotebookAs(k.URI.revive(y),P.apiNotebook,a),!0}async $backupNotebook(l,h,y){const a=this.getNotebookDocument(k.URI.revive(h)),P=this._getProviderData(l),n=this._extensionStoragePaths.workspaceValue(P.extension)??this._extensionStoragePaths.globalValue(P.extension),i=String((0,w.hash)([a.uri.toString(),this._backupIdPool++])),v=k.URI.joinPath(n,i),g=await P.provider.backupNotebook(a.apiNotebook,{destination:v},y);return a.updateBackup(g),g.id}_createExtHostEditor(l,h,y){if(this._editors.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const a=new p.ExtHostNotebookEditor(h,this._notebookEditorsProxy,l,y.visibleRanges.map(r.NotebookRange.to),y.selections.map(r.NotebookRange.to),typeof y.viewColumn=="number"?r.ViewColumn.to(y.viewColumn):void 0);this._editors.set(h,a)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const y of l.value.removedDocuments){const a=k.URI.revive(y),P=this._documents.get(a);P&&(P.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:P.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(P.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===a.toString()&&this._editors.delete(n.id)}if(l.value.addedDocuments){const y=[];for(const a of l.value.addedDocuments){const P=k.URI.revive(a.uri);if(this._documents.has(P))throw new Error(`adding EXISTING notebook ${P} `);const n=this,i=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(v){n._onDidChangeNotebookCells.fire(v)},emitCellOutputsChange(v){n._onDidChangeCellOutputs.fire(v)},emitCellMetadataChange(v){n._onDidChangeCellMetadata.fire(v)},emitCellExecutionStateChange(v){n._onDidChangeCellExecutionState.fire(v)}},P,a);y.push(...a.cells.map(v=>d.ExtHostCell.asModelAddData(i.apiNotebook,v))),this._documents.get(P)?.dispose(),this._documents.set(P,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(l.value.addedEditors)for(const y of l.value.addedEditors){if(this._editors.has(y.id))return;const a=k.URI.revive(y.documentUri),P=this._documents.get(a);P&&this._createExtHostEditor(P,y.id,y)}const h=[];if(l.value.removedEditors)for(const y of l.value.removedEditors){const a=this._editors.get(y);a&&(this._editors.delete(y),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),h.push(a))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const y=new Set;this._visibleNotebookEditors.forEach(a=>y.add(a.id));for(const a of this._editors.values()){const P=y.has(a.id);a._acceptVisibility(P)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=D,D._notebookStatusBarItemProviderHandlePool=0}),define(we[199],Ee([0,1,3,53,12,5,13,8]),function(re,e,c,M,w,T,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(_,r){const m=C._Keys.nextId();_.$registerNotebookEditorDecorationType(m,R.NotebookDecorationRenderOptions.from(r)),this.value={key:m,dispose(){_.$removeNotebookEditorDecorationType(m)}}}}C._Keys=new M.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(_,r,m){this._logService=_,this._extHostRpc=r,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new c.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new c.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new C(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,r){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,r);const m=this._notebooksAndEditors.getEditorById(_);r.visibleRanges&&m._acceptVisibleRanges(r.visibleRanges.ranges.map(R.NotebookRange.to)),r.selections&&m._acceptSelections(r.selections.selections.map(R.NotebookRange.to)),r.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),r.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const r in _)this._notebooksAndEditors.getEditorById(r)._acceptViewColumn(R.ViewColumn.to(_[r]))}};k=Ue([Be(0,w.ILogService),Be(1,t.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(we[200],Ee([0,1,16,14,20,3,7,21,2,26,12,5,38,8,6,67,163,27,37]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let l=class{constructor(n,i,v,g,s){this._initData=i,this._extHostNotebook=v,this._commands=g,this._logService=s,this._activeExecutions=new R.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=n.getProxy(_.MainContext.MainThreadNotebookKernels);const b=new r.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new r.ApiCommandArgument("options","Select kernel options",u=>!0,u=>{if(u&&"notebookEditor"in u&&"id"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);return{id:u.id,extension:u.extension,notebookEditorId:E}}else if(u&&"notebookEditor"in u){const E=this._extHostNotebook.getIdByEditor(u.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${u.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return u})],r.ApiCommandResult.Void);this._commands.registerApiCommand(b)}createNotebookController(n,i,v,g,s,b){for(let Q of this._kernelData.values())if(Q.controller.id===i&&k.ExtensionIdentifier.equals(n.identifier,Q.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const u=this._handlePool++,E=this;this._logService.trace(`NotebookController[${u}], CREATED by ${n.identifier.value}, ${i}`);const A=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${n.identifier}'`);let I=!1;const B=new t.DisposableStore,O=new T.Emitter,S=new T.Emitter,x={id:`${n.identifier.value}/${i}`,notebookType:v,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:g||n.identifier.value,preloads:b?b.map(m.NotebookRendererScript.from):[]};let N=s??A,V;this._proxy.$addKernel(u,x).catch(Q=>{console.log(Q),I=!0});let $=0;const z=()=>{if(I)return;const Q=++$;Promise.resolve().then(()=>{Q===$&&this._proxy.$updateKernel(u,x)})},ee=new R.ResourceMap,j={get id(){return i},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return x.label},set label(Q){x.label=Q??n.displayName??n.name,z()},get detail(){return x.detail??""},set detail(Q){x.detail=Q,z()},get description(){return x.description??""},set description(Q){x.description=Q,z()},get kind(){return(0,D.checkProposedApiEnabled)(n,"notebookControllerKind"),x.kind??""},set kind(Q){(0,D.checkProposedApiEnabled)(n,"notebookControllerKind"),x.kind=Q,z()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(Q){x.supportedLanguages=Q,z()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(Q){x.supportsExecutionOrder=Q,z()},get rendererScripts(){return x.preloads?x.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(Q){N=Q??A},get interruptHandler(){return V},set interruptHandler(Q){V=Q,x.supportsInterrupt=Boolean(Q),z()},createNotebookCellExecution(Q){if(I)throw new Error("notebook controller is DISPOSED");if(!ee.has(Q.notebook.uri))throw E._logService.trace(`NotebookController[${u}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.notebook.uri.toString()}`);return E._createNotebookCellExecution(Q)},dispose:()=>{I||(this._logService.trace(`NotebookController[${u}], DISPOSED`),I=!0,this._kernelData.delete(u),B.dispose(),O.dispose(),S.dispose(),this._proxy.$removeKernel(u))},updateNotebookAffinity(Q,ce){E._proxy.$updateNotebookPriority(u,Q.uri,ce)},onDidReceiveMessage:S.event,postMessage(Q,ce){return(0,D.checkProposedApiEnabled)(n,"notebookMessaging"),E._proxy.$postMessage(u,ce&&E._extHostNotebook.getIdByEditor(ce),Q)},asWebviewUri(Q){return(0,D.checkProposedApiEnabled)(n,"notebookMessaging"),(0,d.asWebviewUri)(Q,E._initData.remote)}};return this._kernelData.set(u,{extensionId:n.identifier,controller:j,onDidReceiveMessage:S,onDidChangeSelection:O,associatedNotebooks:ee}),j}$acceptNotebookAssociation(n,i,v){const g=this._kernelData.get(n);if(g){const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));v?g.associatedNotebooks.set(s.uri,!0):g.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,s.uri.toString(),v),g.onDidChangeSelection.fire({selected:v,notebook:s.apiNotebook})}}async $executeCells(n,i,v){const g=this._kernelData.get(n);if(!g)return;const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i)),b=[];for(let u of v){const E=s.getCell(u);E&&b.push(E.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,s.uri.toString(),b.length),await g.controller.executeHandler.call(g.controller,b,s.apiNotebook,g.controller)}catch(u){this._logService.error(`NotebookController[${n}] execute cells FAILED`,u),console.error(u)}}async $cancelCells(n,i,v){const g=this._kernelData.get(n);if(!g)return;const s=this._extHostNotebook.getNotebookDocument(C.URI.revive(i));if(g.controller.interruptHandler)await g.controller.interruptHandler.call(g.controller,s.apiNotebook);else for(let b of v){const u=s.getCell(b);u&&this._activeExecutions.get(u.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,i,v){const g=this._kernelData.get(n);if(!g)return;const s=this._extHostNotebook.getEditorById(i);g.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:v}))}_createNotebookCellExecution(n){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!v)throw new Error("invalid cell");if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const g=new y(v.notebook,v,this._proxy);this._activeExecutions.set(v.uri,g);const s=g.onDidChangeState(()=>{g.state===h.Resolved&&(g.dispose(),s.dispose(),this._activeExecutions.delete(v.uri))});return g.asApiObject()}};l=Ue([Be(4,F.ILogService)],l),e.ExtHostNotebookKernels=l;var h;(function(P){P[P.Init=0]="Init",P[P.Started=1]="Started",P[P.Resolved=2]="Resolved"})(h||(h={}));class y extends t.Disposable{constructor(n,i,v){super();this._document=n,this._cell=i,this._proxy=v,this._handle=y.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=h.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new a(10,g=>this.update(g)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const i=Array.isArray(n)?n:[n];return this._proxy.$updateExecutions(new f.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===h.Init)throw new Error("Must call start before modifying cell output");if(this._state===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let i=this._cell;if(n&&(i=this._document.getCellFromApiCell(n)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(n){return n.map(i=>{const v=o.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return v===i.items?m.NotebookCellOutput.from(i):m.NotebookCellOutput.from({items:v,id:i.id,metadata:i.metadata})})}async updateOutputs(n,i,v){const g=this.cellIndexToHandle(i),s=this.validateAndConvertOutputs((0,c.asArray)(n));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:g,append:v,outputs:s})}async updateOutputItems(n,i,v){return n=o.NotebookCellOutput.ensureUniqueMimeTypes((0,c.asArray)(n),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:n.map(m.NotebookCellOutputItem.from),outputId:i.id,append:v})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(v){n._executionOrder=v,n.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,executionOrder:n._executionOrder}])},start(v){if(n._state===h.Resolved||n._state===h.Started)throw new Error("Cannot call start again");n._state=h.Started,n._onDidChangeState.fire(),n.update({editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,runStartTime:v})},end(v,g){if(n._state===h.Resolved)throw new Error("Cannot call resolve twice");n._state=h.Resolved,n._onDidChangeState.fire(),n.updateSoon({editType:p.CellExecutionUpdateType.Complete,executionHandle:n._handle,runEndTime:g,lastRunSuccess:v}),n._collector.flush(),n._proxy.$removeExecution(n._handle)},clearOutput(v){return n.verifyStateForOutput(),n.updateOutputs([],v,!1)},appendOutput(v,g){return n.verifyStateForOutput(),n.updateOutputs(v,g,!0)},replaceOutput(v,g){return n.verifyStateForOutput(),n.updateOutputs(v,g,!1)},appendOutputItems(v,g){return n.verifyStateForOutput(),n.updateOutputItems(v,g,!0)},replaceOutputItems(v,g){return n.verifyStateForOutput(),n.updateOutputItems(v,g,!1)}})}}y.HANDLE=0;class a{constructor(n,i){this.delay=n,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>n.complete())}}}),define(we[201],Ee([0,1,3,5,92,27]),function(re,e,c,M,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class t{constructor(C,k){this._extHostNotebook=k,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,k,F){const _=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(k)?.fire({editor:_.apiEditor,message:F})}createRendererMessaging(C,k){if(!C.contributes?.notebookRenderer?.some(m=>m.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);const F=(0,T.isProposedApiEnabled)(C,"notebookEditor"),_=new WeakMap;return{onDidReceiveMessage:(m,o,d)=>{const p=F?m:D=>{const f={};_.set(f,D.editor),m({editor:f,message:D.message})};return this.getOrCreateEmitterFor(k).event(p,o,d)},postMessage:(m,o)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(m)&&([m,o]=[o,m]);const d=F?o:_.get(o),p=d&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);return this.proxy.$postMessage(p?.id,k,m)}}}getOrCreateEmitterFor(C){let k=this._rendererMessageEmitters.get(C);return k||(k=new c.Emitter({onLastListenerRemove:()=>{k?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,k),k)}}e.ExtHostNotebookRenderers=t}),define(we[95],Ee([0,1,5,7,4,13,12,164,50,28,31,114,22]),function(re,e,c,M,w,T,t,R,C,k,F,_,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class m extends M.Disposable{constructor(p,D,f,l){super();this.id=p,this.name=D,this.logger=f,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(p){this.append(p+`
`)}append(p){this.write(p),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Append))}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Clear,p)}replace(p){const D=this.offset;this.write(p),this.proxy.$update(this.id,R.OutputChannelUpdateMode.Replace,D),this.visible&&this.logger.flush()}show(p,D){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:D))}hide(){this.proxy.$close(this.id)}write(p){this.offset+=r.VSBuffer.fromString(p).byteLength,this.logger.info(p)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=m;let o=class{constructor(p,D,f,l,h){this.extHostFileSystem=f,this.extHostFileSystemInfo=l,this.loggerService=h,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(c.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(D.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[D,f]of this.channels)f.visible=D===this.visibleChannelId}createOutputChannel(p,D){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const f=this.doCreateOutputChannel(p,D);return f.then(l=>{this.channels.set(l.id,l),l.visible=l.id===this.visibleChannelId}),this.createExtHostOutputChannel(p,f)}async doCreateOutputChannel(p,D){const f=await this.createOutputDirectory(),l=this.extHostFileSystemInfo.extUri.joinPath(f,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.loggerService.createLogger(l,{always:!0,donotRotate:!0,donotUseFormatters:!0}),y=await this.proxy.$register(p,!1,l,D.identifier.value);return new m(y,p,h,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(p,D){let f=!1;const l=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return p},append(h){l(),D.then(y=>y.append(h))},appendLine(h){l(),D.then(y=>y.appendLine(h))},clear(){l(),D.then(h=>h.clear())},replace(h){l(),D.then(y=>y.replace(h))},show(h,y){l(),D.then(a=>a.show(h,y))},hide(){l(),D.then(h=>h.hide())},dispose(){f=!0,D.then(h=>h.dispose())}}}};o=Ue([Be(0,T.IExtHostRpcService),Be(1,k.IExtHostInitDataService),Be(2,C.IExtHostConsumerFileSystem),Be(3,F.IExtHostFileSystemInfo),Be(4,t.ILoggerService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(we[202],Ee([0,1,14,20,3,7,5,2,6,15,16,35,63,27]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(d,p,D){const f=d.getProxy(t.MainContext.MainThreadQuickOpen);class l{constructor(s,b){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=b}showQuickPick(s,b,u=M.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(s),A=++this._instances,I=f.$show(A,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},u),B={},O=I.then(()=>B);return Promise.race([O,E]).then(S=>{if(S!==B)return E.then(x=>{const N=[];for(let V=0;V<x.length;V++){const $=x[V];typeof $=="string"?N.push({label:$,handle:V}):$.kind===C.QuickPickItemKind.Separator?N.push({type:"separator",label:$.label}):N.push({label:$.label,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,handle:V})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{b.onDidSelectItem(x[V])}),f.$setItems(A,N),I.then(V=>{if(typeof V=="number")return x[V];if(Array.isArray(V))return V.map($=>x[$])})})}).then(void 0,S=>{if(!(0,k.isPromiseCanceledError)(S))return f.$setError(A,S),Promise.reject(S)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,b=M.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,f.$input(s,typeof this._validateInput=="function",b).then(void 0,u=>{if(!(0,k.isPromiseCanceledError)(u))return Promise.reject(u)})}$validateInput(s){return this._validateInput?(0,c.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,b=M.CancellationToken.None){const u=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!u)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(A=>A.uri.toString()===u.uri.toString())}createQuickPick(s){const b=new i(s,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(s){const b=new v(s,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}$onDidChangeValue(s,b){const u=this._sessions.get(s);u&&u._fireDidChangeValue(b)}$onDidAccept(s){const b=this._sessions.get(s);b&&b._fireDidAccept()}$onDidChangeActive(s,b){const u=this._sessions.get(s);u instanceof i&&u._fireDidChangeActive(b)}$onDidChangeSelection(s,b){const u=this._sessions.get(s);u instanceof i&&u._fireDidChangeSelection(b)}$onDidTriggerButton(s,b){const u=this._sessions.get(s);u&&u._fireDidTriggerButton(b)}$onDidTriggerItemButton(s,b,u){const E=this._sessions.get(s);E instanceof i&&E._fireDidTriggerItemButton(b,u)}$onDidHide(s){const b=this._sessions.get(s);b&&b._fireDidHide()}}class h{constructor(s,b){this._extensionId=s,this._onDidDispose=b,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new w.Emitter,this._onDidChangeValueEmitter=new w.Emitter,this._onDidTriggerButtonEmitter=new w.Emitter,this._onDidHideEmitter=new w.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((b,u)=>{const E=b===C.QuickInputButtons.Back?-1:u;this._handlesToButtons.set(E,b)}),this.update({buttons:s.map((b,u)=>({...n(b),tooltip:b.tooltip,handle:b===C.QuickInputButtons.Back?-1:u}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const b=this._handlesToButtons.get(s);b&&this._onDidTriggerButtonEmitter.fire(b)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),f.$dispose(this._id))}update(s){if(!this._disposed){for(const b of Object.keys(s)){const u=s[b];this._pendingUpdate[b]=u===void 0?null:u}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){f.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}h._nextId=1;function y(g){if(g instanceof C.ThemeIcon)return{id:g.id};const s=P(g),b=a(g);return{dark:typeof s=="string"?R.URI.file(s):s,light:typeof b=="string"?R.URI.file(b):b}}function a(g){return typeof g=="object"&&"light"in g?g.light:g}function P(g){return typeof g=="object"&&"dark"in g?g.dark:g}function n(g){const s=y(g.iconPath);let b,u;return"id"in s?u=r.ThemeIcon.asClassName(s):b=s,{iconPath:b,iconClass:u}}class i extends h{constructor(s,b){super(s.identifier,b);this.extension=s,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new w.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new w.Emitter,this._onDidTriggerItemButtonEmitter=new w.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){s.some(u=>u.kind!==void 0)&&(0,m.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((u,E)=>{this._handlesToItems.set(E,u),this._itemsToHandles.set(u,E)});const b=[];for(let u=0;u<s.length;u++){const E=s[u];E.kind===C.QuickPickItemKind.Separator?b.push({type:"separator",label:E.label}):b.push({handle:u,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((A,I)=>({...n(A),tooltip:A.tooltip,handle:I}))})}this.update({items:b})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(b=>this._itemsToHandles.has(b)),this.update({activeItems:this._activeItems.map(b=>this._itemsToHandles.get(b))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(b=>this._itemsToHandles.has(b)),this.update({selectedItems:this._selectedItems.map(b=>this._itemsToHandles.get(b))})}_fireDidChangeActive(s){const b=(0,F.coalesce)(s.map(u=>this._handlesToItems.get(u)));this._activeItems=b,this._onDidChangeActiveEmitter.fire(b)}_fireDidChangeSelection(s){const b=(0,F.coalesce)(s.map(u=>this._handlesToItems.get(u)));this._selectedItems=b,this._onDidChangeSelectionEmitter.fire(b)}_fireDidTriggerItemButton(s,b){const u=this._handlesToItems.get(s);if(!u||!u.buttons||!u.buttons.length)return;const E=u.buttons[b];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:u})}}class v extends h{constructor(s,b){super(s,b);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?_.default.Error:_.default.Ignore})}}return new l(p,D)}e.createExtHostQuickOpen=o}),define(we[203],Ee([0,1,2,3,52,7,14,5,16,106,12,26,63,8,27]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(g){if(g)return typeof g.iconPath=="string"?c.URI.file(g.iconPath):c.URI.isUri(g.iconPath)||r.ThemeIcon.isThemeIcon(g.iconPath)?g.iconPath:void 0}function p(g,s){if(!g.iconPath&&!s.iconPath)return 0;if(g.iconPath){if(!s.iconPath)return 1}else return-1;const b=typeof g.iconPath=="string"?g.iconPath:c.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id,u=typeof s.iconPath=="string"?s.iconPath:c.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,k.comparePaths)(b,u)}function D(g,s){let b=0;if(g.strikeThrough!==s.strikeThrough)return g.strikeThrough?1:-1;if(g.faded!==s.faded)return g.faded?1:-1;if(g.tooltip!==s.tooltip)return(g.tooltip||"").localeCompare(s.tooltip||"");if(b=p(g,s),b!==0)return b;if(g.light&&s.light)b=p(g.light,s.light);else{if(g.light)return 1;if(s.light)return-1}if(b!==0)return b;if(g.dark&&s.dark)b=p(g.dark,s.dark);else{if(g.dark)return 1;if(s.dark)return-1}return b}function f(g,s){if(g.command!==s.command)return g.command<s.command?-1:1;if(g.title!==s.title)return g.title<s.title?-1:1;if(g.tooltip!==s.tooltip){if(g.tooltip!==void 0&&s.tooltip!==void 0)return g.tooltip<s.tooltip?-1:1;if(g.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(g.arguments===s.arguments)return 0;if(g.arguments)if(s.arguments){if(g.arguments.length!==s.arguments.length)return g.arguments.length-s.arguments.length}else return 1;else return-1;for(let b=0;b<g.arguments.length;b++){const u=g.arguments[b],E=s.arguments[b];if(u!==E)return u<E?-1:1}return 0}function l(g,s){let b=(0,k.comparePaths)(g.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(b!==0)return b;if(g.command&&s.command)b=f(g.command,s.command);else{if(g.command)return 1;if(s.command)return-1}if(b!==0)return b;if(g.decorations&&s.decorations)b=D(g.decorations,s.decorations);else{if(g.decorations)return 1;if(s.decorations)return-1}return b}function h(g,s){for(let b=0;b<g.length;b++)if(g[b]!==s[b])return!1;return!0}function y(g,s){return g.command===s.command&&g.title===s.title&&g.tooltip===s.tooltip&&(g.arguments&&s.arguments?h(g.arguments,s.arguments):g.arguments===s.arguments)}function a(g,s){return(0,C.equals)(g,s,y)}class P{constructor(s,b,u){this._extension=s,this._proxy=b,this._sourceControlHandle=u,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(s){if((0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}showValidationMessage(s,b){(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,s,b)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=P;class n{constructor(s,b,u,E,A){this._proxy=s,this._commands=b,this._sourceControlHandle=u,this._id=E,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,b){const u=this._resourceStatesCommandsMap.get(s);return u?(0,t.asPromise)(()=>this._commands.executeCommand(u.command,...u.arguments||[],b)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this._resourceStates].sort(l),u=(0,C.sortedDiff)(this._resourceSnapshot,s,l).map(I=>{const B=I.toInsert.map(O=>{const S=this._resourceHandlePool++;this._resourceStatesMap.set(S,O);const x=O.resourceUri;let N;if(O.command)if(O.command.command==="vscode.open"||O.command.command==="vscode.diff"){const Fe=new T.DisposableStore;N=this._commands.converter.toInternal(O.command,Fe),this._resourceStatesDisposablesMap.set(S,Fe)}else this._resourceStatesCommandsMap.set(S,O.command);const V=d(O.decorations),$=O.decorations&&d(O.decorations.light)||V,z=O.decorations&&d(O.decorations.dark)||V,ee=[$,z],j=O.decorations&&O.decorations.tooltip||"",Q=O.decorations&&!!O.decorations.strikeThrough,ce=O.decorations&&!!O.decorations.faded,ve=O.contextValue||"";return{rawResource:[S,x,ee,j,Q,ce,ve,N],handle:S}});return{start:I.start,deleteCount:I.deleteCount,toInsert:B}}),E=u.map(({start:I,deleteCount:B,toInsert:O})=>[I,B,O.map(S=>S.rawResource)]),A=u.reverse();for(const{start:I,deleteCount:B,toInsert:O}of A){const S=O.map(N=>N.handle),x=this._handlesSnapshot.splice(I,B,...S);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=s,E}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class i{constructor(s,b,u,E,A,I){this._extension=s,this._proxy=b,this._commands=u,this._id=E,this._label=A,this._rootUri=I,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new P(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,A,I)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=s;const b=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:b})}get actionButton(){return(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(s){(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=s;const b=s!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:b??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(this._statusBarCommands&&s&&a(this._statusBarCommands,s))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=s;const b=(s||[]).map(u=>this._commands.converter.toInternal(u,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:b})}get selected(){return this._selected}createResourceGroup(s,b){const u=new n(this._proxy,this._commands,this.handle,s,b),E=M.Event.once(u.onDidDispose)(()=>this.createdResourceGroups.delete(u));return this.createdResourceGroups.set(u,E),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const s=[],b=[];for(const[u,E]of this.createdResourceGroups){E.dispose();const A=u.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(u),this.eventuallyUpdateResourceStates()});M.Event.once(u.onDidDispose)(()=>{this.updatedResourceGroups.delete(u),A.dispose(),this._groups.delete(u.handle),this._proxy.$unregisterGroup(this.handle,u.handle)}),s.push([u.handle,u.id,u.label,u.features]);const I=u._takeResourceStateSnapshot();I.length>0&&b.push([u.handle,I]),this._groups.set(u.handle,u)}this._proxy.$registerGroups(this.handle,s,b),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(b=>{const u=b._takeResourceStateSnapshot();u.length!==0&&s.push([b.handle,u])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ue([(0,w.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ue([(0,w.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let v=class $i{constructor(s,b,u){this._commands=b,this.logService=u,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=s.getProxy(R.MainContext.MainThreadSCM),this._telemetry=s.getProxy(R.MainContext.MainThreadTelemetry),b.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const A=this._sourceControls.get(E.sourceControlHandle);if(!A)return E;const I=A.getResourceGroup(E.groupHandle);return I?I.getResourceState(E.handle):E}else if(E&&E.$mid===4){const A=this._sourceControls.get(E.sourceControlHandle);return A?A.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const A=this._sourceControls.get(E.handle);return A||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,b,u,E){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,b,u,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const A=$i._handlePool++,I=new i(s,this._proxy,this._commands,b,u,E);this._sourceControls.set(A,I);const B=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier))||[];return B.push(I),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(s.identifier),B),I}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const b=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier)),u=b&&b[b.length-1];return u&&u.inputBox}$provideOriginalResource(s,b,u){const E=c.URI.revive(b);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,E.toString());const A=this._sourceControls.get(s);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,t.asPromise)(()=>A.quickDiffProvider.provideOriginalResource(E,u)).then(I=>I||null)}$onInputBoxValueChange(s,b){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const u=this._sourceControls.get(s);return u&&u.inputBox.$onInputBoxValueChange(b),Promise.resolve(void 0)}$executeResourceCommand(s,b,u,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,b,u);const A=this._sourceControls.get(s);if(!A)return Promise.resolve(void 0);const I=A.getResourceGroup(b);return I?I.$executeResourceCommand(u,E):Promise.resolve(void 0)}$validateInput(s,b,u){this.logService.trace("ExtHostSCM#$validateInput",s);const E=this._sourceControls.get(s);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):(0,t.asPromise)(()=>E.inputBox.validateInput(b,u)).then(A=>{if(!A)return Promise.resolve(void 0);const I=m.MarkdownString.fromStrict(A.message);return I?Promise.resolve([I,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this._sourceControls.get(s)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};v._handlePool=0,v=Ue([Be(2,F.ILogService)],v),e.ExtHostSCM=v});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[204],Ee([0,1,6,5,126,7,8,10]),function(re,e,c,M,w,T,t,R){"use strict";var C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(o,d,p,D,f=c.StatusBarAlignment.Left,l){C.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Je(this,C,o,"f"),Je(this,k,d,"f"),this._entryId=F.ID_GEN++,this._extension=p,this._id=D,this._alignment=f,this._priority=this.validatePriority(l)}validatePriority(o){if(!!(0,R.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!F.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Ae(this,k,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Ae(this,k,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let d;this._name?d=this._name:d=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?t.MarkdownString.fromStrict(this._tooltip):void 0;Ae(this,C,"f").$setEntry(this._entryId,o,d,this._text,D,this._command?.internal,p,this._backgroundColor,this._alignment===c.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,C=new WeakMap,k=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new c.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new c.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",c.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const d={message:o};return this._messages.unshift(d),this._update(),new c.Disposable(()=>{const p=this._messages.indexOf(d);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class r{constructor(o,d){this._proxy=o.getProxy(M.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new _(this)}createStatusBarEntry(o,d,p,D){return new F(this._proxy,this._commands,o,d,p,D)}setStatusBarMessage(o,d){const p=this._statusMessage.setMessage(o);let D;return typeof d=="number"?D=setTimeout(()=>p.dispose(),d):typeof d!="undefined"&&d.then(()=>p.dispose(),()=>p.dispose()),new c.Disposable(()=>{p.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=r}),define(we[72],Ee([0,1,5,3,4]),function(re,e,c,M,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(R){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=R.getProxy(c.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,C){this._proxy.$registerExtensionStorageKeysToSync(R,C)}getValue(R,C,k){return this._proxy.$getValue(R,C).then(F=>F||k)}setValue(R,C,k){return this._proxy.$setValue(R,C,k)}$acceptValue(R,C,k){this._onDidChangeStorage.fire({shared:R,key:C,value:k})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(we[73],Ee([0,1,4,28,12,50,2]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,c.createDecorator)("IExtensionStoragePaths");let R=class{constructor(k,F,_){this._logService=F,this._extHostFileSystem=_,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(r=>this._value=r)}async _getWorkspaceStorageURI(k){return t.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,F=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(t.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:t.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(k){if(this._value)return t.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return t.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=Ue([Be(0,M.IExtHostInitDataService),Be(1,w.ILogService),Be(2,T.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(we[39],Ee([0,1,3,5,4,2,13,7,6,127,15,166,20,36,149,63,10,14]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class f{constructor(g,s,b,u){this._proxy=g,this._id=s,this._creationOptions=b,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(A,I=!0){E._checkDisposed(),E._proxy.$sendText(E._id,A,I)},show(A){E._checkDisposed(),E._proxy.$show(E._id,A)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(g,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:g.name,shellPath:(0,p.withNullAsUndefined)(g.shellPath),shellArgs:(0,p.withNullAsUndefined)(g.shellArgs),cwd:(0,p.withNullAsUndefined)(g.cwd),env:(0,p.withNullAsUndefined)(g.env),icon:(0,p.withNullAsUndefined)(n(g.iconPath)),color:d.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:(0,p.withNullAsUndefined)(g.message),strictEnv:(0,p.withNullAsUndefined)(g.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(g.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(g.location,s?.resolvedExtHostIdentifier)})}async createExtensionTerminal(g,s,b,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:d.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(g,s)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(g,s){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in g?{viewColumn:g.viewColumn,preserveFocus:g.preserveFocus}:void 0:g}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(g){this._name=g}setExitCode(g){this._exitStatus=Object.freeze({code:g})}setDimensions(g,s){return g===this._cols&&s===this._rows||g===0||s===0?!1:(this._cols=g,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(g){this._pidPromiseComplete?(this._pidPromiseComplete(g),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==g&&(this._pidPromise=Promise.resolve(g))})}}e.ExtHostTerminal=f;class l{constructor(g){this._pty=g,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new c.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new c.Emitter,this._onDidChangeProperty=new c.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new c.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(g){this._pty.handleInput?.(g)}resize(g,s){this._pty.setDimensions?.({columns:g,rows:s})}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(g){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(g||void 0),g&&this._pty.setDimensions?.(g),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=l;let h=1,y=class extends R.Disposable{constructor(g,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new c.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new c.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new c.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new c.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new c.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new c.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(g),this._register({dispose:()=>{for(const[b,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(g=>g.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(g){return(g?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(g,s){const b=new f(this._proxy,(0,m.generateUuid)(),g,g.name),u=new l(g.pty);return b.createExtensionTerminal(g.location,this._serializeParentTerminal(g,s).resolvedExtHostIdentifier,n(g.iconPath),i(g.color)).then(E=>{const A=this._setupExtHostProcessListeners(E,u);this._terminalProcessDisposables[E]=A}),this._terminals.push(b),b.value}_serializeParentTerminal(g,s){if(s=s||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const b=g.location.parentTerminal;if(b){const u=this._terminals.find(E=>E.value===b);u&&(s.resolvedExtHostIdentifier=u._id)}}else g.location&&typeof g.location!="object"?s.location=g.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(g,s){if(!this._getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const u=new l(s),E=this._setupExtHostProcessListeners(g,u);this._terminalProcessDisposables[g]=E}async $acceptActiveTerminalChanged(g){const s=this._activeTerminal;if(g===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(g);b&&(this._activeTerminal=b,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(g,s){const b=this._getTerminalById(g);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:s})}async $acceptTerminalDimensions(g,s,b){const u=this._getTerminalById(g);u&&u.setDimensions(s,b)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(g,s,b){this._terminalProcesses.get(g)?.resize(s,b)}async $acceptTerminalTitleChange(g,s){const b=this._getTerminalById(g);b&&(b.name=s)}async $acceptTerminalClosed(g,s){const b=this._getTerminalObjectIndexById(this._terminals,g);if(b!==null){const u=this._terminals.splice(b,1)[0];u.setExitCode(s),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(g,s,b,u){if(s){const I=this._getTerminalObjectIndexById(this._terminals,s);if(I!==null){this._terminals[I]._id=g,this._onDidOpenTerminal.fire(this.terminals[I]),this._terminals[I].isOpen=!0;return}}const E={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:T.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},A=new f(this._proxy,g,E,b);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(g,s){const b=this._getTerminalById(g);b&&b._setProcessId(s)}async $startExtensionTerminal(g,s){const b=this._getTerminalById(g);if(!b)return{message:(0,k.localize)(0,null,g)};b.isOpen||await new Promise(E=>{const A=this.onDidOpenTerminal(async I=>{I===b.value&&(A.dispose(),E())})});const u=this._terminalProcesses.get(g);u?u.startSendingEvents(s):this._extensionTerminalAwaitingStart[g]={initialDimensions:s}}_setupExtHostProcessListeners(g,s){const b=new R.DisposableStore;b.add(s.onProcessReady(E=>this._proxy.$sendProcessReady(g,E.pid,E.cwd))),b.add(s.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(g,E))),this._bufferer.startBuffering(g,s.onProcessData),b.add(s.onProcessExit(E=>this._onProcessExit(g,E))),this._terminalProcesses.set(g,s);const u=this._extensionTerminalAwaitingStart[g];return u&&s instanceof l&&(s.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[g]),b}$acceptProcessAckDataEvent(g,s){this._terminalProcesses.get(g)?.acknowledgeDataEvent(s)}$acceptProcessInput(g,s){this._terminalProcesses.get(g)?.input(s)}$acceptTerminalInteraction(g){const s=this._getTerminalById(g);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(g,s,b){try{this._terminalProcesses.get(g)?.resize(s,b)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(g,s){this._terminalProcesses.get(g)?.shutdown(s)}$acceptProcessRequestInitialCwd(g){this._terminalProcesses.get(g)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(g,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(g){this._terminalProcesses.get(g)?.getCwd().then(s=>this._proxy.$sendProcessProperty(g,{type:"cwd",value:s}))}$acceptProcessRequestLatency(g){return g}registerLinkProvider(g){return this._linkProviders.add(g),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(g),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(g,s,b){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,b),this._proxy.$registerProfileProvider(s,g.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(g,s){const b=new r.CancellationTokenSource().token;let u=await this._profileProviders.get(g)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(u&&!("options"in u)&&(u={options:u}),!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,s);return}this.createTerminalFromOptions(u.options,s)}}async $provideLinks(g,s){const b=this._getTerminalById(g);if(!b)return[];this._terminalLinkCache.delete(g);const u=this._terminalLinkCancellationSource.get(g);u&&u.dispose(!0);const E=new r.CancellationTokenSource;this._terminalLinkCancellationSource.set(g,E);const A=[],I={terminal:b.value,line:s},B=[];for(const x of this._linkProviders)B.push(D.Promises.withAsyncBody(async N=>{E.token.onCancellationRequested(()=>N({provider:x,links:[]}));const V=await x.provideTerminalLinks(I,E.token)||[];E.token.isCancellationRequested||N({provider:x,links:V})}));const O=await Promise.all(B);if(E.token.isCancellationRequested)return[];const S=new Map;for(const x of O)x&&x.links.length>0&&A.push(...x.links.map(N=>{const V={id:h++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return S.set(V.id,{provider:x.provider,link:N}),V}));return this._terminalLinkCache.set(g,S),A}$activateLink(g,s){const b=this._terminalLinkCache.get(g)?.get(s);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(g,s){this._bufferer.stopBuffering(g),this._terminalProcesses.delete(g),delete this._extensionTerminalAwaitingStart[g];const b=this._terminalProcessDisposables[g];b&&(b.dispose(),delete this._terminalProcessDisposables[g]),this._proxy.$sendProcessExit(g,s)}_getTerminalById(g){return this._getTerminalObjectById(this._terminals,g)}_getTerminalObjectById(g,s){const b=this._getTerminalObjectIndexById(g,s);return b!==null?g[b]:null}_getTerminalObjectIndexById(g,s){let b=null;return g.some((u,E)=>u._id===s?(b=E,!0):!1),b}getEnvironmentVariableCollection(g){let s=this._environmentVariableCollections.get(g.identifier.value);return s||(s=new a,this._setEnvironmentVariableCollection(g.identifier.value,s)),s}_syncEnvironmentVariableCollection(g,s){const b=(0,_.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(g,s.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(g){g.forEach(s=>{const b=s[0],u=new a(s[1]);this._setEnvironmentVariableCollection(b,u)})}$acceptDefaultProfile(g,s){this._defaultProfile=g,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(g,s){this._environmentVariableCollections.set(g,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(g,s)})}};y=Ue([Be(1,t.IExtHostRpcService)],y),e.BaseExtHostTerminalService=y;class a{constructor(g){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new c.Emitter,this.map=new Map(g)}get persistent(){return this._persistent}set persistent(g){this._persistent=g,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(g,s){this._setIfDiffers(g,{value:s,type:C.EnvironmentVariableMutatorType.Replace})}append(g,s){this._setIfDiffers(g,{value:s,type:C.EnvironmentVariableMutatorType.Append})}prepend(g,s){this._setIfDiffers(g,{value:s,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(g,s){const b=this.map.get(g);(!b||b.value!==s.value||b.type!==s.type)&&(this.map.set(g,s),this._onDidChangeCollection.fire())}get(g){return this.map.get(g)}forEach(g,s){this.map.forEach((b,u)=>g.call(s,u,b,this))}delete(g){this.map.delete(g),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let P=class extends y{constructor(g){super(!1,g)}createTerminal(g,s,b){throw new F.NotSupportedError}createTerminalFromOptions(g,s){throw new F.NotSupportedError}};P=Ue([Be(0,t.IExtHostRpcService)],P),e.WorkerExtHostTerminalService=P;function n(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function i(v){return d.ThemeColor.isThemeColor(v)?v:void 0}});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[205],Ee([0,1,16,22,20,3,234,58,7,25,10,36,5,13,48,8,6,174,89,68]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f,l){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let y=class{constructor(I,B){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=I.getProxy(r.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new P(this.proxy),B.registerArgumentProcessor({processArgument:O=>O?.$mid===13?d.TestItem.toItemFromContext(O):O})}createTestController(I,B){if(this.controllers.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const O=new C.DisposableStore,S=O.add(new D.SingleUseTestCollection(I));S.root.label=B;const x=new Map,N=this.proxy,V={items:S.root.children,get label(){return B},set label(z){B=z,S.root.label=z,N.$updateControllerLabel(I,B)},get id(){return I},createRunProfile:(z,ee,j,Q,ce)=>{let ve=(0,R.hash)(z);for(;x.has(ve);)ve++;const ue=new u(this.proxy,I,ve,z,ee,j,Q,ce);return x.set(ve,ue),ue},createTestItem(z,ee,j){return new o.TestItemImpl(I,z,ee,j)},createTestRun:(z,ee,j=!0)=>this.runTracker.createTestRun(I,S,z,ee,j),set resolveHandler(z){S.resolveHandler=z},get resolveHandler(){return S.resolveHandler},dispose:()=>{O.dispose()}};V.createRunConfiguration=V.createRunProfile,N.$registerTestController(I,B),O.add((0,C.toDisposable)(()=>N.$unregisterTestController(I)));const $={controller:V,collection:S,profiles:x};return this.controllers.set(I,$),O.add((0,C.toDisposable)(()=>this.controllers.delete(I))),O.add(S.onDidGenerateDiff(z=>N.$publishDiff(I,z))),V}createTestObserver(){return this.observer.checkout()}async runTests(I,B=w.CancellationToken.None){const O=n(I);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const S=this.controllers.get(O.controllerId);if(!S)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:I.include?.map(x=>x.id)??[S.collection.root.id],profileGroup:E[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:I.exclude?.map(x=>x.id)},B)}$provideFileCoverage(I,B,O){return(0,c.mapFind)(this.runTracker.trackers,x=>x.id===I?x.getCoverage(B):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(I,B,O,S){return(0,c.mapFind)(this.runTracker.trackers,N=>N.id===I?N.getCoverage(B):void 0)?.resolveFileCoverage(O,S)??Promise.resolve([])}$configureRunProfile(I,B){this.controllers.get(I)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(I){this.results=Object.freeze(I.map(B=>(0,k.deepFreeze)(d.TestResults.to(B))).concat(this.results).sort((B,O)=>O.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(I,B){const O=this.controllers.get(l.TestId.fromString(I).controllerId)?.collection;O&&(await O.expand(I,B<0?Infinity:B),O.flushDiff())}$acceptDiff(I){this.observer.applyDiff(I)}async $runControllerTests(I,B){const O=this.controllers.get(I.controllerId);if(!O)return;const{collection:S,profiles:x}=O,N=x.get(I.profileId);if(!N)return;const V=I.testIds.map(j=>S.tree.get(j)).filter(F.isDefined),$=I.excludeExtIds.map(j=>O.collection.tree.get(j)).filter(F.isDefined).filter(j=>V.some(Q=>Q.fullId.compare(j.fullId)===2));if(!V.length)return;const z=new p.TestRunRequest(V.some(j=>j.actual instanceof o.TestItemRootImpl)?void 0:V.map(j=>j.actual),$.map(j=>j.actual),N),ee=this.runTracker.prepareForMainThreadTestRun(z,i.fromInternal(I,O.collection),B);try{await N.runHandler(z,B)}finally{ee.isRunning&&!B.isCancellationRequested&&await T.Event.toPromise(ee.onEnd),ee.dispose()}}$cancelExtensionTestRun(I){I===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(I)}};y=Ue([Be(0,m.IExtHostRpcService)],y),e.ExtHostTesting=y;class a extends C.Disposable{constructor(I,B,O){super();this.dto=I,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:S}of this.tasks.values())S.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(I){return this.tasks.get(I)?.coverage}createRun(I){const B=this.dto.id,O=this.dto.controllerId,S=(0,_.generateUuid)(),x=new v(this.proxy,B,S),N=ee=>(j,...Q)=>{if($){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),ee(j,...Q))},V=(ee,j)=>{const Q=j instanceof Array?j.map(d.TestMessage.from):[d.TestMessage.from(j)];if(ee.uri&&ee.range){const ce={range:d.Range.from(ee.range),uri:ee.uri};for(const ve of Q)ve.location=ve.location||ce}this.proxy.$appendTestMessagesInRun(B,S,l.TestId.fromExtHostTestItem(ee,O).toString(),Q)};let $=!1;const z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:I,get coverageProvider(){return x.coverageProvider},set coverageProvider(ee){x.coverageProvider=ee},enqueued:N(ee=>{this.proxy.$updateTestStateInRun(B,S,l.TestId.fromExtHostTestItem(ee,O).toString(),1)}),skipped:N(ee=>{this.proxy.$updateTestStateInRun(B,S,l.TestId.fromExtHostTestItem(ee,O).toString(),5)}),started:N(ee=>{this.proxy.$updateTestStateInRun(B,S,l.TestId.fromExtHostTestItem(ee,O).toString(),2)}),errored:N((ee,j,Q)=>{V(ee,j),this.proxy.$updateTestStateInRun(B,S,l.TestId.fromExtHostTestItem(ee,O).toString(),6,Q)}),failed:N((ee,j,Q)=>{V(ee,j),this.proxy.$updateTestStateInRun(B,S,l.TestId.fromExtHostTestItem(ee,O).toString(),4,Q)}),passed:N((ee,j)=>{this.proxy.$updateTestStateInRun(B,S,l.TestId.fromExtHostTestItem(ee,this.dto.controllerId).toString(),3,j)}),appendOutput:(ee,j,Q)=>{$||(Q&&(this.dto.isIncluded(Q)?this.ensureTestIsKnown(Q):Q=void 0),this.proxy.$appendOutputToRun(B,S,M.VSBuffer.fromString(ee),j&&d.location.from(j),Q&&l.TestId.fromExtHostTestItem(Q,O).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(B,S),this.tasks.delete(S),this.isRunning||this.dispose())}};return this.tasks.set(S,{run:z,coverage:x}),this.proxy.$startedTestRunTask(B,{id:S,name:I,running:!0}),z}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(I){if(!(I instanceof o.TestItemImpl))throw new o.InvalidTestItemError(I.id);if(this.sharedTestIds.has(l.TestId.fromExtHostTestItem(I,this.dto.controllerId).toString()))return;const B=[],O=this.dto.colllection.root;for(;;){const S=d.TestItem.from(I);if(B.unshift(S),this.sharedTestIds.has(S.extId)||(this.sharedTestIds.add(S.extId),I===O))break;I=I.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class P{constructor(I){this.proxy=I,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(I,B,O){return this.getTracker(I,B,O)}cancelRunById(I){for(const B of this.tracked.values())if(B.id===I){B.dispose();return}}cancelAllRuns(){for(const I of this.tracked.values())I.dispose()}createTestRun(I,B,O,S,x){const N=this.tracked.get(O);if(N)return N.createRun(S);const V=i.fromPublic(I,B,O,x),$=n(O);this.proxy.$startedExtensionTestRun({controllerId:I,profile:$&&{group:E[$.kind],id:$.profileId},exclude:O.exclude?.map(ee=>ee.id)??[],id:V.id,include:O.include?.map(ee=>ee.id)??[B.root.id],persist:x});const z=this.getTracker(O,V);return z.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),z.createRun(S)}getTracker(I,B,O){const S=new a(B,this.proxy,O);return this.tracked.set(I,S),S.onEnd(()=>this.tracked.delete(I)),S}}e.TestRunCoordinator=P;const n=A=>{if(!!A.profile){if(!(A.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class i{constructor(I,B,O,S,x,N){this.controllerId=I,this.id=B,this.isPersisted=x,this.colllection=N,this.includePrefix=O.map(V=>V+"\0"),this.excludePrefix=S.map(V=>V+"\0")}static fromPublic(I,B,O,S){return new i(I,(0,_.generateUuid)(),O.include?.map(x=>l.TestId.fromExtHostTestItem(x,I).toString())??[I],O.exclude?.map(x=>l.TestId.fromExtHostTestItem(x,I).toString())??[],S,B)}static fromInternal(I,B){return new i(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,B)}isIncluded(I){const B=l.TestId.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(B===O||B.startsWith(O))return!1;for(const O of this.includePrefix)if(B===O||B.startsWith(O))return!0;return!1}}e.TestRunDto=i;class v{constructor(I,B,O){this.proxy=I,this.runId=B,this.taskId=O}set coverageProvider(I){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!I||(this._coverageProvider=I,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(I){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(I))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(I,B){const O=await this.fileCoverage;let S=O?.[I];return!this._coverageProvider||!O||!S?[]:(S.detailedCoverage||(S=O[I]=await this._coverageProvider.resolveFileCoverage?.(S,B)??S),S.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class g extends f.IncrementalChangeCollector{constructor(I){super();this.emitter=I,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(I){this.added.add(I)}update(I){Object.assign(I.revived,d.TestItem.toPlain(I.item)),this.added.has(I)||this.updated.add(I)}remove(I){if(this.added.has(I)){this.added.delete(I);return}if(this.updated.delete(I),I.parent&&this.alreadyRemoved.has(I.parent)){this.alreadyRemoved.add(I.item.extId);return}this.removed.add(I)}getChangeEvent(){const{added:I,updated:B,removed:O}=this;return{get added(){return[...I].map(S=>S.revived)},get updated(){return[...B].map(S=>S.revived)},get removed(){return[...O].map(S=>S.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends f.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(I){return this.items.get(I)}getMirroredTestDataByReference(I){return this.items.get(I.id)}createItem(I,B){return{...I,revived:d.TestItem.toPlain(I.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new g(this.changeEmitter)}}e.MirroredTestCollection=s;class b{constructor(I){this.proxy=I}checkout(){this.current||(this.current=this.createObserverData());const I=this.current;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(B=>B.revived)},dispose:(0,t.once)(()=>{--I.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(I){return this.current?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.current?.tests.apply(I)}createObserverData(){const I=new s;return this.proxy.$subscribeToDiffs(),{observers:0,tests:I}}}class u{constructor(I,B,O,S,x,N,V=!1,$=void 0){this.controllerId=B,this.profileId=O,this._label=S,this.kind=x,this.runHandler=N,this._isDefault=V,this._tag=$,h.set(this,void 0),Je(this,h,I,"f");const z=E[x];if(typeof z!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Ae(this,h,"f").$publishTestRunProfile({profileId:O,controllerId:B,tag:$?d.TestTag.namespace(this.controllerId,$.id):null,label:S,group:z,isDefault:V,hasConfigurationHandler:!1})}get label(){return this._label}set label(I){I!==this._label&&(this._label=I,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:I}))}get isDefault(){return this._isDefault}set isDefault(I){I!==this._isDefault&&(this._isDefault=I,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:I?d.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(I){I!==this._configureHandler&&(this._configureHandler=I,Ae(this,h,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!I}))}dispose(){Ae(this,h,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,h=new WeakMap;const E={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(we[206],Ee([0,1,3,16,5,93,8,6]),function(re,e,c,M,w,T,t,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(F,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new c.Emitter,this._onDidChangeTextEditorOptions=new c.Emitter,this._onDidChangeTextEditorVisibleRanges=new c.Emitter,this._onDidChangeTextEditorViewColumn=new c.Emitter,this._onDidChangeActiveTextEditor=new c.Emitter,this._onDidChangeVisibleTextEditors=new c.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(r=>this._onDidChangeVisibleTextEditors.fire(r)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(r=>this._onDidChangeActiveTextEditor.fire(r))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const _=this._extHostDocumentsAndEditors.allEditors();return F?_:_.map(r=>r.value)}async showTextDocument(F,_,r){let m;typeof _=="number"?m={position:t.ViewColumn.from(_),preserveFocus:r}:typeof _=="object"?m={position:t.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?t.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:m={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(F.uri,m),d=o&&this._extHostDocumentsAndEditors.getEditor(o);if(d)return d.value;throw o?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,_){return new T.TextEditorDecorationType(this._proxy,F,_).value}$acceptEditorPropertiesChanged(F,_){const r=this._extHostDocumentsAndEditors.getEditor(F);if(!r)throw new Error("unknown text editor");if(_.options&&r._acceptOptions(_.options),_.selections){const m=_.selections.selections.map(t.Selection.to);r._acceptSelections(m)}if(_.visibleRanges){const m=M.coalesce(_.visibleRanges.map(t.Range.to));r._acceptVisibleRanges(m)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:r.value,options:{..._.options,lineNumbers:t.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const m=R.TextEditorSelectionChangeKind.fromValue(_.selections.source),o=_.selections.selections.map(t.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:r.value,selections:o,kind:m})}if(_.visibleRanges){const m=M.coalesce(_.visibleRanges.map(t.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:r.value,visibleRanges:m})}}$acceptEditorPositionData(F){for(const _ in F){const r=this._extHostDocumentsAndEditors.getEditor(_);if(!r)throw new Error("Unknown text editor");const m=t.ViewColumn.to(F[_]);r.value.viewColumn!==m&&(r._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:r.value,viewColumn:m}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=C}),define(we[207],Ee([0,1,2,4,5,7,6]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class R{constructor(F,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(w.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===11){const m=r.uri===void 0?void 0:c.URI.revive(r.uri);return this._itemsBySourceAndUriMap.get(r.source)?.get(C(m))?.get(r.handle)}return r}})}async $getTimeline(F,_,r,m,o){return this._providers.get(F)?.provideTimeline(c.URI.revive(_),r,m,o)}registerTimelineProvider(F,_,r,m){const o=new T.DisposableStore,d=this.convertTimelineItem(_.id,m,o).bind(this);let p;_.onDidChange&&(p=_.onDidChange(f=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...f,id:_.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:F,onDidChange:void 0,async provideTimeline(f,l,h,y){y?.resetCache&&(o.clear(),D.get(_.id)?.clear());const a=await _.provideTimeline(f,l,h);if(a==null)return;const P=d(f,y);return{...a,source:_.id,items:a.items.map(P)}},dispose(){for(const f of D.values())f.get(_.id)?.clear();p?.dispose(),o.dispose()}})}convertTimelineItem(F,_,r){return(m,o)=>{let d;if(o?.cacheResults){let p=this._itemsBySourceAndUriMap.get(F);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(F,p));const D=C(m);d=p.get(D),d===void 0&&(d=new Map,p.set(D,d))}return p=>{const{iconPath:D,...f}=p,l=`${F}|${p.id??p.timestamp}`;d?.set(l,p);let h,y,a;return p.iconPath&&(D instanceof t.ThemeIcon?a={id:D.id,color:D.color}:c.URI.isUri(D)?(h=D,y=D):{light:h,dark:y}=D),{...f,id:f.id??void 0,handle:l,source:F,command:p.command?_.toInternal(p.command,r):void 0,icon:h,iconDark:y,themeIcon:a,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,T.toDisposable)(()=>{for(const r of this._itemsBySourceAndUriMap.values())r.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=R;function C(k){return k?.toString()}}),define(we[208],Ee([0,1,7,11,2,5]),function(re,e,c,M,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class t{constructor(C){this._openers=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,k,F,_){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const r=_.schemes.find(m=>!t.supportedSchemes.has(m));if(r)throw new Error(`Scheme '${r}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,F),this._proxy.$registerUriOpener(k,_.schemes,C,_.label),(0,c.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(C,k,F){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener with id: ${C}`);const r=w.URI.revive(k);return _.canOpenExternalUri(r,F)}async $openUri(C,k,F){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener id: '${C}'`);return _.openExternalUri(w.URI.revive(k.resolvedUri),{sourceUri:w.URI.revive(k.sourceUri)},F)}}e.ExtHostUriOpeners=t,t.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(we[209],Ee([0,1,5,2,7,15,26]),function(re,e,c,M,w,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(c.MainContext.MainThreadUrls)}registerUriHandler(k,F){if(this.handles.has(t.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const _=R.HandlePool++;return this.handles.add(t.ExtensionIdentifier.toKey(k)),this.handlers.set(_,F),this._proxy.$registerUriHandler(_,k),(0,w.toDisposable)(()=>{this.handles.delete(t.ExtensionIdentifier.toKey(k)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(k,F){const _=this.handlers.get(k);if(!_)return Promise.resolve(void 0);try{_.handleUri(M.URI.revive(F))}catch(r){(0,T.onUnexpectedError)(r)}return Promise.resolve(void 0)}async createAppUri(k){return M.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=R,R.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[51],Ee([0,1,3,11,2,136,156,67,5]),function(re,e,c,M,w,T,t,R,C){"use strict";var k,F,_,r,m,o,d,p,D,f,l,h;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class y{constructor(b,u,E,A,I,B,O){k.set(this,void 0),F.set(this,void 0),_.set(this,void 0),r.set(this,void 0),m.set(this,void 0),o.set(this,void 0),d.set(this,""),p.set(this,void 0),D.set(this,!1),f.set(this,!1),l.set(this,!1),this._onMessageEmitter=new c.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,h.set(this,new c.Emitter),this._onDidDispose=Ae(this,h,"f").event,Je(this,k,b,"f"),Je(this,F,u,"f"),Je(this,p,E,"f"),Je(this,r,A,"f"),Je(this,m,I,"f"),Je(this,o,B,"f"),Je(this,l,a(B),"f"),Je(this,_,O,"f")}dispose(){Je(this,D,!0,"f"),Ae(this,h,"f").fire(),Ae(this,h,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Je(this,f,!0,"f"),(0,R.asWebviewUri)(b,Ae(this,r,"f").remote)}get cspSource(){const b=Ae(this,o,"f").extensionLocation;if(b.scheme===M.Schemas.https||b.scheme===M.Schemas.http){let u=b.toString();return u.endsWith("/")||(u+="/"),u+" "+R.webviewGenericCspSource}return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,d,"f")}set html(b){this.assertNotDisposed(),Ae(this,d,"f")!==b&&(Je(this,d,b,"f"),!Ae(this,f,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Je(this,f,!0,"f"),Ae(this,_,"f").report("Webview vscode-resource: uris",Ae(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,F,"f").$setHtml(Ae(this,k,"f"),b))}get options(){return this.assertNotDisposed(),Ae(this,p,"f")}set options(b){this.assertNotDisposed(),Ae(this,F,"f").$setOptions(Ae(this,k,"f"),i(Ae(this,o,"f"),Ae(this,m,"f"),b)),Je(this,p,b,"f")}async postMessage(b){if(Ae(this,D,"f"))return!1;const u=(0,t.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Ae(this,l,"f")});return Ae(this,F,"f").$postMessage(Ae(this,k,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Ae(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=y,k=new WeakMap,F=new WeakMap,_=new WeakMap,r=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,p=new WeakMap,D=new WeakMap,f=new WeakMap,l=new WeakMap,h=new WeakMap;function a(s){try{const b=(0,T.normalizeVersion)((0,T.parseVersion)(s.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class P{constructor(b,u,E,A,I){this.initData=u,this.workspace=E,this._logService=A,this._deprecationService=I,this._webviews=new Map,this._webviewProxy=b.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(b,u,...E){const A=this.getWebview(b);if(A){const{message:I}=(0,t.deserializeWebviewMessage)(u,E);A._onMessageEmitter.fire(I)}}$onMissingCsp(b,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,u,E){const A=new y(b,this._webviewProxy,v(u),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(b,A),A._onDidDispose(()=>{this._webviews.delete(b)}),A}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=P;function n(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=n;function i(s,b,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||g(s,b)}}e.serializeWebviewOptions=i;function v(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(b=>w.URI.from(b))}}e.reviveOptions=v;function g(s,b){return[...(b?.getWorkspaceFolders()||[]).map(u=>u.uri),s.extensionLocation]}}),define(we[210],Ee([0,1,20,58,7,11,23,2,8,51,64,5,6]),function(re,e,c,M,w,T,t,R,C,k,F,_,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(a,P){this.document=a,this._storagePath=P,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,P){await this.getEdit(a).undo(),P||this.disposeBackup()}async redo(a,P){await this.getEdit(a).redo(),P||this.disposeBackup()}disposeEdits(a){for(const P of a)this._edits.delete(P)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=h(this.document.uri)+this._backupCounter++;return(0,t.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const P=this._edits.get(a,0);if(!P)throw new Error("No edit found");return P}}class o{constructor(){this._documents=new Map}get(a,P){return this._documents.get(this.key(a,P))}add(a,P,n){const i=this.key(a,P.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${a} resource:${P.uri}`);const v=new m(P,n);return this._documents.set(i,v),v}delete(a,P){const n=this.key(a,P.uri);this._documents.delete(n)}key(a,P){return`${a}@@@${P}`}}var d;(function(y){y[y.Text=0]="Text",y[y.Custom=1]="Custom"})(d||(d={}));class p{constructor(){this._providers=new Map}addTextProvider(a,P,n){return this.add(0,a,P,n)}addCustomProvider(a,P,n){return this.add(1,a,P,n)}get(a){return this._providers.get(a)}add(a,P,n,i){if(this._providers.has(P))throw new Error(`Provider for viewType:${P} already registered`);return this._providers.set(P,{type:a,extension:n,provider:i}),new r.Disposable(()=>this._providers.delete(P))}}class D{constructor(a,P,n,i,v){this._extHostDocuments=P,this._extensionStoragePaths=n,this._extHostWebview=i,this._extHostWebviewPanels=v,this._editorProviders=new p,this._documents=new o,this._proxy=a.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,P,n,i){const v=new w.DisposableStore;return f(n)?(v.add(this._editorProviders.addTextProvider(P,a,n)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(a),P,i.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(a))):(v.add(this._editorProviders.addCustomProvider(P,a,n)),this.supportEditing(n)&&v.add(n.onDidChangeCustomDocument(g=>{const s=this.getCustomDocumentEntry(P,g.document.uri);if(l(g)){const b=s.addEdit(g);this._proxy.$onDidEdit(g.document.uri,P,b,g.label)}else this._proxy.$onContentChange(g.document.uri,P)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(a),P,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(a))),r.Disposable.from(v,new r.Disposable(()=>{this._proxy.$unregisterEditorProvider(P)}))}async $createCustomDocument(a,P,n,i,v){const g=this._editorProviders.get(P);if(!g)throw new Error(`No provider found for '${P}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${P}'`);const s=R.URI.revive(a),b=await g.provider.openCustomDocument(s,{backupId:n,untitledDocumentData:i?.buffer},v);let u;return this.supportEditing(g.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(g.extension)??this._extensionStoragePaths.globalValue(g.extension)),this._documents.add(P,b,u),{editable:this.supportEditing(g.provider)}}async $disposeCustomDocument(a,P){const n=this._editorProviders.get(P);if(!n)throw new Error(`No provider found for '${P}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${P}'`);const i=R.URI.revive(a),{document:v}=this.getCustomDocumentEntry(P,i);this._documents.delete(P,v),v.dispose()}async $resolveWebviewEditor(a,P,n,i,v,g){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);const b=C.ViewColumn.to(v),u=this._extHostWebview.createNewWebview(P,i.webviewOptions,s.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(P,n,i.title,b,i.panelOptions,u),A=R.URI.revive(a);switch(s.type){case 1:{const{document:I}=this.getCustomDocumentEntry(n,A);return s.provider.resolveCustomEditor(I,E,g)}case 0:{const I=this._extHostDocuments.getDocument(A);return s.provider.resolveCustomTextEditor(I,E,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,P,n){this.getCustomDocumentEntry(P,a).disposeEdits(n)}async $onMoveCustomEditor(a,P,n){const i=this._editorProviders.get(n);if(!i)throw new Error(`No provider found for '${n}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const v=this._extHostWebviewPanels.getWebviewPanel(a);if(!v)throw new Error("No webview found");const g=R.URI.revive(P),s=this._extHostDocuments.getDocument(g);await i.provider.moveCustomTextEditor(s,v,c.CancellationToken.None)}async $undo(a,P,n,i){return this.getCustomDocumentEntry(P,a).undo(n,i)}async $redo(a,P,n,i){return this.getCustomDocumentEntry(P,a).redo(n,i)}async $revert(a,P,n){const i=this.getCustomDocumentEntry(P,a);await this.getCustomEditorProvider(P).revertCustomDocument(i.document,n),i.disposeBackup()}async $onSave(a,P,n){const i=this.getCustomDocumentEntry(P,a);await this.getCustomEditorProvider(P).saveCustomDocument(i.document,n),i.disposeBackup()}async $onSaveAs(a,P,n,i){const v=this.getCustomDocumentEntry(P,a);return this.getCustomEditorProvider(P).saveCustomDocumentAs(v.document,R.URI.revive(n),i)}async $backup(a,P,n){const i=this.getCustomDocumentEntry(P,a),g=await this.getCustomEditorProvider(P).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},n);return i.updateBackup(g),g.id}getCustomDocumentEntry(a,P){const n=this._documents.get(a,R.URI.revive(P));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(a){const n=this._editorProviders.get(a)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=D;function f(y){return typeof y.resolveCustomTextEditor=="function"}function l(y){return typeof y.undo=="function"&&typeof y.redo=="function"}function h(y){const a=y.scheme===T.Schemas.file||y.scheme===T.Schemas.untitled?y.fsPath:y.toString();return(0,M.hash)(a)+""}});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[211],Ee([0,1,3,7,2,36,8,51,5,6]),function(re,e,c,M,w,T,t,R,C,k){"use strict";var F,_,r,m,o,d,p,D,f,l,h,y,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class P extends M.Disposable{constructor(g,s,b,u,E,A,I){super();F.set(this,void 0),_.set(this,void 0),r.set(this,void 0),m.set(this,void 0),o.set(this,void 0),d.set(this,void 0),p.set(this,void 0),D.set(this,void 0),f.set(this,!0),l.set(this,!0),h.set(this,!1),y.set(this,this._register(new c.Emitter)),this.onDidDispose=Ae(this,y,"f").event,a.set(this,this._register(new c.Emitter)),this.onDidChangeViewState=Ae(this,a,"f").event,Je(this,F,g,"f"),Je(this,_,s,"f"),Je(this,r,b,"f"),Je(this,o,A,"f"),Je(this,D,E,"f"),Je(this,d,u,"f"),Je(this,m,I,"f")}dispose(){Ae(this,h,"f")||(Je(this,h,!0,"f"),Ae(this,y,"f").fire(),Ae(this,_,"f").$disposeWebview(Ae(this,F,"f")),Ae(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,m,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,r,"f")}get title(){return this.assertNotDisposed(),Ae(this,d,"f")}set title(g){this.assertNotDisposed(),Ae(this,d,"f")!==g&&(Je(this,d,g,"f"),Ae(this,_,"f").$setTitle(Ae(this,F,"f"),g))}get iconPath(){return this.assertNotDisposed(),Ae(this,p,"f")}set iconPath(g){this.assertNotDisposed(),Ae(this,p,"f")!==g&&(Je(this,p,g,"f"),Ae(this,_,"f").$setIconPath(Ae(this,F,"f"),w.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Ae(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,D,"f")=="number"&&Ae(this,D,"f")<0))return Ae(this,D,"f")}get active(){return this.assertNotDisposed(),Ae(this,l,"f")}get visible(){return this.assertNotDisposed(),Ae(this,f,"f")}_updateViewState(g){Ae(this,h,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(Je(this,l,g.active,"f"),Je(this,f,g.visible,"f"),Je(this,D,g.viewColumn,"f"),Ae(this,a,"f").fire({webviewPanel:this}))}reveal(g,s){this.assertNotDisposed(),Ae(this,_,"f").$reveal(Ae(this,F,"f"),{viewColumn:g?t.ViewColumn.from(g):void 0,preserveFocus:!!s})}assertNotDisposed(){if(Ae(this,h,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,_=new WeakMap,r=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,p=new WeakMap,D=new WeakMap,f=new WeakMap,l=new WeakMap,h=new WeakMap,y=new WeakMap,a=new WeakMap;class n{constructor(g,s,b){this.webviews=s,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(g,s,b,u,E={}){const A=typeof u=="object"?u.viewColumn:u,I={viewColumn:t.ViewColumn.from(A),preserveFocus:typeof u=="object"&&!!u.preserveFocus},B=(0,R.shouldSerializeBuffersForPostMessage)(g),O=n.newHandle();this._proxy.$createWebviewPanel((0,R.toExtensionData)(g),O,s,{title:b,panelOptions:i(E),webviewOptions:(0,R.serializeWebviewOptions)(g,this.workspace,E),serializeBuffersForPostMessage:B},I);const S=this.webviews.createNewWebview(O,E,g);return this.createNewWebviewPanel(O,s,b,A,E,S)}$onDidChangeWebviewPanelViewStates(g){const s=Object.keys(g);s.sort((b,u)=>{const E=g[b],A=g[u];return E.active?1:A.active?-1:+E.visible-+A.visible});for(const b of s){const u=this.getWebviewPanel(b);if(!u)continue;const E=g[b];u._updateViewState({active:E.active,visible:E.visible,viewColumn:t.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,s,b){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:b,extension:g}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(g)}),new k.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(g,s,b,u){const E=this._serializers.get(s);if(!E)throw new Error(`No serializer found for '${s}'`);const{serializer:A,extension:I}=E,B=this.webviews.createNewWebview(g,b.webviewOptions,I),O=this.createNewWebviewPanel(g,s,b.title,u,b.panelOptions,B);await A.deserializeWebviewPanel(O,b.state)}createNewWebviewPanel(g,s,b,u,E,A){const I=new P(g,this._proxy,s,b,u,E,A);return this._webviewPanels.set(g,I),I}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=n;function i(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[212],Ee([0,1,3,7,51,5,6]),function(re,e,c,M,w,T,t){"use strict";var R,C,k,F,_,r,m,o,d,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends M.Disposable{constructor(h,y,a,P,n,i){super();R.set(this,void 0),C.set(this,void 0),k.set(this,void 0),F.set(this,void 0),_.set(this,!1),r.set(this,void 0),m.set(this,void 0),o.set(this,void 0),d.set(this,this._register(new c.Emitter)),this.onDidChangeVisibility=Ae(this,d,"f").event,p.set(this,this._register(new c.Emitter)),this.onDidDispose=Ae(this,p,"f").event,Je(this,k,a,"f"),Je(this,m,P,"f"),Je(this,R,h,"f"),Je(this,C,y,"f"),Je(this,F,n,"f"),Je(this,r,i,"f")}dispose(){Ae(this,_,"f")||(Je(this,_,!0,"f"),Ae(this,p,"f").fire(),Ae(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,m,"f")}set title(h){this.assertNotDisposed(),Ae(this,m,"f")!==h&&(Je(this,m,h,"f"),Ae(this,C,"f").$setWebviewViewTitle(Ae(this,R,"f"),h))}get description(){return this.assertNotDisposed(),Ae(this,o,"f")}set description(h){this.assertNotDisposed(),Ae(this,o,"f")!==h&&(Je(this,o,h,"f"),Ae(this,C,"f").$setWebviewViewDescription(Ae(this,R,"f"),h))}get visible(){return Ae(this,r,"f")}get webview(){return Ae(this,F,"f")}get viewType(){return Ae(this,k,"f")}_setVisible(h){h===Ae(this,r,"f")||Ae(this,_,"f")||(Je(this,r,h,"f"),Ae(this,d,"f").fire())}show(h){this.assertNotDisposed(),Ae(this,C,"f").$show(Ae(this,R,"f"),!!h)}assertNotDisposed(){if(Ae(this,_,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,C=new WeakMap,k=new WeakMap,F=new WeakMap,_=new WeakMap,r=new WeakMap,m=new WeakMap,o=new WeakMap,d=new WeakMap,p=new WeakMap;class f{constructor(h,y){this._extHostWebview=y,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(h,y,a,P){if(this._viewProviders.has(y))throw new Error(`View provider for '${y}' already registered`);return this._viewProviders.set(y,{provider:a,extension:h}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(h),y,{retainContextWhenHidden:P?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new t.Disposable(()=>{this._viewProviders.delete(y),this._proxy.$unregisterWebviewViewProvider(y)})}async $resolveWebviewView(h,y,a,P,n){const i=this._viewProviders.get(y);if(!i)throw new Error(`No view provider found for '${y}'`);const{provider:v,extension:g}=i,s=this._extHostWebview.createNewWebview(h,{},g),b=new D(h,this._proxy,y,a,s,!0);this._webviewViews.set(h,b),await v.resolveWebviewView(b,{state:P},n)}async $onDidChangeWebviewViewVisibility(h,y){this.getWebviewView(h)._setVisible(y)}async $disposeWebviewView(h){const y=this.getWebviewView(h);this._webviewViews.delete(h),y.dispose(),this._extHostWebview.deleteWebview(h)}getWebviewView(h){const y=this._webviewViews.get(h);if(!y)throw new Error("No webview found");return y}}e.ExtHostWebviewViews=f}),define(we[96],Ee([0,1,3,5,2,11,9,4,13]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class zi{constructor(_){this._onDidChangeWindowState=new c.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=_.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(r=>this.$onDidChangeWindowFocus(r))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,r){let m;if(typeof _=="string"){m=_;try{_=w.URI.parse(_)}catch(o){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,t.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,m,r)}async asExternalUri(_,r){if((0,t.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(_,r);return w.URI.from(m)}};k.InitialState={focused:!0},k=Ue([Be(0,C.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(we[213],Ee([0,1,14,22,20,15,3,7,107,180,37]),function(re,e,c,M,w,T,t,R,C,k,F){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function r(E,A){try{return JSON.stringify(E,A)}catch(I){return"null"}}const m="$$ref$$",o={[m]:-1};class d{constructor(A,I){this.jsonString=A,this.referencedBuffers=I}}function p(E,A=null,I=!1){const B=[];return{jsonString:(I?r:JSON.stringify)(E,(S,x)=>{if(typeof x=="undefined")return o;if(typeof x=="object"){if(x instanceof M.VSBuffer){const N=B.push(x)-1;return{[m]:N}}if(A)return A(S,x)}return x}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=p;function D(E,A,I){return JSON.parse(E,(B,O)=>{if(O){const S=O[m];if(typeof S=="number")return A[S];if(I&&O.$mid===1)return I.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=D;function f(E,A){return JSON.stringify(E,A)}function l(E){return E?(A,I)=>I&&I.$mid===1?E.transformOutgoing(I):I:null}var h;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var y;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(y=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},P=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class i extends R.Disposable{constructor(A,I=null,B=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new t.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=I,this._uriTransformer=B,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,S=F.ProxyIdentifier.count;O<S;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new c.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{this._pendingRPCReplies[A].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,C.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:I,sid:B}=A;return this._proxies[I]||(this._proxies[I]=this._createProxy(I,B)),this._proxies[I]}_createProxy(A,I){let B={get:(O,S)=>(typeof S=="string"&&!O[S]&&S.charCodeAt(0)===36&&(O[S]=(...x)=>this._remoteCall(A,S,x)),S===n?I:O[S])};return new Proxy(Object.create(null),B)}set(A,I){return this._locals[A.nid]=I,I}assertRegistered(A){for(let I=0,B=A.length;I<B;I++){const O=A[I];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(A){if(this._isDisposed)return;const I=A.byteLength,B=v.read(A,0),O=B.readUInt8(),S=B.readUInt32();switch(O){case 1:case 2:{let{rpcId:x,method:N,args:V}=s.deserializeRequestJSONArgs(B);this._uriTransformer&&(V=(0,C.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(I,S,x,N,V,O===2);break}case 3:case 4:{let{rpcId:x,method:N,args:V}=s.deserializeRequestMixedArgs(B);this._uriTransformer&&(V=(0,C.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(I,S,x,N,V,O===4);break}case 5:{this._logger&&this._logger.logIncoming(I,S,0,"ack"),this._onDidReceiveAcknowledge(S);break}case 6:{this._receiveCancel(I,S);break}case 7:{this._receiveReply(I,S,void 0);break}case 9:{let x=s.deserializeReplyOKJSON(B);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(I,S,x);break}case 10:{const x=s.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(I,S,x);break}case 8:{let x=s.deserializeReplyOKVSBuffer(B);this._receiveReply(I,S,x);break}case 11:{let x=s.deserializeReplyErrError(B);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(I,S,x);break}case 12:{this._receiveReplyErr(I,S,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,I,B,O,S,x){this._logger&&this._logger.logIncoming(A,I,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(B)}.${O}(`,S);const N=String(I);let V,$;if(x){const ee=new w.CancellationTokenSource;S.push(ee.token),V=this._invokeHandler(B,O,S),$=()=>ee.cancel()}else V=this._invokeHandler(B,O,S),$=a;this._cancelInvokedHandlers[N]=$;const z=s.serializeAcknowledged(I);this._logger&&this._logger.logOutgoing(z.byteLength,I,1,"ack"),this._protocol.send(z),V.then(ee=>{delete this._cancelInvokedHandlers[N];const j=s.serializeReplyOK(I,ee,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,I,1,"reply:",ee),this._protocol.send(j)},ee=>{delete this._cancelInvokedHandlers[N];const j=s.serializeReplyErr(I,ee);this._logger&&this._logger.logOutgoing(j.byteLength,I,1,"replyErr:",ee),this._protocol.send(j)})}_receiveCancel(A,I){this._logger&&this._logger.logIncoming(A,I,1,"receiveCancel");const B=String(I);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(A,I,B){this._logger&&this._logger.logIncoming(A,I,0,"receiveReply:",B);const O=String(I);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const S=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],S.resolveOk(B)}_receiveReplyErr(A,I,B){this._logger&&this._logger.logIncoming(A,I,0,"receiveReplyErr:",B);const O=String(I);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const S=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let x;B&&(B.$isError?(x=new Error,x.name=B.name,x.message=B.message,x.stack=B.stack):x=B),S.resolveErr(x)}_invokeHandler(A,I,B){try{return Promise.resolve(this._doInvokeHandler(A,I,B))}catch(O){return Promise.reject(O)}}_doInvokeHandler(A,I,B){const O=this._locals[A];if(!O)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(A));let S=O[I];if(typeof S!="function")throw new Error("Unknown method "+I+" on actor "+(0,F.getStringIdentifierForProxy)(A));return S.apply(O,B)}_remoteCall(A,I,B){if(this._isDisposed)return Promise.reject(T.canceled());let O=null;if(B.length>0&&w.CancellationToken.isCancellationToken(B[B.length-1])&&(O=B.pop()),O&&O.isCancellationRequested)return Promise.reject(T.canceled());const S=s.serializeRequestArguments(B,this._uriReplacer),x=++this._lastMessageId,N=String(x),V=new k.LazyPromise;O&&O.onCancellationRequested(()=>{const z=s.serializeCancel(x);this._logger&&this._logger.logOutgoing(z.byteLength,x,0,"cancel"),this._protocol.send(s.serializeCancel(x))}),this._pendingRPCReplies[N]=V,this._onWillSendRequest(x);const $=s.serializeRequest(x,A,I,S,!!O);return this._logger&&this._logger.logOutgoing($.byteLength,x,0,`request: ${(0,F.getStringIdentifierForProxy)(A)}.${I}(`,B),this._protocol.send($),V}}e.RPCProtocol=i,_=P,i.UNRESPONSIVE_TIME=3*1e3;class v{constructor(A,I){this._buff=A,this._offset=I}static alloc(A,I,B){let O=new v(M.VSBuffer.alloc(B+1+4),0);return O.writeUInt8(A),O.writeUInt32(I),O}static read(A,I){return new v(A,I)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,B}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,B}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const I=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,I}static sizeMixedArray(A){let I=0;I+=1;for(let B=0,O=A.length;B<O;B++){const S=A[B];switch(I+=1,S.type){case 1:I+=this.sizeLongString(S.value);break;case 2:I+=this.sizeVSBuffer(S.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(S.value);for(let x=0;x<S.buffers.length;++x)I+=this.sizeVSBuffer(S.buffers[x]);break;case 4:break}}return I}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let I=0,B=A.length;I<B;I++){const O=A[I];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let S=0;S<O.buffers.length;++S)this.writeBuffer(O.buffers[S]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;let I=new Array(A);for(let B=0;B<A;B++)switch(this.readUInt8()){case 1:I[B]=this.readLongString();break;case 2:I[B]=this.readVSBuffer();break;case 3:const S=this.readUInt32(),x=this.readLongString(),N=[];for(let V=0;V<S;++V)N.push(this.readVSBuffer());I[B]=new F.SerializableObjectWithBuffers(D(x,N,null));break;case 4:I[B]=void 0;break}return I}}v.sizeUInt32=4;var g;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(g||(g={}));class s{static _useMixedArgSerialization(A){for(let I=0,B=A.length;I<B;I++)if(A[I]instanceof M.VSBuffer||A[I]instanceof F.SerializableObjectWithBuffers||typeof A[I]=="undefined")return!0;return!1}static serializeRequestArguments(A,I){if(this._useMixedArgSerialization(A)){const B=[];for(let O=0,S=A.length;O<S;O++){const x=A[O];if(x instanceof M.VSBuffer)B[O]={type:2,value:x};else if(typeof x=="undefined")B[O]={type:4};else if(x instanceof F.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:V}=p(x.value,I);B[O]={type:3,value:M.VSBuffer.fromString(N),buffers:V}}else B[O]={type:1,value:M.VSBuffer.fromString(f(x,I))}}return{type:1,args:B}}return{type:0,args:f(A,I)}}static serializeRequest(A,I,B,O,S){switch(O.type){case 0:return this._requestJSONArgs(A,I,B,O.args,S);case 1:return this._requestMixedArgs(A,I,B,O.args,S)}}static _requestJSONArgs(A,I,B,O,S){const x=M.VSBuffer.fromString(B),N=M.VSBuffer.fromString(O);let V=0;V+=v.sizeUInt8(),V+=v.sizeShortString(x),V+=v.sizeLongString(N);let $=v.alloc(S?2:1,A,V);return $.writeUInt8(I),$.writeShortString(x),$.writeLongString(N),$.buffer}static deserializeRequestJSONArgs(A){const I=A.readUInt8(),B=A.readShortString(),O=A.readLongString();return{rpcId:I,method:B,args:JSON.parse(O)}}static _requestMixedArgs(A,I,B,O,S){const x=M.VSBuffer.fromString(B);let N=0;N+=v.sizeUInt8(),N+=v.sizeShortString(x),N+=v.sizeMixedArray(O);let V=v.alloc(S?4:3,A,N);return V.writeUInt8(I),V.writeShortString(x),V.writeMixedArray(O),V.buffer}static deserializeRequestMixedArgs(A){const I=A.readUInt8(),B=A.readShortString(),O=A.readMixedArray(),S=new Array(O.length);for(let x=0,N=O.length;x<N;x++){const V=O[x];typeof V=="string"?S[x]=JSON.parse(V):S[x]=V}return{rpcId:I,method:B,args:S}}static serializeAcknowledged(A){return v.alloc(5,A,0).buffer}static serializeCancel(A){return v.alloc(6,A,0).buffer}static serializeReplyOK(A,I,B){if(typeof I=="undefined")return this._serializeReplyOKEmpty(A);if(I instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(A,I);if(I instanceof F.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:S}=p(I.value,B,!0);return this._serializeReplyOKJSONWithBuffers(A,O,S)}else return this._serializeReplyOKJSON(A,r(I,B))}static _serializeReplyOKEmpty(A){return v.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,I){let B=0;B+=v.sizeVSBuffer(I);let O=v.alloc(8,A,B);return O.writeVSBuffer(I),O.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,I){const B=M.VSBuffer.fromString(I);let O=0;O+=v.sizeLongString(B);let S=v.alloc(9,A,O);return S.writeLongString(B),S.buffer}static _serializeReplyOKJSONWithBuffers(A,I,B){const O=M.VSBuffer.fromString(I);let S=0;S+=v.sizeUInt32,S+=v.sizeLongString(O);for(const N of B)S+=v.sizeVSBuffer(N);let x=v.alloc(10,A,S);x.writeUInt32(B.length),x.writeLongString(O);for(const N of B)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(A){const I=A.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(A,I){const B=A.readUInt32(),O=A.readLongString(),S=[];for(let x=0;x<B;++x)S.push(A.readVSBuffer());return new F.SerializableObjectWithBuffers(D(O,S,I))}static serializeReplyErr(A,I){return I?this._serializeReplyErrEror(A,I):this._serializeReplyErrEmpty(A)}static _serializeReplyErrEror(A,I){const B=M.VSBuffer.fromString(r(T.transformErrorForSerialization(I),null));let O=0;O+=v.sizeLongString(B);let S=v.alloc(11,A,O);return S.writeLongString(B),S.buffer}static deserializeReplyErrError(A){const I=A.readLongString();return JSON.parse(I)}static _serializeReplyErrEmpty(A){return v.alloc(12,A,0).buffer}}var b;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var u;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(u||(u={}))}),define(we[214],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const c=function(T){const t=R=>{self.removeEventListener("message",t);const C=R.data;Object.defineProperties(self,{postMessage:{value(k,F){C.postMessage(k,F)}},onmessage:{get(){return C.onmessage},set(k){C.onmessage=k}}}),C.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",t)}.toString();class M extends EventTarget{constructor(T,t,R){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${c})('${t}'))`,k=new Blob([C],{type:"application/javascript"}),F=URL.createObjectURL(k),_=new MessageChannel,r=F,m={type:"_newWorker",id:r,port:_.port2,url:F,options:R};T(m,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:r};_.port1.postMessage(o),URL.revokeObjectURL(F),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(o){_.port1.onmessage=o}},onmessageerror:{get(){return _.port1.onmessageerror},set(o){_.port1.onmessageerror=o}}}),_.port1.addEventListener("messageerror",o=>{const d=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(d)}),_.port1.addEventListener("message",o=>{const d=new MessageEvent("message",{data:o.data});this.dispatchEvent(d)}),_.port1.start()}}e.NestedWorker=M}),define(we[215],Ee([0,1,4]),function(re,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,c.createDecorator)("remoteAgentService")}),define(we[216],Ee([0,1,11,17,24,2,4,62,47,175,215]),function(re,e,c,M,w,T,t,R,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,t.createDecorator)("pathService");let _=class Hi{constructor(m,o,d,p){this.localUserHome=m,this.remoteAgentService=o,this.environmentService=d,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||w.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome||m})()}get defaultUriScheme(){return Hi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return c.Schemas.vscodeRemote;const d=(0,R.getVirtualWorkspaceScheme)(o.getWorkspace());if(d)return d;const p=o.getWorkspace().folders[0];if(p)return p.uri.scheme;const D=o.getWorkspace().configuration;return D?D.scheme:c.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?M.win32:M.posix)}async fileURI(m){let o="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const p=m.indexOf("/",2);p===-1?(o=m.substring(2),m="/"):(o=m.substring(2,p),m=m.substring(p)||"/")}return T.URI.from({scheme:c.Schemas.file,authority:o,path:m,query:"",fragment:""})}};_=Ue([Be(1,F.IRemoteAgentService),Be(2,k.IWorkbenchEnvironmentService),Be(3,C.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(we[97],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class c{constructor(t,R){this.line=t,this.character=R}isBefore(t){return!1}isBeforeOrEqual(t){return!1}isAfter(t){return!1}isAfterOrEqual(t){return!1}isEqual(t){return!1}compareTo(t){return 0}translate(t,R){return new c(0,0)}with(t){return new c(0,0)}}e.Position=c;class M{constructor(t,R,C,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new c(t,R),this.end=new c(C,k)}contains(t){return!1}isEqual(t){return!1}intersection(t){}union(t){return new M(0,0,0,0)}with(t){return new M(0,0,0,0)}}e.Range=M;var w;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[40],Ee([0,1,16,29,25,42,9,4,17,15,97,10]),function(re,e,c,M,w,T,t,R,C,k,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const r="\u27EA ",m=" characters skipped \u27EB",o=(r.length+m.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var d;(function(z){z[z.file=0]="file",z[z.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var p;(function(z){z[z.File=1]="File",z[z.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function D(z){return!!z.preview}e.resultIsMatch=D;function f(z){return!!z.resource}e.isFileMatch=f;function l(z){return!!z.message}e.isProgressMessage=l;var h;(function(z){z[z.Normal=0]="Normal",z[z.NewSearchStarted=1]="NewSearchStarted"})(h=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class y{constructor(ee){this.resource=ee,this.results=[]}}e.FileMatch=y;class a{constructor(ee,j,Q){this.ranges=j;const ce=Array.isArray(j)?j:[j];if(Q&&Q.matchLines===1&&P(ce)){ee=(0,t.getNLines)(ee,Q.matchLines);let ve="",ue=0,Fe=0;const Ke=Math.floor(Q.charsPerLine/5),Oe=[];for(const We of ce){const Xe=Math.max(We.startColumn-Ke,0),Ye=We.startColumn+Q.charsPerLine;if(Xe>Fe+Ke+o){const Qe=r+(Xe-Fe)+m;ve+=Qe+ee.slice(Xe,Ye),ue+=Xe-(Fe+Qe.length)}else ve+=ee.slice(Fe,Ye);Oe.push(new i(0,We.startColumn-ue,We.endColumn-ue)),Fe=Ye}this.preview={text:ve,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const ve=Array.isArray(j)?j[0].startLineNumber:j.startLineNumber;this.preview={text:ee,matches:(0,c.mapArrayOrNot)(j,ue=>new n(ue.startLineNumber-ve,ue.startColumn,ue.endLineNumber-ve,ue.endColumn))}}}}e.TextSearchMatch=a;function P(z){const ee=z[0].startLineNumber;for(const j of z)if(j.startLineNumber!==ee||j.endLineNumber!==ee)return!1;return!0}class n{constructor(ee,j,Q,ce){this.startLineNumber=ee,this.startColumn=j,this.endLineNumber=Q,this.endColumn=ce}}e.SearchRange=n;class i extends n{constructor(ee,j,Q){super(ee,j,ee,Q)}}e.OneLineRange=i;var v;(function(z){z.Default="default",z.FileNames="fileNames",z.Type="type",z.Modified="modified",z.CountDescending="countDescending",z.CountAscending="countAscending"})(v=e.SearchSortOrder||(e.SearchSortOrder={}));function g(z,ee=!0){const j=z&&z.files&&z.files.exclude,Q=ee&&z&&z.search&&z.search.exclude;if(!j&&!Q)return;if(!j||!Q)return j||Q;let ce=Object.create(null);return ce=w.mixin(ce,w.deepClone(j)),ce=w.mixin(ce,w.deepClone(Q),!0),ce}e.getExcludes=g;function s(z,ee){return z.excludePattern&&M.match(z.excludePattern,ee)?!1:z.includePattern||z.usingSearchPaths?z.includePattern&&M.match(z.includePattern,ee)?!0:z.usingSearchPaths?!!z.folderQueries&&z.folderQueries.some(j=>{const Q=j.folder.fsPath;if(T.isEqualOrParent(ee,Q)){const ce=C.relative(Q,ee);return!j.includePattern||!!M.match(j.includePattern,ce)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var b;(function(z){z[z.unknownEncoding=1]="unknownEncoding",z[z.regexParseError=2]="regexParseError",z[z.globParseError=3]="globParseError",z[z.invalidLiteral=4]="invalidLiteral",z[z.rgProcessError=5]="rgProcessError",z[z.other=6]="other",z[z.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(ee,j){super(ee);this.code=j}}e.SearchError=u;function E(z){const ee=z.message;if((0,k.isPromiseCanceledError)(z))return new u(ee,b.canceled);try{const j=JSON.parse(ee);return new u(j.message,j.code)}catch(j){return new u(ee,b.other)}}e.deserializeSearchError=E;function A(z){const ee={message:z.message,code:z.code};return new Error(JSON.stringify(ee))}e.serializeSearchError=A;function I(z){return z.type==="error"?!0:z.type==="success"}e.isSerializedSearchComplete=I;function B(z){return z.type==="success"}e.isSerializedSearchSuccess=B;function O(z){return!!z.path}e.isSerializedFileMatch=O;function S(z,ee){const j=z.searchPath?z.searchPath:z.relativePath;return(0,t.fuzzyContains)(j,ee)}e.isFilePatternMatch=S;class x{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N(z,ee){const j={...z||{},...ee||{}};return Object.keys(j).filter(Q=>{const ce=j[Q];return typeof ce=="boolean"&&ce})}e.resolvePatternsForProvider=N;class V{constructor(ee,j){this._parsedIncludeExpression=null,this._excludeExpression={...ee.excludePattern||{},...j.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let Q=ee.includePattern;j.includePattern&&(Q?Q={...Q,...j.includePattern}:Q=j.includePattern),Q&&(this._parsedIncludeExpression=M.parse(Q))}matchesExcludesSync(ee,j,Q){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ee,j,Q))}includedInQuerySync(ee,j,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ee,j,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ee,j,Q))}includedInQuery(ee,j,Q){const ce=this._parsedExcludeExpression(ee,j,Q),ve=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ee,j,Q):!0;return(0,_.isPromise)(ce)?ce.then(ue=>ue?!1:ve()):ve()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=V;function $(z){for(const ee in z)if(typeof z[ee]!="boolean")return!0;return!1}}),define(we[32],Ee([0,1,16,14,20,3,21,11,76,23,9,10,2,129,4,12,142,47,31,28,13,6,40,5]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f,l,h,y,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(A,I,B){return new k.ExtUri(O=>s(O,B)).isEqual(A,I)}function i(A,I,B){return n(A.uri,I.uri,B)?0:(0,F.compare)(A.uri.toString(),I.uri.toString())}function v(A,I,B){return A.index!==I.index?A.index<I.index?-1:1:n(A.uri,I.uri,B)?(0,F.compare)(A.name,I.name):(0,F.compare)(A.uri.toString(),I.uri.toString())}function g(A,I,B,O){const S=A.slice(0).sort((N,V)=>B(N,V,O)),x=I.slice(0).sort((N,V)=>B(N,V,O));return(0,c.delta)(S,x,(N,V)=>B(N,V,O))}function s(A,I){const B=I.getCapabilities(A.scheme);return!(B&&B&1024)}class b extends D.Workspace{constructor(I,B,O,S,x,N,V){super(I,O.map($=>new D.WorkspaceFolder($)),S,x,V);this._name=B,this._isUntitled=N,this._workspaceFolders=[],this._structure=t.TernarySearchTree.forUris(V),O.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(I,B,O,S){if(!I)return{workspace:null,added:[],removed:[]};const{id:x,name:N,folders:V,configuration:$,transient:z,isUntitled:ee}=I,j=[],Q=B;B?V.forEach((Fe,Ke)=>{const Oe=r.URI.revive(Fe.uri),We=b._findFolder(O||B,Oe,S);We?(We.name=Fe.name,We.index=Fe.index,j.push(We)):j.push({uri:Oe,name:Fe.name,index:Ke})}):j.push(...V.map(({uri:Fe,name:Ke,index:Oe})=>({uri:r.URI.revive(Fe),name:Ke,index:Oe}))),j.sort((Fe,Ke)=>Fe.index<Ke.index?-1:1);const ce=new b(x,N,j,!!z,$?r.URI.revive($):null,!!ee,Fe=>s(Fe,S)),{added:ve,removed:ue}=g(Q?Q.workspaceFolders:[],ce.workspaceFolders,i,S);return{workspace:ce,added:ve,removed:ue}}static _findFolder(I,B,O){for(let S=0;S<I.folders.length;S++){const x=I.workspaceFolders[S];if(n(x.uri,B,O))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(I,B){return B&&this._structure.get(I)&&(I=(0,k.dirname)(I)),this._structure.findSubstr(I)}resolveWorkspaceFolder(I){return this._structure.get(I)}}let u=class{constructor(I,B,O,S){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=S,this._extHostFileSystemInfo=O,this._requestIdProvider=new C.Counter,this._barrier=new M.Barrier,this._proxy=I.getProxy(P.MainContext.MainThreadWorkspace),this._messageService=I.getProxy(P.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new b(x.id,x.name,[],!!x.transient,x.configuration?r.URI.revive(x.configuration):null,!!x.isUntitled,N=>s(N,O)):void 0}$initializeWorkspace(I,B){this._trusted=B,this.$acceptWorkspaceData(I),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?r.URI.from({scheme:R.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(I,B,O,...S){const x=[];if(Array.isArray(S)&&S.forEach(ee=>{r.URI.isUri(ee.uri)&&!x.some(j=>n(j.uri,ee.uri,this._extHostFileSystemInfo))&&x.push({uri:ee.uri,name:ee.name||(0,k.basenameOrAuthority)(ee.uri)})}),this._unconfirmedWorkspace||[B,O].some(ee=>typeof ee!="number"||ee<0)||O===0&&x.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+O>N.length)return!1;const V=N.slice(0);V.splice(B,O,...x.map(ee=>({uri:ee.uri,name:ee.name||(0,k.basenameOrAuthority)(ee.uri),index:void 0})));for(let ee=0;ee<V.length;ee++){const j=V[ee];if(V.some((Q,ce)=>ce!==ee&&n(j.uri,Q.uri,this._extHostFileSystemInfo)))return!1}V.forEach((ee,j)=>ee.index=j);const{added:$,removed:z}=g(N,V,v,this._extHostFileSystemInfo);if($.length===0&&z.length===0)return!1;if(this._proxy){const ee=I.displayName||I.name;this._proxy.$updateWorkspaceFolders(ee,B,O,x).then(void 0,j=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,m.localize)(0,null,ee,j.toString()),{extension:I},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(I,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,B)}async getWorkspaceFolder2(I,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(I,B)}async resolveWorkspaceFolder(I){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(I)}getPath(){if(!this._actualWorkspace)return;const{folders:I}=this._actualWorkspace;if(I.length!==0)return I[0].uri.fsPath}getRelativePath(I,B){let O,S="";if(typeof I=="string"?(O=r.URI.file(I),S=I):typeof I!="undefined"&&(O=I,S=I.fsPath),!O)return S;const x=this.getWorkspaceFolder(O,!0);if(!x)return S;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let N=(0,k.relativePath)(x.uri,O);return B&&x.name&&(N=`${x.name}/${N}`),N}trySetWorkspaceFolders(I){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:I,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(I){const{workspace:B,added:O,removed:S}=b.toExtHostWorkspace(I,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:S}))}findFiles(I,B,O,S,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${S.value}, entryPoint: findFiles`);let N;if(B===null?N=!1:B&&(typeof B=="string"?N=B:N=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:$}=E(I);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(V),(0,_.withUndefinedAsNull)($),(0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)(O),x).then(z=>Array.isArray(z)?z.map(ee=>r.URI.revive(ee)):[])}async findTextInFiles(I,B,O,S,x=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${S.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),V=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:$,folder:z}=E(B.include),ee=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,j={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:V,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:$,excludePattern:ee},Q=!1;if(this._activeSearchCallbacks[N]=ce=>{if(Q)return;const ve=r.URI.revive(ce.resource);ce.results.forEach(ue=>{(0,a.resultIsMatch)(ue)?O({uri:ve,preview:{text:ue.preview.text,matches:(0,c.mapArrayOrNot)(ue.preview.matches,Fe=>new y.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))},ranges:(0,c.mapArrayOrNot)(ue.ranges,Fe=>new y.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))}):O({uri:ve,text:ue.text,lineNumber:ue.lineNumber})})},x.isCancellationRequested)return{};try{const ce=await this._proxy.$startTextSearch(I,(0,_.withUndefinedAsNull)(z),j,N,x);return delete this._activeSearchCallbacks[N],ce||{}}catch(ce){throw delete this._activeSearchCallbacks[N],ce}}$handleTextSearchResult(I,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](I)}saveAll(I){return this._proxy.$saveAll(I)}resolveProxy(I){return this._proxy.$resolveProxy(I)}get trusted(){return this._trusted}requestWorkspaceTrust(I){return this._proxy.$requestWorkspaceTrust(I)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=Ue([Be(0,h.IExtHostRpcService),Be(1,l.IExtHostInitDataService),Be(2,f.IExtHostFileSystemInfo),Be(3,d.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function E(A){let I,B;return A&&(typeof A=="string"?I=A:(I=A.pattern,B=A.baseFolder||r.URI.file(A.base))),{includePattern:I,folder:B}}}),define(we[33],Ee([0,1,25,3,32,5,6,146,61,10,14,4,13,12,2]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(P,n){if(n){const i=n.split(".");let v=P;for(let g=0;v&&g<i.length;g++)v=v[i[g]];return v}}function p(P){return P instanceof o.URI}function D(P){return P&&P.uri instanceof o.URI&&P.languageId&&typeof P.languageId=="string"}function f(P){return P&&!P.uri&&P.languageId&&typeof P.languageId=="string"}function l(P){return P&&P.uri instanceof o.URI&&(!P.name||typeof P.name=="string")&&(!P.index||typeof P.index=="number")}function h(P){if(p(P))return{resource:P};if(D(P))return{resource:P.uri,overrideIdentifier:P.languageId};if(f(P))return{overrideIdentifier:P.languageId};if(l(P))return{resource:P.uri};if(P===null)return{resource:null}}let y=class{constructor(n,i,v){this._proxy=n.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=v,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new a(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,i){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(n,i))}};y=Ue([Be(0,r.IExtHostRpcService),Be(1,w.IExtHostWorkspace),Be(2,m.ILogService)],y),e.ExtHostConfiguration=y;class a{constructor(n,i,v,g){this._onDidChangeConfiguration=new M.Emitter,this._proxy=n,this._logService=g,this._extHostWorkspace=i,this._configuration=R.Configuration.parse(v),this._configurationScopes=this._toMap(v.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,i){const v={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=R.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,v))}getConfiguration(n,i,v){const g=h(i)||{},s=this._toReadonlyValue(n?d(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,g,v?.identifier);function b(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case t.ConfigurationTarget.Global:return 1;case t.ConfigurationTarget.Workspace:return 4;case t.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(E){return typeof d(s,E)!="undefined"},get:(E,A)=>{this._validateConfigurationAccess(n?`${n}.${E}`:E,g,v?.identifier);let I=d(s,E);if(typeof I=="undefined")I=A;else{let B;const O=(S,x)=>{let N;const V=()=>{B=B||(0,c.deepClone)(s),N=N||d(B,x)};return(0,k.isObject)(S)?new Proxy(S,{get:($,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return V(),()=>N;if(B)return N=N||d(B,x),N[z];const ee=$[z];return typeof z=="string"?O(ee,`${x}.${z}`):ee},set:($,z,ee)=>(V(),N&&(N[z]=ee),!0),deleteProperty:($,z)=>(V(),N&&delete N[z],!0),defineProperty:($,z,ee)=>(V(),N&&Object.defineProperty(N,z,ee),!0)}):S};I=O(I,E)}return I},update:(E,A,I,B)=>{E=n?`${n}.${E}`:E;const O=b(I);return A!==void 0?this._proxy.$updateConfigurationOption(O,E,A,g,B):this._proxy.$removeConfigurationOption(O,E,g,B)},inspect:E=>{E=n?`${n}.${E}`:E;const A=(0,c.deepClone)(this._configuration.inspect(E,g,this._extHostWorkspace.workspace));if(A)return{key:E,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof s=="object"&&(0,c.mixin)(u,s,!1),Object.freeze(u)}_toReadonlyValue(n){const i=v=>(0,k.isObject)(v)?new Proxy(v,{get:(g,s)=>i(g[s]),set:(g,s,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(g,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(g,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return i(n)}_validateConfigurationAccess(n,i,v){const g=C.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),s=v?`[${v.value}] `:"";if(g===4){typeof i?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){i?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,i){const v=new R.ConfigurationChangeEvent(n,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,s)=>v.affectsConfiguration(g,h(s))})}_toMap(n){return n.reduce((i,v)=>(i.set(v[0],v[1]),i),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[98],Ee([0,1,2,14,3,5,6,32,49,33,20,39,13,28,4,11,24,12,70,165,15]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f,l,h){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(x){function N($){if($!=null)return $}x.from=N;function V($){if($!=null)return $}x.to=V})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var P;(function(x){function N($){if($!=null)return $}x.from=N;function V($){if($!=null)return $}x.to=V})(P=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(x){function N($){if($!=null)return $}x.from=N;function V($){if($!=null)return $}x.to=V})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(x){function N(z){if(z){const ee=z;return ee&&!!ee.process}else return!1}x.is=N;function V(z){if(z==null)return;const ee={process:z.process,args:z.args};return z.options&&(ee.options=n.from(z.options)),ee}x.from=V;function $(z){if(z!=null)return new t.ProcessExecution(z.process,z.args,z.options)}x.to=$})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var v;(function(x){function N($){if($!=null)return $}x.from=N;function V($){if($!=null)return $}x.to=V})(v=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(x){function N(z){if(z){const ee=z;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}x.is=N;function V(z){if(z==null)return;const ee={};return z.commandLine!==void 0?ee.commandLine=z.commandLine:(ee.command=z.command,ee.args=z.args),z.options&&(ee.options=v.from(z.options)),ee}x.from=V;function $(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new t.ShellExecution(z.commandLine,z.options):new t.ShellExecution(z.command,z.args?z.args:[],z.options)}x.to=$})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(x){function N(z){if(z){let ee=z;return ee&&ee.customExecution==="customExecution"}else return!1}x.is=N;function V(z){return{customExecution:"customExecution"}}x.from=V;function $(z,ee){return ee.get(z)}x.to=$})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(x){function N(V,$){let z;return V.scope!==void 0&&typeof V.scope!="number"?z=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===t.TaskScope.Workspace&&$&&$.workspaceFile?z=$.workspaceFile:z=l.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:z}}x.from=N})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(x){function N(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}x.from=N})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(x){function N(z,ee){if(z==null)return[];const j=[];for(let Q of z){const ce=V(Q,ee);ce&&j.push(ce)}return j}x.fromMany=N;function V(z,ee){if(z==null)return;let j;z.execution instanceof t.ProcessExecution?j=i.from(z.execution):z.execution instanceof t.ShellExecution?j=g.from(z.execution):z.execution&&z.execution instanceof t.CustomExecution&&(j=s.from(z.execution));const Q=a.from(z.definition);let ce;return z.scope?typeof z.scope=="number"?ce=z.scope:ce=z.scope.uri:ce=t.TaskScope.Workspace,!Q||!ce?void 0:{_id:z._id,definition:Q,name:z.name,source:{extensionId:ee.identifier.value,label:z.source,scope:ce},execution:j,isBackground:z.isBackground,group:u.from(z.group),presentationOptions:P.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}x.from=V;async function $(z,ee,j){if(z==null)return;let Q;i.is(z.execution)?Q=i.to(z.execution):g.is(z.execution)?Q=g.to(z.execution):s.is(z.execution)&&(Q=s.to(z._id,j));const ce=a.to(z.definition);let ve;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?ve=z.source.scope:ve=await ee.resolveWorkspaceFolder(c.URI.revive(z.source.scope)):ve=t.TaskScope.Workspace),!ce||!ve)return;const ue=new t.Task(ce,ve,z.name,z.source.label,Q,z.problemMatchers);return z.isBackground!==void 0&&(ue.isBackground=z.isBackground),z.group!==void 0&&(ue.group=t.TaskGroup.from(z.group._id),ue.group&&z.group.isDefault&&(ue.group=new t.TaskGroup(ue.group.id,ue.group.label),z.group.isDefault&&(ue.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ue.presentationOptions=P.to(z.presentationOptions)),z._id&&(ue._id=z._id),z.detail&&(ue.detail=z.detail),ue}x.to=$})(E=e.TaskDTO||(e.TaskDTO={}));var A;(function(x){function N($){return $}x.from=N;function V($){if(!!$)return Object.assign(Object.create(null),$)}x.to=V})(A=e.TaskFilterDTO||(e.TaskFilterDTO={}));class I{constructor(N,V,$){this._id=V,this._task=$,y.set(this,void 0),Je(this,y,N,"f")}get task(){return this._task}terminate(){Ae(this,y,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}y=new WeakMap;var B;(function(x){function N(V){return{id:V._id,task:void 0}}x.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor(N,V,$,z,ee,j,Q,ce){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=N.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=z,this._configurationService=ee,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=ce,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,V,$){if(!$)return new t.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:V,provider:$,extension:N}),this._proxy.$registerTaskProvider(z,V),new t.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(N,V){this._proxy.$registerTaskSystem(N,V)}fetchTasks(N){return this._proxy.$fetchTasks(A.from(N)).then(async V=>{const $=[];for(let z of V){const ee=await E.to(z,this._workspaceProvider,this._providedCustomExecutions2);ee&&$.push(ee)}return $})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(V=>N.push(V)),N}terminateTask(N){if(!(N instanceof I))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,V,$){const z=this._providedCustomExecutions2.get(N.id);z&&(this._activeCustomExecutions2.set(N.id,z),this._terminalService.attachPtyToTerminal(V,await z.callback($))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const V=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:V,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:N.exitCode})}$provideTasks(N,V){const $=this._handlers.get(N);if(!$)return Promise.reject(new Error("no handler found"));const z=[],ee=(0,M.asPromise)(()=>$.provider.provideTasks(F.CancellationToken.None)).then(j=>this.provideTasksInternal(V,z,$,j));return new Promise(j=>{ee.then(Q=>{Promise.all(z).then(()=>{j(Q)})})})}async $resolveTask(N,V){const $=this._handlers.get(N);if(!$)return Promise.reject(new Error("no handler found"));if(V.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${$.type}].`);const z=await E.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const ee=await $.provider.resolveTask(z,F.CancellationToken.None);if(!ee)return;this.checkDeprecation(ee,$);const j=E.from(ee,$.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(j.execution)&&await this.addCustomExecution(j,ee,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,V,$){const z=await this._proxy.$createTaskId(N);!$&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,V.execution)),this._providedCustomExecutions2.set(z,V.execution)}async getTaskExecution(N,V){if(typeof N=="string"){const ee=this._taskExecutionPromises.get(N);if(!ee)throw new Error("Unexpected: The specified task is missing an execution");return ee}let $=this._taskExecutionPromises.get(N.id);if($)return $;const z=new Promise((ee,j)=>{function Q(ce,ve,ue){ue?ee(new I(ce,ve.id,ue)):j("Unexpected: Task does not exist.")}V?Q(this,N,V):E.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(ce=>Q(this,N,ce))});return this._taskExecutionPromises.set(N.id,z),z.then(ee=>(this._taskExecutions.set(N.id,ee),ee),ee=>Promise.reject(ee))}checkDeprecation(N,V){N._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let $=this._notProvidedCustomExecutions.values(),z=$.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=$.next()}};O=Ue([Be(0,r.IExtHostRpcService),Be(1,m.IExtHostInitDataService),Be(2,R.IExtHostWorkspace),Be(3,C.IExtHostDocumentsAndEditors),Be(4,k.IExtHostConfiguration),Be(5,_.IExtHostTerminalService),Be(6,D.ILogService),Be(7,f.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let S=class extends O{constructor(N,V,$,z,ee,j,Q,ce){super(N,V,$,z,ee,j,Q,ce);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(N,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const $=E.from(V,N);if($===void 0)throw new Error("Task is not valid");if(s.is($.execution))await this.addCustomExecution($,V,!1);else throw new h.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution($),V);return this._proxy.$executeTask($).catch(ee=>{throw new Error(ee)}),z}provideTasksInternal(N,V,$,z){const ee=[];if(z)for(let j of z){this.checkDeprecation(j,$),(!j.definition||!N[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=E.from(j,$.extension);Q&&s.is(Q.execution)?(ee.push(Q),V.push(this.addCustomExecution(Q,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:$.extension}}async resolveTaskInternal(N){if(s.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,V,$){}};S=Ue([Be(0,r.IExtHostRpcService),Be(1,m.IExtHostInitDataService),Be(2,R.IExtHostWorkspace),Be(3,C.IExtHostDocumentsAndEditors),Be(4,k.IExtHostConfiguration),Be(5,_.IExtHostTerminalService),Be(6,D.ILogService),Be(7,f.IExtHostApiDeprecationService)],S),e.WorkerExtHostTask=S,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(we[217],Ee([0,1,16,75,29,78,21,11,17,23,9,10,2,109,132,84,47,91,216,40]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let h=class{constructor(b,u,E,A){this.configurationService=b,this.workspaceContextService=u,this.editorGroupsService=E,this.pathService=A}text(b,u,E={}){b=this.getContentPattern(b,E);const A=this.configurationService.getValue(),I=u&&u.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(u?.map(p.toWorkspaceFolder),E),type:2,contentPattern:b,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:A.search.usePCRE2||I||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(b,u){const E=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const A={...b,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(b,u)&&(A.isCaseSensitive=!0),this.isMultiline(b)&&(A.isMultiline=!0),A}file(b,u={}){return{...this.commonQuery(b,u),type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey}}handleIncludeExclude(b,u){return b?(b=Array.isArray(b)?b.map(i):i(b),u?this.parseSearchPaths(b):{pattern:a(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],u={}){const E=this.handleIncludeExclude(u.includePattern,u.expandPatterns),A=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),I=b.length>1,B=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,u,A)):b.map(x=>this.getFolderQueryForRoot(x,u,A,I))).filter(x=>!!x),O={_reason:u._reason,folderQueries:B,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:A.pattern,includePattern:E.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const N=c.coalesce(c.flatten(this.editorGroupsService.groups.map($=>$.editors.map(z=>z.resource)))).filter($=>(0,l.pathIncludedInQuery)(O,$.fsPath)),V=this.commonQueryFromFileList(N);return{...O,...V}}const S=u.extraFileResources&&u.extraFileResources.filter(x=>(0,l.pathIncludedInQuery)(O,x.fsPath));return O.extraFileResources=S&&S.length?S:void 0,O}commonQueryFromFileList(b){const u=[],E=new t.ResourceMap,A={};let I=!1;return b.forEach(B=>{if(B.scheme===R.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(B)){const S=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:C.dirname(B.fsPath)});let x=E.get(S);x||(I=!0,x={folder:S,includePattern:{}},u.push(x),E.set(S,x));const N=C.relative(S.fsPath,B.fsPath);(0,_.assertIsDefined)(x.includePattern)[N.replace(/\\/g,"/")]=!0}else B.fsPath&&(I=!0,A[B.fsPath]=!0)}),{folderQueries:u,includePattern:A,usingSearchPaths:!0,excludePattern:I?void 0:{"**/*":!0}}}isCaseSensitive(b,u){if(u.isSmartCase){if(b.isRegExp){if(F.containsUppercaseCharacter(b.pattern,!0))return!0}else if(F.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,m.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const u=V=>C.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),A=(Array.isArray(b)?b:P(b)).map(V=>{const $=this.pathService.resolvedUserHome;return $?(0,T.untildify)(V,$.scheme===R.Schemas.file?$.fsPath:$.path):V}),I=M.groupBy(A,V=>u(V)?"searchPaths":"exprSegments"),B=(I.exprSegments||[]).map(V=>F.rtrim(V,"/")).map(V=>F.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),n(V))),O={},S=this.expandSearchPathPatterns(I.searchPaths||[]);S&&S.length&&(O.searchPaths=S);const x=c.flatten(B),N=a(...x);return N&&(O.pattern=N),O}getExcludesForFolder(b,u){return u.disregardExcludeSettings?void 0:(0,l.getExcludes)(b,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const u=c.flatten(b.map(A=>{let{pathPortion:I,globPortion:B}=y(A);B&&(B=v(B));const O=this.expandOneSearchPath(I);return c.flatten(O.map(S=>this.resolveOneSearchPathPattern(S,B)))})),E=new Map;return u.forEach(A=>{const I=A.searchPath.toString(),B=E.get(I);B?A.pattern&&(B.pattern=B.pattern||{},B.pattern[A.pattern]=!0):E.set(I,{searchPath:A.searchPath,pattern:A.pattern?a(A.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(b){if(C.isAbsolute(b)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==R.Schemas.file?[{searchPath:u[0].uri.with({path:b})}]:[{searchPath:r.URI.file(C.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const A=C.posix.resolve(u.path,b);return[{searchPath:u.with({path:A})}]}const E=v(b);return[{searchPath:u,pattern:E}]}else{if(b==="./"||b===".\\")return[];{const u=b.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(I=>{const B=u.match(new RegExp(`^${F.escapeRegExpCharacters(I.name)}(?:/(.*)|$)`));return B?{match:B,folder:I}:null}).filter(_.isDefined);if(A.length)return A.map(I=>{const B=I.match[1];return{searchPath:I.folder.uri,pattern:B&&v(B)}});{const I=b.match(/\.[\/\\](.+)[\/\\]?/),B=I?I[1]:b,O=o.localize(0,null,B);throw new Error(O)}}}}resolveOneSearchPathPattern(b,u){const E=b.pattern&&u?`${b.pattern}/${u}`:b.pattern||u,A=[{searchPath:b.searchPath,pattern:E}];return E&&!E.endsWith("**")&&A.push({searchPath:b.searchPath,pattern:E+"/**"}),A}getFolderQueryForSearchPath(b,u,E){const A=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(b.searchPath),u,E,!1);return A?{...A,includePattern:b.pattern}:null}getFolderQueryForRoot(b,u,E,A){let I;const B=r.URI.isUri(b)?b:b.uri;if(E.searchPaths){const V=E.searchPaths.filter($=>(0,k.isEqual)($.searchPath,B))[0];if(V&&!V.pattern)return null;V&&(I=V.pattern)}const O=this.configurationService.getValue({resource:B}),x={...this.getExcludesForFolder(O,u)||{},...I||{}},N=r.URI.isUri(b)?(0,k.basename)(b):b.name;return{folder:B,folderName:A?N:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!O.search.followSymlinks}}};h=Ue([Be(0,d.IConfigurationService),Be(1,p.IWorkspaceContextService),Be(2,D.IEditorGroupsService),Be(3,f.IPathService)],h),e.QueryBuilder=h;function y(s){const b=s.match(/[\*\{\}\(\)\[\]\?]/);if(b){const u=b.index,E=s.substr(0,u).match(/[/|\\][^/\\]*$/);if(E){let A=s.substr(0,E.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:s.substr((E.index||0)+1)}}}return{pathPortion:s}}function a(...s){return s.length?s.reduce((b,u)=>(b[u]=!0,b),Object.create(null)):void 0}function P(s){return w.splitGlobAware(s,",").map(b=>b.trim()).filter(b=>!!b.length)}function n(s){return[`**/${s}/**`,`**/${s}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function i(s){return s.replace(/\\/g,"/")}function v(s){return i(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(s,b){s=c.distinct(s,A=>A.toString());const u=[],E=b.getWorkspace();return s&&s.forEach(A=>{let I;if(b.getWorkbenchState()===2)I=(0,k.relativePath)(E.folders[0].uri,A),I&&I!=="."&&(I="./"+I);else{const B=b.getWorkspaceFolder(A);if(B){const O=B.name;if(E.folders.filter(x=>x.name===O).length===1){const x=(0,k.relativePath)(B.uri,A);x===""?I=`./${B.name}`:I=`./${B.name}/${x}`}else I=A.fsPath}}I&&u.push(I)}),u}e.resolveResourcesForSearchIncludes=g}),define(we[218],Ee([0,1,23,2,20,15,4,217,40,47]),function(re,e,c,M,w,T,t,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function _(d,p){const D=p.activationEvents;if(!D)return Promise.resolve(void 0);const f=[],l=[];for(const i of D)if(/^workspaceContains:/.test(i)){const v=i.substr("workspaceContains:".length);v.indexOf("*")>=0||v.indexOf("?")>=0||d.forceUsingSearch?l.push(v):f.push(v)}if(f.length===0&&l.length===0)return Promise.resolve(void 0);let h;const y=new Promise((i,v)=>{h=i}),a=i=>h({activationEvent:i}),P=Promise.all(f.map(i=>r(d,i,a))).then(()=>{}),n=m(d,p.identifier,l,a);return Promise.all([P,n]).then(()=>{h(void 0)}),y}e.checkActivateWorkspaceContainsExtension=_;async function r(d,p,D){for(const f of d.folders)if(await d.exists(c.joinPath(M.URI.revive(f),p))){D(`workspaceContains:${p}`);return}}async function m(d,p,D,f){if(D.length===0)return Promise.resolve(void 0);const l=new w.CancellationTokenSource,h=d.checkExists(d.folders,D,l.token),y=setTimeout(async()=>{l.cancel(),f(`workspaceContainsTimeout:${D.join(",")}`)},F);let a=!1;try{a=await h}catch(P){T.isPromiseCanceledError(P)||T.onUnexpectedError(P)}l.dispose(),clearTimeout(y),a&&f(`workspaceContains:${D.join(",")}`)}function o(d,p,D,f){const l=d.get(t.IInstantiationService),h=d.get(C.ISearchService),a=l.createInstance(R.QueryBuilder).file(p.map(P=>(0,k.toWorkspaceFolder)(M.URI.revive(P))),{_reason:"checkExists",includePattern:D,exists:!0});return h.fileSearch(a,f).then(P=>!!P.limitHit,P=>T.isPromiseCanceledError(P)?!1:Promise.reject(P))}e.checkGlobFileExists=o});var Je=this&&this.__classPrivateFieldSet||function(re,e,c,M,w){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?w.call(re,c):w?w.value=c:e.set(re,c),c},Ae=this&&this.__classPrivateFieldGet||function(re,e,c,M){if(c==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return c==="m"?M:c==="a"?M.call(re):M?M.value:e.get(re)};define(we[34],Ee([0,1,124,17,74,23,14,7,21,2,12,5,33,178,72,32,27,176,15,26,22,151,6,85,4,28,73,13,60,65,39,3,218,69,153,11]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f,l,h,y,a,P,n,i,v,g,s,b,u,E,A,I,B,O){"use strict";var S,x,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let V=class Wi extends R.Disposable{constructor(j,Q,ce,ve,ue,Fe,Ke,Oe,We,Xe){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=ce,this._initData=Ke,this._extHostWorkspace=ve,this._extHostConfiguration=ue,this._logService=Fe,this._extHostTunnelService=We,this._extHostTerminalService=Xe,this._disposables=new R.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new t.Barrier,this._readyToStartExtensionHost=new t.Barrier,this._readyToRunExtensions=new t.Barrier,this._eagerExtensionsActivated=new t.Barrier,this._registry=new D.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new I.ExtHostSecretState(this._extHostContext),this._storagePath=Oe,this._instaService=j.createChild(new s.ServiceCollection([o.IExtHostStorage,this._storage],[I.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(Qe=>Ye.add(l.ExtensionIdentifier.toKey(Qe))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Qe,H,K)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Qe,f.transformErrorForSerialization(H),K)},actualActivateExtension:async(Qe,H)=>{if(Ye.has(l.ExtensionIdentifier.toKey(Qe)))return await this._mainThreadExtensionsProxy.$activateExtension(Qe,H),new m.HostExtension;const K=this._registry.getExtensionDescription(Qe);return this._activateExtension(K,H)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(j){f.onUnexpectedError(j)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let j=[];try{j=this._registry.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this._deactivate(ue))}catch(Q){}await Promise.all(j)}isActivated(j){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(j):!1}_activateByEvent(j,Q){return this._activator.activateByEvent(j,Q)}_activateById(j,Q){return this._activator.activateById(j,Q)}activateByIdWithErrors(j,Q){return this._activateById(j,Q).then(()=>{const ce=this._activator.getActivatedExtension(j);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(j=>this._registry)}getExtensionExports(j){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(j).exports:null}async _realPathExtensionUri(j){if(j.scheme!==O.Schemas.file)return j;const Q=await this._hostUtils.realpath(j.fsPath);return k.URI.file(Q)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const j=C.TernarySearchTree.forUris(Q=>T.extUriBiasedIgnorePathCase.ignorePathCasing(Q));for(const Q of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Q)){const ce=await this._realPathExtensionUri(Q.extensionLocation);j.set(ce,Q)}return j})()),this._extensionPathIndex}_deactivate(j){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(j))return Q;const ce=this._activator.getActivatedExtension(j);if(!ce)return Q;try{typeof ce.module.deactivate=="function"&&(Q=Promise.resolve(ce.module.deactivate()).then(void 0,ve=>(this._logService.error(ve),Promise.resolve(void 0))))}catch(ve){this._logService.error(ve)}try{(0,R.dispose)(ce.subscriptions)}catch(ve){this._logService.error(ve)}return Q}async _activateExtension(j,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier),this._doActivateExtension(j,Q).then(ce=>{const ve=ce.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(j.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,Q),this._logExtensionActivationTimes(j,Q,"success",ve),ce},ce=>{throw this._logExtensionActivationTimes(j,Q,"failure"),ce})}_logExtensionActivationTimes(j,Q,ce,ve){const ue=$(j,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ue,...ve||{},outcome:ce})}_doActivateExtension(j,Q){const ce=$(j,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ce);const ve=this._getEntryPoint(j);if(!ve)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${j.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this._logService.flush();const ue=new m.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(j.identifier,(0,T.joinPath)(j.extensionLocation,ve),ue),this._loadExtensionContext(j)]).then(Fe=>(w.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),Wi._callActivate(this._logService,j.identifier,Fe[0],Fe[1],ue))).then(Fe=>(w.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),Fe))}_loadExtensionContext(j){const Q=new y.ExtensionGlobalMemento(j,this._storage),ce=new y.ExtensionMemento(j.identifier.value,!1,this._storage),ve=new B.ExtensionSecrets(j,this._secretState),ue=j.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,Fe=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([Q.whenReady,ce.whenReady,this._storagePath.whenReady]).then(()=>{const Ke=this;let Oe;return Object.freeze({globalState:Q,workspaceState:ce,secrets:ve,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(We){return M.join(j.extensionLocation.fsPath,We)},get storagePath(){return Ke._storagePath.workspaceValue(j)?.fsPath},get globalStoragePath(){return Ke._storagePath.globalValue(j).fsPath},get logPath(){return M.join(Ke._initData.logsLocation.fsPath,j.identifier.value)},get logUri(){return k.URI.joinPath(Ke._initData.logsLocation,j.identifier.value)},get storageUri(){return Ke._storagePath.workspaceValue(j)},get globalStorageUri(){return Ke._storagePath.globalValue(j)},get extensionMode(){return ue},get extension(){return Oe===void 0&&(Oe=new z(Ke,j.identifier,j,Fe)),Oe},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(j,"extensionRuntime"),Ke.extensionRuntime},get environmentVariableCollection(){return Ke._extHostTerminalService.getEnvironmentVariableCollection(j)}})})}static _callActivate(j,Q,ce,ve,ue){return ce=ce||{activate:void 0,deactivate:void 0},this._callActivateOptional(j,Q,ce,ve,ue).then(Fe=>new m.ActivatedExtension(!1,null,ue.build(),ce,Fe,ve.subscriptions))}static _callActivateOptional(j,Q,ce,ve,ue){if(typeof ce.activate=="function")try{ue.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const Fe=typeof global=="object"?global:self,Ke=ce.activate.apply(Fe,[ve]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(Ke).then(Oe=>(ue.activateResolveStop(),Oe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(ce)}_activateOneStartupFinished(j,Q){this._activateById(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:Q}).then(void 0,ce=>{this._logService.error(ce)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const j of this._registry.getAllExtensionDescriptions())if(j.activationEvents)for(const Q of j.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(j,Q)}_handleEagerExtensions(){const j=this._activateByEvent("*",!0).then(void 0,ue=>{this._logService.error(ue)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ue=>this._handleWorkspaceContainsEagerExtensions(ue.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ce=this._handleWorkspaceContainsEagerExtensions(Q),ve=Promise.all([j,ce]).then(()=>{});return Promise.race([ve,(0,t.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ve}_handleWorkspaceContainsEagerExtensions(j){return j.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(j,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(j,Q){if(this.isActivated(Q.identifier))return;const ce=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ve={folders:j.map(Fe=>Fe.uri),forceUsingSearch:ce,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Ke,Oe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Ke,Oe)},ue=await(0,A.checkActivateWorkspaceContainsExtension)(ve,Q);if(!!ue)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:ue.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(j){throw console.error(j),j}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:Q}=this._initData.environment;if(!j||!Q)throw new Error(c.localize(0,null));const ce=await this._loadCommonJSModule(null,Q,new m.ExtensionActivationTimesBuilder(!1));if(!ce||typeof ce.run!="function")throw new Error(c.localize(1,null,Q.toString()));return new Promise((ve,ue)=>{const Fe=(We,Xe)=>{We?ue(We):ve(typeof Xe=="number"&&Xe>0?1:0)},Ke=(0,T.originalFSPath)(Q),Oe=ce.run(Ke,Fe);Oe&&Oe.then&&Oe.then(()=>{ve(0)}).catch(We=>{ue(We.toString())})})}async $extensionTestsExit(j){this._logService.info(`Extension host terminating: test runner requested exit with code ${j}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${j}`),this._logService.flush(),this._hostUtils.exit(j)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,Q){return this._resolvers[j]=Q,(0,R.toDisposable)(()=>{delete this._resolvers[j]})}async _activateAndGetResolver(j){const Q=j.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const ce=j.substr(0,Q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this._resolvers[ce]}}async $resolveAuthority(j,Q){const{authorityPrefix:ce,resolver:ve}=await this._activateAndGetResolver(j);if(!ve)return{type:"error",error:{code:P.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ce}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ve)),w.mark(`code/extHost/willResolveAuthority/${ce}`);const ue=await ve.resolve(j,{resolveAttempt:Q});w.mark(`code/extHost/didResolveAuthorityOK/${ce}`);const Fe={authority:j,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},Ke={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Fe,options:Ke,tunnelInformation:{environmentTunnels:ue.environmentTunnels}}}}catch(ue){if(w.mark(`code/extHost/didResolveAuthorityError/${ce}`),ue instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(j,Q){const{authorityPrefix:ce,resolver:ve}=await this._activateAndGetResolver(j);if(!ve)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ce}`);const ue=k.URI.revive(Q);if(typeof ve.getCanonicalURI=="undefined")return ue;const Fe=await(0,t.asPromise)(()=>ve.getCanonicalURI(ue));return Fe||ue}$startExtensionHost(j){return this._registry.keepOnly(j),this._startExtensionHost()}$activateByEvent(j,Q){return Q===1?this._activateByEvent(j,!1):this._readyToRunExtensions.wait().then(ce=>this._activateByEvent(j,!1))}async $activate(j,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(j)?(await this._activateById(j,Q),!0):!1}async $deltaExtensions(j,Q){j.forEach(ve=>ve.extensionLocation=k.URI.revive(ve.extensionLocation));const ce=await this.getExtensionPathIndex();return await Promise.all(Q.map(async ve=>{const ue=this._registry.getExtensionDescription(ve);ue&&ce.delete(await this._realPathExtensionUri(ue.extensionLocation))})),await Promise.all(j.map(async ve=>{const ue=await this._realPathExtensionUri(ve.extensionLocation);ce.set(ue,ve)})),this._registry.deltaExtensions(j,Q),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){let Q=h.VSBuffer.alloc(j),ce=Math.random()%256;for(let ve=0;ve<j;ve++)Q.writeUInt8(ce,ve);return Q}async $updateRemoteConnectionData(j){this._remoteConnectionData=j,this._onDidChangeRemoteConnectionData.fire()}};V=Ue([Be(0,n.IInstantiationService),Be(1,e.IHostUtils),Be(2,g.IExtHostRpcService),Be(3,d.IExtHostWorkspace),Be(4,r.IExtHostConfiguration),Be(5,F.ILogService),Be(6,i.IExtHostInitDataService),Be(7,v.IExtensionStoragePaths),Be(8,b.IExtHostTunnelService),Be(9,u.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function $(ee,j){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class z{constructor(j,Q,ce,ve){S.set(this,void 0),x.set(this,void 0),N.set(this,void 0),Je(this,S,j,"f"),Je(this,x,Q,"f"),Je(this,N,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=M.normalize((0,T.originalFSPath)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=ve}get isActive(){return Ae(this,S,"f").isActivated(Ae(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ae(this,S,"f").getExtensionExports(Ae(this,N,"f"))}activate(){return Ae(this,S,"f").activateByIdWithErrors(Ae(this,N,"f"),{startup:!1,extensionId:Ae(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=z,S=new WeakMap,x=new WeakMap,N=new WeakMap}),define(we[99],Ee([0,1,17,2,3,14,5,6,160,32,34,49,167,33,161,13,4,10,90,71]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let h=class{constructor(s,b,u,E,A,I){this._workspaceService=b,this._extensionService=u,this._editorsService=E,this._configurationService=A,this._editorTabs=I,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new w.Emitter,this._onDidTerminateDebugSession=new w.Emitter,this._onDidChangeActiveDebugSession=new w.Emitter,this._onDidReceiveDebugSessionCustomEvent=new w.Emitter,this._debugServiceProxy=s.getProxy(t.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new w.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(O=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,b){const u=s;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let E=`debug:${encodeURIComponent(u.path||"")}`,A="?";return b&&(E+=`${A}session=${encodeURIComponent(b.id)}`,A="&"),E+=`${A}ref=${u.sourceReference}`,M.URI.parse(E)}else{if(u.path)return M.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const b=[];for(const u of s.getAllExtensionDescriptions())if(u.contributes){const E=u.contributes.debuggers;if(E&&E.length>0)for(const A of E)(0,o.isDebuggerMainContribution)(A)&&b.push(A.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(b=>s.push(b)),s}addBreakpoints(s){this.startBreakpoints();const b=s.filter(A=>{const I=A.id;return this._breakpoints.has(I)?!1:(this._breakpoints.set(I,A),!0)});this.fireBreakpointChanges(b,[],[]);const u=[],E=new Map;for(const A of b)if(A instanceof R.SourceBreakpoint){let I=E.get(A.location.uri.toString());I||(I={type:"sourceMulti",uri:A.location.uri,lines:[]},E.set(A.location.uri.toString(),I),u.push(I)),I.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof R.FunctionBreakpoint&&u.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(s){this.startBreakpoints();const b=s.filter(I=>this._breakpoints.delete(I.id));this.fireBreakpointChanges([],b,[]);const u=b.filter(I=>I instanceof R.SourceBreakpoint).map(I=>I.id),E=b.filter(I=>I instanceof R.FunctionBreakpoint).map(I=>I.id),A=b.filter(I=>I instanceof R.DataBreakpoint).map(I=>I.id);return this._debugServiceProxy.$unregisterBreakpoints(u,E,A)}startDebugging(s,b,u){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,b,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,b,u){if(!b)return new R.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:E,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,u,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,E),new R.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(s,b,u){if(!u)return new R.Disposable(()=>{});if(!this.definesDebugType(s,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:E,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,E),new R.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(s,b){if(!b)return new R.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:u,factory:b}),new R.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==b)})}async $runInTerminal(s,b){return Promise.resolve(void 0)}async $substituteVariables(s,b){if(!this._variableResolver){const[A,I]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,I)}let u;const E=await this.getFolder(s);return E&&(u={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,b)}createDebugAdapter(s,b){if(s.type==="implementation")return new i(s.implementation)}createSignService(){}async $startDASession(s,b){const u=this,E=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const I=this.convertToDto(A),B=this.createDebugAdapter(I,E);if(!B)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const O=B;return this._debugAdapters.set(s,O),this.getDebugAdapterTrackers(E).then(S=>(S&&this._debugAdaptersTrackers.set(s,S),O.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const N=x,V={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(N.arguments.value);V.body={signature:$},O.sendResponse(V)}else throw new Error("no signer")}catch($){V.success=!1,V.message=$.message,O.sendResponse(V)}}else S&&S.onDidSendMessage&&S.onDidSendMessage(x),x=(0,o.convertToVSCPaths)(x,!0),u._debugServiceProxy.$acceptDAMessage(s,x)}),O.onError(x=>{S&&S.onError&&S.onError(x),this._debugServiceProxy.$acceptDAError(s,x.name,x.message,x.stack)}),O.onExit(x=>{S&&S.onExit&&S.onExit((0,D.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,D.withNullAsUndefined)(x),void 0)}),S&&S.onWillStartSession&&S.onWillStartSession(),O.startSession()))})}$sendDAMessage(s,b){b=(0,o.convertToDAPaths)(b,!1);const u=this._debugAdaptersTrackers.get(s);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(b);const E=this._debugAdapters.get(s);E&&E.sendMessage(b)}$stopDASession(s){const b=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),b&&b.onWillStopSession&&b.onWillStopSession();const u=this._debugAdapters.get(s);return this._debugAdapters.delete(s),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const b=[],u=[],E=[];if(s.added)for(const A of s.added){const I=A.id;if(I&&!this._breakpoints.has(I)){let B;if(A.type==="function")B=new R.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")B=new R.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const O=M.URI.revive(A.uri);B=new R.SourceBreakpoint(new R.Location(O,new R.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}B._id=I,this._breakpoints.set(I,B),b.push(B)}}if(s.removed)for(const A of s.removed){const I=this._breakpoints.get(A);I&&(this._breakpoints.delete(A),u.push(I))}if(s.changed){for(const A of s.changed)if(A.id){const I=this._breakpoints.get(A.id);if(I){if(I instanceof R.FunctionBreakpoint&&A.type==="function"){const B=I;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.functionName=A.functionName}else if(I instanceof R.SourceBreakpoint&&A.type==="source"){const B=I;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.location=new R.Location(M.URI.revive(A.uri),new R.Position(A.line,A.character))}E.push(I)}}}this.fireBreakpointChanges(b,u,E)}$provideDebugConfigurations(s,b,u){return(0,T.asPromise)(async()=>{const E=this.getConfigProviderByHandle(s);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(b);return E.provideDebugConfigurations(A,u)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(s,b,u,E){return(0,T.asPromise)(async()=>{const A=this.getConfigProviderByHandle(s);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.getFolder(b);return A.resolveDebugConfiguration(I,u,E)})}$resolveDebugConfigurationWithSubstitutedVariables(s,b,u,E){return(0,T.asPromise)(async()=>{const A=this.getConfigProviderByHandle(s);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.getFolder(b);return A.resolveDebugConfigurationWithSubstitutedVariables(I,u,E)})}async $provideDebugAdapter(s,b){const u=this.getAdapterDescriptorFactoryByHandle(s);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(b);return this.getAdapterDescriptor(u,E).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(s){const b=await this.getSession(s);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(s){const b=await this.getSession(s);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,b){const u=await this.getSession(s);u&&u._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(s,b){const E={session:await this.getSession(s),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(s){if(s instanceof R.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof R.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof R.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof R.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const b=this._adapterFactories.filter(u=>u.type===s);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(s){const b=this._adapterFactories.filter(u=>u.handle===s);if(b.length>0)return b[0].factory}getConfigProviderByHandle(s){const b=this._configProviders.filter(u=>u.handle===s);if(b.length>0)return b[0].provider}definesDebugType(s,b){if(s.contributes){const u=s.contributes.debuggers;if(u&&u.length>0){for(const E of u)if(E.label&&E.type&&E.type===b)return!0}}return!1}getDebugAdapterTrackers(s){const u=s.configuration.type,E=this._trackerFactories.filter(A=>A.type===u||A.type==="*").map(A=>(0,T.asPromise)(()=>A.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(E).then(A=>{const I=A.filter(B=>!!B);if(I.length>0)return new n(I)}),new Promise((A,I)=>{const B=setTimeout(()=>{clearTimeout(B),I(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(s,b){const u=b.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new R.DebugAdapterServer(u));if(s){const A=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>s.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,A))).then(I=>{if(I)return I})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,E))}daExecutableFromPackage(s,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,b,u){(s.length>0||b.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:b,changed:u}))}async getSession(s){if(s)if(typeof s=="string"){const b=this._debugSessions.get(s);if(b)return b}else{let b=this._debugSessions.get(s.id);if(!b){const u=await this.getFolder(s.folderUri),E=s.parent?this._debugSessions.get(s.parent):void 0;b=new y(this._debugServiceProxy,s.id,s.type,s.name,u,s.configuration,E),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(s){if(s){const b=M.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};h=Ue([Be(0,d.IExtHostRpcService),Be(1,k.IExtHostWorkspace),Be(2,F.IExtHostExtensionService),Be(3,_.IExtHostDocumentsAndEditors),Be(4,m.IExtHostConfiguration),Be(5,l.IExtHostEditorTabs)],h),e.ExtHostDebugServiceBase=h;class y{constructor(s,b,u,E,A,I,B){this._debugServiceProxy=s,this._id=b,this._type=u,this._name=E,this._workspaceFolder=A,this._configuration=I,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,b)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=y;class a{constructor(s){this.value=Object.freeze({append(b){s.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=a;class P extends r.AbstractVariableResolverService{constructor(s,b,u,E,A){function I(){if(b){const B=b.activeEditor();if(B)return B.document.uri;const O=E.tabs.filter(S=>S.isActive);if(O.length>0){const S=O[0].resource;return S&&(S.primary||S.secondary)?S.primary??S.secondary:O[0].resource}}}super({getFolderUri:B=>{const O=s.filter(S=>S.name===B);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>s.length,getConfigurationValue:(B,O)=>u.getConfiguration(void 0,B).get(O),getAppRoot:()=>f.cwd(),getExecPath:()=>f.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=I();if(B)return c.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const B=I();if(B){const O=A.getWorkspaceFolder(B);if(O)return c.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(b){const B=b.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(b){const B=b.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(f.env))}}e.ExtHostVariableResolverService=P;class n{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(b=>b.onError?b.onError(s):void 0)}onExit(s,b){this.trackers.forEach(u=>u.onExit?u.onExit(s,b):void 0)}}class i extends C.AbstractDebugAdapter{constructor(s){super();this.implementation=s,s.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let v=class extends h{constructor(s,b,u,E,A,I){super(s,b,u,E,A,I)}createVariableResolver(s,b,u){return new P(s,b,u,this._editorTabs)}};v=Ue([Be(0,d.IExtHostRpcService),Be(1,k.IExtHostWorkspace),Be(2,F.IExtHostExtensionService),Be(3,_.IExtHostDocumentsAndEditors),Be(4,m.IExtHostConfiguration),Be(5,l.IExtHostEditorTabs)],v),e.WorkerExtHostDebugService=v}),define(we[219],Ee([0,1,74,2,5,33,27,26,13,28,4,34,90,12]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(l,h,y,a,P,n,i){this._apiFactory=l,this._extensionRegistry=h,this._instaService=y,this._extHostConfiguration=a,this._extHostExtensionService=P,this._initData=n,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),c.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();c.mark("code/extHost/didWaitForConfig");const h=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,h,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(p,h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(D,h,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let h of l.nodeModuleName)this._factories.set(h,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(h=>l.alternativeModuleName(h))}};o=Ue([Be(2,F.IInstantiationService),Be(3,T.IExtHostConfiguration),Be(4,_.IExtHostExtensionService),Be(5,k.IExtHostInitDataService),Be(6,m.ILogService)],o),e.RequireInterceptor=o;class d{constructor(l,h,y,a,P){this._apiFactory=l,this._extensionPaths=h,this._extensionRegistry=y,this._configProvider=a,this._logService=P,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,h){const y=this._extensionPaths.findSubstr(h);if(y){let a=this._extApiImpl.get(R.ExtensionIdentifier.toKey(y.identifier));return a||(a=this._apiFactory(y,this._extensionRegistry,this._configProvider),this._extApiImpl.set(R.ExtensionIdentifier.toKey(y.identifier),a)),a}if(!this._defaultApiImpl){let a="";this._extensionPaths.forEach((P,n)=>a+=`	${n} -> ${P.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${a}`),this._defaultApiImpl=this._apiFactory(t.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(l,h,y){this._extensionPaths=l,this.nodeModuleName="keytar",this._mainThreadTelemetry=h.getProxy(w.MainContext.MainThreadTelemetry);const{environment:a}=y,P=h.getProxy(w.MainContext.MainThreadKeytar);if(a.appRoot){let n=a.appRoot.fsPath;r.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,i)=>P.$getPassword(n,i),setPassword:(n,i,v)=>P.$setPassword(n,i,v),deletePassword:(n,i)=>P.$deletePassword(n,i),findPassword:n=>P.$findPassword(n),findCredentials(n){return P.$findCredentials(n)}}}load(l,h){const y=this._extensionPaths.findSubstr(h);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:y?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(l){const h=l.length;if(h<=7||!this.alternativeNames)return;const y=h-7;if((l.charAt(y)==="/"||l.charAt(y)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};p=Ue([Be(1,C.IExtHostRpcService),Be(2,k.IExtHostInitDataService)],p);let D=class{constructor(l,h,y){this._extensionPaths=l,this._appUriScheme=h,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=y.getProxy(w.MainContext.MainThreadTelemetry);const a=y.getProxy(w.MainContext.MainThreadWindow);this._impl=(P,n)=>{const i=M.URI.parse(P);return n?this.callOriginal(P,n):i.scheme==="http"||i.scheme==="https"?a.$openUri(i,P,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?a.$openUri(i,P,{}):this.callOriginal(P,n)}}load(l,h,y){const a=this._extensionPaths.findSubstr(h);return a&&(this._extensionId=a.identifier.value,this.sendShimmingTelemetry()),this._original=y(l),this._impl}callOriginal(l,h){return this.sendNoForwardTelemetry(),this._original(l,h)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};D=Ue([Be(2,C.IExtHostRpcService)],D)}),define(we[220],Ee([0,1,14,15,74,7,2,5,213,12,57,60,28,141,13,66,34,39]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class f{constructor(h,y,a,P){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new C.RPCProtocol(h,null,P),y=f._transform(y,this._rpcProtocol);const n=new _.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());n.set(r.IExtHostInitDataService,{_serviceBrand:void 0,...y}),n.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),n.set(d.IURITransformerService,new d.URITransformerService(P)),n.set(p.IHostUtils,a);const i=new m.InstantiationService(n,!0),v=i.invokeFunction(u=>u.get(D.IExtHostTerminalService));this._disposables.add(v),this._logService=i.invokeFunction(u=>u.get(k.ILogService)),w.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",y),this._extensionService=i.invokeFunction(u=>u.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const g=new WeakMap;this._extensionService.getExtensionPathIndex().then(u=>{Error.prepareStackTrace=(E,A)=>{let I="",B,O;for(const S of A)I+=`
	at ${S.toString()}`,O=S.getFileName(),!B&&O&&(B=u.findSubstr(t.URI.file(O)));return g.set(E,B),`${E.name||"Error"}: ${E.message||""}${I}`}});const s=this._rpcProtocol.getProxy(R.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(R.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(u=>{const E=M.transformErrorForSerialization(u),A=g.get(u);A?s.$onExtensionRuntimeError(A.identifier,E):b.$onUnexpectedError(E)})}terminate(h){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${h}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const y=this._extensionService.deactivateAll();Promise.race([(0,c.timeout)(5e3),y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(h,y){h.extensions.forEach(P=>P.extensionLocation=t.URI.revive(y.transformIncomingURIs(P.extensionLocation))),h.environment.appRoot=t.URI.revive(y.transformIncomingURIs(h.environment.appRoot));const a=h.environment.extensionDevelopmentLocationURI;return a&&(h.environment.extensionDevelopmentLocationURI=a.map(P=>t.URI.revive(y.transformIncomingURIs(P)))),h.environment.extensionTestsLocationURI=t.URI.revive(y.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=t.URI.revive(y.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=t.URI.revive(y.transformIncomingURIs(h.environment.workspaceStorageHome)),h.logsLocation=t.URI.revive(y.transformIncomingURIs(h.logsLocation)),h.logFile=t.URI.revive(y.transformIncomingURIs(h.logFile)),h.workspace=y.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=f}),define(we[221],Ee([0,1,17,20,44,29,23,194,40]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(r,m,o){this.config=r,this.provider=m,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=r.filePattern,this.includePattern=r.includePattern&&T.parse(r.includePattern),this.maxResults=r.maxResults||void 0,this.exists=r.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=r.excludePattern&&T.parse(r.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(r=>r.cancel()),this.activeCancellationTokens=new Set}search(r){const m=this.config.folderQueries||[];return new Promise((o,d)=>{const p=D=>{this.resultCount++,r(D)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(D=>{const f=D.toString(),l=c.basename(f);this.globalExcludePattern&&this.globalExcludePattern(f,l)||this.matchFile(p,{base:D,basename:l})}),Promise.all(m.map(D=>this.searchInFolder(D,p))).then(D=>{o({limitHit:this.isLimitHit,stats:D[0]||void 0})},D=>{d(new Error((0,w.toErrorMessage)(D)))})})}async searchInFolder(r,m){const o=new M.CancellationTokenSource,d=this.getSearchOptionsForFolder(r),p=this.initDirectoryTree(),D=new C.QueryGlobTester(this.config,r),f=!D.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(o),l=R.StopWatch.create();const h=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,o.token),y=l.elapsed(),a=R.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(h&&h.forEach(P=>{const n=c.posix.relative(r.folder.path,P.path);if(f){const i=c.basename(P.path);this.matchFile(m,{base:r.folder,relativePath:n,basename:i});return}this.addDirectoryEntries(p,r.folder,n,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,D,m),{providerTime:y,postProcessTime:a.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(r){const m=(0,C.resolvePatternsForProvider)(this.config.includePattern,r.includePattern),o=(0,C.resolvePatternsForProvider)(this.config.excludePattern,r.excludePattern);return{folder:r.folder,excludes:o,includes:m,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,followSymlinks:!r.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries({pathToEntries:r},m,o,d){if(o===this.filePattern){const D=c.basename(this.filePattern);this.matchFile(d,{base:m,relativePath:this.filePattern,basename:D})}function p(D){const f=c.basename(D),l=c.dirname(D);let h=r[l];h||(h=r[l]=[],p(l)),h.push({base:m,relativePath:D,basename:f})}p(o)}matchDirectoryTree({rootEntries:r,pathToEntries:m},o,d){const p=this,D=this.filePattern;function f(l){const h=T.hasSiblingFn(()=>l.map(y=>y.basename));for(let y=0,a=l.length;y<a;y++){const P=l[y],{relativePath:n,basename:i}=P;if(o.matchesExcludesSync(n,i,D!==i?h:void 0))continue;const v=m[n];if(v)f(v);else{if(n===D)continue;p.matchFile(d,P)}if(p.isLimitHit)break}}f(r)}matchFile(r,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||r(m))}}class F{constructor(){this.sessions=new Map}fileSearch(r,m,o,d){const p=this.getSessionTokenSource(r.cacheKey),D=new k(r,m,p&&p.token);let f=0;const l=h=>{f+=h.length,o(h.map(y=>this.rawMatchToSearchItem(y)))};return this.doSearch(D,F.BATCH_SIZE,l,d).then(h=>({limitHit:h.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:h.stats}}))}clearCache(r){const m=this.getSessionTokenSource(r);m&&m.cancel()}getSessionTokenSource(r){if(!!r)return this.sessions.has(r)||this.sessions.set(r,new M.CancellationTokenSource),this.sessions.get(r)}rawMatchToSearchItem(r){return r.relativePath?{resource:t.joinPath(r.base,r.relativePath)}:{resource:r.base}}doSearch(r,m,o,d){d.onCancellationRequested(()=>{r.cancel()});const p=f=>{f&&(D.push(f),m>0&&D.length>=m&&(o(D),D=[]))};let D=[];return r.search(p).then(f=>(D.length&&o(D),f),f=>(D.length&&o(D),Promise.reject(f)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(we[222],Ee([0,1,16,20,44,29,11,17,23,10,2,40]),function(re,e,c,M,w,T,t,R,C,k,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class r{constructor(l,h,y,a){this.query=l,this.provider=h,this.fileUtils=y,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,h){const y=this.query.folderQueries||[],a=new M.CancellationTokenSource;return h.onCancellationRequested(()=>a.cancel()),new Promise((P,n)=>{this.collector=new o(l);let i=!1;const v=(g,s)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(g);p(g)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,a.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const u=this.resultSize(g);this.resultCount+=u,(u>0||!p(g))&&this.collector.add(g,s)}};Promise.all(y.map((g,s)=>this.searchInFolder(g,b=>v(b,s),a.token))).then(g=>{a.dispose(),this.collector.flush();const s=g.some(b=>!!b&&!!b.limitHit);P({limitHit:this.isLimitHit||s,messages:(0,c.flatten)(g.map(b=>b?.message?(0,k.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},g=>{a.dispose();const s=(0,w.toErrorMessage)(g);n(new Error(s))})})}resultSize(l){return p(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,h){const y=Array.isArray(l.ranges)?l.ranges:[l.ranges],a=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:y.slice(0,h),preview:{matches:a.slice(0,h),text:l.preview.text},uri:l.uri}}async searchInFolder(l,h,y){const a=new _.QueryGlobTester(this.query,l),P=[],n={report:g=>{if(!this.validateProviderResult(g))return;const s=l.folder.scheme===t.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(g.uri))):void 0,b=C.relativePath(l.folder,g.uri);if(b){const u=a.includedInQuery(b,R.basename(b),s);(0,k.isPromise)(u)?P.push(u.then(E=>{E&&h(g)})):u&&h(g)}}},i=this.getSearchOptionsForFolder(l),v=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,n,y);return P.length&&await Promise.all(P),v}validateProviderResult(l){if(p(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const h=(0,_.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),y=(0,_.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),a={folder:F.URI.from(l.folder),excludes:y,includes:h,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=r;function m(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class o{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new D(512,h=>this.sendItems(h))}add(l,h){this._currentFileMatch&&(this._currentFolderIdx!==h||!C.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=h,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(d(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=o;function d(f){return p(f)?{preview:{matches:(0,c.mapArrayOrNot)(f.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:f.preview.text},ranges:(0,c.mapArrayOrNot)(f.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function p(f){return!!f.preview}e.extensionResultIsMatch=p;class D{constructor(l,h){this.maxBatchSize=l,this.cb=h,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,h){!l||this.addItemToBatch(l,h)}addItems(l,h){!l||this.addItemsToBatch(l,h)}addItemToBatch(l,h){this.batch.push(l),this.batchSize+=h,this.onUpdate()}addItemsToBatch(l,h){this.batch=this.batch.concat(l),this.batchSize+=h,this.onUpdate()}onUpdate(){this.totalNumberCompleted<D.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},D.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=D,D.TIMEOUT=4e3,D.START_BATCH_AFTER_COUNT=50}),define(we[100],Ee([0,1,7,5,4,221,13,66,12,2,222]),function(re,e,c,M,w,T,t,R,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let _=class{constructor(d,p,D){this.extHostRpc=d,this._uriTransformer=p,this._logService=D,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,p){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const D=this._handlePool++;return this._textSearchProvider.set(D,p),this._proxy.$registerTextSearchProvider(D,this._transformScheme(d)),(0,c.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}registerFileSearchProvider(d,p){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const D=this._handlePool++;return this._fileSearchProvider.set(D,p),this._proxy.$registerFileSearchProvider(D,this._transformScheme(d)),(0,c.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}$provideFileSearchResults(d,p,D,f){const l=r(D),h=this._fileSearchProvider.get(d);if(h)return this._fileSearchManager.fileSearch(l,h,y=>{this._proxy.$handleFileMatch(d,p,y.map(a=>a.resource))},f);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,p,D,f){const l=this._textSearchProvider.get(d);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const h=r(D);return this.createTextSearchManager(h,l).search(a=>this._proxy.$handleTextMatch(d,p,a),f)}$enableExtensionHostSearch(){}createTextSearchManager(d,p){return new F.TextSearchManager(d,p,{readdir:D=>Promise.resolve([]),toCanonicalName:D=>D},"textSearchProvider")}};_=Ue([Be(0,t.IExtHostRpcService),Be(1,R.IURITransformerService),Be(2,C.ILogService)],_),e.ExtHostSearch=_;function r(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(m),extraFileResources:o.extraFileResources&&o.extraFileResources.map(d=>k.URI.revive(d))}}e.reviveQuery=r;function m(o){return{...o,folder:k.URI.revive(o.folder)}}}),define(we[223],Ee([0,1,20,15,3,35,2,117,80,111,56,46,5,184,183,38,185,33,186,187,188,169,189,49,34,190,170,193,195,197,95,172,202,203,204,72,39,206,173,8,6,209,51,96,32,75,158,192,62,94,98,99,100,12,66,13,28,198,155,65,70,181,207,154,73,50,212,210,211,182,31,205,208,69,71,86,200,97,201,11,143,199,152,191,27]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f,l,h,y,a,P,n,i,v,g,s,b,u,E,A,I,B,O,S,x,N,V,$,z,ee,j,Q,ce,ve,ue,Fe,Ke,Oe,We,Xe,Ye,Qe,H,K,J,oe,G,ie,de,Te,Ne,ze,je,et,ot,ye,nt,q,X,pe,$e,qe,rt,ft,ht,Ct,It,Pt,Ze,pt,Ie,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(Z){const se=Z.get(K.IExtHostInitDataService),fe=Z.get(q.IExtHostFileSystemInfo),he=Z.get(je.IExtHostConsumerFileSystem),ke=Z.get(n.IExtHostExtensionService),Le=Z.get(Q.IExtHostWorkspace),Me=Z.get(rt.IExtHostTelemetry),He=Z.get(D.IExtHostConfiguration),it=Z.get(Qe.IURITransformerService),Re=Z.get(H.IExtHostRpcService),le=Z.get(O.IExtHostStorage),me=Z.get(ze.IExtensionStoragePaths),ne=Z.get(Ye.ILoggerService),W=Z.get(Ye.ILogService),be=Z.get(G.IExtHostTunnelService),De=Z.get(ie.IExtHostApiDeprecationService),Ge=Z.get(j.IExtHostWindow),xe=Z.get($e.IExtHostSecretState),lt=Z.get(qe.IExtHostEditorTabs);Re.set(r.ExtHostContext.ExtHostFileSystemInfo,fe),Re.set(r.ExtHostContext.ExtHostLogLevelServiceShape,ne),Re.set(r.ExtHostContext.ExtHostWorkspace,Le),Re.set(r.ExtHostContext.ExtHostConfiguration,He),Re.set(r.ExtHostContext.ExtHostExtensionService,ke),Re.set(r.ExtHostContext.ExtHostStorage,le),Re.set(r.ExtHostContext.ExtHostTunnelService,be),Re.set(r.ExtHostContext.ExtHostWindow,Ge),Re.set(r.ExtHostContext.ExtHostSecretState,xe),Re.set(r.ExtHostContext.ExtHostTelemetry,Me),Re.set(r.ExtHostContext.ExtHostEditorTabs,lt);const _t=Re.set(r.ExtHostContext.ExtHostDecorations,Z.get(Ke.IExtHostDecorations)),bt=Re.set(r.ExtHostContext.ExtHostDocumentsAndEditors,Z.get(P.IExtHostDocumentsAndEditors)),ct=Re.set(r.ExtHostContext.ExtHostCommands,Z.get(d.IExtHostCommands)),gt=Re.set(r.ExtHostContext.ExtHostTerminalService,Z.get(S.IExtHostTerminalService)),dt=Re.set(r.ExtHostContext.ExtHostDebugService,Z.get(We.IExtHostDebugService)),Tt=Re.set(r.ExtHostContext.ExtHostSearch,Z.get(Xe.IExtHostSearch)),yt=Re.set(r.ExtHostContext.ExtHostTask,Z.get(Oe.IExtHostTask)),Bt=Re.set(r.ExtHostContext.ExtHostOutputService,Z.get(u.IExtHostOutputService)),Vt=Re.set(r.ExtHostContext.ExtHostUrls,new z.ExtHostUrls(Re)),St=Re.set(r.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(Re,bt)),$t=Re.set(r.ExtHostContext.ExtHostDocumentContentProviders,new h.ExtHostDocumentContentProvider(Re,bt,W)),ti=Re.set(r.ExtHostContext.ExtHostDocumentSaveParticipant,new y.ExtHostDocumentSaveParticipant(W,St,Re.getProxy(r.MainContext.MainThreadBulkEdits))),wt=Re.set(r.ExtHostContext.ExtHostNotebook,new J.ExtHostNotebookController(Re,ct,bt,St,me)),Qt=Re.set(r.ExtHostContext.ExtHostNotebookDocuments,new pt.ExtHostNotebookDocuments(W,wt)),jt=Re.set(r.ExtHostContext.ExtHostNotebookEditors,new Ze.ExtHostNotebookEditors(W,Re,wt)),ii=Re.set(r.ExtHostContext.ExtHostNotebookKernels,new ft.ExtHostNotebookKernels(Re,se,wt,ct,W)),ni=Re.set(r.ExtHostContext.ExtHostNotebookRenderers,new Ct.ExtHostNotebookRenderers(Re,wt)),At=Re.set(r.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(Re,bt)),Yt=Re.set(r.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(Re.getProxy(r.MainContext.MainThreadTreeViews),ct,W)),bi=Re.set(r.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(Re.getProxy(r.MainContext.MainThreadEditorInsets),At,se)),zt=Re.set(r.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(Re,W,fe)),Ht=Re.set(r.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(Re,St,ct.converter,it)),mt=Re.set(r.ExtHostContext.ExtHostLanguageFeatures,new g.ExtHostLanguageFeatures(Re,it,St,ct,zt,W,De)),ri=Re.set(r.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Re,mt)),Ot=Re.set(r.ExtHostContext.ExtHostFileSystemEventService,new v.ExtHostFileSystemEventService(Re,W,bt)),Nt=Re.set(r.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(Re,Le,ct)),Xt=Re.set(r.ExtHostContext.ExtHostSCM,new I.ExtHostSCM(Re,ct,W)),wi=Re.set(r.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(Re,ct,St)),di=Re.set(r.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(Re.getProxy(r.MainContext.MainThreadProgress))),Ei=Re.set(r.ExtHostContext.ExtHosLabelService,new ue.ExtHostLabelService(Re)),hi=Re.set(r.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Re)),Jt=Re.set(r.ExtHostContext.ExtHostAuthentication,new de.ExtHostAuthentication(Re)),oi=Re.set(r.ExtHostContext.ExtHostTimeline,new Te.ExtHostTimeline(Re,ct)),qt=Re.set(r.ExtHostContext.ExtHostWebviews,new ee.ExtHostWebviews(Re,{remote:se.remote},Le,W,De)),si=Re.set(r.ExtHostContext.ExtHostWebviewPanels,new ye.ExtHostWebviewPanels(Re,qt,Le)),_i=Re.set(r.ExtHostContext.ExtHostCustomEditors,new ot.ExtHostCustomEditors(Re,St,me,qt,si)),yi=Re.set(r.ExtHostContext.ExtHostWebviewViews,new et.ExtHostWebviewViews(Re,qt)),Gt=Re.set(r.ExtHostContext.ExtHostTesting,new X.ExtHostTesting(Re,ct)),Zt=Re.set(r.ExtHostContext.ExtHostUriOpeners,new pe.ExtHostUriOpeners(Re));Re.set(r.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Re,wt,bt,ct));const Si=(0,ce.values)(r.ExtHostContext);Re.assertRegistered(Si);const Ci=new nt.ExtHostBulkEdits(Re,bt),Di=new o.ExtHostClipboard(Re),Kt=new b.ExtHostMessageService(Re,W),fi=new l.ExtHostDialogs(Re),Wt=new B.ExtHostStatusBar(Re,ct.converter);return m.ExtHostApiCommands.register(ct),function(Pe,ai,Ft){const vt=function(){let Y=!Pe.isUnderDevelopment;function ae(){Y||(W.info(`Extension '${Pe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Se(at){if(Array.isArray(at))at.forEach(Se);else if(typeof at=="string")ae();else{const Et=at;typeof Et.scheme=="undefined"&&ae(),typeof Et.exclusive=="boolean"&&(0,ge.checkProposedApiEnabled)(Pe,"documentFiltersExclusive")}return at}}(),ki={getSession(Y,ae,Se){return Jt.getSession(Pe,Y,ae,Se)},async hasSession(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"authSession"),!!await Jt.getSession(Pe,Y,ae,{silent:!0})},get onDidChangeSessions(){return Jt.onDidChangeSessions},registerAuthenticationProvider(Y,ae,Se,at){return Jt.registerAuthenticationProvider(Y,ae,Se,at)}},Ii={registerCommand(Y,ae,Se){return ct.registerCommand(!0,Y,ae,Se,void 0,Pe)},registerTextEditorCommand(Y,ae,Se){return ct.registerCommand(!0,Y,(...at)=>{const Et=At.getActiveTextEditor();if(!Et){W.warn("Cannot execute "+Y+" because there is no active text editor.");return}return Et.edit(kt=>{ae.apply(Se,[Et,kt,...at])}).then(kt=>{kt||W.warn("Edits from command "+Y+" were not applied.")},kt=>{W.warn("An error occurred while running command "+Y,kt)})},void 0,void 0,Pe)},registerDiffInformationCommand:(Y,ae,Se)=>((0,ge.checkProposedApiEnabled)(Pe,"diffCommand"),ct.registerCommand(!0,Y,async(...at)=>{const Et=bt.activeEditor(!0);if(!Et){W.warn("Cannot execute "+Y+" because there is no active text editor.");return}const kt=await At.getDiffInformation(Et.id);ae.apply(Se,[kt,...at])},void 0,void 0,Pe)),executeCommand(Y,...ae){return ct.executeCommand(Y,...ae)},getCommands(Y=!1){return ct.getCommands(Y)}},mi={get machineId(){return se.telemetryInfo.machineId},get sessionId(){return se.telemetryInfo.sessionId},get language(){return se.environment.appLanguage},get appName(){return se.environment.appName},get appRoot(){return se.environment.appRoot?.fsPath??""},get appHost(){return se.environment.appHost},get uriScheme(){return se.environment.appUriScheme},get clipboard(){return Di.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Me.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Me.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(se.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ae){return Ge.openUri(Y,{allowTunneling:!!se.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===se.environment.appUriScheme)return Vt.createAppUri(Y);try{return await Ge.asExternalUri(Y,{allowTunneling:!!se.remote.authority})}catch(ae){if((0,Pt.matchesScheme)(Y,It.Schemas.http)||(0,Pt.matchesScheme)(Y,It.Schemas.https))return Y;throw ae}},get remoteName(){return(0,Fe.getRemoteName)(se.remote.authority)},get remoteAuthority(){return(0,ge.checkProposedApiEnabled)(Pe,"resolvers"),se.remote.authority},get uiKind(){return se.uiKind}};se.environment.extensionTestsLocationURI||Object.freeze(mi);const gi=se.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Pi={createTestController(Y,ae){return Gt.createTestController(Y,ae)},createTestObserver(){return(0,ge.checkProposedApiEnabled)(Pe,"testObserver"),Gt.createTestObserver()},runTests(Y){return(0,ge.checkProposedApiEnabled)(Pe,"testObserver"),Gt.runTests(Y)},get onDidChangeTestResults(){return(0,ge.checkProposedApiEnabled)(Pe,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,ge.checkProposedApiEnabled)(Pe,"testObserver"),Gt.results}},Ti={getExtension(Y){const ae=ai.getExtensionDescription(Y);if(ae)return new n.Extension(ke,Pe.identifier,ae,gi)},get all(){return ai.getAllExtensionDescriptions().map(Y=>new n.Extension(ke,Pe.identifier,Y,gi))},get onDidChange(){return ai.onDidChange}},Ai={createDiagnosticCollection(Y){return zt.createDiagnosticCollection(Pe.identifier,Y)},get onDidChangeDiagnostics(){return zt.onDidChangeDiagnostics},getDiagnostics:Y=>zt.getDiagnostics(Y),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(Y,ae){return Ht.changeLanguage(Y.uri,ae)},match(Y,ae){return(0,F.score)(V.LanguageSelector.from(Y),ae.uri,ae.languageId,!0)},registerCodeActionsProvider(Y,ae,Se){return mt.registerCodeActionProvider(Pe,vt(Y),ae,Se)},registerCodeLensProvider(Y,ae){return mt.registerCodeLensProvider(Pe,vt(Y),ae)},registerDefinitionProvider(Y,ae){return mt.registerDefinitionProvider(Pe,vt(Y),ae)},registerDeclarationProvider(Y,ae){return mt.registerDeclarationProvider(Pe,vt(Y),ae)},registerImplementationProvider(Y,ae){return mt.registerImplementationProvider(Pe,vt(Y),ae)},registerTypeDefinitionProvider(Y,ae){return mt.registerTypeDefinitionProvider(Pe,vt(Y),ae)},registerHoverProvider(Y,ae){return mt.registerHoverProvider(Pe,vt(Y),ae,Pe.identifier)},registerEvaluatableExpressionProvider(Y,ae){return mt.registerEvaluatableExpressionProvider(Pe,vt(Y),ae,Pe.identifier)},registerInlineValuesProvider(Y,ae){return mt.registerInlineValuesProvider(Pe,vt(Y),ae,Pe.identifier)},registerDocumentHighlightProvider(Y,ae){return mt.registerDocumentHighlightProvider(Pe,vt(Y),ae)},registerLinkedEditingRangeProvider(Y,ae){return mt.registerLinkedEditingRangeProvider(Pe,vt(Y),ae)},registerReferenceProvider(Y,ae){return mt.registerReferenceProvider(Pe,vt(Y),ae)},registerRenameProvider(Y,ae){return mt.registerRenameProvider(Pe,vt(Y),ae)},registerDocumentSymbolProvider(Y,ae,Se){return mt.registerDocumentSymbolProvider(Pe,vt(Y),ae,Se)},registerWorkspaceSymbolProvider(Y){return mt.registerWorkspaceSymbolProvider(Pe,Y)},registerDocumentFormattingEditProvider(Y,ae){return mt.registerDocumentFormattingEditProvider(Pe,vt(Y),ae)},registerDocumentRangeFormattingEditProvider(Y,ae){return mt.registerDocumentRangeFormattingEditProvider(Pe,vt(Y),ae)},registerOnTypeFormattingEditProvider(Y,ae,Se,...at){return mt.registerOnTypeFormattingEditProvider(Pe,vt(Y),ae,[Se].concat(at))},registerDocumentSemanticTokensProvider(Y,ae,Se){return mt.registerDocumentSemanticTokensProvider(Pe,vt(Y),ae,Se)},registerDocumentRangeSemanticTokensProvider(Y,ae,Se){return mt.registerDocumentRangeSemanticTokensProvider(Pe,vt(Y),ae,Se)},registerSignatureHelpProvider(Y,ae,Se,...at){return typeof Se=="object"?mt.registerSignatureHelpProvider(Pe,vt(Y),ae,Se):mt.registerSignatureHelpProvider(Pe,vt(Y),ae,typeof Se=="undefined"?[]:[Se,...at])},registerCompletionItemProvider(Y,ae,...Se){return mt.registerCompletionItemProvider(Pe,vt(Y),ae,Se)},registerInlineCompletionItemProvider(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"inlineCompletions"),mt.registerInlineCompletionsProvider(Pe,vt(Y),ae)},registerDocumentLinkProvider(Y,ae){return mt.registerDocumentLinkProvider(Pe,vt(Y),ae)},registerColorProvider(Y,ae){return mt.registerColorProvider(Pe,vt(Y),ae)},registerFoldingRangeProvider(Y,ae){return mt.registerFoldingRangeProvider(Pe,vt(Y),ae)},registerSelectionRangeProvider(Y,ae){return mt.registerSelectionRangeProvider(Pe,Y,ae)},registerCallHierarchyProvider(Y,ae){return mt.registerCallHierarchyProvider(Pe,Y,ae)},registerTypeHierarchyProvider(Y,ae){return mt.registerTypeHierarchyProvider(Pe,Y,ae)},setLanguageConfiguration:(Y,ae)=>mt.setLanguageConfiguration(Pe,Y,ae),getTokenInformationAtPosition(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"tokenInformation"),Ht.tokenAtPosition(Y,ae)},registerInlayHintsProvider(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"inlayHints"),mt.registerInlayHintsProvider(Pe,Y,ae)},createLanguageStatusItem(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"languageStatus"),Ht.createLanguageStatusItem(Pe,Y,ae)}},li={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(Y,ae,Se){const at=await(t.URI.isUri(Y)?Promise.resolve(pi.openTextDocument(Y)):Promise.resolve(Y));return At.showTextDocument(at,ae,Se)},createTextEditorDecorationType(Y){return At.createTextEditorDecorationType(Pe,Y)},onDidChangeActiveTextEditor(Y,ae,Se){return At.onDidChangeActiveTextEditor(Y,ae,Se)},onDidChangeVisibleTextEditors(Y,ae,Se){return At.onDidChangeVisibleTextEditors(Y,ae,Se)},onDidChangeTextEditorSelection(Y,ae,Se){return At.onDidChangeTextEditorSelection(Y,ae,Se)},onDidChangeTextEditorOptions(Y,ae,Se){return At.onDidChangeTextEditorOptions(Y,ae,Se)},onDidChangeTextEditorVisibleRanges(Y,ae,Se){return At.onDidChangeTextEditorVisibleRanges(Y,ae,Se)},onDidChangeTextEditorViewColumn(Y,ae,Se){return At.onDidChangeTextEditorViewColumn(Y,ae,Se)},onDidCloseTerminal(Y,ae,Se){return gt.onDidCloseTerminal(Y,ae,Se)},onDidOpenTerminal(Y,ae,Se){return gt.onDidOpenTerminal(Y,ae,Se)},onDidChangeActiveTerminal(Y,ae,Se){return gt.onDidChangeActiveTerminal(Y,ae,Se)},onDidChangeTerminalDimensions(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"terminalDimensions"),gt.onDidChangeTerminalDimensions(Y,ae,Se)},onDidChangeTerminalState(Y,ae,Se){return gt.onDidChangeTerminalState(Y,ae,Se)},onDidWriteTerminalData(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(Y,ae,Se)},get state(){return Ge.state},onDidChangeWindowState(Y,ae,Se){return Ge.onDidChangeWindowState(Y,ae,Se)},showInformationMessage(Y,...ae){return Kt.showMessage(Pe,T.default.Info,Y,ae[0],ae.slice(1))},showWarningMessage(Y,...ae){return Kt.showMessage(Pe,T.default.Warning,Y,ae[0],ae.slice(1))},showErrorMessage(Y,...ae){return Kt.showMessage(Pe,T.default.Error,Y,ae[0],ae.slice(1))},showQuickPick(Y,ae,Se){return Array.isArray(Y)&&Y.some(at=>at.kind!==void 0)&&(0,ge.checkProposedApiEnabled)(Pe,"quickPickSeparators"),Nt.showQuickPick(Y,ae,Se)},showWorkspaceFolderPick(Y){return Nt.showWorkspaceFolderPick(Y)},showInputBox(Y,ae){return Nt.showInput(Y,ae)},showOpenDialog(Y){return fi.showOpenDialog(Y)},showSaveDialog(Y){return fi.showSaveDialog(Y)},createStatusBarItem(Y,ae,Se){let at,Et,kt;return typeof Y=="string"?(at=Y,Et=ae,kt=Se):(Et=Y,kt=ae),Wt.createStatusBarEntry(Pe,at,Et,kt)},setStatusBarMessage(Y,ae){return Wt.setStatusBarMessage(Y,ae)},withScmProgress(Y){return De.report("window.withScmProgress",Pe,"Use 'withProgress' instead."),di.withProgress(Pe,{location:$.ProgressLocation.SourceControl},(ae,Se)=>Y({report(at){}}))},withProgress(Y,ae){return di.withProgress(Pe,Y,ae)},createOutputChannel(Y){return Bt.createOutputChannel(Y,Pe)},createWebviewPanel(Y,ae,Se,at){return si.createWebviewPanel(Pe,Y,ae,Se,at)},createWebviewTextEditorInset(Y,ae,Se,at){return(0,ge.checkProposedApiEnabled)(Pe,"editorInsets"),bi.createWebviewEditorInset(Y,ae,Se,at,Pe)},createTerminal(Y,ae,Se){return typeof Y=="object"?("location"in Y&&(0,ge.checkProposedApiEnabled)(Pe,"terminalLocation"),"pty"in Y?gt.createExtensionTerminal(Y):gt.createTerminalFromOptions(Y)):gt.createTerminal(Y,ae,Se)},registerTerminalLinkProvider(Y){return gt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ae){return gt.registerProfileProvider(Pe,Y,ae)},registerTreeDataProvider(Y,ae){return Yt.registerTreeDataProvider(Y,ae,Pe)},createTreeView(Y,ae){return Yt.createTreeView(Y,ae,Pe)},registerWebviewPanelSerializer:(Y,ae)=>si.registerWebviewPanelSerializer(Pe,Y,ae),registerCustomEditorProvider:(Y,ae,Se={})=>_i.registerCustomEditorProvider(Pe,Y,ae,Se),registerFileDecorationProvider(Y){return _t.registerFileDecorationProvider(Y,Pe.identifier)},registerUriHandler(Y){return Vt.registerUriHandler(Pe.identifier,Y)},createQuickPick(){return Nt.createQuickPick(Pe)},createInputBox(){return Nt.createInputBox(Pe.identifier)},get activeColorTheme(){return hi.activeColorTheme},onDidChangeActiveColorTheme(Y,ae,Se){return hi.onDidChangeActiveColorTheme(Y,ae,Se)},registerWebviewViewProvider(Y,ae,Se){return yi.registerWebviewViewProvider(Pe,Y,ae,Se?.webviewOptions)},get activeNotebookEditor(){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(Y,ae,Se)},get visibleNotebookEditors(){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(Y,ae,Se)},onDidChangeNotebookEditorVisibleRanges(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(Y,ae,Se)},showNotebookDocument(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),wt.showNotebookDocument(Y,ae)},registerExternalUriOpener(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"externalUriOpener"),Zt.registerExternalUriOpener(Pe.identifier,Y,ae,Se)},get tabs(){return(0,ge.checkProposedApiEnabled)(Pe,"tabs"),lt.tabs},get activeTab(){return(0,ge.checkProposedApiEnabled)(Pe,"tabs"),lt.activeTab},get onDidChangeTabs(){return(0,ge.checkProposedApiEnabled)(Pe,"tabs"),lt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ge.checkProposedApiEnabled)(Pe,"tabs"),lt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ge.checkProposedApiEnabled)(Pe,"inlineCompletions"),g.InlineCompletionController.get(Y)}},pi={get rootPath(){return De.report("workspace.rootPath",Pe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(Y){throw M.readonly()},getWorkspaceFolder(Y){return Le.getWorkspaceFolder(Y)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(Y){throw M.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(Y){throw M.readonly()},updateWorkspaceFolders:(Y,ae,...Se)=>Le.updateWorkspaceFolders(Pe,Y,ae||0,...Se),onDidChangeWorkspaceFolders:function(Y,ae,Se){return Le.onDidChangeWorkspace(Y,ae,Se)},asRelativePath:(Y,ae)=>Le.getRelativePath(Y,ae),findFiles:(Y,ae,Se,at)=>Le.findFiles(V.GlobPattern.from(Y),V.GlobPattern.from(ae),Se,Pe.identifier,at),findTextInFiles:(Y,ae,Se,at)=>{(0,ge.checkProposedApiEnabled)(Pe,"findTextInFiles");let Et,kt;return typeof ae=="object"?(Et=ae,kt=Se):(Et={},kt=ae,at=Se),Le.findTextInFiles(Y,Et||{},kt,Pe.identifier,at)},saveAll:Y=>Le.saveAll(Y),applyEdit(Y){return Ci.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ae,Se,at)=>Ot.createFileSystemWatcher(V.GlobPattern.from(Y),ae,Se,at),get textDocuments(){return St.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw M.readonly()},openTextDocument(Y){let ae;const Se=Y;if(typeof Y=="string")ae=Promise.resolve(t.URI.file(Y));else if(t.URI.isUri(Y))ae=Promise.resolve(Y);else if(!Se||typeof Se=="object")ae=St.createDocumentData(Se);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(at=>St.ensureDocumentData(at).then(Et=>Et.document))},onDidOpenTextDocument:(Y,ae,Se)=>St.onDidAddDocument(Y,ae,Se),onDidCloseTextDocument:(Y,ae,Se)=>St.onDidRemoveDocument(Y,ae,Se),onDidChangeTextDocument:(Y,ae,Se)=>St.onDidChangeDocument(Y,ae,Se),onDidSaveTextDocument:(Y,ae,Se)=>St.onDidSaveDocument(Y,ae,Se),onWillSaveTextDocument:(Y,ae,Se)=>ti.getOnWillSaveTextDocumentEvent(Pe)(Y,ae,Se),get notebookDocuments(){return wt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ae){let Se;if(t.URI.isUri(Y))Se=Y,await wt.openNotebookDocument(Y);else if(typeof Y=="string")Se=t.URI.revive(await wt.createNotebookDocument({viewType:Y,content:ae}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Se).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ae,Se,at){return wt.registerNotebookSerializer(Pe,Y,ae,Se,(0,ge.isProposedApiEnabled)(Pe,"notebookLiveShare")?at:void 0)},registerNotebookContentProvider:(Y,ae,Se,at)=>((0,ge.checkProposedApiEnabled)(Pe,"notebookContentProvider"),wt.registerNotebookContentProvider(Pe,Y,ae,Se,(0,ge.isProposedApiEnabled)(Pe,"notebookLiveShare")?at:void 0)),onDidChangeConfiguration:(Y,ae,Se)=>Ft.onDidChangeConfiguration(Y,ae,Se),getConfiguration(Y,ae){return ae=arguments.length===1?void 0:ae,Ft.getConfiguration(Y,ae,Pe)},registerTextDocumentContentProvider(Y,ae){return $t.registerTextDocumentContentProvider(Y,ae)},registerTaskProvider:(Y,ae)=>(De.report("window.registerTaskProvider",Pe,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Pe,Y,ae)),registerFileSystemProvider(Y,ae,Se){return ri.registerFileSystemProvider(Pe,Y,ae,Se)},get fs(){return he.value},registerFileSearchProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Pe,"fileSearchProvider"),Tt.registerFileSearchProvider(Y,ae)),registerTextSearchProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Pe,"textSearchProvider"),Tt.registerTextSearchProvider(Y,ae)),registerRemoteAuthorityResolver:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Pe,"resolvers"),ke.registerRemoteAuthorityResolver(Y,ae)),registerResourceLabelFormatter:Y=>((0,ge.checkProposedApiEnabled)(Pe,"resolvers"),Ei.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ae,Se)=>Ot.onDidCreateFile(Y,ae,Se),onDidDeleteFiles:(Y,ae,Se)=>Ot.onDidDeleteFile(Y,ae,Se),onDidRenameFiles:(Y,ae,Se)=>Ot.onDidRenameFile(Y,ae,Se),onWillCreateFiles:(Y,ae,Se)=>Ot.getOnWillCreateFileEvent(Pe)(Y,ae,Se),onWillDeleteFiles:(Y,ae,Se)=>Ot.getOnWillDeleteFileEvent(Pe)(Y,ae,Se),onWillRenameFiles:(Y,ae,Se)=>Ot.getOnWillRenameFileEvent(Pe)(Y,ae,Se),openTunnel:Y=>((0,ge.checkProposedApiEnabled)(Pe,"resolvers"),be.openTunnel(Pe,Y).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,ge.checkProposedApiEnabled)(Pe,"resolvers"),be.getTunnels()},onDidChangeTunnels:(Y,ae,Se)=>((0,ge.checkProposedApiEnabled)(Pe,"resolvers"),be.onDidChangeTunnels(Y,ae,Se)),registerPortAttributesProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Pe,"portsAttributes"),be.registerPortsAttributesProvider(Y,ae)),registerTimelineProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Pe,"timeline"),oi.registerTimelineProvider(Y,ae,Pe.identifier,ct.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:Y=>((0,ge.checkProposedApiEnabled)(Pe,"workspaceTrust"),Le.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ae,Se)=>Le.onDidGrantWorkspaceTrust(Y,ae,Se)},Ri={get inputBox(){return De.report("scm.inputBox",Pe,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Pe)},createSourceControl(Y,ae,Se){return Xt.createSourceControl(Pe,Y,ae,Se)}},Fi={createCommentController(Y,ae){return wi.createCommentController(Pe,Y,ae)}},Mi={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},onDidStartDebugSession(Y,ae,Se){return dt.onDidStartDebugSession(Y,ae,Se)},onDidTerminateDebugSession(Y,ae,Se){return dt.onDidTerminateDebugSession(Y,ae,Se)},onDidChangeActiveDebugSession(Y,ae,Se){return dt.onDidChangeActiveDebugSession(Y,ae,Se)},onDidReceiveDebugSessionCustomEvent(Y,ae,Se){return dt.onDidReceiveDebugSessionCustomEvent(Y,ae,Se)},onDidChangeBreakpoints(Y,ae,Se){return dt.onDidChangeBreakpoints(Y,ae,Se)},registerDebugConfigurationProvider(Y,ae,Se){return dt.registerDebugConfigurationProvider(Y,ae,Se||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ae){return dt.registerDebugAdapterDescriptorFactory(Pe,Y,ae)},registerDebugAdapterTrackerFactory(Y,ae){return dt.registerDebugAdapterTrackerFactory(Y,ae)},startDebugging(Y,ae,Se){return!Se||typeof Se=="object"&&"configuration"in Se?dt.startDebugging(Y,ae,{parentSession:Se}):dt.startDebugging(Y,ae,Se||{})},stopDebugging(Y){return dt.stopDebugging(Y)},addBreakpoints(Y){return dt.addBreakpoints(Y)},removeBreakpoints(Y){return dt.removeBreakpoints(Y)},asDebugSourceUri(Y,ae){return dt.asDebugSourceUri(Y,ae)}},Li={registerTaskProvider:(Y,ae)=>yt.registerTaskProvider(Pe,Y,ae),fetchTasks:Y=>yt.fetchTasks(Y),executeTask:Y=>yt.executeTask(Pe,Y),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(Y,ae,Se)=>yt.onDidStartTask(Y,ae,Se),onDidEndTask:(Y,ae,Se)=>yt.onDidEndTask(Y,ae,Se),onDidStartTaskProcess:(Y,ae,Se)=>yt.onDidStartTaskProcess(Y,ae,Se),onDidEndTaskProcess:(Y,ae,Se)=>yt.onDidEndTaskProcess(Y,ae,Se)},Oi={createNotebookController(Y,ae,Se,at,Et){return ii.createNotebookController(Pe,Y,ae,Se,at,(0,ge.isProposedApiEnabled)(Pe,"notebookMessaging")?Et:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ae)=>wt.registerNotebookCellStatusBarItemProvider(Pe,Y,ae),get onDidSaveNotebookDocument(){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),Qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return ni.createRendererMessaging(Pe,Y)},onDidChangeNotebookDocumentMetadata(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),Qt.onDidChangeNotebookDocumentMetadata(Y,ae,Se)},onDidChangeNotebookCells(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),wt.onDidChangeNotebookCells(Y,ae,Se)},onDidChangeNotebookCellExecutionState(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookCellExecutionState"),wt.onDidChangeNotebookCellExecutionState(Y,ae,Se)},onDidChangeCellOutputs(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),wt.onDidChangeCellOutputs(Y,ae,Se)},onDidChangeCellMetadata(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Pe,"notebookEditor"),wt.onDidChangeCellMetadata(Y,ae,Se)},createConcatTextDocument(Y,ae){return(0,ge.checkProposedApiEnabled)(Pe,"notebookConcatTextDocument"),new Ne.ExtHostNotebookConcatDocument(wt,St,Y,ae)}};return{version:se.version,authentication:ki,commands:Ii,comments:Fi,debug:Mi,env:mi,extensions:Ti,languages:Ai,notebooks:Oi,scm:Ri,tasks:Li,tests:Pi,window:li,workspace:pi,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:c.CancellationTokenSource,CandidatePortSource:r.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:k.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:r.UIKind,Uri:t.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Ce}),define(we[224],Ee([0,1,57,95,32,94,33,38,49,39,98,99,100,72,65,70,96,50,31,69,86,71,196,12,179]),function(re,e,c,M,w,T,t,R,C,k,F,_,r,m,o,d,p,D,f,l,h,y,a,P,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(P.ILoggerService,a.ExtHostLoggerService),(0,c.registerSingleton)(P.ILogService,n.ExtHostLogService),(0,c.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService),(0,c.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands),(0,c.registerSingleton)(t.IExtHostConfiguration,t.ExtHostConfiguration),(0,c.registerSingleton)(D.IExtHostConsumerFileSystem,D.ExtHostConsumerFileSystem),(0,c.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,c.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,c.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,c.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo),(0,c.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,c.registerSingleton)(r.IExtHostSearch,r.ExtHostSearch),(0,c.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,c.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,c.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,c.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,c.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,c.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace),(0,c.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,c.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,c.registerSingleton)(y.IExtHostEditorTabs,y.ExtHostEditorTabs)}),define(we[225],Ee([0,1,223,34,219,6,14,5,11]),function(re,e,c,M,w,T,t,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(o){const d=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(D,...f)=>{f.forEach(a=>{if(!self.trustedTypes?.isScript(a))throw new Error("TrustedScripts only, please")});const l=f.slice(0,-1).join(","),h=f.pop().toString();return`(function anonymous(${l}) {${h}
})`}});function p(...D){return d?self.eval(d.createScript("",...D)):new Function(...D)}o.create=p})(k||(k={}));class F extends w.RequireInterceptor{_installInterceptor(){}getModule(d,p){for(let D of this._alternatives){let f=D(d);if(f){d=f;break}}if(this._factories.has(d))return this._factories.get(d).load(d,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const d=this._extHostContext.getProxy(R.MainContext.MainThreadConsole);m(d,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(c.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(F,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(d){return d.browser}async _loadCommonJSModule(d,p,D){p=p.with({path:r(p.path,".js")}),d&&performance.mark(`code/extHost/willFetchExtensionCode/${d.value}`);const f=await fetch(C.FileAccess.asBrowserUri(p).toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d.value}`),f.status!==200)throw new Error(f.statusText);const l=await f.text(),h=`${p.toString(!0)}#vscode-extension`,y=`${l}
//# sourceURL=${h}`;let a;try{a=k.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(y)??y)}catch(v){throw console.error(d?`Loading code for extension ${d.value} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${p.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}const P={},n={exports:P},i=v=>{const g=this._fakeModules.getModule(v,p);if(g===void 0)throw new Error(`Cannot load module '${v}'`);return g};try{return D.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d.value}`),a(n,P,i),n.exports!==P?n.exports:P}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d.value}`),D.codeLoadingStop()}}async $setRemoteEnvironment(d){}async _waitForDebuggerAttachment(d=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+d;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,t.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:o=>o});function r(o,d){return o.endsWith(d)?o:o+d}function m(o,d){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(l,h){const y=console[l];console[l]=function(){o.$logExtensionHostMessage({type:"__$console",severity:h,arguments:f(arguments)}),d&&y.apply(console,arguments)}}const D=1e5;function f(l){const h=[],y=[];if(l.length)for(let a=0;a<l.length;a++){if(typeof l[a]=="undefined")l[a]="undefined";else if(l[a]instanceof Error){const P=l[a];P.stack?l[a]=P.stack:l[a]=P.toString()}y.push(l[a])}try{const a=JSON.stringify(y,function(P,n){if(n&&typeof n=="object"){if(h.indexOf(n)!==-1)return"[Circular]";h.push(n)}return n});return a.length>D?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}}),define(we[226],Ee([0,1,57,34,73,225]),function(re,e,c,M,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,c.registerSingleton)(M.IExtHostExtensionService,T.ExtHostExtensionService),(0,c.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths)}),define(we[235],Ee([0,1,22,3,177,220,214,17,74,11,2,224,226]),function(re,e,c,M,w,T,t,R,C,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const r=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const m=fetch.bind(self);if(self.fetch=function(l,h){return l instanceof Request||/^file:/i.test(String(l))&&(l=k.FileAccess.asBrowserUri(F.URI.parse(String(l))).toString(!0)),m(l,h)},self.XMLHttpRequest=class extends XMLHttpRequest{open(l,h,y,a,P){return/^file:/i.test(h.toString())&&(h=k.FileAccess.asBrowserUri(F.URI.parse(h.toString())).toString(!0)),super.open(l,h,y??!0,a,P)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const l=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:y=>y}),h=self.Worker;Worker=function(y,a){/^file:/i.test(y.toString())&&(y=k.FileAccess.asBrowserUri(F.URI.parse(y.toString())).toString(!0));const n=`(${function(s){function b(I){return typeof I=="string"||I instanceof URL?String(I).replace(/^file:\/\//i,"vscode-file://vscode-app"):I}const u=fetch.bind(self);self.fetch=function(I,B){return I instanceof Request?u(I,B):u(b(I),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(I,B,O,S,x){return super.open(I,b(B),O??!0,S,x)}};const E=importScripts.bind(self);self.importScripts=(...I)=>{E(...I.map(b))};const A=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:I=>I}):void 0;E(A?A.createScriptURL(s):s)}.toString()}('${y}'))`;a=a||{},a.name=a.name||R.basename(y.toString());const i=new Blob([n],{type:"application/javascript"}),v=URL.createObjectURL(i);return new h(l?l.createScriptURL(v):v,a)}}else self.Worker=class extends t.NestedWorker{constructor(l,h){super(r,l,{name:R.basename(l.toString()),...h})}};const o=new class{constructor(){this.pid=void 0}exit(l){_()}async exists(l){return!0}async realpath(l){return l}};class d{constructor(){const h=new MessageChannel,y=new M.Emitter;let a=!1;r(h.port2,[h.port2]),h.port1.onmessage=P=>{const{data:n}=P;if(!(n instanceof ArrayBuffer)){console.warn("UNKNOWN data received",n);return}const i=c.VSBuffer.wrap(new Uint8Array(n,0,n.byteLength));if((0,w.isMessageOfType)(i,2)){a=!0,D("received terminate message from renderer");return}y.fire(i)},this.protocol={onMessage:y.event,send:P=>{if(!a){const n=P.buffer.buffer.slice(P.buffer.byteOffset,P.buffer.byteOffset+P.buffer.byteLength);h.port1.postMessage(n,[n])}}}}}function p(l){return new Promise(h=>{const y=l.onMessage(a=>{y.dispose();const P=JSON.parse(a.toString());l.send((0,w.createMessageOfType)(0)),h({protocol:l,initData:P})});l.send((0,w.createMessageOfType)(1))})}let D=l=>_();function f(){const l=new d;C.mark("code/extHost/willConnectToRenderer"),p(l.protocol).then(h=>{C.mark("code/extHost/didWaitForInitData");const y=new T.ExtensionHostMain(h.protocol,h.initData,o,null);D=a=>y.terminate(a)})}e.create=f})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d450b04c783dfa6f83dc439017767acccd4e9fac/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
